/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/remote/common/remoteHosts","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ce=function(X){for(var e=[],S=0,R=X.length;S<R;S++)e[S]=ae[X[S]];return e};define(ae[135],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function S(w,k,h){const f=R(w,k);if(f!==-1)return w[f]}e.$fb=S;function R(w,k,h=w.length-1){for(let f=h;f>=0;f--){const d=w[f];if(k(d))return f}return-1}e.$gb=R;function s(w,k){const h=M(w,k);return h===-1?void 0:w[h]}e.$hb=s;function M(w,k,h=0,f=w.length){let d=h,m=f;for(;d<m;){const c=Math.floor((d+m)/2);k(w[c])?d=c+1:m=c}return d-1}e.$ib=M;function D(w,k){const h=P(w,k);return h===w.length?void 0:w[h]}e.$jb=D;function P(w,k,h=0,f=w.length){let d=h,m=f;for(;d<m;){const c=Math.floor((d+m)/2);k(w[c])?m=c:d=c+1}return d}e.$kb=P;function g(w,k,h=0,f=w.length){const d=P(w,k,h,f);return d===w.length?-1:d}e.$lb=g;class l{static{this.assertInvariants=!1}constructor(k){this.e=k,this.c=0}findLastMonotonous(k){if(l.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!k(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=k}const h=M(this.e,k,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}e.$mb=l;function b(w,k){if(w.length===0)return;let h=w[0];for(let f=1;f<w.length;f++){const d=w[f];k(d,h)>0&&(h=d)}return h}e.$nb=b;function v(w,k){if(w.length===0)return;let h=w[0];for(let f=1;f<w.length;f++){const d=w[f];k(d,h)>=0&&(h=d)}return h}e.$ob=v;function y(w,k){return b(w,(h,f)=>-k(h,f))}e.$pb=y;function u(w,k){if(w.length===0)return-1;let h=0;for(let f=1;f<w.length;f++){const d=w[f];k(d,w[h])>0&&(h=f)}return h}e.$qb=u;function $(w,k){for(const h of w){const f=k(h);if(f!==void 0)return f}}e.$rb=$}),define(ae[136],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function S(D,P){const g=Object.create(null);for(const l of D){const b=P(l);let v=g[b];v||(v=g[b]=[]),v.push(l)}return g}e.$K=S;function R(D,P){const g=[],l=[];for(const b of D)P.has(b)||g.push(b);for(const b of P)D.has(b)||l.push(b);return{removed:g,added:l}}e.$L=R;function s(D,P){const g=[],l=[];for(const[b,v]of D)P.has(b)||g.push(v);for(const[b,v]of P)D.has(b)||l.push(v);return{removed:g,added:l}}e.$M=s;function M(D,P){const g=new Set;for(const l of P)D.has(l)&&g.add(l);return g}e.$N=M}),define(ae[137],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=e.$nt=e.$mt=e.$lt=void 0;function S(P,g){const l=Math.pow(10,g);return Math.round(P*l)/l}class R{constructor(g,l,b,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,g))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=S(Math.max(Math.min(1,v),0),3)}static equals(g,l){return g.r===l.r&&g.g===l.g&&g.b===l.b&&g.a===l.a}}e.$lt=R;class s{constructor(g,l,b,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=S(Math.max(Math.min(1,l),0),3),this.l=S(Math.max(Math.min(1,b),0),3),this.a=S(Math.max(Math.min(1,v),0),3)}static equals(g,l){return g.h===l.h&&g.s===l.s&&g.l===l.l&&g.a===l.a}static fromRGBA(g){const l=g.r/255,b=g.g/255,v=g.b/255,y=g.a,u=Math.max(l,b,v),$=Math.min(l,b,v);let w=0,k=0;const h=($+u)/2,f=u-$;if(f>0){switch(k=Math.min(h<=.5?f/(2*h):f/(2-2*h),1),u){case l:w=(b-v)/f+(b<v?6:0);break;case b:w=(v-l)/f+2;break;case v:w=(l-b)/f+4;break}w*=60,w=Math.round(w)}return new s(w,k,h,y)}static i(g,l,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?g+(l-g)*6*b:b<1/2?l:b<2/3?g+(l-g)*(2/3-b)*6:g}static toRGBA(g){const l=g.h/360,{s:b,l:v,a:y}=g;let u,$,w;if(b===0)u=$=w=v;else{const k=v<.5?v*(1+b):v+b-v*b,h=2*v-k;u=s.i(h,k,l+1/3),$=s.i(h,k,l),w=s.i(h,k,l-1/3)}return new R(Math.round(u*255),Math.round($*255),Math.round(w*255),y)}}e.$mt=s;class M{constructor(g,l,b,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=S(Math.max(Math.min(1,l),0),3),this.v=S(Math.max(Math.min(1,b),0),3),this.a=S(Math.max(Math.min(1,v),0),3)}static equals(g,l){return g.h===l.h&&g.s===l.s&&g.v===l.v&&g.a===l.a}static fromRGBA(g){const l=g.r/255,b=g.g/255,v=g.b/255,y=Math.max(l,b,v),u=Math.min(l,b,v),$=y-u,w=y===0?0:$/y;let k;return $===0?k=0:y===l?k=((b-v)/$%6+6)%6:y===b?k=(v-l)/$+2:k=(l-b)/$+4,new M(Math.round(k*60),w,y,g.a)}static toRGBA(g){const{h:l,s:b,v,a:y}=g,u=v*b,$=u*(1-Math.abs(l/60%2-1)),w=v-u;let[k,h,f]=[0,0,0];return l<60?(k=u,h=$):l<120?(k=$,h=u):l<180?(h=u,f=$):l<240?(h=$,f=u):l<300?(k=$,f=u):l<=360&&(k=u,f=$),k=Math.round((k+w)*255),h=Math.round((h+w)*255),f=Math.round((f+w)*255),new R(k,h,f,y)}}e.$nt=M;class D{static fromHex(g){return D.Format.CSS.parseHex(g)||D.red}static equals(g,l){return!g&&!l?!0:!g||!l?!1:g.equals(l)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(g){if(g)if(g instanceof R)this.rgba=g;else if(g instanceof s)this.i=g,this.rgba=s.toRGBA(g);else if(g instanceof M)this.j=g,this.rgba=M.toRGBA(g);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(g){return!!g&&R.equals(this.rgba,g.rgba)&&s.equals(this.hsla,g.hsla)&&M.equals(this.hsva,g.hsva)}getRelativeLuminance(){const g=D.k(this.rgba.r),l=D.k(this.rgba.g),b=D.k(this.rgba.b),v=.2126*g+.7152*l+.0722*b;return S(v,4)}static k(g){const l=g/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(g){const l=this.getRelativeLuminance(),b=g.getRelativeLuminance();return l>b?(l+.05)/(b+.05):(b+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(g){const l=this.getRelativeLuminance(),b=g.getRelativeLuminance();return l>b}isDarkerThan(g){const l=this.getRelativeLuminance(),b=g.getRelativeLuminance();return l<b}lighten(g){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*g,this.hsla.a))}darken(g){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*g,this.hsla.a))}transparent(g){const{r:l,g:b,b:v,a:y}=this.rgba;return new D(new R(l,b,v,y*g))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(g){const l=g.rgba,b=this.rgba.a,v=l.a,y=b+v*(1-b);if(y<1e-6)return D.transparent;const u=this.rgba.r*b/y+l.r*v*(1-b)/y,$=this.rgba.g*b/y+l.g*v*(1-b)/y,w=this.rgba.b*b/y+l.b*v*(1-b)/y;return new D(new R(u,$,w,y))}makeOpaque(g){if(this.isOpaque()||g.rgba.a!==1)return this;const{r:l,g:b,b:v,a:y}=this.rgba;return new D(new R(g.rgba.r-y*(g.rgba.r-l),g.rgba.g-y*(g.rgba.g-b),g.rgba.b-y*(g.rgba.b-v),1))}flatten(...g){const l=g.reduceRight((b,v)=>D.o(v,b));return D.o(this,l)}static o(g,l){const b=1-g.rgba.a;return new D(new R(b*l.rgba.r+g.rgba.a*g.rgba.r,b*l.rgba.g+g.rgba.a*g.rgba.g,b*l.rgba.b+g.rgba.a*g.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(g,l,b){if(g.isLighterThan(l))return g;b=b||.5;const v=g.getRelativeLuminance(),y=l.getRelativeLuminance();return b=b*(y-v)/y,g.lighten(b)}static getDarkerColor(g,l,b){if(g.isDarkerThan(l))return g;b=b||.5;const v=g.getRelativeLuminance(),y=l.getRelativeLuminance();return b=b*(v-y)/v,g.darken(b)}static{this.white=new D(new R(255,255,255,1))}static{this.black=new D(new R(0,0,0,1))}static{this.red=new D(new R(255,0,0,1))}static{this.blue=new D(new R(0,0,255,1))}static{this.green=new D(new R(0,255,0,1))}static{this.cyan=new D(new R(0,255,255,1))}static{this.lightgrey=new D(new R(211,211,211,1))}static{this.transparent=new D(new R(0,0,0,0))}}e.$ot=D,function(P){let g;(function(l){let b;(function(v){function y(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}v.formatRGB=y;function u(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=u;function $(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}v.formatHSL=$;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=w;function k(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function h(t){return`#${k(t.rgba.r)}${k(t.rgba.g)}${k(t.rgba.b)}`}v.formatHex=h;function f(t,o=!1){return o&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${k(t.rgba.r)}${k(t.rgba.g)}${k(t.rgba.b)}${k(Math.round(t.rgba.a*255))}`}v.formatHexA=f;function d(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}v.format=d;function m(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const r=16*c(t.charCodeAt(1))+c(t.charCodeAt(2)),i=16*c(t.charCodeAt(3))+c(t.charCodeAt(4)),n=16*c(t.charCodeAt(5))+c(t.charCodeAt(6));return new P(new R(r,i,n,1))}if(o===9){const r=16*c(t.charCodeAt(1))+c(t.charCodeAt(2)),i=16*c(t.charCodeAt(3))+c(t.charCodeAt(4)),n=16*c(t.charCodeAt(5))+c(t.charCodeAt(6)),a=16*c(t.charCodeAt(7))+c(t.charCodeAt(8));return new P(new R(r,i,n,a/255))}if(o===4){const r=c(t.charCodeAt(1)),i=c(t.charCodeAt(2)),n=c(t.charCodeAt(3));return new P(new R(16*r+r,16*i+i,16*n+n))}if(o===5){const r=c(t.charCodeAt(1)),i=c(t.charCodeAt(2)),n=c(t.charCodeAt(3)),a=c(t.charCodeAt(4));return new P(new R(16*r+r,16*i+i,16*n+n,(16*a+a)/255))}return null}v.parseHex=m;function c(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=l.CSS||(l.CSS={}))})(g=P.Format||(P.Format={}))}(D||(e.$ot=D={}))}),define(ae[50],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function S(D){return(P,g,l)=>{let b=null,v=null;if(typeof l.value=="function"?(b="value",v=l.value):typeof l.get=="function"&&(b="get",v=l.get),!v)throw new Error("not supported");l[b]=D(v,g)}}function R(D,P,g){let l=null,b=null;if(typeof g.value=="function"?(l="value",b=g.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(l="get",b=g.get),!b)throw new Error("not supported");const v=`$memoize$${P}`;g[l]=function(...y){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,y)}),this[v]}}e.$zh=R;function s(D,P,g){return S((l,b)=>{const v=`$debounce$${b}`,y=`$debounce$result$${b}`;return function(...u){this[y]||(this[y]=g?g():void 0),clearTimeout(this[v]),P&&(this[y]=P(this[y],...u),u=[this[y]]),this[v]=setTimeout(()=>{l.apply(this,u),this[y]=g?g():void 0},D)}})}e.$Ah=s;function M(D,P,g){return S((l,b)=>{const v=`$throttle$timer$${b}`,y=`$throttle$result$${b}`,u=`$throttle$lastRun$${b}`,$=`$throttle$pending$${b}`;return function(...w){if(this[y]||(this[y]=g?g():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),P&&(this[y]=P(this[y],...w)),this[$])return;const k=this[u]+D;k<=Date.now()?(this[u]=Date.now(),l.apply(this,[this[y]]),this[y]=g?g():void 0):(this[$]=!0,this[v]=setTimeout(()=>{this[$]=!1,this[u]=Date.now(),l.apply(this,[this[y]]),this[y]=g?g():void 0},k-Date.now()))}})}e.$Bh=M}),define(ae[14],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class S{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?d.isErrorNoTelemetry(t)?new d(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=S,e.$X=new S;function R(c){e.$X.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=R;function s(c){if(!c||typeof c!="object")return!1;const t=c;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function M(c){l(c)||e.$X.onUnexpectedError(c)}e.$1=M;function D(c){l(c)||e.$X.onUnexpectedExternalError(c)}e.$2=D;function P(c){if(c instanceof Error){const{name:t,message:o}=c,r=c.stacktrace||c.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:d.isErrorNoTelemetry(c)}}return c}e.$3=P;const g="Canceled";function l(c){return c instanceof b?!0:c instanceof Error&&c.name===g&&c.message===g}e.$4=l;class b extends Error{constructor(){super(g),this.name=this.message}}e.$5=b;function v(){const c=new Error(g);return c.name=c.message,c}e.$6=v;function y(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.$7=y;function u(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.$8=u;class $ extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=$;function w(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.$0=w;class k extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=k;class h extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=h;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class d extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof d)return t;const o=new d;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=d;class m extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$cb=m}),define(ae[22],ce([0,1,14,135]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(T,Q=0){return T[T.length-(1+Q)]}e.$sb=s;function M(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.$tb=M;function D(T,Q,H=(_,z)=>_===z){if(T===Q)return!0;if(!T||!Q||T.length!==Q.length)return!1;for(let _=0,z=T.length;_<z;_++)if(!H(T[_],Q[_]))return!1;return!0}e.$ub=D;function P(T,Q){const H=T.length-1;Q<H&&(T[Q]=T[H]),T.pop()}e.$vb=P;function g(T,Q,H){return l(T.length,_=>H(T[_],Q))}e.$wb=g;function l(T,Q){let H=0,_=T-1;for(;H<=_;){const z=(H+_)/2|0,ee=Q(z);if(ee<0)H=z+1;else if(ee>0)_=z-1;else return z}return-(H+1)}e.$xb=l;function b(T,Q,H){if(T=T|0,T>=Q.length)throw new TypeError("invalid index");const _=Q[Math.floor(Q.length*Math.random())],z=[],ee=[],se=[];for(const de of Q){const me=H(de,_);me<0?z.push(de):me>0?ee.push(de):se.push(de)}return T<z.length?b(T,z,H):T<z.length+se.length?se[0]:b(T-(z.length+se.length),ee,H)}e.$yb=b;function v(T,Q){const H=[];let _;for(const z of T.slice(0).sort(Q))!_||Q(_[0],z)!==0?(_=[z],H.push(_)):_.push(z);return H}e.$zb=v;function*y(T,Q){let H,_;for(const z of T)_!==void 0&&Q(_,z)?H.push(z):(H&&(yield H),H=[z]),_=z;H&&(yield H)}e.$Ab=y;function u(T,Q){for(let H=0;H<=T.length;H++)Q(H===0?void 0:T[H-1],H===T.length?void 0:T[H])}e.$Bb=u;function $(T,Q){for(let H=0;H<T.length;H++)Q(H===0?void 0:T[H-1],T[H],H+1===T.length?void 0:T[H+1])}e.$Cb=$;function w(T,Q,H){const _=[];function z(de,me,Ee){if(me===0&&Ee.length===0)return;const Pe=_[_.length-1];Pe&&Pe.start+Pe.deleteCount===de?(Pe.deleteCount+=me,Pe.toInsert.push(...Ee)):_.push({start:de,deleteCount:me,toInsert:Ee})}let ee=0,se=0;for(;;){if(ee===T.length){z(ee,0,Q.slice(se));break}if(se===Q.length){z(ee,T.length-ee,[]);break}const de=T[ee],me=Q[se],Ee=H(de,me);Ee===0?(ee+=1,se+=1):Ee<0?(z(ee,1,[]),ee+=1):Ee>0&&(z(ee,0,[me]),se+=1)}return _}e.$Db=w;function k(T,Q,H){const _=w(T,Q,H),z=[],ee=[];for(const se of _)z.push(...T.slice(se.start,se.start+se.deleteCount)),ee.push(...se.toInsert);return{removed:z,added:ee}}e.$Eb=k;function h(T,Q,H){if(H===0)return[];const _=T.slice(0,H).sort(Q);return d(T,Q,_,H,T.length),_}e.top=h;function f(T,Q,H,_,z){return H===0?Promise.resolve([]):new Promise((ee,se)=>{(async()=>{const de=T.length,me=T.slice(0,H).sort(Q);for(let Ee=H,Pe=Math.min(H+_,de);Ee<de;Ee=Pe,Pe=Math.min(Pe+_,de)){if(Ee>H&&await new Promise(Le=>setTimeout(Le)),z&&z.isCancellationRequested)throw new S.$5;d(T,Q,me,Ee,Pe)}return me})().then(ee,se)})}e.$Gb=f;function d(T,Q,H,_,z){for(const ee=H.length;_<z;_++){const se=T[_];if(Q(se,H[ee-1])<0){H.pop();const de=(0,R.$kb)(H,me=>Q(se,me)<0);H.splice(de,0,se)}}}function m(T){return T.filter(Q=>!!Q)}e.$Hb=m;function c(T){let Q=0;for(let H=0;H<T.length;H++)T[H]&&(T[Q]=T[H],Q+=1);T.length=Q}e.$Ib=c;function t(T,Q,H){T.splice(H,0,T.splice(Q,1)[0])}e.$Jb=t;function o(T){return!Array.isArray(T)||T.length===0}e.$Kb=o;function r(T){return Array.isArray(T)&&T.length>0}e.$Lb=r;function i(T,Q=H=>H){const H=new Set;return T.filter(_=>{const z=Q(_);return H.has(z)?!1:(H.add(z),!0)})}e.$Mb=i;function n(T){const Q=new Set;return H=>{const _=T(H);return Q.has(_)?!1:(Q.add(_),!0)}}e.$Nb=n;function a(T,Q){return T.length>0?T[0]:Q}e.$Ob=a;function p(T,Q){return T.length>0?T[T.length-1]:Q}e.$Pb=p;function A(T,Q,H=(_,z)=>_===z){let _=0;for(let z=0,ee=Math.min(T.length,Q.length);z<ee&&H(T[z],Q[z]);z++)_++;return _}e.$Qb=A;function I(T){return[].concat(...T)}e.$Rb=I;function E(T,Q){let H=typeof Q=="number"?T:0;typeof Q=="number"?H=T:(H=0,Q=T);const _=[];if(H<=Q)for(let z=H;z<Q;z++)_.push(z);else for(let z=H;z>Q;z--)_.push(z);return _}e.$Sb=E;function C(T,Q,H){return T.reduce((_,z)=>(_[Q(z)]=H?H(z):z,_),Object.create(null))}e.$Tb=C;function j(T,Q){return T.push(Q),()=>U(T,Q)}e.$Ub=j;function U(T,Q){const H=T.indexOf(Q);if(H>-1)return T.splice(H,1),Q}e.$Vb=U;function F(T,Q,H){const _=T.slice(0,Q),z=T.slice(Q);return _.concat(H,z)}e.$Wb=F;function V(T,Q){let H;if(typeof Q=="number"){let _=Q;H=()=>{const z=Math.sin(_++)*179426549;return z-Math.floor(z)}}else H=Math.random;for(let _=T.length-1;_>0;_-=1){const z=Math.floor(H()*(_+1)),ee=T[_];T[_]=T[z],T[z]=ee}}e.$Xb=V;function J(T,Q){const H=T.indexOf(Q);H>-1&&(T.splice(H,1),T.unshift(Q))}e.$Yb=J;function le(T,Q){const H=T.indexOf(Q);H>-1&&(T.splice(H,1),T.push(Q))}e.$Zb=le;function oe(T,Q){for(const H of Q)T.push(H)}e.$1b=oe;function ue(T,Q){return Array.isArray(T)?T.map(Q):Q(T)}e.$2b=ue;function Z(T){return Array.isArray(T)?T:[T]}e.$3b=Z;function Y(T){return T[Math.floor(Math.random()*T.length)]}e.$4b=Y;function q(T,Q,H){const _=N(T,Q),z=T.length,ee=H.length;T.length=z+ee;for(let se=z-1;se>=_;se--)T[se+ee]=T[se];for(let se=0;se<ee;se++)T[se+_]=H[se]}e.$5b=q;function L(T,Q,H,_){const z=N(T,Q);let ee=T.splice(z,H);return ee===void 0&&(ee=[]),q(T,z,_),ee}e.$6b=L;function N(T,Q){return Q<0?Math.max(Q+T.length,0):Math.min(Q,T.length)}var G;(function(T){function Q(ee){return ee<0}T.isLessThan=Q;function H(ee){return ee<=0}T.isLessThanOrEqual=H;function _(ee){return ee>0}T.isGreaterThan=_;function z(ee){return ee===0}T.isNeitherLessOrGreaterThan=z,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function B(T,Q){return(H,_)=>Q(T(H),T(_))}e.$7b=B;function te(...T){return(Q,H)=>{for(const _ of T){const z=_(Q,H);if(!G.isNeitherLessOrGreaterThan(z))return z}return G.neitherLessOrGreaterThan}}e.$8b=te;const he=(T,Q)=>T-Q;e.$9b=he;const K=(T,Q)=>(0,e.$9b)(T?1:0,Q?1:0);e.$0b=K;function O(T){return(Q,H)=>-T(Q,H)}e.$$b=O;class W{constructor(Q){this.g=Q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Q){let H=this.c;for(;H<this.g.length&&Q(this.g[H]);)H++;const _=H===this.c?null:this.g.slice(this.c,H);return this.c=H,_}takeFromEndWhile(Q){let H=this.d;for(;H>=0&&Q(this.g[H]);)H--;const _=H===this.d?null:this.g.slice(H+1,this.d+1);return this.d=H,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Q=this.g[this.c];return this.c++,Q}removeLast(){const Q=this.g[this.d];return this.d--,Q}takeCount(Q){const H=this.g.slice(this.c,this.c+Q);return this.c+=Q,H}}e.$_b=W;class x{static{this.empty=new x(Q=>{})}constructor(Q){this.iterate=Q}forEach(Q){this.iterate(H=>(Q(H),!0))}toArray(){const Q=[];return this.iterate(H=>(Q.push(H),!0)),Q}filter(Q){return new x(H=>this.iterate(_=>Q(_)?H(_):!0))}map(Q){return new x(H=>this.iterate(_=>H(Q(_))))}some(Q){let H=!1;return this.iterate(_=>(H=Q(_),!H)),H}findFirst(Q){let H;return this.iterate(_=>Q(_)?(H=_,!1):!0),H}findLast(Q){let H;return this.iterate(_=>(Q(_)&&(H=_),!0)),H}findLastMaxBy(Q){let H,_=!0;return this.iterate(z=>((_||G.isGreaterThan(Q(z,H)))&&(_=!1,H=z),!0)),H}}e.$ac=x}),define(ae[138],ce([0,1,14]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function R(l,b){if(!l)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=R;function s(l,b="Unreachable"){throw new Error(b)}e.$6c=s;function M(l){if(!l)throw new S.$cb("Assertion Failed")}e.$7c=M;function D(l){l||(0,S.$1)(new S.$cb("Assertion Failed"))}e.$8c=D;function P(l){if(!l()){debugger;l(),(0,S.$1)(new S.$cb("Assertion Failed"))}}e.$9c=P;function g(l,b){let v=0;for(;v<l.length-1;){const y=l[v],u=l[v+1];if(!b(y,u))return!1;v++}return!0}e.$0c=g}),define(ae[84],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function S(R,s){const M=this;let D=!1,P;return function(){if(D)return P;if(D=!0,s)try{P=R.apply(M,arguments)}finally{s()}else P=R.apply(M,arguments);return P}}e.$db=S}),define(ae[71],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(R){function s(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}R.is=s;const M=Object.freeze([]);function D(){return M}R.empty=D;function*P(t){yield t}R.single=P;function g(t){return s(t)?t:P(t)}R.wrap=g;function l(t){return t||M}R.from=l;function*b(t){for(let o=t.length-1;o>=0;o--)yield t[o]}R.reverse=b;function v(t){return!t||t[Symbol.iterator]().next().done===!0}R.isEmpty=v;function y(t){return t[Symbol.iterator]().next().value}R.first=y;function u(t,o){for(const r of t)if(o(r))return!0;return!1}R.some=u;function $(t,o){for(const r of t)if(o(r))return r}R.find=$;function*w(t,o){for(const r of t)o(r)&&(yield r)}R.filter=w;function*k(t,o){let r=0;for(const i of t)yield o(i,r++)}R.map=k;function*h(...t){for(const o of t)yield*o}R.concat=h;function f(t,o,r){let i=r;for(const n of t)i=o(i,n);return i}R.reduce=f;function*d(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}R.slice=d;function m(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const i=t[Symbol.iterator]();for(let n=0;n<o;n++){const a=i.next();if(a.done)return[r,R.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return i}}]}R.consume=m;async function c(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}R.asyncToArray=c})(S||(e.Iterable=S={}))}),define(ae[42],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function D(t,o=!1){let r=0;const i=t.length;let n="",a=0,p=16,A=0;function I(J){let le=0,oe=0;for(;le<J;){const ue=t.charCodeAt(r);if(ue>=48&&ue<=57)oe=oe*16+ue-48;else if(ue>=65&&ue<=70)oe=oe*16+ue-65+10;else if(ue>=97&&ue<=102)oe=oe*16+ue-97+10;else break;r++,le++}return le<J&&(oe=-1),oe}function E(J){r=J,n="",a=0,p=16,A=0}function C(){const J=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&l(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&l(t.charCodeAt(r)))for(r++;r<t.length&&l(t.charCodeAt(r));)r++;else return A=3,t.substring(J,r);let le=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&l(t.charCodeAt(r))){for(r++;r<t.length&&l(t.charCodeAt(r));)r++;le=r}else A=3;return t.substring(J,le)}function j(){let J="",le=r;for(;;){if(r>=i){J+=t.substring(le,r),A=2;break}const oe=t.charCodeAt(r);if(oe===34){J+=t.substring(le,r),r++;break}if(oe===92){if(J+=t.substring(le,r),r++,r>=i){A=2;break}switch(t.charCodeAt(r++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:{const Z=I(4);Z>=0?J+=String.fromCharCode(Z):A=4;break}default:A=5}le=r;continue}if(oe>=0&&oe<=31)if(g(oe)){J+=t.substring(le,r),A=2;break}else A=6;r++}return J}function U(){if(n="",A=0,a=r,r>=i)return a=i,p=17;let J=t.charCodeAt(r);if(P(J)){do r++,n+=String.fromCharCode(J),J=t.charCodeAt(r);while(P(J));return p=15}if(g(J))return r++,n+=String.fromCharCode(J),J===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),p=14;switch(J){case 123:return r++,p=1;case 125:return r++,p=2;case 91:return r++,p=3;case 93:return r++,p=4;case 58:return r++,p=6;case 44:return r++,p=5;case 34:return r++,n=j(),p=10;case 47:{const le=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!g(t.charCodeAt(r));)r++;return n=t.substring(le,r),p=12}if(t.charCodeAt(r+1)===42){r+=2;const oe=i-1;let ue=!1;for(;r<oe;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,A=1),n=t.substring(le,r),p=13}return n+=String.fromCharCode(J),r++,p=16}case 45:if(n+=String.fromCharCode(J),r++,r===i||!l(t.charCodeAt(r)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=C(),p=11;default:for(;r<i&&F(J);)r++,J=t.charCodeAt(r);if(a!==r){switch(n=t.substring(a,r),n){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return n+=String.fromCharCode(J),r++,p=16}}function F(J){if(P(J)||g(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let J;do J=U();while(J>=12&&J<=15);return J}return{setPosition:E,getPosition:()=>r,scan:o?V:U,getToken:()=>p,getTokenValue:()=>n,getTokenOffset:()=>a,getTokenLength:()=>r-a,getTokenError:()=>A}}e.$dn=D;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function v(t,o){const r=[],i=new Object;let n;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function A(I,E,C,j){a.value=I,a.offset=E,a.length=C,a.type=j,a.colonOffset=void 0,n=a}try{d(t,{onObjectBegin:(I,E)=>{if(o<=I)throw i;n=void 0,p=o>I,r.push("")},onObjectProperty:(I,E,C)=>{if(o<E||(A(I,E,C,"property"),r[r.length-1]=I,o<=E+C))throw i},onObjectEnd:(I,E)=>{if(o<=I)throw i;n=void 0,r.pop()},onArrayBegin:(I,E)=>{if(o<=I)throw i;n=void 0,r.push(0)},onArrayEnd:(I,E)=>{if(o<=I)throw i;n=void 0,r.pop()},onLiteralValue:(I,E,C)=>{if(o<E||(A(I,E,C,c(I)),o<=E+C))throw i},onSeparator:(I,E,C)=>{if(o<=E)throw i;if(I===":"&&n&&n.type==="property")n.colonOffset=E,p=!1,n=void 0;else if(I===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(p=!0,r[r.length-1]=""),n=void 0}}})}catch(I){if(I!==i)throw I}return{path:r,previousNode:n,isAtPropertyKey:p,matches:I=>{let E=0;for(let C=0;E<I.length&&C<r.length;C++)if(I[E]===r[C]||I[E]==="*")E++;else if(I[E]!=="**")return!1;return E===I.length}}}e.$en=v;function y(t,o=[],r=M.DEFAULT){let i=null,n=[];const a=[];function p(I){Array.isArray(n)?n.push(I):i!==null&&(n[i]=I)}return d(t,{onObjectBegin:()=>{const I={};p(I),a.push(n),n=I,i=null},onObjectProperty:I=>{i=I},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{const I=[];p(I),a.push(n),n=I,i=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:p,onError:(I,E,C)=>{o.push({error:I,offset:E,length:C})}},r),n[0]}e.$fn=y;function u(t,o=[],r=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(I){i.type==="property"&&(i.length=I-i.offset,i=i.parent)}function a(I){return i.children.push(I),I}d(t,{onObjectBegin:I=>{i=a({type:"object",offset:I,length:-1,parent:i,children:[]})},onObjectProperty:(I,E,C)=>{i=a({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:I,offset:E,length:C,parent:i})},onObjectEnd:(I,E)=>{i.length=I+E-i.offset,i=i.parent,n(I+E)},onArrayBegin:(I,E)=>{i=a({type:"array",offset:I,length:-1,parent:i,children:[]})},onArrayEnd:(I,E)=>{i.length=I+E-i.offset,i=i.parent,n(I+E)},onLiteralValue:(I,E,C)=>{a({type:c(I),offset:E,length:C,parent:i,value:I}),n(E+C)},onSeparator:(I,E,C)=>{i.type==="property"&&(I===":"?i.colonOffset=E:I===","&&n(E))},onError:(I,E,C)=>{o.push({error:I,offset:E,length:C})}},r);const A=i.children[0];return A&&delete A.parent,A}e.$gn=u;function $(t,o){if(!t)return;let r=t;for(const i of o)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const a of r.children)if(Array.isArray(a.children)&&a.children[0].value===i){r=a.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$hn=$;function w(t){if(!t.parent||!t.parent.children)return[];const o=w(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}e.$in=w;function k(t){switch(t.type){case"array":return t.children.map(k);case"object":{const o=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(o[r.children[0].value]=k(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$jn=k;function h(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}e.$kn=h;function f(t,o,r=!1){if(h(t,o,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const a=f(i[n],o,r);if(a)return a}return t}}e.$ln=f;function d(t,o,r=M.DEFAULT){const i=D(t,!1);function n(B){return B?()=>B(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(B){return B?te=>B(te,i.getTokenOffset(),i.getTokenLength()):()=>!0}const p=n(o.onObjectBegin),A=a(o.onObjectProperty),I=n(o.onObjectEnd),E=n(o.onArrayBegin),C=n(o.onArrayEnd),j=a(o.onLiteralValue),U=a(o.onSeparator),F=n(o.onComment),V=a(o.onError),J=r&&r.disallowComments,le=r&&r.allowTrailingComma;function oe(){for(;;){const B=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:J||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(B){case 12:case 13:J?ue(10):F();break;case 16:ue(1);break;case 15:case 14:break;default:return B}}}function ue(B,te=[],he=[]){if(V(B),te.length+he.length>0){let K=i.getToken();for(;K!==17;){if(te.indexOf(K)!==-1){oe();break}else if(he.indexOf(K)!==-1)break;K=oe()}}}function Z(B){const te=i.getTokenValue();return B?j(te):A(te),oe(),!0}function Y(){switch(i.getToken()){case 11:{let B=0;try{B=JSON.parse(i.getTokenValue()),typeof B!="number"&&(ue(2),B=0)}catch{ue(2)}j(B);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return oe(),!0}function q(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(Z(!1),i.getToken()===6?(U(":"),oe(),G()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function L(){p(),oe();let B=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(B||ue(4,[],[]),U(","),oe(),i.getToken()===2&&le)break}else B&&ue(6,[],[]);q()||ue(4,[],[2,5]),B=!0}return I(),i.getToken()!==2?ue(7,[2],[]):oe(),!0}function N(){E(),oe();let B=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(B||ue(4,[],[]),U(","),oe(),i.getToken()===4&&le)break}else B&&ue(6,[],[]);G()||ue(4,[],[4,5]),B=!0}return C(),i.getToken()!==4?ue(8,[4],[]):oe(),!0}function G(){switch(i.getToken()){case 3:return N();case 1:return L();case 10:return Z(!0);default:return Y()}}return oe(),i.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):G()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.$mn=d;function m(t,o){const r=D(t),i=[];let n,a=0,p;do switch(p=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:a!==p&&i.push(t.substring(a,p)),o!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,o)),a=r.getPosition();break}while(n!==17);return i.join("")}e.$nn=m;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$on=c}),define(ae[139],ce([0,1,42]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=e.$pn=void 0;function R(l,b,v){let y,u,$,w,k;if(b){for(w=b.offset,k=w+b.length,$=w;$>0&&!g(l,$-1);)$--;let p=k;for(;p<l.length&&!g(l,p);)p++;u=l.substring($,p),y=D(u,v)}else u=l,y=0,$=0,w=0,k=l.length;const h=P(v,l);let f=!1,d=0,m;v.insertSpaces?m=M(" ",v.tabSize||4):m="	";const c=(0,S.$dn)(u,!1);let t=!1;function o(){return h+M(m,y+d)}function r(){let p=c.scan();for(f=!1;p===15||p===14;)f=f||p===14,p=c.scan();return t=p===16||c.getTokenError()!==0,p}const i=[];function n(p,A,I){!t&&A<k&&I>w&&l.substring(A,I)!==p&&i.push({offset:A,length:I-A,content:p})}let a=r();if(a!==17){const p=c.getTokenOffset()+$,A=M(m,y);n(A,$,p)}for(;a!==17;){let p=c.getTokenOffset()+c.getTokenLength()+$,A=r(),I="";for(;!f&&(A===12||A===13);){const C=c.getTokenOffset()+$;n(" ",p,C),p=c.getTokenOffset()+c.getTokenLength()+$,I=A===12?o():"",A=r()}if(A===2)a!==1&&(d--,I=o());else if(A===4)a!==3&&(d--,I=o());else{switch(a){case 3:case 1:d++,I=o();break;case 5:case 12:I=o();break;case 13:f?I=o():I=" ";break;case 6:I=" ";break;case 10:if(A===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:A===12||A===13?I=" ":A!==5&&A!==17&&(t=!0);break;case 16:t=!0;break}f&&(A===12||A===13)&&(I=o())}const E=c.getTokenOffset()+$;n(I,p,E),a=A}return i}e.$pn=R;function s(l,b){const v=JSON.stringify(l,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?v.replace(/\r\n|\r|\n/g,b.eol):v}e.$qn=s;function M(l,b){let v="";for(let y=0;y<b;y++)v+=l;return v}function D(l,b){let v=0,y=0;const u=b.tabSize||4;for(;v<l.length;){const $=l.charAt(v);if($===" ")y++;else if($==="	")y+=u;else break;v++}return Math.floor(y/u)}function P(l,b){for(let v=0;v<b.length;v++){const y=b.charAt(v);if(y==="\r")return v+1<b.length&&b.charAt(v+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return l&&l.eol||`
`}e.$rn=P;function g(l,b){return`\r
`.indexOf(l.charAt(b))!==-1}e.$sn=g}),define(ae[101],ce([0,1,42,139]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=void 0;function s(l,b,v){return M(l,b,void 0,v)}e.$tn=s;function M(l,b,v,y,u){const $=b.slice(),w=[],k=(0,S.$gn)(l,w);let h,f;for(;$.length>0&&(f=$.pop(),h=(0,S.$hn)(k,$),h===void 0&&v!==void 0);)typeof f=="string"?v={[f]:v}:v=[v];if(h)if(h.type==="object"&&typeof f=="string"&&Array.isArray(h.children)){const d=(0,S.$hn)(h,[f]);if(d!==void 0)if(v===void 0){if(!d.parent)throw new Error("Malformed AST");const m=h.children.indexOf(d.parent);let c,t=d.parent.offset+d.parent.length;if(m>0){const o=h.children[m-1];c=o.offset+o.length}else c=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return D(l,{offset:c,length:t-c,content:""},y)}else return D(l,{offset:d.offset,length:d.length,content:JSON.stringify(v)},y);else{if(v===void 0)return[];const m=`${JSON.stringify(f)}: ${JSON.stringify(v)}`,c=u?u(h.children.map(o=>o.children[0].value)):h.children.length;let t;if(c>0){const o=h.children[c-1];t={offset:o.offset+o.length,length:0,content:","+m}}else h.children.length===0?t={offset:h.offset+1,length:0,content:m}:t={offset:h.offset+1,length:0,content:m+","};return D(l,t,y)}}else if(h.type==="array"&&typeof f=="number"&&Array.isArray(h.children))if(v!==void 0){const d=`${JSON.stringify(v)}`;let m;if(h.children.length===0||f===0)m={offset:h.offset+1,length:0,content:h.children.length===0?d:d+","};else{const c=f===-1||f>h.children.length?h.children.length:f,t=h.children[c-1];m={offset:t.offset+t.length,length:0,content:","+d}}return D(l,m,y)}else{const d=f,m=h.children[d];let c;if(h.children.length===1)c={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===d){const t=h.children[d-1],o=t.offset+t.length,r=h.offset+h.length;c={offset:o,length:r-2-o,content:""}}else c={offset:m.offset,length:h.children[d+1].offset-m.offset,content:""};return D(l,c,y)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${h.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return D(l,{offset:k?k.offset:0,length:k?k.length:0,content:JSON.stringify(v)},y)}}e.$un=M;function D(l,b,v){let y=P(l,b),u=b.offset,$=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;u>0&&!(0,R.$sn)(y,u-1);)u--;for(;$<y.length&&!(0,R.$sn)(y,$);)$++}const w=(0,R.$pn)(y,{offset:u,length:$-u},v);for(let h=w.length-1;h>=0;h--){const f=w[h];y=P(y,f),u=Math.min(u,f.offset),$=Math.max($,f.offset+f.length),$+=f.content.length-f.length}const k=l.length-(y.length-$)-u;return[{offset:u,length:k,content:y.substring(u,$)}]}e.$vn=D;function P(l,b){return l.substring(0,b.offset)+b.content+l.substring(b.offset+b.length)}e.$wn=P;function g(l,b){const v=b.slice(0).sort((u,$)=>{const w=u.offset-$.offset;return w===0?u.length-$.length:w});let y=l.length;for(let u=v.length-1;u>=0;u--){const $=v[u];if($.offset+$.length<=y)l=P(l,$);else throw new Error("Overlapping edit");y=$.offset}return l}e.$xn=g}),define(ae[62],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class S{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=S}),define(ae[102],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class S{static{this.Undefined=new S(void 0)}constructor(M){this.element=M,this.next=S.Undefined,this.prev=S.Undefined}}class R{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let M=this.a;for(;M!==S.Undefined;){const D=M.next;M.prev=S.Undefined,M.next=S.Undefined,M=D}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,D){const P=new S(M);if(this.a===S.Undefined)this.a=P,this.b=P;else if(D){const l=this.b;this.b=P,P.prev=l,l.next=P}else{const l=this.a;this.a=P,P.next=l,l.prev=P}this.c+=1;let g=!1;return()=>{g||(g=!0,this.e(P))}}shift(){if(this.a!==S.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==S.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==S.Undefined&&M.next!==S.Undefined){const D=M.prev;D.next=M.next,M.next.prev=D}else M.prev===S.Undefined&&M.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):M.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):M.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==S.Undefined;)yield M.element,M=M.next}}e.$4c=R}),define(ae[31],ce([0,1]),function(X,e){"use strict";var S,R,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function M(d,m,c){let t=d.get(m);return t===void 0&&(t=c,d.set(m,t)),t}e.$xc=M;function D(d){const m=[];return d.forEach((c,t)=>{m.push(`${t} => ${c}`)}),`Map(${d.size}) {${m.join(", ")}}`}e.$yc=D;function P(d){const m=[];return d.forEach(c=>{m.push(c)}),`Set(${d.size}) {${m.join(", ")}}`}e.$zc=P;class g{constructor(m,c){this.uri=m,this.value=c}}function l(d){return Array.isArray(d)}class b{static{this.c=m=>m.toString()}constructor(m,c){if(this[S]="ResourceMap",m instanceof b)this.d=new Map(m.d),this.e=c??b.c;else if(l(m)){this.d=new Map,this.e=c??b.c;for(const[t,o]of m)this.set(t,o)}else this.d=new Map,this.e=m??b.c}set(m,c){return this.d.set(this.e(m),new g(m,c)),this}get(m){return this.d.get(this.e(m))?.value}has(m){return this.d.has(this.e(m))}get size(){return this.d.size}clear(){this.d.clear()}delete(m){return this.d.delete(this.e(m))}forEach(m,c){typeof c<"u"&&(m=m.bind(c));for(const[t,o]of this.d)m(o.value,o.uri,this)}*values(){for(const m of this.d.values())yield m.value}*keys(){for(const m of this.d.values())yield m.uri}*entries(){for(const m of this.d.values())yield[m.uri,m.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,m]of this.d)yield[m.uri,m.value]}}e.$Ac=b;class v{constructor(m,c){this[R]="ResourceSet",!m||typeof m=="function"?this.c=new b(m):(this.c=new b(c),m.forEach(this.add,this))}get size(){return this.c.size}add(m){return this.c.set(m,m),this}clear(){this.c.clear()}delete(m){return this.c.delete(m)}forEach(m,c){this.c.forEach((t,o)=>m.call(c,o,o,this))}has(m){return this.c.has(m)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=v;var y;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class u{constructor(){this[s]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(m){return this.c.has(m)}get(m,c=0){const t=this.c.get(m);if(t)return c!==0&&this.l(t,c),t.value}set(m,c,t=0){let o=this.c.get(m);if(o)o.value=c,t!==0&&this.l(o,t);else{switch(o={key:m,value:c,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(m,o),this.f++}return this}delete(m){return!!this.remove(m)}remove(m){const c=this.c.get(m);if(c)return this.c.delete(m),this.k(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const m=this.d;return this.c.delete(m.key),this.k(m),this.f--,m.value}forEach(m,c){const t=this.g;let o=this.d;for(;o;){if(c?m.bind(c)(o.value,o.key,this):m(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const m=this,c=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(m.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.key,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}values(){const m=this,c=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(m.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.value,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}entries(){const m=this,c=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(m.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:[t.key,t.value],done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(m){if(m>=this.size)return;if(m===0){this.clear();return}let c=this.d,t=this.size;for(;c&&t>m;)this.c.delete(c.key),c=c.next,t--;this.d=c,this.f=t,c&&(c.previous=void 0),this.g++}i(m){if(!this.d&&!this.e)this.e=m;else if(this.d)m.next=this.d,this.d.previous=m;else throw new Error("Invalid list");this.d=m,this.g++}j(m){if(!this.d&&!this.e)this.d=m;else if(this.e)m.previous=this.e,this.e.next=m;else throw new Error("Invalid list");this.e=m,this.g++}k(m){if(m===this.d&&m===this.e)this.d=void 0,this.e=void 0;else if(m===this.d){if(!m.next)throw new Error("Invalid list");m.next.previous=void 0,this.d=m.next}else if(m===this.e){if(!m.previous)throw new Error("Invalid list");m.previous.next=void 0,this.e=m.previous}else{const c=m.next,t=m.previous;if(!c||!t)throw new Error("Invalid list");c.previous=t,t.next=c}m.next=void 0,m.previous=void 0,this.g++}l(m,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(m===this.d)return;const t=m.next,o=m.previous;m===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),m.previous=void 0,m.next=this.d,this.d.previous=m,this.d=m,this.g++}else if(c===2){if(m===this.e)return;const t=m.next,o=m.previous;m===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),m.next=void 0,m.previous=this.e,this.e.next=m,this.e=m,this.g++}}}toJSON(){const m=[];return this.forEach((c,t)=>{m.push([t,c])}),m}fromJSON(m){this.clear();for(const[c,t]of m)this.set(c,t)}}e.$Cc=u;class $ extends u{constructor(m,c=1){super(),this.m=m,this.n=Math.min(Math.max(0,c),1)}get limit(){return this.m}set limit(m){this.m=m,this.o()}get ratio(){return this.n}set ratio(m){this.n=Math.min(Math.max(0,m),1),this.o()}get(m,c=2){return super.get(m,c)}peek(m){return super.get(m,0)}set(m,c){return super.set(m,c,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=$;class w{constructor(){this.c=new Map}add(m){return this.c.set(m,(this.c.get(m)||0)+1),this}delete(m){let c=this.c.get(m)||0;return c===0?!1:(c--,c===0?this.c.delete(m):this.c.set(m,c),!0)}has(m){return this.c.has(m)}}e.$Ec=w;class k{constructor(m){if(this.c=new Map,this.d=new Map,m)for(const[c,t]of m)this.set(c,t)}clear(){this.c.clear(),this.d.clear()}set(m,c){this.c.set(m,c),this.d.set(c,m)}get(m){return this.c.get(m)}getKey(m){return this.d.get(m)}delete(m){const c=this.c.get(m);return c===void 0?!1:(this.c.delete(m),this.d.delete(c),!0)}forEach(m,c){this.c.forEach((t,o)=>{m.call(c,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=k;class h{constructor(){this.c=new Map}add(m,c){let t=this.c.get(m);t||(t=new Set,this.c.set(m,t)),t.add(c)}delete(m,c){const t=this.c.get(m);t&&(t.delete(c),t.size===0&&this.c.delete(m))}forEach(m,c){const t=this.c.get(m);t&&t.forEach(c)}get(m){const c=this.c.get(m);return c||new Set}}e.$Gc=h;function f(d,m){if(d===m)return!0;if(d.size!==m.size)return!1;for(const[c,t]of d)if(!m.has(c)||m.get(c)!==t)return!1;for(const[c]of m)if(!d.has(c))return!1;return!0}e.$Hc=f}),define(ae[2],ce([0,1,22,136,31,84,71]),function(X,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const P=!1;let g=null;class l{constructor(){this.b=new Map}static{this.a=0}c(j){let U=this.b.get(j);return U||(U={parent:null,source:null,isSingleton:!1,value:j,idx:l.a++},this.b.set(j,U)),U}trackDisposable(j){const U=this.c(j);U.source||(U.source=new Error().stack)}setParent(j,U){const F=this.c(j);F.parent=U}markAsDisposed(j){this.b.delete(j)}markAsSingleton(j){this.c(j).isSingleton=!0}f(j,U){const F=U.get(j);if(F)return F;const V=j.parent?this.f(this.c(j.parent),U):j;return U.set(j,V),V}getTrackedDisposables(){const j=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,j).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(j=10,U){let F;if(U)F=U;else{const ue=new Map,Z=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,ue).isSingleton);if(Z.length===0)return;const Y=new Set(Z.map(q=>q.value));if(F=Z.filter(q=>!(q.parent&&Y.has(q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function V(ue){function Z(q,L){for(;q.length>0&&L.some(N=>typeof N=="string"?N===q[0]:q[0].match(N));)q.shift()}const Y=ue.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return Z(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const J=new s.$Gc;for(const ue of F){const Z=V(ue);for(let Y=0;Y<=Z.length;Y++)J.add(Z.slice(0,Y).join(`
`),ue)}F.sort((0,S.$7b)(ue=>ue.idx,S.$9b));let le="",oe=0;for(const ue of F.slice(0,j)){oe++;const Z=V(ue),Y=[];for(let q=0;q<Z.length;q++){let L=Z[q];L=`(shared with ${J.get(Z.slice(0,q+1).join(`
`)).size}/${F.length} leaks) at ${L}`;const G=J.get(Z.slice(0,q).join(`
`)),B=(0,R.$K)([...G].map(te=>V(te)[q]),te=>te);delete B[Z[q]];for(const[te,he]of Object.entries(B))Y.unshift(`    - stacktraces of ${he.length} other leaks continue with ${te}`);Y.unshift(L)}le+=`


==================== Leaking disposable ${oe}/${F.length}: ${ue.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return F.length>j&&(le+=`


... and ${F.length-j} more leaking disposables

`),{leaks:F,details:le}}}e.$Ic=l;function b(C){g=C}if(e.$Jc=b,P){const C="__is_disposable_tracked__";b(new class{trackDisposable(j){const U=new Error("Potentially leaked disposable").stack;setTimeout(()=>{j[C]||console.log(U)},3e3)}setParent(j,U){if(j&&j!==t.None)try{j[C]=!0}catch{}}markAsDisposed(j){if(j&&j!==t.None)try{j[C]=!0}catch{}}markAsSingleton(j){}})}function v(C){return g?.trackDisposable(C),C}e.$Kc=v;function y(C){g?.markAsDisposed(C)}e.$Lc=y;function u(C,j){g?.setParent(C,j)}function $(C,j){if(g)for(const U of C)g.setParent(U,j)}function w(C){return g?.markAsSingleton(C),C}e.$Mc=w;function k(C){return typeof C.dispose=="function"&&C.dispose.length===0}e.$Nc=k;function h(C){if(D.Iterable.is(C)){const j=[];for(const U of C)if(U)try{U.dispose()}catch(F){j.push(F)}if(j.length===1)throw j[0];if(j.length>1)throw new AggregateError(j,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}e.$Oc=h;function f(C){for(const j of C)k(j)&&j.dispose();return[]}e.$Pc=f;function d(...C){const j=m(()=>h(C));return $(C,j),j}e.$Qc=d;function m(C){const j=v({dispose:(0,M.$db)(()=>{y(j),C()})});return j}e.$Rc=m;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||(y(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(j){if(!j)return j;if(j===this)throw new Error("Cannot register a disposable on itself!");return u(j,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(j),j}delete(j){if(j){if(j===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(j),j.dispose()}}deleteAndLeak(j){j&&this.f.has(j)&&(this.f.delete(j),u(j,null))}}e.$Sc=c;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,v(this),u(this.q,this)}dispose(){y(this),this.q.dispose()}B(j){if(j===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(j)}}e.$Tc=t;class o{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(j){this.b||j===this.a||(this.a?.dispose(),j&&u(j,this),this.a=j)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const j=this.a;return this.a=void 0,j&&u(j,null),j}}e.$Uc=o;class r{constructor(j){this.a=new o,this.b=!1,this.a.value=j}get value(){return this.a.value}set value(j){this.b||j===this.a.value||(this.a.value=j)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=r;class i{constructor(j){this.b=j,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(j){let U=j;return this.unset=()=>U=void 0,this.isset=()=>U!==void 0,this.dispose=()=>{U&&(U(),U=void 0,y(this))},this}}e.$Xc=n;class a{constructor(){this.a=new Map}acquire(j,...U){let F=this.a.get(j);F||(F={counter:0,object:this.b(j,...U)},this.a.set(j,F));const{object:V}=F,J=(0,M.$db)(()=>{--F.counter===0&&(this.c(j,F.object),this.a.delete(j))});return F.counter++,{object:V,dispose:J}}}e.$Yc=a;class p{constructor(j){this.a=j}async acquire(j,...U){const F=this.a.acquire(j,...U);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(V){throw F.dispose(),V}}}e.$Zc=p;class A{constructor(j){this.object=j}dispose(){}}e.$1c=A;function I(C){const j=new c;try{C(j)}finally{j.dispose()}}e.$2c=I;class E{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(j){return this.a.has(j)}get size(){return this.a.size}get(j){return this.a.get(j)}set(j,U,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(j)?.dispose(),this.a.set(j,U)}deleteAndDispose(j){this.a.get(j)?.dispose(),this.a.delete(j)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=E}),define(ae[85],ce([0,1,31]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=void 0;const R=new S.$Dc(1e4);function s(l){return g(l,"NFC",R)}e.$Il=s;const M=new S.$Dc(1e4);function D(l){return g(l,"NFD",M)}e.$Jl=D;const P=/[^\u0000-\u0080]/;function g(l,b,v){if(!l)return l;const y=v.get(l);if(y)return y;let u;return P.test(l)?u=l.normalize(b):u=l,v.set(l,u),u}e.$Kl=function(){const l=/[\u0300-\u036f]/g;return function(b){return D(b).replace(l,"")}}()}),define(ae[140],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.rot=e.$9l=void 0;function S(P,g,l){return Math.min(Math.max(P,g),l)}e.$9l=S;function R(P,g){return(g+P%g)%g}e.rot=R;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$$l=s;class M{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$_l=M;class D{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const l=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$am=D}),function(){function X(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function D(g){M.push(g,Date.now())}function P(){const g=[];for(let l=0;l<M.length;l+=2)g.push({name:M[l],startTime:M[l+1]});return g}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const D of performance.getEntriesByType("mark"))M.push({name:D.name,startTime:Math.round(s+D.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function S(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=S(R))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var R in S)(typeof exports=="object"?exports:X)[R]=S[R]}}(typeof self<"u"?self:this,function(){return function(X){var e={};function S(R){if(e[R])return e[R].exports;var s=e[R]={i:R,l:!1,exports:{}};return X[R].call(s.exports,s,s.exports,S),s.l=!0,s.exports}return S.m=X,S.c=e,S.d=function(R,s,M){S.o(R,s)||Object.defineProperty(R,s,{enumerable:!0,get:M})},S.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},S.t=function(R,s){if(1&s&&(R=S(R)),8&s||4&s&&typeof R=="object"&&R&&R.__esModule)return R;var M=Object.create(null);if(S.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:R}),2&s&&typeof R!="string")for(var D in R)S.d(M,D,function(P){return R[P]}.bind(null,D));return M},S.n=function(R){var s=R&&R.__esModule?function(){return R.default}:function(){return R};return S.d(s,"a",s),s},S.o=function(R,s){return Object.prototype.hasOwnProperty.call(R,s)},S.p="",S(S.s=0)}([function(X,e,S){(function(R){var s;e=X.exports=he,s=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],g=e.src=[],l=0,b=l++;g[b]="0|[1-9]\\d*";var v=l++;g[v]="[0-9]+";var y=l++;g[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=l++;g[u]="("+g[b]+")\\.("+g[b]+")\\.("+g[b]+")";var $=l++;g[$]="("+g[v]+")\\.("+g[v]+")\\.("+g[v]+")";var w=l++;g[w]="(?:"+g[b]+"|"+g[y]+")";var k=l++;g[k]="(?:"+g[v]+"|"+g[y]+")";var h=l++;g[h]="(?:-("+g[w]+"(?:\\."+g[w]+")*))";var f=l++;g[f]="(?:-?("+g[k]+"(?:\\."+g[k]+")*))";var d=l++;g[d]="[0-9A-Za-z-]+";var m=l++;g[m]="(?:\\+("+g[d]+"(?:\\."+g[d]+")*))";var c=l++,t="v?"+g[u]+g[h]+"?"+g[m]+"?";g[c]="^"+t+"$";var o="[v=\\s]*"+g[$]+g[f]+"?"+g[m]+"?",r=l++;g[r]="^"+o+"$";var i=l++;g[i]="((?:<|>)?=?)";var n=l++;g[n]=g[v]+"|x|X|\\*";var a=l++;g[a]=g[b]+"|x|X|\\*";var p=l++;g[p]="[v=\\s]*("+g[a]+")(?:\\.("+g[a]+")(?:\\.("+g[a]+")(?:"+g[h]+")?"+g[m]+"?)?)?";var A=l++;g[A]="[v=\\s]*("+g[n]+")(?:\\.("+g[n]+")(?:\\.("+g[n]+")(?:"+g[f]+")?"+g[m]+"?)?)?";var I=l++;g[I]="^"+g[i]+"\\s*"+g[p]+"$";var E=l++;g[E]="^"+g[i]+"\\s*"+g[A]+"$";var C=l++;g[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=l++;g[j]="(?:~>?)";var U=l++;g[U]="(\\s*)"+g[j]+"\\s+",P[U]=new RegExp(g[U],"g");var F=l++;g[F]="^"+g[j]+g[p]+"$";var V=l++;g[V]="^"+g[j]+g[A]+"$";var J=l++;g[J]="(?:\\^)";var le=l++;g[le]="(\\s*)"+g[J]+"\\s+",P[le]=new RegExp(g[le],"g");var oe=l++;g[oe]="^"+g[J]+g[p]+"$";var ue=l++;g[ue]="^"+g[J]+g[A]+"$";var Z=l++;g[Z]="^"+g[i]+"\\s*("+o+")$|^$";var Y=l++;g[Y]="^"+g[i]+"\\s*("+t+")$|^$";var q=l++;g[q]="(\\s*)"+g[i]+"\\s*("+o+"|"+g[p]+")",P[q]=new RegExp(g[q],"g");var L=l++;g[L]="^\\s*("+g[p]+")\\s+-\\s+("+g[p]+")\\s*$";var N=l++;g[N]="^\\s*("+g[A]+")\\s+-\\s+("+g[A]+")\\s*$";var G=l++;g[G]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)s(B,g[B]),P[B]||(P[B]=new RegExp(g[B]));function te(ie,fe){if(ie instanceof he)return ie;if(typeof ie!="string"||ie.length>M||!(fe?P[r]:P[c]).test(ie))return null;try{return new he(ie,fe)}catch{return null}}function he(ie,fe){if(ie instanceof he){if(ie.loose===fe)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof he))return new he(ie,fe);s("SemVer",ie,fe),this.loose=fe;var $e=ie.trim().match(fe?P[r]:P[c]);if(!$e)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+$e[1],this.minor=+$e[2],this.patch=+$e[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");$e[4]?this.prerelease=$e[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Me=+Ie;if(Me>=0&&Me<D)return Me}return Ie}):this.prerelease=[],this.build=$e[5]?$e[5].split("."):[],this.format()}e.parse=te,e.valid=function(ie,fe){var $e=te(ie,fe);return $e?$e.version:null},e.clean=function(ie,fe){var $e=te(ie.trim().replace(/^[=v]+/,""),fe);return $e?$e.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(ie){return s("SemVer.compare",this.version,this.loose,ie),ie instanceof he||(ie=new he(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},he.prototype.compareMain=function(ie){return ie instanceof he||(ie=new he(ie,this.loose)),O(this.major,ie.major)||O(this.minor,ie.minor)||O(this.patch,ie.patch)},he.prototype.comparePre=function(ie){if(ie instanceof he||(ie=new he(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var fe=0;do{var $e=this.prerelease[fe],Ie=ie.prerelease[fe];if(s("prerelease compare",fe,$e,Ie),$e===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if($e===void 0)return-1;if($e!==Ie)return O($e,Ie)}while(++fe)},he.prototype.inc=function(ie,fe){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $e=this.prerelease.length;--$e>=0;)typeof this.prerelease[$e]=="number"&&(this.prerelease[$e]++,$e=-2);$e===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,fe,$e,Ie){typeof $e=="string"&&(Ie=$e,$e=void 0);try{return new he(ie,$e).inc(fe,Ie).version}catch{return null}},e.diff=function(ie,fe){if(Q(ie,fe))return null;var $e=te(ie),Ie=te(fe);if($e.prerelease.length||Ie.prerelease.length){for(var Me in $e)if((Me==="major"||Me==="minor"||Me==="patch")&&$e[Me]!==Ie[Me])return"pre"+Me;return"prerelease"}for(var Me in $e)if((Me==="major"||Me==="minor"||Me==="patch")&&$e[Me]!==Ie[Me])return Me},e.compareIdentifiers=O;var K=/^[0-9]+$/;function O(ie,fe){var $e=K.test(ie),Ie=K.test(fe);return $e&&Ie&&(ie=+ie,fe=+fe),$e&&!Ie?-1:Ie&&!$e?1:ie<fe?-1:ie>fe?1:0}function W(ie,fe,$e){return new he(ie,$e).compare(new he(fe,$e))}function x(ie,fe,$e){return W(ie,fe,$e)>0}function T(ie,fe,$e){return W(ie,fe,$e)<0}function Q(ie,fe,$e){return W(ie,fe,$e)===0}function H(ie,fe,$e){return W(ie,fe,$e)!==0}function _(ie,fe,$e){return W(ie,fe,$e)>=0}function z(ie,fe,$e){return W(ie,fe,$e)<=0}function ee(ie,fe,$e,Ie){var Me;switch(fe){case"===":typeof ie=="object"&&(ie=ie.version),typeof $e=="object"&&($e=$e.version),Me=ie===$e;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof $e=="object"&&($e=$e.version),Me=ie!==$e;break;case"":case"=":case"==":Me=Q(ie,$e,Ie);break;case"!=":Me=H(ie,$e,Ie);break;case">":Me=x(ie,$e,Ie);break;case">=":Me=_(ie,$e,Ie);break;case"<":Me=T(ie,$e,Ie);break;case"<=":Me=z(ie,$e,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return Me}function se(ie,fe){if(ie instanceof se){if(ie.loose===fe)return ie;ie=ie.value}if(!(this instanceof se))return new se(ie,fe);s("comparator",ie,fe),this.loose=fe,this.parse(ie),this.semver===de?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(ie,fe){return O(fe,ie)},e.major=function(ie,fe){return new he(ie,fe).major},e.minor=function(ie,fe){return new he(ie,fe).minor},e.patch=function(ie,fe){return new he(ie,fe).patch},e.compare=W,e.compareLoose=function(ie,fe){return W(ie,fe,!0)},e.rcompare=function(ie,fe,$e){return W(fe,ie,$e)},e.sort=function(ie,fe){return ie.sort(function($e,Ie){return e.compare($e,Ie,fe)})},e.rsort=function(ie,fe){return ie.sort(function($e,Ie){return e.rcompare($e,Ie,fe)})},e.gt=x,e.lt=T,e.eq=Q,e.neq=H,e.gte=_,e.lte=z,e.cmp=ee,e.Comparator=se;var de={};function me(ie,fe){if(ie instanceof me)return ie.loose===fe?ie:new me(ie.raw,fe);if(ie instanceof se)return new me(ie.value,fe);if(!(this instanceof me))return new me(ie,fe);if(this.loose=fe,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function($e){return this.parseRange($e.trim())},this).filter(function($e){return $e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function Ee(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function Pe(ie,fe,$e,Ie,Me,Ne,je,Je,Be,He,Ve,ne,ge){return((fe=Ee($e)?"":Ee(Ie)?">="+$e+".0.0":Ee(Me)?">="+$e+"."+Ie+".0":">="+fe)+" "+(Je=Ee(Be)?"":Ee(He)?"<"+(+Be+1)+".0.0":Ee(Ve)?"<"+Be+"."+(+He+1)+".0":ne?"<="+Be+"."+He+"."+Ve+"-"+ne:"<="+Je)).trim()}function Le(ie,fe){for(var $e=0;$e<ie.length;$e++)if(!ie[$e].test(fe))return!1;if(fe.prerelease.length){for($e=0;$e<ie.length;$e++)if(s(ie[$e].semver),ie[$e].semver!==de&&ie[$e].semver.prerelease.length>0){var Ie=ie[$e].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function ke(ie,fe,$e){try{fe=new me(fe,$e)}catch{return!1}return fe.test(ie)}function pe(ie,fe,$e,Ie){var Me,Ne,je,Je,Be;switch(ie=new he(ie,Ie),fe=new me(fe,Ie),$e){case">":Me=x,Ne=z,je=T,Je=">",Be=">=";break;case"<":Me=T,Ne=_,je=x,Je="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(ie,fe,Ie))return!1;for(var He=0;He<fe.set.length;++He){var Ve=fe.set[He],ne=null,ge=null;if(Ve.forEach(function(be){be.semver===de&&(be=new se(">=0.0.0")),ne=ne||be,ge=ge||be,Me(be.semver,ne.semver,Ie)?ne=be:je(be.semver,ge.semver,Ie)&&(ge=be)}),ne.operator===Je||ne.operator===Be||(!ge.operator||ge.operator===Je)&&Ne(ie,ge.semver)||ge.operator===Be&&je(ie,ge.semver))return!1}return!0}se.prototype.parse=function(ie){var fe=this.loose?P[Z]:P[Y],$e=ie.match(fe);if(!$e)throw new TypeError("Invalid comparator: "+ie);this.operator=$e[1],this.operator==="="&&(this.operator=""),$e[2]?this.semver=new he($e[2],this.loose):this.semver=de},se.prototype.toString=function(){return this.value},se.prototype.test=function(ie){return s("Comparator.test",ie,this.loose),this.semver===de||(typeof ie=="string"&&(ie=new he(ie,this.loose)),ee(ie,this.operator,this.semver,this.loose))},se.prototype.intersects=function(ie,fe){if(!(ie instanceof se))throw new TypeError("a Comparator is required");var $e;if(this.operator==="")return $e=new me(ie.value,fe),ke(this.value,$e,fe);if(ie.operator==="")return $e=new me(this.value,fe),ke(ie.semver,$e,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),Ne=this.semver.version===ie.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),Je=ee(this.semver,"<",ie.semver,fe)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),Be=ee(this.semver,">",ie.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return Ie||Me||Ne&&je||Je||Be},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(ie){var fe=this.loose;ie=ie.trim(),s("range",ie,fe);var $e=fe?P[N]:P[L];ie=ie.replace($e,Pe),s("hyphen replace",ie),ie=ie.replace(P[q],"$1$2$3"),s("comparator trim",ie,P[q]),ie=(ie=(ie=ie.replace(P[U],"$1~")).replace(P[le],"$1^")).split(/\s+/).join(" ");var Ie=fe?P[Z]:P[Y],Me=ie.split(" ").map(function(Ne){return function(je,Je){return s("comp",je),je=function(Be,He){return Be.trim().split(/\s+/).map(function(Ve){return function(ne,ge){s("caret",ne,ge);var be=ge?P[ue]:P[oe];return ne.replace(be,function(Se,ye,Re,Ue,qe){var Xe;return s("caret",ne,Se,ye,Re,Ue,qe),Ee(ye)?Xe="":Ee(Re)?Xe=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ee(Ue)?Xe=ye==="0"?">="+ye+"."+Re+".0 <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+".0 <"+(+ye+1)+".0.0":qe?(s("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Xe=ye==="0"?Re==="0"?">="+ye+"."+Re+"."+Ue+qe+" <"+ye+"."+Re+"."+(+Ue+1):">="+ye+"."+Re+"."+Ue+qe+" <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+"."+Ue+qe+" <"+(+ye+1)+".0.0"):(s("no pr"),Xe=ye==="0"?Re==="0"?">="+ye+"."+Re+"."+Ue+" <"+ye+"."+Re+"."+(+Ue+1):">="+ye+"."+Re+"."+Ue+" <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+"."+Ue+" <"+(+ye+1)+".0.0"),s("caret return",Xe),Xe})}(Ve,He)}).join(" ")}(je,Je),s("caret",je),je=function(Be,He){return Be.trim().split(/\s+/).map(function(Ve){return function(ne,ge){var be=ge?P[V]:P[F];return ne.replace(be,function(Se,ye,Re,Ue,qe){var Xe;return s("tilde",ne,Se,ye,Re,Ue,qe),Ee(ye)?Xe="":Ee(Re)?Xe=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ee(Ue)?Xe=">="+ye+"."+Re+".0 <"+ye+"."+(+Re+1)+".0":qe?(s("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Xe=">="+ye+"."+Re+"."+Ue+qe+" <"+ye+"."+(+Re+1)+".0"):Xe=">="+ye+"."+Re+"."+Ue+" <"+ye+"."+(+Re+1)+".0",s("tilde return",Xe),Xe})}(Ve,He)}).join(" ")}(je,Je),s("tildes",je),je=function(Be,He){return s("replaceXRanges",Be,He),Be.split(/\s+/).map(function(Ve){return function(ne,ge){ne=ne.trim();var be=ge?P[E]:P[I];return ne.replace(be,function(Se,ye,Re,Ue,qe,Xe){s("xRange",ne,Se,ye,Re,Ue,qe,Xe);var xe=Ee(Re),Ye=xe||Ee(Ue),Qe=Ye||Ee(qe);return ye==="="&&Qe&&(ye=""),xe?Se=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Qe?(Ye&&(Ue=0),Qe&&(qe=0),ye===">"?(ye=">=",Ye?(Re=+Re+1,Ue=0,qe=0):Qe&&(Ue=+Ue+1,qe=0)):ye==="<="&&(ye="<",Ye?Re=+Re+1:Ue=+Ue+1),Se=ye+Re+"."+Ue+"."+qe):Ye?Se=">="+Re+".0.0 <"+(+Re+1)+".0.0":Qe&&(Se=">="+Re+"."+Ue+".0 <"+Re+"."+(+Ue+1)+".0"),s("xRange return",Se),Se})}(Ve,He)}).join(" ")}(je,Je),s("xrange",je),je=function(Be,He){return s("replaceStars",Be,He),Be.trim().replace(P[G],"")}(je,Je),s("stars",je),je}(Ne,fe)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(Ne){return!!Ne.match(Ie)})),Me=Me.map(function(Ne){return new se(Ne,fe)})},me.prototype.intersects=function(ie,fe){if(!(ie instanceof me))throw new TypeError("a Range is required");return this.set.some(function($e){return $e.every(function(Ie){return ie.set.some(function(Me){return Me.every(function(Ne){return Ie.intersects(Ne,fe)})})})})},e.toComparators=function(ie,fe){return new me(ie,fe).set.map(function($e){return $e.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},me.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new he(ie,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Le(this.set[fe],ie))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(ie,fe,$e){var Ie=null,Me=null;try{var Ne=new me(fe,$e)}catch{return null}return ie.forEach(function(je){Ne.test(je)&&(Ie&&Me.compare(je)!==-1||(Me=new he(Ie=je,$e)))}),Ie},e.minSatisfying=function(ie,fe,$e){var Ie=null,Me=null;try{var Ne=new me(fe,$e)}catch{return null}return ie.forEach(function(je){Ne.test(je)&&(Ie&&Me.compare(je)!==1||(Me=new he(Ie=je,$e)))}),Ie},e.validRange=function(ie,fe){try{return new me(ie,fe).range||"*"}catch{return null}},e.ltr=function(ie,fe,$e){return pe(ie,fe,"<",$e)},e.gtr=function(ie,fe,$e){return pe(ie,fe,">",$e)},e.outside=pe,e.prerelease=function(ie,fe){var $e=te(ie,fe);return $e&&$e.prerelease.length?$e.prerelease:null},e.intersects=function(ie,fe,$e){return ie=new me(ie,$e),fe=new me(fe,$e),ie.intersects(fe)},e.coerce=function(ie){if(ie instanceof he)return ie;if(typeof ie!="string")return null;var fe=ie.match(P[C]);return fe==null?null:te((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,S(1))},function(X,e){var S,R,s=X.exports={};function M(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P(k){if(S===setTimeout)return setTimeout(k,0);if((S===M||!S)&&setTimeout)return S=setTimeout,setTimeout(k,0);try{return S(k,0)}catch{try{return S.call(null,k,0)}catch{return S.call(this,k,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:M}catch{S=M}try{R=typeof clearTimeout=="function"?clearTimeout:D}catch{R=D}})();var g,l=[],b=!1,v=-1;function y(){b&&g&&(b=!1,g.length?l=g.concat(l):v=-1,l.length&&u())}function u(){if(!b){var k=P(y);b=!0;for(var h=l.length;h;){for(g=l,l=[];++v<h;)g&&g[v].run();v=-1,h=l.length}g=null,b=!1,function(f){if(R===clearTimeout)return clearTimeout(f);if((R===D||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(f);try{R(f)}catch{try{return R.call(null,f)}catch{return R.call(this,f)}}}(k)}}function $(k,h){this.fun=k,this.array=h}function w(){}s.nextTick=function(k){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];l.push(new $(k,h)),l.length!==1||b||P(u)},$.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=w,s.addListener=w,s.once=w,s.off=w,s.removeListener=w,s.removeAllListeners=w,s.emit=w,s.prependListener=w,s.prependOnceListener=w,s.listeners=function(k){return[]},s.binding=function(k){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(k){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(ae[141],ce([0,1]),function(X,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;class R{constructor(P,g,l){this.level=P,this.key=g,this.value=l,this.forward=[]}}const s=void 0;class M{constructor(P,g=2**16){this.comparator=P,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new R(this.c,s,s)}get size(){return this.f}clear(){this.e=new R(this.c,s,s),this.f=0}has(P){return!!M.g(this,P,this.comparator)}get(P){return M.g(this,P,this.comparator)?.value}set(P,g){return M.h(this,P,g,this.comparator)&&(this.f+=1),this}delete(P){const g=M.k(this,P,this.comparator);return g&&(this.f-=1),g}forEach(P,g){let l=this.e.forward[0];for(;l;)P.call(g,l.value,l.key,this),l=l.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",g=this.e.forward[0];for(;g;)P+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return P}static g(P,g,l){let b=P.e;for(let v=P.d-1;v>=0;v--)for(;b.forward[v]&&l(b.forward[v].key,g)<0;)b=b.forward[v];if(b=b.forward[0],b&&l(b.key,g)===0)return b}static h(P,g,l,b){const v=[];let y=P.e;for(let u=P.d-1;u>=0;u--){for(;y.forward[u]&&b(y.forward[u].key,g)<0;)y=y.forward[u];v[u]=y}if(y=y.forward[0],y&&b(y.key,g)===0)return y.value=l,!1;{const u=M.j(P);if(u>P.d){for(let $=P.d;$<u;$++)v[$]=P.e;P.d=u}y=new R(u,g,l);for(let $=0;$<u;$++)y.forward[$]=v[$].forward[$],v[$].forward[$]=y;return!0}}static j(P,g=.5){let l=1;for(;Math.random()<g&&l<P.c;)l+=1;return l}static k(P,g,l){const b=[];let v=P.e;for(let y=P.d-1;y>=0;y--){for(;v.forward[y]&&l(v.forward[y].key,g)<0;)v=v.forward[y];b[y]=v}if(v=v.forward[0],!v||l(v.key,g)!==0)return!1;for(let y=0;y<P.d&&b[y].forward[y]===v;y++)b[y].forward[y]=v.forward[y];for(;P.d>0&&P.e.forward[P.d-1]===s;)P.d-=1;return!0}}e.$3r=M}),define(ae[72],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(M){return new R(M)}constructor(M){this.c=S&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Sd=R}),define(ae[3],ce([0,1,14,84,2,102,72]),function(X,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.Event=void 0;const P=!1,g=!1;var l;(function(I){I.None=()=>s.$Tc.None;function E(z){if(g){const{onDidAddListener:ee}=z,se=$.create();let de=0;z.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),se.print()),ee?.()}}}function C(z,ee){return Y(z,()=>{},0,void 0,!0,void 0,ee)}I.defer=C;function j(z){return(ee,se=null,de)=>{let me=!1,Ee;return Ee=z(Pe=>{if(!me)return Ee?Ee.dispose():me=!0,ee.call(se,Pe)},null,de),me&&Ee.dispose(),Ee}}I.once=j;function U(z,ee,se){return ue((de,me=null,Ee)=>z(Pe=>de.call(me,ee(Pe)),null,Ee),se)}I.map=U;function F(z,ee,se){return ue((de,me=null,Ee)=>z(Pe=>{ee(Pe),de.call(me,Pe)},null,Ee),se)}I.forEach=F;function V(z,ee,se){return ue((de,me=null,Ee)=>z(Pe=>ee(Pe)&&de.call(me,Pe),null,Ee),se)}I.filter=V;function J(z){return z}I.signal=J;function le(...z){return(ee,se=null,de)=>{const me=(0,s.$Qc)(...z.map(Ee=>Ee(Pe=>ee.call(se,Pe))));return Z(me,de)}}I.any=le;function oe(z,ee,se,de){let me=se;return U(z,Ee=>(me=ee(me,Ee),me),de)}I.reduce=oe;function ue(z,ee){let se;const de={onWillAddFirstListener(){se=z(me.fire,me)},onDidRemoveLastListener(){se?.dispose()}};ee||E(de);const me=new d(de);return ee?.add(me),me.event}function Z(z,ee){return ee instanceof Array?ee.push(z):ee&&ee.add(z),z}function Y(z,ee,se=100,de=!1,me=!1,Ee,Pe){let Le,ke,pe,ie=0,fe;const $e={leakWarningThreshold:Ee,onWillAddFirstListener(){Le=z(Me=>{ie++,ke=ee(ke,Me),de&&!pe&&(Ie.fire(ke),ke=void 0),fe=()=>{const Ne=ke;ke=void 0,pe=void 0,(!de||ie>1)&&Ie.fire(Ne),ie=0},typeof se=="number"?(clearTimeout(pe),pe=setTimeout(fe,se)):pe===void 0&&(pe=0,queueMicrotask(fe))})},onWillRemoveListener(){me&&ie>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,Le.dispose()}};Pe||E($e);const Ie=new d($e);return Pe?.add(Ie),Ie.event}I.debounce=Y;function q(z,ee=0,se){return I.debounce(z,(de,me)=>de?(de.push(me),de):[me],ee,void 0,!0,void 0,se)}I.accumulate=q;function L(z,ee=(de,me)=>de===me,se){let de=!0,me;return V(z,Ee=>{const Pe=de||!ee(Ee,me);return de=!1,me=Ee,Pe},se)}I.latch=L;function N(z,ee,se){return[I.filter(z,ee,se),I.filter(z,de=>!ee(de),se)]}I.split=N;function G(z,ee=!1,se=[],de){let me=se.slice(),Ee=z(ke=>{me?me.push(ke):Le.fire(ke)});de&&de.add(Ee);const Pe=()=>{me?.forEach(ke=>Le.fire(ke)),me=null},Le=new d({onWillAddFirstListener(){Ee||(Ee=z(ke=>Le.fire(ke)),de&&de.add(Ee))},onDidAddFirstListener(){me&&(ee?setTimeout(Pe):Pe())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return de&&de.add(Le),Le.event}I.buffer=G;function B(z,ee){return(de,me,Ee)=>{const Pe=ee(new he);return z(function(Le){const ke=Pe.evaluate(Le);ke!==te&&de.call(me,ke)},void 0,Ee)}}I.chain=B;const te=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(se=>(ee(se),se)),this}filter(ee){return this.f.push(se=>ee(se)?se:te),this}reduce(ee,se){let de=se;return this.f.push(me=>(de=ee(de,me),de)),this}latch(ee=(se,de)=>se===de){let se=!0,de;return this.f.push(me=>{const Ee=se||!ee(me,de);return se=!1,de=me,Ee?me:te}),this}evaluate(ee){for(const se of this.f)if(ee=se(ee),ee===te)break;return ee}}function K(z,ee,se=de=>de){const de=(...Le)=>Pe.fire(se(...Le)),me=()=>z.on(ee,de),Ee=()=>z.removeListener(ee,de),Pe=new d({onWillAddFirstListener:me,onDidRemoveLastListener:Ee});return Pe.event}I.fromNodeEventEmitter=K;function O(z,ee,se=de=>de){const de=(...Le)=>Pe.fire(se(...Le)),me=()=>z.addEventListener(ee,de),Ee=()=>z.removeEventListener(ee,de),Pe=new d({onWillAddFirstListener:me,onDidRemoveLastListener:Ee});return Pe.event}I.fromDOMEventEmitter=O;function W(z){return new Promise(ee=>j(z)(ee))}I.toPromise=W;function x(z){const ee=new d;return z.then(se=>{ee.fire(se)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}I.fromPromise=x;function T(z,ee,se){return ee(se),z(de=>ee(de))}I.runAndSubscribe=T;class Q{constructor(ee,se){this._observable=ee,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};se||E(de),this.emitter=new d(de),se&&se.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,se){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function H(z,ee){return new Q(z,ee).emitter.event}I.fromObservable=H;function _(z){return(ee,se,de)=>{let me=0,Ee=!1;const Pe={beginUpdate(){me++},endUpdate(){me--,me===0&&(z.reportChanges(),Ee&&(Ee=!1,ee.call(se)))},handlePossibleChange(){},handleChange(){Ee=!0}};z.addObserver(Pe),z.reportChanges();const Le={dispose(){z.removeObserver(Pe)}};return de instanceof s.$Sc?de.add(Le):Array.isArray(de)&&de.push(Le),Le}}I.fromObservableLight=_})(l||(e.Event=l={}));class b{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${b.f++}`,b.all.add(this)}start(E){this.g=new D.$Sd,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$Ud=b;let v=-1;function y(I){const E=v;return v=I,{dispose(){v=E}}}e.$Vd=y;class u{constructor(E,C=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=C,this.g=0}dispose(){this.f?.clear()}check(E,C){const j=this.threshold;if(j<=0||C<j)return;this.f||(this.f=new Map);const U=this.f.get(E.value)||0;if(this.f.set(E.value,U+1),this.g-=1,this.g<=0){this.g=j*.5;let F,V=0;for(const[J,le]of this.f)(!F||V<le)&&(F=J,V=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${V}):`),console.warn(F)}return()=>{const F=this.f.get(E.value)||0;this.f.set(E.value,F-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class k{constructor(E){this.value=E,this.id=w++}}const h=2,f=(I,E)=>{if(I instanceof k)E(I);else for(let C=0;C<I.length;C++){const j=I[C];j&&E(j)}};class d{constructor(E){this.w=0,this.f=E,this.g=v>0||this.f?.leakWarningThreshold?new u(this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new b(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const E=this.t;queueMicrotask(()=>{f(E,C=>C.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,C,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Tc.None;if(this.m)return s.$Tc.None;C&&(E=E.bind(C));const U=new k(E);let F,V;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(U.stack=$.create(),F=this.g.check(U.stack,this.w+1)),P&&(U.stack=V??$.create()),this.t?this.t instanceof k?(this.u??=new c,this.t=[this.t,U]):this.t.push(U):(this.f?.onWillAddFirstListener?.(this),this.t=U,this.f?.onDidAddFirstListener?.(this)),this.w++;const J=(0,s.$Rc)(()=>{F?.(),this.x(U)});return j instanceof s.$Sc?j.add(J):Array.isArray(j)&&j.push(J),J},this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const C=this.t,j=C.indexOf(E);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,C[j]=void 0;const U=this.u.current===this;if(this.w*h<=C.length){let F=0;for(let V=0;V<C.length;V++)C[V]?C[F++]=C[V]:U&&(this.u.end--,F<this.u.i&&this.u.i--);C.length=F}}y(E,C){if(!E)return;const j=this.f?.onListenerError||S.$1;if(!j){E.value(C);return}try{E.value(C)}catch(U){j(U)}}z(E){const C=E.current.t;for(;E.i<E.end;)this.y(C[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof k)this.y(this.t,E);else{const C=this.u;C.enqueue(this,E,this.t.length),this.z(C)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Wd=d;const m=()=>new c;e.$Xd=m;class c{constructor(){this.i=-1,this.end=0}enqueue(E,C,j){this.i=0,this.end=j,this.current=E,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends d{async fireAsync(E,C,j){if(this.t)for(this.h||(this.h=new M.$4c),f(this.t,U=>this.h.push([U.value,E]));this.h.size>0&&!C.isCancellationRequested;){const[U,F]=this.h.shift(),V=[],J={...F,token:C,waitUntil:le=>{if(Object.isFrozen(V))throw new Error("waitUntil can NOT be called asynchronous");j&&(le=j(le,U)),V.push(le)}};try{U(J)}catch(le){(0,S.$1)(le);continue}Object.freeze(V),await Promise.allSettled(V).then(le=>{for(const oe of le)oe.status==="rejected"&&(0,S.$1)(oe.reason)})}}}e.$Yd=t;class o extends d{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new M.$4c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$Zd=o;class r extends o{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$1d=r;class i extends d{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(C=>super.fire(C)),this.h=[]}))}}e.$2d=i;class n{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const C={event:E,listener:null};this.h.push(C),this.g&&this.m(C);const j=()=>{this.g&&this.o(C);const U=this.h.indexOf(C);this.h.splice(U,1)};return(0,s.$Rc)((0,R.$db)(j))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(C=>this.f.fire(C))}o(E){E.listener?.dispose(),E.listener=null}dispose(){this.f.dispose();for(const E of this.h)E.listener?.dispose();this.h=[]}}e.$3d=n;class a{constructor(E,C,j,U){this.f=new s.$Sc;const F=this.f.add(new n),V=this.f.add(new s.$3c);function J(le){V.set(le,F.add(U(le)))}for(const le of E)J(le);this.f.add(C(le=>{J(le)})),this.f.add(j(le=>{V.deleteAndDispose(le)})),this.event=F.event}dispose(){this.f.dispose()}}e.$4d=a;class p{constructor(){this.f=[]}wrapEvent(E){return(C,j,U)=>E(F=>{const V=this.f[this.f.length-1];V?V.push(()=>C.call(j,F)):C.call(j,F)},void 0,U)}bufferEvents(E){const C=[];this.f.push(C);const j=E();return this.f.pop(),C.forEach(U=>U()),j}}e.$5d=p;class A{constructor(){this.f=!1,this.g=l.None,this.h=s.$Tc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$6d=A}),define(ae[23],ce([0,1,3]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.CancellationToken=void 0;const R=Object.freeze(function(P,g){const l=setTimeout(P.bind(g),0);return{dispose(){clearTimeout(l)}}});var s;(function(P){function g(l){return l===P.None||l===P.Cancelled||l instanceof M?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}P.isCancellationToken=g,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new S.$Wd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(g){this.f=void 0,this.g=void 0,this.g=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(g=!1){g&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$7d=D}),define(ae[142],ce([0,1,23]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=e.$Ge=e.$Fe=void 0;class R{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new S.$7d,g=this.b(P.token);return this.a={promise:g,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$Fe=R;class s{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const g=JSON.stringify(P);return this.b!==g&&(this.b=g,this.a=this.c(P)),this.a}}e.$Ge=s;class M{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const g=this.b(P);return this.a.set(P,g),g}}e.$He=M}),define(ae[63],ce([0,1,14,2]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function s(m){const c=m;return c?typeof c.read=="function":!1}e.$8d=s;function M(m){const c=m;return c?[c.on,c.pause,c.resume,c.destroy].every(t=>typeof t=="function"):!1}e.$9d=M;function D(m){const c=m;return c?M(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.$0d=D;function P(m,c){return new g(m,c)}e.$$d=P;class g{constructor(c,t){this.e=c,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(t=>t(c))}h(c){this.c.error.length===0?(0,S.$1)(c):this.c.error.slice(0).forEach(t=>t(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,t){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(c,t){if(this.a.destroyed)return;let o;switch(c){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(m,c){const t=[];let o;for(;(o=m.read())!==null;)t.push(o);return c(t)}e.$_d=l;function b(m,c,t){const o=[];let r;for(;(r=m.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?c(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return m.read()}}}e.$ae=b;function v(m,c){return new Promise((t,o)=>{const r=[];y(m,{onData:i=>{c&&r.push(i)},onError:i=>{c?o(i):t(void 0)},onEnd:()=>{t(c?c(r):void 0)}})})}e.$be=v;function y(m,c,t){m.on("error",o=>{t?.isCancellationRequested||c.onError(o)}),m.on("end",()=>{t?.isCancellationRequested||c.onEnd()}),m.on("data",o=>{t?.isCancellationRequested||c.onData(o)})}e.$ce=y;function u(m,c){return new Promise((t,o)=>{const r=new R.$Sc,i=[],n=A=>{if(i.push(A),i.length>c)return r.dispose(),m.pause(),t({stream:m,buffer:i,ended:!1})},a=A=>(r.dispose(),o(A)),p=()=>(r.dispose(),t({stream:m,buffer:i,ended:!0}));r.add((0,R.$Rc)(()=>m.removeListener("error",a))),m.on("error",a),r.add((0,R.$Rc)(()=>m.removeListener("end",p))),m.on("end",p),r.add((0,R.$Rc)(()=>m.removeListener("data",n))),m.on("data",n)})}e.$de=u;function $(m,c){const t=P(c);return t.end(m),t}e.$ee=$;function w(){const m=P(()=>{throw new Error("not supported")});return m.end(),m}e.$fe=w;function k(m){let c=!1;return{read:()=>c?null:(c=!0,m)}}e.$ge=k;function h(m,c,t){const o=P(t);return y(m,{onData:r=>o.write(c.data(r)),onError:r=>o.error(c.error?c.error(r):r),onEnd:()=>o.end()}),o}e.$he=h;function f(m,c,t){let o=!1;return{read:()=>{const r=c.read();return o?r:(o=!0,r!==null?t([m,r]):m)}}}e.$ie=f;function d(m,c,t){let o=!1;const r=P(t);return y(c,{onData:i=>o?r.write(i):(o=!0,r.write(t([m,i]))),onError:i=>r.error(i),onEnd:()=>{o||(o=!0,r.write(m)),r.end()}}),r}e.$je=d}),define(ae[17],ce([0,1,62,63]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const s=typeof Buffer<"u",M=new S.$V(()=>new Uint8Array(256));let D,P;class g{static alloc(C){return s?new g(Buffer.allocUnsafe(C)):new g(new Uint8Array(C))}static wrap(C){return s&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new g(C)}static fromString(C,j){return!(j?.dontUseNodeBuffer||!1)&&s?new g(Buffer.from(C)):(D||(D=new TextEncoder),new g(D.encode(C)))}static fromByteArray(C){const j=g.alloc(C.length);for(let U=0,F=C.length;U<F;U++)j.buffer[U]=C[U];return j}static concat(C,j){if(typeof j>"u"){j=0;for(let V=0,J=C.length;V<J;V++)j+=C[V].byteLength}const U=g.alloc(j);let F=0;for(let V=0,J=C.length;V<J;V++){const le=C[V];U.set(le,F),F+=le.byteLength}return U}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=g.alloc(this.byteLength);return C.set(this),C}toString(){return s?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(C,j){return new g(this.buffer.subarray(C,j))}set(C,j){if(C instanceof g)this.buffer.set(C.buffer,j);else if(C instanceof Uint8Array)this.buffer.set(C,j);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),j);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return y(this.buffer,C)}writeUInt32BE(C,j){u(this.buffer,C,j)}readUInt32LE(C){return $(this.buffer,C)}writeUInt32LE(C,j){w(this.buffer,C,j)}readUInt8(C){return k(this.buffer,C)}writeUInt8(C,j){h(this.buffer,C,j)}indexOf(C,j=0){return l(this.buffer,C instanceof g?C.buffer:C,j)}}e.$ke=g;function l(E,C,j=0){const U=C.byteLength,F=E.byteLength;if(U===0)return 0;if(U===1)return E.indexOf(C[0]);if(U>F-j)return-1;const V=M.value;V.fill(C.length);for(let ue=0;ue<C.length;ue++)V[C[ue]]=C.length-ue-1;let J=j+C.length-1,le=J,oe=-1;for(;J<F;)if(E[J]===C[le]){if(le===0){oe=J;break}J--,le--}else J+=Math.max(C.length-le,V[E[J]]),le=C.length-1;return oe}e.$le=l;function b(E,C){return E[C+0]<<0>>>0|E[C+1]<<8>>>0}e.$me=b;function v(E,C,j){E[j+0]=C&255,C=C>>>8,E[j+1]=C&255}e.$ne=v;function y(E,C){return E[C]*2**24+E[C+1]*2**16+E[C+2]*2**8+E[C+3]}e.$oe=y;function u(E,C,j){E[j+3]=C,C=C>>>8,E[j+2]=C,C=C>>>8,E[j+1]=C,C=C>>>8,E[j]=C}e.$pe=u;function $(E,C){return E[C+0]<<0>>>0|E[C+1]<<8>>>0|E[C+2]<<16>>>0|E[C+3]<<24>>>0}e.$qe=$;function w(E,C,j){E[j+0]=C&255,C=C>>>8,E[j+1]=C&255,C=C>>>8,E[j+2]=C&255,C=C>>>8,E[j+3]=C&255}e.$re=w;function k(E,C){return E[C]}e.$se=k;function h(E,C,j){E[j]=C}e.$te=h;function f(E){return R.$_d(E,C=>g.concat(C))}e.$ue=f;function d(E){return R.$ge(E)}e.$ve=d;function m(E){return R.$be(E,C=>g.concat(C))}e.$we=m;async function c(E){return E.ended?g.concat(E.buffer):g.concat([...E.buffer,await m(E.stream)])}e.$xe=c;function t(E){return R.$ee(E,C=>g.concat(C))}e.$ye=t;function o(E){return R.$he(E,{data:C=>typeof C=="string"?g.fromString(C):g.wrap(C)},C=>g.concat(C))}e.$ze=o;function r(E){return R.$$d(C=>g.concat(C),E)}e.$Ae=r;function i(E,C){return R.$ie(E,C,j=>g.concat(j))}e.$Be=i;function n(E,C){return R.$je(E,C,j=>g.concat(j))}e.$Ce=n;function a(E){let C=0,j=0,U=0;const F=new Uint8Array(Math.floor(E.length/4*3)),V=le=>{switch(j){case 3:F[U++]=C|le,j=0;break;case 2:F[U++]=C|le>>>2,C=le<<6,j=3;break;case 1:F[U++]=C|le>>>4,C=le<<4,j=2;break;default:C=le<<2,j=1}};for(let le=0;le<E.length;le++){const oe=E.charCodeAt(le);if(oe>=65&&oe<=90)V(oe-65);else if(oe>=97&&oe<=122)V(oe-97+26);else if(oe>=48&&oe<=57)V(oe-48+52);else if(oe===43||oe===45)V(62);else if(oe===47||oe===95)V(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${E[le]}`)}}const J=U;for(;j>0;)V(0);return g.wrap(F).slice(0,J)}e.$De=a;const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:E},C=!0,j=!1){const U=j?A:p;let F="";const V=E.byteLength%3;let J=0;for(;J<E.byteLength-V;J+=3){const le=E[J+0],oe=E[J+1],ue=E[J+2];F+=U[le>>>2],F+=U[(le<<4|oe>>>4)&63],F+=U[(oe<<2|ue>>>6)&63],F+=U[ue&63]}if(V===1){const le=E[J+0];F+=U[le>>>2],F+=U[le<<4&63],C&&(F+="==")}else if(V===2){const le=E[J+0],oe=E[J+1];F+=U[le>>>2],F+=U[(le<<4|oe>>>4)&63],F+=U[oe<<2&63],C&&(F+="=")}return F}e.$Ee=I}),define(ae[25],ce([0,1,142,62]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$If=e.$Hf=e.$Gf=e.$Ff=e.GraphemeBreakType=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=void 0;function s(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.$Ke=s;const M=/{(\d+)}/g;function D(ne,...ge){return ge.length===0?ne:ne.replace(M,function(be,Se){const ye=parseInt(Se,10);return isNaN(ye)||ye<0||ye>=ge.length?be:ge[ye]})}e.$Le=D;const P=/{([^}]+)}/g;function g(ne,ge){return Object.keys(ge).length===0?ne:ne.replace(P,(be,Se)=>ge[Se]??be)}e.$Me=g;function l(ne){return ne.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}e.$Ne=l;function b(ne){return ne.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.$Oe=b;function v(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Pe=v;function y(ne,ge){let be=0;const Se=ge.charCodeAt(0);for(let ye=ne.length-1;ye>=0;ye--)ne.charCodeAt(ye)===Se&&be++;return be}e.$Qe=y;function u(ne,ge,be="\u2026"){return ne.length<=ge?ne:`${ne.substr(0,ge)}${be}`}e.$Re=u;function $(ne,ge,be="\u2026"){if(ne.length<=ge)return ne;const Se=Math.ceil(ge/2)-be.length/2,ye=Math.floor(ge/2)-be.length/2;return`${ne.substr(0,Se)}${be}${ne.substr(ne.length-ye)}`}e.$Se=$;function w(ne,ge=" "){const be=k(ne,ge);return h(be,ge)}e.$Te=w;function k(ne,ge){if(!ne||!ge)return ne;const be=ge.length;if(be===0||ne.length===0)return ne;let Se=0;for(;ne.indexOf(ge,Se)===Se;)Se=Se+be;return ne.substring(Se)}e.$Ue=k;function h(ne,ge){if(!ne||!ge)return ne;const be=ge.length,Se=ne.length;if(be===0||Se===0)return ne;let ye=Se,Re=-1;for(;Re=ne.lastIndexOf(ge,ye-1),!(Re===-1||Re+be!==ye);){if(Re===0)return"";ye=Re}return ne.substring(0,ye)}e.$Ve=h;function f(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$We=f;function d(ne){return ne.replace(/\*/g,"")}e.$Xe=d;function m(ne,ge,be={}){if(!ne)throw new Error("Cannot create regex from empty string");ge||(ne=v(ne)),be.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let Se="";return be.global&&(Se+="g"),be.matchCase||(Se+="i"),be.multiline&&(Se+="m"),be.unicode&&(Se+="u"),new RegExp(ne,Se)}e.$Ye=m;function c(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.$Ze=c;function t(ne){return ne.split(/\r\n|\r|\n/)}e.$1e=t;function o(ne){for(let ge=0,be=ne.length;ge<be;ge++){const Se=ne.charCodeAt(ge);if(Se!==32&&Se!==9)return ge}return-1}e.$2e=o;function r(ne,ge=0,be=ne.length){for(let Se=ge;Se<be;Se++){const ye=ne.charCodeAt(Se);if(ye!==32&&ye!==9)return ne.substring(ge,Se)}return ne.substring(ge,be)}e.$3e=r;function i(ne,ge=ne.length-1){for(let be=ge;be>=0;be--){const Se=ne.charCodeAt(be);if(Se!==32&&Se!==9)return be}return-1}e.$4e=i;function n(ne,ge,be){const Se=[];let ye=0;for(const Re of ne.matchAll(ge)){if(Se.push(ne.slice(ye,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ye=Re.index+Re[0].length,Se.push(be(Re[0],...Re.slice(1),Re.index,ne,Re.groups))}return Se.push(ne.slice(ye)),Promise.all(Se).then(Re=>Re.join(""))}e.$5e=n;function a(ne,ge){return ne<ge?-1:ne>ge?1:0}e.$6e=a;function p(ne,ge,be=0,Se=ne.length,ye=0,Re=ge.length){for(;be<Se&&ye<Re;be++,ye++){const Xe=ne.charCodeAt(be),xe=ge.charCodeAt(ye);if(Xe<xe)return-1;if(Xe>xe)return 1}const Ue=Se-be,qe=Re-ye;return Ue<qe?-1:Ue>qe?1:0}e.$7e=p;function A(ne,ge){return I(ne,ge,0,ne.length,0,ge.length)}e.$8e=A;function I(ne,ge,be=0,Se=ne.length,ye=0,Re=ge.length){for(;be<Se&&ye<Re;be++,ye++){let Xe=ne.charCodeAt(be),xe=ge.charCodeAt(ye);if(Xe===xe)continue;if(Xe>=128||xe>=128)return p(ne.toLowerCase(),ge.toLowerCase(),be,Se,ye,Re);C(Xe)&&(Xe-=32),C(xe)&&(xe-=32);const Ye=Xe-xe;if(Ye!==0)return Ye}const Ue=Se-be,qe=Re-ye;return Ue<qe?-1:Ue>qe?1:0}e.$9e=I;function E(ne){return ne>=48&&ne<=57}e.$0e=E;function C(ne){return ne>=97&&ne<=122}e.$$e=C;function j(ne){return ne>=65&&ne<=90}e.$_e=j;function U(ne,ge){return ne.length===ge.length&&I(ne,ge)===0}e.$af=U;function F(ne,ge){const be=ge.length;return ge.length>ne.length?!1:I(ne,ge,0,be)===0}e.$bf=F;function V(ne,ge){const be=Math.min(ne.length,ge.length);let Se;for(Se=0;Se<be;Se++)if(ne.charCodeAt(Se)!==ge.charCodeAt(Se))return Se;return be}e.$cf=V;function J(ne,ge){const be=Math.min(ne.length,ge.length);let Se;const ye=ne.length-1,Re=ge.length-1;for(Se=0;Se<be;Se++)if(ne.charCodeAt(ye-Se)!==ge.charCodeAt(Re-Se))return Se;return be}e.$df=J;function le(ne){return 55296<=ne&&ne<=56319}e.$ef=le;function oe(ne){return 56320<=ne&&ne<=57343}e.$ff=oe;function ue(ne,ge){return(ne-55296<<10)+(ge-56320)+65536}e.$gf=ue;function Z(ne,ge,be){const Se=ne.charCodeAt(be);if(le(Se)&&be+1<ge){const ye=ne.charCodeAt(be+1);if(oe(ye))return ue(Se,ye)}return Se}e.$hf=Z;function Y(ne,ge){const be=ne.charCodeAt(ge-1);if(oe(be)&&ge>1){const Se=ne.charCodeAt(ge-2);if(le(Se))return ue(Se,be)}return be}class q{get offset(){return this.e}constructor(ge,be=0){this.c=ge,this.d=ge.length,this.e=be}setOffset(ge){this.e=ge}prevCodePoint(){const ge=Y(this.c,this.e);return this.e-=ge>=65536?2:1,ge}nextCodePoint(){const ge=Z(this.c,this.d,this.e);return this.e+=ge>=65536?2:1,ge}eol(){return this.e>=this.d}}e.$if=q;class L{get offset(){return this.c.offset}constructor(ge,be=0){this.c=new q(ge,be)}nextGraphemeLength(){const ge=Ie.getInstance(),be=this.c,Se=be.offset;let ye=ge.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Re=be.offset,Ue=ge.getGraphemeBreakType(be.nextCodePoint());if(fe(ye,Ue)){be.setOffset(Re);break}ye=Ue}return be.offset-Se}prevGraphemeLength(){const ge=Ie.getInstance(),be=this.c,Se=be.offset;let ye=ge.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Re=be.offset,Ue=ge.getGraphemeBreakType(be.prevCodePoint());if(fe(Ue,ye)){be.setOffset(Re);break}ye=Ue}return Se-be.offset}eol(){return this.c.eol()}}e.$jf=L;function N(ne,ge){return new L(ne,ge).nextGraphemeLength()}e.$kf=N;function G(ne,ge){return new L(ne,ge).prevGraphemeLength()}e.$lf=G;function B(ne,ge){ge>0&&oe(ne.charCodeAt(ge))&&ge--;const be=ge+N(ne,ge);return[be-G(ne,be),be]}e.$mf=B;function te(ne){const ge=new L(ne);let be=0;for(;!ge.eol();)be++,ge.nextGraphemeLength();return be}e.$nf=te;let he;function K(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function O(ne){return he||(he=K()),he.test(ne)}e.$of=O;const W=/^[\t\n\r\x20-\x7E]*$/;function x(ne){return W.test(ne)}e.$pf=x,e.$qf=/[\u2028\u2029]/;function T(ne){return e.$qf.test(ne)}e.$rf=T;function Q(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.$sf=Q;function H(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.$tf=H;function _(ne,ge,be=""){const Se=ne.trimStart();if(Se.length<ge)return Se;const ye=/\b/g;let Re=0;for(;ye.test(Se)&&!(Se.length-ye.lastIndex<ge);)Re=ye.lastIndex,ye.lastIndex+=1;return Re===0?Se:be+Se.substring(Re).trimStart()}e.$uf=_;const z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ee=/\x1b\].*?\x07/g;function se(ne){return ne&&(ne=ne.replace(z,"").replace(ee,"")),ne}e.$vf=se,e.$wf="\uFEFF";function de(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.$xf=de;function me(ne){return de(ne)?ne.substr(1):ne}e.$yf=me;function Ee(ne,ge){if(!ne||!ge||ne.length<ge.length)return!1;const be=ge.length,Se=ne.toLowerCase();let ye=0,Re=-1;for(;ye<be;){const Ue=Se.indexOf(ge[ye],Re+1);if(Ue<0)return!1;Re=Ue,ye++}return!0}e.$zf=Ee;function Pe(ne,ge=!1){return ne?(ge&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.$Af=Pe;function Le(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.$Bf=Le;function ke(ne,ge=1){if(ge===0)return"";let be=-1;do be=ne.indexOf(`
`,be+1),ge--;while(ge>0&&be>=0);return be===-1?ne:(ne[be-1]==="\r"&&be--,ne.substr(0,be))}e.$Cf=ke;function pe(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.$Df=pe;function ie(ne){return Ie.getInstance().getGraphemeBreakType(ne)}e.$Ef=ie;function fe(ne,ge){return ne===0?ge!==5&&ge!==7:ne===2&&ge===3?!1:ne===4||ne===2||ne===3||ge===4||ge===2||ge===3?!0:!(ne===8&&(ge===8||ge===9||ge===11||ge===12)||(ne===11||ne===9)&&(ge===9||ge===10)||(ne===12||ne===10)&&ge===10||ge===5||ge===13||ge===7||ne===1||ne===13&&ge===14||ne===6&&ge===6)}var $e;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})($e||(e.GraphemeBreakType=$e={}));class Ie{static{this.c=null}static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Me()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const be=this.d,Se=be.length/3;let ye=1;for(;ye<=Se;)if(ge<be[3*ye])ye=2*ye;else if(ge>be[3*ye+1])ye=2*ye+1;else return be[3*ye+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(ne,ge){if(ne===0)return 0;const be=je(ne,ge);if(be!==void 0)return be;const Se=new q(ge,ne);return Se.prevCodePoint(),Se.offset}e.$Ff=Ne;function je(ne,ge){const be=new q(ge,ne);let Se=be.prevCodePoint();for(;Je(Se)||Se===65039||Se===8419;){if(be.offset===0)return;Se=be.prevCodePoint()}if(!H(Se))return;let ye=be.offset;return ye>0&&be.prevCodePoint()===8205&&(ye=be.offset),ye}function Je(ne){return 127995<=ne&&ne<=127999}var Be;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.$Gf="\xA0";class He{static{this.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new S.$Ge(ge=>{function be(Ye){const Qe=new Map;for(let nt=0;nt<Ye.length;nt+=2)Qe.set(Ye[nt],Ye[nt+1]);return Qe}function Se(Ye,Qe){const nt=new Map(Ye);for(const[st,ot]of Qe)nt.set(st,ot);return nt}function ye(Ye,Qe){if(!Ye)return Qe;const nt=new Map;for(const[st,ot]of Ye)Qe.has(st)&&nt.set(st,ot);return nt}const Re=this.c.value;let Ue=ge.filter(Ye=>!Ye.startsWith("_")&&Ye in Re);Ue.length===0&&(Ue=["_default"]);let qe;for(const Ye of Ue){const Qe=be(Re[Ye]);qe=ye(qe,Qe)}const Xe=be(Re._common),xe=Se(Xe,qe);return new He(xe)})}static getInstance(ge){return He.d.get(Array.from(ge))}static{this.e=new R.$V(()=>Object.keys(He.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return He.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Hf=He;class Ve{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ve.c())),this.d}static isInvisibleCharacter(ge){return Ve.e().has(ge)}static get codePoints(){return Ve.e()}}e.$If=Ve}),define(ae[45],ce([0,1,25]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=void 0;function R(h){return s(h,0)}e.$Vi=R;function s(h,f){switch(typeof h){case"object":return h===null?M(349,f):Array.isArray(h)?g(h,f):l(h,f);case"string":return P(h,f);case"boolean":return D(h,f);case"number":return M(h,f);case"undefined":return M(937,f);default:return M(617,f)}}e.$Wi=s;function M(h,f){return(f<<5)-f+h|0}e.$Xi=M;function D(h,f){return M(h?433:863,f)}function P(h,f){f=M(149417,f);for(let d=0,m=h.length;d<m;d++)f=M(h.charCodeAt(d),f);return f}e.$Yi=P;function g(h,f){return f=M(104579,f),h.reduce((d,m)=>s(m,d),f)}function l(h,f){return f=M(181387,f),Object.keys(h).sort().reduce((d,m)=>(d=P(m,d),s(h[m],d)),f)}class b{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=s(f,this.g),this.g}}e.$Zi=b;var v;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function y(h,f,d=32){const m=d-f,c=~((1<<m)-1);return(h<<f|(c&h)>>>m)>>>0}function u(h,f=0,d=h.byteLength,m=0){for(let c=0;c<d;c++)h[f+c]=m}function $(h,f,d="0"){for(;h.length<f;)h=d+h;return h}function w(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(d=>d.toString(16).padStart(2,"0")).join(""):$((h>>>0).toString(16),f/4)}e.$1i=w;class k{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const d=f.length;if(d===0)return;const m=this.p;let c=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=f.charCodeAt(0),r=0);;){let i=o;if(S.$ef(o))if(r+1<d){const n=f.charCodeAt(r+1);S.$ff(n)?(r++,i=S.$gf(o,n)):i=65533}else{t=o;break}else S.$ff(o)&&(i=65533);if(c=this.w(m,c,i),r++,r<d)o=f.charCodeAt(r);else break}this.r=c,this.u=t}w(f,d,m){return m<128?f[d++]=m:m<2048?(f[d++]=192|(m&1984)>>>6,f[d++]=128|(m&63)>>>0):m<65536?(f[d++]=224|(m&61440)>>>12,f[d++]=128|(m&4032)>>>6,f[d++]=128|(m&63)>>>0):(f[d++]=240|(m&1835008)>>>18,f[d++]=128|(m&258048)>>>12,f[d++]=128|(m&4032)>>>6,f[d++]=128|(m&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=k.g,d=this.q;for(let p=0;p<64;p+=4)f.setUint32(p,d.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)f.setUint32(p,y(f.getUint32(p-12,!1)^f.getUint32(p-32,!1)^f.getUint32(p-56,!1)^f.getUint32(p-64,!1),1),!1);let m=this.h,c=this.l,t=this.m,o=this.n,r=this.o,i,n,a;for(let p=0;p<80;p++)p<20?(i=c&t|~c&o,n=1518500249):p<40?(i=c^t^o,n=1859775393):p<60?(i=c&t|c&o|t&o,n=2400959708):(i=c^t^o,n=3395469782),a=y(m,5)+i+r+n+f.getUint32(p*4,!1)&4294967295,r=o,o=t,t=y(c,30),c=m,m=a;this.h=this.h+m&4294967295,this.l=this.l+c&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$2i=k}),define(ae[73],ce([0,1,25]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(R||(R={})),function(s){const M="error",D="warning",P="warn",g="info",l="ignore";function b(y){return y?S.$af(M,y)?s.Error:S.$af(D,y)||S.$af(P,y)?s.Warning:S.$af(g,y)?s.Info:s.Ignore:s.Ignore}s.fromValue=b;function v(y){switch(y){case s.Error:return M;case s.Warning:return D;case s.Info:return g;default:return l}}s.toString=v}(R||(R={})),e.default=R}),define(ae[143],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(ae[59],ce([0,1,22,25]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0;class s{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const $=u.charCodeAt(0),w=this.b.charCodeAt(this.c);return $-w}value(){return this.b[this.c]}}e.$0h=s;class M{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,R.$7e)(u,this.b,0,u.length,this.c,this.d):(0,R.$9e)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$$h=M;class D{constructor(u=!0,$=!0){this.f=u,this.g=$}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let $=u.length-1;$>=0;$--,this.c--){const w=this.b.charCodeAt($);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,R.$7e)(u,this.b,0,u.length,this.d,this.e):(0,R.$9e)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$_h=D;var P;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(P||(P={}));class g{constructor(u,$){this.f=u,this.g=$,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,R.$8e)(u,this.c.scheme);if(this.d[this.e]===2)return(0,R.$8e)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,R.$6e)(u,this.c.query);if(this.d[this.e]===5)return(0,R.$6e)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ai=g;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(b||(b={}));class v{static forUris(u=()=>!1,$=()=>!1){return new v(new g(u,$))}static forPaths(u=!1){return new v(new D(void 0,!u))}static forStrings(){return new v(new s)}static forConfigKeys(){return new v(new M)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,$){if($){const w=$.slice(0);(0,S.$Xb)(w);for(const k of w)this.set(k,u)}else{const w=u.slice(0);(0,S.$Xb)(w);for(const k of w)this.set(k[0],k[1])}}set(u,$){const w=this.b.reset(u);let k;this.c||(this.c=new l,this.c.segment=w.value());const h=[];for(k=this.c;;){const d=w.cmp(k.segment);if(d>0)k.left||(k.left=new l,k.left.segment=w.value()),h.push([-1,k]),k=k.left;else if(d<0)k.right||(k.right=new l,k.right.segment=w.value()),h.push([1,k]),k=k.right;else if(w.hasNext())w.next(),k.mid||(k.mid=new l,k.mid.segment=w.value()),h.push([0,k]),k=k.mid;else break}const f=k.value;k.value=$,k.key=u;for(let d=h.length-1;d>=0;d--){const m=h[d][1];m.updateHeight();const c=m.balanceFactor();if(c<-1||c>1){const t=h[d][0],o=h[d+1][0];if(t===1&&o===1)h[d][1]=m.rotateLeft();else if(t===-1&&o===-1)h[d][1]=m.rotateRight();else if(t===1&&o===-1)m.right=h[d+1][1]=h[d+1][1].rotateRight(),h[d][1]=m.rotateLeft();else if(t===-1&&o===1)m.left=h[d+1][1]=h[d+1][1].rotateLeft(),h[d][1]=m.rotateRight();else throw new Error;if(d>0)switch(h[d-1][0]){case-1:h[d-1][1].left=h[d][1];break;case 1:h[d-1][1].right=h[d][1];break;case 0:h[d-1][1].mid=h[d][1];break}else this.c=h[0][1]}}return f}get(u){return this.d(u)?.value}d(u){const $=this.b.reset(u);let w=this.c;for(;w;){const k=$.cmp(w.segment);if(k>0)w=w.left;else if(k<0)w=w.right;else if($.hasNext())$.next(),w=w.mid;else break}return w}has(u){const $=this.d(u);return!($?.value===void 0&&$?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,$){const w=this.b.reset(u),k=[];let h=this.c;for(;h;){const f=w.cmp(h.segment);if(f>0)k.push([-1,h]),h=h.left;else if(f<0)k.push([1,h]),h=h.right;else if(w.hasNext())w.next(),k.push([0,h]),h=h.mid;else break}if(h){if($?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const f=this.f(h.right);if(f.key){const{key:d,value:m,segment:c}=f;this.e(f.key,!1),h.key=d,h.value=m,h.segment=c}}else{const f=h.left??h.right;if(k.length>0){const[d,m]=k[k.length-1];switch(d){case-1:m.left=f;break;case 0:m.mid=f;break;case 1:m.right=f;break}}else this.c=f}for(let f=k.length-1;f>=0;f--){const d=k[f][1];d.updateHeight();const m=d.balanceFactor();if(m>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),k[f][1]=d.rotateLeft()):m<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),k[f][1]=d.rotateRight()),f>0)switch(k[f-1][0]){case-1:k[f-1][1].left=k[f][1];break;case 1:k[f-1][1].right=k[f][1];break;case 0:k[f-1][1].mid=k[f][1];break}else this.c=k[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const $=this.b.reset(u);let w=this.c,k;for(;w;){const h=$.cmp(w.segment);if(h>0)w=w.left;else if(h<0)w=w.right;else if($.hasNext())$.next(),k=w.value||k,w=w.mid;else break}return w&&w.value||k}findSuperstr(u){return this.g(u,!1)}g(u,$){const w=this.b.reset(u);let k=this.c;for(;k;){const h=w.cmp(k.segment);if(h>0)k=k.left;else if(h<0)k=k.right;else if(w.hasNext())w.next(),k=k.mid;else return k.mid?this.h(k.mid):$?k.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[$,w]of this)u(w,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const $=[];return this.j(u,$),$[Symbol.iterator]()}j(u,$){u&&(u.left&&this.j(u.left,$),u.value&&$.push([u.key,u.value]),u.mid&&this.j(u.mid,$),u.right&&this.j(u.right,$))}_isBalanced(){const u=$=>{if(!$)return!0;const w=$.balanceFactor();return w<-1||w>1?!1:u($.left)&&u($.right)};return u(this.c)}}e.$bi=v}),define(ae[12],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=void 0;function S(c){return typeof c=="string"}e.$Jf=S;function R(c){return Array.isArray(c)&&c.every(t=>S(t))}e.$Kf=R;function s(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.$Lf=s;function M(c){const t=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof t}e.$Mf=M;function D(c){return typeof c=="number"&&!isNaN(c)}e.$Nf=D;function P(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.$Of=P;function g(c){return c===!0||c===!1}e.$Pf=g;function l(c){return typeof c>"u"}e.$Qf=l;function b(c){return!v(c)}e.$Rf=b;function v(c){return l(c)||c===null}e.$Sf=v;function y(c,t){if(!c)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Tf=y;function u(c){if(v(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.$Uf=u;function $(...c){const t=[];for(let o=0;o<c.length;o++){const r=c[o];if(v(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}e.$Vf=$;const w=Object.prototype.hasOwnProperty;function k(c){if(!s(c))return!1;for(const t in c)if(w.call(c,t))return!1;return!0}e.$Wf=k;function h(c){return typeof c=="function"}e.$Xf=h;function f(...c){return c.length>0&&c.every(h)}e.$Yf=f;function d(c,t){const o=Math.min(c.length,t.length);for(let r=0;r<o;r++)m(c[r],t[r])}e.$Zf=d;function m(c,t){if(S(t)){if(typeof c!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(h(t)){try{if(c instanceof t)return}catch{}if(!v(c)&&c.constructor===t||t.length===1&&t.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$1f=m}),define(ae[74],ce([0,1,12]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=e.$_j=void 0;const R=Object.create(null);function s(P,g){if((0,S.$Jf)(g)){const l=R[g];if(l===void 0)throw new Error(`${P} references an unknown codicon: ${g}`);g=l}return R[P]=g,{id:P}}function M(){return R}e.$_j=M;function D(){return Object.values(e.$bk)}e.$ak=D,e.$bk={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugBreakpointPending:s("debug-breakpoint-pending",60377),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),lightbulbSparkle:s("lightbulb-sparkle",60447),lightbulbSparkleAutofix:s("lightbulb-sparkle-autofix",60447),robot:s("robot",60448),sparkleFilled:s("sparkle-filled",60449),diffSingle:s("diff-single",60450),diffMultiple:s("diff-multiple",60451),surroundWith:s("surround-with",60452),gitStash:s("git-stash",60454),gitStashApply:s("git-stash-apply",60455),gitStashPop:s("git-stash-pop",60456),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(ae[35],ce([0,1,12]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=void 0;function R(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([d,m])=>{f[d]=m&&typeof m=="object"?R(m):m}),f}e.$yn=R;function s(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const d=f.shift();Object.freeze(d);for(const m in d)if(M.call(d,m)){const c=d[m];typeof c=="object"&&!Object.isFrozen(c)&&!(0,S.$Mf)(c)&&f.push(c)}}return h}e.$zn=s;const M=Object.prototype.hasOwnProperty;function D(h,f){return P(h,f,new Set)}e.$An=D;function P(h,f,d){if((0,S.$Sf)(h))return h;const m=f(h);if(typeof m<"u")return m;if(Array.isArray(h)){const c=[];for(const t of h)c.push(P(t,f,d));return c}if((0,S.$Lf)(h)){if(d.has(h))throw new Error("Cannot clone recursive data-structure");d.add(h);const c={};for(const t in h)M.call(h,t)&&(c[t]=P(h[t],f,d));return d.delete(h),c}return h}function g(h,f,d=!0){return(0,S.$Lf)(h)?((0,S.$Lf)(f)&&Object.keys(f).forEach(m=>{m in h?d&&((0,S.$Lf)(h[m])&&(0,S.$Lf)(f[m])?g(h[m],f[m],d):h[m]=f[m]):h[m]=f[m]}),h):f}e.$Bn=g;function l(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let d,m;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(d=0;d<h.length;d++)if(!l(h[d],f[d]))return!1}else{const c=[];for(m in h)c.push(m);c.sort();const t=[];for(m in f)t.push(m);if(t.sort(),!l(c,t))return!1;for(d=0;d<c.length;d++)if(!l(h[c[d]],f[c[d]]))return!1}return!0}e.$Cn=l;function b(h){const f=new Set;return JSON.stringify(h,(d,m)=>{if((0,S.$Lf)(m)||Array.isArray(m)){if(f.has(m))return"[Circular]";f.add(m)}return m})}e.$Dn=b;function v(h,f){const d=Object.create(null);return!h||!f||Object.keys(f).forEach(c=>{const t=h[c],o=f[c];l(t,o)||(d[c]=o)}),d}e.$En=v;function y(h,f){const d=f.toLowerCase(),m=Object.keys(h).find(c=>c.toLowerCase()===d);return m?h[m]:h[f]}e.$Fn=y;function u(h,f){const d=Object.create(null);for(const[m,c]of Object.entries(h))f(m,c)&&(d[m]=c);return d}e.$Gn=u;function $(h){let f=[];for(;Object.prototype!==h;)f=f.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return f}e.$Hn=$;function w(h){const f=[];for(const d of $(h))typeof h[d]=="function"&&f.push(d);return f}e.$In=w;function k(h,f){const d=c=>function(){const t=Array.prototype.slice.call(arguments,0);return f(c,t)},m={};for(const c of h)m[c]=d(c);return m}e.$Jn=k}),define(ae[103],ce([0,1,74]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ck=e.ThemeColor=void 0;var R;(function(D){function P(g){return g&&typeof g=="object"&&typeof g.id=="string"}D.isThemeColor=P})(R||(e.ThemeColor=R={}));function s(D){return{id:D}}e.$ck=s;var M;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function g(f){const d=P.exec(f.id);if(!d)return g(S.$bk.error);const[,m,c]=d,t=["codicon","codicon-"+m];return c&&t.push("codicon-modifier-"+c.substring(1)),t}D.asClassNameArray=g;function l(f){return g(f).join(" ")}D.asClassName=l;function b(f){return"."+g(f).join(".")}D.asCSSSelector=b;function v(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||R.isThemeColor(f.color))}D.isThemeIcon=v;const y=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function u(f){const d=y.exec(f);if(!d)return;const[,m]=d;return{id:m}}D.fromString=u;function $(f){return{id:f}}D.fromId=$;function w(f,d){let m=f.id;const c=m.lastIndexOf("~");return c!==-1&&(m=m.substring(0,c)),d&&(m=`${m}~${d}`),{id:m}}D.modify=w;function k(f){const d=f.id.lastIndexOf("~");if(d!==-1)return f.id.substring(d+1)}D.getModifier=k;function h(f,d){return f.id===d.id&&f.color?.id===d.color?.id}D.isEqual=h})(M||(e.ThemeIcon=M={}))}),define(ae[32],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(s){return S.test(s)}e.$qg=R,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(P){for(let g=0;g<P.length;g++)P[g]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let g=0,l="";return l+=D[M[g++]],l+=D[M[g++]],l+=D[M[g++]],l+=D[M[g++]],l+="-",l+=D[M[g++]],l+=D[M[g++]],l+="-",l+=D[M[g++]],l+=D[M[g++]],l+="-",l+=D[M[g++]],l+=D[M[g++]],l+="-",l+=D[M[g++]],l+=D[M[g++]],l+=D[M[g++]],l+=D[M[g++]],l+=D[M[g++]],l+=D[M[g++]],l}}()}),define(ae[144],ce([0,1,86,46,84]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EU=void 0;async function M(D,P){if(await new Promise((b,v)=>{const y=R.createReadStream(D),u=S.createHash("sha256");y.pipe(u);const $=(0,s.$db)((w,k)=>{y.removeAllListeners(),u.removeAllListeners(),w?v(w):b(k)});y.once("error",$),y.once("end",$),u.once("error",$),u.once("data",w=>$(void 0,w.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.$EU=M}),define(ae[145],ce([0,1,26]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(D){const P=D.replace(/\-/g,":").toLowerCase();return!R.has(P)}function M(){const D=(0,S.networkInterfaces)();for(const P in D){const g=D[P];if(g){for(const{mac:l}of g)if(s(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$_m=M}),define(ae[104],ce([0,1,87]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vg=e.$ug=e.$tg=void 0;function R(P,g,l,b=1){let v=!1;return new Promise(y=>{const u=setTimeout(()=>{if(!v)return v=!0,y(0)},l);s(P,g,b,$=>{if(!v)return v=!0,clearTimeout(u),y($)})})}e.$tg=R;function s(P,g,l,b){if(g===0)return b(0);const v=new S.Socket;v.once("connect",()=>(D(v),s(P+l,g-1,l,b))),v.once("data",()=>{}),v.once("error",y=>(D(v),y.code!=="ECONNREFUSED"?s(P+l,g-1,l,b):b(P))),v.connect(P,"127.0.0.1")}e.$ug={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(P,g,l,b="127.0.0.1"){let v=!1,y,u=1;const $=S.createServer({pauseOnConnect:!0});function w(k,h){v||(v=!0,$.removeAllListeners(),$.close(),y&&clearTimeout(y),h(k))}return new Promise(k=>{y=setTimeout(()=>{w(0,k)},l),$.on("listening",()=>{w(P,k)}),$.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&u<g?(P++,u++,$.listen(P,b)):w(0,k)}),$.on("close",()=>{w(0,k)}),$.listen(P,b)})}e.$vg=M;function D(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(g){console.error(g)}}}),function(){function X(){function e(){return process.uncHostAllowlist}function S(g){const l=new Set;if(Array.isArray(g))for(const b of g)typeof b=="string"&&l.add(b);return Array.from(l)}function R(){const g=e();return g?Array.from(g):[]}function s(g){if(process.platform!=="win32")return;const l=e();if(l)if(typeof g=="string")l.add(g.toLowerCase());else for(const b of S(g))s(b)}function M(g){if(typeof g!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let b;for(const v of l){if(g.indexOf(v)!==0)continue;const u=g.indexOf("\\",v.length);if(u===-1)continue;const $=g.substring(v.length,u);if($){b=$;break}}return b}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return X()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=X():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ae[146],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IU=e.$HU=void 0,e.$HU="vscode:contextmenu",e.$IU="vscode:onCloseContextMenu"}),define(ae[147],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PU=void 0;class S{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$PU=S}),define(ae[148],ce([11,10]),function(X,e){return X.create("vs/base/common/date",e)}),define(ae[149],ce([0,1,148]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0;const R=60,s=R*60,M=s*24,D=M*7,P=M*30,g=M*365;function l(y,u,$,w){typeof y!="number"&&(y=y.getTime());const k=Math.round((new Date().getTime()-y)/1e3);if(k<-30)return(0,S.localize)(0,null,l(new Date().getTime()+k*1e3,!1));if(!w&&k<30)return(0,S.localize)(1,null);let h;return k<R?(h=k,u?h===1?$?(0,S.localize)(2,null,h):(0,S.localize)(3,null,h):$?(0,S.localize)(4,null,h):(0,S.localize)(5,null,h):h===1?$?(0,S.localize)(6,null,h):(0,S.localize)(7,null,h):$?(0,S.localize)(8,null,h):(0,S.localize)(9,null,h)):k<s?(h=Math.floor(k/R),u?h===1?$?(0,S.localize)(10,null,h):(0,S.localize)(11,null,h):$?(0,S.localize)(12,null,h):(0,S.localize)(13,null,h):h===1?$?(0,S.localize)(14,null,h):(0,S.localize)(15,null,h):$?(0,S.localize)(16,null,h):(0,S.localize)(17,null,h)):k<M?(h=Math.floor(k/s),u?h===1?$?(0,S.localize)(18,null,h):(0,S.localize)(19,null,h):$?(0,S.localize)(20,null,h):(0,S.localize)(21,null,h):h===1?$?(0,S.localize)(22,null,h):(0,S.localize)(23,null,h):$?(0,S.localize)(24,null,h):(0,S.localize)(25,null,h)):k<D?(h=Math.floor(k/M),u?h===1?(0,S.localize)(26,null,h):(0,S.localize)(27,null,h):h===1?(0,S.localize)(28,null,h):(0,S.localize)(29,null,h)):k<P?(h=Math.floor(k/D),u?h===1?$?(0,S.localize)(30,null,h):(0,S.localize)(31,null,h):$?(0,S.localize)(32,null,h):(0,S.localize)(33,null,h):h===1?$?(0,S.localize)(34,null,h):(0,S.localize)(35,null,h):$?(0,S.localize)(36,null,h):(0,S.localize)(37,null,h)):k<g?(h=Math.floor(k/P),u?h===1?$?(0,S.localize)(38,null,h):(0,S.localize)(39,null,h):$?(0,S.localize)(40,null,h):(0,S.localize)(41,null,h):h===1?$?(0,S.localize)(42,null,h):(0,S.localize)(43,null,h):$?(0,S.localize)(44,null,h):(0,S.localize)(45,null,h)):(h=Math.floor(k/g),u?h===1?$?(0,S.localize)(46,null,h):(0,S.localize)(47,null,h):$?(0,S.localize)(48,null,h):(0,S.localize)(49,null,h):h===1?$?(0,S.localize)(50,null,h):(0,S.localize)(51,null,h):$?(0,S.localize)(52,null,h):(0,S.localize)(53,null,h))}e.$xm=l;function b(y,u){const $=Math.abs(y/1e3);return $<1?u?(0,S.localize)(54,null,y):(0,S.localize)(55,null,y):$<R?u?(0,S.localize)(56,null,Math.round(y)/1e3):(0,S.localize)(57,null,Math.round(y)/1e3):$<s?u?(0,S.localize)(58,null,Math.round(y/(1e3*R))):(0,S.localize)(59,null,Math.round(y/(1e3*R))):$<M?u?(0,S.localize)(60,null,Math.round(y/(1e3*s))):(0,S.localize)(61,null,Math.round(y/(1e3*s))):(0,S.localize)(62,null,Math.round(y/(1e3*M)))}e.$ym=b;function v(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$zm=v}),define(ae[150],ce([11,10]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ae[51],ce([0,1,22,12,150]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=void 0;function M(v,y){return y&&(v.stack||v.stacktrace)?s.localize(0,null,P(v),D(v.stack)||D(v.stacktrace)):P(v)}function D(v){return Array.isArray(v)?v.join(`
`):v}function P(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?s.localize(1,null,v.message):v.message||s.localize(2,null)}function g(v=null,y=!1){if(!v)return s.localize(3,null);if(Array.isArray(v)){const u=S.$Hb(v),$=g(u[0],y);return u.length>1?s.localize(4,null,$,u.length):$}if(R.$Jf(v))return v;if(v.detail){const u=v.detail;if(u.error)return M(u.error,y);if(u.exception)return M(u.exception,y)}return v.stack?M(v,y):v.message?v.message:s.localize(5,null)}e.$Si=g;function l(v){const y=v;return y instanceof Error&&Array.isArray(y.actions)}e.$Ti=l;function b(v,y){let u;return typeof v=="string"?u=new Error(v):u=v,u.actions=y,u}e.$Ui=b}),define(ae[151],ce([11,10]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(ae[152],ce([0,1,151]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;function R(s){switch(s){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.$Zp=R}),define(ae[153],ce([11,10]),function(X,e){return X.create("vs/base/common/platform",e)}),define(ae[4],ce([0,1,153]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let R=!1,s=!1,M=!1,D=!1,P=!1,g=!1,l=!1,b=!1,v=!1,y=!1,u,$=e.$g,w=e.$g,k,h;const f=globalThis;let d;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?d=f.vscode.process:typeof process<"u"&&(d=process);const m=typeof d?.versions?.electron=="string",c=m&&d?.type==="renderer";if(typeof d=="object"){R=d.platform==="win32",s=d.platform==="darwin",M=d.platform==="linux",D=M&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,l=m,v=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$g,$=e.$g;const E=d.env.VSCODE_NLS_CONFIG;if(E)try{const C=JSON.parse(E),j=C.availableLanguages["*"];u=C.locale,w=C.osLocale,$=j||e.$g,k=C._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!c?(h=navigator.userAgent,R=h.indexOf("Windows")>=0,s=h.indexOf("Macintosh")>=0,b=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=h.indexOf("Linux")>=0,y=h?.indexOf("Mobi")>=0,g=!0,u=S.getConfiguredDefaultLocale(S.localize(0,null))||e.$g,$=u,w=navigator.language):console.error("Unable to resolve platform.");var t;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let r=0;s?r=1:R?r=3:M&&(r=2),e.$i=R,e.$j=s,e.$k=M,e.$l=D,e.$m=P,e.$n=l,e.$o=g,e.$p=g&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=b,e.$s=y,e.$t=v,e.$u=r,e.$v=h,e.$w=$;var i;(function(E){function C(){return e.$w}E.value=C;function j(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=j;function U(){return e.$w==="en"}E.isDefault=U})(i||(e.Language=i={})),e.$x=u,e.$y=w,e.$z=k,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const E=[];f.addEventListener("message",j=>{if(j.data&&j.data.vscodeScheduleAsyncWork)for(let U=0,F=E.length;U<F;U++){const V=E[U];if(V.id===j.data.vscodeScheduleAsyncWork){E.splice(U,1),V.callback();return}}});let C=0;return j=>{const U=++C;E.push({id:U,callback:j}),f.postMessage({vscodeScheduleAsyncWork:U},"*")}}return E=>setTimeout(E)})();var n;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=s||b?2:R?1:3;let a=!0,p=!1;function A(){if(!p){p=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,a=new Uint16Array(E.buffer)[0]===513}return a}e.$D=A,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(E){return parseFloat(E)>=20}e.$J=I}),define(ae[36],ce([0,1,4]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let R;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const M=s.process;R={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return S.$i?"win32":S.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$dc=R.platform,e.$ec=R.arch}),define(ae[9],ce([0,1,36]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const R=65,s=97,M=90,D=122,P=46,g=47,l=92,b=58,v=63;class y extends Error{constructor(o,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const a=o.indexOf(".")!==-1?"property":"argument";let p=`The "${o}" ${a} ${n} of type ${r}`;p+=`. Received type ${typeof i}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function u(t,o){if(t===null||typeof t!="object")throw new y(o,"Object",t)}function $(t,o){if(typeof t!="string")throw new y(o,"string",t)}const w=S.$dc==="win32";function k(t){return t===g||t===l}function h(t){return t===g}function f(t){return t>=R&&t<=M||t>=s&&t<=D}function d(t,o,r,i){let n="",a=0,p=-1,A=0,I=0;for(let E=0;E<=t.length;++E){if(E<t.length)I=t.charCodeAt(E);else{if(i(I))break;I=g}if(i(I)){if(!(p===E-1||A===1))if(A===2){if(n.length<2||a!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const C=n.lastIndexOf(r);C===-1?(n="",a=0):(n=n.slice(0,C),a=n.length-1-n.lastIndexOf(r)),p=E,A=0;continue}else if(n.length!==0){n="",a=0,p=E,A=0;continue}}o&&(n+=n.length>0?`${r}..`:"..",a=2)}else n.length>0?n+=`${r}${t.slice(p+1,E)}`:n=t.slice(p+1,E),a=E-p-1;p=E,A=0}else I===P&&A!==-1?++A:A=-1}return n}function m(t,o){u(o,"pathObject");const r=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${i}`:`${r}${t}${i}`:i}e.$fc={resolve(...t){let o="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let a;if(n>=0){if(a=t[n],$(a,"path"),a.length===0)continue}else o.length===0?a=S.cwd():(a=S.env[`=${o}`]||S.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==o.toLowerCase()&&a.charCodeAt(2)===l)&&(a=`${o}\\`));const p=a.length;let A=0,I="",E=!1;const C=a.charCodeAt(0);if(p===1)k(C)&&(A=1,E=!0);else if(k(C))if(E=!0,k(a.charCodeAt(1))){let j=2,U=j;for(;j<p&&!k(a.charCodeAt(j));)j++;if(j<p&&j!==U){const F=a.slice(U,j);for(U=j;j<p&&k(a.charCodeAt(j));)j++;if(j<p&&j!==U){for(U=j;j<p&&!k(a.charCodeAt(j));)j++;(j===p||j!==U)&&(I=`\\\\${F}\\${a.slice(U,j)}`,A=j)}}}else A=1;else f(C)&&a.charCodeAt(1)===b&&(I=a.slice(0,2),A=2,p>2&&k(a.charCodeAt(2))&&(E=!0,A=3));if(I.length>0)if(o.length>0){if(I.toLowerCase()!==o.toLowerCase())continue}else o=I;if(i){if(o.length>0)break}else if(r=`${a.slice(A)}\\${r}`,i=E,E&&o.length>0)break}return r=d(r,!i,"\\",k),i?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){$(t,"path");const o=t.length;if(o===0)return".";let r=0,i,n=!1;const a=t.charCodeAt(0);if(o===1)return h(a)?"\\":t;if(k(a))if(n=!0,k(t.charCodeAt(1))){let A=2,I=A;for(;A<o&&!k(t.charCodeAt(A));)A++;if(A<o&&A!==I){const E=t.slice(I,A);for(I=A;A<o&&k(t.charCodeAt(A));)A++;if(A<o&&A!==I){for(I=A;A<o&&!k(t.charCodeAt(A));)A++;if(A===o)return`\\\\${E}\\${t.slice(I)}\\`;A!==I&&(i=`\\\\${E}\\${t.slice(I,A)}`,r=A)}}}else r=1;else f(a)&&t.charCodeAt(1)===b&&(i=t.slice(0,2),r=2,o>2&&k(t.charCodeAt(2))&&(n=!0,r=3));let p=r<o?d(t.slice(r),!n,"\\",k):"";return p.length===0&&!n&&(p="."),p.length>0&&k(t.charCodeAt(o-1))&&(p+="\\"),i===void 0?n?`\\${p}`:p:n?`${i}\\${p}`:`${i}${p}`},isAbsolute(t){$(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return k(r)||o>2&&f(r)&&t.charCodeAt(1)===b&&k(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let a=0;a<t.length;++a){const p=t[a];$(p,"path"),p.length>0&&(o===void 0?o=r=p:o+=`\\${p}`)}if(o===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&k(r.charCodeAt(0))){++n;const a=r.length;a>1&&k(r.charCodeAt(1))&&(++n,a>2&&(k(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<o.length&&k(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.$fc.normalize(o)},relative(t,o){if($(t,"from"),$(o,"to"),t===o)return"";const r=e.$fc.resolve(t),i=e.$fc.resolve(o);if(r===i||(t=r.toLowerCase(),o=i.toLowerCase(),t===o))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===l;)n++;let a=t.length;for(;a-1>n&&t.charCodeAt(a-1)===l;)a--;const p=a-n;let A=0;for(;A<o.length&&o.charCodeAt(A)===l;)A++;let I=o.length;for(;I-1>A&&o.charCodeAt(I-1)===l;)I--;const E=I-A,C=p<E?p:E;let j=-1,U=0;for(;U<C;U++){const V=t.charCodeAt(n+U);if(V!==o.charCodeAt(A+U))break;V===l&&(j=U)}if(U!==C){if(j===-1)return i}else{if(E>C){if(o.charCodeAt(A+U)===l)return i.slice(A+U+1);if(U===2)return i.slice(A+U)}p>C&&(t.charCodeAt(n+U)===l?j=U:U===2&&(j=3)),j===-1&&(j=0)}let F="";for(U=n+j+1;U<=a;++U)(U===a||t.charCodeAt(U)===l)&&(F+=F.length===0?"..":"\\..");return A+=j,F.length>0?`${F}${i.slice(A,I)}`:(i.charCodeAt(A)===l&&++A,i.slice(A,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===l){if(o.charCodeAt(1)===l){const r=o.charCodeAt(2);if(r!==v&&r!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===b&&o.charCodeAt(2)===l)return`\\\\?\\${o}`;return t},dirname(t){$(t,"path");const o=t.length;if(o===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(o===1)return k(n)?t:".";if(k(n)){if(r=i=1,k(t.charCodeAt(1))){let A=2,I=A;for(;A<o&&!k(t.charCodeAt(A));)A++;if(A<o&&A!==I){for(I=A;A<o&&k(t.charCodeAt(A));)A++;if(A<o&&A!==I){for(I=A;A<o&&!k(t.charCodeAt(A));)A++;if(A===o)return t;A!==I&&(r=i=A+1)}}}}else f(n)&&t.charCodeAt(1)===b&&(r=o>2&&k(t.charCodeAt(2))?3:2,i=r);let a=-1,p=!0;for(let A=o-1;A>=i;--A)if(k(t.charCodeAt(A))){if(!p){a=A;break}}else p=!1;if(a===-1){if(r===-1)return".";a=r}return t.slice(0,a)},basename(t,o){o!==void 0&&$(o,"ext"),$(t,"path");let r=0,i=-1,n=!0,a;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===b&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let p=o.length-1,A=-1;for(a=t.length-1;a>=r;--a){const I=t.charCodeAt(a);if(k(I)){if(!n){r=a+1;break}}else A===-1&&(n=!1,A=a+1),p>=0&&(I===o.charCodeAt(p)?--p===-1&&(i=a):(p=-1,i=A))}return r===i?i=A:i===-1&&(i=t.length),t.slice(r,i)}for(a=t.length-1;a>=r;--a)if(k(t.charCodeAt(a))){if(!n){r=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(r,i)},extname(t){$(t,"path");let o=0,r=-1,i=0,n=-1,a=!0,p=0;t.length>=2&&t.charCodeAt(1)===b&&f(t.charCodeAt(0))&&(o=i=2);for(let A=t.length-1;A>=o;--A){const I=t.charCodeAt(A);if(k(I)){if(!a){i=A+1;break}continue}n===-1&&(a=!1,n=A+1),I===P?r===-1?r=A:p!==1&&(p=1):r!==-1&&(p=-1)}return r===-1||n===-1||p===0||p===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:m.bind(null,"\\"),parse(t){$(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return k(n)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(k(n)){if(i=1,k(t.charCodeAt(1))){let j=2,U=j;for(;j<r&&!k(t.charCodeAt(j));)j++;if(j<r&&j!==U){for(U=j;j<r&&k(t.charCodeAt(j));)j++;if(j<r&&j!==U){for(U=j;j<r&&!k(t.charCodeAt(j));)j++;j===r?i=j:j!==U&&(i=j+1)}}}}else if(f(n)&&t.charCodeAt(1)===b){if(r<=2)return o.root=o.dir=t,o;if(i=2,k(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let a=-1,p=i,A=-1,I=!0,E=t.length-1,C=0;for(;E>=i;--E){if(n=t.charCodeAt(E),k(n)){if(!I){p=E+1;break}continue}A===-1&&(I=!1,A=E+1),n===P?a===-1?a=E:C!==1&&(C=1):a!==-1&&(C=-1)}return A!==-1&&(a===-1||C===0||C===1&&a===A-1&&a===p+1?o.base=o.name=t.slice(p,A):(o.name=t.slice(p,a),o.base=t.slice(p,A),o.ext=t.slice(a,A))),p>0&&p!==i?o.dir=t.slice(0,p-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(w){const t=/\\/g;return()=>{const o=S.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>S.cwd()})();e.$gc={resolve(...t){let o="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:c();$(n,"path"),n.length!==0&&(o=`${n}/${o}`,r=n.charCodeAt(0)===g)}return o=d(o,!r,"/",h),r?`/${o}`:o.length>0?o:"."},normalize(t){if($(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===g,r=t.charCodeAt(t.length-1)===g;return t=d(t,!o,"/",h),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return $(t,"path"),t.length>0&&t.charCodeAt(0)===g},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const i=t[r];$(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if($(t,"from"),$(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const r=1,i=t.length,n=i-r,a=1,p=o.length-a,A=n<p?n:p;let I=-1,E=0;for(;E<A;E++){const j=t.charCodeAt(r+E);if(j!==o.charCodeAt(a+E))break;j===g&&(I=E)}if(E===A)if(p>A){if(o.charCodeAt(a+E)===g)return o.slice(a+E+1);if(E===0)return o.slice(a+E)}else n>A&&(t.charCodeAt(r+E)===g?I=E:E===0&&(I=0));let C="";for(E=r+I+1;E<=i;++E)(E===i||t.charCodeAt(E)===g)&&(C+=C.length===0?"..":"/..");return`${C}${o.slice(a+I)}`},toNamespacedPath(t){return t},dirname(t){if($(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===g;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===g){if(!i){r=n;break}}else i=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&$(o,"ext"),$(t,"path");let r=0,i=-1,n=!0,a;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let p=o.length-1,A=-1;for(a=t.length-1;a>=0;--a){const I=t.charCodeAt(a);if(I===g){if(!n){r=a+1;break}}else A===-1&&(n=!1,A=a+1),p>=0&&(I===o.charCodeAt(p)?--p===-1&&(i=a):(p=-1,i=A))}return r===i?i=A:i===-1&&(i=t.length),t.slice(r,i)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===g){if(!n){r=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(r,i)},extname(t){$(t,"path");let o=-1,r=0,i=-1,n=!0,a=0;for(let p=t.length-1;p>=0;--p){const A=t.charCodeAt(p);if(A===g){if(!n){r=p+1;break}continue}i===-1&&(n=!1,i=p+1),A===P?o===-1?o=p:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||i===-1||a===0||a===1&&o===i-1&&o===r+1?"":t.slice(o,i)},format:m.bind(null,"/"),parse(t){$(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===g;let i;r?(o.root="/",i=1):i=0;let n=-1,a=0,p=-1,A=!0,I=t.length-1,E=0;for(;I>=i;--I){const C=t.charCodeAt(I);if(C===g){if(!A){a=I+1;break}continue}p===-1&&(A=!1,p=I+1),C===P?n===-1?n=I:E!==1&&(E=1):n!==-1&&(E=-1)}if(p!==-1){const C=a===0&&r?1:a;n===-1||E===0||E===1&&n===p-1&&n===a+1?o.base=o.name=t.slice(C,p):(o.name=t.slice(C,n),o.base=t.slice(C,p),o.ext=t.slice(n,p))}return a>0?o.dir=t.slice(0,a-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=w?e.$fc.normalize:e.$gc.normalize,e.$ic=w?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=w?e.$fc.join:e.$gc.join,e.$kc=w?e.$fc.resolve:e.$gc.resolve,e.$lc=w?e.$fc.relative:e.$gc.relative,e.$mc=w?e.$fc.dirname:e.$gc.dirname,e.$nc=w?e.$fc.basename:e.$gc.basename,e.$oc=w?e.$fc.extname:e.$gc.extname,e.$pc=w?e.$fc.format:e.$gc.format,e.$qc=w?e.$fc.parse:e.$gc.parse,e.$rc=w?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=w?e.$fc.sep:e.$gc.sep,e.$tc=w?e.$fc.delimiter:e.$gc.delimiter}),define(ae[33],ce([0,1,9,4,25,12]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function D(a){return a===47||a===92}e.$2f=D;function P(a){return a.replace(/[\\/]/g,S.$gc.sep)}e.$3f=P;function g(a){return a.indexOf("/")===-1&&(a=P(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$4f=g;function l(a,p=S.$gc.sep){if(!a)return"";const A=a.length,I=a.charCodeAt(0);if(D(I)){if(D(a.charCodeAt(1))&&!D(a.charCodeAt(2))){let C=3;const j=C;for(;C<A&&!D(a.charCodeAt(C));C++);if(j!==C&&!D(a.charCodeAt(C+1))){for(C+=1;C<A;C++)if(D(a.charCodeAt(C)))return a.slice(0,C+1).replace(/[\\/]/g,p)}}return p}else if(h(I)&&a.charCodeAt(1)===58)return D(a.charCodeAt(2))?a.slice(0,2)+p:a.slice(0,2);let E=a.indexOf("://");if(E!==-1){for(E+=3;E<A;E++)if(D(a.charCodeAt(E)))return a.slice(0,E+1)}return""}e.$5f=l;function b(a){if(!R.$i||!a||a.length<5)return!1;let p=a.charCodeAt(0);if(p!==92||(p=a.charCodeAt(1),p!==92))return!1;let A=2;const I=A;for(;A<a.length&&(p=a.charCodeAt(A),p!==92);A++);return!(I===A||(p=a.charCodeAt(A+1),isNaN(p)||p===92))}e.$6f=b;const v=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(a,p=R.$i){const A=p?v:y;return!(!a||a.length===0||/^\s+$/.test(a)||(A.lastIndex=0,A.test(a))||p&&u.test(a)||a==="."||a===".."||p&&a[a.length-1]==="."||p&&a.length!==a.trim().length||a.length>255)}e.$7f=$;function w(a,p,A){const I=a===p;return!A||I?I:!a||!p?!1:(0,s.$af)(a,p)}e.$8f=w;function k(a,p,A,I=S.sep){if(a===p)return!0;if(!a||!p||p.length>a.length)return!1;if(A){if(!(0,s.$bf)(a,p))return!1;if(p.length===a.length)return!0;let C=p.length;return p.charAt(p.length-1)===I&&C--,a.charAt(C)===I}return p.charAt(p.length-1)!==I&&(p+=I),a.indexOf(p)===0}e.$9f=k;function h(a){return a>=65&&a<=90||a>=97&&a<=122}e.$0f=h;function f(a,p){return R.$i&&a.endsWith(":")&&(a+=S.sep),(0,S.$ic)(a)||(a=(0,S.$jc)(p,a)),a=(0,S.$hc)(a),R.$i?(a=(0,s.$Ve)(a,S.sep),a.endsWith(":")&&(a+=S.sep)):(a=(0,s.$Ve)(a,S.sep),a||(a=S.sep)),a}e.$$f=f;function d(a){const p=(0,S.$hc)(a);return R.$i?a.length>3?!1:m(p)&&(a.length===2||p.charCodeAt(2)===92):p===S.$gc.sep}e.$_f=d;function m(a,p=R.$i){return p?h(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$ag=m;function c(a,p=R.$i){return m(a,p)?a[0]:void 0}e.$bg=c;function t(a,p,A){return p.length>a.length?-1:a===p?0:(A&&(a=a.toLowerCase(),p=p.toLowerCase()),a.indexOf(p))}e.$cg=t;function o(a){const p=a.split(":");let A,I,E;for(const C of p){const j=Number(C);(0,M.$Nf)(j)?I===void 0?I=j:E===void 0&&(E=j):A=A?[A,C].join(":"):C}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:I!==void 0?I:void 0,column:E!==void 0?E:I!==void 0?1:void 0}}e.$dg=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(a,p,A=8){let I="";for(let C=0;C<A;C++){let j;C===0&&R.$i&&!p&&(A===3||A===4)?j=i:j=r,I+=j.charAt(Math.floor(Math.random()*j.length))}let E;return p?E=`${p}-${I}`:E=I,a?(0,S.$jc)(a,E):E}e.$eg=n}),define(ae[75],ce([0,1,4]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0;var R;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(R||(e.Source=R={}));var s;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(P,...g){const l=g.reduce((y,u)=>(y[u]=!0,y),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(y=>!l[y]).forEach(y=>{for(let u=0;u<b.length;u++)if(y.search(b[u])!==-1){delete P[y];break}})}e.$Tl=M;function D(P){P&&(delete P.DEBUG,S.$j&&delete P.DYLD_LIBRARY_PATH,S.$k&&delete P.LD_PRELOAD)}e.$Ul=D}),define(ae[7],ce([0,1,9,4]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,D=/^\/\//;function P(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(i,n){return!i&&!n?"file":i}function l(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==v&&(n=v+n):n=v;break}return n}const b="",v="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(n){return n instanceof u?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,a,p,A,I,E=!1){typeof n=="object"?(this.scheme=n.scheme||b,this.authority=n.authority||b,this.path=n.path||b,this.query=n.query||b,this.fragment=n.fragment||b):(this.scheme=g(n,E),this.authority=a||b,this.path=l(this.scheme,p||b),this.query=A||b,this.fragment=I||b,P(this,E))}get fsPath(){return m(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:p,path:A,query:I,fragment:E}=n;return a===void 0?a=this.scheme:a===null&&(a=b),p===void 0?p=this.authority:p===null&&(p=b),A===void 0?A=this.path:A===null&&(A=b),I===void 0?I=this.query:I===null&&(I=b),E===void 0?E=this.fragment:E===null&&(E=b),a===this.scheme&&p===this.authority&&A===this.path&&I===this.query&&E===this.fragment?this:new k(a,p,A,I,E)}static parse(n,a=!1){const p=y.exec(n);return p?new k(p[2]||b,r(p[4]||b),r(p[5]||b),r(p[7]||b),r(p[9]||b),a):new k(b,b,b,b,b)}static file(n){let a=b;if(R.$i&&(n=n.replace(/\\/g,v)),n[0]===v&&n[1]===v){const p=n.indexOf(v,2);p===-1?(a=n.substring(2),n=v):(a=n.substring(2,p),n=n.substring(p)||v)}return new k("file",a,n,b,b)}static from(n,a){return new k(n.scheme,n.authority,n.path,n.query,n.fragment,a)}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return R.$i&&n.scheme==="file"?p=u.file(S.$fc.join(m(n,!0),...a)).path:p=S.$gc.join(n.path,...a),n.with({path:p})}toString(n=!1){return c(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof u)return n;{const a=new k(n);return a._formatted=n.external??null,a._fsPath=n._sep===w?n.fsPath??null:null,a}}else return n}}e.URI=u;function $(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=$;const w=R.$i?1:void 0;class k extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(n=!1){return n?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=w),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const h={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(i,n,a){let p,A=-1;for(let I=0;I<i.length;I++){const E=i.charCodeAt(I);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47||a&&E===91||a&&E===93||a&&E===58)A!==-1&&(p+=encodeURIComponent(i.substring(A,I)),A=-1),p!==void 0&&(p+=i.charAt(I));else{p===void 0&&(p=i.substr(0,I));const C=h[E];C!==void 0?(A!==-1&&(p+=encodeURIComponent(i.substring(A,I)),A=-1),p+=C):A===-1&&(A=I)}}return A!==-1&&(p+=encodeURIComponent(i.substring(A))),p!==void 0?p:i}function d(i){let n;for(let a=0;a<i.length;a++){const p=i.charCodeAt(a);p===35||p===63?(n===void 0&&(n=i.substr(0,a)),n+=h[p]):n!==void 0&&(n+=i[a])}return n!==void 0?n:i}function m(i,n){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,R.$i&&(a=a.replace(/\//g,"\\")),a}e.$wc=m;function c(i,n){const a=n?d:f;let p="",{scheme:A,authority:I,path:E,query:C,fragment:j}=i;if(A&&(p+=A,p+=":"),(I||A==="file")&&(p+=v,p+=v),I){let U=I.indexOf("@");if(U!==-1){const F=I.substr(0,U);I=I.substr(U+1),U=F.lastIndexOf(":"),U===-1?p+=a(F,!1,!1):(p+=a(F.substr(0,U),!1,!1),p+=":",p+=a(F.substr(U+1),!1,!0)),p+="@"}I=I.toLowerCase(),U=I.lastIndexOf(":"),U===-1?p+=a(I,!1,!0):(p+=a(I.substr(0,U),!1,!0),p+=I.substr(U))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const U=E.charCodeAt(1);U>=65&&U<=90&&(E=`/${String.fromCharCode(U+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const U=E.charCodeAt(0);U>=65&&U<=90&&(E=`${String.fromCharCode(U+32)}:${E.substr(2)}`)}p+=a(E,!0,!1)}return C&&(p+="?",p+=a(C,!1,!1)),j&&(p+="#",p+=n?j:f(j,!1,!1)),p}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(o)?i.replace(o,n=>t(n)):i}}),define(ae[154],ce([0,1,7]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$qq=e.$pq=e.$oq=void 0;function R(l){const b=l;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.$oq=R;function s(l){const b=[];let v;try{const y=JSON.parse(l.arguments),u=y[y.length-1];u&&u.__$stack&&(y.pop(),v=u.__$stack),b.push(...y)}catch{b.push("Unable to log remote console arguments",l.arguments)}return{args:b,stack:v}}e.$pq=s;function M(l){if(typeof l!="string")return M(s(l).stack);const b=l;if(b){const v=D(b),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.$qq=M;function D(l){if(!l)return l;const b=l.indexOf(`
`);return b===-1?l:l.substring(0,b)}function P(l,b){const{args:v,stack:y}=s(l),u=typeof v[0]=="string"&&v.length===1;let $=D(y);$&&($=`(${$.trim()})`);let w=[];if(typeof v[0]=="string"?$&&u?w=[`%c[${b}] %c${v[0]} %c${$}`,g("blue"),g(""),g("grey")]:w=[`%c[${b}] %c${v[0]}`,g("blue"),g(""),...v.slice(1)]:w=[`%c[${b}]%`,g("blue"),...v],$&&!u&&w.push($),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,w)}e.log=P;function g(l){return`color: ${l}`}}),define(ae[76],ce([0,1,17,7]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=void 0;function s(g){return JSON.stringify(g,D)}e.$Ch=s;function M(g){let l=JSON.parse(g);return l=P(l),l}e.$Dh=M;function D(g,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function P(g,l=0){if(!g||l>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return R.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof S.$ke||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let b=0;b<g.length;++b)g[b]=P(g[b],l+1);else for(const b in g)Object.hasOwnProperty.call(g,b)&&(g[b]=P(g[b],l+1))}return g}e.$Eh=P}),define(ae[13],ce([0,1,14,4,25,7]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var D;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeManagedRemoteResource="vscode-managed-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.vscodeChatSesssion="vscode-chat-editor",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(D||(e.Schemas=D={}));function P(y,u){return M.URI.isUri(y)?(0,s.$af)(y.scheme,u):(0,s.$bf)(y,u+":")}e.$fg=P;function g(y,...u){return u.some($=>P(y,$))}e.$gg=g,e.$hg="vscode-tkn",e.$ig="tkn";class l{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(u){this.d=u}setDelegate(u){this.e=u}setServerRootPath(u){this.f=`${u}/${D.vscodeRemoteResource}`}set(u,$,w){this.a[u]=$,this.b[u]=w}setConnectionToken(u,$){this.c[u]=$}getPreferredWebSchema(){return this.d}rewrite(u){if(this.e)try{return this.e(u)}catch(d){return S.$1(d),u}const $=u.authority;let w=this.a[$];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const k=this.b[$],h=this.c[$];let f=`path=${encodeURIComponent(u.path)}`;return typeof h=="string"&&(f+=`&${e.$ig}=${encodeURIComponent(h)}`),M.URI.from({scheme:R.$o?this.d:D.vscodeRemoteResource,authority:`${w}:${k}`,path:this.f,query:f})}}e.$jg=new l,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class b{static{this.a=e.$og}asBrowserUri(u){const $=this.b(u,X);return this.uriToBrowserUri($)}uriToBrowserUri(u){return u.scheme===D.vscodeRemote?e.$jg.rewrite(u):u.scheme===D.file&&(R.$m||R.$q===`${D.vscodeFileResource}://${b.a}`)?u.with({scheme:D.vscodeFileResource,authority:u.authority||b.a,query:null,fragment:null}):u}asFileUri(u){const $=this.b(u,X);return this.uriToFileUri($)}uriToFileUri(u){return u.scheme===D.vscodeFileResource?u.with({scheme:D.file,authority:u.authority!==b.a?u.authority:null,query:null,fragment:null}):u}b(u,$){return M.URI.isUri(u)?u:M.URI.parse($.toUrl(u))}}e.$pg=new b;var v;(function(y){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(u.get("3"));const $="vscode-coi";function w(h){let f;typeof h=="string"?f=new URL(h).searchParams:h instanceof URL?f=h.searchParams:M.URI.isUri(h)&&(f=new URL(h.toString(!0)).searchParams);const d=f?.get($);if(d)return u.get(d)}y.getHeadersFromQuery=w;function k(h,f,d){if(!globalThis.crossOriginIsolated)return;const m=f&&d?"3":d?"2":"1";h instanceof URLSearchParams?h.set($,m):h[$]=m}y.addSearchParam=k})(v||(e.COI=v={}))}),define(ae[19],ce([0,1,33,13,9,4,25,7]),function(X,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function g(u){return(0,P.$wc)(u,!0)}e.$wg=g;class l{constructor($){this.a=$}compare($,w,k=!1){return $===w?0:(0,D.$6e)(this.getComparisonKey($,k),this.getComparisonKey(w,k))}isEqual($,w,k=!1){return $===w?!0:!$||!w?!1:this.getComparisonKey($,k)===this.getComparisonKey(w,k)}getComparisonKey($,w=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,w,k=!1){if($.scheme===w.scheme){if($.scheme===R.Schemas.file)return S.$9f(g($),g(w),this.a($))&&$.query===w.query&&(k||$.fragment===w.fragment);if((0,e.$Ng)($.authority,w.authority))return S.$9f($.path,w.path,this.a($),"/")&&$.query===w.query&&(k||$.fragment===w.fragment)}return!1}joinPath($,...w){return P.URI.joinPath($,...w)}basenameOrAuthority($){return(0,e.$Fg)($)||$.authority}basename($){return s.$gc.basename($.path)}extname($){return s.$gc.extname($.path)}dirname($){if($.path.length===0)return $;let w;return $.scheme===R.Schemas.file?w=P.URI.file(s.$mc(g($))).path:(w=s.$gc.dirname($.path),$.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),w="/")),$.with({path:w})}normalizePath($){if(!$.path.length)return $;let w;return $.scheme===R.Schemas.file?w=P.URI.file(s.$hc(g($))).path:w=s.$gc.normalize($.path),$.with({path:w})}relativePath($,w){if($.scheme!==w.scheme||!(0,e.$Ng)($.authority,w.authority))return;if($.scheme===R.Schemas.file){const f=s.$lc(g($),g(w));return M.$i?S.$3f(f):f}let k=$.path||"/";const h=w.path||"/";if(this.a($)){let f=0;for(const d=Math.min(k.length,h.length);f<d&&!(k.charCodeAt(f)!==h.charCodeAt(f)&&k.charAt(f).toLowerCase()!==h.charAt(f).toLowerCase());f++);k=h.substr(0,f)+k.substr(f)}return s.$gc.relative(k,h)}resolvePath($,w){if($.scheme===R.Schemas.file){const k=P.URI.file(s.$kc(g($),w));return $.with({authority:k.authority,path:k.path})}return w=S.$4f(w),$.with({path:s.$gc.resolve($.path,w)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,w){return $===w||$!==void 0&&w!==void 0&&(0,D.$af)($,w)}hasTrailingPathSeparator($,w=s.sep){if($.scheme===R.Schemas.file){const k=g($);return k.length>S.$5f(k).length&&k[k.length-1]===w}else{const k=$.path;return k.length>1&&k.charCodeAt(k.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,w=s.sep){return(0,e.$Og)($,w)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,w=s.sep){let k=!1;if($.scheme===R.Schemas.file){const h=g($);k=h!==void 0&&h.length===S.$5f(h).length&&h[h.length-1]===w}else{w="/";const h=$.path;k=h.length===1&&h.charCodeAt(h.length-1)===47}return!k&&!(0,e.$Og)($,w)?$.with({path:$.path+"/"}):$}}e.$xg=l,e.$yg=new l(()=>!1),e.$zg=new l(u=>u.scheme===R.Schemas.file?!M.$k:!0),e.$Ag=new l(u=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function b(u,$){const w=[];for(let k=0;k<u.length;k++){const h=$(u[k]);u.some((f,d)=>d===k?!1:(0,e.$Cg)(h,$(f)))||w.push(u[k])}return w}e.$Rg=b;var v;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function $(w){const k=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(d=>{const[m,c]=d.split(":");m&&c&&k.set(m,c)});const f=w.path.substring(0,w.path.indexOf(";"));return f&&k.set(u.META_DATA_MIME,f),k}u.parseMetaData=$})(v||(e.DataUri=v={}));function y(u,$,w){if($){let k=u.path;return k&&k[0]!==s.$gc.sep&&(k=s.$gc.sep+k),u.with({scheme:w,authority:$,path:k})}return u.with({scheme:w})}e.$Sg=y}),define(ae[8],ce([0,1,23,14,3,2,19,4,143,62]),function(X,e,S,R,s,M,D,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.Promises=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function b(_){return!!_&&typeof _.then=="function"}e.$Tg=b;function v(_){const z=new S.$7d,ee=_(z.token),se=new Promise((de,me)=>{const Ee=z.token.onCancellationRequested(()=>{Ee.dispose(),me(new R.$5)});Promise.resolve(ee).then(Pe=>{Ee.dispose(),z.dispose(),de(Pe)},Pe=>{Ee.dispose(),z.dispose(),me(Pe)})});return new class{cancel(){z.cancel(),z.dispose()}then(de,me){return se.then(de,me)}catch(de){return this.then(void 0,de)}finally(de){return se.finally(de)}}}e.$Ug=v;function y(_,z,ee){return new Promise((se,de)=>{const me=z.onCancellationRequested(()=>{me.dispose(),se(ee)});_.then(se,de).finally(()=>me.dispose())})}e.$Vg=y;function u(_,z){return new Promise((ee,se)=>{const de=z.onCancellationRequested(()=>{de.dispose(),se(new R.$5)});_.then(ee,se).finally(()=>de.dispose())})}e.$Wg=u;async function $(_){let z=-1;const ee=_.map((se,de)=>se.then(me=>(z=de,me)));try{return await Promise.race(ee)}finally{_.forEach((se,de)=>{de!==z&&se.cancel()})}}e.$Xg=$;function w(_,z,ee){let se;const de=setTimeout(()=>{se?.(void 0),ee?.()},z);return Promise.race([_.finally(()=>clearTimeout(de)),new Promise(me=>se=me)])}e.$Yg=w;function k(_){return new Promise((z,ee)=>{const se=_();b(se)?se.then(z,ee):z(se)})}e.$Zg=k;function h(){let _,z;return{promise:new Promise((se,de)=>{_=se,z=de}),resolve:_,reject:z}}e.$1g=h;class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=z,!this.b){const ee=()=>{if(this.b=null,this.f)return;const se=this.queue(this.d);return this.d=null,se};this.b=new Promise(se=>{this.a.then(ee,ee).then(se)})}return new Promise((ee,se)=>{this.b.then(ee,se)})}return this.a=z(),new Promise((ee,se)=>{this.a.then(de=>{this.a=null,ee(de)},de=>{this.a=null,se(de)})})}dispose(){this.f=!0}}e.$2g=f;class d{constructor(){this.a=Promise.resolve(null)}queue(z){return this.a=this.a.then(()=>z(),()=>z())}}e.$3g=d;class m{constructor(){this.a=new Map}queue(z,ee){const de=(this.a.get(z)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.a.get(z)===de&&this.a.delete(z)});return this.a.set(z,de),de}}e.$4g=m;const c=(_,z)=>{let ee=!0;const se=setTimeout(()=>{ee=!1,z()},_);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(se),ee=!1}}},t=_=>{let z=!0;return queueMicrotask(()=>{z&&(z=!1,_())}),{isTriggered:()=>z,dispose:()=>{z=!1}}};class o{constructor(z){this.defaultDelay=z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(z,ee=this.defaultDelay){this.g=z,this.h(),this.b||(this.b=new Promise((de,me)=>{this.d=de,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const se=()=>{this.a=null,this.d?.(null)};return this.a=ee===g.$Td?t(se):c(ee,se),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$5g=o;class r{constructor(z){this.a=new o(z),this.b=new f}trigger(z,ee){return this.a.trigger(()=>this.b.queue(z),ee)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$6g=r;class i{constructor(){this.a=!1,this.b=new Promise((z,ee)=>{this.d=z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$7g=i;class n extends i{constructor(z){super(),this.f=setTimeout(()=>this.open(),z)}open(){clearTimeout(this.f),super.open()}}e.$8g=n;function a(_,z){return z?new Promise((ee,se)=>{const de=setTimeout(()=>{me.dispose(),ee()},_),me=z.onCancellationRequested(()=>{clearTimeout(de),me.dispose(),se(new R.$5)})}):v(ee=>a(_,ee))}e.$9g=a;function p(_,z=0,ee){const se=setTimeout(()=>{_(),ee&&de.dispose()},z),de=(0,M.$Rc)(()=>{clearTimeout(se),ee?.deleteAndLeak(de)});return ee?.add(de),de}e.$0g=p;function A(_){const z=[];let ee=0;const se=_.length;function de(){return ee<se?_[ee++]():null}function me(Ee){Ee!=null&&z.push(Ee);const Pe=de();return Pe?Pe.then(me):Promise.resolve(z)}return Promise.resolve(null).then(me)}e.$$g=A;function I(_,z=se=>!!se,ee=null){let se=0;const de=_.length,me=()=>{if(se>=de)return Promise.resolve(ee);const Ee=_[se++];return Promise.resolve(Ee()).then(Le=>z(Le)?Promise.resolve(Le):me())};return me()}e.$_g=I;function E(_,z=se=>!!se,ee=null){if(_.length===0)return Promise.resolve(ee);let se=_.length;const de=()=>{se=-1;for(const me of _)me.cancel?.()};return new Promise((me,Ee)=>{for(const Pe of _)Pe.then(Le=>{--se>=0&&z(Le)?(de(),me(Le)):se===0&&me(ee)}).catch(Le=>{--se>=0&&(de(),Ee(Le))})})}e.$ah=E;class C{constructor(z){this.a=0,this.b=!1,this.f=z,this.g=[],this.d=0,this.h=new s.$Wd}whenIdle(){return this.size>0?s.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ee,se)=>{this.g.push({factory:z,c:ee,e:se}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const z=this.g.shift();this.d++;const ee=z.factory();ee.then(z.c,z.e),ee.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$bh=C;class j extends C{constructor(){super(1)}}e.$ch=j;class U{constructor(){this.a=new N,this.b=0}queue(z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,z())):this.a.run(this.b++,z())}}e.$dh=U;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const z=new te;return this.b.add(z),z.p}g(){for(const[,z]of this.a)if(z.size>0)return!1;return!0}queueSize(z,ee=D.$yg){const se=ee.getComparisonKey(z);return this.a.get(se)?.size??0}queueFor(z,ee,se=D.$yg){const de=se.getComparisonKey(z);let me=this.a.get(de);if(!me){me=new j;const Ee=this.f++,Pe=s.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$3c),this.d.set(Ee,Pe),this.a.set(de,me)}return me.queue(ee)}h(){this.g()&&this.j()}j(){for(const z of this.b)z.complete();this.b.clear()}dispose(){for(const[,z]of this.a)z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$eh=F;class V{constructor(z,ee){this.a=-1,typeof z=="function"&&typeof ee=="number"&&this.setIfNotSet(z,ee)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(z,ee){this.cancel(),this.a=setTimeout(()=>{this.a=-1,z()},ee)}setIfNotSet(z,ee){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,z()},ee))}}e.$fh=V;class J{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(z,ee,se=globalThis){this.cancel();const de=se.setInterval(()=>{z()},ee);this.d=(0,M.$Rc)(()=>{se.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$gh=J;class le{constructor(z,ee){this.b=-1,this.a=z,this.d=ee,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(z=this.d){this.cancel(),this.b=setTimeout(this.f,z)}get delay(){return this.d}set delay(z){this.d=z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$hh=le;class oe{constructor(z,ee){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.a=z,this.b=ee,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(z=this.b){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ih=oe;class ue extends le{constructor(z,ee){super(z,ee),this.j=[]}work(z){this.j.push(z),this.isScheduled()||this.schedule()}h(){const z=this.j;this.j=[],this.a?.(z)}dispose(){this.j=[],super.dispose()}}e.$jh=ue;class Z extends M.$Tc{constructor(z,ee){super(),this.g=z,this.h=ee,this.a=[],this.b=this.B(new M.$Uc),this.f=!1}get pending(){return this.a.length}work(z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+z.length>this.g.maxBufferedWork)return!1}else if(this.pending+z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ee of z)this.a.push(ee);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new le(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$kh=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$mh=(_,z)=>{(0,P.$B)(()=>{if(ee)return;const se=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,se-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.$mh=(_,z,ee)=>{const se=_.requestIdleCallback(z,typeof ee=="number"?{timeout:ee}:void 0);let de=!1;return{dispose(){de||(de=!0,_.cancelIdleCallback(se))}}},e.$lh=_=>(0,e.$mh)(globalThis,_)}();class Y{constructor(z,ee){this.g=!1,this.d=()=>{try{this.j=ee()}catch(se){this.l=se}finally{this.g=!0}},this.f=(0,e.$mh)(z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$nh=Y;class q extends Y{constructor(z){super(globalThis,z)}}e.$oh=q;async function L(_,z,ee){let se;for(let de=0;de<ee;de++)try{return await _()}catch(me){se=me,await a(z)}throw se}e.$ph=L;class N{isRunning(z){return typeof z=="number"?this.a?.taskId===z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(z,ee,se){return this.a={taskId:z,cancel:()=>se?.(),promise:ee},ee.then(()=>this.d(z),()=>this.d(z)),ee}d(z){this.a&&z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const z=this.b;this.b=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}queue(z){if(this.b)this.b.run=z;else{const{promise:ee,resolve:se,reject:de}=h();this.b={run:z,promise:ee,promiseResolve:se,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$qh=N;class G{constructor(z,ee=()=>Date.now()){this.d=z,this.f=ee,this.a=0,this.b=0}increment(){const z=this.f();return z-this.a>this.d&&(this.a=z,this.b=0),this.b++,this.b}}e.$rh=G;var B;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(B||(B={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((z,ee)=>{this.a=z,this.b=ee})}complete(z){return new Promise(ee=>{this.a(z),this.d={outcome:0,value:z},ee()})}error(z){return new Promise(ee=>{this.b(z),this.d={outcome:1,value:z},ee()})}cancel(){return this.error(new R.$5)}}e.$sh=te;var he;(function(_){async function z(se){let de;const me=await Promise.all(se.map(Ee=>Ee.then(Pe=>Pe,Pe=>{de||(de=Pe)})));if(typeof de<"u")throw de;return me}_.settled=z;function ee(se){return new Promise(async(de,me)=>{try{await se(de,me)}catch(Ee){me(Ee)}})}_.withAsyncBody=ee})(he||(e.Promises=he={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=z.then(ee=>(this.a=ee,this.d=!0,ee),ee=>{throw this.b=ee,this.d=!0,ee})}requireValue(){if(!this.d)throw new R.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$th=K;class O{constructor(z){this.b=z,this.a=new l.$V(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$uh=O;var W;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(W||(W={}));class x{static fromArray(z){return new x(ee=>{ee.emitMany(z)})}static fromPromise(z){return new x(async ee=>{ee.emitMany(await z)})}static fromPromises(z){return new x(async ee=>{await Promise.all(z.map(async se=>ee.emitOne(await se)))})}static merge(z){return new x(async ee=>{await Promise.all(z.map(async se=>{for await(const de of se)ee.emitOne(de)}))})}static{this.EMPTY=x.fromArray([])}constructor(z){this.a=0,this.b=[],this.d=null,this.f=new s.$Wd,queueMicrotask(async()=>{const ee={emitOne:se=>this.g(se),emitMany:se=>this.h(se),reject:se=>this.k(se)};try{await Promise.resolve(z(ee)),this.j()}catch(se){this.k(se)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}[Symbol.asyncIterator](){let z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(z<this.b.length)return{done:!1,value:this.b[z++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(z,ee){return new x(async se=>{for await(const de of z)se.emitOne(ee(de))})}map(z){return x.map(this,z)}static filter(z,ee){return new x(async se=>{for await(const de of z)ee(de)&&se.emitOne(de)})}filter(z){return x.filter(this,z)}static coalesce(z){return x.filter(z,ee=>!!ee)}coalesce(){return x.coalesce(this)}static async toPromise(z){const ee=[];for await(const se of z)ee.push(se);return ee}toPromise(){return x.toPromise(this)}g(z){this.a===0&&(this.b.push(z),this.f.fire())}h(z){this.a===0&&(this.b=this.b.concat(z),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(z){this.a===0&&(this.a=2,this.d=z,this.f.fire())}}e.$vh=x;class T extends x{constructor(z,ee){super(ee),this.l=z}cancel(){this.l.cancel()}}e.$wh=T;function Q(_){const z=new S.$7d,ee=_(z.token);return new T(z,async se=>{const de=z.token.onCancellationRequested(()=>{de.dispose(),z.dispose(),se.reject(new R.$5)});try{for await(const me of ee){if(z.token.isCancellationRequested)return;se.emitOne(me)}de.dispose(),z.dispose()}catch(me){de.dispose(),z.dispose(),se.reject(me)}})}e.$xh=Q;class H{constructor(){this.a=new te,this.b=new x(se=>{if(z){se.reject(z);return}return ee&&se.emitMany(ee),this.d=de=>se.reject(de),this.f=de=>se.emitOne(de),this.a.p});let z,ee;this.f=se=>{ee||(ee=[]),ee.push(se)},this.d=se=>{z||(z=se)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(z){this.d(z),this.a.complete()}emitOne(z){this.f(z)}}e.$yh=H}),define(ae[105],ce([0,1,22,8,33,31,9,4,25]),function(X,e,S,R,s,M,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=void 0;function l(){return Object.create(null)}e.$Jj=l,e.$Kj="**",e.$Lj="/";const b="[/\\\\]",v="[^/\\\\]",y=/\//g;function u(Y,q){switch(Y){case 0:return"";case 1:return`${v}*?`;default:return`(?:${b}|${v}+${b}${q?`|${b}${v}+`:""})*?`}}function $(Y,q){if(!Y)return[];const L=[];let N=!1,G=!1,B="";for(const te of Y){switch(te){case q:if(!N&&!G){L.push(B),B="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":G=!0;break;case"]":G=!1;break}B+=te}return B&&L.push(B),L}e.$Mj=$;function w(Y){if(!Y)return"";let q="";const L=$(Y,e.$Lj);if(L.every(N=>N===e.$Kj))q=".*";else{let N=!1;L.forEach((G,B)=>{if(G===e.$Kj){if(N)return;q+=u(2,B===L.length-1)}else{let te=!1,he="",K=!1,O="";for(const W of G){if(W!=="}"&&te){he+=W;continue}if(K&&(W!=="]"||!O)){let x;W==="-"?x=W:(W==="^"||W==="!")&&!O?x="^":W===e.$Lj?x="":x=(0,g.$Pe)(W),O+=x;continue}switch(W){case"{":te=!0;continue;case"[":K=!0;continue;case"}":{const T=`(?:${$(he,",").map(Q=>w(Q)).join("|")})`;q+=T,te=!1,he="";break}case"]":{q+="["+O+"]",K=!1,O="";break}case"?":q+=v;continue;case"*":q+=u(1);continue;default:q+=(0,g.$Pe)(W)}}B<L.length-1&&(L[B+1]!==e.$Kj||B+2<L.length)&&(q+=b)}N=G===e.$Kj})}return q}const k=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Dc(1e4),o=function(){return!1},r=function(){return null};function i(Y,q){if(!Y)return r;let L;typeof Y!="string"?L=Y.pattern:L=Y,L=L.trim();const N=`${L}_${!!q.trimForExclusions}`;let G=t.get(N);if(G)return n(G,Y);let B;return k.test(L)?G=p(L.substr(4),L):(B=h.exec(a(L,q)))?G=A(B[1],L):(q.trimForExclusions?d:f).test(L)?G=I(L,q):(B=m.exec(a(L,q)))?G=E(B[1].substr(1),L,!0):(B=c.exec(a(L,q)))?G=E(B[1],L,!1):G=C(L),t.set(N,G),n(G,Y)}function n(Y,q){if(typeof q=="string")return Y;const L=function(N,G){return(0,s.$9f)(N,q.base,!P.$k)?Y((0,g.$Ue)(N.substr(q.base.length),D.sep),G):null};return L.allBasenames=Y.allBasenames,L.allPaths=Y.allPaths,L.basenames=Y.basenames,L.patterns=Y.patterns,L}function a(Y,q){return q.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function p(Y,q){return function(L,N){return typeof L=="string"&&L.endsWith(Y)?q:null}}function A(Y,q){const L=`/${Y}`,N=`\\${Y}`,G=function(te,he){return typeof te!="string"?null:he?he===Y?q:null:te===Y||te.endsWith(L)||te.endsWith(N)?q:null},B=[Y];return G.basenames=B,G.patterns=[q],G.allBasenames=B,G}function I(Y,q){const L=ue(Y.slice(1,-1).split(",").map(he=>i(he,q)).filter(he=>he!==r),Y),N=L.length;if(!N)return r;if(N===1)return L[0];const G=function(he,K){for(let O=0,W=L.length;O<W;O++)if(L[O](he,K))return Y;return null},B=L.find(he=>!!he.allBasenames);B&&(G.allBasenames=B.allBasenames);const te=L.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return te.length&&(G.allPaths=te),G}function E(Y,q,L){const N=D.sep===D.$gc.sep,G=N?Y:Y.replace(y,D.sep),B=D.sep+G,te=D.$gc.sep+Y;let he;return L?he=function(K,O){return typeof K=="string"&&(K===G||K.endsWith(B)||!N&&(K===Y||K.endsWith(te)))?q:null}:he=function(K,O){return typeof K=="string"&&(K===G||!N&&K===Y)?q:null},he.allPaths=[(L?"*/":"./")+Y],he}function C(Y){try{const q=new RegExp(`^${w(Y)}$`);return function(L){return q.lastIndex=0,typeof L=="string"&&q.test(L)?Y:null}}catch{return r}}function j(Y,q,L){return!Y||typeof q!="string"?!1:U(Y)(q,void 0,L)}e.$Nj=j;function U(Y,q={}){if(!Y)return o;if(typeof Y=="string"||F(Y)){const L=i(Y,q);if(L===r)return o;const N=function(G,B){return!!L(G,B)};return L.allBasenames&&(N.allBasenames=L.allBasenames),L.allPaths&&(N.allPaths=L.allPaths),N}return le(Y,q)}e.$Oj=U;function F(Y){const q=Y;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.$Pj=F;function V(Y){return Y.allBasenames||[]}e.$Qj=V;function J(Y){return Y.allPaths||[]}e.$Rj=J;function le(Y,q){const L=ue(Object.getOwnPropertyNames(Y).map(he=>oe(he,Y[he],q)).filter(he=>he!==r)),N=L.length;if(!N)return r;if(!L.some(he=>!!he.requiresSiblings)){if(N===1)return L[0];const he=function(W,x){let T;for(let Q=0,H=L.length;Q<H;Q++){const _=L[Q](W,x);if(typeof _=="string")return _;(0,R.$Tg)(_)&&(T||(T=[]),T.push(_))}return T?(async()=>{for(const Q of T){const H=await Q;if(typeof H=="string")return H}return null})():null},K=L.find(W=>!!W.allBasenames);K&&(he.allBasenames=K.allBasenames);const O=L.reduce((W,x)=>x.allPaths?W.concat(x.allPaths):W,[]);return O.length&&(he.allPaths=O),he}const G=function(he,K,O){let W,x;for(let T=0,Q=L.length;T<Q;T++){const H=L[T];H.requiresSiblings&&O&&(K||(K=(0,D.$nc)(he)),W||(W=K.substr(0,K.length-(0,D.$oc)(he).length)));const _=H(he,K,W,O);if(typeof _=="string")return _;(0,R.$Tg)(_)&&(x||(x=[]),x.push(_))}return x?(async()=>{for(const T of x){const Q=await T;if(typeof Q=="string")return Q}return null})():null},B=L.find(he=>!!he.allBasenames);B&&(G.allBasenames=B.allBasenames);const te=L.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return te.length&&(G.allPaths=te),G}function oe(Y,q,L){if(q===!1)return r;const N=i(Y,L);if(N===r)return r;if(typeof q=="boolean")return N;if(q){const G=q.when;if(typeof G=="string"){const B=(te,he,K,O)=>{if(!O||!N(te,he))return null;const W=G.replace("$(basename)",()=>K),x=O(W);return(0,R.$Tg)(x)?x.then(T=>T?Y:null):x?Y:null};return B.requiresSiblings=!0,B}}return N}function ue(Y,q){const L=Y.filter(he=>!!he.basenames);if(L.length<2)return Y;const N=L.reduce((he,K)=>{const O=K.basenames;return O?he.concat(O):he},[]);let G;if(q){G=[];for(let he=0,K=N.length;he<K;he++)G.push(q)}else G=L.reduce((he,K)=>{const O=K.patterns;return O?he.concat(O):he},[]);const B=function(he,K){if(typeof he!="string")return null;if(!K){let W;for(W=he.length;W>0;W--){const x=he.charCodeAt(W-1);if(x===47||x===92)break}K=he.substr(W)}const O=N.indexOf(K);return O!==-1?G[O]:null};B.basenames=N,B.patterns=G,B.allBasenames=N;const te=Y.filter(he=>!he.basenames);return te.push(B),te}function Z(Y,q){return(0,S.$ub)(Y,q,(L,N)=>typeof L=="string"&&typeof N=="string"?L===N:typeof L!="string"&&typeof N!="string"?L.base===N.base&&L.pattern===N.pattern:!1)}e.$Sj=Z}),define(ae[47],ce([0,1,22,33,9,4,19,25]),function(X,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=void 0;function g(i,n){const{os:a,tildify:p,relative:A}=n;if(A){const C=l(i,A,a);if(typeof C=="string")return C}let I=i.fsPath;if(a===1&&!M.$i?I=I.replace(/\//g,"\\"):a!==1&&M.$i&&(I=I.replace(/\\/g,"/")),a!==1&&p?.userHome){const C=p.userHome.fsPath;let j;i.scheme!==p.userHome.scheme&&i.path[0]===s.$gc.sep&&i.path[1]!==s.$gc.sep?j=p.userHome.with({path:i.path}).fsPath:j=I,I=y(j,C,a)}return(a===1?s.$fc:s.$gc).normalize(b(I,a===1))}e.$Xv=g;function l(i,n,a){const p=a===1?s.$fc:s.$gc,A=a===3?D.$yg:D.$Ag,I=n.getWorkspace(),E=(0,S.$Ob)(I.folders);if(!E)return;i.scheme!==E.uri.scheme&&i.path[0]===s.$gc.sep&&i.path[1]!==s.$gc.sep&&(i=E.uri.with({path:i.path}));const C=n.getWorkspaceFolder(i);if(!C)return;let j;if(A.isEqual(C.uri,i)?j="":j=A.relativePath(C.uri,i)??"",j&&(j=p.normalize(j)),I.folders.length>1&&!n.noPrefix){const U=C.name?C.name:A.basenameOrAuthority(C.uri);j=j?`${U} \u2022 ${j}`:U}return j}function b(i,n=M.$i){return(0,R.$ag)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$Yv=b;let v=Object.create(null);function y(i,n,a=M.OS){if(a===1||!i||!n)return i;let p=v.original===n?v.normalized:void 0;p||(p=n,M.$i&&(p=(0,R.$3f)(p)),p=`${(0,P.$Ve)(p,s.$gc.sep)}${s.$gc.sep}`,v={original:n,normalized:p});let A=i;return M.$i&&(A=(0,R.$3f)(A)),(a===3?A.startsWith(p):(0,P.$bf)(A,p))?`~/${A.substr(p.length)}`:i}e.$Zv=y;function u(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$1v=u;const $="\u2026",w="\\\\",k="~";function h(i,n=s.sep){const a=new Array(i.length);let p=!1;for(let A=0;A<i.length;A++){const I=i[A];if(I===""){a[A]=`.${n}`;continue}if(!I){a[A]=I;continue}p=!0;let E="",C=I;C.indexOf(w)===0?(E=C.substr(0,C.indexOf(w)+w.length),C=C.substr(C.indexOf(w)+w.length)):C.indexOf(n)===0?(E=C.substr(0,C.indexOf(n)+n.length),C=C.substr(C.indexOf(n)+n.length)):C.indexOf(k)===0&&(E=C.substr(0,C.indexOf(k)+k.length),C=C.substr(C.indexOf(k)+k.length));const j=C.split(n);for(let U=1;p&&U<=j.length;U++)for(let F=j.length-U;p&&F>=0;F--){p=!1;let V=j.slice(F,F+U).join(n);for(let J=0;!p&&J<i.length;J++)if(J!==A&&i[J]&&i[J].indexOf(V)>-1){const le=F+U===j.length,oe=F>0&&i[J].indexOf(n)>-1?n+V:V,ue=i[J].endsWith(oe);p=!le||ue}if(!p){let J="";(j[0].endsWith(":")||E!=="")&&(F===1&&(F=0,U++,V=j[0]+n+V),F>0&&(J=j[0]+n),J=E+J),F>0&&(J=J+$+n),J=J+V,F+U<j.length&&(J=J+n+$),a[A]=J}}p&&(a[A]=I)}return a}e.$2v=h;var f;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function d(i,n=Object.create(null)){const a=[];let p=!1,A="";for(const I of i)if(I==="$"||p&&I==="{")A&&a.push({value:A,type:f.TEXT}),A="",p=!0;else if(I==="}"&&p){const E=n[A];if(typeof E=="string")E.length&&a.push({value:E,type:f.VARIABLE});else if(E){const C=a[a.length-1];(!C||C.type!==f.SEPARATOR)&&a.push({value:E.label,type:f.SEPARATOR})}A="",p=!1}else A+=I;return A&&!p&&a.push({value:A,type:f.TEXT}),a.filter((I,E)=>{if(I.type===f.SEPARATOR){const C=a[E-1],j=a[E+1];return[C,j].every(U=>U&&(U.type===f.VARIABLE||U.type===f.TEXT)&&U.value.length>0)}return!0}).map(I=>I.value).join("")}e.$3v=d;function m(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$4v=m;function c(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,""):M.$i?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$5v=c;function t(i){return i.replace(/&/g,"&&")}e.$6v=t;function o(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const a=r(i.substring(0,n)),p=i.substring(n);return{name:a.name+p,parentPath:a.parentPath}}}return r(i)}e.$7v=o;function r(i){const n=i.indexOf("/")!==-1?s.$gc:s.$fc,a=n.basename(i),p=n.dirname(i);return a.length?{name:a,parentPath:p}:{name:p,parentPath:""}}}),define(ae[155],ce([0,1,17,7]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function s(v){return v.toJSON()}class M{constructor(y){this.a=y}transformIncoming(y){const u=this.a.transformIncoming(y);return u===y?y:s(R.URI.from(u))}transformOutgoing(y){const u=this.a.transformOutgoing(y);return u===y?y:s(R.URI.from(u))}transformOutgoingURI(y){const u=this.a.transformOutgoing(y);return u===y?y:R.URI.from(u)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$7m=M,e.$8m=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function D(v,y,u){if(!v||u>200)return null;if(typeof v=="object"){if(v instanceof R.URI)return y.transformOutgoing(v);for(const $ in v)if(Object.hasOwnProperty.call(v,$)){const w=D(v[$],y,u+1);w!==null&&(v[$]=w)}}return null}function P(v,y){const u=D(v,y,0);return u===null?v:u}e.$9m=P;function g(v,y,u,$){if(!v||$>200)return null;if(typeof v=="object"){if(v.$mid===1)return u?R.URI.revive(y.transformIncoming(v)):y.transformIncoming(v);if(v instanceof S.$ke)return null;for(const w in v)if(Object.hasOwnProperty.call(v,w)){const k=g(v[w],y,u,$+1);k!==null&&(v[w]=k)}}return null}function l(v,y){const u=g(v,y,!1,0);return u===null?v:u}e.$0m=l;function b(v,y){const u=g(v,y,!0,0);return u===null?v:u}e.$$m=b}),define(ae[88],ce([0,1,26,59,32,145,4]),function(X,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=void 0,e.$an=new class{c(y){return this.a||(this.a=R.$bi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,u=0;const $=(0,S.networkInterfaces)();for(const w in $){const k=$[w];if(k)for(const{mac:h,internal:f}of k)f||(u+=1,this.c(h.toUpperCase())&&(y+=1))}this.b=u>0?y/u:0}return this.b}};let P;async function g(y){return P||(P=(async()=>await l(y)||s.$rg())()),P}e.$bn=g;async function l(y){try{const u=await new Promise((w,k)=>{X(["crypto"],w,k)}),$=(0,M.$_m)();return u.createHash("sha256").update($,"utf8").digest("hex")}catch(u){y(u);return}}const b="Software\\Microsoft\\SQMClient";async function v(y){if(D.$i){const u=await new Promise(($,w)=>{X(["@vscode/windows-registry"],$,w)});try{return u.GetStringRegKey("HKEY_LOCAL_MACHINE",b,"MachineId")||""}catch($){return y($),""}}return""}e.$cn=v}),define(ae[21],ce([0,1,46,26,156,8,33,85,9,4,19,7]),function(X,e,S,R,s,M,D,P,g,l,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(oe){oe[oe.UNLINK=0]="UNLINK",oe[oe.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function u(oe,ue=y.UNLINK,Z){if((0,D.$_f)(oe))throw new Error("rimraf - will refuse to recursively delete root");return ue===y.UNLINK?w(oe):$(oe,Z)}async function $(oe,ue=(0,D.$eg)((0,R.tmpdir)())){try{try{await S.promises.rename(oe,ue)}catch(Z){return Z.code==="ENOENT"?void 0:w(oe)}w(ue).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function w(oe){return(0,s.promisify)(S.rm)(oe,{recursive:!0,force:!0,maxRetries:3})}function k(oe){if((0,D.$_f)(oe))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(oe,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=k;async function h(oe,ue){return m(await(ue?f(oe):(0,s.promisify)(S.readdir)(oe)))}async function f(oe){try{return await(0,s.promisify)(S.readdir)(oe,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const ue=[],Z=await h(oe);for(const Y of Z){let q=!1,L=!1,N=!1;try{const G=await e.Promises.lstat((0,g.$jc)(oe,Y));q=G.isFile(),L=G.isDirectory(),N=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}ue.push({name:Y,isFile:()=>q,isDirectory:()=>L,isSymbolicLink:()=>N})}return ue}function d(oe){return m(S.readdirSync(oe))}e.readdirSync=d;function m(oe){return oe.map(ue=>typeof ue=="string"?l.$j?(0,P.$Il)(ue):ue:(ue.name=l.$j?(0,P.$Il)(ue.name):ue.name,ue))}async function c(oe){const ue=await h(oe),Z=[];for(const Y of ue)await o.existsDirectory((0,g.$jc)(oe,Y))&&Z.push(Y);return Z}function t(oe,ue=1e3){return new Promise(Z=>{let Y=!1;const q=setInterval(()=>{Y||(Y=!0,S.access(oe,L=>{Y=!1,L&&(clearInterval(q),Z(void 0))}))},ue)})}e.whenDeleted=t;var o;(function(oe){async function ue(q){let L;try{if(L=await e.Promises.lstat(q),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(l.$i&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw G}throw N}}oe.stat=ue;async function Z(q){try{const{stat:L,symbolicLink:N}=await oe.stat(q);return L.isFile()&&N?.dangling!==!0}catch{}return!1}oe.existsFile=Z;async function Y(q){try{const{stat:L,symbolicLink:N}=await oe.stat(q);return L.isDirectory()&&N?.dangling!==!0}catch{}return!1}oe.existsDirectory=Y})(o||(e.SymlinkSupport=o={}));const r=new M.$eh;function i(oe,ue,Z){return r.queueFor(v.URI.file(oe),()=>{const Y=I(Z);return new Promise((q,L)=>p(oe,ue,Y,N=>N?L(N):q()))},b.$zg)}let n=!0;function a(oe){n=oe}e.configureFlushOnWrite=a;function p(oe,ue,Z,Y){if(!n)return S.writeFile(oe,ue,{mode:Z.mode,flag:Z.flag},Y);S.open(oe,Z.flag,Z.mode,(q,L)=>{if(q)return Y(q);S.writeFile(L,ue,N=>{if(N)return S.close(L,()=>Y(N));S.fdatasync(L,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),a(!1)),S.close(L,B=>Y(B))))})})}function A(oe,ue,Z){const Y=I(Z);if(!n)return S.writeFileSync(oe,ue,{mode:Y.mode,flag:Y.flag});const q=S.openSync(oe,Y.flag,Y.mode);try{S.writeFileSync(q,ue);try{S.fdatasyncSync(q)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),a(!1)}}finally{S.closeSync(q)}}e.writeFileSync=A;function I(oe){return oe?{mode:typeof oe.mode=="number"?oe.mode:438,flag:typeof oe.flag=="string"?oe.flag:"w"}:{mode:438,flag:"w"}}async function E(oe,ue,Z=6e4){if(oe!==ue)try{l.$i&&typeof Z=="number"?await C(oe,ue,Date.now(),Z):await(0,s.promisify)(S.rename)(oe,ue)}catch(Y){if(oe.toLowerCase()!==ue.toLowerCase()&&Y.code==="EXDEV"||oe.endsWith("."))await j(oe,ue,{preserveSymlinks:!1}),await u(oe,y.MOVE);else throw Y}}async function C(oe,ue,Z,Y,q=0){try{return await(0,s.promisify)(S.rename)(oe,ue)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-Z>=Y)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${L}`),L;if(q===0){let N=!1;try{const{stat:G}=await o.stat(ue);G.isFile()||(N=!0)}catch{}if(N)throw L}return await(0,M.$9g)(Math.min(100,q*10)),C(oe,ue,Z,Y,q+1)}}async function j(oe,ue,Z){return F(oe,ue,{root:{source:oe,target:ue},options:Z,handledSourcePaths:new Set})}const U=511;async function F(oe,ue,Z){if(Z.handledSourcePaths.has(oe))return;Z.handledSourcePaths.add(oe);const{stat:Y,symbolicLink:q}=await o.stat(oe);if(q){if(Z.options.preserveSymlinks)try{return await le(oe,ue,Z)}catch{}if(q.dangling)return}return Y.isDirectory()?V(oe,ue,Y.mode&U,Z):J(oe,ue,Y.mode&U)}async function V(oe,ue,Z,Y){await e.Promises.mkdir(ue,{recursive:!0,mode:Z});const q=await h(oe);for(const L of q)await F((0,g.$jc)(oe,L),(0,g.$jc)(ue,L),Y)}async function J(oe,ue,Z){await e.Promises.copyFile(oe,ue),await e.Promises.chmod(ue,Z)}async function le(oe,ue,Z){let Y=await e.Promises.readlink(oe);(0,D.$9f)(Y,Z.root.source,!l.$k)&&(Y=(0,g.$jc)(Z.root.target,Y.substr(Z.root.source.length+1))),await e.Promises.symlink(Y,ue)}e.Promises=new class{get access(){return(0,s.promisify)(S.access)}get stat(){return(0,s.promisify)(S.stat)}get lstat(){return(0,s.promisify)(S.lstat)}get utimes(){return(0,s.promisify)(S.utimes)}get read(){return(oe,ue,Z,Y,q)=>new Promise((L,N)=>{S.read(oe,ue,Z,Y,q,(G,B,te)=>G?N(G):L({bytesRead:B,buffer:te}))})}get readFile(){return(0,s.promisify)(S.readFile)}get write(){return(oe,ue,Z,Y,q)=>new Promise((L,N)=>{S.write(oe,ue,Z,Y,q,(G,B,te)=>G?N(G):L({bytesWritten:B,buffer:te}))})}get appendFile(){return(0,s.promisify)(S.appendFile)}get fdatasync(){return(0,s.promisify)(S.fdatasync)}get truncate(){return(0,s.promisify)(S.truncate)}get copyFile(){return(0,s.promisify)(S.copyFile)}get open(){return(0,s.promisify)(S.open)}get close(){return(0,s.promisify)(S.close)}get symlink(){return(0,s.promisify)(S.symlink)}get readlink(){return(0,s.promisify)(S.readlink)}get chmod(){return(0,s.promisify)(S.chmod)}get mkdir(){return(0,s.promisify)(S.mkdir)}get unlink(){return(0,s.promisify)(S.unlink)}get rmdir(){return(0,s.promisify)(S.rmdir)}get realpath(){return(0,s.promisify)(S.realpath)}async exists(oe){try{return await e.Promises.access(oe),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return c}get writeFile(){return i}get rm(){return u}get rename(){return E}get copy(){return j}}}),define(ae[106],ce([0,1,46,9,4,25,21]),function(X,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.$vq=void 0;function P(y){if(s.$k)return y;const u=(0,R.$mc)(y);if(y===u)return y;const $=((0,R.$nc)(y)||y).toLowerCase();try{const k=(0,D.readdirSync)(u).filter(h=>h.toLowerCase()===$);if(k.length===1){const h=P(u);if(h)return(0,R.$jc)(h,k[0])}else if(k.length>1){const h=k.indexOf($);if(h>=0){const f=P(u);if(f)return(0,R.$jc)(f,k[h])}}}catch{}return null}e.$vq=P;async function g(y){if(s.$k)return y;const u=(0,R.$mc)(y);if(y===u)return y;const $=((0,R.$nc)(y)||y).toLowerCase();try{const k=(await D.Promises.readdir(u)).filter(h=>h.toLowerCase()===$);if(k.length===1){const h=await g(u);if(h)return(0,R.$jc)(h,k[0])}else if(k.length>1){const h=k.indexOf($);if(h>=0){const f=await g(u);if(f)return(0,R.$jc)(f,k[h])}}}catch{}return null}e.$wq=g;async function l(y){try{return await D.Promises.realpath(y)}catch{const $=v(y);return await D.Promises.access($,S.constants.R_OK),$}}e.$xq=l;function b(y){try{return S.realpathSync(y)}catch{const $=v(y);return S.accessSync($,S.constants.R_OK),$}}e.$yq=b;function v(y){return(0,M.$Ve)((0,R.$hc)(y),R.sep)}}),define(ae[107],ce([0,1,26,9,21]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=void 0;const M=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var g;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(g||(g={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class v{constructor(c,t,o){this.exePath=c,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:m=!1}={}){return m?l===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:m=!1,findPreview:c=!1}={}){const t=y({useAlternateBitness:m});if(!t)return null;const o=R.$jc(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(o))return null;let r=-1,i=null;for(const p of await s.Promises.readdir(o)){let A=-1;if(c){const E=p.indexOf("-");if(E<0)continue;const C=p.substring(0,E);if(!M.test(C)||p.substring(E+1)!=="preview")continue;A=parseInt(C,10)}else{if(!M.test(p))continue;A=parseInt(p,10)}if(A<=r)continue;const I=R.$jc(o,p,"pwsh.exe");await s.SymlinkSupport.existsFile(I)&&(i=I,r=A)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",a=c?" Preview":"";return new v(i,`PowerShell${a}${n}`,!0)}async function $({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const c=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=m?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(c))if(t.test(r)){const i=R.$jc(c,r,"pwsh.exe");return new v(i,o)}return null}function w(){const m=R.$jc(S.homedir(),".dotnet","tools","pwsh.exe");return new v(m,".NET Core PowerShell Global Tool")}function k(){const m=R.$jc(process.env.windir,l===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(m,"Windows PowerShell",!0)}async function*h(){let m=await u();m&&(yield m),m=await u({useAlternateBitness:!0}),m&&(yield m),m=await $(),m&&(yield m),m=w(),m&&(yield m),m=await u({findPreview:!0}),m&&(yield m),m=await $({findPreview:!0}),m&&(yield m),m=await u({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=k(),m&&(yield m)}async function*f(){for await(const m of h())await m.exists()&&(yield m)}e.$Rl=f;async function d(){for await(const m of f())return m;return null}e.$Sl=d}),define(ae[89],ce([0,1,9,4,36,75,12,21]),function(X,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Wl=e.$Vl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function g(v=s.env){return v.comspec||"cmd.exe"}e.$Vl=g;function l(v){let y=[],u=!1;const $=function(w){if(u){y.push(w);return}(!v.send(w,h=>{if(h&&console.error(h),u=!1,y.length>0){const f=y.slice(0);y=[],f.forEach(d=>$(d))}})||R.$i)&&(u=!0)};return{send:$}}e.$Wl=l;var b;(function(v){async function y(u,$,w){if(S.$ic(u))return u;if($===void 0&&($=s.cwd()),S.$mc(u)!=="."||(w===void 0&&D.$Jf(s.env.PATH)&&(w=s.env.PATH.split(S.$tc)),w===void 0||w.length===0))return S.$jc($,u);async function h(f){if(await P.Promises.exists(f)){let d;try{d=await P.Promises.stat(f)}catch(m){m.message.startsWith("EACCES")&&(d=await P.Promises.lstat(f))}return d?!d.isDirectory():!1}return!1}for(const f of w){let d;if(S.$ic(f)?d=S.$jc(f,u):d=S.$jc($,f,u),await h(d))return d;let m=d+".com";if(await h(m)||(m=d+".exe",await h(m)))return m}return S.$jc($,u)}v.findExecutable=y})(b||(e.win32=b={}))}),define(ae[108],ce([0,1,48,13]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=void 0;function s(D){return new Promise((P,g)=>{let l;const b=new Map;function v(u,$,w,k,h){const f=b.get($);if(u===D||f){const d={name:y(w),cmd:w,pid:u,ppid:$,load:k,mem:h};b.set(u,d),u===D&&(l=d),f&&(f.children||(f.children=[]),f.children.push(d),f.children.length>1&&(f.children=f.children.sort((m,c)=>m.pid-c.pid)))}}function y(u){const $=/--utility-sub-type=network/i,w=/--crashes-directory/i,k=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(w.exec(u))return"electron-crash-reporter";if(k.exec(u))return"winpty-agent";if(h.exec(u))return"conpty-agent";let d=f.exec(u);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?$.exec(u)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const m=/[a-zA-Z-]+\.js/g;let c="";do d=m.exec(u),d&&(c+=d+" ");while(d);return c&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${c})`:u}if(process.platform==="win32"){const u=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,w)=>{X(["@vscode/windows-process-tree"],$,w)}).then($=>{$.getProcessList(D,w=>{if(!w){g(new Error(`Root process ${D} not found`));return}$.getProcessCpuUsage(w,k=>{const h=new Map;k.forEach(f=>{const d=u(f.commandLine||"");h.set(f.pid,{name:y(d),cmd:d,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),l=h.get(D),l?(h.forEach(f=>{const d=h.get(f.ppid);d&&(d.children||(d.children=[]),d.children.push(f))}),h.forEach(f=>{f.children&&(f.children=f.children.sort((d,m)=>d.pid-m.pid))}),P(l)):g(new Error(`Root process ${D} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let u=function(){let $=[l];const w=[];for(;$.length;){const h=$.shift();h&&(w.push(h.pid),h.children&&($=$.concat(h.children)))}let k=JSON.stringify(R.$pg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);k+=" "+w.join(" "),(0,S.exec)(k,{},(h,f,d)=>{if(h||d)g(h||new Error(d.toString()));else{const m=f.toString().split(`
`);for(let c=0;c<w.length;c++){const t=b.get(w[c]);t.load=parseFloat(m[c])}if(!l){g(new Error(`Root process ${D} not found`));return}P(l)}})};(0,S.exec)("which ps",{},($,w,k)=>{if($||k)if(process.platform!=="linux")g($||new Error(k.toString()));else{const h=JSON.stringify(R.$pg.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)(h,{},(f,d,m)=>{f||m?g(f||new Error(m.toString())):(M(d,v),u())})}else{const h=w.toString().trim();(0,S.exec)(`${h} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,m,c)=>{d||c&&!c.includes("screen size is bogus")?g(d||new Error(c.toString())):(M(m,v),process.platform==="linux"?u():l?P(l):g(new Error(`Root process ${D} not found`)))})}})}})}e.$7r=s;function M(D,P){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=D.toString().split(`
`);for(const b of l){const v=g.exec(b.trim());v&&v.length===6&&P(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(ae[109],ce([0,1,26,4,107,89]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=void 0;async function D(v,y){return v===1?R.$i?b():M.$Vl(y):g(v,y)}e.$Xl=D;let P=null;function g(v,y){if(R.$k&&v===2||R.$j&&v===3)return"/bin/bash";if(!P){let u;if(R.$i)u="/bin/bash";else{if(u=y.SHELL,!u)try{u=(0,S.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}P=u}return P}let l=null;async function b(){return l||(l=(await(0,s.$Sl)()).exePath),l}});var ve=this&&this.__decorate||function(X,e,S,R){var s=arguments.length,M=s<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,S):R,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(X,e,S,R);else for(var P=X.length-1;P>=0;P--)(D=X[P])&&(M=(s<3?D(M):s>3?D(e,S,M):D(e,S))||M);return s>3&&M&&Object.defineProperty(e,S,M),M};define(ae[43],ce([0,1,22,8,17,23,50,14,3,2,76,25,12]),function(X,e,S,R,s,M,D,P,g,l,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.ProxyChannel=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.RequestInitiator=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;var u;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(u||(u={}));function $(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(w||(w={}));function k(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(h||(h={}));function f(q){let L=0;for(let N=0;;N+=7){const G=q.read(1);if(L|=(G.buffer[0]&127)<<N,!(G.buffer[0]&128))return L}}const d=r(0);function m(q,L){if(L===0){q.write(d);return}let N=0;for(let B=L;B!==0;B=B>>>7)N++;const G=s.$ke.alloc(N);for(let B=0;L!==0;B++)G.buffer[B]=L&127,L=L>>>7,L>0&&(G.buffer[B]|=128);q.write(G)}class c{constructor(L){this.b=L,this.a=0}read(L){const N=this.b.slice(this.a,this.a+L);return this.a+=N.byteLength,N}}e.$Fh=c;class t{constructor(){this.a=[]}get buffer(){return s.$ke.concat(this.a)}write(L){this.a.push(L)}}e.$Gh=t;var o;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(o||(o={}));function r(q){const L=s.$ke.alloc(1);return L.writeUInt8(q,0),L}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},n=typeof Buffer<"u";function a(q,L){if(typeof L>"u")q.write(i.Undefined);else if(typeof L=="string"){const N=s.$ke.fromString(L);q.write(i.String),m(q,N.byteLength),q.write(N)}else if(n&&Buffer.isBuffer(L)){const N=s.$ke.wrap(L);q.write(i.Buffer),m(q,N.byteLength),q.write(N)}else if(L instanceof s.$ke)q.write(i.VSBuffer),m(q,L.byteLength),q.write(L);else if(Array.isArray(L)){q.write(i.Array),m(q,L.length);for(const N of L)a(q,N)}else if(typeof L=="number"&&(L|0)===L)q.write(i.Uint),m(q,L);else{const N=s.$ke.fromString(JSON.stringify(L));q.write(i.Object),m(q,N.byteLength),q.write(N)}}e.$Hh=a;function p(q){switch(q.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return q.read(f(q)).toString();case o.Buffer:return q.read(f(q)).buffer;case o.VSBuffer:return q.read(f(q));case o.Array:{const N=f(q),G=[];for(let B=0;B<N;B++)G.push(p(q));return G}case o.Object:return JSON.parse(q.read(f(q)).toString());case o.Int:return f(q)}}e.$Ih=p;class A{constructor(L,N,G=null,B=1e3){this.h=L,this.j=N,this.k=G,this.l=B,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(L,N){this.b.set(L,N),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const N=this.o([L.type]);this.k?.logOutgoing(N,0,1,k(L.type));return}case 201:case 202:case 204:case 203:{const N=this.o([L.type,L.id],L.data);this.k?.logOutgoing(N,L.id,1,k(L.type),L.data);return}}}o(L,N=void 0){const G=new t;return a(G,L),a(G,N),this.p(G.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const N=new c(L),G=p(N),B=p(N),te=G[0];switch(te){case 100:return this.k?.logIncoming(L.byteLength,G[1],1,`${$(te)}: ${G[2]}.${G[3]}`,B),this.s({type:te,id:G[1],channelName:G[2],name:G[3],arg:B});case 102:return this.k?.logIncoming(L.byteLength,G[1],1,`${$(te)}: ${G[2]}.${G[3]}`,B),this.t({type:te,id:G[1],channelName:G[2],name:G[3],arg:B});case 101:return this.k?.logIncoming(L.byteLength,G[1],1,`${$(te)}`),this.u({type:te,id:G[1]});case 103:return this.k?.logIncoming(L.byteLength,G[1],1,`${$(te)}`),this.u({type:te,id:G[1]})}}s(L){const N=this.b.get(L.channelName);if(!N){this.v(L);return}const G=new M.$7d;let B;try{B=N.call(this.j,L.name,L.arg,G.token)}catch(K){B=Promise.reject(K)}const te=L.id;B.then(K=>{this.m({id:te,data:K,type:201})},K=>{K instanceof Error?this.m({id:te,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:te,data:K,type:203})}).finally(()=>{he.dispose(),this.d.delete(L.id)});const he=(0,l.$Rc)(()=>G.cancel());this.d.set(L.id,he)}t(L){const N=this.b.get(L.channelName);if(!N){this.v(L);return}const G=L.id,te=N.listen(this.j,L.name,L.arg)(he=>this.m({id:G,data:he,type:204}));this.d.set(L.id,te)}u(L){const N=this.d.get(L.id);N&&(N.dispose(),this.d.delete(L.id))}v(L){let N=this.g.get(L.channelName);N||(N=[],this.g.set(L.channelName,N));const G=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);N.push({request:L,timeoutTimer:G})}w(L){const N=this.g.get(L);if(N){for(const G of N)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Oc)(this.d.values()),this.d.clear()}}e.$Jh=A;var I;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class E{constructor(L,N=null){this.l=L,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.$Wd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=N}getChannel(L){const N=this;return{call(G,B,te){return N.a?Promise.reject(new P.$5):N.m(L,G,B,te)},listen(G,B){return N.a?g.Event.None:N.o(L,G,B)}}}m(L,N,G,B=M.CancellationToken.None){const te=this.g++,K={id:te,type:100,channelName:L,name:N,arg:G};if(B.isCancellationRequested)return Promise.reject(new P.$5);let O;return new Promise((x,T)=>{if(B.isCancellationRequested)return T(new P.$5);const Q=()=>{const ee=se=>{switch(se.type){case 201:this.f.delete(te),x(se.data);break;case 202:{this.f.delete(te);const de=new Error(se.data.message);de.stack=Array.isArray(se.data.stack)?se.data.stack.join(`
`):se.data.stack,de.name=se.data.name,T(de);break}case 203:this.f.delete(te),T(se.data);break}};this.f.set(te,ee),this.p(K)};let H=null;this.b===h.Idle?Q():(H=(0,R.$Ug)(ee=>this.u()),H.then(()=>{H=null,Q()}));const _=()=>{H?(H.cancel(),H=null):this.p({id:te,type:101}),T(new P.$5)},z=B.onCancellationRequested(_);O=(0,l.$Qc)((0,l.$Rc)(_),z),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(L,N,G){const B=this.g++,he={id:B,type:102,channelName:L,name:N,arg:G};let K=null;const O=new g.$Wd({onWillAddFirstListener:()=>{K=(0,R.$Ug)(x=>this.u()),K.then(()=>{K=null,this.d.add(O),this.p(he)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(O),this.p({id:B,type:103}))}}),W=x=>O.fire(x.data);return this.f.set(B,W),O.event}p(L){switch(L.type){case 100:case 102:{const N=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(N,L.id,0,`${$(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const N=this.q([L.type,L.id]);this.j?.logOutgoing(N,L.id,0,$(L.type));return}}}q(L,N=void 0){const G=new t;return a(G,L),a(G,N),this.r(G.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const N=new c(L),G=p(N),B=p(N),te=G[0];switch(te){case 200:return this.j?.logIncoming(L.byteLength,0,0,k(te)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,G[1],0,k(te),B),this.t({type:G[0],id:G[1],data:B})}}t(L){if(L.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Oc)(this.d.values()),this.d.clear()}}e.$Kh=E,ve([D.$zh],E.prototype,"onDidInitializePromise",null);class C{get connections(){const L=[];return this.f.forEach(N=>L.push(N)),L}constructor(L){this.a=new Map,this.f=new Set,this.g=new g.$Wd,this.onDidAddConnection=this.g.event,this.h=new g.$Wd,this.onDidRemoveConnection=this.h.event,this.j=new l.$Sc,this.j.add(L(({protocol:N,onDidClientDisconnect:G})=>{const B=g.Event.once(N.onMessage);this.j.add(B(te=>{const he=new c(te),K=p(he),O=new A(N,K),W=new E(N);this.a.forEach((T,Q)=>O.registerChannel(Q,T));const x={channelServer:O,channelClient:W,ctx:K};this.f.add(x),this.g.fire(x),this.j.add(G(()=>{O.dispose(),W.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(L,N){const G=this;return{call(B,te,he){let K;if((0,y.$Xf)(N)){const W=(0,S.$4b)(G.connections.filter(N));K=W?Promise.resolve(W):g.Event.toPromise(g.Event.filter(G.onDidAddConnection,N))}else K=N.routeCall(G,B,te);const O=K.then(W=>W.channelClient.getChannel(L));return U(O).call(B,te,he)},listen(B,te){if((0,y.$Xf)(N))return G.k(L,N,B,te);const he=N.routeEvent(G,B,te).then(K=>K.channelClient.getChannel(L));return U(he).listen(B,te)}}}k(L,N,G,B){const te=this;let he;const K=new g.$Wd({onWillAddFirstListener:()=>{he=new l.$Sc;const O=new g.$3d,W=new Map,x=Q=>{const _=Q.channelClient.getChannel(L).listen(G,B),z=O.add(_);W.set(Q,z)},T=Q=>{const H=W.get(Q);H&&(H.dispose(),W.delete(Q))};te.connections.filter(N).forEach(x),g.Event.filter(te.onDidAddConnection,N)(x,void 0,he),te.onDidRemoveConnection(T,void 0,he),O.event(K.fire,K,he),he.add(O)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return K.event}registerChannel(L,N){this.a.set(L,N);for(const G of this.f)G.channelServer.registerChannel(L,N)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Lh=C;class j{constructor(L,N,G=null){const B=new t;a(B,N),L.send(B.buffer),this.a=new E(L,G),this.d=new A(L,N,G)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,N){this.d.registerChannel(L,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Mh=j;function U(q){return{call(L,N,G){return q.then(B=>B.call(L,N,G))},listen(L,N){const G=new g.$6d;return q.then(B=>G.input=B.listen(L,N)),G.event}}}e.$Nh=U;function F(q){let L=!1;return{call(N,G,B){return L?q.call(N,G,B):(0,R.$9g)(0).then(()=>L=!0).then(()=>q.call(N,G,B))},listen(N,G){if(L)return q.listen(N,G);const B=new g.$6d;return(0,R.$9g)(0).then(()=>L=!0).then(()=>B.input=q.listen(N,G)),B.event}}}e.$Oh=F;class V{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const N of L.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await g.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$Ph=V;var J;(function(q){function L(te,he,K){const O=te,W=K&&K.disableMarshalling,x=new Map;for(const T in O)G(T)&&x.set(T,g.Event.buffer(O[T],!0,void 0,he));return new class{listen(T,Q,H){const _=x.get(Q);if(_)return _;if(B(Q)){const z=O[Q];if(typeof z=="function")return z.call(O,H)}throw new P.$bb(`Event not found: ${Q}`)}call(T,Q,H){const _=O[Q];if(typeof _=="function"){if(!W&&Array.isArray(H))for(let ee=0;ee<H.length;ee++)H[ee]=(0,b.$Eh)(H[ee]);let z=_.apply(O,H);return z instanceof Promise||(z=Promise.resolve(z)),z}throw new P.$bb(`Method not found: ${Q}`)}}}q.fromService=L;function N(te,he){const K=he&&he.disableMarshalling;return new Proxy({},{get(O,W){if(typeof W=="string")return he?.properties?.has(W)?he.properties.get(W):B(W)?function(x){return te.listen(W,x)}:G(W)?te.listen(W):async function(...x){let T;he&&!(0,y.$Sf)(he.context)?T=[he.context,...x]:T=x;const Q=await te.call(W,T);return K?Q:(0,b.$Eh)(Q)};throw new P.$bb(`Property not found: ${String(W)}`)}})}q.toService=N;function G(te){return te[0]==="o"&&te[1]==="n"&&v.$_e(te.charCodeAt(2))}function B(te){return/^onDynamic/.test(te)&&v.$_e(te.charCodeAt(9))}})(J||(e.ProxyChannel=J={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function oe(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const L=q.toString();if(L!=="[object Object]")return L}return q}function ue(q){return Array.isArray(q)?q.map(oe):oe(q)}function Z(q,L,N,G,B,te,he){he=ue(he);const K=le[B],O=K[G%K.length];let W=[`%c[${q}]%c[${String(L).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(te)?(W=W.concat(he),W.push(")")):W.push(he),console.log.apply(console,W)}class Y{constructor(L,N){this.d=L,this.f=N,this.a=0,this.b=0}logOutgoing(L,N,G,B,te){this.b+=L,Z(this.d,this.b,L,N,G,B,te)}logIncoming(L,N,G,B,te){this.a+=L,Z(this.f,this.a,L,N,G,B,te)}}e.$Qh=Y}),define(ae[157],ce([0,1,17,3,43]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NU=e.$MU=void 0;class M{constructor(g){this.a=g,this.onMessage=R.Event.fromDOMEventEmitter(this.a,"message",l=>l.data?S.$ke.wrap(l.data):S.$ke.alloc(0)),g.start()}send(g){this.a.postMessage(g.buffer)}disconnect(){this.a.close()}}e.$MU=M;class D extends s.$Mh{constructor(g,l){const b=new M(g);super(b,l),this.b=b}dispose(){this.b.disconnect(),super.dispose()}}e.$NU=D}),define(ae[110],ce([0,1,17,3,2,43]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.ProtocolConstants=e.$Rh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let a=0;function p(I,E){if(!n.has(I)){const C=String(++a);n.set(I,C)}return n.get(I)}function A(I,E,C,j){if(!i.enableDiagnostics)return;const U=p(I,E);if(j instanceof S.$ke||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const F=S.$ke.alloc(j.byteLength);F.set(j),i.records.push({timestamp:Date.now(),id:U,label:E,type:C,buff:F})}else i.records.push({timestamp:Date.now(),id:U,label:E,type:C,data:j})}i.traceSocketEvent=A})(P||(e.SocketDiagnostics=P={}));var g;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(g||(e.SocketCloseEventType=g={}));let l=null;function b(){return l||(l=S.$ke.alloc(0)),l}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,a){if(n===0)return b();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const E=this.a[0];return a&&(this.a.shift(),this.b-=n),E}if(this.a[0].byteLength>n){const E=this.a[0].slice(0,n);return a&&(this.a[0]=this.a[0].slice(n),this.b-=n),E}const p=S.$ke.alloc(n);let A=0,I=0;for(;n>0;){const E=this.a[I];if(E.byteLength>n){const C=E.slice(0,n);p.set(C,A),A+=n,a&&(this.a[I]=E.slice(n),this.b-=n),n-=n}else p.set(E,A),A+=E.byteLength,a?(this.a.shift(),this.b-=E.byteLength):I++,n-=E.byteLength}return p}}e.$Rh=v;var y;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(y||(y={}));function u(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var $;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})($||(e.ProtocolConstants=$={}));class w{constructor(n,a,p,A){this.type=n,this.id=a,this.ack=p,this.data=A,this.writtenTime=0}get size(){return this.data.byteLength}}class k extends s.$Tc{constructor(n){super(),this.f=this.B(new R.$Wd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new v,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:u(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const p=this.g.messageType,A=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new w(p,A,I,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=S.$ke.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:u(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(a,n.data)}g(n,a){const p=this.f===0;return this.d.push(n,a),this.f+=n.byteLength+a.byteLength,p}h(){const n=S.$ke.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,a){this.g(n,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class f extends s.$Tc{constructor(n){super(),this.f=new R.$Wd,this.onMessage=this.f.event,this.g=new R.$Wd,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new h(this.a)),this.c=this.B(new k(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new w(1,0,0,n))}}e.$Sh=f;class d extends M.$Mh{static fromSocket(n,a){return new d(new f(n),a)}get onDidDispose(){return this.b.onDidDispose}constructor(n,a,p=null){super(n,a,p),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Th=d;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$Wd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Uh=m;class c{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,a=this.a;for(;a;)a=a.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let a=0,p=this.a;for(;p;)n[a++]=p.data,p=p.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const a=new c(n);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const n=Date.now();for(let a=0;a<o.a;a++)this.c[a]=n-1e3*a;setInterval(()=>{for(let a=o.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),a=(1+o.a)*1e3;let p=0;for(let A=0;A<o.a;A++)n-this.c[A]<=a&&p++;return 1-p/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??o.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Sc,this.o=n.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new k(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new w(5,0,0,b());this.p.write(n),this.p.flush()}sendPause(){const n=new w(7,0,0,b());this.p.write(n)}sendResume(){const n=new w(8,0,0,b());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,a){this.a=!0,this.r.dispose(),this.r=new s.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new k(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new w(3,0,this.h,b());this.p.write(n);const a=this.b.toArray();for(let p=0,A=a.length;p<A;p++)this.p.write(a[p]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const a=this.b.peek();if(a&&a.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new w(6,0,0,b())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let p=0,A=a.length;p<A;p++)this.p.write(a[p]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const a=++this.c;this.h=this.g;const p=new w(1,a,this.h,n);this.b.push(p),this.a||(this.p.write(p),this.B())}sendControl(n){const a=new w(2,0,0,n);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),a=Date.now()-n.writtenTime,p=Date.now()-this.q.lastReadTime,A=Date.now()-this.n;if(a>=2e4&&p>=2e4&&A>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:p});return}const I=Math.max(2e4-a,2e4-p,2e4-A,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new w(3,0,this.h,b());this.p.write(n)}D(){this.h=this.g;const n=new w(9,0,this.h,b());this.p.write(n)}}e.$Vh=r}),define(ae[37],ce([0,1,15,14,13]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JU=void 0;class M{constructor(){this.a=new WeakMap}on(P,g){const l=(b,...v)=>{this.b(P,b)&&g(b,...v)};return this.a.set(g,l),S.ipcMain.on(P,l),this}once(P,g){return S.ipcMain.once(P,(l,...b)=>{this.b(P,l)&&g(l,...b)}),this}handle(P,g){return S.ipcMain.handle(P,(l,...b)=>this.b(P,l)?g(l,...b):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return S.ipcMain.removeHandler(P),this}removeListener(P,g){const l=this.a.get(g);return l&&(S.ipcMain.removeListener(P,l),this.a.delete(g)),this}b(P,g){if(!P||!P.startsWith("vscode:"))return(0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const l=g.senderFrame,b=l.url;if(!b||b==="about:blank")return!0;let v="unknown";try{v=new URL(b).host}catch{return(0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${b}'.`),!1}return v!==s.$og?((0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${v}'.`),!1):l.parent!==null?((0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${v}' is not a main frame.`),!1):!0}}e.$JU=new M}),define(ae[158],ce([0,1,15,37,146]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KU=void 0;function M(){R.$JU.on(s.$HU,(P,g,l,b,v)=>{const y=D(P,b,l);y.popup({x:v?v.x:void 0,y:v?v.y:void 0,positioningItem:v?v.positioningItem:void 0,callback:()=>{y&&P.sender.send(s.$IU,g)}})})}e.$KU=M;function D(P,g,l){const b=new S.Menu;return l.forEach(v=>{let y;v.type==="separator"?y=new S.MenuItem({type:v.type}):Array.isArray(v.submenu)?y=new S.MenuItem({submenu:D(P,g,v.submenu),label:v.label}):y=new S.MenuItem({label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:v.enabled,visible:v.visible,click:(u,$,w)=>P.sender.send(g,v.id,w)}),b.append(y)}),b}}),define(ae[159],ce([0,1,37,17,3,2,43,147]),function(X,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QU=void 0;function g(b,v){const y=s.Event.fromNodeEventEmitter(S.$JU,v,($,w)=>({event:$,message:w})),u=s.Event.filter(y,({event:$})=>$.sender.id===b);return s.Event.map(u,({message:$})=>$&&R.$ke.wrap($))}class l extends D.$Lh{static{this.b=new Map}static d(){const v=s.Event.fromNodeEventEmitter(S.$JU,"vscode:hello",({sender:y})=>y);return s.Event.map(v,y=>{const u=y.id;l.b.get(u)?.dispose();const w=new s.$Wd;l.b.set(u,(0,M.$Rc)(()=>w.fire()));const k=g(u,"vscode:message"),h=s.Event.any(s.Event.signal(g(u,"vscode:disconnect")),w.event);return{protocol:new P.$PU(y,k),onDidClientDisconnect:h}})}constructor(){super(l.d())}}e.$QU=l}),define(ae[111],ce([0,1,37,3,32,157]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SU=e.$RU=void 0;class D extends M.$NU{constructor(l,b){super({addEventListener:(v,y)=>l.addListener(v,y),removeEventListener:(v,y)=>l.removeListener(v,y),postMessage:v=>l.postMessage(v),start:()=>l.start(),close:()=>l.close()},b)}}e.$RU=D;async function P(g){if(g.isDestroyed()||g.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,s.$rg)();g.webContents.send("vscode:createMessageChannel",l);const b=R.Event.fromNodeEventEmitter(S.$JU,"vscode:createMessageChannelResult",(y,u)=>({nonce:u,port:y.ports[0]})),{port:v}=await R.Event.toPromise(R.Event.once(R.Event.filter(b,y=>y.nonce===l)));return v}e.$SU=P}),define(ae[160],ce([0,1,48,8,17,23,154,14,3,2,35,89,75,43]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=void 0;class $ extends u.$Jh{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",f=>s.$ke.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$sq=$;class w{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new g.$Wd,this.onDidProcessExit=this.h.event;const d=f&&f.timeout?f.timeout:6e4;this.b=new R.$5g(d),this.d=null,this.f=null}getChannel(h){const f=this;return{call(d,m,c){return f.k(h,d,m,c)},listen(d,m){return f.l(h,d,m)}}}k(h,f,d,m=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const c=this.n(h),t=(0,R.$Ug)(i=>c.call(f,d,i)),o=m.onCancellationRequested(()=>t.cancel()),r=(0,l.$Rc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,f,d){if(!this.b)return g.Event.None;this.b.cancel();let m;const c=new g.$Wd({onWillAddFirstListener:()=>{m=this.n(h).listen(f,d)(c.fire,c),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,b.$yn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,y.$Ul)(f.env),this.d=(0,S.fork)(this.i,h,f);const d=new g.$Wd;g.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$oq)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}d.fire(s.$ke.wrap(Buffer.from(n,"base64")))});const c=this.j.useQueue?(0,v.$Wl)(this.d):this.d,t=n=>this.d&&this.d.connected&&c.send(n.buffer.toString("base64")),o=d.event,r={send:t,onMessage:o};this.f=new u.$Kh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,a)=>{process.removeListener("exit",i),this.c.forEach(p=>(0,l.$Oc)(p)),this.c.clear(),n!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:a})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$tq=w}),define(ae[112],ce([0,1,8,3,2,76,12]),function(X,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.StorageState=e.$rp=e.StorageHint=void 0;var P;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function g(y){const u=y;return u?.changed instanceof Map||u?.deleted instanceof Set}e.$rp=g;var l;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(l||(e.StorageState=l={}));class b extends s.$Tc{static{this.a=100}constructor(u,$=Object.create(null)){super(),this.r=u,this.s=$,this.b=this.B(new R.$Zd),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new S.$6g(b.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(u=>this.u(u)))}u(u){this.b.pause();try{u.changed?.forEach(($,w)=>this.w(w,$)),u.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(u,$){if(this.c===l.Closed)return;let w=!1;(0,D.$Sf)($)?w=this.f.delete(u):this.f.get(u)!==$&&(this.f.set(u,$),w=!0),w&&this.b.fire({key:u,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(u,$){const w=this.f.get(u);return(0,D.$Sf)(w)?$:w}getBoolean(u,$){const w=this.get(u);return(0,D.$Sf)(w)?$:w==="true"}getNumber(u,$){const w=this.get(u);return(0,D.$Sf)(w)?$:parseInt(w,10)}getObject(u,$){const w=this.get(u);return(0,D.$Sf)(w)?$:(0,M.$Dh)(w)}async set(u,$,w=!1){if(this.c===l.Closed)return;if((0,D.$Sf)($))return this.delete(u,w);const k=(0,D.$Lf)($)||Array.isArray($)?(0,M.$Ch)($):String($);if(this.f.get(u)!==k)return this.f.set(u,k),this.j.set(u,k),this.h.delete(u),this.b.fire({key:u,external:w}),this.D()}async delete(u,$=!1){if(!(this.c===l.Closed||!this.f.delete(u)))return this.h.has(u)||this.h.add(u),this.j.delete(u),this.b.fire({key:u,external:$}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const u={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(u).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(u){if(this.z)return this.D(u)}async D(u){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),u)}async whenFlushed(){if(this.z)return new Promise(u=>this.n.push(u))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$sp=b;class v{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(u){u.insert?.forEach(($,w)=>this.a.set(w,$)),u.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$tp=v}),define(ae[161],ce([0,1,8,3,31,9,21]),function(X,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cV=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return R.Event.None}static{this.a=2e3}static{this.b=256}constructor(b,v=Object.create(null)){this.g=b,this.h=v,this.c=(0,M.$nc)(this.g),this.d=new g(this.h.logging),this.f=this.n(this.g)}async getItems(){const b=await this.f,v=new Map;return(await this.s(b,"SELECT * FROM ItemTable")).forEach(u=>v.set(u.key,u.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${v.size} rows`),v}async updateItems(b){const v=await this.f;return this.j(v,b)}j(b,v){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${v.insert?(0,s.$yc)(v.insert):"0"}), delete(${v.delete?(0,s.$zc)(v.delete):"0"})`),this.t(b,()=>{const y=v.insert,u=v.delete;if(y&&y.size>0){const $=[];$.push([]);let w=0;y.forEach((k,h)=>{let f=$[w];f.length>P.b&&(w++,f=[],$.push(f)),f.push(h,k)}),$.forEach(k=>{this.u(b,`INSERT INTO ItemTable VALUES ${new Array(k.length/2).fill("(?,?)").join(",")}`,h=>h.run(k),()=>{const h=[];let f=0;return y.forEach((d,m)=>{h.push(m),f+=d.length}),`Keys: ${h.join(", ")} Length: ${f}`})})}if(u&&u.size){const $=[];$.push([]);let w=0;u.forEach(k=>{let h=$[w];h.length>P.b&&(w++,h=[],$.push(h)),h.push(k)}),$.forEach(k=>{this.u(b,`DELETE FROM ItemTable WHERE key IN (${new Array(k.length).fill("?").join(",")})`,h=>h.run(k),()=>{const h=[];return u.forEach(f=>{h.push(f)}),`Keys: ${h.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const b=await this.f;return this.q(b,"VACUUM")}async close(b){this.d.trace(`[storage ${this.c}] close()`);const v=await this.f;return this.k(v,b)}k(b,v){return new Promise((y,u)=>{b.db.close($=>($&&this.o(b,`[storage ${this.c}] close(): ${$}`),this.g===P.IN_MEMORY_PATH?y():!b.isErroneous&&!b.isInMemory?this.l().then(y,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),y())):typeof v=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const k=()=>this.k(w,void 0);return this.j(w,{insert:v()}).then(()=>k(),h=>(k(),Promise.reject(h)))})).then(y,u):u($||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const b=this.m(this.g);return D.Promises.copy(this.g,b,{preserveSymlinks:!1})}m(b){return`${b}.backup`}async checkIntegrity(b){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${b})`);const v=await this.f,y=await this.r(v,b?"PRAGMA integrity_check":"PRAGMA quick_check"),u=b?y.integrity_check:y.quick_check;return v.isErroneous?`${u} (last error: ${v.lastError})`:v.isInMemory?`${u} (in-memory!)`:u}async n(b,v=!0){this.d.trace(`[storage ${this.c}] open(${b}, retryOnBusy: ${v})`);try{return await this.p(b)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&v)return await(0,S.$9g)(P.a),this.n(b,!1);try{await D.Promises.unlink(b);try{await D.Promises.rename(this.m(b),b,!1)}catch{}return await this.p(b)}catch(u){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${u}`),this.p(P.IN_MEMORY_PATH)}}}o(b,v){b.isErroneous=!0,b.lastError=v,this.d.error(v)}p(b){return new Promise((v,y)=>{new Promise((u,$)=>{X(["@vscode/sqlite3"],u,$)}).then(u=>{const $={db:new(this.d.isTracing?u.verbose().Database:u.Database)(b,w=>w?$.db&&w.code!=="SQLITE_CANTOPEN"?$.db.close(()=>y(w)):y(w):this.q($,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v($),k=>$.db.close(()=>y(k)))),isInMemory:b===P.IN_MEMORY_PATH};$.db.on("error",w=>this.o($,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&$.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},y)})}q(b,v){return new Promise((y,u)=>{b.db.exec(v,$=>$?(this.o(b,`[storage ${this.c}] exec(): ${$}`),u($)):y())})}r(b,v){return new Promise((y,u)=>{b.db.get(v,($,w)=>$?(this.o(b,`[storage ${this.c}] get(): ${$}`),u($)):y(w))})}s(b,v){return new Promise((y,u)=>{b.db.all(v,($,w)=>$?(this.o(b,`[storage ${this.c}] all(): ${$}`),u($)):y(w))})}t(b,v){return new Promise((y,u)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),v(),b.db.run("END TRANSACTION",$=>$?(this.o(b,`[storage ${this.c}] transaction(): ${$}`),u($)):y())})})}u(b,v,y,u){const $=b.db.prepare(v),w=k=>{this.o(b,`[storage ${this.c}] prepare(): ${k} (${v}). Details: ${u()}`)};$.on("error",w),y($),$.finalize(k=>{k&&w(k),$.removeListener("error",w)})}}e.$cV=P;class g{static{this.a="VSCODE_TRACE_STORAGE"}constructor(b){b&&typeof b.logTrace=="function"&&process.env[g.a]&&(this.b=b.logTrace),b&&typeof b.logError=="function"&&(this.c=b.logError)}get isTracing(){return!!this.b}trace(b){this.b?.(b)}error(b){this.c?.(b)}}}),define(ae[162],ce([11,10]),function(X,e){return X.create("vs/code/electron-main/app",e)}),define(ae[163],ce([11,10]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[164],ce([11,10]),function(X,e){return X.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[165],ce([11,10]),function(X,e){return X.create("vs/platform/contextkey/common/scanner",e)}),define(ae[166],ce([11,10]),function(X,e){return X.create("vs/platform/dialogs/common/dialogs",e)}),define(ae[167],ce([11,10]),function(X,e){return X.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ae[168],ce([11,10]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(ae[169],ce([11,10]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(ae[170],ce([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[171],ce([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[172],ce([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[173],ce([11,10]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[174],ce([11,10]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ae[175],ce([11,10]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(ae[176],ce([11,10]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ae[177],ce([11,10]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(ae[178],ce([11,10]),function(X,e){return X.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ae[179],ce([11,10]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[180],ce([11,10]),function(X,e){return X.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ae[181],ce([11,10]),function(X,e){return X.create("vs/platform/menubar/electron-main/menubar",e)}),define(ae[182],ce([11,10]),function(X,e){return X.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ae[183],ce([11,10]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(ae[184],ce([11,10]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(ae[185],ce([11,10]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[186],ce([11,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ae[187],ce([11,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ae[188],ce([11,10]),function(X,e){return X.create("vs/platform/update/common/update.config.contribution",e)}),define(ae[189],ce([11,10]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[190],ce([11,10]),function(X,e){return X.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ae[191],ce([11,10]),function(X,e){return X.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ae[192],ce([11,10]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(ae[193],ce([11,10]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ae[194],ce([11,10]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ae[195],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcb=e.$Pcb=void 0;function S(s){return s&&s.hasOwnProperty("folderUri")}e.$Pcb=S;function R(s){return s&&s.hasOwnProperty("workspace")}e.$Qcb=R}),define(ae[196],ce([0,1,7]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z9b=e.$Y9b=e.$X9b=void 0;function R(D){return typeof D?.backupFolder=="string"}e.$X9b=R;function s(D){let P=[];try{Array.isArray(D.workspaces)&&(P=D.workspaces.map(g=>({workspace:{id:g.id,configPath:S.URI.parse(g.configURIPath)},remoteAuthority:g.remoteAuthority})))}catch{}return P}e.$Y9b=s;function M(D){let P=[];try{Array.isArray(D.folders)&&(P=D.folders.map(g=>({folderUri:S.URI.parse(g.folderUri),remoteAuthority:g.remoteAuthority})))}catch{}return P}e.$Z9b=M}),define(ae[197],ce([0,1,14,165]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.TokenType=void 0;var s;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...l){switch(l.length){case 1:return(0,R.localize)(0,null,l[0]);case 2:return(0,R.localize)(1,null,l[0],l[1]);case 3:return(0,R.localize)(2,null,l[0],l[1],l[2]);default:return}}const D=(0,R.localize)(3,null),P=(0,R.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return b.isTripleEq?"===":"==";case 4:return b.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const v=this.d,y=this.c.substring(this.d,this.e),u={type:19,offset:this.d,lexeme:y};this.g.push({offset:v,lexeme:y,additionalInfo:b}),this.f.push(u)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const v=this.c.substring(this.d,this.e),y=g.b.get(v);y?this.k(y):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,v=!1,y=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(P);return}const $=this.c.charCodeAt(b);if(v)v=!1;else if($===47&&!y){b++;break}else $===91?y=!0:$===92?v=!0:$===93&&(y=!1);b++}for(;b<this.c.length&&g.a.has(this.c.charCodeAt(b));)b++;this.e=b;const u=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:u,offset:this.d})}r(){return this.e>=this.c.length}}e.$3i=g}),define(ae[198],ce([0,1,3,2]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=void 0;class s{constructor(){this.a=new S.$Wd,this.b=new S.$Wd,this.c=new S.$Wd,this.d=new S.$Wd}static{this.ChannelName="extensionhostdebugservice"}call(P,g,l){switch(g){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(P,g,l){switch(g){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$eo=s;class M extends R.$Tc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,g,l){this.b.call("attach",[P,g,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,g){this.b.call("terminate",[P,g])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,g){return this.b.call("openExtensionDevelopmentHostWindow",[P,g])}}e.$fo=M}),define(ae[199],ce([0,1,149,50,13,9,36,19,7]),function(X,e,S,R,s,M,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=void 0,e.$Am=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,M.$mc)(s.$pg.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,M.$jc)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,P.$Ig)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$Ig)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,S.$zm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$jc)(this.userDataPath,"logs",u)}return g.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$Ig)(g.URI.file((0,M.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$Ig)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$Ig)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$Ig)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=D.env.VSCODE_PORTABLE;return u?g.URI.file((0,M.$jc)(u,"argv.json")):(0,P.$Ig)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,M.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,M.$kc)(u):(0,M.$hc)((0,M.$jc)(s.$pg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?g.URI.file((0,M.$kc)(u)):g.URI.file((0,M.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,M.$kc)(u);const $=D.env.VSCODE_EXTENSIONS;if($)return $;const w=D.env.VSCODE_PORTABLE;return w?(0,M.$jc)(w,"extensions"):(0,P.$Ig)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map($=>/^[^:/?#]+?:\/\//.test($)?g.URI.parse($):g.URI.file((0,M.$hc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?g.URI.parse(u):g.URI.file((0,M.$hc)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.$Am.test(u))}get extensionLogLevel(){const u=[];for(const $ of this.args.log||[]){const w=e.$Am.exec($);w&&w[1]&&w[2]&&u.push([w[1],w[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,P.$Ig)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=D.env.VSCODE_PORTABLE;return u?g.URI.file((0,M.$jc)(u,"policy.json")):(0,P.$Ig)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,$,w){this.a=u,this.b=$,this.c=w,this.editSessionId=this.args.editSessionId}}e.$Bm=l,ve([R.$zh],l.prototype,"appRoot",null),ve([R.$zh],l.prototype,"userHome",null),ve([R.$zh],l.prototype,"userDataPath",null),ve([R.$zh],l.prototype,"appSettingsHome",null),ve([R.$zh],l.prototype,"tmpDir",null),ve([R.$zh],l.prototype,"cacheHome",null),ve([R.$zh],l.prototype,"stateResource",null),ve([R.$zh],l.prototype,"userRoamingDataHome",null),ve([R.$zh],l.prototype,"userDataSyncHome",null),ve([R.$zh],l.prototype,"sync",null),ve([R.$zh],l.prototype,"machineSettingsResource",null),ve([R.$zh],l.prototype,"workspaceStorageHome",null),ve([R.$zh],l.prototype,"localHistoryHome",null),ve([R.$zh],l.prototype,"keyboardLayoutResource",null),ve([R.$zh],l.prototype,"argvResource",null),ve([R.$zh],l.prototype,"isExtensionDevelopment",null),ve([R.$zh],l.prototype,"untitledWorkspacesHome",null),ve([R.$zh],l.prototype,"builtinExtensionsPath",null),ve([R.$zh],l.prototype,"extensionsPath",null),ve([R.$zh],l.prototype,"extensionDevelopmentLocationURI",null),ve([R.$zh],l.prototype,"extensionDevelopmentKind",null),ve([R.$zh],l.prototype,"extensionTestsLocationURI",null),ve([R.$zh],l.prototype,"debugExtensionHost",null),ve([R.$zh],l.prototype,"logLevel",null),ve([R.$zh],l.prototype,"extensionLogLevel",null),ve([R.$zh],l.prototype,"serviceMachineIdResource",null),ve([R.$zh],l.prototype,"disableTelemetry",null),ve([R.$zh],l.prototype,"disableWorkspaceTrust",null),ve([R.$zh],l.prototype,"useInMemorySecretStorage",null),ve([R.$zh],l.prototype,"policyFile",null);function b(y,u){return v(y["inspect-extensions"],y["inspect-brk-extensions"],5870,u,y.debugId,y.extensionEnvironment)}e.$Cm=b;function v(y,u,$,w,k,h){const d=Number(u||y)||(w?null:$),m=d?!!u:!1;let c;if(h)try{c=JSON.parse(h)}catch{}return{port:d,break:m,debugId:k,env:c}}e.$Dm=v}),define(ae[113],ce([0,1,309,4,168]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Yl=["tunnel","serve-web"],e.$Zl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(w,k,h=D){const f=w.find(a=>a.length>0&&a[0]!=="-"),d={},m=["_"],c=[],t={};let o;for(const a in k){const p=k[a];p.type==="subcommand"?a===f&&(o=p):(p.alias&&(d[a]=p.alias),p.type==="string"||p.type==="string[]"?(m.push(a),p.deprecates&&m.push(...p.deprecates)):p.type==="boolean"&&(c.push(a),p.deprecates&&c.push(...p.deprecates)),p.global&&(t[a]=p))}if(o&&f){const a=t;for(const E in o.options)a[E]=o.options[E];const p=w.filter(E=>E!==f),A=h.getSubcommandReporter?h.getSubcommandReporter(f):void 0,I=P(p,a,A);return{[f]:I,_:[]}}const r=S(w,{string:m,boolean:c,alias:d}),i={},n=r;i._=r._.map(a=>String(a)).filter(a=>a.length>0),delete n._;for(const a in k){const p=k[a];if(p.type==="subcommand")continue;p.alias&&delete n[p.alias];let A=n[a];if(p.deprecates)for(const I of p.deprecates)n.hasOwnProperty(I)&&(A||(A=n[I],A&&h.onDeprecatedOption(I,p.deprecationMessage||(0,s.localize)(38,null,a))),delete n[I]);if(typeof A<"u"){if(p.type==="string[]"){if(Array.isArray(A)||(A=[A]),!p.allowEmptyValue){const I=A.filter(E=>E.length>0);I.length!==A.length&&(h.onEmptyValue(a),A=I.length>0?I:void 0)}}else p.type==="string"&&(Array.isArray(A)?(A=A.pop(),h.onMultipleValues(a,A)):!A&&!p.allowEmptyValue&&(h.onEmptyValue(a),A=void 0));i[a]=A,p.deprecationMessage&&h.onDeprecatedOption(a,p.deprecationMessage)}delete n[a]}for(const a in n)h.onUnknownOption(a);return i}e.$1l=P;function g(w,k){let h="";return k.args&&(Array.isArray(k.args)?h=` <${k.args.join("> <")}>`:h=` <${k.args}>`),k.alias?`-${k.alias} --${w}${h}`:`--${w}${h}`}function l(w,k){const h=[];for(const f in w){const d=w[f],m=g(f,d);h.push([m,d.description])}return b(h,k)}e.$2l=l;function b(w,k){const f=w.reduce((c,t)=>Math.max(c,t[0].length),12)+2+1;if(k-f<25)return w.reduce((c,t)=>c.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const d=k-f-1,m=[];for(const c of w){const t=c[0],o=y(c[1],d),r=v(f-t.length-2);m.push("  "+t+r+o[0]);for(let i=1;i<o.length;i++)m.push(v(f)+o[i])}return m}function v(w){return" ".repeat(w)}function y(w,k){const h=[];for(;w.length;){const f=w.length<k?w.length:w.lastIndexOf(" ",k),d=w.slice(0,f).trim();w=w.slice(f),h.push(d)}return h}function u(w,k,h,f,d){const m=process.stdout.isTTY&&process.stdout.columns||80,c=d?.noInputFiles!==!0?`[${(0,s.localize)(39,null)}...]`:"",t=[`${w} ${h}`];t.push(""),t.push(`${(0,s.localize)(40,null)}: ${k} [${(0,s.localize)(41,null)}]${c}`),t.push(""),d?.noPipe!==!0&&(R.$i?t.push((0,s.localize)(42,null,k)):t.push((0,s.localize)(43,null,k)),t.push(""));const o={},r=[];for(const i in f){const n=f[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let a=o[n.cat];a||(o[n.cat]=a={}),a[i]=n}}for(const i in o){const n=i,a=o[n];a&&(t.push(M[n]),t.push(...l(a,m)),t.push(""))}return r.length&&(t.push((0,s.localize)(44,null)),t.push(...b(r.map(i=>[i.command,i.description]),m)),t.push("")),t.join(`
`)}e.$3l=u;function $(w,k){return`${w||(0,s.localize)(45,null)}
${k||(0,s.localize)(46,null)}
${process.arch}`}e.$4l=$}),define(ae[200],ce([0,1,87,198,113]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z0b=void 0;class M extends R.$eo{constructor(P){super(),this.f=P}call(P,g,l){return g==="openExtensionDevelopmentHostWindow"?this.g(l[0],l[1]):super.call(P,g,l)}async g(P,g){const l=(0,s.$1l)(P,s.$Zl);l.debugRenderer=g;const b=l.extensionDevelopmentPath;if(!b)return{success:!1};const[v]=await this.f.openExtensionDevelopmentHostWindow(b,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!g)return{success:!0};const y=v.win;if(!y)return{success:!0};const u=y.webContents.debugger;let $=u.isAttached()?1/0:0;const w=(0,S.createServer)(k=>{$++===0&&u.attach();let h=!1;const f=c=>{h||k.write(JSON.stringify(c)+"\0")},d=(c,t,o,r)=>f({method:t,params:o,sessionId:r});y.on("close",()=>{u.removeListener("message",d),k.end(),h=!0}),u.addListener("message",d);let m=Buffer.alloc(0);k.on("data",c=>{m=Buffer.concat([m,c]);for(let t=m.indexOf(0);t!==-1;t=m.indexOf(0)){let o;try{const r=m.slice(0,t).toString("utf8");m=m.slice(t+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}u.sendCommand(o.method,o.params,o.sessionId).then(r=>f({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>f({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),k.on("error",c=>{console.error("error on cdp pipe:",c)}),k.on("close",()=>{h=!0,--$===0&&u.detach()})});return await new Promise(k=>w.listen(0,k)),y.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.$z0b=M}),define(ae[64],ce([0,1,310,169,113]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=e.$6l=e.$5l=void 0;function M(v,y){const u=(d,m)=>{console.warn((0,R.localize)(0,null,d,m))},$=d=>{console.warn((0,R.localize)(1,null,d))},w=(d,m)=>{console.warn((0,R.localize)(2,null,d,m))},k=d=>({onUnknownOption:m=>{s.$Yl.includes(d)||console.warn((0,R.localize)(3,null,m,d))},onMultipleValues:u,onEmptyValue:$,onDeprecatedOption:w,getSubcommandReporter:s.$Yl.includes(d)?k:void 0}),h={onUnknownOption:d=>{console.warn((0,R.localize)(4,null,d))},onMultipleValues:u,onEmptyValue:$,onDeprecatedOption:w,getSubcommandReporter:k},f=(0,s.$1l)(v,s.$Zl,y?h:void 0);return f.goto&&f._.forEach(d=>S(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(d),(0,R.localize)(5,null))),f}function D(v){const y=v.findIndex(u=>!/^-/.test(u));if(y>-1)return[...v.slice(0,y),...v.slice(y+1)]}function P(v){let[,...y]=v;process.env.VSCODE_DEV&&(y=D(y)||[]);const u=!b(process.env);return M(y,u)}e.$5l=P;function g(v){let[,,...y]=v;return process.env.VSCODE_DEV&&(y=D(y)||[]),M(y,!0)}e.$6l=g;function l(v,...y){const u=v.indexOf("--");return u===-1?v.push(...y):v.splice(u,0,...y),v}e.$7l=l;function b(v){return v.VSCODE_CLI==="1"}e.$8l=b}),function(){"use strict";function X(e,S,R){function s(D,P){const g=M(D,P),l=[g];return e.isAbsolute(g)||l.unshift(R),e.resolve(...l)}function M(D,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,P);const b=D["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(v,"AppData","Roaming")}break;case"darwin":l=e.join(S.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,P)}return{getUserDataPath:s}}if(typeof define=="function")define(ae[201],ce([114,26,36]),function(e,S,R){return X(e,S,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=X(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[90],ce([0,1,26,199,201]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=void 0;class M extends R.$Bm{constructor(l,b){super(l,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,s.getUserDataPath)(l,b.nameShort)},b)}}e.$Em=M;function D(g,l){return(0,R.$Dm)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,l,g.extensionEnvironment)}e.$Fm=D;function P(g,l){return(0,R.$Dm)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,l,g.extensionEnvironment)}e.$Gm=P}),define(ae[202],ce([0,1,46,26,33]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T$b=void 0;function M(D){const P=(0,s.$eg)((0,R.tmpdir)());try{return(0,S.writeFileSync)(P,""),D&&console.log(`Marker file for --wait created: ${P}`),P}catch(g){D&&console.error(`Failed to create marker file for --wait: ${g}`);return}}e.$T$b=M}),define(ae[203],ce([0,1,12,171]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;function s(D,P,g,l){try{M(D,P,g,l)}catch(b){D.error(b?.message??b)}return P}e.$1p=s;function M(D,P,g,l){const b=(v,y,u)=>{const $=v[y];if((0,S.$Jf)($)){const w=$,k=w.length;if(k>1&&w[0]==="%"&&w[k-1]==="%"){const h=w.substr(1,k-2);let f=g[h];f===void 0&&l&&(f=l[h]);const d=typeof f=="string"?f:f?.message,m=l?.[h],c=typeof m=="string"?m:m?.message;if(!d){c||D.warn(`[${P.name}]: ${(0,R.localize)(0,null,h)}`);return}if(u&&(y==="title"||y==="category")&&c&&c!==d){const t={value:d,original:c};v[y]=t}else v[y]=d}}else if((0,S.$Lf)($))for(const w in $)$.hasOwnProperty(w)&&(w==="commands"?b($,w,!0):b($,w,u));else if(Array.isArray($))for(let w=0;w<$.length;w++)b($,w,u)};for(const v in P)P.hasOwnProperty(v)&&b(P,v)}}),define(ae[204],ce([0,1,19,73,173,205]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function g(h){return h=h.trim(),h==="*"||D.test(h)}e.$cp=g;function l(h){if(!g(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(D);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$dp=l;function b(h){if(!h)return null;const f=h.majorBase,d=h.majorMustEqual,m=h.minorBase;let c=h.minorMustEqual;const t=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(f===0||(c=!1),o=!1);let r=0;if(h.preRelease){const i=P.exec(h.preRelease);if(i){const[,n,a,p]=i;r=Date.UTC(Number(n),Number(a)-1,Number(p))}}return{majorBase:f,majorMustEqual:d,minorBase:m,minorMustEqual:c,patchBase:t,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:r}}e.$ep=b;function v(h,f,d){let m;typeof h=="string"?m=b(l(h)):m=h;let c;f instanceof Date?c=f.getTime():typeof f=="string"&&(c=new Date(f).getTime());let t;if(typeof d=="string"?t=b(l(d)):t=d,!m||!t)return!1;const o=m.majorBase,r=m.minorBase,i=m.patchBase;let n=t.majorBase,a=t.minorBase,p=t.patchBase;const A=t.notBefore;let I=t.majorMustEqual,E=t.minorMustEqual,C=t.patchMustEqual;return t.isMinimum?o>n?!0:o<n?!1:r>a?!0:r<a||c&&c<A?!1:i>=p:(o===1&&n===0&&(!I||!E||!C)&&(n=1,a=0,p=0,I=!0,E=!1,C=!1),o<n?!1:o>n?!I:r<a?!1:r>a?!E:i<p?!1:i>p?!C:!(c&&c<A))}e.$fp=v;function y(h,f,d,m,c){const t=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return t.push([R.default.Error,s.localize(0,null)]),t;if(typeof m.name!="string")return t.push([R.default.Error,s.localize(1,null,"name")]),t;if(typeof m.version!="string")return t.push([R.default.Error,s.localize(2,null,"version")]),t;if(!m.engines)return t.push([R.default.Error,s.localize(3,null,"engines")]),t;if(typeof m.engines.vscode!="string")return t.push([R.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof m.extensionDependencies<"u"&&!k(m.extensionDependencies))return t.push([R.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof m.activationEvents<"u"){if(!k(m.activationEvents))return t.push([R.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof m.main>"u"&&typeof m.browser>"u")return t.push([R.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&t.push([R.default.Warning,s.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return t.push([R.default.Error,s.localize(9,null,"main")]),t;{const i=(0,S.$Ig)(d,m.main);(0,S.$Cg)(i,d)||t.push([R.default.Warning,s.localize(10,null,i.path,d.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return t.push([R.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,S.$Ig)(d,m.browser);(0,S.$Cg)(i,d)||t.push([R.default.Warning,s.localize(12,null,i.path,d.path)])}}if(!M.valid(m.version))return t.push([R.default.Error,s.localize(13,null)]),t;const o=[];if(!u(h,f,m,c,o))for(const i of o)t.push([R.default.Error,i]);return t}e.$gp=y;function u(h,f,d,m,c){return m||typeof d.main>"u"&&typeof d.browser>"u"?!0:w(h,f,d.engines.vscode,c)}e.$hp=u;function $(h,f,d){return h==="*"||w(f,d,h)}e.$ip=$;function w(h,f,d,m=[]){const c=b(l(d));if(!c)return m.push(s.localize(14,null,d)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return m.push(s.localize(15,null,d)),!1}else if(!c.majorMustEqual)return m.push(s.localize(16,null,d)),!1;return v(h,f,c)?!0:(m.push(s.localize(17,null,h,d)),!1)}function k(h){if(!Array.isArray(h))return!1;for(let f=0,d=h.length;f<d;f++)if(typeof h[f]!="string")return!1;return!0}}),define(ae[206],ce([0,1,17,32]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function s(M,D,P){let g=P&&P.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const b=(await D.readFile(M.serviceMachineIdResource)).value.toString();g=(0,R.$qg)(b)?b:null}catch{g=null}if(!g){g=(0,R.$rg)();try{await D.writeFile(M.serviceMachineIdResource,S.$ke.fromString(g))}catch{}}return P?.store("storage.serviceMachineId",g,-1,1),g}e.$Cp=s}),define(ae[77],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class S{constructor(s,M=[],D=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=D}}e.$5h=S}),define(ae[207],ce([0,1,77]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.InstantiationType=void 0;const R=[];var s;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(P,g,l){g instanceof S.$5h||(g=new S.$5h(g,[],!!l)),R.push([P,g])}e.$1r=M;function D(){return R}e.$2r=D}),define(ae[208],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class S{constructor(M,D){this.key=M,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$Eq=S;class R{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const D of this.a.values())D.outgoing.size===0&&M.push(D);return M}insertEdge(M,D){const P=this.lookupOrInsertNode(M),g=this.lookupOrInsertNode(D);P.outgoing.set(g.key,g),g.incoming.set(P.key,P)}removeNode(M){const D=this.b(M);this.a.delete(D);for(const P of this.a.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(M){const D=this.b(M);let P=this.a.get(D);return P||(P=new S(D,M),this.a.set(D,P)),P}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[D,P]of this.a)M.push(`${D}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,D]of this.a){const P=new Set([M]),g=this.c(D,P);if(g)return g}}c(M,D){for(const[P,g]of M.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const l=this.c(g,D);if(l)return l;D.delete(P)}}}e.$Fq=R}),define(ae[6],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e._util=void 0;var S;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(g){return g[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(S||(e._util=S={})),e.$7h=s("instantiationService");function R(D,P,g){P[S.DI_TARGET]===P?P[S.DI_DEPENDENCIES].push({id:D,index:g}):(P[S.DI_DEPENDENCIES]=[{id:D,index:g}],P[S.DI_TARGET]=P)}function s(D){if(S.serviceIds.has(D))return S.serviceIds.get(D);const P=function(g,l,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(P,g,b)};return P.toString=()=>D,S.serviceIds.set(D,P),P}e.$8h=s;function M(D){return D}e.$9h=M}),define(ae[78],ce([0,1,13,6]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S0b=e.$R0b=void 0,e.$R0b=(0,R.$8h)("auxiliaryWindowsMainService");function s(M){return M?.opener?.url.startsWith(`${S.Schemas.vscodeFileResource}://${S.$og}/`)}e.$S0b=s}),define(ae[65],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$19b=void 0,e.$19b=(0,S.$8h)("backupMainService")}),define(ae[18],ce([0,1,12,7,6]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.ConfigurationTarget=e.$Di=e.$Ci=e.$Bi=void 0,e.$Bi=(0,s.$8h)("configurationService");function M(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof R.URI)}e.$Ci=M;function D(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof R.URI)}e.$Di=D;var P;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function g(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ei=g;function l(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$Fi=l;function b(h,f){const d=Object.create(null);for(const m in h)v(d,m,h[m],f);return d}e.$Gi=b;function v(h,f,d,m){const c=f.split("."),t=c.pop();let o=h;for(let r=0;r<c.length;r++){const i=c[r];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${f} as ${c.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[t]=d}catch{m(`Ignoring ${f} as ${c.join(".")} is ${JSON.stringify(o)}`)}else m(`Ignoring ${f} as ${c.join(".")} is ${JSON.stringify(o)}`)}e.$Hi=v;function y(h,f){const d=f.split(".");u(h,d)}e.$Ii=y;function u(h,f){const d=f.shift();if(f.length===0){delete h[d];return}if(Object.keys(h).indexOf(d)!==-1){const m=h[d];typeof m=="object"&&!Array.isArray(m)&&(u(m,f),Object.keys(m).length===0&&delete h[d])}}function $(h,f,d){function m(o,r){let i=o;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const c=f.split("."),t=m(h,c);return typeof t>"u"?d:t}e.$Ji=$;function w(h,f,d){Object.keys(f).forEach(m=>{m!=="__proto__"&&(m in h?S.$Lf(h[m])&&S.$Lf(f[m])?w(h[m],f[m],d):d&&(h[m]=f[m]):h[m]=f[m])})}e.$Ki=w;function k(h){return h.replace(/[\[\]]/g,"")}e.$Li=k}),define(ae[115],ce([0,1,4,25,197,6,164,14]),function(X,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.ContextKeyExprType=e.$4i=void 0;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",S.$j),g.set("isLinux",S.$k),g.set("isWindows",S.$i),g.set("isWeb",S.$o),g.set("isMacNative",S.$j&&!S.$o),g.set("isEdge",S.$H),g.set("isFirefox",S.$F),g.set("isChrome",S.$E),g.set("isSafari",S.$G);function l(K,O){if(g.get(K)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(K,O)}e.$4i=l;const b=Object.prototype.hasOwnProperty;var v;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const y={regexParsingWithErrorRecovery:!0},u=(0,D.localize)(0,null),$=(0,D.localize)(1,null),w=(0,D.localize)(2,null),k=(0,D.localize)(3,null),h=(0,D.localize)(4,null),f=(0,D.localize)(5,null),d=(0,D.localize)(6,null),m=(0,D.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=y){this.k=O,this.d=new s.$3i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:u,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const W=this.l();if(!this.E()){const x=this.D(),T=x.type===17?f:void 0;throw this.h.push({message:h,offset:x.offset,lexeme:s.$3i.getLexeme(x),additionalInfo:T}),c.c}return W}catch(W){if(W!==c.c)throw W;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const W=this.o();O.push(W)}return O.length===1?O[0]:t.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const W=this.s();O.push(W)}return O.length===1?O[0]:t.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const W=this.l();return this.A(1,k),W?.negate()}case 17:return this.z(),j.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const W=this.l();return this.A(1,k),W}case 17:{const W=O.lexeme;if(this.z(),this.y(9)){const T=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),T.type!==10)throw this.B("REGEX",T);const Q=T.lexeme,H=Q.lastIndexOf("/"),_=H===Q.length-1?void 0:this.w(Q.substring(H+1));let z;try{z=new RegExp(Q.substring(1,H),_)}catch{throw this.B("REGEX",T)}return oe.create(W,z)}switch(T.type){case 10:case 19:{const Q=[T.lexeme];this.z();let H=this.D(),_=0;for(let me=0;me<T.lexeme.length;me++)T.lexeme.charCodeAt(me)===40?_++:T.lexeme.charCodeAt(me)===41&&_--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let me=0;me<H.lexeme.length;me++)H.lexeme.charCodeAt(me)===40?_++:T.lexeme.charCodeAt(me)===41&&_--}if(_<0)break;Q.push(s.$3i.getLexeme(H)),this.z(),H=this.D()}const z=Q.join(""),ee=z.lastIndexOf("/"),se=ee===z.length-1?void 0:this.w(z.substring(ee+1));let de;try{de=new RegExp(z.substring(1,ee),se)}catch{throw this.B("REGEX",T)}return t.regex(W,de)}case 18:{const Q=T.lexeme;this.z();let H=null;if(!(0,R.$Ke)(Q)){const _=Q.indexOf("/"),z=Q.lastIndexOf("/");if(_!==z&&_>=0){const ee=Q.slice(_+1,z),se=Q[z+1]==="i"?"i":"";try{H=new RegExp(ee,se)}catch{throw this.B("REGEX",T)}}}if(H===null)throw this.B("REGEX",T);return oe.create(W,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const T=this.u();return t.notIn(W,T)}switch(this.D().type){case 3:{this.z();const T=this.u();if(this.x().type===18)return t.equals(W,T);switch(T){case"true":return t.has(W);case"false":return t.not(W);default:return t.equals(W,T)}}case 4:{this.z();const T=this.u();if(this.x().type===18)return t.notEquals(W,T);switch(T){case"true":return t.not(W);case"false":return t.has(W);default:return t.notEquals(W,T)}}case 5:return this.z(),J.create(W,this.u());case 6:return this.z(),le.create(W,this.u());case 7:return this.z(),F.create(W,this.u());case 8:return this.z(),V.create(W,this.u());case 13:return this.z(),t.in(W,this.u());default:return t.has(W)}}case 20:throw this.h.push({message:d,offset:O.offset,lexeme:"",additionalInfo:m}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,W){if(this.C(O))return this.z();throw this.B(W,this.D())}B(O,W,x){const T=(0,D.localize)(8,null,O,s.$3i.getLexeme(W)),Q=W.offset,H=s.$3i.getLexeme(W);return this.h.push({message:T,offset:Q,lexeme:H,additionalInfo:x}),c.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$5i=c;class t{static false(){return n.INSTANCE}static true(){return a.INSTANCE}static has(O){return p.create(O)}static equals(O,W){return A.create(O,W)}static notEquals(O,W){return C.create(O,W)}static regex(O,W){return oe.create(O,W)}static in(O,W){return I.create(O,W)}static notIn(O,W){return E.create(O,W)}static not(O){return j.create(O)}static and(...O){return Y.create(O,null,!0)}static or(...O){return q.create(O,null,!0)}static greater(O,W){return F.create(O,W)}static greaterEquals(O,W){return V.create(O,W)}static smaller(O,W){return J.create(O,W)}static smallerEquals(O,W){return le.create(O,W)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$6i=t;function o(K){const O=new c({regexParsingWithErrorRecovery:!1});return K.map(W=>(O.parse(W),O.lexingErrors.length>0?O.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,D.localize)(9,null,x.additionalInfo):(0,D.localize)(10,null),offset:x.offset,length:x.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}e.$7i=o;function r(K,O){const W=K?K.substituteConstants():void 0,x=O?O.substituteConstants():void 0;return!W&&!x?!0:!W||!x?!1:W.equals(x)}e.$8i=r;function i(K,O){return K.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return a.INSTANCE}}e.$9i=n;class a{static{this.INSTANCE=new a}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$0i=a;class p{static create(O,W=null){const x=g.get(O);return typeof x=="boolean"?x?a.INSTANCE:n.INSTANCE:new p(O,W)}constructor(O,W){this.key=O,this.c=W,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:N(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=g.get(this.key);return typeof O=="boolean"?O?a.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$$i=p;class A{static create(O,W,x=null){if(typeof W=="boolean")return W?p.create(O,x):j.create(O,x);const T=g.get(O);return typeof T=="boolean"?W===(T?"true":"false")?a.INSTANCE:n.INSTANCE:new A(O,W,x)}constructor(O,W,x){this.c=O,this.d=W,this.f=x,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=g.get(this.c);if(typeof O=="boolean"){const W=O?"true":"false";return this.d===W?a.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$_i=A;class I{static create(O,W){return new I(O,W)}constructor(O,W){this.d=O,this.f=W,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:G(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const W=O.getValue(this.f),x=O.getValue(this.d);return Array.isArray(W)?W.includes(x):typeof x=="string"&&typeof W=="object"&&W!==null?b.call(W,x):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$aj=I;class E{static create(O,W){return new E(O,W)}constructor(O,W){this.d=O,this.f=W,this.type=11,this.c=I.create(O,W)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$bj=E;class C{static create(O,W,x=null){if(typeof W=="boolean")return W?j.create(O,x):p.create(O,x);const T=g.get(O);return typeof T=="boolean"?W===(T?"true":"false")?n.INSTANCE:a.INSTANCE:new C(O,W,x)}constructor(O,W,x){this.c=O,this.d=W,this.f=x,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=g.get(this.c);if(typeof O=="boolean"){const W=O?"true":"false";return this.d===W?n.INSTANCE:a.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$cj=C;class j{static create(O,W=null){const x=g.get(O);return typeof x=="boolean"?x?n.INSTANCE:a.INSTANCE:new j(O,W)}constructor(O,W){this.c=O,this.d=W,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:N(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=g.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:a.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$dj=j;function U(K,O){if(typeof K=="string"){const W=parseFloat(K);isNaN(W)||(K=W)}return typeof K=="string"||typeof K=="number"?O(K):n.INSTANCE}class F{static create(O,W,x=null){return U(W,T=>new F(O,T,x))}constructor(O,W,x){this.c=O,this.d=W,this.f=x,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$ej=F;class V{static create(O,W,x=null){return U(W,T=>new V(O,T,x))}constructor(O,W,x){this.c=O,this.d=W,this.f=x,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$fj=V;class J{static create(O,W,x=null){return U(W,T=>new J(O,T,x))}constructor(O,W,x){this.c=O,this.d=W,this.f=x,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$gj=J;class le{static create(O,W,x=null){return U(W,T=>new le(O,T,x))}constructor(O,W,x){this.c=O,this.d=W,this.f=x,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$hj=le;class oe{static create(O,W){return new oe(O,W)}constructor(O,W){this.d=O,this.f=W,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const W=this.f?this.f.source:"",x=O.f?O.f.source:"";return W<x?-1:W>x?1:0}equals(O){if(O.type===this.type){const W=this.f?this.f.source:"",x=O.f?O.f.source:"";return this.d===O.d&&W===x}return!1}substituteConstants(){return this}evaluate(O){const W=O.getValue(this.d);return this.f?this.f.test(W):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$ij=oe;class ue{static create(O){return new ue(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ue(this.c.map(O))}negate(){return this.c}}e.$jj=ue;function Z(K){let O=null;for(let W=0,x=K.length;W<x;W++){const T=K[W].substituteConstants();if(K[W]!==T&&O===null){O=[];for(let Q=0;Q<W;Q++)O[Q]=K[Q]}O!==null&&(O[W]=T)}return O===null?K:O}class Y{static create(O,W,x){return Y.d(O,W,x)}constructor(O,W){this.expr=O,this.c=W,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let W=0,x=this.expr.length;W<x;W++){const T=i(this.expr[W],O.expr[W]);if(T!==0)return T}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let W=0,x=this.expr.length;W<x;W++)if(!this.expr[W].equals(O.expr[W]))return!1;return!0}return!1}substituteConstants(){const O=Z(this.expr);return O===this.expr?this:Y.create(O,this.c,!1)}evaluate(O){for(let W=0,x=this.expr.length;W<x;W++)if(!this.expr[W].evaluate(O))return!1;return!0}static d(O,W,x){const T=[];let Q=!1;for(const H of O)if(H){if(H.type===1){Q=!0;continue}if(H.type===0)return n.INSTANCE;if(H.type===6){T.push(...H.expr);continue}T.push(H)}if(T.length===0&&Q)return a.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];T.sort(i);for(let H=1;H<T.length;H++)T[H-1].equals(T[H])&&(T.splice(H,1),H--);if(T.length===1)return T[0];for(;T.length>1;){const H=T[T.length-1];if(H.type!==9)break;T.pop();const _=T.pop(),z=T.length===0,ee=q.create(H.expr.map(se=>Y.create([se,_],null,x)),null,z);ee&&(T.push(ee),T.sort(i))}if(T.length===1)return T[0];if(x){for(let H=0;H<T.length;H++)for(let _=H+1;_<T.length;_++)if(T[H].negate().equals(T[_]))return n.INSTANCE;if(T.length===1)return T[0]}return new Y(T,W)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const W of this.expr)O.push(...W.keys());return O}map(O){return new Y(this.expr.map(W=>W.map(O)),null)}negate(){if(!this.c){const O=[];for(const W of this.expr)O.push(W.negate());this.c=q.create(O,this,!0)}return this.c}}e.$kj=Y;class q{static create(O,W,x){return q.d(O,W,x)}constructor(O,W){this.expr=O,this.c=W,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let W=0,x=this.expr.length;W<x;W++){const T=i(this.expr[W],O.expr[W]);if(T!==0)return T}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let W=0,x=this.expr.length;W<x;W++)if(!this.expr[W].equals(O.expr[W]))return!1;return!0}return!1}substituteConstants(){const O=Z(this.expr);return O===this.expr?this:q.create(O,this.c,!1)}evaluate(O){for(let W=0,x=this.expr.length;W<x;W++)if(this.expr[W].evaluate(O))return!0;return!1}static d(O,W,x){let T=[],Q=!1;if(O){for(let H=0,_=O.length;H<_;H++){const z=O[H];if(z){if(z.type===0){Q=!0;continue}if(z.type===1)return a.INSTANCE;if(z.type===9){T=T.concat(z.expr);continue}T.push(z)}}if(T.length===0&&Q)return n.INSTANCE;T.sort(i)}if(T.length!==0){if(T.length===1)return T[0];for(let H=1;H<T.length;H++)T[H-1].equals(T[H])&&(T.splice(H,1),H--);if(T.length===1)return T[0];if(x){for(let H=0;H<T.length;H++)for(let _=H+1;_<T.length;_++)if(T[H].negate().equals(T[_]))return a.INSTANCE;if(T.length===1)return T[0]}return new q(T,W)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const W of this.expr)O.push(...W.keys());return O}map(O){return new q(this.expr.map(W=>W.map(O)),null)}negate(){if(!this.c){const O=[];for(const W of this.expr)O.push(W.negate());for(;O.length>1;){const W=O.shift(),x=O.shift(),T=[];for(const Q of he(W))for(const H of he(x))T.push(Y.create([Q,H],null,!1));O.unshift(q.create(T,null,!1))}this.c=q.create(O,this,!0)}return this.c}}e.$lj=q;class L extends p{static{this.d=[]}static all(){return L.d.values()}constructor(O,W,x){super(O,null),this.f=W,typeof x=="object"?L.d.push({...x,key:O}):x!==!0&&L.d.push({key:O,description:x,type:W!=null?typeof W:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return A.create(this.key,O)}notEqualsTo(O){return C.create(this.key,O)}}e.$mj=L,e.$nj=(0,M.$8h)("contextKeyService");function N(K,O){return K<O?-1:K>O?1:0}function G(K,O,W,x){return K<W?-1:K>W?1:O<x?-1:O>x?1:0}function B(K,O){if(K.type===0||O.type===1)return!0;if(K.type===9)return O.type===9?te(K.expr,O.expr):!1;if(O.type===9){for(const W of O.expr)if(B(K,W))return!0;return!1}if(K.type===6){if(O.type===6)return te(O.expr,K.expr);for(const W of K.expr)if(B(W,O))return!0;return!1}return K.equals(O)}e.$oj=B;function te(K,O){let W=0,x=0;for(;W<K.length&&x<O.length;){const T=K[W].cmp(O[x]);if(T<0)return!1;T===0&&W++,x++}return W===K.length}function he(K){return K.type===9?K.expr:[K]}}),define(ae[91],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=e.ID=void 0,e.ID="diagnosticsService",e.$Lm=(0,S.$8h)(e.ID);function R(M){return!!M.hostName&&!!M.errorMessage}e.$Mm=R;class s{async getPerformanceInfo(D,P){return{}}async getSystemInfo(D,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,P){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$Nm=s}),define(ae[116],ce([0,1,19,73,166,6,47,4,35]),function(X,e,S,R,s,M,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_v=e.$$v=e.ConfirmResult=e.$0v=e.$9v=e.$8v=void 0,e.$8v=(0,M.$8h)("dialogService");var l;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(l||(l={}));class b{a(k){return this.d(k,l.Confirmation)}b(k){return this.d(k,l.Prompt)}c(k){return this.d(k,l.Input)}d(k,h){const f=[];switch(h){case l.Confirmation:{const d=k;d.primaryButton?f.push(d.primaryButton):f.push((0,s.localize)(0,null)),d.cancelButton?f.push(d.cancelButton):f.push((0,s.localize)(1,null));break}case l.Prompt:{const d=k;Array.isArray(d.buttons)&&d.buttons.length>0&&f.push(...d.buttons.map(m=>m.label)),d.cancelButton&&(d.cancelButton===!0?f.push((0,s.localize)(2,null)):typeof d.cancelButton=="string"?f.push(d.cancelButton):d.cancelButton.label?f.push(d.cancelButton.label):f.push((0,s.localize)(3,null))),f.length===0&&f.push((0,s.localize)(4,null));break}case l.Input:{const d=k;d.primaryButton?f.push(d.primaryButton):f.push((0,s.localize)(5,null)),d.cancelButton?f.push(d.cancelButton):f.push((0,s.localize)(6,null));break}}return f}e(k){if(typeof k=="string")return k;if(typeof k=="number")return k===R.default.Info?"info":k===R.default.Error?"error":k===R.default.Warning?"warning":"none"}f(k,h,f){const d=[...k.buttons??[]];k.cancelButton&&typeof k.cancelButton!="string"&&typeof k.cancelButton!="boolean"&&d.push(k.cancelButton);let m=d[h]?.run({checkboxChecked:f});return m instanceof Promise||(m=Promise.resolve(m)),{result:m,checkboxChecked:f}}}e.$9v=b,e.$0v=(0,M.$8h)("fileDialogService");var v;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(v||(e.ConfirmResult=v={}));const y=10;function u(w){const k=[];return k.push(...w.slice(0,y).map(h=>typeof h=="string"?h:(0,S.$Fg)(h))),w.length>y&&(w.length-y===1?k.push((0,s.localize)(7,null)):k.push((0,s.localize)(8,null,w.length-y))),k.push(""),k.join(`
`)}e.$$v=u;function $(w,k){const h=(0,g.$yn)(w);let f=(h.buttons??[]).map(t=>(0,D.$5v)(t)),d=(w.buttons||[]).map((t,o)=>o),m=0,c=h.cancelId??f.length-1;if(f.length>1){const t=typeof c=="number"?f[c]:void 0;if(P.$k||P.$j){if(typeof t=="string"&&f.length>1&&c!==1){f.splice(c,1),f.splice(1,0,t);const o=d[c];d.splice(c,1),d.splice(1,0,o),c=1}P.$k&&f.length>1&&(f=f.reverse(),d=d.reverse(),m=f.length-1,typeof t=="string"&&(c=m-1))}else if(P.$i&&typeof t=="string"&&f.length>1&&c!==f.length-1){f.splice(c,1),f.push(t);const o=d[c];d.splice(c,1),d.push(o),c=f.length-1}}return h.buttons=f,h.defaultId=m,h.cancelId=c,h.noLink=!0,h.title=h.title||k.nameLong,{options:h,buttonIndeces:d}}e.$_v=$}),define(ae[117],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uV=e.$tV=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$sV=e.$rV=void 0,e.$rV=(0,S.$8h)("encryptionService"),e.$sV=(0,S.$8h)("encryptionMainService");var R;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnome="gnome",P.gnomeKeyring="gnome-keyring",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(R||(e.PasswordStoreCLIOption=R={}));var s;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}e.$tV=M;function D(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}e.$uV=D}),define(ae[38],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=void 0,e.$ci=(0,S.$8h)("environmentService"),e.$di=(0,S.$9h)(e.$ci)}),define(ae[118],ce([0,1,170,6]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ExtensionGalleryErrorCode=e.$Co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0,e.$po="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$qo=new RegExp(e.$po),e.$ro="__web_extension",e.$so="skipWalkthrough",e.$to="extensionsSync",e.$uo="dependecyOrPackExtensionInstall";function s(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$vo=s;function M(d){switch(d){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$wo=M;function D(d,m){switch(d){case 3:return m==="x64"?"win32-x64":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$xo=D;function P(d,m){return m==="web"&&!d.includes("web")}e.$yo=P;function g(d,m,c){return P(m,c)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===c}e.$zo=g;function l(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.$Ao=l;var b;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var v;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var y;(function(d){d.Install="install",d.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var u;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(u||(e.InstallOperation=u={})),e.$Bo=(0,R.$8h)("extensionGalleryService");var $;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.DownloadSignature="DownloadSignature",d.UpdateMetadata="UpdateMetadata",d.Extract="Extract",d.Scanning="Scanning",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.NotAllowed="NotAllowed",d.Gallery="Gallery",d.Unknown="Unknown",d.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var w;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class k extends Error{constructor(m,c){super(m),this.code=c,this.name=c}}e.$Co=k;var h;(function(d){d.Timeout="Timeout",d.Cancelled="Cancelled",d.Failed="Failed"})(h||(e.ExtensionGalleryErrorCode=h={}));class f extends Error{constructor(m,c){super(m),this.code=c,this.name=c}}e.$Do=f,e.$Eo=(0,R.$8h)("extensionManagementService"),e.$Fo="extensionsIdentifiers/disabled",e.$Go="extensionsIdentifiers/enabled",e.$Ho=(0,R.$8h)("IGlobalExtensionEnablementService"),e.$Io=(0,R.$8h)("IExtensionTipsService"),e.$Jo=(0,S.localize2)(0,"Extensions"),e.$Ko=(0,S.localize2)(1,"Preferences")}),define(ae[209],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H0b=e.$G0b=void 0,e.$G0b=(0,S.$8h)("extensionHostStarter"),e.$H0b="extensionHostStarter"}),define(ae[210],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O2b=e.$N2b=void 0,e.$N2b=(0,S.$8h)("externalTerminal"),e.$O2b="Terminal.app"}),define(ae[211],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J0b=void 0,e.$J0b=(0,S.$8h)("externalTerminal")}),define(ae[212],ce([0,1,48,50,13,9,4,75,21,89,174,210]),function(X,e,S,R,s,M,D,P,g,l,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M0b=e.$L0b=e.$K0b=void 0;const y=b.localize(0,null);class u{async getDefaultTerminalForPlatforms(){return{windows:$.getDefaultTerminalWindows(),linux:await k.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class $ extends u{static{this.b="cmd.exe"}openTerminal(c,t){return this.spawnTerminal(S,c,l.$Vl(),t)}spawnTerminal(c,t,o,r){const i=t.windowsExec||$.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const n=M.$nc(i,".exe").toLowerCase();if(n==="cmder")return c.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return i.indexOf(" ")>=0&&a.push('""'),a.push(i),n==="wt"&&a.push("-d ."),new Promise((p,A)=>{const I=h(process),E=c.spawn(o,a,{cwd:r,env:I,detached:!0});E.on("error",A),E.on("exit",()=>p())})}async runInTerminal(c,t,o,r,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:$.getDefaultTerminalWindows(),a=await $.f();return new Promise((p,A)=>{const I=`"${t} - ${y}"`,E=`""${o.join('" "')}" & pause"`,C=Object.assign({},h(process),r);Object.keys(C).filter(J=>C[J]===null).forEach(J=>delete C[J]);const j={cwd:t,env:C,windowsVerbatimArguments:!0};let U,F;M.$nc(n,".exe")==="wt"?(U=n,F=["-d",".",$.b,"/c",E]):a?(U=a,F=["-d",t,n,"/c",E]):(U=$.b,F=["/c","start",I,"/wait",n,"/c",E]),S.spawn(U,F,j).on("error",J=>{A(f(J))}),p(void 0)})}static getDefaultTerminalWindows(){if(!$.d){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");$.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return $.d}static async f(){try{const c=await l.win32.findExecutable("wt");return await g.Promises.exists(c)?c:void 0}catch{return}}}e.$K0b=$,ve([R.$zh],$,"f",null);class w extends u{static{this.b="/usr/bin/osascript"}openTerminal(c,t){return this.spawnTerminal(S,c,t)}runInTerminal(c,t,o,r,i){const n=i.osxExec||v.$O2b;return new Promise((a,p)=>{if(n===v.$O2b||n==="iTerm.app"){const A=n===v.$O2b?"TerminalHelper":"iTermHelper",E=[s.$pg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${A}.scpt`).fsPath,"-t",c||y,"-w",t];for(const U of o)E.push("-a"),E.push(U);if(r){const U=Object.assign({},h(process),r);for(const F in U){const V=U[F];V===null?(E.push("-u"),E.push(F)):(E.push("-e"),E.push(`${F}=${V}`))}}let C="";const j=S.spawn(w.b,E);j.on("error",U=>{p(f(U))}),j.stderr.on("data",U=>{C+=U.toString()}),j.on("exit",U=>{if(U===0)a(void 0);else if(C){const F=C.split(`
`,1);p(new Error(F[0]))}else p(new Error(b.localize(1,null,A,U)))})}else p(new Error(b.localize(2,null,n)))})}spawnTerminal(c,t,o){const r=t.osxExec||v.$O2b;return new Promise((i,n)=>{const a=["-a",r];o&&a.push(o);const p=h(process),A=c.spawn("/usr/bin/open",a,{cwd:o,env:p});A.on("error",n),A.on("exit",()=>i())})}}e.$L0b=w;class k extends u{static{this.b=b.localize(3,null)}openTerminal(c,t){return this.spawnTerminal(S,c,t)}runInTerminal(c,t,o,r,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):k.getDefaultTerminalLinuxReady();return new Promise((a,p)=>{const A=[];n.then(I=>{I.indexOf("gnome-terminal")>=0?A.push("-x"):A.push("-e"),A.push("bash"),A.push("-c");const E=`${d(o)}; echo; read -p "${k.b}" -n1;`;A.push(`''${E}''`);const C=Object.assign({},h(process),r);Object.keys(C).filter(V=>C[V]===null).forEach(V=>delete C[V]);const j={cwd:t,env:C};let U="";const F=S.spawn(I,A,j);F.on("error",V=>{p(f(V))}),F.stderr.on("data",V=>{U+=V.toString()}),F.on("exit",V=>{if(V===0)a(void 0);else if(U){const J=U.split(`
`,1);p(new Error(J[0]))}else p(new Error(b.localize(4,null,I,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!k.d)if(!D.$k)k.d=Promise.resolve("xterm");else{const c=await g.Promises.exists("/etc/debian_version");k.d=new Promise(t=>{c?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return k.d}spawnTerminal(c,t,o){const r=t.linuxExec?Promise.resolve(t.linuxExec):k.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{r.then(a=>{const p=h(process),A=c.spawn(a,[],{cwd:o,env:p});A.on("error",n),A.on("exit",()=>i())})})}}e.$M0b=k;function h(m){const c={...m.env};return(0,P.$Tl)(c),c}function f(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(b.localize(5,null,m.path)):m}function d(m){let c="";for(const t of m)t.indexOf(" ")>=0?c+='"'+t+'"':c+=t,c+=" ";return c}}),define(ae[16],ce([0,1,59,9,25,12,7,176,6,4,13,62]),function(X,e,S,R,s,M,D,P,g,l,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.FileKind=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileOperationResult=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileChangeType=e.$Kk=e.FileOperation=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderErrorCode=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileSystemProviderCapabilities=e.$uk=e.FilePermission=e.FileType=e.$tk=e.$sk=void 0,e.$sk=(0,g.$8h)("fileService");function y(B){return B.create===!0}e.$tk=y;var u;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var $;(function(B){B[B.Readonly=1]="Readonly",B[B.Locked=2]="Locked"})($||(e.FilePermission=$={}));function w(B){const te=B;return!!te&&typeof te.onDidChange=="function"}e.$uk=w;var k;(function(B){B[B.None=0]="None",B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileAtomicWrite=32768]="FileAtomicWrite",B[B.FileAtomicDelete=65536]="FileAtomicDelete",B[B.FileClone=131072]="FileClone"})(k||(e.FileSystemProviderCapabilities=k={}));function h(B){return!!(B.capabilities&2)}e.$vk=h;function f(B){return!!(B.capabilities&8)}e.$wk=f;function d(B){return!!(B.capabilities&131072)}e.$xk=d;function m(B){return!!(B.capabilities&4)}e.$yk=m;function c(B){return!!(B.capabilities&16)}e.$zk=c;function t(B){return h(B)?!!(B.capabilities&16384):!1}e.$Ak=t;function o(B){return h(B)?!!(B.capabilities&32768):!1}e.$Bk=o;function r(B){return!!(B.capabilities&65536)}e.$Ck=r;function i(B){return!!(B.capabilities&2048)}e.$Dk=i;var n;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsStorageQuota="EntryExceedsStorageQuota",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class a extends Error{static create(te,he){const K=new a(te.toString(),he);return I(K,he),K}constructor(te,he){super(te),this.code=he}}e.$Ek=a;function p(B,te){return a.create(B,te)}e.$Fk=p;function A(B){return B||p((0,P.localize)(0,null),n.Unknown)}e.$Gk=A;function I(B,te){return B.name=te?`${te} (FileSystemError)`:"FileSystemError",B}e.$Hk=I;function E(B){if(!B)return n.Unknown;if(B instanceof a)return B.code;const te=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!te)return n.Unknown;switch(te[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$Ik=E;function C(B){if(B instanceof le)return B.fileOperationResult;switch(E(B)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$Jk=C;var j;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class U{constructor(te,he,K){this.resource=te,this.operation=he,this.target=K}isOperation(te){return this.operation===te}}e.$Kk=U;var F;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class V{static{this.a=null}constructor(te,he){this.c=he,this.b=void 0,this.d=new v.$V(()=>{const K=S.$bi.forUris(()=>this.c);return K.fill(this.rawAdded.map(O=>[O,!0])),K}),this.f=new v.$V(()=>{const K=S.$bi.forUris(()=>this.c);return K.fill(this.rawUpdated.map(O=>[O,!0])),K}),this.g=new v.$V(()=>{const K=S.$bi.forUris(()=>this.c);return K.fill(this.rawDeleted.map(O=>[O,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of te){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==V.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=V.a):this.b!==void 0&&(this.b=V.a))}}contains(te,...he){return this.h(te,{includeChildren:!1},...he)}affects(te,...he){return this.h(te,{includeChildren:!0},...he)}h(te,he,...K){if(!te)return!1;const O=K.length>0;return!!((!O||K.includes(1))&&(this.d.value.get(te)||he.includeChildren&&this.d.value.findSuperstr(te))||(!O||K.includes(0))&&(this.f.value.get(te)||he.includeChildren&&this.f.value.findSuperstr(te))||(!O||K.includes(2))&&(this.g.value.findSubstr(te)||he.includeChildren&&this.g.value.findSuperstr(te)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(te){return this.b===te}hasCorrelation(){return typeof this.b=="number"}}e.$Lk=V;function J(B,te,he){return!B||!te||B===te||te.length>B.length?!1:(te.charAt(te.length-1)!==R.sep&&(te+=R.sep),he?(0,s.$bf)(B,te):B.indexOf(te)===0)}e.$Mk=J;class le extends Error{constructor(te,he,K){super(te),this.fileOperationResult=he,this.options=K}}e.$Nk=le;class oe extends le{constructor(te,he,K,O){super(te,he,O),this.fileOperationResult=he,this.size=K}}e.$Ok=oe;class ue extends le{constructor(te,he,K){super(te,2,K),this.stat=he}}e.$Pk=ue;var Z;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$Qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Sk="files.associations",e.$Tk="files.exclude",e.$Uk="files.readonlyInclude",e.$Vk="files.readonlyExclude",e.$Wk="files.readonlyFromPermissions";var Y;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.$Xk="";function q(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.$Yk=q;async function L(B,te){if(!te.hasProvider(D.URI.from({scheme:B.scheme})))return new Promise(he=>{const K=te.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===B.scheme&&O.added&&(K.dispose(),he())})})}e.$Zk=L;class N{static{this.KB=1024}static{this.MB=N.KB*N.KB}static{this.GB=N.MB*N.KB}static{this.TB=N.GB*N.KB}static formatSize(te){return(0,M.$Nf)(te)||(te=0),te<N.KB?(0,P.localize)(1,null,te.toFixed(0)):te<N.MB?(0,P.localize)(2,null,(te/N.KB).toFixed(2)):te<N.GB?(0,P.localize)(3,null,(te/N.MB).toFixed(2)):te<N.TB?(0,P.localize)(4,null,(te/N.GB).toFixed(2)):(0,P.localize)(5,null,(te/N.TB).toFixed(2))}}e.$1k=N;function G(B){const te=typeof B=="string"||B?.scheme===b.Schemas.vscodeRemote;return typeof B!="string"&&B?.scheme===b.Schemas.file?1024*N.MB:te?10*N.MB:l.$o?50*N.MB:1024*N.MB}e.$2k=G}),define(ae[119],ce([0,1,17,14,177,16]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;async function D(b,v,y,u,$,w){let k;try{await P(b,v,y,u,$,w)}catch(h){k=h}finally{k&&$.errorTransformer&&(k=$.errorTransformer(k)),typeof k<"u"&&y.error(k),y.end()}}e.$dq=D;async function P(b,v,y,u,$,w){g(w);const k=await b.open(v,{create:!1});try{g(w);let h=0,f=0,d=$&&typeof $.length=="number"?$.length:void 0,m=S.$ke.alloc(Math.min($.bufferSize,typeof d=="number"?d:$.bufferSize)),c=$&&typeof $.position=="number"?$.position:0,t=0;do f=await b.read(k,c,m.buffer,t,m.byteLength-t),c+=f,t+=f,h+=f,typeof d=="number"&&(d-=f),t===m.byteLength&&(await y.write(u(m)),m=S.$ke.alloc(Math.min($.bufferSize,typeof d=="number"?d:$.bufferSize)),t=0);while(f>0&&(typeof d!="number"||d>0)&&g(w)&&l(h,$));if(t>0){let o=t;typeof d=="number"&&(o=Math.min(t,d)),y.write(u(m.slice(0,o)))}}catch(h){throw(0,M.$Gk)(h)}finally{await b.close(k)}}function g(b){if(b.isCancellationRequested)throw(0,R.$6)();return!0}function l(b,v){if(typeof v?.limits?.size=="number"&&b>v.limits.size)throw(0,M.$Fk)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[66],ce([0,1,105,2,9,4,7,16]),function(X,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=void 0;function g(h){return h.recursive===!0}e.$fq=g;class l extends R.$Tc{static{this.a=5}constructor(f,d,m,c){super(),this.h=f,this.j=d,this.m=m,this.n=c,this.c=this.B(new R.$Uc),this.f=void 0,this.g=0}s(){const f=new R.$Sc;this.c.value=f,this.b=this.r(f),this.b.setVerboseLogging(this.m),f.add(this.b.onDidChangeFile(d=>this.h(d))),f.add(this.b.onDidLogMessage(d=>this.j(d))),f.add(this.b.onDidError(d=>this.t(d)))}t(f){this.n.restartOnError?this.g<l.a&&this.f?(this.w(`restarting watcher after error: ${f}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${f}`):this.w(f)}u(f){this.g++,this.s(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.m=f,await this.b?.setVerboseLogging(f)}w(f){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${f}`})}y(f){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.$gq=l;class b extends l{constructor(f,d,m){super(f,d,m,{type:"node.js",restartOnError:!1})}}e.$hq=b;class v extends l{constructor(f,d,m){super(f,d,m,{type:"universal",restartOnError:!0})}}e.$iq=v;function y(h){return h.map(f=>({type:f.type,resource:D.URI.revive(f.resource),cId:f.cId}))}e.$jq=y;function u(h){const f=new k;for(const d of h)f.processEvent(d);return f.coalesce()}e.$kq=u;function $(h,f){return typeof f=="string"&&!f.startsWith(S.$Kj)&&!(0,s.$ic)(f)?{base:h,pattern:f}:f}e.$lq=$;function w(h,f){const d=[];for(const m of f)d.push((0,S.$Oj)($(h,m)));return d}e.$mq=w;class k{constructor(){this.a=new Set,this.b=new Map}c(f){return M.$k?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const d=this.b.get(this.c(f));let m=!1;if(d){const c=d.type,t=f.type;d.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?m=!0:c===1&&t===2?(this.b.delete(this.c(f)),this.a.delete(d)):c===2&&t===1?d.type=0:c===1&&t===0||(d.type=t)}else m=!0;m&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],d=[];return Array.from(this.a).filter(m=>m.type!==2?(f.push(m),!1):!0).sort((m,c)=>m.resource.fsPath.length-c.resource.fsPath.length).filter(m=>d.some(c=>(0,P.$Mk)(m.resource.fsPath,c,!M.$k))?!1:(d.push(m.resource.fsPath),!0)).concat(f)}}}),define(ae[213],ce([0,1,17,51,14,3,2,63,32,16,66]),function(X,e,S,R,s,M,D,P,g,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=e.$tO=void 0,e.$tO="localFilesystem";class v extends D.$Tc{constructor(u,$){super(),this.a=u,this.b=$,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$Wd),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$Wd),this.onDidWatchError=this.g.event,this.h=(0,g.$rg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,$){const{buffer:w}=await this.a.call("readFile",[u,$]);return w}readFileStream(u,$,w){const k=(0,P.$$d)(f=>S.$ke.concat(f.map(d=>S.$ke.wrap(d))).buffer),h=new D.$Sc;return h.add(this.a.listen("readFileStream",[u,$])(f=>{if(f instanceof S.$ke)k.write(f.buffer);else{if(f==="end")k.end();else{let d;if(f instanceof Error)d=f;else{const m=f;d=(0,l.$Fk)(m.message??(0,R.$Si)(m),m.code??l.FileSystemProviderErrorCode.Unknown)}k.error(d),k.end()}h.dispose()}})),h.add(w.onCancellationRequested(()=>{k.error((0,s.$6)()),k.end(),h.dispose()})),k}writeFile(u,$,w){return this.a.call("writeFile",[u,S.$ke.wrap($),w])}open(u,$){return this.a.call("open",[u,$])}close(u){return this.a.call("close",[u])}async read(u,$,w,k,h){const[f,d]=await this.a.call("read",[u,$,h]);return w.set(f.buffer.slice(0,d),k),d}write(u,$,w,k,h){return this.a.call("write",[u,$,S.$ke.wrap(w),k,h])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,$){return this.a.call("delete",[u,$])}rename(u,$,w){return this.a.call("rename",[u,$,w])}copy(u,$,w){return this.a.call("copy",[u,$,w])}cloneFile(u,$){return this.a.call("cloneFile",[u,$])}j(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const $=u;this.f.fire((0,b.$jq)($))}else{const $=u;this.g.fire($)}}))}watch(u,$){const w=(0,g.$rg)();return this.a.call("watch",[this.h,w,u,$]),(0,D.$Rc)(()=>this.a.call("unwatch",[this.h,w]))}}e.$uO=v}),define(ae[214],ce([0,1,46,8,23,33,2,85,9,4,19,7,106,21,66]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=void 0;class w extends D.$Tc{static{this.a=100}static{this.b=75}constructor(f,d,m,c){super(),this.m=f,this.n=d,this.r=m,this.s=c,this.c=this.B(new R.$kh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new R.$jh(t=>this.z(t),w.b)),this.g=(0,$.$mq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,$.$mq)(this.m.path,this.m.includes):void 0,this.j=new s.$7d,this.ready=this.t()}async t(){try{const f=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const d=await u.Promises.stat(f);this.B(await this.w(f,d.isDirectory()))}catch(f){f.code!=="ENOENT"?this.D(f):this.G(f)}}async u(f){let d=f.path;try{d=await u.Promises.realpath(f.path),f.path===d&&(d=await(0,y.$wq)(f.path)??f.path),f.path!==d&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${d})`)}catch{}return d}async w(f,d){if(l.$j&&(0,M.$9f)(f,"/Volumes/",!0))return this.D(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Tc.None;const m=new s.$7d(this.j.token),c=new D.$Sc;try{const t=v.URI.file(this.m.path),o=(0,g.$nc)(f),r=(0,S.watch)(f);c.add((0,D.$Rc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${f}'`);const i=new Set;if(d)try{for(const a of await u.Promises.readdir(f))i.add(a)}catch(a){this.D(a)}const n=new Map;c.add((0,D.$Rc)(()=>{for(const[,a]of n)a.dispose();n.clear()})),r.on("error",(a,p)=>{this.D(`Failed to watch ${f} for changes using fs.watch() (${a}, ${p})`),this.dispose()}),r.on("change",(a,p)=>{if(m.token.isCancellationRequested)return;this.G(`[raw] ["${a}"] ${p}`);let A="";if(p&&(A=p.toString(),l.$j&&(A=(0,P.$Il)(A))),!(!A||a!=="change"&&a!=="rename"))if(d)if(a==="rename"){n.get(A)?.dispose();const I=setTimeout(async()=>{if(n.delete(A),A===o&&!await u.Promises.exists(f)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.C((0,g.$jc)(f,A));if(m.token.isCancellationRequested)return;let C;E?i.has(A)?C=0:(C=1,i.add(A)):(i.delete(A),C=2),this.y({resource:(0,b.$Ig)(t,A),type:C,cId:this.m.correlationId})},w.a);n.set(A,(0,D.$Rc)(()=>clearTimeout(I)))}else{let I;i.has(A)?I=0:(I=1,i.add(A)),this.y({resource:(0,b.$Ig)(t,A),type:I,cId:this.m.correlationId})}else if(a==="rename"||A!==o){const I=setTimeout(async()=>{const E=await u.Promises.exists(f);m.token.isCancellationRequested||(E?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),c.add(await this.w(f,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},w.a);c.clear(),c.add((0,D.$Rc)(()=>clearTimeout(I)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await u.Promises.exists(f)&&!m.token.isCancellationRequested&&this.D(`Failed to watch ${f} for changes using fs.watch() (${t.toString()})`)}return(0,D.$Rc)(()=>{m.dispose(!0),c.dispose()})}y(f,d=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!d&&this.g.some(m=>m(f.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${f.resource.fsPath}`):!d&&this.h&&this.h.length>0&&!this.h.some(m=>m(f.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}z(f){const d=(0,$.$kq)(f);if(d.length>0){if(this.s)for(const c of d)this.G(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(d)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(f){if(l.$k)return u.Promises.exists(f);try{const d=(0,g.$nc)(f);return(await u.Promises.readdir((0,g.$mc)(f))).some(c=>c===d)}catch(d){return this.G(d),!1}}setVerboseLogging(f){this.s=f}D(f){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}F(f){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}G(f){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$zq=w;async function k(h,f,d,m,c=512){const t=await u.Promises.open(h,"r"),o=Buffer.allocUnsafe(c),r=new s.$7d(m);let i,n=!1;const a={path:h,excludes:[],recursive:!1},p=new w(a,A=>{(async()=>{for(const{type:I}of A)if(I===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:E}=await u.Promises.read(t,o,0,c,null);if(!E||r.token.isCancellationRequested)break;f(o.slice(0,E))}}catch(E){i=new Error(E),r.dispose(!0)}finally{n=!1}}})()});return await p.ready,d(),new Promise((A,I)=>{r.token.onCancellationRequested(async()=>{p.dispose();try{await u.Promises.close(t)}catch(E){i=new Error(E)}i?I(i):A()})})}e.$Aq=k}),define(ae[215],ce([0,1,3,105,2,4,214]),function(X,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class P extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new S.$Wd),this.onDidChangeFile=this.a.event,this.b=this.B(new S.$Wd),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(l){const b=this.j(l),v=b.filter(u=>{const $=this.c.get(u.path);return $?!(0,R.$Sj)($.request.excludes,u.excludes)||!(0,R.$Sj)($.request.includes,u.includes):!0}),y=Array.from(this.c.values()).filter(({request:u})=>!b.find($=>$.path===u.path&&(0,R.$Sj)($.excludes,u.excludes)&&(0,R.$Sj)($.includes,u.includes))).map(({request:u})=>u.path);v.length&&this.m(`Request to start watching: ${v.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`).join(",")}`),y.length&&this.m(`Request to stop watching: ${y.join(",")}`);for(const u of y)this.h(u);for(const u of v)this.g(u)}g(l){const b=new D.$zq(l,y=>this.a.fire(y),y=>this.b.fire(y),this.f),v={request:l,instance:b};this.c.set(l.path,v)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const b=this.c.get(l);b&&(this.c.delete(l),b.instance.dispose())}j(l){const b=new Map;for(const v of l){const y=M.$k?v.path:v.path.toLowerCase();let u=b.get(v.correlationId);u||(u=new Map,b.set(v.correlationId,u)),u.set(y,v)}return Array.from(b.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(l){this.f=l;for(const[,b]of this.c)b.instance.setVerboseLogging(l)}m(l){this.f&&this.b.fire({type:"trace",message:this.n(l)})}n(l,b){return b?`[File Watcher (node.js)] ${l} (path: ${b.request.path})`:`[File Watcher (node.js)] ${l}`}}e.$Bq=P}),define(ae[216],ce([0,1,66,215]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class s extends S.$hq{constructor(D,P,g){super(D,P,g),this.s()}r(D){return D.add(new R.$Bq)}}e.$Cq=s}),define(ae[217],ce([0,1,13,43,160,66]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;class D extends M.$iq{constructor(g,l,b){super(g,l,b),this.s()}r(g){const l=g.add(new s.$tq(S.$pg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(l.onDidProcessExit(({code:b,signal:v})=>this.t(`terminated by itself with code ${b}, signal: ${v}`))),R.ProxyChannel.toService((0,R.$Oh)(l.getChannel("watcher")))}}e.$uq=D}),define(ae[92],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=void 0;class S{constructor(...s){this.a=new Map;for(const[M,D]of s)this.set(M,D)}set(s,M){const D=this.a.get(s);return this.a.set(s,M),D}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$6h=S}),define(ae[218],ce([0,1,8,14,2,77,208,6,92,102]),function(X,e,S,R,s,M,D,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;const b=!1;class v extends Error{constructor(k){super("cyclic dependency between services"),this.message=k.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${k.toString()}`}}class y{constructor(k=new g.$6h,h=!1,f,d=b){this.f=k,this.g=h,this.h=f,this.i=d,this.o=new Set,this.f.set(P.$7h,this),this._globalGraph=d?f?._globalGraph??new D.$Fq(m=>m):void 0}createChild(k){return new y(k,this.g,this,this.i)}invokeFunction(k,...h){const f=$.traceInvocation(this.i,k);let d=!1;try{return k({get:c=>{if(d)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(c,f);if(!t)throw new Error(`[invokeFunction] unknown service '${c}'`);return t}},...h)}finally{d=!0,f.stop()}}createInstance(k,...h){let f,d;return k instanceof M.$5h?(f=$.traceCreation(this.i,k.ctor),d=this.j(k.ctor,k.staticArguments.concat(h),f)):(f=$.traceCreation(this.i,k),d=this.j(k,h,f)),f.stop(),d}j(k,h=[],f){const d=P._util.getServiceDependencies(k).sort((t,o)=>t.index-o.index),m=[];for(const t of d){const o=this.m(t.id,f);o||this.u(`[createInstance] ${k.name} depends on UNKNOWN service ${t.id}.`,!1),m.push(o)}const c=d.length>0?d[0].index:h.length;if(h.length!==c){console.trace(`[createInstance] First service dependency of ${k.name} at position ${c+1} conflicts with ${h.length} static arguments`);const t=c-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,c)}return Reflect.construct(k,h.concat(m))}k(k,h){if(this.f.get(k)instanceof M.$5h)this.f.set(k,h);else if(this.h)this.h.k(k,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(k){const h=this.f.get(k);return!h&&this.h?this.h.l(k):h}m(k,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(k));const f=this.l(k);return f instanceof M.$5h?this.q(k,f,h.branch(k,!0)):(h.branch(k,!1),f)}q(k,h,f){if(this.o.has(k))throw new Error(`illegal state - RECURSIVELY instantiating service '${k}'`);this.o.add(k);try{return this.r(k,h,f)}finally{this.o.delete(k)}}r(k,h,f){const d=new D.$Fq(t=>t.id.toString());let m=0;const c=[{id:k,desc:h,_trace:f}];for(;c.length;){const t=c.pop();if(d.lookupOrInsertNode(t),m++>1e3)throw new v(d);for(const o of P._util.getServiceDependencies(t.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${k} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof M.$5h){const i={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};d.insertEdge(t,i),c.push(i)}}}for(;;){const t=d.roots();if(t.length===0){if(!d.isEmpty())throw new v(d);break}for(const{data:o}of t){if(this.l(o.id)instanceof M.$5h){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}d.removeNode(o)}}return this.l(k)}s(k,h,f=[],d,m){if(this.f.get(k)instanceof M.$5h)return this.t(k,h,f,d,m);if(this.h)return this.h.s(k,h,f,d,m);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(k,h,f=[],d,m){if(d){const c=new y(void 0,this.g,this,this.i);c.c=String(k);const t=new Map,o=new S.$oh(()=>{const r=c.j(h,f,m);for(const[i,n]of t){const a=r[i];if(typeof a=="function")for(const p of n)p.disposable=a.apply(r,p.listener)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let p=t.get(i);return p||(p=new l.$4c,t.set(i,p)),(I,E,C)=>{if(o.isInitialized)return o.value[i](I,E,C);{const j={listener:[I,E,C],disposable:void 0},U=p.push(j);return(0,s.$Rc)(()=>{U(),j.disposable?.dispose()})}}}if(i in r)return r[i];const n=o.value;let a=n[i];return typeof a!="function"||(a=a.bind(n),r[i]=a),a},set(r,i,n){return o.value[i]=n,!0},getPrototypeOf(r){return h.prototype}})}else return this.j(h,f,m)}u(k,h){if(h&&console.warn(k),this.g)throw new Error(k)}}e.$Gq=y;var u;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(u||(u={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(k,h){return k?new $(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(k,h){return k?new $(1,h.name):$.c}static{this.f=0}constructor(k,h){this.type=k,this.name=h,this.g=Date.now(),this.h=[]}branch(k,h){const f=new $(3,k.toString());return this.h.push([k,h,f]),f}stop(){const k=Date.now()-this.g;$.f+=k;let h=!1;function f(m,c){const t=[],o=new Array(m+1).join("	");for(const[r,i,n]of c.h)if(i&&n){h=!0,t.push(`${o}CREATES -> ${r}`);const a=f(m+1,n);a&&t.push(a)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${k.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(k>2||h)&&$.all.add(d.join(`
`))}}e.$Hq=$}),define(ae[219],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mAb=e.IssueType=void 0;var R;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(R||(e.IssueType=R={})),e.$mAb=(0,S.$8h)("issueService")}),define(ae[5],ce([0,1,51,3,45,2,31,4,19,12,7,115,6]),function(X,e,S,R,s,M,D,P,g,l,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.log=e.$sj=e.LogLevel=e.$rj=e.$qj=e.$pj=void 0,e.$pj=(0,y.$8h)("logService"),e.$qj=(0,y.$8h)("loggerService");function u(){return new Date().toISOString()}function $(I){return(0,l.$Nf)(I)}e.$rj=$;var w;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$sj=w.Info;function k(I,E,C){switch(E){case w.Trace:I.trace(C);break;case w.Debug:I.debug(C);break;case w.Info:I.info(C);break;case w.Warning:I.warn(C);break;case w.Error:I.error(C);break;case w.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=k;function h(I,E=!1){let C="";for(let j=0;j<I.length;j++){let U=I[j];if(U instanceof Error&&(U=(0,S.$Si)(U,E)),typeof U=="object")try{U=JSON.stringify(U)}catch{}C+=(j>0?" ":"")+U}return C}class f extends M.$Tc{constructor(){super(...arguments),this.b=e.$sj,this.c=this.B(new R.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==w.Off&&this.b<=E}}e.$uj=f;class d extends f{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...C){this.f(w.Trace)&&this.g(w.Trace,h([E,...C],!0))}debug(E,...C){this.f(w.Debug)&&this.g(w.Debug,h([E,...C]))}info(E,...C){this.f(w.Info)&&this.g(w.Info,h([E,...C]))}warn(E,...C){this.f(w.Warning)&&this.g(w.Warning,h([E,...C]))}error(E,...C){if(this.f(w.Error))if(E instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=E.stack,this.g(w.Error,h(j))}else this.g(w.Error,h([E,...C]))}flush(){}}e.$vj=d;class m extends f{constructor(E=e.$sj){super(),this.setLevel(E),this.g=!P.$i}trace(E,...C){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...C):console.log(`[main ${u()}]`,E,...C))}debug(E,...C){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...C):console.log(`[main ${u()}]`,E,...C))}info(E,...C){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...C):console.log(`[main ${u()}]`,E,...C))}warn(E,...C){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,E,...C):console.warn(`[main ${u()}]`,E,...C))}error(E,...C){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,E,...C):console.error(`[main ${u()}]`,E,...C))}flush(){}}e.$wj=m;class c extends f{constructor(E=e.$sj,C=!0){super(),this.g=C,this.setLevel(E)}trace(E,...C){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...C):console.log(E,...C))}debug(E,...C){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...C):console.log(E,...C))}info(E,...C){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...C):console.log(E,...C))}warn(E,...C){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...C):console.log(E,...C))}error(E,...C){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...C):console.error(E,...C))}flush(){}}e.$xj=c;class t extends f{constructor(E,C=e.$sj){super(),this.g=E,this.setLevel(C)}trace(E,...C){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(E),...C])}debug(E,...C){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(E),...C])}info(E,...C){this.f(w.Info)&&this.g.log(w.Info,[this.h(E),...C])}warn(E,...C){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(E),...C])}error(E,...C){this.f(w.Error)&&this.g.log(w.Error,[this.h(E),...C])}h(E){return typeof E=="string"?E:(0,S.$Si)(E,this.f(w.Trace))}flush(){}}e.$yj=t;class o extends f{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const C of this.g)C.setLevel(E);super.setLevel(E)}trace(E,...C){for(const j of this.g)j.trace(E,...C)}debug(E,...C){for(const j of this.g)j.debug(E,...C)}info(E,...C){for(const j of this.g)j.info(E,...C)}warn(E,...C){for(const j of this.g)j.warn(E,...C)}error(E,...C){for(const j of this.g)j.error(E,...C)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$zj=o;class r extends M.$Tc{constructor(E,C,j){if(super(),this.h=E,this.j=C,this.b=new D.$Ac,this.c=this.B(new R.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Wd),this.onDidChangeVisibility=this.g.event,j)for(const U of j)this.b.set(U.resource,{logger:void 0,info:U})}m(E){return(0,l.$Jf)(E)?[...this.b.values()].find(C=>C.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,C){const j=this.n(E),U=(0,l.$Jf)(E)?E:C?.id??(0,s.$Vi)(j.toString()).toString(16);let F=this.b.get(j)?.logger;const V=C?.logLevel==="always"?w.Trace:C?.logLevel;F||(F=this.s(j,V??this.getLogLevel(j)??this.h,{...C,id:U}));const J={logger:F,info:{resource:j,id:U,logLevel:V,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(J.info),this.b.set(j,J),F}n(E){return(0,l.$Jf)(E)?(0,g.$Ig)(this.j,`${E}.log`):E}setLogLevel(E,C){if(b.URI.isUri(E)){const j=E,U=C,F=this.b.get(j);F&&U!==F.info.logLevel&&(F.info.logLevel=U===this.h?void 0:U,F.logger?.setLevel(U),this.b.set(F.info.resource,F),this.f.fire([j,U]))}else{this.h=E;for(const[j,U]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,C){const j=this.m(E);j&&C!==!j.info.hidden&&(j.info.hidden=!C,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,C]))}getLogLevel(E){let C;return E&&(C=this.b.get(E)?.info.logLevel),C??this.h}registerLogger(E){const C=this.b.get(E.resource);C?C.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const C=this.b.get(E);C&&(C.logger&&C.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Aj=r;class i{constructor(){this.onDidChangeLogLevel=new R.$Wd().event}setLevel(E){}getLevel(){return w.Info}trace(E,...C){}debug(E,...C){}info(E,...C){}warn(E,...C){}error(E,...C){}critical(E,...C){}dispose(){}flush(){}}e.$Bj=i;class n extends i{}e.$Cj=n;function a(I){if(I.verbose)return w.Trace;if(typeof I.logLevel=="string"){const E=A(I.logLevel.toLowerCase());if(E!==void 0)return E}return e.$sj}e.$Dj=a;function p(I){switch(I){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$Ej=p;function A(I){switch(I){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$Fj=A,e.$Gj=new v.$mj("logLevel",p(w.Info))});var re=this&&this.__param||function(X,e){return function(S,R){e(S,R,X)}};define(ae[220],ce([0,1,15,4,5]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F0b=void 0;const M=S.safeStorage;let D=class{constructor(g){this.a=g,S.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(g){this.a.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(M.encryptString(g));return this.a.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.a.error(l),l}}async decrypt(g){let l;try{if(l=JSON.parse(g),!l.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${g}`);const b=Buffer.from(l.data);this.a.trace("[EncryptionMainService] Decrypting value.");const v=M.decryptString(b);return this.a.trace("[EncryptionMainService] Decrypted value."),v}catch(b){throw this.a.error(b),b}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(R.$i)return Promise.resolve("dpapi");if(R.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const g=M.getSelectedStorageBackend();return Promise.resolve(g)}catch(g){this.a.error(g)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(R.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(R.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$F0b=D,e.$F0b=D=ve([re(0,s.$pj)],D)}),define(ae[221],ce([0,1,22,8,14,3,2,9,66,5]),function(X,e,S,R,s,M,D,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class b extends D.$Tc{constructor(y,u){super(),this.a=y,this.b=u,this.c=this.B(new M.$Wd),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$Wd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$6g(0)),this.w=[],this.y=this.B(new R.$6g(0))}watch(y,u){return u.recursive||this.b?.watcher?.forceUniversal?this.n(y,u):this.z(y,u)}n(y,u){const $={path:this.H(y),excludes:u.excludes,includes:u.includes,recursive:u.recursive,correlationId:u.correlationId},w=(0,S.$Ub)(this.j,$);return this.r(),(0,D.$Rc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,s.$1)(y))}s(){this.h||(this.h=this.B(this.t(u=>this.c.fire((0,g.$jq)(u)),u=>this.G(u),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const u of this.j)(0,g.$fq)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const u of this.j)(0,g.$fq)(u)&&y.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,u){const $={path:this.H(y),excludes:u.excludes,includes:u.includes,recursive:!1,correlationId:u.correlationId},w=(0,S.$Ub)(this.w,$);return this.C(),(0,D.$Rc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,s.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,g.$jq)(y)),y=>this.G(y),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}H(y){return(0,P.$hc)(y.fsPath)}}e.$nq=b}),define(ae[222],ce([0,1,22,8,17,23,3,45,71,2,59,13,67,19,63,175,16,119,5,14]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h,f,d){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;let c=class extends l.$Tc{static{m=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new D.$Wd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Wd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Wd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Wd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Wd),this.Y=this.B(new D.$Wd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$Wd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$eh)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${o}`);const i=new l.$Sc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),i.add(r.onDidChangeFile(n=>{const a=new k.$Lk(n,!this.S(r));this.X.fire(a),a.hasCorrelation()||this.Y.fire(a)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,l.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,l.$Oc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(i){r.push(i)}}),!this.h.has(o)&&await R.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return g.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,u.$Mg)(o))throw new k.$Nk((0,w.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const i=new d.$bb;throw i.message=(0,w.localize)(1,null,o.toString()),i}return r}async m(o){const r=await this.j(o);if((0,k.$yk)(r)||(0,k.$vk)(r)||(0,k.$zk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,k.$yk)(r)||(0,k.$vk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(i){throw(0,k.$Ik)(i)===k.FileSystemProviderErrorCode.FileNotFound?new k.$Nk((0,w.localize)(2,null,this.sb(o)),1):(0,k.$Gk)(i)}}async s(o,r){const i=await this.j(o),n=this.S(i),a=r?.resolveTo,p=r?.resolveSingleChildDescendants,A=r?.resolveMetadata,I=await i.stat(o);let E;return this.t(i,o,I,void 0,!!A,(C,j)=>(E||(E=b.$bi.forUris(()=>!n),E.set(o,!0),a&&E.fill(!0,a)),E.get(C.resource)||E.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&p?j===1:!1))}async t(o,r,i,n,a,p){const{providerExtUri:A}=this.R(o),I={resource:r,name:A.basename(r),isFile:(i.type&k.FileType.File)!==0,isDirectory:(i.type&k.FileType.Directory)!==0,isSymbolicLink:(i.type&k.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&k.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&k.FilePermission.Locked),etag:(0,k.$Yk)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&p(I,n)){try{const E=await o.readdir(r),C=await R.Promises.settled(E.map(async([j,U])=>{try{const F=A.joinPath(r,j),V=a?await o.stat(F):{type:U};return await this.t(o,F,V,E.length,a,p)}catch(F){return this.b.trace(F),null}}));I.children=(0,S.$Hb)(C)}catch(E){this.b.trace(E),I.children=[]}return I}return I}async resolveAll(o){return R.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),i=await r.stat(o);return this.t(r,o,i,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(i){return i}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new k.$Nk((0,w.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=s.$ke.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,r);return this.r.fire(new k.$Kk(o,0,n)),n}async writeFile(o,r,i){const n=this.qb(await this.n(o),o),{providerExtUri:a}=this.R(n);let p=i;if((0,k.$Bk)(n)&&!p?.atomic){const A=n.enforceAtomicWriteFile?.(o);A&&(p={...i,atomic:A})}try{await this.w(n,o,p)||await this.U(n,a.dirname(o));let I;if((0,k.$vk)(n)&&!(r instanceof s.$ke))if((0,$.$9d)(r)){const E=await(0,$.$de)(r,3);E.ended?I=s.$ke.concat(E.buffer):I=E}else I=(0,$.$ae)(r,E=>s.$ke.concat(E),3);else I=r;!(0,k.$yk)(n)||(0,k.$vk)(n)&&I instanceof s.$ke||(0,k.$vk)(n)&&(0,k.$Bk)(n)&&p?.atomic?await this.hb(n,o,p,I):await this.db(n,o,p,I instanceof s.$ke?(0,s.$ve)(I):I),this.r.fire(new k.$Kk(o,4))}catch(A){throw new k.$Nk((0,w.localize)(4,null,this.sb(o),(0,k.$Gk)(A).toString()),(0,k.$Jk)(A),p)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,w.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,w.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,w.localize)(7,null,this.sb(r)));if(n)throw new Error((0,w.localize)(8,null,this.sb(r)))}let p;try{p=await o.stat(r)}catch{return}if(p.type&k.FileType.Directory)throw new k.$Nk((0,w.localize)(9,null,this.sb(r)),0,i);if(this.rb(r,p),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==k.$Xk&&typeof p.mtime=="number"&&typeof p.size=="number"&&i.mtime<p.mtime&&i.etag!==(0,k.$Yk)({mtime:i.mtime,size:p.size}))throw new k.$Nk((0,w.localize)(10,null),3,i);return p}async readFile(o,r,i){const n=await this.m(o);return r?.atomic?this.z(n,o,r,i):this.C(n,o,r,i)}async z(o,r,i,n){return new Promise((a,p)=>{this.cb.queueFor(r,async()=>{try{const A=await this.C(o,r,i,n);a(A)}catch(A){p(A)}},this.R(o).providerExtUri)})}async C(o,r,i,n){const a=await this.D(o,r,{...i,preferUnbuffered:!0},n);return{...a,value:await(0,s.$we)(a.value)}}async readFileStream(o,r,i){const n=await this.m(o);return this.D(n,o,r,i)}async D(o,r,i,n){const a=new M.$7d(n);let p=i;(0,k.$Ak)(o)&&o.enforceAtomicReadFile?.(r)&&(p={...i,atomic:!0});const A=this.J(r,p).then(E=>E,E=>{throw a.dispose(!0),E});let I;try{return typeof p?.etag=="string"&&p.etag!==k.$Xk&&await A,p?.atomic&&(0,k.$Ak)(o)||!((0,k.$yk)(o)||(0,k.$zk)(o))||(0,k.$vk)(o)&&p?.preferUnbuffered?I=this.I(o,r,p):(0,k.$zk)(o)?I=this.G(o,r,a.token,p):I=this.H(o,r,a.token,p),I.on("end",()=>a.dispose()),I.on("error",()=>a.dispose()),{...await A,value:I}}catch(E){throw I&&await(0,$.$be)(I),this.F(E,r,p)}}F(o,r,i){const n=(0,w.localize)(11,null,this.sb(r),(0,k.$Gk)(o).toString());return o instanceof k.$Pk?new k.$Pk(n,o.stat,i):o instanceof k.$Ok?new k.$Ok(n,o.fileOperationResult,o.size,o.options):new k.$Nk(n,(0,k.$Jk)(o),i)}G(o,r,i,n=Object.create(null)){const a=o.readFileStream(r,n,i);return(0,$.$he)(a,{data:p=>p instanceof s.$ke?p:s.$ke.wrap(p),error:p=>this.F(p,r,n)},p=>s.$ke.concat(p))}H(o,r,i,n=Object.create(null)){const a=(0,s.$Ae)();return(0,h.$dq)(o,r,a,p=>p,{...n,bufferSize:this.a,errorTransformer:p=>this.F(p,r,n)},i),a}I(o,r,i){const n=(0,$.$$d)(a=>s.$ke.concat(a));return(async()=>{try{let a;i?.atomic&&(0,k.$Ak)(o)?a=await o.readFile(r,{atomic:!0}):a=await o.readFile(r),typeof i?.position=="number"&&(a=a.slice(i.position)),typeof i?.length=="number"&&(a=a.slice(0,i.length)),this.L(r,a.byteLength,i),n.end(s.$ke.wrap(a))}catch(a){n.error(a),n.end()}})(),n}async J(o,r){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new k.$Nk((0,w.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==k.$Xk&&r.etag===i.etag)throw new k.$Pk((0,w.localize)(13,null),i,r);return this.L(o,i.size,r),i}L(o,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new k.$Ok((0,w.localize)(14,null,this.sb(o)),7,r,i)}async canMove(o,r,i){return this.M(o,r,"move",i)}async canCopy(o,r,i){return this.M(o,r,"copy",i)}async M(o,r,i,n){if(o.toString()!==r.toString())try{const a=i==="move"?this.qb(await this.n(o),o):await this.m(o),p=this.qb(await this.n(r),r);await this.Q(a,o,p,r,i,n)}catch(a){return a}return!0}async move(o,r,i){const n=this.qb(await this.n(o),o),a=this.qb(await this.n(r),r),p=await this.N(n,o,a,r,"move",!!i),A=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new k.$Kk(o,p==="move"?2:3,A)),A}async copy(o,r,i){const n=await this.m(o),a=this.qb(await this.n(r),r),p=await this.N(n,o,a,r,"copy",!!i),A=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new k.$Kk(o,p==="copy"?3:2,A)),A}async N(o,r,i,n,a,p){if(r.toString()===n.toString())return a;const{exists:A,isSameResourceWithDifferentPathCase:I}=await this.Q(o,r,i,n,a,p);if(A&&!I&&p&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),a==="copy"){if(o===i&&(0,k.$wk)(o))await o.copy(r,n,{overwrite:p});else{const E=await this.resolve(r);E.isDirectory?await this.P(o,E,i,n):await this.O(o,r,i,n)}return a}else return o===i?(await o.rename(r,n,{overwrite:p}),a):(await this.N(o,r,i,n,"copy",p),await this.del(r,{recursive:!0}),"copy")}async O(o,r,i,n){if((0,k.$yk)(o)&&(0,k.$yk)(i))return this.jb(o,r,i,n);if((0,k.$yk)(o)&&(0,k.$vk)(i))return this.pb(o,r,i,n);if((0,k.$vk)(o)&&(0,k.$yk)(i))return this.nb(o,r,i,n);if((0,k.$vk)(o)&&(0,k.$vk)(i))return this.lb(o,r,i,n)}async P(o,r,i,n){await i.mkdir(n),Array.isArray(r.children)&&await R.Promises.settled(r.children.map(async a=>{const p=this.R(i).providerExtUri.joinPath(n,a.name);return a.isDirectory?this.P(o,await this.resolve(a.resource),i,p):this.O(o,a.resource,i,p)}))}async Q(o,r,i,n,a,p){let A=!1;if(o===i){const{providerExtUri:E,isPathCaseSensitive:C}=this.R(o);if(C||(A=E.isEqual(r,n)),A&&a==="copy")throw new Error((0,w.localize)(15,null,this.sb(r),this.sb(n)));if(!A&&E.isEqualOrParent(n,r))throw new Error((0,w.localize)(16,null,this.sb(r),this.sb(n)))}const I=await this.exists(n);if(I&&!A){if(!p)throw new k.$Nk((0,w.localize)(17,null,this.sb(r),this.sb(n)),4);if(o===i){const{providerExtUri:E}=this.R(o);if(E.isEqualOrParent(r,n))throw new Error((0,w.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:I,isSameResourceWithDifferentPathCase:A}}R(o){const r=this.S(o);return{providerExtUri:r?u.$yg:u.$Ag,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new k.$Kk(o,0,i)),i}async U(o,r){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&k.FileType.Directory))throw new Error((0,w.localize)(19,null,this.sb(r)));break}catch(a){if((0,k.$Ik)(a)!==k.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(n.basename(r)),r=n.dirname(r)}for(let a=i.length-1;a>=0;a--){r=n.joinPath(r,i[a]);try{await o.mkdir(r)}catch(p){if((0,k.$Ik)(p)!==k.FileSystemProviderErrorCode.FileExists)throw p}}}async canDelete(o,r){try{await this.W(o,r)}catch(i){return i}return!0}async W(o,r){const i=this.qb(await this.j(o),o),n=!!r?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,w.localize)(20,null,this.sb(o)));const a=r?.atomic;if(a&&!(i.capabilities&65536))throw new Error((0,w.localize)(21,null,this.sb(o)));if(n&&a)throw new Error((0,w.localize)(22,null,this.sb(o)));let p;try{p=await i.stat(o)}catch{}if(p)this.rb(o,p);else throw new k.$Nk((0,w.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const I=await this.resolve(o);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,w.localize)(24,null,this.sb(o)))}return i}async del(o,r){const i=await this.W(o,r);let n=r;if((0,k.$Ck)(i)&&!n?.atomic){const I=i.enforceAtomicDelete?.(o);I&&(n={...r,atomic:I})}const a=!!n?.useTrash,p=!!n?.recursive,A=n?.atomic??!1;await i.delete(o,{recursive:p,useTrash:a,atomic:A}),this.r.fire(new k.$Kk(o,1))}async cloneFile(o,r){const i=await this.j(o),n=this.qb(await this.n(r),r);if(!(i===n&&this.R(i).providerExtUri.isEqual(o,r)))return i===n&&(0,k.$xk)(i)?i.cloneFile(o,r):(await this.U(n,this.R(n).providerExtUri.dirname(r)),i===n&&(0,k.$wk)(i)?this.cb.queueFor(o,()=>i.copy(o,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(o,()=>this.O(i,o,n,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:m.ab++})}watch(o,r={recursive:!1,excludes:[]}){const i=new l.$Sc;let n=!1,a=()=>{n=!0};i.add((0,l.$Rc)(()=>a())),(async()=>{try{const A=await this.bb(o,r);n?(0,l.$Oc)(A):a=()=>(0,l.$Oc)(A)}catch(A){this.b.error(A)}})();const p=r.correlationId;if(typeof p=="number"){const A=i.add(new D.$Wd);return i.add(this.X.event(E=>{E.correlates(p)&&A.fire(E)})),{onDidChange:A.event,dispose:()=>i.dispose()}}return i}async bb(o,r){const i=await this.j(o),n=(0,P.$Vi)([this.R(i).providerExtUri.getComparisonKey(o),r]);let a=this.$.get(n);return a||(a={count:0,disposable:i.watch(o,r)},this.$.set(n,a)),a.count+=1,(0,l.$Rc)(()=>{a&&(a.count--,a.count===0&&((0,l.$Oc)(a.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,l.$Oc)(o.disposable);this.$.clear()}async db(o,r,i,n){return this.cb.queueFor(r,async()=>{const a=await o.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,$.$9d)(n)||(0,$.$0d)(n)?await this.eb(o,a,n):await this.fb(o,a,n)}catch(p){throw(0,k.$Gk)(p)}finally{await o.close(a)}},this.R(o).providerExtUri)}async eb(o,r,i){let n=0,a;if((0,$.$0d)(i)){if(i.buffer.length>0){const p=s.$ke.concat(i.buffer);await this.gb(o,r,p,p.byteLength,n,0),n+=p.byteLength}if(i.ended)return;a=i.stream}else a=i;return new Promise((p,A)=>{(0,$.$ce)(a,{onData:async I=>{a.pause();try{await this.gb(o,r,I,I.byteLength,n,0)}catch(E){return A(E)}n+=I.byteLength,setTimeout(()=>a.resume())},onError:I=>A(I),onEnd:()=>p()})})}async fb(o,r,i){let n=0,a;for(;(a=i.read())!==null;)await this.gb(o,r,a,a.byteLength,n,0),n+=a.byteLength}async gb(o,r,i,n,a,p){let A=0;for(;A<n;){const I=await o.write(r,a+A,i.buffer,p+A,n-A);A+=I}}async hb(o,r,i,n){return this.cb.queueFor(r,()=>this.ib(o,r,i,n),this.R(o).providerExtUri)}async ib(o,r,i,n){let a;n instanceof s.$ke?a=n:(0,$.$9d)(n)?a=await(0,s.$we)(n):(0,$.$0d)(n)?a=await(0,s.$xe)(n):a=(0,s.$ue)(n),await o.writeFile(r,a.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,r,i,n){return this.cb.queueFor(n,()=>this.kb(o,r,i,n),this.R(i).providerExtUri)}async kb(o,r,i,n){let a,p;try{a=await o.open(r,{create:!1}),p=await i.open(n,{create:!0,unlock:!1});const A=s.$ke.alloc(this.a);let I=0,E=0,C=0;do C=await o.read(a,I,A.buffer,E,A.byteLength-E),await this.gb(i,p,A,C,I,E),I+=C,E+=C,E===A.byteLength&&(E=0);while(C>0)}catch(A){throw(0,k.$Gk)(A)}finally{await R.Promises.settled([typeof a=="number"?o.close(a):Promise.resolve(),typeof p=="number"?i.close(p):Promise.resolve()])}}async lb(o,r,i,n){return this.cb.queueFor(n,()=>this.mb(o,r,i,n),this.R(i).providerExtUri)}async mb(o,r,i,n){return i.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,i,n){return this.cb.queueFor(n,()=>this.ob(o,r,i,n),this.R(i).providerExtUri)}async ob(o,r,i,n){const a=await i.open(n,{create:!0,unlock:!1});try{const p=await o.readFile(r);await this.gb(i,a,s.$ke.wrap(p),p.byteLength,0,0)}catch(p){throw(0,k.$Gk)(p)}finally{await i.close(a)}}async pb(o,r,i,n){const a=await(0,s.$we)(this.H(o,r,M.CancellationToken.None));await this.hb(i,n,void 0,a)}qb(o,r){if(o.capabilities&2048)throw new k.$Nk((0,w.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&k.FilePermission.Readonly)throw new k.$Nk((0,w.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===v.Schemas.file?o.fsPath:o.toString(!0)}};e.$eq=c,e.$eq=c=m=ve([re(0,f.$pj)],c)}),define(ae[93],ce([0,1,46,311,8,31,17,3,33,2,9,4,19,63,21,179,16,119,221,51,217,216]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h,f,d,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0,(()=>{try{(0,R.gracefulify)(S)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.$Si)(o)}`)}})();class t extends f.$nq{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=P.Event.None,this.N=new M.$Ac(n=>y.$zg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,v.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:n}=await $.SymlinkSupport.stat(this.H(r));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:k.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await $.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async a=>{try{let p;a.isSymbolicLink()?p=(await this.stat((0,y.$Ig)(r,a.name))).type:p=this.M(a),n.push([a.name,p])}catch(p){this.a.trace(p)}})),n}catch(i){throw this.fb(i)}}M(r,i){let n;return i?.dangling?n=k.FileType.Unknown:r.isFile()?n=k.FileType.File:r.isDirectory()?n=k.FileType.Directory:n=k.FileType.Unknown,i&&(n|=k.FileType.SymbolicLink),n}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const a=new s.$7g;return this.N.set(r,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const a=this.H(r);return await $.Promises.readFile(a)}catch(a){throw this.fb(a)}finally{n?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,n){const a=(0,u.$$d)(p=>D.$ke.concat(p.map(A=>D.$ke.wrap(A))).buffer);return(0,h.$dq)(this,r,a,p=>p.buffer,{...i,bufferSize:256*1024},n),a}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,y.$Ig)((0,y.$Hg)(r),`${(0,y.$Fg)(r)}${n.atomic.postfix}`),i,n):this.S(r,i,n)}async Q(r){try{const i=this.H(r),{symbolicLink:n}=await $.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(r,i,n,a){const p=new l.$Sc;try{p.add(await this.O(r)),p.add(await this.O(i)),await this.S(i,n,a,!0);try{await this.rename(i,r,{overwrite:!0})}catch(A){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw A}}finally{p.dispose()}}async S(r,i,n,a){let p;try{const A=this.H(r);if(!n.create||!n.overwrite){if(await $.Promises.exists(A)){if(!n.overwrite)throw(0,k.$Fk)((0,w.localize)(0,null),k.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,k.$Fk)((0,w.localize)(1,null),k.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:n.unlock},a),await this.write(p,0,i,0,i.byteLength)}catch(A){throw await this.gb(r,A)}finally{typeof p=="number"&&await this.close(p)}}static{this.Y=!0}static configureFlushOnWrite(r){t.Y=r}async open(r,i,n){const a=this.H(r);let p;(0,k.$tk)(i)&&!n&&(p=await this.O(r));let A;try{if((0,k.$tk)(i)&&i.unlock)try{const{stat:E}=await $.SymlinkSupport.stat(a);E.mode&128||await $.Promises.chmod(a,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let I;if((0,k.$tk)(i)){if(v.$i)try{await $.Promises.truncate(a,0),I="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}I||(I="w")}else I="r";A=await $.Promises.open(a,I)}catch(I){throw p?.dispose(),(0,k.$tk)(i)?await this.gb(r,I):this.fb(I)}if(this.U.set(A,0),(0,k.$tk)(i)&&this.X.set(A,r),p){const I=this.W.get(A);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${A} (${a})`),this.W.set(A,p),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${A} (${a})`),I.dispose())}return A}async close(r){const i=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await $.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await $.Promises.close(r)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,a,p){const A=this.Z(r,i);let I=null;try{I=(await $.Promises.read(r,n,a,p,A)).bytesRead}catch(E){throw this.fb(E)}finally{this.$(r,A,I)}return I}Z(r,i){return i===this.U.get(r)?null:i}$(r,i,n){const a=this.U.get(r);typeof a=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(r,a+n):this.U.delete(r)))}async write(r,i,n,a,p){return(0,s.$ph)(()=>this.ab(r,i,n,a,p),100,3)}async ab(r,i,n,a,p){const A=this.Z(r,i);let I=null;try{I=(await $.Promises.write(r,n,a,p,A)).bytesWritten}catch(E){throw await this.gb(this.X.get(r),E)}finally{this.$(r,A,I)}return I}async mkdir(r){try{await $.Promises.mkdir(this.H(r))}catch(i){throw this.fb(i)}}async delete(r,i){try{const n=this.H(r);if(i.recursive){let a;i?.atomic!==!1&&i.atomic.postfix&&(a=(0,b.$jc)((0,b.$mc)(n),`${(0,b.$nc)(n)}${i.atomic.postfix}`)),await $.Promises.rm(n,$.RimRafMode.MOVE,a)}else try{await $.Promises.unlink(n)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let p=!1;try{const{stat:A,symbolicLink:I}=await $.SymlinkSupport.stat(n);p=A.isDirectory()&&!I}catch{}if(p)await $.Promises.rmdir(n);else throw a}else throw a}}catch(n){throw this.fb(n)}}async rename(r,i,n){const a=this.H(r),p=this.H(i);if(a!==p)try{await this.bb(r,i,"move",n.overwrite),await $.Promises.rename(a,p)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,w.localize)(2,null,(0,b.$nc)(a),(0,b.$nc)((0,b.$mc)(p)),A.toString()))),this.fb(A)}}async copy(r,i,n){const a=this.H(r),p=this.H(i);if(a!==p)try{await this.bb(r,i,"copy",n.overwrite),await $.Promises.copy(a,p,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,w.localize)(3,null,(0,b.$nc)(a),(0,b.$nc)((0,b.$mc)(p)),A.toString()))),this.fb(A)}}async bb(r,i,n,a){const p=this.H(r),A=this.H(i);let I=!1;if(!!(this.capabilities&1024)||(I=(0,g.$8f)(p,A,!0)),I){if(n==="copy")throw(0,k.$Fk)((0,w.localize)(4,null),k.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const C=await this.L(r);if(!C)throw(0,k.$Fk)((0,w.localize)(5,null),k.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(i);if(j){if(!a)throw(0,k.$Fk)((0,w.localize)(6,null),k.FileSystemProviderErrorCode.FileExists);C.type&k.FileType.File&&j.type&k.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.cb(r,i,!1)}async cb(r,i,n){const a=this.H(r),p=this.H(i),A=!!(this.capabilities&1024);if((0,g.$8f)(a,p,!A))return;const I=new l.$Sc;try{I.add(await this.O(r)),I.add(await this.O(i)),n&&await $.Promises.mkdir((0,b.$mc)(p),{recursive:!0}),await $.Promises.copyFile(a,p)}catch(E){if(E.code==="ENOENT"&&!n)return this.cb(r,i,!0);throw this.fb(E)}finally{I.dispose()}}t(r,i,n){return new m.$uq(a=>r(a),a=>i(a),n)}F(r,i,n){return new c.$Cq(a=>r(a),a=>i(a),n)}fb(r){if(r instanceof k.$Ek)return r;let i=r,n;switch(r.code){case"ENOENT":n=k.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=k.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=k.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=k.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=k.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=k.FileSystemProviderErrorCode.Unknown;break;default:n=k.FileSystemProviderErrorCode.Unknown}return(0,k.$Fk)(i,n)}async gb(r,i){let n=this.fb(i);if(r&&n.code===k.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await $.SymlinkSupport.stat(this.H(r));a.mode&128||(n=(0,k.$Fk)(i,k.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return n}}e.$Dq=t}),define(ae[223],ce([0,1,3,93,2,17,63,23]),function(X,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=void 0;class g extends s.$Tc{constructor(v,y){super(),this.a=v,this.b=y,this.F=new Map,this.G=new Map}call(v,y,u){const $=this.c(v);switch(y){case"stat":return this.g($,u[0]);case"readdir":return this.h($,u[0]);case"open":return this.r($,u[0],u[1]);case"close":return this.s(u[0]);case"read":return this.t(u[0],u[1],u[2]);case"readFile":return this.j($,u[0],u[1]);case"write":return this.u(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.n($,u[0],u[1],u[2]);case"rename":return this.z($,u[0],u[1],u[2]);case"copy":return this.C($,u[0],u[1],u[2]);case"cloneFile":return this.D($,u[0],u[1]);case"mkdir":return this.w($,u[0]);case"delete":return this.y($,u[0],u[1]);case"watch":return this.I($,u[0],u[1],u[2],u[3]);case"unwatch":return this.J(u[0],u[1])}throw new Error(`IPC Command ${y} not found`)}listen(v,y,u){const $=this.c(v);switch(y){case"fileChange":return this.H($,u[0]);case"readFileStream":return this.m($,u[0],u[1])}throw new Error(`Unknown event ${y}`)}g(v,y){const u=this.f(v,y,!0);return this.a.stat(u)}h(v,y){const u=this.f(v,y);return this.a.readdir(u)}async j(v,y,u){const $=this.f(v,y,!0),w=await this.a.readFile($,u);return M.$ke.wrap(w)}m(v,y,u){const $=this.f(v,y,!0),w=new P.$7d,k=new S.$Wd({onDidRemoveLastListener:()=>{w.cancel()}}),h=this.a.readFileStream($,u,w.token);return(0,D.$ce)(h,{onData:f=>k.fire(M.$ke.wrap(f)),onError:f=>k.fire(f),onEnd:()=>{k.fire("end"),k.dispose(),w.dispose()}}),k.event}n(v,y,u,$){const w=this.f(v,y);return this.a.writeFile(w,u.buffer,$)}r(v,y,u){const $=this.f(v,y,!0);return this.a.open($,u)}s(v){return this.a.close(v)}async t(v,y,u){const $=M.$ke.alloc(u),k=await this.a.read(v,y,$.buffer,0,u);return[$,k]}u(v,y,u,$,w){return this.a.write(v,y,u.buffer,$,w)}w(v,y){const u=this.f(v,y);return this.a.mkdir(u)}y(v,y,u){const $=this.f(v,y);return this.a.delete($,u)}z(v,y,u,$){const w=this.f(v,y),k=this.f(v,u);return this.a.rename(w,k,$)}C(v,y,u,$){const w=this.f(v,y),k=this.f(v,u);return this.a.copy(w,k,$)}D(v,y,u){const $=this.f(v,y),w=this.f(v,u);return this.a.cloneFile($,w)}H(v,y){const u=new S.$Wd({onWillAddFirstListener:()=>{this.F.set(y,this.L(v,u))},onDidRemoveLastListener:()=>{(0,s.$Oc)(this.F.get(y)),this.F.delete(y)}});return u.event}async I(v,y,u,$,w){const k=this.F.get(y);if(k){const h=this.f(v,$),f=k.watch(u,h,w);this.G.set(y+u,f)}}async J(v,y){const u=v+y,$=this.G.get(u);$&&((0,s.$Oc)($),this.G.delete(u))}dispose(){super.dispose();for(const[,v]of this.G)v.dispose();this.G.clear();for(const[,v]of this.F)v.dispose();this.F.clear()}}e.$as=g;class l extends s.$Tc{constructor(v,y,u,$){super(),this.c=v,this.f=u,this.g=$,this.a=new Map,this.b=this.B(new R.$Dq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(y)}h(v){const y=this.B(new S.$Wd);this.B(y.event(u=>{v.fire(u.map($=>({resource:this.c.transformOutgoingURI($.resource),type:$.type,cId:$.cId})))})),this.B(this.b.onDidChangeFile(u=>y.fire(u))),this.B(this.b.onDidWatchError(u=>v.fire(u)))}j(v){}m(v){}watch(v,y,u){const $=this.m(this.g);return Array.isArray($)&&(u.excludes=[...u.excludes,...$]),this.a.set(v,this.b.watch(y,u)),(0,s.$Rc)(()=>{(0,s.$Oc)(this.a.get(v)),this.a.delete(v)})}dispose(){for(const[,v]of this.a)v.dispose();this.a.clear(),super.dispose()}}e.$bs=l}),define(ae[224],ce([0,1,15,178,4,7,16,9,223,155]),function(X,e,S,R,s,M,D,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N0b=void 0;class b extends g.$as{constructor(u,$,w){super(u,$),this.M=w}c(u){return l.$8m}f(u,$){return M.URI.revive($)}async y(u,$,w){if(!w.useTrash)return super.y(u,$,w);const k=this.f(u,$),h=(0,P.$hc)(k.fsPath);try{await S.shell.trashItem(h)}catch{throw(0,D.$Fk)(s.$i?(0,R.localize)(0,null,(0,P.$nc)(h)):(0,R.localize)(1,null,(0,P.$nc)(h)),D.FileSystemProviderErrorCode.Unknown)}}L(u,$){return new v(u,$,this.b,this.M)}}e.$N0b=b;class v extends g.$bs{watch(u,$,w){if(w.recursive)throw(0,D.$Fk)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(u,$,w)}}}),define(ae[225],ce([0,1,5]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E7b=void 0;class R extends S.$vj{constructor(M=S.$sj){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(D=>{this.n?.setLevel(D)}))}set logger(M){this.n=M;for(const{level:D,message:P}of this.m)(0,S.log)(M,D,P);this.m=[]}g(M,D){this.n?(0,S.log)(this.n,M,D):this.getLevel()<=M&&this.m.push({level:M,message:D})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$E7b=R}),define(ae[226],ce([0,1,7,3,5,2]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=e.$Dr=e.$Cr=void 0;class D extends s.$Aj{constructor(v,y,u,$,w){super(y,u,$),this.r=v,this.t=w,this.B(w.listen("onDidChangeLogLevel",v)(k=>{(0,s.$rj)(k)?super.setLogLevel(k):super.setLogLevel(S.URI.revive(k[0]),k[1])})),this.B(w.listen("onDidChangeVisibility",v)(([k,h])=>super.setVisibility(S.URI.revive(k),h))),this.B(w.listen("onDidChangeLoggers",v)(({added:k,removed:h})=>{for(const f of k)super.registerLogger({...f,resource:S.URI.revive(f.resource)});for(const f of h)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new s.$yj({log:(v,y)=>{this.t.call("consoleLog",[v,y])}})}registerLogger(v){super.registerLogger(v),this.t.call("registerLogger",[v,this.r])}deregisterLogger(v){super.deregisterLogger(v),this.t.call("deregisterLogger",[v,this.r])}setLogLevel(v,y){super.setLogLevel(v,y),this.t.call("setLogLevel",[v,y])}setVisibility(v,y){super.setVisibility(v,y),this.t.call("setVisibility",[this.n(v),y])}s(v,y,u){return new P(this.t,v,y,u,this.r)}static setLogLevel(v,y,u){return v.call("setLogLevel",[y,u])}}e.$Cr=D;class P extends s.$vj{constructor(v,y,u,$,w){super($?.logLevel==="always"),this.r=v,this.s=y,this.m=!1,this.n=[],this.setLevel(u),this.r.call("createLogger",[y,$,w]).then(()=>{this.u(this.n),this.m=!0})}g(v,y){const u=[[v,y]];this.m?this.u(u):this.n.push(...u)}u(v){this.r.call("log",[this.s,v])}}class g{constructor(v,y){this.a=v,this.b=y}listen(v,y){const u=this.b(v);switch(y){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(w=>this.c(w,u)),removed:[...$.removed].map(w=>this.c(w,u))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,$=>[u.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,$=>(0,s.$rj)($)?$:[u.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${y}`)}async call(v,y,u){const $=this.b(v);switch(y){case"setLogLevel":return(0,s.$rj)(u[0])?this.a.setLogLevel(u[0]):this.a.setLogLevel(S.URI.revive($.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,$)))}throw new Error(`Call not found: ${y}`)}c(v,y){return{...v,resource:y.transformOutgoingURI(v.resource)}}}e.$Dr=g;class l extends M.$Tc{constructor(v,y){super(),y.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(u=>y.call("setLogLevel",[u]))),y.call("getRegisteredLoggers").then(u=>{for(const $ of u)v.registerLogger({...$,resource:S.URI.revive($.resource)})}),this.B(y.listen("onDidChangeVisibility")(([u,$])=>v.setVisibility(S.URI.revive(u),$))),this.B(y.listen("onDidChangeLoggers")(({added:u,removed:$})=>{for(const w of u)v.registerLogger({...w,resource:S.URI.revive(w.resource)});for(const w of $)v.deregisterLogger(w.resource)}))}}e.$Er=l}),define(ae[227],ce([0,1,2,5]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=void 0;class s extends S.$Tc{constructor(D,P=[]){super(),this.a=new R.$zj([D,...P]),this.B(D.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...P){this.a.trace(D,...P)}debug(D,...P){this.a.debug(D,...P)}info(D,...P){this.a.info(D,...P)}warn(D,...P){this.a.warn(D,...P)}error(D,...P){this.a.error(D,...P)}flush(){this.a.flush()}}e.$LO=s}),define(ae[228],ce([0,1,31,7,5]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J$b=void 0;class M{constructor(P){this.b=P,this.a=new S.$Ac}listen(P,g,l){switch(g){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${g}`)}async call(P,g,l){switch(g){case"createLogger":this.c(R.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(R.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,s.$rj)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(R.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(R.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:R.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(R.URI.revive(l[0]))}throw new Error(`Call not found: ${g}`)}c(P,g,l){this.a.set(P,this.b.createLogger(P,g,l))}d(P,g){let l=console.log;switch(P){case s.LogLevel.Error:l=console.error;break;case s.LogLevel.Warning:l=console.warn;break;case s.LogLevel.Info:l=console.info;break}l.call(console,...g)}e(P,g){const l=this.a.get(P);if(!l)throw new Error("Create the logger before logging");for(const[b,v]of g)(0,s.log)(l,b,v)}}e.$J$b=M}),define(ae[229],ce([0,1,16,5]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=void 0;var s;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(s||(s={}));async function M(l,b,v,y,u){try{const $=await new Promise((k,h)=>{X(["@vscode/spdlog"],k,h)});$.setFlushOn(s.Trace);const w=await $.createAsyncRotatingLogger(l,b,v,y);return u?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch($){console.error($)}return null}function D(l,b,v){switch(b){case R.LogLevel.Trace:l.trace(v);break;case R.LogLevel.Debug:l.debug(v);break;case R.LogLevel.Info:l.info(v);break;case R.LogLevel.Warning:l.warn(v);break;case R.LogLevel.Error:l.error(v);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function P(l,b){switch(b){case R.LogLevel.Trace:l.setLevel(s.Trace);break;case R.LogLevel.Debug:l.setLevel(s.Debug);break;case R.LogLevel.Info:l.setLevel(s.Info);break;case R.LogLevel.Warning:l.setLevel(s.Warning);break;case R.LogLevel.Error:l.setLevel(s.Error);break;case R.LogLevel.Off:l.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class g extends R.$vj{constructor(b,v,y,u,$){super(),this.m=[],this.setLevel($),this.n=this.s(b,v,y,u),this.B(this.onDidChangeLogLevel(w=>{this.r&&P(this.r,w)}))}async s(b,v,y,u){const $=y?6:1,w=30/$*S.$1k.MB,k=await M(b,v,w,$,u);if(k){this.r=k,P(this.r,this.getLevel());for(const{level:h,message:f}of this.m)D(this.r,h,f);this.m=[]}}g(b,v){this.r?D(this.r,b,v):this.getLevel()<=b&&this.m.push({level:b,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$AO=g}),define(ae[230],ce([0,1,32,5,229]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=void 0;class M extends R.$Aj{s(P,g,l){return new s.$AO((0,S.$rg)(),P.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,g)}}e.$BO=M}),define(ae[68],ce([0,1,31,3,6,5,230]),function(X,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j0b=e.$i0b=void 0,e.$i0b=(0,s.$9h)(M.$qj);class P extends D.$BO{constructor(){super(...arguments),this.u=new S.$Ac}createLogger(l,b,v){v!==void 0&&this.u.set(this.n(l),v);try{return super.createLogger(l,b)}catch(y){throw this.u.delete(this.n(l)),y}}registerLogger(l,b){b!==void 0&&this.u.set(l.resource,b),super.registerLogger(l)}deregisterLogger(l){this.u.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const b=[];for(const v of super.getRegisteredLoggers())l===this.u.get(v.resource)&&b.push(v);return b}getOnDidChangeLogLevelEvent(l){return R.Event.filter(this.onDidChangeLogLevel,b=>(0,M.$rj)(b)||this.w(b[0],l))}getOnDidChangeVisibilityEvent(l){return R.Event.filter(this.onDidChangeVisibility,([b])=>this.w(b,l))}getOnDidChangeLoggersEvent(l){return R.Event.filter(R.Event.map(this.onDidChangeLoggers,b=>({added:[...b.added].filter(y=>this.w(y.resource,l)),removed:[...b.removed].filter(y=>this.w(y.resource,l))})),b=>b.added.length>0||b.removed.length>0)}deregisterLoggers(l){for(const[b,v]of this.u)v===l&&this.deregisterLogger(b)}w(l,b){const v=this.u.get(l);return v===void 0||v===b}dispose(){super.dispose(),this.u.clear()}}e.$j0b=P}),define(ae[231],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$50b=e.$40b=e.$30b=e.$20b=void 0;function S(D){return D.submenu!==void 0}e.$20b=S;function R(D){return D.id==="vscode.menubar.separator"}e.$30b=R;function s(D){return D.uri!==void 0}e.$40b=s;function M(D){return!S(D)&&!R(D)&&!s(D)}e.$50b=M}),define(ae[39],ce([0,1,3,71,2,6]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=void 0,e.$Mn=(0,M.$8h)("policy");class D extends s.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$Wd),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const b=Object.keys(this.f).length;return this.f={...l,...this.f},b!==Object.keys(this.f).length&&await this.j(l),R.Iterable.reduce(this.g.entries(),(v,[y,u])=>({...v,[y]:u}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(l,[b,v])=>({...l,[b]:{definition:v,value:this.g.get(b)}}),{})}}e.$Nn=D;class P{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$On=P}),define(ae[232],ce([0,1,8,3,71,12,16,5,39]),function(X,e,S,R,s,M,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3$b=void 0;function l(v,y){const u=[];for(const $ of new Set(s.Iterable.concat(v.keys(),y.keys())))v.get($)!==y.get($)&&u.push($);return u}let b=class extends g.$Nn{constructor(y,u,$){super(),this.m=y,this.n=u,this.s=$,this.c=this.B(new S.$6g(500));const w=R.Event.filter(u.onDidFilesChange,k=>k.affects(y));this.B(u.watch(y)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const u=await this.n.readFile(this.m),$=JSON.parse(u.value.toString());if(!(0,M.$Lf)($))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys($))this.f[w]&&y.set(w,$[w])}catch(u){u.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",u)}return y}async w(){const y=await this.u(),u=l(this.g,y);this.g=y,u.length>0&&this.h.fire(u)}};e.$3$b=b,e.$3$b=b=ve([re(1,D.$sk),re(2,P.$pj)],b)}),define(ae[233],ce([0,1,3,2,39]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B$b=e.$A$b=void 0;class M{constructor(g){this.b=g,this.a=new R.$Sc}listen(g,l){switch(l){case"onDidChange":return S.Event.map(this.b.onDidChange,b=>b.reduce((v,y)=>({...v,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(g,l,b){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(b)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.$A$b=M;class D extends s.$Nn{constructor(g,l){super(),this.a=l;for(const b in g){const{definition:v,value:y}=g[b];this.f[b]=v,y!==void 0&&this.g.set(b,y)}this.a.listen("onDidChange")(b=>{for(const v in b){const y=b[v];y===null?this.g.delete(v):this.g.set(v,y)}this.h.fire(Object.keys(b))})}async j(g){const l=await this.a.call("updatePolicyDefinitions",g);for(const b in l)this.g.set(b,l[b])}}e.$B$b=D}),define(ae[234],ce([0,1,39,8,2,5]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2$b=void 0;let D=class extends S.$Nn{constructor(g,l){super(),this.m=g,this.n=l,this.a=new R.$2g,this.b=this.B(new s.$Uc)}async j(g){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(g).length} policy definitions`);const{createWatcher:l}=await new Promise((b,v)=>{X(["@vscode/policy-watcher"],b,v)});await this.a.queue(()=>new Promise((b,v)=>{try{this.b.value=l(this.n,g,y=>{this.t(y),b()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),v(y)}}))}t(g){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(g)}`);for(const l in g){const b=g[l];b===void 0?this.g.delete(l):this.g.set(l,b)}this.h.fire(Object.keys(g))}};e.$2$b=D,e.$2$b=D=ve([re(0,M.$pj)],D)}),define(ae[79],ce([0,1,36]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.context<"u"){const M=s.context.configuration();if(M)R=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(R=globalThis._VSCODE_PRODUCT_JSON,S.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`,serverDataFolderName:R.serverDataFolderName?`${R.serverDataFolderName}-dev`:void 0}),!R.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(R,{version:M.version})}}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=R}),define(ae[27],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=void 0,e.$Hj=(0,S.$8h)("productService"),e.$Ij="vscode://schemas/vscode-product"}),define(ae[235],ce([0,1,8,5]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q0b=void 0;let s=class{constructor(D,P,g){this.a=D,this.b=P,this.c=g}async inspect(D){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.$9g)(D);const g=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),g.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.$Q0b=s,e.$Q0b=s=ve([re(2,R.$pj)],s)}),define(ae[80],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$49b=void 0,e.$49b=(0,S.$8h)("protocolMainService")}),define(ae[44],ce([0,1,138,12]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class s{constructor(){this.a=new Map}add(D,P){S.ok(R.$Jf(D)),S.ok(R.$Lf(P)),S.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,P)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$Kn=new s}),define(ae[236],ce([0,1,3,44]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0,e.$Ln={JSONContribution:"base.contributions.json"};function s(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class M{constructor(){this.b=new S.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,l){this.a[s(g)]=l,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const D=new M;R.$Kn.add(e.$Ln.JSONContribution,D)}),define(ae[52],ce([0,1,22,3,12,163,18,236,44]),function(X,e,S,R,s,M,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ConfigurationScope=e.$Pn=e.EditPresentationTypes=void 0;var l;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$Pn={Configuration:"base.contributions.configuration"};var b;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b||(e.ConfigurationScope=b={})),e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn={properties:{},patternProperties:{}},e.$Wn="vscode://schemas/settings/resourceLanguage",e.$Xn="vscode://schemas/settings/configurationDefaults";const v=g.$Kn.as(P.$Ln.JSONContribution);class y{constructor(){this.h=new Set,this.i=new R.$Wd,this.onDidSchemaChange=this.i.event,this.j=new R.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$Wn,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),v.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),v.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),v.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:i,source:n}of t)for(const a in i)if(o.add(a),e.$Zn.test(a)){const p=this.a.get(a),A=p?.valuesSources??new Map;if(n)for(const j of Object.keys(i[a]))A.set(j,n);const I={...p?.value||{},...i[a]};this.a.set(a,{source:n,value:I,valuesSources:A});const E=(0,D.$Li)(a),C={type:"object",default:I,description:M.localize(1,null,E),$ref:e.$Wn,defaultDefaultValue:I,source:s.$Jf(n)?void 0:n,defaultValueSource:n};r.push(...w(a)),this.d[a]=C,this.b.properties[a]=C}else{this.a.set(a,{value:i[a],source:n});const p=this.d[a];p&&(this.w(a,p),this.r(a,p))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:i}of t)for(const n in r){const a=this.a.get(n),p=s.$Jf(i)?i:i?.id,A=s.$Jf(a?.source)?a?.source:a?.source?.id;if(p===A)if(o.add(n),this.a.delete(n),e.$Zn.test(n))delete this.d[n],delete this.b.properties[n];else{const I=this.d[n];I&&(this.w(n,I),this.r(n,I))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,o){const r=i=>{if(i.properties)for(const n in i.properties){o.add(n);const a=this.d[n];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,o=!0,r,i,n=3,a){n=s.$Sf(t.scope)?n:t.scope;const p=t.properties;if(p)for(const I in p){const E=p[I];if(o&&d(I,E)){delete p[I];continue}if(E.source=r,E.defaultDefaultValue=p[I].default,this.w(I,E),e.$Zn.test(I)?E.scope=void 0:(E.scope=s.$Sf(E.scope)?n:E.scope,E.restricted=s.$Sf(E.restricted)?!!i?.includes(I):E.restricted),p[I].hasOwnProperty("included")&&!p[I].included){this.f[I]=p[I],delete p[I];continue}else this.d[I]=p[I],p[I].policy?.name&&this.e.set(p[I].policy.name,I);!p[I].deprecationMessage&&p[I].markdownDeprecationMessage&&(p[I].deprecationMessage=p[I].markdownDeprecationMessage),a.add(I)}const A=t.allOf;if(A)for(const I of A)this.p(I,o,r,i,n,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const i=r.properties;if(i)for(const a in i)this.r(a,i[a]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$Qn.properties[t]=o,o.scope){case 1:e.$Rn.properties[t]=o;break;case 2:e.$Sn.properties[t]=o;break;case 6:e.$Tn.properties[t]=o;break;case 3:e.$Un.properties[t]=o;break;case 4:e.$Vn.properties[t]=o;break;case 5:e.$Vn.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$Qn.properties[t],o.scope){case 1:delete e.$Rn.properties[t];break;case 2:delete e.$Sn.properties[t];break;case 6:delete e.$Tn.properties[t];break;case 3:delete e.$Un.properties[t];break;case 4:case 5:delete e.$Vn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$Wn};this.w(o,r),e.$Qn.properties[o]=r,e.$Rn.properties[o]=r,e.$Sn.properties[o]=r,e.$Tn.properties[o]=r,e.$Un.properties[o]=r,e.$Vn.properties[o]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$Wn};e.$Qn.patternProperties[e.$Yn]=t,e.$Rn.patternProperties[e.$Yn]=t,e.$Sn.patternProperties[e.$Yn]=t,e.$Tn.patternProperties[e.$Yn]=t,e.$Un.patternProperties[e.$Yn]=t,e.$Vn.patternProperties[e.$Yn]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$Qf(i)&&(i=o.defaultDefaultValue,n=void 0),s.$Qf(i)&&(i=h(o.type)),o.default=i,o.defaultValueSource=n}}const u="\\[([^\\]]+)\\]",$=new RegExp(u,"g");e.$Yn=`^(${u})+$`,e.$Zn=new RegExp(e.$Yn);function w(c){const t=[];if(e.$Zn.test(c)){let o=$.exec(c);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=$.exec(c)}}return(0,S.$Mb)(t)}e.$1n=w;function k(c){return c.reduce((t,o)=>`${t}[${o}]`,"")}e.$2n=k;function h(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$3n=h;const f=new y;g.$Kn.add(e.$Pn.Configuration,f);function d(c,t){return c.trim()?e.$Zn.test(c)?M.localize(7,null,c):f.getConfigurationProperties()[c]!==void 0?M.localize(8,null,c):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,c,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$4n=d;function m(){const c=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))c.push([o,t[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.$5n=m}),define(ae[120],ce([0,1,22,3,42,2,31,35,12,7,18,52,44]),function(X,e,S,R,s,M,D,P,g,l,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=void 0;function u(o){return Object.isFrozen(o)?o:P.$zn(o)}class ${constructor(r={},i=[],n=[],a){this.b=r,this.c=i,this.d=n,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof $)return i;const n=new w("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,b.$Ji)(this.contents,r):this.contents}inspect(r,i){const n=this;return{get value(){return u(n.rawConfiguration.getValue(r))},get override(){return i?u(n.rawConfiguration.getOverrideValue(r,i)):void 0},get merged(){return u(i?n.rawConfiguration.override(i).getValue(r):n.rawConfiguration.getValue(r))},get overrides(){const a=[];for(const{contents:p,identifiers:A,keys:I}of n.rawConfiguration.overrides){const E=new $(p,I).getValue(r);E!==void 0&&a.push({identifiers:A,value:E})}return a.length?u(a):void 0}}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,b.$Ji)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return S.$Mb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return S.$Mb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=P.$yn(this.contents),n=P.$yn(this.overrides),a=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const A of r)if(p.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.h(i,A.contents);for(const I of A.overrides){const[E]=n.filter(C=>S.$ub(C.identifiers,I.identifiers));E?(this.h(E.contents,I.contents),E.keys.push(...I.keys),E.keys=S.$Mb(E.keys)):n.push(P.$yn(I))}for(const I of A.keys)a.indexOf(I)===-1&&a.push(I)}return new $(i,a,n,p.every(A=>A instanceof $)?void 0:p)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const a of S.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let p=this.contents[a];const A=i[a];A&&(typeof p=="object"&&typeof A=="object"?(p=P.$yn(p),this.h(p,A)):p=A),n[a]=p}return new $(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&g.$Lf(r[n])&&g.$Lf(i[n])){this.h(r[n],i[n]);continue}r[n]=P.$yn(i[n])}}i(r){let i=null,n=null;const a=p=>{p&&(n?this.h(n,p):n=P.$yn(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===r?i=p.contents:p.identifiers.includes(r)&&a(p.contents);return a(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,b.$Ii)(this.contents,r),v.$Zn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>S.$ub(n.identifiers,(0,v.$1n)(r))),1))}j(r,i,n){(0,b.$Hi)(this.contents,r,i,a=>console.error(a)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),v.$Zn.test(r)&&this.overrides.push({identifiers:(0,v.$1n)(r),keys:Object.keys(this.contents[r]),contents:(0,b.$Gi)(this.contents[r],a=>console.error(a))})}}e.$6n=$;class w{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!g.$Sf(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:a,overrides:p,restricted:A,hasExcludedProperties:I}=this.h(r,i);this.b=new $(n,a,p,I?[r]:void 0),this.c=A||[]}g(r){let i={},n=null,a=[];const p=[],A=[];function I(C){Array.isArray(a)?a.push(C):n!==null&&(a[n]=C)}const E={onObjectBegin:()=>{const C={};I(C),p.push(a),a=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{a=p.pop()},onArrayBegin:()=>{const C=[];I(C),p.push(a),a=C,n=null},onArrayEnd:()=>{a=p.pop()},onLiteralValue:I,onError:(C,j,U)=>{A.push({error:C,offset:j,length:U})}};if(r)try{s.$mn(r,E),i=a[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return i}h(r,i){const n=y.$Kn.as(v.$Pn.Configuration).getConfigurationProperties(),a=this.i(r,n,!0,i);r=a.raw;const p=(0,b.$Gi)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),A=Object.keys(r),I=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:p,keys:A,overrides:I,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(r,i,n,a){let p=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:p};const A={},I=[];for(const E in r)if(v.$Zn.test(E)&&n){const C=this.i(r[E],i,!1,a);A[E]=C.raw,p=p||C.hasExcludedProperties,I.push(...C.restricted)}else{const C=i[E],j=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&I.push(E),!a.exclude?.includes(E)&&(a.include?.includes(E)||(j===void 0||a.scopes===void 0||a.scopes.includes(j))&&!(a.skipRestricted&&C?.restricted))?A[E]=r[E]:p=!0}return{raw:A,restricted:I,hasExcludedProperties:p}}j(r,i){const n=[];for(const a of Object.keys(r))if(v.$Zn.test(a)){const p={};for(const A in r[a])p[A]=r[a][A];n.push({identifiers:(0,v.$1n)(a),keys:Object.keys(p),contents:(0,b.$Gi)(p,i)})}return n}}e.$7n=w;class k extends M.$Tc{constructor(r,i,n,a){super(),this.c=r,this.f=i,this.g=a,this.b=this.B(new R.$Wd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&n.isEqual(p.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$8n=k;class h{constructor(r,i,n,a,p,A,I,E,C,j,U,F,V){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=a,this.d=p,this.f=A,this.g=I,this.h=E,this.i=C,this.j=j,this.k=U,this.l=F,this.m=V}get value(){return u(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class f{constructor(r,i,n,a,p=new $,A=new $,I=new D.$Ac,E=new $,C=new D.$Ac){this.c=r,this.d=i,this.f=n,this.g=a,this.h=p,this.i=A,this.j=I,this.l=E,this.m=C,this.a=null,this.b=new D.$Ac,this.n=null}getValue(r,i,n){return this.p(r,i,n).getValue(r)}updateValue(r,i,n={}){let a;n.resource?(a=this.m.get(n.resource),a||(a=new $,this.m.set(n.resource,a))):a=this.l,i===void 0?a.removeValue(r):a.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const a=this.p(r,i,n),p=this.t(i.resource,n),A=i.resource?this.m.get(i.resource)||this.l:this.l,I=new Set;for(const E of a.overrides)for(const C of E.identifiers)a.getOverrideValue(r,C)!==void 0&&I.add(C);return new h(r,i,a.getValue(r),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,p||void 0,A)}keys(r){const i=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:a,updated:p,removed:A}=c(this.c,r);i=[...a,...p,...A]}for(const a of i)for(const p of(0,v.$1n)(a)){const A=this.c.getKeysForOverrideIdentifier(p),I=r.getKeysForOverrideIdentifier(p),E=[...I.filter(C=>A.indexOf(C)===-1),...A.filter(C=>I.indexOf(C)===-1),...A.filter(C=>!P.$Cn(this.c.override(p).getValue(C),r.override(p).getValue(C)))];n.push([p,E])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:a}=c(this.d,r),p=[...i,...n,...a];return p.length&&this.updatePolicyConfiguration(r),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:a,overrides:p}=c(this.applicationConfiguration,r),A=[...i,...n,...a];return A.length&&this.updateApplicationConfiguration(r),{keys:A,overrides:p}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:a,overrides:p}=c(this.localUserConfiguration,r),A=[...i,...n,...a];return A.length&&this.updateLocalUserConfiguration(r),{keys:A,overrides:p}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:a,overrides:p}=c(this.remoteUserConfiguration,r),A=[...i,...n,...a];return A.length&&this.updateRemoteUserConfiguration(r),{keys:A,overrides:p}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:a,overrides:p}=c(this.workspaceConfiguration,r),A=[...i,...n,...a];return A.length&&this.updateWorkspaceConfiguration(r),{keys:A,overrides:p}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:a,updated:p,removed:A,overrides:I}=c(n,i),E=[...a,...p,...A];return(E.length||!n)&&this.updateFolderConfiguration(r,i),{keys:E,overrides:I}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:a,removed:p,overrides:A}=c(i,void 0);return{keys:[...n,...a,...p],overrides:A}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,i,n){let a=this.q(i,n);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(a=a.merge(this.d)),a}q({resource:r},i){let n=this.r();if(i&&r){const a=i.getFolder(r);a&&(n=this.s(a.uri)||n);const p=this.m.get(r);p&&(n=n.merge(p))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let i=this.b.get(r);if(!i){const n=this.r(),a=this.j.get(r);a?(i=n.merge(a),this.b.set(r,i)):i=n}return i}t(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:a,keys:p}=this.j.get(i);return r.push([i,{contents:n,overrides:a,keys:p}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}v(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a))),[...i.values()]}static parse(r){const i=this.w(r.defaults),n=this.w(r.policy),a=this.w(r.application),p=this.w(r.user),A=this.w(r.workspace),I=r.folders.reduce((E,C)=>(E.set(l.URI.revive(C[0]),this.w(C[1])),E),new D.$Ac);return new f(i,n,a,p,new $,A,I,new $,new D.$Ac)}static w(r){return new $(r.contents,r.keys,r.overrides)}}e.$9n=f;function d(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,i=new Map;for(const a of o)a.keys.forEach(p=>r.add(p)),a.overrides.forEach(([p,A])=>{const I=(0,D.$xc)(i,p,new Set);A.forEach(E=>I.add(E))});const n=[];return i.forEach((a,p)=>n.push([p,[...a.values()]])),{keys:[...r.values()],overrides:n}}e.$0n=d;class m{constructor(r,i,n,a){this.change=r,this.f=i,this.g=n,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const p of r.keys)this.affectedKeys.add(p);for(const[,p]of r.overrides)for(const A of p)this.affectedKeys.add(A);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,a=this.d.indexOf(n);if(a<0)return!1;const p=a+n.length;if(p>=this.d.length)return!1;const A=this.d.charCodeAt(p);if(A!==this.b&&A!==this.c)return!1;if(i){const I=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,E=this.g.getValue(r,i,this.h);return!P.$Cn(I,E)}return!0}}e.$$n=m;function c(o,r){const{added:i,removed:n,updated:a}=t(r?.rawConfiguration,o?.rawConfiguration),p=[],A=o?.getAllOverrideIdentifiers()||[],I=r?.getAllOverrideIdentifiers()||[];if(r){const E=I.filter(C=>!A.includes(C));for(const C of E)p.push([C,r.getKeysForOverrideIdentifier(C)])}if(o){const E=A.filter(C=>!I.includes(C));for(const C of E)p.push([C,o.getKeysForOverrideIdentifier(C)])}if(r&&o){for(const E of A)if(I.includes(E)){const C=t({contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});p.push([E,[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:n,updated:a,overrides:p}}function t(o,r){const i=o?r?o.keys.filter(p=>r.keys.indexOf(p)===-1):[...o.keys]:[],n=r?o?r.keys.filter(p=>o.keys.indexOf(p)===-1):[...r.keys]:[],a=[];if(o&&r){for(const p of r.keys)if(o.keys.indexOf(p)!==-1){const A=(0,b.$Ji)(r.contents,p),I=(0,b.$Ji)(o.contents,p);P.$Cn(A,I)||a.push(p)}}return{added:i,removed:n,updated:a}}}),define(ae[237],ce([0,1,22,3,2,35,12,120,52,5,39,44]),function(X,e,S,R,s,M,D,P,g,l,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=void 0;class y extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new R.$Wd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$6n}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.$Kn.as(g.$Pn.Configuration).onDidUpdateConfiguration(({properties:k,defaultsOverrides:h})=>this.c(Array.from(k),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(k,h){this.h(k,v.$Kn.as(g.$Pn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:k})}f(){return{}}g(){this.b=new P.$6n;const k=v.$Kn.as(g.$Pn.Configuration).getConfigurationProperties();this.h(Object.keys(k),k)}h(k,h){const f=this.f();for(const d of k){const m=f[d],c=h[d];m!==void 0?this.b.addValue(d,m):c?this.b.addValue(d,c.default):this.b.removeValue(d)}}}e.$_n=y;class u{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new P.$6n}async initialize(){return this.configurationModel}}e.$ao=u;let $=class extends s.$Tc{get configurationModel(){return this.b}constructor(k,h,f){super(),this.c=k,this.f=h,this.g=f,this.a=this.B(new R.$Wd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$6n}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(k=>this.j(k))),this.B(this.c.onDidChangeConfiguration(async({properties:k})=>this.m(await this.h(k),!0))),this.b}async h(k){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",k);const h={},f=[],d=v.$Kn.as(g.$Pn.Configuration).getConfigurationProperties();for(const m of k){const c=d[m];if(!c){f.push(m);continue}if(c.policy){if(c.type!=="string"&&c.type!=="number"){this.g.warn(`Policy ${c.policy.name} has unsupported type ${c.type}`);continue}f.push(m),h[c.policy.name]={type:c.type}}}return(0,D.$Wf)(h)||await this.f.updatePolicyDefinitions(h),f}j(k){this.g.trace("PolicyConfiguration#onDidChangePolicies",k);const h=v.$Kn.as(g.$Pn.Configuration).getPolicyConfigurations(),f=(0,S.$Hb)(k.map(d=>h.get(d)));this.m(f,!0)}m(k,h){this.g.trace("PolicyConfiguration#update",k);const f=v.$Kn.as(g.$Pn.Configuration).getConfigurationProperties(),d=[],m=this.b.isEmpty();for(const c of k){const t=f[c]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(m?o!==void 0:!(0,M.$Cn)(this.b.getValue(c),o))&&d.push([c,o])}else this.b.getValue(c)!==void 0&&d.push([c,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const c=this.b;this.b=new P.$6n;for(const t of c.keys)this.b.setValue(t,c.getValue(t));for(const[t,o]of d)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);h&&this.a.fire(this.b)}}};e.$bo=$,e.$bo=$=ve([re(1,b.$Mn),re(2,l.$pj)],$)}),define(ae[238],ce([0,1,22,8,17,3,42,101,2,35,4,19,18,120,52,237,39]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class h extends g.$Tc{constructor(m,c,t,o){super(),this.m=m,this.h=this.B(new M.$Wd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.$_n),this.c=t instanceof k.$On?new w.$ao:this.B(new w.$bo(this.b,t,o)),this.f=this.B(new u.$8n(this.m,{},v.$zg,c)),this.a=new u.$9n(this.b.configurationModel,this.c.configurationModel,new u.$6n,new u.$6n),this.j=new f(m,c,this),this.g=this.B(new R.$hh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:i})=>this.r(r,i))),this.B(this.c.onDidChangeConfiguration(r=>this.s(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,c,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new u.$9n(m,c,new u.$6n,t)}getConfigurationData(){return this.a.toData()}getValue(m,c){const t=typeof m=="string"?m:void 0,o=(0,y.$Ci)(m)?m:(0,y.$Ci)(c)?c:{};return this.a.getValue(t,o,void 0)}async updateValue(m,c,t,o,r){const i=(0,y.$Di)(t)?t:(0,y.$Ci)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,n=i?o:t;if(n!==void 0&&n!==3&&n!==2)throw new Error(`Unable to write ${m} to target ${n}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,S.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const a=this.inspect(m,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(a.policyValue!==void 0)throw new Error(`Unable to write ${m} because it is configured in system policy.`);if((0,l.$Cn)(c,a.defaultValue)&&(c=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const A=i.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(E=>(0,S.$ub)([...E.identifiers].sort(),A));I&&(i.overrideIdentifiers=I.identifiers)}const p=i?.overrideIdentifiers?.length?[(0,$.$2n)(i.overrideIdentifiers),m]:[m];await this.j.write(p,c),await this.reloadConfiguration()}inspect(m,c={}){return this.a.inspect(m,c,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.n(m)}n(m){const c=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration(m);this.t(t,c,2)}r(m,c){const t=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(m,c);this.t(o,t,7)}s(m){const c=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration(m);this.t(t,c,7)}t(m,c,t){const o=new u.$$n(m,{data:c},this.a);o.source=t,this.h.fire(o)}}e.$co=h;class f{constructor(m,c,t){this.b=m,this.c=c,this.d=t,this.a=new R.$ch}write(m,c){return this.a.queue(()=>this.e(m,c))}async e(m,c){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)t="{}";else throw i}const o=[];if((0,D.$fn)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const r=this.f(t,m,c);t=(0,P.$xn)(t,r),await this.c.writeFile(this.b,s.$ke.fromString(t))}f(m,c,t){const{tabSize:o,insertSpaces:r,eol:i}=this.h;if(!c.length){const n=JSON.stringify(t,null,r?" ".repeat(o):"	");return[{content:n,length:n.length,offset:0}]}return(0,P.$un)(m,c,t,{tabSize:o,insertSpaces:r,eol:i})}get h(){if(!this.g){let m=b.OS===3||b.OS===2?`
`:`\r
`;const c=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});c&&typeof c=="string"&&c!=="auto"&&(m=c),this.g={eol:m,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ae[239],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q$b=e.$P$b=e.$O$b=void 0,e.$O$b="request",e.$P$b="remoteResourceHandler";class S{async routeCall(s,M,D){if(M!==e.$O$b)throw new Error(`Call not found: ${M}`);const P=D[0];if(P?.authority){const g=s.connections.find(l=>l.ctx===P.authority);if(g)return g}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$Q$b=S}),define(ae[240],ce([0,1,14,6]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.RemoteAuthorityResolverErrorCode=e.$_k=e.$$k=e.RemoteConnectionType=e.$0k=void 0,e.$0k=(0,R.$8h)("remoteAuthorityResolverService");var s;(function(b){b[b.WebSocket=0]="WebSocket",b[b.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(v){this.id=v,this.type=1}toString(){return`Managed(${this.id})`}}e.$$k=M;class D{constructor(v,y){this.host=v,this.port=y,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$_k=D;var P;(function(b){b.Unknown="Unknown",b.NotAvailable="NotAvailable",b.TemporarilyNotAvailable="TemporarilyNotAvailable",b.NoResolverFound="NoResolverFound",b.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class g extends S.$bb{static isNotAvailable(v){return v instanceof g&&v._code===P.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof g&&v._code===P.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof g&&v._code===P.NoResolverFound}static isInvalidAuthority(v){return v instanceof g&&v._code===P.InvalidAuthority}static isHandled(v){return v instanceof g&&v.isHandled}constructor(v,y=P.Unknown,u){super(v),this._message=v,this._code=y,this._detail=u,this.isHandled=y===P.NotAvailable&&u===!0,Object.setPrototypeOf(this,g.prototype)}}e.$al=g;function l(b){const v=b.indexOf("+");return v===-1?b:b.substring(0,v)}e.$bl=l}),define(ae[60],ce([0,1,13]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0;function R(l){return l.scheme===S.Schemas.vscodeRemote?l.authority:void 0}e.$cl=R;function s(l){if(!l)return;const b=l.indexOf("+");return b<0?l:l.substr(0,b)}e.$dl=s;function M(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.$el=M;function D(l){const{host:b,port:v}=g(l);if(typeof v>"u")throw new Error(`Invalid remote authority: ${l}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:b,port:v}}e.$fl=D;function P(l,b){let{host:v,port:y}=g(l);return typeof y>"u"&&(y=b),{host:v,port:y}}e.$gl=P;function g(l){const b=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const v=l.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const y=l.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:l,port:void 0}}}),define(ae[121],ce([0,1,25,6,60]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.TargetPlatform=e.ExtensionType=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=void 0,e.$hm="extensions.user.cache",e.$im="extensions.builtin.cache",e.$jm="undefined_publisher",e.$km=["ui","workspace","web"];function M(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$lm=M,e.$mm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(D||(e.ExtensionType=D={}));var P;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class g{constructor(k){this.value=k,this._lower=k.toLowerCase()}static equals(k,h){if(typeof k>"u"||k===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof k=="string"||typeof h=="string"){const f=typeof k=="string"?k:k.value,d=typeof h=="string"?h:h.value;return S.$af(f,d)}return k._lower===h._lower}static toKey(k){return typeof k=="string"?k.toLowerCase():k._lower}}e.$nm=g;class l{get size(){return this.c.size}constructor(k){if(this.c=new Set,k)for(const h of k)this.add(h)}add(k){this.c.add(g.toKey(k))}delete(k){return this.c.delete(g.toKey(k))}has(k){return this.c.has(g.toKey(k))}}e.$om=l;class b{constructor(){this.c=new Map}clear(){this.c.clear()}delete(k){this.c.delete(g.toKey(k))}get(k){return this.c.get(g.toKey(k))}has(k){return this.c.has(g.toKey(k))}set(k,h){this.c.set(g.toKey(k),h)}values(){return this.c.values()}forEach(k){this.c.forEach(k)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pm=b;function v(w){return y(w)}e.$qm=v;function y(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$rm=y;function u(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$sm=u;function $(w,k){if(k){const h=`onResolveRemoteAuthority:${(0,s.$dl)(k)}`;return!!w.activationEvents?.includes(h)}return!1}e.$tm=$,e.$um=(0,R.$8h)("IBuiltinExtensionsScannerService")}),define(ae[241],ce([0,1,8,17,23,14,3,2,67,72,32,110,240,60]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.PersistentConnectionEventType=e.$nl=e.$ml=e.$ll=e.ConnectionType=void 0;const $=30*1e3;var w;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function k(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(K){const O=new s.$7d;return setTimeout(()=>O.cancel(),K),O.token}function f(K,O){if(K.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const W=new s.$7d;return K.onCancellationRequested(()=>W.cancel()),O.onCancellationRequested(()=>W.cancel()),W.token}class d{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new P.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,S.$1g)(),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function m(K,O){const W=new d(O);return W.registerDisposable(K.onControlMessage(x=>{const T=JSON.parse(x.toString()),Q=L(T);Q?W.reject(Q):W.resolve(T)})),W.promise}function c(K,O,W,x,T,Q,H,_){const z=new d(_),ee=l.$Sd.create(!1);return K.info(`Creating a socket (${H})...`),g.mark(`code/willCreateSocket/${Q}`),O.connect(W,x,T,H).then(se=>{z.didTimeout?(g.mark(`code/didCreateSocketError/${Q}`),K.info(`Creating a socket (${H}) finished after ${ee.elapsed()} ms, but this is too late and has timed out already.`),se?.dispose()):(g.mark(`code/didCreateSocketOK/${Q}`),K.info(`Creating a socket (${H}) was successful after ${ee.elapsed()} ms.`),z.resolve(se))},se=>{g.mark(`code/didCreateSocketError/${Q}`),K.info(`Creating a socket (${H}) returned an error after ${ee.elapsed()} ms.`),K.error(se),z.reject(se)}),z.promise}function t(K,O){const W=new d(O);return K.then(x=>{W.didTimeout||W.resolve(x)},x=>{W.didTimeout||W.reject(x)}),W.promise}async function o(K,O,W,x){const T=te(K,O);K.logService.trace(`${T} 1/6. invoking socketFactory.connect().`);let Q;try{Q=await c(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,u.$el)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,k(O),`renderer-${k(O)}-${K.reconnectionToken}`,x)}catch(se){throw K.logService.error(`${T} socketFactory.connect() failed or timed out. Error:`),K.logService.error(se),se}K.logService.trace(`${T} 2/6. socketFactory.connect() was successful.`);let H,_;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(Q,null),H=K.reconnectionProtocol,_=!1):(H=new v.$Vh({socket:Q}),_=!0),K.logService.trace(`${T} 3/6. sending AuthRequest control message.`);const z=await t(K.signService.createNewMessage((0,b.$rg)()),x),ee={type:"auth",auth:K.connectionToken||"00000000000000000000",data:z.data};H.sendControl(R.$ke.fromString(JSON.stringify(ee)));try{const se=await m(H,f(x,h(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(K.logService.trace(`${T} 4/6. received SignRequest control message.`),!await t(K.signService.validate(z,se.signedData),x)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const me=await t(K.signService.sign(se.data),x),Ee={type:"connectionType",commit:K.commit,signedData:me,desiredConnectionType:O};return W&&(Ee.args=W),K.logService.trace(`${T} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(R.$ke.fromString(JSON.stringify(Ee))),{protocol:H,ownsProtocol:_}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(K.logService.error(`${T} the handshake timed out. Error:`),K.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${T} received error control message when negotiating connection. Error:`),K.logService.error(se)),_&&q(H),se}}async function r(K,O,W,x){const T=Date.now(),Q=te(K,O),{protocol:H,ownsProtocol:_}=await o(K,O,W,x),z=new d(x);return z.registerDisposable(H.onControlMessage(ee=>{const se=JSON.parse(ee.toString()),de=L(se);de?(K.logService.error(`${Q} received error control message when negotiating connection. Error:`),K.logService.error(de),_&&q(H),z.reject(de)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${he(T)}!`),z.resolve({protocol:H,firstMessage:se}))})),z.promise}async function i(K,O){const{protocol:W}=await r(K,1,void 0,O);return{protocol:W}}async function n(K,O,W){const{protocol:x,firstMessage:T}=await r(K,2,O,W),Q=T&&T.debugPort;return{protocol:x,debugPort:Q}}async function a(K,O,W){const x=Date.now(),T=te(K,3),{protocol:Q}=await o(K,3,O,W);return K.logService.trace(`${T} 6/6. handshake finished, connection is up and running after ${he(x)}!`),Q}async function p(K,O,W){const{connectTo:x,connectionToken:T}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:x,connectionToken:T,reconnectionToken:O,reconnectionProtocol:W,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function A(K,O,W){return E(K,async x=>{const{protocol:T}=await i(x,s.CancellationToken.None);return new Z(K,O,W,x.reconnectionToken,T)})}e.$ll=A;async function I(K,O){return E(K,async W=>{const{protocol:x,debugPort:T}=await n(W,O,s.CancellationToken.None);return new Y(K,O,W.reconnectionToken,x,T)})}e.$ml=I;async function E(K,O){for(let x=1;;x++)try{const T=(0,b.$rg)(),Q=await p(K,T,null);return await O(Q)}catch(T){if(x<5)K.logService.error(`[remote-connection][attempt ${x}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(T);else throw K.logService.error(`[remote-connection][attempt ${x}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(T),ue.triggerPermanentFailure(0,0,y.$al.isHandled(T)),T}}async function C(K,O,W){const x=await p(K,(0,b.$rg)(),null);return await a(x,{host:O,port:W},s.CancellationToken.None)}e.$nl=C;function j(K){return(0,S.$Ug)(O=>new Promise((W,x)=>{const T=setTimeout(W,K*1e3);O.onCancellationRequested(()=>{clearTimeout(T),W()})}))}var U;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class F{constructor(O,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.type=0}}e.$ol=F;class V{constructor(O,W,x,T){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.durationSeconds=x,this.c=T,this.type=1}skipWait(){this.c.cancel()}}e.$pl=V;class J{constructor(O,W,x){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.attempt=x,this.type=2}}e.$ql=J;class le{constructor(O,W,x){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.attempt=x,this.type=4}}e.$rl=le;class oe{constructor(O,W,x,T){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.attempt=x,this.handled=T,this.type=3}}e.$sl=oe;class ue extends P.$Tc{static triggerPermanentFailure(O,W,x){this._permanentFailure=!0,this.f=O,this.g=W,this.h=x,this.j.forEach(T=>T.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ue._permanentFailure}constructor(O,W,x,T,Q){super(),this.t=O,this.u=W,this.reconnectionToken=x,this.protocol=T,this.w=Q,this.m=this.B(new D.$Wd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new le(this.reconnectionToken,0,0)),this.B(T.onSocketClose(H=>{const _=B(this.t,this.reconnectionToken,!0);H?H.type===0?(this.u.logService.info(`${_} received socket close event (hadError: ${H.hadError}).`),H.error&&this.u.logService.error(H.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this.u.logService.error(H.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(T.onSocketTimeout(H=>{const _=B(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${H.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${H.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${H.timeSinceLastReceivedSomeData}).`),this.y()})),ue.j.push(this),this.B((0,P.$Rc)(()=>{const H=ue.j.indexOf(this);H>=0&&ue.j.splice(H,1)})),this.n&&this.D(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=B(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let x=-1;do{x++;const T=x<W.length?W[x]:W[W.length-1];try{if(T>0){const H=j(T);this.m.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T,H)),this.u.logService.info(`${O} waiting for ${T} seconds before reconnecting...`);try{await H}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1)),this.u.logService.info(`${O} resolving connection...`);const Q=await p(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${Q.connectTo}...`),await this.G(Q,h($)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1));break}catch(Q){if(Q.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(x>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(y.$al.isTemporarilyNotAvailable(Q)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((Q.code==="ETIMEDOUT"||Q.code==="ENETUNREACH"||Q.code==="ECONNREFUSED"||Q.code==="ECONNRESET")&&Q.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((0,M.$4)(Q)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if(Q instanceof y.$al){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,y.$al.isHandled(Q));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}}while(!this.n&&!this.s)}C(O,W,x){this.w?ue.triggerPermanentFailure(O,W,x):this.D(O,W,x)}D(O,W,x){this.m.fire(new oe(this.reconnectionToken,O,W,x)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$tl=ue;class Z extends ue{constructor(O,W,x,T,Q){super(1,O,T,Q,!0),this.client=this.B(new v.$Th(Q,{remoteAuthority:W,clientId:x},O.ipcLogger))}async G(O,W){await i(O,W)}}e.$ul=Z;class Y extends ue{constructor(O,W,x,T,Q){super(2,O,x,T,!1),this.H=W,this.debugPort=Q}async G(O,W){await n(O,this.H,W)}}e.$vl=Y;function q(K){try{K.acceptDisconnect();const O=K.getSocket();K.dispose(),O.dispose()}catch(O){(0,M.$1)(O)}}function L(K){if(K&&K.type==="error"){const O=new Error(`Connection error: ${K.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function N(K,O){for(;K.length<O;)K+=" ";return K}function G(K,O){return`[remote-connection][${N(k(K),13)}][${O.substr(0,5)}\u2026]`}function B(K,O,W){return`${G(K,O)}[${W?"reconnect":"initial"}]`}function te(K,O){return`${B(O,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function he(K){return`${Date.now()-K} ms`}}),define(ae[242],ce([0,1,2,6]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=void 0,e.$hl=(0,R.$8h)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(D,P){return this.a[D]??=[],this.a[D].push(P),(0,S.$Rc)(()=>{const g=this.a[D]?.indexOf(P);typeof g=="number"&&g>=0&&this.a[D]?.splice(g,1)})}b(D){return(this.a[D.type]||[]).find(g=>g.supports(D))}connect(D,P,g,l){const b=this.b(D);if(!b)throw new Error(`No socket factory found for ${D}`);return b.connect(D,P,g,l)}}e.$il=s}),define(ae[243],ce([0,1,26,48,21,114]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P0b=void 0;let D;async function P(u=!1){return(D===void 0||u)&&(D=g()),D}e.$P0b=P;async function g(){const u=l();if(u===void 0)return!1;if(u>=22e3){const $=v();if($)return new Promise(w=>{R.execFile($,["--status"],k=>w(!k))})}else{const $=y();if($)try{if((await s.Promises.stat($)).isFile())return!0}catch{}}return!1}function l(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(u)return parseInt(u[3])}function b(u){const $=process.env.SystemRoot;if($){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join($,w?"Sysnative":"System32",u)}}function v(){return b("wsl.exe")}function y(){return b("lxss\\LxssManager.dll")}}),define(ae[53],ce([0,1,17,14,2,183,52,6,5,44]),function(X,e,S,R,s,M,D,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$jp=(0,P.$8h)("requestService");class b{constructor(c){this.b=c}toJSON(){if(!this.a){const c=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?c[t]="*****":c[t]=this.b[t];this.a=c}return this.a}}class v extends s.$Tc{constructor(c){super(),this.b=0,this.a=c.createLogger("network",{name:(0,M.localize)(0,null),when:g.$Gj.isEqualTo((0,g.$Ej)(g.LogLevel.Trace)).serialize()})}async c(c,t,o){const r=`${c} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new b(t.headers??{}));try{const i=await o();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,R.$0)(i)),i}}}e.$kp=v;function y(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.$lp=y;function u(m){return m.res.statusCode===204}e.$mp=u;async function $(m){return u(m)?null:(await(0,S.$we)(m.stream)).toString()}e.$np=$;async function w(m){if(!y(m))throw new Error("Server returned "+m.res.statusCode);return $(m)}e.$op=w;async function k(m){if(!y(m))throw new Error("Server returned "+m.res.statusCode);if(u(m))return null;const t=(await(0,S.$we)(m.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$pp=k;function h(m){d(m)}e.$qp=h;let f;function d(m){const c=l.$Kn.as(D.$Pn.Configuration),t=f;f={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},c.updateConfigurations({add:[f],remove:t?[t]:[]})}d(1)}),define(ae[244],ce([0,1,17,23]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=void 0;class s{constructor(P){this.a=P}listen(P,g){throw new Error("Invalid listen")}call(P,g,l,b=R.CancellationToken.None){switch(g){case"request":return this.a.request(l[0],b).then(async({res:v,stream:y})=>{const u=await(0,S.$we)(y);return[{statusCode:v.statusCode,headers:v.headers},u]});case"resolveProxy":return this.a.resolveProxy(l[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$mr=s;class M{constructor(P){this.a=P}async request(P,g){const[l,b]=await this.a.call("request",[P],g);return{res:l,stream:(0,S.$ye)(b)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$nr=M}),define(ae[245],ce([0,1,246,12]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;function s(D,P){return D.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:D.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function M(D,P,g={}){const l=(0,S.parse)(D),b=g.proxyUrl||s(l,P);if(!b)return null;const v=(0,S.parse)(b);if(!/^https?:$/.test(v.protocol||""))return null;const y={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,R.$Pf)(g.strictSSL)?g.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((u,$)=>{X(["http-proxy-agent"],u,$)})).HttpProxyAgent(b,y):new(await new Promise((u,$)=>{X(["https-proxy-agent"],u,$)})).HttpsProxyAgent(b,y)}e.$or=M}),define(ae[247],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a$b=e.$_0b=e.$$0b=void 0,e.$$0b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$_0b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$a$b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[94],ce([0,1,48,9,184,23,51,14,4,32,109,64,8,140]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=void 0;let $;async function w(h,f,d,m){return d["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$8l)(m)&&!d["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$8l)(m)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),$||($=y.Promises.withAsyncBody(async(c,t)=>{const o=new M.$7d;let r=1e4;const i=h.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,u.$9l)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{c(await k(f,o.token))}catch(a){!(0,P.$4)(a)&&!o.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,D.$Si)(a)))):c({})}finally{clearTimeout(n),o.dispose()}})),$)}e.$bm=w;async function k(h,f){const d=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",d);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",m);const c=(0,l.$rg)().replace(/-/g,"").substr(0,12),t=new RegExp(c+"({.*})"+c),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",o);const r=await(0,b.$Xl)(g.OS,o);return h.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(f.isCancellationRequested)return n(new P.$5);const a=(0,R.$nc)(r);let p,A;const I="";/^pwsh(-preview)?$/.test(a)?(p=`& '${process.execPath}' ${I} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,A=["-Login","-Command"]):a==="nu"?(p=`^'${process.execPath}' ${I} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,A=["-i","-l","-c"]):a==="xonsh"?(p=`import os, json; print("${c}", json.dumps(dict(os.environ)), "${c}")`,A=["-i","-l","-c"]):(p=`'${process.execPath}' ${I} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"||a==="csh"?A=["-ic"]:A=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(A),p);const E=(0,S.spawn)(r,[...A,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(E.kill(),n(new P.$5))),E.on("error",U=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,D.$Si)(U)),n(U)});const C=[];E.stdout.on("data",U=>C.push(U));const j=[];E.stderr.on("data",U=>j.push(U)),E.on("close",(U,F)=>{const V=Buffer.concat(C).toString("utf8");h.trace("getUnixShellEnvironment#raw",V);const J=Buffer.concat(j).toString("utf8");if(J.trim()&&h.trace("getUnixShellEnvironment#stderr",J),U||F)return n(new Error((0,s.localize)(2,null,U,F)));const le=t.exec(V),oe=le?le[1]:"{}";try{const ue=JSON.parse(oe);d?ue.ELECTRON_RUN_AS_NODE=d:delete ue.ELECTRON_RUN_AS_NODE,m?ue.ELECTRON_NO_ATTACH_CONSOLE=m:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){h.error("getUnixShellEnvironment#errorCaught",(0,D.$Si)(ue)),n(ue)}})})}}),define(ae[248],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$76b=void 0;class S{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const D=String(S.a++);return this.b.set(D,M),{id:D,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const D=this.b.get(s.id);if(!D)return!1;this.b.delete(s.id);try{return D.validate(M)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$76b=S}),define(ae[95],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=void 0,e.$jl="signService",e.$kl=(0,S.$8h)(e.$jl)}),define(ae[249],ce([0,1,248]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1$b=void 0;class R extends S.$76b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(D=>new D.signer().sign(M))}h(){return new Promise((M,D)=>X(["vsda"],M,D))}}e.$1$b=R}),define(ae[34],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DO=e.$CO=void 0,e.$CO=(0,S.$8h)("stateReadService"),e.$DO=(0,S.$8h)("stateService")}),define(ae[122],ce([0,1,8,17,2,12,38,16,5]),function(X,e,S,R,s,M,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=e.$FO=e.$EO=e.SaveStrategy=void 0;var l;(function(u){u[u.IMMEDIATE=0]="IMMEDIATE",u[u.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class b extends s.$Tc{constructor($,w,k,h){super(),this.h=$,this.j=w,this.m=k,this.n=h,this.a=Object.create(null),this.b="",this.c=this.B(new S.$6g(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch($){$.fileOperationResult!==1&&this.m.error($)}}getItem($,w){const k=this.a[$];return(0,M.$Sf)(k)?w:k}setItem($,w){this.setItems([{key:$,data:w}])}setItems($){let w=!1;for(const{key:k,data:h}of $)this.a[k]!==h&&((0,M.$Sf)(h)?(0,M.$Qf)(this.a[k])||(this.a[k]=void 0,w=!0):(this.a[k]=h,w=!0));w&&this.s()}removeItem($){(0,M.$Qf)(this.a[$])||(this.a[$]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const $=JSON.stringify(this.a,null,4);if($!==this.b)try{await this.n.writeFile(this.h,R.$ke.fromString($),{atomic:{postfix:".vsctmp"}}),this.b=$}catch(w){this.m.error(w)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$EO=b;let v=class extends s.$Tc{constructor($,w,k,h){super(),this.a=this.B(new b(w.stateResource,$,k,h))}async init(){await this.a.init()}getItem($,w){return this.a.getItem($,w)}};e.$FO=v,e.$FO=v=ve([re(1,D.$ci),re(2,g.$pj),re(3,P.$sk)],v);class y extends v{setItem($,w){this.a.setItem($,w)}setItems($){this.a.setItems($)}removeItem($){this.a.removeItem($)}close(){return this.a.close()}}e.$GO=y}),define(ae[123],ce([0,1,4,36,32]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;function M(g){if(S.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function D(g,l,b,v,y,u,$,w,k){const h=Object.create(null);h["common.machineId"]=u,h["common.sqmId"]=$,h.sessionID=(0,s.$rg)()+Date.now(),h.commitHash=v,h.version=y,h["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,S.$h)(S.$u),h["common.nodePlatform"]=R.$dc,h["common.nodeArch"]=b,h["common.product"]=k||"desktop",w&&(h["common.msftInternal"]=w);let f=0;const d=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),S.$l&&(h["common.snap"]="true");const m=M(l);return m&&(h["common.platformDetail"]=m),h}e.$Lo=D;function P(g){const l=R.env.USERDNSDOMAIN;if(!l)return!1;const b=l.toLowerCase();return g.some(v=>b===v)}e.$Mo=P}),define(ae[28],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=void 0,e.$wl=(0,S.$8h)("telemetryService"),e.$xl=(0,S.$8h)("customEndpointTelemetryService"),e.$yl="telemetry.currentSessionDate",e.$zl="telemetry.firstSessionDate",e.$Al="telemetry.lastSessionDate",e.$Bl="telemetry.machineId",e.$Cl="telemetry.sqmId",e.$Dl="telemetry",e.$El="telemetry.telemetryLevel",e.$Fl="telemetry.enableCrashReporter",e.$Gl="telemetry.enableTelemetry";var R;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(ae[250],ce([0,1,26,8,42,13,9,4,7,88,21,108,91,16,27,28]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.$9r=e.$8r=void 0;const k=new Map;async function h(t,o){const r=`${t}::${o.join(":")}`,i=k.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,p=new Map,A=2e4;function I(C,j,U,F){const V=j.substring(C.length+1);return R.Promises.withAsyncBody(async J=>{let le;try{le=await b.Promises.readdir(j,{withFileTypes:!0})}catch{J();return}if(F.count>=A){F.count+=le.length,F.maxReached=!0,J();return}let oe=le.length;if(oe===0){J();return}let ue=le;F.count+le.length>A&&(F.maxReached=!0,oe=A-F.count,ue=le.slice(0,oe)),F.count+=le.length;for(const Z of ue)if(Z.isDirectory()){if(U.includes(Z.name)||await I(C,(0,D.$jc)(j,Z.name),U,F),--oe===0){J();return}}else{const Y=Z.name.lastIndexOf(".");if(Y>=0){const q=Z.name.substring(Y+1);q&&a.set(q,(a.get(q)??0)+1)}for(const q of n)q.relativePathPattern?.test(V)!==!1&&q.filePattern.test(Z.name)&&p.set(q.tag,(p.get(q.tag)??0)+1);if(--oe===0){J();return}}})}const E=R.Promises.withAsyncBody(async C=>{const j={count:0,maxReached:!1};await I(t,t,o,j);const U=await m(t);C({configFiles:f(p),fileTypes:f(a),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:U})});return k.set(r,E),E}e.$8r=h;function f(t){return Array.from(t.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function d(){const t={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/u.$1k.GB).toFixed(2)}GB (${(S.freemem()/u.$1k.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.$an.value()*100)}%`},o=S.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.$9r=d;async function m(t){try{const o=new Map,r=(0,D.$jc)(t,".vscode","launch.json"),i=await b.Promises.readFile(r),n=[],a=(0,s.$fn)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$on)(a)==="object"&&a.configurations)for(const p of a.configurations){const A=p.type;A&&(o.has(A)?o.set(A,o.get(A)+1):o.set(A,1))}return f(o)}catch{return[]}}e.$0r=m;let c=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const i=S.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/u.$1k.GB).toFixed(2)}GB (${(S.freemem()/u.$1k.GB).toFixed(2)}GB free)`),P.$i||r.push(`Load (avg):       ${S.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(l.$an.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,v.$7r)(o.mainPID),this.k(o)]).then(async i=>{let[n,a]=i,p=this.m(o,n);return r.forEach(A=>{if((0,y.$Mm)(A))p+=`
${A.errorMessage}`,a+=`
${A.errorMessage}`;else if(p+=`

Remote: ${A.hostName}`,A.processes&&(p+=`
${this.m(o,A.processes)}`),A.workspaceMetadata){a+=`
|  Remote: ${A.hostName}`;for(const I of Object.keys(A.workspaceMetadata)){const E=A.workspaceMetadata[I];let C=`${E.fileCount} files`;E.maxFilesReached&&(C=`more than ${C}`),a+=`|    Folder (${I}): ${C}`,a+=this.h(E)}}}),{processInfo:p,workspaceInfo:a}})}async getSystemInfo(o,r){const{memory:i,vmHint:n,os:a,cpus:p}=d(),A={os:a,memory:i,cpus:p,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return P.$i||(A.load=`${S.loadavg().map(I=>Math.round(I)).join(", ")}`),P.$k&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(o,r){const i=[];return(0,v.$7r)(o.mainPID).then(async n=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,n)),o.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),r.forEach(a=>{if((0,y.$Mm)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.f(a.machineInfo)),a.processes&&i.push(this.m(o,a.processes)),a.workspaceMetadata)for(const p of Object.keys(a.workspaceMetadata)){const A=a.workspaceMetadata[p];let I=`${A.fileCount} files`;A.maxFilesReached&&(I=`more than ${I}`),i.push(`Folder (${p}): ${I}`),i.push(this.h(A))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const r=[];let n=0;const a=(E,C)=>{const j=` ${E}(${C})`;n+j.length>60?(r.push(p),p="|                 ",n=p.length):n+=j.length,p+=j};let p="|      File types:";const A=10,I=o.fileTypes.length>A?A:o.fileTypes.length;for(let E=0;E<I;E++){const C=o.fileTypes[E];a(C.name,C.count)}if(r.push(p),o.configFiles.length>=0&&(p="|      Conf files:",n=0,o.configFiles.forEach(E=>{a(E.name,E.count)}),r.push(p)),o.launchConfigFiles.length>0){let E="|      Launch Configs:";o.launchConfigFiles.forEach(C=>{const j=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;E+=j}),r.push(E)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const r=[],i=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(a=>{const p=g.URI.revive(a);if(p.scheme===M.Schemas.file){const A=p.fsPath;i.push(h(A,["node_modules",".git"]).then(I=>{let E=`${I.fileCount} files`;I.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,D.$nc)(A)}): ${E}`),r.push(this.h(I))}).catch(I=>{r.push(`|      Error: Unable to collect workspace stats for folder ${A} (${I.toString()})`)}))}else r.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(o,r){const i=new Map;o.windows.forEach(a=>i.set(a.pid,`window [${a.id}] (${a.title})`)),o.pidToNames.forEach(({pid:a,name:p})=>i.set(a,p));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,i,n,r,0),n.join(`
`)}n(o,r,i,n,a){const p=a===0;let A;p?A=n.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?A=r.get(n.pid):A=`${"  ".repeat(a)} ${n.name}`;const I=process.platform==="win32"?n.mem:S.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(I/u.$1k.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(n.children)&&n.children.forEach(E=>this.n(o,r,i,E,a+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:i}of o.folders){const n=g.URI.revive(i);if(n.scheme!==M.Schemas.file)continue;const a=n.fsPath;try{(await h(a,["node_modules",".git"])).fileTypes.forEach(A=>r.add(A.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const i=g.URI.revive(r);if(i.scheme!==M.Schemas.file)continue;const n=i.fsPath;try{const a=await h(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),a.fileTypes.forEach(p=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})}),a.launchConfigFiles.forEach(p=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})}),a.configFiles.forEach(p=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};e.$$r=c,e.$$r=c=ve([re(0,w.$wl),re(1,$.$Hj)],c)}),define(ae[251],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e$b=e.$d$b=void 0;class S{constructor(M){this.b=M}listen(M,D){throw new Error(`Event not found: ${D}`)}call(M,D,{eventName:P,data:g}){return this.b.forEach(l=>l.log(P,g)),Promise.resolve(null)}}e.$d$b=S;class R{constructor(M){this.b=M}log(M,D){return this.b.call("log",{eventName:M,data:D}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$e$b=R}),define(ae[54],ce([0,1,35,12,60,123,28]),function(X,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;class P{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$No=P;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Oo=g,e.$Po=new g;class l{async publicLog(o,r,i){}async publicLogError(o,r,i){}}e.$Qo=l,e.$Ro="telemetry",e.$So="extensionTelemetryLog",e.$To={log:()=>null,flush:()=>Promise.resolve(null)};function b(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}e.$Uo=b;function v(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Vo=v;function y(t){const o=t.getValue(D.$El),r=t.getValue(D.$Fl);if(t.getValue(D.$Gl)===!1||r===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Wo=y;function u(t){const o={},r={},i={};k(t,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const a=i[n];typeof a=="number"?r[n]=a:typeof a=="boolean"?r[n]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${a.length}`),o[n]=a.substring(0,8191)):typeof a<"u"&&a!==null&&(o[n]=a)}return{properties:o,measurements:r}}e.$Xo=u;const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function w(t){if(!t)return"none";const o=(0,s.$dl)(t);return $.has(o)?o:"other"}e.$Yo=w;function k(t,o,r=0,i){if(t)for(const n of Object.getOwnPropertyNames(t)){const a=t[n],p=i?i+n:n;Array.isArray(a)?o[p]=(0,S.$Dn)(a):a instanceof Date?o[p]=a.toISOString():(0,R.$Lf)(a)?r<2?k(a,o,r+1,p+"."):o[p]=(0,S.$Dn)(a):o[p]=a}}function h(t,o){const r=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,M.$Mo)(r)||i}e.$Zo=h;function f(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$1o=f;function d(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const A of o)for(;;){const I=A.exec(t);if(!I)break;i.push([I.index,A.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(r="";;){const A=a.exec(t);if(!A)break;const I=i.some(([E,C])=>A.index<C&&E<a.lastIndex);!n.test(A[0])&&!I&&(r+=t.substring(p,A.index)+"<REDACTED: user-file-path>",p=a.lastIndex)}return p<t.length&&(r+=t.substr(p)),r}function m(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of o)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function c(t,o){return(0,S.$An)(t,r=>{if(r instanceof P||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=d(i,o);for(const n of o)i=i.replace(n,"");return i=m(i),i}})}e.$2o=c}),define(ae[124],ce([0,1,25,118,121,4,7,14,36,54]),function(X,e,S,R,s,M,D,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0;function b(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,S.$8e)(r.id,i.id)===0}e.$3o=b;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const n=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,n,a)}static parse(i){const n=v.exec(i);return n&&n[1]&&n[2]?new y({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,a="undefined"){this.version=n,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?b(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$4o=y;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(r){const i=u.exec(r);return i&&i[1]?[k(i[1]),i[2]]:[k(r),void 0]}e.$5o=$;function w(r,i){return`${r}.${i}`}e.$6o=w;function k(r){return r.toLowerCase()}e.$7o=k;function h(r,i){return k(w(r??s.$jm,i))}e.$8o=h;function f(r,i){const n=[],a=p=>{for(const A of n)if(A.some(I=>b(i(I),i(p))))return A;return null};for(const p of r){const A=a(p);A?A.push(p):n.push([p])}return n}e.$9o=f;function d(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$0o=d;function m(r){return{id:new l.$No(r.identifier.id),name:new l.$No(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$$o=m,e.$_o=new s.$nm("pprice.better-merge");function c(r,i){const n=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const p=a.shift();if(p&&n.every(A=>!b(A.identifier,{id:p}))){const A=r.filter(I=>b(I.identifier,{id:p}));A.length===1&&(n.push(A[0]),a.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$ap=c;async function t(r,i){if(!M.$k)return!1;let n;try{n=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){i.debug("Error while getting the os-release file.",(0,P.$0)(p))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,i){const n=await t(r,i),a=(0,R.$xo)(n?"alpine":M.$u,g.$ec);return i.debug("ComputeTargetPlatform:",a),a}e.$bp=o}),define(ae[252],ce([0,1,206,54]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;async function s(M,D,P,g,l,b,v){const y={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${D.nameShort})`};if((0,R.$Uo)(D,P)&&(0,R.$Wo)(g)===3){const u=await(0,S.$Cp)(P,l,b);y["X-Market-User-Id"]=u,y["VSCode-SessionId"]=v.machineId||u}return y}e.$Dp=s}),define(ae[253],ce([0,1,2,35,4,25,185,18,52,79,27,44,28,54]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,d){this.k=f,this.l=d,this.d={},this.i=new S.$Sc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,M.$Pe)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$Pe)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(y.$El)||m.affectsConfiguration(y.$Gl)||m.affectsConfiguration(y.$Fl))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,u.$Wo)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const d=f.usage?3:f.error?2:0;h=Math.min(h,d)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,f,d){this.g<f||(d=(0,R.$Bn)(d,this.d),d=(0,u.$2o)(d,this.j),d=(0,R.$Bn)(d,this.c),this.b.forEach(m=>m.log(h,d)))}publicLog(h,f){this.n(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this.h&&this.n(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.$rr=$,e.$rr=$=ve([re(1,P.$Bi),re(2,b.$Hj)],$);function w(){const k=(0,D.localize)(0,null,l.default.nameLong),h=l.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=s.$o?"":(0,D.localize)(3,null),d=(0,D.localize)(4,null),m=(0,D.localize)(5,null),c=(0,D.localize)(6,null),t=(0,D.localize)(7,null),o=`
|       | ${d} | ${m} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,D.localize)(8,null);return`
${k} ${h} ${f}

&nbsp;

${t}
${o}

&nbsp;

${r}
`}v.$Kn.as(g.$Pn.Configuration).registerConfiguration({id:y.$Dl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[y.$El]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$Kn.as(g.$Pn.Configuration).registerConfiguration({id:y.$Dl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[y.$Gl]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,D.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,D.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${y.$El}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[254],ce([0,1,4,88,28]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G$b=e.$F$b=void 0;async function M(P,g){let l=P.getItem(s.$Bl);return(typeof l!="string"||S.$j&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,R.$bn)(g.error.bind(g))),l}e.$F$b=M;async function D(P,g){let l=P.getItem(s.$Cl);return typeof l!="string"&&(l=await(0,R.$cn)(g.error.bind(g))),l}e.$G$b=D}),define(ae[255],ce([0,1,28,254]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I$b=e.$H$b=void 0;async function s(D,P){const g=await(0,R.$F$b)(D,P);return D.setItem(S.$Bl,g),g}e.$H$b=s;async function M(D,P){const g=await(0,R.$G$b)(D,P);return D.setItem(S.$Cl,g),g}e.$I$b=M}),define(ae[125],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var S;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(S||(e.EnvironmentVariableMutatorType=S={}))}),define(ae[256],ce([0,1,4,125]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=void 0;const s=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(b){this.collections=b,this.a=new Map,this.b=new Map,b.forEach((v,y)=>{this.d(v,y);const u=v.map.entries();let $=u.next();for(;!$.done;){const w=$.value[1],k=$.value[0];let h=this.a.get(k);if(h||(h=[],this.a.set(k,h)),h.length>0&&h[0].type===R.EnvironmentVariableMutatorType.Replace){$=u.next();continue}const f={extensionIdentifier:y,value:w.value,type:w.type,scope:w.scope,variable:w.variable,options:w.options};f.scope||delete f.scope,h.unshift(f),$=u.next()}})}async applyToProcessEnvironment(b,v,y){let u;S.$i&&(u={},Object.keys(b).forEach($=>u[$.toLowerCase()]=$));for(const[$,w]of this.getVariableMap(v)){const k=S.$i&&u[$.toLowerCase()]||$;for(const h of w){const f=y?await y(h.value):h.value;if(h.options?.applyAtProcessCreation??!0)switch(h.type){case R.EnvironmentVariableMutatorType.Append:b[k]=(b[k]||"")+f;break;case R.EnvironmentVariableMutatorType.Prepend:b[k]=f+(b[k]||"");break;case R.EnvironmentVariableMutatorType.Replace:b[k]=f;break}if(h.options?.applyAtShellIntegration??!1){const d=`VSCODE_ENV_${s.get(h.type)}`;b[d]=(b[d]?b[d]+":":"")+$+"="+this.c(f)}}}}c(b){return b.replaceAll(":","\\x3a")}diff(b,v){const y=new Map,u=new Map,$=new Map;if(b.getVariableMap(v).forEach((w,k)=>{const h=this.getVariableMap(v).get(k),f=P(w,h);f&&y.set(k,f)}),this.getVariableMap(v).forEach((w,k)=>{const h=b.getVariableMap(v).get(k),f=P(w,h);f&&$.set(k,f)}),this.getVariableMap(v).forEach((w,k)=>{const h=b.getVariableMap(v).get(k),f=g(w,h);f&&u.set(k,f)}),!(y.size===0&&u.size===0&&$.size===0))return{added:y,changed:u,removed:$}}getVariableMap(b){const v=new Map;for(const y of this.a.values()){const u=y.filter($=>D($,b));u.length>0&&v.set(u[0].variable,u)}return v}getDescriptionMap(b){const v=new Map;for(const y of this.b.values()){const u=y.filter($=>D($,b,!0));for(const $ of u)v.set($.extensionIdentifier,$.description)}return v}d(b,v){if(!b.descriptionMap)return;const y=b.descriptionMap.entries();let u=y.next();for(;!u.done;){const $=u.value[1],w=u.value[0];let k=this.b.get(w);k||(k=[],this.b.set(w,k));const h={extensionIdentifier:v,scope:$.scope,description:$.description};h.scope||delete h.scope,k.push(h),u=y.next()}}}e.$Ur=M;function D(l,b,v=!1){return l.scope?!!(l.scope.workspaceFolder&&b?.workspaceFolder&&l.scope.workspaceFolder.index===b.workspaceFolder.index):v?b===l.scope:!0}function P(l,b){if(!b)return l;const v=new Set;b.forEach(u=>v.add(u.extensionIdentifier));const y=[];return l.forEach(u=>{v.has(u.extensionIdentifier)||y.push(u)}),y.length===0?void 0:y}function g(l,b){if(!b)return;const v=new Map;b.forEach(u=>v.set(u.extensionIdentifier,u));const y=[];return l.forEach(u=>{const $=v.get(u.extensionIdentifier);$&&(u.type!==$.type||u.value!==$.value||u.scope?.workspaceFolder?.index!==$.scope?.workspaceFolder?.index)&&y.push($)}),y.length===0?void 0:y}}),define(ae[257],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=e.$Or=void 0;function S(g){return[...g.entries()]}e.$Or=S;function R(g){return g?[...g.entries()]:[]}e.$Pr=R;function s(g){return new Map(g)}e.$Qr=s;function M(g){return new Map(g??[])}e.$Rr=M;function D(g){return Array.from(g.entries()).map(l=>[l[0],S(l[1].map),R(l[1].descriptionMap)])}e.$Sr=D;function P(g){return new Map(g.map(l=>[l[0],{map:s(l[1]),descriptionMap:M(l[2])}]))}e.$Tr=P}),define(ae[258],ce([0,1,8,23,3,2,5]),function(X,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;let P=class extends M.$Tc{constructor(l,b){super(),this.h=b,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Wd),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l,this.B((0,M.$Rc)(()=>{for(const v of this.f.values())(0,M.$Oc)(v)}))}createRequest(l){return new Promise((b,v)=>{const y=++this.a;this.c.set(y,b),this.g.fire({requestId:y,...l});const u=new R.$7d;(0,S.$9g)(this.b,u.token).then(()=>v(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,M.$Rc)(()=>u.cancel())])})}acceptReply(l,b){const v=this.c.get(l);v?(this.c.delete(l),(0,M.$Oc)(this.f.get(l)||[]),this.f.delete(l),v(b)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.$Fr=P,e.$Fr=P=ve([re(1,D.$pj)],P)}),define(ae[126],ce([0,1,6,115,44]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.$zr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$yr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$xr=void 0,e.$xr=new R.$mj("terminalTabFocusMode",!1,!0);var M;(function(c){c.AutomationProfile="terminal.integrated.automationProfile.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var D;(function(c){c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.TabStopWidth="terminal.integrated.tabStopWidth",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorStyleInactive="terminal.integrated.cursorStyleInactive",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.TabFocusMode="terminal.integrated.tabFocusMode",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.HideOnStartup="terminal.integrated.hideOnStartup",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",c.EnableImages="terminal.integrated.enableImages",c.SmoothScrolling="terminal.integrated.smoothScrolling",c.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",c.FocusAfterRun="terminal.integrated.focusAfterRun",c.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",c.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",c.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",c.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",c.MouseWheelZoom="terminal.integrated.mouseWheelZoom",c.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",c.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",c.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var P;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(P||(e.PosixShellType=P={}));var g;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(g||(e.WindowsShellType=g={}));var l;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var b;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.PtyHostWindow="ptyHostWindow",c.Logger="logger",c.Heartbeat="heartbeat"})(b||(e.TerminalIpcChannels=b={}));var v;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.$yr=(0,S.$8h)("ptyService");var y;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var u;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(u||(e.TerminalLocation=u={}));var $;(function(c){c.TerminalView="view",c.Editor="editor"})($||(e.TerminalLocationString=$={}));var w;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(w||(e.LocalReconnectConstants=w={}));var k;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(k||(e.FlowControlConstants=k={}));var h;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(h||(e.ProfileSource=h={}));var f;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var d;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(d||(e.TerminalExitReason=d={})),e.$zr={Backend:"workbench.contributions.terminal.processBackend"};class m{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$Kn.add(e.$zr.Backend,new m),e.$Ar=(0,S.$8h)("localPtyService"),e.$Br=(0,S.$8h)("terminalLogService")}),define(ae[259],ce([0,1,74,7,187,103]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=e.$Ir=e.$Hr=e.$Gr=void 0;function D(y,u){const $=[{name:null,description:(0,s.localize)(0,null)}];return $.push(...y.map(w=>({name:w.profileName,description:P(w)}))),u&&$.push(...u.map(w=>({name:w.title,description:g(w)}))),{values:$.map(w=>w.name),markdownDescriptions:$.map(w=>w.description)}}e.$Gr=D;function P(y){let u=`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$bk.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?u+=`
- args: "${y.args}"`:u+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(u+=`
- overrideName: ${y.overrideName}`),y.color&&(u+=`
- color: ${y.color}`),y.env&&(u+=`
- env: ${JSON.stringify(y.env)}`),u}function g(y){return`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$bk.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function l(y,u){if(!y&&!u)return!0;if(typeof y=="string"&&typeof u=="string")return y===u;if(Array.isArray(y)&&Array.isArray(u)){if(y.length!==u.length)return!1;for(let $=0;$<y.length;$++)if(y[$]!==u[$])return!1;return!0}return!1}e.$Hr=l;function b(y,u){if(!y&&!u)return!0;if(!y||!u)return!1;if(M.ThemeIcon.isThemeIcon(y)&&M.ThemeIcon.isThemeIcon(u))return y.id===u.id&&y.color===u.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof u=="object"&&"light"in u&&"dark"in u){const $=y,w=u;if((R.URI.isUri($.light)||v($.light))&&(R.URI.isUri($.dark)||v($.dark))&&(R.URI.isUri(w.light)||v(w.light))&&(R.URI.isUri(w.dark)||v(w.dark)))return $.light.path===w.light.path&&$.dark.path===w.dark.path}if(R.URI.isUri(y)&&R.URI.isUri(u)||v(y)||v(u)){const $=y,w=u;return $.path===w.path&&$.scheme===w.scheme}return!1}e.$Ir=b;function v(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.$Jr=v}),define(ae[260],ce([0,1,74,4,186,52,44,259]),function(X,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=e.$Lr=e.$Kr=void 0,e.$Kr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Lr={type:"string",enum:Array.from((0,S.$ak)(),k=>k.id),markdownEnumDescriptions:Array.from((0,S.$ak)(),k=>`$(${k.id})`)};const g={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$Lr},color:{description:(0,s.localize)(3,null),...e.$Kr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...g}},b={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...g}};function v(k){const h=k===2?"linux":k===1?"osx":"windows";return(0,s.localize)(7,null,(0,R.$h)(k),'```json\n"terminal.integrated.profile.'+h+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:v(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...g}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...g}},{type:"null"},l]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:v(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...g}},{type:"null"},l]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:v(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...g}},{type:"null"},l]}},"terminal.integrated.useWslProfiles":{description:(0,s.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){D.$Kn.as(M.$Pn.Configuration).registerConfiguration(y),w()}e.$Mr=u;let $;function w(k,h){const f=D.$Kn.as(M.$Pn.Configuration);let d;k&&(d=(0,P.$Gr)(k?.profiles,h));const m=$;$={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:k?.os===3?d?.values:void 0,markdownEnumDescriptions:k?.os===3?d?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:k?.os===2?d?.values:void 0,markdownEnumDescriptions:k?.os===2?d?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:k?.os===1?d?.values:void 0,markdownEnumDescriptions:k?.os===1?d?.markdownDescriptions:void 0}}},f.updateConfigurations({add:[$],remove:m?[m]:[]})}e.$Nr=w}),define(ae[261],ce([0,1,26,13,35,9,4,36,25,12,21,125,257,256]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=e.$Vr=void 0;function $(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$Vr=$;async function w(i,n,a,p=P.env,A=b.Promises.exists){if(M.$ic(i))return await A(i)?i:void 0;if(n===void 0&&(n=P.cwd()),M.$mc(i)!=="."){const j=M.$jc(n,i);return await A(j)?j:void 0}const E=(0,s.$Fn)(p,"PATH");if(a===void 0&&(0,l.$Jf)(E)&&(a=E.split(M.$tc)),a===void 0||a.length===0){const j=M.$jc(n,i);return await A(j)?j:void 0}for(const j of a){let U;if(M.$ic(j)?U=M.$jc(j,i):U=M.$jc(n,j,i),await A(U))return U;if(D.$i){let F=U+".com";if(await A(F)||(F=U+".exe",await A(F)))return F}}const C=M.$jc(n,i);return await A(C)?C:void 0}e.$Wr=w;function k(i,n,a,p,A){const I=D.$i&&(!n.windowsEnableConpty||$()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||I)return;const E=i.args,C=P.$dc==="win32"?M.$nc(i.executable).toLowerCase():M.$nc(i.executable),j=M.$mc(R.$pg.asFileUri("").fsPath);let U;const F={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(F.VSCODE_NONCE=n.shellIntegration.nonce),D.$i){if(C==="pwsh.exe"||C==="powershell.exe")return!E||o(E)?U=d.get(f.WindowsPwsh):t(E)&&(U=d.get(f.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,g.$Le)(U[U.length-1],j,""),n.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),{newArgs:U,envMixin:F}):void 0;p.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(C){case"bash":return!E||E.length===0?U=d.get(f.Bash):r(E)&&(F.VSCODE_SHELL_LOGIN="1",h(n,F),U=d.get(f.Bash)),U?(U=[...U],U[U.length-1]=(0,g.$Le)(U[U.length-1],j),{newArgs:U,envMixin:F}):void 0;case"fish":{const V=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",J=M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return F.XDG_DATA_DIRS=`${V}:${J}`,h(n,F),{newArgs:void 0,envMixin:F}}case"pwsh":return!E||o(E)?U=d.get(f.Pwsh):t(E)&&(U=d.get(f.PwshLogin)),U?(n.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),U=[...U],U[U.length-1]=(0,g.$Le)(U[U.length-1],j,""),{newArgs:U,envMixin:F}):void 0;case"zsh":{if(!E||E.length===0?U=d.get(f.Zsh):r(E)?(U=d.get(f.ZshLogin),h(n,F)):(E===d.get(f.Zsh)||E===d.get(f.ZshLogin))&&(U=E),!U)return;U=[...U],U[U.length-1]=(0,g.$Le)(U[U.length-1],j);let V;try{V=S.userInfo().username}catch{V="unknown"}const J=M.$jc(S.tmpdir(),`${V}-${A.applicationName}-zsh`);F.ZDOTDIR=J;const le=a?.ZDOTDIR??S.homedir()??"~";F.USER_ZDOTDIR=le;const oe=[];return oe.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$jc(J,".zshrc")}),oe.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$jc(J,".zprofile")}),oe.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$jc(J,".zshenv")}),oe.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$jc(J,".zlogin")}),{newArgs:U,envMixin:F,filesToCopy:oe}}}p.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$Xr=k;function h(i,n){if(D.$j&&i.environmentVariableCollections){const a=(0,y.$Tr)(i.environmentVariableCollections),A=new u.$Ur(a).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),I=[];if(A)for(const E of A)E.type===v.EnvironmentVariableMutatorType.Prepend&&I.push(E.value);I.length>0&&(n.VSCODE_PATH_PREFIX=I.join(""))}}var f;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(f||(f={}));const d=new Map;d.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(f.Zsh,["-i"]),d.set(f.ZshLogin,["-il"]),d.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const m=["-login","-l"],c=["-nol","-nologo"];function t(i){return typeof i=="string"?m.includes(i.toLowerCase()):i.length===1&&m.includes(i[0].toLowerCase())||i.length===2&&(m.includes(i[0].toLowerCase())||m.includes(i[1].toLowerCase()))&&(c.includes(i[0].toLowerCase())||c.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?c.includes(i.toLowerCase()):i.length===0||i?.length===1&&c.includes(i[0].toLowerCase())}function r(i){return i==="string"&&m.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&m.includes(i[0].toLowerCase())}}),define(ae[262],ce([0,1,48,74,9,4,12,21,107,261,114]),function(X,e,S,R,s,M,D,P,g,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=void 0;var v;(function(a){a.UnixShellsPath="/etc/shells"})(v||(v={}));let y,u=!0;function $(a,p,A,I,E=process.env,C,j,U,F){return C=C||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},M.$i?w(A,C,E,j,I.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:I.getValue("terminal.integrated.profiles.windows"),typeof p=="string"?p:I.getValue("terminal.integrated.defaultProfile.windows"),F,U):r(C,j,A,a&&typeof a=="object"?{...a}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof p=="string"?p:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,U,E)}e.$Yr=$;async function w(a,p,A,I,E,C,j,U,F){const V=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),J=`${process.env.windir}\\${V?"Sysnative":"System32"}`;let le=!1;(0,l.$Vr)()>=16299&&(le=!0),await d(U);const oe=new Map;if(a){oe.set("PowerShell",{source:"PowerShell",icon:R.$bk.terminalPowershell,isAutoDetected:!0}),oe.set("Windows PowerShell",{path:`${J}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$bk.terminalPowershell,isAutoDetected:!0}),oe.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),oe.set("Command Prompt",{path:`${J}\\cmd.exe`,icon:R.$bk.terminalCmd,isAutoDetected:!0}),oe.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),oe.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:R.$bk.terminalBash,isAutoDetected:!0});const Z=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;oe.set("Cmder",{path:`${J}\\cmd.exe`,args:["/K",Z],requiresPath:process.env.CMDER_ROOT?Z:{path:Z,isUnsafe:!0},isAutoDetected:!0})}i(C,oe);const ue=await k(oe.entries(),j,p,A,I,F);if(a&&E)try{const Z=await t(`${J}\\${le?"wsl":"bash"}.exe`,j);for(const Y of Z)(!C||!(Y.profileName in C))&&ue.push(Y)}catch{u&&(I?.trace("WSL is not installed, so could not detect WSL profiles"),u=!1)}return ue}async function k(a,p,A,I=process.env,E,C){const j=[];for(const[U,F]of a)j.push(h(U,F,p,A,I,E,C));return(await Promise.all(j)).filter(U=>!!U)}async function h(a,p,A,I,E=process.env,C,j){if(p===null)return;let U,F,V;if("source"in p&&!("path"in p)){const ue=y?.get(p.source);if(!ue)return;U=ue.paths,F=p.args||ue.args,p.icon?V=f(p.icon):ue.icon&&(V=ue.icon)}else U=Array.isArray(p.path)?p.path:[p.path],F=M.$i||Array.isArray(p.args)?p.args:void 0,V=f(p.icon);let J;if(j){const ue=U.map(Y=>typeof Y=="string"?Y:Y.path),Z=await j(ue);J=new Array(U.length);for(let Y=0;Y<U.length;Y++)typeof U[Y]=="string"?J[Y]=Z[Y]:J[Y]={path:Z[Y],isUnsafe:!0}}else J=U.slice();let le;if(p.requiresPath){let ue;if((0,D.$Jf)(p.requiresPath)?ue=p.requiresPath:(ue=p.requiresPath.path,p.requiresPath.isUnsafe&&(le=ue)),!await I.existsFile(ue))return}const oe=await n(a,A,J,I,E,F,p.env,p.overrideName,p.isAutoDetected,le);if(!oe){C?.debug("Terminal profile not validated",a,U);return}return oe.isAutoDetected=p.isAutoDetected,oe.icon=V,oe.color=p.color,oe}function f(a){return typeof a=="string"?{id:a}:a}async function d(a){if(y&&!a)return;const[p,A]=await Promise.all([m(),a||c()]);y=new Map,y.set("Git Bash",{profileName:"Git Bash",paths:p,args:["--login","-i"]}),y.set("PowerShell",{profileName:"PowerShell",paths:A,icon:R.$bk.terminalPowershell})}async function m(){const a=new Set,p=await(0,l.$Wr)("git.exe");if(p){const E=(0,b.dirname)(p);a.add((0,b.resolve)(E,"../.."))}function A(E,C){C&&E.add(C)}A(a,process.env.ProgramW6432),A(a,process.env.ProgramFiles),A(a,process.env["ProgramFiles(X86)"]),A(a,`${process.env.LocalAppData}\\Program`);const I=[];for(const E of a)I.push(`${E}\\Git\\bin\\bash.exe`,`${E}\\Git\\usr\\bin\\bash.exe`,`${E}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function c(){const a=[];for await(const p of(0,g.$Rl)())a.push(p.exePath);return a}async function t(a,p){const A=[],I=await new Promise((j,U)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,V)=>{if(F)return U("Problem occurred when getting wsl distros");j(V)})});if(!I)return[];const E=new RegExp(/[\r?\n]/),C=I.split(E).filter(j=>j.trim().length>0&&j!=="");for(const j of C){if(j===""||j.startsWith("docker-desktop"))continue;const U=`${j} (WSL)`,F={profileName:U,path:a,args:["-d",`${j}`],isDefault:U===p,icon:o(j),isAutoDetected:!1};A.push(F)}return A}function o(a){return a.includes("Ubuntu")?R.$bk.terminalUbuntu:a.includes("Debian")?R.$bk.terminalDebian:R.$bk.terminalLinux}async function r(a,p,A,I,E,C,j,U){const F=new Map;if(A&&await a.existsFile("/etc/shells")){const V=(await a.readFile("/etc/shells")).toString(),J=(C||V.split(`
`)).map(oe=>{const ue=oe.indexOf("#");return ue===-1?oe:oe.substring(0,ue)}).filter(oe=>oe.trim().length>0),le=new Map;for(const oe of J){let ue=(0,s.$nc)(oe),Z=le.get(ue)||0;Z++,Z>1&&(ue=`${ue} (${Z})`),le.set(ue,Z),F.set(ue,{path:oe,isAutoDetected:!0})}}return i(I,F),await k(F.entries(),E,a,U,p,j)}function i(a,p){if(a)for(const[A,I]of Object.entries(a))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?p.delete(A):(I.icon=I.icon||p.get(A)?.icon,p.set(A,I))}async function n(a,p,A,I,E,C,j,U,F,V){if(A.length===0)return Promise.resolve(void 0);const J=A.shift();if(J==="")return n(a,p,A,I,E,C,j,U,F);const le=typeof J!="string"&&J.isUnsafe,oe=typeof J=="string"?J:J.path,ue={profileName:a,path:oe,args:C,env:j,overrideName:U,isAutoDetected:F,isDefault:a===p,isUnsafePath:le,requiresUnsafePath:V};if((0,s.$nc)(oe)===oe){const Y=E.PATH?E.PATH.split(s.$tc):void 0,q=await(0,l.$Wr)(oe,void 0,Y,void 0,I.existsFile);return q?(ue.path=q,ue.isFromPath=!0,ue):n(a,p,A,I,E,C)}return await I.existsFile((0,s.$hc)(oe))?ue:n(a,p,A,I,E,C,j,U,F)}}),define(ae[263],ce([0,1,3,2,4,43,18,5,226,94,258,126,260,262,109,72]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=void 0;var k;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(k||(k={}));let h=class extends R.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(d,m,c,t){super(),this.M=d,this.N=m,this.O=c,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new S.$Wd),this.onPtyHostExit=this.u.event,this.w=this.B(new S.$Wd),this.onPtyHostStart=this.w.event,this.y=this.B(new S.$Wd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new S.$Wd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new S.$Wd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new S.$Wd),this.onProcessData=this.D.event,this.F=this.B(new S.$Wd),this.onProcessReady=this.F.event,this.G=this.B(new S.$Wd),this.onProcessReplay=this.G.event,this.H=this.B(new S.$Wd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new S.$Wd),this.onDidRequestDetach=this.I.event,this.J=this.B(new S.$Wd),this.onDidChangeProperty=this.J.event,this.L=this.B(new S.$Wd),this.onProcessExit=this.L.event,(0,y.$Mr)(),this.B(this.M),this.B((0,R.$Rc)(()=>this.W())),this.j=this.B(new b.$Fr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&S.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,l.$bm)(this.N,this.O,{_:[]},process.env)}catch(d){return this.O.error("ptyHost was unable to resolve shell environment",d),{}}}U(){const d=this.M.start(),m=d.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(m.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(d.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=k.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=M.ProxyChannel.toService(m.getChannel(v.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new g.$Er(this.P,m.getChannel(v.TerminalIpcChannels.Logger))),this.a=d,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[d,t]}async createProcess(d,m,c,t,o,r,i,n,a,p,A){const I=setTimeout(()=>this.$(),v.HeartbeatConstants.CreateProcessTimeout),E=await this.f.createProcess(d,m,c,t,o,r,i,n,a,p,A);return clearTimeout(I),E}updateTitle(d,m,c){return this.f.updateTitle(d,m,c)}updateIcon(d,m,c,t){return this.f.updateIcon(d,m,c,t)}attachToProcess(d){return this.f.attachToProcess(d)}detachFromProcess(d,m){return this.f.detachFromProcess(d,m)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(d){return this.f.start(d)}shutdown(d,m){return this.f.shutdown(d,m)}input(d,m){return this.f.input(d,m)}processBinary(d,m){return this.f.processBinary(d,m)}resize(d,m,c){return this.f.resize(d,m,c)}clearBuffer(d){return this.f.clearBuffer(d)}acknowledgeDataEvent(d,m){return this.f.acknowledgeDataEvent(d,m)}setUnicodeVersion(d,m){return this.f.setUnicodeVersion(d,m)}getInitialCwd(d){return this.f.getInitialCwd(d)}getCwd(d){return this.f.getCwd(d)}async getLatency(){const d=new w.$Sd,m=await this.f.getLatency();return d.stop(),[{label:"ptyhostservice<->ptyhost",latency:d.elapsed()},...m]}orphanQuestionReply(d){return this.f.orphanQuestionReply(d)}installAutoReply(d,m){return this.f.installAutoReply(d,m)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(d){return this.f.uninstallAutoReply(d)}getDefaultSystemShell(d){return this.g?.getDefaultSystemShell(d)??(0,$.$Xl)(d??s.OS,process.env)}async getProfiles(d,m,c,t=!1){const o=await this.S();return(0,u.$Yr)(m,c,t,this.N,o,void 0,this.O,this.bb.bind(this,d))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(d,m){return this.f.getWslPath(d,m)}getRevivedPtyNewId(d,m){return this.f.getRevivedPtyNewId(d,m)}setTerminalLayoutInfo(d){return this.f.setTerminalLayoutInfo(d)}async getTerminalLayoutInfo(d){return this.g?.getTerminalLayoutInfo(d)}async requestDetachInstance(d,m){return this.f.requestDetachInstance(d,m)}async acceptDetachInstanceReply(d,m){return this.f.acceptDetachInstanceReply(d,m)}async freePortKillProcess(d){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(d)}async serializeTerminalState(d){return this.f.serializeTerminalState(d)}async reviveTerminalProcesses(d,m,c){return this.f.reviveTerminalProcesses(d,m,c)}async refreshProperty(d,m){return this.f.refreshProperty(d,m)}async updateProperty(d,m,c){return this.f.updateProperty(d,m,c)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(d){this.ab(),this.s=setTimeout(()=>this.Y(),d?v.HeartbeatConstants.ConnectingBeatInterval:v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(d,m){return this.j.createRequest({workspaceId:d,originalText:m})}async acceptPtyHostResolvedVariables(d,m){this.j.acceptReply(d,m)}};e.$Zr=h,e.$Zr=h=ve([re(1,D.$Bi),re(2,P.$pj),re(3,P.$qj)],h)}),define(ae[69],ce([0,1,15,3,2,4,18,6,34]),function(X,e,S,R,s,M,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$69b=e.$59b=void 0;const l="#FFFFFF",b="#1E1E1E",v="#000000",y="#FFFFFF",u="theme",$="themeBackground",w="windowSplash";e.$59b=(0,P.$8h)("themeMainService");let k=class extends s.$Tc{constructor(f,d){super(),this.b=f,this.c=d,this.a=this.B(new R.$Wd),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration(m=>{m.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(R.Event.fromNodeEventEmitter(S.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":S.nativeTheme.themeSource="dark";break;case"light":S.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":S.nativeTheme.themeSource="light";break;case"vs-dark":S.nativeTheme.themeSource="dark";break;default:S.nativeTheme.themeSource="system"}break;default:S.nativeTheme.themeSource="system";break}}getColorScheme(){if(M.$i){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const f=this.getColorScheme();if(f.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return f.dark?v:y;let d=this.b.getItem($,null);if(!d)switch(this.g()){case"vs":d=l;break;case"hc-black":d=v;break;case"hc-light":d=y;break;default:d=b}return M.$j&&d.toUpperCase()===b&&(d="#171717"),d}g(){switch(this.b.getItem(u,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(f,d){this.b.setItems([{key:u,data:d.baseTheme},{key:$,data:d.colorInfo.background},{key:w,data:d}]),typeof f=="number"&&this.h(f,d),this.f()}h(f,d){for(const m of S.BrowserWindow.getAllWindows())if(m.id===f){m.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};e.$69b=k,e.$69b=k=ve([re(0,g.$DO),re(1,D.$Bi)],k)}),define(ae[127],ce([0,1,3,18,6,5]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.ProvidedOnAutoForward=e.$Ev=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dv=e.$Cv=void 0,e.$Cv=(0,s.$8h)("tunnelService"),e.$Dv=(0,s.$8h)("sharedTunnelsService");var D;(function(k){k.Http="http",k.Https="https"})(D||(e.TunnelProtocol=D={}));var P;(function(k){k.ConstantPrivate="constantPrivate",k.Private="private",k.Public="public"})(P||(e.TunnelPrivacyId=P={}));function g(k){return!!k.forwardPort}e.$Ev=g;var l;(function(k){k[k.Notify=1]="Notify",k[k.OpenBrowser=2]="OpenBrowser",k[k.OpenPreview=3]="OpenPreview",k[k.Silent=4]="Silent",k[k.Ignore=5]="Ignore",k[k.OpenBrowserOnce=6]="OpenBrowserOnce"})(l||(e.ProvidedOnAutoForward=l={}));function b(k){if(k.scheme!=="http"&&k.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(k.authority);if(h)return{address:h[1],port:+h[2]}}e.$Fv=b,e.$Gv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(k){return e.$Gv.indexOf(k)>=0}e.$Hv=v,e.$Iv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(k){return e.$Iv.indexOf(k)>=0}e.$Jv=y;function u(k,h,f,d){if(f===1)return!1;if(f===2&&y(h)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(m?.length===4&&parseInt(m[1])>=18)return!1}return k<1024}e.$Kv=u;class ${constructor(h,f,d){this.remoteAddress=h,this.localAddress=f,this.b=d,this.a=new S.$Wd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lv=$;let w=class{constructor(h,f){this.k=h,this.l=f,this.a=new S.$Wd,this.onTunnelOpened=this.a.event,this.b=new S.$Wd,this.onTunnelClosed=this.b.event,this.c=new S.$Wd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const h=this.l.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.i=h.privacyOptions,this.h=h.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const h=[],f=Array.from(this.e.values());for(const d of f){const m=Array.from(d.values());for(const c of m){const t=await c.value;t&&typeof t!="string"&&h.push(t)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:f}of h.values())await f.then(d=>typeof d!="string"?d?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,f,d,m,c){this.q(h,f,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:f,localAddress:d,privacy:m,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,f){(y(h)||v(h))&&(h=e.$Gv[0]);const d=this.s(h,f);if(d)return++d.refcount,d.value}openTunnel(h,f,d,m,c,t=!1,o,r){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${d} on local port ${c}.`);const i=this.f??h;if(!i)return;if(f||(f="localhost"),m||(m=this.m),this.f&&this.j.has(d)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.t(i,f,d,m,c,t,o,r);return n?n.then(a=>{if(a){if(typeof a=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(f,d),a}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(f,d);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.o(a);return(a.tunnelRemoteHost!==f||a.tunnelRemotePort!==d)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&a.privacy!==o&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}o(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const f=this.e.get(h.tunnelRemoteHost);if(f){const d=f.get(h.tunnelRemotePort);d&&(d.refcount--,await this.p(h.tunnelRemoteHost,h.tunnelRemotePort,d))}}}}async p(h,f,d){if(d.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${f}.`);const m=d.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(f),m}}async closeTunnel(h,f){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${f} `);const d=this.e.get(h);if(d&&d.has(f)){const m=d.get(f);m.refcount=0,await this.p(h,f,m)}}q(h,f,d){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(f,{refcount:1,value:d})}async r(h,f){const d=this.e.get(h);if(d){const m=d.get(f),c=m?await m.value:void 0;(!c||typeof c=="string")&&d.delete(f),d.size===0&&this.e.delete(h)}}s(h,f){const d=[h];v(h)?(d.push(...e.$Gv),d.push(...e.$Iv)):y(h)&&d.push(...e.$Iv);const m=d.map(c=>this.e.get(c));for(const c of m){const t=c?.get(f);if(t)return t}}canTunnel(h){return!!b(h)}u(h,f,d,m,c,t,o){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${d} on local port ${m}.`);const r=d;this.j.add(r);const i=m===void 0?d:m,n={elevationRequired:c?this.isPortPrivileged(i):!1},a={remoteAddress:{host:f,port:d},localAddressPort:m,privacy:t,public:t?t!==P.Private:void 0,protocol:o},p=h.forwardPort(a,n);return p?(this.q(f,d,p),p.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(r)})):this.j.delete(r),p}};e.$Mv=w,e.$Mv=w=ve([re(0,M.$pj),re(1,R.$Bi)],w)}),define(ae[49],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IV=e.$HV=e.DisablementReason=e.UpdateType=e.StateType=void 0;var R;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(R||(e.StateType=R={}));var s;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$HV={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,P)=>({type:"idle",updateType:D,error:P}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.$IV=(0,S.$8h)("updateService")}),define(ae[264],ce([0,1,4,188,52,44]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$Kn.as(s.$Pn.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:S.$i&&!S.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ae[265],ce([0,1,3,49]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g$b=e.$f$b=void 0;class s{constructor(P){this.a=P}listen(P,g){switch(g){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${g}`)}call(P,g,l){switch(g){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${g}`)}}e.$f$b=s;class M{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new S.$Wd,this.onStateChange=this.a.event,this.b=R.$HV.Uninitialized,this.c.listen("onStateChange")(g=>this.state=g),this.c.call("_getInitialState").then(g=>this.state=g)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$g$b=M}),define(ae[40],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=void 0,e.$3k=(0,S.$8h)("IUriIdentityService")}),define(ae[266],ce([0,1,40,207,16,19,141,3,2]),function(X,e,S,R,s,M,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0;class l{static{this._clock=0}constructor(y){this.uri=y,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let b=class{constructor(y){this.g=y,this.c=new g.$Sc,this.f=2**16;const u=new Map,$=w=>{let k=u.get(w.scheme);return k===void 0&&(k=y.hasProvider(w)&&!this.g.hasCapability(w,1024),u.set(w.scheme,k)),k};this.c.add(P.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(w=>{u.delete(w.scheme)})),this.extUri=new M.$xg($),this.d=new D.$3r((w,k)=>this.extUri.compare(w,k,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,M.$Jg)(y));const u=this.d.get(y);return u?u.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new l(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort(($,w)=>$[1].time<w[1].time?1:$[1].time>w[1].time?-1:0);l._clock=0,this.d.clear();const u=this.f*.5;for(let $=0;$<u;$++)this.d.set(y[$][0],y[$][1].touch())}};e.$4r=b,e.$4r=b=ve([re(0,s.$sk)],b),(0,R.$1r)(S.$3k,b,1)}),define(ae[128],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yV=void 0,e.$yV=(0,S.$8h)("urlService")}),define(ae[267],ce([0,1,7]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p$b=e.$o$b=e.$n$b=void 0;class R{constructor(P){this.a=P}listen(P,g){throw new Error(`Event not found: ${g}`)}call(P,g,l){switch(g){case"handleURL":return this.a.handleURL(S.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${g}`)}}e.$n$b=R;class s{constructor(P){this.a=P}handleURL(P,g){return this.a.call("handleURL",[P.toJSON(),g])}}e.$o$b=s;class M{constructor(P,g){this.a=P,this.b=g}async routeCall(P,g,l,b){if(g!=="handleURL")throw new Error(`Call not found: ${g}`);if(Array.isArray(l)&&l.length>0){const v=S.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const y=/\bwindowId=(\d+)/.exec(v.query);if(y){const u=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${u}"`,v.toString(!0));const $=new RegExp(`window:${u}`),w=P.connections.find(k=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",k.ctx),$.test(k.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,g,l,b)}routeEvent(P,g){throw new Error(`Event not found: ${g}`)}}e.$p$b=M}),define(ae[268],ce([0,1,8,2,7,27]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AV=e.$zV=void 0;class D extends R.$Tc{constructor(){super(...arguments),this.a=new Set}open(l,b){const v=[...this.a.values()];return(0,S.$_g)(v.map(y=>()=>y.handleURL(l,b)),void 0,!1).then(y=>y||!1)}registerHandler(l){return this.a.add(l),(0,R.$Rc)(()=>this.a.delete(l))}}e.$zV=D;let P=class extends D{constructor(l){super(),this.b=l}create(l){let{authority:b,path:v,query:y,fragment:u}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&v&&v.indexOf("/")!==0&&(v=`/${v}`),s.URI.from({scheme:this.b.urlProtocol,authority:b,path:v,query:y,fragment:u})}};e.$AV=P,e.$AV=P=ve([re(0,M.$Hj)],P)}),define(ae[269],ce([0,1,15,8,3,2,4,7]),function(X,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q$b=void 0;class g extends M.$Tc{constructor(b,v,y,u,$,w){if(super(),this.c=v,this.f=w,this.a=[],this.b=0,b&&(w.trace("ElectronURLListener initialUrisToHandle:",b.map(f=>f.originalUrl)),this.a=b),D.$i){const f=u.isBuilt?[]:[`"${u.appRoot}"`];f.push("--open-url","--"),S.app.setAsDefaultProtocolClient($.urlProtocol,process.execPath,f)}const k=s.Event.map(s.Event.fromNodeEventEmitter(S.app,"open-url",(f,d)=>({event:f,url:d})),({event:f,url:d})=>(f.preventDefault(),d));this.B(k(f=>{const d=this.g(f);d&&this.c.open(d,{originalUrl:f})})),y.getWindows().filter(f=>f.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(y.onDidSignalReadyWindow)(()=>this.h())))}g(b){try{return P.URI.parse(b)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const b=[];for(const v of this.a)await this.c.open(v.uri,{originalUrl:v.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),b.push(v));b.length!==0&&(this.a=b,(0,R.$0g)(()=>this.h(),500,this.q))}}e.$q$b=g}),define(ae[270],ce([0,1,3,2,16,59,31]),function(X,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4$b=void 0;class P extends R.$Tc{constructor(l,b,v,y,u,$){super(),this.f=l,this.g=b,this.h=v,this.j=y,this.m=u,this.n=$,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$Wd),this.onDidChangeFile=this.a.event,this.b=M.$bi.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Bc(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,b){return this.g.open(this.t(l),b)}close(l){return this.g.close(l)}read(l,b,v,y,u){return this.g.read(l,b,v,y,u)}write(l,b,v,y,u){return this.g.write(l,b,v,y,u)}watch(l,b){this.b.set(l,l);const v=this.g.watch(this.t(l),b);return(0,R.$Rc)(()=>{this.b.delete(l),v.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,b,v){return this.g.rename(this.t(l),this.t(b),v)}readFile(l,b){return this.g.readFile(this.t(l),b)}readFileStream(l,b,v){return this.g.readFileStream(this.t(l),b,v)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,b,v){return this.g.writeFile(this.t(l),b,v)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,b){return this.g.delete(this.t(l),b)}copy(l,b,v){if((0,s.$wk)(this.g))return this.g.copy(this.t(l),this.t(b),v);throw new Error("copy not supported")}cloneFile(l,b){if((0,s.$xk)(this.g))return this.g.cloneFile(this.t(l),this.t(b));throw new Error("clone not supported")}s(l){const b=[];for(const v of l){if(v.resource.scheme!==this.f)continue;const y=this.u(v.resource);this.b.findSubstr(y)&&b.push({resource:y,type:v.type,cId:v.cId})}b.length&&(this.n.debug("User data changed"),this.a.fire(b))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}e.$4$b=P}),define(ae[271],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K$b=void 0,e.$K$b="utilityProcessWorker"}),define(ae[272],ce([0,1,6]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r$b=void 0,e.$r$b=(0,S.$8h)("webviewManagerService")}),define(ae[273],ce([0,1,15,2,13,7]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s$b=void 0;class D extends R.$Tc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const g=this.b.bind(this);S.protocol.registerFileProtocol(s.Schemas.vscodeWebview,g)}b(g,l){try{const b=M.URI.parse(g.url),v=D.a.get(b.path);if(typeof v=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${v}`,u=s.$pg.asFileUri(y);return l({path:u.fsPath,headers:{...s.COI.getHeadersFromQuery(g.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.$s$b=D}),define(ae[55],ce([0,1,4]),function(X,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=e.$ZC=e.$YC=e.$XC=e.$WC=e.$VC=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$UC=e.$TC=e.$SC=e.$RC=e.$QC=e.$PC=void 0,e.$PC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(h){return typeof h.parentId=="number"}e.$QC=R;function s(h){return!!h.workspaceUri}e.$RC=s;function M(h){return!!h.folderUri}e.$SC=M;function D(h){return!!h.fileUri}e.$TC=D;function P(h){const f=y(h),d=h.getValue("window.menuBarVisibility");return d==="default"||f&&d==="compact"||S.$j&&S.$m?"classic":d}e.$UC=P;var g;(function(h){h.TITLE_BAR_STYLE="window.titleBarStyle",h.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(g||(e.TitleBarSetting=g={}));var l;(function(h){h.NATIVE="native",h.CUSTOM="custom"})(l||(e.TitlebarStyle=l={}));var b;(function(h){h.AUTO="auto",h.WINDOWED="windowed",h.NEVER="never"})(b||(e.CustomTitleBarVisibility=b={}));function v(h,f){return!0}e.$VC=v;function y(h,f){return f||(f=u(h)),f==="native"}e.$WC=y;function u(h){if(S.$o)return"custom";const f=h.getValue("window");if(f){if(S.$j&&f.nativeTabs===!0||S.$j&&f.nativeFullScreen===!1)return"native";const c=f.titleBarStyle;if(c==="native"||c==="custom")return c}return S.$k?"native":"custom"}e.$XC=u;function $(h){return!(!S.$i||S.$o||y(h))}e.$YC=$;function w(h){const f=h.getValue("window");return!f||typeof f.nativeFullScreen!="boolean"||f.nativeTabs?!0:f.nativeFullScreen!==!1}e.$ZC=w;function k(h=0){return Math.pow(1.2,h)}e.$1C=k}),define(ae[129],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$U9b=e.UnloadReason=e.LoadReason=void 0;var S;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(S||(e.LoadReason=S={}));var R;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(R||(e.UnloadReason=R={}));const s=function(P=1){return{width:1024,height:768,mode:P}};e.$U9b=s;var M;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var D;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(ae[274],ce([0,1,8,3,2]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y$b=void 0;class M extends s.$Tc{constructor({onDidOpenMainWindow:P,onDidFocusMainWindow:g,getActiveWindowId:l}){super(),this.a=this.B(new s.$Sc),R.Event.latch(R.Event.any(P,g))(this.f,this,this.a),this.b=(0,S.$Ug)(()=>l()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$y$b=M}),define(ae[30],ce([0,1,192,9,59,19,7,6,13]),function(X,e,S,R,s,M,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.WorkbenchState=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0,e.$ei=(0,P.$8h)("contextService");function l(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$fi=l;function b(i){return typeof i?.id=="string"&&!l(i)&&!y(i)}e.$gi=b,e.$hi={id:"ext-dev"},e.$ii={id:"empty-window"};function v(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.$nc)(i)}:n?e.$hi:e.$ii;const a=i;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$ji=v;function y(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$ki=y;function u(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:D.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}e.$li=u;var $;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function w(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$mi=w;function k(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$ni=k;class h{constructor(n,a,p,A,I){this.h=n,this.j=p,this.k=A,this.l=I,this.c=s.$bi.forUris(this.l,()=>!0),this.folders=a}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$bi.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$oi=h;class f{constructor(n,a){this.raw=a,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$Ig)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$pi=f;function d(i){return new f({uri:i,index:0,name:(0,M.$Eg)(i)},{uri:i.toString()})}e.$qi=d,e.$ri="code-workspace",e.$si=`.${e.$ri}`,e.$ti=[{name:(0,S.localize)(0,null),extensions:[e.$ri]}],e.$ui="workspace.json";function m(i,n){return M.$zg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$vi=m;function c(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===g.Schemas.tmp}e.$wi=c,e.$xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$xi}e.$yi=t;function o(i,n){return!m(i,n)&&!c(i)}e.$zi=o;function r(i){return(typeof i=="string"?(0,R.$oc)(i):(0,M.$Gg)(i))===e.$si}e.$Ai=r}),define(ae[56],ce([0,1,15,8,45,47,2,85,4,21,167,116,6,5,27,30]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$39b=e.$29b=void 0,e.$29b=(0,y.$8h)("dialogMainService");let k=class{constructor(f,d){this.d=f,this.e=d,this.a=new Map,this.b=new Map,this.c=new R.$ch}pickFileFolder(f,d){return this.f({...f,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},d)}pickFolder(f,d){return this.f({...f,pickFolders:!0,title:(0,b.localize)(1,null)},d)}pickFile(f,d){return this.f({...f,pickFiles:!0,title:(0,b.localize)(2,null)},d)}pickWorkspace(f,d){const m=(0,b.localize)(3,null),c=(0,M.$5v)((0,b.localize)(4,null)),t=w.$ti;return this.f({...f,pickFiles:!0,title:m,filters:t,buttonLabel:c},d)}async f(f,d){const m={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters,defaultPath:f.defaultPath};(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&(m.properties=void 0,f.pickFiles&&f.pickFolders&&(m.properties=["multiSelections","openDirectory","openFile","createDirectory"])),m.properties||(m.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),g.$j&&m.properties.push("treatPackageAsDirectory");const c=await this.showOpenDialog(m,(d||S.BrowserWindow.getFocusedWindow())??void 0);if(c&&c.filePaths&&c.filePaths.length>0)return c.filePaths}g(f){if(f){let d=this.b.get(f.id);return d||(d=new R.$ch,this.b.set(f.id,d)),d}else return this.c}showMessageBox(f,d){return this.g(d).queue(async()=>{const{options:m,buttonIndeces:c}=(0,v.$_v)(f,this.e);let t;return d?t=await S.dialog.showMessageBox(d,m):t=await S.dialog.showMessageBox(m),{response:c[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(f,d){const m=this.j(f,d);if(!m)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(d).queue(async()=>{let c;return d?c=await S.dialog.showSaveDialog(d,f):c=await S.dialog.showSaveDialog(f),c.filePath=this.h(c.filePath),c})}finally{(0,D.$Oc)(m)}}h(f){return f&&g.$j&&(f=(0,P.$Il)(f)),f}i(f){return f.map(d=>this.h(d))}async showOpenDialog(f,d){f.defaultPath&&(await l.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const m=this.j(f,d);if(!m)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(d).queue(async()=>{let c;return d?c=await S.dialog.showOpenDialog(d,f):c=await S.dialog.showOpenDialog(f),c.filePaths=this.i(c.filePaths),c})}finally{(0,D.$Oc)(m)}}j(f,d){if(!d)return D.$Tc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",f);let m=this.a.get(d.id);m||(m=new Set,this.a.set(d.id,m));const c=(0,s.$Vi)(f);if(!m.has(c))return this.d.trace("[DialogMainService]: new file dialog lock created",f),m.add(c),(0,D.$Rc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",f),m?.delete(c),m?.size===0&&this.a.delete(d.id)})}};e.$39b=k,e.$39b=k=ve([re(0,u.$pj),re(1,$.$Hj)],k)}),define(ae[275],ce([0,1,3,2,76,30]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c$b=void 0;class D extends R.$Tc{static{this.a=100}constructor(g,l){super(),this.f=g,this.g=l,this.b=this.B(new S.$Wd),this.c=new Map,this.h(l.applicationStorage,this.b)}h(g,l){this.B(S.Event.debounce(g.onDidChangeStorage,(b,v)=>(b?b.push(v):b=[v],b),D.a)(b=>{b.length&&l.fire(this.j(b,g))}))}j(g,l){const b=new Map,v=new Set;return g.forEach(y=>{const u=l.get(y.key);typeof u=="string"?b.set(y.key,u):v.add(y.key)}),{changed:Array.from(b.entries()),deleted:Array.from(v.values())}}listen(g,l,b){switch(l){case"onDidChangeStorage":{const v=b.profile?(0,s.$Eh)(b.profile):void 0;if(!v)return this.b.event;let y=this.c.get(v.id);return y||(y=this.B(new S.$Wd),this.h(this.g.profileStorage(v),y),this.c.set(v.id,y)),y.event}}throw new Error(`Event not found: ${l}`)}async call(g,l,b){const v=b.profile?(0,s.$Eh)(b.profile):void 0,y=(0,M.$li)(b.workspace),u=await this.m(v,y);switch(l){case"getItems":return Array.from(u.items.entries());case"updateItems":{const $=b;if($.insert)for(const[w,k]of $.insert)u.set(w,k);$.delete?.forEach(w=>u.delete(w));break}case"optimize":return u.optimize();case"isUsed":{const $=b.payload;if(typeof $=="string")return this.g.isUsed($)}default:throw new Error(`Call not found: ${l}`)}}async m(g,l){let b;l?b=this.g.workspaceStorage(l):g?b=this.g.profileStorage(g):b=this.g.applicationStorage;try{await b.init()}catch(v){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":g?"profile":"application"} storage due to ${v}`)}return b}}e.$c$b=D}),define(ae[41],ce([0,1,45,3,2,19,7,189,38,16,6,5,30,31,40,8,32,25,12]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.ProfileResourceType=void 0;var d;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function m(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$4k=m,e.$5k=(0,b.$8h)("IUserDataProfilesService");function c(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$6k=c;function t(i,n,a,p,A,I){return{id:i,name:n,location:a,isDefault:!1,shortName:A?.shortName,icon:A?.icon,globalStorageHome:I&&A?.useDefaultFlags?.globalState?I.globalStorageHome:(0,M.$Ig)(a,"globalStorage"),settingsResource:I&&A?.useDefaultFlags?.settings?I.settingsResource:(0,M.$Ig)(a,"settings.json"),keybindingsResource:I&&A?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,M.$Ig)(a,"keybindings.json"),tasksResource:I&&A?.useDefaultFlags?.tasks?I.tasksResource:(0,M.$Ig)(a,"tasks.json"),snippetsHome:I&&A?.useDefaultFlags?.snippets?I.snippetsHome:(0,M.$Ig)(a,"snippets"),extensionsResource:I&&A?.useDefaultFlags?.extensions?I.extensionsResource:(0,M.$Ig)(a,"extensions.json"),cacheHome:(0,M.$Ig)(p,i),useDefaultFlags:A?.useDefaultFlags,isTransient:A?.transient}}e.$7k=t;let o=class extends s.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,a,p,A){super(),this.t=n,this.u=a,this.w=p,this.y=A,this.f=!0,this.h=this.B(new R.$Wd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Wd),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Wd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Wd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new u.$Ac,emptyWindows:new Map},this.profilesHome=(0,M.$Ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$Ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),a=[n];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,f.$Jf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}a.push(t((0,M.$Fg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},n))}}catch(I){this.y.error(I)}const p=new u.$Ac,A=new Map;if(a.length)try{const I=this.Q();if(I.workspaces)for(const[E,C]of Object.entries(I.workspaces)){const j=D.URI.parse(E),U=a.find(F=>F.id===C);U&&p.set(j,U)}if(I.emptyWindows)for(const[E,C]of Object.entries(I.emptyWindows)){const j=a.find(U=>U.id===C);j&&A.set(E,j)}}catch(I){this.y.error(I)}this.z={profiles:a,workspaces:p,emptyWindows:A}}return this.z}D(){const n=t("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const a="Temp",p=new RegExp(`${(0,h.$Pe)(a)}\\s(\\d+)`);let A=0;for(const E of this.profiles){const C=p.exec(E.name),j=C?parseInt(C[1]):0;A=j>A?j:A}const I=`${a} ${A+1}`;return this.createProfile((0,S.$Vi)((0,k.$rg)()).toString(16),I,{transient:!0},n)}async createNamedProfile(n,a,p){return this.createProfile((0,S.$Vi)((0,k.$rg)()).toString(16),n,a,p)}async createProfile(n,a,p,A){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(n,a,p);return A&&await this.setProfileForWorkspace(A,I),I}async F(n,a,p){if(!(0,f.$Jf)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let A=this.r.get(a);return A||(A=(async()=>{try{const I=this.profiles.find(j=>j.name===a||j.id===n);if(I)return I;const E=t(n,a,(0,M.$Ig)(this.profilesHome,n),this.g,p,this.defaultProfile);await this.u.createFolder(E.location);const C=[];return this.j.fire({profile:E,join(j){C.push(j)}}),await w.Promises.settled(C),this.I([E],[],[]),E}finally{this.r.delete(a)}})(),this.r.set(a,A)),A}async updateProfile(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(A=>A.id===n.id);if(!p)throw new Error(`Profile '${n.name}' does not exist`);return p=t(p.id,a.name??p.name,p.location,this.g,{shortName:a.shortName??p.shortName,icon:a.icon===null?void 0:a.icon??p.icon,transient:a.transient??p.isTransient,useDefaultFlags:a.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.I([],[],[p]),p}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(A=>A.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);const p=[];this.m.fire({profile:a,join(A){p.push(A)}});try{await Promise.allSettled(p)}catch(A){this.y.error(A)}for(const A of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(A)?.id&&this.C.emptyWindows.delete(A);for(const A of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(A)?.id&&this.C.workspaces.delete(A);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(A){(0,l.$Jk)(A)!==1&&this.y.error(A)}}async setProfileForWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(A=>A.id===a.id);if(!p)throw new Error(`Profile '${a.name}' does not exist`);this.L(n,p)}unsetWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(a=>a.isDirectory&&this.profiles.every(p=>!this.w.extUri.isEqual(p.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(n.map(a=>this.removeProfile(a)))}getProfileForWorkspace(n){const a=this.G(n);return D.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(n){return(0,y.$fi)(n)?n.uri:(0,y.$ki)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location)))}I(n,a,p){const A=[...this.profiles,...n],I=[];this.s.profiles=[];for(let E of A)E.isDefault||a.some(C=>E.id===C.id)||(E=p.find(C=>E.id===C.id)??E,E.isTransient?this.s.profiles.push(E):I.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(I),this.z=void 0,this.J(n,a,p)}J(n,a,p){this.h.fire({added:n,removed:a,updated:p,all:this.profiles})}L(n,a,p){p=a?.isTransient?!0:p,p||this.L(n,void 0,!0);const A=this.G(n),I=p?this.s:this.C;D.URI.isUri(A)?(I.workspaces.delete(A),a&&I.workspaces.set(A,a)):(I.emptyWindows.delete(A),a&&I.emptyWindows.set(A,a)),p||this.M()}M(){const n={};for(const[p,A]of this.C.workspaces.entries())n[p.toString()]=A.id;const a={};for(const[p,A]of this.C.emptyWindows.entries())a[p.toString()]=A.id;this.R({workspaces:n,emptyWindows:a}),this.z=void 0}N(n){const a={},p=this.D();if(n.workspaces)for(const[I,E]of Object.entries(n.workspaces)){const C=D.URI.parse(E);a[I]=this.w.extUri.isEqual(C,p.location)?p.id:this.w.extUri.basename(C)}const A={};if(n.emptyWindows)for(const[I,E]of Object.entries(n.emptyWindows)){const C=D.URI.parse(E);A[I]=this.w.extUri.isEqual(C,p.location)?p.id:this.w.extUri.basename(C)}return{workspaces:a,emptyWindows:A}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$8k=o,e.$8k=o=ve([re(0,g.$ci),re(1,l.$sk),re(2,$.$3k),re(3,v.$pj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$9k=r}),define(ae[81],ce([0,1,8,17,2,3,31,7,118,124,16,6,5,41,40,12,14,28]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class d extends Error{constructor(r,i){super(r),this.code=i}}e.$Wp=d,e.$Xp=(0,v.$8h)("IExtensionsProfileScannerService");let m=class extends s.$Tc{constructor(r,i,n,a,p,A){super(),this.j=r,this.m=i,this.n=n,this.r=a,this.s=p,this.t=A,this.b=this.B(new M.$Wd),this.onAddExtensions=this.b.event,this.c=this.B(new M.$Wd),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$Wd),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$Wd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],a=[];try{return await this.u(i,p=>{const A=[];for(const I of p)r.some(([E])=>(0,l.$3o)(E.identifier,I.identifier)&&E.manifest.version!==I.version)?n.push(I):A.push(I);for(const[I,E]of r){const C=A.findIndex(U=>(0,l.$3o)(U.identifier,I.identifier)&&U.version===I.manifest.version),j={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:E};C===-1?(a.push(j),A.push(j)):A.splice(C,1,j)}return a.length&&this.b.fire({extensions:a,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),A}),a.length&&this.c.fire({extensions:a,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),a}catch(p){throw a.length&&this.c.fire({extensions:a,error:p,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:p,profileLocation:i}),p}}async updateMetadata(r,i){const n=[];return await this.u(i,a=>{const p=[];for(const A of a){const I=r.find(([E])=>(0,l.$3o)(E.identifier,A.identifier)&&E.manifest.version===A.version);I&&(A.metadata={...A.metadata,...I[1]},n.push(A)),p.push(A)}return p}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,a=>{const p=[];for(const A of a)(0,l.$3o)(A.identifier,r.identifier)?n.push(A):p.push(A);return n.length&&this.f.fire({extensions:n,profileLocation:i}),p}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(a){throw n.length&&this.g.fire({extensions:n,error:a,profileLocation:i}),a}}async u(r,i,n){return this.F(r).queue(async()=>{let a=[],p;try{const A=await this.m.readFile(r);p=JSON.parse(A.value.toString().trim()||"[]")}catch(A){if((0,b.$Jk)(A)!==1)throw A;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(p=await this.D()),!p&&n?.bailOutWhenFileNotFound)throw new d((0,k.$0)(A),"ERROR_PROFILE_NOT_FOUND")}if(p){Array.isArray(p)||this.w(r);let A=!1;for(const I of p){c(I)||this.w(r);let E;if((0,w.$Jf)(I.relativeLocation)&&I.relativeLocation)E=this.z(I.relativeLocation);else if((0,w.$Jf)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{E=P.URI.revive(I.location);const C=this.y(E);C&&(A=!0,I.relativeLocation=C)}(0,w.$Qf)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(A=!0,I.metadata.hasPreReleaseVersion=!0),a.push({identifier:I.identifier,location:E,version:I.version,metadata:I.metadata})}A&&await this.m.writeFile(r,R.$ke.fromString(JSON.stringify(p)))}if(i){a=i(a);const A=a.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(r,R.$ke.fromString(JSON.stringify(A)))}return a})}w(r){const i=new d(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(p){if((0,b.$Jk)(p)===1)return;throw p}this.t.info("Migrating extensions from old default profile location",r.toString());let a;try{const p=JSON.parse(n);Array.isArray(p)&&p.every(A=>c(A))?a=p:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",p)}catch(p){this.t.error(p)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$ke.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(p){if((0,b.$Jk)(p)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw p}try{await this.m.del(r)}catch(p){(0,b.$Jk)(p)!==1&&this.t.error(p)}try{await this.m.del(i)}catch(p){(0,b.$Jk)(p)!==1&&this.t.error(p)}return a})()),this.C}F(r){let i=this.h.get(r);return i||(i=new S.$ch,this.h.set(r,i)),i}};e.$Yp=m,e.$Yp=m=ve([re(1,b.$sk),re(2,u.$5k),re(3,$.$3k),re(4,h.$wl),re(5,y.$pj)],m);function c(o){return(0,w.$Lf)(o)&&(0,g.$Ao)(o.identifier)&&(t(o.location)||(0,w.$Jf)(o.location)&&o.location)&&((0,w.$Qf)(o.relativeLocation)||(0,w.$Jf)(o.relativeLocation))&&o.version&&(0,w.$Jf)(o.version)}function t(o){return o?(0,w.$Jf)(o.path)&&(0,w.$Jf)(o.scheme):!1}}),define(ae[130],ce([0,1,22,8,35,17,14,42,152,2,13,9,4,19,205,73,12,7,172,38,124,121,204,16,6,5,27,3,76,81,41,40,203]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h,f,d,m,c,t,o,r,i,n,a,p,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.Translations=void 0;var j;(function(ue){function Z(Y,q){if(Y===q)return!0;const L=Object.keys(Y),N=new Set;for(const G of Object.keys(q))N.add(G);if(L.length!==N.size)return!1;for(const G of L){if(Y[G]!==q[G])return!1;N.delete(G)}return N.size===0}ue.equals=Z})(j||(e.Translations=j={})),e.$2p=(0,r.$8h)("IExtensionsScannerService");let U=class extends l.$Tc{constructor(Z,Y,q,L,N,G,B,te,he,K,O,W){super(),this.systemExtensionsLocation=Z,this.userExtensionsLocation=Y,this.r=q,this.s=L,this.t=N,this.u=G,this.w=B,this.y=te,this.z=he,this.C=K,this.D=O,this.F=W,this.g=this.B(new a.$Wd),this.onDidChangeCache=this.g.event,this.h=(0,u.$Ig)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(J,this.s,this.h)),this.m=this.B(this.F.createInstance(J,this.s,this.h)),this.n=this.B(this.F.createInstance(V,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,m.$bp)(this.w,this.y)),this.G}async scanAllExtensions(Z,Y,q){const[L,N]=await Promise.all([this.scanSystemExtensions(Z),this.scanUserExtensions(Y)]),G=q?await this.scanExtensionsUnderDevelopment(Z,[...L,...N]):[];return this.L(L,N,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Z){const Y=[];Y.push(this.M(!!Z.useCache,Z.language)),Y.push(this.N(Z.language,!!Z.checkControlFile));const[q,L]=await Promise.all(Y);return this.J([...q,...L],0,Z,!1)}async scanUserExtensions(Z){const Y=Z.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Y);const q=this.D.extUri.isEqual(Z.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(Y,!!Z.profileLocation,1,!Z.includeUninstalled,Z.language,!0,q),N=Z.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let G;try{G=await N.scanExtensions(L)}catch(B){if(B instanceof A.$Wp&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await N.scanExtensions(L);else throw B}return G=await this.J(G,1,Z,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(Z,Y){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===b.Schemas.file).map(async L=>{const N=await this.P(L,!1,1,!0,Z.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(N)).map(B=>(B.type=Y.find(te=>(0,m.$3o)(te.identifier,B.identifier))?.type??B.type,this.n.validate(B,N)))}))).flat();return this.J(q,"development",Z,!0)}return[]}async scanExistingExtension(Z,Y,q){const L=await this.P(Z,!1,Y,!0,q.language,!0,void 0),N=await this.n.scanExtension(L);return!N||!q.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(Z,Y,q){const L=await this.P(Z,!1,Y,!0,q.language,!0,void 0),N=await this.n.scanOneOrMultipleExtensions(L);return this.J(N,Y,q,!0)}async scanMetadata(Z){const Y=(0,u.$Ig)(Z,"package.json"),q=(await this.w.readFile(Y)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(Z,Y){const q=(0,u.$Ig)(Z,"package.json"),L=(await this.w.readFile(q)).value.toString(),N=JSON.parse(L);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,N.__metadata={...N.__metadata,...Y},await this.w.writeFile((0,u.$Ig)(Z,"package.json"),M.$ke.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Z){if(Z instanceof A.$Wp&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Z}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Z=await this.scanUserExtensions({includeInvalid:!0});if(Z.length)await this.u.addExtensionsToProfile(Z.map(Y=>[Y,Y.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$ke.fromString(JSON.stringify([])))}catch(Y){(0,o.$Jk)(Y)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(Y))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Z){this.y.error(Z)}finally{this.H=void 0}})()),this.H}async J(Z,Y,q,L){return q.includeAllVersions||(Z=this.L(Y===0?Z:void 0,Y===1?Z:void 0,Y==="development"?Z:void 0,await this.getTargetPlatform(),L)),q.includeInvalid||(Z=Z.filter(N=>N.isValid)),Z.sort((N,G)=>{const B=v.$nc(N.location.fsPath),te=v.$nc(G.location.fsPath);return B<te?-1:B>te?1:0})}L(Z,Y,q,L,N){const G=(te,he,K)=>{if(te.isValid&&!he.isValid)return!1;if(te.isValid===he.isValid){if(N&&$.gt(te.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if($.eq(te.manifest.version,he.manifest.version)){if(te.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===L)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${te.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${te.location.path} with ${he.location.path}.`),!0},B=new c.$pm;return Z?.forEach(te=>{const he=B.get(te.identifier.id);(!he||G(he,te,!1))&&B.set(te.identifier.id,te)}),Y?.forEach(te=>{const he=B.get(te.identifier.id);if(!he&&Z&&te.type===0){this.y.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!he||G(he,te,!1))&&B.set(te.identifier.id,te)}),q?.forEach(te=>{const he=B.get(te.identifier.id);(!he||G(he,te,!0))&&B.set(te.identifier.id,te),B.set(te.identifier.id,te)}),[...B.values()]}async M(Z,Y){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),N=await(Z&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",N.length),N}async N(Z,Y){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const L=Y?await this.O():{},N=[],G=h.URI.file(v.$hc(v.$jc(b.$pg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of q){const he=L[te.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":N.push((0,u.$Ig)(G,te.name));break;default:N.push(h.URI.file(he));break}}const B=await Promise.all(N.map(async te=>this.n.scanExtension(await this.P(te,!1,0,!0,Z,!0,void 0))));return this.y.trace("Scanned dev system extensions:",B.length),(0,S.$Hb)(B)}async O(){try{const Z=await this.w.readFile(this.r);return JSON.parse(Z.value.toString())}catch{return{}}}async P(Z,Y,q,L,N,G,B){const te=await this.f(N??y.$w),he=await this.Q(Z),K=Y&&!this.D.extUri.isEqual(Z,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=K?await this.Q(K):void 0;return new F(Z,he,K,O,Y,B,q,L,G,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,N,te)}async Q(Z){try{const Y=await this.w.stat(Z);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};e.$3p=U,e.$3p=U=ve([re(4,I.$5k),re(5,A.$Xp),re(6,o.$sk),re(7,i.$pj),re(8,d.$ci),re(9,n.$Hj),re(10,E.$3k),re(11,r.$7h)],U);class F{constructor(Z,Y,q,L,N,G,B,te,he,K,O,W,x,T,Q){this.location=Z,this.mtime=Y,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=L,this.profile=N,this.profileScanOptions=G,this.type=B,this.excludeObsolete=te,this.validate=he,this.productVersion=K,this.productDate=O,this.productCommit=W,this.devMode=x,this.language=T,this.translations=Q}static createNlsConfiguration(Z){return{language:Z.language,pseudo:Z.language==="pseudo",devMode:Z.devMode,translations:Z.translations}}static equals(Z,Y){return(0,u.$Bg)(Z.location,Y.location)&&Z.mtime===Y.mtime&&(0,u.$Bg)(Z.applicationExtensionslocation,Y.applicationExtensionslocation)&&Z.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&Z.profile===Y.profile&&s.$Cn(Z.profileScanOptions,Y.profileScanOptions)&&Z.type===Y.type&&Z.excludeObsolete===Y.excludeObsolete&&Z.validate===Y.validate&&Z.productVersion===Y.productVersion&&Z.productDate===Y.productDate&&Z.productCommit===Y.productCommit&&Z.devMode===Y.devMode&&Z.language===Y.language&&j.equals(Z.translations,Y.translations)}}e.$4p=F;let V=class extends l.$Tc{constructor(Z,Y,q,L,N){super(),this.f=Z,this.g=Y,this.h=q,this.j=L,this.m=N}async scanExtensions(Z){const Y=Z.profile?await this.r(Z):await this.n(Z);let q={};if(Z.excludeObsolete&&Z.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(L)}catch{}return(0,k.$Wf)(q)?Y:Y.filter(L=>!q[m.$4o.create(L).toString()])}async n(Z){const Y=await this.j.resolve(Z.location);if(!Y.children?.length)return[];const q=await Promise.all(Y.children.map(async L=>{if(!L.isDirectory||Z.type===1&&(0,u.$Fg)(L.resource).indexOf(".")===0)return null;const N=new F(L.resource,Z.mtime,Z.applicationExtensionslocation,Z.applicationExtensionslocationMtime,Z.profile,Z.profileScanOptions,Z.type,Z.excludeObsolete,Z.validate,Z.productVersion,Z.productDate,Z.productCommit,Z.devMode,Z.language,Z.translations);return this.scanExtension(N)}));return(0,S.$Hb)(q).sort((L,N)=>L.location.path<N.location.path?-1:1)}async r(Z){let Y=await this.s(Z.location,()=>!0,Z);if(Z.applicationExtensionslocation&&!this.h.extUri.isEqual(Z.location,Z.applicationExtensionslocation)){Y=Y.filter(L=>!L.metadata?.isApplicationScoped);const q=await this.s(Z.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,Z);Y.push(...q)}return Y}async s(Z,Y,q){const L=await this.g.scanProfileExtensions(Z,q.profileScanOptions);if(!L.length)return[];const N=await Promise.all(L.map(async G=>{if(Y(G)){const B=new F(G.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(B,G.metadata)}return null}));return(0,S.$Hb)(N)}async scanOneOrMultipleExtensions(Z){try{if(await this.j.exists((0,u.$Ig)(Z.location,"package.json"))){const Y=await this.scanExtension(Z);return Y?[Y]:[]}else return await this.scanExtensions(Z)}catch(Y){return this.m.error(`Error scanning extensions at ${Z.location.path}:`,(0,D.$0)(Y)),[]}}async scanExtension(Z,Y){try{let q=await this.scanExtensionManifest(Z.location);if(q){q.publisher||(q.publisher=c.$jm),Y=Y??q.__metadata,delete q.__metadata;const L=(0,m.$8o)(q.publisher,q.name),N=Y?.id?{id:L,uuid:Y.id}:{id:L},G=Y?.isSystem?0:Z.type,B=G===0||!!Y?.isBuiltin;q=await this.t(Z.location,q,F.createNlsConfiguration(Z));const te={type:G,identifier:N,manifest:q,location:Z.location,isBuiltin:B,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return Z.validate?this.validate(te,Z):te}}catch(q){Z.type!==0&&this.m.error(q)}return null}validate(Z,Y){let q=!0;const L=(0,t.$gp)(Y.productVersion,Y.productDate,Y.location,Z.manifest,Z.isBuiltin);for(const[N,G]of L)N===w.default.Error&&(q=!1,this.m.error(this.z(Y.location,G)));return Z.isValid=q,Z.validations=L,Z}async scanExtensionManifest(Z){const Y=(0,u.$Ig)(Z,"package.json");let q;try{q=(await this.j.readFile(Y)).value.toString()}catch(N){return(0,o.$Jk)(N)!==1&&this.m.error(this.z(Z,(0,f.localize)(0,null,Y.path,N.message))),null}let L;try{L=JSON.parse(q)}catch{const G=[];(0,P.$fn)(q,G);for(const B of G)this.m.error(this.z(Z,(0,f.localize)(1,null,Y.path,B.offset,B.length,(0,g.$Zp)(B.error))));return null}return(0,P.$on)(L)!=="object"?(this.m.error(this.z(Z,(0,f.localize)(2,null,Y.path))),null):L}async t(Z,Y,q){const L=await this.u(Z,Y,q);if(L)try{const N=[],G=await this.w(L.default,N);if(N.length>0)return N.forEach(te=>{this.m.error(this.z(Z,(0,f.localize)(3,null,L.default?.path,(0,g.$Zp)(te.error))))}),Y;if((0,P.$on)(L)!=="object")return this.m.error(this.z(Z,(0,f.localize)(4,null,L.default?.path))),Y;const B=L.values||Object.create(null);return(0,C.$1p)(this.m,Y,B,G)}catch{}return Y}async u(Z,Y,q){const L=(0,u.$Ig)(Z,"package.nls.json"),N=(he,K)=>{K.forEach(O=>{this.m.error(this.z(Z,(0,f.localize)(5,null,he?.path,(0,g.$Zp)(O.error))))})},G=he=>{this.m.error(this.z(Z,(0,f.localize)(6,null,he?.path)))},B=`${Y.publisher}.${Y.name}`,te=q.translations[B];if(te)try{const he=h.URI.file(te),K=(await this.j.readFile(he)).value.toString(),O=[],W=(0,P.$fn)(K,O);return O.length>0?(N(he,O),{values:void 0,default:L}):(0,P.$on)(W)!=="object"?(G(he),{values:void 0,default:L}):{values:W.contents?W.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let K;try{K=await this.y(Z,q)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const O=(await this.j.readFile(K.localized)).value.toString(),W=[],x=(0,P.$fn)(O,W);return W.length>0?(N(K.localized,W),{values:void 0,default:K.original}):(0,P.$on)(x)!=="object"?(G(K.localized),{values:void 0,default:K.original}):{values:x,default:K.original}}catch{return{values:void 0,default:K.original}}}}async w(Z,Y){if(Z)try{const q=(await this.j.readFile(Z)).value.toString();return(0,P.$fn)(q,Y)}catch{}}y(Z,Y){return new Promise((q,L)=>{const N=G=>{const B=(0,u.$Ig)(Z,`package.nls.${G}.json`);this.j.exists(B).then(te=>{te&&q({localized:B,original:(0,u.$Ig)(Z,"package.nls.json")});const he=G.lastIndexOf("-");he===-1?q({localized:(0,u.$Ig)(Z,"package.nls.json"),original:null}):(G=G.substring(0,he),N(G))})};if(Y.devMode||Y.pseudo||!Y.language)return q({localized:(0,u.$Ig)(Z,"package.nls.json"),original:null});N(Y.language)})}z(Z,Y){return`[${Z.path}]: ${Y}`}};V=ve([re(1,A.$Xp),re(2,E.$3k),re(3,o.$sk),re(4,i.$pj)],V);let J=class extends V{constructor(Z,Y,q,L,N,G,B){super(Y,L,N,G,B),this.G=Z,this.H=q,this.D=this.B(new R.$6g(3e3)),this.F=this.B(new a.$Wd),this.onDidChangeCache=this.F.event}async scanExtensions(Z){const Y=this.M(Z),q=await this.I(Y);if(this.C=Z,q&&q.input&&F.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",Z.location.toString()),this.D.trigger(()=>this.L()),q.result.map(N=>(N.location=h.URI.revive(N.location),N));const L=await super.scanExtensions(Z);return await this.J(Y,{input:Z,result:L}),L}async I(Z){try{const Y=await this.j.readFile(Z),q=JSON.parse(Y.value.toString());return{result:q.result,input:(0,p.$Eh)(q.input)}}catch(Y){this.m.debug("Error while reading the extension cache file:",Z.path,(0,D.$0)(Y))}return null}async J(Z,Y){try{await this.j.writeFile(Z,M.$ke.fromString(JSON.stringify(Y)))}catch(q){this.m.debug("Error while writing the extension cache file:",Z.path,(0,D.$0)(q))}}async L(){if(!this.C)return;const Z=this.M(this.C),Y=await this.I(Z);if(!Y)return;const q=Y.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$Cn(L,q))try{this.m.info("Invalidating Cache",q,L),await this.j.del(Z),this.F.fire()}catch(N){this.m.error(N)}}M(Z){const Y=this.N(Z);return this.h.extUri.joinPath(Y.cacheHome,Z.type===0?c.$im:c.$hm)}N(Z){return Z.type===0?this.H.defaultProfile:Z.profile?this.h.extUri.isEqual(Z.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Y=>this.h.extUri.isEqual(Z.location,Y.extensionsResource))??this.G:this.H.defaultProfile}};J=ve([re(2,I.$5k),re(3,A.$Xp),re(4,E.$3k),re(5,o.$sk),re(6,i.$pj)],J);function le(ue,Z){const Y=(0,m.$6o)(ue.manifest.publisher,ue.manifest.name);return{id:Y,identifier:new c.$nm(Y),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:Z,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.$5p=le;class oe extends U{constructor(Z,Y,q,L,N,G,B,te,he,K,O,W){super(Z,Y,(0,u.$Ig)(q,".vscode-oss-dev","extensions","control.json"),L,N,G,B,te,he,K,O,W),this.R=(async()=>{if(y.$z)try{const x=await this.w.readFile(h.URI.file(y.$z));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}f(Z){return this.R}}e.$6p=oe}),define(ae[276],ce([0,1,5,41,40,28,81,16,38,7]),function(X,e,S,R,s,M,D,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=void 0;let b=class extends D.$Yp{constructor(y,u,$,w,k,h){super(l.URI.file(y.extensionsPath),u,$,w,k,h)}};e.$KO=b,e.$KO=b=ve([re(0,g.$di),re(1,P.$sk),re(2,R.$5k),re(3,s.$3k),re(4,M.$wl),re(5,S.$pj)],b)}),define(ae[277],ce([0,1,7,38,81,130,16,6,5,27,40,41]),function(X,e,S,R,s,M,D,P,g,l,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C$b=void 0;let y=class extends M.$6p{constructor($,w,k,h,f,d,m,c){super(S.URI.file(f.builtinExtensionsPath),S.URI.file(f.extensionsPath),f.userHome,$.defaultProfile,$,w,k,h,f,d,m,c)}};e.$C$b=y,e.$C$b=y=ve([re(0,v.$5k),re(1,s.$Xp),re(2,D.$sk),re(3,g.$pj),re(4,R.$di),re(5,l.$Hj),re(6,b.$3k),re(7,P.$7h)],y)}),define(ae[278],ce([0,1,15,2,13,9,4,59,7,32,37,38,5,41]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U$b=void 0;let $=class extends R.$Tc{constructor(k,h,f){super(),this.c=k,this.f=f,this.a=P.$bi.forPaths(!D.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(k.appRoot),this.addValidFileRoot(k.extensionsPath),this.addValidFileRoot(h.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(k.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:k}=S.session;k.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(h,f)=>this.j(h,f)),k.protocol.interceptFileProtocol(s.Schemas.file,(h,f)=>this.h(h,f)),this.B((0,R.$Rc)(()=>{k.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),k.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(k){const h=(0,M.$hc)(k);return this.a.get(h)?R.$Tc.None:(this.a.set(h,!0),(0,R.$Rc)(()=>this.a.delete(h)))}h(k,h){const f=g.URI.parse(k.url);return this.f.error(`Refused to load resource ${f.fsPath} from ${s.Schemas.file}: protocol (original URL: ${k.url})`),h({error:-3})}j(k,h){const f=this.m(k);let d;return this.c.crossOriginIsolated&&((0,M.$nc)(f)==="workbench.html"||(0,M.$nc)(f)==="workbench-dev.html"?d=s.COI.CoopAndCoep:d=s.COI.getHeadersFromQuery(k.url)),this.a.findSubstr(f)?h({path:f,headers:d}):this.b.has((0,M.$oc)(f).toLowerCase())?h({path:f}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${k.url})`),h({error:-3}))}m(k){const h=g.URI.parse(k.url),f=s.$pg.uriToFileUri(h);return(0,M.$hc)(f.fsPath)}createIPCObjectUrl(){let k;const h=g.URI.from({scheme:"vscode",path:(0,l.$rg)()}),f=h.toString(),d=async()=>k;return b.$JU.handle(f,d),this.f.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:h,update:m=>k=m,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${f}.`),b.$JU.removeHandler(f)}}}};e.$U$b=$,e.$U$b=$=ve([re(0,v.$di),re(1,u.$5k),re(2,y.$pj)],$)}),define(ae[96],ce([0,1,8,3,2,67,12,112,6,41]),function(X,e,S,R,s,M,D,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$wp=e.$vp=e.$up=void 0,e.$up="__$__isNewStorageMarker",e.$vp="__$__targetStorageMarker",e.$wp=(0,g.$8h)("storageService");var b;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(b||(e.WillSaveStateReason=b={}));var v;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var y;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function u(f){const d=f.get(e.$vp);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.$xp=u;class $ extends s.$Tc{static{this.a=60*1e3}constructor(d={flushInterval:$.a}){super(),this.m=d,this.b=this.B(new R.$Zd),this.c=this.B(new R.$Zd),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Wd),this.onWillSaveState=this.f.event,this.h=this.B(new S.$hh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(d,m,c){return R.Event.filter(this.b.event,t=>t.scope===d&&(m===void 0||t.key===m),c)}n(){this.j.value=(0,S.$lh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(d,m){const{key:c,external:t}=m;if(c===e.$vp){switch(d){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:c,target:this.J(d)[c],external:t})}w(d){this.f.fire({reason:d})}get(d,m,c){return this.P(m)?.get(d,c)}getBoolean(d,m,c){return this.P(m)?.getBoolean(d,c)}getNumber(d,m,c){return this.P(m)?.getNumber(d,c)}getObject(d,m,c){return this.P(m)?.getObject(d,c)}storeAll(d,m){this.y(()=>{for(const c of d)this.store(c.key,c.value,c.scope,c.target,m)})}store(d,m,c,t,o=!1){if((0,D.$Sf)(m)){this.remove(d,c,o);return}this.y(()=>{this.z(d,c,t),this.P(c)?.set(d,m,o)})}remove(d,m,c=!1){this.y(()=>{this.z(d,m,void 0),this.P(m)?.delete(d,c)})}y(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,m){const c=[],t=this.J(d);for(const o of Object.keys(t))t[o]===m&&c.push(o);return c}z(d,m,c,t=!1){const o=this.J(m);typeof c=="number"?o[d]!==c&&(o[d]=c,this.P(m)?.set(e.$vp,JSON.stringify(o),t)):typeof o[d]=="number"&&(delete o[d],this.P(m)?.set(e.$vp,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(d){switch(d){case-1:return this.I;case 0:return this.G;default:return this.D}}L(d){const m=this.P(d);return m?u(m):Object.create(null)}isNew(d){return this.getBoolean(e.$up,d)===!0}async flush(d=b.NONE){this.f.fire({reason:d});const m=this.P(-1),c=this.P(0),t=this.P(1);switch(d){case b.NONE:await S.Promises.settled([m?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await S.Promises.settled([m?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,c=this.P(1)?.items??new Map;return h(d,m,c,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(d){return await this.flush(),this.P(d)?.optimize()}async switch(d,m){return this.w(b.NONE),(0,l.$4k)(d)?this.R(d,m):this.S(d,m)}M(d,m){return!(d.id===m.id||w(m)&&w(d))}N(d,m,c){this.y(()=>{const t=new Set;for(const[o,r]of d)t.add(o),m.get(o)!==r&&this.u(c,{key:o,external:!0});for(const[o]of m.items)t.has(o)||this.u(c,{key:o,external:!0})})}}e.$yp=$;function w(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$zp=w;class k extends ${constructor(){super(),this.U=this.B(new P.$sp(new P.$tp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$sp(new P.$tp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$sp(new P.$tp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(d=>this.u(1,d))),this.B(this.W.onDidChangeStorage(d=>this.u(0,d))),this.B(this.U.onDidChangeStorage(d=>this.u(-1,d)))}P(d){switch(d){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(d){return!1}}e.$Ap=k;async function h(f,d,m,c,t,o){const r=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,n=new Map;f.forEach((j,U)=>{i.set(U,j),n.set(U,r(j))});const a=new Map,p=new Map;d.forEach((j,U)=>{a.set(U,j),p.set(U,r(j))});const A=new Map,I=new Map;m.forEach((j,U)=>{A.set(U,j),I.set(U,r(j))}),console.group(c!==t?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const E=[];if(i.forEach((j,U)=>{E.push({key:U,value:j})}),console.table(E),console.groupEnd(),console.log(n),c!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];a.forEach((U,F)=>{j.push({key:F,value:U})}),console.table(j),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${o})`);const C=[];A.forEach((j,U)=>{C.push({key:U,value:j})}),console.table(C),console.groupEnd(),console.log(I)}e.$Bp=h}),define(ae[279],ce([0,1,22,8,3,2,9,72,7,21,112,161,5,96,28,30,13]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s0b=e.$r0b=e.$q0b=e.$p0b=void 0;class h extends M.$Tc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new s.$Wd),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Wd),this.onDidCloseStorage=this.c.event,this.f=this.B(new b.$sp(new b.$tp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new R.$sh,this.whenInit=this.h.p,this.j=b.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===b.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const i=r.getBoolean(u.$up);i===void 0?r.set(u.$up,!0):i&&r.set(u.$up,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=b.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===y.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new P.$Sd(!1);await this.w(),r.stop(),r.elapsed()>h.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,S.top)(Array.from(this.f.items.entries()).map(([a,p])=>({key:a,length:p.length})),(a,p)=>p.length-a.length,5).map(a=>`${a.key}:${a.length}`).join(", "),n=(await this.n.stat(g.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=b.StorageState.Closed,await this.f.close()}}class f extends h{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,D.$jc)(this.z.globalStorageHome.with({scheme:k.Schemas.file}).fsPath,f.y)}constructor(r,i,n,a){super(n,a),this.z=r,this.C=i}async t(){return new b.$sp(new v.$cV(this.path??v.$cV.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:b.StorageHint.STORAGE_IN_MEMORY})}}class d extends f{constructor(r,i,n,a){super(r,i,n,a)}}e.$p0b=d;class m extends f{constructor(r,i,n,a){super(i.defaultProfile,r,n,a)}async s(r){await super.s(r),this.G(r)}G(r){r.get($.$zl,void 0)===void 0&&r.set($.$zl,new Date().toUTCString());const n=r.get($.$yl,void 0),a=new Date().toUTCString();r.set($.$Al,typeof n>"u"?null:n),r.set($.$yl,a)}}e.$q0b=m;class c extends h{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,this.C.id,c.y)}constructor(r,i,n,a,p){super(n,p),this.C=r,this.D=i,this.F=a}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new b.$sp(new v.$cV(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?b.StorageHint.STORAGE_IN_MEMORY:i?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:v.$cV.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,this.C.id),i=(0,D.$jc)(r,c.y);return await l.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await l.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,w.$fi)(this.C)?i={folder:this.C.uri.toString()}:(0,w.$ki)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const n=(0,D.$jc)(r,c.z);await l.Promises.exists(n)||await l.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$r0b=c;class t extends h{get path(){}async t(){return new b.$sp(new b.$tp,{hint:b.StorageHint.STORAGE_IN_MEMORY})}}e.$s0b=t}),define(ae[280],ce([0,1,3,2,96]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$b=void 0;class M extends R.$Tc{constructor(P,g,l){super(),this.b=P,this.c=g,this.f=l;const b=this.B(new R.$Uc);this.a=this.B(new S.$Wd({onWillAddFirstListener:()=>b.value=this.g(),onDidRemoveLastListener:()=>b.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new R.$Sc;return P.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(g,l)=>(g?g.push(l.key):g=[l.key],g),100)(g=>this.h(g))),P.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(g,l)=>{g||(g=new Map);let b=g.get(l.profile.id);return b||g.set(l.profile.id,b={profile:l.profile,keys:[],storage:l.storage}),b.keys.push(l.key),g},100)(g=>this.j(g))),P}h(P){const g=P.includes(s.$vp)?[this.c.defaultProfile]:[],l=[];if(P=P.filter(b=>b!==s.$vp),P.length){const b=(0,s.$xp)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:P.map(v=>({key:v,scope:0,target:b[v]}))})}this.m(g,l)}j(P){const g=[],l=new Map;for(const[b,v]of P.entries()){v.keys.includes(s.$vp)&&g.push(v.profile);const y=v.keys.filter(u=>u!==s.$vp);if(y.length){const u=(0,s.$xp)(v.storage.storage);l.set(b,{profile:v.profile,changes:y.map($=>({key:$,scope:0,target:u[$]}))})}}this.m(g,[...l.values()])}m(P,g){(P.length||g.length)&&this.a.fire({valueChanges:g,targetChanges:P})}listen(P,g,l){switch(g){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${g}`)}async call(P,g){throw new Error(`Call not found: ${g}`)}}e.$E$b=M}),define(ae[281],ce([0,1,7,38,16,5,34,40,41,12,122]),function(X,e,S,R,s,M,D,P,g,l,b){"use strict";var v,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=e.$IO=e.$HO=void 0;let u=class extends g.$8k{static{v=this}static{this.a="profileAssociationsMigration"}constructor(h,f,d,m,c){super(d,m,f,c),this.U=h,this.W=d}O(){return this.U.getItem(v.b,[]).map(f=>({...f,location:(0,l.$Jf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):S.URI.revive(f.location)}))}Q(){const h=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$HO=u,e.$HO=u=v=ve([re(0,D.$CO),re(1,P.$3k),re(2,R.$di),re(3,s.$sk),re(4,M.$pj)],u);let $=y=class extends u{constructor(h,f,d,m,c){super(h,f,d,m,c),this.$=h}P(h){h.length?this.$.setItem(y.b,h.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(y.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(y.c,h):this.$.removeItem(y.c)}Q(){const h="workspaceAndProfileInfo",f=this.$.getItem(h,void 0);if(f){this.$.removeItem(h);const m=f.reduce((c,{workspace:t,profile:o})=>(c[S.URI.revive(t).toString()]=S.URI.revive(o).toString(),c),{});this.$.setItem(y.c,{workspaces:m})}const d=super.Q();return this.$.getItem(y.a,!1)||(this.R(d),this.$.setItem(y.a,!0)),d}};e.$IO=$,e.$IO=$=y=ve([re(0,D.$DO),re(1,P.$3k),re(2,R.$di),re(3,s.$sk),re(4,M.$pj)],$);let w=class extends ${constructor(h,f,d,m){super(new b.$GO(0,f,m,d),h,f,d,m)}async init(){return await this.$.init(),super.init()}};e.$JO=w,e.$JO=w=ve([re(0,P.$3k),re(1,R.$di),re(2,s.$sk),re(3,M.$pj)],w)}),define(ae[57],ce([0,1,38,16,6,5,40,41,281,34]),function(X,e,S,R,s,M,D,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$9b=e.$09b=void 0,e.$09b=(0,s.$9h)(P.$5k);let b=class extends g.$IO{constructor(y,u,$,w,k){super(y,u,$,w,k)}getAssociatedEmptyWindows(){const y=[];for(const u of this.C.emptyWindows.keys())y.push({id:u});return y}};e.$$9b=b,e.$$9b=b=ve([re(0,l.$DO),re(1,D.$3k),re(2,S.$di),re(3,R.$sk),re(4,M.$pj)],b)}),define(ae[131],ce([0,1,19,7,30]),function(X,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b0b=e.$a0b=e.$_9b=void 0;async function M(g,l,b){for(const y of g){const u=y.openedWorkspace;if((0,s.$ki)(u)){const $=await b(u);if($){if($.folders.some(w=>S.$zg.isEqualOrParent(l,w.uri)))return y}else if(S.$zg.isEqualOrParent(l,u.configPath))return y}}const v=g.filter(y=>(0,s.$fi)(y.openedWorkspace)&&S.$zg.isEqualOrParent(l,y.openedWorkspace.uri));if(v.length)return v.sort((y,u)=>-(y.openedWorkspace.uri.path.length-u.openedWorkspace.uri.path.length))[0]}e.$_9b=M;function D(g,l){for(const b of g)if((0,s.$ki)(b.openedWorkspace)&&S.$zg.isEqual(b.openedWorkspace.configPath,l)||(0,s.$fi)(b.openedWorkspace)&&S.$zg.isEqual(b.openedWorkspace.uri,l))return b}e.$a0b=D;function P(g,l){const b=v=>l.some(y=>S.$zg.isEqual(R.URI.file(y),R.URI.file(v)));for(const v of g)if(v.config?.extensionDevelopmentPath?.some(y=>b(y)))return v}e.$b0b=P}),define(ae[97],ce([0,1,33,42,101,47,13,9,4,19,7,6,60,30]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cb=e.$Zcb=e.$Ycb=e.$Xcb=e.$Wcb=e.$Vcb=e.$Ucb=e.$Tcb=e.$Scb=e.$Rcb=void 0,e.$Rcb=(0,v.$8h)("workspacesService");function $(I){return I.hasOwnProperty("workspace")}e.$Scb=$;function w(I){return I.hasOwnProperty("folderUri")}e.$Tcb=w;function k(I){return I.hasOwnProperty("fileUri")}e.$Ucb=k;function h(I){return f(I)||d(I)}e.$Vcb=h;function f(I){const E=I;return typeof E?.path=="string"&&(!E.name||typeof E.name=="string")}function d(I){const E=I;return typeof E?.uri=="string"&&(!E.name||typeof E.name=="string")}function m(I,E,C,j,U){if(I.scheme!==j.scheme)return{name:C,uri:I.toString(!0)};let F=E?void 0:U.relativePath(j,I);if(F!==void 0)F.length===0?F=".":g.$i&&(F=c(F));else if(I.scheme===D.Schemas.file)F=I.fsPath,g.$i&&(F=c(F));else if(U.isEqualAuthority(I.authority,j.authority))F=I.path;else return{name:C,uri:I.toString(!0)};return{name:C,path:F}}e.$Wcb=m;function c(I){return I=(0,M.$Yv)(I),(0,S.$6f)(I)||(I=(0,S.$3f)(I)),I}function t(I,E,C){const j=[],U=new Set,F=C.dirname(E);for(const V of I){let J;if(f(V))V.path&&(J=C.resolvePath(F,V.path));else if(d(V))try{J=b.URI.parse(V.uri),J.path[0]!==P.$gc.sep&&(J=J.with({path:P.$gc.sep+J.path}))}catch(le){console.warn(le)}if(J){const le=C.getComparisonKey(J);if(!U.has(le)){U.add(le);const oe=V.name||C.basenameOrAuthority(J);j.push(new u.$pi({uri:J,name:oe,index:j.length},V))}}}return j}e.$Xcb=t;function o(I,E,C,j,U){const F=r(E,I),V=U.dirname(E),J=U.dirname(j),le=[];for(const Y of F.folders){const q=f(Y)?U.resolvePath(V,Y.path):b.URI.parse(Y.uri);let L;C?L=!1:L=!f(Y)||(0,P.$ic)(Y.path),le.push(m(q,L,Y.name,J,U))}const oe={insertSpaces:!1,tabSize:4,eol:g.$k||g.$j?`
`:`\r
`},ue=s.$un(I,["folders"],le,oe);let Z=s.$xn(I,ue);return(0,l.$Ng)(F.remoteAuthority,(0,y.$cl)(j))&&(Z=s.$xn(Z,s.$tn(Z,["remoteAuthority"],oe))),Z}e.$Ycb=o;function r(I,E){const C=R.$fn(E);if(C&&Array.isArray(C.folders))C.folders=C.folders.filter(j=>h(j));else throw new Error(`${I} looks like an invalid workspace file.`);return C}function i(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function n(I){return typeof I.folderUri=="string"}function a(I){return typeof I.fileUri=="string"}function p(I,E){const C={workspaces:[],files:[]};if(I){const j=function(F,V){for(let J=0;J<F.length;J++)try{V(F[J],J)}catch(le){E.warn(`Error restoring recent entry ${JSON.stringify(F[J])}: ${le.toString()}. Skip entry.`)}},U=I;Array.isArray(U.entries)&&j(U.entries,F=>{const V=F.label,J=F.remoteAuthority;i(F)?C.workspaces.push({label:V,remoteAuthority:J,workspace:{id:F.workspace.id,configPath:b.URI.parse(F.workspace.configPath)}}):n(F)?C.workspaces.push({label:V,remoteAuthority:J,folderUri:b.URI.parse(F.folderUri)}):a(F)&&C.files.push({label:V,remoteAuthority:J,fileUri:b.URI.parse(F.fileUri)})})}return C}e.$Zcb=p;function A(I){const E={entries:[]};for(const C of I.workspaces)w(C)?E.entries.push({folderUri:C.folderUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority}):E.entries.push({workspace:{id:C.workspace.id,configPath:C.workspace.configPath.toString()},label:C.label,remoteAuthority:C.remoteAuthority});for(const C of I.files)E.entries.push({fileUri:C.fileUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority});return E}e.$1cb=A}),define(ae[98],ce([0,1,86,13,4,19]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f0b=e.$e0b=e.$d0b=e.$c0b=void 0,e.$c0b=128/4;function D(l){function b(){let v=l.scheme===R.Schemas.file?(0,M.$wg)(l):l.toString();return s.$k||(v=v.toLowerCase()),(0,S.createHash)("md5").update(v).digest("hex")}return{id:b(),configPath:l}}e.$d0b=D;function P(l,b){function v(){if(l.scheme!==R.Schemas.file)return(0,S.createHash)("md5").update(l.toString()).digest("hex");if(!b)return;let u;return s.$k?u=b.ino:s.$j?u=b.birthtime.getTime():s.$i&&(typeof b.birthtimeMs=="number"?u=Math.floor(b.birthtimeMs):u=b.birthtime.getTime()),(0,S.createHash)("md5").update(l.fsPath).update(u?String(u):"").digest("hex")}const y=v();if(typeof y=="string")return{id:y,uri:l}}e.$e0b=P;function g(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$f0b=g}),define(ae[99],ce([0,1,86,87,26,282,17,14,3,2,9,4,32,43,110]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0;class w{traceSocketEvent(E,C){$.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,C)}constructor(E,C=""){this.f=!0,this.debugLabel=C,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,P.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const C=j=>{this.traceSocketEvent("read",j),E(D.$ke.wrap(j))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(E){const C=j=>{E({type:0,hadError:j,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(E){const C=()=>{E()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,P.$1)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,P.$1)(C)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Wh=w;var k;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(k||(k={}));var h;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(h||(h={}));class f extends l.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,C){this.socket.traceSocketEvent(E,C)}constructor(E,C,j,U){super(),this.f=this.B(new g.$Wd),this.g=this.B(new g.$Wd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:j?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new d(this,C,j,U,this.f,(F,V)=>this.m(F,V))),this.B(this.a.onError(F=>{console.error(F),(0,P.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new $.$Rh,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await g.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let C=0;for(;C<E.byteLength;)this.a.writeMessage(E.slice(C,Math.min(C+262144,E.byteLength)),{compressed:!0,opcode:2}),C+=262144}m(E,{compressed:C,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let U=2;E.byteLength<126?U+=0:E.byteLength<2**16?U+=2:U+=8;const F=D.$ke.alloc(U),V=C?64:0,J=j&15;if(F.writeUInt8(128|V|J,0),E.byteLength<126)F.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){F.writeUInt8(126,1);let le=1;F.writeUInt8(E.byteLength>>>8&255,++le),F.writeUInt8(E.byteLength>>>0&255,++le)}else{F.writeUInt8(127,1);let le=1;F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(E.byteLength>>>24&255,++le),F.writeUInt8(E.byteLength>>>16&255,++le),F.writeUInt8(E.byteLength>>>8&255,++le),F.writeUInt8(E.byteLength>>>0&255,++le)}this.socket.write(D.$ke.concat([F,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const C=this.b.peek(this.j.readLen),j=C.readUInt8(0),U=(j&128)>>>7,F=(j&64)>>>6,V=j&15,J=C.readUInt8(1),le=(J&128)>>>7,oe=J&127;this.j.state=2,this.j.readLen=2+(le?4:0)+(oe===126?2:0)+(oe===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=V,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const C=this.b.read(this.j.readLen),j=C.readUInt8(1),U=(j&128)>>>7;let F=j&127,V=1;F===126?F=C.readUInt8(++V)*2**8+C.readUInt8(++V):F===127&&(F=C.readUInt8(++V)*0+C.readUInt8(++V)*0+C.readUInt8(++V)*0+C.readUInt8(++V)*0+C.readUInt8(++V)*2**24+C.readUInt8(++V)*2**16+C.readUInt8(++V)*2**8+C.readUInt8(++V));let J=0;U&&(J=C.readUInt8(++V)*2**24+C.readUInt8(++V)*2**16+C.readUInt8(++V)*2**8+C.readUInt8(++V)),this.j.state=3,this.j.readLen=F,this.j.mask=J,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const C=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",C),t(C,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",C),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(C,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(C,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await g.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Xh=f;class d extends l.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$ke.alloc(0)}constructor(E,C,j,U,F,V){super(),this.n=E,this.r=F,this.s=V,this.a=this.B(new g.$Wd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new g.$Wd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new g.$Wd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,C?(this.b=this.B(new m(this.n,U,j,{windowBits:15})),this.f=this.B(new c(this.n,{windowBits:15})),this.B(this.b.onError(J=>this.a.fire(J))),this.B(this.f.onError(J=>this.a.fire(J)))):(this.b=null,this.f=null)}writeMessage(E,C){this.g.push({data:E,options:C}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:C}=this.g.shift();if(this.f&&C.compressed){const j=await this.w(this.f,E);this.s(j,C)}else this.s(E,{...C,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,C){return new Promise((j,U)=>{E.write(C),E.flush(F=>j(F))})}acceptFrame(E,C,j){this.h.push({data:E,isCompressed:C,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const C=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(C)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,C,j){return new Promise((U,F)=>{E.write(C),j&&E.write(D.$ke.fromByteArray([0,0,255,255])),E.flush(V=>U(V))})}}class m extends l.$Tc{get recordedInflateBytes(){return this.j?D.$ke.concat(this.f):D.$ke.alloc(0)}constructor(E,C,j,U){super(),this.h=E,this.j=C,this.a=this.B(new g.$Wd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(U),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(D.$ke.wrap(F))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const C=D.$ke.concat(this.g);this.g.length=0,E(C)})}}class c extends l.$Tc{constructor(E,C){super(),this.g=E,this.a=this.B(new g.$Wd),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(D.$ke.wrap(j))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let C=D.$ke.concat(this.f);this.f.length=0,C=C.slice(0,C.byteLength-4),E(C)})}}function t(I,E){if(E===0)return;const C=I.byteLength>>>2;for(let le=0;le<C;le++){const oe=I.readUInt32BE(le*4);I.writeUInt32BE(oe^E,le*4)}const j=C*4,U=I.byteLength-j,F=E>>>24&255,V=E>>>16&255,J=E>>>8&255;U>=1&&I.writeUInt8(I.readUInt8(j)^F,j),U>=2&&I.writeUInt8(I.readUInt8(j+1)^V,j+1),U>=3&&I.writeUInt8(I.readUInt8(j+2)^J,j+2)}e.$Yh=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function r(){const I=(0,y.$rg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const E=process.platform!=="darwin"&&e.$Yh?e.$Yh:(0,s.tmpdir)(),C=(0,b.$jc)(E,`vscode-ipc-${I}.sock`);return n(C),C}e.$Zh=r;function i(I,E,C){const U=(0,S.createHash)("sha256").update(I).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${C}-${E}-sock`;const F=C.substr(0,4),V=E.substr(0,6);let J;return process.platform!=="darwin"&&e.$Yh&&!process.env.VSCODE_PORTABLE?J=(0,b.$jc)(e.$Yh,`vscode-${U}-${F}-${V}.sock`):J=(0,b.$jc)(I,`${F}-${V}.sock`),n(J),J}e.$1h=i;function n(I){const E=o[v.$u];typeof E=="number"&&I.length>=E&&console.warn(`WARNING: IPC handle "${I}" is longer than ${E} chars, try a shorter --user-data-dir`)}class a extends u.$Lh{static b(E){const C=g.Event.fromNodeEventEmitter(E,"connection");return g.Event.map(C,j=>({protocol:new $.$Sh(new w(j,"ipc-server-connection")),onDidClientDisconnect:g.Event.once(g.Event.fromNodeEventEmitter(j,"close"))}))}constructor(E){super(a.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$2h=a;function p(I){return new Promise((E,C)=>{const j=(0,R.createServer)();j.on("error",C),j.listen(I,()=>{j.removeListener("error",C),E(new a(j))})})}e.$3h=p;function A(I,E){return new Promise((C,j)=>{const U=(0,R.createConnection)(I,()=>{U.removeListener("error",j),C($.$Th.fromSocket(new w(U,`ipc-client${E}`),E))});U.once("error",j)})}e.$4h=A}),define(ae[24],ce([0,1,50,9,4,99,38,90,6]),function(X,e,S,R,s,M,D,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W9b=e.$V9b=void 0,e.$V9b=(0,g.$9h)(D.$ci);class l extends P.$Em{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,R.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,R.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$1h)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,R.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const v in process.env)if(v.endsWith("_VSCODE_SNAP_ORIG")){const y=v.slice(0,-17);if(this.d[y])continue;process.env[y]&&(this.d[y]=process.env[y]),process.env[v]?process.env[y]=process.env[v]:delete process.env[y]}}}restoreSnapExportedVariables(){if(s.$k)for(const v in this.d)process.env[v]=this.d[v],delete this.d[v]}}e.$W9b=l,ve([S.$zh],l.prototype,"cachedLanguagesPath",null),ve([S.$zh],l.prototype,"backupHome",null),ve([S.$zh],l.prototype,"mainIPCHandle",null),ve([S.$zh],l.prototype,"mainLockfile",null),ve([S.$zh],l.prototype,"disableUpdates",null),ve([S.$zh],l.prototype,"crossOriginIsolated",null),ve([S.$zh],l.prototype,"codeCachePath",null),ve([S.$zh],l.prototype,"useCodeCache",null)}),define(ae[283],ce([0,1,86,33,13,9,4,19,21,196,18,24,34,16,5,195,30,98]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$y0b=void 0;let d=class{static{f=this}static{this.a="backupWorkspaces"}constructor(c,t,o,r){this.j=c,this.k=t,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$zg,this.i={isEqual:(i,n)=>(0,R.$8f)(i,n,!D.$k)}}async initialize(){const c=this.m.getItem(f.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(c.emptyWindows),this.d=await this.u((0,l.$Y9b)(c)),this.e=await this.v((0,l.$Z9b)(c)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==u.$Rk.OFF}q(){return this.s()===u.$Rk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||u.$Rk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(c,t){this.d.some(r=>c.workspace.id===r.workspace.id)||(this.d.push(c),this.C());const o=(0,M.$jc)(this.c,c.workspace.id);return t?this.t(o,t).then(()=>o):o}async t(c,t){if(await g.Promises.exists(c)&&await this.z(c),await g.Promises.exists(t))try{await g.Promises.rename(t,c,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(c){return this.e.some(t=>this.h.isEqual(c.folderUri,t.folderUri))||(this.e.push(c),this.C()),(0,M.$jc)(this.c,this.D(c))}registerEmptyWindowBackup(c){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,c.backupFolder))||(this.g.push(c),this.C()),(0,M.$jc)(this.c,c.backupFolder)}async u(c){if(!Array.isArray(c))return[];const t=new Set,o=[];for(const r of c){const i=r.workspace;if(!(0,k.$ki)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,M.$jc)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await g.Promises.exists(i.configPath.fsPath)?o.push(r):await this.z(n):await this.x(n)}}return o}async v(c){if(!Array.isArray(c))return[];const t=[],o=new Set;for(const r of c){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!o.has(n)){o.add(n);const a=(0,M.$jc)(this.c,this.D(r));await this.B(a)?i.scheme!==s.Schemas.file||await g.Promises.exists(i.fsPath)?t.push(r):await this.z(a):await this.x(a)}}return t}async w(c){if(!Array.isArray(c))return[];const t=[],o=new Set;for(const r of c){const i=r.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const n=(0,M.$jc)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(c){try{await g.Promises.rm(c,g.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let c=(0,h.$f0b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,c.id));)c=(0,h.$f0b)();return{backupFolder:c.id}}async z(c){const t=this.y(),o=(0,M.$jc)(this.c,t.backupFolder);try{await g.Promises.rename(c,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const c=[];for(const t of this.d)await this.A(t)&&c.push(t);for(const t of this.e)await this.A(t)&&c.push(t);return c}A(c){let t;return(0,l.$X9b)(c)?t=(0,M.$jc)(this.c,c.backupFolder):(0,w.$Pcb)(c)?t=(0,M.$jc)(this.c,this.D(c)):t=(0,M.$jc)(this.c,c.workspace.id),this.B(t)}async B(c){try{const t=await g.Promises.readdir(c);for(const o of t)try{if((await g.Promises.readdir((0,M.$jc)(c,o))).length>0)return!0}catch{}}catch{}return!1}C(){const c={workspaces:this.d.map(({workspace:t,remoteAuthority:o})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:t,remoteAuthority:o})=>{const r={folderUri:t.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:o})=>{const r={backupFolder:t};return o&&(r.remoteAuthority=o),r})};this.m.setItem(f.a,c)}D(c){const t=c.folderUri;let o;return t.scheme===s.Schemas.file?o=D.$k?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,S.createHash)("md5").update(o).digest("hex")}};e.$y0b=d,e.$y0b=d=f=ve([re(0,v.$V9b),re(1,b.$Bi),re(2,$.$pj),re(3,y.$DO)],d)}),define(ae[20],ce([0,1,15,37,8,3,2,4,36,12,6,5,34,24]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$o0b=e.LifecycleMainPhase=e.ShutdownReason=e.$n0b=void 0,e.$n0b=(0,b.$8h)("lifecycleMainService");var w;(function(f){f[f.QUIT=1]="QUIT",f[f.KILL=2]="KILL"})(w||(e.ShutdownReason=w={}));var k;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen",f[f.Eventually=4]="Eventually"})(k||(e.LifecycleMainPhase=k={}));let h=class extends D.$Tc{static{$=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(d,m,c){super(),this.F=d,this.G=m,this.H=c,this.c=this.B(new M.$Wd),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$Wd),this.onWillShutdown=this.f.event,this.g=this.B(new M.$Wd),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$Wd),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem($.b),this.m&&this.G.removeItem($.b)}J(){const d=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$j&&this.t===0&&this.L(1))};S.app.addListener("before-quit",d);const m=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!P.$j)&&S.app.quit()};S.app.addListener("window-all-closed",m),S.app.once("will-quit",c=>{this.S("Lifecycle#app.on(will-quit) - begin"),c.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),S.app.removeListener("before-quit",d),S.app.removeListener("window-all-closed",m),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),S.app.quit()})})}L(d){if(this.y)return this.y;const m=this.F;this.S("Lifecycle#onWillShutdown.fire()");const c=[];return this.f.fire({reason:d,join(t,o){m.trace(`Lifecycle#onWillShutdown - begin '${t}'`),c.push(o.finally(()=>{m.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(c)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(d){if(d<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===d)return;this.S(`lifecycle (main): phase changed (value: ${d})`),this.n=d;const m=this.C.get(this.n);m&&(m.open(),this.C.delete(this.n))}async when(d){if(d<=this.n)return;let m=this.C.get(d);m||(m=new s.$7g,this.C.set(d,m)),await m.wait()}registerWindow(d){const m=new D.$Sc;this.t++,m.add(d.onWillLoad(t=>this.g.fire({window:d,workspace:t.workspace,reason:t.reason})));const c=(0,l.$Uf)(d.win);c.on("close",t=>{const o=d.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${d.id}`),t.preventDefault(),this.unload(d,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(d),d.close()})}),c.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${d.id}`),this.t--,m.dispose(),this.t===0&&(!P.$j||this.j)&&this.L(1)})}registerAuxWindow(d){const m=(0,l.$Uf)(d.win);m.on("close",c=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${d.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),c.preventDefault())}),m.on("closed",()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${d.id}`)})}async reload(d,m){await this.unload(d,3)||d.reload(m)}unload(d,m){const c=this.z.get(d.id);if(c)return c;const t=this.M(d,m).finally(()=>{this.z.delete(d.id)});return this.z.set(d.id,t),t}async M(d,m){if(!d.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${d.id}`);const c=this.j?2:m,t=await this.P(d,c);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${d.id})`),this.N(t)):(await this.Q(d,c),!1)}N(d){return d?(this.O(!0),this.j=!1,!0):!1}O(d){this.w&&(this.w(d),this.w=void 0,this.u=void 0)}P(d,m){return new Promise(c=>{const t=this.s++,o=`vscode:ok${t}`,r=`vscode:cancel${t}`;R.$JU.once(o,()=>{c(!1)}),R.$JU.once(r,()=>{c(!0)}),d.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:m})})}Q(d,m){return new Promise(c=>{const o=`vscode:reply${this.s++}`;R.$JU.once(o,()=>c()),d.send("vscode:onWillUnload",{replyChannel:o,reason:m})})}quit(d){return this.R(d).then(m=>{if(!m&&d)try{if(P.$i){const c=(0,g.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.F.error(c)}return m})}R(d){return this.S(`Lifecycle#quit() - begin (willRestart: ${d})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(d&&this.G.setItem($.b,!0),this.u=new Promise(m=>{this.w=m,this.S("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.u)}S(d){this.H.args["enable-smoke-test-driver"]?this.F.info(d):this.F.trace(d)}setRelaunchHandler(d){this.D=d}async relaunch(d){this.S("Lifecycle#relaunch()");const m=process.argv.slice(1);if(d?.addArgs&&m.push(...d.addArgs),d?.removeArgs)for(const o of d.removeArgs){const r=m.indexOf(o);r>=0&&m.splice(r,1)}const c=()=>{this.D?.handleRelaunch(d)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:m}))};S.app.once("quit",c),await this.quit(!0)&&S.app.removeListener("quit",c)}async kill(d){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$9g)(1e3),(async()=>{for(const m of S.BrowserWindow.getAllWindows())if(m&&!m.isDestroyed()){let c;m.webContents&&!m.webContents.isDestroyed()?c=new Promise(t=>m.once("closed",t)):c=Promise.resolve(),m.destroy(),await c}})()]),S.app.exit(d)}};e.$o0b=h,e.$o0b=h=$=ve([re(0,v.$pj),re(1,y.$DO),re(2,u.$V9b)],h)}),define(ae[284],ce([0,1,4,3,2,6,20]),function(X,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X0b=e.$W0b=void 0,e.$W0b=(0,M.$8h)("keyboardLayoutMainService");let P=class extends s.$Tc{constructor(b){super(),this.a=this.B(new R.$Wd),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,b.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const b=await new Promise((v,y)=>{X(["native-keymap"],v,y)});this.c=g(b),S.$t||b.onDidChangeKeyboardLayout(()=>{this.c=g(b),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$X0b=P,e.$X0b=P=ve([re(0,D.$n0b)],P);function g(l){const b=l.getKeyMap(),v=l.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:v}}}),define(ae[285],ce([0,1,246,8,17,14,12,18,38,94,5,53,245,282]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0;let $=class extends v.$kp{constructor(f,d,m,c){super(c),this.m=f,this.n=d,this.r=m,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,d){const{f:m,g:c}=this;let t;try{t=await(0,l.$bm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$0)(i)))}const o={...process.env,...t},r=f.agent?f.agent:await(0,y.$or)(f.url||"",o,{proxyUrl:m,strictSSL:c});return f.agent=r,f.strictSSL=c,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>k(f,d))}async resolveProxy(f){}async loadCertificates(){return(await new Promise((d,m)=>{X(["@vscode/proxy-agent"],d,m)})).loadSystemCertificates({log:this.r})}};e.$pr=$,e.$pr=$=ve([re(0,P.$Bi),re(1,g.$di),re(2,b.$pj),re(3,b.$qj)],$);async function w(h){return((0,S.parse)(h.url).protocol==="https:"?await new Promise((m,c)=>{X(["https"],m,c)}):await new Promise((m,c)=>{X(["http"],m,c)})).request}async function k(h,f){return R.Promises.withAsyncBody(async(d,m)=>{const c=(0,S.parse)(h.url),t=h.getRawRequest?h.getRawRequest(h):await w(h),o={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,D.$Pf)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(o.auth=h.user+":"+h.password);const r=t(o,i=>{const n=(0,D.$Nf)(h.followRedirects)?h.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)k({...h,url:i.headers.location,followRedirects:n-1},f).then(d,m);else{let a=i;!h.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,u.createGunzip)())),d({res:i,stream:(0,s.$ze)(a)})}});r.on("error",m),h.timeout&&r.setTimeout(h.timeout),h.isChromiumNetwork&&r.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&r.write(h.data),r.end(),f.onCancellationRequested(()=>{r.abort(),m(new M.$5)})})}e.$qr=k}),define(ae[286],ce([0,1,15,285]),function(X,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z$b=void 0;function s(D){return S.net.request}class M extends R.$pr{request(P,g){return super.request({...P||{},getRawRequest:s,isChromiumNetwork:!0},g)}}e.$Z$b=M}),define(ae[82],ce([0,1,7,3,2,38,16,6,20,5,96,279,41,57,40,13]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w0b=e.$v0b=e.$u0b=e.$t0b=void 0,e.$t0b=(0,P.$8h)("storageMainService");let k=class extends s.$Tc{constructor(d,m,c,t,o,r){super(),this.c=d,this.f=m,this.g=c,this.h=t,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new R.$Wd),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(d=>{d.window.profile&&this.profileStorage(d.window.profile).init(),d.workspace&&this.workspaceStorage(d.workspace).init()})),this.B(this.h.onWillShutdown(d=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=d.reason,d.join("applicationStorage",this.applicationStorage.close());for(const[,m]of this.t)d.join("profileStorage",m.close());for(const[,m]of this.w)d.join("workspaceStorage",m.close())})),this.B(this.g.onWillCreateProfile(d=>{d.join((async()=>{await this.j.exists(d.profile.globalStorageHome)||await this.j.createFolder(d.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(d=>{const m=this.t.get(d.profile.id);m&&d.join(m.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const d=new v.$q0b(this.n(),this.g,this.c,this.j);return this.B(R.Event.once(d.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),d}profileStorage(d){if((0,b.$zp)(d))return this.applicationStorage;let m=this.t.get(d.id);if(!m){this.c.trace(`StorageMainService: creating profile storage (${d.name})`),m=this.B(this.u(d)),this.t.set(d.id,m);const c=this.B(m.onDidChangeStorage(t=>this.b.fire({...t,storage:m,profile:d})));this.B(R.Event.once(m.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${d.name})`),this.t.delete(d.id),c.dispose()}))}return m}u(d){return this.a===2?new v.$s0b(this.c,this.j):new v.$p0b(d,this.n(),this.c,this.j)}workspaceStorage(d){let m=this.w.get(d.id);return m||(this.c.trace(`StorageMainService: creating workspace storage (${d.id})`),m=this.B(this.y(d)),this.w.set(d.id,m),this.B(R.Event.once(m.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${d.id})`),this.w.delete(d.id)}))),m}y(d){return this.a===2?new v.$s0b(this.c,this.j):new v.$r0b(d,this.n(),this.c,this.f,this.j)}isUsed(d){const m=S.URI.file(d);for(const c of[this.applicationStorage,...this.t.values(),...this.w.values()])if(c.path&&this.m.extUri.isEqualOrParent(S.URI.file(c.path),m))return!0;return!1}};e.$u0b=k,e.$u0b=k=ve([re(0,l.$pj),re(1,M.$ci),re(2,u.$09b),re(3,g.$n0b),re(4,D.$sk),re(5,$.$3k)],k),e.$v0b=(0,P.$8h)("applicationStorageMainService");let h=class extends b.$yp{constructor(d,m){super(),this.s=d,this.U=m,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(d){if(d===-1)return this.U.applicationStorage.storage}Q(d){if(d===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:w.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$w0b=h,e.$w0b=h=ve([re(0,y.$5k),re(1,e.$t0b)],h)}),define(ae[287],ce([0,1,87,26,104,99,8,2,4,18,5,27,241,242,95,127,17]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y$b=e.$X$b=e.$W$b=e.$V$b=void 0;async function h(t,o,r,i,n){let a;for(let p=3;p&&(a?.dispose(),a=await new f(t,o,r,i,n).waitForReady(),!(n&&s.$ug[n]||!s.$ug[a.tunnelLocalPort]));p--);return a}class f extends P.$Tc{constructor(o,r,i,n,a){super(),this.m=r,this.n=a,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=S.createServer(),this.c=new D.$7g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=p=>this.r(p),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,w.$Jv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$vg)(o,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(o){o.pause();const r=(0,w.$Hv)(this.tunnelRemoteHost)||(0,w.$Jv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,y.$nl)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),a=i.readEntireBuffer();i.dispose(),a.byteLength>0&&o.write(a.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),n instanceof M.$Wh?n.socket.destroy():n.end()}),n instanceof M.$Wh?this.t(o,n):this.s(o,n),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),n.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(i=>o.write(i.buffer)),o.on("data",i=>r.write(k.$ke.wrap(i))),o.resume()}t(o,r){const i=r.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$V$b=f;let d=class extends w.$Mv{constructor(o,r,i,n,a){super(r,a),this.v=o,this.w=i,this.y=n}isPortPrivileged(o){return(0,w.$Kv)(o,this.m,g.OS,R.release())}t(o,r,i,n,a,p,A,I){const E=this.s(r,i);if(E)return++E.refcount,E.value;if((0,w.$Ev)(o))return this.u(o,r,i,a,p,A,I);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${a}.`);const C={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},j=h(C,n,r,i,a);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,i,j),j}}};e.$W$b=d,e.$W$b=d=ve([re(0,u.$hl),re(1,b.$pj),re(2,$.$kl),re(3,v.$Hj),re(4,l.$Bi)],d);let m=class extends d{constructor(o,r,i,n,a){super(o,r,i,n,a)}};e.$X$b=m,e.$X$b=m=ve([re(0,u.$hl),re(1,b.$pj),re(2,$.$kl),re(3,v.$Hj),re(4,l.$Bi)],m);let c=class extends P.$Tc{constructor(o,r,i,n,a){super(),this.b=o,this.c=r,this.f=i,this.g=n,this.h=a,this.a=new Map}async openTunnel(o,r,i,n,a,p,A,I,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${p}.`),!this.a.has(o)){const C=new m(this.b,this.c,this.g,this.f,this.h);this.B(C),this.a.set(o,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,i,n,a,p,A,I,E)}};e.$Y$b=c,e.$Y$b=c=ve([re(0,u.$hl),re(1,b.$pj),re(2,v.$Hj),re(3,$.$kl),re(4,l.$Bi)],c)}),define(ae[100],ce([0,1,8,23,3,18,24,20,5,27,53,49]),function(X,e,S,R,s,M,D,P,g,l,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i$b=e.$h$b=void 0;function y($,w,k){return`${k.updateUrl}/api/update/${$}/${w}/${k.commit}`}e.$h$b=y;let u=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,k,h,f,d,m){this.f=w,this.g=k,this.h=h,this.i=f,this.j=d,this.k=m,this.b=v.$HV.Uninitialized,this.c=new s.$Wd,this.onStateChange=this.c.event,w.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(v.$HV.Disabled(0));return}if(this.h.disableUpdates){this.d(v.$HV.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(v.$HV.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),k=this.m(w);if(!k){this.d(v.$HV.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(k),!this.a){this.d(v.$HV.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const h=new URL(this.a);h.searchParams.set("prss","true"),this.a=h.toString()}if(this.d(v.$HV.Idle(this.q())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,h=>this.j.error(h))}m(w){return w==="none"?void 0:this.k.quality}n(w=60*60*1e3){return(0,S.$9g)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},R.CancellationToken.None)).res.statusCode===204}catch(k){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(k);return}}async _applySpecificUpdate(w){}q(){return 1}r(){}};e.$i$b=u,e.$i$b=u=ve([re(0,P.$n0b),re(1,M.$Bi),re(2,D.$V9b),re(3,b.$jp),re(4,g.$pj),re(5,l.$Hj)],u)}),define(ae[288],ce([0,1,15,50,3,45,2,18,24,20,5,27,53,28,49,100]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j$b=void 0;let k=class extends w.$i$b{get v(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"error",(f,d)=>d)}get w(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(f,d,m)=>({url:d,version:m,productVersion:m}))}get y(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(f,d,m,c)=>({releaseNotes:d,version:m,productVersion:m,date:c}))}constructor(f,d,m,c,t,o,r){super(f,d,c,t,o,r),this.z=m,this.u=new D.$Sc,f.setRelaunchHandler(this)}handleRelaunch(f){return f?.addArgs||f?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(f){this.z.publicLog2("update:error",{messageHash:String((0,M.$Vi)(String(f)))}),this.j.error("UpdateService error:",f);const d=this.state.type==="checking for updates"&&this.state.explicit?f:void 0;this.d($.$HV.Idle(1,d))}s(f){let d;this.k.darwinUniversalAssetId?d=this.k.darwinUniversalAssetId:d=process.arch==="x64"?"darwin":"darwin-arm64";const m=(0,w.$h$b)(d,f,this.k);try{S.autoUpdater.setFeedURL({url:m})}catch(c){this.j.error("Failed to set update feed URL",c);return}return m}t(f){this.d($.$HV.CheckingForUpdates(f)),S.autoUpdater.checkForUpdates()}E(f){this.state.type==="checking for updates"&&this.d($.$HV.Downloading(f))}F(f){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:f.version}),this.d($.$HV.Ready(f)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d($.$HV.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$j$b=k,ve([R.$zh],k.prototype,"v",null),ve([R.$zh],k.prototype,"w",null),ve([R.$zh],k.prototype,"x",null),ve([R.$zh],k.prototype,"y",null),e.$j$b=k=ve([re(0,l.$n0b),re(1,P.$Bi),re(2,u.$wl),re(3,g.$V9b),re(4,y.$jp),re(5,b.$pj),re(6,v.$Hj)],k)}),define(ae[289],ce([0,1,48,46,8,3,9,24,20,5,28,49]),function(X,e,S,R,s,M,D,P,g,l,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l$b=void 0;let y=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,k,h){if(this.f=w,this.g=h,this.a=v.$HV.Uninitialized,this.b=new M.$Wd,this.onStateChange=this.b.event,k.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(v.$HV.Idle(this.k())),this.h(30*1e3).then(void 0,f=>this.g.error(f))}h(w=60*60*1e3){return(0,s.$9g)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};y=ve([re(0,g.$n0b),re(1,P.$V9b),re(2,l.$pj)],y);let u=class extends y{constructor(w,k,h,f,d,m){super(h,f,d),this.o=w,this.p=k,this.q=m;const c=(0,R.watch)(D.$mc(this.o)),t=M.Event.fromNodeEventEmitter(c,"change",(n,a)=>a),o=M.Event.filter(t,n=>n==="current"),i=M.Event.debounce(o,(n,a)=>a,2e3)(()=>this.checkForUpdates(!1));h.onWillShutdown(()=>{i.dispose(),c.close()})}m(){this.d(v.$HV.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(v.$HV.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.$HV.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.$HV.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+D.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((h,f)=>(0,R.realpath)(`${D.$mc(this.o)}/current`,(d,m)=>d?f(d):h(m))),k=D.$nc(w);return this.p!==k}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$l$b=u,e.$l$b=u=ve([re(2,g.$n0b),re(3,P.$V9b),re(4,l.$pj),re(5,b.$wl)],u)}),define(ae[29],ce([0,1,4,6,55,69,27,18,24,9,137]),function(X,e,S,R,s,M,D,P,g,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$99b=e.$89b=e.OpenContext=e.$79b=void 0,e.$79b=(0,R.$8h)("windowsMainService");var v;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(v||(e.OpenContext=v={}));function y($,w,k){const h=$.get(M.$59b),f=$.get(D.$Hj),d=$.get(P.$Bi),m=$.get(g.$V9b),c=d.getValue("window"),t={backgroundColor:h.getBackgroundColor(),minWidth:s.$PC.WIDTH,minHeight:s.$PC.HEIGHT,title:f.nameLong,...k,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$1C)(w?.zoomLevel??c?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...k?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(w&&(t.x=w.x,t.y=w.y,t.width=w.width,t.height=w.height),S.$k?t.icon=(0,l.$jc)(m.appRoot,"resources/linux/code.png"):S.$i&&!m.isBuilt&&(t.icon=(0,l.$jc)(m.appRoot,"resources/win32/code_150x150.png")),S.$j&&(t.acceptFirstMouse=!0,c?.clickThroughInactive===!1&&(t.acceptFirstMouse=!1)),S.$j&&!(0,s.$ZC)(d)&&(t.fullscreenable=!1),S.$j&&c?.nativeTabs===!0&&(t.tabbingIdentifier=f.nameShort),!(0,s.$WC)(d)&&(t.titleBarStyle="hidden",S.$j||(t.frame=!1),(0,s.$YC)(d))){const i=h.getWindowSplash()?.colorInfo.titleBarBackground??h.getBackgroundColor(),n=b.$ot.fromHex(i).isDarker()?"#FFFFFF":"#000000";t.titleBarOverlay={height:29,color:i,symbolColor:n}}return t}e.$89b=y;function u($){let w,k=Number.MIN_VALUE;for(const h of $)h.lastFocusTime>k&&(k=h.lastFocusTime,w=h);return w}e.$99b=u}),define(ae[290],ce([0,1,15,23,3,45,2,32,117,5,82,29]),function(X,e,S,R,s,M,D,P,g,l,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x0b=void 0;var y;(function($){$[$.Initial=1]="Initial",$[$.StoredCredentialsUsed=2]="StoredCredentialsUsed",$[$.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let u=class extends D.$Tc{constructor(w,k,h,f){super(),this.g=w,this.h=k,this.j=h,this.m=f,this.a="proxy-credentials://",this.b=void 0,this.c=y.Initial,this.f=void 0,this.n()}n(){const w=s.Event.fromNodeEventEmitter(S.app,"login",(k,h,f,d,m)=>({event:k,webContents:h,req:f,authInfo:d,callback:m}));this.B(w(this.r,this))}async r({event:w,authInfo:k,req:h,callback:f}){if(!k.isProxy)return;if(!this.b&&this.c===y.LoginDialogShown&&h.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let d;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),d=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(k);try{d=await this.b}finally{this.b=void 0}}f(d?.username,d?.password)}async s(w){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const k=await this.t(w);if(k)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),k;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(w){this.g.trace("auth#doResolveProxyCredentials - enter",w);const k=String((0,M.$Vi)({scheme:w.scheme,host:w.host,port:w.port}));let h,f;try{const t=this.m.get(this.a+k,-1);if(t){const o=JSON.parse(await this.j.decrypt(t));h=o.username,f=o.password}}catch(t){this.g.error(t)}if(this.c!==y.StoredCredentialsUsed&&typeof h=="string"&&typeof f=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=y.StoredCredentialsUsed,{username:h,password:f};const d=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!d){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${d.id} to handle proxy login`);const m={authInfo:w,username:this.f?.username??h,password:this.f?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,P.$rg)()}`};d.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,m),this.c=y.LoginDialogShown;const c=await new Promise(t=>{const o=async(r,i,n)=>{if(i===m.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${d.id}`),d.win?.webContents.off("ipc-message",o),n){const a={username:n.username,password:n.password};try{if(n.remember){const p=await this.j.encrypt(JSON.stringify(a));this.m.store(this.a+k,p,-1,1)}else this.m.remove(this.a+k,-1)}catch(p){this.g.error(p)}t({username:a.username,password:a.password})}else t(void 0)};d.win?.webContents.on("ipc-message",o)});return this.f=c,c}};e.$x0b=u,e.$x0b=u=ve([re(0,l.$pj),re(1,v.$79b),re(2,g.$sV),re(3,b.$v0b)],u)}),define(ae[291],ce([0,1,15,22,4,7,21,18,64,6,5,128,29]),function(X,e,S,R,s,M,D,P,g,l,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$10b=e.$Z0b=e.ID=void 0,e.ID="launchMainService",e.$Z0b=(0,l.$8h)(e.ID);let u=class{constructor(w,k,h,f){this.a=w,this.b=k,this.c=h,this.d=f}async start(w,k){this.a.trace("Received data from other instance: ",w,k),s.$j&&S.app.focus({steal:!0});const h=this.e(w);if(h.length){let f=Promise.resolve();if(this.b.getWindowCount()===0){const d=(0,R.$Ob)(await this.b.openEmptyWindow({context:4}));d&&(f=d.ready())}f.then(()=>{for(const{uri:d,originalUrl:m}of h)this.c.open(d,{originalUrl:m})})}else return this.f(w,k)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,R.$Hb)(w._urls.map(k=>{try{return{uri:M.URI.parse(k),originalUrl:k}}catch{return null}})):[]}async f(w,k){const h=(0,g.$8l)(k)?0:4;let f=[];const d=w.wait&&w.waitMarkerFilePath?M.URI.file(w.waitMarkerFilePath):void 0,m=w.remote||void 0,c={context:h,cli:w,userEnv:w["preserve-env"]||h===0?k:void 0,waitMarkerFileURI:d,remoteAuthority:m,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,c);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||c.forceProfile||c.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)f=await this.b.open({...c,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,c),f=[o]):f=await this.b.open({...c,forceEmpty:!0})}}else f=await this.b.open({...c,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(d&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,D.whenDeleted)(d.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$10b=u,e.$10b=u=ve([re(0,b.$pj),re(1,y.$79b),re(2,v.$yV),re(3,P.$Bi)],u)}),define(ae[292],ce([0,1,2,20,57,30,8,29]),function(X,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D$b=void 0;let g=class extends S.$Tc{constructor(b,v,y){super(),this.a=v,this.b=y,this.B(b.onWillLoadWindow(u=>{u.reason===2&&this.c(u.window)})),this.B(b.onBeforeCloseWindow(u=>this.c(u))),this.B(new D.$hh(()=>this.g(),30*1e3)).schedule()}async c(b){const v=this.f(b),y=this.a.getProfileForWorkspace(v);y?.isTransient&&(this.a.unsetWorkspace(v,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(b){return b.openedWorkspace??(0,M.$ji)(b.backupPath,b.isExtensionDevelopmentHost)}g(){const b=this.a.getAssociatedEmptyWindows();if(b.length===0)return;const v=this.b.getWindows().map(y=>this.f(y));for(const y of b)v.some(u=>u.id===y.id)||this.a.unsetWorkspace(y,!1)}};e.$D$b=g,e.$D$b=g=ve([re(0,R.$n0b),re(1,s.$09b),re(2,P.$79b)],g)}),define(ae[61],ce([0,1,15,2,3,5,312,8,13,29,73,28,20,75,35,4,132]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$B0b=e.$A0b=void 0;function f(c){return typeof c.responseWindowId=="number"}let d=class extends R.$Tc{static{h=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(h.b.values())}constructor(t,o,r){super(),this.u=t,this.w=o,this.y=r,this.c=String(++h.a),this.f=this.B(new s.$Wd),this.onStdout=this.f.event,this.g=this.B(new s.$Wd),this.onStderr=this.g.event,this.h=this.B(new s.$Wd),this.onMessage=this.h.event,this.j=this.B(new s.$Wd),this.onSpawn=this.j.event,this.m=this.B(new s.$Wd),this.onExit=this.m.event,this.n=this.B(new s.$Wd),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case b.default.Error:this.u.error(r);break;case b.default.Warning:this.u.warn(r);break;case b.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",b.default.Error),!1):!0}start(t){const o=this.D(t);return o&&t.payload&&this.postMessage(t.payload),o}D(t){if(!this.C())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,r=g.$pg.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],n=this.t.execArgv??[],a=this.t.allowLoadingUnsignedLibraries,p=this.t.forceAllocationsToV8Sandbox,A="pipe",I=this.F(t);return this.z("creating new...",b.default.Info),this.r=S.utilityProcess.fork(r,i,{serviceName:o,env:I,execArgv:n,allowLoadingUnsignedLibraries:a,forceAllocationsToV8Sandbox:p,stdio:A}),this.G(this.r,this.t,o),!0}F(t){const o=t.env?{...t.env}:{...(0,$.$yn)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,w.$i&&((0,k.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,k.getUNCHostAllowlist)().join("\\")),(0,u.$Ul)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(t,o,r){if(t.stdout){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&h.b.set(t.pid,{pid:t.pid,name:f(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",b.default.Info),this.j.fire(t.pid)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.z(`received exit event with code ${i}`,b.default.Info),this.m.fire({pid:this.s,code:i,signal:"unknown"}),this.H()})),this.B(s.Event.fromNodeEventEmitter(S.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.z(`crashed with code ${i.exitCode} and reason '${i.reason}'`,b.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.H())}))}once(t,o){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),o())}))}postMessage(t,o){this.r&&this.r.postMessage(t,o)}connect(t){const{port1:o,port2:r}=new S.MessageChannelMain;return this.postMessage(t,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",b.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",b.default.Info),this.r.kill()?(this.z("successfully killed the process",b.default.Info),this.H()):this.z("unable to kill the process",b.default.Warning)}H(){typeof this.s=="number"&&h.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",b.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,P.$9g)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,b.default.Info),this.kill()))}};e.$A0b=d,e.$A0b=d=h=ve([re(0,M.$pj),re(1,v.$wl),re(2,y.$n0b)],d);let m=class extends d{constructor(t,o,r,i){super(t,r,i),this.I=o}start(t){const o=this.I.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",b.default.Error),!0;if(!super.D(t))return!1;this.J(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}J(t,o){o.windowLifecycleBound&&(this.B(s.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$B0b=m,e.$B0b=m=ve([re(0,M.$pj),re(1,l.$79b),re(2,v.$wl),re(3,y.$n0b)],m)}),define(ae[293],ce([0,1,14,3,5,20,8,61,29,28]),function(X,e,S,R,s,M,D,P,g,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$I0b=void 0;let v=class{static{b=this}static{this.a=0}constructor(u,$,w,k){this.d=u,this.f=$,this.g=w,this.h=k,this.b=new Map,this.c=!1,this.f.onWillShutdown(h=>{this.c=!0,h.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(u){const $=this.b.get(u);if(!$)throw new Error("Unknown extension host!");return $}onDynamicStdout(u){return this.i(u).onStdout}onDynamicStderr(u){return this.i(u).onStderr}onDynamicMessage(u){return this.i(u).onMessage}onDynamicExit(u){return this.i(u).onExit}async createExtensionHost(){if(this.c)throw(0,S.$6)();const u=String(++b.a),$=new P.$B0b(this.d,this.g,this.h,this.f);return this.b.set(u,$),$.onExit(({pid:w,code:k,signal:h})=>{this.d.info(`Extension host with pid ${w} exited with code: ${k}, signal: ${h}.`),setTimeout(()=>{$.dispose(),this.b.delete(u)}),setTimeout(()=>{try{process.kill(w,0),this.d.error(`Extension host with pid ${w} still exists, forcefully killing it...`),process.kill(w)}catch{}},1e3)}),{id:u}}async start(u,$){if(this.c)throw(0,S.$6)();const w=this.i(u);return w.start({...$,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:$.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:u}),{pid:await R.Event.toPromise(w.onSpawn)}}async enableInspectPort(u){if(this.c)throw(0,S.$6)();const $=this.b.get(u);return $?$.enableInspectPort():!1}async kill(u){if(this.c)throw(0,S.$6)();const $=this.b.get(u);$&&$.kill()}async _killAllNow(){for(const[,u]of this.b)u.kill()}async _waitForAllExit(u){const $=[];for(const[,w]of this.b)$.push(w.waitForExit(u));return D.Promises.settled($).then(()=>{})}};e.$I0b=v,e.$I0b=v=b=ve([re(0,s.$pj),re(1,M.$n0b),re(2,g.$79b),re(3,l.$wl)],v)}),define(ae[294],ce([0,1,37,8,2,24,20,5,41,39,68,61,54,90,12,247]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b$b=void 0;let k=class extends s.$Tc{constructor(f,d,m,c,t,o,r,i){super(),this.c=f,this.f=d,this.g=m,this.h=c,this.j=t,this.m=o,this.n=r,this.r=i,this.a=new R.$7g,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){S.$JU.on(w.$_0b.request,(f,d)=>this.t(f,d,w.$_0b.response)),S.$JU.on(w.$a$b.request,(f,d)=>this.t(f,d,w.$a$b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(f,d,m){this.m.trace(`[SharedProcess] onWindowConnection for: ${m}`),this.a.isOpen()||this.a.open(),await this.whenReady();const c=await this.connect(m);if(f.sender.isDestroyed())return c.close();f.sender.postMessage(m,d,[c])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(w.$$0b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const f=new R.$sh;this.b?this.b.once(w.$$0b.initDone,()=>f.complete()):S.$JU.once(w.$$0b.initDone,()=>f.complete()),await f.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const f=new R.$sh;this.b?this.b.once(w.$$0b.ipcReady,()=>f.complete()):S.$JU.once(w.$$0b.ipcReady,()=>f.complete()),await f.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new v.$A0b(this.m,y.$Po,this.j));const f=(0,u.$Gm)(this.g.args,this.g.isBuilt);let d;f.port&&(d=["--nolazy"],f.break?d.push(`--inspect-brk=${f.port}`):d.push(`--inspect=${f.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:d})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(f){return await this.z,(0,$.$Uf)(this.b).connect(f)}};e.$b$b=k,e.$b$b=k=ve([re(2,M.$V9b),re(3,g.$5k),re(4,D.$n0b),re(5,P.$pj),re(6,b.$i0b),re(7,l.$Mn)],k)}),define(ae[295],ce([0,1,24,90,20,5,54,61,111,37,2,3,35,18,13]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N$b=void 0;let w=class extends b.$Tc{constructor(h,f,d,m,c){super(),this.f=h,this.g=f,this.h=d,this.j=m,this.m=c,this.a=void 0,this.b=new v.$Wd,this.onRequestConnection=this.b.event,this.c=new v.$Wd,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),l.$JU.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,b.$Rc)(()=>{l.$JU.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new P.$A0b(this.m,D.$Po,this.j);const h=(0,R.$Fm)(this.h.args,this.h.isBuilt),f=h.port?["--nolazy",`--inspect${h.break?"-brk":""}=${h.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:f,args:["--logsPath",this.h.logsHome.with({scheme:$.Schemas.file}).fsPath],env:this.n()});const d=this.a.connect(),m=new g.$RU(d,"ptyHost"),c=new b.$Sc;return c.add(m),c.add((0,b.$Rc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:m,store:c,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const h={...(0,y.$yn)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},f=this.g.getValue("terminal.integrated.developer.ptyHost.latency");f&&typeof f=="number"&&(h.VSCODE_LATENCY=String(f));const d=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return d&&typeof d=="number"&&(h.VSCODE_STARTUP_DELAY=String(d)),this.h.restoreSnapExportedVariables(),h}r(h,f){this.b.fire();const d=this.a.connect();if(h.sender.isDestroyed()){d.close();return}h.sender.postMessage("vscode:createPtyHostMessageChannelResult",f,[d])}};e.$N$b=w,e.$N$b=w=ve([re(1,u.$Bi),re(2,S.$V9b),re(3,s.$n0b),re(4,M.$pj)],w)}),define(ae[296],ce([0,1,2,6,5,29,61,28,45,3,8,20]),function(X,e,S,R,s,M,D,P,g,l,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M$b=e.$L$b=void 0,e.$L$b=(0,R.$8h)("utilityProcessWorker");let y=class extends S.$Tc{constructor(w,k,h,f){super(),this.b=w,this.c=k,this.f=h,this.g=f,this.a=new Map}async createWorker(w){const k=`window: ${w.reply.windowId}, moduleId: ${w.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${k})`);const h=this.h(w);this.a.has(h)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${k})`),this.disposeWorker(w));const f=new u(this.b,this.c,this.f,this.g,w);if(!f.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(h,f);const d=new b.$sh;return l.Event.once(f.onDidTerminate)(m=>{m.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${m.code}, signal: ${m.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${m.code}, signal: ${m.signal}`),this.a.delete(h),d.complete({reason:m})}),d.p}h(w){return(0,g.$Vi)({moduleId:w.process.moduleId,windowId:w.reply.windowId})}async disposeWorker(w){const k=this.h(w),h=this.a.get(k);h&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${w.reply.windowId}, moduleId: ${w.process.moduleId})`),h.kill(),this.a.delete(k))}};e.$M$b=y,e.$M$b=y=ve([re(0,s.$pj),re(1,M.$79b),re(2,P.$wl),re(3,v.$n0b)],y);let u=class extends S.$Tc{constructor(w,k,h,f,d){super(),this.c=w,this.f=k,this.g=h,this.h=f,this.j=d,this.a=this.B(new l.$Wd),this.onDidTerminate=this.a.event,this.b=new D.$B0b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(w=>this.a.fire({code:w.code,signal:w.signal}))),this.B(this.b.onCrash(w=>this.a.fire({code:w.code,signal:"ECRASH"})))}spawn(){const k=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:k,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};u=ve([re(0,s.$pj),re(1,M.$79b),re(2,P.$wl),re(3,v.$n0b)],u)}),define(ae[297],ce([0,1,15,3,2,273,29]),function(X,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t$b=void 0;let P=class extends s.$Tc{constructor(l){super(),this.b=l,this.a=this.B(new R.$Wd),this.onFoundInFrame=this.a.event,this.B(new M.$s$b)}async setIgnoreMenuShortcuts(l,b){let v;if(typeof l.windowId=="number"){const{windowId:y}=l,u=this.b.getWindowById(y);if(!u?.win)throw new Error(`Invalid windowId: ${y}`);v=u.win.webContents}else{const{webContentsId:y}=l;if(v=S.webContents.fromId(y),!v)throw new Error(`Invalid webContentsId: ${y}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(b)}async findInFrame(l,b,v,y){const $=this.c(l,b);if(typeof $.findInFrame=="function"){$.findInFrame(v,{findNext:y.findNext,forward:y.forward});const w=(k,h)=>{h.finalUpdate&&(this.a.fire(h),$.removeListener("found-in-frame",w))};$.on("found-in-frame",w)}}async stopFindInFrame(l,b,v){const u=this.c(l,b);typeof u.stopFindInFrame=="function"&&u.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}c(l,b){const v=this.b.getWindowById(l.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${l}`);const y=v.win.webContents.mainFrame.framesInSubtree.find(u=>u.name===b);if(!y)throw new Error(`Unknown frame: ${b}`);return y}};e.$t$b=P,e.$t$b=P=ve([re(0,D.$79b)],P)}),define(ae[298],ce([0,1,15,2,4,19,7,18,20,5,34,29,129,30]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$w$b=e.$v$b=e.$u$b=void 0;let w=class extends R.$Tc{static{$=this}static{this.a="windowsState"}get state(){return this.b}constructor(c,t,o,r,i){super(),this.g=c,this.h=t,this.j=o,this.m=r,this.n=i,this.b=k(this.h.getItem($.a)),this.c=void 0,this.f=!1,this.r()}r(){S.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(c=>this.u(c)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(c=>this.u(c))}s(){this.f=!0,this.t()}t(){const c=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&c.add(t.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.w(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(c.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):c.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.w(i);return n.uiState.mode===3&&(c.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):c.add(n.uiState.display)),n}));const r=f(t);this.h.setItem($.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(c){if(this.j.quitRequested)return;const t=this.w(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,u.$ki)(c.openedWorkspace)&&o.workspace?.id===c.openedWorkspace.id,i=(0,u.$fi)(c.openedWorkspace)&&o.folderUri&&M.$zg.isEqual(o.folderUri,c.openedWorkspace.uri);(r||i)&&(o.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(c){return{windowId:c.id,workspace:(0,u.$ki)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,u.$fi)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const t=this.z(c),o=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(t.mode=1)}return t}z(c){const t=this.g.getLastActiveWindow();if(!c.extensionTestsPath){if(c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const p=c.workspace;if((0,u.$ki)(p)){const I=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===p.id).map(E=>E.uiState);if(I.length)return I[0]}if((0,u.$fi)(p)){const I=this.state.openedWindows.filter(E=>E.folderUri&&M.$zg.isEqual(E.folderUri,p.uri)).map(E=>E.uiState);if(I.length)return I[0]}else if(c.backupPath){const I=this.state.openedWindows.filter(E=>E.backupPath===c.backupPath).map(E=>E.uiState);if(I.length)return I[0]}const A=this.c||this.state.lastActiveWindow;if(!t&&A)return A.uiState}let o;const r=S.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(s.$j){const p=S.screen.getCursorScreenPoint();o=S.screen.getDisplayNearestPoint(p)}!o&&t&&(o=S.screen.getDisplayMatching(t.getBounds())),o||(o=S.screen.getPrimaryDisplay()||r[0])}let i=(0,y.$U9b)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const n=this.n.getValue("window");let a=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,a=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,a=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const p=t.serializeWindowState();p.mode===3?i.mode=3:i={...p,zoomLevel:void 0},a=i.mode!==3&&n.newWindowDimensions==="offset"}}return a&&(i=this.C(i)),i.hasDefaultState=!0,i}C(c){if(this.g.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const t=this.g.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===c.x||o.y===c.y);)c.x+=30,c.y+=30;return c}};e.$u$b=w,e.$u$b=w=$=ve([re(0,v.$79b),re(1,b.$DO),re(2,g.$n0b),re(3,l.$pj),re(4,P.$Bi)],w);function k(m){const c={openedWindows:[]},t=m||{openedWindows:[]};return t.lastActiveWindow&&(c.lastActiveWindow=h(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=h(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(c.openedWindows=t.openedWindows.map(o=>h(o))),c}e.$v$b=k;function h(m){const c={uiState:m.uiState};return m.backupPath&&(c.backupPath=m.backupPath),m.remoteAuthority&&(c.remoteAuthority=m.remoteAuthority),m.folder&&(c.folderUri=D.URI.parse(m.folder)),m.workspaceIdentifier&&(c.workspace={id:m.workspaceIdentifier.id,configPath:D.URI.parse(m.workspaceIdentifier.configURIPath)}),c}function f(m){return{lastActiveWindow:m.lastActiveWindow&&d(m.lastActiveWindow),lastPluginDevelopmentHostWindow:m.lastPluginDevelopmentHostWindow&&d(m.lastPluginDevelopmentHostWindow),openedWindows:m.openedWindows.map(c=>d(c))}}e.$w$b=f;function d(m){return{workspaceIdentifier:m.workspace&&{id:m.workspace.id,configURIPath:m.workspace.configPath.toString()},folder:m.folderUri&&m.folderUri.toString(),backupPath:m.backupPath,remoteAuthority:m.remoteAuthority,uiState:m.uiState}}}),define(ae[58],ce([0,1,15,3,42,2,13,9,19,21,194,65,56,24,6,5,57,131,30,97,98]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h,f,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h0b=e.$g0b=void 0,e.$g0b=(0,$.$8h)("workspacesManagementMainService");let c=class extends M.$Tc{constructor(o,r,i,n,a){super(),this.g=o,this.h=r,this.j=i,this.m=n,this.n=a,this.a=this.B(new R.$Wd),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new R.$Wd),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await l.Promises.readdir(this.c.with({scheme:D.Schemas.file}).fsPath)).map(r=>(0,g.$Ig)(this.c,r,f.$ui));for(const r of o){const i=(0,m.$d0b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>l.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===D.Schemas.file)try{const i=r(o.fsPath);return i instanceof Promise?i.then(n=>this.t(o,n),n=>{}):this.t(o,i)}catch{return}}s(o){return(0,f.$vi)(o,this.g)||(0,f.$Ai)(o)}t(o,r){try{const i=this.u(o,r),n=(0,m.$d0b)(o);return{id:n.id,configPath:n.configPath,folders:(0,d.$Xcb)(i.folders,n.configPath,g.$zg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(o,r){const i=(0,s.$fn)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,d.$Vcb)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,r){const{workspace:i,storedWorkspace:n}=this.w(o,r),a=i.configPath.fsPath;return await l.Promises.mkdir((0,P.$mc)(a),{recursive:!0}),await l.Promises.writeFile(a,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(o=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,g.$Ig)(this.c,i),a=(0,g.$Ig)(n,f.$ui),p=[];for(const A of o)p.push((0,d.$Wcb)(A.uri,!0,A.name,n,g.$zg));return{workspace:(0,m.$d0b)(a),storedWorkspace:{folders:p,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,m.$d0b)(o)}isUntitledWorkspace(o){return(0,f.$vi)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,g.$wg)(o.configPath);try{await l.Promises.rm((0,P.$mc)(r));const i=(0,P.$jc)(this.g.workspaceStorageHome.with({scheme:D.Schemas.file}).fsPath,o.id);await l.Promises.exists(i)&&await l.Promises.writeFile((0,P.$jc)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==o.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,i){if(!o||!o.win||!o.isReady||!await this.z(o,r,i))return;const a=await this.C(o,(0,m.$d0b)(i));if(a)return this.b.fire({window:o,workspace:a.workspace}),a}async z(o,r,i){return i?(0,f.$ki)(o.openedWorkspace)&&g.$zg.isEqual(o.openedWorkspace.configPath,i)?!1:(0,h.$a0b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,b.localize)(0,null)],message:(0,b.localize)(1,null,(0,g.$Fg)(i)),detail:(0,b.localize)(2,null)},S.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,f.$ki)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=i,{workspace:r,backupPath:i}}};e.$h0b=c,e.$h0b=c=ve([re(0,u.$V9b),re(1,w.$pj),re(2,k.$09b),re(3,v.$19b),re(4,y.$29b)],c)}),define(ae[133],ce([0,1,15,37,23,6,29,30,58,12,5,61]),function(X,e,S,R,s,M,D,P,g,l,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E0b=e.$D0b=e.ID=void 0,e.ID="diagnosticsMainService",e.$D0b=(0,M.$8h)(e.ID);let y=class{constructor($,w,k){this.a=$,this.b=w,this.c=k}async getRemoteDiagnostics($){const w=this.a.getWindows();return(await Promise.all(w.map(async h=>{const f=h.remoteAuthority;if(!f)return;const d=`vscode:getDiagnosticInfoResponse${h.id}`,m={includeProcesses:$.includeProcesses,folders:$.includeWorkspaceMetadata?await this.f(h):void 0};return new Promise(c=>{h.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:d,args:m}),R.$JU.once(d,(t,o)=>{o||c({hostName:f,errorMessage:`Unable to resolve connection to '${f}'.`}),c(o)}),setTimeout(()=>{c({hostName:f,errorMessage:`Connection to '${f}' could not be established`})},5e3)})}))).filter(h=>!!h)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const $=[];for(const k of S.BrowserWindow.getAllWindows()){const h=this.a.getWindowById(k.id);h?$.push(await this.d(h)):$.push(this.e(k))}const w=[];for(const{pid:k,name:h}of v.$A0b.getAll())w.push({pid:k,name:h});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:$,pidToNames:w,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d($){const w=await this.f($),k=(0,l.$Uf)($.win);return this.e(k,w,$.remoteAuthority)}e($,w=[],k){return{id:$.id,pid:$.webContents.getOSProcessId(),title:$.getTitle(),folderURIs:w,remoteAuthority:k}}async f($){const w=[],k=$.openedWorkspace;if((0,P.$fi)(k))w.push(k.uri);else if((0,P.$ki)(k)){const h=await this.b.resolveLocalWorkspace(k.configPath);h&&h.folders.forEach(d=>{w.push(d.uri)})}return w}};e.$E0b=y,e.$E0b=y=ve([re(0,D.$79b),re(1,g.$g0b),re(2,b.$pj)],y)}),define(ae[70],ce([0,1,48,15,26,156,50,3,2,13,9,4,7,106,88,21,104,182,56,24,6,20,5,27,69,29,30,58,17,243,235,78,14]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h,f,d,m,c,t,o,r,i,n,a,p,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U0b=e.$T0b=void 0,e.$T0b=(0,m.$8h)("nativeHostMainService");let j=class extends g.$Tc{constructor(F,V,J,le,oe,ue,Z,Y,q){super(),this.a=F,this.b=V,this.c=J,this.f=le,this.g=oe,this.h=ue,this.j=Z,this.m=Y,this.n=q,this.onDidOpenMainWindow=P.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=P.Event.any(P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:N,y:G})=>({windowId:L.id,x:N,y:G})),({windowId:L})=>!!this.a.getWindowById(L)),P.Event.filter(P.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:N,y:G})=>({windowId:L.id,x:N,y:G})),({windowId:L})=>!!this.b.getWindowById(L))),this.onDidMaximizeWindow=P.Event.any(P.Event.filter(P.Event.map(this.a.onDidMaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),P.Event.filter(P.Event.map(this.b.onDidMaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidUnmaximizeWindow=P.Event.any(P.Event.filter(P.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),P.Event.filter(P.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidChangeWindowFullScreen=P.Event.any(P.Event.map(this.a.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen})),P.Event.map(this.b.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen}))),this.onDidBlurMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(L,N)=>N.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(L,N)=>N.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=P.Event.any(this.onDidBlurMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(L,N)=>N),L=>(0,E.$S0b)(L.webContents)),L=>L.id)),this.onDidFocusMainOrAuxiliaryWindow=P.Event.any(this.onDidFocusMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(L,N)=>N),L=>(0,E.$S0b)(L.webContents)),L=>L.id)),this.onDidResumeOS=P.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new P.$Wd),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(L,N,G)=>G),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),P.Event.fromNodeEventEmitter(R.screen,"display-added"),P.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,V){const J=this.a.getWindows().map(oe=>({id:oe.id,workspace:oe.openedWorkspace??(0,n.$ji)(oe.backupPath,oe.isExtensionDevelopmentHost),title:oe.win?.getTitle()??"",filename:oe.getRepresentedFilename(),dirty:oe.isDocumentEdited()})),le=[];return V.includeAuxiliaryWindows&&le.push(...this.b.getWindows().map(oe=>({id:oe.id,parentId:oe.parentId,title:oe.win?.getTitle()??"",filename:oe.getRepresentedFilename()}))),[...J,...le]}async getWindowCount(F){return this.a.getWindowCount()}async getActiveWindowId(F){const V=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(V)return V.id}openWindow(F,V,J){return Array.isArray(V)?this.s(F,V,J):this.t(F,V)}async s(F,V,J=Object.create(null)){V.length>0&&await this.a.open({context:5,contextWindowId:F,urisToOpen:V,cli:this.g.args,forceNewWindow:J.forceNewWindow,forceReuseWindow:J.forceReuseWindow,preferNewWindow:J.preferNewWindow,diffMode:J.diffMode,mergeMode:J.mergeMode,addMode:J.addMode,gotoLineMode:J.gotoLineMode,noRecentEntry:J.noRecentEntry,waitMarkerFileURI:J.waitMarkerFileURI,remoteAuthority:J.remoteAuthority||void 0,forceProfile:J.forceProfile,forceTempProfile:J.forceTempProfile})}async t(F,V){await this.a.openEmptyWindow({context:5,contextWindowId:F},V)}async toggleFullScreen(F,V){this.C(V?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F,V){this.C(V?.targetWindowId,F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const V=R.screen.getCursorScreenPoint(),J=R.screen.getDisplayNearestPoint(V);return{point:V,display:J.bounds}}async isMaximized(F,V){return this.C(V?.targetWindowId,F)?.win?.isMaximized()??!1}async maximizeWindow(F,V){this.C(V?.targetWindowId,F)?.win?.maximize()}async unmaximizeWindow(F,V){this.C(V?.targetWindowId,F)?.win?.unmaximize()}async minimizeWindow(F,V){this.C(V?.targetWindowId,F)?.win?.minimize()}async moveWindowTop(F,V){this.C(V?.targetWindowId,F)?.win?.moveTop()}async positionWindow(F,V,J){const le=this.C(J?.targetWindowId,F);if(le?.win){if(le.win.isFullScreen()){const oe=P.Event.toPromise(P.Event.once(P.Event.fromNodeEventEmitter(le.win,"leave-full-screen")));le.win.setFullScreen(!1),await oe}le.win.setBounds(V)}}async updateWindowControls(F,V){this.C(V?.targetWindowId,F)?.updateWindowControls(V)}async focusWindow(F,V){this.C(V?.targetWindowId,F)?.focus({force:V?.force??!1})}async setMinimumSize(F,V,J){const le=this.D(F);if(le?.win){const[oe,ue]=le.win.getSize(),[Z,Y]=le.win.getMinimumSize(),[q,L]=[V??Z,J??Y],[N,G]=[Math.max(oe,q),Math.max(ue,L)];(Z!==q||Y!==L)&&le.win.setMinimumSize(q,L),(oe!==N||ue!==G)&&le.win.setSize(N,G)}}async saveWindowSplash(F,V){this.m.saveWindowSplash(F,V)}async installShellCommand(F){const{source:V,target:J}=await this.u();try{const{symbolicLink:le}=await w.SymlinkSupport.stat(V);if(le&&!le.dangling){const oe=await(0,u.$xq)(V);if(J===oe)return}await w.Promises.unlink(V)}catch(le){if(le.code!=="ENOENT")throw le}try{await w.Promises.symlink(J,V)}catch(le){if(le.code!=="EACCES"&&le.code!=="ENOENT")throw le;const{response:oe}=await this.showMessageBox(F,{type:"info",message:(0,h.localize)(0,null,this.j.nameShort),buttons:[(0,h.localize)(1,null),(0,h.localize)(2,null)]});if(oe===1)throw new C.$5;try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${J}' '${V}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(ue)}catch{throw new Error((0,h.localize)(3,null,V))}}}async uninstallShellCommand(F){const{source:V}=await this.u();try{await w.Promises.unlink(V)}catch(J){switch(J.code){case"EACCES":{const{response:le}=await this.showMessageBox(F,{type:"info",message:(0,h.localize)(4,null,this.j.nameShort),buttons:[(0,h.localize)(5,null),(0,h.localize)(6,null)]});if(le===1)throw new C.$5;try{const oe=`osascript -e "do shell script \\"rm '${V}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(oe)}catch{throw new Error((0,h.localize)(7,null,V))}break}case"ENOENT":break;default:throw J}}}async u(){const F=(0,b.$kc)(this.g.appRoot,"bin","code"),V=`/usr/local/bin/${this.j.applicationName}`;if(!await w.Promises.exists(F))throw new Error((0,h.localize)(8,null,F));return{source:V,target:F}}async showMessageBox(F,V){const J=this.C(V?.targetWindowId,F);return this.c.showMessageBox(V,J?.win??void 0)}async showSaveDialog(F,V){const J=this.C(V?.targetWindowId,F);return this.c.showSaveDialog(V,J?.win??void 0)}async showOpenDialog(F,V){const J=this.C(V?.targetWindowId,F);return this.c.showOpenDialog(V,J?.win??void 0)}async pickFileFolderAndOpen(F,V){const J=await this.c.pickFileFolder(V);J&&await this.w(await Promise.all(J.map(async le=>await w.SymlinkSupport.existsDirectory(le)?{folderUri:y.URI.file(le)}:{fileUri:y.URI.file(le)})),V,F)}async pickFolderAndOpen(F,V){const J=await this.c.pickFolder(V);J&&await this.w(J.map(le=>({folderUri:y.URI.file(le)})),V,F)}async pickFileAndOpen(F,V){const J=await this.c.pickFile(V);J&&await this.w(J.map(le=>({fileUri:y.URI.file(le)})),V,F)}async pickWorkspaceAndOpen(F,V){const J=await this.c.pickWorkspace(V);J&&await this.w(J.map(le=>({workspaceUri:y.URI.file(le)})),V,F)}async w(F,V,J){await this.a.open({context:3,contextWindowId:J,cli:this.g.args,urisToOpen:F,forceNewWindow:V.forceNewWindow})}async showItemInFolder(F,V){R.shell.showItemInFolder(V)}async setRepresentedFilename(F,V,J){this.C(J?.targetWindowId,F)?.setRepresentedFilename(V)}async setDocumentEdited(F,V,J){this.C(J?.targetWindowId,F)?.setDocumentEdited(V)}async openExternal(F,V){return this.g.unsetSnapExportedVariables(),R.shell.openExternal(V),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(F,V){return R.shell.trashItem(V)}async isAdmin(){let F;return v.$i?F=(await new Promise((V,J)=>{X(["native-is-elevated"],V,J)}))():F=process.getuid?.()===0,F}async writeElevated(F,V,J,le){const oe=await new Promise((ue,Z)=>{X(["@vscode/sudo-prompt"],ue,Z)});return new Promise((ue,Z)=>{const Y=[`"${this.z}"`];le?.unlock&&Y.push("--file-chmod"),Y.push("--file-write",`"${V.fsPath}"`,`"${J.fsPath}"`);const q={name:this.j.nameLong.replace("-",""),icns:v.$j&&this.g.isBuilt?(0,b.$jc)((0,b.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};oe.exec(Y.join(" "),q,(L,N,G)=>{N&&this.h.trace(`[sudo-prompt] received stdout: ${N}`),G&&this.h.trace(`[sudo-prompt] received stderr: ${G}`),L?Z(L):ue(void 0)})})}async isRunningUnderARM64Translation(){return v.$k||v.$i?!1:R.app.runningUnderARM64Translation}get z(){return v.$i?this.g.isBuilt?(0,b.$jc)((0,b.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,b.$jc)(this.g.appRoot,"scripts","code-cli.bat"):v.$k?this.g.isBuilt?(0,b.$jc)((0,b.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,b.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,b.$jc)(this.g.appRoot,"bin","code"):(0,b.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return $.$an.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return v.$i&&(0,A.$P0b)()}async killProcess(F,V,J){process.kill(V,J)}async readClipboardText(F,V){return R.clipboard.readText(V)}async writeClipboardText(F,V,J){return R.clipboard.writeText(V,J)}async readClipboardFindText(F){return R.clipboard.readFindText()}async writeClipboardFindText(F,V){return R.clipboard.writeFindText(V)}async writeClipboardBuffer(F,V,J,le){return R.clipboard.writeBuffer(V,Buffer.from(J.buffer),le)}async readClipboardBuffer(F,V){return p.$ke.wrap(R.clipboard.readBuffer(V))}async hasClipboard(F,V,J){return R.clipboard.has(V,J)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,V){this.D(F)?.updateTouchBar(V)}async notifyReady(F){this.D(F)?.setReady()}async relaunch(F,V){return this.f.relaunch(V)}async reload(F,V){const J=this.D(F);if(J){if((0,n.$ki)(J.openedWorkspace)){const le=J.openedWorkspace.configPath;if(le.scheme===l.Schemas.file&&(await this.n.resolveLocalWorkspace(le))?.transient)return this.openWindow(J.id,{forceReuseWindow:!0})}return this.f.reload(J,V?.disableExtensions!==void 0?{_:[],"disable-extensions":V.disableExtensions}:void 0)}}async closeWindow(F,V){return this.C(V?.targetWindowId,F)?.win?.close()}async quit(F){const V=this.a.getLastActiveWindow();V?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&V.win?V.win.close():this.f.quit()}async exit(F,V){await this.f.kill(V)}async resolveProxy(F,V){return this.D(F)?.win?.webContents?.session?.resolveProxy(V)}async loadCertificates(F){return(await new Promise((J,le)=>{X(["@vscode/proxy-agent"],J,le)})).loadSystemCertificates({log:this.h})}findFreePort(F,V,J,le,oe=1){return(0,k.$tg)(V,J,le,oe)}async openDevTools(F,V){this.C(V?.targetWindowId,F)?.win?.webContents.openDevTools(V?.mode?{mode:V.mode,activate:V.activate}:void 0)}async toggleDevTools(F,V){this.C(V?.targetWindowId,F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,V,J){const le=this.D(F);if(!le||!le.win)throw new Error;return await new I.$Q0b(le.win,V,this.h).inspect(J)}async windowsGetStringRegKey(F,V,J,le){if(!v.$i)return;const oe=await new Promise((ue,Z)=>{X(["@vscode/windows-registry"],ue,Z)});try{return oe.GetStringRegKey(V,J,le)}catch{return}}C(F,V){return this.D(F)??this.F(F)??this.D(V)}D(F){if(typeof F=="number")return this.a.getWindowById(F)}F(F){if(typeof F=="number")return this.b.getWindowById(F)}};e.$U0b=j,ve([D.$zh],j.prototype,"z",null),e.$U0b=j=ve([re(0,i.$79b),re(1,E.$R0b),re(2,f.$29b),re(3,c.$n0b),re(4,d.$V9b),re(5,t.$pj),re(6,o.$Hj),re(7,r.$59b),re(8,a.$g0b)],j)}),define(ae[299],ce([0,1,15,26,8,23,33,2,13,4,7,108,37,180,91,133,56,24,5,70,79,27,80,34,61,55,29]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h,f,d,m,c,t,o,r,i,n){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$V0b=void 0;const p="issue.processExplorerWindowState";let A=class{static{a=this}static{this.a="#1E1E1E"}constructor(C,j,U,F,V,J,le,oe,ue,Z,Y){this.g=C,this.h=j,this.i=U,this.j=F,this.k=V,this.l=J,this.m=le,this.n=oe,this.o=ue,this.p=Z,this.q=Y,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){y.$JU.on("vscode:listProcesses",async C=>{const j=[];try{j.push({name:(0,u.localize)(0,null),rootProcess:await(0,v.$7r)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(F=>{(0,$.$Mm)(F)?j.push({name:F.hostName,rootProcess:F}):F.processes&&j.push({name:F.hostName,rootProcess:F.processes})})}catch(U){this.i.error(`Listing processes failed: ${U}`)}this.t(C,"vscode:listProcessesResponse",j)}),y.$JU.on("vscode:workbenchCommand",(C,j)=>{const{id:U,from:F,args:V}=j;let J;switch(F){case"processExplorer":J=this.f;break;default:throw new Error(`Unexpected command source: ${F}`)}J?.webContents.send("vscode:runAction",{id:U,from:F,args:V})}),y.$JU.on("vscode:closeProcessExplorer",C=>{this.d?.close()}),y.$JU.on("vscode:pidToNameRequest",async C=>{const j=await this.k.getMainDiagnostics(),U=[];for(const F of j.windows)U.push([F.pid,`window [${F.id}] (${F.title})`]);for(const{pid:F,name:V}of r.$A0b.getAll())U.push([F,V]);this.t(C,"vscode:pidToNameResponse",U)})}async openReporter(C){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const j=new P.$Sc,U=j.add(this.n.createIPCObjectUrl()),F=this.v(this.c,700,800);this.b=this.u(F,U,{backgroundColor:C.styles.backgroundColor,title:(0,u.localize)(1,null),zoomLevel:C.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:C,disableExtensions:!!this.h.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:m.default}),this.b.loadURL(g.$pg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(C){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const j=new P.$Sc,U=j.add(this.n.createIPCObjectUrl()),F=this.p.getItem(p,void 0),V=I(F)?F:this.v(this.f,800,500);this.d=this.u(V,U,{backgroundColor:C.styles.backgroundColor,title:(0,u.localize)(2,null),zoomLevel:C.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:C,product:m.default}),this.d.loadURL(g.$pg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const J=()=>{if(!this.d)return;const le=this.d.getSize(),oe=this.d.getPosition();if(!le||!oe)return;const ue={width:le[0],height:le[1],x:oe[0],y:oe[1]};this.p.setItem(p,ue)};this.d.on("moved",J),this.d.on("resized",J)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const C=await S.contentTracing.stopRecording(`${(0,D.$eg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null,C),buttons:[(0,u.localize)(5,null)]},S.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,C)}async getSystemStatus(){const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(C,j)}async $getSystemInfo(){const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(C,j)}async $getPerformanceInfo(){try{const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(C,j)}catch(C){throw this.i.warn("issueService#getPerformanceInfo ",C.message),C}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(C){this.i.error(C)}}async $showConfirmCloseDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(6,null),buttons:[(0,u.localize)(7,null),(0,u.localize)(8,null)]},this.b);C===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(9,null),buttons:[(0,u.localize)(10,null),(0,u.localize)(11,null)]},this.b);return C===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const C=this.q.getWindowById(this.c.id);if(!C)throw new Error("Window not found");return C}async $getIssueReporterUri(C){const j=this.issueReporterWindowCheck(),U=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return s.Promises.withAsyncBody(async(F,V)=>{const J=new M.$7d;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",J.token,{replyChannel:U,extensionId:C}),y.$JU.once(U,(le,oe)=>{F(b.URI.parse(oe))});try{await(0,s.$9g)(5e3),J.cancel(),V(new Error("Timed out waiting for issue reporter URI"))}finally{y.$JU.removeHandler(U)}})}async $getIssueReporterData(C){const j=this.issueReporterWindowCheck(),U=`vscode:triggerIssueDataProviderResponse${j.id}`;return s.Promises.withAsyncBody(async F=>{const V=new M.$7d;j.sendWhenReady("vscode:triggerIssueDataProvider",V.token,{replyChannel:U,extensionId:C}),y.$JU.once(U,(J,le)=>{F(le)});try{await(0,s.$9g)(5e3),V.cancel(),F("Error: Extension timed out waiting for issue reporter data")}finally{y.$JU.removeHandler(U)}})}async $getIssueReporterTemplate(C){const j=this.issueReporterWindowCheck(),U=`vscode:triggerIssueDataTemplateResponse${j.id}`;return s.Promises.withAsyncBody(async F=>{const V=new M.$7d;j.sendWhenReady("vscode:triggerIssueDataTemplate",V.token,{replyChannel:U,extensionId:C}),y.$JU.once(U,(J,le)=>{F(le)});try{await(0,s.$9g)(5e3),V.cancel(),F("Error: Extension timed out waiting for issue reporter template")}finally{y.$JU.removeHandler(U)}})}async $getReporterStatus(C,j){const U=[!1,!1],F=this.issueReporterWindowCheck(),V="vscode:triggerReporterStatus",J=new M.$7d;return F.sendWhenReady(V,J.token,{replyChannel:V,extensionId:C,extensionName:j}),await(0,s.$Yg)(new Promise(oe=>y.$JU.once("vscode:triggerReporterStatusResponse",(ue,Z)=>oe(Z))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),J.cancel()})??U}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(C){C.isMinimized()&&C.restore(),C.focus()}t(C,j,...U){C.sender.isDestroyed()||C.sender.send(j,...U)}u(C,j,U,F){const V=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:C.width,height:C.height,minWidth:300,minHeight:200,x:C.x,y:C.y,title:U.title,backgroundColor:U.backgroundColor||a.a,webPreferences:{preload:g.$pg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.$1C)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return V.setMenuBarVisibility(!1),V}v(C,j,U){let F;const V=S.screen.getAllDisplays();if(V.length===1)F=V[0];else{if(l.$j){const oe=S.screen.getCursorScreenPoint();F=S.screen.getDisplayNearestPoint(oe)}!F&&C&&(F=S.screen.getDisplayMatching(C.getBounds())),F||(F=S.screen.getPrimaryDisplay()||V[0])}const J=F.bounds,le={width:j,height:U,x:J.x+J.width/2-j/2,y:J.y+J.height/2-U/2};return J.width>0&&J.height>0&&(le.x<J.x&&(le.x=J.x),le.y<J.y&&(le.y=J.y),le.x>J.x+J.width&&(le.x=J.x),le.y>J.y+J.height&&(le.y=J.y),le.width>J.width&&(le.width=J.width),le.height>J.height&&(le.height=J.height)),le}};e.$V0b=A,e.$V0b=A=a=ve([re(1,h.$V9b),re(2,f.$pj),re(3,$.$Lm),re(4,w.$D0b),re(5,k.$29b),re(6,d.$T0b),re(7,t.$49b),re(8,c.$Hj),re(9,o.$DO),re(10,n.$79b)],A);function I(E){return typeof E!="object"||E===null?!1:"x"in E&&"y"in E&&"width"in E&&"height"in E}}),define(ae[300],ce([0,1,23,18,24,20,5,70,27,53,28,49,100]),function(X,e,S,R,s,M,D,P,g,l,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k$b=void 0;let u=class extends y.$i$b{constructor(w,k,h,f,d,m,c,t){super(w,k,f,d,m,t),this.e=h,this.u=c}s(w){return(0,y.$h$b)(`linux-${process.arch}`,w,this.k)}t(w){this.a&&(this.d(v.$HV.CheckingForUpdates(w)),this.i.request({url:this.a},S.CancellationToken.None).then(l.$pp).then(k=>{!k||!k.url||!k.version||!k.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(v.$HV.Idle(1))):this.d(v.$HV.AvailableForDownload(k))}).then(void 0,k=>{this.j.error(k);const h=w?k.message||k:void 0;this.d(v.$HV.Idle(1,h))}))}async o(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.u.openExternal(void 0,w.update.url),this.d(v.$HV.Idle(1))}};e.$k$b=u,e.$k$b=u=ve([re(0,M.$n0b),re(1,R.$Bi),re(2,b.$wl),re(3,s.$V9b),re(4,l.$jp),re(5,D.$pj),re(6,P.$T0b),re(7,g.$Hj)],u)}),define(ae[301],ce([0,1,48,46,26,8,23,50,45,9,7,144,21,18,24,16,20,5,70,27,53,28,49,100]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h,f,d,m,c,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m$b=void 0;async function r(p,A=1e3){for(;!p();)await(0,M.$9g)(A)}let i;function n(){return typeof i>"u"&&(i=R.existsSync(l.$jc(l.$mc(process.execPath),"unins000.exe"))?0:1),i}let a=class extends o.$i$b{get cachePath(){const A=l.$jc((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return y.Promises.mkdir(A,{recursive:!0}).then(()=>A)}constructor(A,I,E,C,j,U,F,V,J){super(A,I,C,j,U,J),this.u=E,this.v=F,this.w=V,A.setRelaunchHandler(this)}handleRelaunch(A){return A?.addArgs||A?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$HV.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(A){let I=`win32-${process.arch}`;return n()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,o.$h$b)(I,A,this.k)}t(A){this.a&&(this.d(t.$HV.CheckingForUpdates(A)),this.i.request({url:this.a},D.CancellationToken.None).then(m.$pp).then(I=>{const E=n();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!A}),this.d(t.$HV.Idle(E)),Promise.resolve(null)):E===1?(this.d(t.$HV.AvailableForDownload(I)),Promise.resolve(null)):(this.d(t.$HV.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(C=>y.Promises.exists(C).then(j=>{if(j)return Promise.resolve(C);const U=`${C}.tmp`;return this.i.request({url:I.url},D.CancellationToken.None).then(F=>this.v.writeFile(b.URI.file(U),F.stream)).then(I.sha256hash?()=>(0,v.$EU)(U,I.sha256hash):()=>{}).then(()=>y.Promises.rename(U,C,!1)).then(()=>C)})).then(C=>{const j=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:C},j?this.k.target==="user"?this.p():this.d(t.$HV.Downloaded(I)):this.d(t.$HV.Ready(I))})))}).then(void 0,I=>{this.u.publicLog2("update:error",{messageHash:String((0,g.$Vi)(String(I)))}),this.j.error(I);const E=A?I.message||I:void 0;this.d(t.$HV.Idle(n(),E))}))}async o(A){A.update.url&&this.w.openExternal(void 0,A.update.url),this.d(t.$HV.Idle(n()))}async B(A){const I=await this.cachePath;return l.$jc(I,`CodeSetup-${this.k.quality}-${A}.exe`)}async C(A=null){const I=A?U=>!new RegExp(`${this.k.quality}-${A}\\.exe$`).test(U):()=>!0,E=await this.cachePath,j=(await y.Promises.readdir(E)).filter(I).map(async U=>{try{await y.Promises.unlink(l.$jc(E,U))}catch{}});await Promise.all(j)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const A=this.state.update;this.d(t.$HV.Updating(A));const I=await this.cachePath;this.e.updateFilePath=l.$jc(I,`CodeSetup-${this.k.quality}-${A.version}.flag`),await y.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$HV.Idle(n()))});const C=`${this.k.win32MutexName}-ready`,j=await new Promise((U,F)=>{X(["@vscode/windows-mutex"],U,F)});r(()=>j.isActive(C)).then(()=>this.d(t.$HV.Ready(A)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?R.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return n()}async _applySpecificUpdate(A){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),E={version:"unknown",productVersion:"unknown"};this.d(t.$HV.Downloading(E)),this.e={packagePath:A},I?this.k.target==="user"?this.p():this.d(t.$HV.Downloaded(E)):this.d(t.$HV.Ready(E))}};e.$m$b=a,ve([P.$zh],a.prototype,"cachePath",null),e.$m$b=a=ve([re(0,k.$n0b),re(1,u.$Bi),re(2,c.$wl),re(3,$.$V9b),re(4,m.$jp),re(5,h.$pj),re(6,w.$sk),re(7,f.$T0b),re(8,d.$Hj)],a)}),define(ae[134],ce([0,1,15,8,23,51,3,2,13,67,4,7,190,26,65,18,56,24,64,16,20,5,27,80,252,82,28,103,69,55,29,30,58,129,39,34,57,68,22,6]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h,f,d,m,c,t,o,r,i,n,a,p,A,I,E,C,j,U,F,V,J,le,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l0b=e.$k0b=void 0;var ue;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(ue||(ue={}));class Z extends P.$Tc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(D.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(D.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(D.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(D.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(D.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(D.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const N=!(0,A.$WC)(this.r);if(b.$j&&N&&L.setSheetOffset((0,b.$J)((0,u.release)())?28:22),N&&(b.$i&&(0,A.$YC)(this.r)||b.$j)){const G=this.s.getItem(Z.C);G&&this.updateWindowControls({height:G})}b.$i&&N&&L.hookWindowMessage(278,()=>{const[B,te]=L.getPosition(),he=S.screen.getCursorScreenPoint(),K=he.x-B,O=he.y-te;return!(K>30&&O>=0&&O<=Math.max(L.getBounds().height*.15,35))||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:K,y:O})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools(),b.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.G?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.G?.complete(!0)})))}constructor(L,N,G,B){super(),this.r=L,this.s=N,this.t=G,this.u=B,this.a=this.B(new D.$Wd),this.onDidClose=this.a.event,this.b=this.B(new D.$Wd),this.onDidMaximize=this.b.event,this.c=this.B(new D.$Wd),this.onDidUnmaximize=this.c.event,this.f=this.B(new D.$Wd),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new D.$Wd),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new D.$Wd),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.D=(0,A.$YC)(this.r),this.F=void 0,this.G=void 0}setRepresentedFilename(L){b.$j?this.win?.setRepresentedFilename(L):this.w=L}getRepresentedFilename(){return b.$j?this.win?.getRepresentedFilename():this.w}setDocumentEdited(L){b.$j&&this.win?.setDocumentEdited(L),this.z=L}isDocumentEdited(){return b.$j?!!this.win?.isDocumentEdited():!!this.z}focus(L){b.$j&&L?.force&&S.app.focus({steal:!0});const N=this.win;N&&(N.isMinimized()&&N.restore(),N.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(b.$j)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.C="windowControlHeight"}updateWindowControls(L){const N=this.win;if(N){if(L.height&&this.s.setItem(Y.C,L.height),b.$i&&this.D)N.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(b.$j&&L.height!==void 0){const G=(L.height-15)/2;G?N.setWindowButtonPosition({x:G,y:G}):N.setWindowButtonPosition(null)}}}toggleFullScreen(){this.H(!this.isFullScreen,!1)}H(L,N){(0,A.$ZC)(this.r)?this.I(L,N):this.L(L)}get isFullScreen(){if(b.$j&&typeof this.F=="boolean")return this.F;const L=this.win,N=L?.isFullScreen(),G=L?.isSimpleFullScreen();return!!(N||G)}I(L,N){const G=this.win;G?.isSimpleFullScreen()&&G?.setSimpleFullScreen(!1),this.J(L,N)}J(L,N){if(b.$j){this.F=L;const B=this.G=new R.$sh;(async()=>{const te=await Promise.race([B.p,(0,R.$9g)(1e4).then(()=>!1)]);this.G===B&&(this.F=void 0,this.G=void 0,!te&&L&&N&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(L)}L(L){const N=this.win;N?.isFullScreen()&&this.J(!1,!1),N?.setSimpleFullScreen(L),N?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$k0b=Z;let Y=class extends Z{get id(){return this.P}get backupPath(){return this.R?.backupPath}get openedWorkspace(){return this.R?.workspace}get profile(){if(!this.config)return;const L=this.gb.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.gb.getProfileForWorkspace(this.config.workspace??(0,E.$ji)(this.backupPath,this.isExtensionDevelopmentHost))??this.gb.defaultProfile}get remoteAuthority(){return this.R?.remoteAuthority}get config(){return this.R}get isExtensionDevelopmentHost(){return!!this.R?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.R?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.R?.debugId}constructor(L,N,G,B,te,he,K,O,W,x,T,Q,H,_,z,ee,se,de,me,Ee,Pe){super(x,Ee,B,N),this.eb=G,this.fb=te,this.gb=he,this.hb=K,this.ib=O,this.jb=W,this.kb=T,this.lb=Q,this.mb=H,this.nb=_,this.ob=z,this.pb=ee,this.qb=se,this.rb=de,this.sb=me,this.M=this.B(new D.$Wd),this.onWillLoad=this.M.event,this.N=this.B(new D.$Wd),this.onDidSignalReady=this.N.event,this.O=this.B(new D.$Wd),this.onDidDestroy=this.O.event,this.W=[],this.X=[],this.Y=void 0,this.Z=void 0,this.$=void 0,this.ab=this.B(this.rb.createIPCObjectUrl()),this.db=!1,this.tb=0;{const[Le,ke]=this.Db(L.state);this.S=Le,this.u.trace("window#ctor: using window state",Le);const pe=this.S.mode===0||this.S.mode===3,ie=Pe.invokeFunction(I.$89b,this.S,{show:!pe,webPreferences:{preload:g.$pg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.ab.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"}});(0,l.mark)("code/willCreateCodeBrowserWindow"),this.m=new S.BrowserWindow(ie),(0,l.mark)("code/didCreateCodeBrowserWindow"),this.P=this.m.id,this.n(this.m);const fe=this.r.getValue("window"),$e=b.$j&&fe?.nativeTabs===!0;(b.$j||b.$i)&&ke&&(!$e||S.BrowserWindow.getAllWindows().length===1)&&[this.S.width,this.S.height,this.S.x,this.S.y].every(Ie=>typeof Ie=="number")&&this.m.setBounds({width:this.S.width,height:this.S.height,x:this.S.x,y:this.S.y}),pe&&((0,l.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.S.mode===3&&this.H(!0,!0),this.m.show(),(0,l.mark)("code/didMaximizeCodeWindow")),this.j=Date.now()}this.Ab(),this.Lb(),this.ub()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.P})`),this.tb=2;this.W.length;)this.W.pop()(this);this.N.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.W.push(L)})}get isReady(){return this.tb===2}get whenClosedOrLoaded(){return new Promise(L=>{function N(){G.dispose(),B.dispose(),L()}const G=this.onDidClose(()=>N()),B=this.onWillLoad(()=>N())})}ub(){this.m.on("unresponsive",()=>this.xb(1)),this.m.webContents.on("render-process-gone",(N,G)=>this.xb(2,{...G})),this.m.webContents.on("did-fail-load",(N,G,B)=>this.xb(3,{reason:B,exitCode:G})),this.m.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this.m.webContents.on("did-finish-load",()=>{this.bb&&(this.R=this.bb,this.bb=void 0)}),this.B(this.onDidMaximize(()=>{this.R&&(this.R.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.R&&(this.R.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(N=>this.Ab(N))),this.B(this.lb.onDidDeleteUntitledWorkspace(N=>this.zb(N)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(N,G)=>{const B=await this.wb();G({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,B)})})}wb(){return this.vb||(this.vb=(0,r.$Dp)(this.qb.version,this.qb,this.t,this.r,this.hb,this.ib,this.nb)),this.vb}async xb(L,N){switch(L){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.nb.publicLog2("windowerror",{type:L,reason:N?.reason,code:N?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.pb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.yb(!1,!1),this.pb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:G,checkboxChecked:B}=await this.ob.showMessageBox({type:"warning",buttons:[(0,y.localize)(0,null),(0,y.localize)(1,null),(0,y.localize)(2,null)],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),checkboxLabel:this.R?.workspace?(0,y.localize)(5,null):void 0},this.m);if(G!==2){const te=G===0;await this.yb(te,B)}}else if(L===2){let G;N?G=(0,y.localize)(7,null,N.reason,N.exitCode??"<unknown>"):G=(0,y.localize)(6,null);const{response:B,checkboxChecked:te}=await this.ob.showMessageBox({type:"warning",buttons:[this.R?.workspace?(0,y.localize)(8,null):(0,y.localize)(9,null),(0,y.localize)(10,null)],message:G,detail:this.R?.workspace?(0,y.localize)(11,null):(0,y.localize)(12,null),checkboxLabel:this.R?.workspace?(0,y.localize)(13,null):void 0},this.m),he=B===0;await this.yb(he,te)}break}}async yb(L,N){const G=this.R?.workspace;if(N&&G)try{const B=this.jb.workspaceStorage(G);await B.init(),B.delete("memento/workbench.parts.editor"),await B.close()}catch(B){this.u.error(B)}this.O.fire();try{if(L&&this.R){let B,te;(0,E.$fi)(G)?B={folderUri:G.uri}:(0,E.$ki)(G)?B={workspaceUri:G.configPath}:te=!0,(0,le.$Ob)(await this.sb.open({context:5,userEnv:this.R.userEnv,cli:{...this.t.args,_:[]},urisToOpen:B?[B]:void 0,forceEmpty:te,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}zb(L){this.R?.workspace?.id===L.id&&(this.R.workspace=void 0)}Ab(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const N=this.Hb();N!==this.U&&(this.U=N,this.Ib(N))}if(!L||L.affectsConfiguration("http.proxy")){let N=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const G=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.Y||G!==this.Z)){this.Y=N,this.Z=G;const B=N||"",te=G?`${G},<local>`:"<local>";this.u.trace(`Setting proxy to '${B}', bypassing '${te}'`),this.m.webContents.session.setProxy({proxyRules:B,proxyBypassRules:te,pacScript:""})}}}addTabbedWindow(L){b.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,N=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.P})`),this.isDocumentEdited()&&(!N.isReload||!this.mb.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.qb.nameLong)),this.Bb(L,N),this.tb===0?this.R=L:this.bb=L,this.tb=1,this.m.loadURL(g.$pg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const G=this.db;this.db=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new R.$hh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.M.fire({workspace:L.workspace,reason:N.isReload?3:G?2:1})}Bb(L,N){const G=(this.R??this.bb)?.userEnv;if(G){const B=(0,f.$8l)(G)&&!(0,f.$8l)(L.userEnv),te=this.isExtensionDevelopmentHost;(B||te)&&(L.userEnv={...G,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(L["disable-extensions"]=N.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.kb.getWindowSplash(),L.zoomLevel=this.Kb(),L.isCustomZoomLevel=typeof this.$=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,l.mark)("code/willOpenNewWindow"),L.perfMarks=(0,l.getMarks)(),this.ab.update(L)}async reload(L){const N=Object.assign({},this.R);N.workspace=await this.Cb(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&L&&(N.verbose=L.verbose,N.debugId=L.debugId,N.extensionEnvironment=L.extensionEnvironment,N["inspect-extensions"]=L["inspect-extensions"],N["inspect-brk-extensions"]=L["inspect-brk-extensions"],N["extensions-dir"]=L["extensions-dir"]),N.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.fb.serialize(),N.continueOn=this.t.continueOn,N.profiles={all:this.gb.profiles,profile:this.profile||this.gb.defaultProfile,home:this.gb.profilesHome},N.logLevel=this.eb.getLogLevel(),N.loggers={window:this.eb.getRegisteredLoggers(this.id),global:this.eb.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Cb(L){if((0,E.$ki)(L.workspace)){const N=L.workspace.configPath;if(N.scheme===g.Schemas.file&&!await this.hb.exists(N))return}else if((0,E.$fi)(L.workspace)){const N=L.workspace.uri;if(N.scheme===g.Schemas.file&&!await this.hb.exists(N))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,j.$U9b)();if(this.isFullScreen){let G;try{G=S.screen.getDisplayMatching(this.getBounds())}catch{}const B=(0,j.$U9b)();return{mode:3,display:G?G.id:void 0,width:this.S.width||B.width,height:this.S.height||B.height,x:this.S.x||0,y:this.S.y||0,zoomLevel:this.$}}const L=Object.create(null);let N;if(!b.$j&&this.m.isMaximized()?N=0:N=1,N===0?L.mode=0:L.mode=1,N===1||N===0){let G;N===1?G=this.getBounds():G=this.m.getNormalBounds(),L.x=G.x,L.y=G.y,L.width=G.width,L.height=G.height}return L.zoomLevel=this.$,L}Db(L){(0,l.mark)("code/willRestoreCodeWindowState");let N=!1;if(L){this.$=L.zoomLevel;try{const G=S.screen.getAllDisplays();N=G.length>1,L=this.Eb(L,G)}catch(G){this.u.warn(`Unexpected error validating window state: ${G}
${G.stack}`)}}return(0,l.mark)("code/didRestoreCodeWindowState"),[L||(0,j.$U9b)(),N]}Eb(L,N){if(this.u.trace(`window#validateWindowState: validating window state on ${N.length} display(s)`,L),typeof L.x!="number"||typeof L.y!="number"||typeof L.width!="number"||typeof L.height!="number"){this.u.trace("window#validateWindowState: unexpected type of state values");return}if(L.width<=0||L.height<=0){this.u.trace("window#validateWindowState: unexpected negative values");return}if(N.length===1){const te=this.Fb(N[0]);if(te){let he=function(){!L||typeof L.x!="number"||typeof L.y!="number"||!te||(L.x<te.x&&(L.x=te.x),L.y<te.y&&(L.y=te.y))};this.u.trace("window#validateWindowState: 1 monitor working area",te),he(),L.width>te.width&&(L.width=te.width),L.height>te.height&&(L.height=te.height),L.x>te.x+te.width-128&&(L.x=te.x+te.width-L.width),L.y>te.y+te.height-128&&(L.y=te.y+te.height-L.height),he()}return L}if(L.display&&L.mode===3){const te=N.find(he=>he.id===L.display);if(te&&typeof te.bounds?.x=="number"&&typeof te.bounds?.y=="number"){this.u.trace("window#validateWindowState: restoring fullscreen to previous display");const he=(0,j.$U9b)(3);return he.x=te.bounds.x,he.y=te.bounds.y,he}}let G,B;try{G=S.screen.getDisplayMatching({x:L.x,y:L.y,width:L.width,height:L.height}),B=this.Fb(G)}catch{}if(G&&B&&L.x+L.width>B.x&&L.y+L.height>B.y&&L.x<B.x+B.width&&L.y<B.y+B.height)return this.u.trace("window#validateWindowState: multi-monitor working area",B),L}Fb(L){if(L.workArea.width>0&&L.workArea.height>0)return L.workArea;if(L.bounds.width>0&&L.bounds.height>0)return L.bounds}getBounds(){const[L,N]=this.m.getPosition(),[G,B]=this.m.getSize();return{x:L,y:N,width:G,height:B}}H(L,N){super.H(L,N),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.U&&this.Ib(this.U,!1)}Hb(){let L=(0,A.$UC)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Ib(L,N=!0){b.$j||(L==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,y.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Jb(L)}):this.Jb(L))}Jb(L){const N=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!N),this.m.autoHideMenuBar=N;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.$=L}Kb(){return typeof this.$=="number"?this.$:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,N,...G){this.isReady?this.send(L,...G):this.ready().then(()=>{N.isCancellationRequested||this.send(L,...G)})}send(L,...N){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...N)}catch(G){this.u.warn(`Error sending IPC message to channel '${L}' of window ${this.P}: ${(0,M.$Si)(G)}`)}}}updateTouchBar(L){b.$j&&this.X.forEach((N,G)=>{const B=L[G];N.segments=this.Nb(B)})}Lb(){if(b.$j){for(let L=0;L<10;L++){const N=this.Mb();this.X.push(N)}this.m.setTouchBar(new S.TouchBar({items:this.X}))}}Mb(L=[]){const N=this.Nb(L),G=new S.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:B=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:G.segments[B].id,from:"touchbar"})}});return G}Nb(L=[]){return L.map(G=>{let B;G.icon&&!a.ThemeIcon.isThemeIcon(G.icon)&&G.icon?.dark?.scheme===g.Schemas.file&&(B=S.nativeImage.createFromPath(v.URI.revive(G.icon.dark).fsPath),B.isEmpty()&&(B=void 0));let te;return typeof G.title=="string"?te=G.title:te=G.title.value,{id:G.id,label:B?void 0:te,icon:B}})}dispose(){super.dispose(),this.eb.deregisterLoggers(this.id)}};e.$l0b=Y,e.$l0b=Y=ve([re(1,c.$pj),re(2,J.$i0b),re(3,h.$V9b),re(4,U.$Mn),re(5,V.$09b),re(6,d.$sk),re(7,i.$v0b),re(8,i.$t0b),re(9,w.$Bi),re(10,p.$59b),re(11,C.$g0b),re(12,$.$19b),re(13,n.$wl),re(14,k.$29b),re(15,m.$n0b),re(16,t.$Hj),re(17,o.$49b),re(18,I.$79b),re(19,F.$DO),re(20,oe.$7h)],Y)}),define(ae[302],ce([0,1,15,4,18,24,20,5,34,55,134]),function(X,e,S,R,s,M,D,P,g,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m0b=void 0;let v=class extends b.$k0b{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(u,$,w,k,h,f){super(k,h,$,w),this.M=u,this.N=f,this.id=this.M.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this.m||this.q.isDisposed||this.M.isDestroyed())return;const u=S.BrowserWindow.fromWebContents(this.M);u&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(u),u.setMenu(null),(R.$i||R.$k)&&(0,l.$WC)(this.r)&&u.setAutoHideMenuBar(!0),this.N.registerAuxWindow(this))}};e.$m0b=v,e.$m0b=v=ve([re(1,M.$V9b),re(2,P.$pj),re(3,s.$Bi),re(4,g.$DO),re(5,D.$n0b)],v)}),define(ae[303],ce([0,1,15,3,2,13,37,302,6,5,29]),function(X,e,S,R,s,M,D,P,g,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R$b=void 0;let v=class extends s.$Tc{constructor(u,$){super(),this.h=u,this.j=$,this.a=this.B(new R.$Wd),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new R.$Wd),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new R.$Wd),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new R.$Wd),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){S.app.on("browser-window-created",(u,$)=>{const w=this.getWindowById($.id);w&&(this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),w.tryClaimWindow())}),D.$JU.handle("vscode:registerAuxiliaryWindow",async(u,$)=>{const w=this.getWindowById(u.sender.id);return w&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),w.parentId=$),u.sender.id})}createWindow(){return this.h.invokeFunction(b.$89b,void 0,{webPreferences:{preload:M.$pg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}registerWindow(u){const $=new s.$Sc,w=this.h.createInstance(P.$m0b,u);this.g.set(w.id,w),$.add((0,s.$Rc)(()=>this.g.delete(w.id))),$.add(w.onDidMaximize(()=>this.a.fire(w))),$.add(w.onDidUnmaximize(()=>this.b.fire(w))),$.add(w.onDidEnterFullScreen(()=>this.c.fire({window:w,fullscreen:!0}))),$.add(w.onDidLeaveFullScreen(()=>this.c.fire({window:w,fullscreen:!1}))),$.add(w.onDidTriggerSystemContextMenu(({x:k,y:h})=>this.f.fire({window:w,x:k,y:h}))),R.Event.once(w.onDidClose)(()=>$.dispose())}getWindowById(u){return this.g.get(u)}getFocusedWindow(){const u=S.BrowserWindow.getFocusedWindow();if(u)return this.getWindowById(u.id)}getLastActiveWindow(){return(0,b.$99b)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$R$b=v,e.$R$b=v=ve([re(0,g.$7h),re(1,l.$pj)],v)}),define(ae[83],ce([0,1,15,22,8,3,47,2,13,4,19,7,21,193,6,20,5,82,97,30,58,31,56]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h,f,d,m,c,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$70b=e.$60b=void 0,e.$60b=(0,$.$8h)("workspacesHistoryMainService");let r=class extends P.$Tc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(n,a,p,A,I){super(),this.f=n,this.g=a,this.h=p,this.j=A,this.m=I,this.c=this.B(new M.$Wd),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new s.$6g(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let a=[],p=[];for(const I of n)if((0,f.$Scb)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.w(a,I.workspace)&&a.push(I);else if((0,f.$Tcb)(I))this.y(a,I.folderUri)||a.push(I);else{const E=this.z(p,I.fileUri),C=I.fileUri.scheme===g.Schemas.file&&o.G.indexOf((0,b.$Fg)(I.fileUri))>=0;!E&&!C&&(p.push(I),l.$i&&I.fileUri.scheme===g.Schemas.file&&S.app.addRecentDocument(I.fileUri.fsPath))}const A=await this.r({workspaces:a,files:p});a=A.workspaces,p=A.files,a.length>o.a&&(a.length=o.a),p.length>o.a&&(p.length=o.a),await this.t({workspaces:a,files:p}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(n){const a=E=>{const C=this.u(E);for(const j of n)if(b.$zg.isEqual(j,C))return!1;return!0},p=await this.getRecentlyOpened(),A=p.workspaces.filter(a),I=p.files.filter(a);(A.length!==p.workspaces.length||I.length!==p.files.length)&&(await this.t({files:I,workspaces:A}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(n){if(n?.confirm){const{response:a}=await this.m.showMessageBox({type:"warning",buttons:[(0,u.localize)(0,null),(0,u.localize)(1,null)],message:(0,u.localize)(2,null),detail:(0,u.localize)(3,null),cancelId:1});if(a!==0)return}await this.t({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(n){const a=new c.$Ac(I=>b.$zg.getComparisonKey(I));if(n?.workspaces)for(const I of n.workspaces)a.set(this.u(I),I);const p=new c.$Ac(I=>b.$zg.getComparisonKey(I));if(n?.files)for(const I of n.files)p.set(this.u(I),I);const A=await this.s();for(const I of A.workspaces){const E=a.get(this.u(I));E?E.label=E.label??I.label:a.set(this.u(I),I)}for(const I of A.files){const E=p.get(this.u(I));E?E.label=E.label??I.label:p.set(this.u(I),I)}return{workspaces:[...a.values()],files:[...p.values()]}}async s(){await this.j.whenReady;let n;const a=this.j.get(o.b,-1);if(typeof a=="string")try{n=JSON.parse(a)}catch(p){this.f.error("Unexpected error parsing opened paths list",p)}return(0,f.$Zcb)(n,this.f)}async t(n){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,f.$1cb)(n)),-1,1)}u(n){return(0,f.$Tcb)(n)?n.folderUri:(0,f.$Ucb)(n)?n.fileUri:n.workspace.configPath}w(n,a){return!!n.find(p=>(0,f.$Scb)(p)&&p.workspace.id===a.id)}y(n,a){return!!n.find(p=>(0,f.$Tcb)(p)&&b.$zg.isEqual(p.folderUri,a))}z(n,a){return!!n.find(p=>b.$zg.isEqual(p.fileUri,a))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){l.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!l.$i)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,u.localize)(4,null),description:(0,u.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const a=[];for(const I of S.app.getJumpListSettings().removedItems){const E=I.args;if(E){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(E);C&&a.push(v.URI.parse(C[2]))}}await this.removeRecentlyOpened(a);let p=!1;const A=(0,R.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(I=>{const E=(0,f.$Scb)(I)?I.workspace:I.folderUri,{title:C,description:j}=this.L(E,I.label);let U;return v.URI.isUri(E)?U=`--folder-uri "${E.toString()}"`:(p=!0,U=`--file-uri "${E.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:j.substr(0,255),program:process.execPath,args:U,iconPath:"explorer.exe",iconIndex:0}}));A.length>0&&n.push({type:"custom",name:p?(0,u.localize)(6,null):(0,u.localize)(7,null),items:A})}n.push({type:"recent"});try{const a=S.app.setJumpList(n);a&&a!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${a}`)}catch(a){this.f.warn("updateWindowsJumpList#setJumpList",a)}}L(n,a){if(a)return{title:(0,D.$7v)(a).name,description:a};if(v.URI.isUri(n))return{title:(0,b.$Fg)(n),description:this.M(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,u.localize)(8,null),description:""};let p=(0,b.$Fg)(n.configPath);return p.endsWith(d.$ri)&&(p=p.substr(0,p.length-d.$ri.length-1)),{title:(0,u.localize)(9,null,p),description:this.M(n.configPath)}}M(n){return n.scheme==="file"?(0,D.$Yv)(n.fsPath):n.toString()}async N(){if(!l.$j)return;S.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),a=[];let p=0;for(let I=0;I<n.workspaces.length&&p<o.C;I++){const E=this.u(n.workspaces[I]);if(E.scheme===g.Schemas.file){const C=(0,b.$wg)(E);await y.Promises.exists(C)&&(a.push(C),p++)}}const A=[];for(let I=0;I<n.files.length&&p<o.D;I++){const E=this.u(n.files[I]);if(E.scheme===g.Schemas.file){const C=(0,b.$wg)(E);if(o.G.includes((0,b.$Fg)(E))||a.includes(C))continue;await y.Promises.exists(C)&&(A.push(C),p++)}}A.reverse().forEach(I=>S.app.addRecentDocument(I)),a.reverse().forEach(I=>S.app.addRecentDocument(I))}};e.$70b=r,e.$70b=r=o=ve([re(0,k.$pj),re(1,m.$g0b),re(2,w.$n0b),re(3,h.$v0b),re(4,t.$29b)],r)}),define(ae[304],ce([0,1,15,8,23,47,4,7,181,78,18,24,20,5,231,70,27,34,28,49,55,29,83]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h,f,d,m,c,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$80b=void 0;const r="menu";let i=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(p,A,I,E,C,j,U,F,V,J,le,oe){this.n=p,this.o=A,this.p=I,this.q=E,this.r=C,this.s=j,this.t=U,this.u=F,this.v=V,this.w=J,this.x=le,this.y=oe,this.m=Object.create(null),this.g=new R.$hh(()=>this.F(),0),this.h=new R.$hh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.$j||(0,m.$WC)(A))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const p=this.t.getItem(o.a);p&&(p.menus&&(this.k=p.menus),p.keybindings&&(this.l=p.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(j,U,F)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:U?.id})},this.m["workbench.action.newWindow"]=(j,U,F)=>this.p.openEmptyWindow({context:2,contextWindowId:U?.id}),this.m["workbench.action.files.openFileFolder"]=(j,U,F)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(j,U,F)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(j,U,F)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const p=this.x.youTubeUrl;p&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(p,"openYouTubeUrl"));const A=this.x.requestFeatureUrl;A&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(A,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(I,"openReportIssues"));const E=this.x.licenseUrl;E&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.$w){const j=E.indexOf("?")>0?"&":"?";this.ab(`${E}${j}lang=${D.$w}`,"openLicenseUrl")}else this.ab(E,"openLicenseUrl")});const C=this.x.privacyStatementUrl;C&&E&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(C,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(p=>this.G(p)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const p=this.o.getValue("window.enableMenuBarMnemonics");return typeof p!="boolean"?!0:p}get D(){if(!D.$j)return!1;const p=this.o.getValue("window.nativeTabs");return typeof p!="boolean"?!1:p}updateMenu(p,A){this.k=p.menus,this.l=p.keybindings,this.t.setItem(o.a,p),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(p){D.$j&&(p.oldCount===0&&p.newCount>0||p.oldCount>0&&p.newCount===0)&&(this.d=p.newCount===0,this.E())}H(){if(!D.$j)return;const p=S.BrowserWindow.getFocusedWindow();this.f=!p||!!this.y.getWindowById(p.id),this.E()}I(){const p=S.Menu.getApplicationMenu();if(p&&this.j.push(p),Object.keys(this.k).length===0){this.J(D.$j?new S.Menu:null);return}const A=new S.Menu;let I;if(D.$j){const C=new S.Menu;I=new S.MenuItem({label:this.x.nameShort,submenu:C}),this.K(C),A.append(I)}if(D.$j&&!this.c){this.c=!0;const C=new S.Menu;C.append(new S.MenuItem({label:this.cb(g.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(C)}if(this.M("File")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(1,null)),submenu:C});this.O(C,"File"),A.append(j)}if(this.M("Edit")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(2,null)),submenu:C});this.O(C,"Edit"),A.append(j)}if(this.M("Selection")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(3,null)),submenu:C});this.O(C,"Selection"),A.append(j)}if(this.M("View")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(4,null)),submenu:C});this.O(C,"View"),A.append(j)}if(this.M("Go")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(5,null)),submenu:C});this.O(C,"Go"),A.append(j)}if(this.M("Run")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(6,null)),submenu:C});this.O(C,"Run"),A.append(j)}if(this.M("Terminal")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(7,null)),submenu:C});this.O(C,"Terminal"),A.append(j)}let E;if(this.M("Window")){const C=new S.Menu;E=new S.MenuItem({label:this.cb(g.localize(8,null)),submenu:C,role:"window"}),this.U(C)}if(E&&A.append(E),this.M("Help")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(9,null)),submenu:C,role:"help"});this.O(C,"Help"),A.append(j)}A.items&&A.items.length>0?this.J(A):this.J(null),this.h.schedule()}J(p){if(S.Menu.setApplicationMenu(p),p)for(const A of this.y.getWindows())A.win?.setMenu(null)}K(p){const A=this.W(g.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.V();let E;if(this.M("Preferences")){const oe=new S.Menu;this.O(oe,"Preferences"),E=new S.MenuItem({label:this.cb(g.localize(11,null)),submenu:oe})}const C=new S.Menu,j=new S.MenuItem({label:g.localize(12,null),role:"services",submenu:C}),U=new S.MenuItem({label:g.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),F=new S.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),V=new S.MenuItem({label:g.localize(15,null),role:"unhide"}),J=new S.MenuItem(this.$("workbench.action.quit",{label:g.localize(16,null,this.x.nameLong),click:async(oe,ue,Z)=>{const Y=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||S.BrowserWindow.getFocusedWindow()||Y?.win?.isMinimized())&&await this.L(Z)&&this.w.quit(void 0)}})),le=[A];le.push(...I),E&&le.push(n(),E),le.push(n(),j,n(),U,F,V,n(),J),le.forEach(oe=>p.append(oe))}async L(p){if(this.p.getWindowCount()===0)return!0;const A=this.o.getValue("window.confirmBeforeClose");if(A==="always"||A==="keyboardOnly"&&this.S(p)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[g.localize(17,null),g.localize(18,null)],message:g.localize(19,null)});return I===0}return!0}M(p){if(!D.$j&&!(0,m.$WC)(this.o))return!1;switch(p){case"File":case"Help":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[p];case"Window":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[p]}}N(p,A){A.forEach(I=>{if((0,$.$30b)(I))p.append(n());else if((0,$.$20b)(I)){const E=new S.Menu,C=new S.MenuItem({label:this.cb(I.label),submenu:E});this.N(E,I.submenu.items),p.append(C)}else(0,$.$40b)(I)?p.append(this.Q(I)):(0,$.$50b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.P(p),D.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?p.append(new S.MenuItem(this.$(I.id,{label:this.cb(I.label),click:this.m[I.id]}))):p.append(this.W(I.label,I.id,!1,I.checked)):p.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)):p.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)))})}O(p,A){this.k&&this.k[A]&&this.N(p,this.k[A].items)}P(p){const A=this.V();A.length&&(A.forEach(I=>p.append(I)),p.append(n()))}Q(p){const A=P.URI.revive(p.uri),I=p.id,E=I==="openRecentFile"?{fileUri:A}:I==="openRecentWorkspace"?{workspaceUri:A}:{folderUri:A};return new S.MenuItem(this.$(I,{label:p.label,click:async(C,j,U)=>{const F=this.R(U);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[E],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:p.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([A])}},!1))}R(p){return!!(p&&(!D.$j&&(p.ctrlKey||p.shiftKey)||D.$j&&(p.metaKey||p.altKey)))}S(p){return!!(p.triggeredByAccelerator||p.altKey||p.ctrlKey||p.metaKey||p.shiftKey)}T(p,A,I){const E={label:this.cb(p),role:I,enabled:!0};return new S.MenuItem(this.Z(A,E))}U(p){const A=new S.MenuItem({label:g.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new S.MenuItem({label:g.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),E=new S.MenuItem({label:g.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),C=this.W(g.localize(23,null),"workbench.action.switchWindow"),j=[];this.D&&(j.push(n()),j.push(this.W(g.localize(24,null),"workbench.action.newWindowTab")),j.push(this.T(g.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),j.push(this.T(g.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),j.push(this.T(g.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),j.push(this.T(g.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[A,I,n(),C,...j,n(),E].forEach(U=>p.append(U))}V(){switch(this.n.state.type){case"idle":return[new S.MenuItem({label:this.cb(g.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:g.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.cb(g.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:g.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.cb(g.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:g.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.cb(g.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(p,A,I,E){const C=this.cb(p),j=typeof A=="function"?A:(le,oe,ue)=>{const Z=le?le.userSettingsLabel:null;let Y=A;Array.isArray(A)&&(Y=this.R(ue)?A[1]:A[0]),Z&&ue.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Z}):this.Y({type:"commandId",commandId:Y})},U=typeof I=="boolean"?I:this.p.getWindowCount()>0,F=typeof E=="boolean"?E:!1,V={label:C,click:j,enabled:U};F&&(V.type="checkbox",V.checked=F);let J;return typeof A=="string"?J=A:Array.isArray(A)&&(J=A[0]),D.$j&&(J==="editor.action.clipboardCutAction"?V.role="cut":J==="editor.action.clipboardCopyAction"?V.role="copy":J==="editor.action.clipboardPasteAction"&&(V.role="paste"),J==="undo"?V.click=this.X(j,{inDevTools:le=>le.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):J==="redo"?V.click=this.X(j,{inDevTools:le=>le.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):J==="editor.action.selectAll"&&(V.click=this.X(j,{inDevTools:le=>le.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.Z(J,V))}X(p,A){return(I,E,C)=>{const j=S.BrowserWindow.getFocusedWindow();if(!j)return A.inNoWindow();if(j.webContents.isDevToolsFocused()&&j.webContents.devToolsWebContents)return A.inDevTools(j.webContents.devToolsWebContents);p(I,E||j,C)}}Y(p){let A=S.BrowserWindow.getFocusedWindow();if(A){const E=this.y.getWindowById(A.id);E&&(A=this.p.getWindowById(E.parentId)?.win??null)}if(!A){const E=this.p.getLastActiveWindow();E?.win?.isMinimized()&&(A=E.win)}const I=A?this.p.getWindowById(A.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",p),D.$j&&!this.q.isBuilt&&!I.isReady&&(p.type==="commandId"&&p.commandId==="workbench.action.toggleDevTools"||p.type!=="commandId"&&p.userSettingsLabel==="alt+cmd+i"))return!1;if(p.type==="commandId"){const E={id:p.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,E)}else{const E={userSettingsLabel:p.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,E)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",p),!1}Z(p,A){const I=typeof p=="string"?this.l[p]:void 0;if(I?.label){if(I.isNative!==!1)A.accelerator=I.label,A.userSettingsLabel=I.userSettingsLabel;else if(typeof A.label=="string"){const E=A.label.indexOf("[");E>=0?A.label=`${A.label.substr(0,E)} [${I.label}]`:A.label=`${A.label} [${I.label}]`}}else A.accelerator=void 0;return A}$(p,A,I=!A.accelerator){I&&(A=this.Z(p,A));const E=A.click;return A.click=(C,j,U)=>{this.bb(p),E?.(C,j,U)},A}ab(p,A){this.w.openExternal(void 0,p),this.bb(A)}bb(p){this.r.publicLog2("workbenchActionExecuted",{id:p,from:r})}cb(p){return(0,M.$4v)(p,!this.C)}};e.$80b=i,e.$80b=i=o=ve([re(0,d.$IV),re(1,b.$Bi),re(2,c.$79b),re(3,v.$V9b),re(4,f.$wl),re(5,t.$60b),re(6,h.$DO),re(7,y.$n0b),re(8,u.$pj),re(9,w.$T0b),re(10,k.$Hj),re(11,l.$R0b)],i);function n(){return new S.MenuItem({type:"separator"})}}),define(ae[305],ce([0,1,6,20,5,304]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$00b=e.$90b=void 0,e.$90b=(0,S.$8h)("menubarMainService");let D=class{constructor(g,l,b){this.b=g,this.c=l,this.d=b,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$80b)}async updateMenubar(g,l){this.d.trace("menubarService#updateMenubar",g),(await this.a).updateMenu(l,g)}};e.$00b=D,e.$00b=D=ve([re(0,S.$7h),re(1,R.$n0b),re(2,s.$pj)],D)}),define(ae[306],ce([0,1,15,21,132,26,22,23,3,33,47,2,13,9,67,4,36,19,12,7,191,65,18,56,24,16,6,20,5,79,80,60,34,55,134,29,131,298,30,98,83,58,69,39,57,68,78]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h,f,d,m,c,t,o,r,i,n,a,p,A,I,E,C,j,U,F,V,J,le,oe,ue,Z,Y,q,L,N,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x$b=void 0;function B(K){return(0,le.$ki)(K?.workspace)}function te(K){return(0,le.$fi)(K?.workspace)}let he=class extends v.$Tc{constructor(O,W,x,T,Q,H,_,z,ee,se,de,me,Ee,Pe,Le,ke,pe,ie,fe,$e){super(),this.s=O,this.t=W,this.u=x,this.w=T,this.z=Q,this.C=H,this.D=_,this.F=z,this.G=ee,this.H=se,this.I=de,this.J=me,this.L=Ee,this.M=Pe,this.N=Le,this.O=ke,this.P=pe,this.Q=ie,this.R=fe,this.S=$e,this.a=this.B(new g.$Wd),this.onDidOpenWindow=this.a.event,this.b=this.B(new g.$Wd),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new g.$Wd),this.onDidDestroyWindow=this.c.event,this.f=this.B(new g.$Wd),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new g.$Wd),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new g.$Wd),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new g.$Wd),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new g.$Wd),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new J.$u$b(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(O=>this.b.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const W=new v.$Sc;if(W.add(g.Event.any(O.onDidClose,O.onDidDestroy)(()=>W.dispose())),O.config.extensionDevelopmentPath)for(const x of O.config.extensionDevelopmentPath)W.add(this.Q.addValidFileRoot(x));O.config.extensionTestsPath&&W.add(this.Q.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,W){const x=this.F.args,T=W?.remoteAuthority||void 0,Q=!0,H=W?.forceReuseWindow,_=!H;return this.open({...O,cli:x,forceEmpty:Q,forceNewWindow:_,forceReuseWindow:H,remoteAuthority:T})}openExistingWindow(O,W){O.focus(),this.W(W,[O])}async open(O){this.w.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const W=[],x=[],T=[],Q=[],H=[];let _,z=0;const ee=await this.cb(O);this.w.trace("windowsManager#open pathsToOpen",ee);for(const Pe of ee)te(Pe)?O.addMode?W.push(Pe):x.push(Pe):B(Pe)?T.push(Pe):Pe.fileUri?(_||(_={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Pe.remoteAuthority}),_.filesToOpenOrCreate.push(Pe)):Pe.backupPath?H.push({backupFolder:(0,u.$nc)(Pe.backupPath),remoteAuthority:Pe.remoteAuthority}):z++;O.diffMode&&_&&_.filesToOpenOrCreate.length>=2&&(_.filesToDiff=_.filesToOpenOrCreate.slice(0,2),_.filesToOpenOrCreate=[]),O.mergeMode&&_&&_.filesToOpenOrCreate.length===4&&(_.filesToMerge=_.filesToOpenOrCreate.slice(0,4),_.filesToOpenOrCreate=[],_.filesToDiff=[]),_&&O.waitMarkerFileURI&&(_.filesToWait={paths:(0,D.$Hb)([..._.filesToDiff,_.filesToMerge[3],..._.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(Q.push(...this.M.getUntitledWorkspaces()),T.push(...Q),H.push(...this.I.getEmptyWindowBackups())):H.length=0;const{windows:se,filesOpenedInWindow:de}=await this.X(O,T,x,H,z,_,W);if(this.w.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${T.length}, foldersToOpen: ${x.length}, emptyToRestore: ${H.length}, emptyToOpen: ${z})`),se.length>1)if(de)de.focus();else{const Pe=this.r.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Le=!0,ke=!0;if(Pe){const pe=se.filter(ie=>this.r.state.lastActiveWindow&&ie.backupPath===this.r.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Le=!1,ke=!1)}if(Le)for(let pe=se.length-1;pe>=0;pe--){const ie=se[pe];if(!(ie.openedWorkspace&&Q.some(fe=>ie.openedWorkspace&&fe.workspace.id===ie.openedWorkspace.id)||ie.backupPath&&H.some(fe=>ie.backupPath&&fe.backupFolder===(0,u.$nc)(ie.backupPath)))){ie.focus(),ke=!1;break}}ke&&se[se.length-1].focus()}const me=_&&_.filesToDiff.length>0,Ee=_&&_.filesToMerge.length>0;if(!se.some(Pe=>Pe.isExtensionDevelopmentHost)&&!me&&!Ee&&!O.noRecentEntry){const Pe=[];for(const Le of ee)B(Le)&&!Le.transient?Pe.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):te(Le)?Pe.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Pe.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.L.addRecentlyOpened(Pe)}return this.W(O,se),se}W(O,W){const x=O.waitMarkerFileURI;O.context===0&&x&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.P.del(x)}catch{}})()}async X(O,W,x,T,Q,H,_){const z=[];let ee;function se(pe,ie){z.push(pe),ie&&(ee=pe,H=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:me}=this.ob(O);if(!O.initialStartup&&_.length>0){const pe=_[0].remoteAuthority,ie=this.ub(pe);ie&&se(this.$(ie,_.map(fe=>fe.workspace.uri)))}const Ee=x.length+W.length+T.length;if(H&&Ee===0){const pe=H.filesToOpenOrCreate[0]||H.filesToDiff[0]||H.filesToMerge[3],ie=this.getWindows().filter($e=>H&&(0,h.$Ng)($e.remoteAuthority,H.remoteAuthority));let fe;pe?.fileUri&&!me&&((O.context===4||O.context===0||O.context===1)&&(fe=await(0,V.$_9b)(ie,pe.fileUri,async $e=>$e.configPath.scheme===y.Schemas.file?this.M.resolveLocalWorkspace($e.configPath):void 0)),fe||(fe=this.vb(ie))),fe?(0,le.$ki)(fe.openedWorkspace)?W.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,le.$fi)(fe.openedWorkspace)?x.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):se(this.Y(O,fe,H),!0):se(await this.pb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:H,forceNewWindow:!0,remoteAuthority:H.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const Pe=(0,D.$Mb)(W,pe=>pe.workspace.id);if(Pe.length>0){const pe=(0,D.$Hb)(Pe.map(ie=>(0,V.$a0b)(this.getWindows(),ie.workspace.configPath)));if(pe.length>0){const ie=pe[0],fe=(0,h.$Ng)(H?.remoteAuthority,ie.remoteAuthority)?H:void 0;se(this.Y(O,ie,fe),!!fe),de=!0}for(const ie of Pe){if(pe.some(Ie=>Ie.openedWorkspace&&Ie.openedWorkspace.id===ie.workspace.id))continue;const fe=ie.remoteAuthority,$e=(0,h.$Ng)(H?.remoteAuthority,fe)?H:void 0;se(await this.bb(O,ie,de,$e),!!$e),de=!0}}const Le=(0,D.$Mb)(x,pe=>h.$zg.getComparisonKey(pe.workspace.uri));if(Le.length>0){const pe=(0,D.$Hb)(Le.map(ie=>(0,V.$a0b)(this.getWindows(),ie.workspace.uri)));if(pe.length>0){const ie=pe[0],fe=(0,h.$Ng)(H?.remoteAuthority,ie.remoteAuthority)?H:void 0;se(this.Y(O,ie,fe),!!fe),de=!0}for(const ie of Le){if(pe.some(Ie=>(0,le.$fi)(Ie.openedWorkspace)&&h.$zg.isEqual(Ie.openedWorkspace.uri,ie.workspace.uri)))continue;const fe=ie.remoteAuthority,$e=(0,h.$Ng)(H?.remoteAuthority,fe)?H:void 0;se(await this.bb(O,ie,de,$e),!!$e),de=!0}}const ke=(0,D.$Mb)(T,pe=>pe.backupFolder);if(ke.length>0)for(const pe of ke){const ie=pe.remoteAuthority,fe=(0,h.$Ng)(H?.remoteAuthority,ie)?H:void 0;se(await this.ab(O,!0,ie,fe,pe),!!fe),de=!0}if(z.length===0||H){H&&!Q&&Q++;const pe=H?H.remoteAuthority:O.remoteAuthority;for(let ie=0;ie<Q;ie++)se(await this.ab(O,de,pe,H),!!H),de=!0}return{windows:(0,D.$Mb)(z),filesOpenedInWindow:ee}}Y(O,W,x){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:x}),this.Z(W);const T={filesToOpenOrCreate:x?.filesToOpenOrCreate,filesToDiff:x?.filesToDiff,filesToMerge:x?.filesToMerge,filesToWait:x?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",P.CancellationToken.None,T),W}Z(O){let W=O;const x=S.BrowserWindow.getFocusedWindow();if(x&&x.id!==O.id){const T=this.S.getWindowById(x.id);T&&T.parentId===O.id&&(W=T)}W.focus()}$(O,W){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),O.focus();const x={foldersToAdd:W};return O.sendWhenReady("vscode:addFolders",P.CancellationToken.None,x),O}ab(O,W,x,T,Q){this.w.trace("windowsManager#doOpenEmpty",{restore:!!Q,remoteAuthority:x,filesToOpen:T,forceNewWindow:W});let H;return!W&&typeof O.contextWindowId=="number"&&(H=this.getWindowById(O.contextWindowId)),this.pb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:x,forceNewWindow:W,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:T,windowToUse:H,emptyWindowBackupInfo:Q,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}bb(O,W,x,T,Q){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:T}),!x&&!Q&&typeof O.contextWindowId=="number"&&(Q=this.getWindowById(O.contextWindowId)),this.pb({workspace:W.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:x,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:T,windowToUse:Q,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async cb(O){let W,x=!1,T=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(W=await this.db(O),x=!0):O.forceEmpty?W=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(W=await this.eb(O.cli),W.length===0&&W.push(Object.create(null)),x=!0):(W=await this.gb(),W.length===0&&W.push(Object.create(null)),T=!0),!O.addMode&&x){const Q=W.filter(H=>te(H));if(Q.length>1){const H=Q[0].remoteAuthority;if(Q.every(_=>(0,h.$Ng)(_.remoteAuthority,H))){const _=await this.M.createUntitledWorkspace(Q.map(z=>({uri:z.workspace.uri})));W.push({workspace:_,remoteAuthority:H}),W=W.filter(z=>!te(z))}}}if(O.initialStartup&&!T&&this.J.getValue("window")?.restoreWindows==="preserve"){const Q=await this.gb();W.unshift(...Q.filter(H=>B(H)||te(H)||H.backupPath))}return W}async db(O){const W={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},x=await Promise.all((0,D.$Hb)(O.urisToOpen||[]).map(async T=>{const Q=await this.ib(T,W);if(Q)return Q.label=T.label,Q;const H=this.kb(T);this.O.showMessageBox({type:"info",buttons:[(0,m.localize)(0,null)],message:H.scheme===y.Schemas.file?(0,m.localize)(1,null):(0,m.localize)(2,null),detail:H.scheme===y.Schemas.file?(0,m.localize)(3,null,(0,b.$Xv)(H,{os:w.OS,tildify:this.F})):(0,m.localize)(4,null,H.toString(!0))},S.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.$Hb)(x)}async eb(O){const W=[],x={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},T=O["folder-uri"];if(T){const _=await Promise.all(T.map(z=>{const ee=this.fb(z);if(ee)return this.ib({folderUri:ee},x)}));W.push(...(0,D.$Hb)(_))}const Q=O["file-uri"];if(Q){const _=await Promise.all(Q.map(z=>{const ee=this.fb(z);if(ee)return this.ib((0,le.$Ai)(z)?{workspaceUri:ee}:{fileUri:ee},x)}));W.push(...(0,D.$Hb)(_))}const H=await Promise.all(O._.map(_=>x.remoteAuthority?this.nb(_,x):this.lb(_,x)));return W.push(...(0,D.$Hb)(H)),W}fb(O){try{const W=d.URI.parse(O);if(!W.scheme){this.w.error(`Invalid URI input string, scheme missing: ${O}`);return}return W.path?W:W.with({path:"/"})}catch(W){this.w.error(`Invalid URI input string: ${O}, ${W.message}`)}}async gb(){const O=this.hb();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];O!=="one"&&W.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&W.push(this.r.state.lastActiveWindow);const x=await Promise.all(W.map(async T=>{if(T.workspace){const Q=await this.ib({workspaceUri:T.workspace.configPath},{remoteAuthority:T.remoteAuthority,rejectTransientWorkspaces:!0});if(B(Q))return Q}else if(T.folderUri){const Q=await this.ib({folderUri:T.folderUri},{remoteAuthority:T.remoteAuthority});if(te(Q))return Q}else if(O!=="folders"&&T.backupPath)return{backupPath:T.backupPath,remoteAuthority:T.remoteAuthority}}));return(0,D.$Hb)(x)}}}hb(){let O;return this.H.wasRestarted?O="all":(O=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async ib(O,W=Object.create(null)){const x=this.kb(O);return x.scheme===y.Schemas.file?((0,j.$TC)(O)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.lb(x.fsPath,W)):this.jb(O,W)}jb(O,W){let x=this.kb(O);const T=(0,E.$cl)(x)||W.remoteAuthority;if(x=(0,h.$Pg)((0,h.$Jg)(x)),(0,j.$TC)(O)){if(W.gotoLineMode){const{path:Q,line:H,column:_}=(0,l.$dg)(x.path);return{fileUri:x.with({path:Q}),options:{selection:H?{startLineNumber:H,startColumn:_||1}:void 0},remoteAuthority:T}}return{fileUri:x,remoteAuthority:T}}else if((0,j.$RC)(O))return{workspace:(0,oe.$d0b)(x),remoteAuthority:T};return{workspace:(0,oe.$e0b)(x),remoteAuthority:T}}kb(O){return(0,j.$RC)(O)?O.workspaceUri:(0,j.$SC)(O)?O.folderUri:O.fileUri}async lb(O,W,x){let T,Q;W.gotoLineMode&&({path:O,line:T,column:Q}=(0,l.$dg)(O)),O=(0,l.$$f)((0,u.$hc)(O),(0,k.cwd)());try{const H=await R.Promises.stat(O);if(H.isFile()){if(!W.forceOpenWorkspaceAsFile){const _=await this.M.resolveLocalWorkspace(d.URI.file(O));if(_)return _.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:_.id,configPath:_.configPath},type:i.FileType.File,exists:!0,remoteAuthority:_.remoteAuthority,transient:_.transient}}return{fileUri:d.URI.file(O),type:i.FileType.File,exists:!0,options:{selection:T?{startLineNumber:T,startColumn:Q||1}:void 0}}}else{if(H.isDirectory())return{workspace:(0,oe.$e0b)(d.URI.file(O),H),type:i.FileType.Directory,exists:!0};if(!w.$i&&O==="/dev/null")return{fileUri:d.URI.file(O),type:i.FileType.File,exists:!0}}}catch(H){if(H.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!x)return this.mb(O,W);const _=d.URI.file(O);if(this.L.removeRecentlyOpened([_]),W.ignoreFileNotFound)return{fileUri:_,type:i.FileType.File,exists:!1}}}async mb(O,W){const x=d.URI.file(O),{response:T,checkboxChecked:Q}=await this.O.showMessageBox({type:"warning",buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null),(0,m.localize)(7,null)],message:(0,m.localize)(8,null,x.authority),detail:(0,m.localize)(9,null,(0,b.$Xv)(x,{os:w.OS,tildify:this.F})),checkboxLabel:(0,m.localize)(10,null,x.authority),cancelId:1});if(T===0){if((0,s.addUNCHostToAllowlist)(x.authority),Q){const H={channel:"vscode:configureAllowedUNCHost",args:x.authority};this.sendToFocused(H.channel,H.args),this.sendToOpeningWindow(H.channel,H.args)}return this.lb(O,W,!0)}if(T===2)return S.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(O,W)}nb(O,W){const x=O.charCodeAt(0),T=W.remoteAuthority;let Q,H;W.gotoLineMode&&({path:O,line:Q,column:H}=(0,l.$dg)(O)),x!==47&&((0,l.$0f)(x)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,l.$3f)(O)),O=`/${O}`);const _=d.URI.from({scheme:y.Schemas.vscodeRemote,authority:T,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,le.$Ai)(O))return W.forceOpenWorkspaceAsFile?{fileUri:_,options:{selection:Q?{startLineNumber:Q,startColumn:H||1}:void 0},remoteAuthority:W.remoteAuthority}:{workspace:(0,oe.$d0b)(_),remoteAuthority:T};if(W.gotoLineMode||u.$gc.basename(O).indexOf(".")!==-1)return{fileUri:_,options:{selection:Q?{startLineNumber:Q,startColumn:H||1}:void 0},remoteAuthority:T}}return{workspace:(0,oe.$e0b)(_),remoteAuthority:T}}ob(O){const W=this.J.getValue("window"),x=W?.openFoldersInNewWindow||"default",T=W?.openFilesInNewWindow||"off";let Q=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(x==="on"||x==="off")&&(Q=x==="on");let H=!1;return O.forceNewWindow||O.forceReuseWindow?H=!!O.forceNewWindow&&!O.forceReuseWindow:(w.$j?O.context===1&&(H=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(H=!0),!O.cli.extensionDevelopmentPath&&(T==="on"||T==="off")&&(H=T==="on")),{openFolderInNewWindow:!!Q,openFilesInNewWindow:H}}async openExtensionDevelopmentHostWindow(O,W){const x=(0,V.$b0b)(this.getWindows(),O);if(x)return this.H.reload(x,W.cli),x.focus(),[x];let T=W.cli["folder-uri"]||[],Q=W.cli["file-uri"]||[],H=W.cli._;if(!H.length&&!T.length&&!Q.length&&!W.cli.extensionTestsPath){const ee=this.r.state.lastPluginDevelopmentHostWindow,se=ee?.workspace??ee?.folderUri;se&&(d.URI.isUri(se)?se.scheme===y.Schemas.file?H=[se.fsPath]:T=[se.toString()]:se.configPath.scheme===y.Schemas.file?H=[(0,h.$wg)(se.configPath)]:Q=[se.configPath.toString()])}let _=W.remoteAuthority;for(const ee of O)if(ee.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const se=d.URI.parse(ee),de=(0,E.$cl)(se);de&&(_?(0,h.$Ng)(de,_)||this.w.error("more than one extension development path authority"):_=de)}H=H.filter(ee=>{const se=d.URI.file(ee);return(0,V.$a0b)(this.getWindows(),se)?!1:(0,h.$Ng)((0,E.$cl)(se),_)}),T=T.filter(ee=>{const se=this.fb(ee);return se&&(0,V.$a0b)(this.getWindows(),se)?!1:se?(0,h.$Ng)((0,E.$cl)(se),_):!1}),Q=Q.filter(ee=>{const se=this.fb(ee);return se&&(0,V.$a0b)(this.getWindows(),se)?!1:se?(0,h.$Ng)((0,E.$cl)(se),_):!1}),W.cli._=H,W.cli["folder-uri"]=T,W.cli["file-uri"]=Q;const z={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:!H.length&&!T.length&&!Q.length,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:_,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile};return this.open(z)}async pb(O){const W=this.J.getValue("window"),x=this.getLastActiveWindow(),T=x?.profile??this.G.defaultProfile;let Q;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(Q=O.windowToUse||x,Q&&Q.focus());const H={...this.F.args,...O.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,u.$jc)(this.F.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:T},homeDir:this.F.userHome.with({scheme:y.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:y.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.u,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:y.Schemas.file}).fsPath,product:A.default,isInitialStartup:O.initialStartup,perfMarks:(0,$.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},autoDetectHighContrast:W?.autoDetectHighContrast??!0,autoDetectColorScheme:W?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(Q){const _=Q.config;!H.extensionDevelopmentPath&&_?.extensionDevelopmentPath&&(H.extensionDevelopmentPath=_.extensionDevelopmentPath,H.extensionDevelopmentKind=_.extensionDevelopmentKind,H["enable-proposed-api"]=_["enable-proposed-api"],H.verbose=_.verbose,H["inspect-extensions"]=_["inspect-extensions"],H["inspect-brk-extensions"]=_["inspect-brk-extensions"],H.debugId=_.debugId,H.extensionEnvironment=_.extensionEnvironment,H["extensions-dir"]=_["extensions-dir"],H["disable-extensions"]=_["disable-extensions"]),H.loggers={global:H.loggers.global,window:_?.loggers.window??H.loggers.window}}else{const _=this.r.getNewWindowState(H);(0,$.mark)("code/willCreateCodeWindow");const z=Q=this.N.createInstance(U.$l0b,{state:_,extensionDevelopmentPath:H.extensionDevelopmentPath,isExtensionTestHost:!!H.extensionTestsPath});(0,$.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(z),this.n.set(z.id,z),this.a.fire(z),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ee=new v.$Sc;ee.add(z.onDidSignalReady(()=>this.b.fire(z))),ee.add(g.Event.once(z.onDidClose)(()=>this.sb(z,ee))),ee.add(g.Event.once(z.onDidDestroy)(()=>this.tb(z))),ee.add(z.onDidMaximize(()=>this.g.fire(z))),ee.add(z.onDidUnmaximize(()=>this.h.fire(z))),ee.add(z.onDidEnterFullScreen(()=>this.j.fire({window:z,fullscreen:!0}))),ee.add(z.onDidLeaveFullScreen(()=>this.j.fire({window:z,fullscreen:!1}))),ee.add(z.onDidTriggerSystemContextMenu(({x:de,y:me})=>this.m.fire({window:z,x:de,y:me})));const se=(0,f.$Uf)(z.win?.webContents);se.removeAllListeners("devtools-reload-page"),se.on("devtools-reload-page",()=>this.H.reload(z)),this.H.registerWindow(z)}return H.windowId=Q.id,Q.isReady?this.H.unload(Q,4).then(async _=>{_||await this.qb(Q,H,O,T)}):await this.qb(Q,H,O,T),Q}async qb(O,W,x,T){if(W.extensionDevelopmentPath||((0,le.$ki)(W.workspace)?W.backupPath=this.I.registerWorkspaceBackup({workspace:W.workspace,remoteAuthority:W.remoteAuthority}):(0,le.$fi)(W.workspace)?W.backupPath=this.I.registerFolderBackup({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority}):W.backupPath=this.I.registerEmptyWindowBackup({backupFolder:x.emptyWindowBackupInfo?.backupFolder??(0,oe.$f0b)().id,remoteAuthority:W.remoteAuthority})),this.G.isEnabled()){const Q=W.workspace??(0,le.$ji)(W.backupPath,!1),H=this.rb(x,Q,T),_=H instanceof Promise?await H:H;W.profiles.profile=_,W.extensionDevelopmentPath||await this.G.setProfileForWorkspace(Q,_)}O.load(W)}rb(O,W,x){return O.forceProfile?this.G.profiles.find(T=>T.name===O.forceProfile)??this.G.createNamedProfile(O.forceProfile):O.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(W)??x}sb(O,W){this.n.delete(O.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),W.dispose()}tb(O){this.n.delete(O.id),this.c.fire(O)}getFocusedWindow(){const O=S.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(O){return this.vb(this.getWindows().filter(W=>(0,h.$Ng)(W.remoteAuthority,O)))}vb(O){return(0,F.$99b)(O)}sendToFocused(O,...W){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,P.CancellationToken.None,...W)}sendToOpeningWindow(O,...W){this.B(g.Event.once(this.onDidSignalReadyWindow)(x=>{x.sendWhenReady(O,P.CancellationToken.None,...W)}))}sendToAll(O,W,x){for(const T of this.getWindows())x&&x.indexOf(T.id)>=0||T.sendWhenReady(O,P.CancellationToken.None,W)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(O){return this.n.get(O)}getWindowByWebContents(O){const W=S.BrowserWindow.fromWebContents(O);if(W)return this.getWindowById(W.id)}};e.$x$b=he,e.$x$b=he=ve([re(3,p.$pj),re(4,N.$i0b),re(5,C.$DO),re(6,q.$Mn),re(7,r.$V9b),re(8,L.$09b),re(9,a.$n0b),re(10,c.$19b),re(11,t.$Bi),re(12,ue.$60b),re(13,Z.$g0b),re(14,n.$7h),re(15,o.$29b),re(16,i.$sk),re(17,I.$49b),re(18,Y.$59b),re(19,G.$R0b)],he)}),define(ae[307],ce([0,1,65,29,83,58]),function(X,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z$b=void 0;let D=class{constructor(g,l,b,v){this.a=g,this.b=l,this.c=b,this.d=v,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(g,l){const b=this.b.getWindowById(g);if(b)return this.a.enterWorkspace(b,this.b.getWindows(),l)}createUntitledWorkspace(g,l,b){return this.a.createUntitledWorkspace(l,b)}deleteUntitledWorkspace(g,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(g,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(g){return this.c.getRecentlyOpened()}addRecentlyOpened(g,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(g,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(g){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$z$b=D,e.$z$b=D=ve([re(0,M.$g0b),re(1,R.$79b),re(2,s.$60b),re(3,S.$19b)],D)}),define(ae[308],ce([0,1,15,132,37,26,17,51,14,33,3,42,47,2,13,9,4,12,7,32,158,43,159,111,290,162,65,283,18,200,91,133,56,117,220,24,64,94,209,293,211,212,213,16,224,93,77,6,92,219,299,284,291,20,5,305,70,27,60,294,95,34,275,82,123,28,251,253,54,49,265,288,300,289,301,128,267,268,269,272,297,55,29,306,274,30,97,83,307,58,39,233,57,244,53,81,130,277,292,280,8,255,276,228,68,296,271,22,126,295,263,239,62,78,303]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h,f,d,m,c,t,o,r,i,n,a,p,A,I,E,C,j,U,F,V,J,le,oe,ue,Z,Y,q,L,N,G,B,te,he,K,O,W,x,T,Q,H,_,z,ee,se,de,me,Ee,Pe,Le,ke,pe,ie,fe,$e,Ie,Me,Ne,je,Je,Be,He,Ve,ne,ge,be,Se,ye,Re,Ue,qe,Xe,xe,Ye,Qe,nt,st,ot,pt,yt,vt,kt,Et,St,at,gt,Pt,It,Ct,ct,Dt,$t,lt,At,Rt,ut,Ot,ht,Mt){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$S$b=void 0;let dt=class extends u.$Tc{static{ft=this}static{this.a={[$.Schemas.file]:"security.promptForLocalFileProtocolHandling",[$.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ce,De,Oe,we,Ae,Te,ze,Ke,We,Fe,Ge,Ze){super(),this.g=Ce,this.h=De,this.j=Oe,this.m=we,this.n=Ae,this.s=Te,this.t=ze,this.u=Ke,this.w=We,this.y=Fe,this.z=Ge,this.C=Ze,this.D(),this.F()}D(){const Ce=We=>We?.startsWith(`${$.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((We,Fe,Ge,Ze)=>Ce(Ze.requestingUrl)?Ge(De.has(Fe)):Ge(!1)),S.session.defaultSession.setPermissionCheckHandler((We,Fe,Ge,Ze)=>Ce(Ze.requestingUrl)?De.has(Fe):!1);const Oe=new Set([$.Schemas.file,$.Schemas.vscodeFileResource,$.Schemas.vscodeRemoteResource,$.Schemas.vscodeManagedRemoteResource,"devtools"]),we=We=>{for(let Fe=We;Fe;Fe=Fe.parent)if(Fe.url.startsWith(`${$.Schemas.vscodeWebview}://`))return!0;return!1},Ae=We=>We.resourceType==="xhr"||we(We.frame),Te=We=>{const Fe=We.frame;if(!Fe||!this.b)return!1;const Ge=S.BrowserWindow.getAllWindows();for(const Ze of Ge)if(Fe.processId===Ze.webContents.mainFrame.processId)return!0;return!1},ze=(We,Fe)=>{if(We.path!=="/index.html")return!0;const Ge=Fe.frame;if(!Ge||!this.b)return!1;for(const Ze of this.b.getWindows())if(Ze.win&&Ge.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((We,Fe)=>{const Ge=f.URI.parse(We.url);return Ge.scheme===$.Schemas.vscodeWebview&&!ze(Ge,We)?(this.m.error("Blocked vscode-webview request",We.url),Fe({cancel:!0})):Ge.scheme===$.Schemas.vscodeFileResource&&!Te(We)?(this.m.error("Blocked vscode-file request",We.url),Fe({cancel:!0})):Ge.path.endsWith(".svg")&&!Oe.has(Ge.scheme)?Fe({cancel:!Ae(We)}):Fe({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((We,Fe)=>{const Ge=We.responseHeaders,Ze=Ge["content-type"]||Ge["Content-Type"];if(Ze&&Array.isArray(Ze)){const _e=f.URI.parse(We.url);if(_e.path.endsWith(".svg")&&Oe.has(_e.scheme))return Ge["Content-Type"]=["image/svg+xml"],Fe({cancel:!1,responseHeaders:Ge});if(!_e.path.endsWith($.Schemas.vscodeRemoteResource)&&Ze.some(tt=>tt.toLowerCase().includes("image/svg")))return Fe({cancel:!Ae(We)})}return Fe({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((We,Fe)=>{if(We.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ge=We.responseHeaders??Object.create(null);if(Ge["Access-Control-Allow-Origin"]===void 0)return Ge["Access-Control-Allow-Origin"]=["*"],Fe({cancel:!1,responseHeaders:Ge})}return Fe({cancel:!1})});const Ke=S.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.s.codeCachePath&&Ke.setCodeCachePath((0,w.$jc)(this.s.codeCachePath,"chrome")),k.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,R.disableUNCAccessRestrictions)():(0,R.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,g.setUnexpectedErrorHandler)(Oe=>this.H(Oe)),process.on("uncaughtException",Oe=>{(0,g.$Z)(Oe)||(0,g.$1)(Oe)}),process.on("unhandledRejection",Oe=>(0,g.$1)(Oe)),this.t.onWillShutdown(()=>this.dispose()),(0,m.$KU)(),S.app.on("accessibility-support-changed",(Oe,we)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",we)}),S.app.on("activate",async(Oe,we)=>{this.m.trace("app#activate"),we||await this.b?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(Oe,we)=>{(0,ht.$S0b)(we)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(we)),we.on("will-navigate",Ae=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ae.preventDefault()}),we.setWindowOpenHandler(Ae=>Ae.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow()}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ae.url}}`),this.f?.openExternal(void 0,Ae.url),{action:"deny"}))});let Ce=[],De;S.app.on("open-file",(Oe,we)=>{this.m.trace("app#open-file: ",we),Oe.preventDefault(),Ce.push((0,Ue.$Ai)(we)?{workspaceUri:f.URI.file(we)}:{fileUri:f.URI.file(we)}),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Ce,gotoLineMode:!1,preferNewWindow:!0}),Ce=[],De=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$JU.handle("vscode:fetchShellEnv",Oe=>{const we=this.b?.getWindowByWebContents(Oe.sender);let Ae,Te;return we?.config?(Ae=we.config,Te={...process.env,...we.config.userEnv}):(Ae=this.s.args,Te=process.env),this.X(Ae,Te,!1)}),s.$JU.handle("vscode:writeNlsFile",(Oe,we,Ae)=>{const Te=this.G([we]);if(!Te||typeof Ae!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Te,D.$ke.fromString(Ae))}),s.$JU.handle("vscode:readNlsFile",async(Oe,...we)=>{const Ae=this.G(we);if(!Ae)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ae)).value.toString()}),s.$JU.on("vscode:toggleDevTools",Oe=>Oe.sender.toggleDevTools()),s.$JU.on("vscode:openDevTools",Oe=>Oe.sender.openDevTools()),s.$JU.on("vscode:reloadWindow",Oe=>Oe.sender.reload()),s.$JU.handle("vscode:notifyZoomLevel",async(Oe,we)=>{const Ae=this.b?.getWindowById(Oe.sender.id);Ae&&Ae.notifyZoomLevel(we)})}G(Ce){let De;for(const Oe of Ce)typeof Oe=="string"&&(typeof De!="string"?De=Oe:De=(0,w.$jc)(De,Oe));if(!(typeof De!="string"||!(0,w.$ic)(De)||!(0,l.$9f)(De,this.s.cachedLanguagesPath,!k.$k)))return f.URI.file(De)}H(Ce){if(Ce){const De={message:`[uncaught exception in main]: ${Ce.message}`,stack:Ce.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.m.error(`[uncaught exception in main]: ${Ce}`),Ce.stack&&this.m.error(Ce.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ce=this.z.win32AppUserModelId;k.$i&&Ce&&S.app.setAppUserModelId(Ce);try{k.$j&&this.u.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Fe){this.m.error(Fe)}const De=new t.$QU;this.t.onWillShutdown(Fe=>{Fe.reason===2&&De.dispose()}),this.m.trace("Resolving machine identifier...");const[Oe,we]=await Promise.all([(0,gt.$H$b)(this.w,this.m),(0,gt.$I$b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Oe}`);const{sharedProcessReady:Ae,sharedProcessClient:Te}=this.P(Oe,we),ze=await this.Q(Oe,we,Ae);this.B(ze.createInstance(r.$x0b)),this.B(ze.createInstance(Et.$D$b)),ze.invokeFunction(Fe=>this.R(Fe,De,Te));const Ke=await ze.invokeFunction(Fe=>this.I(Fe,De));this.J(De),this.t.phase=2,await ze.invokeFunction(Fe=>this.S(Fe,Ke)),this.t.phase=3,this.U(),this.B(new at.$hh(()=>{this.B((0,at.$lh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Ce,De){const Oe=this.b=Ce.get(Se.$79b),we=Ce.get(Je.$yV),Ae=this.f=Ce.get(H.$T0b),Te=Ce.get(C.$29b),ze=this;we.registerHandler({async handleURL(_e,tt){return ze.O(Oe,Te,we,_e,tt)}});const Ke=this.B(new Re.$y$b({onDidOpenMainWindow:Ae.onDidOpenMainWindow,onDidFocusMainWindow:Ae.onDidFocusMainWindow,getActiveWindowId:()=>Ae.getActiveWindowId(-1)})),We=new c.$Ph(_e=>Ke.getActiveClientId().then(tt=>_e===tt)),Fe=new Be.$p$b(We,this.m),Ge=De.getChannel("urlHandler",Fe);we.registerHandler(new Be.$o$b(Ge));const Ze=await this.L(Oe,Te);return this.B(new Ve.$q$b(Ze?.urls,we,Oe,this.s,this.z,this.m)),Ze}J(Ce){const De=()=>({statusCode:404,data:"Not found"}),Oe=new Ot.$V(()=>Ce.getChannel(ut.$P$b,new ut.$Q$b));S.protocol.registerBufferProtocol($.Schemas.vscodeManagedRemoteResource,(we,Ae)=>{const Te=f.URI.parse(we.url);if(!Te.authority.startsWith("window:"))return Ae(De());Oe.value.call(ut.$O$b,[Te]).then(ze=>Ae({...ze,data:Buffer.from(ze.body,"base64")}),ze=>{this.m.warn("error dispatching remote resource call",ze),Ae({statusCode:500,data:String(ze)})})})}async L(Ce,De){const Oe=this.s.args["open-url"]?this.s.args._urls||[]:[];Oe.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Oe);const we=global.getOpenUrls()||[];if(we.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",we),Oe.length+we.length===0)return;const Ae=[...Oe,...we].map(Ke=>{try{return{uri:f.URI.parse(Ke),originalUrl:Ke}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),Te=[],ze=[];for(const Ke of Ae){if(!Ke)continue;const We=this.N(Ke.uri);if(We)if(await this.M(We,Ce,De)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),We),Te.push(We);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),ze.push(Ke)}return{urls:ze,openables:Te}}async M(Ce,De,Oe){let we,Ae;if((0,be.$RC)(Ce)?(we=Ce.workspaceUri,Ae=(0,i.localize)(0,null,we.scheme===$.Schemas.file?(0,y.$Xv)(we,{os:k.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(0,be.$SC)(Ce)?(we=Ce.folderUri,Ae=(0,i.localize)(1,null,we.scheme===$.Schemas.file?(0,y.$Xv)(we,{os:k.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(we=Ce.fileUri,Ae=(0,i.localize)(2,null,we.scheme===$.Schemas.file?(0,y.$Xv)(we,{os:k.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)),we.scheme!==$.Schemas.file&&we.scheme!==$.Schemas.vscodeRemote||this.u.getValue(ft.a[we.scheme])===!1)return!1;const{response:ze,checkboxChecked:Ke}=await Oe.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Ae,detail:(0,i.localize)(5,null),checkboxLabel:we.scheme===$.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(ze!==0)return!0;if(Ke){const We={channel:"vscode:disablePromptForProtocolHandling",args:we.scheme===$.Schemas.file?"local":"remote"};De.sendToFocused(We.channel,We.args),De.sendToOpeningWindow(We.channel,We.args)}return!1}N(Ce){if(Ce.path){if(Ce.authority===$.Schemas.file){const De=f.URI.file(Ce.fsPath);return(0,Ue.$Ai)(De)?{workspaceUri:De}:{fileUri:De}}else if(Ce.authority===$.Schemas.vscodeRemote){const De=Ce.path.indexOf(w.$gc.sep,1);if(De!==-1){const Oe=Ce.path.substring(1,De),we=Ce.path.substring(De);let Ae=Ce.query;const Te=new URLSearchParams(Ce.query);Te.get("windowId")==="_blank"&&(Te.delete("windowId"),Ae=Te.toString());const ze=f.URI.from({scheme:$.Schemas.vscodeRemote,authority:Oe,path:we,query:Ae,fragment:Ce.fragment});return(0,Ue.$Ai)(we)?{workspaceUri:ze}:/:[\d]+$/.test(we)?{fileUri:ze}:{folderUri:ze}}}}}async O(Ce,De,Oe,we,Ae){this.m.trace("app#handleProtocolUrl():",we.toString(!0),Ae),we.scheme===this.z.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:f.URI.parse(we.query).path,query:""}));let Te=!1;const ze=new URLSearchParams(we.query);ze.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),ze.delete("windowId"),we=we.with({query:ze.toString()}),Te=!0):k.$j&&Ce.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),Te=!0);const Ke=ze.get("continueOn");Ke!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),ze.delete("continueOn"),we=we.with({query:ze.toString()}),this.s.continueOn=Ke??void 0);const We=this.N(we);return We?await this.M(We,Ce,De)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",We,we.toString(!0)),(0,$t.$Ob)(await Ce.open({context:5,cli:{...this.s.args},urisToOpen:[We],forceNewWindow:Te,gotoLineMode:!0}))?.focus(),!0):Te?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,$t.$Ob)(await Ce.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,z.$cl)(we)}))?.ready(),Oe.open(we,Ae)):(this.m.trace("app#handleProtocolUrl(): not handled",we.toString(!0),Ae),!1)}P(Ce,De){const Oe=this.B(this.j.createInstance(ee.$b$b,Ce,De)),we=(async()=>{this.m.trace("Main->SharedProcess#connect");const Te=await Oe.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$RU(Te,"main")})();return{sharedProcessReady:(async()=>(await Oe.whenReady(),we))(),sharedProcessClient:we}}async Q(Ce,De,Oe){const we=new te.$6h;switch(process.platform){case"win32":we.set(fe.$IV,new G.$5h(je.$m$b));break;case"linux":k.$l?we.set(fe.$IV,new G.$5h(Ne.$l$b,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(fe.$IV,new G.$5h(Me.$k$b));break;case"darwin":we.set(fe.$IV,new G.$5h(Ie.$j$b));break}we.set(Se.$79b,new G.$5h(ye.$x$b,[Ce,De,this.h],!1)),we.set(ht.$R0b,new G.$5h(Mt.$R$b,void 0,!1));const Ae=new C.$39b(this.m,this.z);we.set(C.$29b,Ae),we.set(W.$Z0b,new G.$5h(W.$10b,void 0,!1)),we.set(E.$D0b,new G.$5h(E.$E0b,void 0,!1)),we.set(I.$Lm,c.ProxyChannel.toService((0,c.$Nh)(Oe.then(Fe=>Fe.getChannel("diagnostics"))))),we.set(he.$mAb,new G.$5h(K.$V0b,[this.h])),we.set(j.$sV,new G.$5h(U.$F0b)),we.set(O.$W0b,new G.$5h(O.$X0b)),we.set(H.$T0b,new G.$5h(H.$U0b,void 0,!1)),we.set(ne.$r$b,new G.$5h(ge.$t$b)),we.set(Q.$90b,new G.$5h(Q.$00b)),we.set(le.$G0b,new G.$5h(oe.$I0b)),we.set(Ee.$t0b,new G.$5h(Ee.$u0b)),we.set(Ee.$v0b,new G.$5h(Ee.$w0b));const Te=new At.$N$b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),ze=new Rt.$Zr(Te,this.u,this.m,this.n);we.set(lt.$Ar,ze),k.$i?we.set(ue.$J0b,new G.$5h(Z.$K0b)):k.$j?we.set(ue.$J0b,new G.$5h(Z.$L0b)):k.$k&&we.set(ue.$J0b,new G.$5h(Z.$M0b));const Ke=new a.$y0b(this.s,this.u,this.m,this.w);we.set(n.$19b,Ke);const We=new Ye.$h0b(this.s,this.m,this.C,Ke,Ae);if(we.set(Ye.$g0b,We),we.set(qe.$Rcb,new G.$5h(xe.$z$b,void 0,!1)),we.set(Xe.$60b,new G.$5h(Xe.$70b,void 0,!1)),we.set(Je.$yV,new G.$5h(He.$AV,void 0,!1)),(0,ie.$Uo)(this.z,this.s)){const Fe=(0,ie.$Zo)(this.z,this.u),Ge=(0,c.$Nh)(Oe.then(rt=>rt.getChannel("telemetryAppender"))),Ze=new ke.$e$b(Ge),_e=(0,Pe.$Lo)((0,M.release)(),(0,M.hostname)(),process.arch,this.z.commit,this.z.version,Ce,De,Fe),tt=(0,ie.$1o)(this.s),it={appenders:[Ze],commonProperties:_e,piiPaths:tt,sendErrorTelemetry:!0};we.set(Le.$wl,new G.$5h(pe.$rr,[it],!1))}else we.set(Le.$wl,ie.$Po);return we.set(yt.$Xp,new G.$5h(Pt.$KO,void 0,!0)),we.set(vt.$2p,new G.$5h(kt.$C$b,void 0,!0)),we.set(ct.$L$b,new G.$5h(ct.$M$b,void 0,!0)),await at.Promises.settled([Ke.initialize(),We.initialize()]),this.j.createChild(we)}R(Ce,De,Oe){const we=this.B(new u.$Sc),Ae=c.ProxyChannel.fromService(Ce.get(W.$Z0b),we,{disableMarshalling:!0});this.g.registerChannel("launch",Ae);const Te=c.ProxyChannel.fromService(Ce.get(E.$D0b),we,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Te);const ze=new nt.$A$b(Ce.get(Qe.$Mn));De.registerChannel("policy",ze),Oe.then(et=>et.registerChannel("policy",ze));const Ke=this.y.getProvider($.Schemas.file);(0,h.$Tf)(Ke instanceof N.$Dq);const We=new L.$N0b(Ke,this.m,this.s);De.registerChannel(Y.$tO,We),Oe.then(et=>et.registerChannel(Y.$tO,We));const Fe=c.ProxyChannel.fromService(Ce.get(st.$09b),we);De.registerChannel("userDataProfiles",Fe),Oe.then(et=>et.registerChannel("userDataProfiles",Fe));const Ge=new ot.$mr(Ce.get(pt.$jp));Oe.then(et=>et.registerChannel("request",Ge));const Ze=new $e.$f$b(Ce.get(fe.$IV));De.registerChannel("update",Ze);const _e=c.ProxyChannel.fromService(Ce.get(he.$mAb),we);De.registerChannel("issue",_e);const tt=c.ProxyChannel.fromService(Ce.get(j.$sV),we);De.registerChannel("encryption",tt);const it=c.ProxyChannel.fromService(Ce.get(se.$kl),we);De.registerChannel("sign",it);const rt=c.ProxyChannel.fromService(Ce.get(O.$W0b),we);De.registerChannel("keyboardLayout",rt),this.f=Ce.get(H.$T0b);const mt=c.ProxyChannel.fromService(this.f,we);De.registerChannel("nativeHost",mt),Oe.then(et=>et.registerChannel("nativeHost",mt));const jt=c.ProxyChannel.fromService(Ce.get(qe.$Rcb),we);De.registerChannel("workspaces",jt);const Lt=c.ProxyChannel.fromService(Ce.get(Q.$90b),we);De.registerChannel("menubar",Lt);const Wt=c.ProxyChannel.fromService(Ce.get(Je.$yV),we);De.registerChannel("url",Wt);const Ft=c.ProxyChannel.fromService(Ce.get(ne.$r$b),we);De.registerChannel("webview",Ft);const wt=this.B(new me.$c$b(this.m,Ce.get(Ee.$t0b)));De.registerChannel("storage",wt),Oe.then(et=>et.registerChannel("storage",wt));const Ut=this.B(new St.$E$b(Ce.get(Ee.$t0b),Ce.get(st.$09b),this.m));Oe.then(et=>et.registerChannel("profileStorageListener",Ut));const Nt=c.ProxyChannel.fromService(Ce.get(lt.$Ar),we);De.registerChannel(lt.TerminalIpcChannels.LocalPty,Nt);const Tt=c.ProxyChannel.fromService(Ce.get(ue.$J0b),we);De.registerChannel("externalTerminal",Tt);const bt=new It.$J$b(Ce.get(Ct.$i0b));De.registerChannel("logger",bt),Oe.then(et=>et.registerChannel("logger",bt));const zt=new A.$z0b(Ce.get(Se.$79b));De.registerChannel("extensionhostdebugservice",zt);const Bt=c.ProxyChannel.fromService(Ce.get(le.$G0b),we);De.registerChannel(le.$H0b,Bt);const qt=c.ProxyChannel.fromService(Ce.get(ct.$L$b),we);De.registerChannel(Dt.$K$b,qt)}async S(Ce,De){const Oe=this.b=Ce.get(Se.$79b);this.c=Ce.get(ht.$R0b);const we=(0,V.$8l)(process.env)?0:4,Ae=this.s.args;if(De){if(De.openables.length>0)return Oe.open({context:we,cli:Ae,urisToOpen:De.openables,gotoLineMode:!0,initialStartup:!0});if(De.urls.length>0)for(const it of De.urls){const rt=new URLSearchParams(it.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:rt.toString()}),Oe.open({context:we,cli:Ae,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Te=global.macOpenFiles,ze=Ae._.length,Ke=!!Ae["folder-uri"],We=!!Ae["file-uri"],Fe=Ae["skip-add-to-recently-opened"]===!0,Ge=Ae.wait&&Ae.waitMarkerFilePath?f.URI.file(Ae.waitMarkerFilePath):void 0,Ze=Ae.remote||void 0,_e=Ae.profile,tt=Ae["profile-temp"];if(!ze&&!Ke&&!We){if(Ae["new-window"]||_e||tt)return Oe.open({context:we,cli:Ae,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Fe,waitMarkerFileURI:Ge,initialStartup:!0,remoteAuthority:Ze,forceProfile:_e,forceTempProfile:tt});if(Te.length)return Oe.open({context:1,cli:Ae,urisToOpen:Te.map(it=>(0,Ue.$Ai)(it)?{workspaceUri:f.URI.file(it)}:{fileUri:f.URI.file(it)}),noRecentEntry:Fe,waitMarkerFileURI:Ge,initialStartup:!0})}return Oe.open({context:we,cli:Ae,forceNewWindow:Ae["new-window"]||!ze&&Ae["unity-launch"],diffMode:Ae.diff,mergeMode:Ae.merge,noRecentEntry:Fe,waitMarkerFileURI:Ge,gotoLineMode:Ae.goto,initialStartup:!0,remoteAuthority:Ze,forceProfile:_e,forceTempProfile:tt})}U(){this.W(),S.protocol.registerHttpProtocol($.Schemas.vscodeRemoteResource,(Ce,De)=>{De({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})}),this.X(this.s.args,process.env,!0),this.Y(),k.$j&&S.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ce=this.z.win32MutexName;if(k.$i&&Ce)try{const De=await new Promise((we,Ae)=>{X(["@vscode/windows-mutex"],we,Ae)}),Oe=new De.Mutex(Ce);b.Event.once(this.t.onWillShutdown)(()=>Oe.release())}catch(De){this.m.error(De)}}async X(Ce,De,Oe){try{return await(0,J.$bm)(this.u,this.m,Ce,De)}catch(we){const Ae=(0,P.$Si)(we);Oe?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ae):this.m.error(Ae)}return{}}async Y(){try{const De=(await this.y.readFile(this.s.argvResource)).value.toString(),Oe=JSON.parse((0,v.$nn)(De)),Ae=(0,ie.$Wo)(this.u)>=1;if(Oe["enable-crash-reporter"]===void 0){const Te=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ae},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,d.$rg)()}"`,"}"],ze=De.substring(0,De.length-2).concat(`,
`,Te.join(`
`));await this.y.writeFile(this.s.argvResource,D.$ke.fromString(ze))}else{const Te=De.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ae},`);Te!==De&&await this.y.writeFile(this.s.argvResource,D.$ke.fromString(Te))}}catch(Ce){this.m.error(Ce)}}};e.$S$b=dt,e.$S$b=dt=ft=ve([re(2,B.$7h),re(3,T.$pj),re(4,T.$qj),re(5,F.$V9b),re(6,x.$n0b),re(7,p.$Bi),re(8,de.$DO),re(9,q.$sk),re(10,_.$Hj),re(11,st.$09b)],dt)}),define(ae[313],ce([0,1,15,46,7,22,8,51,14,33,3,47,13,9,67,4,36,25,21,43,99,308,10,18,238,250,24,64,202,16,222,93,77,218,92,20,225,5,79,27,80,278,127,287,53,286,95,249,34,54,69,57,39,234,232,2,40,266,68,227,116,122,270,264]),function(X,e,S,R,s,M,D,P,g,l,b,v,y,u,$,w,k,h,f,d,m,c,t,o,r,i,n,a,p,A,I,E,C,j,U,F,V,J,le,oe,ue,Z,Y,q,L,N,G,B,te,he,K,O,W,x,T,Q,H,_,z,ee,se,de,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ee{main(){try{this.a()}catch(ke){console.error(ke.message),S.app.exit(1)}}async a(){(0,g.setUnexpectedErrorHandler)(je=>console.error(je));const[ke,pe,ie,fe,$e,Ie,Me,Ne]=this.b();try{try{await this.d(ie,Ne,fe,$e,Me)}catch(je){throw this.f(ie,Me,je),je}await ke.invokeFunction(async je=>{const Je=je.get(J.$pj),Be=je.get(F.$n0b),He=je.get(A.$sk),Ve=je.get(J.$qj),ne=await this.e(Je,ie,Be,ke,Me,!0);return f.Promises.writeFile(ie.mainLockfile,String(process.pid)).catch(ge=>{Je.warn(`app#startup(): Error writing main lockfile: ${ge.stack}`)}),Ie.logger=Ve.createLogger("main",{name:(0,t.localize)(0,null)}),b.Event.once(Be.onWillShutdown)(ge=>{He.dispose(),fe.dispose(),ge.join("instanceLockfile",f.Promises.unlink(ie.mainLockfile).catch(()=>{}))}),ke.createInstance(c.$S$b,ne,pe).startup()})}catch(je){ke.invokeFunction(this.i,je)}}b(){const ke=new U.$6h,pe=new Q.$Sc;process.once("exit",()=>pe.dispose());const ie={_serviceBrand:void 0,...le.default};ke.set(oe.$Hj,ie);const fe=new n.$W9b(this.j(),ie),$e=this.c(fe);ke.set(n.$V9b,fe);const Ie=new z.$j0b((0,J.$Dj)(fe),fe.logsHome);ke.set(z.$i0b,Ie);const Me=new V.$E7b(Ie.getLogLevel()),Ne=pe.add(new ee.$LO(Me,[new J.$wj(Ie.getLogLevel())]));ke.set(J.$pj,Ne);const je=new I.$eq(Ne);ke.set(A.$sk,je);const Je=new E.$Dq(Ne);je.registerProvider(y.Schemas.file,Je);const Be=new _.$4r(je);ke.set(H.$3k,Be);const He=new de.$GO(1,fe,Ne,je);ke.set(te.$CO,He),ke.set(te.$DO,He);const Ve=new O.$$9b(He,Be,fe,je,Ne);ke.set(O.$09b,Ve),je.registerProvider(y.Schemas.vscodeUserData,new me.$4$b(y.Schemas.file,Je,y.Schemas.vscodeUserData,Ve,Be,Ne));const ne=w.$i&&ie.win32RegValueName?pe.add(new x.$2$b(Ne,ie.win32RegValueName)):fe.policyFile?pe.add(new T.$3$b(fe.policyFile,je,Ne)):new W.$On;ke.set(W.$Mn,ne);const ge=new r.$co(Ve.defaultProfile.settingsResource,je,ne,Ne);return ke.set(o.$Bi,ge),ke.set(F.$n0b,new C.$5h(F.$o0b,void 0,!1)),ke.set(L.$jp,new C.$5h(N.$Z$b,void 0,!0)),ke.set(K.$59b,new C.$5h(K.$69b)),ke.set(G.$kl,new C.$5h(B.$1$b,void 0,!1)),ke.set(Y.$Cv,new C.$5h(q.$X$b)),ke.set(ue.$49b,new Z.$U$b(fe,Ve,Ne)),[new j.$Gq(ke,!0),$e,fe,ge,He,Me,ie,Ve]}c(ke){const pe={VSCODE_IPC_HOOK:ke.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ie=>{const fe=process.env[ie];typeof fe=="string"&&(pe[ie]=fe)}),Object.assign(process.env,pe),pe}async d(ke,pe,ie,fe,$e){await D.Promises.settled([Promise.all([ke.extensionsPath,ke.codeCachePath,ke.logsHome.with({scheme:y.Schemas.file}).fsPath,pe.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,ke.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,ke.localHistoryHome.with({scheme:y.Schemas.file}).fsPath,ke.backupHome].map(Ie=>Ie?f.Promises.mkdir(Ie,{recursive:!0}):void 0)),fe.init(),ie.initialize()]),pe.init()}async e(ke,pe,ie,fe,$e,Ie){let Me;try{(0,$.mark)("code/willStartMainServer"),Me=await(0,m.$3h)(pe.mainIPCHandle),(0,$.mark)("code/didStartMainServer"),b.Event.once(ie.onWillShutdown)(()=>Me.dispose())}catch(Ne){if(Ne.code!=="EADDRINUSE")throw this.f(pe,$e,Ne),Ne;let je;try{je=await(0,m.$4h)(pe.mainIPCHandle,"main")}catch(Ve){if(!Ie||w.$i||Ve.code!=="ECONNREFUSED")throw Ve.code==="EPERM"&&this.g((0,t.localize)(1,null,$e.nameShort),(0,t.localize)(2,null),$e),Ve;try{(0,R.unlinkSync)(pe.mainIPCHandle)}catch(ne){throw ke.warn("Could not delete obsolete instance handle",ne),ne}return this.e(ke,pe,ie,fe,$e,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const Ve=`Running extension tests from the command line is currently only supported if no other instance of ${$e.nameShort} is running.`;throw ke.error(Ve),je.dispose(),new Error(Ve)}let Je;!pe.args.wait&&!pe.args.status&&(Je=setTimeout(()=>{this.g((0,t.localize)(3,null,$e.nameShort),(0,t.localize)(4,null),$e)},1e4));const Be=d.ProxyChannel.toService(je.getChannel("launch"),{disableMarshalling:!0}),He=d.ProxyChannel.toService(je.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return fe.invokeFunction(async()=>{const Ve=new i.$$r(he.$Po,$e),ne=await He.getMainDiagnostics(),ge=await He.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),be=await Ve.getDiagnostics(ne,ge);throw console.log(be),new g.$ab});throw w.$i&&await this.h(Be,ke),ke.trace("Sending env to running instance..."),await Be.start(pe.args,process.env),je.dispose(),Je&&clearTimeout(Je),new g.$ab("Sent env to running instance. Terminating...")}if(pe.args.status)throw console.log((0,t.localize)(5,null,$e.nameShort)),new g.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Me}f(ke,pe,ie){if(ie.code==="EACCES"||ie.code==="EPERM"){const fe=(0,M.$Hb)([ke.userDataPath,ke.extensionsPath,m.$Yh]).map($e=>(0,v.$Xv)(s.URI.file($e),{os:w.OS,tildify:ke}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,P.$Si)(ie),fe.join(`
`)),pe)}}g(ke,pe,ie){S.dialog.showMessageBoxSync((0,se.$_v)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ke,detail:pe},ie).options)}async h(ke,pe){if(w.$i){const ie=await ke.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",ie);try{(await new Promise((fe,$e)=>{X(["windows-foreground-love"],fe,$e)})).allowSetForegroundWindow(ie)}catch(fe){pe.error(fe)}}}i(ke,pe){const ie=ke.get(J.$pj),fe=ke.get(F.$n0b);let $e=0;pe&&(pe.isExpected?pe.message&&ie.trace(pe.message):($e=1,pe.stack?ie.error(pe.stack):ie.error(`Startup error: ${pe.toString()}`))),fe.kill($e)}j(){const ke=this.k((0,a.$5l)(process.argv));if(ke.wait&&!ke.waitMarkerFilePath){const pe=(0,p.$T$b)(ke.verbose);pe&&((0,a.$7l)(process.argv,"--waitMarkerFilePath",pe),ke.waitMarkerFilePath=pe)}return ke}k(ke){if(ke["open-url"]&&(ke._urls=ke._,ke._=[]),!ke.remote){const pe=this.l(ke._,ke.goto);ke._=pe}return ke}l(ke,pe){const ie=(0,k.cwd)(),fe=ke.map(Me=>{let Ne=String(Me),je;pe&&(je=(0,l.$dg)(Ne),Ne=je.path),Ne&&(Ne=this.m(ie,Ne));const Je=(0,l.$$f)(Ne,ie),Be=(0,u.$nc)(Je);return Be&&!(0,l.$7f)(Be)?null:pe&&je?(je.path=Je,this.n(je)):Je}),$e=w.$i||w.$j,Ie=(0,M.$Mb)(fe,Me=>Me&&$e?Me.toLowerCase():Me||"");return(0,M.$Hb)(Ie)}m(ke,pe){return w.$i&&(pe=(0,h.$Ve)(pe,'"')),pe=(0,h.$Te)((0,h.$Te)(pe," "),"	"),w.$i&&(pe=(0,u.$kc)(ke,pe),pe=(0,h.$Ve)(pe,".")),pe}n(ke){const pe=[ke.path];return typeof ke.line=="number"&&pe.push(String(ke.line)),typeof ke.column=="number"&&pe.push(String(ke.column)),pe.join(":")}}new Ee().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ec291c126878742ad640055ce604a58129cd088c/core/vs/code/electron-main/main.js.map
