/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(me){for(var e=[],S=0,M=me.length;S<M;S++)e[S]=Re[me[S]];return e};define(Re[67],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function S(L){return(g,h,E)=>{let A=null,D=null;if(typeof E.value=="function"?(A="value",D=E.value):typeof E.get=="function"&&(A="get",D=E.get),!D)throw new Error("not supported");E[A]=L(D,h)}}function M(L,g,h){let E=null,A=null;if(typeof h.value=="function"?(E="value",A=h.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(E="get",A=h.get),!A)throw new Error("not supported");const D=`$memoize$${g}`;h[E]=function(...l){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,l)}),this[D]}}e.$zh=M;function I(L,g,h){return S((E,A)=>{const D=`$debounce$${A}`,l=`$debounce$result$${A}`;return function(...p){this[l]||(this[l]=h?h():void 0),clearTimeout(this[D]),g&&(this[l]=g(this[l],...p),p=[this[l]]),this[D]=setTimeout(()=>{E.apply(this,p),this[l]=h?h():void 0},L)}})}e.$Ah=I;function R(L,g,h){return S((E,A)=>{const D=`$throttle$timer$${A}`,l=`$throttle$result$${A}`,p=`$throttle$lastRun$${A}`,$=`$throttle$pending$${A}`;return function(...n){if(this[l]||(this[l]=h?h():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),g&&(this[l]=g(this[l],...n)),this[$])return;const c=this[p]+L;c<=Date.now()?(this[p]=Date.now(),E.apply(this,[this[l]]),this[l]=h?h():void 0):(this[$]=!0,this[D]=setTimeout(()=>{this[$]=!1,this[p]=Date.now(),E.apply(this,[this[l]]),this[l]=h?h():void 0},c-Date.now()))}})}e.$Bh=R}),define(Re[89],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=e.$tN=void 0;class S{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$tN=S,e.$uN=new S("id#")}),define(Re[119],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var I;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function L(i,v=!1){let o=0;const w=i.length;let y="",d=0,b=16,P=0;function f(j){let C=0,N=0;for(;C<j;){const W=i.charCodeAt(o);if(W>=48&&W<=57)N=N*16+W-48;else if(W>=65&&W<=70)N=N*16+W-65+10;else if(W>=97&&W<=102)N=N*16+W-97+10;else break;o++,C++}return C<j&&(N=-1),N}function m(j){o=j,y="",d=0,b=16,P=0}function k(){const j=o;if(i.charCodeAt(o)===48)o++;else for(o++;o<i.length&&E(i.charCodeAt(o));)o++;if(o<i.length&&i.charCodeAt(o)===46)if(o++,o<i.length&&E(i.charCodeAt(o)))for(o++;o<i.length&&E(i.charCodeAt(o));)o++;else return P=3,i.substring(j,o);let C=o;if(o<i.length&&(i.charCodeAt(o)===69||i.charCodeAt(o)===101))if(o++,(o<i.length&&i.charCodeAt(o)===43||i.charCodeAt(o)===45)&&o++,o<i.length&&E(i.charCodeAt(o))){for(o++;o<i.length&&E(i.charCodeAt(o));)o++;C=o}else P=3;return i.substring(j,C)}function T(){let j="",C=o;for(;;){if(o>=w){j+=i.substring(C,o),P=2;break}const N=i.charCodeAt(o);if(N===34){j+=i.substring(C,o),o++;break}if(N===92){if(j+=i.substring(C,o),o++,o>=w){P=2;break}switch(i.charCodeAt(o++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const se=f(4);se>=0?j+=String.fromCharCode(se):P=4;break}default:P=5}C=o;continue}if(N>=0&&N<=31)if(h(N)){j+=i.substring(C,o),P=2;break}else P=6;o++}return j}function O(){if(y="",P=0,d=o,o>=w)return d=w,b=17;let j=i.charCodeAt(o);if(g(j)){do o++,y+=String.fromCharCode(j),j=i.charCodeAt(o);while(g(j));return b=15}if(h(j))return o++,y+=String.fromCharCode(j),j===13&&i.charCodeAt(o)===10&&(o++,y+=`
`),b=14;switch(j){case 123:return o++,b=1;case 125:return o++,b=2;case 91:return o++,b=3;case 93:return o++,b=4;case 58:return o++,b=6;case 44:return o++,b=5;case 34:return o++,y=T(),b=10;case 47:{const C=o-1;if(i.charCodeAt(o+1)===47){for(o+=2;o<w&&!h(i.charCodeAt(o));)o++;return y=i.substring(C,o),b=12}if(i.charCodeAt(o+1)===42){o+=2;const N=w-1;let W=!1;for(;o<N;){if(i.charCodeAt(o)===42&&i.charCodeAt(o+1)===47){o+=2,W=!0;break}o++}return W||(o++,P=1),y=i.substring(C,o),b=13}return y+=String.fromCharCode(j),o++,b=16}case 45:if(y+=String.fromCharCode(j),o++,o===w||!E(i.charCodeAt(o)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return y+=k(),b=11;default:for(;o<w&&G(j);)o++,j=i.charCodeAt(o);if(d!==o){switch(y=i.substring(d,o),y){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return y+=String.fromCharCode(j),o++,b=16}}function G(j){if(g(j)||h(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let j;do j=O();while(j>=12&&j<=15);return j}return{setPosition:m,getPosition:()=>o,scan:v?q:O,getToken:()=>b,getTokenValue:()=>y,getTokenOffset:()=>d,getTokenLength:()=>o-d,getTokenError:()=>P}}e.$dn=L;function g(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function h(i){return i===10||i===13||i===8232||i===8233}function E(i){return i>=48&&i<=57}var A;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(A||(A={}));function D(i,v){const o=[],w=new Object;let y;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function P(f,m,k,T){d.value=f,d.offset=m,d.length=k,d.type=T,d.colonOffset=void 0,y=d}try{s(i,{onObjectBegin:(f,m)=>{if(v<=f)throw w;y=void 0,b=v>f,o.push("")},onObjectProperty:(f,m,k)=>{if(v<m||(P(f,m,k,"property"),o[o.length-1]=f,v<=m+k))throw w},onObjectEnd:(f,m)=>{if(v<=f)throw w;y=void 0,o.pop()},onArrayBegin:(f,m)=>{if(v<=f)throw w;y=void 0,o.push(0)},onArrayEnd:(f,m)=>{if(v<=f)throw w;y=void 0,o.pop()},onLiteralValue:(f,m,k)=>{if(v<m||(P(f,m,k,u(f)),v<=m+k))throw w},onSeparator:(f,m,k)=>{if(v<=m)throw w;if(f===":"&&y&&y.type==="property")y.colonOffset=m,b=!1,y=void 0;else if(f===","){const T=o[o.length-1];typeof T=="number"?o[o.length-1]=T+1:(b=!0,o[o.length-1]=""),y=void 0}}})}catch(f){if(f!==w)throw f}return{path:o,previousNode:y,isAtPropertyKey:b,matches:f=>{let m=0;for(let k=0;m<f.length&&k<o.length;k++)if(f[m]===o[k]||f[m]==="*")m++;else if(f[m]!=="**")return!1;return m===f.length}}}e.$en=D;function l(i,v=[],o=R.DEFAULT){let w=null,y=[];const d=[];function b(f){Array.isArray(y)?y.push(f):w!==null&&(y[w]=f)}return s(i,{onObjectBegin:()=>{const f={};b(f),d.push(y),y=f,w=null},onObjectProperty:f=>{w=f},onObjectEnd:()=>{y=d.pop()},onArrayBegin:()=>{const f=[];b(f),d.push(y),y=f,w=null},onArrayEnd:()=>{y=d.pop()},onLiteralValue:b,onError:(f,m,k)=>{v.push({error:f,offset:m,length:k})}},o),y[0]}e.$fn=l;function p(i,v=[],o=R.DEFAULT){let w={type:"array",offset:-1,length:-1,children:[],parent:void 0};function y(f){w.type==="property"&&(w.length=f-w.offset,w=w.parent)}function d(f){return w.children.push(f),f}s(i,{onObjectBegin:f=>{w=d({type:"object",offset:f,length:-1,parent:w,children:[]})},onObjectProperty:(f,m,k)=>{w=d({type:"property",offset:m,length:-1,parent:w,children:[]}),w.children.push({type:"string",value:f,offset:m,length:k,parent:w})},onObjectEnd:(f,m)=>{w.length=f+m-w.offset,w=w.parent,y(f+m)},onArrayBegin:(f,m)=>{w=d({type:"array",offset:f,length:-1,parent:w,children:[]})},onArrayEnd:(f,m)=>{w.length=f+m-w.offset,w=w.parent,y(f+m)},onLiteralValue:(f,m,k)=>{d({type:u(f),offset:m,length:k,parent:w,value:f}),y(m+k)},onSeparator:(f,m,k)=>{w.type==="property"&&(f===":"?w.colonOffset=m:f===","&&y(m))},onError:(f,m,k)=>{v.push({error:f,offset:m,length:k})}},o);const P=w.children[0];return P&&delete P.parent,P}e.$gn=p;function $(i,v){if(!i)return;let o=i;for(const w of v)if(typeof w=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let y=!1;for(const d of o.children)if(Array.isArray(d.children)&&d.children[0].value===w){o=d.children[1],y=!0;break}if(!y)return}else{const y=w;if(o.type!=="array"||y<0||!Array.isArray(o.children)||y>=o.children.length)return;o=o.children[y]}return o}e.$hn=$;function n(i){if(!i.parent||!i.parent.children)return[];const v=n(i.parent);if(i.parent.type==="property"){const o=i.parent.children[0].value;v.push(o)}else if(i.parent.type==="array"){const o=i.parent.children.indexOf(i);o!==-1&&v.push(o)}return v}e.$in=n;function c(i){switch(i.type){case"array":return i.children.map(c);case"object":{const v=Object.create(null);for(const o of i.children){const w=o.children[1];w&&(v[o.children[0].value]=c(w))}return v}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$jn=c;function r(i,v,o=!1){return v>=i.offset&&v<i.offset+i.length||o&&v===i.offset+i.length}e.$kn=r;function t(i,v,o=!1){if(r(i,v,o)){const w=i.children;if(Array.isArray(w))for(let y=0;y<w.length&&w[y].offset<=v;y++){const d=t(w[y],v,o);if(d)return d}return i}}e.$ln=t;function s(i,v,o=R.DEFAULT){const w=L(i,!1);function y(oe){return oe?()=>oe(w.getTokenOffset(),w.getTokenLength()):()=>!0}function d(oe){return oe?$e=>oe($e,w.getTokenOffset(),w.getTokenLength()):()=>!0}const b=y(v.onObjectBegin),P=d(v.onObjectProperty),f=y(v.onObjectEnd),m=y(v.onArrayBegin),k=y(v.onArrayEnd),T=d(v.onLiteralValue),O=d(v.onSeparator),G=y(v.onComment),q=d(v.onError),j=o&&o.disallowComments,C=o&&o.allowTrailingComma;function N(){for(;;){const oe=w.scan();switch(w.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:j||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(oe){case 12:case 13:j?W(10):G();break;case 16:W(1);break;case 15:case 14:break;default:return oe}}}function W(oe,$e=[],ie=[]){if(q(oe),$e.length+ie.length>0){let x=w.getToken();for(;x!==17;){if($e.indexOf(x)!==-1){N();break}else if(ie.indexOf(x)!==-1)break;x=N()}}}function se(oe){const $e=w.getTokenValue();return oe?T($e):P($e),N(),!0}function ue(){switch(w.getToken()){case 11:{let oe=0;try{oe=JSON.parse(w.getTokenValue()),typeof oe!="number"&&(W(2),oe=0)}catch{W(2)}T(oe);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return N(),!0}function ye(){return w.getToken()!==10?(W(3,[],[2,5]),!1):(se(!1),w.getToken()===6?(O(":"),N(),pe()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function ke(){b(),N();let oe=!1;for(;w.getToken()!==2&&w.getToken()!==17;){if(w.getToken()===5){if(oe||W(4,[],[]),O(","),N(),w.getToken()===2&&C)break}else oe&&W(6,[],[]);ye()||W(4,[],[2,5]),oe=!0}return f(),w.getToken()!==2?W(7,[2],[]):N(),!0}function ae(){m(),N();let oe=!1;for(;w.getToken()!==4&&w.getToken()!==17;){if(w.getToken()===5){if(oe||W(4,[],[]),O(","),N(),w.getToken()===4&&C)break}else oe&&W(6,[],[]);pe()||W(4,[],[4,5]),oe=!0}return k(),w.getToken()!==4?W(8,[4],[]):N(),!0}function pe(){switch(w.getToken()){case 3:return ae();case 1:return ke();case 10:return se(!0);default:return ue()}}return N(),w.getToken()===17?o.allowEmptyContent?!0:(W(4,[],[]),!1):pe()?(w.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$mn=s;function a(i,v){const o=L(i),w=[];let y,d=0,b;do switch(b=o.getPosition(),y=o.scan(),y){case 12:case 13:case 17:d!==b&&w.push(i.substring(d,b)),v!==void 0&&w.push(o.getTokenValue().replace(/[^\r\n]/g,v)),d=o.getPosition();break}while(y!==17);return w.join("")}e.$nn=a;function u(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$on=u}),function(me,e){typeof define=="function"&&define.amd?define(Re[120],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(Le,be){for(var ge=0;ge<be.length;ge++){var K=be[ge];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(Le,K.key,K)}}function S(Le,be,ge){return be&&e(Le.prototype,be),ge&&e(Le,ge),Object.defineProperty(Le,"prototype",{writable:!1}),Le}function M(Le,be){if(Le){if(typeof Le=="string")return I(Le,be);var ge=Object.prototype.toString.call(Le).slice(8,-1);if(ge==="Object"&&Le.constructor&&(ge=Le.constructor.name),ge==="Map"||ge==="Set")return Array.from(Le);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return I(Le,be)}}function I(Le,be){(be==null||be>Le.length)&&(be=Le.length);for(var ge=0,K=new Array(be);ge<be;ge++)K[ge]=Le[ge];return K}function R(Le,be){var ge=typeof Symbol<"u"&&Le[Symbol.iterator]||Le["@@iterator"];if(ge)return(ge=ge.call(Le)).next.bind(ge);if(Array.isArray(Le)||(ge=M(Le))||be&&Le&&typeof Le.length=="number"){ge&&(Le=ge);var K=0;return function(){return K>=Le.length?{done:!0}:{done:!1,value:Le[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=L();function g(Le){me.defaults=Le}var h=/[&<>"']/,E=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(be){return l[be]};function $(Le,be){if(be){if(h.test(Le))return Le.replace(E,p)}else if(A.test(Le))return Le.replace(D,p);return Le}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(Le){return Le.replace(n,function(be,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var r=/(^|[^\[])\^/g;function t(Le,be){Le=typeof Le=="string"?Le:Le.source,be=be||"";var ge={replace:function(ee,le){return le=le.source||le,le=le.replace(r,"$1"),Le=Le.replace(ee,le),ge},getRegex:function(){return new RegExp(Le,be)}};return ge}var s=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(Le,be,ge){if(Le){var K;try{K=decodeURIComponent(c(ge)).replace(s,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}be&&!a.test(ge)&&(ge=y(be,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var i={},v=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,w=/^([^:]+:\/*[^/]*)[\s\S]*$/;function y(Le,be){i[" "+Le]||(v.test(Le)?i[" "+Le]=Le+"/":i[" "+Le]=f(Le,"/",!0)),Le=i[" "+Le];var ge=Le.indexOf(":")===-1;return be.substring(0,2)==="//"?ge?be:Le.replace(o,"$1")+be:be.charAt(0)==="/"?ge?be:Le.replace(w,"$1")+be:Le+be}var d={exec:function(){}};function b(Le){for(var be=1,ge,K;be<arguments.length;be++){ge=arguments[be];for(K in ge)Object.prototype.hasOwnProperty.call(ge,K)&&(Le[K]=ge[K])}return Le}function P(Le,be){var ge=Le.replace(/\|/g,function(le,fe,Ce){for(var de=!1,we=fe;--we>=0&&Ce[we]==="\\";)de=!de;return de?"|":" |"}),K=ge.split(/ \|/),ee=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>be)K.splice(be);else for(;K.length<be;)K.push("");for(;ee<K.length;ee++)K[ee]=K[ee].trim().replace(/\\\|/g,"|");return K}function f(Le,be,ge){var K=Le.length;if(K===0)return"";for(var ee=0;ee<K;){var le=Le.charAt(K-ee-1);if(le===be&&!ge)ee++;else if(le!==be&&ge)ee++;else break}return Le.slice(0,K-ee)}function m(Le,be){if(Le.indexOf(be[1])===-1)return-1;for(var ge=Le.length,K=0,ee=0;ee<ge;ee++)if(Le[ee]==="\\")ee++;else if(Le[ee]===be[0])K++;else if(Le[ee]===be[1]&&(K--,K<0))return ee;return-1}function k(Le){Le&&Le.sanitize&&!Le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(Le,be){if(be<1)return"";for(var ge="";be>1;)be&1&&(ge+=Le),be>>=1,Le+=Le;return ge+Le}function O(Le,be,ge,K){var ee=be.href,le=be.title?$(be.title):null,fe=Le[1].replace(/\\([\[\]])/g,"$1");if(Le[0].charAt(0)!=="!"){K.state.inLink=!0;var Ce={type:"link",raw:ge,href:ee,title:le,text:fe,tokens:K.inlineTokens(fe)};return K.state.inLink=!1,Ce}return{type:"image",raw:ge,href:ee,title:le,text:$(fe)}}function G(Le,be){var ge=Le.match(/^(\s+)(?:```)/);if(ge===null)return be;var K=ge[1];return be.split(`
`).map(function(ee){var le=ee.match(/^\s+/);if(le===null)return ee;var fe=le[0];return fe.length>=K.length?ee.slice(K.length):ee}).join(`
`)}var q=function(){function Le(ge){this.options=ge||me.defaults}var be=Le.prototype;return be.space=function(K){var ee=this.rules.block.newline.exec(K);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},be.code=function(K){var ee=this.rules.block.code.exec(K);if(ee){var le=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?le:f(le,`
`)}}},be.fences=function(K){var ee=this.rules.block.fences.exec(K);if(ee){var le=ee[0],fe=G(le,ee[3]||"");return{type:"code",raw:le,lang:ee[2]?ee[2].trim():ee[2],text:fe}}},be.heading=function(K){var ee=this.rules.block.heading.exec(K);if(ee){var le=ee[2].trim();if(/#$/.test(le)){var fe=f(le,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(le=fe.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:le,tokens:this.lexer.inline(le)}}},be.hr=function(K){var ee=this.rules.block.hr.exec(K);if(ee)return{type:"hr",raw:ee[0]}},be.blockquote=function(K){var ee=this.rules.block.blockquote.exec(K);if(ee){var le=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},be.list=function(K){var ee=this.rules.block.list.exec(K);if(ee){var le,fe,Ce,de,we,F,H,J,B,Q,_,Ee,Ne=ee[1].trim(),We=Ne.length>1,Ke={type:"list",raw:"",ordered:We,start:We?+Ne.slice(0,-1):"",loose:!1,items:[]};Ne=We?"\\d{1,9}\\"+Ne.slice(-1):"\\"+Ne,this.options.pedantic&&(Ne=We?Ne:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+Ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(Ee=!1,!(!(ee=Ye.exec(K))||this.rules.block.hr.test(K)));){if(le=ee[0],K=K.substring(le.length),J=ee[2].split(`
`,1)[0],B=K.split(`
`,1)[0],this.options.pedantic?(de=2,_=J.trimLeft()):(de=ee[2].search(/[^ ]/),de=de>4?1:de,_=J.slice(de),de+=ee[1].length),F=!1,!J&&/^ *$/.test(B)&&(le+=B+`
`,K=K.substring(B.length+1),Ee=!0),!Ee)for(var nt=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");K&&(Q=K.split(`
`,1)[0],J=Q,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(J)||st.test(J)||nt.test(J)||it.test(K)));){if(J.search(/[^ ]/)>=de||!J.trim())_+=`
`+J.slice(de);else if(!F)_+=`
`+J;else break;!F&&!J.trim()&&(F=!0),le+=Q+`
`,K=K.substring(Q.length+1)}Ke.loose||(H?Ke.loose=!0:/\n *\n *$/.test(le)&&(H=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(_),fe&&(Ce=fe[0]!=="[ ] ",_=_.replace(/^\[[ xX]\] +/,""))),Ke.items.push({type:"list_item",raw:le,task:!!fe,checked:Ce,loose:!1,text:_}),Ke.raw+=le}Ke.items[Ke.items.length-1].raw=le.trimRight(),Ke.items[Ke.items.length-1].text=_.trimRight(),Ke.raw=Ke.raw.trimRight();var ct=Ke.items.length;for(we=0;we<ct;we++){this.lexer.state.top=!1,Ke.items[we].tokens=this.lexer.blockTokens(Ke.items[we].text,[]);var Ue=Ke.items[we].tokens.filter(function(Y){return Y.type==="space"}),mt=Ue.every(function(Y){for(var X=Y.raw.split(""),ve=0,Be=R(X),Qe;!(Qe=Be()).done;){var tt=Qe.value;if(tt===`
`&&(ve+=1),ve>1)return!0}return!1});!Ke.loose&&Ue.length&&mt&&(Ke.loose=!0,Ke.items[we].loose=!0)}return Ke}},be.html=function(K){var ee=this.rules.block.html.exec(K);if(ee){var le={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var fe=this.options.sanitizer?this.options.sanitizer(ee[0]):$(ee[0]);le.type="paragraph",le.text=fe,le.tokens=this.lexer.inline(fe)}return le}},be.def=function(K){var ee=this.rules.block.def.exec(K);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var le=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:ee[0],href:ee[2],title:ee[3]}}},be.table=function(K){var ee=this.rules.block.table.exec(K);if(ee){var le={type:"table",header:P(ee[1]).map(function(H){return{text:H}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ee[0];var fe=le.align.length,Ce,de,we,F;for(Ce=0;Ce<fe;Ce++)/^ *-+: *$/.test(le.align[Ce])?le.align[Ce]="right":/^ *:-+: *$/.test(le.align[Ce])?le.align[Ce]="center":/^ *:-+ *$/.test(le.align[Ce])?le.align[Ce]="left":le.align[Ce]=null;for(fe=le.rows.length,Ce=0;Ce<fe;Ce++)le.rows[Ce]=P(le.rows[Ce],le.header.length).map(function(H){return{text:H}});for(fe=le.header.length,de=0;de<fe;de++)le.header[de].tokens=this.lexer.inline(le.header[de].text);for(fe=le.rows.length,de=0;de<fe;de++)for(F=le.rows[de],we=0;we<F.length;we++)F[we].tokens=this.lexer.inline(F[we].text);return le}}},be.lheading=function(K){var ee=this.rules.block.lheading.exec(K);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},be.paragraph=function(K){var ee=this.rules.block.paragraph.exec(K);if(ee){var le=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:le,tokens:this.lexer.inline(le)}}},be.text=function(K){var ee=this.rules.block.text.exec(K);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},be.escape=function(K){var ee=this.rules.inline.escape.exec(K);if(ee)return{type:"escape",raw:ee[0],text:$(ee[1])}},be.tag=function(K){var ee=this.rules.inline.tag.exec(K);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):$(ee[0]):ee[0]}},be.link=function(K){var ee=this.rules.inline.link.exec(K);if(ee){var le=ee[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var fe=f(le.slice(0,-1),"\\");if((le.length-fe.length)%2===0)return}else{var Ce=m(ee[2],"()");if(Ce>-1){var de=ee[0].indexOf("!")===0?5:4,we=de+ee[1].length+Ce;ee[2]=ee[2].substring(0,Ce),ee[0]=ee[0].substring(0,we).trim(),ee[3]=""}}var F=ee[2],H="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(F);J&&(F=J[1],H=J[3])}else H=ee[3]?ee[3].slice(1,-1):"";return F=F.trim(),/^</.test(F)&&(this.options.pedantic&&!/>$/.test(le)?F=F.slice(1):F=F.slice(1,-1)),O(ee,{href:F&&F.replace(this.rules.inline._escapes,"$1"),title:H&&H.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},be.reflink=function(K,ee){var le;if((le=this.rules.inline.reflink.exec(K))||(le=this.rules.inline.nolink.exec(K))){var fe=(le[2]||le[1]).replace(/\s+/g," ");if(fe=ee[fe.toLowerCase()],!fe||!fe.href){var Ce=le[0].charAt(0);return{type:"text",raw:Ce,text:Ce}}return O(le,fe,le[0],this.lexer)}},be.emStrong=function(K,ee,le){le===void 0&&(le="");var fe=this.rules.inline.emStrong.lDelim.exec(K);if(fe&&!(fe[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ce=fe[1]||fe[2]||"";if(!Ce||Ce&&(le===""||this.rules.inline.punctuation.exec(le))){var de=fe[0].length-1,we,F,H=de,J=0,B=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(B.lastIndex=0,ee=ee.slice(-1*K.length+de);(fe=B.exec(ee))!=null;)if(we=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!we){if(F=we.length,fe[3]||fe[4]){H+=F;continue}else if((fe[5]||fe[6])&&de%3&&!((de+F)%3)){J+=F;continue}if(H-=F,!(H>0)){if(F=Math.min(F,F+H+J),Math.min(de,F)%2){var Q=K.slice(1,de+fe.index+F);return{type:"em",raw:K.slice(0,de+fe.index+F+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var _=K.slice(2,de+fe.index+F-1);return{type:"strong",raw:K.slice(0,de+fe.index+F+1),text:_,tokens:this.lexer.inlineTokens(_)}}}}}},be.codespan=function(K){var ee=this.rules.inline.code.exec(K);if(ee){var le=ee[2].replace(/\n/g," "),fe=/[^ ]/.test(le),Ce=/^ /.test(le)&&/ $/.test(le);return fe&&Ce&&(le=le.substring(1,le.length-1)),le=$(le,!0),{type:"codespan",raw:ee[0],text:le}}},be.br=function(K){var ee=this.rules.inline.br.exec(K);if(ee)return{type:"br",raw:ee[0]}},be.del=function(K){var ee=this.rules.inline.del.exec(K);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},be.autolink=function(K,ee){var le=this.rules.inline.autolink.exec(K);if(le){var fe,Ce;return le[2]==="@"?(fe=$(this.options.mangle?ee(le[1]):le[1]),Ce="mailto:"+fe):(fe=$(le[1]),Ce=fe),{type:"link",raw:le[0],text:fe,href:Ce,tokens:[{type:"text",raw:fe,text:fe}]}}},be.url=function(K,ee){var le;if(le=this.rules.inline.url.exec(K)){var fe,Ce;if(le[2]==="@")fe=$(this.options.mangle?ee(le[0]):le[0]),Ce="mailto:"+fe;else{var de;do de=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(de!==le[0]);fe=$(le[0]),le[1]==="www."?Ce="http://"+fe:Ce=fe}return{type:"link",raw:le[0],text:fe,href:Ce,tokens:[{type:"text",raw:fe,text:fe}]}}},be.inlineText=function(K,ee){var le=this.rules.inline.text.exec(K);if(le){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]):le[0]:fe=$(this.options.smartypants?ee(le[0]):le[0]),{type:"text",raw:le[0],text:fe}}},Le}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=t(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=t(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=t(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=t(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=t(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=t(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=b({},j),j.gfm=b({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=t(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=t(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=b({},j.normal,{html:t(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:t(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=t(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=t(j._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=t(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=t(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=t(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=t(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=t(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=t(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=t(C.reflink).replace("label",C._label).replace("ref",j._label).getRegex(),C.nolink=t(C.nolink).replace("ref",j._label).getRegex(),C.reflinkSearch=t(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=b({},C),C.pedantic=b({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:t(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:t(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=b({},C.normal,{escape:t(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=t(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=b({},C.gfm,{br:t(C.br).replace("{2,}","*").getRegex(),text:t(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(Le){return Le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Le){var be="",ge,K,ee=Le.length;for(ge=0;ge<ee;ge++)K=Le.charCodeAt(ge),Math.random()>.5&&(K="x"+K.toString(16)),be+="&#"+K+";";return be}var se=function(){function Le(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||me.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:j.normal,inline:C.normal};this.options.pedantic?(K.block=j.pedantic,K.inline=C.pedantic):this.options.gfm&&(K.block=j.gfm,this.options.breaks?K.inline=C.breaks:K.inline=C.gfm),this.tokenizer.rules=K}Le.lex=function(K,ee){var le=new Le(ee);return le.lex(K)},Le.lexInline=function(K,ee){var le=new Le(ee);return le.inlineTokens(K)};var be=Le.prototype;return be.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},be.blockTokens=function(K,ee){var le=this;ee===void 0&&(ee=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(H,J,B){return J+"    ".repeat(B.length)});for(var fe,Ce,de,we;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(H){return(fe=H.call({lexer:le},K,ee))?(K=K.substring(fe.raw.length),ee.push(fe),!0):!1}))){if(fe=this.tokenizer.space(K)){K=K.substring(fe.raw.length),fe.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(fe);continue}if(fe=this.tokenizer.code(K)){K=K.substring(fe.raw.length),Ce=ee[ee.length-1],Ce&&(Ce.type==="paragraph"||Ce.type==="text")?(Ce.raw+=`
`+fe.raw,Ce.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ce.text):ee.push(fe);continue}if(fe=this.tokenizer.fences(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.heading(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.hr(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.blockquote(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.list(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.html(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.def(K)){K=K.substring(fe.raw.length),Ce=ee[ee.length-1],Ce&&(Ce.type==="paragraph"||Ce.type==="text")?(Ce.raw+=`
`+fe.raw,Ce.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ce.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.lheading(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(de=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var H=1/0,J=K.slice(1),B=void 0;le.options.extensions.startBlock.forEach(function(Q){B=Q.call({lexer:this},J),typeof B=="number"&&B>=0&&(H=Math.min(H,B))}),H<1/0&&H>=0&&(de=K.substring(0,H+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(de))){Ce=ee[ee.length-1],we&&Ce.type==="paragraph"?(Ce.raw+=`
`+fe.raw,Ce.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ce.text):ee.push(fe),we=de.length!==K.length,K=K.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(K)){K=K.substring(fe.raw.length),Ce=ee[ee.length-1],Ce&&Ce.type==="text"?(Ce.raw+=`
`+fe.raw,Ce.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ce.text):ee.push(fe);continue}if(K){var F="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(F);break}else throw new Error(F)}}return this.state.top=!0,ee},be.inline=function(K,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:K,tokens:ee}),ee},be.inlineTokens=function(K,ee){var le=this;ee===void 0&&(ee=[]);var fe,Ce,de,we=K,F,H,J;if(this.tokens.links){var B=Object.keys(this.tokens.links);if(B.length>0)for(;(F=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)B.includes(F[0].slice(F[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,F.index)+"["+T("a",F[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(F=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,F.index)+"["+T("a",F[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(F=this.tokenizer.rules.inline.escapedEmSt.exec(we))!=null;)we=we.slice(0,F.index)+"++"+we.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(H||(J=""),H=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_){return(fe=_.call({lexer:le},K,ee))?(K=K.substring(fe.raw.length),ee.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.tag(K)){K=K.substring(fe.raw.length),Ce=ee[ee.length-1],Ce&&fe.type==="text"&&Ce.type==="text"?(Ce.raw+=fe.raw,Ce.text+=fe.text):ee.push(fe);continue}if(fe=this.tokenizer.link(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(fe.raw.length),Ce=ee[ee.length-1],Ce&&fe.type==="text"&&Ce.type==="text"?(Ce.raw+=fe.raw,Ce.text+=fe.text):ee.push(fe);continue}if(fe=this.tokenizer.emStrong(K,we,J)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.codespan(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.br(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.del(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.autolink(K,W)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(K,W))){K=K.substring(fe.raw.length),ee.push(fe);continue}if(de=K,this.options.extensions&&this.options.extensions.startInline&&function(){var _=1/0,Ee=K.slice(1),Ne=void 0;le.options.extensions.startInline.forEach(function(We){Ne=We.call({lexer:this},Ee),typeof Ne=="number"&&Ne>=0&&(_=Math.min(_,Ne))}),_<1/0&&_>=0&&(de=K.substring(0,_+1))}(),fe=this.tokenizer.inlineText(de,N)){K=K.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(J=fe.raw.slice(-1)),H=!0,Ce=ee[ee.length-1],Ce&&Ce.type==="text"?(Ce.raw+=fe.raw,Ce.text+=fe.text):ee.push(fe);continue}if(K){var Q="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return ee},S(Le,null,[{key:"rules",get:function(){return{block:j,inline:C}}}]),Le}(),ue=function(){function Le(ge){this.options=ge||me.defaults}var be=Le.prototype;return be.code=function(K,ee,le){var fe=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Ce=this.options.highlight(K,fe);Ce!=null&&Ce!==K&&(le=!0,K=Ce)}return K=K.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+$(fe,!0)+'">'+(le?K:$(K,!0))+`</code></pre>
`:"<pre><code>"+(le?K:$(K,!0))+`</code></pre>
`},be.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},be.html=function(K){return K},be.heading=function(K,ee,le,fe){if(this.options.headerIds){var Ce=this.options.headerPrefix+fe.slug(le);return"<h"+ee+' id="'+Ce+'">'+K+"</h"+ee+`>
`}return"<h"+ee+">"+K+"</h"+ee+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(K,ee,le){var fe=ee?"ol":"ul",Ce=ee&&le!==1?' start="'+le+'"':"";return"<"+fe+Ce+`>
`+K+"</"+fe+`>
`},be.listitem=function(K){return"<li>"+K+`</li>
`},be.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(K){return"<p>"+K+`</p>
`},be.table=function(K,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+ee+`</table>
`},be.tablerow=function(K){return`<tr>
`+K+`</tr>
`},be.tablecell=function(K,ee){var le=ee.header?"th":"td",fe=ee.align?"<"+le+' align="'+ee.align+'">':"<"+le+">";return fe+K+("</"+le+`>
`)},be.strong=function(K){return"<strong>"+K+"</strong>"},be.em=function(K){return"<em>"+K+"</em>"},be.codespan=function(K){return"<code>"+K+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(K){return"<del>"+K+"</del>"},be.link=function(K,ee,le){if(K=u(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var fe='<a href="'+$(K)+'"';return ee&&(fe+=' title="'+ee+'"'),fe+=">"+le+"</a>",fe},be.image=function(K,ee,le){if(K=u(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var fe='<img src="'+K+'" alt="'+le+'"';return ee&&(fe+=' title="'+ee+'"'),fe+=this.options.xhtml?"/>":">",fe},be.text=function(K){return K},Le}(),ye=function(){function Le(){}var be=Le.prototype;return be.strong=function(K){return K},be.em=function(K){return K},be.codespan=function(K){return K},be.del=function(K){return K},be.html=function(K){return K},be.text=function(K){return K},be.link=function(K,ee,le){return""+le},be.image=function(K,ee,le){return""+le},be.br=function(){return""},Le}(),ke=function(){function Le(){this.seen={}}var be=Le.prototype;return be.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(K,ee){var le=K,fe=0;if(this.seen.hasOwnProperty(le)){fe=this.seen[K];do fe++,le=K+"-"+fe;while(this.seen.hasOwnProperty(le))}return ee||(this.seen[K]=fe,this.seen[le]=0),le},be.slug=function(K,ee){ee===void 0&&(ee={});var le=this.serialize(K);return this.getNextSafeSlug(le,ee.dryrun)},Le}(),ae=function(){function Le(ge){this.options=ge||me.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new ke}Le.parse=function(K,ee){var le=new Le(ee);return le.parse(K)},Le.parseInline=function(K,ee){var le=new Le(ee);return le.parseInline(K)};var be=Le.prototype;return be.parse=function(K,ee){ee===void 0&&(ee=!0);var le="",fe,Ce,de,we,F,H,J,B,Q,_,Ee,Ne,We,Ke,Ye,nt,it,et,st,ct=K.length;for(fe=0;fe<ct;fe++){if(_=K[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_.type]&&(st=this.options.extensions.renderers[_.type].call({parser:this},_),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_.type))){le+=st||"";continue}switch(_.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(_.tokens),_.depth,c(this.parseInline(_.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(_.text,_.lang,_.escaped);continue}case"table":{for(B="",J="",we=_.header.length,Ce=0;Ce<we;Ce++)J+=this.renderer.tablecell(this.parseInline(_.header[Ce].tokens),{header:!0,align:_.align[Ce]});for(B+=this.renderer.tablerow(J),Q="",we=_.rows.length,Ce=0;Ce<we;Ce++){for(H=_.rows[Ce],J="",F=H.length,de=0;de<F;de++)J+=this.renderer.tablecell(this.parseInline(H[de].tokens),{header:!1,align:_.align[de]});Q+=this.renderer.tablerow(J)}le+=this.renderer.table(B,Q);continue}case"blockquote":{Q=this.parse(_.tokens),le+=this.renderer.blockquote(Q);continue}case"list":{for(Ee=_.ordered,Ne=_.start,We=_.loose,we=_.items.length,Q="",Ce=0;Ce<we;Ce++)Ye=_.items[Ce],nt=Ye.checked,it=Ye.task,Ke="",Ye.task&&(et=this.renderer.checkbox(nt),We?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=et+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=et+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:et}):Ke+=et),Ke+=this.parse(Ye.tokens,We),Q+=this.renderer.listitem(Ke,it,nt);le+=this.renderer.list(Q,Ee,Ne);continue}case"html":{le+=this.renderer.html(_.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(_.tokens));continue}case"text":{for(Q=_.tokens?this.parseInline(_.tokens):_.text;fe+1<ct&&K[fe+1].type==="text";)_=K[++fe],Q+=`
`+(_.tokens?this.parseInline(_.tokens):_.text);le+=ee?this.renderer.paragraph(Q):Q;continue}default:{var Ue='Token with "'+_.type+'" type was not found.';if(this.options.silent){console.error(Ue);return}else throw new Error(Ue)}}}return le},be.parseInline=function(K,ee){ee=ee||this.renderer;var le="",fe,Ce,de,we=K.length;for(fe=0;fe<we;fe++){if(Ce=K[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ce.type]&&(de=this.options.extensions.renderers[Ce.type].call({parser:this},Ce),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ce.type))){le+=de||"";continue}switch(Ce.type){case"escape":{le+=ee.text(Ce.text);break}case"html":{le+=ee.html(Ce.text);break}case"link":{le+=ee.link(Ce.href,Ce.title,this.parseInline(Ce.tokens,ee));break}case"image":{le+=ee.image(Ce.href,Ce.title,Ce.text);break}case"strong":{le+=ee.strong(this.parseInline(Ce.tokens,ee));break}case"em":{le+=ee.em(this.parseInline(Ce.tokens,ee));break}case"codespan":{le+=ee.codespan(Ce.text);break}case"br":{le+=ee.br();break}case"del":{le+=ee.del(this.parseInline(Ce.tokens,ee));break}case"text":{le+=ee.text(Ce.text);break}default:{var F='Token with "'+Ce.type+'" type was not found.';if(this.options.silent){console.error(F);return}else throw new Error(F)}}}return le},Le}();function pe(Le,be,ge){if(typeof Le>"u"||Le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");if(typeof be=="function"&&(ge=be,be=null),be=b({},pe.defaults,be||{}),k(be),ge){var K=be.highlight,ee;try{ee=se.lex(Le,be)}catch(we){return ge(we)}var le=function(F){var H;if(!F)try{be.walkTokens&&pe.walkTokens(ee,be.walkTokens),H=ae.parse(ee,be)}catch(J){F=J}return be.highlight=K,F?ge(F):ge(null,H)};if(!K||K.length<3||(delete be.highlight,!ee.length))return le();var fe=0;pe.walkTokens(ee,function(we){we.type==="code"&&(fe++,setTimeout(function(){K(we.text,we.lang,function(F,H){if(F)return le(F);H!=null&&H!==we.text&&(we.text=H,we.escaped=!0),fe--,fe===0&&le()})},0))}),fe===0&&le();return}function Ce(we){if(we.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+$(we.message+"",!0)+"</pre>";throw we}try{var de=se.lex(Le,be);if(be.walkTokens){if(be.async)return Promise.all(pe.walkTokens(de,be.walkTokens)).then(function(){return ae.parse(de,be)}).catch(Ce);pe.walkTokens(de,be.walkTokens)}return ae.parse(de,be)}catch(we){Ce(we)}}pe.options=pe.setOptions=function(Le){return b(pe.defaults,Le),g(pe.defaults),pe},pe.getDefaults=L,pe.defaults=me.defaults,pe.use=function(){for(var Le=arguments.length,be=new Array(Le),ge=0;ge<Le;ge++)be[ge]=arguments[ge];var K=b.apply(void 0,[{}].concat(be)),ee=pe.defaults.extensions||{renderers:{},childTokens:{}},le;be.forEach(function(fe){if(fe.extensions&&(le=!0,fe.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var we=ee.renderers?ee.renderers[de.name]:null;we?ee.renderers[de.name]=function(){for(var F=arguments.length,H=new Array(F),J=0;J<F;J++)H[J]=arguments[J];var B=de.renderer.apply(this,H);return B===!1&&(B=we.apply(this,H)),B}:ee.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[de.level]?ee[de.level].unshift(de.tokenizer):ee[de.level]=[de.tokenizer],de.start&&(de.level==="block"?ee.startBlock?ee.startBlock.push(de.start):ee.startBlock=[de.start]:de.level==="inline"&&(ee.startInline?ee.startInline.push(de.start):ee.startInline=[de.start]))}de.childTokens&&(ee.childTokens[de.name]=de.childTokens)})),fe.renderer&&function(){var de=pe.defaults.renderer||new ue,we=function(J){var B=de[J];de[J]=function(){for(var Q=arguments.length,_=new Array(Q),Ee=0;Ee<Q;Ee++)_[Ee]=arguments[Ee];var Ne=fe.renderer[J].apply(de,_);return Ne===!1&&(Ne=B.apply(de,_)),Ne}};for(var F in fe.renderer)we(F);K.renderer=de}(),fe.tokenizer&&function(){var de=pe.defaults.tokenizer||new q,we=function(J){var B=de[J];de[J]=function(){for(var Q=arguments.length,_=new Array(Q),Ee=0;Ee<Q;Ee++)_[Ee]=arguments[Ee];var Ne=fe.tokenizer[J].apply(de,_);return Ne===!1&&(Ne=B.apply(de,_)),Ne}};for(var F in fe.tokenizer)we(F);K.tokenizer=de}(),fe.walkTokens){var Ce=pe.defaults.walkTokens;K.walkTokens=function(de){var we=[];return we.push(fe.walkTokens.call(this,de)),Ce&&(we=we.concat(Ce.call(this,de))),we}}le&&(K.extensions=ee),pe.setOptions(K)})},pe.walkTokens=function(Le,be){for(var ge=[],K=function(){var Ce=le.value;switch(ge=ge.concat(be.call(pe,Ce)),Ce.type){case"table":{for(var de=R(Ce.header),we;!(we=de()).done;){var F=we.value;ge=ge.concat(pe.walkTokens(F.tokens,be))}for(var H=R(Ce.rows),J;!(J=H()).done;)for(var B=J.value,Q=R(B),_;!(_=Q()).done;){var Ee=_.value;ge=ge.concat(pe.walkTokens(Ee.tokens,be))}break}case"list":{ge=ge.concat(pe.walkTokens(Ce.items,be));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[Ce.type]?pe.defaults.extensions.childTokens[Ce.type].forEach(function(Ne){ge=ge.concat(pe.walkTokens(Ce[Ne],be))}):Ce.tokens&&(ge=ge.concat(pe.walkTokens(Ce.tokens,be)))}},ee=R(Le),le;!(le=ee()).done;)K();return ge},pe.parseInline=function(Le,be){if(typeof Le>"u"||Le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");be=b({},pe.defaults,be||{}),k(be);try{var ge=se.lexInline(Le,be);return be.walkTokens&&pe.walkTokens(ge,be.walkTokens),ae.parseInline(ge,be)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+$(K.message+"",!0)+"</pre>";throw K}},pe.Parser=ae,pe.parser=ae.parse,pe.Renderer=ue,pe.TextRenderer=ye,pe.Lexer=se,pe.lexer=se.lex,pe.Tokenizer=q,pe.Slugger=ke,pe.parse=pe;var oe=pe.options,$e=pe.setOptions,ie=pe.use,x=pe.walkTokens,V=pe.parseInline,ne=pe,Ie=ae.parse,Me=se.lex;me.Lexer=se,me.Parser=ae,me.Renderer=ue,me.Slugger=ke,me.TextRenderer=ye,me.Tokenizer=q,me.getDefaults=L,me.lexer=Me,me.marked=pe,me.options=oe,me.parse=ne,me.parseInline=V,me.parser=Ie,me.setOptions=$e,me.use=ie,me.walkTokens=x,Object.defineProperty(me,"__esModule",{value:!0})}),define(Re[121],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tj=void 0;function S(n){const c=R(n);if(c&&c.length>0)return new Uint32Array(c)}e.$Tj=S;let M=0;const I=new Uint32Array(10);function R(n){if(M=0,L(n,D,4352),M>0||(L(n,l,4449),M>0)||(L(n,p,4520),M>0)||(L(n,$,12593),M))return I.subarray(0,M);if(n>=44032&&n<=55203){const c=n-44032,r=c%588,t=Math.floor(c/588),s=Math.floor(r/28),a=r%28-1;if(t<D.length?L(t,D,0):4352+t-12593<$.length&&L(4352+t,$,12593),s<l.length?L(s,l,0):4449+s-12593<$.length&&L(4449+s-12593,$,12593),a>=0&&(a<p.length?L(a,p,0):4520+a-12593<$.length&&L(4520+a-12593,$,12593)),M>0)return I.subarray(0,M)}}function L(n,c,r){n>=r&&n<r+c.length&&g(c[n-r])}function g(n){n!==0&&(I[M++]=n&255,n>>8&&(I[M++]=n>>8&255),n>>16&&(I[M++]=n>>16&255))}var h;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(h||(h={}));var E;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(E||(E={}));var A;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(A||(A={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),p=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),$=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Re[122],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.rot=e.$9l=void 0;function S(g,h,E){return Math.min(Math.max(g,h),E)}e.$9l=S;function M(g,h){return(h+g%h)%h}e.rot=M;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$$l=I;class R{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$_l=R;class L{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const E=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$am=L}),function(){function me(I){const R=[];typeof I=="number"&&R.push("code/timeOrigin",I);function L(h){R.push(h,Date.now())}function g(){const h=[];for(let E=0;E<R.length;E+=2)h.push({name:R[E],startTime:R[E+1]});return h}return{mark:L,getMarks:g}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(I+L.startTime)});return R}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function S(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=S(M))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var M in S)(typeof exports=="object"?exports:me)[M]=S[M]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function S(M){if(e[M])return e[M].exports;var I=e[M]={i:M,l:!1,exports:{}};return me[M].call(I.exports,I,I.exports,S),I.l=!0,I.exports}return S.m=me,S.c=e,S.d=function(M,I,R){S.o(M,I)||Object.defineProperty(M,I,{enumerable:!0,get:R})},S.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},S.t=function(M,I){if(1&I&&(M=S(M)),8&I||4&I&&typeof M=="object"&&M&&M.__esModule)return M;var R=Object.create(null);if(S.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:M}),2&I&&typeof M!="string")for(var L in M)S.d(R,L,function(g){return M[g]}.bind(null,L));return R},S.n=function(M){var I=M&&M.__esModule?function(){return M.default}:function(){return M};return S.d(I,"a",I),I},S.o=function(M,I){return Object.prototype.hasOwnProperty.call(M,I)},S.p="",S(S.s=0)}([function(me,e,S){(function(M){var I;e=me.exports=ie,I=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,g=e.re=[],h=e.src=[],E=0,A=E++;h[A]="0|[1-9]\\d*";var D=E++;h[D]="[0-9]+";var l=E++;h[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=E++;h[p]="("+h[A]+")\\.("+h[A]+")\\.("+h[A]+")";var $=E++;h[$]="("+h[D]+")\\.("+h[D]+")\\.("+h[D]+")";var n=E++;h[n]="(?:"+h[A]+"|"+h[l]+")";var c=E++;h[c]="(?:"+h[D]+"|"+h[l]+")";var r=E++;h[r]="(?:-("+h[n]+"(?:\\."+h[n]+")*))";var t=E++;h[t]="(?:-?("+h[c]+"(?:\\."+h[c]+")*))";var s=E++;h[s]="[0-9A-Za-z-]+";var a=E++;h[a]="(?:\\+("+h[s]+"(?:\\."+h[s]+")*))";var u=E++,i="v?"+h[p]+h[r]+"?"+h[a]+"?";h[u]="^"+i+"$";var v="[v=\\s]*"+h[$]+h[t]+"?"+h[a]+"?",o=E++;h[o]="^"+v+"$";var w=E++;h[w]="((?:<|>)?=?)";var y=E++;h[y]=h[D]+"|x|X|\\*";var d=E++;h[d]=h[A]+"|x|X|\\*";var b=E++;h[b]="[v=\\s]*("+h[d]+")(?:\\.("+h[d]+")(?:\\.("+h[d]+")(?:"+h[r]+")?"+h[a]+"?)?)?";var P=E++;h[P]="[v=\\s]*("+h[y]+")(?:\\.("+h[y]+")(?:\\.("+h[y]+")(?:"+h[t]+")?"+h[a]+"?)?)?";var f=E++;h[f]="^"+h[w]+"\\s*"+h[b]+"$";var m=E++;h[m]="^"+h[w]+"\\s*"+h[P]+"$";var k=E++;h[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=E++;h[T]="(?:~>?)";var O=E++;h[O]="(\\s*)"+h[T]+"\\s+",g[O]=new RegExp(h[O],"g");var G=E++;h[G]="^"+h[T]+h[b]+"$";var q=E++;h[q]="^"+h[T]+h[P]+"$";var j=E++;h[j]="(?:\\^)";var C=E++;h[C]="(\\s*)"+h[j]+"\\s+",g[C]=new RegExp(h[C],"g");var N=E++;h[N]="^"+h[j]+h[b]+"$";var W=E++;h[W]="^"+h[j]+h[P]+"$";var se=E++;h[se]="^"+h[w]+"\\s*("+v+")$|^$";var ue=E++;h[ue]="^"+h[w]+"\\s*("+i+")$|^$";var ye=E++;h[ye]="(\\s*)"+h[w]+"\\s*("+v+"|"+h[b]+")",g[ye]=new RegExp(h[ye],"g");var ke=E++;h[ke]="^\\s*("+h[b]+")\\s+-\\s+("+h[b]+")\\s*$";var ae=E++;h[ae]="^\\s*("+h[P]+")\\s+-\\s+("+h[P]+")\\s*$";var pe=E++;h[pe]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)I(oe,h[oe]),g[oe]||(g[oe]=new RegExp(h[oe]));function $e(B,Q){if(B instanceof ie)return B;if(typeof B!="string"||B.length>R||!(Q?g[o]:g[u]).test(B))return null;try{return new ie(B,Q)}catch{return null}}function ie(B,Q){if(B instanceof ie){if(B.loose===Q)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ie))return new ie(B,Q);I("SemVer",B,Q),this.loose=Q;var _=B.trim().match(Q?g[o]:g[u]);if(!_)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Ne=+Ee;if(Ne>=0&&Ne<L)return Ne}return Ee}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=$e,e.valid=function(B,Q){var _=$e(B,Q);return _?_.version:null},e.clean=function(B,Q){var _=$e(B.trim().replace(/^[=v]+/,""),Q);return _?_.version:null},e.SemVer=ie,ie.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ie.prototype.toString=function(){return this.version},ie.prototype.compare=function(B){return I("SemVer.compare",this.version,this.loose,B),B instanceof ie||(B=new ie(B,this.loose)),this.compareMain(B)||this.comparePre(B)},ie.prototype.compareMain=function(B){return B instanceof ie||(B=new ie(B,this.loose)),V(this.major,B.major)||V(this.minor,B.minor)||V(this.patch,B.patch)},ie.prototype.comparePre=function(B){if(B instanceof ie||(B=new ie(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var Q=0;do{var _=this.prerelease[Q],Ee=B.prerelease[Q];if(I("prerelease compare",Q,_,Ee),_===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(_===void 0)return-1;if(_!==Ee)return V(_,Ee)}while(++Q)},ie.prototype.inc=function(B,Q){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,Q,_,Ee){typeof _=="string"&&(Ee=_,_=void 0);try{return new ie(B,_).inc(Q,Ee).version}catch{return null}},e.diff=function(B,Q){if(Le(B,Q))return null;var _=$e(B),Ee=$e(Q);if(_.prerelease.length||Ee.prerelease.length){for(var Ne in _)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&_[Ne]!==Ee[Ne])return"pre"+Ne;return"prerelease"}for(var Ne in _)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&_[Ne]!==Ee[Ne])return Ne},e.compareIdentifiers=V;var x=/^[0-9]+$/;function V(B,Q){var _=x.test(B),Ee=x.test(Q);return _&&Ee&&(B=+B,Q=+Q),_&&!Ee?-1:Ee&&!_?1:B<Q?-1:B>Q?1:0}function ne(B,Q,_){return new ie(B,_).compare(new ie(Q,_))}function Ie(B,Q,_){return ne(B,Q,_)>0}function Me(B,Q,_){return ne(B,Q,_)<0}function Le(B,Q,_){return ne(B,Q,_)===0}function be(B,Q,_){return ne(B,Q,_)!==0}function ge(B,Q,_){return ne(B,Q,_)>=0}function K(B,Q,_){return ne(B,Q,_)<=0}function ee(B,Q,_,Ee){var Ne;switch(Q){case"===":typeof B=="object"&&(B=B.version),typeof _=="object"&&(_=_.version),Ne=B===_;break;case"!==":typeof B=="object"&&(B=B.version),typeof _=="object"&&(_=_.version),Ne=B!==_;break;case"":case"=":case"==":Ne=Le(B,_,Ee);break;case"!=":Ne=be(B,_,Ee);break;case">":Ne=Ie(B,_,Ee);break;case">=":Ne=ge(B,_,Ee);break;case"<":Ne=Me(B,_,Ee);break;case"<=":Ne=K(B,_,Ee);break;default:throw new TypeError("Invalid operator: "+Q)}return Ne}function le(B,Q){if(B instanceof le){if(B.loose===Q)return B;B=B.value}if(!(this instanceof le))return new le(B,Q);I("comparator",B,Q),this.loose=Q,this.parse(B),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(B,Q){return V(Q,B)},e.major=function(B,Q){return new ie(B,Q).major},e.minor=function(B,Q){return new ie(B,Q).minor},e.patch=function(B,Q){return new ie(B,Q).patch},e.compare=ne,e.compareLoose=function(B,Q){return ne(B,Q,!0)},e.rcompare=function(B,Q,_){return ne(Q,B,_)},e.sort=function(B,Q){return B.sort(function(_,Ee){return e.compare(_,Ee,Q)})},e.rsort=function(B,Q){return B.sort(function(_,Ee){return e.rcompare(_,Ee,Q)})},e.gt=Ie,e.lt=Me,e.eq=Le,e.neq=be,e.gte=ge,e.lte=K,e.cmp=ee,e.Comparator=le;var fe={};function Ce(B,Q){if(B instanceof Ce)return B.loose===Q?B:new Ce(B.raw,Q);if(B instanceof le)return new Ce(B.value,Q);if(!(this instanceof Ce))return new Ce(B,Q);if(this.loose=Q,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function de(B){return!B||B.toLowerCase()==="x"||B==="*"}function we(B,Q,_,Ee,Ne,We,Ke,Ye,nt,it,et,st,ct){return((Q=de(_)?"":de(Ee)?">="+_+".0.0":de(Ne)?">="+_+"."+Ee+".0":">="+Q)+" "+(Ye=de(nt)?"":de(it)?"<"+(+nt+1)+".0.0":de(et)?"<"+nt+"."+(+it+1)+".0":st?"<="+nt+"."+it+"."+et+"-"+st:"<="+Ye)).trim()}function F(B,Q){for(var _=0;_<B.length;_++)if(!B[_].test(Q))return!1;if(Q.prerelease.length){for(_=0;_<B.length;_++)if(I(B[_].semver),B[_].semver!==fe&&B[_].semver.prerelease.length>0){var Ee=B[_].semver;if(Ee.major===Q.major&&Ee.minor===Q.minor&&Ee.patch===Q.patch)return!0}return!1}return!0}function H(B,Q,_){try{Q=new Ce(Q,_)}catch{return!1}return Q.test(B)}function J(B,Q,_,Ee){var Ne,We,Ke,Ye,nt;switch(B=new ie(B,Ee),Q=new Ce(Q,Ee),_){case">":Ne=Ie,We=K,Ke=Me,Ye=">",nt=">=";break;case"<":Ne=Me,We=ge,Ke=Ie,Ye="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(H(B,Q,Ee))return!1;for(var it=0;it<Q.set.length;++it){var et=Q.set[it],st=null,ct=null;if(et.forEach(function(Ue){Ue.semver===fe&&(Ue=new le(">=0.0.0")),st=st||Ue,ct=ct||Ue,Ne(Ue.semver,st.semver,Ee)?st=Ue:Ke(Ue.semver,ct.semver,Ee)&&(ct=Ue)}),st.operator===Ye||st.operator===nt||(!ct.operator||ct.operator===Ye)&&We(B,ct.semver)||ct.operator===nt&&Ke(B,ct.semver))return!1}return!0}le.prototype.parse=function(B){var Q=this.loose?g[se]:g[ue],_=B.match(Q);if(!_)throw new TypeError("Invalid comparator: "+B);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new ie(_[2],this.loose):this.semver=fe},le.prototype.toString=function(){return this.value},le.prototype.test=function(B){return I("Comparator.test",B,this.loose),this.semver===fe||(typeof B=="string"&&(B=new ie(B,this.loose)),ee(B,this.operator,this.semver,this.loose))},le.prototype.intersects=function(B,Q){if(!(B instanceof le))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new Ce(B.value,Q),H(this.value,_,Q);if(B.operator==="")return _=new Ce(this.value,Q),H(B.semver,_,Q);var Ee=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),Ne=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),We=this.semver.version===B.semver.version,Ke=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Ye=ee(this.semver,"<",B.semver,Q)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),nt=ee(this.semver,">",B.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return Ee||Ne||We&&Ke||Ye||nt},e.Range=Ce,Ce.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},Ce.prototype.toString=function(){return this.range},Ce.prototype.parseRange=function(B){var Q=this.loose;B=B.trim(),I("range",B,Q);var _=Q?g[ae]:g[ke];B=B.replace(_,we),I("hyphen replace",B),B=B.replace(g[ye],"$1$2$3"),I("comparator trim",B,g[ye]),B=(B=(B=B.replace(g[O],"$1~")).replace(g[C],"$1^")).split(/\s+/).join(" ");var Ee=Q?g[se]:g[ue],Ne=B.split(" ").map(function(We){return function(Ke,Ye){return I("comp",Ke),Ke=function(nt,it){return nt.trim().split(/\s+/).map(function(et){return function(st,ct){I("caret",st,ct);var Ue=ct?g[W]:g[N];return st.replace(Ue,function(mt,Y,X,ve,Be){var Qe;return I("caret",st,mt,Y,X,ve,Be),de(Y)?Qe="":de(X)?Qe=">="+Y+".0.0 <"+(+Y+1)+".0.0":de(ve)?Qe=Y==="0"?">="+Y+"."+X+".0 <"+Y+"."+(+X+1)+".0":">="+Y+"."+X+".0 <"+(+Y+1)+".0.0":Be?(I("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=Y==="0"?X==="0"?">="+Y+"."+X+"."+ve+Be+" <"+Y+"."+X+"."+(+ve+1):">="+Y+"."+X+"."+ve+Be+" <"+Y+"."+(+X+1)+".0":">="+Y+"."+X+"."+ve+Be+" <"+(+Y+1)+".0.0"):(I("no pr"),Qe=Y==="0"?X==="0"?">="+Y+"."+X+"."+ve+" <"+Y+"."+X+"."+(+ve+1):">="+Y+"."+X+"."+ve+" <"+Y+"."+(+X+1)+".0":">="+Y+"."+X+"."+ve+" <"+(+Y+1)+".0.0"),I("caret return",Qe),Qe})}(et,it)}).join(" ")}(Ke,Ye),I("caret",Ke),Ke=function(nt,it){return nt.trim().split(/\s+/).map(function(et){return function(st,ct){var Ue=ct?g[q]:g[G];return st.replace(Ue,function(mt,Y,X,ve,Be){var Qe;return I("tilde",st,mt,Y,X,ve,Be),de(Y)?Qe="":de(X)?Qe=">="+Y+".0.0 <"+(+Y+1)+".0.0":de(ve)?Qe=">="+Y+"."+X+".0 <"+Y+"."+(+X+1)+".0":Be?(I("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=">="+Y+"."+X+"."+ve+Be+" <"+Y+"."+(+X+1)+".0"):Qe=">="+Y+"."+X+"."+ve+" <"+Y+"."+(+X+1)+".0",I("tilde return",Qe),Qe})}(et,it)}).join(" ")}(Ke,Ye),I("tildes",Ke),Ke=function(nt,it){return I("replaceXRanges",nt,it),nt.split(/\s+/).map(function(et){return function(st,ct){st=st.trim();var Ue=ct?g[m]:g[f];return st.replace(Ue,function(mt,Y,X,ve,Be,Qe){I("xRange",st,mt,Y,X,ve,Be,Qe);var tt=de(X),ot=tt||de(ve),Te=ot||de(Be);return Y==="="&&Te&&(Y=""),tt?mt=Y===">"||Y==="<"?"<0.0.0":"*":Y&&Te?(ot&&(ve=0),Te&&(Be=0),Y===">"?(Y=">=",ot?(X=+X+1,ve=0,Be=0):Te&&(ve=+ve+1,Be=0)):Y==="<="&&(Y="<",ot?X=+X+1:ve=+ve+1),mt=Y+X+"."+ve+"."+Be):ot?mt=">="+X+".0.0 <"+(+X+1)+".0.0":Te&&(mt=">="+X+"."+ve+".0 <"+X+"."+(+ve+1)+".0"),I("xRange return",mt),mt})}(et,it)}).join(" ")}(Ke,Ye),I("xrange",Ke),Ke=function(nt,it){return I("replaceStars",nt,it),nt.trim().replace(g[pe],"")}(Ke,Ye),I("stars",Ke),Ke}(We,Q)}).join(" ").split(/\s+/);return this.loose&&(Ne=Ne.filter(function(We){return!!We.match(Ee)})),Ne=Ne.map(function(We){return new le(We,Q)})},Ce.prototype.intersects=function(B,Q){if(!(B instanceof Ce))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(Ee){return B.set.some(function(Ne){return Ne.every(function(We){return Ee.intersects(We,Q)})})})})},e.toComparators=function(B,Q){return new Ce(B,Q).set.map(function(_){return _.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},Ce.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new ie(B,this.loose));for(var Q=0;Q<this.set.length;Q++)if(F(this.set[Q],B))return!0;return!1},e.satisfies=H,e.maxSatisfying=function(B,Q,_){var Ee=null,Ne=null;try{var We=new Ce(Q,_)}catch{return null}return B.forEach(function(Ke){We.test(Ke)&&(Ee&&Ne.compare(Ke)!==-1||(Ne=new ie(Ee=Ke,_)))}),Ee},e.minSatisfying=function(B,Q,_){var Ee=null,Ne=null;try{var We=new Ce(Q,_)}catch{return null}return B.forEach(function(Ke){We.test(Ke)&&(Ee&&Ne.compare(Ke)!==1||(Ne=new ie(Ee=Ke,_)))}),Ee},e.validRange=function(B,Q){try{return new Ce(B,Q).range||"*"}catch{return null}},e.ltr=function(B,Q,_){return J(B,Q,"<",_)},e.gtr=function(B,Q,_){return J(B,Q,">",_)},e.outside=J,e.prerelease=function(B,Q){var _=$e(B,Q);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(B,Q,_){return B=new Ce(B,_),Q=new Ce(Q,_),B.intersects(Q)},e.coerce=function(B){if(B instanceof ie)return B;if(typeof B!="string")return null;var Q=B.match(g[k]);return Q==null?null:$e((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,S(1))},function(me,e){var S,M,I=me.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function g(c){if(S===setTimeout)return setTimeout(c,0);if((S===R||!S)&&setTimeout)return S=setTimeout,setTimeout(c,0);try{return S(c,0)}catch{try{return S.call(null,c,0)}catch{return S.call(this,c,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:R}catch{S=R}try{M=typeof clearTimeout=="function"?clearTimeout:L}catch{M=L}})();var h,E=[],A=!1,D=-1;function l(){A&&h&&(A=!1,h.length?E=h.concat(E):D=-1,E.length&&p())}function p(){if(!A){var c=g(l);A=!0;for(var r=E.length;r;){for(h=E,E=[];++D<r;)h&&h[D].run();D=-1,r=E.length}h=null,A=!1,function(t){if(M===clearTimeout)return clearTimeout(t);if((M===L||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(t);try{M(t)}catch{try{return M.call(null,t)}catch{return M.call(this,t)}}}(c)}}function $(c,r){this.fun=c,this.array=r}function n(){}I.nextTick=function(c){var r=new Array(arguments.length-1);if(arguments.length>1)for(var t=1;t<arguments.length;t++)r[t-1]=arguments[t];E.push(new $(c,r)),E.length!==1||A||g(p)},$.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=n,I.addListener=n,I.once=n,I.off=n,I.removeListener=n,I.removeAllListeners=n,I.emit=n,I.prependListener=n,I.prependOnceListener=n,I.listeners=function(c){return[]},I.binding=function(c){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(c){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Re[123],Ae([1,0,15,6]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function I(a){const u=a;return u?typeof u.read=="function":!1}e.$8d=I;function R(a){const u=a;return u?[u.on,u.pause,u.resume,u.destroy].every(i=>typeof i=="function"):!1}e.$9d=R;function L(a){const u=a;return u?R(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.$0d=L;function g(a,u){return new h(a,u)}e.$$d=g;class h{constructor(u,i){this.e=u,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(i=>i(u))}h(u){this.c.error.length===0?(0,S.$1)(u):this.c.error.slice(0).forEach(i=>i(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,i){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(u,i){if(this.a.destroyed)return;let v;switch(u){case"data":v=this.c.data;break;case"end":v=this.c.end;break;case"error":v=this.c.error;break}if(v){const o=v.indexOf(i);o>=0&&v.splice(o,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(v=>v())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(a,u){const i=[];let v;for(;(v=a.read())!==null;)i.push(v);return u(i)}e.$_d=E;function A(a,u,i){const v=[];let o;for(;(o=a.read())!==null&&v.length<i;)v.push(o);return o===null&&v.length>0?u(v):{read:()=>{if(v.length>0)return v.shift();if(typeof o<"u"){const w=o;return o=void 0,w}return a.read()}}}e.$ae=A;function D(a,u){return new Promise((i,v)=>{const o=[];l(a,{onData:w=>{u&&o.push(w)},onError:w=>{u?v(w):i(void 0)},onEnd:()=>{i(u?u(o):void 0)}})})}e.$be=D;function l(a,u,i){a.on("error",v=>{i?.isCancellationRequested||u.onError(v)}),a.on("end",()=>{i?.isCancellationRequested||u.onEnd()}),a.on("data",v=>{i?.isCancellationRequested||u.onData(v)})}e.$ce=l;function p(a,u){return new Promise((i,v)=>{const o=new M.$Sc,w=[],y=P=>{if(w.push(P),w.length>u)return o.dispose(),a.pause(),i({stream:a,buffer:w,ended:!1})},d=P=>(o.dispose(),v(P)),b=()=>(o.dispose(),i({stream:a,buffer:w,ended:!0}));o.add((0,M.$Rc)(()=>a.removeListener("error",d))),a.on("error",d),o.add((0,M.$Rc)(()=>a.removeListener("end",b))),a.on("end",b),o.add((0,M.$Rc)(()=>a.removeListener("data",y))),a.on("data",y)})}e.$de=p;function $(a,u){const i=g(u);return i.end(a),i}e.$ee=$;function n(){const a=g(()=>{throw new Error("not supported")});return a.end(),a}e.$fe=n;function c(a){let u=!1;return{read:()=>u?null:(u=!0,a)}}e.$ge=c;function r(a,u,i){const v=g(i);return l(a,{onData:o=>v.write(u.data(o)),onError:o=>v.error(u.error?u.error(o):o),onEnd:()=>v.end()}),v}e.$he=r;function t(a,u,i){let v=!1;return{read:()=>{const o=u.read();return v?o:(v=!0,o!==null?i([a,o]):a)}}}e.$ie=t;function s(a,u,i){let v=!1;const o=g(i);return l(u,{onData:w=>v?o.write(w):(v=!0,o.write(i([a,w]))),onError:w=>o.error(w),onEnd:()=>{v||(v=!0,o.write(a)),o.end()}}),o}e.$je=s}),define(Re[23],Ae([1,0,39,123]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const I=typeof Buffer<"u",R=new S.$V(()=>new Uint8Array(256));let L,g;class h{static alloc(k){return I?new h(Buffer.allocUnsafe(k)):new h(new Uint8Array(k))}static wrap(k){return I&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new h(k)}static fromString(k,T){return!(T?.dontUseNodeBuffer||!1)&&I?new h(Buffer.from(k)):(L||(L=new TextEncoder),new h(L.encode(k)))}static fromByteArray(k){const T=h.alloc(k.length);for(let O=0,G=k.length;O<G;O++)T.buffer[O]=k[O];return T}static concat(k,T){if(typeof T>"u"){T=0;for(let q=0,j=k.length;q<j;q++)T+=k[q].byteLength}const O=h.alloc(T);let G=0;for(let q=0,j=k.length;q<j;q++){const C=k[q];O.set(C,G),G+=C.byteLength}return O}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=h.alloc(this.byteLength);return k.set(this),k}toString(){return I?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(k,T){return new h(this.buffer.subarray(k,T))}set(k,T){if(k instanceof h)this.buffer.set(k.buffer,T);else if(k instanceof Uint8Array)this.buffer.set(k,T);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),T);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return l(this.buffer,k)}writeUInt32BE(k,T){p(this.buffer,k,T)}readUInt32LE(k){return $(this.buffer,k)}writeUInt32LE(k,T){n(this.buffer,k,T)}readUInt8(k){return c(this.buffer,k)}writeUInt8(k,T){r(this.buffer,k,T)}indexOf(k,T=0){return E(this.buffer,k instanceof h?k.buffer:k,T)}}e.$ke=h;function E(m,k,T=0){const O=k.byteLength,G=m.byteLength;if(O===0)return 0;if(O===1)return m.indexOf(k[0]);if(O>G-T)return-1;const q=R.value;q.fill(k.length);for(let W=0;W<k.length;W++)q[k[W]]=k.length-W-1;let j=T+k.length-1,C=j,N=-1;for(;j<G;)if(m[j]===k[C]){if(C===0){N=j;break}j--,C--}else j+=Math.max(k.length-C,q[m[j]]),C=k.length-1;return N}e.$le=E;function A(m,k){return m[k+0]<<0>>>0|m[k+1]<<8>>>0}e.$me=A;function D(m,k,T){m[T+0]=k&255,k=k>>>8,m[T+1]=k&255}e.$ne=D;function l(m,k){return m[k]*2**24+m[k+1]*2**16+m[k+2]*2**8+m[k+3]}e.$oe=l;function p(m,k,T){m[T+3]=k,k=k>>>8,m[T+2]=k,k=k>>>8,m[T+1]=k,k=k>>>8,m[T]=k}e.$pe=p;function $(m,k){return m[k+0]<<0>>>0|m[k+1]<<8>>>0|m[k+2]<<16>>>0|m[k+3]<<24>>>0}e.$qe=$;function n(m,k,T){m[T+0]=k&255,k=k>>>8,m[T+1]=k&255,k=k>>>8,m[T+2]=k&255,k=k>>>8,m[T+3]=k&255}e.$re=n;function c(m,k){return m[k]}e.$se=c;function r(m,k,T){m[T]=k}e.$te=r;function t(m){return M.$_d(m,k=>h.concat(k))}e.$ue=t;function s(m){return M.$ge(m)}e.$ve=s;function a(m){return M.$be(m,k=>h.concat(k))}e.$we=a;async function u(m){return m.ended?h.concat(m.buffer):h.concat([...m.buffer,await a(m.stream)])}e.$xe=u;function i(m){return M.$ee(m,k=>h.concat(k))}e.$ye=i;function v(m){return M.$he(m,{data:k=>typeof k=="string"?h.fromString(k):h.wrap(k)},k=>h.concat(k))}e.$ze=v;function o(m){return M.$$d(k=>h.concat(k),m)}e.$Ae=o;function w(m,k){return M.$ie(m,k,T=>h.concat(T))}e.$Be=w;function y(m,k){return M.$je(m,k,T=>h.concat(T))}e.$Ce=y;function d(m){let k=0,T=0,O=0;const G=new Uint8Array(Math.floor(m.length/4*3)),q=C=>{switch(T){case 3:G[O++]=k|C,T=0;break;case 2:G[O++]=k|C>>>2,k=C<<6,T=3;break;case 1:G[O++]=k|C>>>4,k=C<<4,T=2;break;default:k=C<<2,T=1}};for(let C=0;C<m.length;C++){const N=m.charCodeAt(C);if(N>=65&&N<=90)q(N-65);else if(N>=97&&N<=122)q(N-97+26);else if(N>=48&&N<=57)q(N-48+52);else if(N===43||N===45)q(62);else if(N===47||N===95)q(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${m[C]}`)}}const j=O;for(;T>0;)q(0);return h.wrap(G).slice(0,j)}e.$De=d;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:m},k=!0,T=!1){const O=T?P:b;let G="";const q=m.byteLength%3;let j=0;for(;j<m.byteLength-q;j+=3){const C=m[j+0],N=m[j+1],W=m[j+2];G+=O[C>>>2],G+=O[(C<<4|N>>>4)&63],G+=O[(N<<2|W>>>6)&63],G+=O[W&63]}if(q===1){const C=m[j+0];G+=O[C>>>2],G+=O[C<<4&63],k&&(G+="==")}else if(q===2){const C=m[j+0],N=m[j+1];G+=O[C>>>2],G+=O[(C<<4|N>>>4)&63],G+=O[N<<2&63],k&&(G+="=")}return G}e.$Ee=f}),define(Re[124],Ae([1,0,28,121,13]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=e.$9j=e.$8j=e.FuzzyScore=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.or=void 0;function R(...de){return function(we,F){for(let H=0,J=de.length;H<J;H++){const B=de[H](we,F);if(B)return B}return null}}e.or=R,e.$Vj=L.bind(void 0,!1),e.$Wj=L.bind(void 0,!0);function L(de,we,F){if(!F||F.length<we.length)return null;let H;return de?H=I.$bf(F,we):H=F.indexOf(we)===0,H?we.length>0?[{start:0,end:we.length}]:[]:null}function g(de,we){const F=we.toLowerCase().indexOf(de.toLowerCase());return F===-1?null:[{start:F,end:F+de.length}]}e.$Xj=g;function h(de,we){return E(de.toLowerCase(),we.toLowerCase(),0,0)}e.$Yj=h;function E(de,we,F,H){if(F===de.length)return[];if(H===we.length)return null;if(de[F]===we[H]){let J=null;return(J=E(de,we,F+1,H+1))?a({start:H,end:H+1},J):null}return E(de,we,F,H+1)}function A(de){return 97<=de&&de<=122}function D(de){return 65<=de&&de<=90}e.$Zj=D;function l(de){return 48<=de&&de<=57}function p(de){return de===32||de===9||de===10||de===13}const $=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>$.add(de.charCodeAt(0)));function n(de){return p(de)||$.has(de)}function c(de,we){return de===we||n(de)&&n(we)}const r=new Map;function t(de){if(r.has(de))return r.get(de);let we;const F=(0,M.$Tj)(de);return F&&(we=F),r.set(de,we),we}function s(de){return A(de)||D(de)||l(de)}function a(de,we){return we.length===0?we=[de]:de.end===we[0].start?we[0].start=de.start:we.unshift(de),we}function u(de,we){for(let F=we;F<de.length;F++){const H=de.charCodeAt(F);if(D(H)||l(H)||F>0&&!s(de.charCodeAt(F-1)))return F}return de.length}function i(de,we,F,H){if(F===de.length)return[];if(H===we.length)return null;if(de[F]!==we[H].toLowerCase())return null;{let J=null,B=H+1;for(J=i(de,we,F+1,H+1);!J&&(B=u(we,B))<we.length;)J=i(de,we,F+1,B),B++;return J===null?null:a({start:H,end:H+1},J)}}function v(de){let we=0,F=0,H=0,J=0,B=0;for(let We=0;We<de.length;We++)B=de.charCodeAt(We),D(B)&&we++,A(B)&&F++,s(B)&&H++,l(B)&&J++;const Q=we/de.length,_=F/de.length,Ee=H/de.length,Ne=J/de.length;return{upperPercent:Q,lowerPercent:_,alphaPercent:Ee,numericPercent:Ne}}function o(de){const{upperPercent:we,lowerPercent:F}=de;return F===0&&we>.6}function w(de){const{upperPercent:we,lowerPercent:F,alphaPercent:H,numericPercent:J}=de;return F>.2&&we<.8&&H>.6&&J<.2}function y(de){let we=0,F=0,H=0,J=0;for(let B=0;B<de.length;B++)H=de.charCodeAt(B),D(H)&&we++,A(H)&&F++,p(H)&&J++;return(we===0||F===0)&&J===0?de.length<=30:we<=5}function d(de,we){if(!we||(we=we.trim(),we.length===0)||!y(de)||we.length>60)return null;const F=v(we);if(!w(F)){if(!o(F))return null;we=we.toLowerCase()}let H=null,J=0;for(de=de.toLowerCase();J<we.length&&(H=i(de,we,0,J))===null;)J=u(we,J+1);return H}e.$1j=d;function b(de,we,F=!1){if(!we||we.length===0)return null;let H=null,J=0;for(de=de.toLowerCase(),we=we.toLowerCase();J<we.length&&(H=P(de,we,0,J,F),H===null);)J=f(we,J+1);return H}e.$2j=b;function P(de,we,F,H,J){let B=0;if(F===de.length)return[];if(H===we.length)return null;if(!c(de.charCodeAt(F),we.charCodeAt(H))){const Ee=t(de.charCodeAt(F));if(!Ee)return null;for(let Ne=0;Ne<Ee.length;Ne++)if(!c(Ee[Ne],we.charCodeAt(H+Ne)))return null;B+=Ee.length-1}let Q=null,_=H+B+1;if(Q=P(de,we,F+1,_,J),!J)for(;!Q&&(_=f(we,_))<we.length;)Q=P(de,we,F+1,_,J),_++;if(!Q)return null;if(de.charCodeAt(F)!==we.charCodeAt(H)){const Ee=t(de.charCodeAt(F));if(!Ee)return Q;for(let Ne=0;Ne<Ee.length;Ne++)if(Ee[Ne]!==we.charCodeAt(H+Ne))return Q}return a({start:H,end:H+B+1},Q)}function f(de,we){for(let F=we;F<de.length;F++)if(n(de.charCodeAt(F))||F>0&&n(de.charCodeAt(F-1)))return F;return de.length}const m=R(e.$Wj,d,g),k=R(e.$Wj,d,h),T=new S.$Dc(1e4);function O(de,we,F=!1){if(typeof de!="string"||typeof we!="string")return null;let H=T.get(de);H||(H=new RegExp(I.$We(de),"i"),T.set(de,H));const J=H.exec(we);return J?[{start:J.index,end:J.index+J[0].length}]:F?k(de,we):m(de,we)}e.$3j=O;function G(de,we){const F=be(de,de.toLowerCase(),0,we,we.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?j(F):null}e.$4j=G;function q(de,we,F,H,J,B){const Q=Math.min(13,de.length);for(;F<Q;F++){const _=be(de,we,F,H,J,B,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(_)return _}return[0,B]}e.$5j=q;function j(de){if(typeof de>"u")return[];const we=[],F=de[1];for(let H=de.length-1;H>1;H--){const J=de[H]+F,B=we[we.length-1];B&&B.end===J?B.end=J+1:we.push({start:J,end:J+1})}return we}e.$6j=j;const C=128;function N(){const de=[],we=[];for(let F=0;F<=C;F++)we[F]=0;for(let F=0;F<=C;F++)de.push(we.slice(0));return de}function W(de){const we=[];for(let F=0;F<=de;F++)we[F]=0;return we}const se=W(2*C),ue=W(2*C),ye=N(),ke=N(),ae=N(),pe=!1;function oe(de,we,F,H,J){function B(_,Ee,Ne=" "){for(;_.length<Ee;)_=Ne+_;return _}let Q=` |   |${H.split("").map(_=>B(_,3)).join("|")}
`;for(let _=0;_<=F;_++)_===0?Q+=" |":Q+=`${we[_-1]}|`,Q+=de[_].slice(0,J+1).map(Ee=>B(Ee.toString(),3)).join("|")+`
`;return Q}function $e(de,we,F,H){de=de.substr(we),F=F.substr(H),console.log(oe(ke,de,de.length,F,F.length)),console.log(oe(ae,de,de.length,F,F.length)),console.log(oe(ye,de,de.length,F,F.length))}function ie(de,we){if(we<0||we>=de.length)return!1;const F=de.codePointAt(we);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$tf(F)}}function x(de,we){if(we<0||we>=de.length)return!1;switch(de.charCodeAt(we)){case 32:case 9:return!0;default:return!1}}function V(de,we,F){return we[de]!==F[de]}function ne(de,we,F,H,J,B,Q=!1){for(;we<F&&J<B;)de[we]===H[J]&&(Q&&(se[we]=J),we+=1),J+=1;return we===F}e.$7j=ne;var Ie;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Me;(function(de){de.Default=[-100,0];function we(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}de.isDefault=we})(Me||(e.FuzzyScore=Me={}));class Le{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(we,F){this.firstMatchCanBeWeak=we,this.boostFullMatch=F}}e.$8j=Le;function be(de,we,F,H,J,B,Q=Le.default){const _=de.length>C?C:de.length,Ee=H.length>C?C:H.length;if(F>=_||B>=Ee||_-F>Ee-B||!ne(we,F,_,J,B,Ee,!0))return;ge(_,Ee,F,B,we,J);let Ne=1,We=1,Ke=F,Ye=B;const nt=[!1];for(Ne=1,Ke=F;Ke<_;Ne++,Ke++){const Ue=se[Ke],mt=ue[Ke],Y=Ke+1<_?ue[Ke+1]:Ee;for(We=Ue-B+1,Ye=Ue;Ye<Y;We++,Ye++){let X=Number.MIN_SAFE_INTEGER,ve=!1;Ye<=mt&&(X=K(de,we,Ke,F,H,J,Ye,Ee,B,ye[Ne-1][We-1]===0,nt));let Be=0;X!==Number.MAX_SAFE_INTEGER&&(ve=!0,Be=X+ke[Ne-1][We-1]);const Qe=Ye>Ue,tt=Qe?ke[Ne][We-1]+(ye[Ne][We-1]>0?-5:0):0,ot=Ye>Ue+1&&ye[Ne][We-1]>0,Te=ot?ke[Ne][We-2]+(ye[Ne][We-2]>0?-5:0):0;if(ot&&(!Qe||Te>=tt)&&(!ve||Te>=Be))ke[Ne][We]=Te,ae[Ne][We]=3,ye[Ne][We]=0;else if(Qe&&(!ve||tt>=Be))ke[Ne][We]=tt,ae[Ne][We]=2,ye[Ne][We]=0;else if(ve)ke[Ne][We]=Be,ae[Ne][We]=1,ye[Ne][We]=ye[Ne-1][We-1]+1;else throw new Error("not possible")}}if(pe&&$e(de,F,H,B),!nt[0]&&!Q.firstMatchCanBeWeak)return;Ne--,We--;const it=[ke[Ne][We],B];let et=0,st=0;for(;Ne>=1;){let Ue=We;do{const mt=ae[Ne][Ue];if(mt===3)Ue=Ue-2;else if(mt===2)Ue=Ue-1;else break}while(Ue>=1);et>1&&we[F+Ne-1]===J[B+We-1]&&!V(Ue+B-1,H,J)&&et+1>ye[Ne][Ue]&&(Ue=We),Ue===We?et++:et=1,st||(st=Ue),Ne--,We=Ue-1,it.push(We)}Ee===_&&Q.boostFullMatch&&(it[0]+=2);const ct=st-_;return it[0]-=ct,it}e.$9j=be;function ge(de,we,F,H,J,B){let Q=de-1,_=we-1;for(;Q>=F&&_>=H;)J[Q]===B[_]&&(ue[Q]=_,Q--),_--}function K(de,we,F,H,J,B,Q,_,Ee,Ne,We){if(we[F]!==B[Q])return Number.MIN_SAFE_INTEGER;let Ke=1,Ye=!1;return Q===F-H?Ke=de[F]===J[Q]?7:5:V(Q,J,B)&&(Q===0||!V(Q-1,J,B))?(Ke=de[F]===J[Q]?7:5,Ye=!0):ie(B,Q)&&(Q===0||!ie(B,Q-1))?Ke=5:(ie(B,Q-1)||x(B,Q-1))&&(Ke=5,Ye=!0),Ke>1&&F===H&&(We[0]=!0),Ye||(Ye=V(Q,J,B)||ie(B,Q-1)||x(B,Q-1)),F===H?Q>Ee&&(Ke-=Ye?3:5):Ne?Ke+=Ye?2:0:Ke+=Ye?0:1,Q+1===_&&(Ke-=Ye?3:5),Ke}function ee(de,we,F,H,J,B,Q){return fe(de,we,F,H,J,B,!0,Q)}e.$0j=ee;function le(de,we,F,H,J,B,Q){return fe(de,we,F,H,J,B,!1,Q)}e.$$j=le;function fe(de,we,F,H,J,B,Q,_){let Ee=be(de,we,F,H,J,B,_);if(Ee&&!Q)return Ee;if(de.length>=3){const Ne=Math.min(7,de.length-1);for(let We=F+1;We<Ne;We++){const Ke=Ce(de,We);if(Ke){const Ye=be(Ke,Ke.toLowerCase(),F,H,J,B,_);Ye&&(Ye[0]-=3,(!Ee||Ye[0]>Ee[0])&&(Ee=Ye))}}}return Ee}function Ce(de,we){if(we+1>=de.length)return;const F=de[we],H=de[we+1];if(F!==H)return de.slice(0,we)+H+F+de.slice(we+2)}}),define(Re[32],Ae([1,0,13]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(M||(M={})),function(I){const R="error",L="warning",g="warn",h="info",E="ignore";function A(l){return l?S.$af(R,l)?I.Error:S.$af(L,l)||S.$af(g,l)?I.Warning:S.$af(h,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function D(l){switch(l){case I.Error:return R;case I.Warning:return L;case I.Info:return h;default:return E}}I.toString=D}(M||(M={})),e.default=M}),define(Re[125],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(Re[50],Ae([1,0,18,13]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0;class I{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const $=p.charCodeAt(0),n=this.b.charCodeAt(this.c);return $-n}value(){return this.b[this.c]}}e.$0h=I;class R{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,M.$7e)(p,this.b,0,p.length,this.c,this.d):(0,M.$9e)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$$h=R;class L{constructor(p=!0,$=!0){this.f=p,this.g=$}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let $=p.length-1;$>=0;$--,this.c--){const n=this.b.charCodeAt($);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,M.$7e)(p,this.b,0,p.length,this.d,this.e):(0,M.$9e)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$_h=L;var g;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(g||(g={}));class h{constructor(p,$){this.f=p,this.g=$,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,M.$8e)(p,this.c.scheme);if(this.d[this.e]===2)return(0,M.$8e)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,M.$6e)(p,this.c.query);if(this.d[this.e]===5)return(0,M.$6e)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ai=h;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(A||(A={}));class D{static forUris(p=()=>!1,$=()=>!1){return new D(new h(p,$))}static forPaths(p=!1){return new D(new L(void 0,!p))}static forStrings(){return new D(new I)}static forConfigKeys(){return new D(new R)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,$){if($){const n=$.slice(0);(0,S.$Xb)(n);for(const c of n)this.set(c,p)}else{const n=p.slice(0);(0,S.$Xb)(n);for(const c of n)this.set(c[0],c[1])}}set(p,$){const n=this.b.reset(p);let c;this.c||(this.c=new E,this.c.segment=n.value());const r=[];for(c=this.c;;){const s=n.cmp(c.segment);if(s>0)c.left||(c.left=new E,c.left.segment=n.value()),r.push([-1,c]),c=c.left;else if(s<0)c.right||(c.right=new E,c.right.segment=n.value()),r.push([1,c]),c=c.right;else if(n.hasNext())n.next(),c.mid||(c.mid=new E,c.mid.segment=n.value()),r.push([0,c]),c=c.mid;else break}const t=c.value;c.value=$,c.key=p;for(let s=r.length-1;s>=0;s--){const a=r[s][1];a.updateHeight();const u=a.balanceFactor();if(u<-1||u>1){const i=r[s][0],v=r[s+1][0];if(i===1&&v===1)r[s][1]=a.rotateLeft();else if(i===-1&&v===-1)r[s][1]=a.rotateRight();else if(i===1&&v===-1)a.right=r[s+1][1]=r[s+1][1].rotateRight(),r[s][1]=a.rotateLeft();else if(i===-1&&v===1)a.left=r[s+1][1]=r[s+1][1].rotateLeft(),r[s][1]=a.rotateRight();else throw new Error;if(s>0)switch(r[s-1][0]){case-1:r[s-1][1].left=r[s][1];break;case 1:r[s-1][1].right=r[s][1];break;case 0:r[s-1][1].mid=r[s][1];break}else this.c=r[0][1]}}return t}get(p){return this.d(p)?.value}d(p){const $=this.b.reset(p);let n=this.c;for(;n;){const c=$.cmp(n.segment);if(c>0)n=n.left;else if(c<0)n=n.right;else if($.hasNext())$.next(),n=n.mid;else break}return n}has(p){const $=this.d(p);return!($?.value===void 0&&$?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,$){const n=this.b.reset(p),c=[];let r=this.c;for(;r;){const t=n.cmp(r.segment);if(t>0)c.push([-1,r]),r=r.left;else if(t<0)c.push([1,r]),r=r.right;else if(n.hasNext())n.next(),c.push([0,r]),r=r.mid;else break}if(r){if($?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const t=this.f(r.right);if(t.key){const{key:s,value:a,segment:u}=t;this.e(t.key,!1),r.key=s,r.value=a,r.segment=u}}else{const t=r.left??r.right;if(c.length>0){const[s,a]=c[c.length-1];switch(s){case-1:a.left=t;break;case 0:a.mid=t;break;case 1:a.right=t;break}}else this.c=t}for(let t=c.length-1;t>=0;t--){const s=c[t][1];s.updateHeight();const a=s.balanceFactor();if(a>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),c[t][1]=s.rotateLeft()):a<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),c[t][1]=s.rotateRight()),t>0)switch(c[t-1][0]){case-1:c[t-1][1].left=c[t][1];break;case 1:c[t-1][1].right=c[t][1];break;case 0:c[t-1][1].mid=c[t][1];break}else this.c=c[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const $=this.b.reset(p);let n=this.c,c;for(;n;){const r=$.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if($.hasNext())$.next(),c=n.value||c,n=n.mid;else break}return n&&n.value||c}findSuperstr(p){return this.g(p,!1)}g(p,$){const n=this.b.reset(p);let c=this.c;for(;c;){const r=n.cmp(c.segment);if(r>0)c=c.left;else if(r<0)c=c.right;else if(n.hasNext())n.next(),c=c.mid;else return c.mid?this.h(c.mid):$?c.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[$,n]of this)p(n,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const $=[];return this.j(p,$),$[Symbol.iterator]()}j(p,$){p&&(p.left&&this.j(p.left,$),p.value&&$.push([p.key,p.value]),p.mid&&this.j(p.mid,$),p.right&&this.j(p.right,$))}_isBalanced(){const p=$=>{if(!$)return!0;const n=$.balanceFactor();return n<-1||n>1?!1:p($.left)&&p($.right)};return p(this.c)}}e.$bi=D}),define(Re[40],Ae([1,0,90]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ck=e.ThemeColor=void 0;var M;(function(L){function g(h){return h&&typeof h=="object"&&typeof h.id=="string"}L.isThemeColor=g})(M||(e.ThemeColor=M={}));function I(L){return{id:L}}e.$ck=I;var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const g=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function h(t){const s=g.exec(t.id);if(!s)return h(S.$bk.error);const[,a,u]=s,i=["codicon","codicon-"+a];return u&&i.push("codicon-modifier-"+u.substring(1)),i}L.asClassNameArray=h;function E(t){return h(t).join(" ")}L.asClassName=E;function A(t){return"."+h(t).join(".")}L.asCSSSelector=A;function D(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color>"u"||M.isThemeColor(t.color))}L.isThemeIcon=D;const l=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function p(t){const s=l.exec(t);if(!s)return;const[,a]=s;return{id:a}}L.fromString=p;function $(t){return{id:t}}L.fromId=$;function n(t,s){let a=t.id;const u=a.lastIndexOf("~");return u!==-1&&(a=a.substring(0,u)),s&&(a=`${a}~${s}`),{id:a}}L.modify=n;function c(t){const s=t.id.lastIndexOf("~");if(s!==-1)return t.id.substring(s+1)}L.getModifier=c;function r(t,s){return t.id===s.id&&t.color?.id===s.color?.id}L.isEqual=r})(R||(e.ThemeIcon=R={}))}),define(Re[126],Ae([1,0,124,13,40]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=void 0;const R="$(",L=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),g=new RegExp(`(\\\\)?${L.source}`,"g");function h(r){return r.replace(g,(t,s)=>s?t:`\\${t}`)}e.$dk=h;const E=new RegExp(`\\\\${L.source}`,"g");function A(r){return r.replace(E,t=>`\\${t}`)}e.$ek=A;const D=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function l(r){return r.indexOf(R)===-1?r:r.replace(D,(t,s,a,u)=>a?t:s||u||"")}e.$fk=l;function p(r){return r?r.replace(/\$\((.*?)\)/g,(t,s)=>` ${s} `).trim():""}e.$gk=p;const $=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(r){$.lastIndex=0;let t="";const s=[];let a=0;for(;;){const u=$.lastIndex,i=$.exec(r),v=r.substring(u,i?.index);if(v.length>0){t+=v;for(let o=0;o<v.length;o++)s.push(a)}if(!i)break;a+=i[0].length}return{text:t,iconOffsets:s}}e.$hk=n;function c(r,t,s=!1){const{text:a,iconOffsets:u}=t;if(!u||u.length===0)return(0,S.$3j)(r,a,s);const i=(0,M.$Ue)(a," "),v=a.length-i.length,o=(0,S.$3j)(r,i,s);if(o)for(const w of o){const y=u[w.start+v]+v;w.start+=y,w.end+=y}return o}e.$ik=c}),define(Re[33],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(I){return S.test(I)}e.$qg=M,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(g){for(let h=0;h<g.length;h++)g[h]=Math.floor(Math.random()*256);return g};const R=new Uint8Array(16),L=[];for(let g=0;g<256;g++)L.push(g.toString(16).padStart(2,"0"));return function(){I(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let h=0,E="";return E+=L[R[h++]],E+=L[R[h++]],E+=L[R[h++]],E+=L[R[h++]],E+="-",E+=L[R[h++]],E+=L[R[h++]],E+="-",E+=L[R[h++]],E+=L[R[h++]],E+="-",E+=L[R[h++]],E+=L[R[h++]],E+="-",E+=L[R[h++]],E+=L[R[h++]],E+=L[R[h++]],E+=L[R[h++]],E+=L[R[h++]],E+=L[R[h++]],E}}()}),define(Re[127],Ae([1,0,18,68,33]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=e.$rt=e.$qt=e.$pt=void 0;function R(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$pt=R;function L(D,l,p){const $={id:(0,I.$rg)(),name:D,uri:l,data:p};return{asString:async()=>"",asFile:()=>$,value:void 0}}e.$qt=L;class g{constructor(){this.a=new Map}get size(){let l=0;for(const p of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const p=[...this.a.keys()];return M.Iterable.some(this,([$,n])=>n.asFile())&&p.push("files"),A(h(l),p)}get(l){return this.a.get(this.b(l))?.[0]}append(l,p){const $=this.a.get(l);$?$.push(p):this.a.set(this.b(l),[p])}replace(l,p){this.a.set(this.b(l),[p])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,p]of this.a)for(const $ of p)yield[l,$]}b(l){return h(l)}}e.$rt=g;function h(D){return D.toLowerCase()}function E(D,l){return A(h(D),l.map(h))}e.$st=E;function A(D,l){if(D==="*/*")return l.length>0;if(l.includes(D))return!0;const p=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[$,n,c]=p;return c==="*"?l.some(r=>r.startsWith(n+"/")):!1}e.$tt=Object.freeze({create:D=>(0,S.$Mb)(D.map(l=>l.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$tt.split(D).filter(l=>!l.startsWith("#"))})}),define(Re[128],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.StringEOL=void 0;var S;(function(I){I[I.Unknown=0]="Unknown",I[I.Invalid=3]="Invalid",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function M(I){let R=0,L=0,g=0,h=0;for(let E=0,A=I.length;E<A;E++){const D=I.charCodeAt(E);D===13?(R===0&&(L=E),R++,E+1<A&&I.charCodeAt(E+1)===10?(h|=2,E++):h|=3,g=E+1):D===10&&(h|=1,R===0&&(L=E),R++,g=E+1)}return R===0&&(L=I.length),[R,L,I.length-g,h]}e.$wt=M}),define(Re[129],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0,e.$us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[130],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$Tt=e.IndentAction=void 0;var S;(function(L){L[L.None=0]="None",L[L.Indent=1]="Indent",L[L.IndentOutdent=2]="IndentOutdent",L[L.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class M{constructor(g){if(this.e=null,this.f=!1,this.open=g.open,this.close=g.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(g.notIn))for(let h=0,E=g.notIn.length;h<E;h++)switch(g.notIn[h]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(g){switch(g){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(g,h){if(g.getTokenCount()===0)return!0;const E=g.findTokenIndexAtOffset(h-2),A=g.getStandardTokenType(E);return this.isOK(A)}g(g,h){for(let E=g;E<=h;E++){const A=String.fromCharCode(E);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Tt=M;class I{constructor(g){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const h of g)R(this.autoClosingPairsOpenByStart,h.open.charAt(0),h),R(this.autoClosingPairsOpenByEnd,h.open.charAt(h.open.length-1),h),R(this.autoClosingPairsCloseByStart,h.close.charAt(0),h),R(this.autoClosingPairsCloseByEnd,h.close.charAt(h.close.length-1),h),h.close.length===1&&h.open.length===1&&R(this.autoClosingPairsCloseSingleChar,h.close,h)}}e.$Ut=I;function R(L,g,h){L.has(g)?L.get(g).push(h):L.set(g,[h])}}),define(Re[131],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4B=e.$3B=e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.NodeColor=e.$UB=void 0;class S{constructor(c,r){this.piece=c,this.color=r,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$VB)return I(this.right);let c=this;for(;c.parent!==e.$VB&&c.parent.left!==c;)c=c.parent;return c.parent===e.$VB?e.$VB:c.parent}prev(){if(this.left!==e.$VB)return R(this.left);let c=this;for(;c.parent!==e.$VB&&c.parent.right!==c;)c=c.parent;return c.parent===e.$VB?e.$VB:c.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$UB=S;var M;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(M||(e.NodeColor=M={})),e.$VB=new S(null,0),e.$VB.parent=e.$VB,e.$VB.left=e.$VB,e.$VB.right=e.$VB,e.$VB.color=0;function I(n){for(;n.left!==e.$VB;)n=n.left;return n}e.$WB=I;function R(n){for(;n.right!==e.$VB;)n=n.right;return n}e.$XB=R;function L(n){return n===e.$VB?0:n.size_left+n.piece.length+L(n.right)}function g(n){return n===e.$VB?0:n.lf_left+n.piece.lineFeedCnt+g(n.right)}function h(){e.$VB.parent=e.$VB}function E(n,c){const r=c.right;r.size_left+=c.size_left+(c.piece?c.piece.length:0),r.lf_left+=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),c.right=r.left,r.left!==e.$VB&&(r.left.parent=c),r.parent=c.parent,c.parent===e.$VB?n.root=r:c.parent.left===c?c.parent.left=r:c.parent.right=r,r.left=c,c.parent=r}e.$YB=E;function A(n,c){const r=c.left;c.left=r.right,r.right!==e.$VB&&(r.right.parent=c),r.parent=c.parent,c.size_left-=r.size_left+(r.piece?r.piece.length:0),c.lf_left-=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),c.parent===e.$VB?n.root=r:c===c.parent.right?c.parent.right=r:c.parent.left=r,r.right=c,c.parent=r}e.$ZB=A;function D(n,c){let r,t;if(c.left===e.$VB?(t=c,r=t.right):c.right===e.$VB?(t=c,r=t.left):(t=I(c.right),r=t.right),t===n.root){n.root=r,r.color=0,c.detach(),h(),n.root.parent=e.$VB;return}const s=t.color===1;if(t===t.parent.left?t.parent.left=r:t.parent.right=r,t===c?(r.parent=t.parent,$(n,r)):(t.parent===c?r.parent=t:r.parent=t.parent,$(n,r),t.left=c.left,t.right=c.right,t.parent=c.parent,t.color=c.color,c===n.root?n.root=t:c===c.parent.left?c.parent.left=t:c.parent.right=t,t.left!==e.$VB&&(t.left.parent=t),t.right!==e.$VB&&(t.right.parent=t),t.size_left=c.size_left,t.lf_left=c.lf_left,$(n,t)),c.detach(),r.parent.left===r){const u=L(r),i=g(r);if(u!==r.parent.size_left||i!==r.parent.lf_left){const v=u-r.parent.size_left,o=i-r.parent.lf_left;r.parent.size_left=u,r.parent.lf_left=i,p(n,r.parent,v,o)}}if($(n,r.parent),s){h();return}let a;for(;r!==n.root&&r.color===0;)r===r.parent.left?(a=r.parent.right,a.color===1&&(a.color=0,r.parent.color=1,E(n,r.parent),a=r.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,r=r.parent):(a.right.color===0&&(a.left.color=0,a.color=1,A(n,a),a=r.parent.right),a.color=r.parent.color,r.parent.color=0,a.right.color=0,E(n,r.parent),r=n.root)):(a=r.parent.left,a.color===1&&(a.color=0,r.parent.color=1,A(n,r.parent),a=r.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,r=r.parent):(a.left.color===0&&(a.right.color=0,a.color=1,E(n,a),a=r.parent.left),a.color=r.parent.color,r.parent.color=0,a.left.color=0,A(n,r.parent),r=n.root));r.color=0,h()}e.$1B=D;function l(n,c){for($(n,c);c!==n.root&&c.parent.color===1;)if(c.parent===c.parent.parent.left){const r=c.parent.parent.right;r.color===1?(c.parent.color=0,r.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.right&&(c=c.parent,E(n,c)),c.parent.color=0,c.parent.parent.color=1,A(n,c.parent.parent))}else{const r=c.parent.parent.left;r.color===1?(c.parent.color=0,r.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.left&&(c=c.parent,A(n,c)),c.parent.color=0,c.parent.parent.color=1,E(n,c.parent.parent))}n.root.color=0}e.$2B=l;function p(n,c,r,t){for(;c!==n.root&&c!==e.$VB;)c.parent.left===c&&(c.parent.size_left+=r,c.parent.lf_left+=t),c=c.parent}e.$3B=p;function $(n,c){let r=0,t=0;if(c!==n.root){for(;c!==n.root&&c===c.parent.right;)c=c.parent;if(c!==n.root)for(c=c.parent,r=L(c.left)-c.size_left,t=g(c.left)-c.lf_left,c.size_left+=r,c.lf_left+=t;c!==n.root&&(r!==0||t!==0);)c.parent.left===c&&(c.parent.size_left+=r,c.parent.lf_left+=t),c=c.parent}}e.$4B=$}),define(Re[91],Ae([1,0,92,29,93,131,94]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.$bC=e.$aC=e.$_B=e.$$B=void 0;const g=65535;function h(r){let t;return r[r.length-1]<65536?t=new Uint16Array(r.length):t=new Uint32Array(r.length),t.set(r,0),t}class E{constructor(t,s,a,u,i){this.lineStarts=t,this.cr=s,this.lf=a,this.crlf=u,this.isBasicASCII=i}}function A(r,t=!0){const s=[0];let a=1;for(let u=0,i=r.length;u<i;u++){const v=r.charCodeAt(u);v===13?u+1<i&&r.charCodeAt(u+1)===10?(s[a++]=u+2,u++):s[a++]=u+1:v===10&&(s[a++]=u+1)}return t?h(s):s}e.$$B=A;function D(r,t){r.length=0,r[0]=0;let s=1,a=0,u=0,i=0,v=!0;for(let w=0,y=t.length;w<y;w++){const d=t.charCodeAt(w);d===13?w+1<y&&t.charCodeAt(w+1)===10?(i++,r[s++]=w+2,w++):(a++,r[s++]=w+1):d===10?(u++,r[s++]=w+1):v&&d!==9&&(d<32||d>126)&&(v=!1)}const o=new E(h(r),a,u,i,v);return r.length=0,o}e.$_B=D;class l{constructor(t,s,a,u,i){this.bufferIndex=t,this.start=s,this.end=a,this.lineFeedCnt=u,this.length=i}}e.$aC=l;class p{constructor(t,s){this.buffer=t,this.lineStarts=s}}e.$bC=p;class ${constructor(t,s){this.a=[],this.c=t,this.d=s,this.b=0,t.root!==R.$VB&&t.iterate(t.root,a=>(a!==R.$VB&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class n{constructor(t){this.a=t,this.b=[]}get(t){for(let s=this.b.length-1;s>=0;s--){const a=this.b[s];if(a.nodeStartOffset<=t&&a.nodeStartOffset+a.node.piece.length>=t)return a}return null}get2(t){for(let s=this.b.length-1;s>=0;s--){const a=this.b[s];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<t&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=t)return a}return null}set(t){this.b.length>=this.a&&this.b.shift(),this.b.push(t)}validate(t){let s=!1;const a=this.b;for(let u=0;u<a.length;u++){const i=a[u];if(i.node.parent===null||i.nodeStartOffset>=t){a[u]=null,s=!0;continue}}if(s){const u=[];for(const i of a)i!==null&&u.push(i);this.b=u}}}class c{constructor(t,s,a){this.create(t,s,a)}create(t,s,a){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=R.$VB,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=a;let u=null;for(let i=0,v=t.length;i<v;i++)if(t[i].buffer.length>0){t[i].lineStarts||(t[i].lineStarts=A(t[i].buffer));const o=new l(i+1,{line:0,column:0},{line:t[i].lineStarts.length-1,column:t[i].buffer.length-t[i].lineStarts[t[i].lineStarts.length-1]},t[i].lineStarts.length-1,t[i].buffer.length);this.a.push(t[i]),u=this.S(u,o)}this.h=new n(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(t){const s=g,a=s-Math.floor(s/3),u=a*2;let i="",v=0;const o=[];if(this.iterate(this.root,w=>{const y=this.R(w),d=y.length;if(v<=a||v+d<u)return i+=y,v+=d,!0;const b=i.replace(/\r\n|\r|\n/g,t);return o.push(new p(b,A(b))),i=y,v=d,!0}),v>0){const w=i.replace(/\r\n|\r|\n/g,t);o.push(new p(w,A(w)))}this.create(o,t,!0)}getEOL(){return this.d}setEOL(t){this.d=t,this.e=this.d.length,this.normalizeEOL(t)}createSnapshot(t){return new $(this,t)}equal(t){if(this.getLength()!==t.getLength()||this.getLineCount()!==t.getLineCount())return!1;let s=0;return this.iterate(this.root,u=>{if(u===R.$VB)return!0;const i=this.R(u),v=i.length,o=t.G(s),w=t.G(s+v),y=t.getValueInRange2(o,w);return s+=v,i===y})}getOffsetAt(t,s){let a=0,u=this.root;for(;u!==R.$VB;)if(u.left!==R.$VB&&u.lf_left+1>=t)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt+1>=t){a+=u.size_left;const i=this.B(u,t-u.lf_left-2);return a+=i+s-1}else t-=u.lf_left+u.piece.lineFeedCnt,a+=u.size_left+u.piece.length,u=u.right;return a}getPositionAt(t){t=Math.floor(t),t=Math.max(0,t);let s=this.root,a=0;const u=t;for(;s!==R.$VB;)if(s.size_left!==0&&s.size_left>=t)s=s.left;else if(s.size_left+s.piece.length>=t){const i=this.A(s,t-s.size_left);if(a+=s.lf_left+i.index,i.index===0){const v=this.getOffsetAt(a+1,1),o=u-v;return new S.$Vs(a+1,o+1)}return new S.$Vs(a+1,i.remainder+1)}else if(t-=s.size_left+s.piece.length,a+=s.lf_left+s.piece.lineFeedCnt,s.right===R.$VB){const i=this.getOffsetAt(a+1,1),v=u-t-i;return new S.$Vs(a+1,v+1)}else s=s.right;return new S.$Vs(1,1)}getValueInRange(t,s){if(t.startLineNumber===t.endLineNumber&&t.startColumn===t.endColumn)return"";const a=this.H(t.startLineNumber,t.startColumn),u=this.H(t.endLineNumber,t.endColumn),i=this.getValueInRange2(a,u);return s?s!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,s):i}getValueInRange2(t,s){if(t.node===s.node){const o=t.node,w=this.a[o.piece.bufferIndex].buffer,y=this.u(o.piece.bufferIndex,o.piece.start);return w.substring(y+t.remainder,y+s.remainder)}let a=t.node;const u=this.a[a.piece.bufferIndex].buffer,i=this.u(a.piece.bufferIndex,a.piece.start);let v=u.substring(i+t.remainder,i+a.piece.length);for(a=a.next();a!==R.$VB;){const o=this.a[a.piece.bufferIndex].buffer,w=this.u(a.piece.bufferIndex,a.piece.start);if(a===s.node){v+=o.substring(w,w+s.remainder);break}else v+=o.substr(w,a.piece.length);a=a.next()}return v}getLinesContent(){const t=[];let s=0,a="",u=!1;return this.iterate(this.root,i=>{if(i===R.$VB)return!0;const v=i.piece;let o=v.length;if(o===0)return!0;const w=this.a[v.bufferIndex].buffer,y=this.a[v.bufferIndex].lineStarts,d=v.start.line,b=v.end.line;let P=y[d]+v.start.column;if(u&&(w.charCodeAt(P)===10&&(P++,o--),t[s++]=a,a="",u=!1,o===0))return!0;if(d===b)return!this.f&&w.charCodeAt(P+o-1)===13?(u=!0,a+=w.substr(P,o-1)):a+=w.substr(P,o),!0;a+=this.f?w.substring(P,Math.max(P,y[d+1]-this.e)):w.substring(P,y[d+1]).replace(/(\r\n|\r|\n)$/,""),t[s++]=a;for(let f=d+1;f<b;f++)a=this.f?w.substring(y[f],y[f+1]-this.e):w.substring(y[f],y[f+1]).replace(/(\r\n|\r|\n)$/,""),t[s++]=a;return!this.f&&w.charCodeAt(y[b]+v.end.column-1)===13?(u=!0,v.end.column===0?s--:a=w.substr(y[b],v.end.column-1)):a=w.substr(y[b],v.end.column),!0}),u&&(t[s++]=a,a=""),t[s++]=a,t}getLength(){return this.c}getLineCount(){return this.b}getLineContent(t){return this.j.lineNumber===t?this.j.value:(this.j.lineNumber=t,t===this.b?this.j.value=this.getLineRawContent(t):this.f?this.j.value=this.getLineRawContent(t,this.e):this.j.value=this.getLineRawContent(t).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(t){if(t.remainder===t.node.piece.length){const s=t.node.next();if(!s)return 0;const a=this.a[s.piece.bufferIndex],u=this.u(s.piece.bufferIndex,s.piece.start);return a.buffer.charCodeAt(u)}else{const s=this.a[t.node.piece.bufferIndex],u=this.u(t.node.piece.bufferIndex,t.node.piece.start)+t.remainder;return s.buffer.charCodeAt(u)}}getLineCharCode(t,s){const a=this.H(t,s+1);return this.l(a)}getLineLength(t){if(t===this.getLineCount()){const s=this.getOffsetAt(t,1);return this.getLength()-s}return this.getOffsetAt(t+1,1)-this.getOffsetAt(t,1)-this.e}getCharCode(t){const s=this.G(t);return this.l(s)}findMatchesInNode(t,s,a,u,i,v,o,w,y,d,b){const P=this.a[t.piece.bufferIndex],f=this.u(t.piece.bufferIndex,t.piece.start),m=this.u(t.piece.bufferIndex,i),k=this.u(t.piece.bufferIndex,v);let T;const O={line:0,column:0};let G,q;s._wordSeparators?(G=P.buffer.substring(m,k),q=j=>j+m,s.reset(0)):(G=P.buffer,q=j=>j,s.reset(m));do if(T=s.next(G),T){if(q(T.index)>=k)return d;this.s(t,q(T.index)-f,O);const j=this.t(t.piece.bufferIndex,i,O),C=O.line===i.line?O.column-i.column+u:O.column+1,N=C+T[0].length;if(b[d++]=(0,L.$7B)(new M.$Ws(a+j,C,a+j,N),T,w),q(T.index)+T[0].length>=k||d>=y)return d}while(T);return d}findMatchesLineByLine(t,s,a,u){const i=[];let v=0;const o=new L.$0B(s.wordSeparators,s.regex);let w=this.H(t.startLineNumber,t.startColumn);if(w===null)return[];const y=this.H(t.endLineNumber,t.endColumn);if(y===null)return[];let d=this.s(w.node,w.remainder);const b=this.s(y.node,y.remainder);if(w.node===y.node)return this.findMatchesInNode(w.node,o,t.startLineNumber,t.startColumn,d,b,s,a,u,v,i),i;let P=t.startLineNumber,f=w.node;for(;f!==y.node;){const k=this.t(f.piece.bufferIndex,d,f.piece.end);if(k>=1){const O=this.a[f.piece.bufferIndex].lineStarts,G=this.u(f.piece.bufferIndex,f.piece.start),q=O[d.line+k],j=P===t.startLineNumber?t.startColumn:1;if(v=this.findMatchesInNode(f,o,P,j,d,this.s(f,q-G),s,a,u,v,i),v>=u)return i;P+=k}const T=P===t.startLineNumber?t.startColumn-1:0;if(P===t.endLineNumber){const O=this.getLineContent(P).substring(T,t.endColumn-1);return v=this.n(s,o,O,t.endLineNumber,T,v,i,a,u),i}if(v=this.n(s,o,this.getLineContent(P).substr(T),P,T,v,i,a,u),v>=u)return i;P++,w=this.H(P,1),f=w.node,d=this.s(w.node,w.remainder)}if(P===t.endLineNumber){const k=P===t.startLineNumber?t.startColumn-1:0,T=this.getLineContent(P).substring(k,t.endColumn-1);return v=this.n(s,o,T,t.endLineNumber,k,v,i,a,u),i}const m=P===t.startLineNumber?t.startColumn:1;return v=this.findMatchesInNode(y.node,o,P,m,d,b,s,a,u,v,i),i}n(t,s,a,u,i,v,o,w,y){const d=t.wordSeparators;if(!w&&t.simpleSearch){const P=t.simpleSearch,f=P.length,m=a.length;let k=-f;for(;(k=a.indexOf(P,k+f))!==-1;)if((!d||(0,L.$9B)(d,a,m,k,f))&&(o[v++]=new I.$cv(new M.$Ws(u,k+1+i,u,k+1+f+i),null),v>=y))return v;return v}let b;s.reset(0);do if(b=s.next(a),b&&(o[v++]=(0,L.$7B)(new M.$Ws(u,b.index+1+i,u,b.index+1+b[0].length+i),b,w),v>=y))return v;while(b);return v}insert(t,s,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==R.$VB){const{node:u,remainder:i,nodeStartOffset:v}=this.G(t),o=u.piece,w=o.bufferIndex,y=this.s(u,i);if(u.piece.bufferIndex===0&&o.end.line===this.g.line&&o.end.column===this.g.column&&v+o.length===t&&s.length<g){this.F(u,s),this.y();return}if(v===t)this.o(s,u),this.h.validate(t);else if(v+u.piece.length>t){const d=[];let b=new l(o.bufferIndex,y,o.end,this.t(o.bufferIndex,y,o.end),this.u(w,o.end)-this.u(w,y));if(this.K()&&this.M(s)&&this.I(u,i)===10){const k={line:b.start.line+1,column:0};b=new l(b.bufferIndex,k,b.end,this.t(b.bufferIndex,k,b.end),b.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(u,i-1)===13){const k=this.s(u,i-1);this.C(u,k),s="\r"+s,u.piece.length===0&&d.push(u)}else this.C(u,y);else this.C(u,y);const P=this.w(s);b.length>0&&this.S(u,b);let f=u;for(let m=0;m<P.length;m++)f=this.S(f,P[m]);this.v(d)}else this.q(s,u)}else{const u=this.w(s);let i=this.T(null,u[0]);for(let v=1;v<u.length;v++)i=this.S(i,u[v])}this.y()}delete(t,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===R.$VB)return;const a=this.G(t),u=this.G(t+s),i=a.node,v=u.node;if(i===v){const P=this.s(i,a.remainder),f=this.s(i,u.remainder);if(a.nodeStartOffset===t){if(s===i.piece.length){const m=i.next();(0,R.$1B)(this,i),this.N(m),this.y();return}this.D(i,f),this.h.validate(t),this.N(i),this.y();return}if(a.nodeStartOffset+i.piece.length===t+s){this.C(i,P),this.O(i),this.y();return}this.E(i,P,f),this.y();return}const o=[],w=this.s(i,a.remainder);this.C(i,w),this.h.validate(t),i.piece.length===0&&o.push(i);const y=this.s(v,u.remainder);this.D(v,y),v.piece.length===0&&o.push(v);const d=i.next();for(let P=d;P!==R.$VB&&P!==v;P=P.next())o.push(P);const b=i.piece.length===0?i.prev():i;this.v(o),this.O(b),this.y()}o(t,s){const a=[];if(this.K()&&this.M(t)&&this.L(s)){const v=s.piece,o={line:v.start.line+1,column:0},w=new l(v.bufferIndex,o,v.end,this.t(v.bufferIndex,o,v.end),v.length-1);s.piece=w,t+=`
`,(0,R.$3B)(this,s,-1,-1),s.piece.length===0&&a.push(s)}const u=this.w(t);let i=this.T(s,u[u.length-1]);for(let v=u.length-2;v>=0;v--)i=this.T(i,u[v]);this.N(i),this.v(a)}q(t,s){this.Q(t,s)&&(t+=`
`);const a=this.w(t),u=this.S(s,a[0]);let i=u;for(let v=1;v<a.length;v++)i=this.S(i,a[v]);this.N(u)}s(t,s,a){const u=t.piece,i=t.piece.bufferIndex,v=this.a[i].lineStarts,w=v[u.start.line]+u.start.column+s;let y=u.start.line,d=u.end.line,b=0,P=0,f=0;for(;y<=d&&(b=y+(d-y)/2|0,f=v[b],b!==d);)if(P=v[b+1],w<f)d=b-1;else if(w>=P)y=b+1;else break;return a?(a.line=b,a.column=w-f,null):{line:b,column:w-f}}t(t,s,a){if(a.column===0)return a.line-s.line;const u=this.a[t].lineStarts;if(a.line===u.length-1)return a.line-s.line;const i=u[a.line+1],v=u[a.line]+a.column;if(i>v+1)return a.line-s.line;const o=v-1;return this.a[t].buffer.charCodeAt(o)===13?a.line-s.line+1:a.line-s.line}u(t,s){return this.a[t].lineStarts[s.line]+s.column}v(t){for(let s=0;s<t.length;s++)(0,R.$1B)(this,t[s])}w(t){if(t.length>g){const d=[];for(;t.length>g;){const P=t.charCodeAt(g-1);let f;P===13||P>=55296&&P<=56319?(f=t.substring(0,g-1),t=t.substring(g-1)):(f=t.substring(0,g),t=t.substring(g));const m=A(f);d.push(new l(this.a.length,{line:0,column:0},{line:m.length-1,column:f.length-m[m.length-1]},m.length-1,f.length)),this.a.push(new p(f,m))}const b=A(t);return d.push(new l(this.a.length,{line:0,column:0},{line:b.length-1,column:t.length-b[b.length-1]},b.length-1,t.length)),this.a.push(new p(t,b)),d}let s=this.a[0].buffer.length;const a=A(t,!1);let u=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(t)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},u=this.g;for(let d=0;d<a.length;d++)a[d]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+t,s+=1}else{if(s!==0)for(let d=0;d<a.length;d++)a[d]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=t}const i=this.a[0].buffer.length,v=this.a[0].lineStarts.length-1,o=i-this.a[0].lineStarts[v],w={line:v,column:o},y=new l(0,u,w,this.t(0,u,w),i-s);return this.g=w,[y]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(t,s=0){let a=this.root,u="";const i=this.h.get2(t);if(i){a=i.node;const v=this.B(a,t-i.nodeStartLineNumber-1),o=this.a[a.piece.bufferIndex].buffer,w=this.u(a.piece.bufferIndex,a.piece.start);if(i.nodeStartLineNumber+a.piece.lineFeedCnt===t)u=o.substring(w+v,w+a.piece.length);else{const y=this.B(a,t-i.nodeStartLineNumber);return o.substring(w+v,w+y-s)}}else{let v=0;const o=t;for(;a!==R.$VB;)if(a.left!==R.$VB&&a.lf_left>=t-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>t-1){const w=this.B(a,t-a.lf_left-2),y=this.B(a,t-a.lf_left-1),d=this.a[a.piece.bufferIndex].buffer,b=this.u(a.piece.bufferIndex,a.piece.start);return v+=a.size_left,this.h.set({node:a,nodeStartOffset:v,nodeStartLineNumber:o-(t-1-a.lf_left)}),d.substring(b+w,b+y-s)}else if(a.lf_left+a.piece.lineFeedCnt===t-1){const w=this.B(a,t-a.lf_left-2),y=this.a[a.piece.bufferIndex].buffer,d=this.u(a.piece.bufferIndex,a.piece.start);u=y.substring(d+w,d+a.piece.length);break}else t-=a.lf_left+a.piece.lineFeedCnt,v+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==R.$VB;){const v=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const o=this.B(a,0),w=this.u(a.piece.bufferIndex,a.piece.start);return u+=v.substring(w,w+o-s),u}else{const o=this.u(a.piece.bufferIndex,a.piece.start);u+=v.substr(o,a.piece.length)}a=a.next()}return u}y(){let t=this.root,s=1,a=0;for(;t!==R.$VB;)s+=t.lf_left+t.piece.lineFeedCnt,a+=t.size_left+t.piece.length,t=t.right;this.b=s,this.c=a,this.h.validate(this.c)}A(t,s){const a=t.piece,u=this.s(t,s),i=u.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===s){const v=this.t(t.piece.bufferIndex,a.start,u);if(v!==i)return{index:v,remainder:0}}return{index:i,remainder:u.column}}B(t,s){if(s<0)return 0;const a=t.piece,u=this.a[a.bufferIndex].lineStarts,i=a.start.line+s+1;return i>a.end.line?u[a.end.line]+a.end.column-u[a.start.line]-a.start.column:u[i]-u[a.start.line]-a.start.column}C(t,s){const a=t.piece,u=a.lineFeedCnt,i=this.u(a.bufferIndex,a.end),v=s,o=this.u(a.bufferIndex,v),w=this.t(a.bufferIndex,a.start,v),y=w-u,d=o-i,b=a.length+d;t.piece=new l(a.bufferIndex,a.start,v,w,b),(0,R.$3B)(this,t,d,y)}D(t,s){const a=t.piece,u=a.lineFeedCnt,i=this.u(a.bufferIndex,a.start),v=s,o=this.t(a.bufferIndex,v,a.end),w=this.u(a.bufferIndex,v),y=o-u,d=i-w,b=a.length+d;t.piece=new l(a.bufferIndex,v,a.end,o,b),(0,R.$3B)(this,t,d,y)}E(t,s,a){const u=t.piece,i=u.start,v=u.end,o=u.length,w=u.lineFeedCnt,y=s,d=this.t(u.bufferIndex,u.start,y),b=this.u(u.bufferIndex,s)-this.u(u.bufferIndex,i);t.piece=new l(u.bufferIndex,u.start,y,d,b),(0,R.$3B)(this,t,b-o,d-w);const P=new l(u.bufferIndex,a,v,this.t(u.bufferIndex,a,v),this.u(u.bufferIndex,v)-this.u(u.bufferIndex,a)),f=this.S(t,P);this.N(f)}F(t,s){this.Q(s,t)&&(s+=`
`);const a=this.K()&&this.L(s)&&this.M(t),u=this.a[0].buffer.length;this.a[0].buffer+=s;const i=A(s,!1);for(let f=0;f<i.length;f++)i[f]+=u;if(a){const f=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:u-f}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const v=this.a[0].lineStarts.length-1,o=this.a[0].buffer.length-this.a[0].lineStarts[v],w={line:v,column:o},y=t.piece.length+s.length,d=t.piece.lineFeedCnt,b=this.t(0,t.piece.start,w),P=b-d;t.piece=new l(t.piece.bufferIndex,t.piece.start,w,b,y),this.g=w,(0,R.$3B)(this,t,s.length,P)}G(t){let s=this.root;const a=this.h.get(t);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:t-a.nodeStartOffset};let u=0;for(;s!==R.$VB;)if(s.size_left>t)s=s.left;else if(s.size_left+s.piece.length>=t){u+=s.size_left;const i={node:s,remainder:t-s.size_left,nodeStartOffset:u};return this.h.set(i),i}else t-=s.size_left+s.piece.length,u+=s.size_left+s.piece.length,s=s.right;return null}H(t,s){let a=this.root,u=0;for(;a!==R.$VB;)if(a.left!==R.$VB&&a.lf_left>=t-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>t-1){const i=this.B(a,t-a.lf_left-2),v=this.B(a,t-a.lf_left-1);return u+=a.size_left,{node:a,remainder:Math.min(i+s-1,v),nodeStartOffset:u}}else if(a.lf_left+a.piece.lineFeedCnt===t-1){const i=this.B(a,t-a.lf_left-2);if(i+s-1<=a.piece.length)return{node:a,remainder:i+s-1,nodeStartOffset:u};s-=a.piece.length-i;break}else t-=a.lf_left+a.piece.lineFeedCnt,u+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==R.$VB;){if(a.piece.lineFeedCnt>0){const i=this.B(a,0),v=this.J(a);return{node:a,remainder:Math.min(s-1,i),nodeStartOffset:v}}else if(a.piece.length>=s-1){const i=this.J(a);return{node:a,remainder:s-1,nodeStartOffset:i}}else s-=a.piece.length;a=a.next()}return null}I(t,s){if(t.piece.lineFeedCnt<1)return-1;const a=this.a[t.piece.bufferIndex],u=this.u(t.piece.bufferIndex,t.piece.start)+s;return a.buffer.charCodeAt(u)}J(t){if(!t)return 0;let s=t.size_left;for(;t!==this.root;)t.parent.right===t&&(s+=t.parent.size_left+t.parent.piece.length),t=t.parent;return s}K(){return!(this.f&&this.d===`
`)}L(t){if(typeof t=="string")return t.charCodeAt(0)===10;if(t===R.$VB||t.piece.lineFeedCnt===0)return!1;const s=t.piece,a=this.a[s.bufferIndex].lineStarts,u=s.start.line,i=a[u]+s.start.column;return u===a.length-1||a[u+1]>i+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(i)===10}M(t){return typeof t=="string"?t.charCodeAt(t.length-1)===13:t===R.$VB||t.piece.lineFeedCnt===0?!1:this.I(t,t.piece.length-1)===13}N(t){if(this.K()&&this.L(t)){const s=t.prev();this.M(s)&&this.P(s,t)}}O(t){if(this.K()&&this.M(t)){const s=t.next();this.L(s)&&this.P(t,s)}}P(t,s){const a=[],u=this.a[t.piece.bufferIndex].lineStarts;let i;t.piece.end.column===0?i={line:t.piece.end.line-1,column:u[t.piece.end.line]-u[t.piece.end.line-1]-1}:i={line:t.piece.end.line,column:t.piece.end.column-1};const v=t.piece.length-1,o=t.piece.lineFeedCnt-1;t.piece=new l(t.piece.bufferIndex,t.piece.start,i,o,v),(0,R.$3B)(this,t,-1,-1),t.piece.length===0&&a.push(t);const w={line:s.piece.start.line+1,column:0},y=s.piece.length-1,d=this.t(s.piece.bufferIndex,w,s.piece.end);s.piece=new l(s.piece.bufferIndex,w,s.piece.end,d,y),(0,R.$3B)(this,s,-1,-1),s.piece.length===0&&a.push(s);const b=this.w(`\r
`);this.S(t,b[0]);for(let P=0;P<a.length;P++)(0,R.$1B)(this,a[P])}Q(t,s){if(this.K()&&this.M(t)){const a=s.next();if(this.L(a)){if(t+=`
`,a.piece.length===1)(0,R.$1B)(this,a);else{const u=a.piece,i={line:u.start.line+1,column:0},v=u.length-1,o=this.t(u.bufferIndex,i,u.end);a.piece=new l(u.bufferIndex,i,u.end,o,v),(0,R.$3B)(this,a,-1,-1)}return!0}}return!1}iterate(t,s){if(t===R.$VB)return s(R.$VB);const a=this.iterate(t.left,s);return a&&s(t)&&this.iterate(t.right,s)}R(t){if(t===R.$VB)return"";const s=this.a[t.piece.bufferIndex],a=t.piece,u=this.u(a.bufferIndex,a.start),i=this.u(a.bufferIndex,a.end);return s.buffer.substring(u,i)}getPieceContent(t){const s=this.a[t.bufferIndex],a=this.u(t.bufferIndex,t.start),u=this.u(t.bufferIndex,t.end);return s.buffer.substring(a,u)}S(t,s){const a=new R.$UB(s,1);if(a.left=R.$VB,a.right=R.$VB,a.parent=R.$VB,a.size_left=0,a.lf_left=0,this.root===R.$VB)this.root=a,a.color=0;else if(t.right===R.$VB)t.right=a,a.parent=t;else{const i=(0,R.$WB)(t.right);i.left=a,a.parent=i}return(0,R.$2B)(this,a),a}T(t,s){const a=new R.$UB(s,1);if(a.left=R.$VB,a.right=R.$VB,a.parent=R.$VB,a.size_left=0,a.lf_left=0,this.root===R.$VB)this.root=a,a.color=0;else if(t.left===R.$VB)t.left=a,a.parent=t;else{const u=(0,R.$XB)(t.left);u.right=a,a.parent=u}return(0,R.$2B)(this,a),a}U(t){let s="";return this.iterate(t,a=>(s+=this.R(a),!0)),s}}e.$cC=c}),define(Re[132],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F8=e.$E8=void 0;class S{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const L=this.a.get(R);return this.a.delete(R),L}}addDragOperationTransfer(R,L){this.a.set(R,L)}}e.$E8=S;class M{constructor(R){this.identifier=R}}e.$F8=M}),define(Re[133],Ae([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Re[134],Ae([1,0,5,6,133]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class R extends M.$Tc{constructor(l,p="",$="",n=!0,c){super(),this.h=this.B(new S.$Wd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=p,this.u=$,this.w=n,this.C=c}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,p){this.C&&await this.C(l)}}e.$Mi=R;class L extends M.$Tc{constructor(){super(...arguments),this.f=this.B(new S.$Wd),this.onWillRun=this.f.event,this.m=this.B(new S.$Wd),this.onDidRun=this.m.event}async run(l,p){if(!l.enabled)return;this.f.fire({action:l});let $;try{await this.u(l,p)}catch(n){$=n}this.m.fire({action:l,error:$})}async u(l,p){await l.run(p)}}e.$Ni=L;class g{constructor(){this.id=g.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let p=[];for(const $ of l)$.length&&(p.length?p=[...p,new g,...$]:p=$);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$Oi=g;class h{get actions(){return this.a}constructor(l,p,$,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=p,this.class=n,this.a=$}async run(){}}e.$Pi=h;class E extends R{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,I.localize(0,null),void 0,!1)}}e.$Qi=E;function A(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked,run:async(...l)=>D.run(...l),tooltip:D.label}}e.$Ri=A}),define(Re[135],Ae([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Re[136],Ae([1,0,135]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0;const M=60,I=M*60,R=I*24,L=R*7,g=R*30,h=R*365;function E(l,p,$,n){typeof l!="number"&&(l=l.getTime());const c=Math.round((new Date().getTime()-l)/1e3);if(c<-30)return(0,S.localize)(0,null,E(new Date().getTime()+c*1e3,!1));if(!n&&c<30)return(0,S.localize)(1,null);let r;return c<M?(r=c,p?r===1?$?(0,S.localize)(2,null,r):(0,S.localize)(3,null,r):$?(0,S.localize)(4,null,r):(0,S.localize)(5,null,r):r===1?$?(0,S.localize)(6,null,r):(0,S.localize)(7,null,r):$?(0,S.localize)(8,null,r):(0,S.localize)(9,null,r)):c<I?(r=Math.floor(c/M),p?r===1?$?(0,S.localize)(10,null,r):(0,S.localize)(11,null,r):$?(0,S.localize)(12,null,r):(0,S.localize)(13,null,r):r===1?$?(0,S.localize)(14,null,r):(0,S.localize)(15,null,r):$?(0,S.localize)(16,null,r):(0,S.localize)(17,null,r)):c<R?(r=Math.floor(c/I),p?r===1?$?(0,S.localize)(18,null,r):(0,S.localize)(19,null,r):$?(0,S.localize)(20,null,r):(0,S.localize)(21,null,r):r===1?$?(0,S.localize)(22,null,r):(0,S.localize)(23,null,r):$?(0,S.localize)(24,null,r):(0,S.localize)(25,null,r)):c<L?(r=Math.floor(c/R),p?r===1?(0,S.localize)(26,null,r):(0,S.localize)(27,null,r):r===1?(0,S.localize)(28,null,r):(0,S.localize)(29,null,r)):c<g?(r=Math.floor(c/L),p?r===1?$?(0,S.localize)(30,null,r):(0,S.localize)(31,null,r):$?(0,S.localize)(32,null,r):(0,S.localize)(33,null,r):r===1?$?(0,S.localize)(34,null,r):(0,S.localize)(35,null,r):$?(0,S.localize)(36,null,r):(0,S.localize)(37,null,r)):c<h?(r=Math.floor(c/g),p?r===1?$?(0,S.localize)(38,null,r):(0,S.localize)(39,null,r):$?(0,S.localize)(40,null,r):(0,S.localize)(41,null,r):r===1?$?(0,S.localize)(42,null,r):(0,S.localize)(43,null,r):$?(0,S.localize)(44,null,r):(0,S.localize)(45,null,r)):(r=Math.floor(c/h),p?r===1?$?(0,S.localize)(46,null,r):(0,S.localize)(47,null,r):$?(0,S.localize)(48,null,r):(0,S.localize)(49,null,r):r===1?$?(0,S.localize)(50,null,r):(0,S.localize)(51,null,r):$?(0,S.localize)(52,null,r):(0,S.localize)(53,null,r))}e.$xm=E;function A(l,p){const $=Math.abs(l/1e3);return $<1?p?(0,S.localize)(54,null,l):(0,S.localize)(55,null,l):$<M?p?(0,S.localize)(56,null,Math.round(l)/1e3):(0,S.localize)(57,null,Math.round(l)/1e3):$<I?p?(0,S.localize)(58,null,Math.round(l/(1e3*M))):(0,S.localize)(59,null,Math.round(l/(1e3*M))):$<R?p?(0,S.localize)(60,null,Math.round(l/(1e3*I))):(0,S.localize)(61,null,Math.round(l/(1e3*I))):(0,S.localize)(62,null,Math.round(l/(1e3*R)))}e.$ym=A;function D(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$zm=D}),define(Re[137],Ae([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Re[41],Ae([1,0,18,16,137]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=void 0;function R(D,l){return l&&(D.stack||D.stacktrace)?I.localize(0,null,g(D),L(D.stack)||L(D.stacktrace)):g(D)}function L(D){return Array.isArray(D)?D.join(`
`):D}function g(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?I.localize(1,null,D.message):D.message||I.localize(2,null)}function h(D=null,l=!1){if(!D)return I.localize(3,null);if(Array.isArray(D)){const p=S.$Hb(D),$=h(p[0],l);return p.length>1?I.localize(4,null,$,p.length):$}if(M.$Jf(D))return D;if(D.detail){const p=D.detail;if(p.error)return R(p.error,l);if(p.exception)return R(p.exception,l)}return D.stack?R(D,l):D.message?D.message:I.localize(5,null)}e.$Si=h;function E(D){const l=D;return l instanceof Error&&Array.isArray(l.actions)}e.$Ti=E;function A(D,l){let p;return typeof D=="string"?p=new Error(D):p=D,p.actions=l,p}e.$Ui=A}),define(Re[138],Ae([1,0,39,19]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=void 0;const I=new S.$V(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),R=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function g(P,f,m=!1){const k=P||"",T=f||"",O=I.value.collator.compare(k,T);return I.value.collatorIsNumeric&&O===0&&k!==T?k<T?-1:1:O}e.$Kq=g;function h(P,f){const m=R.value.collator;return P=P||"",f=f||"",a(m,P,f)}e.$Lq=h;function E(P,f){const m=R.value.collator;return P=P||"",f=f||"",o(P,f)||a(m,P,f)}e.$Mq=E;function A(P,f){const m=R.value.collator;return P=P||"",f=f||"",v(P,f)||a(m,P,f)}e.$Nq=A;function D(P,f){return P=P||"",f=f||"",P===f?0:P<f?-1:1}e.$Oq=D;function l(P,f){const[m,k]=t(P),[T,O]=t(f);let G=I.value.collator.compare(k,O);if(G===0){if(I.value.collatorIsNumeric&&k!==O)return k<O?-1:1;if(G=I.value.collator.compare(m,T),I.value.collatorIsNumeric&&G===0&&m!==T)return m<T?-1:1}return G}e.$Pq=l;function p(P,f){P=P||"",f=f||"";const m=s(P),k=s(f),T=R.value.collator,O=L.value.collator;return a(O,m,k)||a(T,P,f)}e.$Qq=p;function $(P,f){P=P||"",f=f||"";const m=s(P),k=s(f),T=R.value.collator,O=L.value.collator;return a(O,m,k)||o(P,f)||a(T,P,f)}e.$Rq=$;function n(P,f){P=P||"",f=f||"";const m=s(P),k=s(f),T=R.value.collator,O=L.value.collator;return a(O,m,k)||v(P,f)||a(T,P,f)}e.$Sq=n;function c(P,f){P=P||"",f=f||"";const m=s(P).toLowerCase(),k=s(f).toLowerCase();return m!==k?m<k?-1:1:P!==f?P<f?-1:1:0}e.$Tq=c;const r=/^(.*?)(\.([^.]*))?$/;function t(P,f=!1){const m=P?r.exec(P):[];let k=[m&&m[1]||"",m&&m[3]||""];return f&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function s(P){const f=P?r.exec(P):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function a(P,f,m){const k=P.compare(f,m);return k!==0?k:f.length!==m.length?f.length<m.length?-1:1:0}function u(P){const f=P.charAt(0);return f.toLocaleUpperCase()!==f}function i(P){const f=P.charAt(0);return f.toLocaleLowerCase()!==f}function v(P,f){return u(P)&&i(f)?-1:i(P)&&u(f)?1:0}function o(P,f){return i(P)&&u(f)?-1:u(P)&&i(f)?1:0}function w(P,f,m=!1){return m||(P=P&&P.toLowerCase(),f=f&&f.toLowerCase()),P===f?0:P<f?-1:1}function y(P,f,m=!1){const k=P.split(M.sep),T=f.split(M.sep),O=k.length-1,G=T.length-1;let q,j;for(let C=0;;C++){if(q=O===C,j=G===C,q&&j)return g(k[C],T[C],m);if(q)return-1;if(j)return 1;const N=w(k[C],T[C],m);if(N!==0)return N}}e.$Uq=y;function d(P,f,m){const k=P.toLowerCase(),T=f.toLowerCase(),O=b(P,f,m);if(O)return O;const G=k.endsWith(m),q=T.endsWith(m);if(G!==q)return G?-1:1;const j=g(k,T);return j!==0?j:k.localeCompare(T)}e.$Vq=d;function b(P,f,m){const k=P.toLowerCase(),T=f.toLowerCase(),O=k.startsWith(m),G=T.startsWith(m);if(O!==G)return O?-1:1;if(O&&G){if(k.length<T.length)return-1;if(k.length>T.length)return 1}return 0}e.$Wq=b}),define(Re[45],Ae([1,0,19,20,13,16]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function L(d){return d===47||d===92}e.$2f=L;function g(d){return d.replace(/[\\/]/g,S.$gc.sep)}e.$3f=g;function h(d){return d.indexOf("/")===-1&&(d=g(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$4f=h;function E(d,b=S.$gc.sep){if(!d)return"";const P=d.length,f=d.charCodeAt(0);if(L(f)){if(L(d.charCodeAt(1))&&!L(d.charCodeAt(2))){let k=3;const T=k;for(;k<P&&!L(d.charCodeAt(k));k++);if(T!==k&&!L(d.charCodeAt(k+1))){for(k+=1;k<P;k++)if(L(d.charCodeAt(k)))return d.slice(0,k+1).replace(/[\\/]/g,b)}}return b}else if(r(f)&&d.charCodeAt(1)===58)return L(d.charCodeAt(2))?d.slice(0,2)+b:d.slice(0,2);let m=d.indexOf("://");if(m!==-1){for(m+=3;m<P;m++)if(L(d.charCodeAt(m)))return d.slice(0,m+1)}return""}e.$5f=E;function A(d){if(!M.$i||!d||d.length<5)return!1;let b=d.charCodeAt(0);if(b!==92||(b=d.charCodeAt(1),b!==92))return!1;let P=2;const f=P;for(;P<d.length&&(b=d.charCodeAt(P),b!==92);P++);return!(f===P||(b=d.charCodeAt(P+1),isNaN(b)||b===92))}e.$6f=A;const D=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(d,b=M.$i){const P=b?D:l;return!(!d||d.length===0||/^\s+$/.test(d)||(P.lastIndex=0,P.test(d))||b&&p.test(d)||d==="."||d===".."||b&&d[d.length-1]==="."||b&&d.length!==d.trim().length||d.length>255)}e.$7f=$;function n(d,b,P){const f=d===b;return!P||f?f:!d||!b?!1:(0,I.$af)(d,b)}e.$8f=n;function c(d,b,P,f=S.sep){if(d===b)return!0;if(!d||!b||b.length>d.length)return!1;if(P){if(!(0,I.$bf)(d,b))return!1;if(b.length===d.length)return!0;let k=b.length;return b.charAt(b.length-1)===f&&k--,d.charAt(k)===f}return b.charAt(b.length-1)!==f&&(b+=f),d.indexOf(b)===0}e.$9f=c;function r(d){return d>=65&&d<=90||d>=97&&d<=122}e.$0f=r;function t(d,b){return M.$i&&d.endsWith(":")&&(d+=S.sep),(0,S.$ic)(d)||(d=(0,S.$jc)(b,d)),d=(0,S.$hc)(d),M.$i?(d=(0,I.$Ve)(d,S.sep),d.endsWith(":")&&(d+=S.sep)):(d=(0,I.$Ve)(d,S.sep),d||(d=S.sep)),d}e.$$f=t;function s(d){const b=(0,S.$hc)(d);return M.$i?d.length>3?!1:a(b)&&(d.length===2||b.charCodeAt(2)===92):b===S.$gc.sep}e.$_f=s;function a(d,b=M.$i){return b?r(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$ag=a;function u(d,b=M.$i){return a(d,b)?d[0]:void 0}e.$bg=u;function i(d,b,P){return b.length>d.length?-1:d===b?0:(P&&(d=d.toLowerCase(),b=b.toLowerCase()),d.indexOf(b))}e.$cg=i;function v(d){const b=d.split(":");let P,f,m;for(const k of b){const T=Number(k);(0,R.$Nf)(T)?f===void 0?f=T:m===void 0&&(m=T):P=P?[P,k].join(":"):k}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:f!==void 0?f:void 0,column:m!==void 0?m:f!==void 0?1:void 0}}e.$dg=v;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",w="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y(d,b,P=8){let f="";for(let k=0;k<P;k++){let T;k===0&&M.$i&&!b&&(P===3||P===4)?T=w:T=o,f+=T.charAt(Math.floor(Math.random()*T.length))}let m;return b?m=`${b}-${f}`:m=f,d?(0,S.$jc)(d,m):m}e.$eg=y}),define(Re[69],Ae([1,0,19]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.$is=e.$hs=void 0,e.$hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const D=(0,S.$oc)(A),l=M[D.toLowerCase()];return l!==void 0?l:L(A)}e.$is=R;function L(A){const D=(0,S.$oc)(A);return I[D.toLowerCase()]}e.$js=L;function g(A){for(const D in I)if(I[D]===A)return D}e.$ks=g;const h=/^(.+)\/(.+?)(;.+)?$/;function E(A,D){const l=h.exec(A);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:D?void 0:A}e.$ls=E}),define(Re[51],Ae([1,0,23,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=void 0;function I(h){return JSON.stringify(h,L)}e.$Ch=I;function R(h){let E=JSON.parse(h);return E=g(E),E}e.$Dh=R;function L(h,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function g(h,E=0){if(!h||E>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return M.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof S.$ke||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let A=0;A<h.length;++A)h[A]=g(h[A],E+1);else for(const A in h)Object.hasOwnProperty.call(h,A)&&(h[A]=g(h[A],E+1))}return h}e.$Eh=g}),define(Re[12],Ae([1,0,15,20,13,2]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var L;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={}));function g(l,p){return R.URI.isUri(l)?(0,I.$af)(l.scheme,p):(0,I.$bf)(l,p+":")}e.$fg=g;function h(l,...p){return p.some($=>g(l,$))}e.$gg=h,e.$hg="vscode-tkn",e.$ig="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${L.vscodeRemoteResource}`}set(p,$,n){this.a[p]=$,this.b[p]=n}setConnectionToken(p,$){this.c[p]=$}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(s){return S.$1(s),p}const $=p.authority;let n=this.a[$];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const c=this.b[$],r=this.c[$];let t=`path=${encodeURIComponent(p.path)}`;return typeof r=="string"&&(t+=`&${e.$ig}=${encodeURIComponent(r)}`),R.URI.from({scheme:M.$o?this.d:L.vscodeRemoteResource,authority:`${n}:${c}`,path:this.f,query:t})}}e.$jg=new E,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class A{static{this.a=e.$og}asBrowserUri(p){const $=this.b(p,me);return this.uriToBrowserUri($)}uriToBrowserUri(p){return p.scheme===L.vscodeRemote?e.$jg.rewrite(p):p.scheme===L.file&&(M.$m||M.$q===`${L.vscodeFileResource}://${A.a}`)?p.with({scheme:L.vscodeFileResource,authority:p.authority||A.a,query:null,fragment:null}):p}asFileUri(p){const $=this.b(p,me);return this.uriToFileUri($)}uriToFileUri(p){return p.scheme===L.vscodeFileResource?p.with({scheme:L.file,authority:p.authority!==A.a?p.authority:null,query:null,fragment:null}):p}b(p,$){return R.URI.isUri(p)?p:R.URI.parse($.toUrl(p))}}e.$pg=new A;var D;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const $="vscode-coi";function n(r){let t;typeof r=="string"?t=new URL(r).searchParams:r instanceof URL?t=r.searchParams:R.URI.isUri(r)&&(t=new URL(r.toString(!0)).searchParams);const s=t?.get($);if(s)return p.get(s)}l.getHeadersFromQuery=n;function c(r,t,s){if(!globalThis.crossOriginIsolated)return;const a=t&&s?"3":s?"2":"1";r instanceof URLSearchParams?r.set($,a):r[$]=a}l.addSearchParam=c})(D||(e.COI=D={}))}),define(Re[25],Ae([1,0,45,12,19,20,13,2]),function(me,e,S,M,I,R,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function h(p){return(0,g.$wc)(p,!0)}e.$wg=h;class E{constructor($){this.a=$}compare($,n,c=!1){return $===n?0:(0,L.$6e)(this.getComparisonKey($,c),this.getComparisonKey(n,c))}isEqual($,n,c=!1){return $===n?!0:!$||!n?!1:this.getComparisonKey($,c)===this.getComparisonKey(n,c)}getComparisonKey($,n=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,n,c=!1){if($.scheme===n.scheme){if($.scheme===M.Schemas.file)return S.$9f(h($),h(n),this.a($))&&$.query===n.query&&(c||$.fragment===n.fragment);if((0,e.$Ng)($.authority,n.authority))return S.$9f($.path,n.path,this.a($),"/")&&$.query===n.query&&(c||$.fragment===n.fragment)}return!1}joinPath($,...n){return g.URI.joinPath($,...n)}basenameOrAuthority($){return(0,e.$Fg)($)||$.authority}basename($){return I.$gc.basename($.path)}extname($){return I.$gc.extname($.path)}dirname($){if($.path.length===0)return $;let n;return $.scheme===M.Schemas.file?n=g.URI.file(I.$mc(h($))).path:(n=I.$gc.dirname($.path),$.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),n="/")),$.with({path:n})}normalizePath($){if(!$.path.length)return $;let n;return $.scheme===M.Schemas.file?n=g.URI.file(I.$hc(h($))).path:n=I.$gc.normalize($.path),$.with({path:n})}relativePath($,n){if($.scheme!==n.scheme||!(0,e.$Ng)($.authority,n.authority))return;if($.scheme===M.Schemas.file){const t=I.$lc(h($),h(n));return R.$i?S.$3f(t):t}let c=$.path||"/";const r=n.path||"/";if(this.a($)){let t=0;for(const s=Math.min(c.length,r.length);t<s&&!(c.charCodeAt(t)!==r.charCodeAt(t)&&c.charAt(t).toLowerCase()!==r.charAt(t).toLowerCase());t++);c=r.substr(0,t)+c.substr(t)}return I.$gc.relative(c,r)}resolvePath($,n){if($.scheme===M.Schemas.file){const c=g.URI.file(I.$kc(h($),n));return $.with({authority:c.authority,path:c.path})}return n=S.$4f(n),$.with({path:I.$gc.resolve($.path,n)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,n){return $===n||$!==void 0&&n!==void 0&&(0,L.$af)($,n)}hasTrailingPathSeparator($,n=I.sep){if($.scheme===M.Schemas.file){const c=h($);return c.length>S.$5f(c).length&&c[c.length-1]===n}else{const c=$.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,n=I.sep){return(0,e.$Og)($,n)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,n=I.sep){let c=!1;if($.scheme===M.Schemas.file){const r=h($);c=r!==void 0&&r.length===S.$5f(r).length&&r[r.length-1]===n}else{n="/";const r=$.path;c=r.length===1&&r.charCodeAt(r.length-1)===47}return!c&&!(0,e.$Og)($,n)?$.with({path:$.path+"/"}):$}}e.$xg=E,e.$yg=new E(()=>!1),e.$zg=new E(p=>p.scheme===M.Schemas.file?!R.$k:!0),e.$Ag=new E(p=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function A(p,$){const n=[];for(let c=0;c<p.length;c++){const r=$(p[c]);p.some((t,s)=>s===c?!1:(0,e.$Cg)(r,$(t)))||n.push(p[c])}return n}e.$Rg=A;var D;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function $(n){const c=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(s=>{const[a,u]=s.split(":");a&&u&&c.set(a,u)});const t=n.path.substring(0,n.path.indexOf(";"));return t&&c.set(p.META_DATA_MIME,t),c}p.parseMetaData=$})(D||(e.DataUri=D={}));function l(p,$,n){if($){let c=p.path;return c&&c[0]!==I.$gc.sep&&(c=I.$gc.sep+c),p.with({scheme:n,authority:$,path:c})}return p.with({scheme:n})}e.$Sg=l}),define(Re[11],Ae([1,0,21,15,5,6,25,20,125,39]),function(me,e,S,M,I,R,L,g,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.Promises=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function A(ge){return!!ge&&typeof ge.then=="function"}e.$Tg=A;function D(ge){const K=new S.$7d,ee=ge(K.token),le=new Promise((fe,Ce)=>{const de=K.token.onCancellationRequested(()=>{de.dispose(),Ce(new M.$5)});Promise.resolve(ee).then(we=>{de.dispose(),K.dispose(),fe(we)},we=>{de.dispose(),K.dispose(),Ce(we)})});return new class{cancel(){K.cancel(),K.dispose()}then(fe,Ce){return le.then(fe,Ce)}catch(fe){return this.then(void 0,fe)}finally(fe){return le.finally(fe)}}}e.$Ug=D;function l(ge,K,ee){return new Promise((le,fe)=>{const Ce=K.onCancellationRequested(()=>{Ce.dispose(),le(ee)});ge.then(le,fe).finally(()=>Ce.dispose())})}e.$Vg=l;function p(ge,K){return new Promise((ee,le)=>{const fe=K.onCancellationRequested(()=>{fe.dispose(),le(new M.$5)});ge.then(ee,le).finally(()=>fe.dispose())})}e.$Wg=p;async function $(ge){let K=-1;const ee=ge.map((le,fe)=>le.then(Ce=>(K=fe,Ce)));try{return await Promise.race(ee)}finally{ge.forEach((le,fe)=>{fe!==K&&le.cancel()})}}e.$Xg=$;function n(ge,K,ee){let le;const fe=setTimeout(()=>{le?.(void 0),ee?.()},K);return Promise.race([ge.finally(()=>clearTimeout(fe)),new Promise(Ce=>le=Ce)])}e.$Yg=n;function c(ge){return new Promise((K,ee)=>{const le=ge();A(le)?le.then(K,ee):K(le)})}e.$Zg=c;function r(){let ge,K;return{promise:new Promise((le,fe)=>{ge=le,K=fe}),resolve:ge,reject:K}}e.$1g=r;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const ee=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(ee,ee).then(le)})}return new Promise((ee,le)=>{this.b.then(ee,le)})}return this.a=K(),new Promise((ee,le)=>{this.a.then(fe=>{this.a=null,ee(fe)},fe=>{this.a=null,le(fe)})})}dispose(){this.f=!0}}e.$2g=t;class s{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$3g=s;class a{constructor(){this.a=new Map}queue(K,ee){const fe=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.a.get(K)===fe&&this.a.delete(K)});return this.a.set(K,fe),fe}}e.$4g=a;const u=(ge,K)=>{let ee=!0;const le=setTimeout(()=>{ee=!1,K()},ge);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(le),ee=!1}}},i=ge=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,ge())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class v{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,ee=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((fe,Ce)=>{this.d=fe,this.f=Ce}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=ee===h.$Td?i(le):u(ee,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$5g=v;class o{constructor(K){this.a=new v(K),this.b=new t}trigger(K,ee){return this.a.trigger(()=>this.b.queue(K),ee)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$6g=o;class w{constructor(){this.a=!1,this.b=new Promise((K,ee)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$7g=w;class y extends w{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$8g=y;function d(ge,K){return K?new Promise((ee,le)=>{const fe=setTimeout(()=>{Ce.dispose(),ee()},ge),Ce=K.onCancellationRequested(()=>{clearTimeout(fe),Ce.dispose(),le(new M.$5)})}):D(ee=>d(ge,ee))}e.$9g=d;function b(ge,K=0,ee){const le=setTimeout(()=>{ge(),ee&&fe.dispose()},K),fe=(0,R.$Rc)(()=>{clearTimeout(le),ee?.deleteAndLeak(fe)});return ee?.add(fe),fe}e.$0g=b;function P(ge){const K=[];let ee=0;const le=ge.length;function fe(){return ee<le?ge[ee++]():null}function Ce(de){de!=null&&K.push(de);const we=fe();return we?we.then(Ce):Promise.resolve(K)}return Promise.resolve(null).then(Ce)}e.$$g=P;function f(ge,K=le=>!!le,ee=null){let le=0;const fe=ge.length,Ce=()=>{if(le>=fe)return Promise.resolve(ee);const de=ge[le++];return Promise.resolve(de()).then(F=>K(F)?Promise.resolve(F):Ce())};return Ce()}e.$_g=f;function m(ge,K=le=>!!le,ee=null){if(ge.length===0)return Promise.resolve(ee);let le=ge.length;const fe=()=>{le=-1;for(const Ce of ge)Ce.cancel?.()};return new Promise((Ce,de)=>{for(const we of ge)we.then(F=>{--le>=0&&K(F)?(fe(),Ce(F)):le===0&&Ce(ee)}).catch(F=>{--le>=0&&(fe(),de(F))})})}e.$ah=m;class k{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new I.$Wd}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ee,le)=>{this.g.push({factory:K,c:ee,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const ee=K.factory();ee.then(K.c,K.e),ee.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$bh=k;class T extends k{constructor(){super(1)}}e.$ch=T;class O{constructor(){this.a=new ae,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$dh=O;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new $e;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,ee=L.$yg){const le=ee.getComparisonKey(K);return this.a.get(le)?.size??0}queueFor(K,ee,le=L.$yg){const fe=le.getComparisonKey(K);let Ce=this.a.get(fe);if(!Ce){Ce=new T;const de=this.f++,we=I.Event.once(Ce.onDrained)(()=>{Ce?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$3c),this.d.set(de,we),this.a.set(fe,Ce)}return Ce.queue(ee)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$eh=G;class q{constructor(K,ee){this.a=-1,typeof K=="function"&&typeof ee=="number"&&this.setIfNotSet(K,ee)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,ee){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},ee)}setIfNotSet(K,ee){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},ee))}}e.$fh=q;class j{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,ee,le=globalThis){this.cancel();const fe=le.setInterval(()=>{K()},ee);this.d=(0,R.$Rc)(()=>{le.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$gh=j;class C{constructor(K,ee){this.b=-1,this.a=K,this.d=ee,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$hh=C;class N{constructor(K,ee){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.a=K,this.b=ee,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ih=N;class W extends C{constructor(K,ee){super(K,ee),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$jh=W;class se extends R.$Tc{constructor(K,ee){super(),this.g=K,this.h=ee,this.a=[],this.b=this.B(new R.$Uc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ee of K)this.a.push(ee);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new C(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$kh=se,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$mh=(ge,K)=>{(0,g.$B)(()=>{if(ee)return;const le=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.$mh=(ge,K,ee)=>{const le=ge.requestIdleCallback(K,typeof ee=="number"?{timeout:ee}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,ge.cancelIdleCallback(le))}}},e.$lh=ge=>(0,e.$mh)(globalThis,ge)}();class ue{constructor(K,ee){this.g=!1,this.d=()=>{try{this.j=ee()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$mh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$nh=ue;class ye extends ue{constructor(K){super(globalThis,K)}}e.$oh=ye;async function ke(ge,K,ee){let le;for(let fe=0;fe<ee;fe++)try{return await ge()}catch(Ce){le=Ce,await d(K)}throw le}e.$ph=ke;class ae{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,ee,le){return this.a={taskId:K,cancel:()=>le?.(),promise:ee},ee.then(()=>this.d(K),()=>this.d(K)),ee}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:ee,resolve:le,reject:fe}=r();this.b={run:K,promise:ee,promiseResolve:le,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$qh=ae;class pe{constructor(K,ee=()=>Date.now()){this.d=K,this.f=ee,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$rh=pe;var oe;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(oe||(oe={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,ee)=>{this.a=K,this.b=ee})}complete(K){return new Promise(ee=>{this.a(K),this.d={outcome:0,value:K},ee()})}error(K){return new Promise(ee=>{this.b(K),this.d={outcome:1,value:K},ee()})}cancel(){return this.error(new M.$5)}}e.$sh=$e;var ie;(function(ge){async function K(le){let fe;const Ce=await Promise.all(le.map(de=>de.then(we=>we,we=>{fe||(fe=we)})));if(typeof fe<"u")throw fe;return Ce}ge.settled=K;function ee(le){return new Promise(async(fe,Ce)=>{try{await le(fe,Ce)}catch(de){Ce(de)}})}ge.withAsyncBody=ee})(ie||(e.Promises=ie={}));class x{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(ee=>(this.a=ee,this.d=!0,ee),ee=>{throw this.b=ee,this.d=!0,ee})}requireValue(){if(!this.d)throw new M.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$th=x;class V{constructor(K){this.b=K,this.a=new E.$V(()=>new x(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$uh=V;var ne;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(ne||(ne={}));class Ie{static fromArray(K){return new Ie(ee=>{ee.emitMany(K)})}static fromPromise(K){return new Ie(async ee=>{ee.emitMany(await K)})}static fromPromises(K){return new Ie(async ee=>{await Promise.all(K.map(async le=>ee.emitOne(await le)))})}static merge(K){return new Ie(async ee=>{await Promise.all(K.map(async le=>{for await(const fe of le)ee.emitOne(fe)}))})}static{this.EMPTY=Ie.fromArray([])}constructor(K){this.a=0,this.b=[],this.d=null,this.f=new I.$Wd,queueMicrotask(async()=>{const ee={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(K(ee)),this.j()}catch(le){this.k(le)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(K,ee){return new Ie(async le=>{for await(const fe of K)le.emitOne(ee(fe))})}map(K){return Ie.map(this,K)}static filter(K,ee){return new Ie(async le=>{for await(const fe of K)ee(fe)&&le.emitOne(fe)})}filter(K){return Ie.filter(this,K)}static coalesce(K){return Ie.filter(K,ee=>!!ee)}coalesce(){return Ie.coalesce(this)}static async toPromise(K){const ee=[];for await(const le of K)ee.push(le);return ee}toPromise(){return Ie.toPromise(this)}g(K){this.a===0&&(this.b.push(K),this.f.fire())}h(K){this.a===0&&(this.b=this.b.concat(K),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(K){this.a===0&&(this.a=2,this.d=K,this.f.fire())}}e.$vh=Ie;class Me extends Ie{constructor(K,ee){super(ee),this.l=K}cancel(){this.l.cancel()}}e.$wh=Me;function Le(ge){const K=new S.$7d,ee=ge(K.token);return new Me(K,async le=>{const fe=K.token.onCancellationRequested(()=>{fe.dispose(),K.dispose(),le.reject(new M.$5)});try{for await(const Ce of ee){if(K.token.isCancellationRequested)return;le.emitOne(Ce)}fe.dispose(),K.dispose()}catch(Ce){fe.dispose(),K.dispose(),le.reject(Ce)}})}e.$xh=Le;class be{constructor(){this.a=new $e,this.b=new Ie(le=>{if(K){le.reject(K);return}return ee&&le.emitMany(ee),this.d=fe=>le.reject(fe),this.f=fe=>le.emitOne(fe),this.a.p});let K,ee;this.f=le=>{ee||(ee=[]),ee.push(le)},this.d=le=>{K||(K=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$yh=be}),define(Re[34],Ae([1,0,18,11,45,28,19,20,13]),function(me,e,S,M,I,R,L,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=void 0;function E(){return Object.create(null)}e.$Jj=E,e.$Kj="**",e.$Lj="/";const A="[/\\\\]",D="[^/\\\\]",l=/\//g;function p(ue,ye){switch(ue){case 0:return"";case 1:return`${D}*?`;default:return`(?:${A}|${D}+${A}${ye?`|${A}${D}+`:""})*?`}}function $(ue,ye){if(!ue)return[];const ke=[];let ae=!1,pe=!1,oe="";for(const $e of ue){switch($e){case ye:if(!ae&&!pe){ke.push(oe),oe="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}oe+=$e}return oe&&ke.push(oe),ke}e.$Mj=$;function n(ue){if(!ue)return"";let ye="";const ke=$(ue,e.$Lj);if(ke.every(ae=>ae===e.$Kj))ye=".*";else{let ae=!1;ke.forEach((pe,oe)=>{if(pe===e.$Kj){if(ae)return;ye+=p(2,oe===ke.length-1)}else{let $e=!1,ie="",x=!1,V="";for(const ne of pe){if(ne!=="}"&&$e){ie+=ne;continue}if(x&&(ne!=="]"||!V)){let Ie;ne==="-"?Ie=ne:(ne==="^"||ne==="!")&&!V?Ie="^":ne===e.$Lj?Ie="":Ie=(0,h.$Pe)(ne),V+=Ie;continue}switch(ne){case"{":$e=!0;continue;case"[":x=!0;continue;case"}":{const Me=`(?:${$(ie,",").map(Le=>n(Le)).join("|")})`;ye+=Me,$e=!1,ie="";break}case"]":{ye+="["+V+"]",x=!1,V="";break}case"?":ye+=D;continue;case"*":ye+=p(1);continue;default:ye+=(0,h.$Pe)(ne)}}oe<ke.length-1&&(ke[oe+1]!==e.$Kj||oe+2<ke.length)&&(ye+=A)}ae=pe===e.$Kj})}return ye}const c=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,t=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.$Dc(1e4),v=function(){return!1},o=function(){return null};function w(ue,ye){if(!ue)return o;let ke;typeof ue!="string"?ke=ue.pattern:ke=ue,ke=ke.trim();const ae=`${ke}_${!!ye.trimForExclusions}`;let pe=i.get(ae);if(pe)return y(pe,ue);let oe;return c.test(ke)?pe=b(ke.substr(4),ke):(oe=r.exec(d(ke,ye)))?pe=P(oe[1],ke):(ye.trimForExclusions?s:t).test(ke)?pe=f(ke,ye):(oe=a.exec(d(ke,ye)))?pe=m(oe[1].substr(1),ke,!0):(oe=u.exec(d(ke,ye)))?pe=m(oe[1],ke,!1):pe=k(ke),i.set(ae,pe),y(pe,ue)}function y(ue,ye){if(typeof ye=="string")return ue;const ke=function(ae,pe){return(0,I.$9f)(ae,ye.base,!g.$k)?ue((0,h.$Ue)(ae.substr(ye.base.length),L.sep),pe):null};return ke.allBasenames=ue.allBasenames,ke.allPaths=ue.allPaths,ke.basenames=ue.basenames,ke.patterns=ue.patterns,ke}function d(ue,ye){return ye.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function b(ue,ye){return function(ke,ae){return typeof ke=="string"&&ke.endsWith(ue)?ye:null}}function P(ue,ye){const ke=`/${ue}`,ae=`\\${ue}`,pe=function($e,ie){return typeof $e!="string"?null:ie?ie===ue?ye:null:$e===ue||$e.endsWith(ke)||$e.endsWith(ae)?ye:null},oe=[ue];return pe.basenames=oe,pe.patterns=[ye],pe.allBasenames=oe,pe}function f(ue,ye){const ke=W(ue.slice(1,-1).split(",").map(ie=>w(ie,ye)).filter(ie=>ie!==o),ue),ae=ke.length;if(!ae)return o;if(ae===1)return ke[0];const pe=function(ie,x){for(let V=0,ne=ke.length;V<ne;V++)if(ke[V](ie,x))return ue;return null},oe=ke.find(ie=>!!ie.allBasenames);oe&&(pe.allBasenames=oe.allBasenames);const $e=ke.reduce((ie,x)=>x.allPaths?ie.concat(x.allPaths):ie,[]);return $e.length&&(pe.allPaths=$e),pe}function m(ue,ye,ke){const ae=L.sep===L.$gc.sep,pe=ae?ue:ue.replace(l,L.sep),oe=L.sep+pe,$e=L.$gc.sep+ue;let ie;return ke?ie=function(x,V){return typeof x=="string"&&(x===pe||x.endsWith(oe)||!ae&&(x===ue||x.endsWith($e)))?ye:null}:ie=function(x,V){return typeof x=="string"&&(x===pe||!ae&&x===ue)?ye:null},ie.allPaths=[(ke?"*/":"./")+ue],ie}function k(ue){try{const ye=new RegExp(`^${n(ue)}$`);return function(ke){return ye.lastIndex=0,typeof ke=="string"&&ye.test(ke)?ue:null}}catch{return o}}function T(ue,ye,ke){return!ue||typeof ye!="string"?!1:O(ue)(ye,void 0,ke)}e.$Nj=T;function O(ue,ye={}){if(!ue)return v;if(typeof ue=="string"||G(ue)){const ke=w(ue,ye);if(ke===o)return v;const ae=function(pe,oe){return!!ke(pe,oe)};return ke.allBasenames&&(ae.allBasenames=ke.allBasenames),ke.allPaths&&(ae.allPaths=ke.allPaths),ae}return C(ue,ye)}e.$Oj=O;function G(ue){const ye=ue;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}e.$Pj=G;function q(ue){return ue.allBasenames||[]}e.$Qj=q;function j(ue){return ue.allPaths||[]}e.$Rj=j;function C(ue,ye){const ke=W(Object.getOwnPropertyNames(ue).map(ie=>N(ie,ue[ie],ye)).filter(ie=>ie!==o)),ae=ke.length;if(!ae)return o;if(!ke.some(ie=>!!ie.requiresSiblings)){if(ae===1)return ke[0];const ie=function(ne,Ie){let Me;for(let Le=0,be=ke.length;Le<be;Le++){const ge=ke[Le](ne,Ie);if(typeof ge=="string")return ge;(0,M.$Tg)(ge)&&(Me||(Me=[]),Me.push(ge))}return Me?(async()=>{for(const Le of Me){const be=await Le;if(typeof be=="string")return be}return null})():null},x=ke.find(ne=>!!ne.allBasenames);x&&(ie.allBasenames=x.allBasenames);const V=ke.reduce((ne,Ie)=>Ie.allPaths?ne.concat(Ie.allPaths):ne,[]);return V.length&&(ie.allPaths=V),ie}const pe=function(ie,x,V){let ne,Ie;for(let Me=0,Le=ke.length;Me<Le;Me++){const be=ke[Me];be.requiresSiblings&&V&&(x||(x=(0,L.$nc)(ie)),ne||(ne=x.substr(0,x.length-(0,L.$oc)(ie).length)));const ge=be(ie,x,ne,V);if(typeof ge=="string")return ge;(0,M.$Tg)(ge)&&(Ie||(Ie=[]),Ie.push(ge))}return Ie?(async()=>{for(const Me of Ie){const Le=await Me;if(typeof Le=="string")return Le}return null})():null},oe=ke.find(ie=>!!ie.allBasenames);oe&&(pe.allBasenames=oe.allBasenames);const $e=ke.reduce((ie,x)=>x.allPaths?ie.concat(x.allPaths):ie,[]);return $e.length&&(pe.allPaths=$e),pe}function N(ue,ye,ke){if(ye===!1)return o;const ae=w(ue,ke);if(ae===o)return o;if(typeof ye=="boolean")return ae;if(ye){const pe=ye.when;if(typeof pe=="string"){const oe=($e,ie,x,V)=>{if(!V||!ae($e,ie))return null;const ne=pe.replace("$(basename)",()=>x),Ie=V(ne);return(0,M.$Tg)(Ie)?Ie.then(Me=>Me?ue:null):Ie?ue:null};return oe.requiresSiblings=!0,oe}}return ae}function W(ue,ye){const ke=ue.filter(ie=>!!ie.basenames);if(ke.length<2)return ue;const ae=ke.reduce((ie,x)=>{const V=x.basenames;return V?ie.concat(V):ie},[]);let pe;if(ye){pe=[];for(let ie=0,x=ae.length;ie<x;ie++)pe.push(ye)}else pe=ke.reduce((ie,x)=>{const V=x.patterns;return V?ie.concat(V):ie},[]);const oe=function(ie,x){if(typeof ie!="string")return null;if(!x){let ne;for(ne=ie.length;ne>0;ne--){const Ie=ie.charCodeAt(ne-1);if(Ie===47||Ie===92)break}x=ie.substr(ne)}const V=ae.indexOf(x);return V!==-1?pe[V]:null};oe.basenames=ae,oe.patterns=pe,oe.allBasenames=ae;const $e=ue.filter(ie=>!ie.basenames);return $e.push(oe),$e}function se(ue,ye){return(0,S.$ub)(ue,ye,(ke,ae)=>typeof ke=="string"&&typeof ae=="string"?ke===ae:typeof ke!="string"&&typeof ae!="string"?ke.base===ae.base&&ke.pattern===ae.pattern:!1)}e.$Sj=se}),define(Re[52],Ae([1,0,15,126,25,13,2]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(g||(e.MarkdownStringTextNewlineStyle=g={}));class h{constructor(t="",s=!1){if(this.value=t,typeof this.value!="string")throw(0,S.$7)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(t,s=0){return this.value+=l(this.supportThemeIcons?(0,M.$dk)(t):t).replace(/([ \t]+)/g,(a,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(t){return this.value+=t,this}appendCodeblock(t,s){return this.value+=`
${p(s,t)}
`,this}appendLink(t,s,a){return this.value+="[",this.value+=this.c(s,"]"),this.value+="](",this.value+=this.c(String(t),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(t,s){const a=new RegExp((0,R.$Pe)(s),"g");return t.replace(a,(u,i)=>t.charAt(i-1)!=="\\"?`\\${u}`:u)}}e.$jk=h;function E(r){return A(r)?!r.value:Array.isArray(r)?r.every(E):!0}e.$kk=E;function A(r){return r instanceof h?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.$lk=A;function D(r,t){return r===t?!0:!r||!t?!1:r.value===t.value&&r.isTrusted===t.isTrusted&&r.supportThemeIcons===t.supportThemeIcons&&r.supportHtml===t.supportHtml&&(r.baseUri===t.baseUri||!!r.baseUri&&!!t.baseUri&&(0,I.$Bg)(L.URI.from(r.baseUri),L.URI.from(t.baseUri)))}e.$mk=D;function l(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$nk=l;function p(r,t){const s=r.match(/^`+/gm)?.reduce((u,i)=>u.length>i.length?u:i).length??0,a=s>=3?s+1:3;return[`${"`".repeat(a)}${t}`,r,`${"`".repeat(a)}`].join(`
`)}e.$ok=p;function $(r){return r.replace(/"/g,"&quot;")}e.$pk=$;function n(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$qk=n;function c(r){const t=[],s=r.split("|").map(u=>u.trim());r=s[0];const a=s[1];if(a){const u=/height=(\d+)/.exec(a),i=/width=(\d+)/.exec(a),v=u?u[1]:"",o=i?i[1]:"",w=isFinite(parseInt(o)),y=isFinite(parseInt(v));w&&t.push(`width="${o}"`),y&&t.push(`height="${v}"`)}return{href:r,dimensions:t}}e.$rk=c}),define(Re[95],Ae([1,0,18,45,19,20,25,13]),function(me,e,S,M,I,R,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=void 0;function h(w,y){const{os:d,tildify:b,relative:P}=y;if(P){const k=E(w,P,d);if(typeof k=="string")return k}let f=w.fsPath;if(d===1&&!R.$i?f=f.replace(/\//g,"\\"):d!==1&&R.$i&&(f=f.replace(/\\/g,"/")),d!==1&&b?.userHome){const k=b.userHome.fsPath;let T;w.scheme!==b.userHome.scheme&&w.path[0]===I.$gc.sep&&w.path[1]!==I.$gc.sep?T=b.userHome.with({path:w.path}).fsPath:T=f,f=l(T,k,d)}return(d===1?I.$fc:I.$gc).normalize(A(f,d===1))}e.$Xv=h;function E(w,y,d){const b=d===1?I.$fc:I.$gc,P=d===3?L.$yg:L.$Ag,f=y.getWorkspace(),m=(0,S.$Ob)(f.folders);if(!m)return;w.scheme!==m.uri.scheme&&w.path[0]===I.$gc.sep&&w.path[1]!==I.$gc.sep&&(w=m.uri.with({path:w.path}));const k=y.getWorkspaceFolder(w);if(!k)return;let T;if(P.isEqual(k.uri,w)?T="":T=P.relativePath(k.uri,w)??"",T&&(T=b.normalize(T)),f.folders.length>1&&!y.noPrefix){const O=k.name?k.name:P.basenameOrAuthority(k.uri);T=T?`${O} \u2022 ${T}`:O}return T}function A(w,y=R.$i){return(0,M.$ag)(w,y)?w.charAt(0).toUpperCase()+w.slice(1):w}e.$Yv=A;let D=Object.create(null);function l(w,y,d=R.OS){if(d===1||!w||!y)return w;let b=D.original===y?D.normalized:void 0;b||(b=y,R.$i&&(b=(0,M.$3f)(b)),b=`${(0,g.$Ve)(b,I.$gc.sep)}${I.$gc.sep}`,D={original:y,normalized:b});let P=w;return R.$i&&(P=(0,M.$3f)(P)),(d===3?P.startsWith(b):(0,g.$bf)(P,b))?`~/${P.substr(b.length)}`:w}e.$Zv=l;function p(w,y){return w.replace(/^~($|\/|\\)/,`${y}$1`)}e.$1v=p;const $="\u2026",n="\\\\",c="~";function r(w,y=I.sep){const d=new Array(w.length);let b=!1;for(let P=0;P<w.length;P++){const f=w[P];if(f===""){d[P]=`.${y}`;continue}if(!f){d[P]=f;continue}b=!0;let m="",k=f;k.indexOf(n)===0?(m=k.substr(0,k.indexOf(n)+n.length),k=k.substr(k.indexOf(n)+n.length)):k.indexOf(y)===0?(m=k.substr(0,k.indexOf(y)+y.length),k=k.substr(k.indexOf(y)+y.length)):k.indexOf(c)===0&&(m=k.substr(0,k.indexOf(c)+c.length),k=k.substr(k.indexOf(c)+c.length));const T=k.split(y);for(let O=1;b&&O<=T.length;O++)for(let G=T.length-O;b&&G>=0;G--){b=!1;let q=T.slice(G,G+O).join(y);for(let j=0;!b&&j<w.length;j++)if(j!==P&&w[j]&&w[j].indexOf(q)>-1){const C=G+O===T.length,N=G>0&&w[j].indexOf(y)>-1?y+q:q,W=w[j].endsWith(N);b=!C||W}if(!b){let j="";(T[0].endsWith(":")||m!=="")&&(G===1&&(G=0,O++,q=T[0]+y+q),G>0&&(j=T[0]+y),j=m+j),G>0&&(j=j+$+y),j=j+q,G+O<T.length&&(j=j+y+$),d[P]=j}}b&&(d[P]=f)}return d}e.$2v=r;var t;(function(w){w[w.TEXT=0]="TEXT",w[w.VARIABLE=1]="VARIABLE",w[w.SEPARATOR=2]="SEPARATOR"})(t||(t={}));function s(w,y=Object.create(null)){const d=[];let b=!1,P="";for(const f of w)if(f==="$"||b&&f==="{")P&&d.push({value:P,type:t.TEXT}),P="",b=!0;else if(f==="}"&&b){const m=y[P];if(typeof m=="string")m.length&&d.push({value:m,type:t.VARIABLE});else if(m){const k=d[d.length-1];(!k||k.type!==t.SEPARATOR)&&d.push({value:m.label,type:t.SEPARATOR})}P="",b=!1}else P+=f;return P&&!b&&d.push({value:P,type:t.TEXT}),d.filter((f,m)=>{if(f.type===t.SEPARATOR){const k=d[m-1],T=d[m+1];return[k,T].every(O=>O&&(O.type===t.VARIABLE||O.type===t.TEXT)&&O.value.length>0)}return!0}).map(f=>f.value).join("")}e.$3v=s;function a(w,y){return R.$j||y?w.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):w.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$4v=a;function u(w,y){return R.$j||y?w.replace(/\(&&\w\)|&&/g,""):R.$i?w.replace(/&&|&/g,d=>d==="&"?"&&":"&"):w.replace(/&&/g,"_")}e.$5v=u;function i(w){return w.replace(/&/g,"&&")}e.$6v=i;function v(w){if(w.endsWith("]")){const y=w.lastIndexOf(" [",w.length-2);if(y!==-1){const d=o(w.substring(0,y)),b=w.substring(y);return{name:d.name+b,parentPath:d.parentPath}}}return o(w)}e.$7v=v;function o(w){const y=w.indexOf("/")!==-1?I.$gc:I.$fc,d=y.basename(w),b=y.dirname(w);return d.length?{name:d,parentPath:b}:{name:b,parentPath:""}}}),define(Re[139],Ae([1,0,23,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function I(D){return D.toJSON()}class R{constructor(l){this.a=l}transformIncoming(l){const p=this.a.transformIncoming(l);return p===l?l:I(M.URI.from(p))}transformOutgoing(l){const p=this.a.transformOutgoing(l);return p===l?l:I(M.URI.from(p))}transformOutgoingURI(l){const p=this.a.transformOutgoing(l);return p===l?l:M.URI.from(p)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$7m=R,e.$8m=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function L(D,l,p){if(!D||p>200)return null;if(typeof D=="object"){if(D instanceof M.URI)return l.transformOutgoing(D);for(const $ in D)if(Object.hasOwnProperty.call(D,$)){const n=L(D[$],l,p+1);n!==null&&(D[$]=n)}}return null}function g(D,l){const p=L(D,l,0);return p===null?D:p}e.$9m=g;function h(D,l,p,$){if(!D||$>200)return null;if(typeof D=="object"){if(D.$mid===1)return p?M.URI.revive(l.transformIncoming(D)):l.transformIncoming(D);if(D instanceof S.$ke)return null;for(const n in D)if(Object.hasOwnProperty.call(D,n)){const c=h(D[n],l,p,$+1);c!==null&&(D[n]=c)}}return null}function E(D,l){const p=h(D,l,!1,0);return p===null?D:p}e.$0m=E;function A(D,l){const p=h(D,l,!0,0);return p===null?D:p}e.$$m=A}),define(Re[140],Ae([1,0,13,20,23]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=void 0;let R;function L(){return R||(R=new TextDecoder("UTF-16LE")),R}let g;function h(){return g||(g=new TextDecoder("UTF-16BE")),g}let E;function A(){return E||(E=M.$D()?L():h()),E}e.$ct=A;function D($,n,c){const r=new Uint16Array($.buffer,n,c);return c>0&&(r[0]===65279||r[0]===65534)?l($,n,c):L().decode(r)}e.$dt=D;function l($,n,c){const r=[];let t=0;for(let s=0;s<c;s++){const a=I.$me($,n);n+=2,r[t++]=String.fromCharCode(a)}return r.join("")}class p{constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return A().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const c=this.a-this.d;c<=1&&(c===0||S.$ef(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const c=n.length;if(this.d+c>=this.a){this.f(),this.c[this.c.length]=n;return}for(let r=0;r<c;r++)this.b[this.d++]=n.charCodeAt(r)}}e.$et=p}),define(Re[141],Ae([1,0,23,140]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=void 0;function I(h){return h.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,A,D,l){this.oldPosition=E,this.oldText=A,this.newPosition=D,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,A,D){const l=A.length;S.$pe(E,l,D),D+=4;for(let p=0;p<l;p++)S.$ne(E,A.charCodeAt(p),D),D+=2;return D}static d(E,A){const D=S.$oe(E,A);return A+=4,(0,M.$dt)(E,A,D)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(E,A){return S.$pe(E,this.oldPosition,A),A+=4,S.$pe(E,this.newPosition,A),A+=4,A=R.c(E,this.oldText,A),A=R.c(E,this.newText,A),A}static read(E,A,D){const l=S.$oe(E,A);A+=4;const p=S.$oe(E,A);A+=4;const $=R.d(E,A);A+=R.a($);const n=R.d(E,A);return A+=R.a(n),D.push(new R(l,$,p,n)),A}}e.$ft=R;function L(h,E){return h===null||h.length===0?E:new g(h,E).compress()}e.$gt=L;class g{constructor(E,A){this.a=E,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,A=0,D=this.n(E),l=this.l(A);for(;E<this.f||A<this.h;){if(D===null){this.k(l),l=this.l(++A);continue}if(l===null){this.m(D),D=this.n(++E);continue}if(l.oldEnd<=D.newPosition){this.k(l),l=this.l(++A);continue}if(D.newEnd<=l.oldPosition){this.m(D),D=this.n(++E);continue}if(l.oldPosition<D.newPosition){const[r,t]=g.r(l,D.newPosition-l.oldPosition);this.k(r),l=t;continue}if(D.newPosition<l.oldPosition){const[r,t]=g.q(D,l.oldPosition-D.newPosition);this.m(r),D=t;continue}let n,c;if(l.oldEnd===D.newEnd)n=D,c=l,D=this.n(++E),l=this.l(++A);else if(l.oldEnd<D.newEnd){const[r,t]=g.q(D,l.oldLength);n=r,c=l,D=t,l=this.l(++A)}else{const[r,t]=g.r(l,D.newLength);n=D,c=r,D=this.n(++E),l=t}this.d[this.e++]=new R(n.oldPosition,n.oldText,c.newPosition,c.newText),this.g+=n.newLength-n.oldLength,this.j+=c.newLength-c.oldLength}const p=g.s(this.d);return g.t(p)}k(E){this.d[this.e++]=g.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=g.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,A){return new R(A.oldPosition-E,A.oldText,A.newPosition,A.newText)}static p(E,A){return new R(A.oldPosition,A.oldText,A.newPosition+E,A.newText)}static q(E,A){const D=E.newText.substr(0,A),l=E.newText.substr(A);return[new R(E.oldPosition,E.oldText,E.newPosition,D),new R(E.oldEnd,"",E.newPosition+A,l)]}static r(E,A){const D=E.oldText.substr(0,A),l=E.oldText.substr(A);return[new R(E.oldPosition,D,E.newPosition,E.newText),new R(E.oldPosition+A,l,E.newEnd,"")]}static s(E){if(E.length===0)return E;const A=[];let D=0,l=E[0];for(let p=1;p<E.length;p++){const $=E[p];l.oldEnd===$.oldPosition?l=new R(l.oldPosition,l.oldText+$.oldText,l.newPosition,l.newText+$.newText):(A[D++]=l,l=$)}return A[D++]=l,A}static t(E){if(E.length===0)return E;const A=[];let D=0;for(let l=0;l<E.length;l++){const p=E[l];p.oldText!==p.newText&&(A[D++]=p)}return A}}}),define(Re[142],Ae([1,0,34,19]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=void 0;function I(R,L,g,h,E,A){if(Array.isArray(R)){let D=0;for(const l of R){const p=I(l,L,g,h,E,A);if(p===10)return p;p>D&&(D=p)}return D}else{if(typeof R=="string")return h?R==="*"?5:R===g?10:0:0;if(R){const{language:D,pattern:l,scheme:p,hasAccessToAllModels:$,notebookType:n}=R;if(!h&&!$)return 0;n&&E&&(L=E);let c=0;if(p)if(p===L.scheme)c=10;else if(p==="*")c=5;else return 0;if(D)if(D===g)c=10;else if(D==="*")c=Math.max(c,5);else return 0;if(n)if(n===A)c=10;else if(n==="*"&&A!==void 0)c=Math.max(c,5);else return 0;if(l){let r;if(typeof l=="string"?r=l:r={...l,base:(0,M.$hc)(l.base)},r===L.fsPath||(0,S.$Nj)(r,L.fsPath))c=10;else return 0}return c}else return 0}}e.$Dt=I}),define(Re[143],Ae([1,0,5,13,29,93,91,128,141,6]),function(me,e,S,M,I,R,L,g,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=void 0;class A extends E.$Tc{constructor(l,p,$,n,c,r,t){super(),this.m=this.B(new S.$Wd),this.onDidChangeContent=this.m.event,this.f=p,this.j=!r,this.g=n,this.h=c,this.c=new L.$cC(l,$,t)}equals(l){return!(l instanceof A)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,p){return this.c.getOffsetAt(l,p)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,p){const $=l+p,n=this.getPositionAt(l),c=this.getPositionAt($);return new I.$Ws(n.lineNumber,n.column,c.lineNumber,c.column)}getValueInRange(l,p=0){if(l.isEmpty())return"";const $=this.n(p);return this.c.getValueInRange(l,$)}getValueLengthInRange(l,p=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const $=this.getOffsetAt(l.startLineNumber,l.startColumn),n=this.getOffsetAt(l.endLineNumber,l.endColumn);let c=0;const r=this.n(p),t=this.getEOL();if(r.length!==t.length){const s=r.length-t.length,a=l.endLineNumber-l.startLineNumber;c=s*a}return n-$+c}getCharacterCountInRange(l,p=0){if(this.j){let $=0;const n=l.startLineNumber,c=l.endLineNumber;for(let r=n;r<=c;r++){const t=this.getLineContent(r),s=r===n?l.startColumn-1:0,a=r===c?l.endColumn-1:t.length;for(let u=s;u<a;u++)M.$ef(t.charCodeAt(u))?($=$+1,u=u+1):$=$+1}return $+=this.n(p).length*(c-n),$}return this.getValueLengthInRange(l,p)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,p){return this.c.getLineCharCode(l,p)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const p=M.$2e(this.getLineContent(l));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(l){const p=M.$4e(this.getLineContent(l));return p===-1?0:p+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,p,$){let n=this.g,c=this.h,r=this.j,t=!0,s=[];for(let y=0;y<l.length;y++){const d=l[y];t&&d._isTracked&&(t=!1);const b=d.range;if(d.text){let T=!0;r||(T=!M.$pf(d.text),r=T),!n&&T&&(n=M.$of(d.text)),!c&&T&&(c=M.$rf(d.text))}let P="",f=0,m=0,k=0;if(d.text){let T;[f,m,k,T]=(0,g.$wt)(d.text);const O=this.getEOL();T===0||T===(O===`\r
`?2:1)?P=d.text:P=d.text.replace(/\r\n|\r|\n/g,O)}s[y]={sortIndex:y,identifier:d.identifier||null,range:b,rangeOffset:this.getOffsetAt(b.startLineNumber,b.startColumn),rangeLength:this.getValueLengthInRange(b),text:P,eolCount:f,firstLineLength:m,lastLineLength:k,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}s.sort(A.u);let a=!1;for(let y=0,d=s.length-1;y<d;y++){const b=s[y].range.getEndPosition(),P=s[y+1].range.getStartPosition();if(P.isBeforeOrEqual(b)){if(P.isBefore(b))throw new Error("Overlapping ranges are not allowed!");a=!0}}t&&(s=this.s(s));const u=$||p?A._getInverseEditRanges(s):[],i=[];if(p)for(let y=0;y<s.length;y++){const d=s[y],b=u[y];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let P=b.startLineNumber;P<=b.endLineNumber;P++){let f="";P===b.startLineNumber&&(f=this.getLineContent(d.range.startLineNumber),M.$2e(f)!==-1)||i.push({lineNumber:P,oldContent:f})}}let v=null;if($){let y=0;v=[];for(let d=0;d<s.length;d++){const b=s[d],P=u[d],f=this.getValueInRange(b.range),m=b.rangeOffset+y;y+=b.text.length-f.length,v[d]={sortIndex:b.sortIndex,identifier:b.identifier,range:P,text:f,textChange:new h.$ft(b.rangeOffset,f,m,b.text)}}a||v.sort((d,b)=>d.sortIndex-b.sortIndex)}this.g=n,this.h=c,this.j=r;const o=this.t(s);let w=null;if(p&&i.length>0){i.sort((y,d)=>d.lineNumber-y.lineNumber),w=[];for(let y=0,d=i.length;y<d;y++){const b=i[y].lineNumber;if(y>0&&i[y-1].lineNumber===b)continue;const P=i[y].oldContent,f=this.getLineContent(b);f.length===0||f===P||M.$2e(f)!==-1||w.push(b)}}return this.m.fire(),new R.$gv(v,o,w)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let p=!1;const $=l[0].range,n=l[l.length-1].range,c=new I.$Ws($.startLineNumber,$.startColumn,n.endLineNumber,n.endColumn);let r=$.startLineNumber,t=$.startColumn;const s=[];for(let o=0,w=l.length;o<w;o++){const y=l[o],d=y.range;p=p||y.forceMoveMarkers,s.push(this.getValueInRange(new I.$Ws(r,t,d.startLineNumber,d.startColumn))),y.text.length>0&&s.push(y.text),r=d.endLineNumber,t=d.endColumn}const a=s.join(""),[u,i,v]=(0,g.$wt)(a);return{sortIndex:0,identifier:l[0].identifier,range:c,rangeOffset:this.getOffsetAt(c.startLineNumber,c.startColumn),rangeLength:this.getValueLengthInRange(c,0),text:a,eolCount:u,firstLineLength:i,lastLineLength:v,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}t(l){l.sort(A.w);const p=[];for(let $=0;$<l.length;$++){const n=l[$],c=n.range.startLineNumber,r=n.range.startColumn,t=n.range.endLineNumber,s=n.range.endColumn;if(c===t&&r===s&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const a=new I.$Ws(c,r,t,s);p.push({range:a,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return p}findMatchesLineByLine(l,p,$,n){return this.c.findMatchesLineByLine(l,p,$,n)}getPieceTree(){return this.c}static _getInverseEditRange(l,p){const $=l.startLineNumber,n=l.startColumn,[c,r,t]=(0,g.$wt)(p);let s;if(p.length>0){const a=c+1;a===1?s=new I.$Ws($,n,$,n+r):s=new I.$Ws($,n,$+a-1,t+1)}else s=new I.$Ws($,n,$,n);return s}static _getInverseEditRanges(l){const p=[];let $=0,n=0,c=null;for(let r=0,t=l.length;r<t;r++){const s=l[r];let a,u;c?c.range.endLineNumber===s.range.startLineNumber?(a=$,u=n+(s.range.startColumn-c.range.endColumn)):(a=$+(s.range.startLineNumber-c.range.endLineNumber),u=s.range.startColumn):(a=s.range.startLineNumber,u=s.range.startColumn);let i;if(s.text.length>0){const v=s.eolCount+1;v===1?i=new I.$Ws(a,u,a,u+s.firstLineLength):i=new I.$Ws(a,u,a+v-1,s.lastLineLength+1)}else i=new I.$Ws(a,u,a,u);$=i.endLineNumber,n=i.endColumn,p.push(i),c=s}return p}static u(l,p){const $=I.$Ws.compareRangesUsingEnds(l.range,p.range);return $===0?l.sortIndex-p.sortIndex:$}static w(l,p){const $=I.$Ws.compareRangesUsingEnds(l.range,p.range);return $===0?p.sortIndex-l.sortIndex:-$}}e.$dC=A}),define(Re[144],Ae([1,0,13,91,143]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=void 0;class R{constructor(h,E,A,D,l,p,$,n,c){this.a=h,this.b=E,this.c=A,this.d=D,this.e=l,this.f=p,this.g=$,this.h=n,this.j=c}k(h){const E=this.c+this.d+this.e,A=this.c+this.e;return E===0?h===1?`
`:`\r
`:A>E/2?`\r
`:`
`}create(h){const E=this.k(h),A=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let l=0,p=A.length;l<p;l++){const $=A[l].buffer.replace(/\r\n|\r|\n/g,E),n=(0,M.$$B)($);A[l]=new M.$bC($,n)}const D=new I.$dC(A,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(h){return this.a[0].buffer.substr(0,h).split(/\r\n|\r|\n/)[0]}}class L{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(h){if(h.length===0)return;this.a.length===0&&S.$xf(h)&&(this.b=S.$wf,h=h.substr(1));const E=h.charCodeAt(h.length-1);E===13||E>=55296&&E<=56319?(this.m(h.substr(0,h.length-1),!1),this.c=!0,this.d=E):(this.m(h,!1),this.c=!1,this.d=E)}m(h,E){!E&&h.length===0||(this.c?this.n(String.fromCharCode(this.d)+h):this.n(h))}n(h){const E=(0,M.$_B)(this.e,h);this.a.push(new M.$bC(h,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=S.$of(h)),this.k||(this.k=S.$rf(h)))}finish(h=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,h)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const h=this.a[this.a.length-1];h.buffer+=String.fromCharCode(this.d);const E=(0,M.$$B)(h.buffer);h.lineStarts=E,this.d===13&&this.f++}}}e.$eC=L}),define(Re[96],Ae([1,0,23,20]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O$=e.$N$=void 0;var I;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(I||(I={}));function R(D){for(let l=0,p=D.length;l<p;l+=4){const $=D[l+0],n=D[l+1],c=D[l+2],r=D[l+3];D[l+0]=r,D[l+1]=c,D[l+2]=n,D[l+3]=$}}function L(D){const l=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return M.$D()||R(l),S.$ke.wrap(l)}function g(D){const l=D.buffer;if(M.$D()||R(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const p=new Uint8Array(l.byteLength);return p.set(l),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function h(D){const l=new Uint32Array(E(D));let p=0;if(l[p++]=D.id,D.type==="full")l[p++]=1,l[p++]=D.data.length,l.set(D.data,p),p+=D.data.length;else{l[p++]=2,l[p++]=D.deltas.length;for(const $ of D.deltas)l[p++]=$.start,l[p++]=$.deleteCount,$.data?(l[p++]=$.data.length,l.set($.data,p),p+=$.data.length):l[p++]=0}return L(l)}e.$N$=h;function E(D){let l=0;if(l+=2,D.type==="full")l+=1+D.data.length;else{l+=1,l+=3*D.deltas.length;for(const p of D.deltas)p.data&&(l+=p.data.length)}return l}function A(D){const l=g(D);let p=0;const $=l[p++];if(l[p++]===1){const t=l[p++],s=l.subarray(p,p+t);return p+=t,{id:$,type:"full",data:s}}const c=l[p++],r=[];for(let t=0;t<c;t++){const s=l[p++],a=l[p++],u=l[p++];let i;u>0&&(i=l.subarray(p,p+u),p+=u),r[t]={start:s,deleteCount:a,data:i}}return{id:$,type:"delta",deltas:r}}e.$O$=A}),define(Re[145],Ae([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Re[146],Ae([1,0,18,26,20,129,147,145]),function(me,e,S,M,I,R,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var h;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(h||(e.EditorAutoIndentStrategy=h={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=E;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class D{constructor(X,ve,Be,Qe){this.id=X,this.name=ve,this.defaultValue=Be,this.schema=Qe}applyUpdate(X,ve){return p(X,ve)}compute(X,ve,Be){return Be}}class l{constructor(X,ve){this.newValue=X,this.didChange=ve}}e.ApplyUpdateResult=l;function p(Y,X){if(typeof Y!="object"||typeof X!="object"||!Y||!X)return new l(X,Y!==X);if(Array.isArray(Y)||Array.isArray(X)){const Be=Array.isArray(Y)&&Array.isArray(X)&&S.$ub(Y,X);return new l(X,!Be)}let ve=!1;for(const Be in X)if(X.hasOwnProperty(Be)){const Qe=p(Y[Be],X[Be]);Qe.didChange&&(Y[Be]=Qe.newValue,ve=!0)}return new l(Y,ve)}class ${constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,ve){return p(X,ve)}validate(X){return this.defaultValue}}class n{constructor(X,ve,Be,Qe){this.id=X,this.name=ve,this.defaultValue=Be,this.schema=Qe}applyUpdate(X,ve){return p(X,ve)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,ve,Be){return Be}}function c(Y,X){return typeof Y>"u"?X:Y==="false"?!1:!!Y}e.boolean=c;class r extends n{constructor(X,ve,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Be),super(X,ve,Be,Qe)}validate(X){return c(X,this.defaultValue)}}function t(Y,X,ve,Be){if(typeof Y>"u")return X;let Qe=parseInt(Y,10);return isNaN(Qe)?X:(Qe=Math.max(ve,Qe),Qe=Math.min(Be,Qe),Qe|0)}e.clampedInt=t;class s extends n{static clampedInt(X,ve,Be,Qe){return t(X,ve,Be,Qe)}constructor(X,ve,Be,Qe,tt,ot=void 0){typeof ot<"u"&&(ot.type="integer",ot.default=Be,ot.minimum=Qe,ot.maximum=tt),super(X,ve,Be,ot),this.minimum=Qe,this.maximum=tt}validate(X){return s.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function a(Y,X,ve,Be){if(typeof Y>"u")return X;const Qe=u.float(Y,X);return u.clamp(Qe,ve,Be)}e.clampedFloat=a;class u extends n{static clamp(X,ve,Be){return X<ve?ve:X>Be?Be:X}static float(X,ve){if(typeof X=="number")return X;if(typeof X>"u")return ve;const Be=parseFloat(X);return isNaN(Be)?ve:Be}constructor(X,ve,Be,Qe,tt){typeof tt<"u"&&(tt.type="number",tt.default=Be),super(X,ve,Be,tt),this.validationFn=Qe}validate(X){return this.validationFn(u.float(X,this.defaultValue))}}class i extends n{static string(X,ve){return typeof X!="string"?ve:X}constructor(X,ve,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Be),super(X,ve,Be,Qe)}validate(X){return i.string(X,this.defaultValue)}}function v(Y,X,ve,Be){return typeof Y!="string"?X:Be&&Y in Be?Be[Y]:ve.indexOf(Y)===-1?X:Y}e.stringSet=v;class o extends n{constructor(X,ve,Be,Qe,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Qe,tt.default=Be),super(X,ve,Be,tt),this.c=Qe}validate(X){return v(X,this.defaultValue,this.c)}}class w extends D{constructor(X,ve,Be,Qe,tt,ot,Te=void 0){typeof Te<"u"&&(Te.type="string",Te.enum=tt,Te.default=Qe),super(X,ve,Be,Te),this.c=tt,this.d=ot}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function y(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",tags:["accessibility"],description:g.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ve,Be){return Be===0?X.accessibilitySupport:Be}}class b extends D{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:g.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertSpace:c(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var P;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(P||(e.TextEditorCursorBlinkingStyle=P={}));function f(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(m||(e.TextEditorCursorStyle=m={}));function k(Y){switch(Y){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function T(Y){switch(Y){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class O extends ${constructor(){super(140)}compute(X,ve,Be){const Qe=["monaco-editor"];return ve.get(39)&&Qe.push(ve.get(39)),X.extraEditorClassName&&Qe.push(X.extraEditorClassName),ve.get(73)==="default"?Qe.push("mouse-default"):ve.get(73)==="copy"&&Qe.push("mouse-copy"),ve.get(110)&&Qe.push("showUnused"),ve.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class G extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(X,ve,Be){return Be&&X.emptySelectionClipboard}}class q extends D{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:g.localize(16,null),included:I.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:g.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{cursorMoveOnType:c(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":v(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":v(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(ve.loop,this.defaultValue.loop)}}}class j extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?j.OFF:X==="true"?j.ON:X:X?j.ON:j.OFF}}e.EditorFontLigatures=j;class C extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:g.localize(22,null)},{type:"string",description:g.localize(23,null)}],description:g.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?C.OFF:X==="true"?C.TRANSLATE:X:X?C.TRANSLATE:C.OFF}compute(X,ve,Be){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class N extends ${constructor(){super(50)}compute(X,ve,Be){return X.fontInfo}}class W extends n{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(25,null)})}validate(X){const ve=u.float(X,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(ve,6,100)}compute(X,ve,Be){return X.fontInfo.fontSize}}class se extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:se.d,maximum:se.e,errorMessage:g.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:se.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(s.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,se.d,se.e))}}class ue extends D{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[g.localize(28,null),g.localize(29,null),g.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:g.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:g.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:g.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Be,description:g.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Be,description:g.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Be,description:g.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Be,description:g.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Be,description:g.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{multiple:v(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??v(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??v(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??v(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??v(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??v(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends D{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:g.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:g.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:g.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:g.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:g.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),delay:s.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:c(ve.sticky,this.defaultValue.sticky),hidingDelay:s.clampedInt(ve.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:c(ve.above,this.defaultValue.above)}}}var ke;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class ae extends ${constructor(){super(143)}compute(X,ve,Be){return ae.computeLayout(ve,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const ve=X.height/X.lineHeight,Be=Math.floor(X.paddingTop/X.lineHeight);let Qe=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Qe=Math.max(Qe,ve-1));const tt=(Be+X.viewLineCount+Qe)/(X.pixelRatio*X.height),ot=Math.floor(X.viewLineCount/tt);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Qe,desiredRatio:tt,minimapLineCount:ot}}static c(X,ve){const Be=X.outerWidth,Qe=X.outerHeight,tt=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const ot=ve.stableMinimapLayoutInput,Te=ot&&X.outerHeight===ot.outerHeight&&X.lineHeight===ot.lineHeight&&X.typicalHalfwidthCharacterWidth===ot.typicalHalfwidthCharacterWidth&&X.pixelRatio===ot.pixelRatio&&X.scrollBeyondLastLine===ot.scrollBeyondLastLine&&X.paddingTop===ot.paddingTop&&X.paddingBottom===ot.paddingBottom&&X.minimap.enabled===ot.minimap.enabled&&X.minimap.side===ot.minimap.side&&X.minimap.size===ot.minimap.size&&X.minimap.showSlider===ot.minimap.showSlider&&X.minimap.renderCharacters===ot.minimap.renderCharacters&&X.minimap.maxColumn===ot.minimap.maxColumn&&X.minimap.scale===ot.minimap.scale&&X.verticalScrollbarWidth===ot.verticalScrollbarWidth&&X.isViewportWrapping===ot.isViewportWrapping,zt=X.lineHeight,Rt=X.typicalHalfwidthCharacterWidth,Gt=X.scrollBeyondLastLine,Ft=X.minimap.renderCharacters;let yt=tt>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const qt=X.minimap.maxColumn,Tt=X.minimap.size,Yt=X.minimap.side,Wt=X.verticalScrollbarWidth,jt=X.viewLineCount,Xe=X.remainingWidth,Ht=X.isViewportWrapping,Jt=Ft?2:3;let lt=Math.floor(tt*Qe);const $t=lt/tt;let Ut=!1,Qt=!1,Et=Jt*yt,dt=yt/tt,St=1;if(Tt==="fill"||Tt==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Mt,extraLinesBeyondLastLine:It,desiredRatio:Bt,minimapLineCount:De}=ae.computeContainedMinimapLineCount({viewLineCount:jt,scrollBeyondLastLine:Gt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Qe,lineHeight:zt,pixelRatio:tt});if(jt/De>1)Ut=!0,Qt=!0,yt=1,Et=1,dt=yt/tt;else{let he=!1,Z=yt+1;if(Tt==="fit"){const Pe=Math.ceil((Mt+jt+It)*Et);Ht&&Te&&Xe<=ve.stableFitRemainingWidth?(he=!0,Z=ve.stableFitMaxMinimapScale):he=Pe>lt}if(Tt==="fill"||he){Ut=!0;const Pe=yt;Et=Math.min(zt*tt,Math.max(1,Math.floor(1/Bt))),Ht&&Te&&Xe<=ve.stableFitRemainingWidth&&(Z=ve.stableFitMaxMinimapScale),yt=Math.min(Z,Math.max(1,Math.floor(Et/Jt))),yt>Pe&&(St=Math.min(2,yt/Pe)),dt=yt/tt/St,lt=Math.ceil(Math.max(ft,Mt+jt+It)*Et),Ht?(ve.stableMinimapLayoutInput=X,ve.stableFitRemainingWidth=Xe,ve.stableFitMaxMinimapScale=yt):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const _t=Math.floor(qt*dt),Pt=Math.min(_t,Math.max(0,Math.floor((Xe-Wt-2)*dt/(Rt+dt)))+e.MINIMAP_GUTTER_WIDTH);let He=Math.floor(tt*Pt);const At=He/tt;He=Math.floor(He*St);const Nt=Ft?1:2,Zt=Yt==="left"?0:Be-Pt-Wt;return{renderMinimap:Nt,minimapLeft:Zt,minimapWidth:Pt,minimapHeightIsEditorHeight:Ut,minimapIsSampling:Qt,minimapScale:yt,minimapLineHeight:Et,minimapCanvasInnerWidth:He,minimapCanvasInnerHeight:lt,minimapCanvasOuterWidth:At,minimapCanvasOuterHeight:$t}}static computeLayout(X,ve){const Be=ve.outerWidth|0,Qe=ve.outerHeight|0,tt=ve.lineHeight|0,ot=ve.lineNumbersDigitCount|0,Te=ve.typicalHalfwidthCharacterWidth,zt=ve.maxDigitWidth,Rt=ve.pixelRatio,Gt=ve.viewLineCount,Ft=X.get(135),yt=Ft==="inherit"?X.get(134):Ft,qt=yt==="inherit"?X.get(130):yt,Tt=X.get(133),Yt=ve.isDominatedByLongLines,Wt=X.get(57),jt=X.get(67).renderType!==0,Xe=X.get(68),Ht=X.get(104),Jt=X.get(83),lt=X.get(72),$t=X.get(102),Ut=$t.verticalScrollbarSize,Qt=$t.verticalHasArrows,Et=$t.arrowSize,dt=$t.horizontalScrollbarSize,St=X.get(43),_t=X.get(109)!=="never";let Pt=X.get(65);St&&_t&&(Pt+=16);let He=0;if(jt){const Ze=Math.max(ot,Xe);He=Math.round(Ze*zt)}let At=0;Wt&&(At=tt*ve.glyphMarginDecorationLaneCount);let Nt=0,Zt=Nt+At,ft=Zt+He,Mt=ft+Pt;const It=Be-At-He-Pt;let Bt=!1,De=!1,Fe=-1;yt==="inherit"&&Yt?(Bt=!0,De=!0):qt==="on"||qt==="bounded"?De=!0:qt==="wordWrapColumn"&&(Fe=Tt);const he=ae.c({outerWidth:Be,outerHeight:Qe,lineHeight:tt,typicalHalfwidthCharacterWidth:Te,pixelRatio:Rt,scrollBeyondLastLine:Ht,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:lt,verticalScrollbarWidth:Ut,viewLineCount:Gt,remainingWidth:It,isViewportWrapping:De},ve.memory||new A);he.renderMinimap!==0&&he.minimapLeft===0&&(Nt+=he.minimapWidth,Zt+=he.minimapWidth,ft+=he.minimapWidth,Mt+=he.minimapWidth);const Z=It-he.minimapWidth,Pe=Math.max(1,Math.floor((Z-Ut-2)/Te)),ze=Qt?Et:0;return De&&(Fe=Math.max(1,Pe),qt==="bounded"&&(Fe=Math.min(Fe,Tt))),{width:Be,height:Qe,glyphMarginLeft:Nt,glyphMarginWidth:At,glyphMarginDecorationLaneCount:ve.glyphMarginDecorationLaneCount,lineNumbersLeft:Zt,lineNumbersWidth:He,decorationsLeft:ft,decorationsWidth:Pt,contentLeft:Mt,contentWidth:Z,minimap:he,viewportColumn:Pe,isWordWrapMinified:Bt,isViewportWrapping:De,wrappingColumn:Fe,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:dt,overviewRuler:{top:ze,width:Ut,height:Qe-2*ze,right:0}}}}e.EditorLayoutInfoComputer=ae;class pe extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[g.localize(47,null),g.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:g.localize(49,null)}})}validate(X){return v(X,"simple",["simple","advanced"])}compute(X,ve,Be){return ve.get(2)===2?"advanced":Be}}var oe;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})(oe||(e.ShowLightbulbIconMode=oe={}));class $e extends D{constructor(){const X={enabled:oe.OnCode};super(64,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[oe.Off,oe.OnCode,oe.On],default:X.enabled,enumDescriptions:[g.localize(50,null),g.localize(51,null),g.localize(52,null)],description:g.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:v(X.enabled,this.defaultValue.enabled,[oe.Off,oe.OnCode,oe.On])}}}class ie extends D{constructor(){const X={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:g.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:g.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:g.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:g.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),maxLineCount:s.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:v(ve.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:c(ve.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class x extends D{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:g.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[g.localize(59,null),g.localize(60,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),g.localize(61,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),g.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:g.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:g.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:g.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:v(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:s.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(ve.fontFamily,this.defaultValue.fontFamily),padding:c(ve.padding,this.defaultValue.padding)}}}class V extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):s.clampedInt(X,this.defaultValue,0,1e3)}compute(X,ve,Be){return Be<0?s.clampedInt(-Be*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class ne extends u{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>u.clamp(X,0,150),{markdownDescription:g.localize(66,null)})}compute(X,ve,Be){return X.fontInfo.lineHeight}}class Ie extends D{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:g.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:g.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(69,null),g.localize(70,null),g.localize(71,null)],default:X.size,description:g.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:g.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:g.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:g.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:g.localize(77,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),autohide:c(ve.autohide,this.defaultValue.autohide),size:v(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(ve.side,this.defaultValue.side,["right","left"]),showSlider:v(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(ve.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(ve.scale,1,1,3),maxColumn:s.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Me(Y){return Y==="ctrlCmd"?I.$j?"metaKey":"ctrlKey":"altKey"}class Le extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(79,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{top:s.clampedInt(ve.top,0,0,1e3),bottom:s.clampedInt(ve.bottom,0,0,1e3)}}}class be extends D{constructor(){const X={enabled:!0,cycle:!0};super(85,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:g.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:g.localize(81,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),cycle:c(ve.cycle,this.defaultValue.cycle)}}}class ge extends ${constructor(){super(141)}compute(X,ve,Be){return X.pixelRatio}}class K extends D{constructor(){const X={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[g.localize(82,null),g.localize(83,null),g.localize(84,null)]}];super(88,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:X.strings,description:g.localize(85,null)},comments:{anyOf:ve,default:X.comments,description:g.localize(86,null)},other:{anyOf:ve,default:X.other,description:g.localize(87,null)}},default:X,markdownDescription:g.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Rt=X?"on":"off";return{comments:Rt,strings:Rt,other:Rt}}if(!X||typeof X!="object")return this.defaultValue;const{other:ve,comments:Be,strings:Qe}=X,tt=["on","inline","off"];let ot,Te,zt;return typeof ve=="boolean"?ot=ve?"on":"off":ot=v(ve,this.defaultValue.other,tt),typeof Be=="boolean"?Te=Be?"on":"off":Te=v(Be,this.defaultValue.comments,tt),typeof Qe=="boolean"?zt=Qe?"on":"off":zt=v(Qe,this.defaultValue.strings,tt),{other:ot,comments:Te,strings:zt}}}var ee;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class le extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(89,null),g.localize(90,null),g.localize(91,null),g.localize(92,null)],default:"on",description:g.localize(93,null)})}validate(X){let ve=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(ve=4,Be=X):X==="interval"?ve=3:X==="relative"?ve=2:X==="on"?ve=1:ve=0),{renderType:ve,renderFn:Be}}}function fe(Y){const X=Y.get(97);return X==="editable"?Y.get(90):X!=="on"}e.filterValidationDecorations=fe;class Ce extends D{constructor(){const X=[],ve={type:"number",description:g.localize(94,null)};super(101,"rulers",X,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:g.localize(95,null),format:"color-hex"}}}]},default:X,description:g.localize(96,null)})}validate(X){if(Array.isArray(X)){const ve=[];for(const Be of X)if(typeof Be=="number")ve.push({column:s.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Qe=Be;ve.push({column:s.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return ve.sort((Be,Qe)=>Be.column-Qe.column),ve}return this.defaultValue}}class de extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function we(Y,X){if(typeof Y!="string")return X;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends D{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(97,null),g.localize(98,null),g.localize(99,null)],default:"auto",description:g.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(101,null),g.localize(102,null),g.localize(103,null)],default:"auto",description:g.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:g.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:g.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:g.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:g.localize(108,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X,Be=s.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=s.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:we(ve.vertical,this.defaultValue.vertical),horizontal:we(ve.horizontal,this.defaultValue.horizontal),useShadows:c(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:s.clampedInt(ve.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:s.clampedInt(ve.verticalSliderSize,Qe,0,1e3),scrollByPage:c(ve.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:c(ve.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends D{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:g.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:g.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:g.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:g.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:g.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:g.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:g.localize(115,null)}})}applyUpdate(X,ve){let Be=!1;ve.allowedCharacters&&X&&(M.$Cn(X.allowedCharacters,ve.allowedCharacters)||(X={...X,allowedCharacters:ve.allowedCharacters},Be=!0)),ve.allowedLocales&&X&&(M.$Cn(X.allowedLocales,ve.allowedLocales)||(X={...X,allowedLocales:ve.allowedLocales},Be=!0));const Qe=super.applyUpdate(X,ve);return Be?new l(Qe.newValue,!0):Qe}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{nonBasicASCII:_(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,ve){if(typeof X!="object"||!X)return ve;const Be={};for(const[Qe,tt]of Object.entries(X))tt===!0&&(Be[Qe]=!0);return Be}}class J extends D{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:g.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[g.localize(117,null),g.localize(118,null),g.localize(119,null)],description:g.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:g.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:g.localize(122,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),mode:v(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:v(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:c(ve.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:c(ve.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:i.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class B extends D{constructor(){const X={enabled:R.$us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:g.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:g.localize(124,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:c(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Q extends D{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(125,null),g.localize(126,null),g.localize(127,null)],default:X.bracketPairs,description:g.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(129,null),g.localize(130,null),g.localize(131,null)],default:X.bracketPairsHorizontal,description:g.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:g.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:g.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[g.localize(135,null),g.localize(136,null),g.localize(137,null)],default:X.highlightActiveIndentation,description:g.localize(138,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{bracketPairs:_(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(Y,X,ve){const Be=ve.indexOf(Y);return Be===-1?X:ve[Be]}class Ee extends D{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(139,null),g.localize(140,null)],default:X.insertMode,description:g.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:g.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:g.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:g.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[g.localize(145,null),g.localize(146,null),g.localize(147,null),g.localize(148,null)],default:X.selectionMode,markdownDescription:g.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:g.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:g.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:g.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:g.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:g.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:g.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(186,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertMode:v(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:v(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:c(ve.showIcons,this.defaultValue.showIcons),showStatusBar:c(ve.showStatusBar,this.defaultValue.showStatusBar),preview:c(ve.preview,this.defaultValue.preview),previewMode:v(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(ve.showMethods,this.defaultValue.showMethods),showFunctions:c(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:c(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:c(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:c(ve.showFields,this.defaultValue.showFields),showVariables:c(ve.showVariables,this.defaultValue.showVariables),showClasses:c(ve.showClasses,this.defaultValue.showClasses),showStructs:c(ve.showStructs,this.defaultValue.showStructs),showInterfaces:c(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:c(ve.showModules,this.defaultValue.showModules),showProperties:c(ve.showProperties,this.defaultValue.showProperties),showEvents:c(ve.showEvents,this.defaultValue.showEvents),showOperators:c(ve.showOperators,this.defaultValue.showOperators),showUnits:c(ve.showUnits,this.defaultValue.showUnits),showValues:c(ve.showValues,this.defaultValue.showValues),showConstants:c(ve.showConstants,this.defaultValue.showConstants),showEnums:c(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:c(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(ve.showKeywords,this.defaultValue.showKeywords),showWords:c(ve.showWords,this.defaultValue.showWords),showColors:c(ve.showColors,this.defaultValue.showColors),showFiles:c(ve.showFiles,this.defaultValue.showFiles),showReferences:c(ve.showReferences,this.defaultValue.showReferences),showFolders:c(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:c(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(ve.showSnippets,this.defaultValue.showSnippets),showUsers:c(ve.showUsers,this.defaultValue.showUsers),showIssues:c(ve.showIssues,this.defaultValue.showIssues)}}}class Ne extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:g.localize(188,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:c(X.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class Ke extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[g.localize(189,null),g.localize(190,null),g.localize(191,null),g.localize(192,null)],description:g.localize(193,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,ve,Be){return ve.get(2)===2?0:Be}}class Ye extends ${constructor(){super(144)}compute(X,ve,Be){const Qe=ve.get(143);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class nt extends D{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:g.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:g.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[g.localize(196,null),g.localize(197,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),showDropSelector:v(ve.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends D{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:g.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:g.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[g.localize(200,null),g.localize(201,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),showPasteSelector:v(ve.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$j?st:I.$k?ct:et,fontWeight:"normal",fontSize:I.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var mt;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.letterSpacing=63]="letterSpacing",Y[Y.lightbulb=64]="lightbulb",Y[Y.lineDecorationsWidth=65]="lineDecorationsWidth",Y[Y.lineHeight=66]="lineHeight",Y[Y.lineNumbers=67]="lineNumbers",Y[Y.lineNumbersMinChars=68]="lineNumbersMinChars",Y[Y.linkedEditing=69]="linkedEditing",Y[Y.links=70]="links",Y[Y.matchBrackets=71]="matchBrackets",Y[Y.minimap=72]="minimap",Y[Y.mouseStyle=73]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=75]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=77]="multiCursorModifier",Y[Y.multiCursorPaste=78]="multiCursorPaste",Y[Y.multiCursorLimit=79]="multiCursorLimit",Y[Y.occurrencesHighlight=80]="occurrencesHighlight",Y[Y.overviewRulerBorder=81]="overviewRulerBorder",Y[Y.overviewRulerLanes=82]="overviewRulerLanes",Y[Y.padding=83]="padding",Y[Y.pasteAs=84]="pasteAs",Y[Y.parameterHints=85]="parameterHints",Y[Y.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=88]="quickSuggestions",Y[Y.quickSuggestionsDelay=89]="quickSuggestionsDelay",Y[Y.readOnly=90]="readOnly",Y[Y.readOnlyMessage=91]="readOnlyMessage",Y[Y.renameOnType=92]="renameOnType",Y[Y.renderControlCharacters=93]="renderControlCharacters",Y[Y.renderFinalNewline=94]="renderFinalNewline",Y[Y.renderLineHighlight=95]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=97]="renderValidationDecorations",Y[Y.renderWhitespace=98]="renderWhitespace",Y[Y.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Y[Y.roundedSelection=100]="roundedSelection",Y[Y.rulers=101]="rulers",Y[Y.scrollbar=102]="scrollbar",Y[Y.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=104]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=105]="scrollPredominantAxis",Y[Y.selectionClipboard=106]="selectionClipboard",Y[Y.selectionHighlight=107]="selectionHighlight",Y[Y.selectOnLineNumbers=108]="selectOnLineNumbers",Y[Y.showFoldingControls=109]="showFoldingControls",Y[Y.showUnused=110]="showUnused",Y[Y.snippetSuggestions=111]="snippetSuggestions",Y[Y.smartSelect=112]="smartSelect",Y[Y.smoothScrolling=113]="smoothScrolling",Y[Y.stickyScroll=114]="stickyScroll",Y[Y.stickyTabStops=115]="stickyTabStops",Y[Y.stopRenderingLineAfter=116]="stopRenderingLineAfter",Y[Y.suggest=117]="suggest",Y[Y.suggestFontSize=118]="suggestFontSize",Y[Y.suggestLineHeight=119]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Y[Y.suggestSelection=121]="suggestSelection",Y[Y.tabCompletion=122]="tabCompletion",Y[Y.tabIndex=123]="tabIndex",Y[Y.unicodeHighlighting=124]="unicodeHighlighting",Y[Y.unusualLineTerminators=125]="unusualLineTerminators",Y[Y.useShadowDOM=126]="useShadowDOM",Y[Y.useTabStops=127]="useTabStops",Y[Y.wordBreak=128]="wordBreak",Y[Y.wordSeparators=129]="wordSeparators",Y[Y.wordWrap=130]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=133]="wordWrapColumn",Y[Y.wordWrapOverride1=134]="wordWrapOverride1",Y[Y.wordWrapOverride2=135]="wordWrapOverride2",Y[Y.wrappingIndent=136]="wrappingIndent",Y[Y.wrappingStrategy=137]="wrappingStrategy",Y[Y.showDeprecated=138]="showDeprecated",Y[Y.inlayHints=139]="inlayHints",Y[Y.editorClassName=140]="editorClassName",Y[Y.pixelRatio=141]="pixelRatio",Y[Y.tabFocusMode=142]="tabFocusMode",Y[Y.layoutInfo=143]="layoutInfo",Y[Y.wrappingInfo=144]="wrappingInfo",Y[Y.defaultColorDecorators=145]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(mt||(e.EditorOption=mt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(202,null)})),acceptSuggestionOnEnter:Ue(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(203,null),""],markdownDescription:g.localize(204,null)})),accessibilitySupport:Ue(new d),accessibilityPageSize:Ue(new s(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(205,null),tags:["accessibility"]})),ariaLabel:Ue(new i(4,"ariaLabel",g.localize(206,null))),ariaRequired:Ue(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:g.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new o(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(208,null),g.localize(209,null),""],description:g.localize(210,null)})),autoClosingComments:Ue(new o(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(211,null),g.localize(212,null),""],description:g.localize(213,null)})),autoClosingDelete:Ue(new o(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(214,null),""],description:g.localize(215,null)})),autoClosingOvertype:Ue(new o(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(216,null),""],description:g.localize(217,null)})),autoClosingQuotes:Ue(new o(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(218,null),g.localize(219,null),""],description:g.localize(220,null)})),autoIndent:Ue(new w(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[g.localize(221,null),g.localize(222,null),g.localize(223,null),g.localize(224,null),g.localize(225,null)],description:g.localize(226,null)})),automaticLayout:Ue(new r(13,"automaticLayout",!1)),autoSurround:Ue(new o(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(227,null),g.localize(228,null),g.localize(229,null),""],description:g.localize(230,null)})),bracketPairColorization:Ue(new B),bracketPairGuides:Ue(new Q),stickyTabStops:Ue(new r(115,"stickyTabStops",!1,{description:g.localize(231,null)})),codeLens:Ue(new r(17,"codeLens",!0,{description:g.localize(232,null)})),codeLensFontFamily:Ue(new i(18,"codeLensFontFamily","",{description:g.localize(233,null)})),codeLensFontSize:Ue(new s(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(234,null)})),colorDecorators:Ue(new r(20,"colorDecorators",!0,{description:g.localize(235,null)})),colorDecoratorActivatedOn:Ue(new o(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[g.localize(236,null),g.localize(237,null),g.localize(238,null)],description:g.localize(239,null)})),colorDecoratorsLimit:Ue(new s(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:g.localize(240,null)})),columnSelection:Ue(new r(22,"columnSelection",!1,{description:g.localize(241,null)})),comments:Ue(new b),contextmenu:Ue(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new r(25,"copyWithSyntaxHighlighting",!0,{description:g.localize(242,null)})),cursorBlinking:Ue(new w(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:g.localize(243,null)})),cursorSmoothCaretAnimation:Ue(new o(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),cursorStyle:Ue(new w(28,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:g.localize(248,null)})),cursorSurroundingLines:Ue(new s(29,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(249,null)})),cursorSurroundingLinesStyle:Ue(new o(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(250,null),g.localize(251,null)],markdownDescription:g.localize(252,null)})),cursorWidth:Ue(new s(31,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(253,null)})),disableLayerHinting:Ue(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new r(34,"domReadOnly",!1)),dragAndDrop:Ue(new r(35,"dragAndDrop",!0,{description:g.localize(254,null)})),emptySelectionClipboard:Ue(new G),dropIntoEditor:Ue(new nt),stickyScroll:Ue(new ie),experimentalWhitespaceRendering:Ue(new o(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[g.localize(255,null),g.localize(256,null),g.localize(257,null)],description:g.localize(258,null)})),extraEditorClassName:Ue(new i(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new u(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:g.localize(259,null)})),find:Ue(new q),fixedOverflowWidgets:Ue(new r(42,"fixedOverflowWidgets",!1)),folding:Ue(new r(43,"folding",!0,{description:g.localize(260,null)})),foldingStrategy:Ue(new o(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(261,null),g.localize(262,null)],description:g.localize(263,null)})),foldingHighlight:Ue(new r(45,"foldingHighlight",!0,{description:g.localize(264,null)})),foldingImportsByDefault:Ue(new r(46,"foldingImportsByDefault",!1,{description:g.localize(265,null)})),foldingMaximumRegions:Ue(new s(47,"foldingMaximumRegions",5e3,10,65e3,{description:g.localize(266,null)})),unfoldOnClickAfterEndOfLine:Ue(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(267,null)})),fontFamily:Ue(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(268,null)})),fontInfo:Ue(new N),fontLigatures2:Ue(new j),fontSize:Ue(new W),fontWeight:Ue(new se),fontVariations:Ue(new C),formatOnPaste:Ue(new r(55,"formatOnPaste",!1,{description:g.localize(269,null)})),formatOnType:Ue(new r(56,"formatOnType",!1,{description:g.localize(270,null)})),glyphMargin:Ue(new r(57,"glyphMargin",!0,{description:g.localize(271,null)})),gotoLocation:Ue(new ue),hideCursorInOverviewRuler:Ue(new r(59,"hideCursorInOverviewRuler",!1,{description:g.localize(272,null)})),hover:Ue(new ye),inDiffEditor:Ue(new r(61,"inDiffEditor",!1)),letterSpacing:Ue(new u(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>u.clamp(Y,-5,20),{description:g.localize(273,null)})),lightbulb:Ue(new $e),lineDecorationsWidth:Ue(new V),lineHeight:Ue(new ne),lineNumbers:Ue(new le),lineNumbersMinChars:Ue(new s(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new r(69,"linkedEditing",!1,{description:g.localize(274,null)})),links:Ue(new r(70,"links",!0,{description:g.localize(275,null)})),matchBrackets:Ue(new o(71,"matchBrackets","always",["always","near","never"],{description:g.localize(276,null)})),minimap:Ue(new Ie),mouseStyle:Ue(new o(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new u(74,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:g.localize(277,null)})),mouseWheelZoom:Ue(new r(75,"mouseWheelZoom",!1,{markdownDescription:I.$j?g.localize(278,null):g.localize(279,null)})),multiCursorMergeOverlapping:Ue(new r(76,"multiCursorMergeOverlapping",!0,{description:g.localize(280,null)})),multiCursorModifier:Ue(new w(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Me,{markdownEnumDescriptions:[g.localize(281,null),g.localize(282,null)],markdownDescription:g.localize(283,null)})),multiCursorPaste:Ue(new o(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(284,null),g.localize(285,null)],markdownDescription:g.localize(286,null)})),multiCursorLimit:Ue(new s(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:g.localize(287,null)})),occurrencesHighlight:Ue(new o(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[g.localize(288,null),g.localize(289,null),g.localize(290,null)],markdownDescription:g.localize(291,null)})),overviewRulerBorder:Ue(new r(81,"overviewRulerBorder",!0,{description:g.localize(292,null)})),overviewRulerLanes:Ue(new s(82,"overviewRulerLanes",3,0,3)),padding:Ue(new Le),pasteAs:Ue(new it),parameterHints:Ue(new be),peekWidgetDefaultFocus:Ue(new o(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(293,null),g.localize(294,null)],description:g.localize(295,null)})),definitionLinkOpensInPeek:Ue(new r(87,"definitionLinkOpensInPeek",!1,{description:g.localize(296,null)})),quickSuggestions:Ue(new K),quickSuggestionsDelay:Ue(new s(89,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(297,null)})),readOnly:Ue(new r(90,"readOnly",!1)),readOnlyMessage:Ue(new de),renameOnType:Ue(new r(92,"renameOnType",!1,{description:g.localize(298,null),markdownDeprecationMessage:g.localize(299,null)})),renderControlCharacters:Ue(new r(93,"renderControlCharacters",!0,{description:g.localize(300,null),restricted:!0})),renderFinalNewline:Ue(new o(94,"renderFinalNewline",I.$k?"dimmed":"on",["off","on","dimmed"],{description:g.localize(301,null)})),renderLineHighlight:Ue(new o(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(302,null)],description:g.localize(303,null)})),renderLineHighlightOnlyWhenFocus:Ue(new r(96,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(304,null)})),renderValidationDecorations:Ue(new o(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new o(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(305,null),g.localize(306,null),g.localize(307,null),""],description:g.localize(308,null)})),revealHorizontalRightPadding:Ue(new s(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new r(100,"roundedSelection",!0,{description:g.localize(309,null)})),rulers:Ue(new Ce),scrollbar:Ue(new F),scrollBeyondLastColumn:Ue(new s(103,"scrollBeyondLastColumn",4,0,1073741824,{description:g.localize(310,null)})),scrollBeyondLastLine:Ue(new r(104,"scrollBeyondLastLine",!0,{description:g.localize(311,null)})),scrollPredominantAxis:Ue(new r(105,"scrollPredominantAxis",!0,{description:g.localize(312,null)})),selectionClipboard:Ue(new r(106,"selectionClipboard",!0,{description:g.localize(313,null),included:I.$k})),selectionHighlight:Ue(new r(107,"selectionHighlight",!0,{description:g.localize(314,null)})),selectOnLineNumbers:Ue(new r(108,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new o(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[g.localize(315,null),g.localize(316,null),g.localize(317,null)],description:g.localize(318,null)})),showUnused:Ue(new r(110,"showUnused",!0,{description:g.localize(319,null)})),showDeprecated:Ue(new r(138,"showDeprecated",!0,{description:g.localize(320,null)})),inlayHints:Ue(new x),snippetSuggestions:Ue(new o(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(321,null),g.localize(322,null),g.localize(323,null),g.localize(324,null)],description:g.localize(325,null)})),smartSelect:Ue(new Ne),smoothScrolling:Ue(new r(113,"smoothScrolling",!1,{description:g.localize(326,null)})),stopRenderingLineAfter:Ue(new s(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new Ee),inlineSuggest:Ue(new J),inlineCompletionsAccessibilityVerbose:Ue(new r(147,"inlineCompletionsAccessibilityVerbose",!1,{description:g.localize(327,null)})),suggestFontSize:Ue(new s(118,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new s(119,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new r(120,"suggestOnTriggerCharacters",!0,{description:g.localize(330,null)})),suggestSelection:Ue(new o(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(331,null),g.localize(332,null),g.localize(333,null)],description:g.localize(334,null)})),tabCompletion:Ue(new o(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(335,null),g.localize(336,null),g.localize(337,null)],description:g.localize(338,null)})),tabIndex:Ue(new s(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new H),unusualLineTerminators:Ue(new o(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(339,null),g.localize(340,null),g.localize(341,null)],description:g.localize(342,null)})),useShadowDOM:Ue(new r(126,"useShadowDOM",!0)),useTabStops:Ue(new r(127,"useTabStops",!0,{description:g.localize(343,null)})),wordBreak:Ue(new o(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[g.localize(344,null),g.localize(345,null)],description:g.localize(346,null)})),wordSeparators:Ue(new i(129,"wordSeparators",L.$vs,{description:g.localize(347,null)})),wordWrap:Ue(new o(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(348,null),g.localize(349,null),g.localize(350,null),g.localize(351,null)],description:g.localize(352,null)})),wordWrapBreakAfterCharacters:Ue(new i(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new i(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new s(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(353,null)})),wordWrapOverride1:Ue(new o(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new o(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new O),defaultColorDecorators:Ue(new r(145,"defaultColorDecorators",!1,{markdownDescription:g.localize(354,null)})),pixelRatio:Ue(new ge),tabFocusMode:Ue(new r(142,"tabFocusMode",!1,{markdownDescription:g.localize(355,null)})),layoutInfo:Ue(new ae),wrappingInfo:Ue(new Ye),wrappingIndent:Ue(new Ke),wrappingStrategy:Ue(new pe)}}),define(Re[148],Ae([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Re[149],Ae([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Re[150],Ae([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Re[151],Ae([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Re[152],Ae([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Re[153],Ae([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Re[154],Ae([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Re[155],Ae([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Re[156],Ae([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Re[157],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Re[158],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Re[159],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Re[160],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Re[161],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Re[162],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Re[163],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Re[164],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Re[165],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Re[166],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Re[167],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Re[168],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Re[169],Ae([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Re[170],Ae([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Re[171],Ae([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Re[172],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Re[173],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Re[174],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Re[175],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Re[176],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Re[177],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Re[178],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Re[179],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Re[180],Ae([1,0,15,150]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.TokenType=void 0;var I;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(I||(e.TokenType=I={}));function R(...E){switch(E.length){case 1:return(0,M.localize)(0,null,E[0]);case 2:return(0,M.localize)(1,null,E[0],E[1]);case 3:return(0,M.localize)(2,null,E[0],E[1],E[2]);default:return}}const L=(0,M.localize)(3,null),g=(0,M.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const D=this.d,l=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:l};this.g.push({offset:D,lexeme:l,additionalInfo:A}),this.f.push(p)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const D=this.c.substring(this.d,this.e),l=h.b.get(D);l?this.k(l):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,D=!1,l=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(g);return}const $=this.c.charCodeAt(A);if(D)D=!1;else if($===47&&!l){A++;break}else $===91?l=!0:$===92?D=!0:$===93&&(l=!1);A++}for(;A<this.c.length&&h.a.has(this.c.charCodeAt(A));)A++;this.e=A;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$3i=h}),define(Re[181],Ae([1,0,25,32,152,295]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function h(r){return r=r.trim(),r==="*"||L.test(r)}e.$cp=h;function E(r){if(!h(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=r.match(L);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}e.$dp=E;function A(r){if(!r)return null;const t=r.majorBase,s=r.majorMustEqual,a=r.minorBase;let u=r.minorMustEqual;const i=r.patchBase;let v=r.patchMustEqual;r.hasCaret&&(t===0||(u=!1),v=!1);let o=0;if(r.preRelease){const w=g.exec(r.preRelease);if(w){const[,y,d,b]=w;o=Date.UTC(Number(y),Number(d)-1,Number(b))}}return{majorBase:t,majorMustEqual:s,minorBase:a,minorMustEqual:u,patchBase:i,patchMustEqual:v,isMinimum:r.hasGreaterEquals,notBefore:o}}e.$ep=A;function D(r,t,s){let a;typeof r=="string"?a=A(E(r)):a=r;let u;t instanceof Date?u=t.getTime():typeof t=="string"&&(u=new Date(t).getTime());let i;if(typeof s=="string"?i=A(E(s)):i=s,!a||!i)return!1;const v=a.majorBase,o=a.minorBase,w=a.patchBase;let y=i.majorBase,d=i.minorBase,b=i.patchBase;const P=i.notBefore;let f=i.majorMustEqual,m=i.minorMustEqual,k=i.patchMustEqual;return i.isMinimum?v>y?!0:v<y?!1:o>d?!0:o<d||u&&u<P?!1:w>=b:(v===1&&y===0&&(!f||!m||!k)&&(y=1,d=0,b=0,f=!0,m=!1,k=!1),v<y?!1:v>y?!f:o<d?!1:o>d?!m:w<b?!1:w>b?!k:!(u&&u<P))}e.$fp=D;function l(r,t,s,a,u){const i=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return i.push([M.default.Error,I.localize(0,null)]),i;if(typeof a.name!="string")return i.push([M.default.Error,I.localize(1,null,"name")]),i;if(typeof a.version!="string")return i.push([M.default.Error,I.localize(2,null,"version")]),i;if(!a.engines)return i.push([M.default.Error,I.localize(3,null,"engines")]),i;if(typeof a.engines.vscode!="string")return i.push([M.default.Error,I.localize(4,null,"engines.vscode")]),i;if(typeof a.extensionDependencies<"u"&&!c(a.extensionDependencies))return i.push([M.default.Error,I.localize(5,null,"extensionDependencies")]),i;if(typeof a.activationEvents<"u"){if(!c(a.activationEvents))return i.push([M.default.Error,I.localize(6,null,"activationEvents")]),i;if(typeof a.main>"u"&&typeof a.browser>"u")return i.push([M.default.Error,I.localize(7,null,"activationEvents","main","browser")]),i}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&i.push([M.default.Warning,I.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return i.push([M.default.Error,I.localize(9,null,"main")]),i;{const w=(0,S.$Ig)(s,a.main);(0,S.$Cg)(w,s)||i.push([M.default.Warning,I.localize(10,null,w.path,s.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return i.push([M.default.Error,I.localize(11,null,"browser")]),i;{const w=(0,S.$Ig)(s,a.browser);(0,S.$Cg)(w,s)||i.push([M.default.Warning,I.localize(12,null,w.path,s.path)])}}if(!R.valid(a.version))return i.push([M.default.Error,I.localize(13,null)]),i;const v=[];if(!p(r,t,a,u,v))for(const w of v)i.push([M.default.Error,w]);return i}e.$gp=l;function p(r,t,s,a,u){return a||typeof s.main>"u"&&typeof s.browser>"u"?!0:n(r,t,s.engines.vscode,u)}e.$hp=p;function $(r,t,s){return r==="*"||n(t,s,r)}e.$ip=$;function n(r,t,s,a=[]){const u=A(E(s));if(!u)return a.push(I.localize(14,null,s)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return a.push(I.localize(15,null,s)),!1}else if(!u.majorMustEqual)return a.push(I.localize(16,null,s)),!1;return D(r,t,u)?!0:(a.push(I.localize(17,null,r,s)),!1)}function c(r){if(!Array.isArray(r))return!1;for(let t=0,s=r.length;t<s;t++)if(typeof r[t]!="string")return!1;return!0}}),define(Re[70],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class S{constructor(I,R=[],L=!1){this.ctor=I,this.staticArguments=R,this.supportsDelayedInstantiation=L}}e.$5h=S}),define(Re[53],Ae([1,0,70]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.InstantiationType=void 0;const M=[];var I;(function(g){g[g.Eager=0]="Eager",g[g.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function R(g,h,E){h instanceof S.$5h||(h=new S.$5h(h,[],!!E)),M.push([g,h])}e.$1r=R;function L(){return M}e.$2r=L}),define(Re[182],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class S{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$Eq=S;class M{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const L of this.a.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const g=this.lookupOrInsertNode(R),h=this.lookupOrInsertNode(L);g.outgoing.set(h.key,h),h.incoming.set(g.key,g)}removeNode(R){const L=this.b(R);this.a.delete(L);for(const g of this.a.values())g.outgoing.delete(L),g.incoming.delete(L)}lookupOrInsertNode(R){const L=this.b(R);let g=this.a.get(L);return g||(g=new S(L,R),this.a.set(L,g)),g}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[L,g]of this.a)R.push(`${L}
	(-> incoming)[${[...g.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...g.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this.a){const g=new Set([R]),h=this.c(L,g);if(h)return h}}c(R,L){for(const[g,h]of R.outgoing){if(L.has(g))return[...L,g].join(" -> ");L.add(g);const E=this.c(h,L);if(E)return E;L.delete(g)}}}e.$Fq=M}),define(Re[4],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e._util=void 0;var S;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function g(h){return h[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=g})(S||(e._util=S={})),e.$7h=I("instantiationService");function M(L,g,h){g[S.DI_TARGET]===g?g[S.DI_DEPENDENCIES].push({id:L,index:h}):(g[S.DI_DEPENDENCIES]=[{id:L,index:h}],g[S.DI_TARGET]=g)}function I(L){if(S.serviceIds.has(L))return S.serviceIds.get(L);const g=function(h,E,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(g,h,A)};return g.toString=()=>L,S.serviceIds.set(L,g),g}e.$8h=I;function R(L){return L}e.$9h=R}),define(Re[46],Ae([1,0,16,2,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.ConfigurationTarget=e.$Di=e.$Ci=e.$Bi=void 0,e.$Bi=(0,I.$8h)("configurationService");function R(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof M.URI)}e.$Ci=R;function L(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof M.URI)}e.$Di=L;var g;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(g||(e.ConfigurationTarget=g={}));function h(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ei=h;function E(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}e.$Fi=E;function A(r,t){const s=Object.create(null);for(const a in r)D(s,a,r[a],t);return s}e.$Gi=A;function D(r,t,s,a){const u=t.split("."),i=u.pop();let v=r;for(let o=0;o<u.length;o++){const w=u[o];let y=v[w];switch(typeof y){case"undefined":y=v[w]=Object.create(null);break;case"object":break;default:a(`Ignoring ${t} as ${u.slice(0,o+1).join(".")} is ${JSON.stringify(y)}`);return}v=y}if(typeof v=="object"&&v!==null)try{v[i]=s}catch{a(`Ignoring ${t} as ${u.join(".")} is ${JSON.stringify(v)}`)}else a(`Ignoring ${t} as ${u.join(".")} is ${JSON.stringify(v)}`)}e.$Hi=D;function l(r,t){const s=t.split(".");p(r,s)}e.$Ii=l;function p(r,t){const s=t.shift();if(t.length===0){delete r[s];return}if(Object.keys(r).indexOf(s)!==-1){const a=r[s];typeof a=="object"&&!Array.isArray(a)&&(p(a,t),Object.keys(a).length===0&&delete r[s])}}function $(r,t,s){function a(v,o){let w=v;for(const y of o){if(typeof w!="object"||w===null)return;w=w[y]}return w}const u=t.split("."),i=a(r,u);return typeof i>"u"?s:i}e.$Ji=$;function n(r,t,s){Object.keys(t).forEach(a=>{a!=="__proto__"&&(a in r?S.$Lf(r[a])&&S.$Lf(t[a])?n(r[a],t[a],s):s&&(r[a]=t[a]):r[a]=t[a])})}e.$Ki=n;function c(r){return r.replace(/[\[\]]/g,"")}e.$Li=c}),define(Re[35],Ae([1,0,20,13,180,4,149,15]),function(me,e,S,M,I,R,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.ContextKeyExprType=e.$4i=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",S.$j),h.set("isLinux",S.$k),h.set("isWindows",S.$i),h.set("isWeb",S.$o),h.set("isMacNative",S.$j&&!S.$o),h.set("isEdge",S.$H),h.set("isFirefox",S.$F),h.set("isChrome",S.$E),h.set("isSafari",S.$G);function E(x,V){if(h.get(x)!==void 0)throw(0,g.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(x,V)}e.$4i=E;const A=Object.prototype.hasOwnProperty;var D;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const l={regexParsingWithErrorRecovery:!0},p=(0,L.localize)(0,null),$=(0,L.localize)(1,null),n=(0,L.localize)(2,null),c=(0,L.localize)(3,null),r=(0,L.localize)(4,null),t=(0,L.localize)(5,null),s=(0,L.localize)(6,null),a=(0,L.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new I.$3i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Ie=this.D(),Me=Ie.type===17?t:void 0;throw this.h.push({message:r,offset:Ie.offset,lexeme:I.$3i.getLexeme(Ie),additionalInfo:Me}),u.c}return ne}catch(ne){if(ne!==u.c)throw ne;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ne=this.o();V.push(ne)}return V.length===1?V[0]:i.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ne=this.s();V.push(ne)}return V.length===1?V[0]:i.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),y.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,c),ne?.negate()}case 17:return this.z(),T.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const ne=this.l();return this.A(1,c),ne}case 17:{const ne=V.lexeme;if(this.z(),this.y(9)){const Me=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Me.type!==10)throw this.B("REGEX",Me);const Le=Me.lexeme,be=Le.lastIndexOf("/"),ge=be===Le.length-1?void 0:this.w(Le.substring(be+1));let K;try{K=new RegExp(Le.substring(1,be),ge)}catch{throw this.B("REGEX",Me)}return N.create(ne,K)}switch(Me.type){case 10:case 19:{const Le=[Me.lexeme];this.z();let be=this.D(),ge=0;for(let Ce=0;Ce<Me.lexeme.length;Ce++)Me.lexeme.charCodeAt(Ce)===40?ge++:Me.lexeme.charCodeAt(Ce)===41&&ge--;for(;!this.E()&&be.type!==15&&be.type!==16;){switch(be.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Ce=0;Ce<be.lexeme.length;Ce++)be.lexeme.charCodeAt(Ce)===40?ge++:Me.lexeme.charCodeAt(Ce)===41&&ge--}if(ge<0)break;Le.push(I.$3i.getLexeme(be)),this.z(),be=this.D()}const K=Le.join(""),ee=K.lastIndexOf("/"),le=ee===K.length-1?void 0:this.w(K.substring(ee+1));let fe;try{fe=new RegExp(K.substring(1,ee),le)}catch{throw this.B("REGEX",Me)}return i.regex(ne,fe)}case 18:{const Le=Me.lexeme;this.z();let be=null;if(!(0,M.$Ke)(Le)){const ge=Le.indexOf("/"),K=Le.lastIndexOf("/");if(ge!==K&&ge>=0){const ee=Le.slice(ge+1,K),le=Le[K+1]==="i"?"i":"";try{be=new RegExp(ee,le)}catch{throw this.B("REGEX",Me)}}}if(be===null)throw this.B("REGEX",Me);return N.create(ne,be)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,n);const Me=this.u();return i.notIn(ne,Me)}switch(this.D().type){case 3:{this.z();const Me=this.u();if(this.x().type===18)return i.equals(ne,Me);switch(Me){case"true":return i.has(ne);case"false":return i.not(ne);default:return i.equals(ne,Me)}}case 4:{this.z();const Me=this.u();if(this.x().type===18)return i.notEquals(ne,Me);switch(Me){case"true":return i.not(ne);case"false":return i.has(ne);default:return i.notEquals(ne,Me)}}case 5:return this.z(),j.create(ne,this.u());case 6:return this.z(),C.create(ne,this.u());case 7:return this.z(),G.create(ne,this.u());case 8:return this.z(),q.create(ne,this.u());case 13:return this.z(),i.in(ne,this.u());default:return i.has(ne)}}case 20:throw this.h.push({message:s,offset:V.offset,lexeme:"",additionalInfo:a}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ne){if(this.C(V))return this.z();throw this.B(ne,this.D())}B(V,ne,Ie){const Me=(0,L.localize)(8,null,V,I.$3i.getLexeme(ne)),Le=ne.offset,be=I.$3i.getLexeme(ne);return this.h.push({message:Me,offset:Le,lexeme:be,additionalInfo:Ie}),u.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$5i=u;class i{static false(){return y.INSTANCE}static true(){return d.INSTANCE}static has(V){return b.create(V)}static equals(V,ne){return P.create(V,ne)}static notEquals(V,ne){return k.create(V,ne)}static regex(V,ne){return N.create(V,ne)}static in(V,ne){return f.create(V,ne)}static notIn(V,ne){return m.create(V,ne)}static not(V){return T.create(V)}static and(...V){return ue.create(V,null,!0)}static or(...V){return ye.create(V,null,!0)}static greater(V,ne){return G.create(V,ne)}static greaterEquals(V,ne){return q.create(V,ne)}static smaller(V,ne){return j.create(V,ne)}static smallerEquals(V,ne){return C.create(V,ne)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$6i=i;function v(x){const V=new u({regexParsingWithErrorRecovery:!1});return x.map(ne=>(V.parse(ne),V.lexingErrors.length>0?V.lexingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?(0,L.localize)(9,null,Ie.additionalInfo):(0,L.localize)(10,null),offset:Ie.offset,length:Ie.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?`${Ie.message}. ${Ie.additionalInfo}`:Ie.message,offset:Ie.offset,length:Ie.lexeme.length})):[]))}e.$7i=v;function o(x,V){const ne=x?x.substituteConstants():void 0,Ie=V?V.substituteConstants():void 0;return!ne&&!Ie?!0:!ne||!Ie?!1:ne.equals(Ie)}e.$8i=o;function w(x,V){return x.cmp(V)}class y{static{this.INSTANCE=new y}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return d.INSTANCE}}e.$9i=y;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return y.INSTANCE}}e.$0i=d;class b{static create(V,ne=null){const Ie=h.get(V);return typeof Ie=="boolean"?Ie?d.INSTANCE:y.INSTANCE:new b(V,ne)}constructor(V,ne){this.key=V,this.c=ne,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:ae(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=h.get(this.key);return typeof V=="boolean"?V?d.INSTANCE:y.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=T.create(this.key,this)),this.c}}e.$$i=b;class P{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?b.create(V,Ie):T.create(V,Ie);const Me=h.get(V);return typeof Me=="boolean"?ne===(Me?"true":"false")?d.INSTANCE:y.INSTANCE:new P(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=h.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?d.INSTANCE:y.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$_i=P;class f{static create(V,ne){return new f(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.f),Ie=V.getValue(this.d);return Array.isArray(ne)?ne.includes(Ie):typeof Ie=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,Ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$aj=f;class m{static create(V,ne){return new m(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=11,this.c=f.create(V,ne)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$bj=m;class k{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?T.create(V,Ie):b.create(V,Ie);const Me=h.get(V);return typeof Me=="boolean"?ne===(Me?"true":"false")?y.INSTANCE:d.INSTANCE:new k(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=h.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?y.INSTANCE:d.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$cj=k;class T{static create(V,ne=null){const Ie=h.get(V);return typeof Ie=="boolean"?Ie?y.INSTANCE:d.INSTANCE:new T(V,ne)}constructor(V,ne){this.c=V,this.d=ne,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:ae(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=h.get(this.c);return typeof V=="boolean"?V?y.INSTANCE:d.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$dj=T;function O(x,V){if(typeof x=="string"){const ne=parseFloat(x);isNaN(ne)||(x=ne)}return typeof x=="string"||typeof x=="number"?V(x):y.INSTANCE}class G{static create(V,ne,Ie=null){return O(ne,Me=>new G(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$ej=G;class q{static create(V,ne,Ie=null){return O(ne,Me=>new q(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$fj=q;class j{static create(V,ne,Ie=null){return O(ne,Me=>new j(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$gj=j;class C{static create(V,ne,Ie=null){return O(ne,Me=>new C(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$hj=C;class N{static create(V,ne){return new N(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return ne<Ie?-1:ne>Ie?1:0}equals(V){if(V.type===this.type){const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return this.d===V.d&&ne===Ie}return!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$ij=N;class W{static create(V){return new W(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new W(this.c.map(V))}negate(){return this.c}}e.$jj=W;function se(x){let V=null;for(let ne=0,Ie=x.length;ne<Ie;ne++){const Me=x[ne].substituteConstants();if(x[ne]!==Me&&V===null){V=[];for(let Le=0;Le<ne;Le++)V[Le]=x[Le]}V!==null&&(V[ne]=Me)}return V===null?x:V}class ue{static create(V,ne,Ie){return ue.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Me=w(this.expr[ne],V.expr[ne]);if(Me!==0)return Me}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=se(this.expr);return V===this.expr?this:ue.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].evaluate(V))return!1;return!0}static d(V,ne,Ie){const Me=[];let Le=!1;for(const be of V)if(be){if(be.type===1){Le=!0;continue}if(be.type===0)return y.INSTANCE;if(be.type===6){Me.push(...be.expr);continue}Me.push(be)}if(Me.length===0&&Le)return d.INSTANCE;if(Me.length!==0){if(Me.length===1)return Me[0];Me.sort(w);for(let be=1;be<Me.length;be++)Me[be-1].equals(Me[be])&&(Me.splice(be,1),be--);if(Me.length===1)return Me[0];for(;Me.length>1;){const be=Me[Me.length-1];if(be.type!==9)break;Me.pop();const ge=Me.pop(),K=Me.length===0,ee=ye.create(be.expr.map(le=>ue.create([le,ge],null,Ie)),null,K);ee&&(Me.push(ee),Me.sort(w))}if(Me.length===1)return Me[0];if(Ie){for(let be=0;be<Me.length;be++)for(let ge=be+1;ge<Me.length;ge++)if(Me[be].negate().equals(Me[ge]))return y.INSTANCE;if(Me.length===1)return Me[0]}return new ue(Me,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new ue(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());this.c=ye.create(V,this,!0)}return this.c}}e.$kj=ue;class ye{static create(V,ne,Ie){return ye.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Me=w(this.expr[ne],V.expr[ne]);if(Me!==0)return Me}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=se(this.expr);return V===this.expr?this:ye.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(this.expr[ne].evaluate(V))return!0;return!1}static d(V,ne,Ie){let Me=[],Le=!1;if(V){for(let be=0,ge=V.length;be<ge;be++){const K=V[be];if(K){if(K.type===0){Le=!0;continue}if(K.type===1)return d.INSTANCE;if(K.type===9){Me=Me.concat(K.expr);continue}Me.push(K)}}if(Me.length===0&&Le)return y.INSTANCE;Me.sort(w)}if(Me.length!==0){if(Me.length===1)return Me[0];for(let be=1;be<Me.length;be++)Me[be-1].equals(Me[be])&&(Me.splice(be,1),be--);if(Me.length===1)return Me[0];if(Ie){for(let be=0;be<Me.length;be++)for(let ge=be+1;ge<Me.length;ge++)if(Me[be].negate().equals(Me[ge]))return d.INSTANCE;if(Me.length===1)return Me[0]}return new ye(Me,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new ye(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());for(;V.length>1;){const ne=V.shift(),Ie=V.shift(),Me=[];for(const Le of ie(ne))for(const be of ie(Ie))Me.push(ue.create([Le,be],null,!1));V.unshift(ye.create(Me,null,!1))}this.c=ye.create(V,this,!0)}return this.c}}e.$lj=ye;class ke extends b{static{this.d=[]}static all(){return ke.d.values()}constructor(V,ne,Ie){super(V,null),this.f=ne,typeof Ie=="object"?ke.d.push({...Ie,key:V}):Ie!==!0&&ke.d.push({key:V,description:Ie,type:ne!=null?typeof ne:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return P.create(this.key,V)}notEqualsTo(V){return k.create(this.key,V)}}e.$mj=ke,e.$nj=(0,R.$8h)("contextKeyService");function ae(x,V){return x<V?-1:x>V?1:0}function pe(x,V,ne,Ie){return x<ne?-1:x>ne?1:V<Ie?-1:V>Ie?1:0}function oe(x,V){if(x.type===0||V.type===1)return!0;if(x.type===9)return V.type===9?$e(x.expr,V.expr):!1;if(V.type===9){for(const ne of V.expr)if(oe(x,ne))return!0;return!1}if(x.type===6){if(V.type===6)return $e(V.expr,x.expr);for(const ne of x.expr)if(oe(ne,V))return!0;return!1}return x.equals(V)}e.$oj=oe;function $e(x,V){let ne=0,Ie=0;for(;ne<x.length&&Ie<V.length;){const Me=x[ne].cmp(V[Ie]);if(Me<0)return!1;Me===0&&ne++,Ie++}return ne===x.length}function ie(x){return x.type===9?x.expr:[x]}}),define(Re[183],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=void 0,e.$ci=(0,S.$8h)("environmentService"),e.$di=(0,S.$9h)(e.$ci)}),define(Re[97],Ae([1,0,151,4]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ExtensionGalleryErrorCode=e.$Co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0,e.$po="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$qo=new RegExp(e.$po),e.$ro="__web_extension",e.$so="skipWalkthrough",e.$to="extensionsSync",e.$uo="dependecyOrPackExtensionInstall";function I(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$vo=I;function R(s){switch(s){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$wo=R;function L(s,a){switch(s){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$xo=L;function g(s,a){return a==="web"&&!s.includes("web")}e.$yo=g;function h(s,a,u){return g(a,u)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===u}e.$zo=h;function E(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$Ao=E;var A;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var D;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var l;(function(s){s.Install="install",s.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var p;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$Bo=(0,M.$8h)("extensionGalleryService");var $;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.DownloadSignature="DownloadSignature",s.UpdateMetadata="UpdateMetadata",s.Extract="Extract",s.Scanning="Scanning",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.NotAllowed="NotAllowed",s.Gallery="Gallery",s.Unknown="Unknown",s.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var n;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(n||(e.ExtensionSignaturetErrorCode=n={}));class c extends Error{constructor(a,u){super(a),this.code=u,this.name=u}}e.$Co=c;var r;(function(s){s.Timeout="Timeout",s.Cancelled="Cancelled",s.Failed="Failed"})(r||(e.ExtensionGalleryErrorCode=r={}));class t extends Error{constructor(a,u){super(a),this.code=u,this.name=u}}e.$Do=t,e.$Eo=(0,M.$8h)("extensionManagementService"),e.$Fo="extensionsIdentifiers/disabled",e.$Go="extensionsIdentifiers/enabled",e.$Ho=(0,M.$8h)("IGlobalExtensionEnablementService"),e.$Io=(0,M.$8h)("IExtensionTipsService"),e.$Jo=(0,S.localize2)(0,"Extensions"),e.$Ko=(0,S.localize2)(1,"Preferences")}),define(Re[42],Ae([1,0,50,19,13,16,2,153,4,20,12,39]),function(me,e,S,M,I,R,L,g,h,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.FileKind=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileOperationResult=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileChangeType=e.$Kk=e.FileOperation=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderErrorCode=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileSystemProviderCapabilities=e.$uk=e.FilePermission=e.FileType=e.$tk=e.$sk=void 0,e.$sk=(0,h.$8h)("fileService");function l(oe){return oe.create===!0}e.$tk=l;var p;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var $;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})($||(e.FilePermission=$={}));function n(oe){const $e=oe;return!!$e&&typeof $e.onDidChange=="function"}e.$uk=n;var c;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function r(oe){return!!(oe.capabilities&2)}e.$vk=r;function t(oe){return!!(oe.capabilities&8)}e.$wk=t;function s(oe){return!!(oe.capabilities&131072)}e.$xk=s;function a(oe){return!!(oe.capabilities&4)}e.$yk=a;function u(oe){return!!(oe.capabilities&16)}e.$zk=u;function i(oe){return r(oe)?!!(oe.capabilities&16384):!1}e.$Ak=i;function v(oe){return r(oe)?!!(oe.capabilities&32768):!1}e.$Bk=v;function o(oe){return!!(oe.capabilities&65536)}e.$Ck=o;function w(oe){return!!(oe.capabilities&2048)}e.$Dk=w;var y;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(y||(e.FileSystemProviderErrorCode=y={}));class d extends Error{static create($e,ie){const x=new d($e.toString(),ie);return f(x,ie),x}constructor($e,ie){super($e),this.code=ie}}e.$Ek=d;function b(oe,$e){return d.create(oe,$e)}e.$Fk=b;function P(oe){return oe||b((0,g.localize)(0,null),y.Unknown)}e.$Gk=P;function f(oe,$e){return oe.name=$e?`${$e} (FileSystemError)`:"FileSystemError",oe}e.$Hk=f;function m(oe){if(!oe)return y.Unknown;if(oe instanceof d)return oe.code;const $e=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!$e)return y.Unknown;switch($e[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.$Ik=m;function k(oe){if(oe instanceof C)return oe.fileOperationResult;switch(m(oe)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 9;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileTooLarge:return 7;default:return 10}}e.$Jk=k;var T;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(T||(e.FileOperation=T={}));class O{constructor($e,ie,x){this.resource=$e,this.operation=ie,this.target=x}isOperation($e){return this.operation===$e}}e.$Kk=O;var G;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class q{static{this.a=null}constructor($e,ie){this.c=ie,this.b=void 0,this.d=new D.$V(()=>{const x=S.$bi.forUris(()=>this.c);return x.fill(this.rawAdded.map(V=>[V,!0])),x}),this.f=new D.$V(()=>{const x=S.$bi.forUris(()=>this.c);return x.fill(this.rawUpdated.map(V=>[V,!0])),x}),this.g=new D.$V(()=>{const x=S.$bi.forUris(()=>this.c);return x.fill(this.rawDeleted.map(V=>[V,!0])),x}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const x of $e){switch(x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}this.b!==q.a&&(typeof x.cId=="number"?this.b===void 0?this.b=x.cId:this.b!==x.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains($e,...ie){return this.h($e,{includeChildren:!1},...ie)}affects($e,...ie){return this.h($e,{includeChildren:!0},...ie)}h($e,ie,...x){if(!$e)return!1;const V=x.length>0;return!!((!V||x.includes(1))&&(this.d.value.get($e)||ie.includeChildren&&this.d.value.findSuperstr($e))||(!V||x.includes(0))&&(this.f.value.get($e)||ie.includeChildren&&this.f.value.findSuperstr($e))||(!V||x.includes(2))&&(this.g.value.findSubstr($e)||ie.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$Lk=q;function j(oe,$e,ie){return!oe||!$e||oe===$e||$e.length>oe.length?!1:($e.charAt($e.length-1)!==M.sep&&($e+=M.sep),ie?(0,I.$bf)(oe,$e):oe.indexOf($e)===0)}e.$Mk=j;class C extends Error{constructor($e,ie,x){super($e),this.fileOperationResult=ie,this.options=x}}e.$Nk=C;class N extends C{constructor($e,ie,x,V){super($e,ie,V),this.fileOperationResult=ie,this.size=x}}e.$Ok=N;class W extends C{constructor($e,ie,x){super($e,2,x),this.stat=ie}}e.$Pk=W;var se;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(se||(e.FileOperationResult=se={})),e.$Qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Sk="files.associations",e.$Tk="files.exclude",e.$Uk="files.readonlyInclude",e.$Vk="files.readonlyExclude",e.$Wk="files.readonlyFromPermissions";var ue;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.$Xk="";function ye(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}e.$Yk=ye;async function ke(oe,$e){if(!$e.hasProvider(L.URI.from({scheme:oe.scheme})))return new Promise(ie=>{const x=$e.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===oe.scheme&&V.added&&(x.dispose(),ie())})})}e.$Zk=ke;class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize($e){return(0,R.$Nf)($e)||($e=0),$e<ae.KB?(0,g.localize)(1,null,$e.toFixed(0)):$e<ae.MB?(0,g.localize)(2,null,($e/ae.KB).toFixed(2)):$e<ae.GB?(0,g.localize)(3,null,($e/ae.MB).toFixed(2)):$e<ae.TB?(0,g.localize)(4,null,($e/ae.GB).toFixed(2)):(0,g.localize)(5,null,($e/ae.TB).toFixed(2))}}e.$1k=ae;function pe(oe){const $e=typeof oe=="string"||oe?.scheme===A.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===A.Schemas.file?1024*ae.MB:$e?10*ae.MB:E.$o?50*ae.MB:1024*ae.MB}e.$2k=pe}),define(Re[71],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=void 0;class S{constructor(...I){this.a=new Map;for(const[R,L]of I)this.set(R,L)}set(I,R){const L=this.a.get(I);return this.a.set(I,R),L}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$6h=S}),define(Re[184],Ae([1,0,11,15,6,70,182,4,71,185]),function(me,e,S,M,I,R,L,g,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;const A=!1;class D extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class l{constructor(c=new h.$6h,r=!1,t,s=A){this.f=c,this.g=r,this.h=t,this.i=s,this.o=new Set,this.f.set(g.$7h,this),this._globalGraph=s?t?._globalGraph??new L.$Fq(a=>a):void 0}createChild(c){return new l(c,this.g,this,this.i)}invokeFunction(c,...r){const t=$.traceInvocation(this.i,c);let s=!1;try{return c({get:u=>{if(s)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(u,t);if(!i)throw new Error(`[invokeFunction] unknown service '${u}'`);return i}},...r)}finally{s=!0,t.stop()}}createInstance(c,...r){let t,s;return c instanceof R.$5h?(t=$.traceCreation(this.i,c.ctor),s=this.j(c.ctor,c.staticArguments.concat(r),t)):(t=$.traceCreation(this.i,c),s=this.j(c,r,t)),t.stop(),s}j(c,r=[],t){const s=g._util.getServiceDependencies(c).sort((i,v)=>i.index-v.index),a=[];for(const i of s){const v=this.m(i.id,t);v||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${i.id}.`,!1),a.push(v)}const u=s.length>0?s[0].index:r.length;if(r.length!==u){console.trace(`[createInstance] First service dependency of ${c.name} at position ${u+1} conflicts with ${r.length} static arguments`);const i=u-r.length;i>0?r=r.concat(new Array(i)):r=r.slice(0,u)}return Reflect.construct(c,r.concat(a))}k(c,r){if(this.f.get(c)instanceof R.$5h)this.f.set(c,r);else if(this.h)this.h.k(c,r);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const r=this.f.get(c);return!r&&this.h?this.h.l(c):r}m(c,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const t=this.l(c);return t instanceof R.$5h?this.q(c,t,r.branch(c,!0)):(r.branch(c,!1),t)}q(c,r,t){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,r,t)}finally{this.o.delete(c)}}r(c,r,t){const s=new L.$Fq(i=>i.id.toString());let a=0;const u=[{id:c,desc:r,_trace:t}];for(;u.length;){const i=u.pop();if(s.lookupOrInsertNode(i),a++>1e3)throw new D(s);for(const v of g._util.getServiceDependencies(i.desc.ctor)){const o=this.l(v.id);if(o||this.u(`[createInstance] ${c} depends on ${v.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(v.id)),o instanceof R.$5h){const w={id:v.id,desc:o,_trace:i._trace.branch(v.id,!0)};s.insertEdge(i,w),u.push(w)}}}for(;;){const i=s.roots();if(i.length===0){if(!s.isEmpty())throw new D(s);break}for(const{data:v}of i){if(this.l(v.id)instanceof R.$5h){const w=this.s(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this.k(v.id,w)}s.removeNode(v)}}return this.l(c)}s(c,r,t=[],s,a){if(this.f.get(c)instanceof R.$5h)return this.t(c,r,t,s,a);if(this.h)return this.h.s(c,r,t,s,a);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}t(c,r,t=[],s,a){if(s){const u=new l(void 0,this.g,this,this.i);u.c=String(c);const i=new Map,v=new S.$oh(()=>{const o=u.j(r,t,a);for(const[w,y]of i){const d=o[w];if(typeof d=="function")for(const b of y)b.disposable=d.apply(o,b.listener)}return i.clear(),o});return new Proxy(Object.create(null),{get(o,w){if(!v.isInitialized&&typeof w=="string"&&(w.startsWith("onDid")||w.startsWith("onWill"))){let b=i.get(w);return b||(b=new E.$4c,i.set(w,b)),(f,m,k)=>{if(v.isInitialized)return v.value[w](f,m,k);{const T={listener:[f,m,k],disposable:void 0},O=b.push(T);return(0,I.$Rc)(()=>{O(),T.disposable?.dispose()})}}}if(w in o)return o[w];const y=v.value;let d=y[w];return typeof d!="function"||(d=d.bind(y),o[w]=d),d},set(o,w,y){return v.value[w]=y,!0},getPrototypeOf(o){return r.prototype}})}else return this.j(r,t,a)}u(c,r){if(r&&console.warn(c),this.g)throw new Error(c)}}e.$Gq=l;var p;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(p||(p={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,r){return c?new $(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(c,r){return c?new $(1,r.name):$.c}static{this.f=0}constructor(c,r){this.type=c,this.name=r,this.g=Date.now(),this.h=[]}branch(c,r){const t=new $(3,c.toString());return this.h.push([c,r,t]),t}stop(){const c=Date.now()-this.g;$.f+=c;let r=!1;function t(a,u){const i=[],v=new Array(a+1).join("	");for(const[o,w,y]of u.h)if(w&&y){r=!0,i.push(`${v}CREATES -> ${o}`);const d=t(a+1,y);d&&i.push(d)}else i.push(`${v}uses -> ${o}`);return i.join(`
`)}const s=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${t(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(c>2||r)&&$.all.add(s.join(`
`))}}e.$Hq=$}),define(Re[14],Ae([1,0,41,5,98,6,28,20,25,16,2,35,4]),function(me,e,S,M,I,R,L,g,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.log=e.$sj=e.LogLevel=e.$rj=e.$qj=e.$pj=void 0,e.$pj=(0,l.$8h)("logService"),e.$qj=(0,l.$8h)("loggerService");function p(){return new Date().toISOString()}function $(f){return(0,E.$Nf)(f)}e.$rj=$;var n;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(n||(e.LogLevel=n={})),e.$sj=n.Info;function c(f,m,k){switch(m){case n.Trace:f.trace(k);break;case n.Debug:f.debug(k);break;case n.Info:f.info(k);break;case n.Warning:f.warn(k);break;case n.Error:f.error(k);break;case n.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=c;function r(f,m=!1){let k="";for(let T=0;T<f.length;T++){let O=f[T];if(O instanceof Error&&(O=(0,S.$Si)(O,m)),typeof O=="object")try{O=JSON.stringify(O)}catch{}k+=(T>0?" ":"")+O}return k}class t extends R.$Tc{constructor(){super(...arguments),this.b=e.$sj,this.c=this.B(new M.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==n.Off&&this.b<=m}}e.$uj=t;class s extends t{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...k){this.f(n.Trace)&&this.g(n.Trace,r([m,...k],!0))}debug(m,...k){this.f(n.Debug)&&this.g(n.Debug,r([m,...k]))}info(m,...k){this.f(n.Info)&&this.g(n.Info,r([m,...k]))}warn(m,...k){this.f(n.Warning)&&this.g(n.Warning,r([m,...k]))}error(m,...k){if(this.f(n.Error))if(m instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=m.stack,this.g(n.Error,r(T))}else this.g(n.Error,r([m,...k]))}flush(){}}e.$vj=s;class a extends t{constructor(m=e.$sj){super(),this.setLevel(m),this.g=!g.$i}trace(m,...k){this.f(n.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,m,...k):console.log(`[main ${p()}]`,m,...k))}debug(m,...k){this.f(n.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,m,...k):console.log(`[main ${p()}]`,m,...k))}info(m,...k){this.f(n.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,m,...k):console.log(`[main ${p()}]`,m,...k))}warn(m,...k){this.f(n.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,m,...k):console.warn(`[main ${p()}]`,m,...k))}error(m,...k){this.f(n.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,m,...k):console.error(`[main ${p()}]`,m,...k))}flush(){}}e.$wj=a;class u extends t{constructor(m=e.$sj,k=!0){super(),this.g=k,this.setLevel(m)}trace(m,...k){this.f(n.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...k):console.log(m,...k))}debug(m,...k){this.f(n.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...k):console.log(m,...k))}info(m,...k){this.f(n.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...k):console.log(m,...k))}warn(m,...k){this.f(n.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...k):console.log(m,...k))}error(m,...k){this.f(n.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...k):console.error(m,...k))}flush(){}}e.$xj=u;class i extends t{constructor(m,k=e.$sj){super(),this.g=m,this.setLevel(k)}trace(m,...k){this.f(n.Trace)&&this.g.log(n.Trace,[this.h(m),...k])}debug(m,...k){this.f(n.Debug)&&this.g.log(n.Debug,[this.h(m),...k])}info(m,...k){this.f(n.Info)&&this.g.log(n.Info,[this.h(m),...k])}warn(m,...k){this.f(n.Warning)&&this.g.log(n.Warning,[this.h(m),...k])}error(m,...k){this.f(n.Error)&&this.g.log(n.Error,[this.h(m),...k])}h(m){return typeof m=="string"?m:(0,S.$Si)(m,this.f(n.Trace))}flush(){}}e.$yj=i;class v extends t{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const k of this.g)k.setLevel(m);super.setLevel(m)}trace(m,...k){for(const T of this.g)T.trace(m,...k)}debug(m,...k){for(const T of this.g)T.debug(m,...k)}info(m,...k){for(const T of this.g)T.info(m,...k)}warn(m,...k){for(const T of this.g)T.warn(m,...k)}error(m,...k){for(const T of this.g)T.error(m,...k)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose();super.dispose()}}e.$zj=v;class o extends R.$Tc{constructor(m,k,T){if(super(),this.h=m,this.j=k,this.b=new L.$Ac,this.c=this.B(new M.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Wd),this.onDidChangeVisibility=this.g.event,T)for(const O of T)this.b.set(O.resource,{logger:void 0,info:O})}m(m){return(0,E.$Jf)(m)?[...this.b.values()].find(k=>k.info.id===m):this.b.get(m)}getLogger(m){return this.m(m)?.logger}createLogger(m,k){const T=this.n(m),O=(0,E.$Jf)(m)?m:k?.id??(0,I.$Vi)(T.toString()).toString(16);let G=this.b.get(T)?.logger;const q=k?.logLevel==="always"?n.Trace:k?.logLevel;G||(G=this.s(T,q??this.getLogLevel(T)??this.h,{...k,id:O}));const j={logger:G,info:{resource:T,id:O,logLevel:q,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(j.info),this.b.set(T,j),G}n(m){return(0,E.$Jf)(m)?(0,h.$Ig)(this.j,`${m}.log`):m}setLogLevel(m,k){if(A.URI.isUri(m)){const T=m,O=k,G=this.b.get(T);G&&O!==G.info.logLevel&&(G.info.logLevel=O===this.h?void 0:O,G.logger?.setLevel(O),this.b.set(G.info.resource,G),this.f.fire([T,O]))}else{this.h=m;for(const[T,O]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,k){const T=this.m(m);T&&k!==!T.info.hidden&&(T.info.hidden=!k,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,k]))}getLogLevel(m){let k;return m&&(k=this.b.get(m)?.info.logLevel),k??this.h}registerLogger(m){const k=this.b.get(m.resource);k?k.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const k=this.b.get(m);k&&(k.logger&&k.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Aj=o;class w{constructor(){this.onDidChangeLogLevel=new M.$Wd().event}setLevel(m){}getLevel(){return n.Info}trace(m,...k){}debug(m,...k){}info(m,...k){}warn(m,...k){}error(m,...k){}critical(m,...k){}dispose(){}flush(){}}e.$Bj=w;class y extends w{}e.$Cj=y;function d(f){if(f.verbose)return n.Trace;if(typeof f.logLevel=="string"){const m=P(f.logLevel.toLowerCase());if(m!==void 0)return m}return e.$sj}e.$Dj=d;function b(f){switch(f){case n.Trace:return"trace";case n.Debug:return"debug";case n.Info:return"info";case n.Warning:return"warn";case n.Error:return"error";case n.Off:return"off"}}e.$Ej=b;function P(f){switch(f){case"trace":return n.Trace;case"debug":return n.Debug;case"info":return n.Info;case"warn":return n.Warning;case"error":return n.Error;case"critical":return n.Error;case"off":return n.Off}}e.$Fj=P,e.$Gj=new D.$mj("logLevel",b(n.Info))}),define(Re[186],Ae([1,0,6,14]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=void 0;class I extends S.$Tc{constructor(L,g=[]){super(),this.a=new M.$zj([L,...g]),this.B(L.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...g){this.a.trace(L,...g)}debug(L,...g){this.a.debug(L,...g)}info(L,...g){this.a.info(L,...g)}warn(L,...g){this.a.warn(L,...g)}error(L,...g){this.a.error(L,...g)}flush(){this.a.flush()}}e.$LO=I}),define(Re[99],Ae([1,0,32,154,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(h){h[h.Unnecessary=1]="Unnecessary",h[h.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var L;(function(h){h[h.Hint=1]="Hint",h[h.Info=2]="Info",h[h.Warning=4]="Warning",h[h.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(h){function E($,n){return n-$}h.compare=E;const A=Object.create(null);A[h.Error]=(0,M.localize)(0,null),A[h.Warning]=(0,M.localize)(1,null),A[h.Info]=(0,M.localize)(2,null);function D($){return A[$]||""}h.toString=D;function l($){switch($){case S.default.Error:return h.Error;case S.default.Warning:return h.Warning;case S.default.Info:return h.Info;case S.default.Ignore:return h.Hint}}h.fromSeverity=l;function p($){switch($){case h.Error:return S.default.Error;case h.Warning:return S.default.Warning;case h.Info:return S.default.Info;case h.Hint:return S.default.Ignore}}h.toSeverity=p}(L||(e.MarkerSeverity=L={}));var g;(function(h){const E="";function A(l){return D(l,!0)}h.makeKey=A;function D(l,p){const $=[E];return l.source?$.push(l.source.replace("\xA6","\\\xA6")):$.push(E),l.code?typeof l.code=="string"?$.push(l.code.replace("\xA6","\\\xA6")):$.push(l.code.value.replace("\xA6","\\\xA6")):$.push(E),l.severity!==void 0&&l.severity!==null?$.push(L.toString(l.severity)):$.push(E),l.message&&p?$.push(l.message.replace("\xA6","\\\xA6")):$.push(E),l.startLineNumber!==void 0&&l.startLineNumber!==null?$.push(l.startLineNumber.toString()):$.push(E),l.startColumn!==void 0&&l.startColumn!==null?$.push(l.startColumn.toString()):$.push(E),l.endLineNumber!==void 0&&l.endLineNumber!==null?$.push(l.endLineNumber.toString()):$.push(E),l.endColumn!==void 0&&l.endColumn!==null?$.push(l.endColumn.toString()):$.push(E),$.push(E),$.join("\xA6")}h.makeKeyOptionalMessage=D})(g||(e.IMarkerData=g={})),e.$Ct=(0,I.$8h)("markerService")}),define(Re[187],Ae([1,0,5,32,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.NotificationsFilter=e.$sv=e.NeverShowAgainScope=e.NotificationPriority=e.$rv=e.Severity=void 0,e.Severity=M.default,e.$rv=(0,I.$8h)("notificationService");var R;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var L;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function g(D){if(D){const l=D;return typeof l.id=="string"&&typeof l.label=="string"}return!1}e.$sv=g;var h;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})(h||(e.NotificationsFilter=h={}));class E{constructor(){this.progress=new A,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$tv=E;class A{infinite(){}done(){}total(l){}worked(l){}}e.$uv=A}),define(Re[188],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=void 0,e.$Hj=(0,S.$8h)("productService"),e.$Ij="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(me,e,S,M){var I=arguments.length,R=I<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,S):M,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(me,e,S,M);else for(var g=me.length-1;g>=0;g--)(L=me[g])&&(R=(I<3?L(R):I>3?L(e,S,R):L(e,S))||R);return I>3&&R&&Object.defineProperty(e,S,R),R},qe=this&&this.__param||function(me,e){return function(S,M){e(S,M,me)}};define(Re[72],Ae([1,0,11,21,6,4]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.ProgressLocation=e.$vv=void 0,e.$vv=(0,R.$8h)("progressService");var L;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$wv=Object.freeze({total(){},worked(){},done(){}});class g{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$xv=g;class h{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const p=this.d;this.d=()=>{p?.(),l()}}):Promise.resolve()}}e.$yv=h;let E=class extends I.$Tc{constructor(l,p){super(),this.a=new S.$sh,p.withProgress(l,$=>(this.b=$,this.c&&$.report(this.c),this.a.p)),this.B((0,I.$Rc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$zv=E,e.$zv=E=Je([qe(1,e.$vv)],E);class A extends I.$Tc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new I.$Sc)}start(l){this.stop();const p=++this.a,$=new M.$7d;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,I.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Rc)(()=>$.cancel())),this.b.add((0,I.$Rc)(()=>this.c?this.c.done():void 0)),{id:p,token:$.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$Av=A,e.$Bv=(0,R.$8h)("editorProgressService")}),define(Re[30],Ae([1,0,54,16]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class I{constructor(){this.a=new Map}add(L,g){S.ok(M.$Jf(L)),S.ok(M.$Lf(g)),S.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,g)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$Kn=new I}),define(Re[73],Ae([1,0,5,30]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0,e.$Ln={JSONContribution:"base.contributions.json"};function I(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class R{constructor(){this.b=new S.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,E){this.a[I(h)]=E,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const L=new R;M.$Kn.add(e.$Ln.JSONContribution,L)}),define(Re[55],Ae([1,0,18,5,16,148,46,73,30]),function(me,e,S,M,I,R,L,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ConfigurationScope=e.$Pn=e.EditPresentationTypes=void 0;var E;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$Pn={Configuration:"base.contributions.configuration"};var A;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn={properties:{},patternProperties:{}},e.$Wn="vscode://schemas/settings/resourceLanguage",e.$Xn="vscode://schemas/settings/configurationDefaults";const D=h.$Kn.as(g.$Ln.JSONContribution);class l{constructor(){this.h=new Set,this.i=new M.$Wd,this.onDidSchemaChange=this.i.event,this.j=new M.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$Wn,this.g),this.v()}registerConfiguration(i,v=!0){this.registerConfigurations([i],v)}registerConfigurations(i,v=!0){const o=new Set;this.n(i,v,o),D.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(i){const v=new Set;this.o(i,v),D.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:v})}updateConfigurations({add:i,remove:v}){const o=new Set;this.o(v,o),this.n(i,!1,o),D.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(i){const v=new Set;this.k(i,v),this.i.fire(),this.j.fire({properties:v,defaultsOverrides:!0})}k(i,v){const o=[];for(const{overrides:w,source:y}of i)for(const d in w)if(v.add(d),e.$Zn.test(d)){const b=this.a.get(d),P=b?.valuesSources??new Map;if(y)for(const T of Object.keys(w[d]))P.set(T,y);const f={...b?.value||{},...w[d]};this.a.set(d,{source:y,value:f,valuesSources:P});const m=(0,L.$Li)(d),k={type:"object",default:f,description:R.localize(1,null,m),$ref:e.$Wn,defaultDefaultValue:f,source:I.$Jf(y)?void 0:y,defaultValueSource:y};o.push(...n(d)),this.d[d]=k,this.b.properties[d]=k}else{this.a.set(d,{value:w[d],source:y});const b=this.d[d];b&&(this.w(d,b),this.r(d,b))}this.m(o)}deregisterDefaultConfigurations(i){const v=new Set;this.l(i,v),this.i.fire(),this.j.fire({properties:v,defaultsOverrides:!0})}l(i,v){for(const{overrides:o,source:w}of i)for(const y in o){const d=this.a.get(y),b=I.$Jf(w)?w:w?.id,P=I.$Jf(d?.source)?d?.source:d?.source?.id;if(b===P)if(v.add(y),this.a.delete(y),e.$Zn.test(y))delete this.d[y],delete this.b.properties[y];else{const f=this.d[y];f&&(this.w(y,f),this.r(y,f))}}this.u()}deltaConfiguration(i){let v=!1;const o=new Set;i.removedDefaults&&(this.l(i.removedDefaults,o),v=!0),i.addedDefaults&&(this.k(i.addedDefaults,o),v=!0),i.removedConfigurations&&this.o(i.removedConfigurations,o),i.addedConfigurations&&this.n(i.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:v})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const v of i)this.h.add(v);this.u()}n(i,v,o){i.forEach(w=>{this.p(w,v,w.extensionInfo,w.restrictedProperties,void 0,o),this.c.push(w),this.q(w)})}o(i,v){const o=w=>{if(w.properties)for(const y in w.properties){v.add(y);const d=this.d[y];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[y],this.s(y,w.properties[y])}w.allOf?.forEach(y=>o(y))};for(const w of i){o(w);const y=this.c.indexOf(w);y!==-1&&this.c.splice(y,1)}}p(i,v=!0,o,w,y=3,d){y=I.$Sf(i.scope)?y:i.scope;const b=i.properties;if(b)for(const f in b){const m=b[f];if(v&&s(f,m)){delete b[f];continue}if(m.source=o,m.defaultDefaultValue=b[f].default,this.w(f,m),e.$Zn.test(f)?m.scope=void 0:(m.scope=I.$Sf(m.scope)?y:m.scope,m.restricted=I.$Sf(m.restricted)?!!w?.includes(f):m.restricted),b[f].hasOwnProperty("included")&&!b[f].included){this.f[f]=b[f],delete b[f];continue}else this.d[f]=b[f],b[f].policy?.name&&this.e.set(b[f].policy.name,f);!b[f].deprecationMessage&&b[f].markdownDeprecationMessage&&(b[f].deprecationMessage=b[f].markdownDeprecationMessage),d.add(f)}const P=i.allOf;if(P)for(const f of P)this.p(f,v,o,w,y,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const v=o=>{const w=o.properties;if(w)for(const d in w)this.r(d,w[d]);o.allOf?.forEach(v)};v(i)}r(i,v){switch(e.$Qn.properties[i]=v,v.scope){case 1:e.$Rn.properties[i]=v;break;case 2:e.$Sn.properties[i]=v;break;case 6:e.$Tn.properties[i]=v;break;case 3:e.$Un.properties[i]=v;break;case 4:e.$Vn.properties[i]=v;break;case 5:e.$Vn.properties[i]=v,this.g.properties[i]=v;break}}s(i,v){switch(delete e.$Qn.properties[i],v.scope){case 1:delete e.$Rn.properties[i];break;case 2:delete e.$Sn.properties[i];break;case 6:delete e.$Tn.properties[i];break;case 3:delete e.$Un.properties[i];break;case 4:case 5:delete e.$Vn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const v=`[${i}]`,o={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$Wn};this.w(v,o),e.$Qn.properties[v]=o,e.$Rn.properties[v]=o,e.$Sn.properties[v]=o,e.$Tn.properties[v]=o,e.$Un.properties[v]=o,e.$Vn.properties[v]=o}}v(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$Wn};e.$Qn.patternProperties[e.$Yn]=i,e.$Rn.patternProperties[e.$Yn]=i,e.$Sn.patternProperties[e.$Yn]=i,e.$Tn.patternProperties[e.$Yn]=i,e.$Un.patternProperties[e.$Yn]=i,e.$Vn.patternProperties[e.$Yn]=i,this.i.fire()}w(i,v){const o=this.a.get(i);let w=o?.value,y=o?.source;I.$Qf(w)&&(w=v.defaultDefaultValue,y=void 0),I.$Qf(w)&&(w=r(v.type)),v.default=w,v.defaultValueSource=y}}const p="\\[([^\\]]+)\\]",$=new RegExp(p,"g");e.$Yn=`^(${p})+$`,e.$Zn=new RegExp(e.$Yn);function n(u){const i=[];if(e.$Zn.test(u)){let v=$.exec(u);for(;v?.length;){const o=v[1].trim();o&&i.push(o),v=$.exec(u)}}return(0,S.$Mb)(i)}e.$1n=n;function c(u){return u.reduce((i,v)=>`${i}[${v}]`,"")}e.$2n=c;function r(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$3n=r;const t=new l;h.$Kn.add(e.$Pn.Configuration,t);function s(u,i){return u.trim()?e.$Zn.test(u)?R.localize(7,null,u):t.getConfigurationProperties()[u]!==void 0?R.localize(8,null,u):i.policy?.name&&t.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,u,i.policy?.name,t.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.$4n=s;function a(){const u=[],i=t.getConfigurationProperties();for(const v of Object.keys(i))u.push([v,i[v].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.$5n=a}),define(Re[189],Ae([1,0,18,5,119,6,28,26,16,2,46,55,30]),function(me,e,S,M,I,R,L,g,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=void 0;function p(v){return Object.isFrozen(v)?v:g.$zn(v)}class ${constructor(o={},w=[],y=[],d){this.b=o,this.c=w,this.d=y,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(w=>{if(w instanceof $)return w;const y=new n("");return y.parseRaw(w),y.configurationModel});this.f=o.reduce((w,y)=>y===w?y:w.merge(y),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,A.$Ji)(this.contents,o):this.contents}inspect(o,w){const y=this;return{get value(){return p(y.rawConfiguration.getValue(o))},get override(){return w?p(y.rawConfiguration.getOverrideValue(o,w)):void 0},get merged(){return p(w?y.rawConfiguration.override(w).getValue(o):y.rawConfiguration.getValue(o))},get overrides(){const d=[];for(const{contents:b,identifiers:P,keys:f}of y.rawConfiguration.overrides){const m=new $(b,f).getValue(o);m!==void 0&&d.push({identifiers:P,value:m})}return d.length?p(d):void 0}}}getOverrideValue(o,w){const y=this.i(w);return y?o?(0,A.$Ji)(y,o):y:void 0}getKeysForOverrideIdentifier(o){const w=[];for(const y of this.overrides)y.identifiers.includes(o)&&w.push(...y.keys);return S.$Mb(w)}getAllOverrideIdentifiers(){const o=[];for(const w of this.overrides)o.push(...w.identifiers);return S.$Mb(o)}override(o){let w=this.a.get(o);return w||(w=this.g(o),this.a.set(o,w)),w}merge(...o){const w=g.$yn(this.contents),y=g.$yn(this.overrides),d=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const P of o)if(b.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(w,P.contents);for(const f of P.overrides){const[m]=y.filter(k=>S.$ub(k.identifiers,f.identifiers));m?(this.h(m.contents,f.contents),m.keys.push(...f.keys),m.keys=S.$Mb(m.keys)):y.push(g.$yn(f))}for(const f of P.keys)d.indexOf(f)===-1&&d.push(f)}return new $(w,d,y,b.every(P=>P instanceof $)?void 0:b)}g(o){const w=this.i(o);if(!w||typeof w!="object"||!Object.keys(w).length)return this;const y={};for(const d of S.$Mb([...Object.keys(this.contents),...Object.keys(w)])){let b=this.contents[d];const P=w[d];P&&(typeof b=="object"&&typeof P=="object"?(b=g.$yn(b),this.h(b,P)):b=P),y[d]=b}return new $(y,this.keys,this.overrides)}h(o,w){for(const y of Object.keys(w)){if(y in o&&h.$Lf(o[y])&&h.$Lf(w[y])){this.h(o[y],w[y]);continue}o[y]=g.$yn(w[y])}}i(o){let w=null,y=null;const d=b=>{b&&(y?this.h(y,b):y=g.$yn(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===o?w=b.contents:b.identifiers.includes(o)&&d(b.contents);return d(w),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,w){this.j(o,w,!0)}setValue(o,w){this.j(o,w,!1)}removeValue(o){const w=this.keys.indexOf(o);w!==-1&&(this.keys.splice(w,1),(0,A.$Ii)(this.contents,o),D.$Zn.test(o)&&this.overrides.splice(this.overrides.findIndex(y=>S.$ub(y.identifiers,(0,D.$1n)(o))),1))}j(o,w,y){(0,A.$Hi)(this.contents,o,w,d=>console.error(d)),y=y||this.keys.indexOf(o)===-1,y&&this.keys.push(o),D.$Zn.test(o)&&this.overrides.push({identifiers:(0,D.$1n)(o),keys:Object.keys(this.contents[o]),contents:(0,A.$Gi)(this.contents[o],d=>console.error(d))})}}e.$6n=$;class n{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,w){if(!h.$Sf(o)){const y=this.g(o);this.parseRaw(y,w)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,w){this.a=o;const{contents:y,keys:d,overrides:b,restricted:P,hasExcludedProperties:f}=this.h(o,w);this.b=new $(y,d,b,f?[o]:void 0),this.c=P||[]}g(o){let w={},y=null,d=[];const b=[],P=[];function f(k){Array.isArray(d)?d.push(k):y!==null&&(d[y]=k)}const m={onObjectBegin:()=>{const k={};f(k),b.push(d),d=k,y=null},onObjectProperty:k=>{y=k},onObjectEnd:()=>{d=b.pop()},onArrayBegin:()=>{const k=[];f(k),b.push(d),d=k,y=null},onArrayEnd:()=>{d=b.pop()},onLiteralValue:f,onError:(k,T,O)=>{P.push({error:k,offset:T,length:O})}};if(o)try{I.$mn(o,m),w=d[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return w}h(o,w){const y=l.$Kn.as(D.$Pn.Configuration).getConfigurationProperties(),d=this.i(o,y,!0,w);o=d.raw;const b=(0,A.$Gi)(o,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),P=Object.keys(o),f=this.j(o,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:b,keys:P,overrides:f,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(o,w,y,d){let b=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:b};const P={},f=[];for(const m in o)if(D.$Zn.test(m)&&y){const k=this.i(o[m],w,!1,d);P[m]=k.raw,b=b||k.hasExcludedProperties,f.push(...k.restricted)}else{const k=w[m],T=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&f.push(m),!d.exclude?.includes(m)&&(d.include?.includes(m)||(T===void 0||d.scopes===void 0||d.scopes.includes(T))&&!(d.skipRestricted&&k?.restricted))?P[m]=o[m]:b=!0}return{raw:P,restricted:f,hasExcludedProperties:b}}j(o,w){const y=[];for(const d of Object.keys(o))if(D.$Zn.test(d)){const b={};for(const P in o[d])b[P]=o[d][P];y.push({identifiers:(0,D.$1n)(d),keys:Object.keys(b),contents:(0,A.$Gi)(b,w)})}return y}}e.$7n=n;class c extends R.$Tc{constructor(o,w,y,d){super(),this.c=o,this.f=w,this.g=d,this.b=this.B(new M.$Wd),this.onDidChange=this.b.event,this.a=new n(this.c.toString()),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&y.isEqual(b.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$8n=c;class r{constructor(o,w,y,d,b,P,f,m,k,T,O,G,q){this.a=o,this.b=w,this.c=y,this.overrideIdentifiers=d,this.d=b,this.f=P,this.g=f,this.h=m,this.i=k,this.j=T,this.k=O,this.l=G,this.m=q}get value(){return p(this.c)}n(o){return o?.value!==void 0||o?.override!==void 0||o?.overrides!==void 0?o:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class t{constructor(o,w,y,d,b=new $,P=new $,f=new L.$Ac,m=new $,k=new L.$Ac){this.c=o,this.d=w,this.f=y,this.g=d,this.h=b,this.i=P,this.j=f,this.l=m,this.m=k,this.a=null,this.b=new L.$Ac,this.n=null}getValue(o,w,y){return this.p(o,w,y).getValue(o)}updateValue(o,w,y={}){let d;y.resource?(d=this.m.get(y.resource),d||(d=new $,this.m.set(y.resource,d))):d=this.l,w===void 0?d.removeValue(o):d.setValue(o,w),y.resource||(this.a=null)}inspect(o,w,y){const d=this.p(o,w,y),b=this.t(w.resource,y),P=w.resource?this.m.get(w.resource)||this.l:this.l,f=new Set;for(const m of d.overrides)for(const k of m.identifiers)d.getOverrideValue(o,k)!==void 0&&f.add(k);return new r(o,w,d.getValue(o),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.i:void 0,b||void 0,P)}keys(o){const w=this.t(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:w?w.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,w){this.j.set(o,w),this.b.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,w){const y=[];if(!w){const{added:d,updated:b,removed:P}=u(this.c,o);w=[...d,...b,...P]}for(const d of w)for(const b of(0,D.$1n)(d)){const P=this.c.getKeysForOverrideIdentifier(b),f=o.getKeysForOverrideIdentifier(b),m=[...f.filter(k=>P.indexOf(k)===-1),...P.filter(k=>f.indexOf(k)===-1),...P.filter(k=>!g.$Cn(this.c.override(b).getValue(k),o.override(b).getValue(k)))];y.push([b,m])}return this.updateDefaultConfiguration(o),{keys:w,overrides:y}}compareAndUpdatePolicyConfiguration(o){const{added:w,updated:y,removed:d}=u(this.d,o),b=[...w,...y,...d];return b.length&&this.updatePolicyConfiguration(o),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:w,updated:y,removed:d,overrides:b}=u(this.applicationConfiguration,o),P=[...w,...y,...d];return P.length&&this.updateApplicationConfiguration(o),{keys:P,overrides:b}}compareAndUpdateLocalUserConfiguration(o){const{added:w,updated:y,removed:d,overrides:b}=u(this.localUserConfiguration,o),P=[...w,...y,...d];return P.length&&this.updateLocalUserConfiguration(o),{keys:P,overrides:b}}compareAndUpdateRemoteUserConfiguration(o){const{added:w,updated:y,removed:d,overrides:b}=u(this.remoteUserConfiguration,o),P=[...w,...y,...d];return P.length&&this.updateRemoteUserConfiguration(o),{keys:P,overrides:b}}compareAndUpdateWorkspaceConfiguration(o){const{added:w,updated:y,removed:d,overrides:b}=u(this.workspaceConfiguration,o),P=[...w,...y,...d];return P.length&&this.updateWorkspaceConfiguration(o),{keys:P,overrides:b}}compareAndUpdateFolderConfiguration(o,w){const y=this.folderConfigurations.get(o),{added:d,updated:b,removed:P,overrides:f}=u(y,w),m=[...d,...b,...P];return(m.length||!y)&&this.updateFolderConfiguration(o,w),{keys:m,overrides:f}}compareAndDeleteFolderConfiguration(o){const w=this.folderConfigurations.get(o);if(!w)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:y,updated:d,removed:b,overrides:P}=u(w,void 0);return{keys:[...y,...d,...b],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(o,w,y){let d=this.q(w,y);return w.overrideIdentifier&&(d=d.override(w.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(d=d.merge(this.d)),d}q({resource:o},w){let y=this.r();if(w&&o){const d=w.getFolder(o);d&&(y=this.s(d.uri)||y);const b=this.m.get(o);b&&(y=y.merge(b))}return y}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(o){let w=this.b.get(o);if(!w){const y=this.r(),d=this.j.get(o);d?(w=y.merge(d),this.b.set(o,w)):w=y}return w}t(o,w){if(w&&o){const y=w.getFolder(o);if(y)return this.j.get(y.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,w)=>{const{contents:y,overrides:d,keys:b}=this.j.get(w);return o.push([w,{contents:y,overrides:d,keys:b}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(w=>o.add(w)),this.userConfiguration.keys.forEach(w=>o.add(w)),this.i.keys.forEach(w=>o.add(w)),this.j.forEach(w=>w.keys.forEach(y=>o.add(y))),[...o.values()]}u(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(w=>o.add(w)),this.userConfiguration.getAllOverrideIdentifiers().forEach(w=>o.add(w)),this.i.getAllOverrideIdentifiers().forEach(w=>o.add(w)),this.j.forEach(w=>w.getAllOverrideIdentifiers().forEach(y=>o.add(y))),[...o.values()]}v(o){const w=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(y=>w.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(y=>w.add(y)),this.i.getKeysForOverrideIdentifier(o).forEach(y=>w.add(y)),this.j.forEach(y=>y.getKeysForOverrideIdentifier(o).forEach(d=>w.add(d))),[...w.values()]}static parse(o){const w=this.w(o.defaults),y=this.w(o.policy),d=this.w(o.application),b=this.w(o.user),P=this.w(o.workspace),f=o.folders.reduce((m,k)=>(m.set(E.URI.revive(k[0]),this.w(k[1])),m),new L.$Ac);return new t(w,y,d,b,new $,P,f,new $,new L.$Ac)}static w(o){return new $(o.contents,o.keys,o.overrides)}}e.$9n=t;function s(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const o=new Set,w=new Map;for(const d of v)d.keys.forEach(b=>o.add(b)),d.overrides.forEach(([b,P])=>{const f=(0,L.$xc)(w,b,new Set);P.forEach(m=>f.add(m))});const y=[];return w.forEach((d,b)=>y.push([b,[...d.values()]])),{keys:[...o.values()],overrides:y}}e.$0n=s;class a{constructor(o,w,y,d){this.change=o,this.f=w,this.g=y,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const b of o.keys)this.affectedKeys.add(b);for(const[,b]of o.overrides)for(const P of b)this.affectedKeys.add(P);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=t.parse(this.f.data)),this.i}affectsConfiguration(o,w){const y=this.a+o,d=this.d.indexOf(y);if(d<0)return!1;const b=d+y.length;if(b>=this.d.length)return!1;const P=this.d.charCodeAt(b);if(P!==this.b&&P!==this.c)return!1;if(w){const f=this.previousConfiguration?this.previousConfiguration.getValue(o,w,this.f?.workspace):void 0,m=this.g.getValue(o,w,this.h);return!g.$Cn(f,m)}return!0}}e.$$n=a;function u(v,o){const{added:w,removed:y,updated:d}=i(o?.rawConfiguration,v?.rawConfiguration),b=[],P=v?.getAllOverrideIdentifiers()||[],f=o?.getAllOverrideIdentifiers()||[];if(o){const m=f.filter(k=>!P.includes(k));for(const k of m)b.push([k,o.getKeysForOverrideIdentifier(k)])}if(v){const m=P.filter(k=>!f.includes(k));for(const k of m)b.push([k,v.getKeysForOverrideIdentifier(k)])}if(o&&v){for(const m of P)if(f.includes(m)){const k=i({contents:v.getOverrideValue(void 0,m)||{},keys:v.getKeysForOverrideIdentifier(m)},{contents:o.getOverrideValue(void 0,m)||{},keys:o.getKeysForOverrideIdentifier(m)});b.push([m,[...k.added,...k.removed,...k.updated]])}}return{added:w,removed:y,updated:d,overrides:b}}function i(v,o){const w=v?o?v.keys.filter(b=>o.keys.indexOf(b)===-1):[...v.keys]:[],y=o?v?o.keys.filter(b=>v.keys.indexOf(b)===-1):[...o.keys]:[],d=[];if(v&&o){for(const b of o.keys)if(v.keys.indexOf(b)!==-1){const P=(0,A.$Ji)(o.contents,b),f=(0,A.$Ji)(v.contents,b);g.$Cn(P,f)||d.push(b)}}return{added:w,removed:y,updated:d}}}),define(Re[100],Ae([1,0,15,4]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.RemoteAuthorityResolverErrorCode=e.$_k=e.$$k=e.RemoteConnectionType=e.$0k=void 0,e.$0k=(0,M.$8h)("remoteAuthorityResolverService");var I;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class R{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$$k=R;class L{constructor(D,l){this.host=D,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$_k=L;var g;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(g||(e.RemoteAuthorityResolverErrorCode=g={}));class h extends S.$bb{static isNotAvailable(D){return D instanceof h&&D._code===g.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof h&&D._code===g.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof h&&D._code===g.NoResolverFound}static isInvalidAuthority(D){return D instanceof h&&D._code===g.InvalidAuthority}static isHandled(D){return D instanceof h&&D.isHandled}constructor(D,l=g.Unknown,p){super(D),this._message=D,this._code=l,this._detail=p,this.isHandled=l===g.NotAvailable&&p===!0,Object.setPrototypeOf(this,h.prototype)}}e.$al=h;function E(A){const D=A.indexOf("+");return D===-1?A:A.substring(0,D)}e.$bl=E}),define(Re[56],Ae([1,0,12]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0;function M(E){return E.scheme===S.Schemas.vscodeRemote?E.authority:void 0}e.$cl=M;function I(E){if(!E)return;const A=E.indexOf("+");return A<0?E:E.substr(0,A)}e.$dl=I;function R(E){return`/${E.quality??"oss"}-${E.commit??"dev"}`}e.$el=R;function L(E){const{host:A,port:D}=h(E);if(typeof D>"u")throw new Error(`Invalid remote authority: ${E}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:A,port:D}}e.$fl=L;function g(E,A){let{host:D,port:l}=h(E);return typeof l>"u"&&(l=A),{host:D,port:l}}e.$gl=g;function h(E){const A=E.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const D=E.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const l=E.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:E,port:void 0}}}),define(Re[22],Ae([1,0,13,4,56]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.TargetPlatform=e.ExtensionType=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=void 0,e.$hm="extensions.user.cache",e.$im="extensions.builtin.cache",e.$jm="undefined_publisher",e.$km=["ui","workspace","web"];function R(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.$lm=R,e.$mm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(L||(e.ExtensionType=L={}));var g;(function(n){n.WIN32_X64="win32-x64",n.WIN32_ARM64="win32-arm64",n.LINUX_X64="linux-x64",n.LINUX_ARM64="linux-arm64",n.LINUX_ARMHF="linux-armhf",n.ALPINE_X64="alpine-x64",n.ALPINE_ARM64="alpine-arm64",n.DARWIN_X64="darwin-x64",n.DARWIN_ARM64="darwin-arm64",n.WEB="web",n.UNIVERSAL="universal",n.UNKNOWN="unknown",n.UNDEFINED="undefined"})(g||(e.TargetPlatform=g={}));class h{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,r){if(typeof c>"u"||c===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof c=="string"||typeof r=="string"){const t=typeof c=="string"?c:c.value,s=typeof r=="string"?r:r.value;return S.$af(t,s)}return c._lower===r._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$nm=h;class E{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const r of c)this.add(r)}add(c){this.c.add(h.toKey(c))}delete(c){return this.c.delete(h.toKey(c))}has(c){return this.c.has(h.toKey(c))}}e.$om=E;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(h.toKey(c))}get(c){return this.c.get(h.toKey(c))}has(c){return this.c.has(h.toKey(c))}set(c,r){this.c.set(h.toKey(c),r)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pm=A;function D(n){return l(n)}e.$qm=D;function l(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.$rm=l;function p(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.$sm=p;function $(n,c){if(c){const r=`onResolveRemoteAuthority:${(0,I.$dl)(c)}`;return!!n.activationEvents?.includes(r)}return!1}e.$tm=$,e.$um=(0,M.$8h)("IBuiltinExtensionsScannerService")}),define(Re[101],Ae([1,0,15,22]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(L,g){this.a.set(L,g)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const g=Object.create(null);for(const h of L){const E=this.readActivationEvents(h);E.length>0&&(g[M.$nm.toKey(h.identifier)]=E)}return g}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const g=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let h=0;h<g.length;h++)g[h]==="onUri"&&(g[h]=`onUri:${M.$nm.toKey(L.identifier)}`);if(!L.contributes)return g;for(const h in L.contributes){const E=this.a.get(h);if(!E)continue;const A=L.contributes[h],D=Array.isArray(A)?A:[A];try{E(D,g)}catch(l){(0,S.$1)(l)}}return g}}e.$pF=I,e.$qF=new I}),define(Re[190],Ae([1,0,20,74,33]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;function R(h){if(S.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function L(h,E,A,D,l,p,$,n,c){const r=Object.create(null);r["common.machineId"]=p,r["common.sqmId"]=$,r.sessionID=(0,I.$rg)()+Date.now(),r.commitHash=D,r.version=l,r["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,S.$h)(S.$u),r["common.nodePlatform"]=M.$dc,r["common.nodeArch"]=A,r["common.product"]=c||"desktop",n&&(r["common.msftInternal"]=n);let t=0;const s=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>t++,enumerable:!0}}),S.$l&&(r["common.snap"]="true");const a=R(E);return a&&(r["common.platformDetail"]=a),r}e.$Lo=L;function g(h){const E=M.env.USERDNSDOMAIN;if(!E)return!1;const A=E.toLowerCase();return h.some(D=>A===D)}e.$Mo=g}),define(Re[191],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=void 0,e.$wl=(0,S.$8h)("telemetryService"),e.$xl=(0,S.$8h)("customEndpointTelemetryService"),e.$yl="telemetry.currentSessionDate",e.$zl="telemetry.firstSessionDate",e.$Al="telemetry.lastSessionDate",e.$Bl="telemetry.machineId",e.$Cl="telemetry.sqmId",e.$Dl="telemetry",e.$El="telemetry.telemetryLevel",e.$Fl="telemetry.enableCrashReporter",e.$Gl="telemetry.enableTelemetry";var M;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var I;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Re[57],Ae([1,0,26,16,56,190,191]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;class g{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.$No=g;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Oo=h,e.$Po=new h;class E{async publicLog(v,o,w){}async publicLogError(v,o,w){}}e.$Qo=E,e.$Ro="telemetry",e.$So="extensionTelemetryLog",e.$To={log:()=>null,flush:()=>Promise.resolve(null)};function A(i,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!i.enableTelemetry)}e.$Uo=A;function D(i,v){return v.extensionTestsLocationURI?!0:!(v.isBuilt||v.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$Vo=D;function l(i){const v=i.getValue(L.$El),o=i.getValue(L.$Fl);if(i.getValue(L.$Gl)===!1||o===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Wo=l;function p(i){const v={},o={},w={};c(i,w);for(let y in w){y=y.length>150?y.substr(y.length-149):y;const d=w[y];typeof d=="number"?o[y]=d:typeof d=="boolean"?o[y]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${y} has been trimmed to 8192, the original length is ${d.length}`),v[y]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(v[y]=d)}return{properties:v,measurements:o}}e.$Xo=p;const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(i){if(!i)return"none";const v=(0,I.$dl)(i);return $.has(v)?v:"other"}e.$Yo=n;function c(i,v,o=0,w){if(i)for(const y of Object.getOwnPropertyNames(i)){const d=i[y],b=w?w+y:y;Array.isArray(d)?v[b]=(0,S.$Dn)(d):d instanceof Date?v[b]=d.toISOString():(0,M.$Lf)(d)?o<2?c(d,v,o+1,b+"."):v[b]=(0,S.$Dn)(d):v[b]=d}}function r(i,v){const o=i.msftInternalDomains||[],w=v.getValue("telemetry.internalTesting");return(0,R.$Mo)(o)||w}e.$Zo=r;function t(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$1o=t;function s(i,v){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const w=[];for(const P of v)for(;;){const f=P.exec(i);if(!f)break;w.push([f.index,P.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(o="";;){const P=d.exec(i);if(!P)break;const f=w.some(([m,k])=>P.index<k&&m<d.lastIndex);!y.test(P[0])&&!f&&(o+=i.substring(b,P.index)+"<REDACTED: user-file-path>",b=d.lastIndex)}return b<i.length&&(o+=i.substr(b)),o}function a(i){if(!i)return i;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of v)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function u(i,v){return(0,S.$An)(i,o=>{if(o instanceof g||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let w=o.replaceAll("%20"," ");w=s(w,v);for(const y of v)w=w.replace(y,"");return w=a(w),w}})}e.$2o=u}),define(Re[192],Ae([1,0,13,97,22,20,2,15,74,57]),function(me,e,S,M,I,R,L,g,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0;function A(o,w){return o.uuid&&w.uuid?o.uuid===w.uuid:o.id===w.id?!0:(0,S.$8e)(o.id,w.id)===0}e.$3o=A;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(w){const y=w.manifest?w.manifest.version:w.version,d=w.manifest?w.targetPlatform:w.properties.targetPlatform;return new l(w.identifier,y,d)}static parse(w){const y=D.exec(w);return y&&y[1]&&y[2]?new l({id:y[1]},y[2],y[4]||void 0):null}constructor(w,y,d="undefined"){this.version=y,this.targetPlatform=d,this.id=w.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(w){return w instanceof l?A(this,w)&&this.version===w.version&&this.targetPlatform===w.targetPlatform:!1}}e.$4o=l;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(o){const w=p.exec(o);return w&&w[1]?[c(w[1]),w[2]]:[c(o),void 0]}e.$5o=$;function n(o,w){return`${o}.${w}`}e.$6o=n;function c(o){return o.toLowerCase()}e.$7o=c;function r(o,w){return c(n(o??I.$jm,w))}e.$8o=r;function t(o,w){const y=[],d=b=>{for(const P of y)if(P.some(f=>A(w(f),w(b))))return P;return null};for(const b of o){const P=d(b);P?P.push(b):y.push([b])}return y}e.$9o=t;function s(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$0o=s;function a(o){return{id:new E.$No(o.identifier.id),name:new E.$No(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$$o=a,e.$_o=new I.$nm("pprice.better-merge");function u(o,w){const y=[],d=w.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const b=d.shift();if(b&&y.every(P=>!A(P.identifier,{id:b}))){const P=o.filter(f=>A(f.identifier,{id:b}));P.length===1&&(y.push(P[0]),d.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.$ap=u;async function i(o,w){if(!R.$k)return!1;let y;try{y=(await o.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{y=(await o.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){w.debug("Error while getting the os-release file.",(0,g.$0)(b))}}return!!y&&(y.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function v(o,w){const y=await i(o,w),d=(0,M.$xo)(y?"alpine":R.$u,h.$ec);return w.debug("ComputeTargetPlatform:",d),d}e.$bp=v}),define(Re[193],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=e.$Or=void 0;function S(h){return[...h.entries()]}e.$Or=S;function M(h){return h?[...h.entries()]:[]}e.$Pr=M;function I(h){return new Map(h)}e.$Qr=I;function R(h){return new Map(h??[])}e.$Rr=R;function L(h){return Array.from(h.entries()).map(E=>[E[0],S(E[1].map),M(E[1].descriptionMap)])}e.$Sr=L;function g(h){return new Map(h.map(E=>[E[0],{map:I(E[1]),descriptionMap:R(E[2])}]))}e.$Tr=g}),define(Re[194],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zsb=void 0;class S{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,R,L=5){const g=R(h=>{const E=typeof h=="string"?h:h.data;let A=this.a.get(I);if(A){A.data.push(E);return}const D=setTimeout(()=>this.flushBuffer(I),L);A={data:[E],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(I),g.dispose()}},this.a.set(I,A)});return g}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const R=this.a.get(I);R&&(this.a.delete(I),this.b(I,R.data.join("")))}}e.$zsb=S}),define(Re[195],Ae([1,0,11,90,40,5,16,2,155,73,30]),function(me,e,S,M,I,R,L,g,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gw=e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.IconFontDefinition=e.IconContribution=e.$yw=void 0,e.$yw={IconContribution:"base.contributions.icons"};var D;(function(a){function u(i,v){let o=i.defaults;for(;I.ThemeIcon.isThemeIcon(o);){const w=$.getIcon(o.id);if(!w)return;o=w.defaults}return o}a.getDefinition=u})(D||(e.IconContribution=D={}));var l;(function(a){function u(v){return{weight:v.weight,style:v.style,src:v.src.map(o=>({format:o.format,location:o.location.toString()}))}}a.toJSONObject=u;function i(v){const o=w=>(0,L.$Jf)(w)?w:void 0;if(v&&Array.isArray(v.src)&&v.src.every(w=>(0,L.$Jf)(w.format)&&(0,L.$Jf)(w.location)))return{weight:o(v.weight),style:o(v.style),src:v.src.map(w=>({format:w.format,location:g.URI.parse(w.location)}))}}a.fromJSONObject=i})(l||(e.IconFontDefinition=l={}));class p{constructor(){this.a=new R.$Wd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,h.localize)(0,null)},fontCharacter:{type:"string",description:(0,h.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(u,i,v,o){const w=this.b[u];if(w){if(v&&!w.description){w.description=v,this.d.properties[u].markdownDescription=`${v} $(${u})`;const b=this.e.enum.indexOf(u);b!==-1&&(this.e.enumDescriptions[b]=v),this.a.fire()}return w}const y={id:u,description:v,defaults:i,deprecationMessage:o};this.b[u]=y;const d={$ref:"#/definitions/icons"};return o&&(d.deprecationMessage=o),v&&(d.markdownDescription=`${v}: $(${u})`),this.d.properties[u]=d,this.e.enum.push(u),this.e.enumDescriptions.push(v||""),this.a.fire(),{id:u}}deregisterIcon(u){delete this.b[u],delete this.d.properties[u];const i=this.e.enum.indexOf(u);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(u=>this.b[u])}getIcon(u){return this.b[u]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(u,i){const v=this.f[u];return v||(this.f[u]=i,this.a.fire(),i)}deregisterIconFont(u){delete this.f[u]}getIconFont(u){return this.f[u]}toString(){const u=(w,y)=>w.id.localeCompare(y.id),i=w=>{for(;I.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},v=[];v.push("| preview     | identifier                        | default codicon ID                | description"),v.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.b).map(w=>this.b[w]);for(const w of o.filter(y=>!!y.description).sort(u))v.push(`|<i class="${i(w)}"></i>|${w.id}|${I.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);v.push("| preview     | identifier                        "),v.push("| ----------- | --------------------------------- |");for(const w of o.filter(y=>!I.ThemeIcon.isThemeIcon(y.defaults)).sort(u))v.push(`|<i class="${i(w)}"></i>|${w.id}|`);return v.join(`
`)}}const $=new p;A.$Kn.add(e.$yw.IconContribution,$);function n(a,u,i,v){return $.registerIcon(a,u,i,v)}e.$zw=n;function c(){return $}e.$Aw=c;function r(){const a=(0,M.$_j)();for(const u in a){const i="\\"+a[u].toString(16);$.registerIcon(u,{fontCharacter:i})}}r(),e.$Bw="vscode://schemas/icons";const t=A.$Kn.as(E.$Ln.JSONContribution);t.registerSchema(e.$Bw,$.getIconSchema());const s=new S.$hh(()=>t.notifySchemaChanged(e.$Bw),200);$.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$Cw=n("widget-close",M.$bk.close,(0,h.localize)(2,null)),e.$Dw=n("goto-previous-location",M.$bk.arrowUp,(0,h.localize)(3,null)),e.$Ew=n("goto-next-location",M.$bk.arrowDown,(0,h.localize)(4,null)),e.$Fw=I.ThemeIcon.modify(M.$bk.sync,"spin"),e.$Gw=I.ThemeIcon.modify(M.$bk.loading,"spin")}),define(Re[196],Ae([1,0,5,46,4,14]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.ProvidedOnAutoForward=e.$Ev=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dv=e.$Cv=void 0,e.$Cv=(0,I.$8h)("tunnelService"),e.$Dv=(0,I.$8h)("sharedTunnelsService");var L;(function(c){c.Http="http",c.Https="https"})(L||(e.TunnelProtocol=L={}));var g;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(g||(e.TunnelPrivacyId=g={}));function h(c){return!!c.forwardPort}e.$Ev=h;var E;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(E||(e.ProvidedOnAutoForward=E={}));function A(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(r)return{address:r[1],port:+r[2]}}e.$Fv=A,e.$Gv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(c){return e.$Gv.indexOf(c)>=0}e.$Hv=D,e.$Iv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(c){return e.$Iv.indexOf(c)>=0}e.$Jv=l;function p(c,r,t,s){if(t===1)return!1;if(t===2&&l(r)){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(a?.length===4&&parseInt(a[1])>=18)return!1}return c<1024}e.$Kv=p;class ${constructor(r,t,s){this.remoteAddress=r,this.localAddress=t,this.b=s,this.a=new S.$Wd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lv=$;let n=class{constructor(r,t){this.k=r,this.l=t,this.a=new S.$Wd,this.onTunnelOpened=this.a.event,this.b=new S.$Wd,this.onTunnelClosed=this.b.event,this.c=new S.$Wd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const r=this.l.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.f=r,r?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.g=r.elevation,this.i=r.privacyOptions,this.h=r.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const r=[],t=Array.from(this.e.values());for(const s of t){const a=Array.from(s.values());for(const u of a){const i=await u.value;i&&typeof i!="string"&&r.push(i)}}return r}async dispose(){for(const r of this.e.values()){for(const{value:t}of r.values())await t.then(s=>typeof s!="string"?s?.dispose():void 0);r.clear()}this.e.clear()}setEnvironmentTunnel(r,t,s,a,u){this.q(r,t,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:t,localAddress:s,privacy:a,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,t){(l(r)||D(r))&&(r=e.$Gv[0]);const s=this.s(r,t);if(s)return++s.refcount,s.value}openTunnel(r,t,s,a,u,i=!1,v,o){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${t}:${s} on local port ${u}.`);const w=this.f??r;if(!w)return;if(t||(t="localhost"),a||(a=this.m),this.f&&this.j.has(s)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.t(w,t,s,a,u,i,v,o);return y?y.then(d=>{if(d){if(typeof d=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(t,s),d}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(t,s);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.o(d);return(d.tunnelRemoteHost!==t||d.tunnelRemotePort!==s)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),v&&d.privacy!==v&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}o(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const t=this.e.get(r.tunnelRemoteHost);if(t){const s=t.get(r.tunnelRemotePort);s&&(s.refcount--,await this.p(r.tunnelRemoteHost,r.tunnelRemotePort,s))}}}}async p(r,t,s){if(s.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${t}.`);const a=s.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.e.has(r)&&this.e.get(r).delete(t),a}}async closeTunnel(r,t){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${t} `);const s=this.e.get(r);if(s&&s.has(t)){const a=s.get(t);a.refcount=0,await this.p(r,t,a)}}q(r,t,s){this.e.has(r)||this.e.set(r,new Map),this.e.get(r).set(t,{refcount:1,value:s})}async r(r,t){const s=this.e.get(r);if(s){const a=s.get(t),u=a?await a.value:void 0;(!u||typeof u=="string")&&s.delete(t),s.size===0&&this.e.delete(r)}}s(r,t){const s=[r];D(r)?(s.push(...e.$Gv),s.push(...e.$Iv)):l(r)&&s.push(...e.$Iv);const a=s.map(u=>this.e.get(u));for(const u of a){const i=u?.get(t);if(i)return i}}canTunnel(r){return!!A(r)}u(r,t,s,a,u,i,v){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${t}:${s} on local port ${a}.`);const o=s;this.j.add(o);const w=a===void 0?s:a,y={elevationRequired:u?this.isPortPrivileged(w):!1},d={remoteAddress:{host:t,port:s},localAddressPort:a,privacy:i,public:i?i!==g.Private:void 0,protocol:v},b=r.forwardPort(d,y);return b?(this.q(t,s,b),b.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(o)})):this.j.delete(o),b}};e.$Mv=n,e.$Mv=n=Je([qe(0,R.$pj),qe(1,M.$Bi)],n)}),define(Re[197],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Nv=void 0,e.$Nv=(0,S.$8h)("editSessionIdentityService");var M;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Re[198],Ae([1,0,12]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=void 0;function M(h){return h.scheme!==S.Schemas.file&&h.scheme!==S.Schemas.vscodeRemote}e.$SK=M;function I(h){if(h.folders.length)return h.folders.every(E=>M(E.uri))?h.folders[0].uri:void 0;if(h.configuration&&M(h.configuration))return h.configuration}e.$TK=I;function R(h){return I(h)?.scheme}e.$UK=R;function L(h){return I(h)?.authority}e.$VK=L;function g(h){return I(h)!==void 0}e.$WK=g}),define(Re[47],Ae([1,0,156,19,50,25,2,4,12]),function(me,e,S,M,I,R,L,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.WorkbenchState=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0,e.$ei=(0,g.$8h)("contextService");function E(w){const y=w;return typeof y?.id=="string"&&L.URI.isUri(y.uri)}e.$fi=E;function A(w){return typeof w?.id=="string"&&!E(w)&&!l(w)}e.$gi=A,e.$hi={id:"ext-dev"},e.$ii={id:"empty-window"};function D(w,y){if(typeof w=="string"||typeof w>"u")return typeof w=="string"?{id:(0,M.$nc)(w)}:y?e.$hi:e.$ii;const d=w;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$ji=D;function l(w){const y=w;return typeof y?.id=="string"&&L.URI.isUri(y.configPath)}e.$ki=l;function p(w){const y=w;if(y?.uri)return{id:y.id,uri:L.URI.revive(y.uri)};const d=w;if(d?.configPath)return{id:d.id,configPath:L.URI.revive(d.configPath)};if(w?.id)return{id:w.id}}e.$li=p;var $;(function(w){w[w.EMPTY=1]="EMPTY",w[w.FOLDER=2]="FOLDER",w[w.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function n(w){const y=w;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.$mi=n;function c(w){const y=w;return!!(y&&typeof y=="object"&&L.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.$ni=c;class r{constructor(y,d,b,P,f){this.h=y,this.j=b,this.k=P,this.l=f,this.c=I.$bi.forUris(this.l,()=>!0),this.folders=d}update(y){this.h=y.id,this.k=y.configuration,this.j=y.transient,this.l=y.l,this.folders=y.folders}get folders(){return this.g}set folders(y){this.g=y,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(y){this.k=y}getFolder(y){return y&&this.c.findSubstr(y)||null}n(){this.c=I.$bi.forUris(this.l,()=>!0);for(const y of this.folders)this.c.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$oi=r;class t{constructor(y,d){this.raw=d,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,R.$Ig)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$pi=t;function s(w){return new t({uri:w,index:0,name:(0,R.$Eg)(w)},{uri:w.toString()})}e.$qi=s,e.$ri="code-workspace",e.$si=`.${e.$ri}`,e.$ti=[{name:(0,S.localize)(0,null),extensions:[e.$ri]}],e.$ui="workspace.json";function a(w,y){return R.$zg.isEqualOrParent(w,y.untitledWorkspacesHome)}e.$vi=a;function u(w){let y;return L.URI.isUri(w)?y=w:y=w.configuration,y?.scheme===h.Schemas.tmp}e.$wi=u,e.$xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(w){return w.id===e.$xi}e.$yi=i;function v(w,y){return!a(w,y)&&!u(w)}e.$zi=v;function o(w){return(typeof w=="string"?(0,M.$oc)(w):(0,R.$Gg)(w))===e.$si}e.$Ai=o}),define(Re[75],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=void 0;class S{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const R=this.c++;return this.b.set(R,I),this.e(),R}get(I,R){return this.b.has(I)?this.b.get(I)[R]:void 0}delete(I){this.b.delete(I),this.e()}e(){S.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$2fc=S}),define(Re[43],Ae([1,0,12,25,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=e.$5fc=void 0;class R{constructor(){this.a=new Set(Object.keys(S.Schemas)),this.b=new Map,this.extUri=new M.$xg(g=>{const h=this.b.get(g.scheme);return!(h===void 0||h&1024)})}$acceptProviderInfos(g,h){h===null?this.b.delete(g.scheme):this.b.set(g.scheme,h)}isFreeScheme(g){return!this.b.has(g)&&!this.a.has(g)}getCapabilities(g){return this.b.get(g)}}e.$5fc=R,e.$6fc=(0,I.$8h)("IExtHostFileSystemInfo")}),define(Re[27],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=void 0,e.$EN=(0,S.$8h)("IExtHostInitDataService")}),define(Re[199],Ae([1,0,161,14,186,27]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;let L=class extends I.$LO{constructor(h,E,A){const D=A.remote.isRemote?"remoteexthost":h?"workerexthost":"exthost",l=A.remote.isRemote?(0,S.localize)(0,null):h?(0,S.localize)(1,null):(0,S.localize)(2,null);super(E.createLogger(D,{name:l}))}};e.$_hc=L,e.$_hc=L=Je([qe(1,M.$qj),qe(2,R.$EN)],L)}),define(Re[200],Ae([1,0,11]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=void 0;class M{constructor(L,g,h){this.h=new Map,this.a=L,this.b=g,this.c=h,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new S.$hh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of E.values())A.complete()}catch(A){for(const D of E.values())D.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,g){let h=this.f[L];return typeof h>"u"&&(h=g),h}update(L,g){this.f[L]=g;const h=this.h.get(L);if(h!==void 0)return h.p;const E=new S.$sh;return this.h.set(L,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Ngc=M;class I extends M{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,g){super(L.identifier.value,!0,g),this.j=L}}e.$Ogc=I}),define(Re[201],Ae([1,0,5,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;class I{constructor(L){this.c=L,this.a=new S.$Wd,this.onDidSaveNotebookDocument=this.a.event,this.b=new S.$Wd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,g,h,E){const D=this.c.getNotebookDocument(M.URI.revive(L)).acceptModelChanged(g.value,h,E);this.b.fire(D)}$acceptDirtyStateChanged(L,g){this.c.getNotebookDocument(M.URI.revive(L)).acceptDirty(g)}$acceptModelSaved(L){const g=this.c.getNotebookDocument(M.URI.revive(L));this.a.fire(g.apiNotebook)}}e.$Bhc=I}),define(Re[17],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pN=e.$oN=void 0,e.$oN=(0,S.$8h)("IExtHostRpcService");class M{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$pN=M}),define(Re[202],Ae([1,0,22,5]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;class I{#e;constructor(L,g){this.b=new M.$Wd,this.onDidChange=this.b.event,this.a=S.$nm.toKey(L.identifier),this.#e=g,this.#e.onDidChangePassword(h=>{h.extensionId===this.a&&this.b.fire({key:h.key})})}get(L){return this.#e.get(this.a,L)}store(L,g){return this.#e.store(this.a,L,g)}delete(L){return this.#e.delete(this.a,L)}}e.$Vgc=I}),define(Re[58],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=e.$lgc=void 0,e.$lgc=(0,S.$8h)("IURITransformerService");class M{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$mgc=M}),define(Re[203],Ae([1,0,23]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlb=e.$Glb=void 0;class M{constructor(){this.buffers=[]}add(h){let E=this.buffers.indexOf(h);return E<0&&(E=this.buffers.length,this.buffers.push(h)),E}}function I(g,h){if(h.serializeBuffersForPostMessage){const E=new M,D=JSON.stringify(g,(p,$)=>{if($ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add($)};if(ArrayBuffer.isView($)){const n=R($);if(n)return{$$vscode_array_buffer_reference$$:!0,index:E.add($.buffer),view:{type:n,byteLength:$.byteLength,byteOffset:$.byteOffset}}}return $}),l=E.buffers.map(p=>{const $=new Uint8Array(p);return S.$ke.wrap($)});return{message:D,buffers:l}}else return{message:JSON.stringify(g),buffers:[]}}e.$Glb=I;function R(g){switch(g.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function L(g,h){const E=h.map(l=>{const p=new ArrayBuffer(l.byteLength);return new Uint8Array(p).set(l.buffer),p}),A=h.length?(l,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const $=p,{index:n}=$,c=E[n];if($.view)switch($.view.type){case 1:return new Int8Array(c,$.view.byteOffset,$.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,$.view.byteOffset,$.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,$.view.byteOffset,$.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,$.view.byteOffset,$.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,$.view.byteOffset,$.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,$.view.byteOffset,$.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,$.view.byteOffset,$.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,$.view.byteOffset,$.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,$.view.byteOffset,$.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,$.view.byteOffset,$.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,$.view.byteOffset,$.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return p}:void 0;return{message:JSON.parse(g,A),arrayBuffers:E}}e.$Hlb=L}),define(Re[102],Ae([1,0,170,16,2,6,4,30,42,12,41,134,32]),function(me,e,S,M,I,R,L,g,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9E=e.$8E=e.$7E=e.EditorsOrder=e.$6E=e.CloseDirection=e.$5E=e.$4E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.EditorInputCapabilities=e.$UE=e.SaveReason=e.Verbosity=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=void 0,e.$HE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$IE={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.$JE="workbench.editor.sidebysideEditor",e.$KE="workbench.editors.textDiffEditor",e.$LE="workbench.editors.binaryResourceDiffEditor";var p;(function(ie){ie[ie.PROGRAMMATIC=1]="PROGRAMMATIC",ie[ie.USER=2]="USER",ie[ie.EDIT=3]="EDIT",ie[ie.NAVIGATION=4]="NAVIGATION",ie[ie.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var $;(function(ie){ie[ie.IDENTICAL=1]="IDENTICAL",ie[ie.SIMILAR=2]="SIMILAR",ie[ie.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function n(ie){const x=ie;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.$ME=n;function c(ie,x,V){for(const ne of V.visibleEditorPanes)if(ne.group.id===x&&ie.matches(ne.input))return ne.getViewState()}e.$NE=c;function r(ie){if(b(ie))return!1;const x=ie;return I.URI.isUri(x?.resource)}e.$OE=r;function t(ie){if(b(ie))return!1;const x=ie;return x?.original!==void 0&&x.modified!==void 0}e.$PE=t;function s(ie){if(b(ie))return!1;const x=ie;return!x||x.resources&&!Array.isArray(x.resources)?!1:!!x.resources||!!x.multiDiffSource}e.$QE=s;function a(ie){if(b(ie)||t(ie))return!1;const x=ie;return x?.primary!==void 0&&x.secondary!==void 0}e.$RE=a;function u(ie){if(b(ie))return!1;const x=ie;return x?x.resource===void 0||x.resource.scheme===E.Schemas.untitled||x.forceUntitled===!0:!1}e.$SE=u;function i(ie){if(b(ie))return!1;const x=ie;return I.URI.isUri(x?.base?.resource)&&I.URI.isUri(x?.input1?.resource)&&I.URI.isUri(x?.input2?.resource)&&I.URI.isUri(x?.result?.resource)}e.$TE=i;var v;(function(ie){ie[ie.SHORT=0]="SHORT",ie[ie.MEDIUM=1]="MEDIUM",ie[ie.LONG=2]="LONG"})(v||(e.Verbosity=v={}));var o;(function(ie){ie[ie.EXPLICIT=1]="EXPLICIT",ie[ie.AUTO=2]="AUTO",ie[ie.FOCUS_CHANGE=3]="FOCUS_CHANGE",ie[ie.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o||(e.SaveReason=o={}));class w{constructor(){this.a=new Map}registerSource(x,V){let ne=this.a.get(x);return ne||(ne={source:x,label:V},this.a.set(x,ne)),ne.source}getSourceLabel(x){return this.a.get(x)?.label??x}}e.$UE=new w;var y;(function(ie){ie[ie.None=0]="None",ie[ie.Readonly=2]="Readonly",ie[ie.Untitled=4]="Untitled",ie[ie.Singleton=8]="Singleton",ie[ie.RequiresTrust=16]="RequiresTrust",ie[ie.CanSplitInGroup=32]="CanSplitInGroup",ie[ie.ForceDescription=64]="ForceDescription",ie[ie.CanDropIntoEditor=128]="CanDropIntoEditor",ie[ie.MultipleEditors=256]="MultipleEditors",ie[ie.Scratchpad=512]="Scratchpad",ie[ie.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(y||(e.EditorInputCapabilities=y={}));class d extends R.$Tc{}e.$VE=d;function b(ie){return ie instanceof d}e.$WE=b;function P(ie){const x=ie;return I.URI.isUri(x?.preferredResource)}function f(ie){const x=ie;return b(x?.primary)&&b(x?.secondary)}e.$XE=f;function m(ie){const x=ie;return b(x?.modified)&&b(x?.original)}e.$YE=m;function k(ie,x,V,ne,Ie){return $e(ne,[(0,D.$Ri)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const Me={...V,limits:{size:Number.MAX_VALUE}};ie.openEditor(x,Me)}}),(0,D.$Ri)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$ZE=k;function T(ie){return b(ie?.editor)}e.$1E=T;function O(ie){const x=ie;return T(ie)&&x?.group!==void 0}e.$2E=O;function G(ie){const x=ie;return typeof x?.groupId=="number"&&b(x.editor)}e.$3E=G;var q;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.REPLACE=1]="REPLACE",ie[ie.MOVE=2]="MOVE",ie[ie.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var j;(function(ie){ie[ie.GROUP_ACTIVE=0]="GROUP_ACTIVE",ie[ie.GROUP_INDEX=1]="GROUP_INDEX",ie[ie.GROUP_LABEL=2]="GROUP_LABEL",ie[ie.GROUP_LOCKED=3]="GROUP_LOCKED",ie[ie.EDITOR_OPEN=4]="EDITOR_OPEN",ie[ie.EDITOR_CLOSE=5]="EDITOR_CLOSE",ie[ie.EDITOR_MOVE=6]="EDITOR_MOVE",ie[ie.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ie[ie.EDITOR_LABEL=8]="EDITOR_LABEL",ie[ie.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ie[ie.EDITOR_PIN=10]="EDITOR_PIN",ie[ie.EDITOR_STICKY=11]="EDITOR_STICKY",ie[ie.EDITOR_DIRTY=12]="EDITOR_DIRTY",ie[ie.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var C;(function(ie){ie[ie.PRIMARY=1]="PRIMARY",ie[ie.SECONDARY=2]="SECONDARY",ie[ie.BOTH=3]="BOTH",ie[ie.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class N{getOriginalUri(x,V){if(!x)return;if(i(x))return e.$5E.getOriginalUri(x.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Me}=this.a(x);if(Ie&&Me){if(V?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Me,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Me,{filterByScheme:V.filterByScheme});x=V.supportSideBySide===C.PRIMARY?Ie:Me}}if(t(x)||s(x)||a(x)||i(x))return;const ne=P(x)?x.preferredResource:x.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}a(x){return f(x)||a(x)?{primary:x.primary,secondary:x.secondary}:m(x)||t(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,V){if(!x)return;if(i(x))return e.$5E.getCanonicalUri(x.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Me}=this.a(x);if(Ie&&Me){if(V?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Me,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Me,{filterByScheme:V.filterByScheme});x=V.supportSideBySide===C.PRIMARY?Ie:Me}}if(t(x)||s(x)||a(x)||i(x))return;const ne=x.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}b(x,V){if(Array.isArray(V)){if(V.some(ne=>x.scheme===ne))return x}else if(V===x.scheme)return x}}var W;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.KEYBOARD=1]="KEYBOARD",ie[ie.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function se(ie,x,V,ne){if(!ie.isSticky(x))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return V===W.MOUSE||V===W.KEYBOARD;case"mouse":return V===W.MOUSE;case"keyboard":return V===W.KEYBOARD}return!1}e.$4E=se,e.$5E=new N;var ue;(function(ie){ie[ie.LEFT=0]="LEFT",ie[ie.RIGHT=1]="RIGHT"})(ue||(e.CloseDirection=ue={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(x){const V=this.a=x.get(L.$7h);for(const[ne,Ie]of this.c)this.e(ne,Ie,V);this.c.clear()}e(x,V,ne){const Ie=ne.createInstance(V);this.d.set(x,Ie)}registerFileEditorFactory(x){if(this.b)throw new Error("Can only register one file editor factory.");this.b=x}getFileEditorFactory(){return(0,M.$Uf)(this.b)}registerEditorSerializer(x,V){if(this.c.has(x)||this.d.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.a?this.e(x,V,this.a):this.c.set(x,V),(0,R.$Rc)(()=>{this.c.delete(x),this.d.delete(x)})}getEditorSerializer(x){return this.d.get(typeof x=="string"?x:x.typeId)}}g.$Kn.add(e.$HE.EditorFactory,new ye);async function ke(ie,x,V){return!ie||!ie.length?[]:await Promise.all(ie.map(async ne=>{const Ie=I.URI.revive(ne.fileUri);if(!Ie){V.info("Cannot resolve the path because it is not valid.",ne);return}if(!await x.canHandleResource(Ie)){V.info("Cannot resolve the path because it cannot be handled",ne);return}let Le=ne.exists,be=ne.type;if(typeof Le!="boolean"||typeof be!="number")try{be=(await x.stat(Ie)).isDirectory?h.FileType.Directory:h.FileType.Unknown,Le=!0}catch(K){V.error(K),Le=!1}if(!Le&&ne.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ne);return}if(be===h.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ne);return}const ge={...ne.options,pinned:!0};return Le?{resource:Ie,options:ge}:{resource:Ie,options:ge,forceUntitled:!0}}))}e.$6E=ke;var ae;(function(ie){ie[ie.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ie[ie.SEQUENTIAL=1]="SEQUENTIAL"})(ae||(e.EditorsOrder=ae={}));function pe(ie){const x=ie;if(!x)return!1;const V=x;if(V.modified)return pe(V.modified);const ne=x;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$7E=pe;function oe(ie){return(0,A.$Ti)(ie)}e.$8E=oe;function $e(ie,x,V){const ne=(0,A.$Ui)(ie,x);return ne.forceMessage=V?.forceMessage,ne.forceSeverity=V?.forceSeverity,ne.allowDialog=V?.allowDialog,ne}e.$9E=$e}),define(Re[204],Ae([1,0,5,171,4,6,28,30,18,26,90,195]),function(me,e,S,M,I,R,L,g,h,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$cF=e.ViewContentGroups=e.$bF=e.$aF=e.ViewContainerLocation=e.Extensions=e.$_E=e.$$E=e.$0E=void 0,e.$0E="views",e.$$E=(0,M.localize)(0,null),e.$_E=(0,D.$zw)("default-view-icon",A.$bk.window,(0,M.localize)(1,null));var l;(function(v){v.ViewContainersRegistry="workbench.registry.view.containers",v.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var p;(function(v){v[v.Sidebar=0]="Sidebar",v[v.Panel=1]="Panel",v[v.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$aF=[0,1,2];function $(v){switch(v){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$bF=$;class n extends R.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$Wd),this.onDidRegister=this.c.event,this.f=this.B(new S.$Wd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,h.$Rb)([...this.g.values()])}registerViewContainer(o,w,y){const d=this.get(o.id);if(d)return d;const b=o;return b.openCommandActionDescriptor=y?.doNotRegisterOpenCommand?void 0:b.openCommandActionDescriptor??{id:b.id},(0,L.$xc)(this.g,w,[]).push(b),y?.isDefault&&this.h.push(b),this.c.fire({viewContainer:b,viewContainerLocation:w}),b}deregisterViewContainer(o){for(const w of this.g.keys()){const y=this.g.get(w),d=y?.indexOf(o);if(d!==-1){y?.splice(d,1),y.length===0&&this.g.delete(w),this.f.fire({viewContainer:o,viewContainerLocation:w});return}}}get(o){return this.all.filter(w=>w.id===o)[0]}getViewContainers(o){return[...this.g.get(o)||[]]}getViewContainerLocation(o){return[...this.g.keys()].filter(w=>this.getViewContainers(w).filter(y=>y?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.h.find(w=>this.getViewContainerLocation(w)===o)}}g.$Kn.add(l.ViewContainersRegistry,new n);var c;(function(v){v.Open="2_open",v.Debug="4_debug",v.SCM="5_scm",v.More="9_more"})(c||(e.ViewContentGroups=c={}));function r(v,o){const w=v.group??c.More,y=o.group??c.More;return w!==y?w.localeCompare(y):(v.order??5)-(o.order??5)}class t extends R.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$Wd),this.onViewsRegistered=this.c.event,this.f=this.B(new S.$Wd),this.onViewsDeregistered=this.f.event,this.g=this.B(new S.$Wd),this.onDidChangeContainer=this.g.event,this.h=this.B(new S.$Wd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Gc}registerViews(o,w){this.registerViews2([{views:o,viewContainer:w}])}registerViews2(o){o.forEach(({views:w,viewContainer:y})=>this.r(w,y)),this.c.fire(o)}deregisterViews(o,w){const y=this.s(o,w);y.length&&this.f.fire({views:y,viewContainer:w})}moveViews(o,w){for(const y of this.m.keys())if(y!==w){const d=this.s(o,y);d.length&&(this.r(d,w),this.g.fire({views:d,from:y,to:w}))}}getViews(o){return this.m.get(o)||[]}getView(o){for(const w of this.j){const y=(this.m.get(w)||[]).filter(d=>d.id===o)[0];if(y)return y}return null}getViewContainer(o){for(const w of this.j)if((this.m.get(w)||[]).filter(d=>d.id===o)[0])return w;return null}registerViewWelcomeContent(o,w){return this.n.add(o,w),this.h.fire(o),(0,R.$Rc)(()=>{this.n.delete(o,w),this.h.fire(o)})}registerViewWelcomeContent2(o,w){const y=new Map;for(const[d,b]of w)this.n.add(o,b),y.set(d,(0,R.$Rc)(()=>{this.n.delete(o,b),this.h.fire(o)}));return this.h.fire(o),y}getViewWelcomeContent(o){const w=[];return this.n.forEach(o,y=>w.push(y)),w.sort(r)}r(o,w){let y=this.m.get(w);y||(y=[],this.m.set(w,y),this.j.push(w));for(const d of o){if(this.getView(d.id)!==null)throw new Error((0,M.localize)(2,null,d.id));y.push(d)}}s(o,w){const y=this.m.get(w);if(!y)return[];const d=[],b=[];for(const P of y)o.includes(P)?d.push(P):b.push(P);return d.length&&(b.length?this.m.set(w,b):(this.m.delete(w),this.j.splice(this.j.indexOf(w),1))),d}}g.$Kn.add(l.ViewsRegistry,new t),e.$cF=(0,I.$8h)("viewDescriptorService");var s;(function(v){v[v.Default=0]="Default",v[v.Expand=1]="Expand"})(s||(e.ViewVisibilityState=s={}));var a;(function(v){v[v.None=0]="None",v[v.Collapsed=1]="Collapsed",v[v.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class u{constructor(o,w){this.c=!1,this.d=!1,(0,E.$Bn)(this,o),this.d=!!w,this.resolve=async y=>{if(w&&!this.c){const d=await w(y);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}y.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$dF=u;class i extends Error{constructor(o){super((0,M.localize)(3,null,o)),this.name="NoTreeViewError"}static is(o){return o.name==="NoTreeViewError"}}e.$eF=i}),define(Re[205],Ae([1,0,2,29,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oF=e.$nF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$mF=e.$lF=void 0;function R(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof S.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(M.$Ws.isIRange)}e.$lF=R;function L(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(R)}e.$mF=L;var g;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(g||(e.InteractiveSessionVoteDirection=g={}));var h;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(h||(e.ChatAgentCopyKind=h={})),e.$nF=(0,I.$8h)("IChatService"),e.$oF="accessibility.voice.keywordActivation"}),define(Re[206],Ae([1,0,5,11,172]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$amb=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new S.$Wd,this.n=new S.$Wd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(g){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=g}onEvent(g){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=g}onRequest(g){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=g}sendResponse(g){g.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${g.command}`)):this.s("response",g)}sendRequest(g,h,E,A){const D={command:g};if(h&&Object.keys(h).length>0&&(D.arguments=h),this.s("request",D),typeof A=="number"){const l=setTimeout(()=>{clearTimeout(l);const p=this.f.get(D.seq);if(p){this.f.delete(D.seq);const $={type:"response",seq:0,request_seq:D.seq,success:!1,command:g,message:(0,I.localize)(0,null,A,g)};p($)}},A)}return E&&this.f.set(D.seq,E),D.seq}acceptMessage(g){this.j?this.j(g):(this.k.push(g),this.k.length===1&&this.q())}o(g,h){return g.type!=="event"||h.type!=="event"}async q(){let g;for(;this.k.length;){if((!g||this.o(this.k[0],g))&&await(0,M.$9g)(0),g=this.k.shift(),!g)return;switch(g.type){case"event":this.i?.(g);break;case"request":this.g?.(g);break;case"response":{const h=g,E=this.f.get(h.request_seq);E&&(this.f.delete(h.request_seq),E(h));break}}}}s(g,h){h.type=g,h.seq=this.d++,this.sendMessage(h)}async u(){if(this.f.size===0)return Promise.resolve();const g=new Map;this.f.forEach((h,E)=>g.set(E,h)),await(0,M.$9g)(500),g.forEach((h,E)=>{h({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$amb=R}),define(Re[207],Ae([1,0,2,173,35,4]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$VH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$UH=e.MemoryRangeType=e.$TH=e.State=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=void 0,e.$NG="workbench.view.debug",e.$OG="workbench.debug.variablesView",e.$PG="workbench.debug.watchExpressionsView",e.$QG="workbench.debug.callStackView",e.$RG="workbench.debug.loadedScriptsView",e.$SG="workbench.debug.breakPointsView",e.$TG="workbench.debug.disassemblyView",e.$UG="workbench.panel.repl",e.$VG="workbench.panel.repl.view",e.$WG=new I.$mj("debugType",void 0,{type:"string",description:M.localize(0,null)}),e.$XG=new I.$mj("debugConfigurationType",void 0,{type:"string",description:M.localize(1,null)}),e.$YG=new I.$mj("debugState","inactive",{type:"string",description:M.localize(2,null)}),e.$ZG="debugUx",e.$1G=new I.$mj(e.$ZG,"default",{type:"string",description:M.localize(3,null)}),e.$2G=new I.$mj("hasDebugged",!1,{type:"boolean",description:M.localize(4,null)}),e.$3G=new I.$mj("inDebugMode",!1,{type:"boolean",description:M.localize(5,null)}),e.$4G=new I.$mj("inDebugRepl",!1,{type:"boolean",description:M.localize(6,null)}),e.$5G=new I.$mj("breakpointWidgetVisible",!1,{type:"boolean",description:M.localize(7,null)}),e.$6G=new I.$mj("inBreakpointWidget",!1,{type:"boolean",description:M.localize(8,null)}),e.$7G=new I.$mj("breakpointsFocused",!0,{type:"boolean",description:M.localize(9,null)}),e.$8G=new I.$mj("watchExpressionsFocused",!0,{type:"boolean",description:M.localize(10,null)}),e.$9G=new I.$mj("watchExpressionsExist",!1,{type:"boolean",description:M.localize(11,null)}),e.$0G=new I.$mj("variablesFocused",!0,{type:"boolean",description:M.localize(12,null)}),e.$$G=new I.$mj("expressionSelected",!1,{type:"boolean",description:M.localize(13,null)}),e.$_G=new I.$mj("breakpointInputFocused",!1,{type:"boolean",description:M.localize(14,null)}),e.$aH=new I.$mj("callStackItemType",void 0,{type:"string",description:M.localize(15,null)}),e.$bH=new I.$mj("callStackSessionIsAttach",!1,{type:"boolean",description:M.localize(16,null)}),e.$cH=new I.$mj("callStackItemStopped",!1,{type:"boolean",description:M.localize(17,null)}),e.$dH=new I.$mj("callStackSessionHasOneThread",!1,{type:"boolean",description:M.localize(18,null)}),e.$eH=new I.$mj("watchItemType",void 0,{type:"string",description:M.localize(19,null)}),e.$fH=new I.$mj("canViewMemory",void 0,{type:"boolean",description:M.localize(20,null)}),e.$gH=new I.$mj("breakpointItemType",void 0,{type:"string",description:M.localize(21,null)}),e.$hH=new I.$mj("breakpointSupportsCondition",!1,{type:"boolean",description:M.localize(22,null)}),e.$iH=new I.$mj("loadedScriptsSupported",!1,{type:"boolean",description:M.localize(23,null)}),e.$jH=new I.$mj("loadedScriptsItemType",void 0,{type:"string",description:M.localize(24,null)}),e.$kH=new I.$mj("focusedSessionIsAttach",!1,{type:"boolean",description:M.localize(25,null)}),e.$lH=new I.$mj("focusedSessionIsNoDebug",!1,{type:"boolean",description:M.localize(26,null)}),e.$mH=new I.$mj("stepBackSupported",!1,{type:"boolean",description:M.localize(27,null)}),e.$nH=new I.$mj("restartFrameSupported",!1,{type:"boolean",description:M.localize(28,null)}),e.$oH=new I.$mj("stackFrameSupportsRestart",!1,{type:"boolean",description:M.localize(29,null)}),e.$pH=new I.$mj("jumpToCursorSupported",!1,{type:"boolean",description:M.localize(30,null)}),e.$qH=new I.$mj("stepIntoTargetsSupported",!1,{type:"boolean",description:M.localize(31,null)}),e.$rH=new I.$mj("breakpointsExist",!1,{type:"boolean",description:M.localize(32,null)}),e.$sH=new I.$mj("debuggersAvailable",!1,{type:"boolean",description:M.localize(33,null)}),e.$tH=new I.$mj("debugExtensionAvailable",!0,{type:"boolean",description:M.localize(34,null)}),e.$uH=new I.$mj("debugProtocolVariableMenuContext",void 0,{type:"string",description:M.localize(35,null)}),e.$vH=new I.$mj("debugSetVariableSupported",!1,{type:"boolean",description:M.localize(36,null)}),e.$wH=new I.$mj("debugSetExpressionSupported",!1,{type:"boolean",description:M.localize(37,null)}),e.$xH=new I.$mj("breakWhenValueChangesSupported",!1,{type:"boolean",description:M.localize(38,null)}),e.$yH=new I.$mj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:M.localize(39,null)}),e.$zH=new I.$mj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:M.localize(40,null)}),e.$AH=new I.$mj("terminateDebuggeeSupported",!1,{type:"boolean",description:M.localize(41,null)}),e.$BH=new I.$mj("suspendDebuggeeSupported",!1,{type:"boolean",description:M.localize(42,null)}),e.$CH=new I.$mj("variableEvaluateNamePresent",!1,{type:"boolean",description:M.localize(43,null)}),e.$DH=new I.$mj("variableIsReadonly",!1,{type:"boolean",description:M.localize(44,null)}),e.$EH=new I.$mj("variableValue",!1,{type:"string",description:M.localize(45,null)}),e.$FH=new I.$mj("variableType",!1,{type:"string",description:M.localize(46,null)}),e.$GH=new I.$mj("variableName",!1,{type:"string",description:M.localize(47,null)}),e.$HH=new I.$mj("exceptionWidgetVisible",!1,{type:"boolean",description:M.localize(48,null)}),e.$IH=new I.$mj("multiSessionRepl",!1,{type:"boolean",description:M.localize(49,null)}),e.$JH=new I.$mj("multiSessionDebug",!1,{type:"boolean",description:M.localize(50,null)}),e.$KH=new I.$mj("disassembleRequestSupported",!1,{type:"boolean",description:M.localize(51,null)}),e.$LH=new I.$mj("disassemblyViewFocus",!1,{type:"boolean",description:M.localize(52,null)}),e.$MH=new I.$mj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:M.localize(53,null)}),e.$NH=new I.$mj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:M.localize(54,null)});const L=n=>M.localize(55,null,n);e.$OH=L,e.$PH="editor.contrib.debug",e.$QH="editor.contrib.breakpoint",e.$RH="debug",e.$SH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:M.localize(56,null)};var g;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(g||(e.State=g={}));function h(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$TH=h;var E;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$UH="vscode-debug-memory";var A;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(A||(e.DebugConfigurationProviderTriggerKind=A={}));var D;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(D||(e.DebuggerString=D={})),e.$VH=(0,R.$8h)("debugService");var l;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(l||(e.BreakpointWidgetContext=l={}));var p;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(p||(e.DebugVisualizationType=p={}));var $;(function(n){n.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:S.URI.revive(c.iconPath.light),dark:S.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),n.serialize=c=>c})($||(e.IDebugVisualization=$={}))}),define(Re[208],Ae([1,0,13,2,19,26,12,29,21,18]),function(me,e,S,M,I,R,L,g,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=void 0;const A=/{([^}]+)}/g;function D(P,f,m){return P.replace(A,function(k,T){return f&&T.length>0&&T[0]!=="_"?k:m&&m.hasOwnProperty(T)?m[T]:k})}e.$cG=D;function l(P){const f={};for(const m of Object.keys(P))m.startsWith("!")||(f[m]=P[m]);return f}e.$dG=l;function p(P){return P.configuration.request==="attach"&&!$(P)&&(!P.parentSession||p(P.parentSession))}e.$eG=p;function $(P){let f=P.configuration.type;if(f)return f==="vslsShare"&&(f=P.configuration.adapterProxy.configuration.type),(0,S.$af)(f,"extensionhost")||(0,S.$af)(f,"pwa-extensionhost")?P:P.parentSession?$(P.parentSession):void 0}e.$fG=$;function n(P){return P.type&&(P.label||P.program||P.runtime)}e.$gG=n;function c(P,f,m){let k,T=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=O.exec(P);){const q=G.index+1,j=q+G[0].length;if(q<=f&&j>=m){k=G[0],T=q;break}}if(k){const q=/\w+/g;let j=null;for(;(j=q.exec(k))&&!(j.index+1+T+j[0].length>=m););j&&(k=k.substring(0,q.lastIndex))}return k?{start:T,end:T+k.length-1}:{start:0,end:0}}e.$hG=c;async function r(P,f,m,k){if(P.evaluatableExpressionProvider.has(f)){const T=P.evaluatableExpressionProvider.ordered(f),O=(0,E.$Hb)(await Promise.all(T.map(async G=>{try{return await G.provideEvaluatableExpression(f,m,k??h.CancellationToken.None)}catch{return}})));if(O.length>0){let G=O[0].expression;const q=O[0].range;return G||(G=f.getLineContent(m.lineNumber).substring(q.startColumn-1,q.endColumn-1)),{range:q,matchingExpression:G}}}else{const T=f.getLineContent(m.lineNumber),{start:O,end:G}=c(T,m.column,m.column),q=T.substring(O-1,G);return{matchingExpression:q,range:new g.$Ws(m.lineNumber,O,m.lineNumber,O+q.length)}}return null}e.$iG=r;const t=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(P){return!!(P&&P.match(t))}e.$jG=s;function a(P){if(typeof P.path=="string"&&!(typeof P.sourceReference=="number"&&P.sourceReference>0)){if(s(P.path))return M.URI.parse(P.path);if((0,I.$ic)(P.path))return M.URI.file(P.path)}return P.path}function u(P){if(typeof P.path=="object"){const f=M.URI.revive(P.path);if(f)return f.scheme===L.Schemas.file?f.fsPath:f.toString()}return P.path}function i(P,f){const m=f?a:u,k=(0,R.$yn)(P);return o(k,(T,O)=>{T&&O&&(O.path=m(O))}),k}e.$kG=i;function v(P,f){const m=f?a:u,k=(0,R.$yn)(P);return o(k,(T,O)=>{!T&&O&&(O.path=m(O))}),k}e.$lG=v;function o(P,f){switch(P.type){case"event":{const m=P;switch(m.event){case"output":f(!1,m.body.source);break;case"loadedSource":f(!1,m.body.source);break;case"breakpoint":f(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=P;switch(m.command){case"setBreakpoints":f(!0,m.arguments.source);break;case"breakpointLocations":f(!0,m.arguments.source);break;case"source":f(!0,m.arguments.source);break;case"gotoTargets":f(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(k=>f(!1,k));break;default:break}break}case"response":{const m=P;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(k=>f(!1,k.source));break;case"loadedSources":m.body.sources.forEach(k=>f(!1,k));break;case"scopes":m.body.scopes.forEach(k=>f(!1,k.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(k=>f(!1,k.source));break;case"setBreakpoints":m.body.breakpoints.forEach(k=>f(!1,k.source));break;case"disassemble":m.body?.instructions.forEach(T=>f(!1,T.location));break;default:break}break}}}function w(P){return P.filter(f=>!f.presentation?.hidden).sort((f,m)=>f.presentation?m.presentation?f.presentation.group?m.presentation.group?f.presentation.group!==m.presentation.group?f.presentation.group.localeCompare(m.presentation.group):y(f.presentation.order,m.presentation.order):-1:m.presentation.group?1:y(f.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.$mG=w;function y(P,f){return typeof P!="number"?typeof f!="number"?0:1:typeof f!="number"?-1:P-f}async function d(P,f){const m=P.getValue("debug.saveBeforeStart",{overrideIdentifier:f.activeTextEditorLanguageId});if(m!=="none"&&(await f.saveAll(),m==="allEditorsInActiveGroup")){const k=f.activeEditorPane;k&&k.input.resource?.scheme===L.Schemas.untitled&&await f.save({editor:k.input,groupId:k.group.id})}await P.reloadConfiguration()}e.$nG=d;const b=(P,f)=>!P||!f?P===f:P.name===f.name&&P.path===f.path&&P.sourceReference===f.sourceReference;e.$oG=b}),define(Re[209],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.CellExecutionUpdateType=void 0;var M;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$qJ=(0,S.$8h)("INotebookExecutionService")}),define(Re[210],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efb=e.$Dfb=e.ProxyKernelState=e.$Cfb=void 0,e.$Cfb=100;var M;(function(I){I[I.Disconnected=1]="Disconnected",I[I.Connected=2]="Connected",I[I.Initializing=3]="Initializing"})(M||(e.ProxyKernelState=M={})),e.$Dfb=(0,S.$8h)("INotebookKernelService"),e.$Efb=(0,S.$8h)("INotebookKernelHistoryService")}),define(Re[211],Ae([1,0,6,29,144,94]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GRb=void 0;class L extends S.$Tc{constructor(h,E,A){super(),this._source=h,this.b=E,this.c=A,this.a=void 0}f(h){const E=h.getLineCount();return new M.$Ws(1,1,E,this.g(h,E))}g(h,E){if(E<1||E>h.getLineCount())throw new Error("Illegal value for lineNumber");return h.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const h=new I.$eC;h.acceptChunk(this._source);const E=h.finish(!0),{textBuffer:A,disposable:D}=E.create(1);this.b=A,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(h=>{const E=new I.$eC;E.acceptChunk(h);const A=E.finish(!0),{textBuffer:D,disposable:l}=A.create(1);return this.B(l),D})),this.a}findInInputs(h){const A=new R.$5B(h,!1,!1,null).parseSearchRequest();if(!A)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,A,!0,5e3)}findInOutputs(h){const A=new R.$5B(h,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(D=>{const l=D.findMatchesLineByLine(this.f(D),A,!0,5e3);if(l.length!==0)return{textBuffer:D,matches:l}}).filter(D=>!!D):[]}}e.$GRb=L}),define(Re[48],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(R){R.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var M;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class I{static fromExtHostTestItem(L,g,h=L.parent){if(L._isRoot)return new I([g]);const E=[L.id];for(let A=h;A&&A.id!==g;A=A.parent)E.push(A.id);return E.push(g),new I(E.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const g=L.indexOf("\0");return g===-1?L:L.slice(0,g)}static fromString(L){return new I(L.split("\0"))}static join(L,g){return new I([...L.path,g])}static joinToString(L,g){return L.toString()+"\0"+g}static parentId(L){const g=L.lastIndexOf("\0");return g===-1?void 0:L.slice(0,g)}static localId(L){const g=L.lastIndexOf("\0");return g===-1?L:L.slice(g+1)}static isChild(L,g){return g.startsWith(L)&&g[L.length]==="\0"}static compare(L,g){return L===g?0:I.isChild(L,g)?2:I.isChild(g,L)?3:1}constructor(L,g=L.length){if(this.path=L,this.d=g,L.length===0||g<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new I(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new I(this.path,L)}compare(L){if(typeof L=="string")return I.compare(this.toString(),L);for(let g=0;g<L.d&&g<this.d;g++)if(L.path[g]!==this.path[g])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.$bK=I}),define(Re[59],Ae([1,0,2,92,29,48]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$iK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$hK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$gK=e.$fK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$eK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$dK=e.$cK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var g;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(g||(e.ExtTestRunProfileKind=g={}));var h;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(h||(e.TestRunProfileBitset=h={})),e.$cK=[2,4,8,16,32,64];const E=C=>"runId"in C;e.$dK=E;var A;(function(C){C.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),C.deserialize=(N,W)=>({range:I.$Ws.lift(W.range),uri:N.asCanonicalUri(S.URI.revive(W.uri))})})(A||(e.IRichLocation=A={}));var D;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(D||(e.TestMessageType=D={}));var l;(function(C){C.serialize=N=>({message:N.message,type:0,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&A.serialize(N.location)}),C.deserialize=(N,W)=>({message:W.message,type:0,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&A.deserialize(N,W.location)})})(l||(e.ITestErrorMessage=l={}));const p=(C,N)=>`${N?"s":"e"}${C}`;e.$eK=p;var $;(function(C){C.serialize=N=>({message:N.message,type:1,offset:N.offset,length:N.length,location:N.location&&A.serialize(N.location)}),C.deserialize=(N,W)=>({message:W.message,type:1,offset:W.offset,length:W.length,location:W.location&&A.deserialize(N,W.location)})})($||(e.ITestOutputMessage=$={}));var n;(function(C){C.serialize=N=>N.type===0?l.serialize(N):$.serialize(N),C.deserialize=(N,W)=>W.type===0?l.deserialize(N,W):$.deserialize(N,W)})(n||(e.ITestMessage=n={}));var c;(function(C){C.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),C.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(n.serialize)}),C.deserialize=(N,W)=>({state:W.state,duration:W.duration,messages:W.messages.map(se=>n.deserialize(N,se))})})(c||(e.ITestTaskState=c={}));const r="\0",t=(C,N)=>C+r+N;e.$fK=t;const s=C=>{const N=C.indexOf(r);return{ctrlId:C.slice(0,N),tagId:C.slice(N+1)}};e.$gK=s;var a;(function(C){C.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),C.deserialize=(N,W)=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?N.asCanonicalUri(S.URI.revive(W.uri)):void 0,range:W.range?I.$Ws.lift(W.range):null,description:W.description,error:W.error,sortText:W.sortText})})(a||(e.ITestItem=a={}));var u;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var i;(function(C){C.serialize=N=>({expand:N.expand,item:a.serialize(N.item)}),C.deserialize=(N,W)=>({controllerId:R.$bK.root(W.item.extId),expand:W.expand,item:a.deserialize(N,W.item)})})(i||(e.InternalTestItem=i={}));var v;(function(C){C.serialize=N=>{let W;return N.item&&(W={},N.item.label!==void 0&&(W.label=N.item.label),N.item.tags!==void 0&&(W.tags=N.item.tags),N.item.busy!==void 0&&(W.busy=N.item.busy),N.item.uri!==void 0&&(W.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&(W.range=N.item.range?.toJSON()),N.item.description!==void 0&&(W.description=N.item.description),N.item.error!==void 0&&(W.error=N.item.error),N.item.sortText!==void 0&&(W.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:W}},C.deserialize=N=>{let W;return N.item&&(W={},N.item.label!==void 0&&(W.label=N.item.label),N.item.tags!==void 0&&(W.tags=N.item.tags),N.item.busy!==void 0&&(W.busy=N.item.busy),N.item.range!==void 0&&(W.range=N.item.range?I.$Ws.lift(N.item.range):null),N.item.description!==void 0&&(W.description=N.item.description),N.item.error!==void 0&&(W.error=N.item.error),N.item.sortText!==void 0&&(W.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:W}}})(v||(e.ITestItemUpdate=v={}));const o=(C,N)=>{N.expand!==void 0&&(C.expand=N.expand),N.item!==void 0&&(C.item=C.item?Object.assign(C.item,N.item):N.item)};e.$hK=o;var w;(function(C){C.serializeWithoutMessages=N=>({...i.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(c.serializeWithoutMessages)}),C.serialize=N=>({...i.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(c.serialize)}),C.deserialize=(N,W)=>({...i.deserialize(N,W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(se=>c.deserialize(N,se)),retired:!0})})(w||(e.TestResultItem=w={}));var y;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(N,W)=>{N.covered+=W.covered,N.total+=W.total}})(y||(e.ICoveredCount=y={}));var d;(function(C){C.serialize=N=>({statement:N.statement,branch:N.branch,function:N.function,details:N.details?.map(m.serialize),uri:N.uri.toJSON()}),C.deserialize=(N,W)=>({statement:W.statement,branch:W.branch,function:W.function,details:W.details?.map(m.deserialize),uri:N.asCanonicalUri(S.URI.revive(W.uri))})})(d||(e.IFileCoverage=d={}));function b(C){return{...C,location:C.location?.toJSON()}}function P(C){return C.location=C.location?M.$Vs.isIPosition(C.location)?M.$Vs.lift(C.location):I.$Ws.lift(C.location):void 0,C}e.$iK=3;var f;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement",C[C.Branch=2]="Branch"})(f||(e.DetailType=f={}));var m;(function(C){C.serialize=N=>N.type===0?T.serialize(N):O.serialize(N),C.deserialize=N=>N.type===0?T.deserialize(N):O.deserialize(N)})(m||(e.CoverageDetails=m={}));var k;(function(C){C.serialize=b,C.deserialize=P})(k||(e.IBranchCoverage=k={}));var T;(function(C){C.serialize=b,C.deserialize=P})(T||(e.IFunctionCoverage=T={}));var O;(function(C){C.serialize=N=>({...b(N),branches:N.branches?.map(k.serialize)}),C.deserialize=N=>({...P(N),branches:N.branches?.map(k.deserialize)})})(O||(e.IStatementCoverage=O={}));var G;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var q;(function(C){C.deserialize=(N,W)=>W.op===0?{op:W.op,item:i.deserialize(N,W.item)}:W.op===1?{op:W.op,item:v.deserialize(W.item)}:W.op===2?{op:W.op,uri:N.asCanonicalUri(S.URI.revive(W.uri)),docv:W.docv}:W,C.serialize=N=>N.op===0?{op:N.op,item:i.serialize(N.item)}:N.op===1?{op:N.op,item:v.serialize(N.item)}:N})(q||(e.TestsDiffOp=q={}));class j{constructor(N){this.k=N,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(N){const W=this.v();for(const se of N)switch(se.op){case 0:this.l(i.deserialize(this.k,se.item),W);break;case 1:this.o(v.deserialize(se.item),W);break;case 3:this.p(se.itemId,W);break;case 5:this.q(se.itemId);break;case 4:this.updatePendingRoots(se.amount);break;case 6:this.c.set(se.tag.id,se.tag);break;case 7:this.c.delete(se.id);break}W.complete?.()}l(N,W){const se=R.$bK.parentId(N.item.extId)?.toString();let ue;if(!se)ue=this.w(N),this.g.add(ue),this.f.set(N.item.extId,ue);else if(this.f.has(se)){const ye=this.f.get(se);ye.children.add(N.item.extId),ue=this.w(N,ye),this.f.set(N.item.extId,ue)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return W.add?.(ue),N.expand===2&&this.h++,ue}o(N,W){const se=this.f.get(N.extId);if(se)return N.expand!==void 0&&(se.expand===2&&this.h--,N.expand===2&&this.h++),(0,e.$hK)(se,N),W.update?.(se),se}p(N,W){const se=this.f.get(N);if(!se)return;const ue=R.$bK.parentId(se.item.extId)?.toString();ue?this.f.get(ue).children.delete(se.item.extId):this.g.delete(se);const ye=[[N]];for(;ye.length;)for(const ke of ye.pop()){const ae=this.f.get(ke);ae&&(ye.push(ae.children),this.f.delete(ke),W.remove?.(ae,ae!==se),ae.expand===2&&this.h--)}}q(N){}updatePendingRoots(N){this.j+=N}v(){return{}}}e.$jK=j}),define(Re[76],Ae([1,0,11,5,6,54,59,48]),function(me,e,S,M,I,R,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.TestItemEventOp=void 0;var h;(function(t){t[t.Upsert=0]="Upsert",t[t.SetTags=1]="SetTags",t[t.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",t[t.RemoveChild=3]="RemoveChild",t[t.SetProp=4]="SetProp",t[t.Bulk=5]="Bulk",t[t.DocumentSynced=6]="DocumentSynced"})(h||(e.TestItemEventOp=h={}));const E=(t,s)=>t===s,D=Object.entries({range:(t,s)=>t===s?!0:!t||!s?!1:t.equalsRange(s),busy:E,label:E,description:E,error:E,sortText:E,tags:(t,s)=>!(t.length!==s.length||t.some(a=>!s.includes(a)))}),l=(t,s)=>{let a;for(const[u,i]of D)i(t[u],s[u])||(a?a[u]=s[u]:a={[u]:s[u]});return a};class p extends I.$Tc{get root(){return this.s.root}constructor(s){super(),this.s=s,this.f=this.B(new S.$hh(()=>this.flushDiff(),200)),this.g=this.B(new M.$Wd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(s){this.h=s;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const s=this.m;return this.m=[],s}pushDiff(s){switch(s.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===s.uri){a.docv=s.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===s.item.extId){(0,L.$hK)(a.item,s.item);return}if(a.op===0&&a.item.item.extId===s.item.extId){(0,L.$hK)(a.item,s.item);return}}break}}this.m.push(s),this.f.isScheduled()||this.f.schedule()}expand(s,a){const u=this.tree.get(s);if(u){if((u.expandLevels===void 0||a>u.expandLevels)&&(u.expandLevels=a),u.expand===1){const i=this.M(u);return i.isOpen()?this.L(u,a-1):i.wait().then(()=>this.L(u,a-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.L(u,a-1)):this.L(u,a-1)}}dispose(){for(const s of this.tree.values())this.s.getApiFor(s.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(s,a){switch(a.op){case 3:this.O(g.$bK.joinToString(s.fullId,a.id));break;case 0:this.z(a.item,s);break;case 5:for(const u of a.ops)this.w(s,u);break;case 1:this.C(a.new,a.old,s.fullId.toString());break;case 2:this.J(s);break;case 4:this.pushDiff({op:1,item:{extId:s.fullId.toString(),item:a.update}});break;case 6:this.y(s.actual.uri);break;default:(0,R.$6c)(a)}}y(s){s&&this.pushDiff({op:2,uri:s,docv:this.s.getDocumentVersion(s)})}z(s,a){const u=g.$bK.fromExtHostTestItem(s,this.root.id,a?.actual),i=this.s.getApiFor(s);i.parent&&i.parent!==a?.actual&&this.s.getChildren(i.parent).delete(s.id);let v=this.tree.get(u.toString());if(!v){v={fullId:u,actual:s,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},s.tags.forEach(this.D,this),this.tree.set(v.fullId.toString(),v),this.G(s,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:v.expand,item:this.s.toITestItem(s)}}),this.I(s,v,a);return}if(v.actual===s){this.H(s,v,a);return}if(v.actual.uri?.toString()!==s.uri?.toString())return this.O(u.toString()),this.z(s,a);const o=this.s.getChildren(v.actual),w=v.actual,y=l(this.s.toITestItem(w),this.s.toITestItem(s));this.s.getApiFor(w).listener=void 0,v.actual=s,v.expand=0,y&&(y.hasOwnProperty("tags")&&(this.C(s.tags,w.tags,u.toString()),delete y.tags),this.w(v,{op:4,update:y})),this.I(s,v,a);for(const[d,b]of o)this.s.getChildren(s).get(b.id)||this.O(g.$bK.joinToString(u,b.id));this.y(v.actual.uri)}C(s,a,u){const i=new Set(a.map(v=>v.id));for(const v of s)i.delete(v.id)||this.D(v);this.pushDiff({op:1,item:{extId:u,item:{tags:s.map(v=>(0,L.$fK)(this.s.controllerId,v.id))}}}),i.forEach(this.F,this)}D(s){const a=this.j.get(s.id);a?a.refCount++:(this.j.set(s.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.$fK)(this.s.controllerId,s.id)}}))}F(s){const a=this.j.get(s);a&&!--a.refCount&&(this.j.delete(s),this.pushDiff({op:7,id:(0,L.$fK)(this.s.controllerId,s)}))}G(s,a){this.s.getApiFor(s).parent=a&&a.actual!==this.root?a.actual:void 0}H(s,a,u){this.G(s,u);const i=this.s.getApiFor(s);i.parent=u?.actual,i.listener=v=>this.w(a,v),this.J(a)}I(s,a,u){this.H(s,a,u);for(const[i,v]of this.s.getChildren(s))this.z(v,a)}J(s){let a;this.h?s.resolveBarrier?a=s.resolveBarrier.isOpen()?3:2:a=s.actual.canResolveChildren?1:0:a=0,a!==s.expand&&(s.expand=a,this.pushDiff({op:1,item:{extId:s.fullId.toString(),expand:a}}),a===1&&s.expandLevels!==void 0&&this.M(s))}L(s,a){if(a<0)return;const u=[];for(const[i,v]of this.s.getChildren(s.actual)){const o=this.expand(g.$bK.joinToString(s.fullId,v.id),a);(0,S.$Tg)(o)&&u.push(o)}if(u.length)return Promise.all(u).then(()=>{})}M(s){if(s.resolveBarrier)return s.resolveBarrier;if(!this.h){const v=new S.$7g;return v.open(),v}s.expand=2,this.N(s);const a=s.resolveBarrier=new S.$7g,u=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,v)};let i;try{i=this.h(s.actual===this.root?void 0:s.actual)}catch(v){u(v)}return(0,S.$Tg)(i)?i.catch(u).then(()=>{a.open(),this.J(s)}):(a.open(),this.J(s)),s.resolveBarrier}N(s){this.pushDiff({op:1,item:{extId:s.fullId.toString(),expand:s.expand}})}O(s){const a=this.tree.get(s);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:s});const u=[a];for(;u.length;){const i=u.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const v of i.actual.tags)this.F(v.id);this.tree.delete(i.fullId.toString());for(const[v,o]of this.s.getChildren(i.actual))u.push(this.tree.get(g.$bK.joinToString(i.fullId,o.id)))}}}flushDiff(){const s=this.collectDiff();s.length&&this.g.fire(s)}}e.$eN=p;class $ extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.$fN=$;class n extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$gN=n;class c extends Error{constructor(s,a,u){super(`TestItem with ID "${s}" is from controller "${a}" and cannot be added as a child of an item from controller "${u}".`)}}e.$hN=c;const r=(t,s,a)=>{let u=new Map;return{get size(){return u.size},forEach(i,v){for(const o of u.values())i.call(v,o,this)},[Symbol.iterator](){return u.entries()},replace(i){const v=new Map,o=new Set(u.keys()),w={op:5,ops:[]};for(const y of i){if(!(y instanceof a))throw new n(y.id);const d=s(y).controllerId;if(d!==t.controllerId)throw new c(y.id,d,t.controllerId);if(v.has(y.id))throw new $(y.id);v.set(y.id,y),o.delete(y.id),w.ops.push({op:0,item:y})}for(const y of o.keys())w.ops.push({op:3,id:y});t.listener?.(w),u=v},add(i){if(!(i instanceof a))throw new n(i.id);u.set(i.id,i),t.listener?.({op:0,item:i})},delete(i){u.delete(i)&&t.listener?.({op:3,id:i})},get(i){return u.get(i)},toJSON(){return Array.from(u.values())}}};e.$iN=r}),define(Re[103],Ae([1,0,76]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=void 0;const M=new WeakMap,I=(L,g)=>{const h={controllerId:g};return M.set(L,h),h};e.$jN=I;const R=L=>{const g=M.get(L);if(!g)throw new S.$gN(L?.id||"<unknown>");return g};e.$kN=R}),define(Re[77],Ae([1,0,12,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qwb=e.$pwb=e.$owb=e.$nwb=e.$mwb=void 0,e.$mwb="vscode-cdn.net",e.$nwb=`vscode-resource.${e.$mwb}`,e.$owb=`'self' https://*.${e.$mwb}`;function I(g,h){return g.scheme===S.Schemas.http||g.scheme===S.Schemas.https?g:(h&&h.authority&&h.isRemote&&g.scheme===S.Schemas.file&&(g=M.URI.from({scheme:S.Schemas.vscodeRemote,authority:h.authority,path:g.path})),M.URI.from({scheme:S.Schemas.https,authority:`${g.scheme}+${R(g.authority)}.${e.$nwb}`,path:g.path,fragment:g.fragment,query:g.query}))}e.$pwb=I;function R(g){return g.replace(/./g,h=>{const E=h.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?h:"-"+E.toString(16).padStart(4,"0")})}function L(g){return g.replace(/-([0-9a-f]{4})/g,(h,E)=>String.fromCharCode(parseInt(E,16)))}e.$qwb=L}),define(Re[212],Ae([1,0,5,6,77]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;class R{constructor(g,h,E){this.d=g,this.e=h,this.f=E,this.a=0,this.b=new M.$Sc,this.c=new Map,this.b.add(h.onDidChangeVisibleTextEditors(()=>{const A=h.getVisibleTextEditors();for(const D of this.c.values())A.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(g=>g.inset.dispose()),this.b.dispose()}createWebviewEditorInset(g,h,E,A,D){let l;for(const s of this.e.getVisibleTextEditors(!0))if(s.value===g){l=s;break}if(!l)throw new Error("not a visible editor");const p=this,$=this.a++,n=new S.$Wd,c=new S.$Wd,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(s){return(0,I.$pwb)(s,p.f)}get cspSource(){return I.$owb}set options(s){this.b=s,p.d.$setOptions($,s)}get options(){return this.b}set html(s){this.a=s,p.d.$setHtml($,s)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(s){return p.d.$postMessage($,s)}},t=new class{constructor(){this.editor=g,this.line=h,this.height=E,this.webview=r,this.onDidDispose=c.event}dispose(){p.c.has($)&&(p.c.delete($),p.d.$disposeEditorInset($),c.fire(),c.dispose(),n.dispose())}};return this.d.$createEditorInset($,l.id,l.value.document.uri,h+1,E,A||{},D.identifier,D.extensionLocation),this.c.set($,{editor:g,inset:t,onDidReceiveMessage:n}),t}$onDidDispose(g){const h=this.c.get(g);h&&h.inset.dispose()}$onDidReceiveMessage(g,h){this.c.get(g)?.onDidReceiveMessage.fire(h)}}e.$jgc=R}),define(Re[213],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=e.VariableKind=e.$aO=void 0,e.$aO=(0,S.$8h)("configurationResolverService");var M;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(M||(e.VariableKind=M={}));class I extends Error{constructor(L,g){super(g),this.variable=L}}e.$bO=I}),define(Re[214],Ae([1,0,19,74,16,26,20,95,176,213,13]),function(me,e,S,M,I,R,L,g,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pO=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,$,n,c){this.h=new Map,this.a=p,this.b=$,this.g=n,c&&(this.c=c.then(r=>this.i(r)))}i(p){if(L.$i){const $=Object.create(null);return Object.keys(p).forEach(n=>{$[n.toLowerCase()]=p[n]}),$}return p}resolveWithEnvironment(p,$,n){return this.l({env:this.i(p),userHome:void 0},$?$.uri:void 0,n)}async resolveAsync(p,$){const n={env:await this.c,userHome:await this.g};return this.l(n,p?p.uri:void 0,$)}async j(p,$,n,c){const r=R.$yn($);L.$i&&r.windows?Object.keys(r.windows).forEach(s=>r[s]=r.windows[s]):L.$j&&r.osx?Object.keys(r.osx).forEach(s=>r[s]=r.osx[s]):L.$k&&r.linux&&Object.keys(r.linux).forEach(s=>r[s]=r.linux[s]),delete r.windows,delete r.osx,delete r.linux;const t={env:await this.c,userHome:await this.g};return this.l(t,p?p.uri:void 0,r,n,c)}async resolveAnyAsync(p,$,n){return this.j(p,$,n)}async resolveAnyMap(p,$,n){const c=new Map;return{newConfig:await this.j(p,$,n,c),resolvedVariables:c}}resolveWithInteractionReplace(p,$,n,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,$,n,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,$){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,$)}async l(p,$,n,c,r){if(I.$Jf(n))return this.m(p,$,n,c,r);if(Array.isArray(n))return Promise.all(n.map(t=>this.l(p,$,t,c,r)));if(I.$Lf(n)){const t=Object.create(null),s=await Promise.all(Object.keys(n).map(async a=>[await this.m(p,$,a,c,r),await this.l(p,$,n[a],c,r)]));for(const[a,u]of s)t[a]=u;return t}return n}m(p,$,n,c,r){return(0,A.$5e)(n,D.VARIABLE_REGEXP,async(t,s)=>{if(s.includes(D.VARIABLE_LHS))return t;let a=await this.o(p,t,s,$,c);return r?.set(s,a),a!==t&&I.$Jf(a)&&a.match(D.VARIABLE_REGEXP)&&(a=await this.m(p,$,a,c,r)),a})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,$,n,c,r){let t;const s=n.split(":");s.length>1&&(n=s[0],t=s[1]);const a=v=>{const o=this.a.getFilePath();if(o)return(0,g.$Yv)(o);throw new E.$bO(v,(0,h.localize)(0,null,$))},u=v=>{const o=a(v);if(this.a.getWorkspaceFolderPathForFile){const w=this.a.getWorkspaceFolderPathForFile();if(w)return(0,g.$Yv)(w)}throw new E.$bO(v,(0,h.localize)(1,null,$,S.$nc(o)))},i=v=>{if(t){const o=this.a.getFolderUri(t);if(o)return o;throw new E.$bO(v,(0,h.localize)(2,null,$,t))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new E.$bO(v,(0,h.localize)(3,null,$)):new E.$bO(v,(0,h.localize)(4,null,$))};switch(n){case"env":if(t){if(p.env){const v=p.env[L.$i?t.toLowerCase():t];if(I.$Jf(v))return v}return""}throw new E.$bO(E.VariableKind.Env,(0,h.localize)(5,null,$));case"config":if(t){const v=this.a.getConfigurationValue(c,t);if(I.$Sf(v))throw new E.$bO(E.VariableKind.Config,(0,h.localize)(6,null,$,t));if(I.$Lf(v))throw new E.$bO(E.VariableKind.Config,(0,h.localize)(7,null,$,t));return v}throw new E.$bO(E.VariableKind.Config,(0,h.localize)(8,null,$));case"command":return this.p(E.VariableKind.Command,$,t,r,"command");case"input":return this.p(E.VariableKind.Input,$,t,r,"input");case"extensionInstallFolder":if(t){const v=await this.a.getExtension(t);if(!v)throw new E.$bO(E.VariableKind.ExtensionInstallFolder,(0,h.localize)(9,null,$,t));return this.n(v.extensionLocation)}throw new E.$bO(E.VariableKind.ExtensionInstallFolder,(0,h.localize)(10,null,$));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,g.$Yv)(this.n(i(E.VariableKind.WorkspaceFolder)));case"cwd":return c||t?(0,g.$Yv)(this.n(i(E.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,g.$Yv)(S.$nc(this.n(i(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new E.$bO(E.VariableKind.UserHome,(0,h.localize)(11,null,$))}case"lineNumber":{const v=this.a.getLineNumber();if(v)return v;throw new E.$bO(E.VariableKind.LineNumber,(0,h.localize)(12,null,$))}case"selectedText":{const v=this.a.getSelectedText();if(v)return v;throw new E.$bO(E.VariableKind.SelectedText,(0,h.localize)(13,null,$))}case"file":return a(E.VariableKind.File);case"fileWorkspaceFolder":return u(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.$nc(u(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return c||t?S.$lc(this.n(i(E.VariableKind.RelativeFile)),a(E.VariableKind.RelativeFile)):a(E.VariableKind.RelativeFile);case"relativeFileDirname":{const v=S.$mc(a(E.VariableKind.RelativeFileDirname));if(c||t){const o=S.$lc(this.n(i(E.VariableKind.RelativeFileDirname)),v);return o.length===0?".":o}return v}case"fileDirname":return S.$mc(a(E.VariableKind.FileDirname));case"fileExtname":return S.$oc(a(E.VariableKind.FileExtname));case"fileBasename":return S.$nc(a(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const v=S.$nc(a(E.VariableKind.FileBasenameNoExtension));return v.slice(0,v.length-S.$oc(v).length)}case"fileDirnameBasename":return S.$nc(S.$mc(a(E.VariableKind.FileDirnameBasename)));case"execPath":{const v=this.a.getExecPath();return v||$}case"execInstallFolder":{const v=this.a.getAppRoot();return v||$}case"pathSeparator":case"/":return S.sep;default:try{const v=t?`${n}:${t}`:n;return this.p(E.VariableKind.Unknown,$,v,r,void 0)}catch{return $}}}}p(p,$,n,c,r){if(n&&c){const t=r===void 0?c[n]:c[r+":"+n];if(typeof t=="string")return t;throw new E.$bO(p,(0,h.localize)(14,null,$))}return $}}e.$pO=D}),define(Re[104],Ae([1,0,4,102]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=e.$cD=e.OpenEditorContext=e.GroupsOrder=e.$bD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$aD=void 0,e.$aD=(0,S.$8h)("editorGroupsService");var I;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var R;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var L;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var g;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EXPAND=1]="EXPAND",$[$.EVEN=2]="EVEN"})(g||(e.GroupsArrangement=g={}));var h;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(h||(e.MergeGroupMode=h={}));function E($){const n=$;return(0,M.$WE)(n?.editor)&&(0,M.$WE)(n?.replacement)}e.$bD=E;var A;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var D;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function l($){const n=$;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}e.$cD=l;function p($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$dD=p}),define(Re[215],Ae([1,0,4,104]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=e.$hD=e.$gD=e.$fD=e.$eD=void 0,e.$eD=(0,S.$8h)("editorService"),e.$fD=-1,e.$gD=-2,e.$hD=-3;function I(R){const L=R;return typeof R=="number"||(0,M.$cD)(L)}e.$iD=I}),define(Re[216],Ae([1,0,4,183]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GK=void 0,e.$GK=(0,S.$9h)(M.$ci)}),define(Re[105],Ae([1,0,22,5,19,6,11]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$07b=e.$97b=e.$87b=e.$77b=e.$67b=void 0;class g{constructor(t,s){this.versionId=t,this.removedDueToLooping=s}}e.$67b=g;class h{static isHostExtension(t,s,a){if(s.getExtensionDescription(t))return!1;const u=a.getExtensionDescription(t);return u?!!((u.main||u.browser)&&u.api==="none"):!1}constructor(t,s){this.j=t,this.c=new M.$Wd,this.onDidChange=this.c.event,this.d=0,this.e=s,this.k()}k(){this.e.sort(n),this.f=new S.$pm,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const s=this.j.readActivationEvents(t);for(const a of s)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,s){this.e=c(this.e,s),this.e=this.e.concat(t);const a=h.l(this.e);return this.e=c(this.e,a.map(u=>u.identifier)),this.k(),this.d++,this.c.fire(void 0),new g(this.d,a)}static l(t){const s=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(o){this.d.has(o)||(this.d.add(o),this.e.push(o))}addArc(o,w){this.addNode(o),this.addNode(w),this.c.has(o)?this.c.get(o).push(w):this.c.set(o,[w])}getArcs(o){return this.c.has(o)?this.c.get(o):[]}hasOnlyGoodArcs(o,w){const y=s.getArcs(o);for(let d=0;d<y.length;d++)if(!w.has(y[d]))return!1;return!0}getNodes(){return this.e}},a=new S.$pm;for(const o of t)if(a.set(o.identifier,o),o.extensionDependencies)for(const w of o.extensionDependencies)s.addArc(S.$nm.toKey(o.identifier),S.$nm.toKey(w));const u=new Set;s.getNodes().filter(o=>s.getArcs(o).length===0).forEach(o=>u.add(o));const i=s.getNodes().filter(o=>!u.has(o));let v;do{v=!1;for(let o=0;o<i.length;o++){const w=i[o];s.hasOnlyGoodArcs(w,u)&&(i.splice(o,1),o--,u.add(w),v=!0)}}while(v);return i.map(o=>a.get(o))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const s=this.h.get(t);return s?s.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const s=this.f.get(t);return s||void 0}getExtensionDescriptionByUUID(t){for(const s of this.g)if(s.uuid===t)return s}getExtensionDescriptionByIdOrUUID(t,s){return this.getExtensionDescription(t)??(s?this.getExtensionDescriptionByUUID(s):void 0)}}e.$77b=h;class E{constructor(t,s){this.versionId=t,this.extensions=s}}e.$87b=E;class A{constructor(t){this.d=new p,this.c=new h(t,[])}async acquireLock(t){const s=await this.d.acquire(t);return new D(this,s)}deltaExtensions(t,s,a){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(s,a)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,s){return this.c.getExtensionDescriptionByIdOrUUID(t,s)}}e.$97b=A;class D extends R.$Tc{constructor(t,s){super(),this.f=t,this.c=!1,this.B(s)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$07b=D;class l{constructor(t){this.name=t;const s=(0,L.$1g)();this.promise=s.promise,this.c=s.resolve}resolve(t){this.c(t)}}class p{constructor(){this.c=[],this.d=!1}async acquire(t){const s=new l(t);return this.c.push(s),this.e(),s.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let s=!0;const a=setTimeout(()=>{s&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),u=()=>{s&&(clearTimeout(a),s=!1,this.d=!1,this.e())};t.resolve((0,R.$Rc)(u))}}var $;(function(r){r[r.Builtin=0]="Builtin",r[r.User=1]="User",r[r.Dev=2]="Dev"})($||($={}));function n(r,t){const s=r.isBuiltin?0:r.isUnderDevelopment?2:1,a=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(s!==a)return s-a;const u=I.$gc.basename(r.extensionLocation.path),i=I.$gc.basename(t.extensionLocation.path);return u<i?-1:u>i?1:0}function c(r,t){const s=new S.$om(t);return r.filter(a=>!s.has(a.identifier))}}),define(Re[78],Ae([1,0,23]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$wm=e.$vm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(M||(e.UIKind=M={}));var I;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var R;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function L(E){const A=S.$ke.alloc(1);switch(E){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$vm=L;function g(E,A){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$wm=g;var h;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(h||(e.NativeLogMarkers=h={}))}),define(Re[60],Ae([1,0,4,5,14,27,78,56,57,26,2,6,164]),function(me,e,S,M,I,R,L,g,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=e.$HN=e.$GN=e.$FN=void 0;let p=class extends D.$Tc{constructor(r,t){super(),this.s=r,this.t=t,this.a=this.B(new M.$Wd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Wd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=t.createLogger(this.m,{id:h.$So,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(t.onDidChangeLogLevel(s=>{(0,I.$rj)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,t,s){const a=this.getTelemetryDetails(),u=new $(t,s,r,this.n,this.j,this.getBuiltInCommonProperties(r),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),i=this.r.get(r.identifier.value)??[];return this.r.set(r.identifier.value,[...i,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(r,t,s){this.f=r,this.g=t,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(r){const t=Object.create(null);switch(t["common.extname"]=`${r.publisher}.${r.name}`,t["common.extversion"]=r.version,t["common.vscodemachineid"]=this.s.telemetryInfo.machineId,t["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,t["common.sqmid"]=this.s.telemetryInfo.sqmId,t["common.vscodeversion"]=this.s.version,t["common.isnewappinstall"]=n(this.s.telemetryInfo.firstSessionDate),t["common.product"]=this.s.environment.appHost,this.s.uiKind){case L.UIKind.Web:t["common.uikind"]="web";break;case L.UIKind.Desktop:t["common.uikind"]="desktop";break;default:t["common.uikind"]="unknown"}return t["common.remotename"]=(0,g.$dl)((0,h.$Yo)(this.s.remote.authority)),t}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const t=this.getTelemetryDetails();this.r.forEach((s,a)=>{const u=s.filter(i=>!i.isDisposed);u.length===0?this.r.delete(a):this.r.set(a,u)}),this.r.forEach(s=>{for(const a of s)a.updateTelemetryEnablements(t.isUsageEnabled,t.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(r,t){const a=this.r.get(r.value)?.filter(i=>!i.isDisposed);if(!a)return this.r.delete(r.value),!1;let u=!1;for(const i of a)i.ignoreUnhandledExtHostErrors||(i.logError(t),u=!0);return u}};e.$FN=p,e.$FN=p=Je([qe(0,R.$EN),qe(1,I.$qj)],p);class ${static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,t,s,a,u,i,v){this.g=s,this.h=a,this.i=u,this.j=i,this.a=new M.$Wd,this.ignoreUnhandledExtHostErrors=t?.ignoreUnhandledErrors??!1,this.b=t?.ignoreBuiltInCommonProperties??!1,this.c=t?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled}}updateTelemetryEnablements(r,t){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:t},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let t="properties"in r?r.properties??{}:r;return t=(0,h.$2o)(t,[]),this.c&&(t=(0,E.$Bn)(t,this.c)),this.b||(t=(0,E.$Bn)(t,this.j)),"properties"in r?r.properties=t:r=t,r}k(r,t){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,t=this.mixInCommonPropsAndCleanData(t||{}),this.i||this.f?.sendEventData(r,t),this.h.trace(r,t))}logUsage(r,t){this.d.isUsageEnabled&&this.k(r,t)}logError(r,t){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof r=="string")this.k(r,t);else{const s={name:r.name,message:r.message,stack:r.stack,cause:r.cause},a=(0,h.$2o)(s,[]),u=new Error(a.message,{cause:a.cause});u.stack=a.stack,u.name=a.name,t=this.mixInCommonPropsAndCleanData(t||{}),this.i||this.f.sendErrorData(u,t),this.h.trace("exception",t)}}get apiTelemetryLogger(){if(!this.e){const r=this,t={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(t)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$GN=$;function n(c){const r=Date.now()-new Date(c).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$HN=n,e.$IN=(0,S.$8h)("IExtHostTelemetry")}),define(Re[24],Ae([1,0,5,2,192,101,22,4]),function(me,e,S,M,I,R,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=e.$PF=e.$OF=e.ActivationKind=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.ExtensionHostStartup=e.$IF=e.$HF=e.$GF=e.$FF=void 0,e.$FF=Object.freeze({identifier:new L.$nm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$GF="extensions.webWorker",e.$HF=(0,g.$8h)("extensionService");class h{constructor(u){this.dependency=u}}e.$IF=h;var E;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(u,i,v){this.c=u,this.d=i.slice(0),this.e=v.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$qF.createActivationEventsMap(this.d)}}set(u,i,v){if(this.c>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this.c})`);const o=[],w=[],y=[],d=[],b=D(this.d),P=D(i),f=(G,q)=>G.extensionLocation.toString()===q.extensionLocation.toString()||G.isBuiltin===q.isBuiltin||G.isUserBuiltin===q.isUserBuiltin||G.isUnderDevelopment===q.isUnderDevelopment;for(const G of this.d){const q=P.get(G.identifier);if(!q){o.push(G.identifier),b.delete(G.identifier);continue}if(!f(G,q)){o.push(G.identifier),b.delete(G.identifier);continue}}for(const G of i){const q=b.get(G.identifier);if(!q){w.push(G);continue}if(!f(q,G)){o.push(q.identifier),b.delete(q.identifier);continue}}const m=new L.$om(this.e),k=new L.$om(v);for(const G of this.e)k.has(G)||y.push(G);for(const G of v)m.has(G)||d.push(G);const T=R.$qF.createActivationEventsMap(w),O={versionId:u,toRemove:o,toAdd:w,addActivationEvents:T,myToRemove:y,myToAdd:d};return this.delta(O),O}delta(u){if(this.c>=u.versionId)return null;const{toRemove:i,toAdd:v,myToRemove:o,myToAdd:w}=u,y=new L.$om(i),d=new L.$om(o);for(let b=0;b<this.d.length;b++)y.has(this.d[b].identifier)&&(this.d.splice(b,1),b--);for(let b=0;b<this.e.length;b++)d.has(this.e[b])&&(this.e.splice(b,1),b--);for(const b of v)this.d.push(b);for(const b of w)this.e.push(b);return this.f=null,u}containsExtension(u){for(const i of this.e)if(L.$nm.equals(i,u))return!0;return!1}containsActivationEvent(u){return this.f||(this.f=this.g()),this.f.has(u)}g(){const u=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const v=R.$qF.readActivationEvents(i);for(const o of v)u.add(o)}return u}}e.$JF=A;function D(a){const u=new L.$pm;for(const i of a)u.set(i.identifier,i);return u}function l(a,u){return a.enabledApiProposals?a.enabledApiProposals.includes(u):!1}e.$KF=l;function p(a,u){if(!l(a,u))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.$LF=p;class ${constructor(u,i,v,o){this.codeLoadingTime=u,this.activateCallTime=i,this.activateResolvedTime=v,this.activationReason=o}}e.$MF=$;class n{constructor(u,i){this.description=u,this.value=i}}e.$NF=n;var c;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(c||(e.ActivationKind=c={}));function r(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,I.$8o)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.$OF=r;function t(a,u){return{identifier:new L.$nm((0,I.$6o)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!u,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}e.$PF=t;class s{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activateById(u,i){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$QF=s}),define(Re[217],Ae([1,0,15,105,22,24,14,11]),function(me,e,S,M,I,R,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=e.$Jgc=e.$Igc=e.$Hgc=e.$Ggc=e.$Fgc=void 0;class h{static{this.NONE=new h(!1,-1,-1,-1)}constructor(r,t,s,a){this.startup=r,this.codeLoadingTime=t,this.activateCallTime=s,this.activateResolvedTime=a}}e.$Fgc=h;class E{constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,t){return r===-1||t===-1?-1:t-r}build(){return new h(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ggc=E;class A{constructor(r,t,s,a,u,i){this.activationFailed=r,this.activationFailedError=t,this.activationTimes=s,this.module=a,this.exports=u,this.subscriptions=i}}e.$Hgc=A;class D extends A{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Igc=D;class l extends A{constructor(){super(!1,null,h.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Jgc=l;class p extends A{constructor(r){super(!0,r,h.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let $=class{constructor(r,t,s,a){this.g=a,this.a=r,this.b=t,this.c=s,this.d=new I.$pm,this.f=Object.create(null)}dispose(){for(const[r,t]of this.d)t.dispose()}async waitForActivatingExtensions(){const r=[];for(const[t,s]of this.d)r.push(s.wait());await Promise.all(r)}isActivated(r){const t=this.d.get(r);return!!(t&&t.value)}getActivatedExtension(r){const t=this.d.get(r);if(!t||!t.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return t.value}async activateByEvent(r,t){if(this.f[r])return;const s=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(s.map(a=>({id:a.identifier,reason:{startup:t,extensionId:a.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,t){const s=this.a.getExtensionDescription(r);if(!s)throw new Error(`Extension '${r}' is not known`);return this.h([{id:s.identifier,reason:t}])}async h(r){const t=r.filter(s=>!this.isActivated(s.id)).map(s=>this.j(s));await Promise.all(t.map(s=>s.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const t=this.a.getExtensionDescription(r.id);if(!t){const u=new Error(`Cannot activate unknown extension '${r.id.value}'`),i=this.k(r,null,[],new p(u));return this.c.onExtensionActivationError(r.id,u,new R.$IF(r.id.value)),i}const s=[],a=typeof t.extensionDependencies>"u"?[]:t.extensionDependencies;for(const u of a){if(this.m(u))continue;const i=this.d.get(u);if(i){s.push(i);continue}if(this.l(u)){s.push(this.j({id:this.b.getExtensionDescription(u).identifier,reason:r.reason}));continue}const v=this.a.getExtensionDescription(u);if(v){if(!v.main&&!v.browser)continue;s.push(this.j({id:v.identifier,reason:r.reason}));continue}const o=t.displayName||t.identifier.value,w=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${u}'`),y=this.k(r,t.displayName,[],new p(w));return this.c.onExtensionActivationError(t.identifier,w,new R.$IF(u)),y}return this.k(r,t.displayName,s,null)}k(r,t,s,a){const u=new n(r.id,t,r.reason,s,a,this.c,this.g);return this.d.set(r.id,u),u}l(r){return M.$77b.isHostExtension(r,this.a,this.b)}m(r){const t=this.b.getExtensionDescription(r);return t?!t.main&&!t.browser:!1}};e.$Kgc=$,e.$Kgc=$=Je([qe(3,L.$pj)],$);let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,t,s,a,u,i,v){this.c=r,this.d=t,this.f=s,this.g=a,this.h=u,this.j=i,this.k=v,this.a=new g.$7g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const t=this.g[r];if(t.value&&!t.value.activationFailed){this.g.splice(r,1),r--;continue}if(t.value&&t.value.activationFailed){const s=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${t.friendlyName}' failed to activate`);s.detail=t.value.activationFailedError,this.h=new p(s),this.j.onExtensionActivationError(this.c,s,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const t=new Error;if(r&&r.name&&(t.name=r.name),r&&r.message?t.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:t.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(t.stack=r.stack),this.h=new p(t),this.b&&S.$4(r))return;this.j.onExtensionActivationError(this.c,t,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};n=Je([qe(6,L.$pj)],n)}),define(Re[218],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Re[219],Ae([1,0,178,15,32,97,73,30,22,218,188,101]),function(me,e,S,M,I,R,L,g,h,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=void 0;const l=g.$Kn.as(L.$Ln.JSONContribution);class p{constructor(u,i,v){this.a=u,this.b=i,this.c=v}d(u,i){this.a({type:u,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(u){this.d(I.default.Error,u)}warn(u){this.d(I.default.Warning,u)}info(u){this.d(I.default.Info,u)}}e.$zF=p;class ${static a(u){const i=new h.$om;for(let v=0,o=u.length;v<o;v++)i.add(u[v].description.identifier);return i}static compute(u,i){if(!u||!u.length)return new $(i,[]);if(!i||!i.length)return new $([],u);const v=this.a(u),o=this.a(i),w=i.filter(d=>!v.has(d.description.identifier)),y=u.filter(d=>!o.has(d.description.identifier));return new $(w,y)}constructor(u,i){this.added=u,this.removed=i}}e.$AF=$;class n{constructor(u,i){this.name=u,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(u){if(this.a!==null)throw new Error("Handler already set!");this.a=u,this.d()}acceptUsers(u){this.c=$.compute(this.b,u),this.b=u,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(u){(0,M.$1)(u)}}}e.$BF=n;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$CF={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:h.$mm},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"*",description:S.localize(43,null),body:"*"}]}},badges:{type:"array",description:S.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(45,null)},href:{type:"string",description:S.localize(46,null)},description:{type:"string",description:S.localize(47,null)}}}},markdown:{type:"string",description:S.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$po}},extensionPack:{description:S.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$po}},extensionKind:{description:S.localize(52,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(53,null)},{body:["workspace"],description:S.localize(54,null)},{body:["ui","workspace"],description:S.localize(55,null)},{body:["workspace","ui"],description:S.localize(56,null)},{body:[],description:S.localize(57,null)}]},capabilities:{description:S.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},description:{type:"string",markdownDescription:S.localize(64,null)}}},untrustedWorkspaces:{description:S.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(67,null),S.localize(68,null),S.localize(69,null)]},restrictedConfigurations:{description:S.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(71,null)}}}}},sponsor:{description:S.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(74,null),type:"string"},"vscode:uninstall":{description:S.localize(75,null),type:"string"}}},icon:{type:"string",description:S.localize(76,null)},l10n:{type:"string",description:S.localize(77,null)},pricing:{type:"string",markdownDescription:S.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class t{constructor(){this.a=new Map}registerExtensionPoint(u){if(this.a.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const i=new n(u.extensionPoint,u.defaultExtensionKind);return this.a.set(u.extensionPoint,i),u.activationEventsGenerator&&D.$qF.register(u.extensionPoint,u.activationEventsGenerator),e.$CF.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,l.registerSchema(r,e.$CF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$DF=t;const s={ExtensionsRegistry:"ExtensionsRegistry"};g.$Kn.add(s.ExtensionsRegistry,new t),e.$EF=g.$Kn.as(s.ExtensionsRegistry),l.registerSchema(r,e.$CF),l.registerSchema(A.$Ij,{properties:{extensionEnabledApiProposals:{description:S.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Re[220],Ae([1,0,174,16,26,219,35,5]),function(me,e,S,M,I,R,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=void 0;const h={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var E;(function(l){function p($,n,c){if(!$)return;const r=M.$Jf($.type)?$.type:void 0;if(!r||r.length===0){c.error(S.localize(3,null));return}const t=[];if(Array.isArray($.required))for(const s of $.required)M.$Jf(s)&&t.push(s);return{extensionId:n.value,taskType:r,required:t,properties:$.properties?I.$yn($.properties):{},when:$.when?L.$6i.deserialize($.when):void 0}}l.from=p})(E||(E={}));const A=R.$EF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,p)=>{for(const $ of l)$.type&&p.push(`onTaskType:${$.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:h}});class D{constructor(){this.d=new g.$Wd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,$)=>{A.setHandler((n,c)=>{this.c=void 0;try{for(const r of c.removed){const t=r.value;for(const s of t)this.a&&s.type&&this.a[s.type]&&delete this.a[s.type]}for(const r of c.added){const t=r.value;for(const s of t){const a=E.from(s,r.description.identifier,r.collector);a&&(this.a[a.taskType]=a)}}(c.removed.length>0||c.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const $ of this.all()){const n={type:"object",additionalProperties:!1};$.required.length>0&&(n.required=$.required.slice(0)),$.properties!==void 0?n.properties=I.$yn($.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[$.taskType]},p.push(n)}this.c={oneOf:p}}return this.c}}e.$CG=new D}),define(Re[221],Ae([1,0,175,16,25,26,35,220]),function(me,e,S,M,I,R,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$MG=e.JsonSchemaVersion=e.ExecutionEngine=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$GG=e.ShellQuoting=e.$FG=e.$EG=e.$DG=void 0,e.$DG="settings",e.$EG=new L.$mj("taskRunning",!1,S.localize(0,null)),e.$FG=S.localize2(2,"Tasks");var h;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(h||(e.ShellQuoting=h={})),e.$GG="$customized",function(C){function N(W){if(!W)return C.Strong;switch(W.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=N}(h||(e.ShellQuoting=h={}));var E;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var A;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(A||(e.RevealKind=A={})),function(C){function N(W){switch(W.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=N}(A||(e.RevealKind=A={}));var D;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(C){function N(W){switch(W.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=N}(D||(e.RevealProblemKind=D={}));var l;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(l||(e.PanelKind=l={})),function(C){function N(W){switch(W.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=N}(l||(e.PanelKind=l={}));var p;(function(C){C.defaults={echo:!0,reveal:A.Always,revealProblems:D.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var $;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})($||(e.RuntimeType=$={})),function(C){function N(se){switch(se.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=N;function W(se){switch(se){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=W}($||(e.RuntimeType=$={}));var n;(function(C){function N(W){return M.$Jf(W)?W:W.value}C.value=N})(n||(e.CommandString=n={}));var c;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function N(se){return se===C.Clean._id||se===C.Build._id||se===C.Rebuild._id||se===C.Test._id}C.is=N;function W(se){if(se!==void 0)return M.$Jf(se)?N(se)?{_id:se,isDefault:!1}:void 0:se}C.from=W})(c||(e.TaskGroup=c={}));var r;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var t;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function N(W){switch(W){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=N})(t||(e.TaskSourceKind=t={}));var s;(function(C){C.parallel="parallel",C.sequence="sequence"})(s||(e.DependsOrder=s={}));var a;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var u;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class i{constructor(N,W,se,ue,ye,ke){this._label="",this._id=N,W&&(this._label=W),se&&(this.type=se),this.runOptions=ue,this.configurationProperties=ye,this._source=ke}getDefinition(N){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,W=!1){if(N===void 0)return!1;if(M.$Jf(N))return N===this._label||N===this.configurationProperties.identifier||W&&N===this._id;const se=this.getDefinition(!0);return se!==void 0&&se._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$HG=i;class v extends i{constructor(N,W,se,ue,ye,ke,ae,pe){super(N,se,void 0,ae,pe,W),this.command={},this._source=W,this.hasDefinedMatchers=ke,ye&&(this.command=ye)}clone(){return new v(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case $.Shell:W="shell";break;case $.Process:W="process";break;case $.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(N){return N instanceof v}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===t.User?e.$DG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const N=this.d();if(!N)return;let W=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(W+=this._source.kind);const se={type:e.$GG,folder:N,id:W};return JSON.stringify(se)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Fg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new v(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$IG=v;class o extends i{constructor(N,W,se,ue,ye,ke,ae){super(N,se,ue,ke,ae,W),this._source=W,this.configures=ye}static is(N){return N instanceof o}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Fg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===t.User?e.$DG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const N=this.d();if(!N)return;let W=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(W+=this._source.kind);const se={type:e.$GG,folder:N,id:W};return JSON.stringify(se)}}e.$JG=o;class w extends i{constructor(N,W,se,ue,ye,ke,ae,pe,oe){super(N,se,ue,pe,oe,W),this.defines=ye,this.hasDefinedMatchers=ae,this.command=ke,this.icon=oe.icon,this.hide=oe.hide}clone(){return new w(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof w}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new w(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$KG=w;class y extends i{constructor(N,W,se,ue,ye,ke){super(N,se,ue,ye,ke,W),this._source=W}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new y(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$LG=y;var d;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(C){C._default=C.Terminal}(d||(e.ExecutionEngine=d={}));var b;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class P{constructor(N){this.c=new Map;for(let W=0;W<N.length;W++)this.c.set(N[W].uri.toString(),W)}compare(N,W){const se=N.getWorkspaceFolder(),ue=W.getWorkspaceFolder();if(se&&ue){let ye=this.c.get(se.uri.toString());ye=ye===void 0?0:ye+1;let ke=this.c.get(ue.uri.toString());return ke=ke===void 0?0:ke+1,ye===ke?N._label.localeCompare(W._label):ye-ke}else return!se&&ue?-1:se&&!ue?1:0}}e.$MG=P;var f;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(f||(e.TaskEventKind=f={}));var m;(function(C){C.SingleRun="singleRun",C.Background="background"})(m||(e.TaskRunType=m={}));var k;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var T;(function(C){function N(pe){return{taskId:pe._id,taskName:pe.configurationProperties.name,runType:pe.configurationProperties.isBackground?"background":"singleRun",group:pe.configurationProperties.group,__task:pe}}function W(pe,oe,$e){return{...N(pe),kind:"start",terminalId:oe,resolvedVariables:$e}}C.start=W;function se(pe,oe,$e){return{...N(pe),kind:"processStarted",terminalId:oe,processId:$e}}C.processStarted=se;function ue(pe,oe,$e){return{...N(pe),kind:"processEnded",terminalId:oe,exitCode:$e}}C.processEnded=ue;function ye(pe,oe,$e){return{...N(pe),kind:"terminated",exitReason:$e,terminalId:oe}}C.terminated=ye;function ke(pe,oe,$e){return{...N(oe),kind:pe,terminalId:$e}}C.general=ke;function ae(){return{kind:"changed"}}C.changed=ae})(T||(e.TaskEvent=T={}));var O;(function(C){function N(se){const ue=Object.keys(se).sort();let ye="";for(const ke of ue){let ae=se[ke];ae instanceof Object?ae=N(ae):typeof ae=="string"&&(ae=ae.replace(/,/g,",,")),ye+=ke+","+ae+","}return ye}function W(se){const ye={_key:N(se),type:se.taskType};return Object.assign(ye,se),ye}C.create=W})(O||(e.KeyedTaskIdentifier=O={}));var G;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var q;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var j;(function(C){function N(W,se){const ue=g.$CG.get(W.type);if(ue===void 0){const pe=R.$yn(W);return delete pe._key,O.create(pe)}const ye=Object.create(null);ye.type=ue.taskType;const ke=new Set;ue.required.forEach(pe=>ke.add(pe));const ae=ue.properties;for(const pe of Object.keys(ae)){const oe=W[pe];if(oe!=null)ye[pe]=oe;else if(ke.has(pe)){const $e=ae[pe];if($e.default!==void 0)ye[pe]=R.$yn($e.default);else switch($e.type){case"boolean":ye[pe]=!1;break;case"number":case"integer":ye[pe]=0;break;case"string":ye[pe]="";break;default:se.error(S.localize(1,null,JSON.stringify(W,void 0,0),pe));return}}}return O.create(ye)}C.createTaskIdentifier=N})(j||(e.TaskDefinition=j={}))}),define(Re[222],Ae([1,0,15]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_7b=e.$$7b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,g)=>{this.b=L,this.d=g,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,S.$1)(L))}then(L,g){return this.j().then(L,g)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$$7b=M;class I extends M{constructor(){super(),this.h=!0,this.i=new S.$5}}e.$_7b=I}),define(Re[49],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.$Tv=e.$Sv=void 0;class S{static{this.count=0}constructor(h){this._proxyIdentifierBrand=void 0,this.sid=h,this.nid=++S.count}}e.$Sv=S;const M=[];function I(g){const h=new S(g);return M[h.nid]=h,h}e.$Tv=I;function R(g){return M[g].sid}e.$Uv=R;class L{constructor(h){this.value=h}}e.$Vv=L}),define(Re[3],Ae([1,0,49]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$jL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$iL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var I;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput"})(I||(e.TabInputKind=I={}));var R;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var L;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var g;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(g||(e.WebviewMessageArrayBufferViewType=g={}));var h;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(h||(e.CellOutputKind=h={}));var E;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var A;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class D{static{this.a=0}static mixin(c){return c._id=D.a++,c}}e.$iL=D;var l;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var p;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var $;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$jL={MainThreadAuthentication:(0,S.$Tv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.$Tv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,S.$Tv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,S.$Tv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.$Tv)("MainThreadChatVariables"),MainThreadClipboard:(0,S.$Tv)("MainThreadClipboard"),MainThreadCommands:(0,S.$Tv)("MainThreadCommands"),MainThreadComments:(0,S.$Tv)("MainThreadComments"),MainThreadConfiguration:(0,S.$Tv)("MainThreadConfiguration"),MainThreadConsole:(0,S.$Tv)("MainThreadConsole"),MainThreadDebugService:(0,S.$Tv)("MainThreadDebugService"),MainThreadDecorations:(0,S.$Tv)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.$Tv)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.$Tv)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.$Tv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.$Tv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.$Tv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.$Tv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.$Tv)("MainThreadEditorTabs"),MainThreadErrors:(0,S.$Tv)("MainThreadErrors"),MainThreadTreeViews:(0,S.$Tv)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.$Tv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.$Tv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.$Tv)("MainThreadLanguages"),MainThreadLogger:(0,S.$Tv)("MainThreadLogger"),MainThreadMessageService:(0,S.$Tv)("MainThreadMessageService"),MainThreadOutputService:(0,S.$Tv)("MainThreadOutputService"),MainThreadProgress:(0,S.$Tv)("MainThreadProgress"),MainThreadQuickDiff:(0,S.$Tv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.$Tv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.$Tv)("MainThreadStatusBar"),MainThreadSecretState:(0,S.$Tv)("MainThreadSecretState"),MainThreadStorage:(0,S.$Tv)("MainThreadStorage"),MainThreadSpeech:(0,S.$Tv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.$Tv)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.$Tv)("MainThreadTerminalService"),MainThreadWebviews:(0,S.$Tv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.$Tv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.$Tv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.$Tv)("MainThreadCustomEditors"),MainThreadUrls:(0,S.$Tv)("MainThreadUrls"),MainThreadUriOpeners:(0,S.$Tv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.$Tv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.$Tv)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.$Tv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.$Tv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.$Tv)("MainThreadExtensionService"),MainThreadSCM:(0,S.$Tv)("MainThreadSCM"),MainThreadSearch:(0,S.$Tv)("MainThreadSearch"),MainThreadShare:(0,S.$Tv)("MainThreadShare"),MainThreadTask:(0,S.$Tv)("MainThreadTask"),MainThreadWindow:(0,S.$Tv)("MainThreadWindow"),MainThreadLabelService:(0,S.$Tv)("MainThreadLabelService"),MainThreadNotebook:(0,S.$Tv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.$Tv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.$Tv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.$Tv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.$Tv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.$Tv)("MainThreadInteractive"),MainThreadChat:(0,S.$Tv)("MainThreadChat"),MainThreadInlineChat:(0,S.$Tv)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.$Tv)("MainThreadTheming"),MainThreadTunnelService:(0,S.$Tv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.$Tv)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.$Tv)("MainThreadTimeline"),MainThreadTesting:(0,S.$Tv)("MainThreadTesting"),MainThreadLocalization:(0,S.$Tv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.$Tv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.$Tv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,S.$Tv)("MainThreadIssueReporter")},e.$kL={ExtHostCommands:(0,S.$Tv)("ExtHostCommands"),ExtHostConfiguration:(0,S.$Tv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.$Tv)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.$Tv)("ExtHostDebugService"),ExtHostDecorations:(0,S.$Tv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.$Tv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.$Tv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.$Tv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.$Tv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.$Tv)("ExtHostEditors"),ExtHostTreeViews:(0,S.$Tv)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.$Tv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.$Tv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.$Tv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.$Tv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.$Tv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.$Tv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.$Tv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.$Tv)("ExtHostStatusBar"),ExtHostShare:(0,S.$Tv)("ExtHostShare"),ExtHostExtensionService:(0,S.$Tv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.$Tv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.$Tv)("ExtHostTerminalService"),ExtHostSCM:(0,S.$Tv)("ExtHostSCM"),ExtHostSearch:(0,S.$Tv)("ExtHostSearch"),ExtHostTask:(0,S.$Tv)("ExtHostTask"),ExtHostWorkspace:(0,S.$Tv)("ExtHostWorkspace"),ExtHostWindow:(0,S.$Tv)("ExtHostWindow"),ExtHostWebviews:(0,S.$Tv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.$Tv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.$Tv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.$Tv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.$Tv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.$Tv)("ExtHostEditorTabs"),ExtHostProgress:(0,S.$Tv)("ExtHostProgress"),ExtHostComments:(0,S.$Tv)("ExtHostComments"),ExtHostSecretState:(0,S.$Tv)("ExtHostSecretState"),ExtHostStorage:(0,S.$Tv)("ExtHostStorage"),ExtHostUrls:(0,S.$Tv)("ExtHostUrls"),ExtHostUriOpeners:(0,S.$Tv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.$Tv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.$Tv)("ExtHostOutputService"),ExtHostLabelService:(0,S.$Tv)("ExtHostLabelService"),ExtHostNotebook:(0,S.$Tv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.$Tv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.$Tv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.$Tv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.$Tv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.$Tv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.$Tv)("ExtHostInteractive"),ExtHostInlineChat:(0,S.$Tv)("ExtHostInlineChatShape"),ExtHostChat:(0,S.$Tv)("ExtHostChat"),ExtHostChatAgents2:(0,S.$Tv)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.$Tv)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.$Tv)("ExtHostChatProvider"),ExtHostSpeech:(0,S.$Tv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,S.$Tv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.$Tv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.$Tv)("ExtHostTheming"),ExtHostTunnelService:(0,S.$Tv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.$Tv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.$Tv)("ExtHostAuthentication"),ExtHostTimeline:(0,S.$Tv)("ExtHostTimeline"),ExtHostTesting:(0,S.$Tv)("ExtHostTesting"),ExtHostTelemetry:(0,S.$Tv)("ExtHostTelemetry"),ExtHostLocalization:(0,S.$Tv)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.$Tv)("ExtHostIssueReporter")}}),define(Re[79],Ae([1,0,4,14,3,17]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=e.$0fc=e.$9fc=void 0,e.$9fc=(0,S.$8h)("IExtHostApiDeprecationService");let L=class{constructor(h,E){this.c=E,this.a=new Set,this.b=h.getProxy(I.$jL.MainThreadTelemetry)}report(h,E,A){const D=this.d(h,E);this.a.has(D)||(this.a.add(D),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${h}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:h}))}d(h,E){return`${h}-${E.identifier.value}`}};e.$0fc=L,e.$0fc=L=Je([qe(0,R.$oN),qe(1,M.$pj)],L),e.$$fc=Object.freeze(new class{report(g,h,E){}})}),define(Re[223],Ae([1,0,68,6,3]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;class R{static{this.a=0}constructor(h,E){this.extension=h,this.provider=E,this.handle=R.a++}}class L{static{this.a=0}constructor(h){this.b=new Map,this.c=new Map,this.d=h.getProxy(I.$jL.MainThreadChat)}registerChatProvider(h,E,A){const D=new R(h,A);return this.b.set(D.handle,D),this.d.$registerChatProvider(D.handle,E),(0,M.$Rc)(()=>{this.d.$unregisterChatProvider(D.handle),this.b.delete(D.handle)})}transferChatSession(h,E){const A=S.Iterable.find(this.c.keys(),D=>this.c.get(D)===h)??0;typeof A=="number"&&this.d.$transferChatSession(A,E)}sendInteractiveRequestToProvider(h,E){this.d.$sendRequestToProvider(h,E)}async $prepareChat(h,E){const A=this.b.get(h);if(!A)return;const D=await A.provider.prepareSession(E);if(!D)return;const l=L.a++;return this.c.set(l,D),{id:l,requesterUsername:D.requester?.name,requesterAvatarIconUri:D.requester?.icon,responderUsername:D.responder?.name,responderAvatarIconUri:D.responder?.icon,inputPlaceholder:D.inputPlaceholder}}$releaseSession(h){this.c.delete(h)}}e.$dgc=L}),define(Re[224],Ae([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;class M{constructor(R){const L=R.getProxy(S.$jL.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(g){return L.$writeText(g)}})}}e.$hgc=M}),define(Re[225],Ae([1,0,26,3,27,17]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;let L=class{constructor(A,D){this.a=A.getProxy(M.$jL.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,D){const l=this,p=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){l.e(A,D,p,arguments)}})}e(A,D,l,p){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:h(p,this.b)}),this.c&&this.f(A,l,p)}};e.$$hc=L,e.$$hc=L=Je([qe(0,R.$oN),qe(1,I.$EN)],L);const g=1e5;function h(E,A){const D=[];if(E.length)for(let l=0;l<E.length;l++){let p=E[l];if(typeof p>"u")p="undefined";else if(p instanceof Error){const $=p;$.stack?p=$.stack:p=$.toString()}D.push(p)}if(A){const l=new Error().stack;l&&D.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,S.$Dn)(D);return l.length>g?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Re[226],Ae([1,0,2,3,24]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class R{constructor(g){this.a=g.getProxy(M.$jL.MainThreadDialogs)}showOpenDialog(g,h){return h?.allowUIResources&&(0,I.$LF)(g,"showLocal"),this.a.$showOpenDialog(h).then(E=>E?E.map(A=>S.URI.revive(A)):void 0)}showSaveDialog(g){return this.a.$showSaveDialog(g).then(h=>h?S.URI.revive(h):void 0)}}e.$chc=R}),define(Re[227],Ae([1,0,6,3]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;class I{constructor(L){this.b=0,this.a=L.getProxy(M.$jL.MainThreadLabelService)}$registerResourceLabelFormatter(L){const g=this.b++;return this.a.$registerResourceLabelFormatter(g,L),(0,S.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(g)})}}e.$xhc=I}),define(Re[80],Ae([1,0,20,13,2,4,14,3,27,17]),function(me,e,S,M,I,R,L,g,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=e.$Wgc=void 0;let A=class{constructor(l,p,$){this.f=$,this.d=new Map,this.a=p.getProxy(g.$jL.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===S.$g}getMessage(l,p){const{message:$,args:n,comment:c}=p;if(this.c)return(0,M.$Me)($,n??{});let r=$;c&&c.length>0&&(r+=`/${Array.isArray(c)?c.join(""):c}`);const t=this.d.get(l)?.contents[r];return t||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,M.$Me)(t??$,n??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let p;const $=await this.g(l);if(!$){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents($),c=JSON.parse(n);p=l.isBuiltin?c.contents?.bundle:c}catch(n){this.f.error(`Failed to load translations for ${l.identifier.value} from ${$}: ${n.message}`);return}p&&this.d.set(l.identifier.value,{contents:p,uri:$})}async g(l){if(l.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return I.URI.revive(p)}return l.l10n?I.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Wgc=A,e.$Wgc=A=Je([qe(0,h.$EN),qe(1,E.$oN),qe(2,L.$pj)],A),e.$Xgc=(0,R.$8h)("IExtHostLocalizationService")}),define(Re[228],Ae([1,0,14,3,27,17,2,51]),function(me,e,S,M,I,R,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;let h=class extends S.$Aj{constructor(D,l){super(l.logLevel,l.logsLocation,l.loggers.map(p=>(0,g.$Eh)(p))),this.r=D.getProxy(M.$jL.MainThreadLogger)}$setLogLevel(D,l){l?this.setLogLevel(L.URI.revive(l),D):this.setLogLevel(D)}setVisibility(D,l){super.setVisibility(D,l),this.r.$setVisibility(D,l)}s(D,l,p){return new E(this.r,D,l,p)}};e.$0hc=h,e.$0hc=h=Je([qe(0,R.$oN),qe(1,I.$EN)],h);class E extends S.$vj{constructor(D,l,p,$){super($?.logLevel==="always"),this.r=D,this.s=l,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(l,$).then(()=>{this.u(this.n),this.m=!0})}g(D,l){const p=[[D,l]];this.m?this.u(p):this.n.push(...p)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Re[81],Ae([1,0,3,4,6,17,23]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=e.$Ygc=void 0,e.$Ygc=(0,M.$8h)("IExtHostManagedSockets");let g=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(S.$jL.MainThreadManagedSockets)}setFactory(D,l){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new h(D,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const l=++this.b,p=await this.c.makeConnection(),$=new I.$Sc;return this.d.set(l,new E(l,p,$)),$.add((0,I.$Rc)(()=>this.d.delete(l))),$.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),$.dispose()})),$.add(p.onDidClose(n=>{this.a.$onDidManagedSocketClose(l,n?.stack??n?.message),$.dispose()})),$.add(p.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(l,L.$ke.wrap(n)))),l}$remoteSocketWrite(D,l){this.d.get(D)?.actual.send(l.buffer)}$remoteSocketEnd(D){const l=this.d.get(D);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$Zgc=g,e.$Zgc=g=Je([qe(0,R.$oN)],g);class h{constructor(D,l){this.socketFactoryId=D,this.makeConnection=l}}class E extends I.$Tc{constructor(D,l,p){super(),this.socketId=D,this.actual=l,this.B(p)}}}),define(Re[229],Ae([1,0,3,14,24]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;function R(g){return g&&g.title}let L=class{constructor(h,E){this.b=E,this.a=h.getProxy(S.$jL.MainThreadMessageService)}showMessage(h,E,A,D,l){const p={source:{identifier:h.identifier,label:h.displayName||h.name}};let $;typeof D=="string"||R(D)?$=[D,...l]:(p.modal=D?.modal,p.useCustom=D?.useCustom,p.detail=D?.detail,$=l),p.useCustom&&(0,I.$LF)(h,"resolvers");const n=[];let c=!1;for(let r=0;r<$.length;r++){const t=$[r];if(typeof t=="string")n.push({title:t,handle:r,isCloseAffordance:!1});else if(typeof t=="object"){const{title:s,isCloseAffordance:a}=t;n.push({title:s,isCloseAffordance:!!a,handle:r}),a&&(c?this.b.warn(`[${h.identifier}] Only one message item can have 'isCloseAffordance':`,t):c=!0)}else this.b.warn(`[${h.identifier}] Invalid message item:`,t)}return this.a.$showMessage(E,A,p,n).then(r=>{if(typeof r=="number")return $[r]})}};e.$zhc=L,e.$zhc=L=Je([qe(1,M.$pj)],L)}),define(Re[230],Ae([1,0,6,16,2,24,3]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0;class g{constructor(E){this.b=new Map,this.a=E.getProxy(L.$jL.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,A,D){if((0,R.$LF)(E,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,D),this.a.$registerProfileContentHandler(A,D.name,D.description,E.identifier.value),(0,S.$Rc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(E,A,D,l){const p=this.b.get(E);if(!p)throw new Error(`Unknown handler with id: ${E}`);return p.saveProfile(A,D,l)}async $readProfile(E,A,D){const l=this.b.get(E);if(!l)throw new Error(`Unknown handler with id: ${E}`);return l.readProfile((0,M.$Jf)(A)?A:I.URI.revive(A),D)}}e.$Ihc=g}),define(Re[82],Ae([1,0,3,5,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=e.$Tgc=void 0;class R{constructor(g){this.b=new M.$Wd,this.onDidChangePassword=this.b.event,this.a=g.getProxy(S.$jL.MainThreadSecretState)}async $onDidChangePassword(g){this.b.fire(g)}get(g,h){return this.a.$getPassword(g,h)}store(g,h,E){return this.a.$setPassword(g,h,E)}delete(g,h){return this.a.$deletePassword(g,h)}}e.$Tgc=R,e.$Ugc=(0,I.$8h)("IExtHostSecretState")}),define(Re[231],Ae([1,0,21,6,3]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=void 0;class R{static{this.a=1}constructor(g){this.c=new Map,this.d=new Map,this.b=g.getProxy(I.$jL.MainThreadSpeech)}async $createSpeechToTextSession(g,h){const E=this.c.get(g);if(!E)return;const A=new M.$Sc,D=new S.$7d;this.d.set(h,D);const l=A.add(E.provideSpeechToTextSession(D.token));A.add(l.onDidChange(p=>{D.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(h,p)})),A.add(D.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(g){this.d.get(g)?.dispose(!0),this.d.delete(g)}async $createKeywordRecognitionSession(g,h){const E=this.c.get(g);if(!E)return;const A=new M.$Sc,D=new S.$7d;this.d.set(h,D);const l=A.add(E.provideKeywordRecognitionSession(D.token));A.add(l.onDidChange(p=>{D.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(h,p)})),A.add(D.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(g){this.d.get(g)?.dispose(!0),this.d.delete(g)}registerProvider(g,h,E){const A=R.a++;return this.c.set(A,E),this.b.$registerProvider(A,h,{extension:g,displayName:g.value}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Phc=R}),define(Re[83],Ae([1,0,3,5,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=e.$Lgc=void 0;class R{constructor(g,h){this.c=h,this.b=new M.$Wd,this.onDidChangeStorage=this.b.event,this.a=g.getProxy(S.$jL.MainThreadStorage)}registerExtensionStorageKeysToSync(g,h){this.a.$registerExtensionStorageKeysToSync(g,h)}async initializeExtensionStorage(g,h,E){const A=await this.a.$initializeExtensionStorage(g,h);let D;return A&&(D=this.d(g,h,A)),D||E}setValue(g,h,E){return this.a.$setValue(g,h,E)}$acceptValue(g,h,E){const A=this.d(g,h,E);A&&this.b.fire({shared:g,key:h,value:A})}d(g,h,E){try{return JSON.parse(E)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${g}): ${A}`)}}}e.$Lgc=R,e.$Mgc=(0,I.$8h)("IExtHostStorage")}),define(Re[232],Ae([1,0,6,12,2,3]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;class L{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(h){this.c=new Map,this.b=h.getProxy(R.$jL.MainThreadUriOpeners)}registerExternalUriOpener(h,E,A,D){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const l=D.schemes.find(p=>!L.a.has(p));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(E,A),this.b.$registerUriOpener(E,D.schemes,h,D.label),(0,S.$Rc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(h,E,A){const D=this.c.get(h);if(!D)throw new Error(`Unknown opener with id: ${h}`);const l=I.URI.revive(E);return D.canOpenExternalUri(l,A)}async $openUri(h,E,A){const D=this.c.get(h);if(!D)throw new Error(`Unknown opener id: '${h}'`);return D.openExternalUri(I.URI.revive(E.resolvedUri),{sourceUri:I.URI.revive(E.sourceUri)},A)}}e.$4hc=L}),define(Re[233],Ae([1,0,3,2,6,15,22]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0;class g{static{this.a=0}constructor(E){this.c=new L.$om,this.d=new Map,this.b=E.getProxy(S.$jL.MainThreadUrls)}registerUriHandler(E,A){const D=E.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const l=g.a++;return this.c.add(D),this.d.set(l,A),this.b.$registerUriHandler(l,D,E.displayName||E.name),(0,I.$Rc)(()=>{this.c.delete(D),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(E,A){const D=this.d.get(E);if(!D)return Promise.resolve(void 0);try{D.handleUri(M.URI.revive(A))}catch(l){(0,R.$1)(l)}return Promise.resolve(void 0)}async createAppUri(E){return M.URI.revive(await this.b.$createAppUri(E))}}e.$5hc=g}),define(Re[61],Ae([1,0,5,6,12,26,2,181,203,77,3]),function(me,e,S,M,I,R,L,g,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=e.$zgc=e.$ygc=e.$xgc=e.$wgc=void 0;class D{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,u,i,v,o,w,y){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new S.$Wd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new S.$Wd,this._onDidDispose=this.#h.event,this.#e=a,this.#t=u,this.#o=i,this.#n=v,this.#s=o,this.#r=w,this.#l=l(w),this.#d=p(w),this.#i=y}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,E.$pwb)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===I.Schemas.https||a.scheme===I.Schemas.http){let u=a.toString();return u.endsWith("/")||(u+="/"),u+" "+E.$owb}return E.$owb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),R.$Cn(this.#o,a)||this.#t.$setOptions(this.#e,c(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const u=(0,h.$Glb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,u.message,...u.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const u=this.#r.extensionLocation?.scheme===I.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,o,w,y,d,b)=>{const P=L.URI.from({scheme:y||"file",path:decodeURIComponent(d)}),f=(0,E.$pwb)(P,{isRemote:u,authority:i}).toString();return`${o}${f}${b}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,o,w,y,d,b)=>{const P=L.URI.from({scheme:y||"file",path:decodeURIComponent(d)}),f=(0,E.$pwb)(P,{isRemote:u,authority:i}).toString();return`${o}${f}${b}`})}}e.$wgc=D;function l(s){try{const a=(0,g.$ep)((0,g.$dp)(s.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}e.$xgc=l;function p(s){try{const a=(0,g.$ep)((0,g.$dp)(s.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class $ extends M.$Tc{constructor(a,u,i,v,o){super(),this.c=u,this.f=i,this.g=v,this.h=o,this.b=new Map,this.a=a.getProxy(A.$jL.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,u,i){const v=this.j(a);if(v){const{message:o}=(0,h.$Hlb)(u,i.value);v._onMessageEmitter.fire(o)}}$onMissingCsp(a,u){this.g.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,u,i){const v=new D(a,this.a,r(u),this.c,this.f,i,this.h);this.b.set(a,v);const o=v._onDidDispose(()=>{o.dispose(),this.deleteWebview(a)});return v}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$ygc=$;function n(s){return{id:s.identifier,location:s.extensionLocation}}e.$zgc=n;function c(s,a,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||t(s,a)}}e.$Agc=c;function r(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(a=>L.URI.from(a))}}function t(s,a){return[...(a?.getWorkspaceFolders()||[]).map(u=>u.uri),s.extensionLocation]}}),define(Re[106],Ae([1,0,5,3,2,12,13,4,17,24]),function(me,e,S,M,I,R,L,g,h,E){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=e.$7hc=void 0;let D=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(p){const $=this.d;return{get focused(){return $.focused},get active(){return(0,E.$LF)(p,"windowActivity"),$.active}}}constructor(p){this.c=new S.$Wd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=p.getProxy(M.$jL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:$,isActive:n})=>{this.onDidChangeWindowProperty("focused",$),this.onDidChangeWindowProperty("active",n)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,$){$!==this.d[p]&&(this.d={...this.d,[p]:$},this.c.fire(this.d))}openUri(p,$){let n;if(typeof p=="string"){n=p;try{p=I.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,L.$Ke)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,n,$)}async asExternalUri(p,$){if((0,L.$Ke)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const n=await this.b.$asExternalUri(p,$);return I.URI.from(n)}};e.$7hc=D,e.$7hc=D=A=Je([qe(0,h.$oN)],D),e.$8hc=(0,g.$8h)("IExtHostWindow")}),define(Re[234],Ae([1,0,225,27,17]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hkc=void 0;let R=class extends S.$$hc{constructor(g,h){super(g,h)}f(g,h,E){h.apply(console,E)}};e.$hkc=R,e.$hkc=R=Je([qe(0,I.$oN),qe(1,M.$EN)],R)}),define(Re[235],Ae([1,0,11,23,21,15,5,6,139,222,49]),function(me,e,S,M,I,R,L,g,h,E,A){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$c8b=e.ResponsiveState=e.RequestInitiator=e.$b8b=e.$a8b=void 0;function l(k,T){try{return JSON.stringify(k,T)}catch{return"null"}}const p="$$ref$$",$={[p]:-1};class n{constructor(T,O){this.jsonString=T,this.referencedBuffers=O}}function c(k,T=null,O=!1){const G=[];return{jsonString:(O?l:JSON.stringify)(k,(j,C)=>{if(typeof C>"u")return $;if(typeof C=="object"){if(C instanceof M.$ke){const N=G.push(C)-1;return{[p]:N}}if(T)return T(j,C)}return C}),referencedBuffers:G}}e.$a8b=c;function r(k,T,O){return JSON.parse(k,(G,q)=>{if(q){const j=q[p];if(typeof j=="number")return T[j];if(O&&q.$mid===1)return O.transformIncoming(q)}return q})}e.$b8b=r;function t(k,T){return JSON.stringify(k,T)}function s(k){return k?(T,O)=>O&&O.$mid===1?k.transformOutgoing(O):O:null}var a;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var u;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const i=()=>{},v=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class w extends g.$Tc{static{D=v}static{this.a=3*1e3}constructor(T,O=null,G=null){super(),this[D]=!0,this.b=this.B(new L.$Wd),this.onDidChangeResponsiveState=this.b.event,this.c=T,this.f=O,this.g=G,this.h=s(this.g),this.j=!1,this.m=[],this.s=[];for(let q=0,j=A.$Sv.count;q<j;q++)this.m[q]=null,this.s[q]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new S.$hh(()=>this.H(),1e3)),this.c.onMessage(q=>this.L(q))}dispose(){this.j=!0,Object.keys(this.w).forEach(T=>{const O=this.w[T];delete this.w[T],O.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(T){this.z===0&&(this.C=Date.now()+w.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(T){this.C=Date.now()+w.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(T){this.y!==T&&(this.y=T,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(T){return this.g?(0,h.$0m)(T,this.g):T}getProxy(T){const{nid:O,sid:G}=T;return this.s[O]||(this.s[O]=this.J(O,G)),this.s[O]}J(T,O){const G={get:(q,j)=>(typeof j=="string"&&!q[j]&&j.charCodeAt(0)===36&&(q[j]=(...C)=>this.U(T,j,C)),j===o?O:q[j])};return new Proxy(Object.create(null),G)}set(T,O){return this.m[T.nid]=O,O}assertRegistered(T){for(let O=0,G=T.length;O<G;O++){const q=T[O];if(!this.m[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}L(T){if(this.j)return;const O=T.byteLength,G=d.read(T,0),q=G.readUInt8(),j=G.readUInt32();switch(q){case 1:case 2:{let{rpcId:C,method:N,args:W}=P.deserializeRequestJSONArgs(G);this.g&&(W=(0,h.$0m)(W,this.g)),this.M(O,j,C,N,W,q===2);break}case 3:case 4:{let{rpcId:C,method:N,args:W}=P.deserializeRequestMixedArgs(G);this.g&&(W=(0,h.$0m)(W,this.g)),this.M(O,j,C,N,W,q===4);break}case 5:{this.f?.logIncoming(O,j,0,"ack"),this.G(j);break}case 6:{this.N(O,j);break}case 7:{this.O(O,j,void 0);break}case 9:{let C=P.deserializeReplyOKJSON(G);this.g&&(C=(0,h.$0m)(C,this.g)),this.O(O,j,C);break}case 10:{const C=P.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(O,j,C);break}case 8:{const C=P.deserializeReplyOKVSBuffer(G);this.O(O,j,C);break}case 11:{let C=P.deserializeReplyErrError(G);this.g&&(C=(0,h.$0m)(C,this.g)),this.P(O,j,C);break}case 12:{this.P(O,j,void 0);break}default:console.error("received unexpected message"),console.error(T)}}M(T,O,G,q,j,C){this.f?.logIncoming(T,O,1,`receiveRequest ${(0,A.$Uv)(G)}.${q}(`,j);const N=String(O);let W,se;if(C){const ye=new I.$7d;j.push(ye.token),W=this.Q(G,q,j),se=()=>ye.cancel()}else W=this.Q(G,q,j),se=i;this.u[N]=se;const ue=P.serializeAcknowledged(O);this.f?.logOutgoing(ue.byteLength,O,1,"ack"),this.c.send(ue),W.then(ye=>{delete this.u[N];const ke=P.serializeReplyOK(O,ye,this.h);this.f?.logOutgoing(ke.byteLength,O,1,"reply:",ye),this.c.send(ke)},ye=>{delete this.u[N];const ke=P.serializeReplyErr(O,ye);this.f?.logOutgoing(ke.byteLength,O,1,"replyErr:",ye),this.c.send(ke)})}N(T,O){this.f?.logIncoming(T,O,1,"receiveCancel");const G=String(O);this.u[G]?.()}O(T,O,G){this.f?.logIncoming(T,O,0,"receiveReply:",G);const q=String(O);if(!this.w.hasOwnProperty(q))return;const j=this.w[q];delete this.w[q],j.resolveOk(G)}P(T,O,G){this.f?.logIncoming(T,O,0,"receiveReplyErr:",G);const q=String(O);if(!this.w.hasOwnProperty(q))return;const j=this.w[q];delete this.w[q];let C;G&&(G.$isError?(C=new Error,C.name=G.name,C.message=G.message,C.stack=G.stack):C=G),j.resolveErr(C)}Q(T,O,G){try{return Promise.resolve(this.S(T,O,G))}catch(q){return Promise.reject(q)}}S(T,O,G){const q=this.m[T];if(!q)throw new Error("Unknown actor "+(0,A.$Uv)(T));const j=q[O];if(typeof j!="function")throw new Error("Unknown method "+O+" on actor "+(0,A.$Uv)(T));return j.apply(q,G)}U(T,O,G){if(this.j)return new E.$_7b;let q=null;if(G.length>0&&I.CancellationToken.isCancellationToken(G[G.length-1])&&(q=G.pop()),q&&q.isCancellationRequested)return Promise.reject(R.$6());const j=P.serializeRequestArguments(G,this.h),C=++this.t,N=String(C),W=new E.$$7b,se=new g.$Sc;q&&se.add(q.onCancellationRequested(()=>{const ye=P.serializeCancel(C);this.f?.logOutgoing(ye.byteLength,C,0,"cancel"),this.c.send(P.serializeCancel(C))})),this.w[N]=new y(W,se),this.F(C);const ue=P.serializeRequest(C,T,O,j,!!q);return this.f?.logOutgoing(ue.byteLength,C,0,`request: ${(0,A.$Uv)(T)}.${O}(`,G),this.c.send(ue),W}}e.$c8b=w;class y{constructor(T,O){this.a=T,this.b=O}resolveOk(T){this.a.resolveOk(T),this.b.dispose()}resolveErr(T){this.a.resolveErr(T),this.b.dispose()}}class d{static alloc(T,O,G){const q=new d(M.$ke.alloc(G+1+4),0);return q.writeUInt8(T),q.writeUInt32(O),q}static read(T,O){return new d(T,O)}get buffer(){return this.a}constructor(T,O){this.a=T,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(T){this.a.writeUInt8(T,this.b),this.b+=1}readUInt8(){const T=this.a.readUInt8(this.b);return this.b+=1,T}writeUInt32(T){this.a.writeUInt32BE(T,this.b),this.b+=4}readUInt32(){const T=this.a.readUInt32BE(this.b);return this.b+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this.a.writeUInt8(T.byteLength,this.b),this.b+=1,this.a.set(T,this.b),this.b+=T.byteLength}readShortString(){const T=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+T).toString();return this.b+=T,G}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readLongString(){const T=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+T).toString();return this.b+=T,G}writeBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readVSBuffer(){const T=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+T);return this.b+=T,O}static sizeMixedArray(T){let O=0;O+=1;for(let G=0,q=T.length;G<q;G++){const j=T[G];switch(O+=1,j.type){case 1:O+=this.sizeLongString(j.value);break;case 2:O+=this.sizeVSBuffer(j.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(j.value);for(let C=0;C<j.buffers.length;++C)O+=this.sizeVSBuffer(j.buffers[C]);break;case 4:break}}return O}writeMixedArray(T){this.a.writeUInt8(T.length,this.b),this.b+=1;for(let O=0,G=T.length;O<G;O++){const q=T[O];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let j=0;j<q.buffers.length;++j)this.writeBuffer(q.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this.a.readUInt8(this.b);this.b+=1;const O=new Array(T);for(let G=0;G<T;G++)switch(this.readUInt8()){case 1:O[G]=this.readLongString();break;case 2:O[G]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),C=this.readLongString(),N=[];for(let W=0;W<j;++W)N.push(this.readVSBuffer());O[G]=new A.$Vv(r(C,N,null));break}case 4:O[G]=void 0;break}return O}}var b;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(b||(b={}));class P{static a(T){for(let O=0,G=T.length;O<G;O++)if(T[O]instanceof M.$ke||T[O]instanceof A.$Vv||typeof T[O]>"u")return!0;return!1}static serializeRequestArguments(T,O){if(this.a(T)){const G=[];for(let q=0,j=T.length;q<j;q++){const C=T[q];if(C instanceof M.$ke)G[q]={type:2,value:C};else if(typeof C>"u")G[q]={type:4};else if(C instanceof A.$Vv){const{jsonString:N,referencedBuffers:W}=c(C.value,O);G[q]={type:3,value:M.$ke.fromString(N),buffers:W}}else G[q]={type:1,value:M.$ke.fromString(t(C,O))}}return{type:1,args:G}}return{type:0,args:t(T,O)}}static serializeRequest(T,O,G,q,j){switch(q.type){case 0:return this.b(T,O,G,q.args,j);case 1:return this.c(T,O,G,q.args,j)}}static b(T,O,G,q,j){const C=M.$ke.fromString(G),N=M.$ke.fromString(q);let W=0;W+=d.sizeUInt8(),W+=d.sizeShortString(C),W+=d.sizeLongString(N);const se=d.alloc(j?2:1,T,W);return se.writeUInt8(O),se.writeShortString(C),se.writeLongString(N),se.buffer}static deserializeRequestJSONArgs(T){const O=T.readUInt8(),G=T.readShortString(),q=T.readLongString();return{rpcId:O,method:G,args:JSON.parse(q)}}static c(T,O,G,q,j){const C=M.$ke.fromString(G);let N=0;N+=d.sizeUInt8(),N+=d.sizeShortString(C),N+=d.sizeMixedArray(q);const W=d.alloc(j?4:3,T,N);return W.writeUInt8(O),W.writeShortString(C),W.writeMixedArray(q),W.buffer}static deserializeRequestMixedArgs(T){const O=T.readUInt8(),G=T.readShortString(),q=T.readMixedArray(),j=new Array(q.length);for(let C=0,N=q.length;C<N;C++){const W=q[C];typeof W=="string"?j[C]=JSON.parse(W):j[C]=W}return{rpcId:O,method:G,args:j}}static serializeAcknowledged(T){return d.alloc(5,T,0).buffer}static serializeCancel(T){return d.alloc(6,T,0).buffer}static serializeReplyOK(T,O,G){if(typeof O>"u")return this.d(T);if(O instanceof M.$ke)return this.e(T,O);if(O instanceof A.$Vv){const{jsonString:q,referencedBuffers:j}=c(O.value,G,!0);return this.g(T,q,j)}else return this.f(T,l(O,G))}static d(T){return d.alloc(7,T,0).buffer}static e(T,O){let G=0;G+=d.sizeVSBuffer(O);const q=d.alloc(8,T,G);return q.writeVSBuffer(O),q.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static f(T,O){const G=M.$ke.fromString(O);let q=0;q+=d.sizeLongString(G);const j=d.alloc(9,T,q);return j.writeLongString(G),j.buffer}static g(T,O,G){const q=M.$ke.fromString(O);let j=0;j+=d.sizeUInt32,j+=d.sizeLongString(q);for(const N of G)j+=d.sizeVSBuffer(N);const C=d.alloc(10,T,j);C.writeUInt32(G.length),C.writeLongString(q);for(const N of G)C.writeBuffer(N);return C.buffer}static deserializeReplyOKJSON(T){const O=T.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(T,O){const G=T.readUInt32(),q=T.readLongString(),j=[];for(let C=0;C<G;++C)j.push(T.readVSBuffer());return new A.$Vv(r(q,j,O))}static serializeReplyErr(T,O){const G=O?l(R.$3(O),null):void 0;if(typeof G!="string")return this.h(T);const q=M.$ke.fromString(G);let j=0;j+=d.sizeLongString(q);const C=d.alloc(11,T,j);return C.writeLongString(q),C.buffer}static deserializeReplyErrError(T){const O=T.readLongString();return JSON.parse(O)}static h(T){return d.alloc(12,T,0).buffer}}var f;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var m;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(m||(m={}))}),define(Re[236],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=void 0;const S=function(R){const L=g=>{globalThis.removeEventListener("message",L);const h=g.data;Object.defineProperties(globalThis,{postMessage:{value(E,A){h.postMessage(E,A)}},onmessage:{get(){return h.onmessage},set(E){h.onmessage=E}}}),h.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),h.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(R)};globalThis.addEventListener("message",L)}.toString();class M extends EventTarget{constructor(R,L,g){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const h=`((${S})('${L}'))`,E=new Blob([h],{type:"application/javascript"}),A=URL.createObjectURL(E),D=new MessageChannel,l=A,p={type:"_newWorker",id:l,port:D.port2,url:A,options:g};R(p,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{R({type:"_terminateWorker",id:l}),URL.revokeObjectURL(A),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set($){D.port1.onmessage=$}},onmessageerror:{get(){return D.port1.onmessageerror},set($){D.port1.onmessageerror=$}}}),D.port1.addEventListener("messageerror",$=>{const n=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(n)}),D.port1.addEventListener("message",$=>{const n=new MessageEvent("message",{data:$.data});this.dispatchEvent(n)}),D.port1.start()}}e.$jkc=M}),define(Re[237],Ae([1,0,23,28,12,53,4]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9I=e.$8I=e.$7I=e.$6I=void 0,e.$6I=(0,L.$8h)("notebookDocumentService");const g=["W","X","Y","Z","a","b","c","d","e","f"],h=new RegExp(`^[${g.join("")}]+`),E=7;function A(p){if(p.scheme!==I.Schemas.vscodeNotebookCell)return;const $=p.fragment.indexOf("s");if($<0)return;const n=parseInt(p.fragment.substring(0,$).replace(h,""),E),c=(0,S.$De)(p.fragment.substring($+1)).toString();if(!isNaN(n))return{handle:n,notebook:p.with({scheme:c,fragment:null})}}e.$7I=A;function D(p,$){const n=$.toString(E),r=`${n.length<g.length?g[n.length-1]:"z"}${n}s${(0,S.$Ee)(S.$ke.fromString(p.scheme),!0,!0)}`;return p.with({scheme:I.Schemas.vscodeNotebookCell,fragment:r})}e.$8I=D;class l{constructor(){this.a=new M.$Ac}getNotebook($){if($.scheme===I.Schemas.vscodeNotebookCell){const n=A($);if(n){const c=this.a.get(n.notebook);if(c)return c}}return this.a.get($)}addNotebookDocument($){this.a.set($.uri,$)}removeNotebookDocument($){this.a.delete($.uri)}}e.$9I=l,(0,R.$1r)(e.$6I,l,1)}),define(Re[84],Ae([1,0,23,34,68,69,12,19,20,35,237]),function(me,e,S,M,I,R,L,g,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.CellStatusbarAlignment=e.$kJ=e.$jJ=e.$iJ=e.NotebookEditorPriority=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.CellKind=e.$_I=e.$$I=e.$0I=void 0,e.$0I="workbench.editor.notebook",e.$$I="workbench.editor.notebookTextDiffEditor",e.$_I="workbench.editor.interactive";var D;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(D||(e.CellKind=D={})),e.$aJ=["application/json","application/javascript","text/html","image/svg+xml",R.$hs.latex,R.$hs.markdown,"image/png","image/jpeg",R.$hs.text],e.$bJ=[R.$hs.latex,R.$hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$hs.text],e.$cJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$dJ="_notAvailable";var l;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var p;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(p||(e.NotebookCellExecutionState=p={}));var $;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})($||(e.NotebookExecutionState=$={}));var n;(function(W){W[W.WithHardKernelDependency=0]="WithHardKernelDependency",W[W.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",W[W.Pure=2]="Pure",W[W.Never=3]="Never"})(n||(e.NotebookRendererMatch=n={}));var c;(function(W){W.Always="always",W.Never="never",W.Optional="optional"})(c||(e.RendererMessagingSpec=c={}));var r;(function(W){W[W.ModelChange=1]="ModelChange",W[W.Move=2]="Move",W[W.ChangeCellLanguage=5]="ChangeCellLanguage",W[W.Initialize=6]="Initialize",W[W.ChangeCellMetadata=7]="ChangeCellMetadata",W[W.Output=8]="Output",W[W.OutputItem=9]="OutputItem",W[W.ChangeCellContent=10]="ChangeCellContent",W[W.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",W[W.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",W[W.ChangeCellMime=13]="ChangeCellMime",W[W.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var t;(function(W){W[W.Handle=0]="Handle",W[W.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var s;(function(W){W[W.Replace=1]="Replace",W[W.Output=2]="Output",W[W.Metadata=3]="Metadata",W[W.CellLanguage=4]="CellLanguage",W[W.DocumentMetadata=5]="DocumentMetadata",W[W.Move=6]="Move",W[W.OutputItems=7]="OutputItems",W[W.PartialMetadata=8]="PartialMetadata",W[W.PartialInternalMetadata=9]="PartialInternalMetadata"})(s||(e.CellEditType=s={}));var a;(function(W){W.scheme=L.Schemas.vscodeNotebookCell;function se(oe,$e){return(0,A.$8I)(oe,$e)}W.generate=se;function ue(oe){return(0,A.$7I)(oe)}W.parse=ue;function ye(oe,$e){return oe.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${oe.scheme!==L.Schemas.file?oe.scheme:""}`})}W.generateCellOutputUri=ye;function ke(oe){if(oe.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!$e)return;const ie=$e[1]&&$e[1]!==""?$e[1]:void 0,x=$e[2];return{outputId:ie,notebook:oe.with({scheme:x||L.Schemas.file,fragment:null})}}W.parseCellOutputUri=ke;function ae(oe,$e,ie){return W.generate(oe,$e).with({scheme:ie})}W.generateCellPropertyUri=ae;function pe(oe,$e){if(oe.scheme===$e)return W.parse(oe.with({scheme:W.scheme}))}W.parseCellPropertyUri=pe})(a||(e.CellUri=a={}));const u=W=>h.$i?W.replace(/\//g,"\\"):W;class i{constructor(se=[],ue=e.$aJ){this.e=ue,this.d=[...new Set(se)].map(ye=>({pattern:ye,matches:M.$Oj(u(ye))}))}sort(se){const ue=new Map(I.Iterable.map(se,ke=>[ke,u(ke)]));let ye=[];for(const{matches:ke}of this.d)for(const[ae,pe]of ue)if(ke(pe)){ye.push(ae),ue.delete(ae);break}return ue.size&&(ye=ye.concat([...ue.keys()].sort((ke,ae)=>this.e.indexOf(ke)-this.e.indexOf(ae)))),ye}prioritize(se,ue){const ye=this.f(se);if(ye===-1){this.d.unshift({pattern:se,matches:M.$Oj(u(se))});return}const ke=new Set(ue.map(pe=>this.f(pe,ye)));ke.delete(-1);const ae=Array.from(ke).sort();this.d.splice(ye+1,0,...ae.map(pe=>this.d[pe]));for(let pe=ae.length-1;pe>=0;pe--)this.d.splice(ae[pe],1)}toArray(){return this.d.map(se=>se.pattern)}f(se,ue=this.d.length){const ye=u(se);for(let ke=0;ke<ue;ke++)if(this.d[ke].matches(ye))return ke;return-1}}e.$eJ=i;function v(W,se,ue,ye=(ke,ae)=>ke===ae){const ke=[];function ae($e,ie,x){if(ie===0&&x.length===0)return;const V=ke[ke.length-1];V&&V.start+V.deleteCount===$e?(V.deleteCount+=ie,V.toInsert.push(...x)):ke.push({start:$e,deleteCount:ie,toInsert:x})}let pe=0,oe=0;for(;;){if(pe===W.length){ae(pe,0,se.slice(oe));break}if(oe===se.length){ae(pe,W.length-pe,[]);break}const $e=W[pe],ie=se[oe];if(ye($e,ie)){pe+=1,oe+=1;continue}ue(ie)?(ae(pe,1,[]),pe+=1):(ae(pe,0,[ie]),oe+=1)}return ke}e.$fJ=v,e.$gJ=new E.$mj("notebookEditorCursorAtBoundary","none"),e.$hJ=new E.$mj("notebookEditorCursorAtLineBoundary","none");var o;(function(W){W.default="default",W.option="option"})(o||(e.NotebookEditorPriority=o={}));function w(W){const se=W;return!!((typeof se.include=="string"||M.$Pj(se.include))&&(typeof se.exclude=="string"||M.$Pj(se.exclude)))}e.$iJ=w;function y(W,se,ue){if(Array.isArray(W.viewType)&&W.viewType.indexOf(se)>=0||W.viewType===se)return!0;if(W.filenamePattern){const ye=w(W.filenamePattern)?W.filenamePattern.include:W.filenamePattern,ke=w(W.filenamePattern)?W.filenamePattern.exclude:void 0;if(M.$Nj(ye,(0,g.$nc)(ue.fsPath).toLowerCase()))return!(ke&&M.$Nj(ke,(0,g.$nc)(ue.fsPath).toLowerCase()))}return!1}e.$jJ=y,e.$kJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var d;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(d||(e.CellStatusbarAlignment=d={}));class b{static{this.d="notebook/"}static create(se){return`${b.d}${se}`}static parse(se){if(se.startsWith(b.d))return se.substring(b.d.length)}}e.$lJ=b;function P(W){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(W)}e.$mJ=P;const f=new TextDecoder;function m(W){const se=[];let ue=!1;for(const pe of W)(se.length===0||ue)&&(se.push(pe),ue=!0);let ye=O(se);const ke=S.$ke.concat(se.map(pe=>S.$ke.wrap(pe))),ae=N(ke);return ye=ye||ae.byteLength!==ke.byteLength,{data:ae,didCompression:ye}}e.$nJ=m,e.$oJ="\x1B[A";const k=e.$oJ.split("").map(W=>W.charCodeAt(0)),T=10;function O(W){let se=!1;return W.forEach((ue,ye)=>{if(ye===0||ue.length<e.$oJ.length)return;const ke=W[ye-1],ae=ue.subarray(0,e.$oJ.length);if(ae[0]===k[0]&&ae[1]===k[1]&&ae[2]===k[2]){const pe=ke.lastIndexOf(T);if(pe===-1)return;se=!0,W[ye-1]=ke.subarray(0,pe),W[ye]=ue.subarray(e.$oJ.length)}}),se}function G(W){let se=W;do W=se,se=W.replace(/[^\n]\x08/gm,"");while(se.length<W.length);return W}function q(W){for(W=W.replace(/\r+\n/gm,`
`);W.search(/\r[^$]/g)>-1;){const se=W.match(/^(.*)\r+/m)[1];let ue=W.match(/\r+(.*)$/m)[1];ue=ue+se.slice(ue.length,se.length),W=W.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ue)}return W}const j=8,C=13;function N(W){return!W.buffer.includes(j)&&!W.buffer.includes(C)?W:S.$ke.fromString(q(G(f.decode(W.buffer))))}}),define(Re[7],Ae([1,0,18,15,52,28,69,13,16,2,33,22,42,100,84]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$){"use strict";var n,c,r,t,s,a,u,i,v,o,w,y,d,b,P,f,m;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$dN=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$cN=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.TestRunProfileKind=e.TestResultState=e.$UM=e.$TM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$SM=e.NotebookVariablesRequestKind=e.$RM=e.$QM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$PM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.ColorThemeKind=e.$JM=e.$IM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$HM=e.$GM=e.DebugConsoleMode=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$AM=e.$zM=e.FileChangeType=e.$yM=e.$xM=e.$wM=e.$vM=e.InlineCompletionTriggerKind=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.ConfigurationTarget=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$$L=e.ViewBadge=e.ProgressLocation=e.$0L=e.$9L=e.TaskScope=e.ShellQuoting=e.$8L=e.$7L=e.$6L=e.TaskPanelKind=e.TaskRevealKind=e.$5L=e.TerminalLocation=e.$4L=e.$3L=e.$2L=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$1L=e.$ZL=e.$YL=e.$XL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$WL=e.StatusBarAlignment=e.ViewColumn=e.$VL=e.$UL=e.$TL=e.$SL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$RL=e.$QL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.LanguageStatusSeverity=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.CodeActionTriggerKind=e.$EL=e.$DL=e.SymbolTag=e.SymbolKind=e.$CL=e.$BL=e.DocumentHighlightKind=e.$AL=e.$zL=e.$yL=e.$xL=e.DiagnosticSeverity=e.DiagnosticTag=e.$wL=e.$vL=e.FileEditType=e.$uL=e.$tL=e.$sL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function k(U){return Object.assign(U,{apply:function(...re){if(re.length===0)return Reflect.construct(U,[]);{const Se=re.length===1?[]:re[1];return Reflect.construct(U,Se,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(U,[]);{const[Se,...Ge]=re;return Reflect.construct(U,Ge,Se.constructor)}}})}var T;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(T||(e.TerminalOutputAnchor=T={}));var O;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let G=n=class{static from(...z){let re=z;return new n(function(){if(re){for(const Se of re)Se&&typeof Se.dispose=="function"&&Se.dispose();re=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$lL=G,e.$lL=G=n=Je([k],G);let q=c=class{static Min(...z){if(z.length===0)throw new TypeError;let re=z[0];for(let Se=1;Se<z.length;Se++){const Ge=z[Se];Ge.isBefore(re)&&(re=Ge)}return re}static Max(...z){if(z.length===0)throw new TypeError;let re=z[0];for(let Se=1;Se<z.length;Se++){const Ge=z[Se];Ge.isAfter(re)&&(re=Ge)}return re}static isPosition(z){if(!z)return!1;if(z instanceof c)return!0;const{line:re,character:Se}=z;return typeof re=="number"&&typeof Se=="number"}static of(z){if(z instanceof c)return z;if(this.isPosition(z))return new c(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,re){if(z<0)throw(0,M.$7)("line must be non-negative");if(re<0)throw(0,M.$7)("character must be non-negative");this.c=z,this.e=re}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,re=0){if(z===null||re===null)throw(0,M.$7)();let Se;return typeof z>"u"?Se=0:typeof z=="number"?Se=z:(Se=typeof z.lineDelta=="number"?z.lineDelta:0,re=typeof z.characterDelta=="number"?z.characterDelta:0),Se===0&&re===0?this:new c(this.line+Se,this.character+re)}with(z,re=this.character){if(z===null||re===null)throw(0,M.$7)();let Se;return typeof z>"u"?Se=this.line:typeof z=="number"?Se=z:(Se=typeof z.line=="number"?z.line:this.line,re=typeof z.character=="number"?z.character:this.character),Se===this.line&&re===this.character?this:new c(Se,re)}toJSON(){return{line:this.line,character:this.character}}};e.$mL=q,e.$mL=q=c=Je([k],q);let j=r=class{static isRange(z){return z instanceof r?!0:z?q.isPosition(z.start)&&q.isPosition(z.end):!1}static of(z){if(z instanceof r)return z;if(this.isRange(z))return new r(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,re,Se,Ge){let xe,ut;if(typeof z=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Ge=="number"?(xe=new q(z,re),ut=new q(Se,Ge)):q.isPosition(z)&&q.isPosition(re)&&(xe=q.of(z),ut=q.of(re)),!xe||!ut)throw new Error("Invalid arguments");xe.isBefore(ut)?(this.c=xe,this.e=ut):(this.c=ut,this.e=xe)}contains(z){return r.isRange(z)?this.contains(z.start)&&this.contains(z.end):q.isPosition(z)?!(q.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const re=q.Max(z.start,this.c),Se=q.Min(z.end,this.e);if(!re.isAfter(Se))return new r(re,Se)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const re=q.Min(z.start,this.c),Se=q.Max(z.end,this.end);return new r(re,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,re=this.end){if(z===null||re===null)throw(0,M.$7)();let Se;return z?q.isPosition(z)?Se=z:(Se=z.start||this.start,re=z.end||this.end):Se=this.start,Se.isEqual(this.c)&&re.isEqual(this.end)?this:new r(Se,re)}toJSON(){return[this.start,this.end]}};e.$nL=j,e.$nL=j=r=Je([k],j);let C=t=class extends j{static isSelection(z){return z instanceof t?!0:z?j.isRange(z)&&q.isPosition(z.anchor)&&q.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,re,Se,Ge){let xe,ut;if(typeof z=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Ge=="number"?(xe=new q(z,re),ut=new q(Se,Ge)):q.isPosition(z)&&q.isPosition(re)&&(xe=q.of(z),ut=q.of(re)),!xe||!ut)throw new Error("Invalid arguments");super(xe,ut),this.f=xe,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$oL=C,e.$oL=C=t=Je([k],C);const N=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,M.$7)("connectionToken")};class W{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,re,Se){if(typeof z!="string"||z.length===0)throw(0,M.$7)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,M.$7)("port");typeof Se<"u"&&N(Se),this.host=z,this.port=Math.round(re),this.connectionToken=Se}}e.$pL=W;class se{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,re){this.makeConnection=z,this.connectionToken=re,typeof re<"u"&&N(re)}}e.$qL=se;class ue extends Error{static NotAvailable(z,re){return new ue(z,p.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(z){return new ue(z,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,re=p.RemoteAuthorityResolverErrorCode.Unknown,Se){super(z),this._message=z,this._code=re,this._detail=Se,Object.setPrototypeOf(this,ue.prototype)}}e.$rL=ue;var ye;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var ke;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(ke||(e.EnvironmentVariableMutatorType=ke={}));let ae=s=class{static isTextEdit(z){return z instanceof s?!0:z?j.isRange(z)&&typeof z.newText=="string":!1}static replace(z,re){return new s(z,re)}static insert(z,re){return s.replace(new j(z,z),re)}static delete(z){return s.replace(z,"")}static setEndOfLine(z){const re=new s(new j(new q(0,0),new q(0,0)),"");return re.newEol=z,re}get range(){return this.c}set range(z){if(z&&!j.isRange(z))throw(0,M.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,M.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,M.$7)("newEol");this.f=z}constructor(z,re){this.c=z,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$sL=ae,e.$sL=ae=s=Je([k],ae);let pe=a=class{static isNotebookCellEdit(z){return z instanceof a?!0:z?ni.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,re){return new a(z,re)}static insertCells(z,re){return new a(new ni(z,z),re)}static deleteCells(z){return new a(z,[])}static updateCellMetadata(z,re){const Se=new a(new ni(z,z),[]);return Se.newCellMetadata=re,Se}static updateNotebookMetadata(z){const re=new a(new ni(0,0),[]);return re.newNotebookMetadata=z,re}constructor(z,re){this.range=z,this.newCells=re}};e.$tL=pe,e.$tL=pe=a=Je([k],pe);class oe{static isSnippetTextEdit(z){return z instanceof oe?!0:z?j.isRange(z.range)&&x.isSnippetString(z.snippet):!1}static replace(z,re){return new oe(z,re)}static insert(z,re){return oe.replace(new j(z,z),re)}constructor(z,re){this.range=z,this.snippet=re}}e.$uL=oe;var $e;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,re,Se,Ge){this.c.push({_type:1,from:z,to:re,options:Se,metadata:Ge})}createFile(z,re,Se){this.c.push({_type:1,from:void 0,to:z,options:re,metadata:Se})}deleteFile(z,re,Se){this.c.push({_type:1,from:z,to:void 0,options:re,metadata:Se})}e(z,re,Se){this.c.push({_type:3,metadata:Se,uri:z,edit:{editType:5,metadata:re},notebookMetadata:re})}f(z,re,Se,Ge){const xe=re.start,ut=re.end;(xe!==ut||Se.length>0)&&this.c.push({_type:5,uri:z,index:xe,count:ut-xe,cells:Se,metadata:Ge})}g(z,re,Se,Ge){this.c.push({_type:3,metadata:Ge,uri:z,edit:{editType:3,index:re,metadata:Se}})}replace(z,re,Se,Ge){this.c.push({_type:2,uri:z,edit:new ae(re,Se),metadata:Ge})}insert(z,re,Se,Ge){this.replace(z,new j(re,re),Se,Ge)}delete(z,re,Se){this.replace(z,re,"",Se)}has(z){return this.c.some(re=>re._type===2&&re.uri.toString()===z.toString())}set(z,re){if(re)for(const Se of re){if(!Se)continue;let Ge,xe;Array.isArray(Se)?(Ge=Se[0],xe=Se[1]):Ge=Se,pe.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(z,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(z,Ge.newNotebookMetadata,xe):this.f(z,Ge.range,Ge.newCells,xe):oe.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:z,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:z,edit:Ge,metadata:xe})}else{for(let Se=0;Se<this.c.length;Se++){const Ge=this.c[Se];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===z.toString()&&(this.c[Se]=void 0);break}}(0,S.$Ib)(this.c)}}get(z){const re=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===z.toString()&&re.push(Se.edit);return re}entries(){const z=new R.$Ac;for(const re of this.c)if(re._type===2){let Se=z.get(re.uri);Se||(Se=[re.uri,[]],z.set(re.uri,Se)),Se[1].push(re.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$vL=ie,e.$vL=ie=Je([k],ie);let x=u=class{static isSnippetString(z){return z instanceof u?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=u.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,re=this.e++){if(typeof z=="function"){const Se=new u;Se.e=this.e,z(Se),this.e=Se.e,z=Se.value}else z=u.c(z);return this.value+="${",this.value+=re,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,re=this.e++){const Se=z.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(z,re){if(typeof re=="function"){const Se=new u;Se.e=this.e,re(Se),this.e=Se.e,re=Se.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$wL=x,e.$wL=x=u=Je([k],x);var V;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ne;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Ie=i=class{static isLocation(z){return z instanceof i?!0:z?j.isRange(z.range)&&E.URI.isUri(z.uri):!1}constructor(z,re){if(this.uri=z,re)if(j.isRange(re))this.range=j.of(re);else if(q.isPosition(re))this.range=new j(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$xL=Ie,e.$xL=Ie=i=Je([k],Ie);let Me=class{static is(z){return z?typeof z.message=="string"&&z.location&&j.isRange(z.location.range)&&E.URI.isUri(z.location.uri):!1}constructor(z,re){this.location=z,this.message=re}static isEqual(z,re){return z===re?!0:!z||!re?!1:z.message===re.message&&z.location.range.isEqual(re.location.range)&&z.location.uri.toString()===re.location.uri.toString()}};e.$yL=Me,e.$yL=Me=Je([k],Me);let Le=class{constructor(z,re,Se=ne.Error){if(!j.isRange(z))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=z,this.message=re,this.severity=Se}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,re){return z===re?!0:!z||!re?!1:z.message===re.message&&z.severity===re.severity&&z.code===re.code&&z.severity===re.severity&&z.source===re.source&&z.range.isEqual(re.range)&&(0,S.$ub)(z.tags,re.tags)&&(0,S.$ub)(z.relatedInformation,re.relatedInformation,Me.isEqual)}};e.$zL=Le,e.$zL=Le=Je([k],Le);let be=class{constructor(z,re){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=re}};e.$AL=be,e.$AL=be=Je([k],be);var ge;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(ge||(e.DocumentHighlightKind=ge={}));let K=class{constructor(z,re=ge.Text){this.range=z,this.kind=re}toJSON(){return{range:this.range,kind:ge[this.kind]}}};e.$BL=K,e.$BL=K=Je([k],K);let ee=class{constructor(z,re){this.uri=z,this.highlights=re}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$CL=ee,e.$CL=ee=Je([k],ee);var le;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var fe;(function(U){U[U.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let Ce=v=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,re,Se,Ge,xe){this.name=z,this.kind=re,this.containerName=xe,typeof Se=="string"&&(this.containerName=Se),Ge instanceof Ie?this.location=Ge:Se instanceof j&&(this.location=new Ie(Ge,Se)),v.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.$DL=Ce,e.$DL=Ce=v=Je([k],Ce);let de=o=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(o.validate)}constructor(z,re,Se,Ge,xe){this.name=z,this.detail=re,this.kind=Se,this.range=Ge,this.selectionRange=xe,this.children=[],o.validate(this)}};e.$EL=de,e.$EL=de=o=Je([k],de);var we;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(we||(e.CodeActionTriggerKind=we={}));let F=class{constructor(z,re){this.title=z,this.kind=re}};e.$FL=F,e.$FL=F=Je([k],F);let H=class{static{w=this}static{this.c="."}constructor(z){this.value=z}append(z){return new w(this.value?this.value+w.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+w.c)}};e.$GL=H,e.$GL=H=w=Je([k],H),H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorMove=H.Refactor.append("move"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll"),H.Notebook=H.Empty.append("notebook");let J=class{constructor(z,re){if(this.range=z,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$HL=J,e.$HL=J=Je([k],J);class B{constructor(z,re,Se,Ge,xe,ut){this.kind=z,this.name=re,this.detail=Se,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$IL=B;class Q{constructor(z,re){this.fromRanges=re,this.from=z}}e.$JL=Q;class _{constructor(z,re){this.fromRanges=re,this.to=z}}e.$KL=_;var Ee;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ee||(e.LanguageStatusSeverity=Ee={}));let Ne=class{constructor(z,re){this.range=z,this.command=re}get isResolved(){return!!this.command}};e.$LL=Ne,e.$LL=Ne=Je([k],Ne);let We=y=class{#e;static isMarkdownString(z){return z instanceof y?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,re=!1){this.#e=new I.$jk(z,{supportThemeIcons:re})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,re){return this.#e.appendCodeblock(re??"",z),this}};e.$ML=We,e.$ML=We=y=Je([k],We);let Ke=class{constructor(z,re){this.label=z,this.documentation=re}};e.$NL=Ke,e.$NL=Ke=Je([k],Ke);let Ye=class{constructor(z,re){this.label=z,this.documentation=re,this.parameters=[]}};e.$OL=Ye,e.$OL=Ye=Je([k],Ye);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$PL=nt,e.$PL=nt=Je([k],nt);var it;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var et;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(et||(e.InlayHintKind=et={}));let st=class{constructor(z){this.value=z}};e.$QL=st,e.$QL=st=Je([k],st);let ct=class{constructor(z,re,Se){this.position=z,this.label=re,this.kind=Se}};e.$RL=ct,e.$RL=ct=Je([k],ct);var Ue;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue||(e.CompletionTriggerKind=Ue={}));var mt;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(mt||(e.CompletionItemKind=mt={}));var Y;(function(U){U[U.Deprecated=1]="Deprecated"})(Y||(e.CompletionItemTag=Y={}));let X=class{constructor(z,re){this.label=z,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&mt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$SL=X,e.$SL=X=Je([k],X);let ve=class{constructor(z=[],re=!1){this.items=z,this.isIncomplete=re}};e.$TL=ve,e.$TL=ve=Je([k],ve);let Be=class{constructor(z,re,Se){this.insertText=z,this.range=re,this.command=Se}};e.$UL=Be,e.$UL=Be=Je([k],Be);let Qe=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$VL=Qe,e.$VL=Qe=Je([k],Qe);var tt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(tt||(e.ViewColumn=tt={}));var ot;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function Te(U,z){return`${D.$nm.toKey(U)}.${z}`}e.$WL=Te;var zt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative",U[U.Interval=3]="Interval"})(zt||(e.TextEditorLineNumbersStyle=zt={}));var Rt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Rt||(e.TextDocumentSaveReason=Rt={}));var Gt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Gt||(e.TextEditorRevealType=Gt={}));var Ft;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var yt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(yt||(e.TextDocumentChangeReason=yt={}));var qt;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(qt||(e.DecorationRangeBehavior=qt={})),function(U){function z(re){switch(re){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=z}(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var Tt;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Tt||(e.SyntaxTokenType=Tt={})),function(U){function z(re){switch(re){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=z}(Tt||(e.SyntaxTokenType=Tt={}));let Yt=class{constructor(z,re){if(re&&!E.URI.isUri(re))throw(0,M.$7)("target");if(!j.isRange(z)||z.isEmpty)throw(0,M.$7)("range");this.range=z,this.target=re}};e.$XL=Yt,e.$XL=Yt=Je([k],Yt);let Wt=class{constructor(z,re,Se,Ge){this.red=z,this.green=re,this.blue=Se,this.alpha=Ge}};e.$YL=Wt,e.$YL=Wt=Je([k],Wt);let jt=class{constructor(z,re){if(re&&!(re instanceof Wt))throw(0,M.$7)("color");if(!j.isRange(z)||z.isEmpty)throw(0,M.$7)("range");this.range=z,this.color=re}};e.$ZL=jt,e.$ZL=jt=Je([k],jt);let Xe=class{constructor(z){if(!z||typeof z!="string")throw(0,M.$7)("label");this.label=z}};e.$1L=Xe,e.$1L=Xe=Je([k],Xe);var Ht;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Ht||(e.ColorFormat=Ht={}));var Jt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var lt;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(lt||(e.TerminalExitReason=lt={}));class $t{constructor(z,re,Se){if(this.startIndex=z,this.length=re,this.tooltip=Se,typeof z!="number"||z<0)throw(0,M.$7)("startIndex");if(typeof re!="number"||re<1)throw(0,M.$7)("length");if(Se!==void 0&&typeof Se!="string")throw(0,M.$7)("tooltip")}}e.$2L=$t;class Ut{constructor(z){this.uri=z}}e.$3L=Ut;class Qt{constructor(z){this.terminalCommand=z}}e.$4L=Qt;var Et;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Et||(e.TerminalLocation=Et={}));class dt{constructor(z){if(this.options=z,typeof z!="object")throw(0,M.$7)("options")}}e.$5L=dt;var St;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(St||(e.TaskRevealKind=St={}));var _t;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(_t||(e.TaskPanelKind=_t={}));let Pt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(z){switch(z){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(z,re){if(this.label=re,typeof z!="string"||typeof re!="string")throw(0,M.$7)("name");this.c=z}get id(){return this.c}};e.$6L=Pt,e.$6L=Pt=d=Je([k],Pt);function He(U){let z="";for(let re=0;re<U.length;re++)z+=U[re].replace(/,/g,",,")+",";return z}let At=class{constructor(z,re,Se){if(typeof z!="string")throw(0,M.$7)("process");this.e=[],this.c=z,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=Se):this.f=re)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,M.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const re of this.e)z.push(re);return He(z)}};e.$7L=At,e.$7L=At=Je([k],At);let Nt=class{constructor(z,re,Se){if(this.f=[],Array.isArray(re)){if(!z)throw(0,M.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,M.$7)("command");this.e=z,this.f=re,this.g=Se}else{if(typeof z!="string")throw(0,M.$7)("commandLine");this.c=z,this.g=re}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,M.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,M.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)z.push(typeof re=="string"?re:re.value);return He(z)}};e.$8L=Nt,e.$8L=Nt=Je([k],Nt);var Zt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Zt||(e.ShellQuoting=Zt={}));var ft;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Mt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,A.$rg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$9L=Mt;let It=class{static{b=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,re,Se,Ge,xe,ut){this.k=!1,this.l=this.definition=z;let gt;typeof re=="string"?(this.o=this.name=re,this.w=this.source=Se,this.execution=Ge,gt=xe,this.k=!0):re===ft.Global||re===ft.Workspace?(this.target=re,this.o=this.name=Se,this.w=this.source=Ge,this.execution=xe,gt=ut):(this.target=re,this.o=this.name=Se,this.w=this.source=Ge,this.execution=xe,gt=ut),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof At?this.l={type:b.e,id:this.q.computeId()}:this.q instanceof Nt?this.l={type:b.f,id:this.q.computeId()}:this.q instanceof Mt?this.l={type:b.c,id:this.q.computeId()}:this.l={type:b.g,id:(0,A.$rg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,M.$7)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,M.$7)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const re=this.l.type;(b.g===re||b.e===re||b.f===re||b.c===re)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,M.$7)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$0L=It,e.$0L=It=b=Je([k],It);var Bt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(Bt||(e.ProgressLocation=Bt={}));var De;(function(U){function z(re){const Se=re;return(0,h.$Nf)(Se.value)?Se.tooltip&&!(0,h.$Jf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}U.isViewBadge=z})(De||(e.ViewBadge=De={}));let Fe=P=class{static isTreeItem(z,re){const Se=z;if(Se.checkboxState!==void 0){const Ge=(0,h.$Nf)(Se.checkboxState)?Se.checkboxState:(0,h.$Lf)(Se.checkboxState)&&(0,h.$Nf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,xe=!(0,h.$Nf)(Se.checkboxState)&&(0,h.$Lf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Z.Checked&&Ge!==Z.Unchecked||xe!==void 0&&!(0,h.$Jf)(xe))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(z instanceof P)return!0;if(Se.label!==void 0&&!(0,h.$Jf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,h.$Jf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,h.$Jf)(Se.iconPath)&&!E.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,h.$Jf)(Se.iconPath.id))){const Ge=Se.iconPath;if(!Ge||!(0,h.$Jf)(Ge.light)&&!E.URI.isUri(Ge.light)&&!(0,h.$Jf)(Ge.dark)&&!E.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,h.$Jf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!E.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,h.$Jf)(Se.tooltip)&&!(Se.tooltip instanceof We)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<he.None&&Se.collapsibleState>he.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,h.$Jf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(z,re=he.None){this.collapsibleState=re,E.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$$L=Fe,e.$$L=Fe=P=Je([k],Fe);var he;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(he||(e.TreeItemCollapsibleState=he={}));var Z;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(Z||(e.TreeItemCheckboxState=Z={}));let Pe=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$_L=Pe,e.$_L=Pe=Je([k],Pe);class ze extends Pe{}e.$aM=ze;class Ze extends ze{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$bM=Ze;class Ve{constructor(z,re,Se,Ge){this.name=z,this.uri=re,this._itemId=Se,this.c=Ge}data(){return this.c()}}e.$cM=Ve;let at=class{#e=new Map;constructor(z){for(const[re,Se]of z??[]){const Ge=this.#e.get(this.#t(re));Ge?Ge.push(Se):this.#e.set(this.#t(re),[Se])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,re){this.#e.set(this.#t(z),[re])}forEach(z,re){for(const[Se,Ge]of this.#e)for(const xe of Ge)z.call(re,xe,Se,this)}*[Symbol.iterator](){for(const[z,re]of this.#e)for(const Se of re)yield[z,Se]}#t(z){return z.toLowerCase()}};e.$dM=at,e.$dM=at=Je([k],at);let wt=class{constructor(z){this.insertText=z}};e.$eM=wt,e.$eM=wt=Je([k],wt);let Kt=class{constructor(z,re){this.label=re,this.insertText=z}};e.$fM=Kt,e.$fM=Kt=Je([k],Kt);let kt=class{constructor(z,re){this.id=z,this.color=re}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$gM=kt,e.$gM=kt=Je([k],kt),kt.File=new kt("file"),kt.Folder=new kt("folder");let Dt=class{constructor(z){this.id=z}};e.$hM=Dt,e.$hM=Dt=Je([k],Dt);var bt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(bt||(e.ConfigurationTarget=bt={}));let Di=class{get base(){return this.c}set base(z){this.c=z,this.e=E.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,re){if(typeof z!="string"&&(!z||!E.URI.isUri(z)&&!E.URI.isUri(z.uri)))throw(0,M.$7)("base");if(typeof re!="string")throw(0,M.$7)("pattern");typeof z=="string"?this.baseUri=E.URI.file(z):E.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$iM=Di,e.$iM=Di=Je([k],Di);const Ji=new WeakMap;function Ct(U,z){Ji.set(U,z)}e.$jM=Ct;let si=class{constructor(z,re,Se,Ge){this.enabled=typeof z=="boolean"?z:!0,typeof re=="string"&&(this.condition=re),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Ji.get(this)??(0,A.$rg)()),this.c}};e.$kM=si,e.$kM=si=Je([k],si);let mi=class extends si{constructor(z,re,Se,Ge,xe){if(super(re,Se,Ge,xe),z===null)throw(0,M.$7)("location");this.location=z}};e.$lM=mi,e.$lM=mi=Je([k],mi);let ui=class extends si{constructor(z,re,Se,Ge,xe){super(re,Se,Ge,xe),this.functionName=z}};e.$mM=ui,e.$mM=ui=Je([k],ui);let Si=class extends si{constructor(z,re,Se,Ge,xe,ut,gt){if(super(Ge,xe,ut,gt),!re)throw(0,M.$7)("dataId");this.label=z,this.dataId=re,this.canPersist=Se}};e.$nM=Si,e.$nM=Si=Je([k],Si);let Ii=class{constructor(z,re,Se){this.command=z,this.args=re||[],this.options=Se}};e.$oM=Ii,e.$oM=Ii=Je([k],Ii);let Ot=class{constructor(z,re){this.port=z,this.host=re}};e.$pM=Ot,e.$pM=Ot=Je([k],Ot);let $i=class{constructor(z){this.path=z}};e.$qM=$i,e.$qM=$i=Je([k],$i);let Ci=class{constructor(z){this.implementation=z}};e.$rM=Ci,e.$rM=Ci=Je([k],Ci);let li=class{constructor(z,re,Se){this.session=z,this.threadId=re,this.frameId=Se}};e.$sM=li,e.$sM=li=Je([k],li);let hi=class{constructor(z,re){this.session=z,this.threadId=re}};e.$tM=hi,e.$tM=hi=Je([k],hi);let ht=class{constructor(z,re){this.range=z,this.expression=re}};e.$uM=ht,e.$uM=ht=Je([k],ht);var Qi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Qi||(e.InlineCompletionTriggerKind=Qi={}));let ei=class{constructor(z,re){this.range=z,this.text=re}};e.$vM=ei,e.$vM=ei=Je([k],ei);let oi=class{constructor(z,re,Se=!0){this.range=z,this.variableName=re,this.caseSensitiveLookup=Se}};e.$wM=oi,e.$wM=oi=Je([k],oi);let pi=class{constructor(z,re){this.range=z,this.expression=re}};e.$xM=pi,e.$xM=pi=Je([k],pi);let Pi=class{constructor(z,re){this.frameId=z,this.stoppedLocation=re}};e.$yM=Pi,e.$yM=Pi=Je([k],Pi);var Zi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Zi||(e.FileChangeType=Zi={}));let Li=f=class extends Error{static FileExists(z){return new f(z,l.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(z){return new f(z,l.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(z){return new f(z,l.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(z){return new f(z,l.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(z){return new f(z,l.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(z){return new f(z,l.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}constructor(z,re=l.FileSystemProviderErrorCode.Unknown,Se){super(E.URI.isUri(z)?z.toString(!0):z),this.code=Se?.name??"Unknown",(0,l.$Hk)(this,re),Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$zM=Li,e.$zM=Li=f=Je([k],Li);let vi=class{constructor(z,re,Se){this.start=z,this.end=re,this.kind=Se}};e.$AM=vi,e.$AM=vi=Je([k],vi);var Yi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Yi||(e.FoldingRangeKind=Yi={}));var Ri;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ri||(e.CommentThreadCollapsibleState=Ri={}));var di;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(di||(e.CommentMode=di={}));var Xi;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var bi;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));class Ai{constructor(z,re=[]){this.tokenTypes=z,this.tokenModifiers=re}}e.$BM=Ai;function ln(U){return typeof U>"u"||(0,h.$Kf)(U)}class Mi{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let re=0,Se=z.tokenTypes.length;re<Se;re++)this.k.set(z.tokenTypes[re],re);for(let re=0,Se=z.tokenModifiers.length;re<Se;re++)this.l.set(z.tokenModifiers[re],re)}}push(z,re,Se,Ge,xe){if(typeof z=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.q(z,re,Se,Ge,xe);if(j.isRange(z)&&typeof re=="string"&&ln(Se))return this.o(z,re,Se);throw(0,M.$7)()}o(z,re,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(re))throw new Error("`tokenType` is not in the provided legend");const Ge=z.start.line,xe=z.start.character,ut=z.end.character-z.start.character,gt=this.k.get(re);let Vt=0;if(Se)for(const xt of Se){if(!this.l.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(xt);Vt|=1<<ii>>>0}this.q(Ge,xe,ut,gt,Vt)}q(z,re,Se,Ge,xe){if(this.f&&(z<this.c||z===this.c&&re<this.e)){this.f=!1;const Vt=this.g.length/5|0;let xt=0,ii=0;for(let ri=0;ri<Vt;ri++){let ci=this.g[5*ri],Ki=this.g[5*ri+1];ci===0?(ci=xt,Ki+=ii):ci+=xt,this.g[5*ri]=ci,this.g[5*ri+1]=Ki,xt=ci,ii=Ki}}let ut=z,gt=re;this.f&&this.j>0&&(ut-=this.c,ut===0&&(gt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=gt,this.g[this.j++]=Se,this.g[this.j++]=Ge,this.g[this.j++]=xe,this.c=z,this.e=re}static r(z){const re=[],Se=z.length/5|0;for(let gt=0;gt<Se;gt++)re[gt]=gt;re.sort((gt,Vt)=>{const xt=z[5*gt],ii=z[5*Vt];if(xt===ii){const ri=z[5*gt+1],ci=z[5*Vt+1];return ri-ci}return xt-ii});const Ge=new Uint32Array(z.length);let xe=0,ut=0;for(let gt=0;gt<Se;gt++){const Vt=5*re[gt],xt=z[Vt+0],ii=z[Vt+1],ri=z[Vt+2],ci=z[Vt+3],Ki=z[Vt+4],Cn=xt-xe,Un=Cn===0?ii-ut:ii,Gi=5*gt;Ge[Gi+0]=Cn,Ge[Gi+1]=Un,Ge[Gi+2]=ri,Ge[Gi+3]=ci,Ge[Gi+4]=Ki,xe=xt,ut=ii}return Ge}build(z){return this.f?new ai(new Uint32Array(this.g),z):new ai(Mi.r(this.g),z)}}e.$CM=Mi;class ai{constructor(z,re){this.resultId=re,this.data=z}}e.$DM=ai;class hn{constructor(z,re,Se){this.start=z,this.deleteCount=re,this.data=Se}}e.$EM=hn;class dn{constructor(z,re){this.resultId=re,this.edits=z}}e.$FM=dn;var xi;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(xi||(e.DebugConsoleMode=xi={}));class Fi{constructor(z){this.name=z}}e.$GM=Fi;let Ti=class{static{this.Back={iconPath:new kt("arrow-left")}}constructor(){}};e.$HM=Ti,e.$HM=Ti=Je([k],Ti);var _i;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(_i||(e.QuickPickItemKind=_i={}));var wi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(wi||(e.InputBoxValidationSeverity=wi={}));var Ni;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Ni||(e.ExtensionKind=Ni={}));class fn{static validate(z){if(typeof z.badge=="string"){let re=(0,g.$kf)(z.badge,0);if(re<z.badge.length&&(re+=(0,g.$kf)(z.badge,re)),z.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!kt.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,re,Se){this.badge=z,this.tooltip=re,this.color=Se}}e.$IM=fn;let yi=class{constructor(z){this.kind=z}};e.$JM=yi,e.$JM=yi=Je([k],yi);var Oi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(Oi||(e.ColorThemeKind=Oi={}));class ni{static isNotebookRange(z){return z instanceof ni?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,re){if(z<0)throw(0,M.$7)("start must be positive");if(re<0)throw(0,M.$7)("end must be positive");z<=re?(this.c=z,this.e=re):(this.c=re,this.e=z)}with(z){let re=this.c,Se=this.e;return z.start!==void 0&&(re=z.start),z.end!==void 0&&(Se=z.end),re===this.c&&Se===this.e?this:new ni(re,Se)}}e.$KM=ni;class Ei{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(re=>Ei.isNotebookCellData(re))}static isNotebookCellData(z){return!0}constructor(z,re,Se,Ge,xe,ut,gt){this.kind=z,this.value=re,this.languageId=Se,this.mime=Ge,this.outputs=xe??[],this.metadata=ut,this.executionSummary=gt,Ei.validate(this)}}e.$LM=Ei;class gn{constructor(z){this.cells=z}}e.$MM=gn;class Xt{static isNotebookCellOutputItem(z){return z instanceof Xt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const re={name:z.name,message:z.message,stack:z.stack};return Xt.json(re,"application/vnd.code.notebook.error")}static stdout(z){return Xt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Xt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,re="application/octet-stream"){return new Xt(z,re)}static#e=new TextEncoder;static text(z,re=L.$hs.text){const Se=Xt.#e.encode(String(z));return new Xt(Se,re)}static json(z,re="text/x-json"){const Se=JSON.stringify(z,void 0,"	");return Xt.text(Se,re)}constructor(z,re){this.data=z,this.mime=re;const Se=(0,L.$ls)(re,!0);if(!Se)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$NM=Xt;class fi{static isNotebookCellOutput(z){return z instanceof fi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,re=!1){const Se=new Set,Ge=new Set;for(let xe=0;xe<z.length;xe++){const ut=z[xe],gt=(0,L.$ls)(ut.mime);if(!Se.has(gt)||(0,$.$mJ)(gt)){Se.add(gt);continue}Ge.add(xe),re&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ge.size===0?z:z.filter((xe,ut)=>!Ge.has(ut))}constructor(z,re,Se){this.items=fi.ensureUniqueMimeTypes(z,!0),typeof re=="string"?(this.id=re,this.metadata=Se):(this.id=(0,A.$rg)(),this.metadata=re??Se)}}e.$OM=fi;var zi;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(zi||(e.NotebookCellKind=zi={}));var je;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(je||(e.NotebookCellExecutionState=je={}));var ti;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(ti||(e.NotebookCellStatusBarAlignment=ti={}));var ji;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(ji||(e.NotebookEditorRevealType=ji={}));class _e{constructor(z,re){this.text=z,this.alignment=re}}e.$PM=_e;var pt;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(pt||(e.NotebookControllerAffinity=pt={}));var en;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(en||(e.NotebookControllerAffinity2=en={}));class mn{constructor(z,re=[]){this.uri=z,this.provides=(0,S.$3b)(re)}}e.$QM=mn;class tn{constructor(z){this.label=z}}e.$RM=tn;var nn;(function(U){U[U.Named=1]="Named",U[U.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let gi=class{constructor(z,re){this.label=z,this.timestamp=re}};e.$SM=gi,e.$SM=gi=Je([k],gi);var rn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class an{constructor(z,re){this.ranges=z,this.wordPattern=re}}e.$TM=an;class $n{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$UM=$n;var cn;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Ui=class{constructor(z=void 0,re=void 0,Se=void 0,Ge=!1){this.include=z,this.exclude=re,this.profile=Se,this.continuous=Ge}};e.$VM=Ui,e.$VM=Ui=Je([k],Ui);let Bi=m=class{static diff(z,re,Se){const Ge=new m(z);return Ge.expectedOutput=re,Ge.actualOutput=Se,Ge}constructor(z){this.message=z}};e.$WM=Bi,e.$WM=Bi=m=Je([k],Bi);let Wi=class{constructor(z){this.id=z}};e.$XM=Wi,e.$XM=Wi=Je([k],Wi);class ki{constructor(z,re){this.covered=z,this.total=re}}e.$YM=ki;const Vi=U=>{if(U&&U.covered>U.total)throw new Error(`The total number of covered items (${U.covered}) cannot be greater than the total (${U.total})`)};class qi{static fromDetails(z,re){const Se=new ki(0,0),Ge=new ki(0,0),xe=new ki(0,0);for(const gt of re)if("branches"in gt){Se.total+=1,Se.covered+=gt.executed?1:0;for(const Vt of gt.branches)Ge.total+=1,Ge.covered+=Vt.executed?1:0}else xe.total+=1,xe.covered+=gt.executed?1:0;const ut=new qi(z,Se,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return ut.detailedCoverage=re,ut}constructor(z,re,Se,Ge){this.uri=z,this.statementCoverage=re,this.branchCoverage=Se,this.functionCoverage=Ge,Vi(re),Vi(Se),Vi(Ge)}}e.$ZM=qi;class pn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,Se=[]){this.executed=z,this.location=re,this.branches=Se}}e.$1M=pn;class te{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,Se){this.executed=z,this.location=re,this.label=Se}}e.$2M=te;class ce{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,Se){this.name=z,this.executed=re,this.location=Se}}e.$3M=ce;var Oe;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Oe||(e.ExternalUriOpenerPriority=Oe={}));var rt;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(rt||(e.WorkspaceTrustState=rt={}));var vt;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(vt||(e.PortAutoForwardAction=vt={}));class Lt{constructor(z,re,Se,Ge,xe,ut){this.kind=z,this.name=re,this.detail=Se,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$4M=Lt;class Hi{constructor(z){this.uri=z}}e.$5M=Hi;class Pn{constructor(z,re){this.original=z,this.modified=re}}e.$6M=Pn;class Ln{constructor(z,re,Se,Ge){this.base=z,this.input1=re,this.input2=Se,this.result=Ge}}e.$7M=Ln;class Rn{constructor(z,re){this.uri=z,this.viewType=re}}e.$8M=Rn;class An{constructor(z){this.viewType=z}}e.$9M=An;class Mn{constructor(z,re){this.uri=z,this.notebookType=re}}e.$0M=Mn;class Fn{constructor(z,re,Se){this.original=z,this.modified=re,this.notebookType=Se}}e.$$M=Fn;class Tn{constructor(){}}e.$_M=Tn;class Nn{constructor(z,re){this.uri=z,this.inputBoxUri=re}}e.$aN=Nn;class On{constructor(z){this.providerId=z}}e.$bN=On;var vn;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var bn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(bn||(e.ChatAgentCopyKind=bn={}));var wn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class zn{constructor(z,re){this.label=z,this.values=re}}e.$cN=zn;var yn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted",U[U.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class jn{constructor(z,re){this.role=z,this.content=re}}e.$dN=jn;var kn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Dn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Sn;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}));var In;(function(U){U[U.Recognized=1]="Recognized",U[U.Stopped=2]="Stopped"})(In||(e.KeywordRecognitionStatus=In={}))}),define(Re[238],Ae([1,0,3,7]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;class I{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(S.$jL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,g,h){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(L);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(g,h)??[]}getRelatedInformation(L,g,h){return this.c.$getAiRelatedInformation(g,h)}registerRelatedInformationProvider(L,g,h){const E=this.b;return this.b++,this.a.set(E,h),this.c.$registerAiRelatedInformationProvider(E,g),new M.$lL(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$3fc=I}),define(Re[239],Ae([1,0,5,3,7,22]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;class L{constructor(E){this.b=new Map,this.c=new S.$Wd,this.onDidChangeSessions=this.c.event,this.d=new g,this.f=new g,this.a=E.getProxy(M.$jL.MainThreadAuthentication)}async getSession(E,A,D,l={}){const p=R.$nm.toKey(E.identifier),$=[...D].sort().join(" ");return await this.d.getOrCreate(`${p} ${A} ${$}`,async()=>{await this.a.$ensureProvider(A);const n=E.displayName||E.name;return this.a.$getSession(A,D,p,n,l)})}async getSessions(E,A,D){const l=R.$nm.toKey(E.identifier),p=[...D].sort().join(" ");return await this.f.getOrCreate(`${l} ${p}`,async()=>{await this.a.$ensureProvider(A);const $=E.displayName||E.name;return this.a.$getSessions(A,D,l,$)})}async removeSession(E,A){const D=this.b.get(E);return D?D.provider.removeSession(A):this.a.$removeSession(E,A)}registerAuthenticationProvider(E,A,D,l){if(this.b.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this.b.set(E,{label:A,provider:D,options:l??{supportsMultipleAccounts:!1}});const p=D.onDidChangeSessions($=>this.a.$sendDidChangeSessions(E,$));return this.a.$registerAuthenticationProvider(E,A,l?.supportsMultipleAccounts??!1),new I.$lL(()=>{p.dispose(),this.b.delete(E),this.a.$unregisterAuthenticationProvider(E)})}$createSession(E,A,D){const l=this.b.get(E);if(l)return Promise.resolve(l.provider.createSession(A,D));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,A){const D=this.b.get(E);if(D)return Promise.resolve(D.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,A){const D=this.b.get(E);if(D)return Promise.resolve(D.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,A){return this.c.fire({provider:{id:E,label:A}}),Promise.resolve()}}e.$bgc=L;class g{constructor(){this.a=new Map}getOrCreate(E,A){const D=this.a.get(E);if(D)return D;const l=A().finally(()=>this.a.delete(E));return this.a.set(E,l),l}}}),define(Re[107],Ae([1,0,2,3,7,4,17,14,18,13,19,24]),function(me,e,S,M,I,R,L,g,h,E,A,D){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=e.$ahc=void 0;let p=class{static{l=this}static{this.c=0}static{this.d=250}constructor(n,c){this.h=c,this.f=new Map,this.g=n.getProxy(M.$jL.MainThreadDecorations)}registerFileDecorationProvider(n,c){const r=l.c++;this.f.set(r,{provider:n,extensionDescription:c}),this.g.$registerDecorationProvider(r,c.identifier.value);const t=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(s=>{if(!s){this.g.$onDidChange(r,null);return}const a=(0,h.$3b)(s);if(a.length<=l.d){this.g.$onDidChange(r,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",c.identifier.value,a.length);const u=a.map(o=>({uri:o,rank:(0,E.$Qe)(o.path,"/")})),i=(0,h.$zb)(u,(o,w)=>o.rank-w.rank||(0,E.$6e)(o.uri.path,w.uri.path)),v=[];e:for(const o of i){let w;for(const y of o){const d=(0,A.$mc)(y.uri.path);if(w!==d&&(w=d,v.push(y.uri)>=l.d))break e}}this.g.$onDidChange(r,v)});return new I.$lL(()=>{t?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(n,c,r){if(!this.f.has(n))return Object.create(null);const t=Object.create(null),{provider:s,extensionDescription:a}=this.f.get(n);return await Promise.all(c.map(async u=>{try{const{uri:i,id:v}=u,o=await Promise.resolve(s.provideFileDecoration(S.URI.revive(i),r));if(!o)return;try{I.$IM.validate(o),o.badge&&typeof o.badge!="string"&&(0,D.$LF)(a,"codiconDecoration"),t[v]=[o.propagate,o.tooltip,o.badge,o.color]}catch(w){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${w}`)}}catch(i){this.h.error(i)}})),t}};e.$ahc=p,e.$ahc=p=l=Je([qe(0,L.$oN),qe(1,g.$pj)],p),e.$bhc=(0,R.$8h)("IExtHostDecorations")}),define(Re[240],Ae([1,0,15,2,7,3,12,21,13]),function(me,e,S,M,I,R,L,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;class E{static{this.a=0}constructor(D,l,p){this.d=l,this.e=p,this.b=new Map,this.c=D.getProxy(R.$jL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,l){if(Object.keys(L.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const p=E.a++;this.b.set(p,l),this.c.$registerTextContentProvider(p,D);let $;if(typeof l.onDidChange=="function"){let n;$=l.onDidChange(async c=>{if(c.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(c))return;n&&await n;const r=this.$provideTextDocumentContent(p,c).then(async t=>{if(!t&&typeof t!="string")return;const s=this.d.getDocument(c);if(!s)return;const a=(0,h.$1e)(t);if(!s.equalLines(a))return this.c.$onVirtualDocumentChange(c,t)}).catch(S.$1).finally(()=>{n===r&&(n=void 0)});n=r})}return new I.$lL(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(D,l){const p=this.b.get(D);return p?Promise.resolve(p.provideTextDocumentContent(M.URI.revive(l),g.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$dhc=E}),define(Re[108],Ae([1,0,54,12,13,296,147,7,18]),function(me,e,S,M,I,R,L,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=e.$rN=e.$qN=void 0;const E=new Map;function A($,n){n?E.set($,n):E.delete($)}e.$qN=A;function D($){return E.get($)}class l extends R.$nv{constructor(n,c,r,t,s,a,u,i){super(c,r,t,s),this.c=n,this.m=a,this.q=u,this.notebook=i,this.b=!1}dispose(){(0,S.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,h.$ub)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===M.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(c){return c?n.s(c):n.getText()},get eol(){return n.g===`
`?g.EndOfLine.LF:g.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(c){return n.t(c)},offsetAt(c){return n.u(c)},positionAt(c){return n.v(c)},validateRange(c){return n.w(c)},validatePosition(c){return n.x(c)},getWordRangeAtPosition(c,r){return n.y(c,r)}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,S.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,S.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const c=this.w(n);if(c.isEmpty)return"";if(c.isSingleLine)return this.f[c.start.line].substring(c.start.character,c.end.character);const r=this.g,t=c.start.line,s=c.end.line,a=[];a.push(this.f[t].substring(c.start.character));for(let u=t+1;u<s;u++)a.push(this.f[u]);return a.push(this.f[s].substring(0,c.end.character)),a.join(r)}t(n){let c;if(n instanceof g.$mL?c=n.line:typeof n=="number"&&(c=n),typeof c!="number"||c<0||c>=this.f.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new p(c,this.f[c],c===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const c=this.j.getIndexOf(n),r=this.f[c.index].length;return new g.$mL(c.index,Math.min(c.remainder,r))}w(n){if(!(n instanceof g.$nL))throw new Error("Invalid argument");const c=this.x(n.start),r=this.x(n.end);return c===n.start&&r===n.end?n:new g.$nL(c.line,c.character,r.line,r.character)}x(n){if(!(n instanceof g.$mL))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:c,character:r}=n,t=!1;if(c<0)c=0,r=0,t=!0;else if(c>=this.f.length)c=this.f.length-1,r=this.f[c].length,t=!0;else{const s=this.f[c].length;r<0?(r=0,t=!0):r>s&&(r=s,t=!0)}return t?new g.$mL(c,r):n}y(n,c){const r=this.x(n);if(!c)c=D(this.m);else if((0,I.$Ze)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const t=(0,L.$zs)(r.character+1,(0,L.$xs)(c),this.f[r.line],0);if(t)return new g.$nL(r.line,t.startColumn-1,r.line,t.endColumn-1)}}e.$rN=l;class p{constructor(n,c,r){this.a=n,this.b=c,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new g.$nL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new g.$nL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$sN=p}),define(Re[241],Ae([1,0,3,7]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;class I{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(S.$jL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,g,h){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(L);if(!E)throw new Error("Embedding vector provider not found");const A=await E.provideEmbeddingVector(g,h);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(L,g,h){const E=this.b;return this.b++,this.a.set(E,h),this.c.$registerAiEmbeddingVectorProvider(g,E),new M.$lL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$fhc=I}),define(Re[62],Ae([1,0,3,42,7,23,4,17,43,6,11,25,12]),function(me,e,S,M,I,R,L,g,h,E,A,D,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=void 0;let $=p=class{constructor(c,r){this.b=new Map,this.c=new A.$eh,this.a=c.getProxy(S.$jL.MainThreadFileSystem);const t=this;this.value=Object.freeze({async stat(s){try{let a;const u=t.b.get(s.scheme);return u?(await t.a.$ensureActivation(s.scheme),a=await u.impl.stat(s)):a=await t.a.$stat(s),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===M.FilePermission.Readonly?1:void 0}}catch(a){p.e(a)}},async readDirectory(s){try{const a=t.b.get(s.scheme);return a?(await t.a.$ensureActivation(s.scheme),(await a.impl.readDirectory(s)).slice()):await t.a.$readdir(s)}catch(a){return p.e(a)}},async createDirectory(s){try{const a=t.b.get(s.scheme);return a&&!a.isReadonly?(await t.a.$ensureActivation(s.scheme),await t.d(a.impl,a.extUri,s)):await t.a.$mkdir(s)}catch(a){return p.e(a)}},async readFile(s){try{const a=t.b.get(s.scheme);return a?(await t.a.$ensureActivation(s.scheme),(await a.impl.readFile(s)).slice()):(await t.a.$readFile(s)).buffer}catch(a){return p.e(a)}},async writeFile(s,a){try{const u=t.b.get(s.scheme);return u&&!u.isReadonly?(await t.a.$ensureActivation(s.scheme),await t.d(u.impl,u.extUri,u.extUri.dirname(s)),await t.c.queueFor(s,()=>Promise.resolve(u.impl.writeFile(s,a,{create:!0,overwrite:!0})))):await t.a.$writeFile(s,R.$ke.wrap(a))}catch(u){return p.e(u)}},async delete(s,a){try{const u=t.b.get(s.scheme);return u&&!u.isReadonly&&!a?.useTrash?(await t.a.$ensureActivation(s.scheme),await u.impl.delete(s,{recursive:!1,...a})):await t.a.$delete(s,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(u){return p.e(u)}},async rename(s,a,u){try{return await t.a.$rename(s,a,{overwrite:!1,...u})}catch(i){return p.e(i)}},async copy(s,a,u){try{return await t.a.$copy(s,a,{overwrite:!1,...u})}catch(i){return p.e(i)}},isWritableFileSystem(s){const a=r.getCapabilities(s);if(typeof a=="number")return!(a&2048)}})}async d(c,r,t){const s=[];for(;!r.isEqual(t,r.dirname(t));)try{if(!((await c.stat(t)).type&M.FileType.Directory))throw I.$zM.FileExists(`Unable to create folder '${t.scheme===l.Schemas.file?t.fsPath:t.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(M.$Ik(a)!==M.FileSystemProviderErrorCode.FileNotFound)throw a;s.push(r.basename(t)),t=r.dirname(t)}for(let a=s.length-1;a>=0;a--){t=r.joinPath(t,s[a]);try{await c.createDirectory(t)}catch(u){if(M.$Ik(u)!==M.FileSystemProviderErrorCode.FileExists)throw u}}}static e(c){if(c instanceof I.$zM)throw c;if(c instanceof M.$Ek)switch(c.code){case M.FileSystemProviderErrorCode.FileExists:throw I.$zM.FileExists(c.message);case M.FileSystemProviderErrorCode.FileNotFound:throw I.$zM.FileNotFound(c.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw I.$zM.FileNotADirectory(c.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw I.$zM.FileIsADirectory(c.message);case M.FileSystemProviderErrorCode.NoPermissions:throw I.$zM.NoPermissions(c.message);case M.FileSystemProviderErrorCode.Unavailable:throw I.$zM.Unavailable(c.message);default:throw new I.$zM(c.message,c.name)}if(!(c instanceof Error))throw new I.$zM(String(c));if(c.name==="ENOPRO"||c.message.includes("ENOPRO"))throw I.$zM.Unavailable(c.message);switch(c.name){case M.FileSystemProviderErrorCode.FileExists:throw I.$zM.FileExists(c.message);case M.FileSystemProviderErrorCode.FileNotFound:throw I.$zM.FileNotFound(c.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw I.$zM.FileNotADirectory(c.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw I.$zM.FileIsADirectory(c.message);case M.FileSystemProviderErrorCode.NoPermissions:throw I.$zM.NoPermissions(c.message);case M.FileSystemProviderErrorCode.Unavailable:throw I.$zM.Unavailable(c.message);default:throw new I.$zM(c.message,c.name)}}addFileSystemProvider(c,r,t){return this.b.set(c,{impl:r,extUri:t?.isCaseSensitive?D.$yg:D.$Ag,isReadonly:!!t?.isReadonly}),(0,E.$Rc)(()=>this.b.delete(c))}getFileSystemProviderExtUri(c){return this.b.get(c)?.extUri??D.$yg}};e.$sgc=$,e.$sgc=$=p=Je([qe(0,g.$oN),qe(1,h.$6fc)],$),e.$tgc=(0,L.$8h)("IExtHostConsumerFileSystem")}),define(Re[242],Ae([1,0,3,7]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;class I{constructor(L){this.a=new Map,this.b=new Map,this.c=L.getProxy(S.$jL.MainThreadIssueReporter)}async $getIssueReporterUri(L,g){if(this.a.size===0)throw new Error("No issue request handlers registered");const h=this.a.get(L);if(!h)throw new Error("Issue request handler not found");const E=await h.handleIssueUrlRequest();if(!E)throw new Error("Issue request handler returned no result");return E}async $getIssueReporterData(L,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const h=this.b.get(L);if(!h)throw new Error("Issue data provider not found");const E=await h.provideIssueData(g);if(!E)throw new Error("Issue data provider returned no result");return E}async $getIssueReporterTemplate(L,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const h=this.b.get(L);if(!h)throw new Error("Issue data provider not found");const E=await h.provideIssueTemplate(g);if(!E)throw new Error("Issue template provider returned no result");return E}registerIssueUriRequestHandler(L,g){const h=L.identifier.value;return this.a.set(h,g),this.c.$registerIssueUriRequestHandler(h),new M.$lL(()=>{this.c.$unregisterIssueUriRequestHandler(h),this.a.delete(h)})}registerIssueDataProvider(L,g){const h=L.identifier.value;return this.b.set(h,g),this.c.$registerIssueDataProvider(h),new M.$lL(()=>{this.c.$unregisterIssueDataProvider(h),this.b.delete(h)})}}e.$whc=I}),define(Re[85],Ae([1,0,4,27,14,62,2]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=void 0,e.$ugc=(0,S.$8h)("IExtensionStoragePaths");let g=class{constructor(E,A,D){this.d=A,this.f=D,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(E){return L.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,A=await this.g(E);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(L.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(E){if(this.c)return L.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return L.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$vgc=g,e.$vgc=g=Je([qe(0,M.$EN),qe(1,I.$pj),qe(2,R.$tgc)],g)}),define(Re[243],Ae([1,0,7,17,5]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;let R=class{constructor(g){this.a=new S.$JM(S.ColorThemeKind.Dark),this.b=new I.$Wd}get activeColorTheme(){return this.a}$onColorThemeChange(g){let h;switch(g){case"light":h=S.ColorThemeKind.Light;break;case"hcDark":h=S.ColorThemeKind.HighContrast;break;case"hcLight":h=S.ColorThemeKind.HighContrastLight;break;default:h=S.ColorThemeKind.Dark}this.a=new S.$JM(h),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Zhc=R,e.$Zhc=R=Je([qe(0,M.$oN)],R)}),define(Re[86],Ae([1,0,21,5,6,167,4,14,196,3,27,17,7]),function(me,e,S,M,I,R,L,g,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jzb=e.$izb=e.TunnelDtoConverter=void 0;class p extends h.$Lv{}var $;(function(c){function r(s){return{remoteAddress:s.remoteAddress,localAddress:s.localAddress,public:!!s.public,privacy:s.privacy??(s.public?h.TunnelPrivacyId.Public:h.TunnelPrivacyId.Private),protocol:s.protocol}}c.fromApiTunnel=r;function t(s){return{remoteAddress:{host:s.tunnelRemoteHost,port:s.tunnelRemotePort},localAddress:s.localAddress,public:s.privacy!==h.TunnelPrivacyId.ConstantPrivate&&s.privacy!==h.TunnelPrivacyId.ConstantPrivate,privacy:s.privacy,protocol:s.protocol}}c.fromServiceTunnel=t})($||(e.TunnelDtoConverter=$={})),e.$izb=(0,L.$8h)("IExtHostTunnelService");let n=class extends I.$Tc{constructor(r,t,s){super(),this.s=s,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Wd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=r.getProxy(E.$jL.MainThreadTunnelService)}async openTunnel(r,t){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${t.remoteAddress.host}:${t.remoteAddress.port}.`);const s=await this.a.$openTunnel(t,r.displayName);if(s){const a=new p(s.remoteAddress,s.localAddress,()=>this.a.$closeTunnel(s.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(r,t){const s=this.u();return this.r.set(s,{selector:r,provider:t}),this.a.$registerPortsAttributesProvider(r,s),new l.$lL(()=>{this.r.delete(s),this.a.$unregisterPortsAttributesProvider(s)})}async $providePortAttributes(r,t,s,a,u){const i=[];for(const o of r){const w=this.r.get(o);if(!w)return[];i.push(...await Promise.all(t.map(async y=>{let d;try{d=await w.provider.providePortAttributes({port:y,pid:s,commandLine:a},u)}catch{d=await w.provider.providePortAttributes(y,s,a,u)}return{providedAttributes:d,port:y}})))}const v=i.filter(o=>!!o.providedAttributes);return v.length>0?v.map(o=>({autoForwardAction:o.providedAttributes.autoForwardAction,port:o.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,t){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,u)=>await r.provideTunnel(a,u,new S.$7d().token)??void 0;const s=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,privacyOptions:t.tunnelFeatures?.privacyOptions,protocol:t.tunnelFeatures.protocol===void 0?!0:t.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(s),Promise.resolve((0,I.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,t){if(r){r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.f=r.showCandidatePort,this.a.$setCandidateFilter());const s=r.tunnelFactory??(t?this.w(t):void 0);if(s){this.b=s;let a=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const u=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(u)}}else this.b=void 0;return(0,I.$Rc)(()=>{this.b=void 0})}w(r){}async $closeTunnel(r,t){if(this.g.has(r.host)){const s=this.g.get(r.host);s.has(r.port)&&(t&&s.get(r.port).disposeListener.dispose(),await s.get(r.port).tunnel.dispose(),s.delete(r.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(r,t){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const s=this.b(r,t);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),s!==void 0){const a=await s;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(r.remoteAddress.host)||this.g.set(r.remoteAddress.host,new Map);const u=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:a,disposeListener:u}),$.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(s){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),s instanceof Error)return s.message}}async $applyCandidateFilter(r){const t=await Promise.all(r.map(a=>this.f(a.host,a.port,a.detail??""))),s=r.filter((a,u)=>t[u]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(a=>a.port).join(", ")} to ${s.map(a=>a.port).join(", ")}`),s}};e.$jzb=n,e.$jzb=n=Je([qe(0,D.$oN),qe(1,A.$EN),qe(2,g.$pj)],n)}),define(Re[8],Ae([1,0,18,23,127,244,52,28,120,51,69,26,16,2,29,87,99,103,102,84,48,59,215,24,7]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c,r,t,s,a,u,i,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$nN=e.$mN=e.MarkdownString=e.$lN=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var w;(function(De){function Fe(Z){const{selectionStartLineNumber:Pe,selectionStartColumn:ze,positionLineNumber:Ze,positionColumn:Ve}=Z,at=new o.$mL(Pe-1,ze-1),wt=new o.$mL(Ze-1,Ve-1);return new o.$oL(at,wt)}De.to=Fe;function he(Z){const{anchor:Pe,active:ze}=Z;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}De.from=he})(w||(e.Selection=w={}));var y;(function(De){function Fe(Z){if(!Z)return;const{start:Pe,end:ze}=Z;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}De.from=Fe;function he(Z){if(!Z)return;const{startLineNumber:Pe,startColumn:ze,endLineNumber:Ze,endColumn:Ve}=Z;return new o.$nL(Pe-1,ze-1,Ze-1,Ve-1)}De.to=he})(y||(e.Range=y={}));var d;(function(De){function Fe(he){return new o.$xL(p.URI.revive(he.uri),y.to(he.range))}De.to=Fe})(d||(e.Location=d={}));var b;(function(De){function Fe(he){switch(he){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}De.to=Fe})(b||(e.TokenType=b={}));var P;(function(De){function Fe(Z){return new o.$mL(Z.lineNumber-1,Z.column-1)}De.to=Fe;function he(Z){return{lineNumber:Z.line+1,column:Z.character+1}}De.from=he})(P||(e.Position=P={}));var f;(function(De){function Fe(Pe,ze,Ze){return(0,S.$Hb)((0,S.$3b)(Pe).map(Ve=>he(Ve,ze,Ze)))}De.from=Fe;function he(Pe,ze,Ze){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:Ze?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:Z(Pe.scheme,ze),pattern:X.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:Ze?.isBuiltin}}function Z(Pe,ze){return ze&&typeof Pe=="string"?ze.transformOutgoingScheme(Pe):Pe}})(f||(e.DocumentSelector=f={}));var m;(function(De){function Fe(Z){switch(Z){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}De.from=Fe;function he(Z){switch(Z){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}De.to=he})(m||(e.DiagnosticTag=m={}));var k;(function(De){function Fe(Z){let Pe;return Z.code&&((0,l.$Jf)(Z.code)||(0,l.$Nf)(Z.code)?Pe=String(Z.code):Pe={value:String(Z.code.value),target:Z.code.target}),{...y.from(Z.range),message:Z.message,source:Z.source,code:Pe,severity:O.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(T.from),tags:Array.isArray(Z.tags)?(0,S.$Hb)(Z.tags.map(m.from)):void 0}}De.from=Fe;function he(Z){const Pe=new o.$zL(y.to(Z),Z.message,O.to(Z.severity));return Pe.source=Z.source,Pe.code=(0,l.$Jf)(Z.code)?Z.code:Z.code?.value,Pe.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(T.to),Pe.tags=Z.tags&&(0,S.$Hb)(Z.tags.map(m.to)),Pe}De.to=he})(k||(e.Diagnostic=k={}));var T;(function(De){function Fe(Z){return{...y.from(Z.location.range),message:Z.message,resource:Z.location.uri}}De.from=Fe;function he(Z){return new o.$yL(new o.$xL(Z.resource,y.to(Z)),Z.message)}De.to=he})(T||(e.DiagnosticRelatedInformation=T={}));var O;(function(De){function Fe(Z){switch(Z){case o.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}De.from=Fe;function he(Z){switch(Z){case c.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}De.to=he})(O||(e.DiagnosticSeverity=O={}));var G;(function(De){function Fe(Z){return typeof Z=="number"&&Z>=o.ViewColumn.One?Z-1:Z===o.ViewColumn.Beside?i.$gD:i.$fD}De.from=Fe;function he(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=he})(G||(e.ViewColumn=G={}));function q(De){return typeof De.range<"u"}function j(De){return De.length===0?!0:!!q(De[0])}e.$lN=j;var C;(function(De){function Fe(Ve){return Ve.map(De.from)}De.fromMany=Fe;function he(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function Z(Ve){let at;if(he(Ve)){const{language:Dt,value:bt}=Ve;at={value:"```"+Dt+`
`+bt+"\n```\n"}}else o.$ML.isMarkdownString(Ve)?at={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?at={value:Ve}:at={value:""};const wt=Object.create(null);at.uris=wt;const Kt=Dt=>{try{let bt=p.URI.parse(Dt,!0);bt=bt.with({query:Pe(bt.query,wt)}),wt[Dt]=bt}catch{}return""},kt=new h.marked.Renderer;return kt.link=Kt,kt.image=Dt=>typeof Dt=="string"?Kt(L.$rk(Dt).href):"",(0,h.marked)(at.value,{renderer:kt}),at}De.from=Z;function Pe(Ve,at){if(!Ve)return Ve;let wt;try{wt=(0,E.$Dh)(Ve)}catch{}if(!wt)return Ve;let Kt=!1;return wt=(0,D.$An)(wt,kt=>{if(p.URI.isUri(kt)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[Dt]=kt,Kt=!0,Dt}else return}),Kt?JSON.stringify(wt):Ve}function ze(Ve){const at=new o.$ML(Ve.value,Ve.supportThemeIcons);return at.isTrusted=Ve.isTrusted,at.supportHtml=Ve.supportHtml,at.baseUri=Ve.baseUri?p.URI.from(Ve.baseUri):void 0,at}De.to=ze;function Ze(Ve){if(Ve)return typeof Ve=="string"?Ve:De.from(Ve)}De.fromStrict=Ze})(C||(e.MarkdownString=C={}));function N(De){return j(De)?De.map(Fe=>({range:y.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?C.fromMany(Fe.hoverMessage):Fe.hoverMessage?C.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):De.map(Fe=>({range:y.from(Fe)}))}e.$mN=N;function W(De){return typeof De>"u"?De:typeof De=="string"?p.URI.file(De):De}e.$nN=W;var se;(function(De){function Fe(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?W(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}De.from=Fe})(se||(e.ThemableDecorationAttachmentRenderOptions=se={}));var ue;(function(De){function Fe(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?W(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?se.from(he.before):void 0,after:he.after?se.from(he.after):void 0}}De.from=Fe})(ue||(e.ThemableDecorationRenderOptions=ue={}));var ye;(function(De){function Fe(he){if(typeof he>"u")return he;switch(he){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}De.from=Fe})(ye||(e.DecorationRangeBehavior=ye={}));var ke;(function(De){function Fe(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?ye.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?ue.from(he.light):void 0,dark:he.dark?ue.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?W(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?se.from(he.before):void 0,after:he.after?se.from(he.after):void 0}}De.from=Fe})(ke||(e.DecorationRenderOptions=ke={}));var ae;(function(De){function Fe(Z){return{text:Z.newText,eol:Z.newEol&&st.from(Z.newEol),range:y.from(Z.range)}}De.from=Fe;function he(Z){const Pe=new o.$sL(y.to(Z.range),Z.text);return Pe.newEol=typeof Z.eol>"u"?void 0:st.to(Z.eol),Pe}De.to=he})(ae||(e.TextEdit=ae={}));var pe;(function(De){function Fe(Z,Pe){const ze={edits:[]};if(Z instanceof o.$vL){const Ze=new g.$Bc;for(const Ve of Z._allEntries())Ve._type===1&&p.URI.isUri(Ve.to)&&Ve.from===void 0&&Ze.add(Ve.to);for(const Ve of Z._allEntries())if(Ve._type===1){let at;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?at={type:"base64",value:(0,M.$Ee)(M.$ke.wrap(Ve.options.contents))}:at={type:"dataTransferItem",id:Ve.options.contents._itemId}),ze.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:at},metadata:Ve.metadata})}else Ve._type===2?ze.edits.push({resource:Ve.uri,textEdit:ae.from(Ve.edit),versionId:Ze.has(Ve.uri)?void 0:Pe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?ze.edits.push({resource:Ve.uri,textEdit:{range:y.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ve.uri)?void 0:Pe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?ze.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&ze.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(Rt.from)}})}return ze}De.from=Fe;function he(Z){const Pe=new o.$vL,ze=new g.$Ac;for(const Ze of Z.edits)if(Ze.textEdit){const Ve=Ze,at=p.URI.revive(Ve.resource),wt=y.to(Ve.textEdit.range),Kt=Ve.textEdit.text,kt=Ve.textEdit.insertAsSnippet;let Dt;kt?Dt=o.$uL.replace(wt,new o.$wL(Kt)):Dt=o.$sL.replace(wt,Kt);const bt=ze.get(at);bt?bt.push(Dt):ze.set(at,[Dt])}else Pe.renameFile(p.URI.revive(Ze.oldResource),p.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ve]of ze)Pe.set(Ze,Ve);return Pe}De.to=he})(pe||(e.WorkspaceEdit=pe={}));var oe;(function(De){const Fe=Object.create(null);Fe[o.SymbolKind.File]=0,Fe[o.SymbolKind.Module]=1,Fe[o.SymbolKind.Namespace]=2,Fe[o.SymbolKind.Package]=3,Fe[o.SymbolKind.Class]=4,Fe[o.SymbolKind.Method]=5,Fe[o.SymbolKind.Property]=6,Fe[o.SymbolKind.Field]=7,Fe[o.SymbolKind.Constructor]=8,Fe[o.SymbolKind.Enum]=9,Fe[o.SymbolKind.Interface]=10,Fe[o.SymbolKind.Function]=11,Fe[o.SymbolKind.Variable]=12,Fe[o.SymbolKind.Constant]=13,Fe[o.SymbolKind.String]=14,Fe[o.SymbolKind.Number]=15,Fe[o.SymbolKind.Boolean]=16,Fe[o.SymbolKind.Array]=17,Fe[o.SymbolKind.Object]=18,Fe[o.SymbolKind.Key]=19,Fe[o.SymbolKind.Null]=20,Fe[o.SymbolKind.EnumMember]=21,Fe[o.SymbolKind.Struct]=22,Fe[o.SymbolKind.Event]=23,Fe[o.SymbolKind.Operator]=24,Fe[o.SymbolKind.TypeParameter]=25;function he(Pe){return typeof Fe[Pe]=="number"?Fe[Pe]:6}De.from=he;function Z(Pe){for(const ze in Fe)if(Fe[ze]===Pe)return Number(ze);return o.SymbolKind.Property}De.to=Z})(oe||(e.SymbolKind=oe={}));var $e;(function(De){function Fe(Z){switch(Z){case o.SymbolTag.Deprecated:return 1}}De.from=Fe;function he(Z){switch(Z){case 1:return o.SymbolTag.Deprecated}}De.to=he})($e||(e.SymbolTag=$e={}));var ie;(function(De){function Fe(Z){return{name:Z.name,kind:oe.from(Z.kind),tags:Z.tags&&Z.tags.map($e.from),containerName:Z.containerName,location:Me.from(Z.location)}}De.from=Fe;function he(Z){const Pe=new o.$DL(Z.name,oe.to(Z.kind),Z.containerName,Me.to(Z.location));return Pe.tags=Z.tags&&Z.tags.map($e.to),Pe}De.to=he})(ie||(e.WorkspaceSymbol=ie={}));var x;(function(De){function Fe(Z){const Pe={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:y.from(Z.range),selectionRange:y.from(Z.selectionRange),kind:oe.from(Z.kind),tags:Z.tags?.map($e.from)??[]};return Z.children&&(Pe.children=Z.children.map(Fe)),Pe}De.from=Fe;function he(Z){const Pe=new o.$EL(Z.name,Z.detail,oe.to(Z.kind),y.to(Z.range),y.to(Z.selectionRange));return(0,S.$Lb)(Z.tags)&&(Pe.tags=Z.tags.map($e.to)),Z.children&&(Pe.children=Z.children.map(he)),Pe}De.to=he})(x||(e.DocumentSymbol=x={}));var V;(function(De){function Fe(Z){const Pe=new o.$IL(oe.to(Z.kind),Z.name,Z.detail||"",p.URI.revive(Z.uri),y.to(Z.range),y.to(Z.selectionRange));return Pe._sessionId=Z._sessionId,Pe._itemId=Z._itemId,Pe}De.to=Fe;function he(Z,Pe,ze){if(Pe=Pe??Z._sessionId,ze=ze??Z._itemId,Pe===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:ze,name:Z.name,detail:Z.detail,kind:oe.from(Z.kind),uri:Z.uri,range:y.from(Z.range),selectionRange:y.from(Z.selectionRange),tags:Z.tags?.map($e.from)}}De.from=he})(V||(e.CallHierarchyItem=V={}));var ne;(function(De){function Fe(he){return new o.$JL(V.to(he.from),he.fromRanges.map(Z=>y.to(Z)))}De.to=Fe})(ne||(e.CallHierarchyIncomingCall=ne={}));var Ie;(function(De){function Fe(he){return new o.$KL(V.to(he.to),he.fromRanges.map(Z=>y.to(Z)))}De.to=Fe})(Ie||(e.CallHierarchyOutgoingCall=Ie={}));var Me;(function(De){function Fe(Z){return{range:Z.range&&y.from(Z.range),uri:Z.uri}}De.from=Fe;function he(Z){return new o.$xL(p.URI.revive(Z.uri),y.to(Z.range))}De.to=he})(Me||(e.location=Me={}));var Le;(function(De){function Fe(Z){const Pe=Z,ze=Z;return{originSelectionRange:Pe.originSelectionRange?y.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:ze.uri,range:y.from(Pe.targetRange?Pe.targetRange:ze.range),targetSelectionRange:Pe.targetSelectionRange?y.from(Pe.targetSelectionRange):void 0}}De.from=Fe;function he(Z){return{targetUri:p.URI.revive(Z.uri),targetRange:y.to(Z.range),targetSelectionRange:Z.targetSelectionRange?y.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?y.to(Z.originSelectionRange):void 0}}De.to=he})(Le||(e.DefinitionLink=Le={}));var be;(function(De){function Fe(Z){return{range:y.from(Z.range),contents:C.fromMany(Z.contents)}}De.from=Fe;function he(Z){return new o.$AL(Z.contents.map(C.to),y.to(Z.range))}De.to=he})(be||(e.Hover=be={}));var ge;(function(De){function Fe(Z){return{range:y.from(Z.range),expression:Z.expression}}De.from=Fe;function he(Z){return new o.$uM(y.to(Z.range),Z.expression)}De.to=he})(ge||(e.EvaluatableExpression=ge={}));var K;(function(De){function Fe(Z){if(Z instanceof o.$vM)return{type:"text",range:y.from(Z.range),text:Z.text};if(Z instanceof o.$wM)return{type:"variable",range:y.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof o.$xM)return{type:"expression",range:y.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Fe;function he(Z){switch(Z.type){case"text":return{range:y.to(Z.range),text:Z.text};case"variable":return{range:y.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:y.to(Z.range),expression:Z.expression}}}De.to=he})(K||(e.InlineValue=K={}));var ee;(function(De){function Fe(Z){return{frameId:Z.frameId,stoppedLocation:y.from(Z.stoppedLocation)}}De.from=Fe;function he(Z){return new o.$yM(Z.frameId,y.to(Z.stoppedLocation))}De.to=he})(ee||(e.InlineValueContext=ee={}));var le;(function(De){function Fe(Z){return{range:y.from(Z.range),kind:Z.kind}}De.from=Fe;function he(Z){return new o.$BL(y.to(Z.range),Z.kind)}De.to=he})(le||(e.DocumentHighlight=le={}));var fe;(function(De){function Fe(Z){return{uri:Z.uri,highlights:Z.highlights.map(le.from)}}De.from=Fe;function he(Z){return new o.$CL(p.URI.revive(Z.uri),Z.highlights.map(le.to))}De.to=he})(fe||(e.MultiDocumentHighlight=fe={}));var Ce;(function(De){function Fe(he){switch(he){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}De.to=Fe})(Ce||(e.CompletionTriggerKind=Ce={}));var de;(function(De){function Fe(he){return{triggerKind:Ce.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}De.to=Fe})(de||(e.CompletionContext=de={}));var we;(function(De){function Fe(Z){switch(Z){case o.CompletionItemTag.Deprecated:return 1}}De.from=Fe;function he(Z){switch(Z){case 1:return o.CompletionItemTag.Deprecated}}De.to=he})(we||(e.CompletionItemTag=we={}));var F;(function(De){const Fe=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function he(ze){return Fe.get(ze)??9}De.from=he;const Z=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Pe(ze){return Z.get(ze)??o.CompletionItemKind.Property}De.to=Pe})(F||(e.CompletionItemKind=F={}));var H;(function(De){function Fe(he,Z){const Pe=new o.$SL(he.label);return Pe.insertText=he.insertText,Pe.kind=F.to(he.kind),Pe.tags=he.tags?.map(we.to),Pe.detail=he.detail,Pe.documentation=L.$lk(he.documentation)?C.to(he.documentation):he.documentation,Pe.sortText=he.sortText,Pe.filterText=he.filterText,Pe.preselect=he.preselect,Pe.commitCharacters=he.commitCharacters,$.$Ws.isIRange(he.range)?Pe.range=y.to(he.range):typeof he.range=="object"&&(Pe.range={inserting:y.to(he.range.insert),replacing:y.to(he.range.replace)}),Pe.keepWhitespace=typeof he.insertTextRules>"u"?!1:!!(he.insertTextRules&1),typeof he.insertTextRules<"u"&&he.insertTextRules&4?Pe.insertText=new o.$wL(he.insertText):(Pe.insertText=he.insertText,Pe.textEdit=Pe.range instanceof o.$nL?new o.$sL(Pe.range,Pe.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(Pe.additionalTextEdits=he.additionalTextEdits.map(ze=>ae.to(ze))),Pe.command=Z&&he.command?Z.fromInternal(he.command):void 0,Pe}De.to=Fe})(H||(e.CompletionItem=H={}));var J;(function(De){function Fe(Z){if(typeof Z.label!="string"&&!Array.isArray(Z.label))throw new TypeError("Invalid label");return{label:Z.label,documentation:C.fromStrict(Z.documentation)}}De.from=Fe;function he(Z){return{label:Z.label,documentation:L.$lk(Z.documentation)?C.to(Z.documentation):Z.documentation}}De.to=he})(J||(e.ParameterInformation=J={}));var B;(function(De){function Fe(Z){return{label:Z.label,documentation:C.fromStrict(Z.documentation),parameters:Array.isArray(Z.parameters)?Z.parameters.map(J.from):[],activeParameter:Z.activeParameter}}De.from=Fe;function he(Z){return{label:Z.label,documentation:L.$lk(Z.documentation)?C.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map(J.to):[],activeParameter:Z.activeParameter}}De.to=he})(B||(e.SignatureInformation=B={}));var Q;(function(De){function Fe(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(B.from):[]}}De.from=Fe;function he(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(B.to):[]}}De.to=he})(Q||(e.SignatureHelp=Q={}));var _;(function(De){function Fe(he,Z){const Pe=new o.$RL(P.to(Z.position),typeof Z.label=="string"?Z.label:Z.label.map(Ee.to.bind(void 0,he)),Z.kind&&Ne.to(Z.kind));return Pe.textEdits=Z.textEdits&&Z.textEdits.map(ae.to),Pe.tooltip=L.$lk(Z.tooltip)?C.to(Z.tooltip):Z.tooltip,Pe.paddingLeft=Z.paddingLeft,Pe.paddingRight=Z.paddingRight,Pe}De.to=Fe})(_||(e.InlayHint=_={}));var Ee;(function(De){function Fe(he,Z){const Pe=new o.$QL(Z.label);return Pe.tooltip=L.$lk(Z.tooltip)?C.to(Z.tooltip):Z.tooltip,n.Command.is(Z.command)&&(Pe.command=he.fromInternal(Z.command)),Z.location&&(Pe.location=Me.to(Z.location)),Pe}De.to=Fe})(Ee||(e.InlayHintLabelPart=Ee={}));var Ne;(function(De){function Fe(Z){return Z}De.from=Fe;function he(Z){return Z}De.to=he})(Ne||(e.InlayHintKind=Ne={}));var We;(function(De){function Fe(Z){return{range:y.from(Z.range),url:Z.target,tooltip:Z.tooltip}}De.from=Fe;function he(Z){let Pe;if(Z.url)try{Pe=typeof Z.url=="string"?p.URI.parse(Z.url,!0):p.URI.revive(Z.url)}catch{}return new o.$XL(y.to(Z.range),Pe)}De.to=he})(We||(e.DocumentLink=We={}));var Ke;(function(De){function Fe(Z){const Pe=new o.$1L(Z.label);return Z.textEdit&&(Pe.textEdit=ae.to(Z.textEdit)),Z.additionalTextEdits&&(Pe.additionalTextEdits=Z.additionalTextEdits.map(ze=>ae.to(ze))),Pe}De.to=Fe;function he(Z){return{label:Z.label,textEdit:Z.textEdit?ae.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(Pe=>ae.from(Pe)):void 0}}De.from=he})(Ke||(e.ColorPresentation=Ke={}));var Ye;(function(De){function Fe(Z){return new o.$YL(Z[0],Z[1],Z[2],Z[3])}De.to=Fe;function he(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}De.from=he})(Ye||(e.Color=Ye={}));var nt;(function(De){function Fe(Z){return{range:y.from(Z.range)}}De.from=Fe;function he(Z){return new o.$HL(y.to(Z.range))}De.to=he})(nt||(e.SelectionRange=nt={}));var it;(function(De){function Fe(he){switch(he){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}De.to=Fe})(it||(e.TextDocumentSaveReason=it={}));var et;(function(De){function Fe(Z){switch(Z){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.Interval:return 3;case o.TextEditorLineNumbersStyle.On:default:return 1}}De.from=Fe;function he(Z){switch(Z){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 3:return o.TextEditorLineNumbersStyle.Interval;case 1:default:return o.TextEditorLineNumbersStyle.On}}De.to=he})(et||(e.TextEditorLineNumbersStyle=et={}));var st;(function(De){function Fe(Z){if(Z===o.EndOfLine.CRLF)return 1;if(Z===o.EndOfLine.LF)return 0}De.from=Fe;function he(Z){if(Z===1)return o.EndOfLine.CRLF;if(Z===0)return o.EndOfLine.LF}De.to=he})(st||(e.EndOfLine=st={}));var ct;(function(De){function Fe(he){if(typeof he=="object")return he.viewId;switch(he){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}De.from=Fe})(ct||(e.ProgressLocation=ct={}));var Ue;(function(De){function Fe(Z){const Pe={start:Z.start+1,end:Z.end+1};return Z.kind&&(Pe.kind=mt.from(Z.kind)),Pe}De.from=Fe;function he(Z){const Pe={start:Z.start-1,end:Z.end-1};return Z.kind&&(Pe.kind=mt.to(Z.kind)),Pe}De.to=he})(Ue||(e.FoldingRange=Ue={}));var mt;(function(De){function Fe(Z){if(Z)switch(Z){case o.FoldingRangeKind.Comment:return n.$Mt.Comment;case o.FoldingRangeKind.Imports:return n.$Mt.Imports;case o.FoldingRangeKind.Region:return n.$Mt.Region}}De.from=Fe;function he(Z){if(Z)switch(Z.value){case n.$Mt.Comment.value:return o.FoldingRangeKind.Comment;case n.$Mt.Imports.value:return o.FoldingRangeKind.Imports;case n.$Mt.Region.value:return o.FoldingRangeKind.Region}}De.to=he})(mt||(e.FoldingRangeKind=mt={}));var Y;(function(De){function Fe(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?y.from(he.selection):void 0,override:typeof he.override=="boolean"?t.$IE.id:void 0}}De.from=Fe})(Y||(e.TextEditorOpenOptions=Y={}));var X;(function(De){function Fe(ze){return ze instanceof o.$iM?ze.toJSON():typeof ze=="string"?ze:he(ze)||Z(ze)?new o.$iM(ze.baseUri??ze.base,ze.pattern).toJSON():ze}De.from=Fe;function he(ze){const Ze=ze;return Ze?p.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function Z(ze){const Ze=ze;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Pe(ze){return typeof ze=="string"?ze:new o.$iM(p.URI.revive(ze.baseUri),ze.pattern)}De.to=Pe})(X||(e.GlobPattern=X={}));var ve;(function(De){function Fe(he){if(he){if(Array.isArray(he))return he.map(Fe);if(typeof he=="string")return he;{const Z=he;return{language:Z.language,scheme:Z.scheme,pattern:X.from(Z.pattern),exclusive:Z.exclusive,notebookType:Z.notebookType}}}else return}De.from=Fe})(ve||(e.LanguageSelector=ve={}));var Be;(function(De){function Fe(Z){return!!Z&&typeof Z=="object"&&"documents"in Z&&Array.isArray(Z.documents)&&Z.documents.every(Pe=>Array.isArray(Pe)&&Pe.every(ze=>ze&&typeof ze=="object"&&"uri"in ze&&p.URI.isUri(ze.uri)&&"version"in ze&&typeof ze.version=="number"&&"ranges"in ze&&Array.isArray(ze.ranges)&&ze.ranges.every(Ze=>Ze instanceof o.$nL)))}De.is=Fe;function he(Z){return{documents:Z.documents.map(Pe=>Pe.map(ze=>({uri:p.URI.from(ze.uri),version:ze.version,ranges:ze.ranges.map(Ze=>y.from(Ze))})))}}De.from=he})(Be||(e.MappedEditsContext=Be={}));var Qe;(function(De){function Fe(Z){return{start:Z.start,end:Z.end}}De.from=Fe;function he(Z){return new o.$KM(Z.start,Z.end)}De.to=he})(Qe||(e.NotebookRange=Qe={}));var tt;(function(De){function Fe(Z){return{timing:typeof Z.runStartTime=="number"&&typeof Z.runEndTime=="number"?{startTime:Z.runStartTime,endTime:Z.runEndTime}:void 0,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}De.to=Fe;function he(Z){return{lastRunSuccess:Z.success,runStartTime:Z.timing?.startTime,runEndTime:Z.timing?.endTime,executionOrder:Z.executionOrder}}De.from=he})(tt||(e.NotebookCellExecutionSummary=tt={}));var ot;(function(De){function Fe(he){if(he===s.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(he===s.NotebookCellExecutionState.Pending)return;if(he===s.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}De.to=Fe})(ot||(e.NotebookCellExecutionState=ot={}));var Te;(function(De){function Fe(Z){switch(Z){case o.NotebookCellKind.Markup:return s.CellKind.Markup;case o.NotebookCellKind.Code:default:return s.CellKind.Code}}De.from=Fe;function he(Z){switch(Z){case s.CellKind.Markup:return o.NotebookCellKind.Markup;case s.CellKind.Code:default:return o.NotebookCellKind.Code}}De.to=he})(Te||(e.NotebookCellKind=Te={}));var zt;(function(De){function Fe(Z){const Pe={metadata:Z.metadata??Object.create(null),cells:[]};for(const ze of Z.cells)o.$LM.validate(ze),Pe.cells.push(Rt.from(ze));return Pe}De.from=Fe;function he(Z){const Pe=new o.$MM(Z.cells.map(Rt.to));return(0,l.$Wf)(Z.metadata)||(Pe.metadata=Z.metadata),Pe}De.to=he})(zt||(e.NotebookData=zt={}));var Rt;(function(De){function Fe(Z){return{cellKind:Te.from(Z.kind),language:Z.languageId,mime:Z.mime,source:Z.value,metadata:Z.metadata,internalMetadata:tt.from(Z.executionSummary??{}),outputs:Z.outputs?Z.outputs.map(Ft.from):[]}}De.from=Fe;function he(Z){return new o.$LM(Te.to(Z.cellKind),Z.source,Z.language,Z.mime,Z.outputs?Z.outputs.map(Ft.to):void 0,Z.metadata,Z.internalMetadata?tt.to(Z.internalMetadata):void 0)}De.to=he})(Rt||(e.NotebookCellData=Rt={}));var Gt;(function(De){function Fe(Z){return{mime:Z.mime,valueBytes:M.$ke.wrap(Z.data)}}De.from=Fe;function he(Z){return new o.$NM(Z.valueBytes.buffer,Z.mime)}De.to=he})(Gt||(e.NotebookCellOutputItem=Gt={}));var Ft;(function(De){function Fe(Z){return{outputId:Z.id,items:Z.items.map(Gt.from),metadata:Z.metadata}}De.from=Fe;function he(Z){const Pe=Z.items.map(Gt.to);return new o.$OM(Pe,Z.outputId,Z.metadata)}De.to=he})(Ft||(e.NotebookCellOutput=Ft={}));var yt;(function(De){function Fe(Pe){return Z(Pe)?{include:X.from(Pe.include)??void 0,exclude:X.from(Pe.exclude)??void 0}:X.from(Pe)??void 0}De.from=Fe;function he(Pe){return Z(Pe)?{include:X.to(Pe.include),exclude:X.to(Pe.exclude)}:X.to(Pe)}De.to=he;function Z(Pe){const ze=Pe;return ze?!(0,l.$Sf)(ze.include)&&!(0,l.$Sf)(ze.exclude):!1}})(yt||(e.NotebookExclusiveDocumentPattern=yt={}));var qt;(function(De){function Fe(he,Z,Pe){const ze=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:Z.toInternal(ze,Pe),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}De.from=Fe})(qt||(e.NotebookStatusBarItem=qt={}));var Tt;(function(De){function Fe(he,Z,Pe){const ze=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:Z.toInternal(ze,Pe),label:he.label,description:he.description,detail:he.detail,documentation:he.documentation}}De.from=Fe})(Tt||(e.NotebookKernelSourceAction=Tt={}));var Yt;(function(De){function Fe(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}De.from=Fe})(Yt||(e.NotebookDocumentContentOptions=Yt={}));var Wt;(function(De){function Fe(Z){return{uri:Z.uri,provides:Z.provides}}De.from=Fe;function he(Z){return new o.$QM(p.URI.revive(Z.uri),Z.provides)}De.to=he})(Wt||(e.NotebookRendererScript=Wt={}));var jt;(function(De){function Fe(Z){return{message:C.fromStrict(Z.message)||"",type:0,expected:Z.expectedOutput,actual:Z.actualOutput,contextValue:Z.contextValue,location:Z.location&&{range:y.from(Z.location.range),uri:Z.location.uri}}}De.from=Fe;function he(Z){const Pe=new o.$WM(typeof Z.message=="string"?Z.message:C.to(Z.message));return Pe.actualOutput=Z.actual,Pe.expectedOutput=Z.expected,Pe.contextValue=Z.contextValue,Pe.location=Z.location?Me.to(Z.location):void 0,Pe}De.to=he})(jt||(e.TestMessage=jt={}));var Xe;(function(De){De.namespace=u.$fK,De.denamespace=u.$gK})(Xe||(e.TestTag=Xe={}));var Ht;(function(De){function Fe(Z){const Pe=(0,r.$kN)(Z).controllerId;return{extId:a.$bK.fromExtHostTestItem(Z,Pe).toString(),label:Z.label,uri:p.URI.revive(Z.uri),busy:Z.busy,tags:Z.tags.map(ze=>Xe.namespace(Pe,ze.id)),range:$.$Ws.lift(y.from(Z.range)),description:Z.description||null,sortText:Z.sortText||null,error:Z.error&&C.fromStrict(Z.error)||null}}De.from=Fe;function he(Z){return{parent:void 0,error:void 0,id:a.$bK.fromString(Z.extId).localId,label:Z.label,uri:p.URI.revive(Z.uri),tags:(Z.tags||[]).map(Pe=>{const{tagId:ze}=Xe.denamespace(Pe);return new o.$XM(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:y.to(Z.range||void 0),canResolveChildren:!1,busy:Z.busy,description:Z.description||void 0,sortText:Z.sortText||void 0}}De.toPlain=he})(Ht||(e.TestItem=Ht={})),function(De){function Fe(Z){return{id:Z.id}}De.from=Fe;function he(Z){return new o.$XM(Z.id)}De.to=he}(Xe||(e.TestTag=Xe={}));var Jt;(function(De){const Fe=(Z,Pe)=>{const ze=[];for(const[Ve,at]of Pe)a.$bK.compare(at.item.extId,Ve)===2&&(Pe.delete(Ve),ze.push(at));const Ze={...Ht.toPlain(Z.item),parent:void 0,taskStates:Z.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(at=>at.type===0).map(jt.to)})),children:ze.map(Ve=>Fe(Ve,Pe))};for(const Ve of Ze.children)Ve.parent=Ze;return Ze};function he(Z){const Pe=[],ze=new Map;for(const Ze of Z.items){ze.set(Ze.item.extId,Ze);const Ve=a.$bK.root(Ze.item.extId);Z.request.targets.some(at=>at.controllerId===Ve&&at.testIds.includes(Ze.item.extId))&&Pe.push(Ze)}return{completedAt:Z.completedAt,results:Pe.map(Ze=>Fe(Ze,ze))}}De.to=he})(Jt||(e.TestResults=Jt={}));var lt;(function(De){function Fe(ze){return{covered:ze.covered,total:ze.total}}function he(ze){return"line"in ze?P.from(ze):y.from(ze)}function Z(ze){return"branches"in ze?{count:ze.executed,location:he(ze.location),type:1,branches:ze.branches.length?ze.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&he(Ze.location),label:Ze.label})):void 0}:{type:0,name:ze.name,count:ze.executed,location:he(ze.location)}}De.fromDetailed=Z;function Pe(ze){return{uri:ze.uri,statement:Fe(ze.statementCoverage),branch:ze.branchCoverage&&Fe(ze.branchCoverage),function:ze.functionCoverage&&Fe(ze.functionCoverage),details:ze.detailedCoverage?.map(Z)}}De.fromFile=Pe})(lt||(e.TestCoverage=lt={}));var $t;(function(De){function Fe(he){switch(he){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}De.to=Fe})($t||(e.CodeActionTriggerKind=$t={}));var Ut;(function(De){function Fe(Z){const Pe=new o.$4M(oe.to(Z.kind),Z.name,Z.detail||"",p.URI.revive(Z.uri),y.to(Z.range),y.to(Z.selectionRange));return Pe._sessionId=Z._sessionId,Pe._itemId=Z._itemId,Pe}De.to=Fe;function he(Z,Pe,ze){if(Pe=Pe??Z._sessionId,ze=ze??Z._itemId,Pe===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:ze,kind:oe.from(Z.kind),name:Z.name,detail:Z.detail??"",uri:Z.uri,range:y.from(Z.range),selectionRange:y.from(Z.selectionRange),tags:Z.tags?.map($e.from)}}De.from=he})(Ut||(e.TypeHierarchyItem=Ut={}));var Qt;(function(De){function Fe(he){if(he)return{value:he.value,tooltip:he.tooltip}}De.from=Fe})(Qt||(e.ViewBadge=Qt={}));var Et;(function(De){function Fe(ze,Ze,Ve){const at=Ze.fileData;return at?new o.$bM(new o.$cM(at.name,p.URI.revive(at.uri),at.id,(0,R.$db)(()=>Ve(at.id)))):ze===A.$hs.uriList&&Ze.uriListData?new o.$aM(Pe(Ze.uriListData)):new o.$aM(Ze.asString)}De.to=Fe;async function he(ze,Ze){const Ve=await Ze.asString();if(ze===A.$hs.uriList)return{asString:Ve,fileData:void 0,uriListData:Z(Ve)};const at=Ze.asFile();return{asString:Ve,fileData:at?{name:at.name,uri:at.uri,id:at._itemId??at.id}:void 0}}De.from=he;function Z(ze){return I.$tt.split(ze).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return p.URI.parse(Ze)}catch{}return Ze})}function Pe(ze){return I.$tt.create(ze.map(Ze=>typeof Ze=="string"?Ze:p.URI.revive(Ze)))}})(Et||(e.DataTransferItem=Et={}));var dt;(function(De){function Fe(Z,Pe){const ze=Z.items.map(([Ze,Ve])=>[Ze,Et.to(Ze,Ve,Pe)]);return new o.$dM(ze)}De.toDataTransfer=Fe;async function he(Z){const Pe={items:[]},ze=[];for(const[Ze,Ve]of Z)ze.push((async()=>{Pe.items.push([Ze,await Et.from(Ze,Ve)])})());return await Promise.all(ze),Pe}De.from=he})(dt||(e.DataTransfer=dt={}));var St;(function(De){function Fe(he){return{kind:"reply",message:he.message,title:he.title,tooltip:he.tooltip}}De.from=Fe})(St||(e.ChatReplyFollowup=St={}));var _t;(function(De){function Fe(he){return typeof he=="string"?{title:he,message:he,kind:"reply"}:"commandId"in he?{kind:"command",title:he.title??"",commandId:he.commandId??"",when:he.when??"",args:he.args}:St.from(he)}De.from=Fe})(_t||(e.ChatFollowup=_t={}));var Pt;(function(De){function Fe(Z){const Pe=new o.$dN(He.to(Z.role),Z.content);return Pe.name=Z.name,Pe}De.to=Fe;function he(Z){return{role:He.from(Z.role),content:Z.content,name:Z.name}}De.from=he})(Pt||(e.ChatMessage=Pt={}));var He;(function(De){function Fe(Z){switch(Z){case 0:return o.ChatMessageRole.System;case 1:return o.ChatMessageRole.User;case 2:return o.ChatMessageRole.Assistant;case 3:return o.ChatMessageRole.Function}}De.to=Fe;function he(Z){switch(Z){case o.ChatMessageRole.System:return 0;case o.ChatMessageRole.Assistant:return 2;case o.ChatMessageRole.Function:return 3;case o.ChatMessageRole.User:default:return 1}}De.from=he})(He||(e.ChatMessageRole=He={}));var At;(function(De){function Fe(Pe){const ze={};for(const Ze of Object.keys(Pe))ze[Ze]=Pe[Ze].map(De.to);return ze}De.objectTo=Fe;function he(Pe){return{level:Nt.to(Pe.level),kind:Pe.kind,value:(0,p.$vc)(Pe.value)?p.URI.revive(Pe.value):Pe.value,description:Pe.description}}De.to=he;function Z(Pe){return{level:Nt.from(Pe.level),kind:Pe.kind,value:Pe.value,description:Pe.description}}De.from=Z})(At||(e.ChatVariable=At={}));var Nt;(function(De){function Fe(Z){switch(Z){case"short":return o.ChatVariableLevel.Short;case"medium":return o.ChatVariableLevel.Medium;case"full":default:return o.ChatVariableLevel.Full}}De.to=Fe;function he(Z){switch(Z){case o.ChatVariableLevel.Short:return"short";case o.ChatVariableLevel.Medium:return"medium";case o.ChatVariableLevel.Full:default:return"full"}}De.from=he})(Nt||(e.ChatVariableLevel=Nt={}));var Zt;(function(De){function Fe(he){switch(he){case 1:return o.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return o.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return o.InteractiveEditorResponseFeedbackKind.Undone;case 3:return o.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return o.InteractiveEditorResponseFeedbackKind.Bug}}De.to=Fe})(Zt||(e.InteractiveEditorResponseFeedbackKind=Zt={}));var ft;(function(De){function Fe(Pe,ze){return"markdownContent"in ze?((0,v.$LF)(Pe,"chatAgents2Additions"),{content:C.from(ze.markdownContent),kind:"markdownContent"}):"content"in ze?"vulnerabilities"in ze&&ze.vulnerabilities?((0,v.$LF)(Pe,"chatAgents2Additions"),{content:ze.content,vulnerabilities:ze.vulnerabilities,kind:"vulnerability"}):typeof ze.content=="string"?{content:ze.content,kind:"content"}:((0,v.$LF)(Pe,"chatAgents2Additions"),{content:C.from(ze.content),kind:"markdownContent"}):"documents"in ze?{documents:ze.documents.map(Ze=>({uri:Ze.uri,version:Ze.version,ranges:Ze.ranges.map(Ve=>y.from(Ve))})),kind:"usedContext"}:"reference"in ze?{reference:"uri"in ze.reference?{uri:ze.reference.uri,range:y.from(ze.reference.range)}:ze.reference,kind:"reference"}:"inlineReference"in ze?{inlineReference:"uri"in ze.inlineReference?{uri:ze.inlineReference.uri,range:y.from(ze.inlineReference.range)}:ze.inlineReference,name:ze.title,kind:"inlineReference"}:"agentName"in ze?((0,v.$LF)(Pe,"chatAgents2Additions"),{agentName:ze.agentName,command:ze.command,kind:"agentDetection"}):"treeData"in ze?{treeData:ze.treeData,kind:"treeData"}:"message"in ze?{content:C.from(ze.message),kind:"progressMessage"}:void 0}De.from=Fe;function he(Pe){switch(Pe.kind){case"markdownContent":case"inlineReference":case"treeData":return De.to(Pe);case"content":return{content:Pe.content};case"usedContext":return{documents:Pe.documents.map(ze=>({uri:p.URI.revive(ze.uri),version:ze.version,ranges:ze.ranges.map(Ze=>y.to(Ze))}))};case"reference":return{reference:(0,p.$vc)(Pe.reference)?p.URI.revive(Pe.reference):d.to(Pe.reference)};case"agentDetection":return;case"progressMessage":return{message:Pe.content.value};case"vulnerability":return{content:Pe.content,vulnerabilities:Pe.vulnerabilities};default:return}}De.to=he;function Z(Pe){switch(Pe.kind){case"markdownContent":return{content:Pe.content.value};case"inlineReference":return{inlineReference:(0,p.$vc)(Pe.inlineReference)?p.URI.revive(Pe.inlineReference):d.to(Pe.inlineReference),title:Pe.name};case"treeData":return{treeData:(0,E.$Eh)(Pe.treeData)};default:return}}De.toProgressContent=Z})(ft||(e.ChatResponseProgress=ft={}));var Mt;(function(De){function Fe(he){return{prompt:he.message,variables:At.objectTo(he.variables),subCommand:he.command,agentId:he.agentId}}De.to=Fe})(Mt||(e.ChatAgentRequest=Mt={}));var It;(function(De){function Fe(he){return{label:he.label,values:he.values.map(At.from),insertText:he.insertText,detail:he.detail,documentation:he.documentation}}De.from=Fe})(It||(e.ChatAgentCompletionItem=It={}));var Bt;(function(De){function Fe(he,Z,Pe){return"terminalCommand"in he?{terminalCommand:he.terminalCommand,shouldExecute:he.shouldExecute}:"uri"in he?{uri:he.uri}:Z.toInternal(he,Pe)}De.from=Fe})(Bt||(e.TerminalQuickFix=Bt={}))}),define(Re[245],Ae([1,0,3,17,8]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;let R=class{constructor(g,h){this.a=g.getProxy(S.$jL.MainThreadBulkEdits),this.b={getTextDocumentVersion:E=>h.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,h,E){const A=I.WorkspaceEdit.from(g,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,E?.isRefactoring??!1)}};e.$cgc=R,e.$cgc=R=Je([qe(0,M.$oN)],R)}),define(Re[246],Ae([1,0,18,11,41,5,63,2,157,72,3,8,7,205,24]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0;class n{static{this.a=0}constructor(t,s,a){this.j=s,this.k=a,this.b=new Map,this.g=new Map,this.i=new Map,this.d=t.getProxy(A.$jL.MainThreadChatAgents2)}createChatAgent(t,s,a){const u=n.a++,i=new c(t,s,this.d,u,a);return this.b.set(u,i),this.d.$registerAgent(u,s,{}),i.apiAgent}async $invokeAgent(t,s,a,u){this.g.delete(s.sessionId);const i=this.b.get(t);if(!i)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let v=!1;function o(){if(v)throw new Error("Only valid while executing the command")}const w=new M.$sh;u.onCancellationRequested(()=>w.complete()),this.j.allowListExtensionWhile(i.extension.identifier,w.p);const y=L.$Sd.create(!1);let d;try{const b=await this.l(i,s,a),P=i.invoke(D.ChatAgentRequest.to(s),{history:b},new E.$xv(f=>{o(),typeof d>"u"&&"content"in f&&(d=y.elapsed());const m=D.ChatResponseProgress.from(i.extension,f);if(!m){this.k.error("Unknown progress type: "+JSON.stringify(f));return}"placeholder"in f&&"resolvedContent"in f||this.d.$handleProgressChunk(s.requestId,m)}),u);return await(0,M.$Vg)(Promise.resolve(P).then(f=>{if(f){this.g.set(s.sessionId,f);let m=this.i.get(s.sessionId);m||(m=new Map,this.i.set(s.sessionId,m)),m.set(s.requestId,f);const k={firstProgress:d,totalElapsed:y.elapsed()};return{errorDetails:f.errorDetails,timings:k}}else this.g.delete(s.sessionId)}),u)}catch(b){return this.k.error(b,i.extension),{errorDetails:{message:(0,h.localize)(0,null,(0,I.$Si)(b)),responseIsIncomplete:!0}}}finally{v=!0,w.complete()}}async l(t,s,a){return(0,S.$Hb)(await Promise.all(a.history.map(async u=>{const i=s.agentId===u.request.agentId&&this.i.get(s.sessionId)?.get(u.request.requestId)||u.result;return{request:D.ChatAgentRequest.to(u.request),response:(0,S.$Hb)(u.response.map(v=>D.ChatResponseProgress.toProgressContent(v))),result:i}})))}$releaseSession(t){this.g.delete(t),this.i.delete(t)}async $provideSlashCommands(t,s){const a=this.b.get(t);return a?a.provideSlashCommands(s):[]}$provideFollowups(t,s,a){const u=this.b.get(t);if(!u)return Promise.resolve([]);const i=this.g.get(s);return i?u.provideFollowups(i,a):Promise.resolve([])}$acceptFeedback(t,s,a,u,i){const v=this.b.get(t);if(!v)return;const o=this.i.get(s)?.get(a);if(!o)return;let w;switch(u){case p.InteractiveSessionVoteDirection.Down:w=l.ChatAgentResultFeedbackKind.Unhelpful;break;case p.InteractiveSessionVoteDirection.Up:w=l.ChatAgentResultFeedbackKind.Helpful;break}v.acceptFeedback(Object.freeze(i?{result:o,kind:w,reportIssue:i}:{result:o,kind:w}))}$acceptAction(t,s,a,u){const i=this.b.get(t);if(!i)return;const v=this.i.get(s)?.get(a);v&&u.action.kind!=="vote"&&i.acceptAction(Object.freeze({action:u.action,result:v}))}async $invokeCompletionProvider(t,s,a){const u=this.b.get(t);return u?(await u.invokeCompletionProvider(s,a)).map(D.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,s){const a=this.b.get(t);if(a)return await a.provideWelcomeMessage(s)}async $provideSampleQuestions(t,s){const a=this.b.get(t);if(a)return await a.provideSampleQuestions(s)}}e.$fgc=n;class c{constructor(t,s,a,u,i){this.extension=t,this.id=s,this.w=a,this.x=u,this.y=i,this.o=new R.$Wd,this.q=new R.$Wd}acceptFeedback(t){this.o.fire(t)}acceptAction(t){this.q.fire(t)}async invokeCompletionProvider(t,s){return this.t?await this.t.provider.provideCompletionItems(t,s)??[]:[]}async provideSlashCommands(t){if(!this.a)return[];const s=await this.a.provideSubCommands(t);return s?s.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate,sampleRequest:a.sampleRequest})):[]}async provideFollowups(t,s){if(!this.b)return[];const a=await this.b.provideFollowups(t,s);return a?a.map(u=>D.ChatFollowup.from(u)):[]}async provideWelcomeMessage(t){if(!this.u)return[];const s=await this.u.provideWelcomeMessage(t);return s?s.map(a=>typeof a=="string"?a:D.MarkdownString.from(a)):[]}async provideSampleQuestions(t){if(!this.u||!this.u.provideSampleQuestions)return[];const s=await this.u.provideSampleQuestions(t);return s?s?.map(a=>D.ChatReplyFollowup.from(a)):[]}get apiAgent(){let t=!1,s=!1;const a=()=>{t||s||(s=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{description:this.d??"",fullName:this.g,icon:this.i?this.i instanceof g.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof l.$gM?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.b!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:D.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:D.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.s}),s=!1}))},u=this;return{get name(){return u.id},get description(){return u.d??""},set description(i){u.d=i,a()},get fullName(){return u.g??u.extension.displayName??u.extension.name},set fullName(i){u.g=i,a()},get iconPath(){return u.i},set iconPath(i){u.i=i,a()},get subCommandProvider(){return u.a},set subCommandProvider(i){u.a=i,a()},get followupProvider(){return u.b},set followupProvider(i){u.b=i,a()},get isDefault(){return(0,$.$LF)(u.extension,"defaultChatAgent"),u.j},set isDefault(i){(0,$.$LF)(u.extension,"defaultChatAgent"),u.j=i,a()},get helpTextPrefix(){return(0,$.$LF)(u.extension,"defaultChatAgent"),u.k},set helpTextPrefix(i){if((0,$.$LF)(u.extension,"defaultChatAgent"),!u.j)throw new Error("helpTextPrefix is only available on the default chat agent");u.k=i,a()},get helpTextPostfix(){return(0,$.$LF)(u.extension,"defaultChatAgent"),u.l},set helpTextPostfix(i){if((0,$.$LF)(u.extension,"defaultChatAgent"),!u.j)throw new Error("helpTextPostfix is only available on the default chat agent");u.l=i,a()},get isSecondary(){return(0,$.$LF)(u.extension,"defaultChatAgent"),u.n},set isSecondary(i){(0,$.$LF)(u.extension,"defaultChatAgent"),u.n=i,a()},get sampleRequest(){return u.m},set sampleRequest(i){u.m=i,a()},get supportIssueReporting(){return(0,$.$LF)(u.extension,"chatAgents2Additions"),u.s},set supportIssueReporting(i){(0,$.$LF)(u.extension,"chatAgents2Additions"),u.s=i,a()},get onDidReceiveFeedback(){return u.o.event},set agentVariableProvider(i){if(u.t=i,i){if(!i.triggerCharacters.length)throw new Error("triggerCharacters are required");u.w.$registerAgentCompletionsProvider(u.x,i.triggerCharacters)}else u.w.$unregisterAgentCompletionsProvider(u.x)},get agentVariableProvider(){return u.t},set welcomeMessageProvider(i){u.u=i,a()},get welcomeMessageProvider(){return u.u},onDidPerformAction:(0,$.$KF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){t=!0,u.a=void 0,u.b=void 0,u.o.dispose(),u.w.$unregisterAgent(u.x)}}}invoke(t,s,a,u){return this.y(t,s,a,u)}}}),define(Re[247],Ae([1,0,21,6,3,8,72,22,11,5]),function(me,e,S,M,I,R,L,g,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0;class A{constructor($,n){this.stream=new h.$yh,this.stream=n??new h.$yh;const c=this;this.apiObj={option:$,response:c.stream.asyncIterable}}}class D{constructor($,n){this.a=new E.$Wd,this.b=new Map,this.c=new h.$yh,this.d=!1;const c=this;this.apiObject={result:$,response:c.c.asyncIterable,onDidStartResponseStream:c.a.event,cancel(){n.cancel()}},$.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,r]of this.b)r.stream.resolve();else this.c.resolve()})}handleFragment($){if(this.d)return;let n=this.b.get($.index);n||(this.b.size===0?n=new A($.index,this.c):n=new A($.index),this.b.set($.index,n),this.a.fire(n.apiObj)),n.stream.emitOne($.part)}}class l{static{this.a=1}constructor($,n){this.d=n,this.c=new Map,this.e=new Map,this.f=new g.$pm,this.b=$.getProxy(I.$jL.MainThreadChatProvider)}registerProvider($,n,c,r){const t=l.a++;return this.c.set(t,{extension:$,provider:c}),this.b.$registerProvider(t,n,{extension:$,model:r.name??""}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(t),this.c.delete(t)})}async $provideChatResponse($,n,c,r,t){const s=this.c.get($);if(!s)return;const a=new L.$xv(async u=>{if(t.isCancellationRequested){this.d.warn(`[CHAT](${s.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(n,{index:u.index,part:u.part})});return s.provider.provideChatResponse(c.map(R.ChatMessage.to),r,a,t)}allowListExtensionWhile($,n){this.f.set($,n),n.finally(()=>this.f.delete($))}async requestChatResponseProvider($,n){if(!this.f.has($))throw new Error("Extension is NOT allowed to make chat requests");const c=await this.b.$prepareChatAccess(n);if(!c)throw new Error(`ChatAccess '${n}' NOT found`);const r=this;return{get model(){return c.model},get isRevoked(){return!r.f.has($)},makeRequest(t,s,a){if(!r.f.has($))throw new Error("Access to chat has been revoked");const u=new S.$7d(a),i=Math.random()*1e6|0,v=r.b.$fetchResponse($,n,i,t.map(R.ChatMessage.from),s??{},u.token),o=new D(v,u);return r.e.set(i,{res:o}),v.finally(()=>{r.e.delete(i)}),o.apiObject}}}async $handleResponseFragment($,n){const c=this.e.get($);c&&c.res.handleFragment(n)}}e.$egc=l}),define(Re[248],Ae([1,0,6,3,15,8]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;class L{static{this.a=0}constructor(h){this.b=new Map,this.c=h.getProxy(M.$jL.MainThreadChatVariables)}async $resolveVariable(h,E,A){const D=this.b.get(h);if(D)try{const l=await D.resolver.resolve(D.data.name,{prompt:E},A);if(l)return l.map(R.ChatVariable.from)}catch(l){(0,I.$2)(l)}}registerVariableResolver(h,E,A,D){const l=L.a++;return this.b.set(l,{extension:h.identifier,data:{name:E,description:A},resolver:D}),this.c.$registerVariable(l,{name:E,description:A}),(0,S.$Rc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$ggc=L}),define(Re[249],Ae([1,0,11,67,5,6,2,87,22,8,7,3,24]),function(me,e,S,M,I,R,L,g,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;function p($,n,c){const r=$.getProxy(D.$jL.MainThreadComments);class t{static{this.a=0}constructor(){this.b=new Map,this.c=new h.$pm,n.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const b=this.b.get(d.handle);return b?b.value:d}else if(d&&d.$mid===7){const b=this.b.get(d.commentControlHandle);if(!b)return d;const P=b.getCommentThread(d.commentThreadHandle);return P?P.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const b=this.b.get(d.thread.commentControlHandle);if(!b)return d;const P=b.getCommentThread(d.thread.commentThreadHandle);return P?d.$mid===8?P.value:{thread:P.value,text:d.text}:d}else if(d&&d.$mid===10){const b=this.b.get(d.thread.commentControlHandle);if(!b)return d;const P=b.getCommentThread(d.thread.commentThreadHandle);if(!P)return d;const f=d.commentUniqueId,m=P.getCommentByUniqueId(f);return m||d}else if(d&&d.$mid===11){const b=this.b.get(d.thread.commentControlHandle);if(!b)return d;const P=b.getCommentThread(d.thread.commentThreadHandle);if(!P)return d;const f=d.text,m=d.commentUniqueId,k=P.getCommentByUniqueId(m);return k?(typeof k.body=="string"?k.body=f:k.body=new A.$ML(f),k):d}return d}})}createCommentController(d,b,P){const f=t.a++,m=new a(d,f,b,P);this.b.set(m.handle,m);const k=this.c.get(d.identifier)||[];return k.push(m),this.c.set(d.identifier,k),m.value}async $createCommentThreadTemplate(d,b,P){const f=this.b.get(d);f&&f.$createCommentThreadTemplate(b,P)}async $updateCommentThreadTemplate(d,b,P){const f=this.b.get(d);f&&f.$updateCommentThreadTemplate(b,P)}$deleteCommentThread(d,b){this.b.get(d)?.$deleteCommentThread(b)}$provideCommentingRanges(d,b,P){const f=this.b.get(d);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const m=c.getDocument(L.URI.revive(b));return(0,S.$Zg)(async()=>{const k=await f.commentingRangeProvider.provideCommentingRanges(m,P);let T;return Array.isArray(k)?T={ranges:k,fileComments:!1}:k?T={ranges:k.ranges||[],fileComments:k.fileComments||!1}:T=k??void 0,T}).then(k=>{let T;return k&&(T={ranges:k.ranges.map(O=>E.Range.from(O)),fileComments:k.fileComments}),T})}$toggleReaction(d,b,P,f,m){const k=this.b.get(d);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,S.$Zg)(()=>{const T=k.getCommentThread(b);if(T){const O=T.getCommentByUniqueId(f.uniqueIdInThread);if(k!==void 0&&O&&k.reactionHandler)return k.reactionHandler(O,v(m))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,b,P,f,m,k,T,O){this.m=b,this.n=P,this.o=f,this.p=m,this.q=k,this.extensionDescription=T,this.r=O,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$Wd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Uc,this.l.value=new R.$Sc,this.n===void 0&&(this.n=`${d}.${this.handle}`),r.$createCommentThread(b,this.handle,this.n,this.o,E.Range.from(this.p),T.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{r.$deleteCommentThread(b,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(q){G.range=q},get comments(){return G.comments},set comments(q){G.comments=q},get collapsibleState(){return G.collapsibleState},set collapsibleState(q){G.collapsibleState=q},get canReply(){return G.canReply},set canReply(q){G.canReply=q},get contextValue(){return G.contextValue},set contextValue(q){G.contextValue=q},get label(){return G.label},set label(q){G.label=q},get state(){return G.state},set state(q){G.state=q},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Sc);const d=P=>Object.prototype.hasOwnProperty.call(this.b,P),b={};d("range")&&(b.range=E.Range.from(this.p)),d("label")&&(b.label=this.label),d("contextValue")&&(b.contextValue=this.contextValue??null),d("comments")&&(b.comments=this.q.map(P=>u(this,P,this.k,this.extensionDescription))),d("collapsibleState")&&(b.collapseState=o(this.g)),d("canReply")&&(b.canReply=this.canReply),d("state")&&(b.state=w(this.h)),d("isTemplate")&&(b.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,b)}getCommentByUniqueId(d){for(const b of this.k){const P=b[0],f=b[1];if(d===f)return P}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Je([(0,M.$Ah)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,r.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,b,P,f){this.f=d,this.g=b,this.h=P,this.i=f,this.a=new Map,r.$registerCommentController(this.handle,P,f,this.f.identifier.value);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(k){m.options=k},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(k){m.commentingRangeProvider=k},get reactionHandler(){return m.reactionHandler},set reactionHandler(k){m.reactionHandler=k},createCommentThread(k,T,O){return m.createCommentThread(k,T,O).value},dispose:()=>{m.dispose()}}),this.e=[],this.e.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(d,b,P){b===void 0&&(0,l.$LF)(this.f,"fileComments");const f=new s(this.id,this.handle,void 0,d,b,P,this.f,!1);return this.a.set(f.handle,f),f}$createCommentThreadTemplate(d,b){const P=new s(this.id,this.handle,void 0,L.URI.revive(d),E.Range.to(b),[],this.f,!0);return P.collapsibleState=g.CommentThreadCollapsibleState.Expanded,this.a.set(P.handle,P),P}$updateCommentThreadTemplate(d,b){const P=this.a.get(d);P&&(P.range=E.Range.to(b))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function u(y,d,b,P){let f=b.get(d);return f||(f=++y.commentHandle,b.set(d,f)),d.state!==void 0&&(0,l.$LF)(P,"commentsDraftState"),d.reactions?.some(m=>m.reactors!==void 0)&&(0,l.$LF)(P,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:f,body:typeof d.body=="string"?d.body:E.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(m=>i(m)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function i(y){return{label:y.label,iconPath:y.iconPath?E.$nN(y.iconPath):void 0,count:y.count,hasReacted:y.authorHasReacted,reactors:y.reactors&&y.reactors.length>0&&typeof y.reactors[0]!="string"?y.reactors.map(d=>d.name):y.reactors}}function v(y){return{label:y.label||"",count:y.count||0,iconPath:y.iconPath?L.URI.revive(y.iconPath):"",authorHasReacted:y.hasReacted||!1,reactors:y.reactors?.map(d=>({name:d}))}}function o(y){if(y!==void 0)switch(y){case A.CommentThreadCollapsibleState.Expanded:return g.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return g.CommentThreadCollapsibleState.Collapsed}return g.CommentThreadCollapsibleState.Collapsed}function w(y){if(y!==void 0)switch(y){case A.CommentThreadState.Unresolved:return g.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return g.CommentThreadState.Resolved}return g.CommentThreadState.Unresolved}return new t}e.$kgc=p}),define(Re[250],Ae([1,0,21,98,6,12,25,2,8,61,75,3,7]),function(me,e,S,M,I,R,L,g,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=void 0;class p{constructor(v,o){this.document=v,this.b=o,this.a=1,this.c=new A.$2fc("custom documents")}addEdit(v){return this.c.add([v])}async undo(v,o){await this.f(v).undo(),o||this.disposeBackup()}async redo(v,o){await this.f(v).redo(),o||this.disposeBackup()}disposeEdits(v){for(const o of v)this.c.delete(o)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const v=u(this.document.uri)+this.a++;return(0,L.$Ig)(this.b,v)}updateBackup(v){this.d?.delete(),this.d=v}disposeBackup(){this.d?.delete(),this.d=void 0}f(v){const o=this.c.get(v,0);if(!o)throw new Error("No edit found");return o}}class ${constructor(){this.a=new Map}get(v,o){return this.a.get(this.b(v,o))}add(v,o,w){const y=this.b(v,o.uri);if(this.a.has(y))throw new Error(`Document already exists for viewType:${v} resource:${o.uri}`);const d=new p(o,w);return this.a.set(y,d),d}delete(v,o){const w=this.b(v,o.uri);this.a.delete(w)}b(v,o){return`${v}@@@${o}`}}var n;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(n||(n={}));class c{constructor(){this.a=new Map}addTextProvider(v,o,w){return this.b(0,v,o,w)}addCustomProvider(v,o,w){return this.b(1,v,o,w)}get(v){return this.a.get(v)}b(v,o,w,y){if(this.a.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this.a.set(o,{type:v,extension:w,provider:y}),new l.$lL(()=>this.a.delete(o))}}class r{constructor(v,o,w,y,d){this.d=o,this.f=w,this.g=y,this.h=d,this.b=new c,this.c=new $,this.a=v.getProxy(D.$jL.MainThreadCustomEditors)}registerCustomEditorProvider(v,o,w,y){const d=new I.$Sc;return s(w)?(d.add(this.b.addTextProvider(o,v,w)),this.a.$registerTextEditorProvider((0,E.$zgc)(v),o,y.webviewOptions||{},{supportsMove:!!w.moveCustomTextEditor},(0,E.$xgc)(v))):(d.add(this.b.addCustomProvider(o,v,w)),t(w)&&d.add(w.onDidChangeCustomDocument(b=>{const P=this.i(o,b.document.uri);if(a(b)){const f=P.addEdit(b);this.a.$onDidEdit(b.document.uri,o,f,b.label)}else this.a.$onContentChange(b.document.uri,o)})),this.a.$registerCustomEditorProvider((0,E.$zgc)(v),o,y.webviewOptions||{},!!y.supportsMultipleEditorsPerDocument,(0,E.$xgc)(v))),l.$lL.from(d,new l.$lL(()=>{this.a.$unregisterEditorProvider(o)}))}async $createCustomDocument(v,o,w,y,d){const b=this.b.get(o);if(!b)throw new Error(`No provider found for '${o}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${o}'`);const P=g.URI.revive(v),f=await b.provider.openCustomDocument(P,{backupId:w,untitledDocumentData:y?.buffer},d);let m;return t(b.provider)&&this.f&&(m=this.f.workspaceValue(b.extension)??this.f.globalValue(b.extension)),this.c.add(o,f,m),{editable:t(b.provider)}}async $disposeCustomDocument(v,o){const w=this.b.get(o);if(!w)throw new Error(`No provider found for '${o}'`);if(w.type!==1)throw new Error(`Invalid provider type for '${o}'`);const y=g.URI.revive(v),{document:d}=this.i(o,y);this.c.delete(o,d),d.dispose()}async $resolveCustomEditor(v,o,w,y,d,b){const P=this.b.get(w);if(!P)throw new Error(`No provider found for '${w}'`);const f=h.ViewColumn.to(d),m=this.g.createNewWebview(o,y.contentOptions,P.extension),k=this.h.createNewWebviewPanel(o,w,y.title,f,y.options,m,y.active),T=g.URI.revive(v);switch(P.type){case 1:{const{document:O}=this.i(w,T);return P.provider.resolveCustomEditor(O,k,b)}case 0:{const O=this.d.getDocument(T);return P.provider.resolveCustomTextEditor(O,k,b)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(v,o,w){this.i(o,v).disposeEdits(w)}async $onMoveCustomEditor(v,o,w){const y=this.b.get(w);if(!y)throw new Error(`No provider found for '${w}'`);if(!y.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${w}'`);const d=this.h.getWebviewPanel(v);if(!d)throw new Error("No webview found");const b=g.URI.revive(o),P=this.d.getDocument(b);await y.provider.moveCustomTextEditor(P,d,S.CancellationToken.None)}async $undo(v,o,w,y){return this.i(o,v).undo(w,y)}async $redo(v,o,w,y){return this.i(o,v).redo(w,y)}async $revert(v,o,w){const y=this.i(o,v);await this.j(o).revertCustomDocument(y.document,w),y.disposeBackup()}async $onSave(v,o,w){const y=this.i(o,v);await this.j(o).saveCustomDocument(y.document,w),y.disposeBackup()}async $onSaveAs(v,o,w,y){const d=this.i(o,v);return this.j(o).saveCustomDocumentAs(d.document,g.URI.revive(w),y)}async $backup(v,o,w){const y=this.i(o,v),b=await this.j(o).backupCustomDocument(y.document,{destination:y.getNewBackupUri()},w);return y.updateBackup(b),b.id}i(v,o){const w=this.c.get(v,g.URI.revive(o));if(!w)throw new Error("No custom document found");return w}j(v){const w=this.b.get(v)?.provider;if(!w||!t(w))throw new Error("Custom document is not editable");return w}}e.$Cgc=r;function t(i){return!!i.onDidChangeCustomDocument}function s(i){return typeof i.resolveCustomTextEditor=="function"}function a(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function u(i){const v=i.scheme===R.Schemas.file||i.scheme===R.Schemas.untitled?i.fsPath:i.toString();return(0,M.$Vi)(v)+""}}),define(Re[251],Ae([1,0,158,99,2,3,7,8,5,14,28,43]),function(me,e,S,M,I,R,L,g,h,E,A,D){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=e.$7fc=void 0;class p{#e;#t;#i;constructor(c,r,t,s,a,u,i,v){this.d=c,this.e=r,this.f=t,this.g=s,this.h=a,this.c=!1,this.f=Math.max(s,t),this.#i=new A.$Ac(o=>u.getComparisonKey(o)),this.#e=i,this.#t=v}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(c,r){if(!c){this.clear();return}this.j();let t=[];if(I.URI.isUri(c)){if(!r){this.delete(c);return}this.#i.set(c,r.slice()),t=[c]}else if(Array.isArray(c)){t=[];let u;c=[...c].sort(p.k);for(const i of c){const[v,o]=i;if((!u||v.toString()!==u.toString())&&(u&&this.#i.get(u).length===0&&this.#i.delete(u),u=v,t.push(v),this.#i.set(v,[])),o)this.#i.get(v)?.push(...o);else{const w=this.#i.get(v);w&&(w.length=0)}}}if(this.#t.fire(t),!this.#e)return;const s=[];let a=0;for(const u of t){let i=[];const v=this.#i.get(u);if(v)if(v.length>this.g){i=[];const o=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let w=0;w<4;w++)for(const y of v)if(y.severity===o[w]&&i.push({...g.Diagnostic.from(y),modelVersionId:this.h(u)})===this.g)break e;i.push({severity:M.MarkerSeverity.Info,message:(0,S.localize)(0,null,v.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=v.map(o=>({...g.Diagnostic.from(o),modelVersionId:this.h(u)}));if(s.push([u,i]),a+=i.length,a>this.f)break}this.#e.$changeMany(this.e,s)}delete(c){this.j(),this.#t.fire([c]),this.#i.delete(c),this.#e?.$changeMany(this.e,[[c,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(c,r){this.j();for(const[t,s]of this)c.call(r,t,s,this)}*[Symbol.iterator](){this.j();for(const c of this.#i.keys())yield[c,this.get(c)]}get(c){this.j();const r=this.#i.get(c);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(c){return this.j(),Array.isArray(this.#i.get(c))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(c,r){return c[0].toString()<r[0].toString()?-1:c[0].toString()>r[0].toString()?1:0}}e.$7fc=p;let $=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(c){const r=new A.$Ac;for(const t of c)r.set(t,t);return{uris:Object.freeze(Array.from(r.values()))}}constructor(c,r,t,s){this.j=r,this.k=t,this.l=s,this.g=new Map,this.h=new h.$1d({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=h.Event.map(this.h.event,l._mapper),this.f=c.getProxy(R.$jL.MainThreadDiagnostics)}createDiagnosticCollection(c,r){const{g:t,f:s,h:a,j:u,k:i,l:v}=this,o=new class{$changeMany(d,b){s.$changeMany(d,b),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,d,b.length===0?"CLEARING":b)}$clear(d){s.$clear(d),u.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,d)}dispose(){s.dispose()}};let w;if(!r)r="_generated_diagnostic_collection_name_#"+l.c++,w=r;else if(!t.has(r))w=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do w=r+l.c++;while(t.has(w))}return new class extends p{constructor(){super(r,w,l.e,l.d,d=>v.getDocument(d)?.version,i.extUri,o,a),t.set(w,this)}dispose(){super.dispose(),t.delete(w)}}}getDiagnostics(c){if(c)return this.m(c);{const r=new Map,t=[];for(const s of this.g.values())s.forEach((a,u)=>{let i=r.get(a.toString());typeof i>"u"&&(i=t.length,r.set(a.toString(),i),t.push([a,[]])),t[i][1]=t[i][1].concat(...u)});return t}}m(c){let r=[];for(const t of this.g.values())t.has(c)&&(r=r.concat(t.get(c)));return r}$acceptMarkersChange(c){if(!this.n){const r="_generated_mirror",t=new p(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,s=>{},this.k.extUri,void 0,this.h);this.g.set(r,t),this.n=t}for(const[r,t]of c)this.n.set(I.URI.revive(r),t.map(g.Diagnostic.to))}};e.$8fc=$,e.$8fc=$=l=Je([qe(1,E.$pj),qe(2,D.$6fc)],$)}),define(Re[252],Ae([1,0,2,15,7,8,185]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;class g{constructor(E,A,D,l={timeout:1500,errors:3}){this.c=E,this.d=A,this.f=D,this.g=l,this.a=new L.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(E){return(A,D,l)=>{const $={dispose:this.a.push([A,D,E])};return Array.isArray(l)&&l.push($),$}}async $participateInSave(E,A){const D=S.URI.revive(E);let l=!1;const p=setTimeout(()=>l=!0,this.g.timeout),$=[];try{for(const n of[...this.a]){if(l)break;const c=this.d.getDocument(D),r=await this.h(n,{document:c,reason:R.TextDocumentSaveReason.to(A)});$.push(r)}}finally{clearTimeout(p)}return $}h([E,A,D],l){const p=this.b.get(E);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(D,E,A,l).then(()=>!0,$=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error($),!($ instanceof Error)||$.message!=="concurrent_edits"){const n=this.b.get(E);this.b.set(E,n?n+1:1),typeof n=="number"&&n>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(E,A,D,l){const p=[],$=Date.now(),{document:n,reason:c}=l,{version:r}=n,t=Object.freeze({document:n,reason:c,waitUntil(s){if(Object.isFrozen(p))throw(0,M.$8)("waitUntil can not be called async");p.push(Promise.resolve(s))}});try{A.apply(D,[t])}catch(s){return Promise.reject(s)}return Object.freeze(p),new Promise((s,a)=>{const u=setTimeout(()=>a(new Error("timeout")),this.g.timeout);return Promise.all(p).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' finished after ${Date.now()-$}ms`),clearTimeout(u),s(i)}).catch(i=>{clearTimeout(u),a(i)})}).then(s=>{const a={edits:[]};for(const u of s)if(Array.isArray(u)&&u.every(i=>i instanceof I.$sL))for(const{newText:i,newEol:v,range:o}of u)a.edits.push({resource:n.uri,versionId:void 0,textEdit:{range:o&&R.Range.from(o),text:i,eol:v&&R.EndOfLine.from(v)}});if(a.edits.length!==0)return r===n.version?this.f.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.$ehc=g}),define(Re[253],Ae([1,0,5,6,2,3,108,8,16,26,7]),function(me,e,S,M,I,R,L,g,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;class D{constructor(p,$){this.a=new S.$Wd,this.b=new S.$Wd,this.c=new S.$Wd,this.d=new S.$Wd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Sc,this.h=new Map,this.f=p.getProxy(R.$jL.MainThreadDocuments),this.g=$,this.g.onDidRemoveDocuments(n=>{for(const c of n)this.b.fire(c.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const c of n)this.a.fire(c.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const $=this.g.getDocument(p);if($)return $}getDocument(p){const $=this.getDocumentData(p);if(!$?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return $.document}ensureDocumentData(p){const $=this.g.getDocument(p);if($)return Promise.resolve($);let n=this.h.get(p.toString());return n||(n=this.f.$tryOpenDocument(p).then(c=>{this.h.delete(p.toString());const r=I.URI.revive(c);return(0,h.$Uf)(this.g.getDocument(r))},c=>(this.h.delete(p.toString()),Promise.reject(c))),this.h.set(p.toString(),n)),n}createDocumentData(p){return this.f.$tryCreateDocument(p).then($=>I.URI.revive($))}$acceptModelLanguageChanged(p,$){const n=I.URI.revive(p),c=this.g.getDocument(n);if(!c)throw new Error("unknown document");this.b.fire(c.document),c._acceptLanguageId($),this.a.fire(c.document)}$acceptModelSaved(p){const $=I.URI.revive(p),n=this.g.getDocument($);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(p,$){const n=I.URI.revive(p),c=this.g.getDocument(n);if(!c)throw new Error("unknown document");c._acceptIsDirty($),this.c.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,$,n){const c=I.URI.revive(p),r=this.g.getDocument(c);if(!r)throw new Error("unknown document");r._acceptIsDirty(n),r.onEvents($);let t;$.isUndoing?t=A.TextDocumentChangeReason.Undo:$.isRedoing&&(t=A.TextDocumentChangeReason.Redo),this.c.fire((0,E.$zn)({document:r.document,contentChanges:$.changes.map(s=>({range:g.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:t}))}setWordDefinitionFor(p,$){(0,L.$qN)(p,$)}}e.$4fc=D}),define(Re[64],Ae([1,0,254,5,16,2,4,3,17,8,7]),function(me,e,S,M,I,R,L,g,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=e.$Dgc=void 0,e.$Dgc=(0,L.$8h)("IExtHostEditorTabs");class D{constructor(c,r,t){this.e=t,this.d=r,this.acceptDtoUpdate(c)}get apiObject(){if(!this.a){const c=this,r={get isActive(){return c.b.id===c.e()},get label(){return c.b.label},get input(){return c.c},get isDirty(){return c.b.isDirty},get isPinned(){return c.b.isPinned},get isPreview(){return c.b.isPreview},get group(){return c.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(c){this.b=c,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$5M(R.URI.revive(this.b.input.uri));case 2:return new A.$6M(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$7M(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$8M(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$9M(this.b.input.viewType);case 4:return new A.$0M(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$$M(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$_M;case 9:return new A.$aN(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$bN(this.b.input.providerId);default:return}}}class l{constructor(c,r){this.c=[],this.d="",this.b=c,this.e=r;for(const t of c.tabs)t.isActive&&(this.d=t.id),this.c.push(new D(t,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const c=this,r={get isActive(){return c.b.groupId===c.e()},get viewColumn(){return E.ViewColumn.to(c.b.viewColumn)},get activeTab(){return c.c.find(t=>t.tabId===c.d)?.apiObject},get tabs(){return Object.freeze(c.c.map(t=>t.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(c){this.b=c}acceptTabOperation(c){if(c.kind===0){const t=new D(c.tabDto,this,()=>this.activeTabId());return this.c.splice(c.index,0,t),c.tabDto.isActive&&(this.d=t.tabId),t}else if(c.kind===1){const t=this.c.splice(c.index,1)[0];if(!t)throw new Error(`Tab close updated received for index ${c.index} which does not exist`);return t.tabId===this.d&&(this.d=""),t}else if(c.kind===3){if(c.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const t=this.c.splice(c.oldIndex,1)[0];if(!t)throw new Error(`Tab move updated received for index ${c.oldIndex} which does not exist`);return this.c.splice(c.index,0,t),t}const r=this.c.find(t=>t.tabId===c.tabDto.id);if(!r)throw new Error("INVALID tab");return c.tabDto.isActive?this.d=c.tabDto.id:this.d===c.tabDto.id&&!c.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(c.tabDto),r}activeTabId(){return this.d}}let p=class{constructor(c){this.b=new M.$Wd,this.c=new M.$Wd,this.e=[],this.a=c.getProxy(g.$jL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const c=this,r={onDidChangeTabGroups:c.c.event,onDidChangeTabs:c.b.event,get all(){return Object.freeze(c.e.map(t=>t.apiObject))},get activeTabGroup(){const t=c.d;return(0,I.$Uf)(c.e.find(a=>a.groupId===t)?.apiObject)},close:async(t,s)=>{const a=Array.isArray(t)?t:[t];return a.length?$(a[0])?this.j(a,s):this.i(a,s):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(c){const r=new Set(this.e.map(o=>o.groupId)),t=new Set(c.map(o=>o.groupId)),s=(0,S.$L)(r,t),a=this.e.filter(o=>s.removed.includes(o.groupId)).map(o=>o.apiObject),u=[],i=[];this.e=c.map(o=>{const w=new l(o,()=>this.d);return s.added.includes(w.groupId)?u.push(w.apiObject):i.push(w.apiObject),w});const v=(0,I.$Uf)(c.find(o=>o.isActive===!0)?.groupId);v!==void 0&&this.d!==v&&(this.d=v),this.c.fire(Object.freeze({opened:u,closed:a,changed:i}))}$acceptTabGroupUpdate(c){const r=this.e.find(t=>t.groupId===c.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(c),c.isActive&&(this.d=c.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(c){const r=this.e.find(s=>s.groupId===c.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const t=r.acceptTabOperation(c);switch(c.kind){case 0:this.b.fire(Object.freeze({opened:[t.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[t.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[t.apiObject]}));return}}g(c){for(const r of this.e)for(const t of r.tabs)if(t.apiObject===c)return t}h(c){return this.e.find(r=>r.apiObject===c)}async i(c,r){const t=[];for(const s of c){const a=this.g(s);if(!a)throw new Error("Tab close: Invalid tab not found!");t.push(a.tabId)}return this.a.$closeTab(t,r)}async j(c,r){const t=[];for(const s of c){const a=this.h(s);if(!a)throw new Error("Group close: Invalid group not found!");t.push(a.groupId)}return this.a.$closeGroup(t,r)}};e.$Egc=p,e.$Egc=p=Je([qe(0,h.$oN)],p);function $(n){return n.tabs!==void 0}}),define(Re[255],Ae([1,0,2,3,6,7,8,297,13,23,24,52]),function(me,e,S,M,I,R,L,g,h,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;class l{constructor(){this.a=[]}add(n){this.b=void 0,this.a.push(n)}delete(n){const c=this.a.indexOf(n);c>=0&&(this.a.splice(c,1),this.b=void 0)}c(){if(!this.b){const n=this.a.sort(),c=[];let r,t,s=14,a=14;for(const u of n){let i=r?(0,h.$cf)(r,u):0;for(i===0?t=1:t=a;i<u.length;i++)i+1===u.length?(s=a,a=9):a+=1,c.push([t,u.toUpperCase().charCodeAt(i),a]),c.push([t,u.toLowerCase().charCodeAt(i),a]),t=a;r=u,a=s}c.push([9,58,10]),c.push([10,47,12]),this.b=new g.$MZ(c)}}provideDocumentLinks(n){this.c();const c=[],r=g.$NZ.computeLinks({getLineContent(t){return n.lineAt(t-1).text},getLineCount(){return n.lineCount}},this.b);for(const t of r){const s=L.DocumentLink.to(t);s.target&&c.push(s)}return c}}class p{constructor(n,c){this.i=c,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=n.getProxy(M.$jL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(n,c,r,t={}){if(p.j(r),this.d.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(n,"*",this.b));const s=this.h++;this.b.add(c),this.d.add(c),this.c.set(s,r);let a=2;t.isCaseSensitive&&(a+=1024),t.isReadonly&&(a+=2048),typeof r.copy=="function"&&(a+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,A.$LF)(n,"fsChunks"),a+=4);let u;t.isReadonly&&(0,D.$lk)(t.isReadonly)&&t.isReadonly.value!==""&&(u={value:t.isReadonly.value,isTrusted:t.isReadonly.isTrusted,supportThemeIcons:t.isReadonly.supportThemeIcons,supportHtml:t.isReadonly.supportHtml,baseUri:t.isReadonly.baseUri,uris:t.isReadonly.uris}),this.a.$registerFileSystemProvider(s,c,a,u).catch(v=>{console.error(`FAILED to register filesystem provider of ${n.identifier.value}-extension for the scheme ${c}`),console.error(v)});const i=r.onDidChangeFile(v=>{const o=[];for(const w of v){const{uri:y,type:d}=w;if(y.scheme!==c)continue;let b;switch(d){case R.FileChangeType.Changed:b=0;break;case R.FileChangeType.Created:b=1;break;case R.FileChangeType.Deleted:b=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:y,type:b})}this.a.$onFileSystemChange(s,o)});return(0,I.$Rc)(()=>{i.dispose(),this.b.delete(c),this.d.delete(c),this.c.delete(s),this.a.$unregisterProvider(s)})}static j(n){if(!n)throw new Error("MISSING provider");if(typeof n.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof n.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof n.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof n.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof n.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof n.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof n.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof n.rename!="function")throw new Error("Provider does NOT implement rename")}static k(n){const{type:c,ctime:r,mtime:t,size:s,permissions:a}=n;return{type:c,ctime:r,mtime:t,size:s,permissions:a}}$stat(n,c){return Promise.resolve(this.l(n).stat(S.URI.revive(c))).then(r=>p.k(r))}$readdir(n,c){return Promise.resolve(this.l(n).readDirectory(S.URI.revive(c)))}$readFile(n,c){return Promise.resolve(this.l(n).readFile(S.URI.revive(c))).then(r=>E.$ke.wrap(r))}$writeFile(n,c,r,t){return Promise.resolve(this.l(n).writeFile(S.URI.revive(c),r.buffer,t))}$delete(n,c,r){return Promise.resolve(this.l(n).delete(S.URI.revive(c),r))}$rename(n,c,r,t){return Promise.resolve(this.l(n).rename(S.URI.revive(c),S.URI.revive(r),t))}$copy(n,c,r,t){const s=this.l(n);if(!s.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(s.copy(S.URI.revive(c),S.URI.revive(r),t))}$mkdir(n,c){return Promise.resolve(this.l(n).createDirectory(S.URI.revive(c)))}$watch(n,c,r,t){const s=this.l(n).watch(S.URI.revive(r),t);this.f.set(c,s)}$unwatch(n,c){const r=this.f.get(c);r&&(r.dispose(),this.f.delete(c))}$open(n,c,r){const t=this.l(n);if(!t.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(t.open(S.URI.revive(c),r))}$close(n,c){const r=this.l(n);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(c))}$read(n,c,r,t){const s=this.l(n);if(!s.read)throw new Error('FileSystemProvider does not implement "read"');const a=E.$ke.alloc(t);return Promise.resolve(s.read(c,r,a.buffer,0,t)).then(u=>a.slice(0,u))}$write(n,c,r,t){const s=this.l(n);if(!s.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(s.write(c,r,t.buffer,0,t.byteLength))}l(n){const c=this.c.get(n);if(!c){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return c}}e.$ghc=p}),define(Re[256],Ae([1,0,5,34,2,3,8,7,39]),function(me,e,S,M,I,R,L,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,$,n,c,r,t){this.a=Math.random(),this.b=new S.$Wd,this.c=new S.$Wd,this.d=new S.$Wd,this.h=0,t?.ignoreCreateEvents&&(this.h+=1),t?.ignoreChangeEvents&&(this.h+=2),t?.ignoreDeleteEvents&&(this.h+=4);const s=(0,M.$Oj)(r),a=typeof r=="string",u=t?.correlate,i=c(v=>{if(!(typeof v.session=="number"&&v.session!==this.a)&&!(u&&typeof v.session>"u")){if(!t?.ignoreCreateEvents)for(const o of v.created){const w=I.URI.revive(o);s(w.fsPath)&&(!a||$.getWorkspaceFolder(w))&&this.b.fire(w)}if(!t?.ignoreChangeEvents)for(const o of v.changed){const w=I.URI.revive(o);s(w.fsPath)&&(!a||$.getWorkspaceFolder(w))&&this.c.fire(w)}if(!t?.ignoreDeleteEvents)for(const o of v.deleted){const w=I.URI.revive(o);s(w.fsPath)&&(!a||$.getWorkspaceFolder(w))&&this.d.fire(w)}}});this.g=g.$lL.from(this.i(p,n,r,t,t?.correlate),this.b,this.c,this.d,i)}i(p,$,n,c,r){const t=g.$lL.from();if(typeof n=="string")return t;const s=p.getProxy(R.$jL.MainThreadFileSystemEventService);let a=!1;return(n.pattern.includes(M.$Kj)||n.pattern.includes(M.$Lj))&&(a=!0),s.$watch($.identifier.value,this.a,n.baseUri,{recursive:a,excludes:c?.excludes??[]},!!r),g.$lL.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(p){this.a=p,this.session=this.a.session,this.b=new h.$V(()=>this.a.created.map(I.URI.revive)),this.c=new h.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new h.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(p,$,n){this.j=p,this.k=$,this.l=n,this.a=new S.$Wd,this.b=new S.$Wd,this.c=new S.$Wd,this.d=new S.$Wd,this.g=new S.$Yd,this.h=new S.$Yd,this.i=new S.$Yd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,$,n,c){return new E(this.j,p,$,this.a.event,L.GlobPattern.from(n),c)}$onFileEvent(p){this.a.fire(new A(p))}$onDidRunFileOperation(p,$){switch(p){case 2:this.b.fire(Object.freeze({files:$.map(n=>({oldUri:I.URI.revive(n.source),newUri:I.URI.revive(n.target)}))}));break;case 1:this.d.fire(Object.freeze({files:$.map(n=>I.URI.revive(n.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:$.map(n=>I.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,$){return(n,c,r)=>{const t=function(a){n.call(c,a)};return t.extension=p,$.event(t,void 0,r)}}async $onWillRunFileOperation(p,$,n,c){switch(p){case 2:return await this.n(this.g,{files:$.map(r=>({oldUri:I.URI.revive(r.source),newUri:I.URI.revive(r.target)}))},n,c);case 1:return await this.n(this.i,{files:$.map(r=>I.URI.revive(r.target))},n,c);case 0:case 3:return await this.n(this.h,{files:$.map(r=>I.URI.revive(r.target))},n,c)}}async n(p,$,n,c){const r=new Set,t=[];if(await p.fireAsync($,c,async(a,u)=>{const i=Date.now(),v=await Promise.resolve(a);v instanceof g.$vL&&(t.push([u.extension,v]),r.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-i>n&&this.k.warn("SLOW file-participant",u.extension.identifier)}),c.isCancellationRequested||t.length===0)return;const s={edits:[]};for(const[,a]of t){const{edits:u}=L.WorkspaceEdit.from(a,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(u)}return{edit:s,extensionNames:Array.from(r)}}}e.$hhc=D}),define(Re[257],Ae([1,0,2,26,8,7,87,3,13,29,18,16,298,21,22,6,96,89,75,63,15,11,24,160]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c,r,t,s,a,u,i,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;class o{constructor(F,H){this.d=F,this.e=H}async provideDocumentSymbols(F,H){const J=this.d.getDocument(F),B=await this.e.provideDocumentSymbols(J,H);if(!(0,A.$Kb)(B))return B[0]instanceof R.$EL?B.map(I.DocumentSymbol.from):o.f(B)}static f(F){F=F.slice(0).sort((B,Q)=>{let _=B.location.range.start.compareTo(Q.location.range.start);return _===0&&(_=Q.location.range.end.compareTo(B.location.range.end)),_});const H=[],J=[];for(const B of F){const Q={name:B.name||"!!MISSING: name!!",kind:I.SymbolKind.from(B.kind),tags:B.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:B.containerName,range:I.Range.from(B.location.range),selectionRange:I.Range.from(B.location.range),children:[]};for(;;){if(J.length===0){J.push(Q),H.push(Q);break}const _=J[J.length-1];if(E.$Ws.containsRange(_.range,Q.range)&&!E.$Ws.equalsRange(_.range,Q.range)){_.children?.push(Q),J.push(Q);break}J.pop()}}return H}}class w{constructor(F,H,J,B,Q,_){this.f=F,this.g=H,this.h=J,this.j=B,this.k=Q,this.l=_,this.d=new t.$2fc("CodeLens"),this.e=new Map}async provideCodeLenses(F,H){const J=this.f.getDocument(F),B=await this.h.provideCodeLenses(J,H);if(!B||H.isCancellationRequested)return;const Q=this.d.add(B),_=new n.$Sc;this.e.set(Q,_);const Ee={cacheId:Q,lenses:[]};for(let Ne=0;Ne<B.length;Ne++)Ee.lenses.push({cacheId:[Q,Ne],range:I.Range.from(B[Ne].range),command:this.g.toInternal(B[Ne].command,_)});return Ee}async resolveCodeLens(F,H){const J=F.cacheId&&this.d.get(...F.cacheId);if(!J)return;let B;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?B=J:B=await this.h.resolveCodeLens(J,H),B||(B=J),H.isCancellationRequested)return;const Q=F.cacheId&&this.e.get(F.cacheId[0]);if(Q){if(!B.command){const _=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,_),this.l.error(_);return}return F.command=this.g.toInternal(B.command,Q),F}}releaseCodeLenses(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}}function y(we){return Array.isArray(we)?we.map(I.DefinitionLink.from):we?[I.DefinitionLink.from(we)]:[]}class d{constructor(F,H){this.d=F,this.e=H}async provideDefinition(F,H,J){const B=this.d.getDocument(F),Q=I.Position.to(H),_=await this.e.provideDefinition(B,Q,J);return y(_)}}class b{constructor(F,H){this.d=F,this.e=H}async provideDeclaration(F,H,J){const B=this.d.getDocument(F),Q=I.Position.to(H),_=await this.e.provideDeclaration(B,Q,J);return y(_)}}class P{constructor(F,H){this.d=F,this.e=H}async provideImplementation(F,H,J){const B=this.d.getDocument(F),Q=I.Position.to(H),_=await this.e.provideImplementation(B,Q,J);return y(_)}}class f{constructor(F,H){this.d=F,this.e=H}async provideTypeDefinition(F,H,J){const B=this.d.getDocument(F),Q=I.Position.to(H),_=await this.e.provideTypeDefinition(B,Q,J);return y(_)}}class m{constructor(F,H){this.d=F,this.e=H}async provideHover(F,H,J){const B=this.d.getDocument(F),Q=I.Position.to(H),_=await this.e.provideHover(B,Q,J);if(!(!_||(0,A.$Kb)(_.contents)))return _.range||(_.range=B.getWordRangeAtPosition(Q)),_.range||(_.range=new R.$nL(Q,Q)),I.Hover.from(_)}}class k{constructor(F,H){this.d=F,this.e=H}async provideEvaluatableExpression(F,H,J){const B=this.d.getDocument(F),Q=I.Position.to(H),_=await this.e.provideEvaluatableExpression(B,Q,J);if(_)return I.EvaluatableExpression.from(_)}}class T{constructor(F,H){this.d=F,this.e=H}async provideInlineValues(F,H,J,B){const Q=this.d.getDocument(F),_=await this.e.provideInlineValues(Q,I.Range.to(H),I.InlineValueContext.to(J),B);if(Array.isArray(_))return _.map(Ee=>I.InlineValue.from(Ee))}}class O{constructor(F,H){this.d=F,this.e=H}async provideDocumentHighlights(F,H,J){const B=this.d.getDocument(F),Q=I.Position.to(H),_=await this.e.provideDocumentHighlights(B,Q,J);if(Array.isArray(_))return _.map(I.DocumentHighlight.from)}}class G{constructor(F,H){this.d=F,this.e=H}async provideMultiDocumentHighlights(F,H,J,B){const Q=this.d.getDocument(F),_=J.map(We=>this.d.getDocument(We)),Ee=I.Position.to(H),Ne=await this.e.provideMultiDocumentHighlights(Q,Ee,_,B);if(Array.isArray(Ne))return Ne.map(I.MultiDocumentHighlight.from)}}class q{constructor(F,H){this.d=F,this.e=H}async provideLinkedEditingRanges(F,H,J){const B=this.d.getDocument(F),Q=I.Position.to(H),_=await this.e.provideLinkedEditingRanges(B,Q,J);if(_&&Array.isArray(_.ranges))return{ranges:(0,A.$Hb)(_.ranges.map(I.Range.from)),wordPattern:_.wordPattern}}}class j{constructor(F,H){this.d=F,this.e=H}async provideReferences(F,H,J,B){const Q=this.d.getDocument(F),_=I.Position.to(H),Ee=await this.e.provideReferences(Q,_,J,B);if(Array.isArray(Ee))return Ee.map(I.location.from)}}class C{static{this.d=1e3}constructor(F,H,J,B,Q,_,Ee){this.g=F,this.h=H,this.j=J,this.k=B,this.l=Q,this.m=_,this.n=Ee,this.e=new t.$2fc("CodeAction"),this.f=new Map}async provideCodeActions(F,H,J,B){const Q=this.g.getDocument(F),_=l.$Ys.isISelection(H)?I.Selection.to(H):I.Range.to(H),Ee=[];for(const it of this.j.getDiagnostics(F))if(_.intersection(it.range)&&Ee.push(it)>C.d)break;const Ne={diagnostics:Ee,only:J.only?new R.$GL(J.only):void 0,triggerKind:I.CodeActionTriggerKind.to(J.trigger)},We=await this.k.provideCodeActions(Q,_,Ne,B);if(!(0,A.$Lb)(We)||B.isCancellationRequested)return;const Ke=this.e.add(We),Ye=new n.$Sc;this.f.set(Ke,Ye);const nt=[];for(let it=0;it<We.length;it++){const et=We[it];if(et)if(C.o(et))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,Ye)});else{Ne.only&&(et.kind?Ne.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const st=et.ranges??[];nt.push({cacheId:[Ke,it],title:et.title,command:et.command&&this.h.toInternal(et.command,Ye),diagnostics:et.diagnostics&&et.diagnostics.map(I.Diagnostic.from),edit:et.edit&&I.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,i.$KF)(this.m,"codeActionAI")?et.isAI:!1,ranges:(0,i.$KF)(this.m,"codeActionRanges")?(0,A.$Hb)(st.map(I.Range.from)):void 0,disabled:et.disabled?.reason})}}return{cacheId:Ke,actions:nt}}async resolveCodeAction(F,H){const[J,B]=F,Q=this.e.get(J,B);if(!Q||C.o(Q))return{};if(!this.k.resolveCodeAction)return{};const _=await this.k.resolveCodeAction(Q,H)??Q;let Ee;_.edit&&(Ee=I.WorkspaceEdit.from(_.edit,void 0));let Ne;if(_.command){const We=this.f.get(J);We&&(Ne=this.h.toInternal(_.command,We))}return{edit:Ee,command:Ne}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}class N{static toInternalProviderId(F,H){return F+"."+H}constructor(F,H,J,B,Q){this.d=F,this.e=H,this.f=J,this.g=B,this.h=Q}async prepareDocumentPaste(F,H,J,B){if(!this.f.prepareDocumentPaste)return;const Q=this.e.getDocument(F),_=H.map(We=>I.Range.to(We)),Ee=I.DataTransfer.toDataTransfer(J,()=>{throw new a.$$});if(await this.f.prepareDocumentPaste(Q,_,Ee,B),B.isCancellationRequested)return;const Ne=Array.from(Ee).filter(([,We])=>!(We instanceof R.$aM));return I.DataTransfer.from(Ne)}async providePasteEdits(F,H,J,B,Q){if(!this.f.provideDocumentPasteEdits)return;const _=this.e.getDocument(H),Ee=J.map(Ke=>I.Range.to(Ke)),Ne=I.DataTransfer.toDataTransfer(B,async Ke=>(await this.d.$resolvePasteFileData(this.g,F,Ke)).buffer),We=await this.f.provideDocumentPasteEdits(_,Ee,Ne,Q);if(We)return{label:We.label??(0,v.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(Ke=>"mimeType"in Ke?Ke:{providerId:N.toInternalProviderId(Ke.extensionId,Ke.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class W{constructor(F,H){this.d=F,this.e=H}async provideDocumentFormattingEdits(F,H,J){const B=this.d.getDocument(F),Q=await this.e.provideDocumentFormattingEdits(B,H,J);if(Array.isArray(Q))return Q.map(I.TextEdit.from)}}class se{constructor(F,H){this.d=F,this.e=H}async provideDocumentRangeFormattingEdits(F,H,J,B){const Q=this.d.getDocument(F),_=I.Range.to(H),Ee=await this.e.provideDocumentRangeFormattingEdits(Q,_,J,B);if(Array.isArray(Ee))return Ee.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,H,J,B){(0,D.$Tf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Q=this.d.getDocument(F),_=H.map(I.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(Q,_,J,B);if(Array.isArray(Ee))return Ee.map(I.TextEdit.from)}}class ue{constructor(F,H){this.d=F,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,H,J,B,Q){const _=this.d.getDocument(F),Ee=I.Position.to(H),Ne=await this.e.provideOnTypeFormattingEdits(_,Ee,J,B,Q);if(Array.isArray(Ne))return Ne.map(I.TextEdit.from)}}class ye{constructor(F,H){this.e=F,this.f=H,this.d=new t.$2fc("WorkspaceSymbols")}async provideWorkspaceSymbols(F,H){const J=await this.e.provideWorkspaceSymbols(F,H);if(!(0,A.$Lb)(J))return{symbols:[]};const B=this.d.add(J),Q={cacheId:B,symbols:[]};for(let _=0;_<J.length;_++){const Ee=J[_];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}Q.symbols.push({...I.WorkspaceSymbol.from(Ee),cacheId:[B,_]})}return Q}async resolveWorkspaceSymbol(F,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const J=this.d.get(...F.cacheId);if(J){const B=await this.e.resolveWorkspaceSymbol(J,H);return B&&(0,M.$Bn)(F,I.WorkspaceSymbol.from(B),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class ke{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,H,J){this.d=F,this.e=H,this.f=J}async provideRenameEdits(F,H,J,B){const Q=this.d.getDocument(F),_=I.Position.to(H);try{const Ee=await this.e.provideRenameEdits(Q,_,J,B);return Ee?I.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Ne=ke.g(Ee);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(F,H,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const B=this.d.getDocument(F),Q=I.Position.to(H);try{const _=await this.e.prepareRename(B,Q,J);let Ee,Ne;if(R.$nL.isRange(_)?(Ee=_,Ne=B.getText(_)):(0,D.$Lf)(_)&&(Ee=_.range,Ne=_.placeholder),!Ee||!Ne)return;if(Ee.start.line>Q.line||Ee.end.line<Q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Ee),text:Ne}}catch(_){const Ee=ke.g(_);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(_)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class ae{constructor(F,H){this.resultId=F,this.tokens=H}}class pe{constructor(F,H){this.f=F,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,H,J){const B=this.f.getDocument(F),Q=H!==0?this.d.get(H):null;let _=typeof Q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(B,Q.resultId,J):await this.g.provideDocumentSemanticTokens(B,J);return Q&&this.d.delete(H),_?(_=pe.h(_),this.o(pe.n(Q,_),_)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return pe.j(F)?pe.k(F)?F:new R.$DM(new Uint32Array(F.data),F.resultId):pe.l(F)?pe.m(F)?F:new R.$FM(F.edits.map(H=>new R.$EM(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const H of F.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(F,H){if(!pe.j(H)||!F||!F.tokens)return H;const J=F.tokens,B=J.length,Q=H.data,_=Q.length;let Ee=0;const Ne=Math.min(B,_);for(;Ee<Ne&&J[Ee]===Q[Ee];)Ee++;if(Ee===B&&Ee===_)return new R.$FM([],H.resultId);let We=0;const Ke=Ne-Ee;for(;We<Ke&&J[B-We-1]===Q[_-We-1];)We++;return new R.$FM([{start:Ee,deleteCount:B-Ee-We,data:Q.subarray(Ee,_-We)}],H.resultId)}o(F,H){if(pe.j(F)){const J=this.e++;return this.d.set(J,new ae(F.resultId,F.data)),(0,c.$N$)({id:J,type:"full",data:F.data})}if(pe.l(F)){const J=this.e++;return pe.j(H)?this.d.set(J,new ae(H.resultId,H.data)):this.d.set(J,new ae(F.resultId)),(0,c.$N$)({id:J,type:"delta",deltas:(F.edits||[]).map(B=>({start:B.start,deleteCount:B.deleteCount,data:B.data}))})}return null}}class oe{constructor(F,H){this.d=F,this.e=H}async provideDocumentRangeSemanticTokens(F,H,J){const B=this.d.getDocument(F),Q=await this.e.provideDocumentRangeSemanticTokens(B,I.Range.to(H),J);return Q?this.f(Q):null}f(F){return(0,c.$N$)({id:0,type:"full",data:F.data})}}class $e{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,H,J,B,Q){this.f=F,this.g=H,this.h=J,this.j=B,this.k=Q,this.d=new t.$2fc("CompletionItem"),this.e=new Map}async provideCompletionItems(F,H,J,B){const Q=this.f.getDocument(F),_=I.Position.to(H),Ee=Q.getWordRangeAtPosition(_)||new R.$nL(_,_),Ne=Ee.with({end:_}),We=new s.$Sd,Ke=await this.h.provideCompletionItems(Q,_,B,I.CompletionContext.to(J));if(!Ke||B.isCancellationRequested)return;const Ye=Array.isArray(Ke)?new R.$TL(Ke):Ke,nt=$e.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),it=new n.$Sc;this.e.set(nt,it);const et=[],st={x:nt,b:et,a:{replace:I.Range.from(Ee),insert:I.Range.from(Ne)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let ct=0;ct<Ye.items.length;ct++){const Ue=Ye.items[ct],mt=this.l(Ue,[nt,ct],Ne,Ee);et.push(mt)}return st}async resolveCompletionItem(F,H){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...F);if(!J)return;const B=this.l(J,F),Q=await this.h.resolveCompletionItem(J,H);if(!Q)return;const _=this.l(Q,F);return(B.h!==_.h||B.i!==_.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(B.n!==_.n||B.o!==_.o||!(0,M.$Cn)(B.p,_.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...B,d:_.d,c:_.c,l:_.l,h:_.h,i:_.i,n:_.n,o:_.o,p:_.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,H,J,B){const Q=this.e.get(H[0]);if(!Q)throw Error("DisposableStore is missing...");const _=this.g.toInternal(F.command,Q),Ee={x:H,a:F.label,b:F.kind!==void 0?I.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(I.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:I.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(I.TextEdit.from),n:_?.$ident,o:_?.id,p:_?.$ident?void 0:_?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=F.textEdit.newText):typeof F.insertText=="string"?Ee.h=F.insertText:F.insertText instanceof R.$wL&&(Ee.h=F.insertText.value,Ee.i|=4);let Ne;return F.textEdit?Ne=F.textEdit.range:F.range&&(Ne=F.range),R.$nL.isRange(Ne)?Ee.j=I.Range.from(Ne):Ne&&(!J?.isEqual(Ne.inserting)||!B?.isEqual(Ne.replacing))&&(Ee.j={insert:I.Range.from(Ne.inserting),replace:I.Range.from(Ne.replacing)}),Ee}}class ie{async provideInlineCompletions(F,H,J,B){}disposeCompletions(F){}handleDidShowCompletionItem(F,H,J){}handlePartialAccept(F,H,J){}}class x extends ie{constructor(F,H,J,B){super(),this.f=F,this.g=H,this.h=J,this.j=B,this.d=new V,this.e=(0,i.$KF)(this.f,"inlineCompletionsAdditions"),this.k={[L.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[L.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$KF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,H,J,B){const Q=this.g.getDocument(F),_=I.Position.to(H),Ee=await this.h.provideInlineCompletionItems(Q,_,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:I.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},B);if(!Ee||B.isCancellationRequested)return;const Ne=Array.isArray(Ee)?Ee:Ee.items,We=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],Ke=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:Ne}),items:Ne.map((it,et)=>{let st;it.command&&(Ye||(Ye=new n.$Sc),st=this.j.toInternal(it.command,Ye));const ct=it.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:it.filterText,range:it.range?I.Range.from(it.range):void 0,command:st,idx:et,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:We.map(it=>(Ye||(Ye=new n.$Sc),this.j.toInternal(it,Ye))),suppressSuggestions:!1,enableForwardStability:Ke}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,H,J){const B=this.d.get(F)?.items[H];B&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(B,J)}handlePartialAccept(F,H,J){const B=this.d.get(F)?.items[H];B&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(B,J)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const H=this.e++;return this.d.set(H,F),H}disposeReferenceId(F){const H=this.d.get(F);return this.d.delete(F),H}get(F){return this.d.get(F)}}class ne{constructor(F,H){this.e=F,this.f=H,this.d=new t.$2fc("SignatureHelp")}async provideSignatureHelp(F,H,J,B){const Q=this.e.getDocument(F),_=I.Position.to(H),Ee=this.g(J),Ne=await this.f.provideSignatureHelp(Q,_,B,Ee);if(Ne){const We=this.d.add([Ne]);return{...I.SignatureHelp.from(Ne),id:We}}}g(F){let H;if(F.activeSignatureHelp){const J=I.SignatureHelp.to(F.activeSignatureHelp),B=this.d.get(F.activeSignatureHelp.id,0);B?(H=B,H.activeSignature=J.activeSignature,H.activeParameter=J.activeParameter):H=J}return{...F,activeSignatureHelp:H}}releaseSignatureHelp(F){this.d.delete(F)}}class Ie{constructor(F,H,J,B,Q){this.f=F,this.g=H,this.h=J,this.j=B,this.k=Q,this.d=new t.$2fc("InlayHints"),this.e=new Map}async provideInlayHints(F,H,J){const B=this.f.getDocument(F),Q=I.Range.to(H),_=await this.h.provideInlayHints(B,Q,J);if(!Array.isArray(_)||_.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`);return}if(J.isCancellationRequested)return;const Ee=this.d.add(_);this.e.set(Ee,new n.$Sc);const Ne={hints:[],cacheId:Ee};for(let We=0;We<_.length;We++)this.l(_[We],Q)&&Ne.hints.push(this.m(_[We],[Ee,We]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`),Ne}async resolveInlayHint(F,H){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...F);if(!J)return;const B=await this.h.resolveInlayHint(J,H);if(B&&this.l(B))return this.m(B,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,H){return F.label.length===0||Array.isArray(F.label)&&F.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(H&&!H.contains(F.position))}m(F,H){const J=this.e.get(H[0]);if(!J)throw Error("DisposableStore is missing...");const B={label:"",cacheId:H,tooltip:I.MarkdownString.fromStrict(F.tooltip),position:I.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(I.TextEdit.from),kind:F.kind&&I.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};if(typeof F.label=="string")B.label=F.label;else{const Q=[];B.label=Q;for(const _ of F.label){if(!_.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:_.value,tooltip:I.MarkdownString.fromStrict(_.tooltip)};R.$xL.isLocation(_.location)&&(Ee.location=I.location.from(_.location)),_.command&&(Ee.command=this.g.toInternal(_.command,J)),Q.push(Ee)}}return B}}class Me{constructor(F,H){this.e=F,this.f=H,this.d=new t.$2fc("DocumentLink")}async provideLinks(F,H){const J=this.e.getDocument(F),B=await this.f.provideDocumentLinks(J,H);if(!(!Array.isArray(B)||B.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:B.filter(Me.g).map(I.DocumentLink.from)};{const Q=this.d.add(B),_={links:[],cacheId:Q};for(let Ee=0;Ee<B.length;Ee++){if(!Me.g(B[Ee]))continue;const Ne=I.DocumentLink.from(B[Ee]);Ne.cacheId=[Q,Ee],_.links.push(Ne)}return _}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,H){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...F);if(!J)return;const B=await this.f.resolveDocumentLink(J,H);if(!(!B||!Me.g(B)))return I.DocumentLink.from(B)}releaseLinks(F){this.d.delete(F)}}class Le{constructor(F,H){this.d=F,this.e=H}async provideColors(F,H){const J=this.d.getDocument(F),B=await this.e.provideDocumentColors(J,H);return Array.isArray(B)?B.map(_=>({color:I.Color.from(_.color),range:I.Range.from(_.range)})):[]}async provideColorPresentations(F,H,J){const B=this.d.getDocument(F),Q=I.Range.to(H.range),_=I.Color.to(H.color),Ee=await this.e.provideColorPresentations(_,{document:B,range:Q},J);if(Array.isArray(Ee))return Ee.map(I.ColorPresentation.from)}}class be{constructor(F,H){this.d=F,this.e=H}async provideFoldingRanges(F,H,J){const B=this.d.getDocument(F),Q=await this.e.provideFoldingRanges(B,H,J);if(Array.isArray(Q))return Q.map(I.FoldingRange.from)}}class ge{constructor(F,H,J){this.d=F,this.e=H,this.f=J}async provideSelectionRanges(F,H,J){const B=this.d.getDocument(F),Q=H.map(I.Position.to),_=await this.e.provideSelectionRanges(B,Q,J);if(!(0,A.$Lb)(_))return[];if(_.length!==Q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Ne=0;Ne<Q.length;Ne++){const We=[];Ee.push(We);let Ke=Q[Ne],Ye=_[Ne];for(;;){if(!Ye.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(We.push(I.SelectionRange.from(Ye)),!Ye.parent)break;Ke=Ye.range,Ye=Ye.parent}}return Ee}}class K{constructor(F,H){this.f=F,this.g=H,this.d=new r.$tN(""),this.e=new Map}async prepareSession(F,H,J){const B=this.f.getDocument(F),Q=I.Position.to(H),_=await this.g.prepareCallHierarchy(B,Q,J);if(!_)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(_)?_.map(Ne=>this.h(Ee,Ne)):[this.h(Ee,_)]}async provideCallsTo(F,H,J){const B=this.j(F,H);if(!B)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyIncomingCalls(B,J);if(Q)return Q.map(_=>({from:this.h(F,_.from),fromRanges:_.fromRanges.map(Ee=>I.Range.from(Ee))}))}async provideCallsFrom(F,H,J){const B=this.j(F,H);if(!B)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyOutgoingCalls(B,J);if(Q)return Q.map(_=>({to:this.h(F,_.to),fromRanges:_.fromRanges.map(Ee=>I.Range.from(Ee))}))}releaseSession(F){this.e.delete(F)}h(F,H){const J=this.e.get(F),B=I.CallHierarchyItem.from(H,F,J.size.toString(36));return J.set(B._itemId,H),B}j(F,H){return this.e.get(F)?.get(H)}}class ee{constructor(F,H){this.f=F,this.g=H,this.d=new r.$tN(""),this.e=new Map}async prepareSession(F,H,J){const B=this.f.getDocument(F),Q=I.Position.to(H),_=await this.g.prepareTypeHierarchy(B,Q,J);if(!_)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(_)?_.map(Ne=>this.h(Ee,Ne)):[this.h(Ee,_)]}async provideSupertypes(F,H,J){const B=this.j(F,H);if(!B)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySupertypes(B,J);if(Q)return Q.map(_=>this.h(F,_))}async provideSubtypes(F,H,J){const B=this.j(F,H);if(!B)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySubtypes(B,J);if(Q)return Q.map(_=>this.h(F,_))}releaseSession(F){this.e.delete(F)}h(F,H){const J=this.e.get(F),B=I.TypeHierarchyItem.from(H,F,J.size.toString(36));return J.set(B._itemId,H),B}j(F,H){return this.e.get(F)?.get(H)}}class le{static toInternalProviderId(F,H){return F+"."+H}constructor(F,H,J,B,Q){this.d=F,this.e=H,this.f=J,this.g=B,this.h=Q}async provideDocumentOnDropEdits(F,H,J,B,Q){const _=this.e.getDocument(H),Ee=I.Position.to(J),Ne=I.DataTransfer.toDataTransfer(B,async Ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Ke)).buffer),We=await this.f.provideDocumentDropEdits(_,Ee,Ne,Q);if(We)return{label:We.label??(0,v.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(Ke=>"mimeType"in Ke?Ke:{providerId:le.toInternalProviderId(Ke.extensionId,Ke.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class fe{constructor(F,H){this.d=F,this.e=H}async provideMappedEdits(F,H,J,B){const Q=S.URI.revive(F),_=this.d.getDocument(Q),Ee=J.documents.map(Ke=>Ke.map(Ye=>({uri:S.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(nt=>I.Range.to(nt))}))),Ne={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(_,H,Ne,B);return We?I.WorkspaceEdit.from(We):null}}class Ce{constructor(F,H){this.adapter=F,this.extension=H}}class de{static{this.d=0}constructor(F,H,J,B,Q,_,Ee,Ne){this.g=H,this.h=J,this.j=B,this.k=Q,this.l=_,this.m=Ee,this.n=Ne,this.f=new Map,this.e=F.getProxy(g.$jL.MainThreadLanguageFeatures)}o(F,H){return I.DocumentSelector.from(F,this.g,H)}p(F){return new R.$lL(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return de.d++}async s(F,H,J,B,Q,_=!1){const Ee=this.f.get(F);if(!Ee||!(Ee.adapter instanceof H))return B;const Ne=Date.now();_||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const We=J(Ee.adapter,Ee.extension);return Promise.resolve(We).catch(Ke=>{(0,a.$4)(Ke)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(Ke),this.n.onExtensionError(Ee.extension.identifier,Ke))}).finally(()=>{_||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),p.CancellationToken.isCancellationToken(Q)?(0,u.$Wg)(We,Q):We}t(F,H){const J=this.q();return this.f.set(J,new Ce(F,H)),J}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,H,J,B){const Q=this.t(new o(this.h,J),F),_=B&&B.label||de.u(F);return this.e.$registerDocumentSymbolProvider(Q,this.o(H,F),_),this.p(Q)}$provideDocumentSymbols(F,H,J){return this.s(F,o,B=>B.provideDocumentSymbols(S.URI.revive(H),J),void 0,J)}registerCodeLensProvider(F,H,J){const B=this.q(),Q=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(B,new Ce(new w(this.h,this.j.converter,J,F,this.n,this.l),F)),this.e.$registerCodeLensSupport(B,this.o(H,F),Q);let _=this.p(B);if(Q!==void 0){const Ee=J.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(Q));_=R.$lL.from(_,Ee)}return _}$provideCodeLenses(F,H,J){return this.s(F,w,B=>B.provideCodeLenses(S.URI.revive(H),J),void 0,J)}$resolveCodeLens(F,H,J){return this.s(F,w,B=>B.resolveCodeLens(H,J),void 0,void 0)}$releaseCodeLenses(F,H){this.s(F,w,J=>Promise.resolve(J.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(F,H,J){const B=this.t(new d(this.h,J),F);return this.e.$registerDefinitionSupport(B,this.o(H,F)),this.p(B)}$provideDefinition(F,H,J,B){return this.s(F,d,Q=>Q.provideDefinition(S.URI.revive(H),J,B),[],B)}registerDeclarationProvider(F,H,J){const B=this.t(new b(this.h,J),F);return this.e.$registerDeclarationSupport(B,this.o(H,F)),this.p(B)}$provideDeclaration(F,H,J,B){return this.s(F,b,Q=>Q.provideDeclaration(S.URI.revive(H),J,B),[],B)}registerImplementationProvider(F,H,J){const B=this.t(new P(this.h,J),F);return this.e.$registerImplementationSupport(B,this.o(H,F)),this.p(B)}$provideImplementation(F,H,J,B){return this.s(F,P,Q=>Q.provideImplementation(S.URI.revive(H),J,B),[],B)}registerTypeDefinitionProvider(F,H,J){const B=this.t(new f(this.h,J),F);return this.e.$registerTypeDefinitionSupport(B,this.o(H,F)),this.p(B)}$provideTypeDefinition(F,H,J,B){return this.s(F,f,Q=>Q.provideTypeDefinition(S.URI.revive(H),J,B),[],B)}registerHoverProvider(F,H,J,B){const Q=this.t(new m(this.h,J),F);return this.e.$registerHoverProvider(Q,this.o(H,F)),this.p(Q)}$provideHover(F,H,J,B){return this.s(F,m,Q=>Q.provideHover(S.URI.revive(H),J,B),void 0,B)}registerEvaluatableExpressionProvider(F,H,J,B){const Q=this.t(new k(this.h,J),F);return this.e.$registerEvaluatableExpressionProvider(Q,this.o(H,F)),this.p(Q)}$provideEvaluatableExpression(F,H,J,B){return this.s(F,k,Q=>Q.provideEvaluatableExpression(S.URI.revive(H),J,B),void 0,B)}registerInlineValuesProvider(F,H,J,B){const Q=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,_=this.t(new T(this.h,J),F);this.e.$registerInlineValuesProvider(_,this.o(H,F),Q);let Ee=this.p(_);if(Q!==void 0){const Ne=J.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Q));Ee=R.$lL.from(Ee,Ne)}return Ee}$provideInlineValues(F,H,J,B,Q){return this.s(F,T,_=>_.provideInlineValues(S.URI.revive(H),J,B,Q),void 0,Q)}registerDocumentHighlightProvider(F,H,J){const B=this.t(new O(this.h,J),F);return this.e.$registerDocumentHighlightProvider(B,this.o(H,F)),this.p(B)}registerMultiDocumentHighlightProvider(F,H,J){const B=this.t(new G(this.h,J),F);return this.e.$registerMultiDocumentHighlightProvider(B,this.o(H,F)),this.p(B)}$provideDocumentHighlights(F,H,J,B){return this.s(F,O,Q=>Q.provideDocumentHighlights(S.URI.revive(H),J,B),void 0,B)}$provideMultiDocumentHighlights(F,H,J,B,Q){return this.s(F,G,_=>_.provideMultiDocumentHighlights(S.URI.revive(H),J,B.map(Ee=>S.URI.revive(Ee)),Q),void 0,Q)}registerLinkedEditingRangeProvider(F,H,J){const B=this.t(new q(this.h,J),F);return this.e.$registerLinkedEditingRangeProvider(B,this.o(H,F)),this.p(B)}$provideLinkedEditingRanges(F,H,J,B){return this.s(F,q,async Q=>{const _=await Q.provideLinkedEditingRanges(S.URI.revive(H),J,B);if(_)return{ranges:_.ranges,wordPattern:_.wordPattern?de.w(_.wordPattern):void 0}},void 0,B)}registerReferenceProvider(F,H,J){const B=this.t(new j(this.h,J),F);return this.e.$registerReferenceSupport(B,this.o(H,F)),this.p(B)}$provideReferences(F,H,J,B,Q){return this.s(F,j,_=>_.provideReferences(S.URI.revive(H),J,B,Q),void 0,Q)}registerCodeActionProvider(F,H,J,B){const Q=new n.$Sc,_=this.t(new C(this.h,this.j.converter,this.k,J,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(_,this.o(H,F),{providedKinds:B?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:B?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,Q)}))},de.u(F),!!J.resolveCodeAction),Q.add(this.p(_)),Q}$provideCodeActions(F,H,J,B,Q){return this.s(F,C,_=>_.provideCodeActions(S.URI.revive(H),J,B,Q),void 0,Q)}$resolveCodeAction(F,H,J){return this.s(F,C,B=>B.resolveCodeAction(H,J),{},void 0)}$releaseCodeActions(F,H){this.s(F,C,J=>Promise.resolve(J.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(F,H,J){const B=this.t(new W(this.h,J),F);return this.e.$registerDocumentFormattingSupport(B,this.o(H,F),F.identifier,F.displayName||F.name),this.p(B)}$provideDocumentFormattingEdits(F,H,J,B){return this.s(F,W,Q=>Q.provideDocumentFormattingEdits(S.URI.revive(H),J,B),void 0,B)}registerDocumentRangeFormattingEditProvider(F,H,J){const B=typeof J.provideDocumentRangesFormattingEdits=="function",Q=this.t(new se(this.h,J),F);return this.e.$registerRangeFormattingSupport(Q,this.o(H,F),F.identifier,F.displayName||F.name,B),this.p(Q)}$provideDocumentRangeFormattingEdits(F,H,J,B,Q){return this.s(F,se,_=>_.provideDocumentRangeFormattingEdits(S.URI.revive(H),J,B,Q),void 0,Q)}$provideDocumentRangesFormattingEdits(F,H,J,B,Q){return this.s(F,se,_=>_.provideDocumentRangesFormattingEdits(S.URI.revive(H),J,B,Q),void 0,Q)}registerOnTypeFormattingEditProvider(F,H,J,B){const Q=this.t(new ue(this.h,J),F);return this.e.$registerOnTypeFormattingSupport(Q,this.o(H,F),B,F.identifier),this.p(Q)}$provideOnTypeFormattingEdits(F,H,J,B,Q,_){return this.s(F,ue,Ee=>Ee.provideOnTypeFormattingEdits(S.URI.revive(H),J,B,Q,_),void 0,_)}registerWorkspaceSymbolProvider(F,H){const J=this.t(new ye(H,this.l),F);return this.e.$registerNavigateTypeSupport(J,typeof H.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(F,H,J){return this.s(F,ye,B=>B.provideWorkspaceSymbols(H,J),{symbols:[]},J)}$resolveWorkspaceSymbol(F,H,J){return this.s(F,ye,B=>B.resolveWorkspaceSymbol(H,J),void 0,void 0)}$releaseWorkspaceSymbols(F,H){this.s(F,ye,J=>J.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(F,H,J){const B=this.t(new ke(this.h,J,this.l),F);return this.e.$registerRenameSupport(B,this.o(H,F),ke.supportsResolving(J)),this.p(B)}$provideRenameEdits(F,H,J,B,Q){return this.s(F,ke,_=>_.provideRenameEdits(S.URI.revive(H),J,B,Q),void 0,Q)}$resolveRenameLocation(F,H,J,B){return this.s(F,ke,Q=>Q.resolveRenameLocation(S.URI.revive(H),J,B),void 0,B)}registerDocumentSemanticTokensProvider(F,H,J,B){const Q=this.t(new pe(this.h,J),F),_=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Q,this.o(H,F),B,_);let Ee=this.p(Q);if(_){const Ne=J.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(_));Ee=R.$lL.from(Ee,Ne)}return Ee}$provideDocumentSemanticTokens(F,H,J,B){return this.s(F,pe,Q=>Q.provideDocumentSemanticTokens(S.URI.revive(H),J,B),null,B)}$releaseDocumentSemanticTokens(F,H){this.s(F,pe,J=>J.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,H,J,B){const Q=this.t(new oe(this.h,J),F);return this.e.$registerDocumentRangeSemanticTokensProvider(Q,this.o(H,F),B),this.p(Q)}$provideDocumentRangeSemanticTokens(F,H,J,B){return this.s(F,oe,Q=>Q.provideDocumentRangeSemanticTokens(S.URI.revive(H),J,B),null,B)}registerCompletionItemProvider(F,H,J,B){const Q=this.t(new $e(this.h,this.j.converter,J,this.m,F),F);return this.e.$registerCompletionsProvider(Q,this.o(H,F),B,$e.supportsResolving(J),F.identifier),this.p(Q)}$provideCompletionItems(F,H,J,B,Q){return this.s(F,$e,_=>_.provideCompletionItems(S.URI.revive(H),J,B,Q),void 0,Q)}$resolveCompletionItem(F,H,J){return this.s(F,$e,B=>B.resolveCompletionItem(H,J),void 0,J)}$releaseCompletionItems(F,H){this.s(F,$e,J=>J.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(F,H,J,B){const Q=new x(F,this.h,J,this.j.converter),_=this.t(Q,F);return this.e.$registerInlineCompletionsSupport(_,this.o(H,F),Q.supportsHandleEvents,$.$nm.toKey(F.identifier.value),B?.yieldTo?.map(Ee=>$.$nm.toKey(Ee))||[]),this.p(_)}$provideInlineCompletions(F,H,J,B,Q){return this.s(F,ie,_=>_.provideInlineCompletions(S.URI.revive(H),J,B,Q),void 0,Q)}$handleInlineCompletionDidShow(F,H,J,B){this.s(F,ie,async Q=>{Q.handleDidShowCompletionItem(H,J,B)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,H,J,B){this.s(F,ie,async Q=>{Q.handlePartialAccept(H,J,B)},void 0,void 0)}$freeInlineCompletionsList(F,H){this.s(F,ie,async J=>{J.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(F,H,J,B){const Q=Array.isArray(B)?{triggerCharacters:B,retriggerCharacters:[]}:B,_=this.t(new ne(this.h,J),F);return this.e.$registerSignatureHelpProvider(_,this.o(H,F),Q),this.p(_)}$provideSignatureHelp(F,H,J,B,Q){return this.s(F,ne,_=>_.provideSignatureHelp(S.URI.revive(H),J,B,Q),void 0,Q)}$releaseSignatureHelp(F,H){this.s(F,ne,J=>J.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(F,H,J){const B=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,Q=this.t(new Ie(this.h,this.j.converter,J,this.l,F),F);this.e.$registerInlayHintsProvider(Q,this.o(H,F),typeof J.resolveInlayHint=="function",B,de.u(F));let _=this.p(Q);if(B!==void 0){const Ee=J.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(B));_=R.$lL.from(_,Ee)}return _}$provideInlayHints(F,H,J,B){return this.s(F,Ie,Q=>Q.provideInlayHints(S.URI.revive(H),J,B),void 0,B)}$resolveInlayHint(F,H,J){return this.s(F,Ie,B=>B.resolveInlayHint(H,J),void 0,J)}$releaseInlayHints(F,H){this.s(F,Ie,J=>J.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(F,H,J){const B=this.t(new Me(this.h,J),F);return this.e.$registerDocumentLinkProvider(B,this.o(H,F),typeof J.resolveDocumentLink=="function"),this.p(B)}$provideDocumentLinks(F,H,J){return this.s(F,Me,B=>B.provideLinks(S.URI.revive(H),J),void 0,J,H.scheme==="output")}$resolveDocumentLink(F,H,J){return this.s(F,Me,B=>B.resolveLink(H,J),void 0,void 0,!0)}$releaseDocumentLinks(F,H){this.s(F,Me,J=>J.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(F,H,J){const B=this.t(new Le(this.h,J),F);return this.e.$registerDocumentColorProvider(B,this.o(H,F)),this.p(B)}$provideDocumentColors(F,H,J){return this.s(F,Le,B=>B.provideColors(S.URI.revive(H),J),[],J)}$provideColorPresentations(F,H,J,B){return this.s(F,Le,Q=>Q.provideColorPresentations(S.URI.revive(H),J,B),void 0,B)}registerFoldingRangeProvider(F,H,J){const B=this.q(),Q=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(B,new Ce(new be(this.h,J),F)),this.e.$registerFoldingRangeProvider(B,this.o(H,F),F.identifier,Q);let _=this.p(B);if(Q!==void 0){const Ee=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Q));_=R.$lL.from(_,Ee)}return _}$provideFoldingRanges(F,H,J,B){return this.s(F,be,Q=>Q.provideFoldingRanges(S.URI.revive(H),J,B),void 0,B)}registerSelectionRangeProvider(F,H,J){const B=this.t(new ge(this.h,J,this.l),F);return this.e.$registerSelectionRangeProvider(B,this.o(H,F)),this.p(B)}$provideSelectionRanges(F,H,J,B){return this.s(F,ge,Q=>Q.provideSelectionRanges(S.URI.revive(H),J,B),[],B)}registerCallHierarchyProvider(F,H,J){const B=this.t(new K(this.h,J),F);return this.e.$registerCallHierarchyProvider(B,this.o(H,F)),this.p(B)}$prepareCallHierarchy(F,H,J,B){return this.s(F,K,Q=>Promise.resolve(Q.prepareSession(S.URI.revive(H),J,B)),void 0,B)}$provideCallHierarchyIncomingCalls(F,H,J,B){return this.s(F,K,Q=>Q.provideCallsTo(H,J,B),void 0,B)}$provideCallHierarchyOutgoingCalls(F,H,J,B){return this.s(F,K,Q=>Q.provideCallsFrom(H,J,B),void 0,B)}$releaseCallHierarchy(F,H){this.s(F,K,J=>Promise.resolve(J.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(F,H,J){const B=this.t(new ee(this.h,J),F);return this.e.$registerTypeHierarchyProvider(B,this.o(H,F)),this.p(B)}$prepareTypeHierarchy(F,H,J,B){return this.s(F,ee,Q=>Promise.resolve(Q.prepareSession(S.URI.revive(H),J,B)),void 0,B)}$provideTypeHierarchySupertypes(F,H,J,B){return this.s(F,ee,Q=>Q.provideSupertypes(H,J,B),void 0,B)}$provideTypeHierarchySubtypes(F,H,J,B){return this.s(F,ee,Q=>Q.provideSubtypes(H,J,B),void 0,B)}$releaseTypeHierarchy(F,H){this.s(F,ee,J=>Promise.resolve(J.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(F,H,J,B){const Q=this.q();this.f.set(Q,new Ce(new le(this.e,this.h,J,Q,F),F));const _=(0,i.$KF)(F,"dropMetadata")&&B?le.toInternalProviderId(F.identifier.value,B.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Q,this.o(H,F),_,(0,i.$KF)(F,"dropMetadata")?B:void 0),this.p(Q)}$provideDocumentOnDropEdits(F,H,J,B,Q,_){return this.s(F,le,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(H,S.URI.revive(J),B,Q,_)),void 0,void 0)}registerMappedEditsProvider(F,H,J){const B=this.t(new fe(this.h,J),F);return this.e.$registerMappedEditsProvider(B,this.o(H,F)),this.p(B)}$provideMappedEdits(F,H,J,B,Q){return this.s(F,fe,_=>Promise.resolve(_.provideMappedEdits(H,J,B,Q)),null,Q)}registerDocumentPasteEditProvider(F,H,J,B){const Q=this.q();this.f.set(Q,new Ce(new N(this.e,this.h,J,Q,F),F));const _=N.toInternalProviderId(F.identifier.value,B.id);return this.e.$registerPasteEditProvider(Q,this.o(H,F),_,{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,copyMimeTypes:B.copyMimeTypes,pasteMimeTypes:B.pasteMimeTypes}),this.p(Q)}$prepareDocumentPaste(F,H,J,B,Q){return this.s(F,N,_=>_.prepareDocumentPaste(S.URI.revive(H),J,B,Q),void 0,Q)}$providePasteEdits(F,H,J,B,Q,_){return this.s(F,N,Ee=>Ee.providePasteEdits(H,S.URI.revive(J),B,Q,_),void 0,_)}static w(F){return{pattern:F.source,flags:F.flags}}static y(F){return{decreaseIndentPattern:de.w(F.decreaseIndentPattern),increaseIndentPattern:de.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?de.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?de.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:de.w(F.beforeText),afterText:F.afterText?de.w(F.afterText):void 0,previousLineText:F.previousLineText?de.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(de.z)}static C(F){return{open:F.open,close:F.close,notIn:F.notIn?F.notIn.map(H=>R.SyntaxTokenType.toString(H)):void 0}}static D(F){return F.map(de.C)}setLanguageConfiguration(F,H,J){const{wordPattern:B}=J;if(B&&(0,h.$Ze)(B))throw new Error(`Invalid language configuration: wordPattern '${B}' is not allowed to match the empty string.`);B?this.h.setWordDefinitionFor(H,B):this.h.setWordDefinitionFor(H,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const Q=this.q(),_={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?de.w(J.wordPattern):void 0,indentationRules:J.indentationRules?de.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?de.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?de.D(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Q,H,_),this.p(Q)}$setWordDefinitions(F){for(const H of F)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.$_fc=de}),define(Re[258],Ae([1,0,3,8,7,32,11,6,24]),function(me,e,S,M,I,R,L,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=void 0;class E{constructor(D,l,p,$){this.c=l,this.d=p,this.e=$,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(S.$jL.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,l){await this.a.$changeLanguage(D,l);const p=this.c.getDocumentData(D);if(!p)throw new Error(`document '${D.toString()}' NOT found`);return p.document}async tokenAtPosition(D,l){const p=D.version,$=M.Position.from(l),n=await this.a.$tokensAtPosition(D.uri,$),c={type:I.StandardTokenType.Other,range:D.getWordRangeAtPosition(l)??new I.$nL(l.line,l.character,l.line,l.character)};if(!n)return c;const r={range:M.Range.to(n.range),type:M.TokenType.to(n.type)};return!r.range.contains(l)||p!==D.version?c:r}createLanguageStatusItem(D,l,p){const $=this.f++,n=this.a,c=this.g,r=`${D.identifier.value}/${l}`;if(c.has(r))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);c.add(r);const t={selector:p,id:l,name:D.displayName??D.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let s;const a=new g.$Sc,u=()=>{if(s?.dispose(),!c.has(r)){console.warn(`LanguageStatusItem (${l}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}s=(0,L.$0g)(()=>{a.clear(),this.a.$setLanguageStatus($,{id:r,name:t.name??D.displayName??D.name,source:D.displayName??D.name,selector:M.DocumentSelector.from(t.selector,this.e),label:t.text,detail:t.detail??"",severity:t.severity===I.LanguageStatusSeverity.Error?R.default.Error:t.severity===I.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:t.command&&this.d.toInternal(t.command,a),accessibilityInfo:t.accessibilityInformation,busy:t.busy})},0)},i={dispose(){a.dispose(),s?.dispose(),n.$removeLanguageStatus($),c.delete(r)},get id(){return t.id},get name(){return t.name},set name(v){t.name=v,u()},get selector(){return t.selector},set selector(v){t.selector=v,u()},get text(){return t.text},set text(v){t.text=v,u()},set text2(v){(0,h.$LF)(D,"languageStatusText"),t.text=v,u()},get text2(){return(0,h.$LF)(D,"languageStatusText"),t.text},get detail(){return t.detail},set detail(v){t.detail=v,u()},get severity(){return t.severity},set severity(v){t.severity=v,u()},get accessibilityInformation(){return t.accessibilityInformation},set accessibilityInformation(v){t.accessibilityInformation=v,u()},get command(){return t.command},set command(v){t.command=v,u()},get busy(){return t.busy},set busy(v){t.busy=v,u()}};return u(),i}}e.$yhc=E}),define(Re[259],Ae([1,0,12,2,8,7,84]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=void 0;class g{constructor(D,l,p,$){this.start=D,this.deletedCount=l,this.deletedItems=p,this.items=$}asApiEvent(){return{range:new R.$KM(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class h{static asModelAddData(D,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,l,p){this.notebook=D,this.h=l,this.j=p,this.handle=p.handle,this.uri=M.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(I.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return D.g},set mime($){D.g=$},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(p)}return this.f}setOutputs(D){this.a=D.map(I.NotebookCellOutput.to)}setOutputItems(D,l,p){const $=p.map(I.NotebookCellOutputItem.to),n=this.a.find(c=>c.id===D);if(n&&(l||(n.items.length=0),n.items.push(...$),n.items.length>1&&n.items.every(c=>L.$mJ(c.mime)))){const c=new Map,r=[];n.items.forEach(t=>{let s;c.has(t.mime)?s=c.get(t.mime):(s=[],c.set(t.mime,s),r.push(t.mime)),s.push(t.data)}),n.items.length=0,r.forEach(t=>{const s=L.$nJ(c.get(t));n.items.push({mime:t,data:s.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$jhc=h;class E{static{this.a=0}constructor(D,l,p,$,n){this.k=D,this.l=l,this.m=p,this.uri=$,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,l={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===S.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(p){return p=D.n(p),D.b[p].apiCell},getCells(p){return(p?D.p(p):D.b).map(n=>n.apiCell)},save(){return D.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,l,p){this.g=D.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:p});const $={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},n=[];for(const r of D.rawEvents)r.kind===L.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,$.contentChanges):r.kind===L.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,$.contentChanges):r.kind===L.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),n.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===L.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),n.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),n.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===L.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),n.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),n.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const c=new Map;for(let r=0;r<n.length;r++){const t=n[r],s=c.get(t.cell);if(s===void 0){const a=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...t});c.set(t.cell,a-1)}else $.cellChanges[s]={...$.cellChanges[s],...t}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let l=D.start|0,p=D.end|0;return l<0&&(l=0),p>this.b.length&&(p=this.b.length),D.with({start:l,end:p})}p(D){D=this.o(D);const l=[];for(let p=D.start;p<D.end;p++)l.push(this.b[p]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,l,p){if(this.j)return;const $=[],n=[],c=[];if(D.reverse().forEach(r=>{const s=r[2].map(i=>{const v=new h(this,this.l,i);return l||n.push(h.asModelAddData(this.apiNotebook,i)),v}),a=new g(r[0],r[1],[],s),u=this.b.splice(r[0],r[1],...s);for(const i of u)c.push(i.uri),a.deletedItems.push(i.apiCell);$.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:c}),p)for(const r of $)p.push(r.asApiEvent())}s(D,l,p,$){const n=this.b.splice(D,l);this.b.splice(p,0,...n);const c=[new g(D,l,n.map(r=>r.apiCell),[]),new g(p,0,[],n)];for(const r of c)$.push(r.asApiEvent())}t(D,l){this.b[D].setOutputs(l)}u(D,l,p,$){this.b[D].setOutputItems(l,p,$)}v(D,l){const p=this.b[D];p.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(p.uri,l)}w(D,l){const p=this.b[D];p.apiCell.mime=l}x(D,l){this.b[D].setMetadata(l)}y(D,l){this.b[D].setInternalMetadata(l)}getCellFromApiCell(D){return this.b.find(l=>l.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(l=>l.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$khc=E}),define(Re[260],Ae([1,0,5,2,8,7]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;class L{constructor(h,E,A,D={timeout:1500,errors:3}){this.b=h,this.c=E,this.d=A,this.f=D,this.a=new S.$Yd}dispose(){}getOnWillSaveNotebookDocumentEvent(h){return(E,A,D)=>{const l=function($){E.call(A,$)};return l.extension=h,this.a.event(l,void 0,D)}}async $participateInSave(h,E,A){const D=M.URI.revive(h),l=this.c.getNotebookDocument(D);if(!l)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:I.TextDocumentSaveReason.to(E)},A,async(n,c)=>{const r=Date.now(),t=await await Promise.resolve(n);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!A.isCancellationRequested&&t&&(t instanceof R.$vL?p.push(t):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(p.length===0)return!0;const $={edits:[]};for(const n of p){const{edits:c}=I.WorkspaceEdit.from(n);$.edits=$.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit($)}}e.$Ahc=L}),define(Re[109],Ae([1,0,15,8,7]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(g,h,E,A,D,l){this.id=g,this.f=h,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=A,this.c=l}get apiEditor(){if(!this.e){const g=this;this.e={get notebook(){return g.notebookData.apiNotebook},get selection(){return g.a[0]},set selection(h){this.selections=[h]},get selections(){return g.a},set selections(h){if(!Array.isArray(h)||!h.every(I.$KM.isNotebookRange))throw(0,S.$7)("selections");g.a=h,g.g(h)},get visibleRanges(){return g.b},revealRange(h,E){g.f.$tryRevealRange(g.id,M.NotebookRange.from(h),E??I.NotebookEditorRevealType.Default)},get viewColumn(){return g.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(g){this.d=g}_acceptVisibleRanges(g){this.b=g}_acceptSelections(g){this.a=g}g(g){this.f.$trySetSelections(this.id,g.map(M.NotebookRange.from))}_acceptViewColumn(g){this.c=g}}e.$lhc=R}),define(Re[261],Ae([1,0,5,14,8]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;let R=class{constructor(g,h){this.c=g,this.d=h,this.a=new S.$Wd,this.b=new S.$Wd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(g,h){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,h);const E=this.d.getEditorById(g);h.visibleRanges&&E._acceptVisibleRanges(h.visibleRanges.ranges.map(I.NotebookRange.to)),h.selections&&E._acceptSelections(h.selections.selections.map(I.NotebookRange.to)),h.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),h.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(g){for(const h in g)this.d.getEditorById(h)._acceptViewColumn(I.ViewColumn.to(g[h]))}};e.$Chc=R,e.$Chc=R=Je([qe(0,M.$pj)],R)}),define(Re[262],Ae([1,0,5,3,109]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;class R{constructor(g,h){this.c=h,this.a=new Map,this.b=g.getProxy(M.$jL.MainThreadNotebookRenderers)}$postRendererMessage(g,h,E){const A=this.c.getEditorById(g);this.a.get(h)?.fire({editor:A.apiEditor,message:E})}createRendererMessaging(g,h){if(!g.contributes?.notebookRenderer?.some(A=>A.id===h))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${h})`);return{onDidReceiveMessage:(A,D,l)=>this.d(h).event(A,D,l),postMessage:(A,D)=>{I.$lhc.apiEditorsToExtHost.has(A)&&([A,D]=[D,A]);const l=D&&I.$lhc.apiEditorsToExtHost.get(D);return this.b.$postMessage(l?.id,h,A)}}}d(g){let h=this.a.get(g);return h||(h=new S.$Wd({onDidRemoveLastListener:()=>{h?.dispose(),this.a.delete(g)}}),this.a.set(g,h),h)}}e.$Fhc=R}),define(Re[263],Ae([1,0,8,72,21,67,15]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=void 0;class g{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,l,p){const $=this.b++,{title:n,location:c,cancellable:r}=l,t={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress($,{location:S.ProgressLocation.from(c),title:n,source:t,cancellable:r},D.isUnderDevelopment?void 0:D.identifier.value).catch(L.$2),this.d($,p,!!r)}d(D,l,p){let $;p&&($=new I.$7d,this.c.set(D,$));const n=r=>{this.a.$progressEnd(r),this.c.delete(r),$?.dispose()};let c;try{c=l(new E(this.a,D),p&&$?$.token:I.CancellationToken.None)}catch(r){throw n(D),r}return c.then(r=>n(D),r=>n(D)),c}$acceptProgressCanceled(D){const l=this.c.get(D);l&&(l.cancel(),this.c.delete(D))}}e.$Jhc=g;function h(A,D){return A.message=D.message,typeof D.increment=="number"&&(typeof A.increment=="number"?A.increment+=D.increment:A.increment=D.increment),A}class E extends M.$xv{constructor(D,l){super(p=>this.throttledReport(p)),this.c=D,this.d=l}throttledReport(D){this.c.$progressReport(this.d,D)}}Je([(0,R.$Bh)(100,(A,D)=>h(A,D),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Re[264],Ae([1,0,2,3,11,8]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=void 0;class L{static{this.a=0}constructor(h,E){this.d=E,this.c=new Map,this.b=h.getProxy(M.$jL.MainThreadQuickDiff)}$provideOriginalResource(h,E,A){const D=S.URI.revive(E),l=this.c.get(h);return l?(0,I.$Zg)(()=>l.provideOriginalResource(D,A)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(h,E,A,D){const l=L.a++;return this.c.set(l,E),this.b.$registerQuickDiffProvider(l,R.DocumentSelector.from(h,this.d),A,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Khc=L}),define(Re[265],Ae([1,0,21,5,6,3,2,7,15,18,32,40,24,8]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;function $(n,c,r){const t=n.getProxy(R.$jL.MainThreadQuickOpen);class s{constructor(b,P){this.e=new Map,this.f=0,this.a=b,this.b=P}showQuickPick(b,P,f,m=S.CancellationToken.None){this.c=void 0;const k=Promise.resolve(P),T=++this.f,O=t.$show(T,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},m),G={},q=O.then(()=>G);return Promise.race([q,k]).then(j=>{if(j===G)return;const C=(0,l.$KF)(b,"quickPickItemTooltip");return k.then(N=>{const W=[];for(let se=0;se<N.length;se++){const ue=N[se];if(typeof ue=="string")W.push({label:ue,handle:se});else if(ue.kind===g.QuickPickItemKind.Separator)W.push({type:"separator",label:ue.label});else{ue.tooltip&&!C&&console.warn(`Extension '${b.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`);const ye=ue.iconPath?o(ue.iconPath):void 0;W.push({label:ue.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:ue.description,detail:ue.detail,picked:ue.picked,alwaysShow:ue.alwaysShow,tooltip:C?p.MarkdownString.fromStrict(ue.tooltip):void 0,handle:se})}}return f&&typeof f.onDidSelectItem=="function"&&(this.c=se=>{f.onDidSelectItem(N[se])}),t.$setItems(T,W),O.then(se=>{if(typeof se=="number")return N[se];if(Array.isArray(se))return se.map(ue=>N[ue])})})}).then(void 0,j=>{if(!(0,h.$4)(j))return t.$setError(T,j),Promise.reject(j)})}$onItemSelected(b){this.c?.(b)}showInput(b,P=S.CancellationToken.None){return this.d=b?.validateInput,t.$input(b,typeof this.d=="function",P).then(void 0,f=>{if(!(0,h.$4)(f))return Promise.reject(f)})}async $validateInput(b){if(!this.d)return;const P=await this.d(b);if(!P||typeof P=="string")return P;let f;switch(P.severity){case g.InputBoxValidationSeverity.Info:f=A.default.Info;break;case g.InputBoxValidationSeverity.Warning:f=A.default.Warning;break;case g.InputBoxValidationSeverity.Error:f=A.default.Error;break;default:f=P.message?A.default.Error:A.default.Ignore;break}return{content:P.message,severity:f}}async showWorkspaceFolderPick(b,P=S.CancellationToken.None){const f=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[b]);if(!f)return;const m=await this.a.getWorkspaceFolders2();if(m)return m.find(k=>k.uri.toString()===f.uri.toString())}createQuickPick(b){const P=new w(b,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}createInputBox(b){const P=new y(b,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}$onDidChangeValue(b,P){this.e.get(b)?._fireDidChangeValue(P)}$onDidAccept(b){this.e.get(b)?._fireDidAccept()}$onDidChangeActive(b,P){const f=this.e.get(b);f instanceof w&&f._fireDidChangeActive(P)}$onDidChangeSelection(b,P){const f=this.e.get(b);f instanceof w&&f._fireDidChangeSelection(P)}$onDidTriggerButton(b,P){this.e.get(b)?._fireDidTriggerButton(P)}$onDidTriggerItemButton(b,P,f){const m=this.e.get(b);m instanceof w&&m._fireDidTriggerItemButton(P,f)}$onDidHide(b){this.e.get(b)?._fireDidHide()}}class a{static{this.a=1}constructor(b,P){this.x=b,this.y=P,this._id=w.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Wd,this.q=new M.$Wd,this.r=new M.$Wd,this.s=new M.$Wd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(b){this.b=b,this.z({title:b})}get step(){return this.c}set step(b){this.c=b,this.z({step:b})}get totalSteps(){return this.d}set totalSteps(b){this.d=b,this.z({totalSteps:b})}get enabled(){return this.g}set enabled(b){this.g=b,this.z({enabled:b})}get busy(){return this.j}set busy(b){this.j=b,this.z({busy:b})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(b){this.k=b,this.z({ignoreFocusOut:b})}get value(){return this.l}set value(b){this.l=b,this.z({value:b})}get placeholder(){return this.m}set placeholder(b){this.m=b,this.z({placeholder:b})}get buttons(){return this.n}set buttons(b){this.n=b.slice(),this.o.clear(),b.forEach((P,f)=>{const m=P===g.$HM.Back?-1:f;this.o.set(m,P)}),this.z({buttons:b.map((P,f)=>({...o(P.iconPath),tooltip:P.tooltip,handle:P===g.$HM.Back?-1:f}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(b){this.l=b,this.q.fire(b)}_fireDidTriggerButton(b){const P=this.o.get(b);P&&this.r.fire(P)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),t.$dispose(this._id))}z(b){if(!this.v){for(const P of Object.keys(b)){const f=b[P];this.u[P]=f===void 0?null:f}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){t.$createOrUpdate(this.u),this.u={id:this._id}}}function u(d){if(d instanceof g.$gM)return{id:d.id};const b=v(d),P=i(d);return{dark:typeof b=="string"?L.URI.file(b):b,light:typeof P=="string"?L.URI.file(P):P}}function i(d){return typeof d=="object"&&"light"in d?d.light:d}function v(d){return typeof d=="object"&&"dark"in d?d.dark:d}function o(d){const b=u(d);let P,f;return"id"in b?f=D.ThemeIcon.asClassName(b):P=b,{iconPath:P,iconClass:f}}class w extends a{constructor(b,P){super(b.identifier,P),this.O=b,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Wd,this.L=[],this.M=new M.$Wd,this.N=new M.$Wd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(b){this.B=b.slice(),this.C.clear(),this.D.clear(),b.forEach((m,k)=>{this.C.set(k,m),this.D.set(m,k)});const P=(0,l.$KF)(this.O,"quickPickItemTooltip"),f=[];for(let m=0;m<b.length;m++){const k=b[m];if(k.kind===g.QuickPickItemKind.Separator)f.push({type:"separator",label:k.label});else{k.tooltip&&!P&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const T=k.iconPath?o(k.iconPath):void 0;f.push({handle:m,label:k.label,iconPath:T?.iconPath,iconClass:T?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:P?p.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((O,G)=>({...o(O.iconPath),tooltip:O.tooltip,handle:G}))})}}this.z({items:f})}get canSelectMany(){return this.E}set canSelectMany(b){this.E=b,this.z({canSelectMany:b})}get matchOnDescription(){return this.F}set matchOnDescription(b){this.F=b,this.z({matchOnDescription:b})}get matchOnDetail(){return this.G}set matchOnDetail(b){this.G=b,this.z({matchOnDetail:b})}get sortByLabel(){return this.H}set sortByLabel(b){this.H=b,this.z({sortByLabel:b})}get keepScrollPosition(){return this.I}set keepScrollPosition(b){this.I=b,this.z({keepScrollPosition:b})}get activeItems(){return this.J}set activeItems(b){this.J=b.filter(P=>this.D.has(P)),this.z({activeItems:this.J.map(P=>this.D.get(P))})}get selectedItems(){return this.L}set selectedItems(b){this.L=b.filter(P=>this.D.has(P)),this.z({selectedItems:this.L.map(P=>this.D.get(P))})}_fireDidChangeActive(b){const P=(0,E.$Hb)(b.map(f=>this.C.get(f)));this.J=P,this.K.fire(P)}_fireDidChangeSelection(b){const P=(0,E.$Hb)(b.map(f=>this.C.get(f)));this.L=P,this.M.fire(P)}_fireDidTriggerItemButton(b,P){const f=this.C.get(b);if(!f||!f.buttons||!f.buttons.length)return;const m=f.buttons[P];m&&this.N.fire({button:m,item:f})}}class y extends a{constructor(b,P){super(b.identifier,P),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(b){this.B=b,this.z({password:b})}get prompt(){return this.C}set prompt(b){this.C=b,this.z({prompt:b})}get valueSelection(){return this.D}set valueSelection(b){this.D=b,this.z({valueSelection:b})}get validationMessage(){return this.E}set validationMessage(b){this.E=b,b?typeof b=="string"?this.z({validationMessage:b,severity:A.default.Error}):this.z({validationMessage:b.message,severity:b.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new s(c,r)}e.$Lhc=$}),define(Re[266],Ae([1,0,2,5,67,6,11,3,18,138,14,22,40,8,24,12,20]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=e.$Mhc=void 0;function t(T){return T instanceof S.URI}function s(T,O){return T.scheme===n.Schemas.file&&O.scheme===n.Schemas.file&&c.$k?T.toString()===O.toString():T.toString().toLowerCase()===O.toString().toLowerCase()}function a(T){if(T)return typeof T.iconPath=="string"?S.URI.file(T.iconPath):S.URI.isUri(T.iconPath)||l.ThemeIcon.isThemeIcon(T.iconPath)?T.iconPath:void 0}function u(T){if(T.icon){if(S.URI.isUri(T.icon))return T.icon;if(l.ThemeIcon.isThemeIcon(T.icon))return T.icon;{const O=T.icon;return{light:O.light,dark:O.dark}}}else return}function i(T,O){if(!T.iconPath&&!O.iconPath)return 0;if(T.iconPath){if(!O.iconPath)return 1}else return-1;const G=typeof T.iconPath=="string"?T.iconPath:S.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id,q=typeof O.iconPath=="string"?O.iconPath:S.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,E.$Uq)(G,q)}function v(T,O){let G=0;if(T.strikeThrough!==O.strikeThrough)return T.strikeThrough?1:-1;if(T.faded!==O.faded)return T.faded?1:-1;if(T.tooltip!==O.tooltip)return(T.tooltip||"").localeCompare(O.tooltip||"");if(G=i(T,O),G!==0)return G;if(T.light&&O.light)G=i(T.light,O.light);else{if(T.light)return 1;if(O.light)return-1}if(G!==0)return G;if(T.dark&&O.dark)G=i(T.dark,O.dark);else{if(T.dark)return 1;if(O.dark)return-1}return G}function o(T,O){if(T.command!==O.command)return T.command<O.command?-1:1;if(T.title!==O.title)return T.title<O.title?-1:1;if(T.tooltip!==O.tooltip){if(T.tooltip!==void 0&&O.tooltip!==void 0)return T.tooltip<O.tooltip?-1:1;if(T.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(T.arguments===O.arguments)return 0;if(T.arguments)if(O.arguments){if(T.arguments.length!==O.arguments.length)return T.arguments.length-O.arguments.length}else return 1;else return-1;for(let G=0;G<T.arguments.length;G++){const q=T.arguments[G],j=O.arguments[G];if(q!==j&&!(t(q)&&t(j)&&s(q,j)))return q<j?-1:1}return 0}function w(T,O){let G=(0,E.$Uq)(T.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(G!==0)return G;if(T.command&&O.command)G=o(T.command,O.command);else{if(T.command)return 1;if(O.command)return-1}if(G!==0)return G;if(T.decorations&&O.decorations)G=v(T.decorations,O.decorations);else{if(T.decorations)return 1;if(O.decorations)return-1}if(T.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)G=(0,E.$Uq)(T.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(T.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(T.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)G=(0,E.$Uq)(T.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(T.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return G}function y(T,O){for(let G=0;G<T.length;G++)if(T[G]!==O[G])return!1;return!0}function d(T,O){return T.command===O.command&&T.title===O.title&&T.tooltip===O.tooltip&&(T.arguments&&O.arguments?y(T.arguments,O.arguments):T.arguments===O.arguments)}function b(T,O){return(0,h.$ub)(T,O,d)}class P{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,$.$LF)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,$.$LF)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,$.$LF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,G,q,j,C){this.k=O,this.l=j,this.m=C,this.d="",this.e=new M.$Wd,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=q}showValidationMessage(O,G){(0,$.$LF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,G)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$Mhc=P;class f{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,G,q,j,C,N,W){this.q=O,this.s=G,this.t=q,this.u=j,this.v=C,this.multiDiffEditorEnableViewChanges=N,this.w=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Wd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Wd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=f.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,G){const q=this.h.get(O);return q?(0,L.$Zg)(()=>this.s.executeCommand(q.command,...q.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(w),q=(0,h.$Db)(this.o,O,w).map(N=>{const W=N.toInsert.map(se=>{const ue=this.e++;this.g.set(ue,se);const ye=se.resourceUri;let ke;if(se.command)if(se.command.command==="vscode.open"||se.command.command==="vscode.diff"||se.command.command==="vscode.changes"){const ge=new R.$Sc;ke=this.s.converter.toInternal(se.command,ge),this.j.set(ue,ge)}else this.h.set(ue,se.command);const ae=(0,$.$KF)(this.w,"scmMultiDiffEditor"),pe=ae?se.multiDiffEditorOriginalUri:void 0,oe=ae?se.multiFileDiffEditorModifiedUri:void 0,$e=a(se.decorations),ie=se.decorations&&a(se.decorations.light)||$e,x=se.decorations&&a(se.decorations.dark)||$e,V=[ie,x],ne=se.decorations&&se.decorations.tooltip||"",Ie=se.decorations&&!!se.decorations.strikeThrough,Me=se.decorations&&!!se.decorations.faded,Le=se.contextValue||"";return{rawResource:[ue,ye,V,ne,Ie,Me,Le,ke,pe,oe],handle:ue}});return{start:N.start,deleteCount:N.deleteCount,toInsert:W}}),j=q.map(({start:N,deleteCount:W,toInsert:se})=>[N,W,se.map(ue=>ue.rawResource)]),C=q.reverse();for(const{start:N,deleteCount:W,toInsert:se}of C){const ue=se.map(ke=>ke.handle),ye=this.n.splice(N,W,...ue);for(const ke of ye)this.g.delete(ke),this.h.delete(ke),this.j.get(ke)?.dispose(),this.j.delete(ke)}return this.o=O,j}dispose(){this.l=!0,this.m.fire()}}class m{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let G;(0,$.$KF)(this.x,"quickDiffProvider")&&(G=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:G})}get historyProvider(){return(0,$.$LF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,$.$LF)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new R.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new R.$Sc,this.o=O;const G=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,$.$LF)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,$.$LF)(this.x,"scmActionButton"),this.p.value=new R.$Sc,this.q=O;const G=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(q=>q.map(j=>this.y.converter.toInternal(j,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&b(this.t,O))return;this.s.value=new R.$Sc,this.t=O;const G=(O||[]).map(q=>this.y.converter.toInternal(q,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(O,G,q,j,C,N,W){this.x=O,this.y=j,this.z=C,this.A=N,this.B=W,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Uc,this.m=void 0,this.n=new R.$Uc,this.o=void 0,this.p=new R.$Uc,this.s=new R.$Uc,this.t=void 0,this.u=!1,this.v=new M.$Wd,this.onDidChangeSelection=this.v.event,this.w=m.d++,this.C=new Map,this.D=new Set,this.#e=q;const se=S.URI.from({scheme:n.Schemas.vscodeSourceControl,path:`${C}/scm${this.w}/input`,query:W?`rootUri=${encodeURIComponent(W.toString())}`:void 0});this.f=new P(O,G,this.#e,this.w,se),this.#e.$registerSourceControl(this.w,C,N,W,se)}createResourceGroup(O,G,q){const j=(0,$.$KF)(this.x,"scmMultiDiffEditor")&&q?.multiDiffEditorEnableViewChanges===!0,C=new f(this.#e,this.y,this.w,O,G,j,this.x),N=M.Event.once(C.onDidDispose)(()=>this.C.delete(C));return this.C.set(C,N),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const O=[],G=[];for(const[q,j]of this.C){j.dispose();const C=q.onDidUpdateResourceStates(()=>{this.D.add(q),this.eventuallyUpdateResourceStates()});M.Event.once(q.onDidDispose)(()=>{this.D.delete(q),C.dispose(),this.e.delete(q.handle),this.#e.$unregisterGroup(this.w,q.handle)}),O.push([q.handle,q.id,q.label,q.features,q.multiDiffEditorEnableViewChanges]);const N=q._takeResourceStateSnapshot();N.length>0&&G.push([q.handle,N]),this.e.set(q.handle,q)}this.#e.$registerGroups(this.w,O,G),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(G=>{const q=G._takeResourceStateSnapshot();q.length!==0&&O.push([G.handle,q])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,I.$Ah)(100)],m.prototype,"eventuallyAddResourceGroups",null),Je([(0,I.$Ah)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{r=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,G,q,j){this.l=G,this.m=q,this.n=j,this.g=new Map,this.h=new D.$pm,this.j=new M.$Wd,this.e=O.getProxy(g.$jL.MainThreadSCM),this.f=O.getProxy(g.$jL.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===3){const N=this.g.get(C.sourceControlHandle);if(!N)return C;const W=N.getResourceGroup(C.groupHandle);return W?W.getResourceState(C.handle):C}else if(C&&C.$mid===4){const N=this.g.get(C.sourceControlHandle);return N?N.getResourceGroup(C.groupHandle):C}else if(C&&C.$mid===5){const N=this.g.get(C.handle);return N||C}return C}})}createSourceControl(O,G,q,j){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,G,q,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const C=r.d++,N=new m(O,this.m,this.e,this.l,G,q,j);this.g.set(C,N);const W=this.h.get(O.identifier)||[];return W.push(N),this.h.set(O.identifier,W),N}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const G=this.h.get(O.identifier),q=G&&G[G.length-1];return q&&q.inputBox}$provideOriginalResource(O,G,q){const j=S.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",O,j.toString());const C=this.g.get(O);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$Zg)(()=>C.quickDiffProvider.provideOriginalResource(j,q)).then(N=>N||null)}$onInputBoxValueChange(O,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const q=this.g.get(O);return q&&q.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(O,G,q,j){this.n.trace("ExtHostSCM#$executeResourceCommand",O,G,q);const C=this.g.get(O);if(!C)return Promise.resolve(void 0);const N=C.getResourceGroup(G);return N?N.$executeResourceCommand(q,j):Promise.resolve(void 0)}$validateInput(O,G,q){this.n.trace("ExtHostSCM#$validateInput",O);const j=this.g.get(O);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,L.$Zg)(()=>j.inputBox.validateInput(G,q)).then(C=>{if(!C)return Promise.resolve(void 0);const N=p.MarkdownString.fromStrict(C.message);return N?Promise.resolve([N,C.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,G,q,j){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,q,j)??void 0}async $provideHistoryItems(O,G,q,j){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(G,q,j))?.map(W=>({...W,icon:u(W)}))??void 0}async $provideHistoryItemSummary(O,G,q,j){const C=this.g.get(O)?.historyProvider;if(typeof C?.provideHistoryItemSummary!="function")return;const N=await C.provideHistoryItemSummary(G,q,j);return N?{...N,icon:u(N)}:void 0}async $provideHistoryItemChanges(O,G,q,j){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(G,q,j)??void 0}};e.$Nhc=k,e.$Nhc=k=r=Je([qe(3,A.$pj)],k)}),define(Re[267],Ae([1,0,3,8,2]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;class R{static{this.a=0}constructor(g,h){this.d=h,this.c=new Map,this.b=g.getProxy(S.$jL.MainThreadShare)}async $provideShare(g,h,E){return await this.c.get(g)?.provideShare({selection:M.Range.to(h.selection),resourceUri:I.URI.revive(h.resourceUri)},E)??void 0}registerShareProvider(g,h){const E=R.a++;return this.c.set(E,h),this.b.$registerShareProvider(E,M.DocumentSelector.from(g,this.d),h.id,h.label,h.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Ohc=R}),define(Re[268],Ae([1,0,7,3,163,6,8,16]),function(me,e,S,M,I,R,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=e.$Qhc=void 0;class h{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new S.$hM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.$hM("statusBarItem.warningForeground")]])}#e;#t;constructor(l,p,$,n,c,r=S.StatusBarAlignment.Left,t){if(this.i=!1,this.k="",this.q=new R.$Sc,this.#e=l,this.#t=p,c&&n){this.c=(0,S.$WL)(n.identifier,c);const s=$.get(this.c);s&&(r=s.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,t=s.priority,this.j=!0,this.name=s.name,this.text=s.text,this.tooltip=s.tooltip,this.command=s.command,this.accessibilityInformation=s.accessibilityInformation)}else this.c=String(h.a++);this.e=n,this.f=c,this.g=r,this.h=this.u(t)}u(l){if((0,g.$Nf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!h.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new R.$Sc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let p;this.m?p=this.m:p=(0,I.localize)(0,null,this.e.displayName||this.e.name);let $=this.n;this.o&&($=h.b.get(this.o.id));const n=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,p,this.k,n,this.r?.internal,$,this.o,this.g===S.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Qhc=h;class E{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const p={message:l};return this.b.unshift(p),this.c(),new S.$lL(()=>{const $=this.b.indexOf(p);$>=0&&(this.b.splice($,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(l,p){this.e=new Map,this.a=l.getProxy(M.$jL.MainThreadStatusBar),this.b=p,this.c=new E(this)}$acceptStaticEntries(l){for(const p of l)this.e.set(p.entryId,p)}createStatusBarEntry(l,p,$,n){return new h(this.a,this.b,this.e,l,p,$,n)}setStatusBarMessage(l,p){const $=this.c.setMessage(l);let n;return typeof p=="number"?n=setTimeout(()=>$.dispose(),p):typeof p<"u"&&p.then(()=>$.dispose(),()=>$.dispose()),new S.$lL(()=>{$.dispose(),clearTimeout(n)})}}e.$Rhc=A}),define(Re[110],Ae([1,0,29,103,48,76,59,8,2]),function(me,e,S,M,I,R,L,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=e.$CN=e.$BN=e.$AN=void 0;const E=(s,a,u,i)=>{let v=a;return{enumerable:!0,configurable:!1,get(){return v},set(o){if(!u(v,o)){const w=v;v=o,s.listener?.(i(o,w))}}}},A=(s,a)=>s===a,D={range:(s,a)=>s===a?!0:!s||!a?!1:s.isEqual(a),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(s,a)=>!(s.length!==a.length||s.some(u=>!a.find(i=>u.id===i.id)))},l=s=>a=>({op:4,update:s(a)}),p=(s,a)=>({range:(()=>{let u;const i=l(v=>({range:S.$Ws.lift(g.Range.from(v))}));return{enumerable:!0,configurable:!1,get(){return u},set(v){s.listener?.({op:6}),D.range(u,v)||(u=v,s.listener?.(i(v)))}}})(),label:E(s,a,D.label,l(u=>({label:u}))),description:E(s,void 0,D.description,l(u=>({description:u}))),sortText:E(s,void 0,D.sortText,l(u=>({sortText:u}))),canResolveChildren:E(s,!1,D.canResolveChildren,u=>({op:2,state:u})),busy:E(s,!1,D.busy,l(u=>({busy:u}))),error:E(s,void 0,D.error,l(u=>({error:g.MarkdownString.fromStrict(u)||null}))),tags:E(s,[],D.tags,(u,i)=>({op:1,new:u.map(g.TestTag.from),old:i.map(g.TestTag.from)}))}),$=s=>{const a=I.$bK.fromString(s.extId),u=new c(a.controllerId,a.localId,s.label,h.URI.revive(s.uri)||void 0);return u.range=g.Range.to(s.range||void 0),u.description=s.description||void 0,u.sortText=s.sortText||void 0,u.tags=s.tags.map(i=>g.TestTag.to({id:(0,L.$gK)(i).tagId})),u},n=s=>{let a;for(const u of s.tests){const i=$(u.item);(0,M.$kN)(i).parent=a,a=i}return a};e.$AN=n;class c{constructor(a,u,i,v){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const o=(0,M.$jN)(this,a);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:v,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof r?void 0:o.parent}},children:{value:(0,R.$iN)(o,M.$kN,c),enumerable:!0,writable:!1},...p(o,i)})}}e.$BN=c;class r extends c{constructor(a,u){super(a,a,u,void 0),this._isRoot=!0}}e.$CN=r;class t extends R.$eN{constructor(a,u,i){super({controllerId:a,getDocumentVersion:v=>v&&i.getDocument(v)?.version,getApiFor:M.$kN,getChildren:v=>v.children,root:new r(a,u),toITestItem:g.TestItem.from})}}e.$DN=t}),define(Re[31],Ae([1,0,16,7,8,26,3,18,14,51,29,92,2,6,4,17,110,23,49,41,63,57,60,33]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c,r,t,s,a,u,i,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=void 0;let o=class{#e;#t;#i;constructor(f,m,k){this.b=new Map,this.c=new Map,this.#e=f.getProxy(L.$jL.MainThreadCommands),this.d=m,this.#i=k,this.#t=f.getProxy(L.$jL.MainThreadTelemetry),this.converter=new w(this,T=>{const O=this.c.get(T);return O?.result===d.Void?O:void 0},m),this.f=[{processArgument(T){return(0,E.$Eh)(T)}},{processArgument(T){return(0,R.$An)(T,function(O){if(A.$Ws.isIRange(O))return I.Range.to(O);if(D.$Vs.isIPosition(O))return I.Position.to(O);if(A.$Ws.isIRange(O.range)&&l.URI.isUri(O.uri))return I.location.to(O);if(O instanceof r.$ke)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const m=this.registerCommand(!1,f.id,async(...k)=>{const T=f.args.map((G,q)=>{if(!G.validate(k[q]))throw new Error(`Invalid argument '${G.name}' when running '${f.id}', received: ${typeof k[q]=="object"?JSON.stringify(k[q],null,"	"):k[q]} `);return G.convert(k[q])}),O=await this.executeCommand(f.internalId,...T);return f.result.convert(O,k,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new M.$lL(()=>{m.dispose(),this.c.delete(f.id)})}registerCommand(f,m,k,T,O,G){if(this.d.trace("ExtHostCommands#registerCommand",m),!m.trim().length)throw new Error("invalid id");if(this.b.has(m))throw new Error(`command '${m}' already exists`);return this.b.set(m,{callback:k,thisArg:T,metadata:O,extension:G}),f&&this.#e.$registerCommand(m),new M.$lL(()=>{this.b.delete(m)&&f&&this.#e.$unregisterCommand(m)})}executeCommand(f,...m){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,m,!0)}async g(f,m,k){if(this.b.has(f))return this.#e.$fireCommandActivationEvent(f),this.h(f,m,!1);{let T=!1;const O=(0,R.$An)(m,function(G){if(G instanceof M.$mL)return I.Position.from(G);if(G instanceof M.$nL)return I.Range.from(G);if(G instanceof M.$xL)return I.location.from(G);if(M.$KM.isNotebookRange(G))return I.NotebookRange.from(G);if(G instanceof ArrayBuffer)return T=!0,r.$ke.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return T=!0,r.$ke.wrap(G);if(G instanceof r.$ke)return T=!0,G;if(!Array.isArray(G))return G});try{const G=await this.#e.$executeCommand(f,T?new t.$Vv(O):O,k);return(0,E.$Eh)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(f,m,!1);throw G}}}async h(f,m,k){const T=this.b.get(f);if(!T)throw new Error("Unknown command");const{callback:O,thisArg:G,metadata:q}=T;if(q?.args)for(let C=0;C<q.args.length;C++)try{(0,S.$1f)(m[C],q.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${q.args[C].name}' - ${q.args[C].description}`)}const j=a.$Sd.create();try{return await O.apply(G,m)}catch(C){if(f===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...m);N&&(f=N.command)}if(this.d.error(C,f,T.extension?.identifier),!k)throw C;if(T.extension?.identifier){const N=this.#i.onExtensionError(T.extension.identifier,C);this.d.trace("forwarded error to extension?",N,T.extension?.identifier)}throw new class extends Error{constructor(){super((0,s.$Si)(C)),this.id=f,this.source=T.extension?.displayName??T.extension?.name}}}finally{this.j(T,f,j.elapsed())}}j(f,m,k){f.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new u.$No(m),duration:k})}$executeContributedCommand(f,...m){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const k=this.b.get(f);return k?(m=m.map(T=>this.f.reduce((O,G)=>G.processArgument(O,k.extension?.identifier),T)),this.h(f,m,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),this.#e.$getCommands().then(m=>(f&&(m=m.filter(k=>k[0]!=="_")),m))}$getContributedCommandMetadata(){const f=Object.create(null);for(const[m,k]of this.b){const{metadata:T}=k;T&&(f[m]=T)}return Promise.resolve(f)}};e.$JN=o,e.$JN=o=Je([qe(0,n.$oN),qe(1,h.$pj),qe(2,i.$IN)],o),e.$KN=(0,$.$8h)("IExtHostCommands");class w{constructor(f,m,k){this.d=f,this.f=m,this.g=k,this.delegatingCommandId=`__vsc${(0,v.$rg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,m){if(!f)return;const k={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return k;const T=this.f(f.command);if(T)k.id=T.internalId,k.arguments=T.args.map((O,G)=>O.convert(f.arguments&&f.arguments[G]));else if((0,g.$Lb)(f.arguments)){const O=`${f.command} /${++this.c}`;this.b.set(O,f),m.add((0,p.$Rc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),k.$ident=O,k.id=this.delegatingCommandId,k.arguments=[O],this.g.trace("CommandsConverter#CREATE",f.command,O)}return k}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const m=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],m?m.command:"MISSING"),m?this.d.executeCommand(m.command,...m.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.$LN=w;class y{static{this.Uri=new y("uri","Uri of a text document",f=>l.URI.isUri(f),f=>f)}static{this.Position=new y("position","A position in a text document",f=>M.$mL.isPosition(f),I.Position.from)}static{this.Range=new y("range","A range in a text document",f=>M.$nL.isRange(f),I.Range.from)}static{this.Selection=new y("selection","A selection in a text document",f=>M.$oL.isSelection(f),I.Selection.from)}static{this.Number=new y("number","",f=>typeof f=="number",f=>f)}static{this.String=new y("string","",f=>typeof f=="string",f=>f)}static{this.StringArray=y.Arr(y.String)}static Arr(f){return new y(`${f.name}_array`,`Array of ${f.name}, ${f.description}`,m=>Array.isArray(m)&&m.every(k=>f.validate(k)),m=>m.map(k=>f.convert(k)))}static{this.CallHierarchyItem=new y("item","A call hierarchy item",f=>f instanceof M.$IL,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new y("item","A type hierarchy item",f=>f instanceof M.$4M,I.TypeHierarchyItem.from)}static{this.TestItem=new y("testItem","A VS Code TestItem",f=>f instanceof c.$BN,I.TestItem.from)}constructor(f,m,k,T){this.name=f,this.description=m,this.validate=k,this.convert=T}optional(){return new y(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,m){return new y(f??this.name,m??this.description,this.validate,this.convert)}}e.$MN=y;class d{static{this.Void=new d("no result",f=>f)}constructor(f,m){this.description=f,this.convert=m}}e.$NN=d;class b{constructor(f,m,k,T,O){this.id=f,this.internalId=m,this.description=k,this.args=T,this.result=O}}e.$ON=b}),define(Re[269],Ae([1,0,18,12,2,87,96,35,31,8,7]),function(me,e,S,M,I,R,L,g,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;const D=[new h.$ON("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[h.$MN.Uri,h.$MN.Position],new h.$NN("A promise that resolves to an array of DocumentHighlight-instances.",p(E.DocumentHighlight.to))),new h.$ON("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[h.$MN.Uri],new h.$NN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,c)=>{if((0,S.$Kb)(n))return;class r extends A.$DL{static to(s){const a=new r(s.name,E.SymbolKind.to(s.kind),s.containerName||"",new A.$xL(c[0],E.Range.to(s.range)));return a.detail=s.detail,a.range=a.location.range,a.selectionRange=E.Range.to(s.selectionRange),a.children=s.children?s.children.map(r.to):[],a}}return n.map(r.to)})),new h.$ON("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[h.$MN.Uri,new h.$MN("options","Formatting options",n=>!0,n=>n)],new h.$NN("A promise that resolves to an array of TextEdits.",p(E.TextEdit.to))),new h.$ON("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[h.$MN.Uri,h.$MN.Range,new h.$MN("options","Formatting options",n=>!0,n=>n)],new h.$NN("A promise that resolves to an array of TextEdits.",p(E.TextEdit.to))),new h.$ON("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[h.$MN.Uri,h.$MN.Position,new h.$MN("ch","Trigger character",n=>typeof n=="string",n=>n),new h.$MN("options","Formatting options",n=>!0,n=>n)],new h.$NN("A promise that resolves to an array of TextEdits.",p(E.TextEdit.to))),new h.$ON("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[h.$MN.Uri,h.$MN.Position],new h.$NN("A promise that resolves to an array of Location or LocationLink instances.",$)),new h.$ON("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[h.$MN.Uri,h.$MN.Position],new h.$NN("A promise that resolves to an array of Location or LocationLink instances.",$)),new h.$ON("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[h.$MN.Uri,h.$MN.Position],new h.$NN("A promise that resolves to an array of Location or LocationLink instances.",$)),new h.$ON("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[h.$MN.Uri,h.$MN.Position],new h.$NN("A promise that resolves to an array of Location or LocationLink instances.",$)),new h.$ON("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[h.$MN.Uri,h.$MN.Position],new h.$NN("A promise that resolves to an array of Location-instances.",p(E.location.to))),new h.$ON("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[h.$MN.Uri,h.$MN.Position],new h.$NN("A promise that resolves to an array of Hover-instances.",p(E.Hover.to))),new h.$ON("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[h.$MN.Uri,new h.$MN("position","A position in a text document",n=>Array.isArray(n)&&n.every(c=>A.$mL.isPosition(c)),n=>n.map(E.Position.from))],new h.$NN("A promise that resolves to an array of ranges.",n=>n.map(c=>{let r;for(const t of c.reverse())r=new A.$HL(E.Range.to(t),r);return r}))),new h.$ON("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[h.$MN.String.with("query","Search string")],new h.$NN("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(E.WorkspaceSymbol.to))),new h.$ON("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[h.$MN.Uri,h.$MN.Position],new h.$NN("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(E.CallHierarchyItem.to))),new h.$ON("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[h.$MN.CallHierarchyItem],new h.$NN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(E.CallHierarchyIncomingCall.to))),new h.$ON("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[h.$MN.CallHierarchyItem],new h.$NN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(E.CallHierarchyOutgoingCall.to))),new h.$ON("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[h.$MN.Uri,h.$MN.Position],new h.$NN("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:E.Range.to(n.range),placeholder:n.text}})),new h.$ON("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[h.$MN.Uri,h.$MN.Position,h.$MN.String.with("newName","The new symbol name")],new h.$NN("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return E.WorkspaceEdit.to(n)}})),new h.$ON("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[h.$MN.Uri,h.$MN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new h.$NN("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(E.DocumentLink.to))),new h.$ON("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[h.$MN.Uri],new h.$NN("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new A.$BM(n.tokenTypes,n.tokenModifiers)})),new h.$ON("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[h.$MN.Uri],new h.$NN("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const c=(0,L.$O$)(n);if(c.type==="full")return new A.$DM(c.data,void 0)})),new h.$ON("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[h.$MN.Uri,h.$MN.Range.optional()],new h.$NN("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new A.$BM(n.tokenTypes,n.tokenModifiers)})),new h.$ON("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[h.$MN.Uri,h.$MN.Range],new h.$NN("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const c=(0,L.$O$)(n);if(c.type==="full")return new A.$DM(c.data,void 0)})),new h.$ON("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[h.$MN.Uri,h.$MN.Position,h.$MN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),h.$MN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new h.$NN("A promise that resolves to a CompletionList-instance.",(n,c,r)=>{if(!n)return new A.$TL([]);const t=n.suggestions.map(s=>E.CompletionItem.to(s,r));return new A.$TL(t,n.incomplete)})),new h.$ON("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[h.$MN.Uri,h.$MN.Position,h.$MN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new h.$NN("A promise that resolves to SignatureHelp.",n=>{if(n)return E.SignatureHelp.to(n)})),new h.$ON("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[h.$MN.Uri,h.$MN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new h.$NN("A promise that resolves to an array of CodeLens-instances.",(n,c,r)=>p(t=>new A.$LL(E.Range.to(t.range),t.command&&r.fromInternal(t.command)))(n))),new h.$ON("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[h.$MN.Uri,new h.$MN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>A.$nL.isRange(n),n=>A.$oL.isSelection(n)?E.Selection.from(n):E.Range.from(n)),h.$MN.String.with("kind","Code action kind to return code actions for").optional(),h.$MN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new h.$NN("A promise that resolves to an array of Command-instances.",(n,c,r)=>p(t=>{if(t._isSynthetic){if(!t.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(t.command)}else{const s=new A.$FL(t.title,t.kind?new A.$GL(t.kind):void 0);return t.edit&&(s.edit=E.WorkspaceEdit.to(t.edit)),t.command&&(s.command=r.fromInternal(t.command)),s.isPreferred=t.isPreferred,s}})(n))),new h.$ON("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[h.$MN.Uri],new h.$NN("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(c=>new A.$ZL(E.Range.to(c.range),E.Color.to(c.color))):[])),new h.$ON("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new h.$MN("color","The color to show and insert",n=>n instanceof A.$YL,E.Color.from),new h.$MN("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:E.Range.from(n.range)}))],new h.$NN("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(E.ColorPresentation.to):[])),new h.$ON("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[h.$MN.Uri,h.$MN.Range],new h.$NN("A promise that resolves to an array of Inlay objects",(n,c,r)=>n.map(E.InlayHint.to.bind(void 0,r)))),new h.$ON("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[h.$MN.Uri],new h.$NN("A promise that resolves to an array of FoldingRange objects",(n,c)=>{if(n)return n.map(E.FoldingRange.to)})),new h.$ON("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new h.$NN("A promise that resolves to an array of NotebookContentProvider static info objects.",p(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(c=>E.NotebookExclusiveDocumentPattern.to(c))})))),new h.$ON("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[h.$MN.Uri,h.$MN.Range,new h.$MN("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof A.$nL,n=>E.InlineValueContext.from(n))],new h.$NN("A promise that resolves to an array of InlineValue objects",n=>n.map(E.InlineValue.to))),new h.$ON("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new h.$MN("uriOrString","Uri-instance or string (only http/https)",n=>I.URI.isUri(n)||typeof n=="string"&&(0,M.$gg)(n,M.Schemas.http,M.Schemas.https),n=>n),new h.$MN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[E.ViewColumn.from(n),void 0]:[E.ViewColumn.from(n.viewColumn),E.TextEditorOpenOptions.from(n)])).optional(),h.$MN.String.with("label","").optional()],h.$NN.Void),new h.$ON("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[h.$MN.Uri.with("resource","Resource to open"),h.$MN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new h.$MN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[E.ViewColumn.from(n),void 0]:[E.ViewColumn.from(n.viewColumn),E.TextEditorOpenOptions.from(n)])).optional()],h.$NN.Void),new h.$ON("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[h.$MN.Uri.with("left","Left-hand side resource of the diff editor"),h.$MN.Uri.with("right","Right-hand side resource of the diff editor"),h.$MN.String.with("title","Human readable title for the diff editor").optional(),new h.$MN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[E.ViewColumn.from(n.viewColumn),E.TextEditorOpenOptions.from(n)]).optional()],h.$NN.Void),new h.$ON("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[h.$MN.String.with("title","Human readable title for the changes editor"),new h.$MN("resourceList","List of resources to compare",n=>{for(const c of n){if(c.length!==3)return!1;const[r,t,s]=c;if(!I.URI.isUri(r)||!I.URI.isUri(t)&&t!==void 0&&t!==null||!I.URI.isUri(s)&&s!==void 0&&s!==null)return!1}return!0},n=>n)],h.$NN.Void),new h.$ON("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[h.$MN.Uri,h.$MN.Position],new h.$NN("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(E.TypeHierarchyItem.to))),new h.$ON("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[h.$MN.TypeHierarchyItem],new h.$NN("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(E.TypeHierarchyItem.to))),new h.$ON("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[h.$MN.TypeHierarchyItem],new h.$NN("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(E.TypeHierarchyItem.to))),new h.$ON("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[h.$MN.TestItem],h.$NN.Void),new h.$ON("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[h.$MN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],h.$NN.Void),new h.$ON("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[h.$MN.String.with("name","The context key name"),new h.$MN("value","The context key value",()=>!0,n=>n)],h.$NN.Void),new h.$ON("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[h.$MN.Uri,h.$MN.StringArray,new h.$MN("MappedEditsContext","Mapped Edits Context",n=>E.MappedEditsContext.is(n),n=>E.MappedEditsContext.from(n))],new h.$NN("A promise that resolves to a workspace edit or null",n=>n?E.WorkspaceEdit.to(n):null))];class l{static register(c){D.forEach(c.registerApiCommand,c),this.a(c)}static a(c){c.registerCommand(!1,"_validateWhenClauses",g.$7i)}}e.$agc=l;function p(n){return c=>{if(Array.isArray(c))return c.map(n)}}function $(n){if(!Array.isArray(n))return;const c=[];for(const r of n)R.$It(r)?c.push(E.DefinitionLink.to(r)):c.push(E.location.to(r));return c}}),define(Re[270],Ae([1,0,6,2,3,8,7,31,11]),function(me,e,S,M,I,R,L,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;class E{static{this.a=0}constructor(p,$){this.extension=p,this.provider=$,this.handle=E.a++}}class A{constructor(p){this.session=p,this.responses=[]}}class D{static{this.a=0}constructor(p,$,n,c){this.f=n,this.g=c,this.b=new Map,this.d=new Map,this.e=p.getProxy(I.$jL.MainThreadInlineChat),$.registerApiCommand(new g.$ON("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new g.$MN("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?R.Range.from(r.initialRange):void 0,initialSelection:L.$oL.isSelection(r.initialSelection)?R.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?R.Position.from(r.position):void 0}})],g.$NN.Void))}registerProvider(p,$,n){const c=new E(p,$);return this.b.set(c.handle,c),this.e.$registerInteractiveEditorProvider(c.handle,n?.label??p.displayName??p.name,p.identifier.value,typeof $.handleInteractiveEditorResponseFeedback=="function",typeof $.provideFollowups=="function",n?.supportReportIssue??!1),(0,S.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(c.handle),this.b.delete(c.handle)})}async $prepareSession(p,$,n,c){const r=this.b.get(p);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const t=this.f.getDocument(M.URI.revive($)),s=R.Selection.to(n),a=await r.provider.prepareInteractiveEditorSession({document:t,selection:s},c);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(s))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const u=D.a++;return this.d.set(u,new A(a)),{id:u,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:R.Range.from(a.wholeRange),message:a.message}}async $provideResponse(p,$,n,c){const r=this.b.get(p);if(!r)return;const t=this.d.get($.id);if(!t)return;const s={prompt:n.prompt,selection:R.Selection.to(n.selection),wholeRange:R.Range.to(n.wholeRange),attempt:n.attempt,live:n.live,previewDocument:this.f.getDocument(M.URI.revive(n.previewDocument)),withIntentDetection:n.withIntentDetection};let a=!1;const u={report:async P=>{if(!n.live&&P.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||c.isCancellationRequested||await this.e.$handleProgressChunk(n.requestId,{message:P.message,edits:P.edits?.map(R.TextEdit.from),editsShouldBeInstant:P.editsShouldBeInstant,slashCommand:P.slashCommand?.command,markdownFragment:L.$ML.isMarkdownString(P.content)?P.content.value:P.content})}},i=Promise.resolve(r.provider.provideInteractiveEditorResponse(t.session,s,u,c));let v;try{v=await(0,h.$Vg)(i,c)}finally{a=!0}if(!v)return;const o=t.responses.push(v)-1,w={wholeRange:R.Range.from(v.wholeRange),placeholder:v.placeholder};if(!D.h(v))return{...w,id:o,type:"editorEdit",message:R.MarkdownString.from(v.contents),edits:[]};const{edits:y,contents:d}=v,b=d!==void 0?R.MarkdownString.from(d):void 0;return y instanceof L.$vL?{...w,id:o,type:"bulkEdit",edits:R.WorkspaceEdit.from(y),message:b}:{...w,id:o,type:"editorEdit",edits:y.map(R.TextEdit.from),message:b}}async $provideFollowups(p,$,n,c){const r=this.b.get(p),t=this.d.get($),s=t?.responses[n];if(r&&s&&r.provider.provideFollowups){const a=Promise.resolve(r.provider.provideFollowups(t.session,s,c));return(await(0,h.$Vg)(a,c))?.map(R.ChatFollowup.from)}}$handleFeedback(p,$,n,c){const r=this.b.get(p),t=this.d.get($),s=t?.responses[n];if(r&&s){const a=R.InteractiveEditorResponseFeedbackKind.to(c);r.provider.handleInteractiveEditorResponseFeedback?.(t.session,s,a)}}$releaseSession(p,$){}static h(p){return typeof p=="object"&&typeof p.edits=="object"}}e.$ihc=D}),define(Re[271],Ae([1,0,2,31]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0;class I{constructor(L,g,h,E,A){this.a=g,this.b=h,this.c=E;const D=new M.$ON("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$MN("showOptions","Show Options",l=>!0,l=>l),new M.$MN("resource","Interactive resource Uri",l=>!0,l=>l),new M.$MN("controllerId","Notebook controller Id",l=>!0,l=>l),new M.$MN("title","Interactive editor title",l=>!0,l=>l)],new M.$NN("Notebook and input URI",l=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const p=this.a.getEditorById(l.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri),notebookEditor:p.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(L,g,h,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:g,lines:[""],languageId:h,uri:L,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(S.URI.revive(E))?.apiNotebook}]})}$willRemoveInteractiveDocument(L,g){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$vhc=I}),define(Re[272],Ae([1,0,18,11,21,5,6,28,2,22,14,3,31,8,7,77,209,24,49,210]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c,r,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=e.$Dhc=void 0;let a=class{constructor(b,P,f,m,k){this.m=P,this.n=f,this.o=m,this.q=k,this.b=new g.$Ac,this.c=new g.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$Wd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=b.getProxy(D.$jL.MainThreadNotebookKernels);const T=new l.$ON("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$MN("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const G=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:G}}else if(O&&"notebookEditor"in O){const G=this.n.getIdByEditor(O.notebookEditor);if(G===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:G}}return O})],l.$NN.Void);this.o.registerApiCommand(T)}createNotebookController(b,P,f,m,k,T){for(const $e of this.j.values())if($e.controller.id===P&&E.$nm.equals(b.identifier,$e.extensionId))throw new Error(`notebook controller with id '${P}' ALREADY exist`);const O=this.k++,G=this;this.q.trace(`NotebookController[${O}], CREATED by ${b.identifier.value}, ${P}`);const q=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${b.identifier}'`);let j=!1;const C=new R.$Wd,N=new R.$Wd,W={id:y(b.identifier,P),notebookType:f,extensionId:b.identifier,extensionLocation:b.extensionLocation,label:m||b.identifier.value,preloads:T?T.map(p.NotebookRendererScript.from):[]};let se=k??q,ue,ye;this.a.$addKernel(O,W).catch($e=>{console.log($e),j=!0});let ke=0;const ae=()=>{if(j)return;const $e=++ke;Promise.resolve().then(()=>{$e===ke&&this.a.$updateKernel(O,W)})},pe=new g.$Ac,oe={get id(){return P},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:C.event,get label(){return W.label},set label($e){W.label=$e??b.displayName??b.name,ae()},get detail(){return W.detail??""},set detail($e){W.detail=$e,ae()},get description(){return W.description??""},set description($e){W.description=$e,ae()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages($e){W.supportedLanguages=$e,ae()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder($e){W.supportsExecutionOrder=$e,ae()},get rendererScripts(){return W.preloads?W.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return se},set executeHandler($e){se=$e??q},get interruptHandler(){return ue},set interruptHandler($e){ue=$e,W.supportsInterrupt=!!$e,ae()},set variableProvider($e){(0,r.$LF)(b,"notebookVariableProvider"),ye=$e,W.hasVariableProvider=!!$e,$e?.onDidChangeVariables(ie=>G.a.$variablesUpdated(ie.uri)),ae()},get variableProvider(){return ye},createNotebookCellExecution($e){if(j)throw new Error("notebook controller is DISPOSED");if(!pe.has($e.notebook.uri))throw G.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return G._createNotebookCellExecution($e,y(b.identifier,this.id))},createNotebookExecution($e){if((0,r.$LF)(b,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!pe.has($e.uri))throw G.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return G._createNotebookExecution($e,y(b.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${O}], DISPOSED`),j=!0,this.j.delete(O),C.dispose(),N.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity($e,ie){ie===$.NotebookControllerAffinity2.Hidden&&(0,r.$LF)(b,"notebookControllerAffinityHidden"),G.a.$updateNotebookPriority(O,$e.uri,ie)},onDidReceiveMessage:N.event,postMessage($e,ie){return(0,r.$LF)(b,"notebookMessaging"),G.a.$postMessage(O,ie&&G.n.getIdByEditor(ie),$e)},asWebviewUri($e){return(0,r.$LF)(b,"notebookMessaging"),(0,n.$pwb)($e,G.m.remote)}};return this.j.set(O,{extensionId:b.identifier,controller:oe,onDidReceiveMessage:N,onDidChangeSelection:C,associatedNotebooks:pe}),oe}getIdByController(b){for(const[P,f]of this.j)if(f.controller===b)return y(f.extensionId,b.id);return null}createNotebookControllerDetectionTask(b,P){const f=this.g++,m=this;this.q.trace(`NotebookControllerDetectionTask[${f}], CREATED by ${b.identifier.value}`),this.a.$addKernelDetectionTask(f,P);const k={dispose:()=>{this.f.delete(f),m.a.$removeKernelDetectionTask(f)}};return this.f.set(f,k),k}registerKernelSourceActionProvider(b,P,f){const m=this.i++,k=typeof f.onDidChangeNotebookKernelSourceActions=="function"?m:void 0,T=this;this.h.set(m,f),this.q.trace(`NotebookKernelSourceActionProvider[${m}], CREATED by ${b.identifier.value}`),this.a.$addKernelSourceActionProvider(m,m,P);let O;return k!==void 0&&(O=f.onDidChangeNotebookKernelSourceActions(G=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(m),T.a.$removeKernelSourceActionProvider(m,m),O?.dispose()}}}async $provideKernelSourceActions(b,P){const f=this.h.get(b);if(f){const m=new L.$Sc;return(await f.provideNotebookKernelSourceActions(P)??[]).map(T=>p.NotebookKernelSourceAction.from(T,this.o.converter,m))}return[]}$acceptNotebookAssociation(b,P,f){const m=this.j.get(b);if(m){const k=this.n.getNotebookDocument(h.URI.revive(P));f?m.associatedNotebooks.set(k.uri,!0):m.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${b}] ASSOCIATE notebook`,k.uri.toString(),f),m.onDidChangeSelection.fire({selected:f,notebook:k.apiNotebook})}}async $executeCells(b,P,f){const m=this.j.get(b);if(!m)return;const k=this.n.getNotebookDocument(h.URI.revive(P)),T=[];for(const O of f){const G=k.getCell(O);G&&T.push(G.apiCell)}try{this.q.trace(`NotebookController[${b}] EXECUTE cells`,k.uri.toString(),T.length),await m.controller.executeHandler.call(m.controller,T,k.apiNotebook,m.controller)}catch(O){this.q.error(`NotebookController[${b}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(b,P,f){const m=this.j.get(b);if(!m)return;const k=this.n.getNotebookDocument(h.URI.revive(P));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,k.apiNotebook);else for(const T of f){const O=k.getCell(T);O&&this.b.get(O.uri)?.cancel()}if(m.controller.interruptHandler){const T=this.c.get(k.uri);f.length&&Array.isArray(T)&&T.length&&T.forEach(O=>O.dispose())}}async $provideVariables(b,P,f,m,k,T,O){const G=this.j.get(b);if(!G)return;const q=this.n.getNotebookDocument(h.URI.revive(f)),j=G.controller.variableProvider;if(!j)return;let C;if(m!==void 0){if(C=this.s[m],!C)return}else this.s={};const N=k==="named"?$.NotebookVariablesRequestKind.Named:$.NotebookVariablesRequestKind.Indexed,W=j.provideVariables(q.apiNotebook,C,N,T,O);let se=0;for await(const ue of W){if(O.isCancellationRequested)return;const ye={id:this.r++,name:ue.variable.name,value:ue.variable.value,type:ue.variable.type,hasNamedChildren:ue.hasNamedChildren,indexedChildrenCount:ue.indexedChildrenCount};if(this.s[ye.id]=ue.variable,this.a.$receiveVariable(P,ye),se++>=s.$Cfb)return}}$acceptKernelMessageFromRenderer(b,P,f){const m=this.j.get(b);if(!m)return;const k=this.n.getEditorById(P);m.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:f}))}$cellExecutionChanged(b,P,f){const k=this.n.getNotebookDocument(h.URI.revive(b)).getCell(P);if(k){const T=f?p.NotebookCellExecutionState.to(f):$.NotebookCellExecutionState.Idle;T!==void 0&&this.l.fire({cell:k.apiCell,state:T})}}_createNotebookCellExecution(b,P){if(b.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const m=this.n.getNotebookDocument(b.notebook.uri).getCellFromApiCell(b);if(!m)throw new Error("invalid cell");if(this.b.has(m.uri))throw new Error(`duplicate execution for ${m.uri}`);const k=new i(P,m,this.a);this.b.set(m.uri,k);const T=k.onDidChangeState(()=>{k.state===u.Resolved&&(k.dispose(),T.dispose(),this.b.delete(m.uri))});return k.asApiObject()}_createNotebookExecution(b,P){const f=this.n.getNotebookDocument(b.uri),m=b.getCells().find(O=>{const G=f.getCellFromApiCell(O);return G&&this.b.has(G.uri)});if(m)throw new Error(`duplicate cell execution for ${m.document.uri}`);if(this.c.has(f.uri))throw new Error(`duplicate notebook execution for ${f.uri}`);const k=new o(P,f,this.a),T=k.onDidChangeState(()=>{k.state===v.Resolved&&(k.dispose(),T.dispose(),this.c.delete(f.uri))});return this.c.set(f.uri,[k,T]),k.asApiObject()}};e.$Dhc=a,e.$Dhc=a=Je([qe(4,A.$pj)],a);var u;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(u||(u={}));class i extends L.$Tc{static{this.a=0}get state(){return this.f}constructor(b,P,f){super(),this.m=P,this.n=f,this.b=i.a++,this.c=new R.$Wd,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new I.$7d),this.h=new w(10,m=>this.s(m)),this.j=P.internalMetadata.executionOrder,this.n.$createExecution(this.b,b,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(b){await this.h.addItem(b)}async s(b){const P=Array.isArray(b)?b:[b];return this.n.$updateExecution(this.b,new t.$Vv(P))}t(){if(this.f===u.Init)throw new Error("Must call start before modifying cell output");if(this.f===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(b){let P=this.m;if(b&&(P=this.m.notebook.getCellFromApiCell(b)),!P)throw new Error("INVALID cell");return P.handle}y(b){return b.map(P=>{const f=$.$OM.ensureUniqueMimeTypes(P.items,!0);return f===P.items?p.NotebookCellOutput.from(P):p.NotebookCellOutput.from({items:f,id:P.id,metadata:P.metadata})})}async z(b,P,f){const m=this.w(P),k=this.y((0,S.$3b)(b));return this.r({editType:c.CellExecutionUpdateType.Output,cellHandle:m,append:f,outputs:k})}async C(b,P,f){return b=$.$OM.ensureUniqueMimeTypes((0,S.$3b)(b),!0),this.r({editType:c.CellExecutionUpdateType.OutputItems,items:b.map(p.NotebookCellOutputItem.from),outputId:P.id,append:f})}asApiObject(){const b=this;return Object.freeze({get token(){return b.g.token},get cell(){return b.m.apiCell},get executionOrder(){return b.j},set executionOrder(f){b.j=f,b.s([{editType:c.CellExecutionUpdateType.ExecutionState,executionOrder:b.j}])},start(f){if(b.f===u.Resolved||b.f===u.Started)throw new Error("Cannot call start again");b.f=u.Started,b.c.fire(),b.s({editType:c.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,m){if(b.f===u.Resolved)throw new Error("Cannot call resolve twice");b.f=u.Resolved,b.c.fire(),b.h.flush(),b.n.$completeExecution(b.b,new t.$Vv({runEndTime:m,lastRunSuccess:f}))},clearOutput(f){return b.t(),b.z([],f,!1)},appendOutput(f,m){return b.t(),b.z(f,m,!0)},replaceOutput(f,m){return b.t(),b.z(f,m,!1)},appendOutputItems(f,m){return b.t(),b.C(f,m,!0)},replaceOutputItems(f,m){return b.t(),b.C(f,m,!1)}})}}var v;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(v||(v={}));class o extends L.$Tc{static{this.a=0}get state(){return this.f}constructor(b,P,f){super(),this.h=P,this.j=f,this.b=o.a++,this.c=new R.$Wd,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new I.$7d),this.j.$createNotebookExecution(this.b,b,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===v.Resolved||this.f===v.Started)throw new Error("Cannot call start again");this.f=v.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===v.Resolved)throw new Error("Cannot call resolve twice");this.f=v.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class w{constructor(b,P){this.f=b,this.g=P,this.a=[],this.b=Date.now()}addItem(b){return this.a.push(b),this.c||(this.c=new M.$sh,this.b=Date.now(),(0,M.$9g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const b=this.c;this.c=void 0;const P=this.a;return this.a=[],this.g(P).finally(()=>b.complete())}}function y(d,b){return`${d.value}/${b}`}e.$Ehc=y}),define(Re[65],Ae([1,0,5,3,4,2,17,6,7,165,15,193,21,33,194,40,11,8,31]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=e.$Rgc=e.$Qgc=e.$Pgc=void 0,e.$Pgc=(0,I.$8h)("IExtHostTerminalService");class s{constructor(f,m,k,T){this.l=f,this._id=m,this.m=k,this.n=T,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(G=>this.f=G);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(G,q=!0){O.q(),O.l.$sendText(O._id,G,q)},show(G){O.q(),O.l.$show(O._id,G)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(f,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??m?.cwd??void 0,env:f.env??void 0,icon:y(f.iconPath)??void 0,color:n.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this.o(f.location,m?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,m,k,T,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:T,color:n.ThemeColor.isThemeColor(O)?O.id:void 0,location:m?.location||this.o(f,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(f,m){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in f?{viewColumn:r.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.n=f}setExitStatus(f,m){this.h=Object.freeze({code:f,reason:m})}setDimensions(f,m){return f===this.d&&m===this.g||f===0||m===0?!1:(this.d=f,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(f){this.k=f}_setProcessId(f){this.f?(this.f(f),this.f=void 0):this.b.then(m=>{m!==f&&(this.b=Promise.resolve(f))})}}e.$Qgc=s;class a{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new S.$Wd,this.onProcessData=this.a.event,this.b=new S.$Wd,this.d=new S.$Wd,this.onDidChangeProperty=this.d.event,this.f=new S.$Wd,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,m){this.g.setDimensions?.({columns:f,rows:m})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,i=class extends g.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,m,k){super(),this.Q=m,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new g.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new S.$Wd,this.onDidCloseTerminal=this.H.event,this.I=new S.$Wd,this.onDidOpenTerminal=this.I.event,this.J=new S.$Wd,this.onDidChangeActiveTerminal=this.J.event,this.L=new S.$Wd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new S.$Wd,this.onDidChangeTerminalState=this.M.event,this.N=new S.$Wd,this.onDidChangeShell=this.N.event,this.O=new S.$Wd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new S.$Wd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(M.$jL.MainThreadTerminalService),this.y=new $.$zsb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:T=>{const O=G=>{const q=G;return this.W(q.instanceId)?.value};switch(T?.$mid){case 15:return O(T);default:{if(Array.isArray(T))for(let G=0;G<T.length&&T[G].$mid===15;G++)T[G]=O(T[G]);return T}}}}),this.B({dispose:()=>{for(const[T,O]of this.g)O.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,m){const k=new s(this.a,(0,p.$rg)(),f,f.name),T=new a(f.pty);return k.createExtensionTerminal(f.location,m,this.R(f,m).resolvedExtHostIdentifier,y(f.iconPath),d(f.color)).then(O=>{const G=this.S(O,T);this.h[O]=G}),this.f.push(k),k.value}R(f,m){if(m=m||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const k=f.location.parentTerminal;if(k){const T=this.f.find(O=>O.value===k);T&&(m.resolvedExtHostIdentifier=T._id)}}else f.location&&typeof f.location!="object"?m.location=f.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(f,m){if(!this.W(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const T=new a(m),O=this.S(f,T);this.h[f]=O}async $acceptActiveTerminalChanged(f){const m=this.b;if(f===null){this.b=void 0,m!==this.b&&this.J.fire(this.b);return}const k=this.W(f);k&&(this.b=k,m!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,m){const k=this.W(f);k&&this.O.fire({terminal:k.value,data:m})}async $acceptTerminalDimensions(f,m,k){const T=this.W(f);T&&T.setDimensions(m,k)&&this.L.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptDidExecuteCommand(f,m){const k=this.W(f);k&&this.P.fire({terminal:k.value,...m})}async $acceptTerminalMaximumDimensions(f,m,k){this.g.get(f)?.resize(m,k)}async $acceptTerminalTitleChange(f,m){const k=this.W(f);k&&(k.name=m)}async $acceptTerminalClosed(f,m,k){const T=this.Y(this.f,f);if(T!==null){const O=this.f.splice(T,1)[0];O.setExitStatus(m,k),this.H.fire(O.value)}}$acceptTerminalOpened(f,m,k,T){if(m){const q=this.Y(this.f,m);if(q!==null){this.f[q]._id=f,this.I.fire(this.terminals[q]),this.f[q].isOpen=!0;return}}const O={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:R.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},G=new s(this.a,f,O,k);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(f,m){this.W(f)?._setProcessId(m)}async $startExtensionTerminal(f,m){const k=this.W(f);if(!k)return{message:(0,E.localize)(0,null,f)};k.isOpen||await new Promise(O=>{const G=this.onDidOpenTerminal(async q=>{q===k.value&&(G.dispose(),O())})});const T=this.g.get(f);T?T.startSendingEvents(m):this.j[f]={initialDimensions:m}}S(f,m){const k=new g.$Sc;k.add(m.onProcessReady(O=>this.a.$sendProcessReady(f,O.pid,O.cwd,O.windowsPty))),k.add(m.onDidChangeProperty(O=>this.a.$sendProcessProperty(f,O))),this.y.startBuffering(f,m.onProcessData),k.add(m.onProcessExit(O=>this.U(f,O))),this.g.set(f,m);const T=this.j[f];return T&&m instanceof a&&(m.startSendingEvents(T.initialDimensions),delete this.j[f]),k}$acceptProcessAckDataEvent(f,m){this.g.get(f)?.acknowledgeDataEvent(m)}$acceptProcessInput(f,m){this.g.get(f)?.input(m)}$acceptTerminalInteraction(f){const m=this.W(f);m?.setInteractedWith()&&this.M.fire(m.value)}$acceptTerminalSelection(f,m){this.W(f)?.setSelection(m)}$acceptProcessResize(f,m,k){try{this.g.get(f)?.resize(m,k)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(f,m){this.g.get(f)?.shutdown(m)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(f,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(m=>this.a.$sendProcessProperty(f,{type:"cwd",value:m}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new h.$lL(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,m,k){if(this.C.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.C.set(m,k),this.a.$registerProfileProvider(m,f.identifier.value),new h.$lL(()=>{this.C.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(f,m,k){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,k),this.a.$registerQuickFixProvider(f,m),new h.$lL(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,m){const k=new l.$7d().token;if(k.isCancellationRequested)return;const T=this.D.get(f);if(!T)return;const O=await T.provideTerminalQuickFixes(m,k);if(O===null||Array.isArray(O)&&O.length===0)return;const G=new g.$Sc;if(this.w.value=G,!Array.isArray(O))return O?r.TerminalQuickFix.from(O,this.Q.converter,G):void 0;const q=[];for(const j of O){const C=r.TerminalQuickFix.from(j,this.Q.converter,G);C&&q.push(C)}return q}async $createContributedProfileTerminal(f,m){const k=new l.$7d().token;let T=await this.C.get(f)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,m);return}this.createTerminalFromOptions(T.options,m)}}async $provideLinks(f,m){const k=this.W(f);if(!k)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const O=new l.$7d;this.G.set(f,O);const G=[],q={terminal:k.value,line:m},j=[];for(const W of this.z)j.push(c.Promises.withAsyncBody(async se=>{O.token.onCancellationRequested(()=>se({provider:W,links:[]}));const ue=await W.provideTerminalLinks(q,O.token)||[];O.token.isCancellationRequested||se({provider:W,links:ue})}));const C=await Promise.all(j);if(O.token.isCancellationRequested)return[];const N=new Map;for(const W of C)W&&W.links.length>0&&G.push(...W.links.map(se=>{const ue={id:u++,startIndex:se.startIndex,length:se.length,label:se.tooltip};return N.set(ue.id,{provider:W.provider,link:se}),ue}));return this.F.set(f,N),G}$activateLink(f,m){const k=this.F.get(f)?.get(m);k&&k.provider.handleTerminalLink(k.link)}U(f,m){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const k=this.h[f];k&&(k.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,m)}W(f){return this.X(this.f,f)}X(f,m){const k=this.Y(f,m);return k!==null?f[k]:null}Y(f,m){const k=f.findIndex(T=>T._id===m);return k===-1?null:k}getEnvironmentVariableCollection(f){let m=this.n.get(f.identifier.value);return m||(m=new v,this.$(f.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}Z(f,m){const k=(0,D.$Or)(m.map),T=(0,D.$Pr)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(f,m.persistent,k.length===0?void 0:k,T)}$initEnvironmentVariableCollections(f){f.forEach(m=>{const k=m[0],T=new v(m[1]);this.$(k,T)})}$acceptDefaultProfile(f,m){const k=this.s;this.s=f,this.u=m,k?.path!==f.path&&this.N.fire(f.path)}$(f,m){this.n.set(f,m),m.onDidChangeCollection(()=>{this.Z(f,m)})}};e.$Rgc=i,e.$Rgc=i=Je([qe(1,t.$KN),qe(2,L.$oN)],i);class v{get persistent(){return this.b}set persistent(f){this.b=f,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(f){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new S.$Wd,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const m=this.h(f);let k=this.a.get(m);return k||(k=new o(this,f),this.a.set(m,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(f,m,k,T){this.f(f,{value:m,type:h.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:T})}append(f,m,k,T){this.f(f,{value:m,type:h.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:T})}prepend(f,m,k,T){this.f(f,{value:m,type:h.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:T})}f(f,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(f,m.scope),T=this.map.get(k),O=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!T||T.value!==m.value||T.type!==m.type||T.options?.applyAtProcessCreation!==O.applyAtProcessCreation||T.options?.applyAtShellIntegration!==O.applyAtShellIntegration||T.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const G=this.g(f,m.scope),q={variable:f,...m,options:O};this.map.set(G,q),this.d.fire()}}get(f,m){const k=this.g(f,m),T=this.map.get(k);return T?b(T):void 0}g(f,m){const k=this.h(m);return k.length?`${f}:::${k}`:f}h(f){return this.j(f?.workspaceFolder)??""}j(f){return f?f.uri.toString():void 0}getVariableMap(f){const m=new Map;for(const[k,T]of this.map)this.h(T.scope)===this.h(f)&&m.set(T.variable,b(T));return m}delete(f,m){const k=this.g(f,m);this.map.delete(k),this.d.fire()}clear(f){if(f?.workspaceFolder){for(const[m,k]of this.map)k.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(m);this.k(f)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(f,m){const k=this.h(m),T=this.descriptionMap.get(k);if(!T||T.description!==f){let O;typeof f=="string"?O=f:O=f?.value.split(`

`)[0];const G={description:O,scope:m};this.descriptionMap.set(k,G),this.d.fire()}}getDescription(f){const m=this.h(f);return this.descriptionMap.get(m)?.description}k(f){const m=this.h(f);this.descriptionMap.delete(m)}}class o{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,m){this.b=f,this.d=m,this.a=new S.$Wd}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,m,k){this.b.replace(f,m,k,this.d)}append(f,m,k){this.b.append(f,m,k,this.d)}prepend(f,m,k){this.b.prepend(f,m,k,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,m){this.b.getVariableMap(this.d).forEach((k,T)=>f.call(m,T,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let w=class extends i{constructor(f,m){super(!1,f,m)}createTerminal(f,m,k){throw new A.$_}createTerminalFromOptions(f,m){throw new A.$_}};e.$Sgc=w,e.$Sgc=w=Je([qe(0,t.$KN),qe(1,L.$oN)],w);function y(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function d(P){return n.ThemeColor.isThemeColor(P)?P:void 0}function b(P){const f={...P};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Re[273],Ae([1,0,11,23,21,5,244,98,6,26,16,33,14,3,17,110,8,7,48,76,59,24]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c,r,t,s,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=e.$Xhc=e.$Whc=e.$Vhc=void 0;let i=class extends h.$Tc{constructor(j,C,N,W){super(),this.w=W,this.f=this.B(new R.$Wd),this.g=new Map,this.s=this.B(new R.$Wd),this.onResultsChanged=this.f.event,this.results=[],this.h=j.getProxy(p.$jL.MainThreadTesting),this.m=new k(this.h),this.j=new y(this.h,C),N.registerArgumentProcessor({processArgument:se=>{switch(se?.$mid){case 16:{const ue=se,ye=ue.tests[ue.tests.length-1].item.extId;return this.g.get(t.$bK.root(ye))?.collection.tree.get(ye)?.actual??(0,n.$AN)(se)}case 18:{const{extId:ue,message:ye}=se;return{test:this.g.get(t.$bK.root(ue))?.collection.tree.get(ue)?.actual,message:c.TestMessage.to(ye)}}default:return se}}}),N.registerCommand(!1,"testing.getExplorerSelection",async()=>{const se=await N.executeCommand("_testing.getExplorerSelection"),ue=ye=>{const ke=this.g.get(t.$bK.root(ye));if(ke)return t.$bK.isRoot(ye)?ke.controller:ke.collection.tree.get(ye)?.actual};return{include:se?.include.map(ue).filter(A.$Rf)||[],exclude:se?.exclude.map(ue).filter(A.$Rf)||[]}})}createTestController(j,C,N,W){if(this.g.has(C))throw new Error(`Attempt to insert a duplicate controller with ID "${C}"`);const se=new h.$Sc,ue=se.add(new n.$DN(C,N,this.w));ue.root.label=N;const ye=new Map,ke=new Set,ae=this.h,pe={items:ue.root.children,get label(){return N},set label($e){N=$e,ue.root.label=$e,ae.$updateController(C,{label:N})},get refreshHandler(){return W},set refreshHandler($e){W=$e,ae.$updateController(C,{canRefresh:!!$e})},get id(){return C},createRunProfile:($e,ie,x,V,ne,Ie)=>{let Me=(0,g.$Vi)($e);for(;ye.has(Me);)Me++;return new O(this.h,ye,ke,this.s.event,C,Me,$e,ie,x,V,ne,Ie)},createTestItem($e,ie,x){return new n.$BN(C,$e,ie,x)},createTestRun:($e,ie,x=!0)=>this.j.createTestRun(j,C,ue,$e,ie,x),invalidateTestResults:$e=>{if($e===void 0)this.h.$markTestRetired(void 0);else{const ie=$e instanceof Array?$e:[$e];this.h.$markTestRetired(ie.map(x=>t.$bK.fromExtHostTestItem(x,C).toString()))}},set resolveHandler($e){ue.resolveHandler=$e},get resolveHandler(){return ue.resolveHandler},dispose:()=>{se.dispose()}};ae.$registerTestController(C,N,!!W),se.add((0,h.$Rc)(()=>ae.$unregisterTestController(C)));const oe={controller:pe,collection:ue,profiles:ye,extension:j,activeProfiles:ke};return this.g.set(C,oe),se.add((0,h.$Rc)(()=>this.g.delete(C))),se.add(ue.onDidGenerateDiff($e=>ae.$publishDiff(C,$e.map(a.TestsDiffOp.serialize)))),pe}createTestObserver(){return this.m.checkout()}async runTests(j,C=I.CancellationToken.None){const N=d(j);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.g.get(N.controllerId);if(!W)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(se=>t.$bK.fromExtHostTestItem(se,W.collection.root.id).toString())??[W.collection.root.id],profileGroup:G[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:j.exclude?.map(se=>se.id)},C)}$syncTests(){for(const{collection:j}of this.g.values())j.flushDiff();return Promise.resolve()}async $provideFileCoverage(j,C,N){return await this.j.getCoverageReport(j,C)?.provideFileCoverage(N)??[]}async $resolveFileCoverage(j,C,N,W){return await this.j.getCoverageReport(j,C)?.resolveFileCoverage(N,W)??[]}$configureRunProfile(j,C){this.g.get(j)?.profiles.get(C)?.configureHandler?.()}$setDefaultRunProfiles(j){const C=new Map;for(const[N,W]of Object.entries(j)){const se=this.g.get(N);if(!se)continue;const ue=new Map,ye=W.filter(ae=>!se.activeProfiles.has(ae)),ke=[...se.activeProfiles].filter(ae=>!W.includes(ae));for(const ae of ye)ue.set(ae,!0),se.activeProfiles.add(ae);for(const ae of ke)ue.set(ae,!1),se.activeProfiles.delete(ae);ue.size&&C.set(N,ue)}this.s.fire(C)}async $refreshTests(j,C){await this.g.get(j)?.controller.refreshHandler?.(C)}$publishTestResults(j){this.results=Object.freeze(j.map(C=>(0,E.$zn)(c.TestResults.to(C))).concat(this.results).sort((C,N)=>N.completedAt-C.completedAt).slice(0,32)),this.f.fire()}async $expandTest(j,C){const N=this.g.get(t.$bK.fromString(j).controllerId)?.collection;N&&(await N.expand(j,C<0?1/0:C),N.flushDiff())}$acceptDiff(j){this.m.applyDiff(j.map(C=>a.TestsDiffOp.deserialize({asCanonicalUri:N=>N},C)))}async $runControllerTests(j,C){return Promise.all(j.map(N=>this.y(N,!1,C)))}async $startContinuousRun(j,C){const N=new I.$7d(C),W=await Promise.all(j.map(se=>this.y(se,!0,N.token)));return!C.isCancellationRequested&&!W.some(se=>se.error)&&await new Promise(se=>C.onCancellationRequested(se)),N.dispose(!0),W}async y(j,C,N){const W=this.g.get(j.controllerId);if(!W)return{};const{collection:se,profiles:ue,extension:ye}=W,ke=ue.get(j.profileId);if(!ke)return{};const ae=j.testIds.map(ie=>se.tree.get(ie)).filter(A.$Rf),pe=j.excludeExtIds.map(ie=>W.collection.tree.get(ie)).filter(A.$Rf).filter(ie=>ae.some(x=>x.fullId.compare(ie.fullId)===2));if(!ae.length)return{};const oe=new r.$VM(ae.some(ie=>ie.actual instanceof n.$CN)?void 0:ae.map(ie=>ie.actual),pe.map(ie=>ie.actual),ke,C),$e=(0,a.$dK)(j)&&this.j.prepareForMainThreadTestRun(oe,b.fromInternal(j,W.collection),ye,N);try{return await ke.runHandler(oe,N),{}}catch(ie){return{error:String(ie)}}finally{$e&&($e.hasRunningTasks&&!N.isCancellationRequested&&await R.Event.toPromise($e.onEnd),$e.dispose())}}$cancelExtensionTestRun(j){j===void 0?this.j.cancelAllRuns():this.j.cancelRunById(j)}};e.$Vhc=i,e.$Vhc=i=Je([qe(0,$.$oN),qe(1,l.$pj)],i);const v=1e4;var o;(function(q){q[q.Running=0]="Running",q[q.Cancelling=1]="Cancelling",q[q.Ended=2]="Ended"})(o||(o={}));class w extends h.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(j,C,N,W,se){super(),this.s=j,this.w=C,this.y=N,this.z=W,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$Wd),this.m=this.B(new R.$Wd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new I.$7d(se));const ue=this.B(new S.$hh(()=>this.C(),v));this.B(this.h.token.onCancellationRequested(()=>ue.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(j){const C=this.s.id,N=this.s.controllerId,W=(0,D.$rg)(),se=this.y,ue=this.m;let ye;const ke=$e=>(ie,...x)=>{if(pe){this.z.warn(`Setting the state of test "${ie.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ie)&&(this.F(ie),$e(ie,...x))},ae=($e,ie)=>{const x=ie instanceof Array?ie.map(c.TestMessage.from):[c.TestMessage.from(ie)];if($e.uri&&$e.range){const V={range:c.Range.from($e.range),uri:$e.uri};for(const ne of x)ne.location=ne.location||V}this.w.$appendTestMessagesInRun(C,W,t.$bK.fromExtHostTestItem($e,N).toString(),x)};let pe=!1;const oe={isPersisted:this.s.isPersisted,token:this.h.token,name:j,get coverageProvider(){return ye?.provider},set coverageProvider($e){(0,u.$LF)(se,"testCoverage"),ye=$e&&new P($e),ue.fire({taskId:W,runId:C,coverage:ye})},enqueued:ke($e=>{this.w.$updateTestStateInRun(C,W,t.$bK.fromExtHostTestItem($e,N).toString(),1)}),skipped:ke($e=>{this.w.$updateTestStateInRun(C,W,t.$bK.fromExtHostTestItem($e,N).toString(),5)}),started:ke($e=>{this.w.$updateTestStateInRun(C,W,t.$bK.fromExtHostTestItem($e,N).toString(),2)}),errored:ke(($e,ie,x)=>{ae($e,ie),this.w.$updateTestStateInRun(C,W,t.$bK.fromExtHostTestItem($e,N).toString(),6,x)}),failed:ke(($e,ie,x)=>{ae($e,ie),this.w.$updateTestStateInRun(C,W,t.$bK.fromExtHostTestItem($e,N).toString(),4,x)}),passed:ke(($e,ie)=>{this.w.$updateTestStateInRun(C,W,t.$bK.fromExtHostTestItem($e,this.s.controllerId).toString(),3,ie)}),appendOutput:($e,ie,x)=>{pe||(x&&(this.s.isIncluded(x)?this.F(x):x=void 0),this.w.$appendOutputToRun(C,W,M.$ke.fromString($e),ie&&c.location.from(ie),x&&t.$bK.fromExtHostTestItem(x,N).toString()))},end:()=>{pe||(pe=!0,this.w.$finishedTestRunTask(C,W),this.f.delete(W),this.f.size||this.D())}};return this.f.set(W,{run:oe}),this.w.$startedTestRunTask(C,{id:W,name:j,running:!0}),oe}C(){for(const{run:j}of this.f.values())j.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(j){if(!(j instanceof n.$BN))throw new s.$gN(j.id);if(this.g.has(t.$bK.fromExtHostTestItem(j,this.s.controllerId).toString()))return;const C=[],N=this.s.colllection.root;for(;;){const W=c.TestItem.from(j);if(C.unshift(W),this.g.has(W.extId)||(this.g.add(W.extId),j===N))break;j=j.parent||N}this.w.$addTestsToRun(this.s.controllerId,this.s.id,C)}dispose(){this.D(),super.dispose()}}class y{get trackers(){return this.c.values()}constructor(j,C){this.g=j,this.h=C,this.c=new Map,this.f=[]}getCoverageReport(j,C){return this.f.find(N=>N.runId===j)?.coverage.get(C)}prepareForMainThreadTestRun(j,C,N,W){return this.j(j,C,N,W)}cancelRunById(j){for(const C of this.c.values())if(C.id===j){C.cancel();return}}cancelAllRuns(){for(const j of this.c.values())j.cancel()}createTestRun(j,C,N,W,se,ue){const ye=this.c.get(W);if(ye)return ye.createRun(se);const ke=b.fromPublic(C,N,W,ue),ae=d(W);this.g.$startedExtensionTestRun({controllerId:C,continuous:!!W.continuous,profile:ae&&{group:G[ae.kind],id:ae.profileId},exclude:W.exclude?.map(oe=>t.$bK.fromExtHostTestItem(oe,N.root.id).toString())??[],id:ke.id,include:W.include?.map(oe=>t.$bK.fromExtHostTestItem(oe,N.root.id).toString())??[N.root.id],persist:ue});const pe=this.j(W,ke,j);return R.Event.once(pe.onEnd)(()=>{this.g.$finishedExtensionTestRun(ke.id),pe.dispose()}),pe.createRun(se)}j(j,C,N,W){const se=new w(C,this.g,N,this.h,W);this.c.set(j,se);let ue;const ye=se.onDidCoverage(({runId:ke,taskId:ae,coverage:pe})=>{ue||(ue={runId:ke,coverage:new Map},this.f.unshift(ue),this.f.length>a.$iK&&this.f.pop()),ue.coverage.set(ae,pe),this.g.$signalCoverageAvailable(ke,ae,!!pe)});return R.Event.once(se.onEnd)(()=>{this.c.delete(j),ye.dispose()}),se}}e.$Whc=y;const d=q=>{if(q.profile){if(!(q.profile instanceof O))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return q.profile}};class b{static fromPublic(j,C,N,W){return new b(j,(0,D.$rg)(),N.include?.map(se=>t.$bK.fromExtHostTestItem(se,j).toString())??[j],N.exclude?.map(se=>t.$bK.fromExtHostTestItem(se,j).toString())??[],W,C)}static fromInternal(j,C){return new b(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,C)}constructor(j,C,N,W,se,ue){this.controllerId=j,this.id=C,this.isPersisted=se,this.colllection=ue,this.c=N.map(ye=>ye+"\0"),this.f=W.map(ye=>ye+"\0")}isIncluded(j){const C=t.$bK.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const N of this.f)if(C===N||C.startsWith(N))return!1;for(const N of this.c)if(C===N||C.startsWith(N))return!0;return!1}}e.$Xhc=b;class P{constructor(j){this.provider=j}async provideFileCoverage(j){this.c||(this.c=(async()=>this.provider.provideFileCoverage(j))());try{return(await this.c)?.map(c.TestCoverage.fromFile)??[]}catch(C){throw this.c=void 0,C}}async resolveFileCoverage(j,C){const N=await this.c;let W=N?.[j];return!this.provider||!N||!W?[]:(W.detailedCoverage||(W=N[j]=await this.provider.resolveFileCoverage?.(W,C)??W),W.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class f{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(j){this.j=j,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(j){this.c.add(j)}update(j){Object.assign(j.revived,c.TestItem.toPlain(j.item)),this.c.has(j)||this.f.add(j)}remove(j){if(this.c.has(j)){this.c.delete(j);return}this.f.delete(j);const C=t.$bK.parentId(j.item.extId);if(C&&this.h.has(C.toString())){this.h.add(j.item.extId);return}this.g.add(j)}getChangeEvent(){const{c:j,f:C,g:N}=this;return{get added(){return[...j].map(W=>W.revived)},get updated(){return[...C].map(W=>W.revived)},get removed(){return[...N].map(W=>W.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class m extends a.$jK{constructor(){super(...arguments),this.s=new R.$Wd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(j){return this.f.get(j)}getMirroredTestDataByReference(j){return this.f.get(j.id)}w(j,C){return{...j,revived:c.TestItem.toPlain(j.item),depth:C?C.depth+1:0,children:new Set}}v(){return new f(this.s)}}class k{constructor(j){this.f=j}checkout(){this.c||(this.c=this.g());const j=this.c;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(C=>C.revived)},dispose:(0,L.$db)(()=>{--j.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(j){return this.c?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.c?.tests.apply(j)}g(){const j=new m({asCanonicalUri:C=>C});return this.f.$subscribeToDiffs(),{observers:0,tests:j}}}const T=(q,j,C,N)=>{C?Object.assign(C,N):j.$updateTestRunConfig(q.controllerId,q.profileId,N)};class O{#e;#t;#i;#n;#s;get label(){return this.f}set label(j){j!==this.f&&(this.f=j,T(this,this.#e,this.#n,{label:j}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(j){j!==this.g&&(this.g=j,T(this,this.#e,this.#n,{supportsContinuousRun:j}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(j){j!==this.isDefault&&(j?this.#t.add(this.profileId):this.#t.delete(this.profileId),T(this,this.#e,this.#n,{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,T(this,this.#e,this.#n,{tag:j?c.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.c}set configureHandler(j){j!==this.c&&(this.c=j,T(this,this.#e,this.#n,{hasConfigurationHandler:!!j}))}get onDidChangeDefault(){return R.Event.chain(this.#i,j=>j.map(C=>C.get(this.controllerId)?.get(this.profileId)).filter(A.$Rf))}constructor(j,C,N,W,se,ue,ye,ke,ae,pe=!1,oe=void 0,$e=!1){this.controllerId=se,this.profileId=ue,this.f=ye,this.kind=ke,this.runHandler=ae,this._tag=oe,this.g=$e,this.#e=j,this.#s=C,this.#t=N,this.#i=W,C.set(ue,this);const ie=G[ke];if(typeof ie!="number")throw new Error(`Unknown TestRunProfile.group ${ke}`);pe&&N.add(ue),this.#n={profileId:ue,controllerId:se,tag:oe?c.TestTag.namespace(this.controllerId,oe.id):null,label:ye,group:ie,isDefault:pe,hasConfigurationHandler:!1,supportsContinuousRun:$e},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Yhc=O;const G={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(Re[111],Ae([1,0,54,15,89,8,7]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=e.$wN=e.$vN=void 0;class g{static{this.c=new I.$tN("TextEditorDecorationType")}constructor(l,p,$){const n=g.c.nextId();l.$registerTextEditorDecorationType(p.identifier,n,R.DecorationRenderOptions.from($)),this.value=Object.freeze({key:n,dispose(){l.$removeTextEditorDecorationType(n)}})}}e.$vN=g;class h{constructor(l,p){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,p){this.k();let $=null;if(l instanceof L.$mL)$=new L.$nL(l,l);else if(l instanceof L.$nL)$=l;else throw new Error("Unrecognized location");this.l($,p,!1)}insert(l,p){this.k(),this.l(new L.$nL(l,l),p,!0)}delete(l){this.k();let p=null;if(l instanceof L.$nL)p=l;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(l,p,$){const n=this.c.validateRange(l);this.g.push({range:n,text:p,forceMoveMarkers:$})}setEndOfLine(l){if(this.k(),l!==L.EndOfLine.LF&&l!==L.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=l}}class E{constructor(l,p,$,n){this.c=l,this.d=p,this._accept($),this.e=n;const c=this;this.value={get tabSize(){return c.f},set tabSize(r){c.n(r)},get indentSize(){return c.g},set indentSize(r){c.p(r)},get insertSpaces(){return c.j},set insertSpaces(r){c.s(r)},get cursorStyle(){return c.k},set cursorStyle(r){c.t(r)},get lineNumbers(){return c.l},set lineNumbers(r){c.u(r)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}n(l){const p=this.m(l);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}p(l){const p=this.o(l);if(p!==null){if(typeof p=="number"){if(this.h===p)return;this.g=p,this.h=p}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const p=this.q(l);if(typeof p=="boolean"){if(this.j===p)return;this.j=p}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(l)})))}assign(l){const p={};let $=!1;if(typeof l.tabSize<"u"){const n=this.m(l.tabSize);n==="auto"?($=!0,p.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,$=!0,p.tabSize=n)}if(typeof l.indentSize<"u"){const n=this.o(l.indentSize);n==="tabSize"?($=!0,p.indentSize=n):typeof n=="number"&&this.h!==n&&(this.g=n,this.h=n,$=!0,p.indentSize=n)}if(typeof l.insertSpaces<"u"){const n=this.q(l.insertSpaces);n==="auto"?($=!0,p.insertSpaces=n):this.j!==n&&(this.j=n,$=!0,p.insertSpaces=n)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,$=!0,p.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,$=!0,p.lineNumbers=R.TextEditorLineNumbersStyle.from(l.lineNumbers)),$&&this.v("setOptions",this.c.$trySetOptions(this.d,p))}v(l,p){p.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn($)})}}e.$wN=E;class A{constructor(l,p,$,n,c,r,t,s){this.id=l,this.j=p,this.k=$,this.g=!1,this.h=new Set,this.c=c,this.d=new E(this.j,this.id,r,$),this.e=t,this.f=s;const a=this;this.value=Object.freeze({get document(){return n.value},set document(u){throw new M.$9("document")},get selection(){return a.c&&a.c[0]},set selection(u){if(!(u instanceof L.$oL))throw(0,M.$7)("selection");a.c=[u],a.l()},get selections(){return a.c},set selections(u){if(!Array.isArray(u)||u.some(i=>!(i instanceof L.$oL)))throw(0,M.$7)("selections");a.c=u,a.l()},get visibleRanges(){return a.e},set visibleRanges(u){throw new M.$9("visibleRanges")},get options(){return a.d.value},set options(u){a.g||a.d.assign(u)},get viewColumn(){return a.f},set viewColumn(u){throw new M.$9("viewColumn")},edit(u,i={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const v=new h(n.value,i);return u(v),a.m(v)},insertSnippet(u,i,v={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!i||Array.isArray(i)&&i.length===0)o=a.c.map(w=>R.Range.from(w));else if(i instanceof L.$mL){const{lineNumber:w,column:y}=R.Position.from(i);o=[{startLineNumber:w,startColumn:y,endLineNumber:w,endColumn:y}]}else if(i instanceof L.$nL)o=[R.Range.from(i)];else{o=[];for(const w of i)if(w instanceof L.$nL)o.push(R.Range.from(w));else{const{lineNumber:y,column:d}=R.Position.from(w);o.push({startLineNumber:y,startColumn:d,endLineNumber:y,endColumn:d})}}return p.$tryInsertSnippet(l,n.value.version,u.value,o,v)},setDecorations(u,i){const v=i.length===0;v&&!a.h.has(u.key)||(v?a.h.delete(u.key):a.h.add(u.key),a.n(()=>{if(R.$lN(i))return p.$trySetDecorations(l,u.key,R.$mN(i));{const o=new Array(4*i.length);for(let w=0,y=i.length;w<y;w++){const d=i[w];o[4*w]=d.start.line+1,o[4*w+1]=d.start.character+1,o[4*w+2]=d.end.line+1,o[4*w+3]=d.end.character+1}return p.$trySetDecorationsFast(l,u.key,o)}}))},revealRange(u,i){a.n(()=>p.$tryRevealRange(l,R.Range.from(u),i||L.TextEditorRevealType.Default))},show(u){p.$tryShowEditor(l,R.ViewColumn.from(u))},hide(){p.$tryHideEditor(l)}})}dispose(){(0,S.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,S.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,S.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,S.ok)(!this.g),this.f=l}_acceptSelections(l){(0,S.ok)(!this.g),this.c=l}async l(){const l=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const p=l.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const $=p.edits.map(c=>c.range);$.sort((c,r)=>c.end.line===r.end.line?c.end.character===r.end.character?c.start.line===r.start.line?c.start.character-r.start.character:c.start.line-r.start.line:c.end.character-r.end.character:c.end.line-r.end.line);for(let c=0,r=$.length-1;c<r;c++){const t=$[c].end;if($[c+1].start.isBefore(t))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=p.edits.map(c=>({range:R.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,n,{setEndOfLine:typeof p.setEndOfLine=="number"?R.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$xN=A}),define(Re[66],Ae([1,0,54,5,6,2,4,3,108,17,111,8,14,28,12,68,39]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=e.$yN=void 0;class r{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let t=class{constructor(a,u){this.h=a,this.i=u,this.a=null,this.b=new Map,this.c=new p.$Ac,this.d=new M.$Wd,this.e=new M.$Wd,this.f=new M.$Wd,this.g=new M.$Wd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const u=[],i=[],v=[];if(a.removedDocuments)for(const o of a.removedDocuments){const w=R.URI.revive(o),y=this.c.get(w);y?.unref()&&(this.c.delete(w),u.push(y.value))}if(a.addedDocuments)for(const o of a.addedDocuments){const w=R.URI.revive(o.uri);let y=this.c.get(w);if(y&&w.scheme!==$.Schemas.vscodeNotebookCell&&w.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${w} already exists!'`);y||(y=new r(new h.$rN(this.h.getProxy(g.$jL.MainThreadDocuments),w,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this.c.set(w,y),i.push(y.value)),y.ref()}if(a.removedEditors)for(const o of a.removedEditors){const w=this.b.get(o);this.b.delete(o),w&&v.push(w)}if(a.addedEditors)for(const o of a.addedEditors){const w=R.URI.revive(o.documentUri);S.ok(this.c.has(w),`document '${w}' does not exist`),S.ok(!this.b.has(o.id),`editor '${o.id}' already exists!`);const y=this.c.get(w).value,d=new A.$xN(o.id,this.h.getProxy(g.$jL.MainThreadTextEditors),this.i,new c.$V(()=>y.document),o.selections.map(D.Selection.to),o.options,o.visibleRanges.map(b=>D.Range.to(b)),typeof o.editorPosition=="number"?D.ViewColumn.to(o.editorPosition):void 0);this.b.set(o.id,d)}a.newActiveEditor!==void 0&&(S.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,I.$Oc)(u),(0,I.$Oc)(v),a.removedDocuments&&this.e.fire(u),a.addedDocuments&&this.d.fire(i),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(o=>o.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return n.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const u=this.b.get(this.a);return a?u:u?.value}allEditors(){return[...this.b.values()]}};e.$yN=t,e.$yN=t=Je([qe(0,E.$oN),qe(1,l.$pj)],t),e.$zN=(0,L.$8h)("IExtHostDocumentsAndEditors")}),define(Re[274],Ae([1,0,18,5,3,111,8,7]),function(me,e,S,M,I,R,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;class h{constructor(A,D){this.i=D,this.a=new M.$Wd,this.b=new M.$Wd,this.c=new M.$Wd,this.d=new M.$Wd,this.f=new M.$Wd,this.g=new M.$Wd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(I.$jL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const D=this.i.allEditors();return A?D:D.map(l=>l.value)}async showTextDocument(A,D,l){let p;typeof D=="number"?p={position:L.ViewColumn.from(D),preserveFocus:l}:typeof D=="object"?p={position:L.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?L.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:p={preserveFocus:!1};const $=await this.h.$tryShowTextDocument(A.uri,p),n=$&&this.i.getEditor($);if(n)return n.value;throw $?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,D){return new R.$vN(this.h,A,D).value}$acceptEditorPropertiesChanged(A,D){const l=this.i.getEditor(A);if(!l)throw new Error("unknown text editor");if(D.options&&l._acceptOptions(D.options),D.selections){const p=D.selections.selections.map(L.Selection.to);l._acceptSelections(p)}if(D.visibleRanges){const p=S.$Hb(D.visibleRanges.map(L.Range.to));l._acceptVisibleRanges(p)}if(D.options&&this.b.fire({textEditor:l.value,options:{...D.options,lineNumbers:L.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const p=g.TextEditorSelectionChangeKind.fromValue(D.selections.source),$=D.selections.selections.map(L.Selection.to);this.a.fire({textEditor:l.value,selections:$,kind:p})}if(D.visibleRanges){const p=S.$Hb(D.visibleRanges.map(L.Range.to));this.c.fire({textEditor:l.value,visibleRanges:p})}}$acceptEditorPositionData(A){for(const D in A){const l=this.i.getEditor(D);if(!l)throw new Error("Unknown text editor");const p=L.ViewColumn.to(A[D]);l.value.viewColumn!==p&&(l._acceptViewColumn(p),this.d.fire({textEditor:l.value,viewColumn:p}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$igc=h}),define(Re[275],Ae([1,0,2,4,3,6,7,8,22,16]),function(me,e,S,M,I,R,L,g,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=e.$1hc=void 0,e.$1hc=(0,M.$8h)("IExtHostTimeline");class A{constructor(p,$){this.b=new Map,this.c=new Map,this.a=p.getProxy(I.$jL.MainThreadTimeline),$.registerArgumentProcessor({processArgument:(n,c)=>{if(n&&n.$mid===12)if(this.b.get(n.source)&&h.$nm.equals(c,this.b.get(n.source)?.extension)){const r=n.uri===void 0?void 0:S.URI.revive(n.uri);return this.c.get(n.source)?.get(D(r))?.get(n.handle)}else return;return n}})}async $getTimeline(p,$,n,c){return this.b.get(p)?.provider.provideTimeline(S.URI.revive($),n,c)}registerTimelineProvider(p,$,n,c){const r=new R.$Sc,t=this.d($.id,c,r).bind(this);let s;$.onDidChange&&(s=$.onDidChange(u=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:$.id}),this));const a=this.c;return this.f({...$,scheme:p,onDidChange:void 0,async provideTimeline(u,i,v){i?.resetCache&&(r.clear(),a.get($.id)?.clear());const o=await $.provideTimeline(u,i,v);if(o==null)return;const w=t(u,i);return{...o,source:$.id,items:o.items.map(w)}},dispose(){for(const u of a.values())u.get($.id)?.clear();s?.dispose(),r.dispose()}},n)}d(p,$,n){return(c,r)=>{let t;if(r?.cacheResults){let s=this.c.get(p);s===void 0&&(s=new Map,this.c.set(p,s));const a=D(c);t=s.get(a),t===void 0&&(t=new Map,s.set(a,t))}return s=>{const{iconPath:a,...u}=s,i=`${p}|${s.id??s.timestamp}`;t?.set(i,s);let v,o,w;s.iconPath&&(a instanceof L.$gM?w={id:a.id,color:a.color}:S.URI.isUri(a)?(v=a,o=a):{light:v,dark:o}=a);let y;return L.$ML.isMarkdownString(u.tooltip)?y=g.MarkdownString.from(u.tooltip):(0,E.$Jf)(u.tooltip)?y=u.tooltip:L.$ML.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=g.MarkdownString.from(u.detail)):(0,E.$Jf)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=u.detail),{...u,id:u.id??void 0,handle:i,source:p,command:s.command?$.toInternal(s.command,n):void 0,icon:v,iconDark:o,themeIcon:w,tooltip:y,accessibilityInformation:s.accessibilityInformation}}}}f(p,$){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:$}),(0,R.$Rc)(()=>{for(const c of this.c.values())c.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$2hc=A;function D(l){return l?.toString()}}),define(Re[276],Ae([1,0,166,25,2,5,6,204,11,7,16,18,8,52,21,132,24]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;function r(a,u){if((0,A.$Jf)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let i;return Array.isArray(a.highlights)&&(i=a.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),i=i.length?i:void 0),{label:a.label,highlights:i}}}class t extends L.$Tc{constructor(u,i,v){super(),this.f=u,this.g=i,this.h=v,this.a=new Map,this.b=new n.$E8;function o(w){return w&&w.$treeViewId&&(w.$treeItemHandle||w.$selectedTreeItems||w.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:w=>o(w)?this.r(w):Array.isArray(w)&&w.length>0?w.map(y=>o(y)?this.r(y):y):w})}registerTreeDataProvider(u,i,v){const o=this.createTreeView(u,{treeDataProvider:i},v);return{dispose:()=>o.dispose()}}createTreeView(u,i,v){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=i.dragAndDropController?.dropMimeTypes??[],w=i.dragAndDropController?.dragMimeTypes??[],y=!!i.dragAndDropController?.handleDrag,d=!!i.dragAndDropController?.handleDrop,b=this.m(u,i,v),P={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:o,dragMimeTypes:w,hasHandleDrag:y,hasHandleDrop:d,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},f=this.f.$registerTreeViewDataProvider(u,P),m={get onDidCollapseElement(){return b.onDidCollapseElement},get onDidExpandElement(){return b.onDidExpandElement},get selection(){return b.selectedElements},get onDidChangeSelection(){return b.onDidChangeSelection},get activeItem(){return(0,c.$LF)(v,"treeViewActiveItem"),b.focusedElement},get onDidChangeActiveItem(){return(0,c.$LF)(v,"treeViewActiveItem"),b.onDidChangeActiveItem},get visible(){return b.visible},get onDidChangeVisibility(){return b.onDidChangeVisibility},get onDidChangeCheckboxState(){return b.onDidChangeCheckboxState},get message(){return b.message},set message(k){(0,p.$lk)(k)&&(0,c.$LF)(v,"treeViewMarkdownMessage"),b.message=k},get title(){return b.title},set title(k){b.title=k},get description(){return b.description},set description(k){b.description=k},get badge(){return b.badge},set badge(k){k!==void 0&&E.ViewBadge.isViewBadge(k)?b.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(b.badge=void 0)},reveal:(k,T)=>b.reveal(k,T),dispose:async()=>{await f,this.a.delete(u),b.dispose()}};return this.B(m),m}$getChildren(u,i){const v=this.a.get(u);return v?v.getChildren(i):Promise.reject(new g.$eF(u))}async $handleDrop(u,i,v,o,w,y,d,b){const P=this.a.get(u);if(!P)return Promise.reject(new g.$eF(u));const f=l.DataTransfer.toDataTransfer(v,async m=>(await this.f.$resolveDropFileData(u,i,m)).buffer);return d===u&&b&&await this.j(f,P,b,w,y),P.onDrop(f,o,w)}async j(u,i,v,o,w){const y=this.b.removeDragOperationTransfer(w);if(y)(await y)?.forEach((d,b)=>{d&&u.set(b,d)});else if(w&&i.handleDrag){const d=i.handleDrag(v,u,o);this.b.addDragOperationTransfer(w,d),await d}return u}async $handleDrag(u,i,v,o){const w=this.a.get(u);if(!w)return Promise.reject(new g.$eF(u));const y=await this.j(new E.$dM,w,i,o,v);if(!(!y||o.isCancellationRequested))return l.DataTransfer.from(y)}async $hasResolve(u){const i=this.a.get(u);if(!i)throw new g.$eF(u);return i.hasResolve}$resolve(u,i,v){const o=this.a.get(u);if(!o)throw new g.$eF(u);return o.resolveTreeItem(i,v)}$setExpanded(u,i,v){const o=this.a.get(u);if(!o)throw new g.$eF(u);o.setExpanded(i,v)}$setSelectionAndFocus(u,i,v){const o=this.a.get(u);if(!o)throw new g.$eF(u);o.setSelectionAndFocus(i,v)}$setVisible(u,i){const v=this.a.get(u);if(!v){if(!i)return;throw new g.$eF(u)}v.setVisible(i)}$changeCheckboxState(u,i){const v=this.a.get(u);if(!v)throw new g.$eF(u);v.setCheckboxState(i)}m(u,i,v){const o=this.B(new s(u,i,this.f,this.g.converter,this.h,v));return this.a.set(u,o),o}r(u){const i=this.a.get(u.$treeViewId);return i&&"$treeItemHandle"in u?i.getExtensionElement(u.$treeItemHandle):i&&"$focusedTreeItem"in u&&u.$focusedTreeItem?i.focusedElement:null}}e.$3hc=t;class s extends L.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(u=>this.getExtensionElement(u)).filter(u=>!(0,A.$Sf)(u))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(u,i,v,o,w,y){if(super(),this.I=u,this.J=v,this.L=o,this.M=w,this.N=y,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$Wd),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$Wd),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$Wd),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$Wd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$Wd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$Wd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$Wd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new $.$7d,y.contributes&&y.contributes.views)for(const f in y.contributes.views)for(const m of y.contributes.views[f])m.id===u&&(this.P=m.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(f=>this.F.fire({message:!1,element:f})));let d,b;const P=R.Event.debounce(this.F.event,(f,m)=>(f||(f={message:!1,elements:[]}),m.element!==!1&&(d||(d=new Promise(k=>b=k),this.G=this.G.then(()=>d)),Array.isArray(m.element)?f.elements.push(...m.element):f.elements.push(m.element)),m.message&&(f.message=!0),f),200,!0);this.B(P(({message:f,elements:m})=>{m.length&&(this.H=this.H.then(()=>{const k=b;return d=null,this.$(m).then(()=>k())})),f&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(u){const i=u?this.getExtensionElement(u):void 0;if(u&&!i)return this.M.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let v=this.X(u);return v||(v=await this.Y(i)),v?v.map(o=>o.item):void 0}getExtensionElement(u){return this.j.get(u)}reveal(u,i){i=i||{select:!0,focus:!1};const v=(0,A.$Sf)(i.select)?!0:i.select,o=(0,A.$Sf)(i.focus)?!1:i.focus,w=(0,A.$Sf)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.G.then(()=>this.S(u)).then(y=>this.W(u,y[y.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:y.map(b=>b.item)},{select:v,focus:o,expand:w})),y=>this.M.error(y)):this.J.$reveal(this.I,void 0,{select:v,focus:o,expand:w})}get message(){return this.O}set message(u){this.O=u,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(u){this.P=u,this.J.$setTitle(this.I,u,this.Q)}get description(){return this.Q}set description(u){this.Q=u,this.J.$setTitle(this.I,this.P,u)}get badge(){return this.R}set badge(u){this.R?.value===u?.value&&this.R?.tooltip===u?.tooltip||(this.R=l.ViewBadge.from(u),this.J.$setBadge(this.I,u))}setExpanded(u,i){const v=this.getExtensionElement(u);v&&(i?this.u.fire(Object.freeze({element:v})):this.w.fire(Object.freeze({element:v})))}setSelectionAndFocus(u,i){const v=!(0,D.$ub)(this.s,u);this.s=u;const o=this.t!==i;this.t=i,v&&this.y.fire(Object.freeze({selection:this.selectedElements})),o&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this.r&&(this.r=u,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(u){const i=(await Promise.all(u.map(async v=>{const o=this.getExtensionElement(v.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:v.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(v=>v!==void 0);i.forEach(v=>{v.treeItem.checkboxState=v.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(v=>[v.extensionItem,v.newState])})}async handleDrag(u,i,v){const o=[];for(const w of u){const y=this.getExtensionElement(w);y&&o.push(y)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,i,v),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(u,i,v){const o=i?this.getExtensionElement(i):void 0;if(!(!o&&i||!this.g?.handleDrop))return(0,h.$Zg)(()=>this.g?.handleDrop?this.g.handleDrop(o,u,v):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(u,i){if(!this.f.resolveTreeItem)return;const v=this.j.get(u);if(v){const o=this.m.get(v);if(o){const w=await this.f.resolveTreeItem(o.extensionItem,v,i)??o.extensionItem;return this.hb(w),o.item.tooltip=this.eb(w.tooltip),o.item.command=this.fb(o.disposableStore,w.command),o.item}}}S(u){return this.U(u).then(i=>i?this.S(i).then(v=>this.W(i,v[v.length-1]).then(o=>(v.push(o),v))):Promise.resolve([]))}U(u){const i=this.m.get(u);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,h.$Zg)(()=>this.f.getParent(u))}W(u,i){const v=this.m.get(u);return v?Promise.resolve(v):(0,h.$Zg)(()=>this.f.getTreeItem(u)).then(o=>this.kb(u,o,i,!0)).then(o=>this.getChildren(i?i.item.handle:void 0).then(()=>{const w=this.getExtensionElement(o);if(w){const y=this.m.get(w);if(y)return Promise.resolve(y)}throw new Error(`Cannot resolve tree item for element ${o} from extension ${this.N.identifier.value}`)}))}X(u){if(u){let i;if(typeof u=="string"){const v=this.getExtensionElement(u);i=v?this.m.get(v):void 0}else i=u;return i&&i.children||void 0}return this.h}async Y(u){this.rb(u);const i=new $.$7d(this.Z.token);try{const v=u?this.m.get(u):void 0,o=await this.f.getChildren(u);if(i.token.isCancellationRequested)return;const w=(0,D.$Hb)(o||[]),y=await Promise.all((0,D.$Hb)(w).map(b=>this.f.getTreeItem(b)));if(i.token.isCancellationRequested)return;const d=y.map((b,P)=>b?this.db(w[P],b,v):null);return(0,D.$Hb)(d)}finally{i.dispose()}}$(u){if(u.some(v=>!v))return this.Z.dispose(!0),this.Z=new $.$7d,this.tb(),this.J.$refresh(this.I);{const v=this.ab(u);if(v.length)return this.bb(v)}return Promise.resolve(void 0)}ab(u){const i=new Set,v=u.map(w=>this.m.get(w));for(const w of v)if(w&&!i.has(w.item.handle)){let y=w;for(;y&&y.parent&&v.findIndex(d=>y&&y.parent&&d&&d.item.handle===y.parent.item.handle)===-1;){const d=this.j.get(y.parent.item.handle);y=d?this.m.get(d):void 0}y&&!y.parent&&i.add(w.item.handle)}const o=[];return i.forEach(w=>{const y=this.j.get(w);if(y){const d=this.m.get(y);d&&(!d.parent||!i.has(d.parent.item.handle))&&o.push(w)}}),o}bb(u){const i={};return Promise.all(u.map(v=>this.cb(v).then(o=>{o&&(i[v]=o.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(u){const i=this.getExtensionElement(u);if(i){const v=this.m.get(i);if(v)return this.rb(i),(0,h.$Zg)(()=>this.f.getTreeItem(i)).then(o=>{if(o){const w=this.ib(i,o,v.parent);return this.pb(i,w,v,v.parent),v.dispose(),w}return null})}return Promise.resolve(null)}db(u,i,v){const o=this.ib(u,i,v);if(i.id&&this.j.has(o.item.handle))throw new Error((0,S.localize)(0,null,i.id));return this.ob(u,o),this.qb(o,v),o}eb(u){return E.$ML.isMarkdownString(u)?l.MarkdownString.from(u):u}fb(u,i){return i?{...this.L.toInternal(i,u),originalId:i.command}:void 0}gb(u){if(u.checkboxState===void 0)return;let i,v,o;return typeof u.checkboxState=="number"?i=u.checkboxState:(i=u.checkboxState.state,v=u.checkboxState.tooltip,o=u.checkboxState.accessibilityInformation),{isChecked:i===E.TreeItemCheckboxState.Checked,tooltip:v,accessibilityInformation:o}}hb(u){if(!E.$$L.isTreeItem(u,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(u,i,v){this.hb(i);const o=this.B(new L.$Sc),w=this.kb(u,i,v),y=this.lb(i);return{item:{handle:w,parentHandle:v?v.item.handle:void 0,label:r(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(o,i.command),contextValue:i.contextValue,icon:y,iconDark:this.mb(i)||y,themeIcon:this.jb(i),collapsibleState:(0,A.$Sf)(i.collapsibleState)?E.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:v,children:void 0,disposableStore:o,dispose(){o.dispose()}}}jb(u){return u.iconPath instanceof E.$gM?u.iconPath:void 0}kb(u,{id:i,label:v,resourceUri:o},w,y){if(i)return`${s.b}/${i}`;const d=r(v,this.N),b=w?w.item.handle:s.a;let P=d?d.label:o?(0,M.$Fg)(o):"";P=P.indexOf("/")!==-1?P.replace("/","//"):P;const f=this.m.has(u)?this.m.get(u).item.handle:void 0,m=this.X(w)||[];let k,T=0;do{if(k=`${b}/${T}:${P}`,y||!this.j.has(k)||f===k)break;T++}while(T<=m.length);return k}lb(u){if(u.iconPath&&!(u.iconPath instanceof E.$gM))return typeof u.iconPath=="string"||I.URI.isUri(u.iconPath)?this.nb(u.iconPath):this.nb(u.iconPath.light)}mb(u){if(u.iconPath&&!(u.iconPath instanceof E.$gM)&&u.iconPath.dark)return this.nb(u.iconPath.dark)}nb(u){return I.URI.isUri(u)?u:I.URI.file(u)}ob(u,i){this.j.set(i.item.handle,u),this.m.set(u,i)}pb(u,i,v,o){this.j.delete(i.item.handle),this.m.delete(u),i.item.handle!==v.item.handle&&this.j.delete(v.item.handle),this.ob(u,i);const w=this.X(o)||[],y=w.filter(d=>d.item.handle===v.item.handle)[0];y&&w.splice(w.indexOf(y),1,i)}qb(u,i){i?(i.children||(i.children=[]),i.children.push(u)):(this.h||(this.h=[]),this.h.push(u))}rb(u){if(u){const i=this.m.get(u);if(i){if(i.children)for(const v of i.children){const o=this.j.get(v.item.handle);o&&this.sb(o)}i.children=void 0}}else this.tb()}sb(u){const i=this.m.get(u);if(i){if(i.children)for(const v of i.children){const o=this.j.get(v.item.handle);o&&this.sb(o)}this.m.delete(u),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(u=>u.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[277],Ae([1,0,5,6,2,33,8,61,3,7]),function(me,e,S,M,I,R,L,g,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=void 0;class A extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor($,n,c,r){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new S.$Wd),this.onDidDispose=this.#d.event,this.#h=this.B(new S.$Wd),this.onDidChangeViewState=this.#h.event,this.#e=$,this.#t=n,this.#n=c,this.#i=r.viewType,this.#s=r.panelOptions,this.#o=r.viewColumn,this.#r=r.title,this.#u=r.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title($){this.c(),this.#r!==$&&(this.#r=$,this.#t.$setTitle(this.#e,$))}get iconPath(){return this.c(),this.#a}set iconPath($){this.c(),this.#a!==$&&(this.#a=$,this.#t.$setIconPath(this.#e,I.URI.isUri($)?{light:$,dark:$}:$))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState($){this.#l||(this.active!==$.active||this.visible!==$.visible||this.viewColumn!==$.viewColumn)&&(this.#u=$.active,this.#c=$.visible,this.#o=$.viewColumn,this.#h.fire({webviewPanel:this}))}reveal($,n){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof $>"u"?void 0:L.ViewColumn.from($),preserveFocus:!!n})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends M.$Tc{static c(){return(0,R.$rg)()}constructor($,n,c){super(),this.j=n,this.m=c,this.g=new Map,this.h=new Map,this.f=$.getProxy(h.$jL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach($=>$.dispose()),this.g.clear()}createWebviewPanel($,n,c,r,t={}){const s=typeof r=="object"?r.viewColumn:r,a={viewColumn:L.ViewColumn.from(s),preserveFocus:typeof r=="object"&&!!r.preserveFocus},u=(0,g.$xgc)($),i=D.c();this.f.$createWebviewPanel((0,g.$zgc)($),i,n,{title:c,panelOptions:l(t),webviewOptions:(0,g.$Agc)($,this.m,t),serializeBuffersForPostMessage:u},a);const v=this.j.createNewWebview(i,t,$);return this.createNewWebviewPanel(i,n,c,s,t,v,!0)}$onDidChangeWebviewPanelViewStates($){const n=Object.keys($);n.sort((c,r)=>{const t=$[c],s=$[r];return t.active?1:s.active?-1:+t.visible-+s.visible});for(const c of n){const r=this.getWebviewPanel(c);if(!r)continue;const t=$[c];r._updateViewState({active:t.active,visible:t.visible,viewColumn:L.ViewColumn.to(t.position)})}}async $onDidDisposeWebviewPanel($){this.getWebviewPanel($)?.dispose(),this.g.delete($),this.j.deleteWebview($)}registerWebviewPanelSerializer($,n,c){if(this.h.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.h.set(n,{serializer:c,extension:$}),this.f.$registerSerializer(n,{serializeBuffersForPostMessage:(0,g.$xgc)($)}),new E.$lL(()=>{this.h.delete(n),this.f.$unregisterSerializer(n)})}async $deserializeWebviewPanel($,n,c,r){const t=this.h.get(n);if(!t)throw new Error(`No serializer found for '${n}'`);const{serializer:s,extension:a}=t,u=this.j.createNewWebview($,c.webviewOptions,a),i=this.createNewWebviewPanel($,n,c.title,r,c.panelOptions,u,c.active);await s.deserializeWebviewPanel(i,c.state)}createNewWebviewPanel($,n,c,r,t,s,a){const u=new A($,this.f,s,{viewType:n,title:c,viewColumn:r,panelOptions:t,active:a});return this.g.set($,u),u}getWebviewPanel($){return this.g.get($)}}e.$Bgc=D;function l(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Re[278],Ae([1,0,5,6,61,8,3,7]),function(me,e,S,M,I,R,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class h extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(D,l,p,$,n,c){super(),this.#s=!1,this.#u=this.B(new S.$Wd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new S.$Wd),this.onDidDispose=this.#l.event,this.#i=p,this.#a=$,this.#e=D,this.#t=l,this.#n=n,this.#r=c}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#o}set description(D){this.a(),this.#o!==D&&(this.#o=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(D){D===this.#r||this.#s||(this.#r=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(D,l){this.d=l,this.b=new Map,this.c=new Map,this.a=D.getProxy(L.$jL.MainThreadWebviewViews)}registerWebviewViewProvider(D,l,p,$){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:p,extension:D}),this.a.$registerWebviewViewProvider((0,I.$zgc)(D),l,{retainContextWhenHidden:$?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$xgc)(D)}),new g.$lL(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(D,l,p,$,n){const c=this.b.get(l);if(!c)throw new Error(`No view provider found for '${l}'`);const{provider:r,extension:t}=c,s=this.d.createNewWebview(D,{},t),a=new h(D,this.a,l,p,s,!0);this.c.set(D,a),await r.resolveWebviewView(a,{state:$},n)}async $onDidChangeWebviewViewVisibility(D,l){this.e(D)._setVisible(l)}async $disposeWebviewView(D){const l=this.e(D);this.c.delete(D),l.dispose(),this.d.deleteWebview(D)}e(D){const l=this.c.get(D);if(!l)throw new Error("No webview found");return l}}e.$6hc=E}),define(Re[279],Ae([1,0,5,30,35,4]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FK=e.$EK=e.OutputChannelUpdateMode=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=void 0,e.$uK="text/x-code-output",e.$vK="output",e.$wK="Log",e.$xK="text/x-code-log-output",e.$yK="log",e.$zK="workbench.panel.output",e.$AK=new I.$mj("inOutput",!1),e.$BK=new I.$mj("activeLogOutput",!1),e.$CK=new I.$mj("outputView.scrollLock",!1),e.$DK=(0,R.$8h)("outputService");var L;(function(h){h[h.Append=1]="Append",h[h.Replace=2]="Replace",h[h.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$EK={OutputChannels:"workbench.contributions.outputChannels"};class g{constructor(){this.a=new Map,this.b=new S.$Wd,this.onDidRegisterChannel=this.b.event,this.c=new S.$Wd,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(A=>E.push(A)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}M.$Kn.add(e.$EK.OutputChannels,new g),e.$FK=new I.$mj("activeOutputChannel","")}),define(Re[112],Ae([1,0,3,4,17,22,14,279,62,27,43,136,23,16,42,5,6]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=e.$Ghc=void 0;class r extends L.$vj{get disposed(){return this.n}constructor(u,i,v,o,w){super(),this.id=u,this.name=i,this.r=v,this.s=o,this.extension=w,this.m=0,this.n=!1,this.visible=!1,this.setLevel(v.getLevel()),this.B(v.onDidChangeLogLevel(y=>this.setLevel(y)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.m;this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Clear,u)}replace(u){const i=this.m;this.info(u),this.s.$update(this.id,g.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(u,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof u=="boolean"?u:i))}hide(){this.s.$close(this.id)}g(u,i){this.m+=l.$ke.fromString(i).byteLength,(0,L.log)(this.r,u,i),this.visible&&(this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class t extends r{appendLine(u){this.append(u)}}let s=class{constructor(u,i,v,o,w,y){this.i=i,this.j=v,this.k=o,this.l=w,this.m=y,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=u.getProxy(S.$jL.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,D.$zm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.h=u;for(const[i,v]of this.g)v.visible=i===this.h}createOutputChannel(u,i,v){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const o=typeof i=="object"&&i.log,w=(0,p.$Jf)(i)?i:void 0;if((0,p.$Jf)(w)&&!w.trim())throw new Error("illegal argument `languageId`. must not be empty");let y;const d=this.i.environment.extensionLogLevel?.find(([P])=>R.$nm.equals(v.identifier,P))?.[1];d&&(y=(0,L.$Fj)(d));const b=o?this.o(u,y,v):this.n(u,w,v);return b.then(P=>{this.g.set(P.id,P),P.visible=P.id===this.h}),o?this.r(u,y??this.m.getLevel(),b):this.q(u,b)}async n(u,i,v){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const o=await this.c,w=this.k.extUri.joinPath(o,`${this.f++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),y=this.l.createLogger(w,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(u,w,i,v.identifier.value);return new r(d,u,y,this.a,v)}async o(u,i,v){const o=await this.p(v),w=u.replace(/[\\/:\*\?"<>\|]/g,""),y=this.k.extUri.joinPath(o,`${w}.log`),d=`${v.identifier.value}.${w}`,b=this.l.createLogger(y,{id:d,name:u,logLevel:i,extensionId:v.identifier.value});return new t(d,u,b,this.a,v)}p(u){let i=this.d.get(u.identifier.value);if(!i){const v=this.k.extUri.joinPath(this.i.logsLocation,u.identifier.value);this.d.set(u.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(v)}catch(o){if((0,$.$Ik)(o)!==$.FileSystemProviderErrorCode.FileExists)throw o}return v})())}return i}q(u,i){let v=!1;const o=()=>{if(v)throw new Error("Channel has been closed")};return{get name(){return u},append(w){o(),i.then(y=>y.append(w))},appendLine(w){o(),i.then(y=>y.appendLine(w))},clear(){o(),i.then(w=>w.clear())},replace(w){o(),i.then(y=>y.replace(w))},show(w,y){o(),i.then(d=>d.show(w,y))},hide(){o(),i.then(w=>w.hide())},dispose(){v=!0,i.then(w=>w.dispose())}}}r(u,i,v){const o=new c.$Sc,w=()=>{if(o.isDisposed)throw new Error("Channel has been closed")},y=o.add(new n.$Wd);function d(b){i=b,y.fire(b)}return v.then(b=>{o.add(b),b.logLevel!==i&&d(b.logLevel),o.add(b.onDidChangeLogLevel(P=>d(P)))}),{...this.q(u,v),get logLevel(){return i},onDidChangeLogLevel:y.event,trace(b,...P){w(),v.then(f=>f.trace(b,...P))},debug(b,...P){w(),v.then(f=>f.debug(b,...P))},info(b,...P){w(),v.then(f=>f.info(b,...P))},warn(b,...P){w(),v.then(f=>f.warn(b,...P))},error(b,...P){w(),v.then(f=>f.error(b,...P))},dispose(){o.dispose()}}}};e.$Ghc=s,e.$Ghc=s=Je([qe(0,I.$oN),qe(1,E.$EN),qe(2,h.$tgc),qe(3,A.$6fc),qe(4,L.$qj),qe(5,L.$pj)],s),e.$Hhc=(0,M.$8h)("IExtHostOutputService")}),define(Re[113],Ae([1,0,4,11]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=void 0,e.$Om=(0,S.$8h)("remoteAgentService"),e.$Pm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let R=1/0;for(let g=0;g<this.maxSampleCount;g++){const h=await I.getRoundTripTime();if(h===void 0)return;R=Math.min(R,h/2),await(0,M.$9g)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(R):L=this.initial.reduce((g,h)=>g+h,0)/this.initial.length,this.lastMeasurement={initial:L,current:R,average:this.average.reduce((g,h)=>g+h,0)/this.average.length,high:typeof L>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(Re[280],Ae([1,0,169,55,30,47,46,6,5,113,20,26,11]),function(me,e,S,M,I,R,L,g,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=void 0,e.$3H=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.$4H=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.$5H=Object.freeze({id:"security",scope:1,title:(0,S.localize)(2,null),type:"object",order:7}),e.$6H=Object.freeze({id:"problems",title:(0,S.localize)(3,null),type:"object",order:101}),e.$7H={ConfigurationMigration:"base.contributions.configuration.migration"};class p{constructor(){this.migrations=[],this.a=new h.$Wd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const $=new p;I.$Kn.add(e.$7H.ConfigurationMigration,$);let n=class extends g.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(t,s){super(),this.a=t,this.b=s,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const u of a.added)await this.f(u,$.migrations)})),this.c($.migrations),this.B($.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(t){await this.f(void 0,t);for(const s of this.b.getWorkspace().folders)await this.f(s,t)}async f(t,s){await Promise.all([s.map(a=>this.g(a,t?.uri))])}async g(t,s){const a=this.a.inspect(t.key,{resource:s}),u=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[i,v]of u){const o=a[i];if(!o)continue;const w=[];if(o.value!==void 0){const y=await this.h(t,i,o.value,s,void 0);for(const d of y??[])w.push([d,[]])}for(const{identifiers:y,value:d}of o.overrides??[])if(d!==void 0){const b=await this.h(t,i,d,s,y);for(const P of b??[])w.push([P,y])}w.length&&await Promise.allSettled(w.map(async([[y,d],b])=>this.a.updateValue(y,d.value,{resource:s,overrideIdentifiers:b},v)))}}async h(t,s,a,u,i){const v=w=>{const d=this.a.inspect(w,{resource:u})[s];if(d)return i?d.overrides?.find(({identifiers:b})=>(0,D.$Cn)(b,i))?.value:d.value},o=await t.migrateFn(a,v);return Array.isArray(o)?o:[[t.key,o]]}};e.$8H=n,e.$8H=n=Je([qe(0,L.$Bi),qe(1,R.$ei)],n);let c=class extends g.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(t){super(),this.b=t,this.a=new l.$sh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;I.$Kn.as(M.$Pn.Configuration).registerConfiguration({...e.$5H,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(4,null)},default:[],markdownDescription:(0,S.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(6,null),scope:2}}})}};e.$9H=c,e.$9H=c=Je([qe(0,E.$Om)],c)}),define(Re[281],Ae([1,0,34,12,19,25,177,280,55,4,30]),function(me,e,S,M,I,R,L,g,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdb=e.$Fdb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Edb=e.$Ddb=void 0,e.$Ddb=(0,E.$8h)("editorResolverService"),e.$Edb="workbench.editorAssociations";const D=A.$Kn.as(h.$Pn.Configuration),l={...g.$4H,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(l);var p;(function(r){r.builtin="builtin",r.option="option",r.exclusive="exclusive",r.default="default"})(p||(e.RegisteredEditorPriority=p={}));var $;(function(r){r[r.ABORT=1]="ABORT",r[r.NONE=2]="NONE"})($||(e.ResolvedStatus=$={}));function n(r){switch(r){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.$Fdb=n;function c(r,t){if(new Set([M.Schemas.extension,M.Schemas.webviewPanel,M.Schemas.vscodeWorkspaceTrust,M.Schemas.vscodeSettings]).has(t.scheme))return!1;const u=typeof r=="string"&&r.indexOf(I.$gc.sep)>=0?`${t.scheme}:${t.path}`:(0,R.$Fg)(t);return S.$Nj(typeof r=="string"?r.toLowerCase():r,u.toLowerCase())}e.$Gdb=c}),define(Re[282],Ae([1,0,45,12,19,20,25,2,4,198,47,216,113]),function(me,e,S,M,I,R,L,g,h,E,A,D,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$YK=e.$XK=void 0,e.$XK=(0,h.$8h)("pathService");let $=p=class{constructor(c,r,t,s){this.d=c,this.e=r,this.f=t,this.g=s,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??c})()}hasValidBasename(c,r,t){return typeof r=="string"||typeof r>"u"?this.a.then(s=>this.h(c,s,r)):this.h(c,r,t)}h(c,r,t){return c.scheme===M.Schemas.file||c.scheme===M.Schemas.vscodeRemote?(0,S.$7f)(t??(0,L.$Fg)(c),r===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(c,r){if(c.remoteAuthority)return M.Schemas.vscodeRemote;const t=(0,E.$UK)(r.getWorkspace());if(t)return t;const s=r.getWorkspace().folders[0];if(s)return s.uri.scheme;const a=r.getWorkspace().configuration;return a?a.scheme:M.Schemas.file}userHome(c){return c?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(c=>c===1?I.$fc:I.$gc)}async fileURI(c){let r="";if(await this.a===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const s=c.indexOf("/",2);s===-1?(r=c.substring(2),c="/"):(r=c.substring(2,s),c=c.substring(s)||"/")}return g.URI.from({scheme:M.Schemas.file,authority:r,path:c,query:"",fragment:""})}};e.$YK=$,e.$YK=$=p=Je([qe(1,l.$Om),qe(2,D.$GK),qe(3,A.$ei)],$)}),define(Re[114],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$zJ=e.$yJ=void 0;class S{constructor(L,g){this.line=L,this.character=g}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,g){return new S(0,0)}with(L){return new S(0,0)}}e.$yJ=S;class M{constructor(L,g,h,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(L,g),this.end=new S(h,E)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new M(0,0,0,0)}with(L){return new M(0,0,0,0)}}e.$zJ=M;var I;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Re[44],Ae([1,0,18,34,26,45,13,4,19,15,114,11]),function(me,e,S,M,I,R,L,g,h,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.SearchErrorCode=e.$OJ=e.$NJ=e.SearchSortOrder=e.ViewMode=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.SearchCompletionExitCode=e.$IJ=e.$HJ=e.$GJ=e.QueryType=e.SearchProviderType=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$AJ="workbench.view.search",e.$BJ="workbench.panel.search",e.$CJ="workbench.view.search",e.$DJ="search-result",e.$EJ="search.exclude";const l="\u27EA ",p=" characters skipped \u27EB",$=(l.length+p.length+5)*2;e.$FJ=(0,g.$8h)("searchService");var n;(function(ae){ae[ae.file=0]="file",ae[ae.text=1]="text"})(n||(e.SearchProviderType=n={}));var c;(function(ae){ae[ae.File=1]="File",ae[ae.Text=2]="Text"})(c||(e.QueryType=c={}));function r(ae){return!!ae.preview}e.$GJ=r;function t(ae){return!!ae.resource}e.$HJ=t;function s(ae){return!!ae.message}e.$IJ=s;var a;(function(ae){ae[ae.Normal=0]="Normal",ae[ae.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class u{constructor(pe){this.resource=pe,this.results=[]}}e.$JJ=u;class i{constructor(pe,oe,$e,ie){this.ranges=oe,this.webviewIndex=ie;const x=Array.isArray(oe)?oe:[oe];if($e&&$e.matchLines===1&&v(x)){pe=(0,L.$Cf)(pe,$e.matchLines);let V="",ne=0,Ie=0;const Me=Math.floor($e.charsPerLine/5),Le=[];for(const be of x){const ge=Math.max(be.startColumn-Me,0),K=be.startColumn+$e.charsPerLine;if(ge>Ie+Me+$){const ee=l+(ge-Ie)+p;V+=ee+pe.slice(ge,K),ne+=ge-(Ie+ee.length)}else V+=pe.slice(Ie,K);Le.push(new w(0,be.startColumn-ne,be.endColumn-ne)),Ie=K}this.preview={text:V,matches:Array.isArray(this.ranges)?Le:Le[0]}}else{const V=Array.isArray(oe)?oe[0].startLineNumber:oe.startLineNumber;this.preview={text:pe,matches:(0,S.$2b)(oe,ne=>new o(ne.startLineNumber-V,ne.startColumn,ne.endLineNumber-V,ne.endColumn))}}}}e.$KJ=i;function v(ae){const pe=ae[0].startLineNumber;for(const oe of ae)if(oe.startLineNumber!==pe||oe.endLineNumber!==pe)return!1;return!0}class o{constructor(pe,oe,$e,ie){this.startLineNumber=pe,this.startColumn=oe,this.endLineNumber=$e,this.endColumn=ie}}e.$LJ=o;class w extends o{constructor(pe,oe,$e){super(pe,oe,pe,$e)}}e.$MJ=w;var y;(function(ae){ae.List="list",ae.Tree="tree"})(y||(e.ViewMode=y={}));var d;(function(ae){ae.Default="default",ae.FileNames="fileNames",ae.Type="type",ae.Modified="modified",ae.CountDescending="countDescending",ae.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function b(ae,pe=!0){const oe=ae&&ae.files&&ae.files.exclude,$e=pe&&ae&&ae.search&&ae.search.exclude;if(!oe&&!$e)return;if(!oe||!$e)return oe||$e;let ie=Object.create(null);return ie=I.$Bn(ie,I.$yn(oe)),ie=I.$Bn(ie,I.$yn($e),!0),ie}e.$NJ=b;function P(ae,pe){return ae.excludePattern&&M.$Nj(ae.excludePattern,pe)?!1:ae.includePattern||ae.usingSearchPaths?ae.includePattern&&M.$Nj(ae.includePattern,pe)?!0:ae.usingSearchPaths?!!ae.folderQueries&&ae.folderQueries.some(oe=>{const $e=oe.folder.fsPath;if(R.$9f(pe,$e)){const ie=h.$lc($e,pe);return!oe.includePattern||!!M.$Nj(oe.includePattern,ie)}else return!1}):!1:!0}e.$OJ=P;var f;(function(ae){ae[ae.unknownEncoding=1]="unknownEncoding",ae[ae.regexParseError=2]="regexParseError",ae[ae.globParseError=3]="globParseError",ae[ae.invalidLiteral=4]="invalidLiteral",ae[ae.rgProcessError=5]="rgProcessError",ae[ae.other=6]="other",ae[ae.canceled=7]="canceled"})(f||(e.SearchErrorCode=f={}));class m extends Error{constructor(pe,oe){super(pe),this.code=oe}}e.$PJ=m;function k(ae){const pe=ae.message;if((0,E.$4)(ae))return new m(pe,f.canceled);try{const oe=JSON.parse(pe);return new m(oe.message,oe.code)}catch{return new m(pe,f.other)}}e.$QJ=k;function T(ae){const pe={message:ae.message,code:ae.code};return new Error(JSON.stringify(pe))}e.$RJ=T;function O(ae){return ae.type==="error"?!0:ae.type==="success"}e.$SJ=O;function G(ae){return ae.type==="success"}e.$TJ=G;function q(ae){return!!ae.path}e.$UJ=q;function j(ae,pe){const oe=ae.searchPath?ae.searchPath:ae.relativePath;return(0,L.$zf)(oe,pe)}e.$VJ=j;class C{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$WJ=C;function N(ae,pe){const oe={...ae||{},...pe||{}};return Object.keys(oe).filter($e=>{const ie=oe[$e];return typeof ie=="boolean"&&ie})}e.$XJ=N;class W{constructor(pe,oe){this.c=null,this.a={...pe.excludePattern||{},...oe.excludePattern||{}},this.b=M.$Oj(this.a);let $e=pe.includePattern;oe.includePattern&&($e?$e={...$e,...oe.includePattern}:$e=oe.includePattern),$e&&(this.c=M.$Oj($e))}matchesExcludesSync(pe,oe,$e){return!!(this.b&&this.b(pe,oe,$e))}includedInQuerySync(pe,oe,$e){return!(this.b&&this.b(pe,oe,$e)||this.c&&!this.c(pe,oe,$e))}includedInQuery(pe,oe,$e){const ie=this.b(pe,oe,$e),x=()=>this.c?!!this.c(pe,oe,$e):!0;return(0,D.$Tg)(ie)?ie.then(V=>V?!1:x()):x()}hasSiblingExcludeClauses(){return se(this.a)}}e.$YJ=W;function se(ae){for(const pe in ae)if(typeof ae[pe]!="boolean")return!0;return!1}function ue(ae){if(!ae)return;let pe;return oe=>(pe||(pe=(ae()||Promise.resolve([])).then($e=>$e?ke($e):{})),pe.then($e=>!!$e[oe]))}e.$ZJ=ue;function ye(ae){if(!ae)return;let pe;return oe=>{if(!pe){const $e=ae();pe=$e?ke($e):{}}return!!pe[oe]}}e.$1J=ye;function ke(ae){const pe={};for(const oe of ae)pe[oe]=!0;return pe}}),define(Re[36],Ae([1,0,18,11,21,5,6,50,12,122,25,13,2,168,4,14,187,47,43,27,17,8,7,58,44,3,51]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c,r,t,s,a,u,i,v,o,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=e.$ngc=void 0;function d(G,q,j){return new A.$xg(C=>m(C,j)).isEqual(G,q)}function b(G,q,j){return d(G.uri,q.uri,j)?0:(0,D.$6e)(G.uri.toString(),q.uri.toString())}function P(G,q,j){return G.index!==q.index?G.index<q.index?-1:1:d(G.uri,q.uri,j)?(0,D.$6e)(G.name,q.name):(0,D.$6e)(G.uri.toString(),q.uri.toString())}function f(G,q,j,C){const N=G.slice(0).sort((se,ue)=>j(se,ue,C)),W=q.slice(0).sort((se,ue)=>j(se,ue,C));return(0,S.$Eb)(N,W,(se,ue)=>j(se,ue,C))}function m(G,q){const j=q.getCapabilities(G.scheme);return!(j&&j&1024)}class k extends r.$oi{static toExtHostWorkspace(q,j,C,N){if(!q)return{workspace:null,added:[],removed:[]};const{id:W,name:se,folders:ue,configuration:ye,transient:ke,isUntitled:ae}=q,pe=[],oe=j;j?ue.forEach((V,ne)=>{const Ie=l.URI.revive(V.uri),Me=k.o(C||j,Ie,N);Me?(Me.name=V.name,Me.index=V.index,pe.push(Me)):pe.push({uri:Ie,name:V.name,index:ne})}):pe.push(...ue.map(({uri:V,name:ne,index:Ie})=>({uri:l.URI.revive(V),name:ne,index:Ie}))),pe.sort((V,ne)=>V.index<ne.index?-1:1);const $e=new k(W,se,pe,!!ke,ye?l.URI.revive(ye):null,!!ae,V=>m(V,N)),{added:ie,removed:x}=f(oe?oe.workspaceFolders:[],$e.workspaceFolders,b,N);return{workspace:$e,added:ie,removed:x}}static o(q,j,C){for(let N=0;N<q.folders.length;N++){const W=q.workspaceFolders[N];if(d(W.uri,j,C))return W}}constructor(q,j,C,N,W,se,ue){super(q,C.map(ye=>new r.$pi(ye)),N,W,ue),this.t=j,this.u=se,this.q=[],this.s=g.$bi.forUris(ue),C.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,j){return j&&this.s.get(q)&&(q=(0,A.$Hg)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let T=class{constructor(q,j,C,N,W){this.c=new R.$Wd,this.onDidChangeWorkspace=this.c.event,this.g=new R.$Wd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.$Yd,this.B=new Map,this.h=N,this.s=C,this.t=W,this.j=new E.$$l,this.k=new M.$7g,this.o=q.getProxy(w.$jL.MainThreadWorkspace),this.q=q.getProxy(w.$jL.MainThreadMessageService);const se=j.workspace;this.l=se?new k(se.id,se.name,[],!!se.transient,se.configuration?l.URI.revive(se.configuration):null,!!se.isUntitled,ue=>m(ue,C)):void 0}$initializeWorkspace(q,j){this.v=j,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:h.Schemas.untitled,path:(0,A.$Fg)((0,A.$Hg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,j,C,...N){const W=[];if(Array.isArray(N)&&N.forEach(ae=>{l.URI.isUri(ae.uri)&&!W.some(pe=>d(pe.uri,ae.uri,this.s))&&W.push({uri:ae.uri,name:ae.name||(0,A.$Eg)(ae.uri)})}),this.n||[j,C].some(ae=>typeof ae!="number"||ae<0)||C===0&&W.length===0)return!1;const se=this.x?this.x.workspaceFolders:[];if(j+C>se.length)return!1;const ue=se.slice(0);ue.splice(j,C,...W.map(ae=>({uri:ae.uri,name:ae.name||(0,A.$Eg)(ae.uri),index:void 0})));for(let ae=0;ae<ue.length;ae++){const pe=ue[ae];if(ue.some((oe,$e)=>$e!==ae&&d(pe.uri,oe.uri,this.s)))return!1}ue.forEach((ae,pe)=>ae.index=pe);const{added:ye,removed:ke}=f(se,ue,P,this.s);if(ye.length===0&&ke.length===0)return!1;if(this.o){const ae=q.displayName||q.name;this.o.$updateWorkspaceFolders(ae,j,C,W).then(void 0,pe=>{this.n=void 0;const oe={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(c.Severity.Error,(0,p.localize)(0,null,ae,pe.toString()),oe,[])})}return this.y(ue),!0}getWorkspaceFolder(q,j){if(this.x)return this.x.getWorkspaceFolder(q,j)}async getWorkspaceFolder2(q,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,j)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,j){let C,N="";if(typeof q=="string"?(C=l.URI.file(q),N=q):typeof q<"u"&&(C=q,N=q.fsPath),!C)return N;const W=this.getWorkspaceFolder(C,!0);if(!W)return N;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let se=(0,A.$Kg)(W.uri,C);return j&&W.name&&(se=`${W.name}/${se}`),se}y(q){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:j,added:C,removed:N}=k.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:N}))}findFiles(q,j,C,N,W=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let se;if(j===null?se=!1:j&&(typeof j=="string"?se=j:se=j.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:ue,folder:ye}=O(u.GlobPattern.from(q));return this.o.$startFileSearch(ue??null,ye??null,se??null,C??null,W).then(ke=>Array.isArray(ke)?ke.map(ae=>l.URI.revive(ae)):[])}async findTextInFiles(q,j,C,N,W=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const se=this.j.getNext(),ue=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:ye,folder:ke}=O(u.GlobPattern.from(j.include)),ae=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,pe={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:ue,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:ye,excludePattern:ae},oe=!1;if(this.u[se]=$e=>{if(oe)return;const ie=l.URI.revive($e.resource);$e.results.forEach(x=>{const V=(0,y.$Eh)(x);(0,o.$GJ)(V)?C({uri:ie,preview:{text:V.preview.text,matches:(0,S.$2b)(V.preview.matches,ne=>new i.$nL(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,S.$2b)(V.ranges,ne=>new i.$nL(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):C({uri:ie,text:V.text,lineNumber:V.lineNumber})})},W.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(q,ke??null,pe,se,W);return delete this.u[se],$e||{}}catch($e){throw delete this.u[se],$e}}$handleTextSearchResult(q,j){this.u[j]?.(q)}async save(q){const j=await this.o.$save(q,{saveAs:!1});return l.URI.revive(j)}async saveAs(q){const j=await this.o.$save(q,{saveAs:!0});return l.URI.revive(j)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,j){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,j);const C=this.t.transformOutgoingScheme(q),N=this.z++;return this.o.$registerEditSessionIdentityProvider(N,C),(0,L.$Rc)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(q,j){this.h.info("Getting edit session identifier for workspaceFolder",q);const C=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const N=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!N),!N)return;const W=await N.provideEditSessionIdentity(C,j);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(q,j,C,N){this.h.info("Getting edit session identifier for workspaceFolder",q);const W=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const se=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!se),!se)return;const ue=await se.provideEditSessionIdentityMatch?.(j,C,N);if(this.h.info("Provider returned edit session identifier match result: ",ue),!!ue)return ue}getOnWillCreateEditSessionIdentityEvent(q){return(j,C,N)=>{const W=function(ue){j.call(C,ue)};return W.extension=q,this.A.event(W,void 0,N)}}async $onWillCreateEditSessionIdentity(q,j,C){const N=await this.resolveWorkspaceFolder(l.URI.revive(q));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:N},j,async(W,se)=>{const ue=Date.now();await Promise.resolve(W),Date.now()-ue>C&&this.h.warn("SLOW edit session create-participant",se.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(q,j){if(this.B.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.B.set(q,j);const C=this.t.transformOutgoingScheme(q),N=this.z++;return this.o.$registerCanonicalUriProvider(N,C),(0,L.$Rc)(()=>{this.B.delete(q),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(q,j,C){const N=this.B.get(q.scheme);if(!N)return;const W=await N.provideCanonicalUri?.(l.URI.revive(q),j,C);if(W)return W}async $provideCanonicalUri(q,j,C){return this.provideCanonicalUri(l.URI.revive(q),{targetScheme:j},C)}};e.$ngc=T,e.$ngc=T=Je([qe(0,a.$oN),qe(1,s.$EN),qe(2,t.$6fc),qe(3,n.$pj),qe(4,v.$lgc)],T),e.$ogc=(0,$.$8h)("IExtHostWorkspace");function O(G){let q,j;return G&&(typeof G=="string"?q=G:(q=G.pattern,j=l.URI.revive(G.baseUri))),{includePattern:q,folder:j}}}),define(Re[37],Ae([1,0,26,5,36,3,7,189,55,16,11,4,17,14,2]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=e.$qgc=e.$pgc=void 0;function n(v,o){if(o){const w=o.split(".");let y=v;for(let d=0;y&&d<w.length;d++)y=y[w[d]];return y}}function c(v){return v instanceof $.URI}function r(v){return v&&v.uri instanceof $.URI&&v.languageId&&typeof v.languageId=="string"}function t(v){return v&&!v.uri&&v.languageId&&typeof v.languageId=="string"}function s(v){return v&&v.uri instanceof $.URI&&(!v.name||typeof v.name=="string")&&(!v.index||typeof v.index=="number")}function a(v){if(c(v))return{resource:v};if(r(v))return{resource:v.uri,overrideIdentifier:v.languageId};if(t(v))return{overrideIdentifier:v.languageId};if(s(v))return{resource:v.uri};if(v===null)return{resource:null}}let u=class{constructor(o,w,y){this.a=o.getProxy(R.$jL.MainThreadConfiguration),this.c=w,this.b=y,this.d=new A.$7g,this.e=null}getConfigProvider(){return this.d.wait().then(o=>this.e)}$initializeConfiguration(o){this.e=new i(this.a,this.c,o,this.b),this.d.open()}$acceptConfigurationChanged(o,w){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(o,w))}};e.$pgc=u,e.$pgc=u=Je([qe(0,l.$oN),qe(1,I.$ogc),qe(2,p.$pj)],u);class i{constructor(o,w,y,d){this.a=new M.$Wd,this.b=o,this.f=d,this.c=w,this.e=g.$9n.parse(y),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(o,w){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=g.$9n.parse(o),this.d=this.k(o.configurationScopes),this.a.fire(this.j(w,y))}getConfiguration(o,w,y){const d=a(w)||{},b=this.g(o?n(this.e.getValue(void 0,d,this.c.workspace),o):this.e.getValue(void 0,d,this.c.workspace));o&&this.h(o,d,y?.identifier);function P(m){if(m==null)return null;if(typeof m=="boolean")return m?2:5;switch(m){case L.ConfigurationTarget.Global:return 2;case L.ConfigurationTarget.Workspace:return 5;case L.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(m){return typeof n(b,m)<"u"},get:(m,k)=>{this.h(o?`${o}.${m}`:m,d,y?.identifier);let T=n(b,m);if(typeof T>"u")T=k;else{let O;const G=(q,j)=>{if((0,E.$Lf)(q)){let C;const N=()=>{O=O||(0,S.$yn)(b),C=C||n(O,j)};return new Proxy(q,{get:(W,se)=>{if(typeof se=="string"&&se.toLowerCase()==="tojson")return N(),()=>C;if(O)return C=C||n(O,j),C[se];const ue=W[se];return typeof se=="string"?G(ue,`${j}.${se}`):ue},set:(W,se,ue)=>(N(),C&&(C[se]=ue),!0),deleteProperty:(W,se)=>(N(),C&&delete C[se],!0),defineProperty:(W,se,ue)=>(N(),C&&Object.defineProperty(C,se,ue),!0)})}return Array.isArray(q)?(0,S.$yn)(q):q};T=G(T,m)}return T},update:(m,k,T,O)=>{m=o?`${o}.${m}`:m;const G=P(T);return k!==void 0?this.b.$updateConfigurationOption(G,m,k,d,O):this.b.$removeConfigurationOption(G,m,d,O)},inspect:m=>{m=o?`${o}.${m}`:m;const k=this.e.inspect(m,d,this.c.workspace);if(k)return{key:m,defaultValue:(0,S.$yn)(k.policy?.value??k.default?.value),globalValue:(0,S.$yn)(k.user?.value??k.application?.value),workspaceValue:(0,S.$yn)(k.workspace?.value),workspaceFolderValue:(0,S.$yn)(k.workspaceFolder?.value),defaultLanguageValue:(0,S.$yn)(k.default?.override),globalLanguageValue:(0,S.$yn)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,S.$yn)(k.workspace?.override),workspaceFolderLanguageValue:(0,S.$yn)(k.workspaceFolder?.override),languageIds:(0,S.$yn)(k.overrideIdentifiers)}}};return typeof b=="object"&&(0,S.$Bn)(f,b,!1),Object.freeze(f)}g(o){const w=y=>(0,E.$Lf)(y)?new Proxy(y,{get:(d,b)=>w(d[b]),set:(d,b,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(d,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(d,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return w(o)}h(o,w,y){const d=h.$Zn.test(o)?4:this.d.get(o),b=y?`[${y.value}] `:"";if(d===4){typeof w?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){w?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(o,w){const y=new g.$$n(o,w,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,b)=>y.affectsConfiguration(d,a(b))})}k(o){return o.reduce((w,y)=>(w.set(y[0],y[1]),w),new Map)}}e.$qgc=i,e.$rgc=(0,D.$8h)("IExtHostConfiguration")}),define(Re[115],Ae([1,0,2,11,5,3,7,36,66,37,21,65,17,27,4,12,20,14,79,221,15]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c,r,t,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=e.$Thc=e.$Shc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var u;(function(G){function q(C){if(C!=null)return C}G.from=q;function j(C){if(C!=null)return C}G.to=j})(u||(u={}));var i;(function(G){function q(C){if(C!=null)return C}G.from=q;function j(C){if(C!=null)return C}G.to=j})(i||(i={}));var v;(function(G){function q(C){if(C!=null)return C}G.from=q;function j(C){if(C!=null)return C}G.to=j})(v||(v={}));var o;(function(G){function q(N){if(N){const W=N;return W&&!!W.process}else return!1}G.is=q;function j(N){if(N==null)return;const W={process:N.process,args:N.args};return N.options&&(W.options=v.from(N.options)),W}G.from=j;function C(N){if(N!=null)return new L.$7L(N.process,N.args,N.options)}G.to=C})(o||(o={}));var w;(function(G){function q(C){if(C!=null)return C}G.from=q;function j(C){if(C!=null)return C}G.to=j})(w||(w={}));var y;(function(G){function q(N){if(N){const W=N;return W&&(!!W.commandLine||!!W.command)}else return!1}G.is=q;function j(N){if(N==null)return;const W={};return N.commandLine!==void 0?W.commandLine=N.commandLine:(W.command=N.command,W.args=N.args),N.options&&(W.options=w.from(N.options)),W}G.from=j;function C(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new L.$8L(N.commandLine,N.options):new L.$8L(N.command,N.args?N.args:[],N.options)}G.to=C})(y||(y={}));var d;(function(G){function q(N){if(N){const W=N;return W&&W.customExecution==="customExecution"}else return!1}G.is=q;function j(N){return{customExecution:"customExecution"}}G.from=j;function C(N,W){return W.get(N)}G.to=C})(d||(e.CustomExecutionDTO=d={}));var b;(function(G){function q(j,C){let N;return j.scope!==void 0&&typeof j.scope!="number"?N=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===L.TaskScope.Workspace&&C&&C.workspaceFile?N=C.workspaceFile:N=s.$DG),{id:j._id,workspaceFolder:N}}G.from=q})(b||(e.TaskHandleDTO=b={}));var P;(function(G){function q(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}G.from=q})(P||(P={}));var f;(function(G){function q(N,W){if(N==null)return[];const se=[];for(const ue of N){const ye=j(ue,W);ye&&se.push(ye)}return se}G.fromMany=q;function j(N,W){if(N==null)return;let se;N.execution instanceof L.$7L?se=o.from(N.execution):N.execution instanceof L.$8L?se=y.from(N.execution):N.execution&&N.execution instanceof L.$9L&&(se=d.from(N.execution));const ue=u.from(N.definition);let ye;return N.scope?typeof N.scope=="number"?ye=N.scope:ye=N.scope.uri:ye=L.TaskScope.Workspace,!ue||!ye?void 0:{_id:N._id,definition:ue,name:N.name,source:{extensionId:W.identifier.value,label:N.source,scope:ye},execution:se,isBackground:N.isBackground,group:P.from(N.group),presentationOptions:i.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}G.from=j;async function C(N,W,se){if(N==null)return;let ue;o.is(N.execution)?ue=o.to(N.execution):y.is(N.execution)?ue=y.to(N.execution):d.is(N.execution)&&(ue=d.to(N._id,se));const ye=u.to(N.definition);let ke;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?ke=N.source.scope:ke=await W.resolveWorkspaceFolder(S.URI.revive(N.source.scope)):ke=L.TaskScope.Workspace),!ye||!ke)return;const ae=new L.$0L(ye,ke,N.name,N.source.label,ue,N.problemMatchers);return N.isBackground!==void 0&&(ae.isBackground=N.isBackground),N.group!==void 0&&(ae.group=L.$6L.from(N.group._id),ae.group&&N.group.isDefault&&(ae.group=new L.$6L(ae.group.id,ae.group.label),N.group.isDefault===!0&&(ae.group.isDefault=N.group.isDefault))),N.presentationOptions&&(ae.presentationOptions=i.to(N.presentationOptions)),N._id&&(ae._id=N._id),N.detail&&(ae.detail=N.detail),ae}G.to=C})(f||(e.TaskDTO=f={}));var m;(function(G){function q(C){return C}G.from=q;function j(C){if(C)return Object.assign(Object.create(null),C)}G.to=j})(m||(m={}));class k{#e;constructor(q,j,C){this._id=j,this.a=C,this.#e=q}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}let T=class{constructor(q,j,C,N,W,se,ue,ye){this.q=new I.$Wd,this.r=new I.$Wd,this.s=new I.$Wd,this.u=new I.$Wd,this.a=q.getProxy(R.$jL.MainThreadTask),this.b=C,this.c=N,this.d=W,this.e=se,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ue,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(q,j,C){if(!C)return new L.$lL(()=>{});const N=this.x();return this.j.set(N,{type:j,provider:C,extension:q}),this.a.$registerTaskProvider(N,j),new L.$lL(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(q,j){this.a.$registerTaskSystem(q,j)}fetchTasks(q){return this.a.$fetchTasks(m.from(q)).then(async j=>{const C=[];for(const N of j){const W=await f.to(N,this.b,this.m);W&&C.push(W)}return C})}get taskExecutions(){const q=[];return this.k.forEach(j=>q.push(j)),q}terminateTask(q){if(!(q instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(q._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(q,j,C){const N=this.m.get(q.id);N&&(this.o.set(q.id,N),this.e.attachPtyToTerminal(j,await N.callback(C))),this.p=q.id,this.q.fire({execution:await this.z(q)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(q){if(!this.l.has(q.id))return;const j=await this.z(q);this.l.delete(q.id),this.k.delete(q.id),this.B(q),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(q){const j=await this.z(q.id);this.s.fire({execution:j,processId:q.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(q){const j=await this.z(q.id);this.u.fire({execution:j,exitCode:q.exitCode})}$provideTasks(q,j){const C=this.j.get(q);if(!C)return Promise.reject(new Error("no handler found"));const N=[],W=(0,M.$Zg)(()=>C.provider.provideTasks(A.CancellationToken.None)).then(se=>this.v(j,N,C,se));return new Promise(se=>{W.then(ue=>{Promise.all(N).then(()=>{se(ue)})})})}async $resolveTask(q,j){const C=this.j.get(q);if(!C)return Promise.reject(new Error("no handler found"));if(j.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${C.type}].`);const N=await f.to(j,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const W=await C.provider.resolveTask(N,A.CancellationToken.None);if(!W)return;this.A(W,C);const se=f.from(W,C.extension);if(!se)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(se.execution)&&await this.y(se,W,!0),await this.w(se)}x(){return this.h++}async y(q,j,C){const N=await this.a.$createTaskId(q);!C&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,j.execution)),this.m.set(N,j.execution)}async z(q,j){if(typeof q=="string"){const W=this.l.get(q);if(!W)throw new a.$bb("Unexpected: The specified task is missing an execution");return W}const C=this.l.get(q.id);if(C)return C;let N;return j?N=Promise.resolve(new k(this,q.id,j)):N=f.to(q.task,this.b,this.m).then(W=>{if(!W)throw new a.$bb("Unexpected: Task does not exist.");return new k(this,q.id,W)}),this.l.set(q.id,N),N.then(W=>(this.k.set(q.id,W),W))}A(q,j){q._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(q){this.o.get(q.id)&&this.o.delete(q.id),this.n.has(q.id)&&this.p!==q.id&&(this.m.delete(q.id),this.n.delete(q.id));const C=this.n.values();let N=C.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=C.next()}};e.$Shc=T,e.$Shc=T=Je([qe(0,l.$oN),qe(1,p.$EN),qe(2,g.$ogc),qe(3,h.$zN),qe(4,E.$rgc),qe(5,D.$Pgc),qe(6,r.$pj),qe(7,t.$9fc)],T);let O=class extends T{constructor(q,j,C,N,W,se,ue,ye){super(q,j,C,N,W,se,ue,ye),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:c.$h(0)})}async executeTask(q,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const C=f.from(j,q);if(C===void 0)throw new Error("Task is not valid");if(d.is(C.execution))await this.y(C,j,!1);else throw new a.$_;const N=await this.z(await this.a.$getTaskExecution(C),j);return this.a.$executeTask(C).catch(W=>{throw new Error(W)}),N}v(q,j,C,N){const W=[];if(N)for(const se of N){if(this.A(se,C),!se.definition||!q[se.definition.type]){const ye=se.source?se.source:"No task source";this.f.warn(`The task [${ye}, ${se.name}] uses an undefined task type. The task will be ignored in the future.`)}const ue=f.from(se,C.extension);ue&&d.is(ue.execution)?(W.push(ue),j.push(this.y(ue,se,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:C.extension}}async w(q){if(d.is(q.execution))return q;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(q,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,j,C){}};e.$Thc=O,e.$Thc=O=Je([qe(0,l.$oN),qe(1,p.$EN),qe(2,g.$ogc),qe(3,h.$zN),qe(4,E.$rgc),qe(5,D.$Pgc),qe(6,r.$pj),qe(7,t.$9fc)],O),e.$Uhc=(0,$.$8h)("IExtHostTask")}),define(Re[283],Ae([1,0,44,29]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9J=e.$8J=e.$7J=void 0;function I(L){return"cellResults"in L}e.$7J=I,e.$8J="rawCell#";function R(L,g){let h=-1;const E=[];let A=[];return L.forEach(l=>{l.range.startLineNumber!==h&&A.length>0&&(E.push([...A]),A=[]),A.push(l),h=l.range.endLineNumber}),A.length>0&&E.push([...A]),E.map(l=>{const p=[],$=l[0].range.startLineNumber,n=l[l.length-1].range.endLineNumber;for(let c=$;c<=n;c++)p.push(g.getLineContent(c));return new S.$KJ(p.join(`
`)+`
`,l.map(c=>new M.$Ws(c.range.startLineNumber-1,c.range.startColumn-1,c.range.endLineNumber-1,c.range.endColumn-1)))})}e.$9J=R}),define(Re[284],Ae([1,0,162,23,5,6,28,13,16,2,42,75,3,31,8,7,49,259,109,26,12,211,283,281]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c,r,t,s,a,u,i,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=void 0;class o{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(y=>y.apiEditor)}constructor(y,d,b,P,f,m){this.q=b,this.r=P,this.s=f,this.t=m,this.f=new Map,this.g=new L.$Ac,this.h=new Map,this.j=new I.$Wd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$Wd,this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$Wd,this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$Wd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$2fc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=y.getProxy(l.$jL.MainThreadNotebook),this.c=y.getProxy(l.$jL.MainThreadNotebookDocuments),this.d=y.getProxy(l.$jL.MainThreadNotebookEditors),this.i=d.converter,d.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const T=k.notebookEditor?.notebookUri,O=k.cell.handle,q=this.g.get(T)?.getCell(O);if(q)return q.apiCell}if(k&&k.$mid===14){const T=k.uri,O=this.g.get(T);if(O)return O.apiNotebook}return k}}),o.B(d)}getEditorById(y){const d=this.h.get(y);if(!d)throw new Error(`unknown text editor: ${y}. known editors: ${[...this.h.keys()]} `);return d}getIdByEditor(y){for(const[d,b]of this.h)if(b.apiEditor===y)return d}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(y,d){const b=this.g.get(y);if(!b&&!d)throw new Error(`NO notebook document for '${y}'`);return b}static u(y,d){if(!d)return;const b=d.filenamePattern.map(P=>$.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(d.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:y.identifier,providerDisplayName:y.displayName||y.name,displayName:d.displayName,filenamePattern:b,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(y,d,b){const P=o.a++,f=typeof b.onDidChangeCellStatusBarItems=="function"?o.a++:void 0;this.f.set(P,b),this.b.$registerNotebookCellStatusBarItemProvider(P,f,d);let m;return f!==void 0&&(m=b.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(f))),new n.$lL(()=>{this.f.delete(P),this.b.$unregisterNotebookCellStatusBarItemProvider(P,f),m?.dispose()})}async createNotebookDocument(y){const d=await this.c.$tryCreateNotebook({viewType:y.viewType,content:y.content&&$.NotebookData.from(y.content)});return E.URI.revive(d)}async openNotebookDocument(y){const d=this.g.get(y);if(d)return d.apiNotebook;const b=await this.c.$tryOpenNotebook(y),P=this.g.get(E.URI.revive(b));return(0,h.$Uf)(P?.apiNotebook)}async showNotebookDocument(y,d){E.URI.isUri(y)&&(y=await this.openNotebookDocument(y));let b;typeof d=="object"?b={position:$.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map($.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:b={preserveFocus:!1};const P=await this.d.$tryShowNotebookDocument(y.uri,y.notebookType,b),f=P&&this.h.get(P)?.apiEditor;if(f)return f;throw P?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(y,d,b,P){const f=this.f.get(y),m=E.URI.revive(d),k=this.g.get(m);if(!k||!f)return;const T=k.getCellFromIndex(b);if(!T)return;const O=await f.provideCellStatusBarItems(T.apiCell,P);if(!O)return;const G=new R.$Sc,q=this.p.add([G]),C=(Array.isArray(O)?O:[O]).map(N=>$.NotebookStatusBarItem.from(N,this.i,G));return{cacheId:q,items:C}}$releaseNotebookCellStatusBarItems(y){this.p.delete(y)}registerNotebookSerializer(y,d,b,P,f){if((0,g.$Ke)(d))throw new Error("viewType cannot be empty or just whitespace");const m=this.w++;return this.x.set(m,{viewType:d,serializer:b,options:P}),this.b.$registerNotebookSerializer(m,{id:y.identifier,location:y.extensionLocation},d,$.NotebookDocumentContentOptions.from(P),o.u(y,f)),(0,R.$Rc)(()=>{this.b.$unregisterNotebookSerializer(m)})}async $dataToNotebook(y,d,b){const P=this.x.get(y);if(!P)throw new Error("NO serializer found");const f=await P.serializer.deserializeNotebook(d.buffer,b);return new c.$Vv($.NotebookData.from(f))}async $notebookToData(y,d,b){const P=this.x.get(y);if(!P)throw new Error("NO serializer found");const f=await P.serializer.serializeNotebook($.NotebookData.to(d.value),b);return M.$ke.wrap(f)}async $saveNotebook(y,d,b,P,f){const m=E.URI.revive(d),k=this.x.get(y);if(!k)throw new Error("NO serializer found");const T=this.g.get(m);if(!T)throw new Error("Document NOT found");if(T.versionId!==b)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(m.scheme))throw new A.$Nk((0,S.localize)(0,null,this.z(m)),6);await this.y(m,P);const O={metadata:(0,s.$Gn)(T.apiNotebook.metadata,N=>!(k.options?.transientDocumentMetadata??{})[N]),cells:[]};for(const N of T.apiNotebook.getCells()){const W=new n.$LM(N.kind,N.document.getText(),N.document.languageId,N.mime,k.options?.transientOutputs?[]:[...N.outputs],N.metadata,N.executionSummary);W.metadata=(0,s.$Gn)(N.metadata,se=>!(k.options?.transientCellMetadata??{})[se]),O.cells.push(W)}const G=await k.serializer.serializeNotebook(O,f);await this.s.value.writeFile(m,G);const q=this.s.getFileSystemProviderExtUri(m.scheme),j=await this.s.value.stat(m);return{name:q.basename(m),isFile:(j.type&A.FileType.File)!==0,isDirectory:(j.type&A.FileType.Directory)!==0,isSymbolicLink:(j.type&A.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(m.scheme),locked:!!((j.permissions??0)&A.FilePermission.Locked),etag:A.$Yk({mtime:j.mtime,size:j.size}),children:void 0}}async $searchInNotebooks(y,d,b,P,f){const m=this.x.get(y)?.serializer;if(!m)return{limitHit:!1,results:[]};const k=new L.$Bc;await(async(j,C,N)=>{await Promise.all(j.map(async W=>await Promise.all(W.filenamePatterns.map(se=>{const ue={_reason:N._reason,folderQueries:N.folderQueries,includePattern:N.includePattern,excludePattern:N.excludePattern,maxResults:N.maxResults,type:1,filePattern:se};return this.t.doInternalFileSearchWithCustomCallback(ue,C,ye=>{ye.forEach(ke=>{k.has(ke)||P.some(pe=>W.isFromSettings&&!pe.isFromSettings?!1:pe.filenamePatterns.some(oe=>(0,v.$Gdb)(oe,ke)))||k.add(ke)})})}))))})(b,f,d);const O=new L.$Ac;let G=!1;const q=Array.from(k).map(async j=>{const C=[];try{if(f.isCancellationRequested)return;if(d.maxResults&&[...O.values()].reduce((ue,ye)=>ue+ye.cellResults.length,0)>d.maxResults){G=!0;return}const N=[],W=this.g.get(j);if(W)W.apiNotebook.getCells().forEach(ye=>N.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(ke=>ke.items.map(ae=>ae.data.toString()))}));else{const ue=await this.s.value.readFile(j),ye=M.$ke.fromString(ue.toString()),ke=await m.deserializeNotebook(ye.buffer,f);if(f.isCancellationRequested)return;$.NotebookData.from(ke).cells.forEach(pe=>N.push({input:pe.source,outputs:pe.outputs.flatMap(oe=>oe.items.map($e=>$e.valueBytes.toString()))}))}if(f.isCancellationRequested)return;N.forEach((ue,ye)=>{const ke=d.contentPattern.pattern,ae=new u.$GRb(ue.input,void 0,ue.outputs),pe=ae.findInInputs(ke),oe=ae.findInOutputs(ke),$e=oe.flatMap(ie=>(0,i.$9J)(ie.matches,ie.textBuffer)).map((ie,x)=>(ie.webviewIndex=x,ie));if(pe.length>0||oe.length>0){const ie={index:ye,contentResults:(0,i.$9J)(pe,ae.inputTextBuffer),webviewResults:$e};C.push(ie)}});const se={resource:j,cellResults:C};O.set(j,se);return}catch{return}});return await Promise.all(q),{limitHit:G,results:[...O.values()]}}async y(y,d){const b=await this.s.value.stat(y);if(typeof d?.mtime=="number"&&typeof d.etag=="string"&&d.etag!==A.$Xk&&typeof b.mtime=="number"&&typeof b.size=="number"&&d.mtime<b.mtime&&d.etag!==A.$Yk({mtime:d.mtime,size:b.size}))throw new A.$Nk((0,S.localize)(1,null),3,d)}z(y){return y.scheme===a.Schemas.file?y.fsPath:y.toString()}A(y,d,b){if(this.h.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const P=new t.$lhc(d,this.d,y,b.visibleRanges.map($.NotebookRange.to),b.selections.map($.NotebookRange.to),typeof b.viewColumn=="number"?$.ViewColumn.to(b.viewColumn):void 0);this.h.set(d,P)}$acceptDocumentAndEditorsDelta(y){if(y.value.removedDocuments)for(const b of y.value.removedDocuments){const P=E.URI.revive(b),f=this.g.get(P);f&&(f.dispose(),this.g.delete(P),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(m=>m.document.uri)}),this.n.fire(f.apiNotebook));for(const m of this.h.values())m.notebookData.uri.toString()===P.toString()&&this.h.delete(m.id)}if(y.value.addedDocuments){const b=[];for(const P of y.value.addedDocuments){const f=E.URI.revive(P.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const m=new r.$khc(this.c,this.q,this.r,f,P);b.push(...P.cells.map(k=>r.$jhc.asModelAddData(m.apiNotebook,k))),this.g.get(f)?.dispose(),this.g.set(f,m),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(m.apiNotebook)}}if(y.value.addedEditors)for(const b of y.value.addedEditors){if(this.h.has(b.id))return;const P=E.URI.revive(b.documentUri),f=this.g.get(P);f&&this.A(f,b.id,b)}const d=[];if(y.value.removedEditors)for(const b of y.value.removedEditors){const P=this.h.get(b);P&&(this.h.delete(b),this.k?.id===P.id&&(this.k=void 0),d.push(P))}if(y.value.visibleEditors){this.l=y.value.visibleEditors.map(P=>this.h.get(P)).filter(P=>!!P);const b=new Set;this.l.forEach(P=>b.add(P.id));for(const P of this.h.values()){const f=b.has(P.id);P._acceptVisibility(f)}this.l=[...this.h.values()].map(P=>P).filter(P=>P.visible),this.o.fire(this.visibleNotebookEditors)}y.value.newActiveEditor===null?this.k=void 0:y.value.newActiveEditor&&(this.h.get(y.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${y.value.newActiveEditor}`),this.k=this.h.get(y.value.newActiveEditor)),y.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(y){const d=p.$MN.String.with("notebookType","A notebook type"),b=new p.$ON("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new p.$MN("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>M.$ke.wrap(f))],new p.$NN("Notebook Data",f=>$.NotebookData.to(f.value))),P=new p.$ON("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new p.$MN("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new c.$Vv($.NotebookData.from(f)))],new p.$NN("Bytes",f=>f.buffer));y.registerApiCommand(b),y.registerApiCommand(P)}}e.$uhc=o}),define(Re[285],Ae([1,0,19,21,41,34,25,63,44]),function(me,e,S,M,I,R,L,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0;class E{constructor(l,p,$){this.k=l,this.l=p,this.o=$,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&R.$Oj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&R.$Oj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const p=this.k.folderQueries||[];return new Promise(($,n)=>{const c=r=>{this.f++,l(r)};if(this.g)return $({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const t=r.toString(),s=S.$nc(t);this.j&&this.j(t,s)||this.v(c,{base:r,basename:s})}),Promise.all(p.map(r=>this.p(r,c))).then(r=>{$({limitHit:this.e,stats:r[0]||void 0})},r=>{n(new Error((0,I.$Si)(r)))})})}async p(l,p){const $=new M.$7d,n=this.q(l),c=this.r(),r=new h.$YJ(this.k,l),t=!r.hasSiblingExcludeClauses();let s;try{this.h.add($),s=g.$Sd.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,$.token),u=s.elapsed(),i=g.$Sd.create();return this.g&&!this.e||(a&&a.forEach(v=>{const o=S.$gc.relative(l.folder.path,v.path);if(t){const w=S.$nc(v.path);this.v(p,{base:l.folder,relativePath:o,basename:w});return}this.s(c,l.folder,o,p)}),this.g&&!this.e)?null:(this.u(c,r,p),{providerTime:u,postProcessTime:i.elapsed()})}finally{$.dispose(),this.h.delete($)}}q(l){const p=(0,h.$XJ)(this.k.includePattern,l.includePattern),$=(0,h.$XJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:$,includes:p,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},p,$,n){if($===this.a){const r=S.$nc(this.a);this.v(n,{base:p,relativePath:this.a,basename:r})}function c(r){const t=S.$nc(r),s=S.$mc(r);let a=l[s];a||(a=l[s]=[],c(s)),a.push({base:p,relativePath:r,basename:t})}c($)}u({rootEntries:l,pathToEntries:p},$,n){const c=this,r=this.a;function t(s){const a=(0,h.$1J)(()=>s.map(u=>u.basename));for(let u=0,i=s.length;u<i;u++){const v=s[u],{relativePath:o,basename:w}=v;if($.matchesExcludesSync(o,w,r!==w?a:void 0))continue;const y=p[o];if(y)t(y);else{if(o===r)continue;c.v(n,v)}if(c.e)break}}t(l)}v(l,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(p))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,p,$,n){const c=this.c(l.cacheKey),r=new E(l,p,c&&c.token);let t=0;const s=a=>{t+=a.length,$(a.map(u=>this.d(u)))};return this.e(r,A.a,s,n).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:t,detailStats:a.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new M.$7d),this.b.get(l)}d(l){return l.relativePath?{resource:L.$Ig(l.base,l.relativePath)}:{resource:l.base}}e(l,p,$,n){const c=n.onCancellationRequested(()=>{l.cancel()}),r=s=>{s&&(t.push(s),p>0&&t.length>=p&&($(t),t=[]))};let t=[];return l.search(r).then(s=>(t.length&&$(t),c.dispose(),s),s=>(t.length&&$(t),c.dispose(),Promise.reject(s)))}}e.$mhc=A}),define(Re[286],Ae([1,0,18,254,34,95,28,12,19,25,13,16,2,94,179,46,14,47,104,282,44]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c,r,t,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1K=e.$ZK=void 0;let u=class{constructor(m,k,T,O,G){this.a=m,this.b=k,this.c=T,this.d=O,this.e=G}text(m,k,T={}){m=this.f(m,T);const O=this.a.getValue(),G=k&&k.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(k?.map(r.$qi),T),type:2,contentPattern:m,previewOptions:T.previewOptions,maxFileSize:T.maxFileSize,usePCRE2:O.search.usePCRE2||G||!1,beforeContext:T.beforeContext,afterContext:T.afterContext,userDisabledExcludesAndIgnoreFiles:T.disregardExcludeSettings&&T.disregardIgnoreFiles}}f(m,k){const T=this.a.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const O={...m,wordSeparators:T.editor.wordSeparators};return this.j(m,k)&&(O.isCaseSensitive=!0),this.k(m)&&(O.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),O}file(m,k={}){return{...this.h(m,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(m,k){return m?(m=Array.isArray(m)?m.map(y):y(m),k?this.parseSearchPaths(m):{pattern:v(...Array.isArray(m)?m:[m])}):{}}h(m=[],k={}){const T=this.g(k.includePattern,k.expandPatterns),O=this.g(k.excludePattern,k.expandPatterns),G=m.length>1,q=(T.searchPaths&&T.searchPaths.length?T.searchPaths.map(N=>this.q(N,k,O)):m.map(N=>this.r(N,k,O,G))).filter(N=>!!N),j={_reason:k._reason,folderQueries:q,usingSearchPaths:!!(T.searchPaths&&T.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:O.pattern,includePattern:T.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const N=S.$Hb(S.$Rb(this.c.groups.map(ue=>ue.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const W=N.filter(ue=>(0,a.$OJ)(j,ue.fsPath)),se=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(se)),{...j,...se}}const C=k.extraFileResources&&k.extraFileResources.filter(N=>(0,a.$OJ)(j,N.fsPath));return j.extraFileResources=C&&C.length?C:void 0,j}i(m){const k=[],T=new L.$Ac,O={};let G=!1;return m.forEach(q=>{if(q.scheme===g.Schemas.walkThrough)return;if((0,E.$Mg)(q)){const C=this.b.getWorkspaceFolder(q)?.uri??q.with({path:h.$mc(q.fsPath)});let N=T.get(C);N||(G=!0,N={folder:C,includePattern:{}},k.push(N),T.set(C,N));const W=h.$lc(C.fsPath,q.fsPath);(0,D.$Uf)(N.includePattern)[W.replace(/\\/g,"/")]=!0}else q.fsPath&&(G=!0,O[q.fsPath]=!0)}),{folderQueries:k,includePattern:O,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(m,k){if(k.isSmartCase){if(m.isRegExp){if(A.$Af(m.pattern,!0))return!0}else if(A.$Af(m.pattern))return!0}return!!m.isCaseSensitive}k(m){return m.isMultiline||m.isRegExp&&(0,p.$6B)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const k=se=>h.$ic(se)||/^\.\.?([\/\\]|$)/.test(se),O=(Array.isArray(m)?m:o(m)).map(se=>{const ue=this.e.resolvedUserHome;return ue?(0,R.$1v)(se,ue.scheme===g.Schemas.file?ue.fsPath:ue.path):se}),G=M.$K(O,se=>k(se)?"searchPaths":"exprSegments"),q=(G.exprSegments||[]).map(se=>A.$Ve(se,"/")).map(se=>A.$Ve(se,"\\")).map(se=>(se[0]==="."&&(se="*"+se),w(se))),j={},C=this.m(G.searchPaths||[]);C&&C.length&&(j.searchPaths=C);const N=S.$Rb(q),W=v(...N);return W&&(j.pattern=W),j}l(m,k){return k.disregardExcludeSettings?void 0:(0,a.$NJ)(m,!k.disregardSearchExcludeSettings)}m(m){if(!m||!m.length)return[];const k=m.flatMap(O=>{let{pathPortion:G,globPortion:q}=i(O);return q&&(q=d(q)),this.n(G).flatMap(C=>this.o(C,q))}),T=new Map;return k.forEach(O=>{const G=O.searchPath.toString(),q=T.get(G);q?O.pattern&&(q.pattern=q.pattern||{},q.pattern[O.pattern]=!0):T.set(G,{searchPath:O.searchPath,pattern:O.pattern?v(O.pattern):void 0})}),Array.from(T.values())}n(m){if(h.$ic(m)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==g.Schemas.file?[{searchPath:k[0].uri.with({path:m})}]:[{searchPath:l.URI.file(h.$hc(m))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(m=y(m),m.startsWith("../")||m===".."){const O=h.$gc.resolve(k.path,m);return[{searchPath:k.with({path:O})}]}const T=d(m);return[{searchPath:k,pattern:T}]}else{if(m==="./"||m===".\\")return[];{const k=m.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(G=>{const q=k.match(new RegExp(`^${A.$Pe(G.name)}(?:/(.*)|$)`));return q?{match:q,folder:G}:null}).filter(D.$Rf);if(O.length)return O.map(G=>{const q=G.match[1];return{searchPath:G.folder.uri,pattern:q&&d(q)}});{const G=m.match(/\.[\/\\](.+)[\/\\]?/),q=G?G[1]:m,j=$.localize(0,null,q);throw new Error(j)}}}}o(m,k){const T=m.pattern&&k?`${m.pattern}/${k}`:m.pattern||k,O=[{searchPath:m.searchPath,pattern:T}];return T&&!T.endsWith("**")&&O.push({searchPath:m.searchPath,pattern:T+"/**"}),O}q(m,k,T){const O=this.r((0,r.$qi)(m.searchPath),k,T,!1);return O?{...O,includePattern:m.pattern}:null}r(m,k,T,O){let G;const q=l.URI.isUri(m)?m:m.uri;if(T.searchPaths){const se=T.searchPaths.filter(ue=>(0,E.$Bg)(ue.searchPath,q))[0];if(se&&!se.pattern)return null;se&&(G=se.pattern)}const j=this.a.getValue({resource:q}),N={...this.l(j,k)||{},...G||{}},W=l.URI.isUri(m)?(0,E.$Fg)(m):m.name;return{folder:q,folderName:O?W:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!j.search.followSymlinks}}};e.$ZK=u,e.$ZK=u=Je([qe(0,n.$Bi),qe(1,r.$ei),qe(2,t.$aD),qe(3,c.$pj),qe(4,s.$XK)],u);function i(f){const m=f.match(/[\*\{\}\(\)\[\]\?]/);if(m){const k=m.index,T=f.substr(0,k).match(/[/|\\][^/\\]*$/);if(T){let O=f.substr(0,T.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:f.substr((T.index||0)+1)}}}return{pathPortion:f}}function v(...f){return f.length?f.reduce((m,k)=>(m[k]=!0,m),Object.create(null)):void 0}function o(f){return I.$Mj(f,",").map(m=>m.trim()).filter(m=>!!m.length)}function w(f){return[`**/${f}/**`,`**/${f}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function y(f){return f.replace(/\\/g,"/")}function d(f){return y(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function b(f){return f.replace(/([?*[\]])/g,"[$1]")}function P(f,m){f=S.$Mb(f,O=>O.toString());const k=[],T=m.getWorkspace();return f&&f.forEach(O=>{let G;if(m.getWorkbenchState()===2)G=(0,E.$Kg)(T.folders[0].uri,O),G&&G!=="."&&(G="./"+G);else{const q=m.getWorkspaceFolder(O);if(q){const j=q.name;if(T.folders.filter(N=>N.name===j).length===1){const N=(0,E.$Kg)(q.uri,O);N===""?G=`./${q.name}`:G=`./${q.name}/${N}`}else G=O.fsPath}}G&&k.push(b(G))}),k}e.$1K=P}),define(Re[287],Ae([1,0,25,2,21,15,4,286,44,47,11]),function(me,e,S,M,I,R,L,g,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gtb=e.$ftb=void 0;const D=7e3;function l(c,r){const t=r.activationEvents;if(!t)return Promise.resolve(void 0);const s=[],a=[];for(const y of t)if(/^workspaceContains:/.test(y)){const d=y.substr(18);d.indexOf("*")>=0||d.indexOf("?")>=0||c.forceUsingSearch?a.push(d):s.push(d)}if(s.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:u,resolve:i}=(0,A.$1g)(),v=y=>i({activationEvent:y}),o=Promise.all(s.map(y=>p(c,y,v))).then(()=>{}),w=$(c,r.identifier,a,v);return Promise.all([o,w]).then(()=>{i(void 0)}),u}e.$ftb=l;async function p(c,r,t){for(const s of c.folders)if(await c.exists(S.$Ig(M.URI.revive(s),r))){t(`workspaceContains:${r}`);return}}async function $(c,r,t,s){if(t.length===0)return Promise.resolve(void 0);const a=new I.$7d,u=c.checkExists(c.folders,t,a.token),i=setTimeout(async()=>{a.cancel(),c.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},D);let v=!1;try{v=await u}catch(o){R.$4(o)||R.$1(o)}a.dispose(),clearTimeout(i),v&&s(`workspaceContains:${t.join(",")}`)}function n(c,r,t,s){const a=c.get(L.$7h),u=c.get(h.$FJ),v=a.createInstance(g.$ZK).file(r.map(o=>(0,E.$qi)(M.URI.revive(o))),{_reason:"checkExists",includePattern:t,exists:!0});return u.fileSearch(v,s).then(o=>!!o.limitHit,o=>R.$4(o)?!1:Promise.reject(o))}e.$gtb=n}),define(Re[38],Ae([1,0,159,19,88,25,11,6,50,2,14,3,37,217,83,36,24,105,15,22,23,200,7,100,4,27,85,17,71,86,65,5,287,82,202,12,80,63,20,81]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c,r,t,s,a,u,i,v,o,w,y,d,b,P,f,m,k,T,O,G,q,j,C,N){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=e.$4gc=e.$3gc=e.$2gc=e.$1gc=void 0,e.$1gc=(0,o.$8h)("IHostUtils");let se=W=class extends g.$Tc{constructor(x,V,ne,Ie,Me,Le,be,ge,K,ee,le,fe){super(),this.X=fe,this.a=this.B(new m.$Wd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ne,this.f=be,this.j=Ie,this.m=Me,this.s=Le,this.t=K,this.u=ee,this.w=le,this.y=this.g.getProxy(D.$jL.MainThreadWorkspace),this.z=this.g.getProxy(D.$jL.MainThreadTelemetry),this.C=this.g.getProxy(D.$jL.MainThreadExtensionService),this.D=new L.$7g,this.F=new L.$7g,this.G=new L.$7g,this.H=new L.$7g,this.I=new $e(this.f.extensions.activationEvents),this.L=new r.$77b(this.I,this.f.extensions.allExtensions);const Ce=new s.$om(this.f.extensions.myExtensions);this.J=new r.$77b(this.I,pe(this.L,Ce)),C.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ke(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ke(this.J)}`)),this.M=new $.$Lgc(this.g,this.s),this.N=new T.$Tgc(this.g),this.O=ge,this.h=x.createChild(new b.$6h([$.$Mgc,this.M],[T.$Ugc,this.N])),this.P=this.B(new p.$Kgc(this.J,this.L,{onExtensionActivationError:(de,we,F)=>{this.C.$onExtensionActivationError(de,t.$3(we),F)},actualActivateExtension:async(de,we)=>{if(r.$77b.isHostExtension(de,this.J,this.L))return await this.C.$activateExtension(de,we),new p.$Jgc;const F=this.J.getExtensionDescription(de);return this.db(F,we)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(x){t.$1(x)}}async Y(){this.O.onWillDeactivateAll();let x=[];try{x=this.J.getAllExtensionDescriptions().map(Me=>Me.identifier).filter(Me=>this.isActivated(Me)).map(Me=>this.cb(Me))}catch{}await Promise.all(x)}terminate(x,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${x}`),this.s.flush(),this.u.dispose(),this.P.dispose(),t.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const ne=this.Y();Promise.race([(0,L.$9g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(x){return this.G.isOpen()?this.P.isActivated(x):!1}async getExtension(x){const V=await this.C.$getExtension(x);return V&&{...V,identifier:new s.$nm(V.identifier.value),extensionLocation:E.URI.revive(V.extensionLocation)}}Z(x,V){return this.P.activateByEvent(x,V)}$(x,V){return this.P.activateById(x,V)}activateByIdWithErrors(x,V){return this.$(x,V).then(()=>{const ne=this.P.getActivatedExtension(x);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(x=>this.J)}getExtensionExports(x){if(this.G.isOpen())return this.P.getActivatedExtension(x).exports;try{return this.P.getActivatedExtension(x).exports}catch{return null}}async ab(x){if(x.scheme===G.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(x.fsPath);return E.URI.file(V)}return x}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(x=>new oe(x))),this.Q}async bb(x){const V=h.$bi.forUris(ne=>R.$zg.ignorePathCasing(ne));return await Promise.all(x.map(async ne=>{if(this.ub(ne)){const Ie=await this.ab(ne.extensionLocation);V.set(Ie,ne)}})),V}cb(x){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(x))return V;const ne=this.P.getActivatedExtension(x);if(!ne)return V;try{typeof ne.module.deactivate=="function"&&(V=Promise.resolve(ne.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${x.value}':`),this.s.error(Ie)}try{(0,g.$Oc)(ne.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${x.value}':`),this.s.error(Ie)}return V}async db(x,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(x.identifier):await this.C.$onWillActivateExtension(x.identifier),this.fb(x,V).then(ne=>{const Ie=ne.activationTimes;return this.C.$onDidActivateExtension(x.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,V),this.eb(x,V,"success",Ie),ne},ne=>{throw this.eb(x,V,"failure"),ne})}eb(x,V,ne,Ie){const Me=ye(x,V);this.z.$publicLog2("extensionActivationTimes",{...Me,...Ie||{},outcome:ne})}fb(x,V){const ne=ye(x,V);this.z.$publicLog2("activatePlugin",ne);const Ie=this.ub(x);if(!Ie)return Promise.resolve(new p.$Igc(p.$Fgc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${x.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${x.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Me=new p.$Ggc(V.startup);return Promise.all([this.vb(x,(0,R.$Ig)(x.extensionLocation,Ie),Me),this.gb(x)]).then(Le=>(I.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),W.hb(this.s,x.identifier,Le[0],Le[1],Me))).then(Le=>(I.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),Le))}gb(x){const V=new u.$Ogc(x,this.M),ne=new u.$Ngc(x.identifier.value,!1,this.M),Ie=new O.$Vgc(x,this.N),Me=x.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Le=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([V.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const be=this;let ge,K;const ee=(0,c.$KF)(x,"ipc")?this.f.messagePorts?.get(s.$nm.toKey(x.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ne,secrets:Ie,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(le){return M.$jc(x.extensionLocation.fsPath,le)},get storagePath(){return be.O.workspaceValue(x)?.fsPath},get globalStoragePath(){return be.O.globalValue(x).fsPath},get logPath(){return M.$jc(be.f.logsLocation.fsPath,x.identifier.value)},get logUri(){return E.URI.joinPath(be.f.logsLocation,x.identifier.value)},get storageUri(){return be.O.workspaceValue(x)},get globalStorageUri(){return be.O.globalValue(x)},get extensionMode(){return Me},get extension(){return ge===void 0&&(ge=new ae(be,x.identifier,x,Le,!1)),ge},get extensionRuntime(){return(0,c.$LF)(x,"extensionRuntime"),be.extensionRuntime},get environmentVariableCollection(){return be.u.getEnvironmentVariableCollection(x)},get messagePassingProtocol(){if(!K){if(!ee)return;const le=m.Event.buffer(m.Event.fromDOMEventEmitter(ee,"message",fe=>fe.data));ee.start(),K={onDidReceiveMessage:le,postMessage:ee.postMessage.bind(ee)}}return K}})})}static hb(x,V,ne,Ie,Me){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(x,V,ne,Ie,Me).then(Le=>new p.$Hgc(!1,null,Me.build(),ne,Le,Ie.subscriptions))}static ib(x,V,ne,Ie,Me){if(typeof ne.activate=="function")try{Me.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Le=typeof global=="object"?global:self,be=ne.activate.apply(Le,[Ie]);return Me.activateCallStop(),Me.activateResolveStart(),Promise.resolve(be).then(ge=>(Me.activateResolveStop(),ge))}catch(Le){return Promise.reject(Le)}else return Promise.resolve(ne)}jb(x,V){this.$(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:V}).then(void 0,ne=>{this.s.error(ne)})}kb(x,V=0){const Ie=Date.now();(0,C.$B)(()=>{for(let Me=V;Me<x.length;Me+=1){const Le=x[Me];for(const be of Le.activationEvents??[])if(be==="onStartupFinished")if(Date.now()-Ie>50){this.kb(x,Me);break}else this.jb(Le,be)}})}lb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(x=>{const V=x.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(V)this.kb(ne);else for(const Ie of ne)if(Ie.activationEvents)for(const Me of Ie.activationEvents)Me==="onStartupFinished"&&this.jb(Ie,Me)})}mb(){const x=this.Z("*",!0).then(void 0,Le=>{this.s.error(Le)});this.B(this.j.onDidChangeWorkspace(Le=>this.nb(Le.added)));const V=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(V),Ie=this.pb(),Me=Promise.all([Ie,x,ne]).then(()=>{});return Promise.race([Me,(0,L.$9g)(1e4)]).then(()=>{this.lb()}),Me}nb(x){return x.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(x,V))).then(()=>{})}async ob(x,V){if(this.isActivated(V.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:x.map(Le=>Le.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Le=>this.c.fsExists(Le.fsPath),checkExists:(Le,be,ge)=>this.y.$checkExists(Le,be,ge)},Me=await(0,k.$ftb)(Ie,V);if(Me)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Me.activationEvent}).then(void 0,Le=>this.s.error(Le))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(x){throw console.error(x),x}}async qb(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:V}=this.f.environment;if(!x||!V)throw new Error(S.localize(0,null));const ne=await this.vb(null,V,new p.$Ggc(!1));if(!ne||typeof ne.run!="function")throw new Error(S.localize(1,null,V.toString()));return new Promise((Ie,Me)=>{const Le=(K,ee)=>{K?(C.$t&&this.s.error("Test runner called back with error",K),Me(K)):(C.$t&&(ee?this.s.info(`Test runner called back with ${ee} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof ee=="number"&&ee>0?1:0))},be=(0,R.$wg)(V),ge=ne.run(be,Le);ge&&ge.then&&ge.then(()=>{C.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(K=>{C.$t&&this.s.error("Test runner finished with error",K),Me(K instanceof Error&&K.stack?K.stack:String(K))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$9g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(x,V){return this.R[x]=V,(0,g.$Rc)(()=>{delete this.R[x]})}async getRemoteExecServer(x){const{resolver:V}=await this.sb(x);return V?.resolveExecServer?.(x,{resolveAttempt:0})}async sb(x){const V=x.indexOf("+");if(V===-1)throw new i.$rL("Not an authority that can be resolved!",v.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=x.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(x,V){const ne=j.$Sd.create(!1),Ie=()=>`[resolveAuthority(${(0,v.$bl)(x)},${V})][${ne.elapsed()}ms] `,Me=J=>this.s.info(`${Ie()}${J}`),Le=J=>this.s.warn(`${Ie()}${J}`),be=(J,B=void 0)=>this.s.error(`${Ie()}${J}`,B),ge=J=>{if(J instanceof i.$rL)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},K=async J=>{Me(`activating resolver for ${J}...`);const{resolver:B,authorityPrefix:Q}=await this.sb(J);if(!B)throw be(`no resolver for ${Q}`),new i.$rL(`No remote extension installed to resolve ${Q}.`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:B,authorityPrefix:Q,remoteAuthority:J}},ee=x.split(/@|%40/g).reverse();Me(`activating remote resolvers ${ee.join(" -> ")}`);let le;try{le=await Promise.all(ee.map(K)).catch(async J=>{if(!(J instanceof i.$rL)||J._code!==v.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return Le(`resolving nested authorities failed: ${J.message}`),[await K(x)]})}catch(J){return ge(J)}const fe=new L.$gh;fe.cancelAndSet(()=>Me("waiting..."),1e3);let Ce,de;for(const[J,{authorityPrefix:B,resolver:Q,remoteAuthority:_}]of le.entries())try{if(J===le.length-1)Me("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${B}`),Ce=await Q.resolve(_,{resolveAttempt:V,execServer:de}),I.mark(`code/extHost/didResolveAuthorityOK/${B}`),Me("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Q,i.$qL.isManagedResolvedAuthority(Ce)?Ce:void 0));else{if(Me(`invoking resolveExecServer() for ${_}`),I.mark(`code/extHost/willResolveExecServer/${B}`),de=await Q.resolveExecServer?.(_,{resolveAttempt:V,execServer:de}),!de)throw new i.$rL(`Exec server was not available for ${_}`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${B}`)}}catch(Ee){return I.mark(`code/extHost/didResolveAuthorityError/${B}`),be("returned an error",Ee),fe.dispose(),ge(Ee)}fe.dispose();const we={environmentTunnels:Ce.environmentTunnels,features:Ce.tunnelFeatures?{elevation:Ce.tunnelFeatures.elevation,privacyOptions:Ce.tunnelFeatures.privacyOptions,protocol:Ce.tunnelFeatures.protocol===void 0?!0:Ce.tunnelFeatures.protocol}:void 0},F={extensionHostEnv:Ce.extensionHostEnv,isTrusted:Ce.isTrusted,authenticationSession:Ce.authenticationSessionForInitializingExtensions?{id:Ce.authenticationSessionForInitializingExtensions.id,providerId:Ce.authenticationSessionForInitializingExtensions.providerId}:void 0};Me(`returned ${i.$qL.isManagedResolvedAuthority(Ce)?"managed authority":`${Ce.host}:${Ce.port}`}`);let H;if(i.$qL.isManagedResolvedAuthority(Ce)){const J=V;this.X.setFactory(J,Ce.makeConnection),H={authority:x,connectTo:new v.$$k(J),connectionToken:Ce.connectionToken}}else H={authority:x,connectTo:new v.$_k(Ce.host,Ce.port),connectionToken:Ce.connectionToken};return{type:"ok",value:{authority:H,options:F,tunnelInformation:we}}}async $getCanonicalURI(x,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,v.$bl)(x)})`);const{resolver:ne}=await this.sb(x);if(!ne)return null;const Ie=E.URI.revive(V);if(typeof ne.getCanonicalURI>"u")return Ie;const Me=await(0,L.$Zg)(()=>ne.getCanonicalURI(Ie));return Me||Ie}$startExtensionHost(x){x.toAdd.forEach(Ie=>Ie.extensionLocation=E.URI.revive(Ie.extensionLocation));const{globalRegistry:V,myExtensions:ne}=ue(this.I,this.L,this.J,x);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ke(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ke(this.J)}`)),this.rb()}$activateByEvent(x,V){return V===1?this.D.wait().then(ne=>this.Z(x,!1)):this.G.wait().then(ne=>this.Z(x,!1))}async $activate(x,V){return await this.G.wait(),this.J.getExtensionDescription(x)?(await this.$(x,V),!0):!1}async $deltaExtensions(x){x.toAdd.forEach(Le=>Le.extensionLocation=E.URI.revive(Le.extensionLocation));const{globalRegistry:V,myExtensions:ne}=ue(this.I,this.L,this.J,x),Ie=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ke(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ke(this.J)}`)),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){const V=a.$ke.alloc(x),ne=Math.random()%256;for(let Ie=0;Ie<x;Ie++)V.writeUInt8(ne,Ie);return V}async $updateRemoteConnectionData(x){this.W=x,this.a.fire()}};e.$2gc=se,e.$2gc=se=W=Je([qe(0,o.$7h),qe(1,e.$1gc),qe(2,d.$oN),qe(3,n.$ogc),qe(4,l.$rgc),qe(5,A.$pj),qe(6,w.$EN),qe(7,y.$ugc),qe(8,P.$izb),qe(9,f.$Pgc),qe(10,q.$Xgc),qe(11,N.$Ygc)],se);function ue(ie,x,V,ne){ie.addActivationEvents(ne.addActivationEvents);const Ie=new r.$77b(ie,x.getAllExtensionDescriptions());Ie.deltaExtensions(ne.toAdd,ne.toRemove);const Me=new s.$om(V.getAllExtensionDescriptions().map(be=>be.identifier));for(const be of ne.myToRemove)Me.delete(be);for(const be of ne.myToAdd)Me.add(be);const Le=pe(Ie,Me);return{globalRegistry:Ie,myExtensions:Le}}function ye(ie,x){return{id:ie.identifier.value,name:ie.name,extensionVersion:ie.version,publisherDisplayName:ie.publisher,activationEvents:ie.activationEvents?ie.activationEvents.join(","):null,isBuiltin:ie.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}function ke(ie){return ie.getAllExtensionDescriptions().map(x=>x.identifier.value).join(",")}e.$3gc=(0,o.$8h)("IExtHostExtensionService");class ae{#e;#t;#i;constructor(x,V,ne,Ie,Me){this.#e=x,this.#t=V,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=M.$hc((0,R.$wg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ie,this.isFromDifferentExtensionHost=Me}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$4gc=ae;function pe(ie,x){return ie.getAllExtensionDescriptions().filter(V=>x.has(V.identifier))}class oe{constructor(x){this.a=x}setSearchTree(x){this.a=x}findSubstr(x){return this.a.findSubstr(x)}forEach(x){return this.a.forEach(x)}}e.$5gc=oe;class $e{constructor(x){this.a=new s.$pm,this.addActivationEvents(x)}readActivationEvents(x){return this.a.get(x.identifier)??[]}addActivationEvents(x){for(const V of Object.keys(x))this.a.set(V,x[V])}}}),define(Re[288],Ae([1,0,88,2,3,37,24,22,17,27,4,38,14,13]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=void 0;let n=class{constructor(a,u,i,v,o,w,y){this.c=a,this.d=u,this.e=i,this.f=v,this.g=o,this.h=w,this.i=y,this.a=new Map,this.b=[]}async install(){this.j(),S.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const u=await this.g.getExtensionPathIndex();this.register(new r(this.c,u,this.d,a,this.i)),this.register(this.e.createInstance(c)),this.h.remote.isRemote&&this.register(this.e.createInstance(t,u,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const u of a.nodeModuleName)this.a.set(u,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(u=>a.alternativeModuleName(u))}};e.$aic=n,e.$aic=n=Je([qe(2,A.$7h),qe(3,R.$rgc),qe(4,D.$3gc),qe(5,E.$EN),qe(6,l.$pj)],n);let c=class{static{$=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&$.a.size){const u=(0,p.$Pe)(this.c(a.environment.appRoot.fsPath)),i="[a-z0-9_.-]",v=`@${i}+\\/${i}+|${i}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${u}/${o}\\/)(${v})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const u=this.b.exec(this.c(a));if(!u)return;const[,i,v,o]=u,w=$.a.get(v);if(w!==void 0)return console.warn(`${v} as been renamed to ${w}, please update your imports`),i+w+o}c(a){return a.replace(/\\/g,"/")}};c=$=Je([qe(0,E.$EN)],c);class r{constructor(a,u,i,v,o){this.c=a,this.d=u,this.e=i,this.f=v,this.g=o,this.nodeModuleName="vscode",this.a=new g.$pm}load(a,u){const i=this.d.findSubstr(u);if(i){let v=this.a.get(i.identifier);return v||(v=this.c(i,this.e,this.f),this.a.set(i.identifier,v)),v}if(!this.b){let v="";this.d.forEach((o,w)=>v+=`	${w} -> ${o.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${v}`),this.b=this.c(L.$FF,this.e,this.f)}return this.b}}let t=class{constructor(a,u,i){this.e=a,this.f=u,this.nodeModuleName=["open","opn"],this.d=i.getProxy(I.$jL.MainThreadTelemetry);const v=i.getProxy(I.$jL.MainThreadWindow);this.c=(o,w)=>{const y=M.URI.parse(o);return w?this.g(o,w):y.scheme==="http"||y.scheme==="https"?v.$openUri(y,o,{allowTunneling:!0}):y.scheme==="mailto"||y.scheme===this.f?v.$openUri(y,o,{}):this.g(o,w)}}load(a,u,i){const v=this.e.findSubstr(u);return v&&(this.a=v.identifier.value,this.h()),this.b=i(a),this.c}g(a,u){return this.i(),this.b(a,u)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};t=Je([qe(2,h.$oN)],t)}),define(Re[116],Ae([1,0,39,6,19,74,4,66,64,38,7,36,214,37]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=e.$6gc=void 0,e.$6gc=(0,L.$8h)("IExtHostVariableResolverProvider");class $ extends l.$pO{constructor(r,t,s,a,u,i,v){function o(){if(s){const w=s.activeEditor();if(w)return w.document.uri;const y=a.tabGroups.all.find(d=>d.isActive)?.activeTab;if(y!==void 0){if(y.input instanceof A.$6M||y.input instanceof A.$$M)return y.input.modified;if(y.input instanceof A.$5M||y.input instanceof A.$0M||y.input instanceof A.$8M)return y.input.uri}}}super({getFolderUri:w=>{const y=i.folders.filter(d=>d.name===w);if(y&&y.length>0)return y[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(w,y)=>u.getConfiguration(void 0,w).get(y),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const w=o();if(w)return I.$hc(w.fsPath)},getWorkspaceFolderPathForFile:()=>{if(t){const w=o();if(w){const y=t.getWorkspaceFolder(w);if(y)return I.$hc(y.uri.fsPath)}}},getSelectedText:()=>{if(s){const w=s.activeEditor();if(w&&!w.selection.isEmpty)return w.document.getText(w.selection)}},getLineNumber:()=>{if(s){const w=s.activeEditor();if(w)return String(w.selection.end.line+1)}},getExtension:w=>r.getExtension(w)},void 0,v?Promise.resolve(v):void 0,Promise.resolve(R.env))}}let n=class extends M.$Tc{constructor(r,t,s,a,u){super(),this.b=r,this.c=t,this.g=s,this.h=a,this.j=u,this.a=new S.$V(async()=>{const i=await this.h.getConfigProvider(),o={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async w=>{o.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.j,i,o,this.m())})}getResolver(){return this.a.value}m(){}};e.$7gc=n,e.$7gc=n=Je([qe(0,E.$3gc),qe(1,D.$ogc),qe(2,g.$zN),qe(3,p.$rgc),qe(4,h.$Dgc)],n)}),define(Re[117],Ae([1,0,11,5,2,22,4,3,64,38,17,7,36,206,208,37,116,6,40,31]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c,r,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=e.$$gc=e.$0gc=e.$9gc=e.$8gc=void 0,e.$8gc=(0,L.$8h)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q?.api}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.w.value}constructor(d,b,P,f,m,k,T){this.I=b,this.J=P,this.K=f,this.L=m,this.M=k,this.N=T,this.l=new Map,this.E=new Map,this.G=new Map,this.H=0,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new M.$Wd,this.n=new M.$Wd,this.o=new M.$Wd,this.u=new M.$Wd,this.k=d.getProxy(g.$jL.MainThreadDebugService),this.z=new M.$Wd,this.B=new M.$Wd,this.w=new i(this.k),this.y=new Map,this.J.getExtensionRegistry().then(O=>{O.onDidChange(G=>{this.O(O)}),this.O(O)})}asDebugSourceUri(d,b){const P=d;if(typeof P.sourceReference=="number"&&P.sourceReference>0){let f=`debug:${encodeURIComponent(P.path||"")}`,m="?";return b&&(f+=`${m}session=${encodeURIComponent(b.id)}`,m="&"),f+=`${m}ref=${P.sourceReference}`,I.URI.parse(f)}else{if(P.path)return I.URI.file(P.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}O(d){const b=[];for(const P of d.getAllExtensionDescriptions())if(P.contributes){const f=P.contributes.debuggers;if(f&&f.length>0)for(const m of f)(0,$.$gG)(m)&&b.push(m.type)}this.k.$registerDebugTypes(b)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){const d=[];return this.y.forEach(b=>d.push(b)),d}async $resolveDebugVisualizer(d,b){const P=this.G.get(d);if(!P)throw new Error(`No debug visualizer found with id '${d}'`);let{v:f,provider:m}=P;if(f.visualization||(f=await m.resolveDebugVisualization?.(f,b)||f,P.v=f),!f.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${m}'`);return this.db(f.visualization)}async $executeDebugVisualizerCommand(d){const b=this.G.get(d);if(!b)throw new Error(`No debug visualizer found with id '${d}'`);const P=b.v.visualization;P&&"command"in P&&this.N.executeCommand(P.command,...P.arguments||[])}async $provideDebugVisualizers(d,b,P,f){const m=this.l.get(P.sessionId),k=this.cb(d,b),T=this.E.get(k);if(!m||!T)return[];const O=await T.provideDebugVisualization({session:m.api,variable:P.variable,containerId:P.containerId,frameId:P.frameId,threadId:P.threadId},f);return O?O.map(G=>{const q=++this.H;this.G.set(q,{v:G,provider:T});const j=G.iconPath?this.eb(G.iconPath):void 0;return{id:q,name:G.name,iconClass:j?.iconClass,iconPath:j?.iconPath,visualization:this.db(G.visualization)}}):[]}$disposeDebugVisualizers(d){for(const b of d)this.G.delete(b)}registerDebugVisualizationProvider(d,b,P){if(!d.contributes?.debugVisualizers?.some(k=>k.id===b))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${b})`);const f=R.$nm.toKey(d.identifier),m=this.cb(f,b);if(this.E.has(m))throw new Error(`A debug visualization provider with id '${b}' is already registered`);return this.E.set(m,P),this.k.$registerDebugVisualizer(f,b),(0,r.$Rc)(()=>{this.k.$unregisterDebugVisualizer(f,b),this.E.delete(b)})}addBreakpoints(d){const b=d.filter(m=>{const k=m.id;return this.y.has(k)?!1:(this.y.set(k,m),!0)});this.$(b,[],[]);const P=[],f=new Map;for(const m of b)if(m instanceof D.$lM){let k=f.get(m.location.uri.toString());k||(k={type:"sourceMulti",uri:m.location.uri,lines:[]},f.set(m.location.uri.toString(),k),P.push(k)),k.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof D.$mM&&P.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(P)}removeBreakpoints(d){const b=d.filter(k=>this.y.delete(k.id));this.$([],b,[]);const P=b.filter(k=>k instanceof D.$lM).map(k=>k.id),f=b.filter(k=>k instanceof D.$mM).map(k=>k.id),m=b.filter(k=>k instanceof D.$nM).map(k=>k.id);return this.k.$unregisterBreakpoints(P,f,m)}startDebugging(d,b,P){return this.k.$startDebugging(d?d.uri:void 0,b,{parentSessionID:P.parentSession?P.parentSession.id:void 0,lifecycleManagedByParent:P.lifecycleManagedByParent,repl:P.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:P.noDebug,compact:P.compact,suppressSaveBeforeStart:P.suppressSaveBeforeStart,suppressDebugStatusbar:P.suppressDebugStatusbar??P.debugUI?.simple,suppressDebugToolbar:P.suppressDebugToolbar??P.debugUI?.simple,suppressDebugView:P.suppressDebugView??P.debugUI?.simple})}stopDebugging(d){return this.k.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,b,P){if(!b)return new D.$lL(()=>{});const f=this.d++;return this.f.push({type:d,handle:f,provider:b}),this.k.$registerDebugConfigurationProvider(d,P,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,f),new D.$lL(()=>{this.f=this.f.filter(m=>m.provider!==b),this.k.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(d,b,P){if(!P)return new D.$lL(()=>{});if(!this.W(d,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.S(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this.g++;return this.h.push({type:b,handle:f,factory:P}),this.k.$registerDebugAdapterDescriptorFactory(b,f),new D.$lL(()=>{this.h=this.h.filter(m=>m.factory!==P),this.k.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(d,b){if(!b)return new D.$lL(()=>{});const P=this.i++;return this.j.push({type:d,handle:P,factory:b}),new D.$lL(()=>{this.j=this.j.filter(f=>f.factory!==b)})}async $runInTerminal(d,b){return Promise.resolve(void 0)}async $substituteVariables(d,b){let P;const f=await this.bb(d);return f&&(P={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.M.getResolver()).resolveAnyAsync(P,b)}P(d,b){if(d.type==="implementation")return new o(d.implementation)}Q(){}async $startDASession(d,b){const P=this,f=await this.ab(b);return this.Y(this.S(f.type),f).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const k=this.R(m),T=this.P(k,f);if(!T)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const O=T;return this.C.set(d,O),this.X(f).then(G=>(G&&this.D.set(d,G),O.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const j=q,C={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this.F||(this.F=this.Q());try{if(this.F){const N=await this.F.sign(j.arguments.value);C.body={signature:N},O.sendResponse(C)}else throw new Error("no signer")}catch(N){C.success=!1,C.message=N.message,O.sendResponse(C)}}else G&&G.onDidSendMessage&&G.onDidSendMessage(q),q=(0,$.$lG)(q,!0),P.k.$acceptDAMessage(d,q)}),O.onError(q=>{G&&G.onError&&G.onError(q),this.k.$acceptDAError(d,q.name,q.message,q.stack)}),O.onExit(q=>{G&&G.onExit&&G.onExit(q??void 0,void 0),this.k.$acceptDAExit(d,q??void 0,void 0)}),G&&G.onWillStartSession&&G.onWillStartSession(),O.startSession()))})}$sendDAMessage(d,b){b=(0,$.$kG)(b,!1);const P=this.D.get(d);P&&P.onWillReceiveMessage&&P.onWillReceiveMessage(b),this.C.get(d)?.sendMessage(b)}$stopDASession(d){const b=this.D.get(d);this.D.delete(d),b&&b.onWillStopSession&&b.onWillStopSession();const P=this.C.get(d);return this.C.delete(d),P?P.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const b=[],P=[],f=[];if(d.added)for(const m of d.added){const k=m.id;if(k&&!this.y.has(k)){let T;if(m.type==="function")T=new D.$mM(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")T=new D.$nM(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const O=I.URI.revive(m.uri);T=new D.$lM(new D.$xL(O,new D.$mL(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,D.$jM)(T,k),this.y.set(k,T),b.push(T)}}if(d.removed)for(const m of d.removed){const k=this.y.get(m);k&&(this.y.delete(m),P.push(k))}if(d.changed){for(const m of d.changed)if(m.id){const k=this.y.get(m.id);if(k){if(k instanceof D.$mM&&m.type==="function"){const T=k;T.enabled=m.enabled,T.condition=m.condition,T.hitCondition=m.hitCondition,T.logMessage=m.logMessage,T.functionName=m.functionName}else if(k instanceof D.$lM&&m.type==="source"){const T=k;T.enabled=m.enabled,T.condition=m.condition,T.hitCondition=m.hitCondition,T.logMessage=m.logMessage,T.location=new D.$xL(I.URI.revive(m.uri),new D.$mL(m.line,m.character))}f.push(k)}}}this.$(b,P,f)}async $acceptStackFrameFocus(d){let b;const P=d.sessionId?await this.ab(d.sessionId):void 0;if(!P)throw new Error("no DebugSession found for debug focus context");d.kind==="thread"?b=new D.$tM(P.api,d.threadId):b=new D.$sM(P.api,d.threadId,d.frameId),this.A=b,this.B.fire(this.A)}$provideDebugConfigurations(d,b,P){return(0,S.$Zg)(async()=>{const f=this.V(d);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.bb(b);return f.provideDebugConfigurations(m,P)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(d,b,P,f){return(0,S.$Zg)(async()=>{const m=this.V(d);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.bb(b);return m.resolveDebugConfiguration(k,P,f)})}$resolveDebugConfigurationWithSubstitutedVariables(d,b,P,f){return(0,S.$Zg)(async()=>{const m=this.V(d);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.bb(b);return m.resolveDebugConfigurationWithSubstitutedVariables(k,P,f)})}async $provideDebugAdapter(d,b){const P=this.U(d);if(!P)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.ab(b);return this.Y(P,f).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.R(m)})}async $acceptDebugSessionStarted(d){const b=await this.ab(d);this.m.fire(b.api)}async $acceptDebugSessionTerminated(d){const b=await this.ab(d);b&&(this.n.fire(b.api),this.l.delete(b.id))}async $acceptDebugSessionActiveChanged(d){this.q=d?await this.ab(d):void 0,this.o.fire(this.q?.api)}async $acceptDebugSessionNameChanged(d,b){(await this.ab(d))?._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(d,b){const f={session:(await this.ab(d)).api,event:b.event,body:b.body};this.u.fire(f)}R(d){if(d instanceof D.$oM)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof D.$pM)return{type:"server",port:d.port,host:d.host};if(d instanceof D.$qM)return{type:"pipeServer",path:d.path};if(d instanceof D.$rM)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}S(d){const b=this.h.filter(P=>P.type===d);if(b.length>0)return b[0].factory}U(d){const b=this.h.filter(P=>P.handle===d);if(b.length>0)return b[0].factory}V(d){const b=this.f.filter(P=>P.handle===d);if(b.length>0)return b[0].provider}W(d,b){if(d.contributes){const P=d.contributes.debuggers;if(P&&P.length>0){for(const f of P)if(f.label&&f.type&&f.type===b)return!0}}return!1}X(d){const P=d.configuration.type,f=this.j.filter(m=>m.type===P||m.type==="*").map(m=>(0,S.$Zg)(()=>m.factory.createDebugAdapterTracker(d.api)).then(k=>k,k=>null));return Promise.race([Promise.all(f).then(m=>{const k=m.filter(T=>!!T);if(k.length>0)return new v(k)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async Y(d,b){const P=b.configuration.debugServer;if(typeof P=="number")return Promise.resolve(new D.$pM(P));if(d){const m=await this.J.getExtensionRegistry();return(0,S.$Zg)(()=>d.createDebugAdapterDescriptor(b.api,this.Z(b,m))).then(k=>{if(k)return k})}const f=await this.J.getExtensionRegistry();return Promise.resolve(this.Z(b,f))}Z(d,b){}$(d,b,P){(d.length>0||b.length>0||P.length>0)&&this.z.fire(Object.freeze({added:d,removed:b,changed:P}))}async ab(d){if(d)if(typeof d=="string"){const b=this.l.get(d);if(b)return b}else{let b=this.l.get(d.id);if(!b){const P=await this.bb(d.folderUri),f=d.parent?this.l.get(d.parent):void 0;b=new u(this.k,d.id,d.type,d.name,P,d.configuration,f?.api),this.l.set(b.id,b),this.k.$sessionCached(b.id)}return b}throw new Error("cannot find session")}bb(d){if(d){const b=I.URI.revive(d);return this.I.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}cb(d,b){return`${d}\0${b}`}db(d){if(d){if("title"in d&&"command"in d)return{type:0};throw new Error("Unsupported debug visualization type")}}eb(d){const b=this.fb(d);let P,f;return"id"in b?f=t.ThemeIcon.asClassName(b):P=b,{iconPath:P,iconClass:f}}fb(d){if(d instanceof D.$gM)return{id:d.id};const b=typeof d=="object"&&"dark"in d?d.dark:d,P=typeof d=="object"&&"light"in d?d.light:d;return{dark:typeof b=="string"?I.URI.file(b):b,light:typeof P=="string"?I.URI.file(P):P}}};e.$9gc=a,e.$9gc=a=Je([qe(0,A.$oN),qe(1,l.$ogc),qe(2,E.$3gc),qe(3,n.$rgc),qe(4,h.$Dgc),qe(5,c.$6gc),qe(6,s.$KN)],a);class u{constructor(d,b,P,f,m,k,T){this.f=d,this.g=b,this.h=P,this.i=f,this.j=m,this.k=k,this.l=T}get api(){const d=this;return this.d??=Object.freeze({id:d.g,type:d.h,get name(){return d.i},set name(b){d.i=b,d.f.$setDebugSessionName(d.g,b)},parentSession:d.l,workspaceFolder:d.j,configuration:d.k,customRequest(b,P){return d.f.$customDebugAdapterRequest(d.g,b,P)},getDebugProtocolBreakpoint(b){return d.f.$getDebugProtocolBreakpoint(d.g,b.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(d){this.i=d}get configuration(){return this.k}}e.$0gc=u;class i{constructor(d){this.value=Object.freeze({append(b){d.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.$$gc=i;class v{constructor(d){this.d=d}onWillStartSession(){this.d.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.d.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.d.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(d):void 0)}onWillStopSession(){this.d.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.d.forEach(b=>b.onError?b.onError(d):void 0)}onExit(d,b){this.d.forEach(P=>P.onExit?P.onExit(d,b):void 0)}}class o extends p.$amb{constructor(d){super(),this.h=d,d.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.h.handleMessage(d)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let w=class extends a{constructor(d,b,P,f,m,k,T){super(d,b,P,f,m,k,T)}};e.$_gc=w,e.$_gc=w=Je([qe(0,A.$oN),qe(1,l.$ogc),qe(2,E.$3gc),qe(3,n.$rgc),qe(4,h.$Dgc),qe(5,c.$6gc),qe(6,s.$KN)],w)}),define(Re[289],Ae([1,0,15,88,2,3,235,14,53,71,27,184,17,58,38,60]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=e.$bic=void 0;class c{static async installEarlyHandler(s){Error.stackTraceLimit=100;const a=s.get(g.$pj),i=s.get(l.$oN).getProxy(R.$jL.MainThreadErrors);S.setUnexpectedErrorHandler(v=>{a.error(v);const o=S.$3(v);i.$onUnexpectedError(o)})}static async installFullHandler(s){const a=s.get(g.$pj),u=s.get(l.$oN),i=s.get($.$3gc),v=s.get(n.$IN),o=u.getProxy(R.$jL.MainThreadExtensionService),w=u.getProxy(R.$jL.MainThreadErrors),y=await i.getExtensionPathIndex(),d=new WeakMap;function b(m,k){if(d.has(m))return d.get(m).stack;let T="",O,G;for(const j of k)T+=`
	at ${j.toString()}`,G=j.getFileName(),!O&&G&&(O=y.findSubstr(I.URI.file(G)));const q=`${m.name||"Error"}: ${m.message||""}${T}`;return d.set(m,{extensionIdentifier:O?.identifier,stack:q}),q}const P=Symbol("prepareStackTrace wrapped");let f=b;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return f},set(m){if(m===b||!m||m[P]){f=m||b;return}f=function(k,T){return b(k,T),m.call(Error,k,T)},Object.assign(f,{[P]:!0})}}),S.setUnexpectedErrorHandler(m=>{a.error(m);const k=S.$3(m),T=d.get(m);if(!T?.extensionIdentifier){w.$onUnexpectedError(k);return}o.$onExtensionRuntimeError(T.extensionIdentifier,k);const O=v.onExtensionError(T.extensionIdentifier,m);a.trace("forwarded error to extension?",O,T)})}}e.$bic=c;class r{constructor(s,a,u,i,v){this.a=u,this.b=new L.$c8b(s,null,i),a=r.e(a,this.b);const o=new E.$6h(...(0,h.$2r)());o.set(A.$EN,{_serviceBrand:void 0,...a,messagePorts:v}),o.set(l.$oN,new l.$pN(this.b)),o.set(p.$lgc,new p.$mgc(i)),o.set($.$1gc,u);const w=new D.$Gq(o,!0);w.invokeFunction(c.installEarlyHandler),this.d=w.invokeFunction(y=>y.get(g.$pj)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=w.invokeFunction(y=>y.get($.$3gc)),this.c.initialize(),w.invokeFunction(c.installFullHandler)}async asBrowserUri(s){const a=this.b.getProxy(R.$jL.MainThreadExtensionService);return I.URI.revive(await a.$asBrowserUri(s))}terminate(s){this.c.terminate(s)}static e(s,a){s.extensions.allExtensions.forEach(i=>{i.extensionLocation=I.URI.revive(a.transformIncomingURIs(i.extensionLocation))}),s.environment.appRoot=I.URI.revive(a.transformIncomingURIs(s.environment.appRoot));const u=s.environment.extensionDevelopmentLocationURI;return u&&(s.environment.extensionDevelopmentLocationURI=u.map(i=>I.URI.revive(a.transformIncomingURIs(i)))),s.environment.extensionTestsLocationURI=I.URI.revive(a.transformIncomingURIs(s.environment.extensionTestsLocationURI)),s.environment.globalStorageHome=I.URI.revive(a.transformIncomingURIs(s.environment.globalStorageHome)),s.environment.workspaceStorageHome=I.URI.revive(a.transformIncomingURIs(s.environment.workspaceStorageHome)),s.environment.extensionTelemetryLogResource=I.URI.revive(a.transformIncomingURIs(s.environment.extensionTelemetryLogResource)),s.nlsBaseUrl=I.URI.revive(a.transformIncomingURIs(s.nlsBaseUrl)),s.logsLocation=I.URI.revive(a.transformIncomingURIs(s.logsLocation)),s.workspace=a.transformIncomingURIs(s.workspace),s}}e.$cic=r}),define(Re[290],Ae([1,0,18,11,21,41,12,19,25,2,44]),function(me,e,S,M,I,R,L,g,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=e.$phc=e.$ohc=e.$nhc=void 0;class D{constructor(t,s,a,u){this.d=t,this.e=s,this.f=a,this.g=u,this.a=null,this.b=!1,this.c=0}search(t,s){const a=this.d.folderQueries||[],u=new I.$7d(s);return new Promise((i,v)=>{this.a=new p(t);let o=!1;const w=(y,d)=>{if(!o&&!this.b){const b=this.h(y);n(y)&&typeof this.d.maxResults=="number"&&this.c+b>this.d.maxResults&&(this.b=!0,o=!0,u.cancel(),y=this.j(y,this.d.maxResults-this.c));const P=this.h(y);this.c+=P,(P>0||!n(y))&&this.a.add(y,d)}};Promise.all(a.map((y,d)=>this.k(y,b=>w(b,d),u.token))).then(y=>{u.dispose(),this.a.flush();const d=y.some(b=>!!b&&!!b.limitHit);i({limitHit:this.b||d,messages:(0,S.$Rb)(y.map(b=>b?.message?Array.isArray(b.message)?b.message:[b.message]:[])),stats:{type:this.g}})},y=>{u.dispose();const d=(0,R.$Si)(y);v(new Error(d))})})}h(t){return n(t)?Array.isArray(t.ranges)?t.ranges.length:1:0}j(t,s){const a=Array.isArray(t.ranges)?t.ranges:[t.ranges],u=Array.isArray(t.preview.matches)?t.preview.matches:[t.preview.matches];return{ranges:a.slice(0,s),preview:{matches:u.slice(0,s),text:t.preview.text},uri:t.uri}}async k(t,s,a){const u=new A.$YJ(this.d,t),i=[],v={report:y=>{if(!this.l(y))return;const d=t.folder.scheme===L.Schemas.file?(0,A.$ZJ)(()=>this.f.readdir(h.$Hg(y.uri))):void 0,b=h.$Kg(t.folder,y.uri);if(b){const P=u.includedInQuery(b,g.$nc(b),d);(0,M.$Tg)(P)?i.push(P.then(f=>{f&&s(y)})):P&&s(y)}}},o=this.n(t),w=await this.e.provideTextSearchResults(l(this.d.contentPattern),o,v,a);return i.length&&await Promise.all(i),w}l(t){if(n(t)){if(Array.isArray(t.ranges)){if(!Array.isArray(t.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(t.preview.matches.length!==t.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(t.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(t){const s=(0,A.$XJ)(this.d.includePattern,t.includePattern),a=(0,A.$XJ)(this.d.excludePattern,t.excludePattern),u={folder:E.URI.from(t.folder),excludes:a,includes:s,useIgnoreFiles:!t.disregardIgnoreFiles,useGlobalIgnoreFiles:!t.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!t.disregardParentIgnoreFiles,followSymlinks:!t.ignoreSymlinks,encoding:t.fileEncoding&&this.f.toCanonicalName(t.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return u.usePCRE2=this.d.usePCRE2,u}}e.$nhc=D;function l(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class p{constructor(t){this.e=t,this.b=-1,this.d=null,this.a=new c(512,s=>this.g(s))}add(t,s){this.d&&(this.b!==s||!h.$Bg(this.c,t.uri))&&(this.f(),this.d=null),this.d||(this.b=s,this.d={resource:t.uri,results:[]}),this.d.results.push($(t))}f(){const t=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,t)}flush(){this.f(),this.a.flush()}g(t){this.e(t)}}e.$ohc=p;function $(r){return n(r)?{preview:{matches:(0,S.$2b)(r.preview.matches,t=>({startLineNumber:t.start.line,startColumn:t.start.character,endLineNumber:t.end.line,endColumn:t.end.character})),text:r.preview.text},ranges:(0,S.$2b)(r.ranges,t=>({startLineNumber:t.start.line,startColumn:t.start.character,endLineNumber:t.end.line,endColumn:t.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function n(r){return!!r.preview}e.$phc=n;class c{static{this.a=4e3}static{this.b=50}constructor(t,s){this.g=t,this.h=s,this.c=0,this.d=[],this.e=0}addItem(t,s){t&&this.j(t,s)}addItems(t,s){t&&this.k(t,s)}j(t,s){this.d.push(t),this.e+=s,this.l()}k(t,s){this.d=this.d.concat(t),this.e+=s,this.l()}l(){this.c<c.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},c.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$qhc=c}),define(Re[118],Ae([1,0,6,3,4,285,17,58,14,2,290]),function(me,e,S,M,I,R,L,g,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=e.$shc=e.$rhc=void 0,e.$rhc=(0,I.$8h)("IExtHostSearch");let D=class{constructor(n,c,r){this.k=n,this.l=c,this.n=r,this.c=this.k.getProxy(M.$jL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.$mhc}o(n){return this.l.transformOutgoingScheme(n)}registerTextSearchProvider(n,c){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const r=this.d++;return this.e.set(r,c),this.c.$registerTextSearchProvider(r,this.o(n)),(0,S.$Rc)(()=>{this.g.delete(n),this.e.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(n,c){if(this.i.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.i.add(n);const r=this.d++;return this.h.set(r,c),this.c.$registerFileSearchProvider(r,this.o(n)),(0,S.$Rc)(()=>{this.i.delete(n),this.h.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(n,c,r,t){const s=l(r),a=this.h.get(n);if(a)return this.j.fileSearch(s,a,u=>{this.c.$handleFileMatch(n,c,u.map(i=>i.resource))},t);throw new Error("unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,c,r){return{messages:[]}}$clearCache(n){return this.j.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,c,r,t){const s=this.e.get(n);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${n}`);const a=l(r);return this.q(a,s).search(i=>this.c.$handleTextMatch(n,c,i),t)}$enableExtensionHostSearch(){}q(n,c){return new A.$nhc(n,c,{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}};e.$shc=D,e.$shc=D=Je([qe(0,L.$oN),qe(1,g.$lgc),qe(2,h.$pj)],D);function l($){return{...$,folderQueries:$.folderQueries&&$.folderQueries.map(p),extraFileResources:$.extraFileResources&&$.extraFileResources.map(n=>E.URI.revive(n))}}e.$thc=l;function p($){return{...$,folder:E.URI.revive($.folder)}}}),define(Re[291],Ae([1,0,21,15,5,6,12,32,2,146,142,130,93,22,42,14,56,57,197,3,238,269,79,239,245,223,246,247,248,224,212,31,249,37,250,117,107,251,226,240,252,253,66,64,241,38,255,62,256,43,27,270,271,242,227,257,258,80,81,229,284,260,201,261,272,262,112,230,263,264,265,17,266,118,82,267,231,268,83,85,115,60,65,273,274,243,275,276,86,8,7,232,58,233,61,277,278,106,36,207,78,24,114]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c,r,t,s,a,u,i,v,o,w,y,d,b,P,f,m,k,T,O,G,q,j,C,N,W,se,ue,ye,ke,ae,pe,oe,$e,ie,x,V,ne,Ie,Me,Le,be,ge,K,ee,le,fe,Ce,de,we,F,H,J,B,Q,_,Ee,Ne,We,Ke,Ye,nt,it,et,st,ct,Ue,mt,Y,X,ve,Be,Qe,tt,ot,Te,zt,Rt,Gt,Ft,yt,qt,Tt,Yt,Wt,jt,Xe,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;function Jt(lt){const $t=lt.get(x.$EN),Ut=lt.get(ie.$6fc),Qt=lt.get(oe.$tgc),Et=lt.get(ae.$3gc),dt=lt.get(Yt.$ogc),St=lt.get(Ue.$IN),_t=lt.get(T.$rgc),Pt=lt.get(Rt.$lgc),He=lt.get(Ee.$oN),At=lt.get(et.$Mgc),Nt=lt.get(st.$ugc),Zt=lt.get(n.$qj),ft=lt.get(n.$pj),Mt=lt.get(tt.$izb),It=lt.get(i.$9fc),Bt=lt.get(Tt.$8hc),De=lt.get(Ke.$Ugc),Fe=lt.get(ye.$Dgc),he=lt.get(K.$Ygc);He.set(s.$kL.ExtHostFileSystemInfo,Ut),He.set(s.$kL.ExtHostLogLevelServiceShape,Zt),He.set(s.$kL.ExtHostWorkspace,dt),He.set(s.$kL.ExtHostConfiguration,_t),He.set(s.$kL.ExtHostExtensionService,Et),He.set(s.$kL.ExtHostStorage,At),He.set(s.$kL.ExtHostTunnelService,Mt),He.set(s.$kL.ExtHostWindow,Bt),He.set(s.$kL.ExtHostSecretState,De),He.set(s.$kL.ExtHostTelemetry,St),He.set(s.$kL.ExtHostEditorTabs,Fe),He.set(s.$kL.ExtHostManagedSockets,he);const Z=He.set(s.$kL.ExtHostDecorations,lt.get(q.$bhc)),Pe=He.set(s.$kL.ExtHostDocumentsAndEditors,lt.get(ue.$zN)),ze=He.set(s.$kL.ExtHostCommands,lt.get(m.$KN)),Ze=He.set(s.$kL.ExtHostTerminalService,lt.get(mt.$Pgc)),Ve=He.set(s.$kL.ExtHostDebugService,lt.get(G.$8gc)),at=He.set(s.$kL.ExtHostSearch,lt.get(We.$rhc)),wt=He.set(s.$kL.ExtHostTask,lt.get(ct.$Uhc)),Kt=He.set(s.$kL.ExtHostOutputService,lt.get(H.$Hhc)),kt=He.set(s.$kL.ExtHostLocalization,lt.get(ge.$Xgc)),Dt=He.set(s.$kL.ExtHostUrls,new Gt.$5hc(He)),bt=He.set(s.$kL.ExtHostDocuments,new se.$4fc(He,Pe)),Di=He.set(s.$kL.ExtHostDocumentContentProviders,new N.$dhc(He,Pe,ft)),Ji=He.set(s.$kL.ExtHostDocumentSaveParticipant,new W.$ehc(ft,bt,He.getProxy(s.$jL.MainThreadBulkEdits))),Ct=He.set(s.$kL.ExtHostNotebook,new le.$uhc(He,ze,Pe,bt,Qt,at)),si=He.set(s.$kL.ExtHostNotebookDocuments,new Ce.$Bhc(Ct)),mi=He.set(s.$kL.ExtHostNotebookEditors,new de.$Chc(ft,Ct)),ui=He.set(s.$kL.ExtHostNotebookKernels,new we.$Dhc(He,$t,Ct,ze,ft)),Si=He.set(s.$kL.ExtHostNotebookRenderers,new F.$Fhc(He,Ct)),Ii=He.set(s.$kL.ExtHostNotebookDocumentSaveParticipant,new fe.$Ahc(ft,Ct,He.getProxy(s.$jL.MainThreadBulkEdits))),Ot=He.set(s.$kL.ExtHostEditors,new X.$igc(He,Pe)),$i=He.set(s.$kL.ExtHostTreeViews,new Qe.$3hc(He.getProxy(s.$jL.MainThreadTreeViews),ze,ft)),Ci=He.set(s.$kL.ExtHostEditorInsets,new f.$jgc(He.getProxy(s.$jL.MainThreadEditorInsets),Ot,$t.remote)),li=He.set(s.$kL.ExtHostDiagnostics,new j.$8fc(He,ft,Ut,Pe)),hi=He.set(s.$kL.ExtHostLanguages,new be.$yhc(He,bt,ze.converter,Pt)),ht=He.set(s.$kL.ExtHostLanguageFeatures,new Le.$_fc(He,Pt,bt,ze,li,ft,It,St)),Qi=He.set(s.$kL.ExtHostFileSystem,new pe.$ghc(He,ht)),ei=He.set(s.$kL.ExtHostFileSystemEventService,new $e.$hhc(He,ft,Pe)),oi=He.set(s.$kL.ExtHostQuickOpen,(0,_.$Lhc)(He,dt,ze)),pi=He.set(s.$kL.ExtHostSCM,new Ne.$Nhc(He,ze,bt,ft)),Pi=He.set(s.$kL.ExtHostQuickDiff,new Q.$Khc(He,Pt)),Zi=He.set(s.$kL.ExtHostShare,new Ye.$Ohc(He,Pt)),Li=He.set(s.$kL.ExtHostComments,(0,k.$kgc)(He,ze,bt)),vi=He.set(s.$kL.ExtHostProgress,new B.$Jhc(He.getProxy(s.$jL.MainThreadProgress))),Yi=He.set(s.$kL.ExtHostLabelService,new Me.$xhc(He)),Ri=He.set(s.$kL.ExtHostTheming,new ve.$Zhc(He)),di=He.set(s.$kL.ExtHostAuthentication,new v.$bgc(He)),Xi=He.set(s.$kL.ExtHostTimeline,new Be.$2hc(He,ze)),bi=He.set(s.$kL.ExtHostWebviews,new Ft.$ygc(He,$t.remote,dt,ft,It)),Ai=He.set(s.$kL.ExtHostWebviewPanels,new yt.$Bgc(He,bi,dt)),ln=He.set(s.$kL.ExtHostCustomEditors,new O.$Cgc(He,bt,Nt,bi,Ai)),Mi=He.set(s.$kL.ExtHostWebviewViews,new qt.$6hc(He,bi)),ai=He.set(s.$kL.ExtHostTesting,new Y.$Vhc(He,ft,ze,Pe)),hn=He.set(s.$kL.ExtHostUriOpeners,new zt.$4hc(He)),dn=He.set(s.$kL.ExtHostProfileContentHandlers,new J.$Ihc(He));He.set(s.$kL.ExtHostInteractive,new ne.$vhc(He,Ct,Pe,ze,ft));const xi=He.set(s.$kL.ExtHostInlineChat,new V.$ihc(He,ze,bt,ft)),Fi=He.set(s.$kL.ExtHostChatProvider,new d.$egc(He,ft)),Ti=He.set(s.$kL.ExtHostChatAgents2,new y.$fgc(He,Fi,ft)),_i=He.set(s.$kL.ExtHostChatVariables,new b.$ggc(He)),wi=He.set(s.$kL.ExtHostChat,new w.$dgc(He)),Ni=He.set(s.$kL.ExtHostAiRelatedInformation,new a.$3fc(He)),fn=He.set(s.$kL.ExtHostAiEmbeddingVector,new ke.$fhc(He)),yi=He.set(s.$kL.ExtHostIssueReporter,new Ie.$whc(He)),Oi=He.set(s.$kL.ExtHostStatusBar,new it.$Rhc(He,ze.converter)),ni=He.set(s.$kL.ExtHostSpeech,new nt.$Phc(He)),Ei=Object.values(s.$kL);He.assertRegistered(Ei);const gn=new o.$cgc(He,Pe),Xt=new P.$hgc(He),fi=new ee.$zhc(He,ft),zi=new C.$chc(He);return u.$agc.register(ze),function(je,ti,ji){function _e(te){return(ce,Oe,rt)=>{const vt=te(Lt=>{try{ce.call(Oe,Lt)}catch(Hi){M.$2(new Error(`[ExtensionListenerError] Extension '${je.identifier.value}' FAILED to handle event: ${Hi.toString()}`,{cause:Hi})),St.onExtensionError(je.identifier,Hi)}});return rt?.push(vt),vt}}const pt=function(){let te=!je.isUnderDevelopment;function ce(){te||(ft.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Oe(rt){if(Array.isArray(rt))rt.forEach(Oe);else if(typeof rt=="string")ce();else{const vt=rt;typeof vt.scheme>"u"&&ce(),typeof vt.exclusive=="boolean"&&(0,Xe.$LF)(je,"documentFiltersExclusive")}return rt}}(),en={getSession(te,ce,Oe){return di.getSession(je,te,ce,Oe)},getSessions(te,ce){return(0,Xe.$LF)(je,"authGetSessions"),di.getSessions(je,te,ce)},async hasSession(te,ce){return(0,Xe.$LF)(je,"authSession"),!!await di.getSession(je,te,ce,{silent:!0})},get onDidChangeSessions(){return _e(di.onDidChangeSessions)},registerAuthenticationProvider(te,ce,Oe,rt){return di.registerAuthenticationProvider(te,ce,Oe,rt)}},mn={registerCommand(te,ce,Oe){return ze.registerCommand(!0,te,ce,Oe,void 0,je)},registerTextEditorCommand(te,ce,Oe){return ze.registerCommand(!0,te,(...rt)=>{const vt=Ot.getActiveTextEditor();if(!vt){ft.warn("Cannot execute "+te+" because there is no active text editor.");return}return vt.edit(Lt=>{ce.apply(Oe,[vt,Lt,...rt])}).then(Lt=>{Lt||ft.warn("Edits from command "+te+" were not applied.")},Lt=>{ft.warn("An error occurred while running command "+te,Lt)})},void 0,void 0,je)},registerDiffInformationCommand:(te,ce,Oe)=>((0,Xe.$LF)(je,"diffCommand"),ze.registerCommand(!0,te,async(...rt)=>{const vt=Pe.activeEditor(!0);if(!vt){ft.warn("Cannot execute "+te+" because there is no active text editor.");return}const Lt=await Ot.getDiffInformation(vt.id);ce.apply(Oe,[Lt,...rt])},void 0,void 0,je)),executeCommand(te,...ce){return ze.executeCommand(te,...ce)},getCommands(te=!1){return ze.getCommands(te)}},tn={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Xt.value},get shell(){return Ze.getDefaultShell(!1)},get onDidChangeShell(){return _e(Ze.onDidChangeShell)},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return _e(St.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$LF)(je,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$LF)(je,"telemetry"),_e(St.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Ue.$HN)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,ce){return Ue.$GN.validateSender(te),St.instantiateLogger(je,te,ce)},openExternal(te,ce){return Bt.openUri(te,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===$t.environment.appUriScheme)return Dt.createAppUri(te);try{return await Bt.asExternalUri(te,{allowTunneling:!!$t.remote.authority})}catch(ce){if((0,L.$fg)(te,L.Schemas.http)||(0,L.$fg)(te,L.Schemas.https))return te;throw ce}},get remoteName(){return(0,c.$dl)($t.remote.authority)},get remoteAuthority(){return(0,Xe.$LF)(je,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return _e(ft.onDidChangeLogLevel)},registerIssueUriRequestHandler(te){return(0,Xe.$LF)(je,"handleIssueUri"),yi.registerIssueUriRequestHandler(je,te)},registerIssueDataProvider(te){return(0,Xe.$LF)(je,"handleIssueUri"),yi.registerIssueDataProvider(je,te)},get appQuality(){return(0,Xe.$LF)(je,"resolvers"),$t.quality},get appCommit(){return(0,Xe.$LF)(je,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(tn);const nn={createTestController(te,ce,Oe){return ai.createTestController(je,te,ce,Oe)},createTestObserver(){return(0,Xe.$LF)(je,"testObserver"),ai.createTestObserver()},runTests(te){return(0,Xe.$LF)(je,"testObserver"),ai.runTests(te)},get onDidChangeTestResults(){return(0,Xe.$LF)(je,"testObserver"),_e(ai.onResultsChanged)},get testResults(){return(0,Xe.$LF)(je,"testObserver"),ai.results}},gi=$t.remote.isRemote?Te.ExtensionKind.Workspace:Te.ExtensionKind.UI,rn={getExtension(te,ce){(0,Xe.$KF)(je,"extensionsAny")||(ce=!1);const Oe=ti.mine.getExtensionDescription(te);if(Oe)return new ae.$4gc(Et,je.identifier,Oe,gi,!1);if(ce){const rt=ti.all.getExtensionDescription(te);if(rt)return new ae.$4gc(Et,je.identifier,rt,gi,!0)}},get all(){const te=[];for(const ce of ti.mine.getAllExtensionDescriptions())te.push(new ae.$4gc(Et,je.identifier,ce,gi,!1));return te},get allAcrossExtensionHosts(){(0,Xe.$LF)(je,"extensionsAny");const te=new p.$om(ti.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ce=[];for(const Oe of ti.all.getAllExtensionDescriptions()){const rt=!te.has(Oe.identifier);ce.push(new ae.$4gc(Et,je.identifier,Oe,gi,rt))}return ce},get onDidChange(){return(0,Xe.$KF)(je,"extensionsAny")?_e(I.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):_e(ti.mine.onDidChange)}},sn={createDiagnosticCollection(te){return li.createDiagnosticCollection(je.identifier,te)},get onDidChangeDiagnostics(){return _e(li.onDidChangeDiagnostics)},getDiagnostics:te=>li.getDiagnostics(te),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(te,ce){return hi.changeLanguage(te.uri,ce)},match(te,ce){const Oe=bt.getDocumentData(ce.uri)?.notebook;return(0,A.$Dt)(ot.LanguageSelector.from(te),ce.uri,ce.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(te,ce,Oe){return ht.registerCodeActionProvider(je,pt(te),ce,Oe)},registerDocumentPasteEditProvider(te,ce,Oe){return(0,Xe.$LF)(je,"documentPaste"),ht.registerDocumentPasteEditProvider(je,pt(te),ce,Oe)},registerCodeLensProvider(te,ce){return ht.registerCodeLensProvider(je,pt(te),ce)},registerDefinitionProvider(te,ce){return ht.registerDefinitionProvider(je,pt(te),ce)},registerDeclarationProvider(te,ce){return ht.registerDeclarationProvider(je,pt(te),ce)},registerImplementationProvider(te,ce){return ht.registerImplementationProvider(je,pt(te),ce)},registerTypeDefinitionProvider(te,ce){return ht.registerTypeDefinitionProvider(je,pt(te),ce)},registerHoverProvider(te,ce){return ht.registerHoverProvider(je,pt(te),ce,je.identifier)},registerEvaluatableExpressionProvider(te,ce){return ht.registerEvaluatableExpressionProvider(je,pt(te),ce,je.identifier)},registerInlineValuesProvider(te,ce){return ht.registerInlineValuesProvider(je,pt(te),ce,je.identifier)},registerDocumentHighlightProvider(te,ce){return ht.registerDocumentHighlightProvider(je,pt(te),ce)},registerMultiDocumentHighlightProvider(te,ce){return ht.registerMultiDocumentHighlightProvider(je,pt(te),ce)},registerLinkedEditingRangeProvider(te,ce){return ht.registerLinkedEditingRangeProvider(je,pt(te),ce)},registerReferenceProvider(te,ce){return ht.registerReferenceProvider(je,pt(te),ce)},registerRenameProvider(te,ce){return ht.registerRenameProvider(je,pt(te),ce)},registerDocumentSymbolProvider(te,ce,Oe){return ht.registerDocumentSymbolProvider(je,pt(te),ce,Oe)},registerWorkspaceSymbolProvider(te){return ht.registerWorkspaceSymbolProvider(je,te)},registerDocumentFormattingEditProvider(te,ce){return ht.registerDocumentFormattingEditProvider(je,pt(te),ce)},registerDocumentRangeFormattingEditProvider(te,ce){return ht.registerDocumentRangeFormattingEditProvider(je,pt(te),ce)},registerOnTypeFormattingEditProvider(te,ce,Oe,...rt){return ht.registerOnTypeFormattingEditProvider(je,pt(te),ce,[Oe].concat(rt))},registerDocumentSemanticTokensProvider(te,ce,Oe){return ht.registerDocumentSemanticTokensProvider(je,pt(te),ce,Oe)},registerDocumentRangeSemanticTokensProvider(te,ce,Oe){return ht.registerDocumentRangeSemanticTokensProvider(je,pt(te),ce,Oe)},registerSignatureHelpProvider(te,ce,Oe,...rt){return typeof Oe=="object"?ht.registerSignatureHelpProvider(je,pt(te),ce,Oe):ht.registerSignatureHelpProvider(je,pt(te),ce,typeof Oe>"u"?[]:[Oe,...rt])},registerCompletionItemProvider(te,ce,...Oe){return ht.registerCompletionItemProvider(je,pt(te),ce,Oe)},registerInlineCompletionItemProvider(te,ce,Oe){return ce.handleDidShowCompletionItem&&(0,Xe.$LF)(je,"inlineCompletionsAdditions"),ce.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$LF)(je,"inlineCompletionsAdditions"),Oe&&(0,Xe.$LF)(je,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(je,pt(te),ce,Oe)},registerDocumentLinkProvider(te,ce){return ht.registerDocumentLinkProvider(je,pt(te),ce)},registerColorProvider(te,ce){return ht.registerColorProvider(je,pt(te),ce)},registerFoldingRangeProvider(te,ce){return ht.registerFoldingRangeProvider(je,pt(te),ce)},registerSelectionRangeProvider(te,ce){return ht.registerSelectionRangeProvider(je,te,ce)},registerCallHierarchyProvider(te,ce){return ht.registerCallHierarchyProvider(je,te,ce)},registerTypeHierarchyProvider(te,ce){return ht.registerTypeHierarchyProvider(je,te,ce)},setLanguageConfiguration:(te,ce)=>ht.setLanguageConfiguration(je,te,ce),getTokenInformationAtPosition(te,ce){return(0,Xe.$LF)(je,"tokenInformation"),hi.tokenAtPosition(te,ce)},registerInlayHintsProvider(te,ce){return ht.registerInlayHintsProvider(je,te,ce)},createLanguageStatusItem(te,ce){return hi.createLanguageStatusItem(je,te,ce)},registerDocumentDropEditProvider(te,ce,Oe){return ht.registerDocumentOnDropEditProvider(je,te,ce,(0,Xe.$KF)(je,"dropMetadata")?Oe:void 0)}},on={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return Ze.activeTerminal},get terminals(){return Ze.terminals},async showTextDocument(te,ce,Oe){h.URI.isUri(te)&&te.scheme===L.Schemas.vscodeRemote&&!te.authority&&It.report("workspace.showTextDocument",je,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(h.URI.isUri(te)?Promise.resolve(an.openTextDocument(te)):Promise.resolve(te));return Ot.showTextDocument(rt,ce,Oe)},createTextEditorDecorationType(te){return Ot.createTextEditorDecorationType(je,te)},onDidChangeActiveTextEditor(te,ce,Oe){return _e(Ot.onDidChangeActiveTextEditor)(te,ce,Oe)},onDidChangeVisibleTextEditors(te,ce,Oe){return _e(Ot.onDidChangeVisibleTextEditors)(te,ce,Oe)},onDidChangeTextEditorSelection(te,ce,Oe){return _e(Ot.onDidChangeTextEditorSelection)(te,ce,Oe)},onDidChangeTextEditorOptions(te,ce,Oe){return _e(Ot.onDidChangeTextEditorOptions)(te,ce,Oe)},onDidChangeTextEditorVisibleRanges(te,ce,Oe){return _e(Ot.onDidChangeTextEditorVisibleRanges)(te,ce,Oe)},onDidChangeTextEditorViewColumn(te,ce,Oe){return _e(Ot.onDidChangeTextEditorViewColumn)(te,ce,Oe)},onDidCloseTerminal(te,ce,Oe){return _e(Ze.onDidCloseTerminal)(te,ce,Oe)},onDidOpenTerminal(te,ce,Oe){return _e(Ze.onDidOpenTerminal)(te,ce,Oe)},onDidChangeActiveTerminal(te,ce,Oe){return _e(Ze.onDidChangeActiveTerminal)(te,ce,Oe)},onDidChangeTerminalDimensions(te,ce,Oe){return(0,Xe.$LF)(je,"terminalDimensions"),_e(Ze.onDidChangeTerminalDimensions)(te,ce,Oe)},onDidChangeTerminalState(te,ce,Oe){return _e(Ze.onDidChangeTerminalState)(te,ce,Oe)},onDidWriteTerminalData(te,ce,Oe){return(0,Xe.$LF)(je,"terminalDataWriteEvent"),_e(Ze.onDidWriteTerminalData)(te,ce,Oe)},onDidExecuteTerminalCommand(te,ce,Oe){return(0,Xe.$LF)(je,"terminalExecuteCommandEvent"),_e(Ze.onDidExecuteTerminalCommand)(te,ce,Oe)},get state(){return Bt.getState(je)},onDidChangeWindowState(te,ce,Oe){return _e(Bt.onDidChangeWindowState)(te,ce,Oe)},showInformationMessage(te,...ce){return fi.showMessage(je,g.default.Info,te,ce[0],ce.slice(1))},showWarningMessage(te,...ce){return fi.showMessage(je,g.default.Warning,te,ce[0],ce.slice(1))},showErrorMessage(te,...ce){return fi.showMessage(je,g.default.Error,te,ce[0],ce.slice(1))},showQuickPick(te,ce,Oe){return oi.showQuickPick(je,te,ce,Oe)},showWorkspaceFolderPick(te){return oi.showWorkspaceFolderPick(te)},showInputBox(te,ce){return oi.showInput(te,ce)},showOpenDialog(te){return zi.showOpenDialog(je,te)},showSaveDialog(te){return zi.showSaveDialog(te)},createStatusBarItem(te,ce,Oe){let rt,vt,Lt;return typeof te=="string"?(rt=te,vt=ce,Lt=Oe):(vt=te,Lt=ce),Oi.createStatusBarEntry(je,rt,vt,Lt)},setStatusBarMessage(te,ce){return Oi.setStatusBarMessage(te,ce)},withScmProgress(te){return It.report("window.withScmProgress",je,"Use 'withProgress' instead."),vi.withProgress(je,{location:Te.ProgressLocation.SourceControl},(ce,Oe)=>te({report(rt){}}))},withProgress(te,ce){return vi.withProgress(je,te,ce)},createOutputChannel(te,ce){return Kt.createOutputChannel(te,ce,je)},createWebviewPanel(te,ce,Oe,rt){return Ai.createWebviewPanel(je,te,ce,Oe,rt)},createWebviewTextEditorInset(te,ce,Oe,rt){return(0,Xe.$LF)(je,"editorInsets"),Ci.createWebviewEditorInset(te,ce,Oe,rt,je)},createTerminal(te,ce,Oe){return typeof te=="object"?"pty"in te?Ze.createExtensionTerminal(te):Ze.createTerminalFromOptions(te):Ze.createTerminal(te,ce,Oe)},registerTerminalLinkProvider(te){return Ze.registerLinkProvider(te)},registerTerminalProfileProvider(te,ce){return Ze.registerProfileProvider(je,te,ce)},registerTerminalQuickFixProvider(te,ce){return(0,Xe.$LF)(je,"terminalQuickFixProvider"),Ze.registerTerminalQuickFixProvider(te,je.identifier.value,ce)},registerTreeDataProvider(te,ce){return $i.registerTreeDataProvider(te,ce,je)},createTreeView(te,ce){return $i.createTreeView(te,ce,je)},registerWebviewPanelSerializer:(te,ce)=>Ai.registerWebviewPanelSerializer(je,te,ce),registerCustomEditorProvider:(te,ce,Oe={})=>ln.registerCustomEditorProvider(je,te,ce,Oe),registerFileDecorationProvider(te){return Z.registerFileDecorationProvider(te,je)},registerUriHandler(te){return Dt.registerUriHandler(je,te)},createQuickPick(){return oi.createQuickPick(je)},createInputBox(){return oi.createInputBox(je)},get activeColorTheme(){return Ri.activeColorTheme},onDidChangeActiveColorTheme(te,ce,Oe){return _e(Ri.onDidChangeActiveColorTheme)(te,ce,Oe)},registerWebviewViewProvider(te,ce,Oe){return Mi.registerWebviewViewProvider(je,te,ce,Oe?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ce,Oe){return _e(Ct.onDidChangeActiveNotebookEditor)(te,ce,Oe)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return _e(Ct.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(te,ce,Oe){return _e(mi.onDidChangeNotebookEditorSelection)(te,ce,Oe)},onDidChangeNotebookEditorVisibleRanges(te,ce,Oe){return _e(mi.onDidChangeNotebookEditorVisibleRanges)(te,ce,Oe)},showNotebookDocument(te,ce){return Ct.showNotebookDocument(te,ce)},registerExternalUriOpener(te,ce,Oe){return(0,Xe.$LF)(je,"externalUriOpener"),hn.registerExternalUriOpener(je.identifier,te,ce,Oe)},registerProfileContentHandler(te,ce){return(0,Xe.$LF)(je,"profileContentHandlers"),dn.registerProfileContentHandler(je,te,ce)},registerQuickDiffProvider(te,ce,Oe,rt){return(0,Xe.$LF)(je,"quickDiffProvider"),Pi.registerQuickDiffProvider(pt(te),ce,Oe,rt)},get tabGroups(){return Fe.tabGroups},registerShareProvider(te,ce){return(0,Xe.$LF)(je,"shareProvider"),Zi.registerShareProvider(pt(te),ce)}},an={get rootPath(){return It.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(te){throw new M.$9("rootPath")},getWorkspaceFolder(te){return dt.getWorkspaceFolder(te)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(te){throw new M.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(te){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(te,ce,...Oe)=>dt.updateWorkspaceFolders(je,te,ce||0,...Oe),onDidChangeWorkspaceFolders:function(te,ce,Oe){return _e(dt.onDidChangeWorkspace)(te,ce,Oe)},asRelativePath:(te,ce)=>dt.getRelativePath(te,ce),findFiles:(te,ce,Oe,rt)=>dt.findFiles(te,ce,Oe,je.identifier,rt),findTextInFiles:(te,ce,Oe,rt)=>{(0,Xe.$LF)(je,"findTextInFiles");let vt,Lt;return typeof ce=="object"?(vt=ce,Lt=Oe):(vt={},Lt=ce,rt=Oe),dt.findTextInFiles(te,vt||{},Lt,je.identifier,rt)},save:te=>dt.save(te),saveAs:te=>dt.saveAs(te),saveAll:te=>dt.saveAll(te),applyEdit(te,ce){return gn.applyWorkspaceEdit(te,je,ce)},createFileSystemWatcher:(te,ce,Oe,rt)=>{let vt;return typeof ce=="boolean"?vt={ignoreCreateEvents:!!ce,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!rt,correlate:!1}:ce&&((0,Xe.$LF)(je,"createFileSystemWatcher"),vt={...ce,correlate:!0}),ei.createFileSystemWatcher(dt,je,te,vt)},get textDocuments(){return bt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new M.$9("textDocuments")},openTextDocument(te){let ce;const Oe=te;if(typeof te=="string")ce=Promise.resolve(h.URI.file(te));else if(h.URI.isUri(te))ce=Promise.resolve(te);else if(!Oe||typeof Oe=="object")ce=bt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(rt=>(rt.scheme===L.Schemas.vscodeRemote&&!rt.authority&&It.report("workspace.openTextDocument",je,"A URI of 'vscode-remote' scheme requires an authority."),bt.ensureDocumentData(rt).then(vt=>vt.document)))},onDidOpenTextDocument:(te,ce,Oe)=>_e(bt.onDidAddDocument)(te,ce,Oe),onDidCloseTextDocument:(te,ce,Oe)=>_e(bt.onDidRemoveDocument)(te,ce,Oe),onDidChangeTextDocument:(te,ce,Oe)=>_e(bt.onDidChangeDocument)(te,ce,Oe),onDidSaveTextDocument:(te,ce,Oe)=>_e(bt.onDidSaveDocument)(te,ce,Oe),onWillSaveTextDocument:(te,ce,Oe)=>_e(Ji.getOnWillSaveTextDocumentEvent(je))(te,ce,Oe),get notebookDocuments(){return Ct.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,ce){let Oe;if(h.URI.isUri(te))Oe=te,await Ct.openNotebookDocument(te);else if(typeof te=="string")Oe=h.URI.revive(await Ct.createNotebookDocument({viewType:te,content:ce}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(te,ce,Oe){return _e(si.onDidSaveNotebookDocument)(te,ce,Oe)},onDidChangeNotebookDocument(te,ce,Oe){return _e(si.onDidChangeNotebookDocument)(te,ce,Oe)},onWillSaveNotebookDocument(te,ce,Oe){return _e(Ii.getOnWillSaveNotebookDocumentEvent(je))(te,ce,Oe)},get onDidOpenNotebookDocument(){return _e(Ct.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return _e(Ct.onDidCloseNotebookDocument)},registerNotebookSerializer(te,ce,Oe,rt){return Ct.registerNotebookSerializer(je,te,ce,Oe,(0,Xe.$KF)(je,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,ce,Oe)=>_e(ji.onDidChangeConfiguration)(te,ce,Oe),getConfiguration(te,ce){return ce=arguments.length===1?void 0:ce,ji.getConfiguration(te,ce,je)},registerTextDocumentContentProvider(te,ce){return Di.registerTextDocumentContentProvider(te,ce)},registerTaskProvider:(te,ce)=>(It.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),wt.registerTaskProvider(je,te,ce)),registerFileSystemProvider(te,ce,Oe){return(0,R.$Qc)(Qi.registerFileSystemProvider(je,te,ce,Oe),Qt.addFileSystemProvider(te,ce,Oe))},get fs(){return Qt.value},registerFileSearchProvider:(te,ce)=>((0,Xe.$LF)(je,"fileSearchProvider"),at.registerFileSearchProvider(te,ce)),registerTextSearchProvider:(te,ce)=>((0,Xe.$LF)(je,"textSearchProvider"),at.registerTextSearchProvider(te,ce)),registerRemoteAuthorityResolver:(te,ce)=>((0,Xe.$LF)(je,"resolvers"),Et.registerRemoteAuthorityResolver(te,ce)),registerResourceLabelFormatter:te=>((0,Xe.$LF)(je,"resolvers"),Yi.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Xe.$LF)(je,"resolvers"),Et.getRemoteExecServer(te)),onDidCreateFiles:(te,ce,Oe)=>_e(ei.onDidCreateFile)(te,ce,Oe),onDidDeleteFiles:(te,ce,Oe)=>_e(ei.onDidDeleteFile)(te,ce,Oe),onDidRenameFiles:(te,ce,Oe)=>_e(ei.onDidRenameFile)(te,ce,Oe),onWillCreateFiles:(te,ce,Oe)=>_e(ei.getOnWillCreateFileEvent(je))(te,ce,Oe),onWillDeleteFiles:(te,ce,Oe)=>_e(ei.getOnWillDeleteFileEvent(je))(te,ce,Oe),onWillRenameFiles:(te,ce,Oe)=>_e(ei.getOnWillRenameFileEvent(je))(te,ce,Oe),openTunnel:te=>((0,Xe.$LF)(je,"tunnels"),Mt.openTunnel(je,te).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,Xe.$LF)(je,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(te,ce,Oe)=>((0,Xe.$LF)(je,"tunnels"),_e(Mt.onDidChangeTunnels)(te,ce,Oe)),registerPortAttributesProvider:(te,ce)=>((0,Xe.$LF)(je,"portsAttributes"),Mt.registerPortsAttributesProvider(te,ce)),registerTunnelProvider:(te,ce)=>((0,Xe.$LF)(je,"tunnelFactory"),Mt.registerTunnelProvider(te,ce)),registerTimelineProvider:(te,ce)=>((0,Xe.$LF)(je,"timeline"),Xi.registerTimelineProvider(te,ce,je.identifier,ze.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:te=>((0,Xe.$LF)(je,"workspaceTrust"),dt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ce,Oe)=>_e(dt.onDidGrantWorkspaceTrust)(te,ce,Oe),registerEditSessionIdentityProvider:(te,ce)=>((0,Xe.$LF)(je,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(te,ce)),onWillCreateEditSessionIdentity:(te,ce,Oe)=>((0,Xe.$LF)(je,"editSessionIdentityProvider"),_e(dt.getOnWillCreateEditSessionIdentityEvent(je))(te,ce,Oe)),registerCanonicalUriProvider:(te,ce)=>((0,Xe.$LF)(je,"canonicalUriProvider"),dt.registerCanonicalUriProvider(te,ce)),getCanonicalUri:(te,ce,Oe)=>((0,Xe.$LF)(je,"canonicalUriProvider"),dt.provideCanonicalUri(te,ce,Oe))},$n={get inputBox(){return It.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(je)},createSourceControl(te,ce,Oe){return pi.createSourceControl(je,te,ce,Oe)}},cn={createCommentController(te,ce){return Li.createCommentController(je,te,ce)}},un={get activeDebugSession(){return Ve.activeDebugSession},get activeDebugConsole(){return Ve.activeDebugConsole},get breakpoints(){return Ve.breakpoints},get stackFrameFocus(){return Ve.stackFrameFocus},registerDebugVisualizationProvider(te,ce){return(0,Xe.$LF)(je,"debugVisualization"),Ve.registerDebugVisualizationProvider(je,te,ce)},onDidStartDebugSession(te,ce,Oe){return _e(Ve.onDidStartDebugSession)(te,ce,Oe)},onDidTerminateDebugSession(te,ce,Oe){return _e(Ve.onDidTerminateDebugSession)(te,ce,Oe)},onDidChangeActiveDebugSession(te,ce,Oe){return _e(Ve.onDidChangeActiveDebugSession)(te,ce,Oe)},onDidReceiveDebugSessionCustomEvent(te,ce,Oe){return _e(Ve.onDidReceiveDebugSessionCustomEvent)(te,ce,Oe)},onDidChangeBreakpoints(te,ce,Oe){return _e(Ve.onDidChangeBreakpoints)(te,ce,Oe)},onDidChangeStackFrameFocus(te,ce,Oe){return(0,Xe.$LF)(je,"debugFocus"),_e(Ve.onDidChangeStackFrameFocus)(te,ce,Oe)},registerDebugConfigurationProvider(te,ce,Oe){return Ve.registerDebugConfigurationProvider(te,ce,Oe||Wt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ce){return Ve.registerDebugAdapterDescriptorFactory(je,te,ce)},registerDebugAdapterTrackerFactory(te,ce){return Ve.registerDebugAdapterTrackerFactory(te,ce)},startDebugging(te,ce,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?Ve.startDebugging(te,ce,{parentSession:Oe}):Ve.startDebugging(te,ce,Oe||{})},stopDebugging(te){return Ve.stopDebugging(te)},addBreakpoints(te){return Ve.addBreakpoints(te)},removeBreakpoints(te){return Ve.removeBreakpoints(te)},asDebugSourceUri(te,ce){return Ve.asDebugSourceUri(te,ce)}},Ui={registerTaskProvider:(te,ce)=>wt.registerTaskProvider(je,te,ce),fetchTasks:te=>wt.fetchTasks(te),executeTask:te=>wt.executeTask(je,te),get taskExecutions(){return wt.taskExecutions},onDidStartTask:(te,ce,Oe)=>_e(wt.onDidStartTask)(te,ce,Oe),onDidEndTask:(te,ce,Oe)=>_e(wt.onDidEndTask)(te,ce,Oe),onDidStartTaskProcess:(te,ce,Oe)=>_e(wt.onDidStartTaskProcess)(te,ce,Oe),onDidEndTaskProcess:(te,ce,Oe)=>_e(wt.onDidEndTaskProcess)(te,ce,Oe)},Bi={createNotebookController(te,ce,Oe,rt,vt){return ui.createNotebookController(je,te,ce,Oe,rt,(0,Xe.$KF)(je,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(te,ce)=>Ct.registerNotebookCellStatusBarItemProvider(je,te,ce),createRendererMessaging(te){return Si.createRendererMessaging(je,te)},createNotebookControllerDetectionTask(te){return(0,Xe.$LF)(je,"notebookKernelSource"),ui.createNotebookControllerDetectionTask(je,te)},registerKernelSourceActionProvider(te,ce){return(0,Xe.$LF)(je,"notebookKernelSource"),ui.registerKernelSourceActionProvider(je,te,ce)},onDidChangeNotebookCellExecutionState(te,ce,Oe){return(0,Xe.$LF)(je,"notebookCellExecutionState"),_e(ui.onDidChangeNotebookCellExecutionState)(te,ce,Oe)}},Wi={t(...te){if(typeof te[0]=="string"){const ce=te.shift(),Oe=!te||typeof te[0]!="object"?te:te[0];return kt.getMessage(je.identifier.value,{message:ce,args:Oe})}return kt.getMessage(je.identifier.value,te[0])},get bundle(){return kt.getBundle(je.identifier.value)},get uri(){return kt.getBundleUri(je.identifier.value)}},ki={_version:1,registerInteractiveEditorSessionProvider(te,ce){return(0,Xe.$LF)(je,"interactive"),xi.registerProvider(je,te,ce)},registerInteractiveSessionProvider(te,ce){return(0,Xe.$LF)(je,"interactive"),wi.registerChatProvider(je,te,ce)},sendInteractiveRequestToProvider(te,ce){return(0,Xe.$LF)(je,"interactive"),wi.sendInteractiveRequestToProvider(te,ce)},transferChatSession(te,ce){return(0,Xe.$LF)(je,"interactive"),wi.transferChatSession(te,ce)}},Vi={getRelatedInformation(te,ce){return(0,Xe.$LF)(je,"aiRelatedInformation"),Ni.getRelatedInformation(je,te,ce)},registerRelatedInformationProvider(te,ce){return(0,Xe.$LF)(je,"aiRelatedInformation"),Ni.registerRelatedInformationProvider(je,te,ce)},registerEmbeddingVectorProvider(te,ce){return(0,Xe.$LF)(je,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(je,te,ce)}},qi={registerChatResponseProvider(te,ce,Oe){return(0,Xe.$LF)(je,"chatProvider"),Fi.registerProvider(je.identifier,te,ce,Oe)},requestChatAccess(te){return(0,Xe.$LF)(je,"chatRequestAccess"),Fi.requestChatResponseProvider(je.identifier,te)},registerVariable(te,ce,Oe){return(0,Xe.$LF)(je,"chatAgents2"),_i.registerVariableResolver(je,te,ce,Oe)},registerMappedEditsProvider(te,ce){return(0,Xe.$LF)(je,"mappedEditsProvider"),ht.registerMappedEditsProvider(je,te,ce)},createChatAgent(te,ce){return(0,Xe.$LF)(je,"chatAgents2"),Ti.createChatAgent(je,te,ce)}},pn={registerSpeechProvider(te,ce){return(0,Xe.$LF)(je,"speech"),ni.registerProvider(je.identifier,te,ce)}};return{version:$t.version,ai:Vi,authentication:en,commands:mn,comments:cn,chat:qi,debug:un,env:tn,extensions:rn,interactive:ki,l10n:Wi,languages:sn,notebooks:Bi,scm:$n,speech:pn,tasks:Ui,tests:nn,window:on,workspace:an,Breakpoint:Te.$kM,TerminalOutputAnchor:Te.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Te.ChatAgentResultFeedbackKind,ChatMessage:Te.$dN,ChatMessageRole:Te.ChatMessageRole,ChatVariableLevel:Te.ChatVariableLevel,ChatAgentCompletionItem:Te.$cN,CallHierarchyIncomingCall:Te.$JL,CallHierarchyItem:Te.$IL,CallHierarchyOutgoingCall:Te.$KL,CancellationError:M.$5,CancellationTokenSource:S.$7d,CandidatePortSource:s.CandidatePortSource,CodeAction:Te.$FL,CodeActionKind:Te.$GL,CodeActionTriggerKind:Te.CodeActionTriggerKind,CodeLens:Te.$LL,Color:Te.$YL,ColorInformation:Te.$ZL,ColorPresentation:Te.$1L,ColorThemeKind:Te.ColorThemeKind,CommentMode:Te.CommentMode,CommentState:Te.CommentState,CommentThreadCollapsibleState:Te.CommentThreadCollapsibleState,CommentThreadState:Te.CommentThreadState,CompletionItem:Te.$SL,CompletionItemKind:Te.CompletionItemKind,CompletionItemTag:Te.CompletionItemTag,CompletionList:Te.$TL,CompletionTriggerKind:Te.CompletionTriggerKind,ConfigurationTarget:Te.ConfigurationTarget,CustomExecution:Te.$9L,DebugAdapterExecutable:Te.$oM,DebugAdapterInlineImplementation:Te.$rM,DebugAdapterNamedPipeServer:Te.$qM,DebugAdapterServer:Te.$pM,DebugConfigurationProviderTriggerKind:Wt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Te.DebugConsoleMode,DebugVisualization:Te.$GM,DecorationRangeBehavior:Te.DecorationRangeBehavior,Diagnostic:Te.$zL,DiagnosticRelatedInformation:Te.$yL,DiagnosticSeverity:Te.DiagnosticSeverity,DiagnosticTag:Te.DiagnosticTag,Disposable:Te.$lL,DocumentHighlight:Te.$BL,DocumentHighlightKind:Te.DocumentHighlightKind,MultiDocumentHighlight:Te.$CL,DocumentLink:Te.$XL,DocumentSymbol:Te.$EL,EndOfLine:Te.EndOfLine,EnvironmentVariableMutatorType:Te.EnvironmentVariableMutatorType,EvaluatableExpression:Te.$uM,InlineValueText:Te.$vM,InlineValueVariableLookup:Te.$wM,InlineValueEvaluatableExpression:Te.$xM,InlineCompletionTriggerKind:Te.InlineCompletionTriggerKind,EventEmitter:I.$Wd,ExtensionKind:Te.ExtensionKind,ExtensionMode:Te.ExtensionMode,ExternalUriOpenerPriority:Te.ExternalUriOpenerPriority,FileChangeType:Te.FileChangeType,FileDecoration:Te.$IM,FileDecoration2:Te.$IM,FileSystemError:Te.$zM,FileType:$.FileType,FilePermission:$.FilePermission,FoldingRange:Te.$AM,FoldingRangeKind:Te.FoldingRangeKind,FunctionBreakpoint:Te.$mM,InlineCompletionItem:Te.$UL,InlineCompletionList:Te.$VL,Hover:Te.$AL,IndentAction:D.IndentAction,Location:Te.$xL,MarkdownString:Te.$ML,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Te.$NL,PortAutoForwardAction:Te.PortAutoForwardAction,Position:Te.$mL,ProcessExecution:Te.$7L,ProgressLocation:Te.ProgressLocation,QuickInputButtons:Te.$HM,Range:Te.$nL,RelativePattern:Te.$iM,Selection:Te.$oL,SelectionRange:Te.$HL,SemanticTokens:Te.$DM,SemanticTokensBuilder:Te.$CM,SemanticTokensEdit:Te.$EM,SemanticTokensEdits:Te.$FM,SemanticTokensLegend:Te.$BM,ShellExecution:Te.$8L,ShellQuoting:Te.ShellQuoting,SignatureHelp:Te.$PL,SignatureHelpTriggerKind:Te.SignatureHelpTriggerKind,SignatureInformation:Te.$OL,SnippetString:Te.$wL,SourceBreakpoint:Te.$lM,StandardTokenType:Te.StandardTokenType,StatusBarAlignment:Te.StatusBarAlignment,SymbolInformation:Te.$DL,SymbolKind:Te.SymbolKind,SymbolTag:Te.SymbolTag,Task:Te.$0L,TaskGroup:Te.$6L,TaskPanelKind:Te.TaskPanelKind,TaskRevealKind:Te.TaskRevealKind,TaskScope:Te.TaskScope,TerminalLink:Te.$2L,TerminalQuickFixTerminalCommand:Te.$4L,TerminalQuickFixOpener:Te.$3L,TerminalLocation:Te.TerminalLocation,TerminalProfile:Te.$5L,TerminalExitReason:Te.TerminalExitReason,TextDocumentSaveReason:Te.TextDocumentSaveReason,TextEdit:Te.$sL,SnippetTextEdit:Te.$uL,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Te.TextEditorLineNumbersStyle,TextEditorRevealType:Te.TextEditorRevealType,TextEditorSelectionChangeKind:Te.TextEditorSelectionChangeKind,SyntaxTokenType:Te.SyntaxTokenType,TextDocumentChangeReason:Te.TextDocumentChangeReason,ThemeColor:Te.$hM,ThemeIcon:Te.$gM,TreeItem:Te.$$L,TreeItemCheckboxState:Te.TreeItemCheckboxState,TreeItemCollapsibleState:Te.TreeItemCollapsibleState,TypeHierarchyItem:Te.$4M,UIKind:jt.UIKind,Uri:h.URI,ViewColumn:Te.ViewColumn,WorkspaceEdit:Te.$vL,DocumentDropEdit:Te.$eM,DocumentPasteEdit:Te.$fM,InlayHint:Te.$RL,InlayHintLabelPart:Te.$QL,InlayHintKind:Te.InlayHintKind,RemoteAuthorityResolverError:Te.$rL,ResolvedAuthority:Te.$pL,ManagedResolvedAuthority:Te.$qL,SourceControlInputBoxValidationType:Te.SourceControlInputBoxValidationType,ExtensionRuntime:Te.ExtensionRuntime,TimelineItem:Te.$SM,NotebookRange:Te.$KM,NotebookCellKind:Te.NotebookCellKind,NotebookCellExecutionState:Te.NotebookCellExecutionState,NotebookCellData:Te.$LM,NotebookData:Te.$MM,NotebookRendererScript:Te.$QM,NotebookCellStatusBarAlignment:Te.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Te.NotebookEditorRevealType,NotebookCellOutput:Te.$OM,NotebookCellOutputItem:Te.$NM,NotebookCellStatusBarItem:Te.$PM,NotebookControllerAffinity:Te.NotebookControllerAffinity,NotebookControllerAffinity2:Te.NotebookControllerAffinity2,NotebookEdit:Te.$tL,NotebookKernelSourceAction:Te.$RM,NotebookVariablesRequestKind:Te.NotebookVariablesRequestKind,PortAttributes:Te.$UM,LinkedEditingRanges:Te.$TM,TestResultState:Te.TestResultState,TestRunRequest:Te.$VM,TestMessage:Te.$WM,TestMessage2:Te.$WM,TestTag:Te.$XM,TestRunProfileKind:Te.TestRunProfileKind,TextSearchCompleteMessageType:Ht.TextSearchCompleteMessageType,DataTransfer:Te.$dM,DataTransferItem:Te.$_L,CoveredCount:Te.$YM,FileCoverage:Te.$ZM,StatementCoverage:Te.$1M,BranchCoverage:Te.$2M,FunctionCoverage:Te.$3M,WorkspaceTrustState:Te.WorkspaceTrustState,LanguageStatusSeverity:Te.LanguageStatusSeverity,QuickPickItemKind:Te.QuickPickItemKind,InputBoxValidationSeverity:Te.InputBoxValidationSeverity,TabInputText:Te.$5M,TabInputTextDiff:Te.$6M,TabInputTextMerge:Te.$7M,TabInputCustom:Te.$8M,TabInputNotebook:Te.$0M,TabInputNotebookDiff:Te.$$M,TabInputWebview:Te.$9M,TabInputTerminal:Te.$_M,TabInputInteractiveWindow:Te.$aN,TabInputChat:Te.$bN,TelemetryTrustedValue:r.$No,LogLevel:n.LogLevel,EditSessionIdentityMatch:t.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Te.InteractiveSessionVoteDirection,ChatAgentCopyKind:Te.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Te.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Te.$sM,ThreadFocus:Te.$tM,RelatedInformationType:Te.RelatedInformationType,SpeechToTextStatus:Te.SpeechToTextStatus,KeywordRecognitionStatus:Te.KeywordRecognitionStatus}}}e.$9hc=Jt}),define(Re[292],Ae([1,0,53,112,36,107,37,31,66,65,115,117,118,83,86,79,106,62,43,82,60,64,228,14,116,80,81]),function(me,e,S,M,I,R,L,g,h,E,A,D,l,p,$,n,c,r,t,s,a,u,i,v,o,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$1r)(w.$Xgc,w.$Wgc,1),(0,S.$1r)(v.$qj,i.$0hc,1),(0,S.$1r)(n.$9fc,n.$0fc,1),(0,S.$1r)(g.$KN,g.$JN,0),(0,S.$1r)(L.$rgc,L.$pgc,0),(0,S.$1r)(r.$tgc,r.$sgc,0),(0,S.$1r)(D.$8gc,D.$_gc,0),(0,S.$1r)(R.$bhc,R.$ahc,0),(0,S.$1r)(h.$zN,h.$yN,0),(0,S.$1r)(y.$Ygc,y.$Zgc,0),(0,S.$1r)(t.$6fc,t.$5fc,0),(0,S.$1r)(M.$Hhc,M.$Ghc,1),(0,S.$1r)(l.$rhc,l.$shc,0),(0,S.$1r)(p.$Mgc,p.$Lgc,0),(0,S.$1r)(A.$Uhc,A.$Thc,0),(0,S.$1r)(E.$Pgc,E.$Sgc,0),(0,S.$1r)($.$izb,$.$jzb,0),(0,S.$1r)(c.$8hc,c.$7hc,0),(0,S.$1r)(I.$ogc,I.$ngc,0),(0,S.$1r)(s.$Ugc,s.$Tgc,0),(0,S.$1r)(a.$IN,a.$FN,0),(0,S.$1r)(u.$Dgc,u.$Egc,0),(0,S.$1r)(o.$6gc,o.$7gc,0)}),define(Re[293],Ae([1,0,291,38,2,288,7,11,234]),function(me,e,S,M,I,R,L,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=void 0;class E extends R.$aic{j(){}getModule(p,$){for(const n of this.b){const c=n(p);if(c){p=c;break}}if(this.a.has(p))return this.a.get(p).load(p,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends M.$2gc{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(h.$hkc);const p=this.h.invokeFunction(S.$9hc);this.r=this.h.createInstance(E,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,$,n){$=$.with({path:D($.path,".js")});const c=p?.identifier.value;c&&performance.mark(`code/extHost/willFetchExtensionCode/${c}`);const r=I.URI.revive(await this.C.$asBrowserUri($)),t=await fetch(r.toString(!0));if(c&&performance.mark(`code/extHost/didFetchExtensionCode/${c}`),t.status!==200)throw new Error(t.statusText);const s=await t.text(),a=`${$.toString(!0)}#vscode-extension`,u=`${s}
//# sourceURL=${a}`;let i;try{i=new Function("module","exports","require",u)}catch(y){throw console.error(c?`Loading code for extension ${c} failed: ${y.message}`:`Loading code failed: ${y.message}`),console.error(`${$.toString(!0)}${typeof y.line=="number"?` line ${y.line}`:""}${typeof y.column=="number"?` column ${y.column}`:""}`),console.error(y),y}p&&await this.w.initializeLocalizedMessages(p);const v={},o={exports:v},w=y=>{const d=this.r.getModule(y,$);if(d===void 0)throw new Error(`Cannot load module '${y}'`);return d};try{return n.codeLoadingStart(),c&&performance.mark(`code/extHost/willLoadExtensionCode/${c}`),i(o,v,w),o.exports!==v?o.exports:v}finally{c&&performance.mark(`code/extHost/didLoadExtensionCode/${c}`),n.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+p;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,g.$9g)(10)}}e.$ikc=A;function D(l,p){return l.endsWith(p)?l:l+p}}),define(Re[294],Ae([1,0,70,53,14,38,199,85,293]),function(me,e,S,M,I,R,L,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$1r)(I.$pj,new S.$5h(L.$_hc,[!0],!0)),(0,M.$1r)(R.$3gc,h.$ikc,0),(0,M.$1r)(g.$ugc,g.$vgc,0)}),define(Re[299],Ae([1,0,23,5,78,289,236,19,88,12,2,292,294]),function(me,e,S,M,I,R,L,g,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(i){return/^(file|vscode-remote):/i.test(i)}const $=fetch.bind(self);function n(i){self.fetch=async function(v,o){return v instanceof Request||p(String(v))&&(v=(await i(A.URI.parse(String(v)))).toString(!0)),$(v,o)},self.XMLHttpRequest=class extends XMLHttpRequest{open(v,o,w,y,d){(async()=>(p(o.toString())&&(o=(await i(A.URI.parse(o.toString()))).toString(!0)),super.open(v,o,w??!0,y,d)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(v,o){if(/^file:/i.test(v.toString()))v=E.$pg.uriToBrowserUri(A.URI.parse(v.toString())).toString(!0);else if(/^vscode-remote:/i.test(v.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const y=`(${function(f){function m(O){return typeof O=="string"||O instanceof URL?String(O).replace(/^file:\/\//i,"vscode-file://vscode-app"):O}const k=fetch.bind(self);self.fetch=function(O,G){return O instanceof Request?k(O,G):k(m(O),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(O,G,q,j,C){return super.open(O,m(G),q??!0,j,C)}};const T=importScripts.bind(self);self.importScripts=(...O)=>{T(...O.map(m))},T(f)}.toString()}('${v}'))`;o=o||{},o.name=`${name} -> ${o.name||g.$nc(v.toString())}`;const d=new Blob([y],{type:"application/javascript"}),b=URL.createObjectURL(d);return new i(b,o)}}else self.Worker=class extends L.$jkc{constructor(i,v){super(l,i,{name:g.$nc(i.toString()),...v})}};const c=new class{constructor(){this.pid=void 0}exit(i){D()}};class r{constructor(){const v=new MessageChannel,o=new M.$Wd;let w=!1;l(v.port2,[v.port2]),v.port1.onmessage=y=>{const{data:d}=y;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const b=S.$ke.wrap(new Uint8Array(d,0,d.byteLength));if((0,I.$wm)(b,2)){w=!0,s("received terminate message from renderer");return}o.fire(b)},this.protocol={onMessage:o.event,send:y=>{if(!w){const d=y.buffer.buffer.slice(y.buffer.byteOffset,y.buffer.byteOffset+y.buffer.byteLength);v.port1.postMessage(d,[d])}}}}}function t(i){return new Promise(v=>{const o=i.onMessage(w=>{o.dispose();const y=JSON.parse(w.toString());i.send((0,I.$vm)(0)),v({protocol:i,initData:y})});i.send((0,I.$vm)(1))})}let s=i=>D();function a(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function u(){h.mark("code/extHost/willConnectToRenderer");const i=new r;return{onmessage(v){a(v)&&t(i.protocol).then(o=>{h.mark("code/extHost/didWaitForInitData");const w=new R.$cic(o.protocol,o.initData,c,null,v.data);n(y=>w.asBrowserUri(y)),s=y=>w.terminate(y)})}}}e.create=u})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ec291c126878742ad640055ce604a58129cd088c/core/vs/workbench/api/worker/extensionHostWorker.js.map
